prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4416
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4416 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4416
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305967142364363')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'pt-br'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4416)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112718'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4416)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4416)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Sair'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>'Sair do Application Express'
,p_list_text_09=>'Y'
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4416)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Criar um aplicativo em uma planilha'
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>'Importar seus arquivos Excel ou csv e criar um aplicativo'
,p_list_text_09=>'Y'
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4416)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Home Page do Oracle APEX'
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>unistr('in\00EDcio da homepage ')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4416)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Procurar \00CDcones de Fonte APEX')
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('Procure \00EDcones de Fonte APEX, adicione modificadores e copie CSS ou HTML que voc\00EA precisa.')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('gr\00E1ficos da biblioteca de \00EDcones de fonte apex')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4416)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4416)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Exportar Aplicativo'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>'Exportar Aplicativo {APP_ID} como Arquivo SQL'
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4416)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Listas N\00E3o Utilizadas')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4416)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4416)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4416)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4416)
,p_theme_id=>1
,p_name=>'One Level Tabs.pt-br'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4416)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4416)
,p_theme_id=>1
,p_name=>'Printer Friendly.pt-br'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4416)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4416)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4416)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4416)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4416)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4416)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4416)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4416)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4416)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4416)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4416)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4416)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4416)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4416)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>unistr('Caixa de Di\00E1logo Pesquisar')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>'Pesquisar'
,p_close_button_text=>'Fechar'
,p_next_button_text=>unistr('Pr\00F3ximo >')
,p_prev_button_text=>'< Anterior'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4416)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4416)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4416)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207022726310702)
,p_name=>'2DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 2D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209157276310704)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha de Coluna em 2D'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207142643310702)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'pt-br'
,p_message_text=>'Anel em 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208962440310703)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 2D Horizontal Sobreposta (Percentual)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207239158310702)
,p_name=>'2DLINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha em 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207325975310702)
,p_name=>'2DPIE'
,p_message_language=>'pt-br'
,p_message_text=>'Pizza em 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208700161310703)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 2D Sobreposta (Percentual)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207499474310702)
,p_name=>'3DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209035239310703)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 3D Horizontal Sobreposta (Percentual)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207515788310702)
,p_name=>'3DPIE'
,p_message_language=>'pt-br'
,p_message_text=>'Pizza em 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208892713310703)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 3D Sobreposta (Percentual)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976912124311327)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('0 Item para inser\00E7\00E3o no Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976784443311326)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('0 Item para atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977102653311327)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('0 Item para atualiza\00E7\00E3o do Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977552374311327)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('0 Coluna do Relat\00F3rio para inser\00E7\00E3o no Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977799938311327)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('0 Coluna do Relat\00F3rio para atualiza\00E7\00E3o do Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976694786311326)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revisar %0 Itens para atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977320100311327)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('0 Coluna do Relat\00F3rio para atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976850934311326)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revisar %0 Itens para inser\00E7\00E3o no Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977080349311327)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revisar %0 Itens para atualiza\00E7\00E3o do Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977439564311327)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revisar %0 Colunas do Relat\00F3rio para inser\00E7\00E3o no Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977244475311327)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revisar %0 Colunas do Relat\00F3rio para atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977616311311327)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revisar %0 Colunas do Relat\00F3rio para atualiza\00E7\00E3o do Dicion\00E1rio de Atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769346681311154)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor deve ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754564138311142)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<span class="fielddata"> N\00E3o \00E9 poss\00EDvel reordenar porque as sequ\00EAncias da Regi\00E3o n\00E3o s\00E3o \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754634613311142)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<span class="fielddata">N\00E3o \00E9 poss\00EDvel reordenar porque as sequ\00EAncias do Bot\00E3o n\00E3o s\00E3o \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754719214311142)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<span class="fielddata">N\00E3o \00E9 poss\00EDvel reordenar porque as sequ\00EAncias da Barra de Navega\00E7\00E3o n\00E3o s\00E3o \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754862723311142)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<span class="fielddata">N\00E3o \00E9 poss\00EDvel reordenar porque as sequ\00EAncias do Item da Regi\00E3o n\00E3o s\00E3o \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823798729311203)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338459222310816)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Aplicativo: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728055683311120)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O formato de data especificado \00E9 inv\00E1lido. O calend\00E1rio requer uma data no formato AAAAMMDD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774057841311158)
,p_name=>'4000_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823865401311203)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID do Espa\00E7o de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618457617311031)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Informe o nome do novo esquema a ser criado. Escolha',
unistr('         uma senha para o esquema e tamb\00E9m o padr\00E3o tablespace'),
unistr('         e o tablespace tempor\00E1rio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618599351311031)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o nome do esquema existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618668592311031)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando terminar, clique em <strong>Pr\00F3ximo</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488748305310931)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'pt-br'
,p_message_text=>'Eliminar tablespaces e arquivos de dados associados: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488622977310931)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eliminar usu\00E1rios do banco de dados: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352599234311617)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de Log da Atividade do Servi\00E7o Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200687013310696)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas do Log de Sincroniza\00E7\00E3o REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201462379310696)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas do Log de Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612326586311027)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de log de atividade do desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251294049310742)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas do Log de Acesso ao Log-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611888449311026)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00F5es de Altera\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611963165311026)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00F5es de Runtime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611659839311026)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00F5es de Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614133843311028)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de hist\00F3rico no Processador do Comando SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614014310311028)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de log de execu\00E7\00E3o de Arquivo de Controle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613993701311028)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de log de execu\00E7\00E3o de Arquivo de Script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614290555311028)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Arquivos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615987860311029)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es sobre Log Ativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616093185311029)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Log Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616102439311030)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'pt-br'
,p_message_text=>'Timestamp do Log Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616775227311030)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Horas at\00E9 a pr\00F3xima altern\00E2ncia de log')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616364002311030)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo em dias (constante)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616676935311030)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima altern\00E2ncia de log programada para')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617096825311030)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de log de atividade do desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617204127311030)
,p_name=>'4050_71_CLICK'
,p_message_language=>'pt-br'
,p_message_text=>'Clique nas entradas de log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618089209311031)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de hist\00F3rico no Processador do Comando SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617933936311031)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de log de execu\00E7\00E3o de Arquivo de Controle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617797107311031)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de log de execu\00E7\00E3o de Arquivo de Script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618113982311031)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Arquivos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618259728311031)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Espa\00E7o de Trabalho %1 tem %2 aplicativos e %3 usu\00E1rio(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618350748311031)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas do log de Contagem de Cliques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799404928311179)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos de Produtividade e Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799517770311179)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'pt-br'
,p_message_text=>'Websheets de Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798710567311178)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Contagem do Espa\00E7o de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545801627310977)
,p_name=>'4350_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545960867310977)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Aplicativo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265716745310758)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Database Express Edition 2 Day DBA.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265861744310758)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265699256310758)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265961733310758)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266044246310758)
,p_name=>'4500 800 HD NET'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266153717310758)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus PHP Developer.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266223130310759)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'pt-br'
,p_message_text=>'Trata de tarefas administrativas rotineiras.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266326003310759)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'pt-br'
,p_message_text=>'Explica como tirar proveito do ambiente de desenvolvimento Oracle Database Express Edition.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266440624310759)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Oferece uma s\00E9rie de tutoriais que descrevem como criar aplicativos Web centrados no banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266690566310759)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'pt-br'
,p_message_text=>'Este documento fornece um tutorial que mostra como usar Java e JDBC para conectar o Oracle Database XE, e demonstra como desenvolver um aplicativo Java simples que acessa e modifica dados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266746451310759)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este documento descreve os principais recursos do Oracle Data Provider for .NET e do Oracle Developer Tools for Visual Studio .NET. Ele conduz o usu\00E1rio durante a instala\00E7\00E3o e a configura\00E7\00E3o, mostra como criar aplicativos b\00E1sicos usando o Oracle Data')
||' Provider for .NET e o Oracle Developer Tools for Visual Studio .NET, e mostra como usar procedimentos PL/SQL e procedimentos armazenados .NET.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266536713310759)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este documento fornece um tutorial que mostra como fazer download e instalar drivers Apache e Zend Core PHP, e como usar PHP para conectar o Oracle Database XE. Tamb\00E9m mostra como usar PHP para desenvolver um aplicativo simples que acessa e modifica ')
||'dados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237289521310729)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237135598310729)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237458271310729)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669058017311068)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237838501310730)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237994838310730)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237320892310729)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237784525310730)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237599515310730)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237604693310730)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ordem de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240454277310732)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'pt-br'
,p_message_text=>'Join'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234243274310726)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'pt-br'
,p_message_text=>'Clique aqui para selecionar uma coluna para join.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240878572310733)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 poss\00EDvel selecionar no m\00E1ximo 60 colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234182588310726)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234067065310726)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar/Ocultar Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240515467310732)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'pt-br'
,p_message_text=>'para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233054058310725)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados de %0, executar %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489374069310931)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar para Consulta Original'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248273580310739)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 primeiras colunas exibidas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696636755311090)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'pt-br'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696595825311089)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'pt-br'
,p_message_text=>'Kilobytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696456905311089)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'pt-br'
,p_message_text=>'Megabytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269040903310761)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os Padr\00F5es da Interface do Usu\00E1rio s\00E3o usados pelo Application Builder para preencher os valores iniciais das propriedades de item e de regi\00E3o, proporcionando consist\00EAncia entre v\00E1rias p\00E1ginas de um ou de v\00E1rios aplicativos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299157074310785)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Este aplicativo requer que os cookies estejam ativados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299047877310785)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Este aplicativo requer que o JavaScript esteja ativado.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726324676311118)
,p_name=>'ABOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Sobre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419844939311665)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirme a adi\00E7\00E3o dos seguintes %0 usu\00E1rios ao seu espa\00E7o de trabalho.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737816339311129)
,p_name=>'ACCEPTED'
,p_message_language=>'pt-br'
,p_message_text=>'Aceito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705910023311097)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'pt-br'
,p_message_text=>'Favorecido de Acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704028966311095)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>'Impacto de Acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706312523311097)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status de Acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470768721311701)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'pt-br'
,p_message_text=>'Acessibilidade Testada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379567036310846)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Direitos de Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245818454310737)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Administra\00E7\00E3o de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658243563311060)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'pt-br'
,p_message_text=>'Administrador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763130356311149)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o designada a administradores de aplicativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246055713310737)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246639431310738)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246506783310738)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifique como o acesso a este aplicativo ser\00E1 controlado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247651399310739)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel processar solicita\00E7\00E3o de defini\00E7\00E3o de modo de aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247781571310739)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Modo de Aplicativo Definido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379946968310846)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode excluir voc\00EA mesmo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380055190310846)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode remover privil\00E9gio de administrador de si mesmo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245907523310737)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658181879311060)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Direitos de Contribui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658357214311060)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'pt-br'
,p_message_text=>'Colaborador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763201059311149)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o designada a colaboradores de aplicativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698806817311091)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A(s) seguinte(s) Defini\00E7\00E3o(\00F5es) do Aplicativo ser\00E1(\00E3o) criada(s):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658473421311060)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As seguintes Atribui\00E7\00F5es de Acesso de Aplicativo ser\00E3o criadas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263245130310754)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O(s) seguinte(s) Esquema(s) de Autoriza\00E7\00E3o ser\00E3(\00E3o) criado(s):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319085971310802)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina de controle de acesso. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318945406310802)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar tabelas de controle de acesso. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381385081310847)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel informar um nome do usu\00E1rio duplicado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379622625310846)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>'controle de acesso - editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247384262310739)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe crit\00E9rios de consulta sem distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas e pressione o bot\00E3o <strong>Ir</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247455645310739)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel obter o modo de administra\00E7\00E3o do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247230260310738)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Modifica\00E7\00E3o por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246932914310738)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246148063310737)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso total a todos, lista de controle de acesso n\00E3o utilizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246261974310738)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso restrito. Somente usu\00E1rios definidos na lista de controle de acesso t\00EAm permiss\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246390354310738)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente leitura p\00FAblica. Privil\00E9gios de edi\00E7\00E3o e administra\00E7\00E3o controlados por lista de controle de acesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246479626310738)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'pt-br'
,p_message_text=>'Somente acesso administrativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247565997310739)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 privil\00E9gio na tentativa de executar a\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247137265310738)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698728678311091)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>'Direitos do Leitor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698617835311091)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'pt-br'
,p_message_text=>'Leitor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763365975311149)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o designada a leitores de aplicativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264048669310757)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica nomes de usu\00E1rios que correspondam ao esquema de autentica\00E7\00E3o deste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246786302310738)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Modo de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345168623310821)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As p\00E1ginas de controle de acesso foram criadas com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658501128311060)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Atribui\00E7\00E3o de Controle de Acesso Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263914517310757)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Esquema de Autoriza\00E7\00E3o Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263133951310753)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Tabela Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379733078310846)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>'controle de acesso - exibir'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266926737310759)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Conta Criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952656015311308)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Menu da Conta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686577985311082)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686734880311082)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirmado, nenhuma a\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747203641311136)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355826535311619)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355983263311619)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade do Monitor de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355458886311619)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar/Modificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355759606311619)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o ao Executar o Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354690239311618)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o no Application Builder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355392541311619)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Anota\00E7\00F5es (arquivos, tags, observa\00E7\00F5es)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354308698311618)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' Autentica\00E7\00E3o da Conta do Application Express sem Lista de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354212990311618)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o com Lista de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355049221311618)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Acesso de SQL e Objetos Sugeridos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359057299311621)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Depois de autenticado em um aplicativo, o controle de acesso especifica o que os usu\00E1rios podem fazer no aplicativo. A tabela abaixo identifica quais tipos de recursos diferentes os usu\00E1rios ter\00E3o com base na autentica\00E7\00E3o que est\00E1 sendo usada no apli')
||'cativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356079566311619)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'pt-br'
,p_message_text=>'Manter Lista de Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355131881311619)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Executar e Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354807430311618)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar Propriedades do Aplicativo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972195449311323)
,p_name=>'ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353754964311617)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Menu A\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275484466310766)
,p_name=>'ACTIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Ativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665560022311066)
,p_name=>'ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707261791311098)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Resumo da Atividade',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907879253311268)
,p_name=>'ADDED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionado Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350193087311615)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionado \00E0 Lista de Expurga\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965072499311317)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es adicionais solicitadas')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625347505311036)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Argumento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615718231311029)
,p_name=>'ADD_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813087488311194)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454986833310901)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Constraint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613863902311028)
,p_name=>'ADD_MORE...'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679683703311077)
,p_name=>'ADD_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818133707311198)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Interface do Usu\00E1rio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821636476311201)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuste o espa\00E7o provisionado em %0 megabytes')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612515294311027)
,p_name=>'ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>'Admin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201375017310696)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cor do Banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201151136310696)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Banner do Ambiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201281980310696)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label do Banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620571922311033)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o do Banner')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259386682310750)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administrador de Espa\00E7os de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707055558311097)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'pt-br'
,p_message_text=>'Administradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619221003311032)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'pt-br'
,p_message_text=>'O e-mail dos administradores deve ser fornecido'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771533672311156)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'pt-br'
,p_message_text=>'Acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281821240310771)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282113273310771)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>'Desempenho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282224842310771)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Qualidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281954105310771)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282317745310772)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'pt-br'
,p_message_text=>'Usabilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282047093310771)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876574492311244)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item "%1" est\00E1 protegido e n\00E3o pode ser definido por uma chamada Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876619364311244)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item "%1" est\00E1 protegido e n\00E3o pode ser definido por uma chamada Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905961944311267)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item "%1" est\00E1 protegido e n\00E3o pode ser definido por uma chamada Ajax.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308297627310792)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefixo do esquema SYS n\00E3o encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012261867311357)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'pt-br'
,p_message_text=>'Uso de APIs WWV_FLOW (use APIs APEX em seu lugar)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962510132311316)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna %0 n\00E3o existe na Instru\00E7\00E3o SQL de Origem da Regi\00E3o!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291920828310779)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna do Relat\00F3rio Interativo %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289663369310777)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269950621310762)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna %0 n\00E3o existe na Instru\00E7\00E3o SQL de Origem da Regi\00E3o!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042371578311380)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna %0 do Form Tabular n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289751161310777)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o pode ser referenciado como nome do item do aplicativo ou p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424999390311669)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O processo do aplicativo Ajax Callback n\00E3o \00E9 protegido por um esquema de autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424569308311668)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina n\00E3o \00E9 protegida por um esquema de autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290686751310778)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina de destino %1 (no aplicativo %0) possui um esquema de autoriza\00E7\00E3o definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426258566311670)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A autoriza\00E7\00E3o desta p\00E1gina \00E9 diferente da autoriza\00E7\00E3o "%1" da p\00E1gina pai %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290771456310778)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A autoriza\00E7\00E3o "%0" na p\00E1gina de destino \00E9 diferente de "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289270796310777)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289152814310777)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel executar a verifica\00E7\00E3o de sintaxe da vari\00E1vel de bind. Erro: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289351689310777)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o pode ser referenciado com a sintaxe da vari\00E1vel de bind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291368288310778)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o incondicional antes de outras ramifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424365394311668)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O recurso de preenchimento autom\00E1tico \00E9 definido para "Ativado" em uma p\00E1gina que cont\00E9m itens de senha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424447276311668)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'pt-br'
,p_message_text=>'O "Cache" permite que o browser armazene dados confidenciais no cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224022643311520)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('"Incorporar em Quadros" deixa o aplicativo vulner\00E1vel a ataques de "clickjacking".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224132147311520)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O "Modo de Escape HTML" s\00F3 cria escape em um conjunto limitado de caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212625610310707)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os itens dever\00E3o ter escape para caracteres especiais para evitar ataques de XSS (Cross-Site-Scripting).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231172036311525)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O cabe\00E7alho de solicita\00E7\00E3o HTTP "Referencial" pode vazar informa\00E7\00F5es confidenciais da sess\00E3o para terceiros.'),
unistr('Os aplicativos devem definir a op\00E7\00E3o "Pol\00EDtica de Refer\00EAncia" como "origem estrita".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228708031310721)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ID encontrado nos Atributos do Bot\00E3o, para um bot\00E3o referenciado em uma A\00E7\00E3o Din\00E2mica (%0). '),
'',
unistr('Quando um ID for definido nos Atributos do Bot\00E3o, isso far\00E1 com que as A\00E7\00F5es Din\00E2micas que referenciam o bot\00E3o n\00E3o funcionem. Tente remover esse ID, pois o bot\00E3o gerar\00E1 um ID por padr\00E3o.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228832136310721)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O Modelo usado por um bot\00E3o, que ele pr\00F3prio \00E9 referenciado em uma A\00E7\00E3o Din\00E2mica (%0) n\00E3o cont\00E9m a string de substitui\00E7\00E3o #BUTTON_ID#.'),
'',
'Modelo:',
'%1',
'',
unistr('Recomenda-se adicionar a string de substitui\00E7\00E3o #BUTTON_ID# a esse modelo ou alterar o modelo de bot\00E3o para um que inclua a string de substitui\00E7\00E3o #BUTTON_ID#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232141255310724)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A ''A\00E7\00E3o'' do bot\00E3o n\00E3o \00E9 ''Definido por A\00E7\00E3o Din\00E2mica'', para um bot\00E3o referenciado em uma A\00E7\00E3o Din\00E2mica (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238220812310730)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o (%0) tem uma a\00E7\00E3o ''A\00E7\00E3o'' igual a ''Definido por A\00E7\00E3o Din\00E2mica'', mas n\00E3o h\00E1 A\00E7\00E3o Din\00E2mica correspondente que fa\00E7a refer\00EAncia a esse bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290342139310778)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Limpar Cache %0 n\00E3o \00E9 a p\00E1gina atual ou de destino %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289013167310777)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398150817311649)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Este valor de atributo tornou-se obsoleto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400662360311651)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Este tipo de componente tornou-se obsoleto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876713672311244)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'pt-br'
,p_message_text=>'Itens protegidos nas chamadas Ajax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308151741310792)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'pt-br'
,p_message_text=>'Code Smell (interno ao APEX)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287101166310775)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias Declarativas de Itens do Aplicativo, Itens de P\00E1gina, Colunas ou Filtros de Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424295196311668)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286891727310775)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias com Sintaxe da Vari\00E1vel de Bind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288292328310776)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o Incondicional antes de outras Ramifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424725744311669)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Seguran\00E7a do Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228663926310721)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o n\00E3o \00E9 compat\00EDvel com A\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238070084310730)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias inconsistentes entre A\00E7\00F5es Din\00E2micas e Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287457877310776)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O N\00FAmero da P\00E1gina Limpar Cache \00E9 igual \00E0 P\00E1gina de Destino ou Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286795442310775)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias com Sintaxe da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398014175311649)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Valores de atributos obsoletos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287772026310776)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os Processos de Extra\00E7\00E3o, DML, MR* s\00E3o V\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288184314310776)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Aplicativo com Hardcode'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683847386311080)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de P\00E1gina tem Texto de Ajuda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771358205311155)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina tem t\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795593760311176)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'pt-br'
,p_message_text=>'O item Exibir Imagem tem o texto de imagem ALT definido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223860589311520)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Os atributos do aplicativo que podem ser bloqueados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286973121310775)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item Referenciado est\00E1 na P\00E1gina Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287025370310775)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item Referenciado \00E9 o Item de P\00E1gina da P\00E1gina de Destino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772074660311156)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item da p\00E1gina n\00E3o causa uma altera\00E7\00E3o de contexto inesperada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772721562311157)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item da p\00E1gina tem label')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288471184310776)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Item ou do Nome da Coluna do Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287268607310775)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias de Item de P\00E1gina em uma String')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287363433310775)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O N\00FAmero de P\00E1gina Referenciado Existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771647711311156)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A regi\00E3o tem Cabe\00E7alho de Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288620288310776)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Relat\00F3rio tem Ordem Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424855026311669)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prote\00E7\00E3o de Estado de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287886046310776)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uso inapropriado da Sintaxe de Substitui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286650500310775)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias com Sintaxe de Substitui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287697475310776)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Autoriza\00E7\00E3o da P\00E1gina de Destino tamb\00E9m \00E9 definida para o Componente Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771866604311156)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo de Tema testado para verificar acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866610260311236)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Interface do Usu\00E1rio inclui JavaScript de compatibilidade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288330984310776)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item ou Coluna de Valida\00E7\00F5es Associado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287538856310776)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo SQL ou PL/SQL V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288089347310776)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'pt-br'
,p_message_text=>'Verificar Propriedade Clob'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106287923117310776)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o V usada em Instru\00E7\00F5es SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288551199310776)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Referenciado em Quando o Bot\00E3o For Pressionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290938021310778)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de compila\00E7\00E3o - %0 Instru\00E7\00E3o: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291231085310778)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O link cont\00E9m o ID do Aplicativo atual como um valor em hardcode.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683766330311080)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum texto de ajuda definido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771403831311156)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Essa p\00E1gina n\00E3o tem t\00EDtulo. T\00EDtulos significativos s\00E3o importantes para acessibilidade, ajudando os usu\00E1rios a entender o conte\00FAdo e o prop\00F3sito da p\00E1gina atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795694862311176)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o tem o texto alternativo obrigat\00F3rio para a imagem. Um bom texto deve descrever adequadamente o conte\00FAdo da imagem e n\00E3o deve duplicar qualquer informa\00E7\00E3o vis\00EDvel na p\00E1gina exibida no contexto da imagem (para evitar poss\00EDvel duplica\00E7\00E3o). Ob')
||unistr('serva\00E7\00E3o: se a imagem for fornecida pelos usu\00E1rios, tamb\00E9m dever\00E1 ter o texto alternativo, com a orienta\00E7\00E3o apropriada para ajudar os usu\00E1rios a fornecer um texto de alta qualidade.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223972059311520)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O "Uso da API de Runtime" permite modifica\00E7\00E3o do aplicativo e do espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289473159310777)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 um item da p\00E1gina %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289528678310777)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 um item na p\00E1gina de destino %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772105185311156)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A defini\00E7\00E3o ''A\00E7\00E3o da P\00E1gina na Sele\00E7\00E3o'' do item da p\00E1gina pode causar uma altera\00E7\00E3o inesperada de contexto para o usu\00E1rio. Tente alternar para ''Nenhum'' para que n\00E3o haja altera\00E7\00E3o de contexto e substitui\00E7\00E3o da funcionalidade por A\00E7\00F5es Din\00E2micas ou LO')
||unistr('Vs em Cascata (se voc\00EA precisar permanecer na mesma p\00E1gina). Se preferir, tente informar o usu\00E1rio para que ele saiba o que acontecer\00E1, por exemplo, adicionar ''Inicia uma nova p\00E1gina'' no label. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795410201311176)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um label para o item deve ser definido. Se voc\00EA preferir n\00E3o exibir um label vis\00EDvel, ainda assim defina um e depois selecione o modelo de label ''Oculto''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772811484311157)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item define um valor ''Marcador de Espa\00E7o de Valor'', mas nenhum label. O texto do marcador de espa\00E7o n\00E3o deve ser usado unicamente para identificar o item, j\00E1 que isso causa problemas de acessibilidade. Para melhor acessibilidade, um label do item d')
||unistr('eve ser definido. Se voc\00EA preferir n\00E3o exibir um label vis\00EDvel, ainda assim defina um label e depois selecione o modelo de label ''Oculto''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291691017310779)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome tem %0 caracteres, mas deve ter no m\00E1ximo 30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289859612310777)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 pode n\00E3o existir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106289931435310777)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 pode n\00E3o ser um item de p\00E1gina ou aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290207136310778)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Limpar Cache %1 (no aplicativo %0) n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290058003310777)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290153123310778)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina de Destino %1 (no aplicativo %0) n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698960306311091)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta regi\00E3o de Altern\00E2ncia de Coluna n\00E3o tem uma coluna com a op\00E7\00E3o ''Usar como Cabe\00E7alho de Linha'' definida como ''Sim''. A coluna Cabe\00E7alho de Linha deve ser a coluna que melhor identifica a linha atual (por exemplo, o nome do cliente em um relat\00F3rio ')
||unistr('de informa\00E7\00F5es do cliente).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699026636311091)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta regi\00E3o de Reflow n\00E3o tem uma coluna com a op\00E7\00E3o ''Usar como Cabe\00E7alho de Linha'' definida como ''Sim''. A coluna Cabe\00E7alho de Linha deve ser a coluna que melhor identifica a linha atual (por exemplo, o nome do cliente em um relat\00F3rio de informa\00E7\00F5es ')
||'do cliente).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771743176311156)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Essa regi\00E3o de Formato Tabular n\00E3o tem uma coluna com "Usar como Cabe\00E7alho de Linha" definido como Sim. A coluna Cabe\00E7alho de Linha deve ser aquela que melhor identifique a linha atual (por exemplo, um nome de cliente em uma tabela de informa\00E7\00F5es de ')
||unistr('clientes). Essas informa\00E7\00F5es ent\00E3o s\00E3o usadas ao renderizar o Formato Tabular para fornecer labels exclusivos para os campos de formato de cada linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291892662310779)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio n\00E3o tem uma ordem padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224291397311520)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A "Fun\00E7\00E3o Hash de Marcador" \00E9 definida como algoritmo legado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224330680311520)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A "Prote\00E7\00E3o de Estado de Sess\00E3o" foi desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424645894311669)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em uma p\00E1gina com processo de extra\00E7\00E3o, voc\00EA deve usar a Prote\00E7\00E3o de Acesso \00E0 P\00E1gina e habilitar a prote\00E7\00E3o para os itens que voc\00EA passar por meio do URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261486573310752)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A regi\00E3o cont\00E9m o URL "f?p" que n\00E3o passou pelo APEX_UTIL.PREPARE_URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291043602310778)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Poss\00EDvel Inje\00E7\00E3o SQL detectada. %0 \00E9 usado com a sintaxe de substitui\00E7\00E3o em c\00F3digo SQL, PL/SQL ou nome da tabela de processos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288827898310777)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288996164310777)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o pode ser referenciado com a sintaxe de substitui\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290873770310778)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina de destino %1 (no aplicativo %0) tem um esquema de autoriza\00E7\00E3o definido, mas o componente atual n\00E3o est\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771943790311156)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Estilo de Tema atual do aplicativo n\00E3o foi testado quanto \00E0 acessibilidade. Mude para um estilo que tenha a op\00E7\00E3o Acessibilidade Testada definida como Sim, ou se seu Estilo de Tema atual tiver sido testado, defina seu atributo Acessibilidade Testad')
||unistr('a como Sim nas defini\00E7\00F5es do Tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866877099311236)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Interface do Usu\00E1rio inclui o jQuery Migrate. Ele ajuda na migra\00E7\00E3o para uma vers\00E3o mais nova do jQuery restaurando APIs removidas e mostra advert\00EAncias na console do browser quando s\00E3o utilizadas APIs removidas ou obsoletas. Isso inclui um arquivo')
||unistr(' JavaScript extra em cada p\00E1gina de seu aplicativo. Para ajudar a remover isso, revise o guia de upgrade do jQuery Migrate para obter detalhes das APIs que devem ser alteradas; depois, quando voc\00EA tiver certeza de que n\00E3o depende mais de nenhuma dess')
||unistr('as APIs, defina Incluir jQuery Migrate como N\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866797256311236)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Interface do Usu\00E1rio inclui fun\00E7\00F5es JavaScript Obsoletas ou N\00E3o Suportadas. Isso inclui um arquivo JavaScript extra em cada p\00E1gina de seu aplicativo. Para ajudar a remover isso, revise a se\00E7\00E3o ''Funcionalidades Obsoletas'' das Notas da Release, onde ')
||unistr('voc\00EA encontrar\00E1 instru\00E7\00F5es sobre como verificar depend\00EAncias para fun\00E7\00F5es obsoletas ou n\00E3o suportadas e providenciar para n\00E3o mais incluir isso em seu aplicativo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291553133310779)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item ou Coluna Associado n\00E3o est\00E1 definido, mas seria exigido pela "Mensagem de Erro Local de Exibi\00E7\00E3o".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291405089310779)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item ou Coluna Associado n\00E3o \00E9 igual ao "%0" especificado na Express\00E3o de Valida\00E7\00E3o 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290481916310778)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de compila\00E7\00E3o - %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106290590812310778)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum c\00F3digo SQL ou PL/SQL definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106288712336310776)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem mais que 32767. Apenas os primeiros 32767 ser\00E3o verificados. Tamanho: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291149887310778)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cont\00E9m a chamada de fun\00E7\00E3o V/NV/DV na instru\00E7\00E3o SQL (pode ser um problema de desempenho).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106291706580310779)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o mencionado n\00E3o existe mais.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671488378311070)
,p_name=>'AFTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618707531311031)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1 faltando o acordo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412848378310870)
,p_name=>'ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015044339311360)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir cria\00E7\00E3o do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956441153311311)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permita a instala\00E7\00E3o de aplicativos de produtividade e amostra.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858246694311230)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir Uso de Servi\00E7os RESTful')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015119297311360)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'Permitir Uso do SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015399539311360)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Permitir Uso do Team Development'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014939077311360)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir que o espa\00E7o de trabalho seja expurgado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015238068311360)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'pt-br'
,p_message_text=>'Permitir Websheet Development'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432019811310884)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Todos os Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249210730310740)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'pt-br'
,p_message_text=>'- Tudo - '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249001582310740)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Categorias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249306084310740)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'pt-br'
,p_message_text=>'- Todas as Categorias -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017630361311362)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'Todos os Marcos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797027194311177)
,p_name=>'ALL_RELEASES'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Releases'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436447790310887)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('todos os arquivos est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435055670310886)
,p_name=>'ALL_THEMES'
,p_message_language=>'pt-br'
,p_message_text=>'todos os temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035742089311375)
,p_name=>'ALL_TYPES'
,p_message_language=>'pt-br'
,p_message_text=>'Todos os Tipos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036157498311376)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'pt-br'
,p_message_text=>'- Todos os Tipos -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432129190310884)
,p_name=>'ALL_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todos os Usu\00E1rios')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420094683311665)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio j\00E1 tem uma conta APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409954695311658)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio j\00E1 existe no espa\00E7o de trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376323900311634)
,p_name=>'ALWAYS'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686334589311082)
,p_name=>'ANALYSIS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 An\00E1lise')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686426150311082)
,p_name=>'ANALYZE'
,p_message_language=>'pt-br'
,p_message_text=>'Analisar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814029863311195)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Analisar usando o m\00E9todo %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433918685310885)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('bloco an\00F4nimo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295064500310781)
,p_name=>'ANSWERS'
,p_message_language=>'pt-br'
,p_message_text=>'Respostas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261138043310751)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'pt-br'
,p_message_text=>'(Qualquer Desenvolvedor)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462080257311695)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00F5es no Aplicativo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461963815311695)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'pt-br'
,p_message_text=>'Hora:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466018779311698)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'pt-br'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462154810311695)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218777438311516)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Uma chamada de API foi proibida.',
'Entre em contato com o administrador.',
unistr('Detalhes sobre este incidente est\00E3o dispon\00EDveis por meio do id de depura\00E7\00E3o "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320390177310803)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A chamada API "%0" n\00E3o \00E9 suportada na vers\00E3o %1 do Application Express. Detalhes sobre este incidente est\00E3o dispon\00EDveis por meio do id de depura\00E7\00E3o "%2".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696263105311089)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o existe na lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973469085311324)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As ramifica\00E7\00F5es Somente para Exibi\00E7\00E3o n\00E3o ser\00E3o suportadas se o atributo de p\00E1gina "Recarregar ao Submeter" estiver definido como "Somente para \00CAxito".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438188134310889)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar ramifica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227431512310720)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418252502310874)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469734894310912)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de condi\00E7\00E3o desconhecido "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223465117310716)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item de navega\00E7\00E3o de arquivo %0 deve usar a tabela APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200820362310696)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de carga "Mesclar" n\00E3o \00E9 suportado para o carregamento em cole\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354076302311618)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de carga "Mesclar" requer pelo menos uma coluna de chave prim\00E1ria no Perfil de Dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353896064311618)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer parsing da Consulta SQL de Origem de Carga: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353911291311618)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'A Consulta SQL de Origem de Carga deve retornar VARCHAR2, CLOB ou BLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631196365311040)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel renderizar a p\00E1gina da caixa de di\00E1logo %1 do aplicativo %0 com sucesso. Verifique se o modelo da p\00E1gina em uso na p\00E1gina %1 \00E9 do tipo "P\00E1gina da Caixa de Di\00E1logo", com inicializa\00E7\00E3o da caixa de di\00E1logo JavaScript apropriada, fechament')
||unistr('o de caixa de di\00E1logo e c\00F3digo de cancelamento de caixa de di\00E1logo definidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451040844311687)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copyright \00A9 %0, Oracle. Todos os direitos reservados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451825673311688)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450955632311687)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 uma mensagem gerada pelo sistema. N\00E3o responda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459443455311693)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Ambiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470016522311701)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio do Oracle Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452411669311688)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conceitos B\00E1sicos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451112185311687)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ol\00E1, %0,')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452146205311688)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459595805311693)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impedir Expurga\00E7\00E3o do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452314624311688)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode impedir seu espa\00E7o de trabalho de ser expurgado, clicando no bot\00E3o abaixo e seguindo as instru\00E7\00F5es na tela. Se voc\00EA n\00E3o agir em %0 dia(s), seu espa\00E7o de trabalho ser\00E1 automaticamente removido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459218680311693)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma a\00E7\00E3o ser\00E1 necess\00E1ria caso voc\00EA n\00E3o precise mais do seu espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459702171311693)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu espa\00E7o de trabalho est\00E1 prestes a ser expurgado!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459022557311693)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu espa\00E7o de trabalho %0 n\00E3o mostrou nenhuma atividade recente e est\00E1 programado para ser expurgado em breve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458963327311693)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aviso! Seu espa\00E7o de trabalho "%0" est\00E1 prestes a ser expurgado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459361073311693)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de Expurga\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460032042311693)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclua sua solicita\00E7\00E3o de espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459875814311693)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu espa\00E7o de trabalho "%0" est\00E1 pronto!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460199263311693)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu espa\00E7o de trabalho "%0" foi aprovado!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459946986311693)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de espa\00E7o de trabalho foi recusada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451759644311688)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459620622311693)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451672608311688)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451233988311687)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o do Espa\00E7o de Trabalho Aprovada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451939433311688)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no bot\00E3o abaixo para concluir o processo de aprova\00E7\00E3o e definir sua senha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451413221311687)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o do espa\00E7o de trabalho foi aprovada!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452039091311688)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no bot\00E3o abaixo para come\00E7ar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452229133311688)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu espa\00E7o de trabalho est\00E1 pronto!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451371039311687)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o do Espa\00E7o de Trabalho Recusada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107451508312311687)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desculpe, sua solicita\00E7\00E3o do espa\00E7o de trabalho foi recusada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227816750310720)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o haver\00E1 suporte para downloads se o atributo de p\00E1gina "Recarregar ao Submeter" estiver definido como "Somente para \00CAxito". Altere o atributo de p\00E1gina "Recarregar ao Submeter" para "Sempre" ou use um antes do processo do cabe\00E7alho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761626826311148)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'pt-br'
,p_message_text=>'Enfileirado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761766698311148)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'pt-br'
,p_message_text=>'Enviado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257638371310748)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257748499310748)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir Entradas de Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257802284310748)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596831885311015)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O grupo "%0" n\00E3o foi encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431857215311674)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Documenta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339749744310817)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O cabe\00E7alho HTTP %0 foi enviado duas vezes. Isso pode ser um ataque.'),
'<ul>',
'<li>1o. valor: "%1"</li>',
'<li>2o. valor: "%2"</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376953629310844)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O suporte a impress\00E3o deve ser STANDARD, ADVANCED, APEX_LISTENER, AOP ou NONE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377090352310844)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel remover o primeiro esquema provisionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280398164310770)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de aplicativo inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796488271311176)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o de E-mail inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272682626310764)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor deve ser zero ou um n\00FAmero inteiro positivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377133021310844)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de porta inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824168956311203)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de assinatura inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377232272310844)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'pt-br'
,p_message_text=>'O caminho da wallet deve estar no arquivo do form:<filesystempath>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456129384310902)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho n\00E3o foi encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456020123310902)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de espa\00E7o de trabalho inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481404562310922)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor n\00E3o deve ser maior que %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391841233310855)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor "%1" do par\00E2metro da inst\00E2ncia "%0" n\00E3o corresponde \00E0 express\00E3o regular "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391750208310855)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O par\00E2metro "%0" da inst\00E2ncia deve ter um valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377324608310844)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro da inst\00E2ncia n\00E3o encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820210734311200)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227506809310720)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha (Somente para autentica\00E7\00E3o no reposit\00F3rio de contas do usu\00E1rio do espa\00E7o de trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012680162311357)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha (Somente para autentica\00E7\00E3o no reposit\00F3rio de contas do usu\00E1rio do espa\00E7o de trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905827381311267)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha (Somente para autentica\00E7\00E3o no reposit\00F3rio de contas do usu\00E1rio do espa\00E7o de trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311894784310796)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha (Somente para autentica\00E7\00E3o no reposit\00F3rio de contas do usu\00E1rio do espa\00E7o de trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535011950310969)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha (Somente para autentica\00E7\00E3o no reposit\00F3rio de contas do usu\00E1rio do espa\00E7o de trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820112778311200)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha (Somente para autentica\00E7\00E3o no reposit\00F3rio de contas do usu\00E1rio do espa\00E7o de trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379272907310846)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O protocolo do servidor de impress\00E3o deve ser http ou https')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379368994310846)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema n\00E3o existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379429762310846)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema \00E9 restrito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252745762310744)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252596785310743)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo n\00E3o existe mais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057426917311392)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'pt-br'
,p_message_text=>'Designar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454368140310901)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384448057311640)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258197752310749)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Fechado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254609361310745)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'pt-br'
,p_message_text=>'Comentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254555831310745)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('coment\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258249404310749)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639678407311046)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'Criou este problema %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229267311310722)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229099097310722)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem certeza de que deseja excluir este coment\00E1rio?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041864785311380)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Problema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238910341310731)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Tem certeza de que deseja excluir este problema?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256200272310747)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Documento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255191021310746)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Documentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229148190310722)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169935545311479)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Coment\00E1rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170041288311479)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Problema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253381834310744)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo especificado n\00E3o existe neste espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253765752310744)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao tentar excluir o coment\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253670599310744)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rio n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253947873310745)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Problema n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254070640310745)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao tentar marcar o problema para exclus\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253412730310744)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina especificada n\00E3o existe neste espa\00E7o de trabalho ou no aplicativo fornecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253889756310745)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio n\00E3o est\00E1 autorizado a excluir este coment\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254107714310745)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio n\00E3o autorizado a excluir este problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253575227310744)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio n\00E3o est\00E1 autorizado a alterar a visibilidade deste coment\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263479460311550)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Ocorreu um problema ao verificar os tamanhos de arquivo. Entre em contato com o administrador do sistema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263348376311550)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um desses arquivos \00E9 maior do que o tamanho m\00E1ximo de %0 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263276146311550)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este arquivo \00E9 maior do que o tamanho m\00E1ximo de %0 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229387750310722)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256082274310747)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254990141310746)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Imagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252368142310743)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('um problema que n\00E3o foi encontrado no sistema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201727039310697)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Prefer\00EAncia do Usu\00E1rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254712864310745)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Anexar Arquivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254432664310745)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Fechado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388316671311642)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255784168310746)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('est\00E1 vazio.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255580698310746)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um destes arquivos \00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254378503310745)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256808601310747)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Permanentemente Selecionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042762016311380)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Expurgar Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256730518310747)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Reintegrar Selecionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254861600310746)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Resposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255642162310746)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>'muito grande para upload. <br>Os arquivos devem ser menores que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255966123310747)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os tipos de arquivos suportados s\00E3o: ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238371536311532)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar um Modelo de Resposta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255491877310746)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este arquivo est\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255870652310746)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o \00E9 um tipo de arquivo suportado.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985278807311333)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'pt-br'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985872649311334)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Problema na Documenta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985335026311333)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Melhoria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985478493311333)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Funcionalidade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985787277311334)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Problema de Instala\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985689467311333)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'Problema de Desempenho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985521171311333)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Problema de Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985974790311334)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'Problema de Treinamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986696943311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986300830311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'pt-br'
,p_message_text=>'CSS / HTML'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986479395311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es Din\00E2micas / JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986191779311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'pt-br'
,p_message_text=>'Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986737756311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Integra\00E7\00E3o do Sistema Externo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986281960311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Integra\00E7\00E3o REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986560438311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986016429311334)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'pt-br'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985151408311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Categoria designada ao problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984275067311332)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106985073379311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea funcional afetada pelo problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984358378311332)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea Funcional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984920776311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDvel de import\00E2ncia designado ao problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984490398311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Import\00E2ncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984806466311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDvel de esfor\00E7o para tratar do problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984573237311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDvel de Esfor\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984789941311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento do problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984606013311333)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987132836311335)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'pt-br'
,p_message_text=>'Backlog'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986873816311334)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cr\00EDtico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106986904815311334)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'pt-br'
,p_message_text=>'Importante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987085905311335)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987243803311335)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Ser\00E1 Tratado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987384756311335)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corre\00E7\00E3o F\00E1cil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987502239311335)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grande Esfor\00E7o de Desenvolvimento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987445284311335)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esfor\00E7o Moderado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987984701311335)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Pode Ser Corrigido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988032183311335)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987703851311335)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Requer Mais Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987861145311335)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'pt-br'
,p_message_text=>'Aguardando Terceiros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106987602337311335)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'pt-br'
,p_message_text=>'Trabalhando nisso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998146165311345)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este Grupo de Labels n\00E3o pode ser exclu\00EDdo porque um ou mais de seus membros foram designados a um problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257917887310748)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106254265445310745)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Duplica\00E7\00E3o marcada de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042216713311380)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'pt-br'
,p_message_text=>'Favorecidos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042104506311380)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'pt-br'
,p_message_text=>'Labels'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042686292311380)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'Marcos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042025788311380)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252188703310743)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'marcos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988402000311336)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Congelamento do C\00F3digo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988647069311336)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'Release Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988559519311336)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Congelamento da Interface de Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256685756310747)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 adicionou um coment\00E1rio a %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200710349310696)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>'foi alterado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005795665311352)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00FAmero do problema %0 no espa\00E7o de trabalho %1 foi alterado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263176379311550)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Label foi definido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258053327310748)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255336061310746)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'pt-br'
,p_message_text=>'Outro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252836229310744)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252642307310743)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina n\00E3o existe mais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381900557311638)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>'Expurgar Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057506571311392)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252456352310743)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Removida a associa\00E7\00E3o de Aplicativo e P\00E1gina de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253104689310744)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Removido o anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356655191311620)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deseja substituir seu coment\00E1rio atual por este modelo?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358629595311621)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ol\00E1! '),
'',
unistr('Este \00E9 o seu primeiro problema! Voc\00EA pode criar problemas para fazer o acompanhamento de tarefas, funcionalidades, bugs e feedback de todos os seus projetos APEX! \00C9 poss\00EDvel adicionar labels aos problemas, adicionar favorecidos, definir marcos e at\00E9 ')
||unistr('mesmo aplicar formata\00E7\00E3o usando Markdown abreviada!  '),
'',
unistr('Abaixo est\00E1 uma r\00E1pida amostra do que voc\00EA pode fazer com a Markdown:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358555694311621)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Bem-vindo ao Team Development no Oracle APEX!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057641765311392)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253222046310744)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Definir o status como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229548287310722)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar a\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358420474311621)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252965492310744)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>'Assinado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263523506311550)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no espa\00E7o de trabalho %1 possui %2 novas notifica\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981762621311330)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo usado para registrar um bug no log.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981674287311330)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981559198311330)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Comportamento Esperado**',
unistr('- Informe o que voc\00EA acredita que deve acontecer.'),
'',
'',
'**Comportamento Atual**',
'- Informe o que acontece.',
'',
'',
unistr('**Quem \00E9 afetado**'),
unistr('- Informe quem/o que \00E9 afetado. '),
'',
unistr('**Poss\00EDvel Solu\00E7\00E3o**'),
unistr('- Se puder, sugira como voc\00EA corrigiria esse bug.'),
'',
'**Etapas a Serem Reproduzidas**',
unistr('- Forne\00E7a um conjunto n\00E3o amb\00EDguo de etapas a serem reproduzidas, incluindo capturas de tela e trechos de c\00F3digo, se for apropriado.'),
'1.',
'2.',
'3.',
'',
'**Contexto**',
unistr('- O que voc\00EA estava tentando fazer quando o bug ocorreu. O bug s\00F3 o corre em determinadas condi\00E7\00F5es, ou em certas horas do dia, e assim por diante.'),
'',
'**Ambiente**',
'',
unistr('- Vers\00E3o: '),
'- Plataforma: ',
'- Subsistema:',
'',
'______',
'',
unistr('_**OBSERVA\00C7\00C3O:** Para associar um problema a um aplicativo e/ou p\00E1gina, primeiro registro o problema, depois use o drop down **A\00C7\00D5ES** para associar o Aplicativo e a P\00E1gina._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982819532311331)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Um bug foi adicionado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982757682311331)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Bug Adicionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982930827311331)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Um **Bug** foi arquivado no sistema externo apropriado.',
'',
'- Sistema de Rastreamento de Bug: ',
'- ID do Bug: ',
'- URL para o bug: ',
'',
unistr('Coment\00E1rios:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981979852311331)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo usado para registrar uma funcionalidade no log.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981821098311331)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Solicita\00E7\00E3o de Funcionalidade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982013288311331)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Resumo da Funcionalidade**',
unistr(' - Forne\00E7a um par\00E1grafo de vis\00E3o geral da solicita\00E7\00E3o da funcionalidade.'),
'',
'',
'**Contexto**',
unistr(' - Essa solicita\00E7\00E3o se refere a uma situa\00E7\00E3o ou processo espec\00EDfico? Por exemplo, "Fico sempre frustrado quando [...]"'),
'',
'',
unistr(' - Forne\00E7a informa\00E7\00F5es de apoio, incluindo capturas de tela, casos de uso e assim por diante.'),
'',
'',
unistr('**Solu\00E7\00E3o Preferencial**'),
unistr('- Forne\00E7a uma descri\00E7\00E3o clara do que voc\00EA gostaria que fosse implementado.'),
'',
'',
unistr('**Solu\00E7\00F5es Alternativas**'),
unistr('- Forne\00E7a uma descri\00E7\00E3o de outras solu\00E7\00F5es ou funcionalidades consideradas, ou de solu\00E7\00F5es alternativas usadas.'),
'',
'',
'______',
unistr('_**OBSERVA\00C7\00C3O:** Para associar um problema a um aplicativo e/ou p\00E1gina, primeiro registre o problema, depois use o drop down **A\00C7\00D5ES** para associar o Aplicativo e a P\00E1gina._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983148818311332)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma solicita\00E7\00E3o de funcionalidade foi arquivada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983071431311331)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Funcionalidade Arquivada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983238684311332)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uma **Solicita\00E7\00E3o de Funcionalidade** foi arquivada no sistema externo apropriado.'),
'',
'- Sistema de Rastreamento de Funcionalidade: ',
'- ID da Funcionalidade: ',
unistr('- URL para a Defini\00E7\00E3o da Funcionalidade: '),
'',
unistr('Coment\00E1rios:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984049833311332)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma a\00E7\00E3o de acompanhamento \00E9 necess\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983986346311332)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o de Acompanhamento Necess\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106984162775311332)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Execute as seguintes a\00E7\00F5es: '),
'',
'1.',
'2.',
'3.',
'4.',
'',
unistr('Coment\00E1rios: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982238141311331)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo usado para fazer uma pergunta de procedimento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982172979311331)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Como Posso...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982342552311331)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Pergunta**',
unistr('- Fa\00E7a sua pergunta ou solicita\00E7\00E3o da forma mais sucinta poss\00EDvel.'),
'',
'**Contexto Geral**',
unistr('- O que voc\00EA est\00E1 tentando fazer? '),
'',
'',
unistr('- Onde mais voc\00EA procurou ou quem mais voc\00EA contatou para encontrar uma resposta? '),
'',
'',
'**Ambiente** ',
unistr('Essa pergunta \00E9 espec\00EDfica de um ambiente, linguagem de programa\00E7\00E3o ou outra \00E1rea?'),
'',
'______',
unistr('_**OBSERVA\00C7\00C3O:** Para associar um problema a um aplicativo e/ou p\00E1gina, primeiro registre o problema, depois use o drop down **A\00C7\00D5ES** para associar o Aplicativo e a P\00E1gina._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983759688311332)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fa\00E7a refer\00EAncia a um problema conhecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983656609311332)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Problema Conhecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983855994311332)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ap\00F3s an\00E1lise, foi determinado que este \00E9 um problema conhecido. Veja os detalhes abaixo.'),
'',
'- Sistema de Rastreamento de Bug: ',
'- ID do Bug: ',
'- URL para o bug: ',
'',
unistr('Coment\00E1rios: ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983498627311332)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicitar mais informa\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983314268311332)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mais Informa\00E7\00F5es S\00E3o Necess\00E1rias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106983592747311332)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**Mais informa\00E7\00F5es s\00E3o necess\00E1rias para esse problema:**'),
'',
unistr('Forne\00E7a as informa\00E7\00F5es solicitadas abaixo. Sem elas, ser\00E1 dif\00EDcil fazer a triagem e continuar a tratar do problema.'),
'',
'',
unistr('Coment\00E1rios:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982583718311331)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esse problema n\00E3o ser\00E1 tratado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982426423311331)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Negativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106982617582311331)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ap\00F3s uma considera\00E7\00E3o cuidadosa, **nenhuma provid\00EAncia mais ser\00E1 tomada quanto a esse problema**. '),
'',
unistr('Coment\00E1rios:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256360370310747)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255288031310746)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252069464310743)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'esse problema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006853886311353)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'anexo %0 adicionado a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005860818311352)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 adicionado a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007402480311353)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'%0 adicionado a %1 %2				'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006024742311352)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 designado a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006448155311352)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 associado a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256506640310747)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('editou um coment\00E1rio para %0	%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454268188310901)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>'editado o problema %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007340285311353)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Esse problema foi oculto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006207715311352)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'pt-br'
,p_message_text=>'%0 marcado como duplicata de %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007298062311353)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 aberto por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006925174311353)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'anexo %0 removido de %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005993083311352)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 removido de %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007581062311353)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'%0 removido de %1 %2 			'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007055600311353)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'status de %0 definido como %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006646931311353)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>'inscrito em %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006166041311352)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('designa\00E7\00E3o de %0 retirada de %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006516354311353)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('removida a associa\00E7\00E3o de Aplicativo e P\00E1gina de %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006317360311352)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'pt-br'
,p_message_text=>'%0 desmarcado como duplicata de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107006796929311353)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('cancelada a inscri\00E7\00E3o de %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007142419311353)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'pt-br'
,p_message_text=>'duplicata de %0 %1 marcada por %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106252278607310743)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o designado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229487048310722)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106253062388310744)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Inscrito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041973369311380)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256128100310747)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo Zip'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106255021905310746)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos Zip'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213350857310707)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 um item de Endere\00E7o Geocodificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351629766311616)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item %0 n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242012342311535)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A checksum da p\00E1gina fornece uma maneira f\00E1cil de determinar se a mesma p\00E1gina foi implantada em outro lugar. Voc\00EA pode comparar essa checksum para determinar se h\00E1 uma correspond\00EAncia.	As altera\00E7\00F5es nos Componentes Compartilhados usados nesta p\00E1gina')
||unistr(' n\00E3o ser\00E3o refletidas nesta checksum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397612345311649)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'pt-br'
,p_message_text=>'Sobre este Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397429720311649)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397534273311649)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Estilo do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230083716310723)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 s\00E3o permitidas fontes CFF (Compact Font Format) com uma fonte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230170431310723)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 s\00E3o permitidas fontes CFF (Compact Font Format) com um elemento top DICT.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230289676310723)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 s\00E3o permitidas fontes CFF (Compact Font Format) com Formato CharString Tipo 2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242477356310734)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A fonte n\00E3o foi encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242349347310734)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente tabelas de formato cmap 4 e 12 s\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242738505310734)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o de p\00E1gina inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242574569310734)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O PDF n\00E3o foi inicializado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242242415310734)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma subtabela cmap v\00E1lida foi encontrada na fonte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242630820310734)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O PDF n\00E3o tem p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677624081311075)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro interno ao criar o arquivo PDF.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248013782310739)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O processo "%0" tem uma Regi\00E3o Edit\00E1vel inv\00E1lida (n\00E3o \00E9 Multilinha) designada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236160152310728)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel obter o pr\00F3ximo valor da chave prim\00E1ria/obter o valor anterior da chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905693464311267)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Web service n\00E3o foi encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443467771310893)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao executar o processo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262777063310753)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O Application Express n\00E3o p\00F4de processar a solicita\00E7\00E3o devido a limita\00E7\00F5es de recurso da sess\00E3o do banco de dados. Tente novamente mais tarde.'),
'<p/>',
unistr('Os detalhes sobre este incidente est\00E3o dispon\00EDveis via id de depura\00E7\00E3o "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236945788310729)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'O seguinte erro ocorreu ao implantar o aplicativo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239679558310731)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo %0 implantado com sucesso no servidor remoto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243348265310735)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo %0 implantado com sucesso como %1 no servidor remoto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877819233311245)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha de autentica\00E7\00E3o do servi\00E7o de SQL Ativada REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263007106310753)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha de autentica\00E7\00E3o. A Lista de Valores usa uma origem de dados SQL Ativada REST que menciona credenciais web inv\00E1lidas, o que impedir\00E1 voc\00EA de editar as informa\00E7\00F5es da coluna nessa LOV. Verifique as credenciais de autentica\00E7\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384145845311639)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha de comunica\00E7\00E3o. Houve um problema ao chamar a origem de dados REST Enabled SQL referenciada pela Lista de Valores, o que o impedir\00E1 de editar informa\00E7\00F5es de coluna da LOV. Verifique se a origem de dados REST Enabled SQL est\00E1 funcionando correta')
||unistr('mente, e tamb\00E9m se as credenciais de autentica\00E7\00E3o correspondentes est\00E3o corretas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879176428311246)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro no Servidor Remoto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853947147311226)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A inst\00E2ncia especificada de SQL Ativada REST do ORDS n\00E3o foi encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459760756310905)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'pt-br'
,p_message_text=>'O servidor enviou um redirecionamento para: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754285471311142)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>'O Demonstrativo SQL tem mais de 32.767 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772990250311157)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ol\00E1, Application Express! Voc\00EA est\00E1 conectado como #USER#.'),
unistr('O timestamp do banco de dados local \00E9: #SYSDATE#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998074588311345)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 editando o alias do esquema padr\00E3o do espa\00E7o de trabalho. A defini\00E7\00E3o deste alias tamb\00E9m alterar\00E1 o Prefixo do Caminho no n\00EDvel do espa\00E7o de trabalho. Isso afetar\00E1 o URL de quaisquer servi\00E7os RESTful Baseados no APEX que voc\00EA possa ter defi')
||'nido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751951334311140)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('refer\00EAncias %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989379135311336)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Utilit\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989450766311336)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Utilit\00E1rios do Aplicativo \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996892144311344)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir para a p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996723908311344)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Ir para Componentes Compartilhados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989518524311337)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989614385311337)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefas do App Builder > '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989777979311337)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989810833311337)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Itens de Aplicativo \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989947567311337)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('L\00F3gica do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990005662311337)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990199959311337)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Esquemas de Autentica\00E7\00E3o de Seguran\00E7a \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990299594311337)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990392349311337)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Esquemas de Autoriza\00E7\00E3o de Seguran\00E7a \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990467342311337)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumbs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990512011311337)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Breadcrumbs \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990696436311337)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990790013311337)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Op\00E7\00F5es de Build \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990800360311338)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Componentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106990947356311338)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Defini\00E7\00F5es do Componente \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991035616311338)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991118401311338)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C C\00E1lculos do Aplicativo \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991296990311338)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Item do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991389663311338)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Esquema de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991423239311340)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Op\00E7\00E3o de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991525378311340)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar C\00E1lculo do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991631392311340)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Modelo de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991759995311340)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991877711311340)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106991984970311340)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Credenciais Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992059660311340)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992136383311341)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue para: Componentes Compartilhados \005C Defini\00E7\00F5es de Carga de Dados \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992268576311341)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'pt-br'
,p_message_text=>'Origens de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992350819311341)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos de Defini\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992428504311341)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992539883311341)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992675147311341)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Layouts de Relat\00F3rio \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992707170311341)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>'Web Services Legados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992830711311341)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Web Services Legados \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106992951220311341)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Listas de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993034407311341)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Listas de Navega\00E7\00E3o Cl\00E1ssica \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993141606311342)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993241905311342)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Lista de Valores \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993309637311342)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993476933311342)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Outros Componentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993545178311342)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993691693311342)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Plug-ins \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993751556311342)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>'Processos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993892685311342)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Processos do Aplicativo \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106993957827311342)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consultas de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994073120311342)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Consultas de Relat\00F3rio \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994133540311342)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994280575311342)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994364325311343)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C REST Enabled SQL \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994412923311343)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994596671311343)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prote\00E7\00E3o de Estado de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994679329311343)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir Prote\00E7\00E3o de Estado do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994855070311343)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Componentes Compartilhados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994967792311343)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995053169311343)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'Atalhos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995177510311343)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Atalhos \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995279042311343)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Guias (Legado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995319340311343)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995407512311343)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Modelos de Interface do Usu\00E1rio \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995571313311343)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'pt-br'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995649833311343)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Temas de Interface do Usu\00E1rio \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995743865311344)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995840806311344)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>'Credenciais Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106995961713311344)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Credenciais Web de Seguran\00E7a \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996007539311344)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'pt-br'
,p_message_text=>'Origem de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996151099311344)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegue at\00E9: Componentes Compartilhados \005C Origens de Dados REST \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996268532311344)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996363618311344)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996486281311344)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>'Criar %LIST_ITEM_NAME% no SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996565396311344)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Editor de Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996600509311344)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefas do SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455487574311690)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item de p\00E1gina %0 \00E9 baseado em uma Coluna do Banco de Dados, mas o atributo ''Origem Usada'' est\00E1 definido como ''Somente quando o valor atual no estado da sess\00E3o for nulo''. Isso \00E9 muito perigoso e pode resultar na substitui\00E7\00E3o acidental de dados ao v')
||unistr('isualizar e salvar v\00E1rios registros. Sempre defina ''Origem Usada'' como ''Sempre, substituindo qualquer valor existente no estado da sess\00E3o''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392737536311645)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O acesso ao estado da sess\00E3o foi desativado; tentativa de leitura/grava\00E7\00E3o bloqueada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276101703310767)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tentativa de salvar o item %0 no estado da sess\00E3o durante o processamento da exibi\00E7\00E3o; o item possui o n\00EDvel de prote\00E7\00E3o Interna Somente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268948071310761)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tentativa de salvar o item %0 no estado da sess\00E3o durante o processamento da aceita\00E7\00E3o; o item possui o n\00EDvel de prote\00E7\00E3o Interna Somente ou n\00E3o \00E9 um item de form que possa ser publicado com o comando POST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268708454310761)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A checksum calculada com base na solicita\00E7\00E3o, limpeza de cache, nomes de argumentos e valores de argumentos (%0) n\00E3o correspondeu \00E0 checksum especificada no procedimento de exibi\00E7\00E3o (%1).'),
'',
unistr('Observa\00E7\00E3o: Os usu\00E1rios finais obt\00EAm uma mensagem de erro diferente.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268290380310760)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tentativa de salvar o item %0 no estado da sess\00E3o durante o processamento de exibi\00E7\00E3o. O n\00EDvel de prote\00E7\00E3o do item indica:'),
' %1',
unistr('Nenhuma checksum foi especificada ou a checksum especificada \00E9 adequada para um item com n\00EDvel de prote\00E7\00E3o "%2".'),
'',
unistr('Observa\00E7\00E3o: os usu\00E1rios finais recebem uma mensagem de erro diferente.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443275938310892)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1022 N\00E3o foi poss\00EDvel salvar os atributos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212801336310707)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel converter o valor SDO_GEOMETRY em GeoJSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210390566310705)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel converter texto em um objeto SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211514882310706)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o cont\00E9m um GeoJSON v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227166365310720)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao calcular valor padr\00E3o para a coluna #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228046394310721)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar Exclus\00E3o de V\00E1rias Linhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470246037310913)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna de checksum ("FCS") \00E9 obrigat\00F3ria e n\00E3o foi fornecida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470458585310913)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram fornecidos valores-chave; pelo menos uma linha deve ser fornecida para que as atualiza\00E7\00F5es ocorram')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471297855310914)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram fornecidos valores secund\00E1rios para a coluna de chave secund\00E1ria identificada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610887373311025)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'nenhum dado encontrado em formato tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470103796310913)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna de chave prim\00E1ria n\00E3o foi especificada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471115304310913)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna de chave secund\00E1ria identificada n\00E3o foi localizada na lista de sele\00E7\00E3o da consulta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470044849310913)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome da Tabela n\00E3o foi especificado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469935404310913)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Propriet\00E1rio da Tabela n\00E3o foi especificado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491171583310933)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao executar processo de Atualiza\00E7\00E3o de V\00E1rias Linhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251316955310742)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel copiar o tema "%0" no aplicativo "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448929040311686)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O tema importado n\00E3o \00E9 compat\00EDvel com o tema atual.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431063523311673)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00FAmero do tema \00E9 inv\00E1lido ou o tema n\00E3o \00E9 um tema de IU atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391837593311645)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As Colunas de Chave Prim\00E1ria e Chave M\00E3e s\00E3o obrigat\00F3rias para calcular a hierarquia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391986588311645)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As Colunas de N\00EDvel e Status do N\00F3 s\00E3o obrigat\00F3rias quando a hierarquia n\00E3o \00E9 calculada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410242123311658)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169285772311479)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383731990310849)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo Escuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383842338310849)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169108452311479)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo Claro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812694800311194)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma interface de usu\00E1rio na lista abaixo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814991420311196)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 - Sele\00E7\00E3o de Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354402136310828)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso n\00E3o autorizado (vari\00E1vel de pacote de grupo de seguran\00E7a n\00E3o definida).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354874380310828)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel extrair informa\00E7\00F5es de localiza\00E7\00E3o do usu\00E1rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340604113310817)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio %0 precisa ter o privil\00E9gio ADMIN para executar esta opera\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354727534310828)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio %0 n\00E3o forneceu um endere\00E7o de e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310570249310794)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso n\00E3o autorizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354674917310828)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio %0 n\00E3o existe.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269605791310761)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A valida\00E7\00E3o "%0" tem uma Regi\00E3o Edit\00E1vel inv\00E1lida (n\00E3o \00E9 Multilinha) designada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443381442310892)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393125464311646)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Application Express n\00E3o pode calcular um perfil de dados com base nos dados de resposta do tipo: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859809289311231)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859763456311231)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379757142311636)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A express\00E3o de filtro n\00E3o \00E9 uma JSON v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372967474311631)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O filtro n\00E3o \00E9 suportado pelos Oracle REST Data Services.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751864897311140)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Par\00E2metro "%0" do URL de Pagina\00E7\00E3o est\00E1 em conflito com um Par\00E2metro de Origem REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854729775311227)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP 200: Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854878421311227)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP 201: Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854237900311227)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 400: Solicita\00E7\00E3o Inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854062596311226)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 401: N\00E3o Autorizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854328475311227)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP 403: Proibido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854102531311226)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 404: N\00E3o Encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854457651311227)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 405: M\00E9todo n\00E3o permitido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212197985310706)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 407: Autentica\00E7\00E3o de Proxy obrigat\00F3ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212482255310707)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP 409: Conflito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212216026310706)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 412: Falha na Pr\00E9-condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212364019310706)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 428: Pr\00E9-condi\00E7\00E3o Obrigat\00F3ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854522897311227)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP 500: Erro Interno do Servidor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854618610311227)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 502: Gateway Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393582879311646)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTTP 503: Servi\00E7o Indispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393604234311646)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP 504: Timeout do Gateway'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235701315311528)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'pt-br'
,p_message_text=>'A Origem de Dados REST retornou um erro de HTTP: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853801466311226)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem de Dados REST n\00E3o encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409636627310868)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Seletor de Linha "%0" n\00E3o selecionou um array de objetos a serem tratados como uma Tabela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409721549310868)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Seletor de Linha "%0" n\00E3o selecionou um objeto a ser tratado como uma Linha \00DAnica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215318150310709)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O limite de taxa da Origem de Dados REST (%0 solicita\00E7\00F5es dentro de %1 segundos) foi excedido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204399516310699)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O limite de taxa da Origem de Dados REST (%0 solicita\00E7\00F5es dentro de %1 segundos) foi excedido e o tempo de espera necess\00E1rio \00E9 longo demais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235656042311528)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O par\00E2metro obrigat\00F3rio IN "%0" do tipo "%1" da Origem REST deve ter um valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153675783311467)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O corpo da resposta \00E9 muito grande para ser exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819061193311199)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O servi\00E7o REST legado do ORDS usa um Tamanho de P\00E1gina Fixo pequeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218959057310712)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Esta chamada de API sincroniza dinamicamente as colunas da tabela com o ',
unistr('-- perfil de dados da Origem de Dados REST executando instru\00E7\00F5es ALTER TABLE. '),
unistr('-- Se n\00E3o for poss\00EDvel alterar um tipo de dados da coluna usando ALTER TABLE, uma mensagem de erro '),
unistr('-- ser\00E1 gerada.'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217892258310711)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel aplicar altera\00E7\00F5es no Perfil de Dados automaticamente; as colunas da tabela local devem ser ajustadas manualmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219012390310713)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- A partir de %0, essa opera\00E7\00E3o ser\00E1 executada:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217010777310711)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O m\00E9todo de sincroniza\00E7\00E3o ''mesclar'' requer a defini\00E7\00E3o de uma chave prim\00E1ria no Perfil de Dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217368111310711)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A tabela local e o perfil de dados n\00E3o t\00EAm colunas comuns.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203947467310699)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'pt-br'
,p_message_text=>'Job abortado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217513499310711)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>'Falha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217635189310711)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incompleto (Limite da solicita\00E7\00E3o excedido)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217740874310711)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O job j\00E1 est\00E1 em execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204842558310700)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204925444310700)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'pt-br'
,p_message_text=>'Programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217490462310711)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217124006310711)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa %0 da Sincroniza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217253863310711)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'pt-br'
,p_message_text=>'%0 (Novo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701952904311094)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00E3o de Teste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773013119311157)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>'Timeout excedido ao extrair todos os dados da Origem REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748966022311137)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os filtros de SQL locais atuais exigem muitas solicita\00E7\00F5es de "Pr\00F3xima P\00E1gina" ao servi\00E7o REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818953769311199)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Tamanho de P\00E1gina Fixo para o Servi\00E7o REST Legado do ORDS \00E9 desconhecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525355648310961)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para P\00E1gina Admin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499882019310939)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521491463310956)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'pt-br'
,p_message_text=>'Comentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505928907310944)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506223171310944)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506637049310944)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506766715310944)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506859470310945)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505616853310944)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar Altera\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505765081310944)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505816592310944)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505588662310944)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494820622310936)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506086164310944)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Marcado(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506154779310944)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506319068310944)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'pt-br'
,p_message_text=>'Finalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494621048310935)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495336990310936)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506463325310944)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>'Acessar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495081211310936)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494978108310936)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494768458310936)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495167413310936)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495283872310936)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506993485310945)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106506552055310944)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes da View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499726145310939)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518948670310954)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511334935310948)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499598795310939)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510319419310947)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade por hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509677315310947)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499436989310939)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498697986310938)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509223324310946)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9d. Decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508604348310946)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510230735310947)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Contexto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507579153310945)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507217706310945)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509585633310946)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Distintos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498485856310938)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508381611310946)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>'Decorrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511279005310948)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'pt-br'
,p_message_text=>'Encerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508973820310946)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498530355310938)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511195023310948)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas de Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507035833310945)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'pt-br'
,p_message_text=>'Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499177672310939)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498965517310939)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511537675310948)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510058325310947)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Visualiza\00E7\00F5es de P\00E1gina Inteira')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508897195310946)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa de IR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507625487310945)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507917740310945)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Atividade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509123477310946)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1x. Decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509348384310946)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>'Mediano Decorrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510725933310947)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510816737310947)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Mensagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509065162310946)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDn. Decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510686903310947)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'pt-br'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508704647310946)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAm. de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510196959310947)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorr\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508434727310946)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510478706310947)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eventos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508509437310946)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508068509310945)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509703121310947)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509931612310947)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views Parciais da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510936247310947)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499002495310939)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511419974310948)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'pt-br'
,p_message_text=>'Motivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499288228310939)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'pt-br'
,p_message_text=>'Resposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106510518945310947)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Extra\00EDdas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498812668310939)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'pt-br'
,p_message_text=>'Programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498773622310938)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507161468310945)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511015212310948)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas com \00CAxito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508280676310946)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'pt-br'
,p_message_text=>'Timestamp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509863817310947)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Total de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507497268310945)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507319370310945)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106508123079310945)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507864009310945)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499326714310939)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agente do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106507736929310945)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106509454488310946)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>'Desempenho Ponderado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492011197310933)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo Fechada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504954235310943)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cancelar Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505428050310943)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505021679310943)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Bot\00E3o - Caixa de Di\00E1logo Fechada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505159322310943)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Relat\00F3rio - Caixa de Di\00E1logo Fechada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505249229310943)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106505358591310943)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494521826310935)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Caracteres do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494106392310935)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517784098310953)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando o Controle de Acesso \00E9 ativado, os Administradores t\00EAm a capacidade de restringir o acesso a determinadas funcionalidades do aplicativo para usu\00E1rios autenticados. Este aplicativo suporta os seguintes 3 n\00EDveis de acesso: Leitor, Colaborador')
||' e Administrador.<p>',
'<ul>',
unistr('  <li><strong>Leitores</strong> t\00EAm acesso somente para leitura a todas as informa\00E7\00F5es e tamb\00E9m podem exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Colaboradores</strong> podem criar, editar e excluir informa\00E7\00F5es e exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Administradores</strong>,al\00E9m da capacidade de Colaboradores, tamb\00E9m podem executar a configura\00E7\00E3o do aplicativo.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517518744310953)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Qualquer usu\00E1rio autenticado pode acessar este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517641946310953)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha <strong>N\00E3o</strong> se todos os usu\00E1rios forem definidos na lista de controle de acesso. Escolha <strong>Sim</strong> se os usu\00E1rios autenticados que n\00E3o estiverem na lista de controle de acesso tamb\00E9m puderem usar este aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515845315310951)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formatos de Data / N\00FAmero a serem usados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515941375310951)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha se vai fornecer m\00E1scaras de formato personalizado ou usar as de formato padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518398911310953)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517335416310953)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516066640310951)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Caracteres do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514854302310950)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar e Colar Dados Delimitados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516120840310951)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00EDmbolo da Moeda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516204842310952)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se seus dados contiverem o s\00EDmbolo de moeda internacional, informe-o aqui. Por exemplo, se seus dados tiverem "&euro;1,234.56" ou "&yen;1,234.56", informe "&euro;" ou "&yen;". Do contr\00E1rio, os dados n\00E3o ser\00E3o carregados corretamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514579032310950)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Importar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516587449310952)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Caractere de Decimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516608092310952)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O caractere de decimal separa o inteiro e as partes decimais de um n\00FAmero.</p>'),
unistr('<p> Qualquer caractere pode ser o caractere de decimal. O caractere especificado deve ser monobyte, e o caractere de decimal deve ser diferente do separador de grupo. O caractere pode ser um espa\00E7o, mas n\00E3o pode ser um n\00FAmero ou um dos seguintes cara')
||'cteres:</p>',
'<ul class="noIndent">',
'<li>mais (+)</li>',
unistr('<li>h\00EDfen (-)</li> '),
'<li>sinal de menor que (<)</li>',
'<li>sinal de maior que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493773619310935)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518405779310954)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515141084310951)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opcionalmente Inclu\00EDdo Por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494064792310935)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um caractere delimitador. Voc\00EA pode usar este caractere para delinear os limites inicial e final de um valor de dados. Caso voc\00EA especifique um caractere delimitador, o Data Workshop ignorar\00E1 espa\00E7os em branco antes dos limites inicial e fina')
||unistr('l de um valor de dados. Tamb\00E9m \00E9 poss\00EDvel usar esta op\00E7\00E3o para incluir um valor de dados com o caractere delimitador especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518281172310953)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Experi\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515523062310951)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) com Falha:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494264186310935)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518569028310954)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514668840310950)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514716730310950)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do arquivo para upload'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515211270310951)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione esta caixa se seus dados contiverem nomes de coluna na primeira linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516391457310952)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Separador de Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516457817310952)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Um separador de grupo \00E9 um caractere que separa grupos de inteiros, por exemplo, para mostrar milhares e milh\00F5es.</p>'),
unistr('<p>Qualquer caractere pode ser o separador de grupo. O caractere especificado deve ser monobyte, e o separador de grupo deve ser diferente de qualquer outro caractere de decimal. O caractere pode ser um espa\00E7o, mas n\00E3o pode ser um n\00FAmero ou um dos se')
||'guintes:</p>',
'<ul class="noIndent">',
'<li>mais (+)</li>',
unistr('<li>h\00EDfen (-)</li> '),
'<li>sinal de menor que (<)</li>',
'<li>sinal de maior que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515344746310951)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) Inserida(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494376226310935)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493973576310935)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518694275310954)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514398603310950)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lembrar nome do usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514412668310950)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se voc\00EA marcar esta caixa de sele\00E7\00E3o, o aplicativo salvar\00E1 seu nome de usu\00E1rio em um cookie de browser persistente chamado "LOGIN_USERNAME_COOKIE".'),
unistr('Quando voc\00EA for at\00E9 a p\00E1gina de log-in na pr\00F3xima vez, '),
unistr('o campo de nome do usu\00E1rio ser\00E1 preenchido automaticamente com esse valor.'),
'</p>',
'<p>',
unistr('Se voc\00EA desmarcar esta caixa de sele\00E7\00E3o e o seu nome de usu\00E1rio j\00E1 estiver salvo no cookie,'),
unistr('o aplicativo o substituir\00E1 por um valor vazio.'),
unistr('Voc\00EA tamb\00E9m pode usar as ferramentas de desenvolvedor do seu browser para remover completamente o cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518775005310954)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'pt-br'
,p_message_text=>'Resposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515658617310951)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas a Serem Revisadas:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493586746310935)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493641260310935)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514902854310950)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515076222310951)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Identifique um caractere separador de coluna. Use <strong>\t</strong> para separadores de guia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515770423310951)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir defini\00E7\00F5es avan\00E7adas para carregamento de dados: S\00EDmbolo de Moeda, Caracteres Decimais, Codifica\00E7\00E3o de Arquivo ou Formatos de Data')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517490014310953)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106494453125310935)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517063340310952)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia de Tema do Usu\00E1rio Final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517118544310952)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se essa op\00E7\00E3o for marcada, os usu\00E1rios finais poder\00E3o escolher seu pr\00F3prio Estilo do Tema usando o link Personalizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516815530310952)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo do Tema do Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516928511310952)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Estilo do Tema padr\00E3o \00E9 aplicado a todos os usu\00E1rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106516711054310952)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'pt-br'
,p_message_text=>'Prazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106515453069310951)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) Atualizada(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493868616310935)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517834060310953)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nomes de Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518056531310953)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite os nomes de usu\00E1rios separados por v\00EDrgulas, pontos e v\00EDrgulas ou espa\00E7o em branco. Os nomes de usu\00E1rio existentes ou duplicados ser\00E3o automaticamente ignorados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517985993310953)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite os nomes de usu\00E1rios aqui')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518174059310953)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Nome de Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106518842171310954)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agente do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106517292900310952)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496596521310937)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496453999310937)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Atividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521119580310956)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496375337310937)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496754859310937)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera\00E7\00E3o de Relat\00F3rio de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496688117310937)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521041036310956)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496869751310937)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Jobs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520919011310956)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521262937310956)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496228672310937)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521341337310956)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497034250310937)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497106108310937)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Log-out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496954993310937)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519129903310954)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Linha por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520647332310955)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520056408310955)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520823356310955)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Fechado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519355040310954)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar e Colar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519690027310954)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar m\00E1scaras de formato padr\00E3o do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519719160310955)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Fornecer formatos personalizados para colunas submetidas a upload'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520194813310955)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7os de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519875807310955)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite que os Usu\00E1rios Finais escolham o Estilo do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519459248310954)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'A Primeira Linha tem Nomes de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520419390310955)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Negativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520373943310955)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'pt-br'
,p_message_text=>'Neutro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520515583310955)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520793594310955)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106520270859310955)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Positivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519979167310955)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519550220310954)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Defini\00E7\00F5es Avan\00E7adas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519255939310954)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivo obtido por upload, separado por v\00EDrgulas (*.csv) ou delimitado por tabula\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523292717310958)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Controle de Atividades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497739288310938)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios - Etapa %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497992228310938)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522827330310958)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522927727310958)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A p\00E1gina de administra\00E7\00E3o permite que os propriet\00E1rios do aplicativo (Administradores) configurem o aplicativo e mantenham os dados comuns usados pelo aplicativo.'),
unistr('Selecionando uma das defini\00E7\00F5es dispon\00EDveis, os administradores podem alterar muito a forma pela qual o aplicativo \00E9 exibido e/ou as funcionalidades dispon\00EDveis para os usu\00E1rios finais.</p>'),
unistr('<p>O acesso a esta p\00E1gina deve ser limitado somente aos Administradores.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523498602310958)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Log de Automa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523570795310959)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina oferece um relat\00F3rio interativo do log de automa\00E7\00F5es.</p>'),
unistr('<p>Analise as informa\00E7\00F5es registradas sobre execu\00E7\00F5es de automa\00E7\00E3o anteriores. O log cont\00E9m timestamps inicial e final, bem como detalhes sobre linhas processadas (bem-sucedidas e com erros). Fa\00E7a drill down at\00E9 Mensagens para ver mensagens individua')
||'is para linhas processadas.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523159770310958)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As defini\00E7\00F5es da configura\00E7\00E3o permitem que voc\00EA torne a funcionalidade espec\00EDfica dispon\00EDvel (ativada) ou indispon\00EDvel (desativada) para os usu\00E1rios finais.</p>'),
unistr('<p>Se uma fun\00E7\00E3o espec\00EDfica n\00E3o estiver 100% pronta ou precisar ser removida temporariamente, clique em <strong>Desativada</strong>.'),
unistr('Depois que ela ficar dispon\00EDvel, basta clicar em <strong>Ativada</strong>.</p>'),
unistr('<p><em><strong>Observa\00E7\00F5es:</strong> As altera\00E7\00F5es feitas aqui n\00E3o ser\00E3o refletidas para os usu\00E1rios individuais que no momento executam o aplicativo. Depois que o usu\00E1rio final sair do sistema e entrar novamente, as defini\00E7\00F5es da funcionalidade revi')
||unistr('sadas ser\00E3o chamadas.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524513262310960)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Configurar Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524614245310960)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a op\00E7\00E3o apropriada para quaisquer usu\00E1rios autenticados.<br>'),
unistr('Selecionar <strong>N\00E3o</strong> torna o aplicativo mais seguro, pois somente os usu\00E1rios especificados podem acessar o aplicativo.'),
unistr('Por\00E9m, se seu aplicativo tiver uma comunidade de usu\00E1rios maior, ent\00E3o manter os usu\00E1rios pode implicar em gastos e talvez voc\00EA prefira escolher <strong>Sim</strong> e s\00F3 inserir Administradores do aplicativo e, possivelmente, Colaboradores.<br>'),
unistr('Se voc\00EA selecionar <strong>Sim</strong>, ent\00E3o tamb\00E9m dever\00E1 selecionar quantos usu\00E1rios n\00E3o inclu\00EDdos na lista de usu\00E1rios ser\00E3o tratados.</p>'),
unistr('<p>Selecione entre endere\00E7os de e-mail necess\00E1rios e qualquer valor alfanum\00E9rico para Nomes de usu\00E1rios.<br>'),
unistr('Geralmente, voc\00EA deve estabelecer esta defini\00E7\00E3o como <strong>Endere\00E7o de E-mail</strong> se seu aplicativo usar (ou for configurado para usar) um esquema de autentica\00E7\00E3o centralizado, como Oracle Access Manager ou SSO.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Este aplicativo suporta os seguintes 3 n\00EDveis de acesso: Leitor, Colaborador e Administrador.'),
'<ul>',
unistr('  <li><strong>Leitores</strong> t\00EAm acesso somente para leitura a todas as informa\00E7\00F5es e tamb\00E9m podem exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Colaboradores</strong> podem criar, editar e excluir informa\00E7\00F5es e exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Administradores</strong> al\00E9m do recurso de Colaboradores, tamb\00E9m podem executar a configura\00E7\00E3o do aplicativo, acessando a se\00E7\00E3o Administra\00E7\00E3o do aplicativo.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524031473310959)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'pt-br'
,p_message_text=>'Log de Erros do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524133896310959)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina fornece um relat\00F3rio interativo de todos os erros inesperados registrados por este aplicativo.</p>'),
unistr('<p>Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades adicionais avan\00E7adas. Clique no bot\00E3o <strong>Redefinir</strong> para red')
||unistr('efinir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524835197310960)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524960965310960)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525002625310960)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p><strong>Ativar Anexos</strong> - Em caso afirmativo, os usu\00E1rios poder\00E3o fazer upload de um anexo em suporte a seu feedback.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497852171310938)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback Enviado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497545994310938)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497250900310937)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521978821310957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique no \00EDcone de feedback ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o, em qualquer p\00E1gina do aplicativo, para deixar feedback para os administradores do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521788159310956)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Esta \00E9 a home page do aplicativo. Clique nos cart\00F5es para acessar diferentes p\00E1ginas do aplicativo ou use o menu de navega\00E7\00E3o na lateral da p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522395934310957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique na lista suspensa do nome na barra de navega\00E7\00E3o para sair do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522274911310957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique no menu do usu\00E1rio ( <span class="fa fa-user" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o para atualizar sua prefer\00EAncia de fuso hor\00E1rio e sair do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521609886310956)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Home Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521861828310957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Esta \00E9 a home page do aplicativo. Clique nos cart\00F5es para acessar diferentes p\00E1ginas do aplicativo ou use o menu de navega\00E7\00E3o na parte superior da p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522108147310957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Clique no menu do usu\00E1rio ( <span class="fa fa-user" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o (parte superior direita da p\00E1gina) para acessar o perfil do usu\00E1rio e sair do aplicativo.<br>'),
unistr('Se voc\00EA clicar em <strong>Exibir Meu Perfil</strong>, poder\00E1 clicar em <strong>Atualizar Perfil</strong> para inserir seus detalhes pessoais e fazer upload de uma foto ou avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522076607310957)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Clique no menu do usu\00E1rio ( <span class="fa fa-user" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o para acessar seu perfil do usu\00E1rio, atualizar sua prefer\00EAncia de fuso hor\00E1rio e sair do aplicativo.<br>'),
unistr('Se voc\00EA clicar em <strong>Exibir Meu Perfil</strong>, poder\00E1 clicar em <strong>Atualizar Perfil</strong> para inserir seus detalhes pessoais e fazer upload de uma foto ou avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522599006310957)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voc\00EA pode inserir, atualizar e excluir dados diretamente dessa grade interativa.<br>'),
unistr('  Insira uma nova linha clicando no bot\00E3o Adicionar Linha.<br>'),
unistr('  Clique duas vezes em uma c\00E9lula ou clique no bot\00E3o <strong>Editar</strong> para atualizar valores de dados, como na edi\00E7\00E3o de dados em uma planilha.</p>'),
'',
unistr('<p>Use o menu A\00E7\00F5es da Linha ( <span class="fa fa-bars" aria-hidden="true"></span> ) na parte superior do relat\00F3rio para duplicar, excluir, atualizar ou reverter as linhas selecionadas.<br> '),
unistr('  Use o menu A\00E7\00F5es da Linha em linhas individuais para tamb\00E9m acessar a view de linha \00FAnica ou adicionar uma nova linha.</p>'),
'',
unistr('<p>Para localizar dados, digite um termo de pesquisa na caixa de di\00E1logo ou clique nos cabe\00E7alhos das colunas para limitar os registros retornados.</p>'),
'',
unistr('<p>Voc\00EA pode executar v\00E1rias fun\00E7\00F5es clicando no bot\00E3o <strong>A\00E7\00F5es</strong>. Isso inclui a sele\00E7\00E3o de colunas que s\00E3o exibidas/ocultadas e sua sequ\00EAncia de exibi\00E7\00E3o, mais v\00E1rios dados e fun\00E7\00F5es de formato. Tamb\00E9m \00E9 poss\00EDvel definir uma view adicion')
||unistr('al dos dados usando a op\00E7\00E3o de gr\00E1fico.</p>'),
'',
unistr('<p>Se quiser salvar suas personaliza\00E7\00F5es, selecione o relat\00F3rio ou clique em download para descarregar os dados.<p>'),
'',
unistr('<p>Para obter informa\00E7\00F5es adicionais, clique em Ajuda na parte inferior do menu A\00E7\00F5es.</p> '),
'',
unistr('<p>Clique no bot\00E3o <strong>Redefinir</strong> para redefinir a grade interativa de volta ao padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522629107310958)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para localizar os dados, digite um termo de pesquisa na caixa de di\00E1logo ou clique nos cabe\00E7alhos da coluna para limitar os registros retornados.</p>'),
'',
unistr('<p>Voc\00EA pode executar v\00E1rias fun\00E7\00F5es clicando no bot\00E3o <strong>A\00E7\00F5es</strong>. Isso inclui a sele\00E7\00E3o de colunas que s\00E3o exibidas/ocultas e sua sequ\00EAncia de exibi\00E7\00E3o, mais v\00E1rios dados e fun\00E7\00F5es de formato. Tamb\00E9m \00E9 poss\00EDvel definir uma exibi\00E7\00E3o adici')
||unistr('onal de dados usando a op\00E7\00E3o do gr\00E1fico.</p>'),
'',
unistr('<p>Se quiser salvar suas personaliza\00E7\00F5es, selecione relat\00F3rio ou clique em download para descarregar os dados.<p>'),
'<br>',
unistr('<p>Para obter informa\00E7\00F5es adicionais, clique em Ajuda na parte inferior do menu A\00E7\00F5es.</p>'),
'',
unistr('<p>Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo para as configura\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522471879310957)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para localizar os dados, digite um termo de pesquisa na caixa de di\00E1logo ou clique nos cabe\00E7alhos da coluna para limitar os registros retornados.</p>'),
'',
unistr('<p>Voc\00EA pode executar v\00E1rias fun\00E7\00F5es clicando no bot\00E3o <strong>A\00E7\00F5es</strong>. Isso inclui a sele\00E7\00E3o de colunas que s\00E3o exibidas/ocultas e sua sequ\00EAncia de exibi\00E7\00E3o, mais v\00E1rios dados e fun\00E7\00F5es de formato. Tamb\00E9m \00E9 poss\00EDvel definir views adicionais d')
||unistr('e dados usando a op\00E7\00E3o do gr\00E1fico, agrupar por e tabela din\00E2mica.</p>'),
'',
unistr('<p>Se quiser salvar suas personaliza\00E7\00F5es, selecione o relat\00F3rio ou clique em download para descarregar os dados. Informe seu endere\00E7o de e-mail e per\00EDodo de assinatura para que os dados sejam enviados regularmente.<p>'),
'',
unistr('<p>Para obter informa\00E7\00F5es adicionais, clique em Ajuda na parte inferior do menu A\00E7\00F5es.</p>'),
'',
unistr('<p>Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo para as configura\00E7\00F5es padr\00E3o.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497379691310937)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497425176310938)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - Log-In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524290307310959)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525192321310961)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525201800310961)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O feedback pode ser inserido pelos usu\00E1rios finais em qualquer p\00E1gina normal dentro do aplicativo.</p>'),
unistr('<p>Este relat\00F3rio mostra o feedback informado, qualquer resposta inserida pelos administradores e o status do feedback.</p>'),
unistr('<p>Clique no \00EDcone de edi\00E7\00E3o (l\00E1pis amarelo) para inserir uma resposta ou atualizar o status do feedback.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Se os destinat\00E1rios de feedback forem definidos, ent\00E3o os envios de feedback tamb\00E9m ser\00E3o feitos por e-mail aos endere\00E7os de e-mail da lista de destinat\00E1rios de feedback.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524340778310960)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar Acesso do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524450213310960)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina mostra um relat\00F3rio de usu\00E1rios do aplicativo e o n\00EDvel de acesso concedido.</p>'),
unistr('<p>Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades avan\00E7adas adicionais.<br>'),
unistr('Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>'),
unistr('<p>Clique no \00EDcone de edi\00E7\00E3o (l\00E1pis amarelo) para editar os detalhes do usu\00E1rio e o n\00EDvel de acesso ou para excluir o usu\00E1rio.</p>'),
unistr('<p>Clique em <strong>Adicionar Usu\00E1rio</strong>, na parte superior do relat\00F3rio, para adicionar um novo usu\00E1rio e seu n\00EDvel de acesso.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106524785776310960)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este form para inserir usu\00E1rios, seus endere\00E7os de e-mail e definir seu n\00EDvel de acesso.'),
unistr('As defini\00E7\00F5es estabelecidas em <em>Configurar Controle de Acesso</em> determinar\00E3o se o nome de usu\00E1rio deve ser o endere\00E7o de e-mail ou se pode ser qualquer entrada alfanum\00E9rica.</p>'),
unistr('<p>Este aplicativo suporta os seguintes 3 n\00EDveis de acesso: Leitor, Colaborador e Administrador.</p>'),
'<ul>',
unistr('  <li><strong>Leitores</strong> t\00EAm acesso somente para leitura a todas as informa\00E7\00F5es e tamb\00E9m podem exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Colaboradores</strong> podem criar, editar e excluir informa\00E7\00F5es e exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Administradores</strong>, al\00E9m do recurso de Colaboradores, tamb\00E9m podem executar configura\00E7\00E3o do aplicativo, acessando a se\00E7\00E3o Administra\00E7\00E3o do aplicativo.</li>'),
'</ul>',
unistr('<p>Ao editar um usu\00E1rio existente, voc\00EA pode bloquear sua conta, o que impedir\00E1 que ele acesse o aplicativo.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Se usar as contas do Oracle Application Express, ent\00E3o os usu\00E1rios inseridos aqui tamb\00E9m devem ser definidos como usu\00E1rios finais por um Administrador do Espa\00E7o de Trabalho que tamb\00E9m pode definir as senhas dos usu')
||unistr('\00E1rios.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106522714917310958)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina de relat\00F3rio exibe os principais registros em um seletor no lado da p\00E1gina. '),
'  Selecione um registro para ver o registro mestre e todos os registros detalhados definidos.<br> ',
unistr('  Clique no \00EDcone de edi\00E7\00E3o ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) para editar o registro mestre.'),
unistr('  Para registros detalhados, clique no l\00E1pis, no in\00EDcio de cada linha, para editar esse registro.</p>'),
unistr('<p>Para limitar os dados exibidos no seletor, digite um termo de pesquisa na caixa de di\00E1logo de pesquisa.</p>'),
unistr('<p>Para adicionar um novo registro mestre, clique em <strong>Criar</strong> na parte superior da p\00E1gina.'),
unistr('  Para registros detalhados, clique no \00EDcone de mais ( + ) na parte superior da regi\00E3o de detalhes para adicionar um registro detalhado.</p>'),
'',
unistr('<p>Clique em <strong>Redefinir</strong> na parte superior da p\00E1gina para redefinir a p\00E1gina novamente \00E0s defini\00E7\00F5es padr\00E3o, removendo qualquer termo de pesquisa e filtros anteriormente definidos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523884332310959)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desempenho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523903125310959)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina fornece um relat\00F3rio interativo do desempenho e popularidade da p\00E1gina. O relat\00F3rio \00E9 classificado por <strong>Desempenho Ponderado</strong> que \00E9 calculado multiplicando-se o tempo M\00E9dio Decorrido e o n\00FAmero de Visualiza\00E7\00F5es de P\00E1gina')
||'.</p>',
unistr('<p>Selecione o per\00EDodo do relat\00F3rio (Padr\00E3o = 1 dia) na parte superior da p\00E1gina, conforme necess\00E1rio.<br>'),
unistr('Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades adicionais avan\00E7adas. Clique no bot\00E3o <strong>Redefinir</strong> para redefi')
||unistr('nir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523617534310959)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523770071310959)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina fornece um relat\00F3rio interativo das visualiza\00E7\00F5es de p\00E1gina mais recentes.</p>'),
unistr('<p>Selecione o per\00EDodo do relat\00F3rio (Padr\00E3o = 1 dia) na parte superior da p\00E1gina, conforme necess\00E1rio.<br>'),
unistr('Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades adicionais avan\00E7adas. Clique no bot\00E3o <strong>Redefinir</strong> para redefi')
||unistr('nir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523026911310958)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o esquema de cor padr\00E3o usado para exibir o aplicativo.</p>'),
unistr('<p>Se a op\00E7\00E3o <strong>Permitir Que os Usu\00E1rios Finais escolham o Estilo do Tema</strong> estiver marcada, ent\00E3o cada usu\00E1rio final pode selecionar os estilos de tema dispon\00EDveis, clicando no link <em>Personalizar</em> no canto inferior esquerdo da Ho')
||'me page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106497658989310938)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Principais Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106523386801310958)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este relat\00F3rio e gr\00E1fico para ver os usu\00E1rios com mais visualiza\00E7\00F5es de p\00E1gina no per\00EDodo especificado.</p>'),
unistr('<p>Selecione o per\00EDodo do relat\00F3rio (Padr\00E3o = 1 dia) e escolha entre os \00EDcones de relat\00F3rio e de gr\00E1fico na parte superior da p\00E1gina.</p>'),
unistr('<p>Para o relat\00F3rio interativo, use o campo de pesquisa ou selecione o cabe\00E7alho da coluna <strong>Usu\00E1rio</strong>, para selecionar um usu\00E1rio espec\00EDfico. \00C9 poss\00EDvel executar v\00E1rias fun\00E7\00F5es, clicando no bot\00E3o <strong>A\00E7\00F5es</strong>, tais como coluna')
||unistr('s exibidas/ocultas, linhas por p\00E1gina e assim por diante. Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513766963310950)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rios \00E0 Lista de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513833828310950)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio(s) adicionado(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512071464310948)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Limpar Cache de P\00E1gina(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495684125310936)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fechar Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513604267310949)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Cole\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495913889310936)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496021824310937)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Feedback Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513592523310949)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Processar o form %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514208331310950)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Obter ID do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513209651310949)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Obter Detalhes do Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512539308310949)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Pr\00F3ximo Valor de Chave Prim\00E1ria/Obter Valor Anterior de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511908463310948)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Cookie de Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511653562310948)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - Salvar Dados da Grade Interativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513402290310949)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Inicializar o form %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512408303310949)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Processada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495773581310936)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512625103310949)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Falha ao Carregar Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495894142310936)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Responder ao Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495468712310936)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511794140310948)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir pesquisa de relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106495526133310936)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513375879310949)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Controle de Acesso salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513091296310949)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513107922310949)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Configura\00E7\00E3o atualizadas. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514170403310950)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Defini\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106511891596310948)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir Cookie de Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106513982523310950)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106514085015310950)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback Enviado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512134514310948)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha(s) #MRD_COUNT# exclu\00EDdas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512218087310948)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00E3o aplicada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512336603310949)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) #MRU_COUNT# atualizada(s); linha(s) #MRI_COUNT# inserida(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512987602310949)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Prefer\00EAncia de Estilo do Usu\00E1rio Final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106496111042310937)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Apar\00EAncia do Aplicativo Salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512764397310949)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar Estilo do Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106512808826310949)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Apar\00EAncia do Aplicativo Salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502485013310941)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502303298310941)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504101781310943)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o do Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502584906310941)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es sobre ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502170807310941)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Atividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493106761310934)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501906249310941)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503918846310942)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Execu\00E7\00E3o da Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492251954310934)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501041883310940)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493002013310934)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501861270310941)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502299753310941)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configurar Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492561323310934)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501479457310941)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'pt-br'
,p_message_text=>'Registros com Falha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501576004310941)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Registros Alterados por Outro Usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501389125310940)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento do Assistente de Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492861587310934)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A contagem m\00E1xima de linhas deste relat\00F3rio \00E9 %0 linhas. Aplique um filtro para reduzir o n\00FAmero de registros em sua consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492738641310934)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados n\00E3o encontrados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502937690310942)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera\00E7\00E3o de Relat\00F3rio de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504383799310943)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exce\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502610687310941)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493424770310935)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback Enviado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503642389310942)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504820438310943)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Itens do Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492668035310934)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Form em %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504782889310943)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens Ocultos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503161084310942)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eventos da P\00E1gina por Hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501276170310940)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503048075310942)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Jobs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502783542310942)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503487975310942)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade Mais Recente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503521105310942)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma atividade encontrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501636957310941)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'pt-br'
,p_message_text=>'Registros Mestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504022012310942)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503252301310942)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas Mais Ativas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492979146310934)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492443034310934)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Registro Selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501726401310941)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Registro Selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504571192310943)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Existem Usu\00E1rios V\00E1lidos - Informa\00E7\00F5es da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504625364310943)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum novo usu\00E1rio v\00E1lido encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503332620310942)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'Erros Recentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492354334310934)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Exibi\00E7\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493209312310934)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106492113224310934)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503781826310942)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Principais Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106503837031310942)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Principais Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106493367556310935)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Usu\00E1rios a serem Adicionados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502844903310942)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Contagens do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106502049030310941)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504448971310943)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Existem Usu\00E1rios V\00E1lidos - Informa\00E7\00F5es da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106504274034310943)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cont\00EAiner do Assistente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106501115160310940)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento do Assistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106521545980310956)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106519072225310954)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem certeza de que deseja sair desta p\00E1gina sem salvar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499613720310939)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linha(s) atualizada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500825709310940)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 Obrigat\00F3rio pelo Menos um Feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500915261310940)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a feedback ou sua experi\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500696194310940)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel remover a si pr\00F3prio da fun\00E7\00E3o de administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500717700310940)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode remover de si mesmo a atribui\00E7\00E3o de administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500187064310940)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#COLUMN_HEADER# deve ser uma data v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106499959553310939)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'#COLUMN_HEADER# deve ter um valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500002399310939)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#COLUMN_HEADER# deve ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500278444310940)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#COLUMN_HEADER# deve ser um valor de timestamp v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498208614310938)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 deve ser uma data v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500475998310940)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser uma data v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500303259310940)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ter algum valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106500556436310940)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um timestamp v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498032766310938)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498192435310938)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 deve ser num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106498315815310938)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 deve ser um timestamp v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415572739311662)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna de Grade Interativa ''%0'' especificada para a A\00E7\00E3o Din\00E2mica ''#COMPONENT_NAME#'' n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415796001311662)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'pt-br'
,p_message_text=>'O processo ''%0'' gerou ''%1'' ao desempenhar o bloqueio de linha. Esse erro pode ocorrer quando o processo emite um SELECT FOR UPDATE em uma view complexa com um trigger instead-of, para bloquear a linha. Defina o atributo de processo ''Bloquear Linha'' c'
||unistr('omo N\00E3o ou C\00F3digo PL/SQL.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415621405311662)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O processo ''%0'' gerou ''%1'' ao executar um comando DML. Esse erro pode ocorrer se uma coluna se basear em uma agrega\00E7\00E3o ou express\00E3o SQL. Defina o atributo de coluna ''S\00F3 Consulta'' como Sim para excluir a coluna da instru\00E7\00E3o INSERT e UPDATE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037384181311376)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna detalhe mestre ''%0'' n\00E3o cont\00E9m um valor. Certifique-se de que o processo ''%1'' seja executado ap\00F3s o processo correspondente da regi\00E3o mestra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397857923311649)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Grade Interativa ''%0'' n\00E3o tem uma coluna mestra definida que \00E9 obrigat\00F3ria para um relacionamento detalhe/mestre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812214930311194)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Grade Interativa ''%0'' n\00E3o tem uma coluna de chave prim\00E1ria definida que \00E9 obrigat\00F3ria para um relacionamento detalhe/mestre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375230853311633)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para uma Grade Interativa Edit\00E1vel, o atributo de P\00E1gina ''Recarregar ao Submeter'' deve ser definido como ''Somente para \00CAxito''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346201259311612)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editor de C\00F3digos: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346331282311612)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'pt-br'
,p_message_text=>'Contrair %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346474048311612)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Cores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346551473311612)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Componente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346679169311612)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'pt-br'
,p_message_text=>' (Erro)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346784910311613)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346186617311612)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346829077311613)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum resultado encontrado.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346980722311613)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum resultado encontrado. Tente pesquisar todas as propriedades clicando no bot\00E3o "Mostrar Tudo" acima.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347057123311613)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'pt-br'
,p_message_text=>'Propriedades do Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347100921311613)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 (Inv\00E1lido)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347210737311613)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347326569311613)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347456898311613)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os componentes selecionados n\00E3o t\00EAm propriedades em comum.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348631717311614)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum componente selecionado no momento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347584708311613)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347619198311613)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Fixar Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347700292311613)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o R\00E1pida: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347810260311613)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Limpar Sele\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107347948673311613)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348014204311613)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348188957311614)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348282334311614)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'pt-br'
,p_message_text=>' (O Valor Varia)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348344196311614)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348430815311614)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' (Advert\00EAncia)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348575068311614)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375313400311633)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para um Form Tabular, o atributo de P\00E1gina ''Recarregar ao Submeter'' deve ser definido como ''Sempre''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154905315311468)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID Est\00E1tico da Regi\00E3o deve ser especificado porque a p\00E1gina cont\00E9m diversas Grades Interativas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380124220310846)
,p_name=>'APEXIR_3D'
,p_message_language=>'pt-br'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490610895310932)
,p_name=>'APEXIR_ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972843419311323)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Inscri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629630166311039)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os agregados s\00E3o exibidos depois de cada interrup\00E7\00E3o de controle e no final do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545598423310977)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'pt-br'
,p_message_text=>'Contar Diferentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491028271310933)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373050528311631)
,p_name=>'APEXIR_AREA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970606243311322)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'pt-br'
,p_message_text=>'Preto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491328754310933)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597270601311016)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405262353311655)
,p_name=>'APEXIR_DAY'
,p_message_language=>'pt-br'
,p_message_text=>'Dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525531723310961)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Marcado(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629937068311040)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gostaria de executar esta a\00E7\00E3o de exclus\00E3o?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608988689311024)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Desativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380324577310846)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358056764310830)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'pt-br'
,p_message_text=>'Rosca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229680557310722)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380281764310846)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- N\00E3o agregar -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356264430311619)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Alternativa Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608811300311024)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629780686311039)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel realizar a solicita\00E7\00E3o de flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959997082311314)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Fun\00E7\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970716276311322)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'pt-br'
,p_message_text=>'Cinza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357832277310830)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar Quando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905766265311267)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>'Prefixo do Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961713579311315)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>'Clique em <a href=''%0''>aqui</a> para gerenciar sua assinatura.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630516917311040)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Mais Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375901054310843)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'pt-br'
,p_message_text=>'- Nova Categoria -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525610942310961)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma agrega\00E7\00E3o definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453707329310901)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 informa\00E7\00F5es de colunas dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525729265310961)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum c\00E1lculo definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405138530311654)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'- Sem Data Final -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458885580311693)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione outra coluna de linha. A express\00E3o ou link HTML na coluna de linha cont\00E9m a coluna definida como piv\00F4 ou coluna agregada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490797675310932)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Agregados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859432593311230)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00FAmero de colunas de exibi\00E7\00E3o atingiu o limite no relat\00F3rio. Clique em Selecionar Colunas no menu A\00E7\00F5es para minimizar a lista de colunas de exibi\00E7\00E3o do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464930909310909)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>'Ordem da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228987200310721)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00FAmero de colunas de exibi\00E7\00E3o atingiu o limite no relat\00F3rio. Clique em Selecionar Colunas no menu A\00E7\00F5es para minimizar a lista de colunas de exibi\00E7\00E3o do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525472990310961)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar como Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357924823310830)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Categoria -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630612994311040)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>'As colunas calculadas recebem o prefixo **.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405091037311654)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Selecionar Coluna de Classifica\00E7\00E3o -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630459677311040)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404949702311654)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959813880311313)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'Encerrando Unidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629893972311039)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o autorizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607152592311023)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Cabe\00E7alho da Coluna deve ser exclusivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405317136311655)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>'Semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226229251310719)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servi\00E7os Administrativos do Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356548633311619)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 autentica\00E7\00E3o configurada para este aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668869294311068)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os seguintes objetos de banco de dados ser\00E3o %0 no esquema selecionado:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668968472311068)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Os seguintes objetos de banco de dados foram %0 com sucesso:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044018763311381)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Rolar para baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044135120311382)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'pt-br'
,p_message_text=>'Rolar para cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232367134310725)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Form de navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356149641311619)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823968748311203)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos Inv\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409358231311657)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o existem p\00E1ginas de mesmo n\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359468834311622)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos a serem criados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359688768311622)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir das Tabelas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359871344311622)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Eliminar Objetos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978833653311328)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'pt-br'
,p_message_text=>'Eliminar Tabelas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978183049311328)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Estes objetos ser\00E3o criados no esquema <strong>%0</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359958515311622)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Estes objetos j\00E1 existem no esquema <strong>%0</strong> e s\00E3o usados por outros espa\00E7os de trabalho. Se voc\00EA continuar, os objetos da Websheet de <strong>%0</strong> ser\00E3o associados tamb\00E9m a este espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360056456311622)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o esquema a ser usado para estes objetos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360103457311622)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'pt-br'
,p_message_text=>'Tabelas existentes a serem usadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360934385311623)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os objetos de banco de dados da websheet ser\00E3o criados com as informa\00E7\00F5es as informa\00E7\00F5es a seguir. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978296607311328)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se voc\00EA preferir criar os objetos da Websheet em um novo esquema use o assistente <a href=%0>Esquema do Banco de Dados da Solicita\00E7\00E3o</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978362845311328)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para executar Websheets, os seguintes objetos s\00E3o necess\00E1rios:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978428778311328)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os objetos do banco de dados da websheet ser\00E3o criados usando as seguintes informa\00E7\00F5es. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978527186311328)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'pt-br'
,p_message_text=>'Tabelas para criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978677688311328)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a remover os objetos do banco de dados da Websheet. Isso eliminar\00E1 os objetos do banco de dados da Websheet e tamb\00E9m os dados internos que cont\00EAm componentes da Websheet em seu espa\00E7o de trabalho. Deseja continuar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978923263311328)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os seguintes objetos inv\00E1lidos precisam ser corrigidos para que as Websheet sejam executadas adequadamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359504313311622)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a remover as defini\00E7\00F5es da Websheet deste espa\00E7o de trabalho. Os objetos do banco de dados da Websheet tamb\00E9m s\00E3o usados por outros espa\00E7os de trabalho, de forma que n\00E3o ser\00E3o eliminados. Os registros associados a este espa\00E7o de tra')
||unistr('balho ser\00E3o exclu\00EDdos. Deseja continuar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979052385311328)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979135380311328)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978719438311328)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359350412311622)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos existentes a serem usados'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281667666310771)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281575235310771)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Processos do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817721740311198)
,p_name=>'APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878705783311246)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733499011311125)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de C\00E1lculo do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736269938311127)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733511421311125)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Processo do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664561645311065)
,p_name=>'APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799018983311178)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707602858311098)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745696056311135)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743757976311133)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226013101310719)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Desenvolvimento de Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744680193311134)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Identifica o Aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704454480311095)
,p_name=>'APPLICATION_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604349597311021)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo est\00E1 reservado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604240408311021)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo deve ser um n\00FAmero inteiro positivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019085290311363)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Imagens do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773721874311157)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307505960310791)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276430684310767)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745521008311135)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408914609311657)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'pt-br'
,p_message_text=>'Nomes de Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855497542311227)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de Substitui\00E7\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743235425311133)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408836379311657)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382946569310848)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743428037311133)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819366533311199)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241104460310733)
,p_name=>'APPLICATION_X'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692004635311086)
,p_name=>'APPROVED'
,p_message_language=>'pt-br'
,p_message_text=>'Aprovado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749898508311138)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O aplicativo foi criado com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411438062311659)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo-Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274394845310765)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274440610310765)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Produtividade ou Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770673673311155)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'pt-br'
,p_message_text=>'Websheet de Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274214006310765)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Websheet'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691563118311086)
,p_name=>'ARCHIVED'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276741117310767)
,p_name=>'ARCHIVELOG'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivamento de Log: Ativado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527674862310963)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'pt-br'
,p_message_text=>'Argumentos Devem Ter Checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615270325311029)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Argumento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615424264311029)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Argumento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685726168311081)
,p_name=>'ASAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O mais r\00E1pido poss\00EDvel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683035461311079)
,p_name=>'ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>'Designado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380503123310847)
,p_name=>'ASSIGNEE'
,p_message_language=>'pt-br'
,p_message_text=>'Favorecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431186938311673)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Atribuir  %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436577125310887)
,p_name=>'ASSOCIATED'
,p_message_language=>'pt-br'
,p_message_text=>'associado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382179120310848)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos Associados'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712876828311108)
,p_name=>'ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438989748311679)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Em Risco'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408091325310866)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a migrar estas op\00E7\00F5es de autentica\00E7\00E3o personalizada deste aplicativo para um esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407525471310866)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo de Autentica\00E7\00E3o Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407998814310866)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Autentica\00E7\00E3o Personalizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407640820310866)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407862405310866)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'pt-br'
,p_message_text=>'URL de Log-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407708400310866)
,p_name=>'AUTH.NONE'
,p_message_language=>'pt-br'
,p_message_text=>'nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413090991310870)
,p_name=>'AUTHENTICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734480571311126)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734171777311125)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428095786310881)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a excluir um esquema de autentica\00E7\00E3o do aplicativo %0. Se o aplicativo n\00E3o estiver atualmente usando a autentica\00E7\00E3o SCHEME ou se este n\00E3o for o esquema de autentica\00E7\00E3o atual, a exclus\00E3o do esquema n\00E3o afetar\00E1 a opera\00E7\00E3o do aplicativ')
||unistr('o. Se o aplicativo estiver usando a autentica\00E7\00E3o SCHEME e se este for o esquema de autentica\00E7\00E3o atual, o aplicativo continuar\00E1 a ser executada com o uso da autentica\00E7\00E3o SCHEME, mas com um esquema de autentica\00E7\00E3o padr\00E3o. Ela usar\00E1 uma p\00E1gina de log-in')
||unistr(' incorporada com verifica\00E7\00E3o de credenciais de "acesso livre" (ou seja, qualquer pessoa ter\00E1 autoriza\00E7\00E3o para executar o aplicativo). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430011570310883)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no bot\00E3o Tornar Atual para que o seu aplicativo use este esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906021798311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'pt-br'
,p_message_text=>'Contas do Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222623603310716)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906105628311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906410359311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906285775311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'pt-br'
,p_message_text=>'Contas de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167891334311478)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel de Cabe\00E7alho HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906682182311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'pt-br'
,p_message_text=>'SSO do Oracle Application Server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906376569311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Diret\00F3rio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906575764311267)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'pt-br'
,p_message_text=>'Credenciais de Acesso Livre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200574702310696)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso \00E0 SAML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251118667310742)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'pt-br'
,p_message_text=>'Acesso Social'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774737331311158)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734054666311125)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222765723310716)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241332195310733)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241451732310733)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o PL/SQL que Retorna Booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596979073311015)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1 na Atribui\00E7\00E3o ou Grupo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597018275311015)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Est\00E1 na Atribui\00E7\00E3o ou Grupo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241564715310733)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Item da Express\00E3o 1 \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241640926310733)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item da Express\00E3o1 \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241718999310733)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item da Express\00E3o 1 \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241876450310734)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Item da Express\00E3o 1 N\00C3O \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241930453310734)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL N\00C3O Existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242068061310734)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Prefer\00EAncia da Express\00E3o 1 \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242142375310734)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Prefer\00EAncia da Express\00E3o 1 N\00C3O \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293216026310780)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avaliar a cada view de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293379156310780)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avaliar uma vez por sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245053187310736)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Conta Expirada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244981277310736)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Conta Bloqueada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245364053310737)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero M\00E1ximo de Tentativas de Log-in Excedido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245414276310737)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro Interno Desconhecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245281822310737)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro Uso da Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245186481310737)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'pt-br'
,p_message_text=>'Senha Incorreta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244781514310736)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Normal, autentica\00E7\00E3o bem-sucedida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244827702310736)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de Usu\00E1rio Desconhecido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339613673310817)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de Espa\00E7o de Trabalho Desconhecido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349716104310824)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de Espa\00E7o de Trabalho Desconhecido: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470792884310913)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00E3o de commit n\00E3o aplic\00E1vel. Todas as instru\00E7\00F5es t\00EAm commit autom\00E1tico.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168833365311478)
,p_name=>'AUTOMATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168931689311478)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o de Automa\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799674913311179)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo de Provisionamento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220269665310714)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro Item'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821132740311201)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'pt-br'
,p_message_text=>'Disponibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249456651310741)
,p_name=>'AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956072536311311)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispon\00EDvel Apenas para Desenvolvedores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955908730311310)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispon\00EDvel com a Barra de Ferramentas do Desenvolvedor')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708493629311099)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tempo M\00E9dio de Renderiza\00E7\00E3o (Segundos)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689986717311084)
,p_name=>'BAR_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Barras')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007750709311354)
,p_name=>'BASIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('B\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263359601310754)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desenvolvedor B\00E1sico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671310133311070)
,p_name=>'BEFORE'
,p_message_language=>'pt-br'
,p_message_text=>'Antes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414213883311661)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Antes da Entrada da Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430252599311672)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Primeiro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737314832311128)
,p_name=>'BIND_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label do Bind'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736747394311128)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel de Bind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736883091311128)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label da Vari\00E1vel de Bind')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751306273311139)
,p_name=>'BLACK_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto em Preto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226687827310719)
,p_name=>'BLANK'
,p_message_language=>'pt-br'
,p_message_text=>'Em Branco'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712046779311107)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857110530311229)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275329486310766)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato Blob'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857518514311229)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857263208311229)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857308477311229)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857407851311229)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713078876311108)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>'Formato BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712554616311108)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna da \00DAltima Atualiza\00E7\00E3o do BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711996306311107)
,p_name=>'BLOB_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela BLOB'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751267636311139)
,p_name=>'BLUE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto em Azul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728401154311120)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297099229310783)
,p_name=>'BRANCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491513502310933)
,p_name=>'BREADCRUMB'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672078427311071)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672116061311071)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome Longo do Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491649347310933)
,p_name=>'BREADCRUMBS'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumbs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760194113311146)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773953479311158)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada Breadcrumb: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604698647311021)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas de Breadcrumb')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679585685311076)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o de Breadcrumb')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353600176310827)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O breadcrumb foi criado com sucesso.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674686781311073)
,p_name=>'BROWSE_ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Procurar \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674410030311073)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar Pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615092383311029)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar Tabela'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206385699310701)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'pt-br'
,p_message_text=>'ACLs de Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202695976310698)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250999661310742)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao fazer backup do aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202798075310698)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202938272310698)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>'Processos do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250669149310742)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo %0 restaurado da revis\00E3o %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202564456310697)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013421154311358)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'Propriedades do Aplicativo: Modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756790451311144)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203649884310698)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203782372310699)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205322818310700)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumbs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205429258310700)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202818260310698)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205607753310700)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205596370310700)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756508934311144)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Componentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167768914311478)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167649724311477)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167593152311477)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204051380310699)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Componentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210548076310705)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>'Credenciais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206830504310701)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214737785310709)
,p_name=>'BU.DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214843330310709)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'pt-br'
,p_message_text=>'Desenvolvedores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204223589310699)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251008235310742)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O backup do aplicativo est\00E1 em andamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205927692310701)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756908235311144)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo Backup: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756460003311143)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Atualiza\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203010585310698)
,p_name=>'BU.LISTS'
,p_message_language=>'pt-br'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205882006310700)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250781742310742)
,p_name=>'BU.LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203305899310698)
,p_name=>'BU.LOVS'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206225402310701)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210412887310705)
,p_name=>'BU.MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214625842310709)
,p_name=>'BU.MODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203529295310698)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756699154311144)
,p_name=>'BU.NEW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205213820310700)
,p_name=>'BU.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167409361311477)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167355435311477)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167212139311477)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203457773310698)
,p_name=>'BU.PLUGINS'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205755475310700)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210784099310705)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Servidores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206634736310701)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206179921310701)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711729971311107)
,p_name=>'BU.RESTORED'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo Restaurado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241084708310733)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo restaurado da revis\00E3o %0 do backup')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204774721310699)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206544178310701)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'pt-br'
,p_message_text=>'Consultas compartilhadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204124348310699)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'Atalhos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204406294310699)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos de Aplicativo Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204582527310699)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos de Espa\00E7o de Trabalho Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247926450310739)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resumo de altera\00E7\00F5es n\00E3o dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206078883310701)
,p_name=>'BU.TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106204612989310699)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203213778310698)
,p_name=>'BU.THEMES'
,p_message_language=>'pt-br'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206415175310701)
,p_name=>'BU.TREES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250818044310742)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203188670310698)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos da Interface do Usu\00E1rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106203877107310699)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>'Credenciais Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206750752310701)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>'Web Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210653259310705)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'pt-br'
,p_message_text=>'Origens de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230535868310723)
,p_name=>'BUFFER CACHE'
,p_message_language=>'pt-br'
,p_message_text=>'Buffer Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686266263311082)
,p_name=>'BUG'
,p_message_language=>'pt-br'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709570416311099)
,p_name=>'BUGS'
,p_message_language=>'pt-br'
,p_message_text=>'Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730918784311123)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>'bugs designados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768174615311153)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Bugs Designados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259106657310749)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Bugs fechados (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036644431311376)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual de bugs fechados (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768254598311153)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bugs N\00E3o Designados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768303896311153)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Corre\00E7\00E3o por Datas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037041289311376)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'pt-br'
,p_message_text=>'Bugs: %1 de %0 fechados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435572281311676)
,p_name=>'BUG_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Bug: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724654072311117)
,p_name=>'BUILD QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214456988310708)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214300179310708)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214298180310708)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214542983310708)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214137568310708)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818740285311199)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816108030311197)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('[N\00E3o suportado]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015437405311360)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mensagem do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420206986310875)
,p_name=>'BUILD_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865707767311235)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Build: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434272508311675)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Status do Build: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866598448311236)
,p_name=>'BUILD_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o do Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762019061311148)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desenvolver o Modelo de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670605702311070)
,p_name=>'BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858865710311230)
,p_name=>'BUTTON.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238702734310731)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os Atributos do Bot\00E3o selecionado n\00E3o devem conter um ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238639128310731)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o selecionado deve ser um bot\00E3o com uma A\00E7\00E3o configurada como ''Definido por A\00E7\00E3o Din\00E2mica''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238816817310731)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o selecionado usa um ''Modelo de Bot\00E3o'' que n\00E3o cont\00E9m a string de substitui\00E7\00E3o #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858602104311230)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297237970310783)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275981054310766)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta do Relat\00F3rio deve ser especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274020080310765)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Solicita\00E7\00E3o de Bot\00E3o deve ser especificada em todos os Tipos de Origem da Solicita\00E7\00E3o de Bot\00E3o, a menos que o Tipo de Origem da Solicita\00E7\00E3o de Bot\00E3o seja "Sempre Nulo".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274703934310765)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Tipo de Origem de Solicita\00E7\00E3o do Bot\00E3o deve ser especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297320473310783)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o Destino do URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240709335310732)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando a A\00E7\00E3o \00E9 ''Definido por A\00E7\00E3o Din\00E2mica'', os Atributos do Bot\00E3o n\00E3o devem conter um ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298432940310784)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'A imagem deve ser especificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298542003310784)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'O estilo deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298302803310784)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o modelo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240632677310732)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando o Estilo de Bot\00E3o \00E9 ''Bot\00E3o Baseado em Modelo'' e A\00E7\00E3o \00E9 ''Definido por A\00E7\00E3o Din\00E2mica'', o Modelo de Bot\00E3o selecionado deve conter a string de substitui\00E7\00E3o #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228545335310721)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o n\00E3o pode ser deletado, pois ele \00E9 referenciado em uma A\00E7\00E3o Din\00E2mica (P\00E1gina: %0, A\00E7\00E3o Din\00E2mica: ''%1'', A\00E7\00E3o: ''%2'', Atributo: ''Elemento Afetado'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228435254310721)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bot\00E3o n\00E3o pode ser deletado, pois ele \00E9 referenciado em uma A\00E7\00E3o Din\00E2mica (P\00E1gina: %0, A\00E7\00E3o Din\00E2mica: ''%1'', Atributo: ''Quando'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858709208311230)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106854913130311227)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'Para ser usado em um atributo"onclick"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858182539311229)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Para ser usado em um atributo"href"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297117076310783)
,p_name=>'BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737788724311128)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos do Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434088228311675)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742068713311132)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Bot\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294432645310781)
,p_name=>'BYTES'
,p_message_language=>'pt-br'
,p_message_text=>'bytes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685864672311081)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No pr\00F3ximo patch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685928427311081)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Na pr\00F3xima release')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508637650311728)
,p_name=>'CA.ABOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Sobre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474957282311704)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Sobre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474887393311704)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inclua uma p\00E1gina sobre este aplicativo que apresente uma descri\00E7\00E3o do aplicativo, sua vers\00E3o e uma contagem de p\00E1ginas.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397858121310859)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cont\00EAiner do Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508813112311728)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Sobre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508959984311728)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'O texto sobre este aplicativo pode ser colocado aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508586545311728)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sobre esta P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519721907311736)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sobre este pr\00E9-lan\00E7amento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357797732310830)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel remover a si pr\00F3prio da fun\00E7\00E3o de administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357680561310830)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode remover de si mesmo a atribui\00E7\00E3o de administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475292354311704)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511135766311730)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500640788311722)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o do Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473688533311703)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativar autoriza\00E7\00E3o do usu\00E1rio com base na fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475397347311704)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incorpora a autentica\00E7\00E3o do usu\00E1rio com base na fun\00E7\00E3o dentro do aplicativo.'),
unistr('Os usu\00E1rios podem ser definidos como Administradores, Colaboradores ou Leitores.'),
unistr('Voc\00EA pode definir rapidamente acesso diverso a diferentes fun\00E7\00F5es para os v\00E1rios componentes por todo o aplicativo, como p\00E1ginas, entradas do menu, regi\00F5es, colunas, itens, bot\00F5es e assim por diante.</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>\00C1rea da p\00E1gina administrativa com links para acessar as funcionalidades de controle</li>'),
unistr('<li>Tabela de usu\00E1rios para gerenciar o controle de acesso</li>'),
unistr('<li>P\00E1gina de configura\00E7\00E3o para definir o n\00EDvel de acesso aos usu\00E1rios autenticados</li>'),
unistr('<li>P\00E1gina de configura\00E7\00E3o para especificar se os nomes de usu\00E1rios s\00E3o ou n\00E3o endere\00E7os de e-mail</li>'),
unistr('<li>P\00E1gina de gerenciamento de acesso dos usu\00E1rios para reportar e editar o acesso do usu\00E1rio</li>'),
unistr('<li>P\00E1gina de adi\00E7\00E3o de usu\00E1rio com a capacidade de adicionar um \00FAnico usu\00E1rio</li>'),
unistr('<li>P\00E1gina de adi\00E7\00E3o de v\00E1rios usu\00E1rios com a capacidade de adicionar v\00E1rios usu\00E1rios (somente nomes de usu\00E1rios do e-mail)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499572247311721)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500297964311722)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acessar ID de Atribui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329320741310809)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499679710311722)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Conta Bloqueada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357243016310830)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510952089311730)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es sobre ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511686438311730)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios insuficientes; o usu\00E1rio n\00E3o \00E9 um Administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511712048311730)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o est\00E1 autorizado a exibir este aplicativo porque n\00E3o recebeu acesso ou sua conta foi bloqueada. Entre em contato com o administrador do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511880424311730)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios insuficientes; o usu\00E1rio n\00E3o \00E9 um Colaborador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501341536311723)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Controle de Acesso salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506032779311726)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTML de Bot\00E3o de A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504946117311725)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label da A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505018788311725)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Link de A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507651967311727)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTML de Link de A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493138790311717)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Processada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498688027311721)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade por hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531849278311745)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Controle de Atividades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475429137311704)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Atividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474601656311704)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir atividade do usu\00E1rio e relat\00F3rios de erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475573414311704)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inclui v\00E1rios relat\00F3rios sobre a atividade do usu\00E1rio final de seu aplicativo. Determina os usu\00E1rios mais ativos, as p\00E1ginas mais utilizadas, o desempenho das p\00E1ginas e os erros surgidos, para compreender melhor como o aplicativo est\00E1 sendo utiliz')
||unistr('ado e as \00E1reas a serem aprimoradas.</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Relat\00F3rio de principais usu\00E1rios</li>'),
unistr('<li>Relat\00F3rio do Log de Erros do Aplicativo</li>'),
unistr('<li>Desempenho da P\00E1gina, atividade e desempenho por p\00E1gina</li>'),
unistr('<li>Relat\00F3rio de atividade do aplicativo por p\00E1gina</li>'),
unistr('<li>Relat\00F3rio detalhado das visualiza\00E7\00F5es de p\00E1gina</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721637713311115)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio Real')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510868307311730)
,p_name=>'CA.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506269582311726)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Modelo de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522755785311738)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios - Etapa 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509113914311728)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Novo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492195967311716)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397752103311649)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500387028311722)
,p_name=>'CA.ADD.USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523185932311738)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477046125311705)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionando P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477550462311706)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique em <strong>Adicionar P\00E1gina</strong> para adicionar uma p\00E1gina a seu aplicativo. Em seguida, selecione um tipo de p\00E1gina (como Em Branco, Gr\00E1fico, Form, Relat\00F3rio etc.) e defina seus atributos. Tamb\00E9m pode ser necess\00E1rio especificar uma tab')
||unistr('ela ou view v\00E1lida ou usar o SQL Workshop para preparar os objetos do banco de dados em seu espa\00E7o de trabalho.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507032481311727)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avan\00E7ado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720971521311114)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es Adicionais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500039857311722)
,p_name=>'CA.ADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480255998311708)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480883200311708)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina o n\00EDvel de acesso dos usu\00E1rios autenticados deste aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479369902311707)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Atividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480324333311708)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482019227311709)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480723533311708)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'pt-br'
,p_message_text=>'Administradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754158120311142)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853752674311226)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515617850311733)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515727450311733)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478968009311707)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Estilo do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479070245311707)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Define a apar\00EAncia e a funcionalidade do aplicativo padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478684787311707)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478526383311707)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar ou desativar funcionalidades do aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479656336311707)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'pt-br'
,p_message_text=>'Log de Erros do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479786142311707)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de erros registrados por este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479194282311707)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479287868311707)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina um nome e uma descri\00E7\00E3o curta para o aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478760463311707)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478839170311707)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mantenha a lista de atualiza\00E7\00F5es do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478269950311706)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480609372311708)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'pt-br'
,p_message_text=>'Colaboradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530671424311744)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Controle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530596783311744)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir m\00E9tricas de atividade do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483714279311710)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fuso Hor\00E1rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483827440311710)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina o fuso hor\00E1rio padr\00E3o deste aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481518587311709)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483943125311710)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484091517311711)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Defina se o e-mail deve ser enviado e, em caso afirmativo, quem deve responder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481051944311708)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481304629311709)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481464178311709)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Gerencie se os anexos devem ser permitidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481199170311708)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Feedback do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481200369311709)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de todo o feedback enviado pelos usu\00E1rios do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481668731311709)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481748684311709)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Gerencie HTML e CSS do modelo de e-mail usado por este aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478381472311706)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478424221311706)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir notifica\00E7\00F5es na home page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516324437311734)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398466061311650)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Log de Automa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398532287311650)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de execu\00E7\00F5es de automa\00E7\00E3o e mensagens registradas em log por este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479881459311708)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desempenho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479975262311708)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de atividade e desempenho por p\00E1gina do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480082955311708)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480156964311708)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de cada visualiza\00E7\00E3o de p\00E1gina por usu\00E1rio, incluindo a data de acesso e o tempo decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480505517311708)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'pt-br'
,p_message_text=>'Leitores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523822680311739)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523988027311739)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar e-mail baseado em modelo deste aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479422163311707)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Principais Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107479560126311707)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de views de p\00E1gina agregadas por usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480479957311708)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107480971733311708)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altere as defini\00E7\00F5es de controle de acesso e desative o controle de acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481887923311709)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'pt-br'
,p_message_text=>'Log de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107481936839311709)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Exiba log de e-mails enviados por este aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489463280310932)
,p_name=>'CA.ADVANCED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Avan\00E7ado</strong> - Expanda para ver op\00E7\00F5es avan\00E7adas.'),
'    <ul>',
unistr('      <li><strong>Definir como Home Page</strong> - Torne esta p\00E1gina a home page do aplicativo.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Qualquer p\00E1gina definida anteriormente como a home page ser\00E1 atualizada.</li>'),
unistr('      <li><strong>Definir como P\00E1gina de Administra\00E7\00E3o</strong> - Adicione esta p\00E1gina sob Administra\00E7\00E3o, em vez de como p\00E1gina normal no aplicativo. Acesse clicando em Administra\00E7\00E3o no menu principal e depois selecionando na lista de Administra\00E7\00E3o d')
||'e Aplicativos.<br>',
unistr('        <em><strong>Observa\00E7\00E3o:</strong> Uma p\00E1gina n\00E3o pode ser uma Home page e uma p\00E1gina sob Administra\00E7\00E3o.</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>Ajuda da P\00E1gina</strong> - Digite o texto a ser adicionado ao Texto de Ajuda da p\00E1gina.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376587348310844)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Avan\00E7ado</strong> - Expanda para ver op\00E7\00F5es avan\00E7adas.'),
'    <ul>',
unistr('      <li><strong>Ajuda da P\00E1gina</strong> - Digite um texto a ser adicionado ao Texto da Ajuda da p\00E1gina.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516785810311734)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00F5es Avan\00E7adas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516868289311734)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Fa\00E7a defini\00E7\00F5es adicionais, de seguran\00E7a e de globaliza\00E7\00E3o. Essas defini\00E7\00F5es podem ser aplicadas durante a cria\00E7\00E3o do aplicativo e tamb\00E9m editadas ap\00F3s a cria\00E7\00E3o do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518773651311735)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Leia a ajuda do item ( <span class="fa fa-question-circle" aria-hidden="true"></span> ) referente a cada defini\00E7\00E3o para obter mais informa\00E7\00F5es.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524529146311739)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s as Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505911402311726)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTML ap\00F3s as Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509035240311728)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505103161311725)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'pt-br'
,p_message_text=>'Permitir Recusa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714584853311109)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir Execu\00E7\00F5es no Modo Restrito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498523128311721)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'pt-br'
,p_message_text=>'Log de Erros do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494483215311718)
,p_name=>'CA.APP.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764591539311150)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se o controle de acesso est\00E1 ou n\00E3o ativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764627899311150)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00EDvel de acesso padr\00E3o fornecido a usu\00E1rios autenticados que n\00E3o est\00E3o na lista de controle de acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494813819311718)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do aplicativo atualizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494676783311718)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o Breve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494720823311718)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto inserido aqui \00E9 exibido sob o nome do aplicativo na home page do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484135343311711)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484223928311711)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Defina o esquema de cores do aplicativo padr\00E3o (estilo de tema) no qual a navega\00E7\00E3o est\00E1 localizada e o \00EDcone usado para o aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503633503311724)
,p_name=>'CA.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490778358311715)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484790470311711)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484863307311711)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique em <strong>Escolher Novo \00CDcone</strong> para selecionar a cor do \00EDcone e um dos \00EDcones dispon\00EDveis. Sua sele\00E7\00E3o \00E9 exibida na home page do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485117559311711)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485201730311711)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe um identificador num\00E9rico, exclusivo para seu aplicativo. Este campo cont\00E9m um identificador gerado automaticamente, por padr\00E3o.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504246683311725)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496493351311719)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475001443311704)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473929756311703)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina um nome e uma descri\00E7\00E3o curta para o aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475105847311704)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os administradores do aplicativo atualizem v\00E1rias defini\00E7\00F5es, como o nome do aplicativo e uma descri\00E7\00E3o, fuso hor\00E1rio padr\00E3o e assim por diante.</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Entrada e form da lista da p\00E1gina administrativa</li>'),
'<li>Capacidade de definir o nome do aplicativo</li>',
unistr('<li>Capacidade de definir o subt\00EDtulo da \00E1rea de imagem principal da home page</li>'),
unistr('<li>Capacidade de definir destinat\00E1rios de feedback, se usar o feedback</li>'),
unistr('<li>Capacidade de definir o fuso hor\00E1rio padr\00E3o do aplicativo</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529605613311743)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531432685311744)
,p_name=>'CA.APPLY'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533231203311746)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicando padr\00F5es do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489939284311715)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar Altera\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531291958311744)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851871990311225)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo criado com base no assistente de cria\00E7\00E3o de aplicativos %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853133363311226)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Defini\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535478636311747)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591382393311011)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem de Anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535567339311747)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591253103311011)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531598331311744)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00F5es de Atributo j\00E1 definidos para: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500731646311722)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Qualquer usu\00E1rio autenticado pode acessar este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485901878311712)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486080985311712)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Selecione como voc\00EA deseja que os usu\00E1rios sejam autenticados em seu aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717214809311111)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Elimina\00E7\00E3o Autom\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399159582311650)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Execu\00E7\00E3o da Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497196851311720)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9d. Decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761823483311148)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voltar ao Relat\00F3rio de Jobs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592022237311012)
,p_name=>'CA.BCC'
,p_message_language=>'pt-br'
,p_message_text=>'CCO'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524494816311739)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Antes das Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505850884311726)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'pt-br'
,p_message_text=>'HTML antes das Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507327844311727)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo antes das Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482637011311709)
,p_name=>'CA.BLANK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina em Branco')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482739214311710)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina em branco como placeholder. Quando voc\00EA criar o aplicativo, poder\00E1 prontamente criar regi\00F5es na p\00E1gina com base no Designer de P\00E1ginas.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone para exibir no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('<!--  <li><strong>Incluir Navega\00E7\00E3o de P\00E1gina</strong> - Marque esta op\00E7\00E3o para exibir uma lista de cart\00F5es de todas as outras p\00E1ginas definidas no seu aplicativo.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Esta op\00E7\00E3o em geral \00E9 usada na home page do seu aplicativo.</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516015177311733)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'pt-br'
,p_message_text=>'Projeto do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516145155311733)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O blueprint lista a defini\00E7\00E3o do aplicativo no formato JSON.</p>'),
unistr('<p>Quando se acessa essa tela pela primeira vez, a defini\00E7\00E3o atual do aplicativo \00E9 transformada em um documento JSON e exibida. Voc\00EA pode editar o documento para atualizar as propriedades do aplicativo e, em seguida, clicar em <strong>Aplicar Bluepri')
||'nt</strong> para alterar os detalhes do aplicativo atual.</p>',
'<p>&nbsp;</p>',
unistr('<p>Se for necess\00E1rio criar um n\00FAmero grande de p\00E1ginas semelhantes, a a\00E7\00E3o de copiar o c\00F3digo JSON relevante de uma p\00E1gina, colar diversas vezes e fazer pequenos ajustes no JSON ser\00E1 significativamente mais r\00E1pida do que usar manualmente a a\00E7\00E3o <stro')
||unistr('ng>Adicionar P\00E1gina</strong> para cada p\00E1gina.</p>'),
unistr('<p>Clique em <strong>Carregar um Blueprint Anterior</strong> para substituir o blueprint pela defini\00E7\00E3o de um aplicativo gerado anteriormente. Dessa forma, ser\00E1 poss\00EDvel iterar muito facilmente um design de aplicativo adicionando mais p\00E1ginas, altera')
||unistr('ndo as funcionalidades ou ajustando as defini\00E7\00F5es, antes de gerar o aplicativo novamente.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504742423311725)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Corpo1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504898381311725)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Corpo2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524871906311740)
,p_name=>'CA.BOTH'
,p_message_language=>'pt-br'
,p_message_text=>'Ambos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491131948311716)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para P\00E1gina Admin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488085061310930)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490878370311715)
,p_name=>'CA.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483383307311710)
,p_name=>'CA.CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina do Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483472739311710)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cria uma p\00E1gina que exibe um calend\00E1rio.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Informe um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone para exibir no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tabela ou View</strong> (Obrigat\00F3rio) - Selecione o objeto do banco de dados do calend\00E1rio.</li>'),
unistr('  <li><strong>Coluna para Exibi\00E7\00E3o</strong> (Obrigat\00F3rio) - Selecione a coluna da tabela ou view a ser exibida nos eventos do calend\00E1rio.</li>'),
unistr('  <li><strong>Coluna de Data Inicial</strong> (Obrigat\00F3rio) - Selecione a coluna de data da tabela ou view a ser usada como data inicial dos eventos do calend\00E1rio.</li>'),
unistr('  <li><strong>Coluna de Data Final</strong> - Selecione a coluna de data na tabela ou view a ser usada como a data final dos eventos do calend\00E1rio.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Se a Data Final for especificada, os eventos com base na dura\00E7\00E3o ser\00E3o exibidos. </li>'),
unistr('  <li><strong>Mostrar Hora</strong> - Selecione <strong>Sim</strong> para mostrar a parte de hora dos eventos e tamb\00E9m ativar as views do calend\00E1rio Semanal e Di\00E1rio. Selecione <strong>N\00E3o</strong> para mostrar somente as datas dos eventos.</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489887172311715)
,p_name=>'CA.CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491778754311716)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cancelar Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469048037310912)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar Modal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501613490311723)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode remover os direitos de administra\00E7\00E3o de seu pr\00F3prio registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532424146311745)
,p_name=>'CA.CARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina de Cart\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532362659311745)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que exiba cart\00F5es.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tabela ou View</strong> (Obrigat\00F3rio) - Selecione o objeto de banco de dados para o cart\00E3o.</li>'),
unistr('  <li><strong>T\00EDtulo do Cart\00E3o</strong> (Obrigat\00F3rio) - Selecione a coluna da tabela ou view a ser usada como o t\00EDtulo do cart\00E3o.</li>'),
unistr('  <li><strong>Coluna de Descri\00E7\00E3o</strong> (Obrigat\00F3rio) - Selecione a coluna da tabela ou view a ser usada como a descri\00E7\00E3o do cart\00E3o.</li>'),
unistr('  <li><strong>Coluna de Texto Adicional</strong> - Selecione a coluna na tabela ou view a ser usada como a descri\00E7\00E3o secund\00E1ria do cart\00E3o.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530903750311744)
,p_name=>'CA.CARDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531092303311744)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View de Cart\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592181105311012)
,p_name=>'CA.CC'
,p_message_language=>'pt-br'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852581103311225)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482405917311709)
,p_name=>'CA.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482545465311709)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que exiba um gr\00E1fico de \00E1reas, barras, linhas ou pizza.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone para exibir no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tipo de Gr\00E1fico</strong> - Selecione o tipo de gr\00E1fico a ser exibido [<strong>\00C1reas</strong>, <strong>Barras</strong>, <strong>Linhas</strong>, <strong>Pizza</strong>].</li>'),
unistr('  <li><strong>Tabela ou View</strong> (Obrigat\00F3rio) - Selecione o objeto do banco de dados do gr\00E1fico.</li>'),
unistr('  <li><strong>Coluna do Label</strong> (Obrigat\00F3rio) - Selecione a coluna da tabela ou view a ser usada como label para o gr\00E1fico.</li>'),
unistr('  <li><strong>Agrega\00E7\00E3o de Valor</strong> - Selecione como a coluna de valor deve ser exibida ou agregada<br>'),
'      &nbsp;&nbsp;&nbsp;[Valor da Coluna, Soma, Contagem].</li>',
unistr('  <li><strong>Coluna de Valor</strong> (Obrigat\00F3rio) - Selecione uma coluna num\00E9rica na tabela ou da view que \00E9 usada para calcular os valores do gr\00E1fico exibidos.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482828455311710)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Exemplos</h3>',
'<p>Revisa os exemplos de como utilizar os diferentes tipos de <strong>Resumo</strong>:</p>',
unistr('<p><strong>Exemplo 1:</strong> Exibe um gr\00E1fico de Funcion\00E1rios com o n\00FAmero de funcion\00E1rios do gerente de cada funcion\00E1rio.'),
'<code><ul>',
'  <li>Tabela ou View - Selecione EMP.</li>',
'  <li>Coluna de Label - Selecione ENAME.</li>',
'  <li>Resumo - Selecione <u><strong>Valor da Coluna</strong></u>.</li>',
'  <li>Valor da Coluna - Selecione MGR.</li>',
'</ul></code>',
'</p>',
unistr('<p><strong>Exemplo 2:</strong> Exibe um gr\00E1fico sobre os Funcion\00E1rios com o sal\00E1rio total de cada cargo.'),
'<code><ul>',
'  <li>Tabela ou View - Selecione EMP.</li>',
'  <li>Coluna do Label - Selecione JOB.</li>',
'  <li>Resumo - Selecione <u><strong>Res.</strong></u>.</li>',
'  <li>Coluna de Valor - Selecione SAL.</li>',
'</ul></code>',
'</p>',
unistr('<p><strong>Exemplo 3:</strong> Exibe um gr\00E1fico sobre os Funcion\00E1rios com o n\00FAmero de funcion\00E1rios de cada departamento.'),
'<code><ul>',
'  <li>Tabela ou View - Selecione EMP.</li>',
'  <li>Coluna do Label - Selecione DEPTNO.</li>',
'  <li>Resumo - Selecione <u><strong>Contagem</strong></u>.</li>',
'  <li>Coluna de Valor - Selecione EMPNO.</li>',
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719258438311113)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Cliente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535629409311747)
,p_name=>'CA.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357173570310830)
,p_name=>'CA.CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Fechado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533693181311746)
,p_name=>'CA.COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510658553311729)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510791039311730)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498099266311720)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529472254311743)
,p_name=>'CA.COMMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495793429311719)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500580350311722)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Configurar Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490943504311715)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configurar Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491041464311716)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>A apar\00EAncia de seu aplicativo \00E9 definida pelo Estilo do Tema.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494390669311718)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Configura\00E7\00E3o atualizadas. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476268568311705)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474512594311704)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar ou desativar funcionalidades do aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476394746311705)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os administradores do aplicativo ativem ou desativem a funcionalidade espec\00EDfica dentro do aplicativo. Esta funcionalidade \00E9 muito \00FAtil, se forem selecionadas funcionalidades que demandem maior esfor\00E7o de desenvolvimento para que possa')
||unistr('m ser usadas pelos usu\00E1rios finais.<br>'),
unistr('Esta funcionalidade tamb\00E9m pode ser expandida para as funcionalidades espec\00EDficas do aplicativo. Se os desenvolvedores definirem op\00E7\00F5es de build adicionais e associarem-nas \00E0 funcionalidade espec\00EDfica por todo o aplicativo, ent\00E3o elas poder\00E3o ser adi')
||unistr('cionadas \00E0s defini\00E7\00F5es de configura\00E7\00E3o para os administradores. Por exemplo, dentro do Pacote de Aplicativos do Rastreador de Clientes, os administradores podem ativar ou desativar funcionalidades como Contatos, Carga de Dados, Geografia e muito mais')
||'.',
'</p>',
'<p>Inclui os seguintes componentes:',
'<ul>',
'<li>Permite que a funcionalidade do aplicativo seja ativada ou desativada</li>',
unistr('<li>Usa a funcionalidade para permitir funcionalidade seletiva por implanta\00E7\00E3o</li>'),
unistr('<li>Permite o agrupamento de defini\00E7\00F5es do aplicativo relacionadas</li>'),
unistr('<li>Os desenvolvedores do aplicativo controlam os componentes usando as op\00E7\00F5es de build</li>'),
unistr('<li>Dispon\00EDvel na p\00E1gina de Administra\00E7\00E3o</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714143148311109)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da Credencial de Conex\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714223606311109)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conectar Propriet\00E1rio da Credencial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380667326311637)
,p_name=>'CA.CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Contexto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501084753311723)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'pt-br'
,p_message_text=>'Colaborador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721127721311114)
,p_name=>'CA.CPU.USED'
,p_message_language=>'pt-br'
,p_message_text=>'CPU Utilizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509588855311729)
,p_name=>'CA.CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514676808311732)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512286731311731)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Criando aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513398692311731)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando c\00E1lculos do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512602376311731)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando \00EDcone do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513222971311731)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Criando itens de aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513412036311731)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Criando processos do aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389746293311643)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando defini\00E7\00F5es de aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519597579311736)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Criar um Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763068480311149)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando atribui\00E7\00F5es de aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512844162311731)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando esquemas de autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513641375311732)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina em branco')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512779898311731)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando op\00E7\00F5es de build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514053385311732)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina do calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525815674311740)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando a p\00E1gina de cart\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513823423311732)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina do gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514353952311732)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de relat\00F3rio cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513982321311732)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina do painel de controle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512162847311731)
,p_name=>'CA.CREATE.END'
,p_message_language=>'pt-br'
,p_message_text=>'Finalizando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533151136311746)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de pesquisa facetada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514975940311733)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Criando funcionalidades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530400822311744)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando P\00E1gina de Conte\00FAdo Filtrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513735110311732)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina do form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512305760311731)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514570674311732)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando lista de navega\00E7\00E3o da home page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514486122311732)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de grade interativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514254284311732)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de relat\00F3rio interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223629182310717)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de mapa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519243712311736)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1ginas detalhe/mestre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513039738311731)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando barras de navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516262724311733)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando um grupo de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514890323311732)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executando a tradu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514778000311732)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executando a tradu\00E7\00E3o de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107514178794311732)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando relat\00F3rio e p\00E1gina do form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519414079311736)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'pt-br'
,p_message_text=>'Salvando o blueprint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513109234311731)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'pt-br'
,p_message_text=>'Criando atalho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107513552022311732)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina de acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223366630310716)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('p\00E1gina Criando Filtros Inteligentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512094395311730)
,p_name=>'CA.CREATE.START'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512494229311731)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'pt-br'
,p_message_text=>'Criando scripts de objeto de suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512946410311731)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Criando mensagens de texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525966207311740)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando a p\00E1gina de linha do tempo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533330673311746)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando p\00E1gina do assistente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493615050311717)
,p_name=>'CA.CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493795188311717)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'pt-br'
,p_message_text=>'Criado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482142359311709)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Criando Aplicativo ...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714894625311110)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Credencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721002802311114)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Credencial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494229000311718)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515298901311733)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta Personalizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804046008311187)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Tema Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804172612311187)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Alterne o assistente para usar um tema personalizado em vez do Universal Theme.</p>',
'',
unistr('<p>Selecione um Tema de Espa\00E7o de Trabalho para o aplicativo. Se o tema suportar Estilos de Temas, o estilo tamb\00E9m poder\00E1 ser selecionado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468709194310912)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515851801311733)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina de Painel de Controle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379655059311636)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515911716311733)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina do painel de controle com v\00E1rios gr\00E1ficos.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
unistr('<p>Cada gr\00E1fico (Gr\00E1fico 1, Gr\00E1fico 2, Gr\00E1fico 3 e Gr\00E1fico 4) adota como padr\00E3o diversos tipos de gr\00E1ficos e se baseia na <em>Amostra de Dados</em>. '),
unistr('  Como tal, voc\00EA n\00E3o precisa inserir nenhum detalhe adicional para adicionar esta p\00E1gina.'),
unistr('  No entanto, voc\00EA pode personalizar cada gr\00E1fico substituindo os valores padr\00E3o por suas pr\00F3prias sele\00E7\00F5es.<br>'),
unistr('  Para personalizar um gr\00E1fico, informe os seguintes atributos:</p>'),
'<ul>',
unistr('  <li><strong>Nome do Gr\00E1fico</strong> (Obrigat\00F3rio) - Digite o nome do gr\00E1fico.</li>'),
unistr('  <li><strong>Tipo de Gr\00E1fico</strong> - Selecione o tipo de gr\00E1fico a ser exibido [<strong>\00C1reas</strong>, <strong>Barras</strong>, <strong>Linhas</strong>, <strong>Pizza</strong>].</li>'),
unistr('  <li><strong>Tabela ou View</strong> (Obrigat\00F3rio) - Selecione o objeto de banco de dados para o gr\00E1fico.</li>'),
unistr('  <li><strong>Coluna do Label</strong> (Obrigat\00F3rio) - Selecione a coluna na tabela ou view a ser usada como o label para o gr\00E1fico.</li>'),
unistr('  <li><strong>Agrega\00E7\00E3o de Valor</strong> - Selecione como a coluna de valor deve ser exibida ou agregada<br>'),
'      &nbsp;&nbsp;&nbsp;[Valor da Coluna, Soma, Contagem].</li>',
unistr('  <li><strong>Coluna de Valor</strong> (Obrigat\00F3rio) - Selecione uma coluna num\00E9rica na tabela ou view que seja usada para calcular os valores de gr\00E1fico exibidos.</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526581624311741)
,p_name=>'CA.DATATYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527664215311741)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato de Data')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494966094311718)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fuso Hor\00E1rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495036607311718)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fuso hor\00E1rio padr\00E3o atualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516674308311734)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00F5es de Atributo de Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516966881311734)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esse documento JSON permite controle fino da gera\00E7\00E3o de nomes de colunas, m\00E1scaras de formato etc. de relat\00F3rios e forms. Voc\00EA tamb\00E9m pode definir listas de valores e outros componentes compartilhados. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532963888311745)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos da Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533028528311746)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Adicione um atributo de lista de valores (LOV). As LOVs podem ser usadas em defini\00E7\00F5es de colunas da tabela.</p>'),
'<p>Informe os seguintes atributos:',
'  <ul>',
unistr('    <li><strong>Nome</strong> (Obrigat\00F3rio) - Digite o nome da lista de valores.</li>'),
unistr('    <li><strong>Tipo</strong> - Selecione o tipo de lista de valores [Estruturada, Din\00E2mica, Est\00E1tica].<br>'),
'      Para o Tipo <u>Estruturado</u> - ',
'      <ul>',
unistr('          <li><strong>Tabela</strong> (Obrigat\00F3rio) - Selecione a tabela ou view na qual a lista de valores se basear\00E1.</li>'),
unistr('          <li><strong>Coluna de Exibi\00E7\00E3o</strong> (Obrigat\00F3rio) - Selecione a coluna a ser exibida aos usu\00E1rios finais.</li>'),
unistr('          <li><strong>Coluna de Chaves</strong> (Obrigat\00F3rio) - Selecione o valor da coluna a ser retornado. Em geral \00E9 a chave prim\00E1ria da tabela.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      Para o Tipo <u>Din\00E2mico</u> -'),
'      <ul>',
unistr('          <li><strong>Consulta SQL</strong> (Obrigat\00F3rio) - Informe uma instru\00E7\00E3o SQL select v\00E1lida que retorne dois valores (valor de exibi\00E7\00E3o e valor de retorno).</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      Para o Tipo <u>Est\00E1tico</u> -'),
'      <ul>',
unistr('          <li><strong>Lista de Valores Est\00E1tica</strong> (Obrigat\00F3rio) - Informe uma lista est\00E1tica v\00E1lida com o formato:'),
'          <ul>',
'            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>Lista exibida na ordem digitada</li>',
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>Lista em ordem alfab\00E9tica</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>Valor de exibi\00E7\00E3o e valor de retorno s\00E3o iguais</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534182965311746)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534262888311746)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Edite os atributos de todos os relat\00F3rios.</p>'),
'<p>Informe os seguintes atributos:',
'  <ul>',
unistr('    <li><strong>Linhas por P\00E1gina</strong> - Informe o n\00FAmero de linhas de relat\00F3rio a serem exibidas por padr\00E3o.</li>'),
unistr('    <li><strong>M\00E9todo de Pagina\00E7\00E3o</strong> - Selecione como a pagina\00E7\00E3o do relat\00F3rio ser\00E1 exibida.</li>'),
unistr('    <li><strong>M\00E1scara de Formato Num\00E9rico</strong> - Informe a m\00E1scara de formato a ser aplicada a colunas e itens num\00E9ricos.</li>'),
unistr('    <li><strong>M\00E1scara de Formato de Data</strong> - Informe a m\00E1scara de formato a ser aplicada a colunas e itens de data.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533992462311746)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos de Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533705316311746)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos de Coluna da Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533821668311746)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edite os atributos da coluna da tabela selecionada.</p>',
'<p>Informe os seguintes atributos:',
'  <ul>',
unistr('    <li><strong>Tabela</strong> (Somente para Exibi\00E7\00E3o) - A tabela associada.</li>'),
unistr('    <li><strong>Coluna</strong> (Somente para Exibi\00E7\00E3o) - A coluna com base na qual os atributos s\00E3o definidos.</li>'),
unistr('    <li><strong>Label</strong> - Informe o label a ser usado nos t\00EDtulos dos relat\00F3rios e nos labels de forms.</li>'),
'    <li><strong>Controle de Form</strong> - Selecione o tipo de item a ser usado em forms.</li>',
unistr('    <li><strong>Lista de Valores</strong> - Selecione uma Lista de Valores existente a ser usada para exibir nomes f\00E1ceis conforme apropriado.</li>'),
unistr('    <li><strong>M\00E1scara de Formato</strong> - Informe uma m\00E1scara de formato apropriada com base no tipo de coluna (texto, n\00FAmero, data etc.).</li>'),
unistr('    <li><strong>Valor Padr\00E3o Est\00E1tico</strong> - Informe um valor padr\00E3o de texto para a coluna.</li>'),
unistr('    <li><strong>Incluir em Forms</strong> - Clique em Sim se a coluna tiver de ser inclu\00EDda em forms.</li>'),
unistr('    <li><strong>Incluir em Relat\00F3rios</strong> - Clique em Sim se a coluna tiver de ser inclu\00EDda em relat\00F3rios.</li>'),
unistr('    <li><strong>Obrigat\00F3rio</strong> - Clique em Sim se os dados tiverem de ser inseridos nesta coluna dos forms.</li>'),
'    <li><strong>Ajuda</strong> - Digite um texto de ajuda a ser adicionado ao atributo de ajuda do item.</li>',
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534029144311746)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edite os atributos da tabela selecionada.</p>',
'<p>Informe os seguintes atributos:',
'  <ul>',
unistr('    <li><strong>Tabela</strong> (Somente para Exibi\00E7\00E3o) - A tabela associada.</li>'),
unistr('    <li><strong>Label, Singular</strong> (Obrigat\00F3rio) - Informe o label a ser usado nas p\00E1ginas dos forms.</li>'),
unistr('    <li><strong>Label, Plural</strong> (Obrigat\00F3rio) - Informe o label a ser usado em t\00EDtulos de regi\00E3o e nomes de p\00E1ginas.</li>'),
unistr('    <li><strong>Coluna de Exibi\00E7\00E3o Principal</strong> - Selecione a primeira coluna a ser exibida, por exemplo, em regi\00F5es do cart\00E3o.</li>'),
unistr('    <li><strong>Coluna de Exibi\00E7\00E3o Secund\00E1ria</strong> - Selecione a segunda coluna a ser exibida, por exemplo, em regi\00F5es do cart\00E3o.</li>'),
unistr('    <li><strong>Coluna de Chave Prim\00E1ria</strong> - Selecione a coluna de chave exclusiva para a tabela.</li>'),
unistr('    <li><strong>Descri\00E7\00E3o</strong> - Digite uma descri\00E7\00E3o para a tabela.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714647469311109)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Elimina\00E7\00E3o Adiada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528291672311742)
,p_name=>'CA.DEFINITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511906841311730)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desinstala\00E7\00E3o conclu\00EDda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492297112311716)
,p_name=>'CA.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511596495311730)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gostaria de executar esta a\00E7\00E3o de exclus\00E3o?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477829495311706)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem certeza de que deseja excluir esta p\00E1gina?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502003084311723)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492949266311717)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510114182311729)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510071689311729)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491220061311716)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo do Tema do Desktop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491376872311716)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Estilo do Tema padr\00E3o \00E9 aplicado a todos os usu\00E1rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715000367311110)
,p_name=>'CA.DESTINATION'
,p_message_language=>'pt-br'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715134841311110)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio de Destino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468857044310912)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es de Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506507568311726)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Despachar E-mails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525097153311740)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Determina se os e-mails devem ser enviados pela Estrutura de E-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492777061311717)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir - De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492611075311717)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492883500311717)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir - At\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526786725311741)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496396391311719)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Distintos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509614723311729)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516574388311734)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arrastar para reordenar a p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489579836310932)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
'  <li><strong>Link de Drill-down</strong> - Expanda para ver atributos para definir um link de drill-down.',
'&nbsp;<br>',
unistr('    <em><strong>Observa\00E7\00E3o:</strong> O Link de Drill-down s\00F3 aparecer\00E1 se a p\00E1gina atual se basear em uma tabela ou view e for do tipo Relat\00F3rio Interativo, e voc\00EA tiver definido uma p\00E1gina de relat\00F3rio (Relat\00F3rio Interativo) ou de detalhe mestre (De')
||'talhe Mestre).</em>',
'  <ul>',
unistr('    <li><strong>Coluna de Link</strong> - Selecione a coluna a ser alterada para uma coluna de link no relat\00F3rio.</li>'),
unistr('    <li><strong>Chave de Link</strong> - Selecione a coluna de chave de link (chave externa) usada para identificar o registro espec\00EDfico na p\00E1gina ao qual est\00E1 sendo vinculado.</li>'),
unistr('    <li><strong>Link para a P\00E1gina</strong> - Selecione o relat\00F3rio ou p\00E1gina de form para a qual o link navegar\00E1.</li>'),
unistr('    <li><strong>Chave de Destino</strong> - Selecione a coluna de chave de destino (chave prim\00E1ria) na tabela na qual a p\00E1gina de relat\00F3rio se baseia e at\00E9 a qual o link navega.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495401970311719)
,p_name=>'CA.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>'Decorrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478030134311706)
,p_name=>'CA.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Estrutura de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524665477311739)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7os de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534665918311747)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477944526311706)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Adicione a capacidade de configurar e enviar e-mails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107478199546311706)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inclua a capacidade para enviar e-mails do seu aplicativo. Com o uso do modelo de e-mail de exemplo, envie e-mails de pesquisa profissionais aos usu\00E1rios. Os e-mails enviados s\00E3o registrados para que os administradores possam acompanhar a atividad')
||'e de e-mail.<br>',
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Sistema de modelo de E-mail HTML Extens\00EDvel </li>'),
'<li>Pacote PL/SQL para enviar e-mail por pacotes APEX</li>',
'<li>Registro de atividades de e-mail e status</li>',
'<li>IU Administrativa para gerenciar modelos</li>',
'<li>IU Administrativa para exibir logs de e-mail</li>',
'<li>IU Administrativa para enviar e-mails</li>',
'</ul>',
'</p>',
unistr('<p><em>Observa\00E7\00E3o: essa funcionalidade ser\00E1 ativada quando Feedback for selecionado</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530319123311744)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Remetente do E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505554059311726)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'pt-br'
,p_message_text=>'Log de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535235027311747)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Detalhes exigidos da defini\00E7\00E3o de e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534707781311747)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Endere\00E7o do Remetente n\00E3o \00E9 um e-mail v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526299601311741)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Endere\00E7o do Remetente n\00E3o \00E9 um e-mail v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525447798311740)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail processado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592411408311012)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera\00E7\00E3o de Relat\00F3rio de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764746913311150)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de todos os e-mails enfileirados a serem enviados e os que j\00E1 foram enviados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506495425311726)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506885733311727)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de e-mail atualizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530775758311744)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status do E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506920765311727)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes do Modelo de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013196149311358)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interrup\00E7\00E3o Programada para #SERVICE_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811412752311193)
,p_name=>'CA.EMAIL2'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505488836311726)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'pt-br'
,p_message_text=>'E-mails Enviados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534875427311747)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720155969311114)
,p_name=>'CA.ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717320800311111)
,p_name=>'CA.END.DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507507280311727)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo ap\00F3s as Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398880152311650)
,p_name=>'CA.ENDED'
,p_message_language=>'pt-br'
,p_message_text=>'Encerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522560221311738)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite os nomes de usu\00E1rios aqui')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496062485311719)
,p_name=>'CA.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498382782311721)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'pt-br'
,p_message_text=>'Rastreamento de Pilha de Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498221204311721)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497563480311720)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721852429311115)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero do Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720842641311114)
,p_name=>'CA.ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399086871311650)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas de Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717715135311112)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o do Evento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717820636311112)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'pt-br'
,p_message_text=>'Agente da Fila do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717911226311112)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Fila do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718022465311112)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Fila do Evento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717615242311112)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'pt-br'
,p_message_text=>'Regra de Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522887071311738)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exce\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535713952311748)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Experi\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719864826311113)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem de Falhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494068103311718)
,p_name=>'CA.FEATURE'
,p_message_language=>'pt-br'
,p_message_text=>'Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168638317311478)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168744529311478)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852923320311226)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Usu\00E1rios \00E0 Lista de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852730403311225)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir para Pr\00F3xima Etapa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852883102311225)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Cole\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852649627311225)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel alterar o \00FAltimo administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168339204311478)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Atividade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852409597311225)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma atividade encontrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168574527311478)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'pt-br'
,p_message_text=>'Motivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853037934311226)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 Obrigat\00F3rio pelo Menos um Feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853363732311226)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Obter ID do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851996565311225)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar Estilo do Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852027281311225)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Prefer\00EAncia de Estilo do Usu\00E1rio Final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168421186311478)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482200151311709)
,p_name=>'CA.FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Funcionalidades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482347329311709)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os recursos fornecem funcionalidades no n\00EDvel do aplicativo e s\00E3o tipicamente adicionados uma vez por aplicativo. Escolhe as funcionalidades a serem inclu\00EDdas no seu aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476140523311705)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474140136311703)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir que os usu\00E1rios forne\00E7am feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476005884311705)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fornece um mecanismo para que os usu\00E1rios finais postem coment\00E1rios gerais aos administradores e desenvolvedores do aplicativo. As postagens incluem informa\00E7\00F5es \00FAteis do estado da sess\00E3o para ajudar a determinar de onde o usu\00E1rio final enviou o fe')
||unistr('edback. Fornecer um loop de feedback f\00E1cil melhora a comunica\00E7\00E3o entre a comunidade de usu\00E1rios e os propriet\00E1rios do aplicativo, o que conduz a uma satisfa\00E7\00E3o muito maior por parte do usu\00E1rio final.</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Capacidade dos usu\00E1rios finais de deixar feedback, clicando no \00EDcone da barra de navega\00E7\00E3o</li>'),
unistr('<li>Relat\00F3rio administrativo para exibir e atualizar feedback</li>'),
unistr('<li>O feedback capturar\00E1 as informa\00E7\00F5es de usu\00E1rio, data e hora e agente do usu\00E1rio</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536185782311748)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a feedback ou sua experi\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535174605311747)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534558769311747)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Feedback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503530384311724)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de feedback atualizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535334615311747)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback Enviado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717473682311111)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Observador de Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717577605311112)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio do Observador de Arquivos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375611095310843)
,p_name=>'CA.FILED'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375758162310843)
,p_name=>'CA.FILED.BY'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530877563311744)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio do Filtro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507977478311727)
,p_name=>'CA.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533597305311746)
,p_name=>'CA.FINISH'
,p_message_language=>'pt-br'
,p_message_text=>'Finalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502231952311723)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714426092311109)
,p_name=>'CA.FLAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Flags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483661856311710)
,p_name=>'CA.FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483590732311710)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que exiba uma p\00E1gina de form para permitir que os usu\00E1rios finais mantenham dados.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tabela</strong> (Obrigat\00F3rio) - Selecione a tabela para o form.</li>'),
unistr('<li><strong>Incluir Relat\00F3rio</strong> (Obrigat\00F3rio) - Selecione esta op\00E7\00E3o para criar um relat\00F3rio e um form. A primeira p\00E1gina \00E9 um relat\00F3rio interativo. Cada linha fornece um link para um form no qual os usu\00E1rios podem atualizar o registro. </li>'),
'  &nbsp;<br>',
unistr('<li><strong>Avan\00E7ado</strong> - Expanda para ver op\00E7\00F5es avan\00E7adas.'),
'     <ul>',
unistr('      <li><strong>Ajuda da P\00E1gina</strong> - Digite o texto a ser adicionado ao Texto de Ajuda da p\00E1gina.</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488116215310931)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Itens do Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509886607311729)
,p_name=>'CA.FORM.ON'
,p_message_language=>'pt-br'
,p_message_text=>'Form em %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522394748311738)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de form n\00E3o \00E9 v\00E1lido')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528788314311742)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527770466311742)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Controle de Formul\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493411653311717)
,p_name=>'CA.FROM'
,p_message_language=>'pt-br'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506683297311726)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o do Remetente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530216592311743)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o do "Endere\00E7o do Remetente" do E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526168758311740)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail do Remetente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526033120311740)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'pt-br'
,p_message_text=>'De quem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219035133311516)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa 0%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496940330311720)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Visualiza\00E7\00F5es de P\00E1gina Inteira')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505606696311726)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'pt-br'
,p_message_text=>'HTML de Modelo Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527207116311741)
,p_name=>'CA.FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476549366311705)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa Global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474303320311704)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Fornecer recursos de pesquisa do aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476497440311705)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os usu\00E1rios finais procurem texto em tabelas ou views da chave dentro do aplicativo. A p\00E1gina avan\00E7ada de pesquisa inclui filtros para simplificar a restri\00E7\00E3o de resultados para os usu\00E1rios finais.<br>'),
unistr('Esta funcionalidade muito avan\00E7ada n\00E3o requer esfor\00E7o de desenvolvimento para definir a SQL (com base nos exemplos fornecidos).</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Exibe um \00EDcone de pesquisa na barra do cabe\00E7alho</li>'),
unistr('<li>Inclui uma p\00E1gina de resultados de pesquisa com filtro da barra lateral</li>'),
'<li>Requer que o desenvolvedor implemente a SQL para definir a pesquisa do Aplicativo</li>',
unistr('<li>Inclui dados de amostra para ilustra\00E7\00E3o</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719186548311113)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'pt-br'
,p_message_text=>'ID Exclusivo Global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851558987311224)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Global - Desktop')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468963600310912)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir para a P\00E1gina de Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483168289311710)
,p_name=>'CA.GRID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina de Grade Interativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483281514311710)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que exibe uma grade interativa, que \00E9 semelhante a uma planilha que permite que v\00E1rias linhas sejam editadas diretamente na p\00E1gina (quando a op\00E7\00E3o Permitir Edi\00E7\00E3o estiver ativada).</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Informe um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone para exibir no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tipo de Consulta</strong> - Selecione a origem do relat\00F3rio [<strong>Tabela ou View</strong> ou <strong>Consulta SQL</strong>].<br>'),
'    <strong>Tabela ou View</strong>:',
'    <ul>',
unistr('      <li><strong>Tabela ou View</strong> (Obrigat\00F3rio) - Selecione o objeto do banco de dados da grade.</li>'),
'    </ul>',
'    <strong>Consulta SQL</strong>:',
'    <ul>',
unistr('      <li><strong>Consulta SQL</strong> (Obrigat\00F3ria) - Informe uma instru\00E7\00E3o SQL v\00E1lida que retorne colunas distintas.</li>'),
'    </ul>',
unistr('  <li><strong>Tipo de Grade</strong> - Selecione se os usu\00E1rios finais podem editar as linhas na grade [<strong>Permitir Edi\00E7\00E3o</strong> ou <strong>Somente para Leitura</strong>].</li>'),
unistr('Para ativar a edi\00E7\00E3o, selecione <strong>Permitir Edi\00E7\00E3o</strong>.</li>'),
'  &nbsp;<br>',
unistr('<em><strong>Advert\00EAncia:</strong> Se voc\00EA selecionar um Tipo de Consulta de <strong>Consulta SQL</strong> mais um Tipo de Grade de <strong>Permitir Edi\00E7\00E3o</strong> e sua consulta juntar duas ou mais tabelas, a grade interativa gerada falhar\00E1 quando o')
||unistr('s usu\00E1rios tentarem atualizar os registros.'),
unistr('Al\00E9m disso, se voc\00EA selecionar o Tipo de Grade de <strong>Permitir Edi\00E7\00E3o</strong> e a consulta (ou Tabela ou View selecionada) usar uma exibi\00E7\00E3o que n\00E3o \00E9 atualiz\00E1vel, ent\00E3o a Grade Interativa gerada falhar\00E1 quando os usu\00E1rios tentarem atualizar os ')
||'registros.</em><br>',
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508495940311728)
,p_name=>'CA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398609394311650)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina oferece um relat\00F3rio interativo do log de automa\00E7\00F5es.</p>'),
unistr('<p>Analise as informa\00E7\00F5es registradas sobre execu\00E7\00F5es de automa\00E7\00E3o anteriores. O log cont\00E9m timestamps inicial e final, bem como detalhes sobre linhas processadas (bem-sucedidas e com erros). Fa\00E7a drill down at\00E9 Mensagens para ver mensagens individua')
||'is para linhas processadas.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500828040311722)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha <strong>N\00E3o</strong> se todos os usu\00E1rios forem definidos na lista de controle de acesso. Escolha <strong>Sim</strong> se os usu\00E1rios autenticados que n\00E3o estiverem na lista de controle de acesso tamb\00E9m puderem usar este aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494549548311718)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto informado aqui \00E9 usado por todo o aplicativo, mais notavelmente, no canto superior esquerdo de cada p\00E1gina. A altera\00E7\00E3o ter\00E1 efeito imediatamente para o administrador que faz a altera\00E7\00E3o, mas os outros usu\00E1rios s\00F3 ver\00E3o a altera\00E7\00E3o quando ini')
||unistr('ciarem uma nova sess\00E3o (por exemplo, no pr\00F3ximo log-in).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489154827311714)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique no \00EDcone de feedback ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o, em qualquer p\00E1gina do aplicativo, para deixar feedback para os administradores do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488874831311714)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Esta \00E9 a home page do aplicativo. Clique nos cart\00F5es para acessar diferentes p\00E1ginas do aplicativo ou use o menu de navega\00E7\00E3o na lateral da p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489054246311714)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Esta \00E9 a home page do aplicativo. Clique nos cart\00F5es para acessar diferentes p\00E1ginas do aplicativo ou use o menu de navega\00E7\00E3o na parte superior da p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489299975311714)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe um termo de pesquisa no campo <strong>Pesquisar Aplicativo</strong> nesta p\00E1gina ou clique no \00EDcone de pesquisa ( <span class="fa fa-search" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o de qualquer p\00E1gina para procurar o termo dentro')
||' do aplicativo.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489501212311714)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique na lista suspensa do nome na barra de navega\00E7\00E3o para sair do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489409822311714)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique no menu do usu\00E1rio ( <span class="fa fa-user" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o para atualizar sua prefer\00EAncia de fuso hor\00E1rio e sair do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488988488311714)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Home Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489622129311715)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Clique no menu do usu\00E1rio ( <span class="fa fa-user" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o (parte superior direita da p\00E1gina) para acessar o perfil do usu\00E1rio e sair do aplicativo.<br>'),
unistr('Se voc\00EA clicar em <strong>Exibir Meu Perfil</strong>, poder\00E1 clicar em <strong>Atualizar Perfil</strong> para inserir seus detalhes pessoais e fazer upload de uma foto ou avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489394067311714)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Clique no menu do usu\00E1rio ( <span class="fa fa-user" aria-hidden="true"></span> ) na barra de navega\00E7\00E3o para acessar seu perfil do usu\00E1rio, atualizar sua prefer\00EAncia de fuso hor\00E1rio e sair do aplicativo.<br>'),
unistr('Se voc\00EA clicar em <strong>Exibir Meu Perfil</strong>, poder\00E1 clicar em <strong>Atualizar Perfil</strong> para inserir seus detalhes pessoais e fazer upload de uma foto ou avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515423023311733)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para localizar os dados, digite um termo de pesquisa na caixa de di\00E1logo ou clique nos cabe\00E7alhos da coluna para limitar os registros retornados.</p>'),
'',
unistr('<p>Voc\00EA pode executar v\00E1rias fun\00E7\00F5es clicando no bot\00E3o <strong>A\00E7\00F5es</strong>. Isso inclui a sele\00E7\00E3o de colunas que s\00E3o exibidas/ocultas e sua sequ\00EAncia de exibi\00E7\00E3o, mais v\00E1rios dados e fun\00E7\00F5es de formato. Tamb\00E9m \00E9 poss\00EDvel definir uma exibi\00E7\00E3o adici')
||unistr('onal de dados usando a op\00E7\00E3o do gr\00E1fico.</p>'),
'',
unistr('<p>Se quiser salvar suas personaliza\00E7\00F5es, selecione relat\00F3rio ou clique em download para descarregar os dados.<p>'),
'<br>',
unistr('<p>Para obter informa\00E7\00F5es adicionais, clique em Ajuda na parte inferior do menu A\00E7\00F5es.</p>'),
'',
unistr('<p>Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo para as configura\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515326474311733)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voc\00EA pode inserir, atualizar e excluir dados diretamente dessa grade interativa.<br>'),
unistr('  Insira uma nova linha clicando no bot\00E3o Adicionar Linha.<br>'),
unistr('  Clique duas vezes em uma c\00E9lula ou clique no bot\00E3o <strong>Editar</strong> para atualizar valores de dados, como na edi\00E7\00E3o de dados em uma planilha.</p>'),
'',
unistr('<p>Use o menu A\00E7\00F5es da Linha ( <span class="fa fa-bars" aria-hidden="true"></span> ) na parte superior do relat\00F3rio para duplicar, excluir, atualizar ou reverter as linhas selecionadas.<br> '),
unistr('  Use o menu A\00E7\00F5es da Linha em linhas individuais para tamb\00E9m acessar a view de linha \00FAnica ou adicionar uma nova linha.</p>'),
'',
unistr('<p>Para localizar dados, digite um termo de pesquisa na caixa de di\00E1logo ou clique nos cabe\00E7alhos das colunas para limitar os registros retornados.</p>'),
'',
unistr('<p>Voc\00EA pode executar v\00E1rias fun\00E7\00F5es clicando no bot\00E3o <strong>A\00E7\00F5es</strong>. Isso inclui a sele\00E7\00E3o de colunas que s\00E3o exibidas/ocultadas e sua sequ\00EAncia de exibi\00E7\00E3o, mais v\00E1rios dados e fun\00E7\00F5es de formato. Tamb\00E9m \00E9 poss\00EDvel definir uma view adicion')
||unistr('al dos dados usando a op\00E7\00E3o de gr\00E1fico.</p>'),
'',
unistr('<p>Se quiser salvar suas personaliza\00E7\00F5es, selecione o relat\00F3rio ou clique em download para descarregar os dados.<p>'),
'',
unistr('<p>Para obter informa\00E7\00F5es adicionais, clique em Ajuda na parte inferior do menu A\00E7\00F5es.</p> '),
'',
unistr('<p>Clique no bot\00E3o <strong>Redefinir</strong> para redefinir a grade interativa de volta ao padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488778718311714)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para localizar os dados, digite um termo de pesquisa na caixa de di\00E1logo ou clique nos cabe\00E7alhos da coluna para limitar os registros retornados.</p>'),
'',
unistr('<p>Voc\00EA pode executar v\00E1rias fun\00E7\00F5es clicando no bot\00E3o <strong>A\00E7\00F5es</strong>. Isso inclui a sele\00E7\00E3o de colunas que s\00E3o exibidas/ocultas e sua sequ\00EAncia de exibi\00E7\00E3o, mais v\00E1rios dados e fun\00E7\00F5es de formato. Tamb\00E9m \00E9 poss\00EDvel definir views adicionais d')
||unistr('e dados usando a op\00E7\00E3o do gr\00E1fico, agrupar por e tabela din\00E2mica.</p>'),
'',
unistr('<p>Se quiser salvar suas personaliza\00E7\00F5es, selecione o relat\00F3rio ou clique em download para descarregar os dados. Informe seu endere\00E7o de e-mail e per\00EDodo de assinatura para que os dados sejam enviados regularmente.<p>'),
'',
unistr('<p>Para obter informa\00E7\00F5es adicionais, clique em Ajuda na parte inferior do menu A\00E7\00F5es.</p>'),
'',
unistr('<p>Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo para as configura\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523354830311738)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina de relat\00F3rio exibe os principais registros em um seletor no lado da p\00E1gina. '),
'  Selecione um registro para ver o registro mestre e todos os registros detalhados definidos.<br> ',
unistr('  Clique no \00EDcone de edi\00E7\00E3o ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) para editar o registro mestre.'),
unistr('  Para registros detalhados, clique no l\00E1pis, no in\00EDcio de cada linha, para editar esse registro.</p>'),
unistr('<p>Para limitar os dados exibidos no seletor, digite um termo de pesquisa na caixa de di\00E1logo de pesquisa.</p>'),
unistr('<p>Para adicionar um novo registro mestre, clique em <strong>Criar</strong> na parte superior da p\00E1gina.'),
unistr('  Para registros detalhados, clique no \00EDcone de mais ( + ) na parte superior da regi\00E3o de detalhes para adicionar um registro detalhado.</p>'),
'',
unistr('<p>Clique em <strong>Redefinir</strong> na parte superior da p\00E1gina para redefinir a p\00E1gina novamente \00E0s defini\00E7\00F5es padr\00E3o, removendo qualquer termo de pesquisa e filtros anteriormente definidos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486748329311712)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A p\00E1gina de administra\00E7\00E3o permite que os propriet\00E1rios do aplicativo (Administradores) configurem o aplicativo e mantenham os dados comuns usados pelo aplicativo.'),
unistr('Selecionando uma das defini\00E7\00F5es dispon\00EDveis, os administradores podem alterar muito a forma pela qual o aplicativo \00E9 exibido e/ou as funcionalidades dispon\00EDveis para os usu\00E1rios finais.</p>'),
unistr('<p>O acesso a esta p\00E1gina deve ser limitado somente aos Administradores.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487948337311713)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a op\00E7\00E3o apropriada para quaisquer usu\00E1rios autenticados.<br>'),
unistr('Selecionar <strong>N\00E3o</strong> torna o aplicativo mais seguro, pois somente os usu\00E1rios especificados podem acessar o aplicativo.'),
unistr('Por\00E9m, se seu aplicativo tiver uma comunidade de usu\00E1rios maior, ent\00E3o manter os usu\00E1rios pode implicar em gastos e talvez voc\00EA prefira escolher <strong>Sim</strong> e s\00F3 inserir Administradores do aplicativo e, possivelmente, Colaboradores.<br>'),
unistr('Se voc\00EA selecionar <strong>Sim</strong>, ent\00E3o tamb\00E9m dever\00E1 selecionar quantos usu\00E1rios n\00E3o inclu\00EDdos na lista de usu\00E1rios ser\00E3o tratados.</p>'),
unistr('<p>Selecione entre endere\00E7os de e-mail necess\00E1rios e qualquer valor alfanum\00E9rico para Nomes de usu\00E1rios.<br>'),
unistr('Geralmente, voc\00EA deve estabelecer esta defini\00E7\00E3o como <strong>Endere\00E7o de E-mail</strong> se seu aplicativo usar (ou for configurado para usar) um esquema de autentica\00E7\00E3o centralizado, como Oracle Access Manager ou SSO.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Este aplicativo suporta os seguintes 3 n\00EDveis de acesso: Leitor, Colaborador e Administrador.'),
'<ul>',
unistr('  <li><strong>Leitores</strong> t\00EAm acesso somente para leitura a todas as informa\00E7\00F5es e tamb\00E9m podem exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Colaboradores</strong> podem criar, editar e excluir informa\00E7\00F5es e exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Administradores</strong> al\00E9m do recurso de Colaboradores, tamb\00E9m podem executar a configura\00E7\00E3o do aplicativo, acessando a se\00E7\00E3o Administra\00E7\00E3o do aplicativo.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488138065311713)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este form para inserir usu\00E1rios, seus endere\00E7os de e-mail e definir seu n\00EDvel de acesso.'),
unistr('As defini\00E7\00F5es estabelecidas em <em>Configurar Controle de Acesso</em> determinar\00E3o se o nome de usu\00E1rio deve ser o endere\00E7o de e-mail ou se pode ser qualquer entrada alfanum\00E9rica.</p>'),
unistr('<p>Este aplicativo suporta os seguintes 3 n\00EDveis de acesso: Leitor, Colaborador e Administrador.</p>'),
'<ul>',
unistr('  <li><strong>Leitores</strong> t\00EAm acesso somente para leitura a todas as informa\00E7\00F5es e tamb\00E9m podem exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Colaboradores</strong> podem criar, editar e excluir informa\00E7\00F5es e exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Administradores</strong>, al\00E9m do recurso de Colaboradores, tamb\00E9m podem executar configura\00E7\00E3o do aplicativo, acessando a se\00E7\00E3o Administra\00E7\00E3o do aplicativo.</li>'),
'</ul>',
unistr('<p>Ao editar um usu\00E1rio existente, voc\00EA pode bloquear sua conta, o que impedir\00E1 que ele acesse o aplicativo.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Se usar as contas do Oracle Application Express, ent\00E3o os usu\00E1rios inseridos aqui tamb\00E9m devem ser definidos como usu\00E1rios finais por um Administrador do Espa\00E7o de Trabalho que tamb\00E9m pode definir as senhas dos usu')
||unistr('\00E1rios.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488091727311713)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina mostra um relat\00F3rio de usu\00E1rios do aplicativo e o n\00EDvel de acesso concedido.</p>'),
unistr('<p>Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades avan\00E7adas adicionais.<br>'),
unistr('Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>'),
unistr('<p>Clique no \00EDcone de edi\00E7\00E3o (l\00E1pis amarelo) para editar os detalhes do usu\00E1rio e o n\00EDvel de acesso ou para excluir o usu\00E1rio.</p>'),
unistr('<p>Clique em <strong>Adicionar Usu\00E1rio</strong>, na parte superior do relat\00F3rio, para adicionar um novo usu\00E1rio e seu n\00EDvel de acesso.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501578505311723)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando o Controle de Acesso \00E9 ativado, os Administradores t\00EAm a capacidade de restringir o acesso a determinadas funcionalidades do aplicativo para usu\00E1rios autenticados. Este aplicativo suporta os seguintes 3 n\00EDveis de acesso: Leitor, Colaborador')
||' e Administrador.<p>',
'<ul>',
unistr('  <li><strong>Leitores</strong> t\00EAm acesso somente para leitura a todas as informa\00E7\00F5es e tamb\00E9m podem exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Colaboradores</strong> podem criar, editar e excluir informa\00E7\00F5es e exibir relat\00F3rios.</li>'),
unistr('  <li><strong>Administradores</strong>,al\00E9m da capacidade de Colaboradores, tamb\00E9m podem executar a configura\00E7\00E3o do aplicativo.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522403475311738)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite os nomes de usu\00E1rios separados por v\00EDrgulas, pontos e v\00EDrgulas ou espa\00E7o em branco. Os nomes de usu\00E1rio existentes ou duplicados ser\00E3o automaticamente ignorados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486916506311713)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As defini\00E7\00F5es da configura\00E7\00E3o permitem que voc\00EA torne a funcionalidade espec\00EDfica dispon\00EDvel (ativada) ou indispon\00EDvel (desativada) para os usu\00E1rios finais.</p>'),
unistr('<p>Se uma fun\00E7\00E3o espec\00EDfica n\00E3o estiver 100% pronta ou precisar ser removida temporariamente, clique em <strong>Desativada</strong>.'),
unistr('Depois que ela ficar dispon\00EDvel, basta clicar em <strong>Ativada</strong>.</p>'),
unistr('<p><em><strong>Observa\00E7\00F5es:</strong> As altera\00E7\00F5es feitas aqui n\00E3o ser\00E3o refletidas para os usu\00E1rios individuais que no momento executam o aplicativo. Depois que o usu\00E1rio final sair do sistema e entrar novamente, as defini\00E7\00F5es da funcionalidade revi')
||unistr('sadas ser\00E3o chamadas.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487035223311713)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o esquema de cor padr\00E3o usado para exibir o aplicativo.</p>'),
unistr('<p>Se a op\00E7\00E3o <strong>Permitir Que os Usu\00E1rios Finais escolham o Estilo do Tema</strong> estiver marcada, ent\00E3o cada usu\00E1rio final pode selecionar os estilos de tema dispon\00EDveis, clicando no link <em>Personalizar</em> no canto inferior esquerdo da Ho')
||'me page.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487646048311713)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina fornece um relat\00F3rio interativo de todos os erros inesperados registrados por este aplicativo.</p>'),
unistr('<p>Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades adicionais avan\00E7adas. Clique no bot\00E3o <strong>Redefinir</strong> para red')
||unistr('efinir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487540920311713)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este relat\00F3rio e gr\00E1fico para ver os usu\00E1rios com mais visualiza\00E7\00F5es de p\00E1gina no per\00EDodo especificado.</p>'),
unistr('<p>Selecione o per\00EDodo do relat\00F3rio (Padr\00E3o = 1 dia) e escolha entre os \00EDcones de relat\00F3rio e de gr\00E1fico na parte superior da p\00E1gina.</p>'),
unistr('<p>Para o relat\00F3rio interativo, use o campo de pesquisa ou selecione o cabe\00E7alho da coluna <strong>Usu\00E1rio</strong>, para selecionar um usu\00E1rio espec\00EDfico. \00C9 poss\00EDvel executar v\00E1rias fun\00E7\00F5es, clicando no bot\00E3o <strong>A\00E7\00F5es</strong>, tais como coluna')
||unistr('s exibidas/ocultas, linhas por p\00E1gina e assim por diante. Clique no bot\00E3o <strong>Redefinir</strong> para redefinir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487766901311713)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina fornece um relat\00F3rio interativo do desempenho e popularidade da p\00E1gina. O relat\00F3rio \00E9 classificado por <strong>Desempenho Ponderado</strong> que \00E9 calculado multiplicando-se o tempo M\00E9dio Decorrido e o n\00FAmero de Visualiza\00E7\00F5es de P\00E1gina')
||'.</p>',
unistr('<p>Selecione o per\00EDodo do relat\00F3rio (Padr\00E3o = 1 dia) na parte superior da p\00E1gina, conforme necess\00E1rio.<br>'),
unistr('Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades adicionais avan\00E7adas. Clique no bot\00E3o <strong>Redefinir</strong> para redefi')
||unistr('nir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487896514311713)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina fornece um relat\00F3rio interativo das visualiza\00E7\00F5es de p\00E1gina mais recentes.</p>'),
unistr('<p>Selecione o per\00EDodo do relat\00F3rio (Padr\00E3o = 1 dia) na parte superior da p\00E1gina, conforme necess\00E1rio.<br>'),
unistr('Clique nos cabe\00E7alhos da coluna para classificar e filtrar os dados ou clique no bot\00E3o <strong>A\00E7\00F5es</strong> para personalizar a exibi\00E7\00E3o da coluna e muitas funcionalidades adicionais avan\00E7adas. Clique no bot\00E3o <strong>Redefinir</strong> para redefi')
||unistr('nir o relat\00F3rio interativo de volta \00E0s defini\00E7\00F5es padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486883846311712)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As notifica\00E7\00F5es s\00E3o exibidas na home page, quando estiverem ativas.</p>'),
unistr('<p>Este relat\00F3rio mostra as notifica\00E7\00F5es definidas e o per\00EDodo no qual elas s\00E3o exibidas.</p>'),
unistr('<p>Clique no \00EDcone de edi\00E7\00E3o (l\00E1pis amarelo) para editar uma notifica\00E7\00E3o existente ou clique em <strong>Adicionar Notifica\00E7\00E3o</strong> para inserir uma nova notifica\00E7\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487151260311713)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome e a descri\00E7\00E3o curta do aplicativo.</p>'),
unistr('<p>O nome \00E9 exibido na home page; a descri\00E7\00E3o, abaixo do nome.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487360525311713)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O feedback pode ser inserido pelos usu\00E1rios finais em qualquer p\00E1gina normal dentro do aplicativo.</p>'),
unistr('<p>Este relat\00F3rio mostra o feedback informado, qualquer resposta inserida pelos administradores e o status do feedback.</p>'),
unistr('<p>Clique no \00EDcone de edi\00E7\00E3o (l\00E1pis amarelo) para inserir uma resposta ou atualizar o status do feedback.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Se os destinat\00E1rios de feedback forem definidos, ent\00E3o os envios de feedback tamb\00E9m ser\00E3o feitos por e-mail aos endere\00E7os de e-mail da lista de destinat\00E1rios de feedback.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503428284311724)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a uma lista separada por v\00EDrgulas de endere\00E7os de e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487428014311713)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p><strong>Ativar Anexos</strong> - Em caso afirmativo, os usu\00E1rios poder\00E3o fazer upload de um anexo em suporte a seu feedback.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488487573311714)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina lista os modelos de e-mail definidos e quantas vezes o modelo foi mencionado nos e-mails enviados.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488277219311714)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina lista os e-mails enviados.</p>'),
unistr('<p>Clique no \00EDcone de Lupa para exibir mais detalhes sobre os e-mails enviados.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488333479311714)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Preencha os seguintes campos para definir um modelo de e-mail:</p>',
'<ul>',
unistr('  <li><strong>Nome do Modelo</strong> (Obrigat\00F3rio) - Digite um nome significativo para o modelo.</li>'),
unistr('  <li><strong>Modelo HTML</strong> (Obrigat\00F3rio) - Digite o c\00F3digo HTML usado para criar o e-mail enviado aos destinat\00E1rios que permitem a entrega de e-mails baseados em HTML.</li>'),
unistr('  <li><strong>Modelo de Texto sem Formata\00E7\00E3o</strong> (Obrigat\00F3rio) - Digite o texto sem formata\00E7\00E3o usado para criar o e-mail enviado aos destinat\00E1rios que n\00E3o aceitam e-mails baseados em HTML.'),
'    Os valores substitutos incluem:',
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong> - ser\00E1 substitu\00EDdo pelo nome do aplicativo</li>'),
unistr('        <li><strong>#BODY1#</strong> - ser\00E1 substitu\00EDdo pelo valor informado como p_body1_text</li> '),
unistr('        <li><strong>#TABLE#</strong> - ser\00E1 substitu\00EDdo pelo valor informado como p_table_content, usando HTML de Abertura da Tabela, HTML de Linha da Tabela e HTML de Fechamento da Tabela</li> '),
unistr('        <li><strong>#BODY2#</strong> - ser\00E1 substitu\00EDdo pelo valor informado como p_body2_text</li> '),
unistr('        <li><strong>#ACTION#</strong> - ser\00E1 substitu\00EDdo pelo valor informado como p_action_label e p_action_link, usando o modelo de Link de A\00E7\00E3o</li>'),
'     </ul></li>',
unistr('  <li><strong>Modelo de Texto Simples</strong> (Obrigat\00F3rio) - Digite o texto simples usado para criar o e-mail enviado aos destinat\00E1rios que n\00E3o aceitam e-mails baseados em HTML. Ele usa as mesmas substitui\00E7\00F5es que o Modelo HTML, exceto #TABLE# e #A')
||unistr('CTION#, que ser\00E3o renderizados como texto simples.</li>'),
'<ul>',
unistr('<p>Modelos HTML adicionais permitem e-mails mais avan\00E7ados. Esses itens incluem:</p>'),
'<ul>',
unistr('  <li><strong>Antes das Linhas</strong> - Informe HTML para substituir #TABLE# no Modelo HTML. S\00F3 ser\00E1 utilizado se p_table_content for informado.</li>'),
unistr('  <li><strong>Modelo de Linha</strong> - Informe HTML para renderizar cada linha da tabela. Isso inclui abertura/fechamento de linha e de dados usando as substitui\00E7\00F5es #LABEL# e #VALUE#. S\00F3 ser\00E1 utilizado se p_table_content for informado.</li>'),
unistr('  <li><strong>Ap\00F3s as Linhas</strong> - Informe HTML para fechar a tabela ou div. S\00F3 ser\00E1 utilizado se p_table_content for informado.</li>'),
unistr('  <li><strong>HTML de Link de A\00E7\00E3o</strong> - Informe o HTML para substituir #ACTION# no Modelo de HTML. Dever\00E1 conter #ACTION_LINK# e #ACTION_TEXT#. S\00F3 ser\00E1 utilizado se p_action_label e p_action_link forem informados.</li>'),
'</ul>',
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Use as entradas do <strong>modelo padr\00E3o</strong> como exemplo para desenvolver seu pr\00F3prio modelo. O modelo padr\00E3o usa todas as vari\00E1veis de substitui\00E7\00E3o que voc\00EA pode ou n\00E3o querer incluir em seu pr\00F3prio modelo d')
||'e e-mail.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488540938311714)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ative ou desative o envio de e-mails selecionando uma das op\00E7\00F5es de <strong>Despachar E-mails</strong>.</p>'),
unistr('<p>Informe <strong>E-mails Enviados de</strong> usando um endere\00E7o de e-mail do contato principal para problemas no aplicativo. Esse valor pode ser usado ou substitu\00EDdo ao utilizar a funcionalidade de e-mail.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506783237311727)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este \00E9 o endere\00E7o do remetente que ser\00E1 usado para enviar e-mails. Ele pode ser substitu\00EDdo durante a utiliza\00E7\00E3o da funcionalidade de e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524089845311739)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Preencha os itens a seguir e clique em [Enviar E-mail]. Todos os e-mails enviados s\00E3o registrados no Log de E-mails.'),
'    <ul>',
unistr('        <li><strong>De</strong> - Se o "Endere\00E7o do Remetente" estiver configurado nas Defini\00E7\00F5es de E-mail, esse endere\00E7o ser\00E1 uma op\00E7\00E3o de origem de envio. Se esse aplicativo usar Endere\00E7os de E-mail como nome de usu\00E1rio, voc\00EA poder\00E1 selecionar o e')
||unistr('nvio de e-mails do seu endere\00E7o. Por \00FAltimo, voc\00EA sempre poder\00E1 definir ''Enviar de'' da mesma forma que ''Enviar para''.</li>'),
unistr('        <li><strong>Enviar para</strong> - Se esse aplicativo usar Endere\00E7os de E-mail como nome de usu\00E1rio, voc\00EA ter\00E1 a op\00E7\00E3o de selecionar o envio de e-mails para Endere\00E7os de E-mail e/ou Usu\00E1rios.</li>'),
unistr('        <li><strong>Endere\00E7os de E-mail</strong> - Lista de endere\00E7os de e-mail separados por v\00EDrgulas para receber o e-mail. Aqueles descobertos como inv\00E1lidos n\00E3o ser\00E3o inclu\00EDdos.</li>'),
unistr('        <li><strong>Atribui\00E7\00E3o</strong> - Envie um e-mail para todos os usu\00E1rios de uma atribui\00E7\00E3o selecionada ou a todos os usu\00E1rios definidos. A lista de sele\00E7\00E3o inclui uma lista de atribui\00E7\00F5es e a contagem de usu\00E1rios com essa atribui\00E7\00E3o.</li>'),
'        <li><strong>Modelo</strong> - Selecione o modelo de e-mail a ser usado para criar o corpo do e-mail.</li>',
'        <li><strong>Assunto</strong> - O assunto do e-mail.</li>',
unistr('        <li><strong>Corpo do E-mail</strong> - Texto a ser inclu\00EDdo como corpo do e-mail.</li>'),
unistr('        <li><strong>Permitir Recusa</strong> - Alguns e-mails dever\00E3o ser enviados independentemente de o usu\00E1rio optar pelo n\00E3o recebimento. Isso inclui mensagens de interrup\00E7\00E3o etc. Esse flag identifica se esse e-mail pode ser recusado ou se deve s')
||unistr('er enviado independentemente da prefer\00EAncia do usu\00E1rio.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525723961311740)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Preencha os itens a seguir e clique em [Enviar E-mail]. Todos os e-mails enviados s\00E3o registrados no Log de E-mails.'),
'    <ul>',
unistr('        <li><strong>De</strong> - Se o "Endere\00E7o do Remetente" for configurado nas Defini\00E7\00F5es de E-mail, esse endere\00E7o ser\00E1 uma op\00E7\00E3o de origem de envio. Caso contr\00E1rio, voc\00EA sempre poder\00E1 definir ''Enviar de'' da mesma forma que ''Enviar para''.</li>'),
unistr('        <li><strong>Endere\00E7os de E-mail</strong> - Lista de endere\00E7os de e-mail separados por v\00EDrgulas para receber o e-mail. Aqueles descobertos como inv\00E1lidos n\00E3o ser\00E3o inclu\00EDdos.</li>'),
'        <li><strong>Modelo</strong> - Selecione o modelo de e-mail a ser usado para criar o corpo do e-mail.</li>',
'        <li><strong>Assunto</strong> - O assunto do e-mail.</li>',
unistr('        <li><strong>Corpo do E-mail</strong> - Texto a ser inclu\00EDdo como corpo do e-mail.</li>'),
unistr('        <li><strong>Permitir Recusa</strong> - Alguns e-mails dever\00E3o ser enviados independentemente de o usu\00E1rio optar pelo recebimento. Isso inclui mensagens de interrup\00E7\00E3o etc. Esse flag identifica se esse e-mail pode ser recusado ou se deve ser e')
||unistr('nviado independentemente da prefer\00EAncia do usu\00E1rio.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107487275217311713)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o fuso hor\00E1rio padr\00E3o para todos os usu\00E1rios deste aplicativo.</p>'),
unistr('<p>Os usu\00E1rios individuais podem substituir esta defini\00E7\00E3o, clicando no nome do usu\00E1rio (parte superior direita) e selecionando <strong>Prefer\00EAncias</strong>. Se preferir, eles podem clicar no link do fuso hor\00E1rio exibido na parte inferior da home pa')
||'ge.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503174469311724)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina n\00E3o fica acess\00EDvel diretamente pela Interface do Usu\00E1rio. \00C9 usada para facilitar o download da foto de perfil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502849696311724)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina de Perfil do Usu\00E1rio permite que voc\00EA veja informa\00E7\00F5es relevantes sobre um usu\00E1rio em uma tela f\00E1cil de usar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502504465311724)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fa\00E7a upload de uma foto com um aspecto quadrado; caso contr\00E1rio, ela poder\00E1 ser distorcida. O tamanho de imagem preferido \00E9 250x250 pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107488634569311714)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este form permite que voc\00EA atualize seus detalhes pessoais e fa\00E7a upload de uma foto ou avatar.</p>'),
unistr('<p>Para fazer upload de uma imagem, clique em <strong>Procurar</strong> ou arraste e solte a imagem acima do bot\00E3o.<br>'),
unistr('Fa\00E7a upload de uma foto com um aspecto quadrado, caso contr\00E1rio ela poder\00E1 ficar distorcida. O tamanho preferido da imagem \00E9 250x250 pixels.</p>'),
'<p>Clique em <strong>Excluir Foto</strong> para remover a imagem.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508701147311728)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todo texto de ajuda do aplicativo pode ser acessado nesta p\00E1gina. Os links da regi\00E3o "Documenta\00E7\00E3o" fornecem uma explica\00E7\00E3o mais detalhada das funcionalidades do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107489755650311715)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 poss\00EDvel definir as prefer\00EAncias do aplicativo para sua conta nesta p\00E1gina. As prefer\00EAncias podem afetar v\00E1rios aspectos do aplicativo, como por exemplo, fuso hor\00E1rio. Clique nos \00EDcones de ajuda em n\00EDvel de item para saber o que cada prefer\00EAncia fa')
||'z.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592579993311012)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Este relat\00F3rio mostra todos os e-mails enfileirados a serem enviados e os que j\00E1 foram enviados.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714025428311109)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Este relat\00F3rio inclui todos os jobs selecionados para serem monitorados por este aplicativo. Mais detalhes de cada job podem ser vistos clicando-se no nome do job.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720638803311114)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Este relat\00F3rio inclui os detalhes da execu\00E7\00E3o sobre os jobs selecionados para serem monitorados por este aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474099769311703)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar p\00E1gina sobre este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490447503311715)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina esta op\00E7\00E3o como N\00E3o, se n\00E3o quiser receber e-mails deste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523581157311739)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite um termo de pesquisa na caixa de di\00E1logo de pesquisa e clique em <strong>Pesquisar</strong>.<br>'),
unistr('Clique em qualquer um dos t\00EDtulos de resultados para navegar at\00E9 esse registro espec\00EDfico.</p>'),
unistr('<p>Para limitar a pesquisa, desmarque uma ou mais origens. Isso remover\00E1 o relat\00F3rio dos resultados da pesquisa.</p>'),
'<p>Clique em <strong>Redefinir</strong> para remover o termo de pesquisa e marque todas as Origens.</p> '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490259384311715)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina seu fuso hor\00E1rio preferido para usar por todo o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488453243310931)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens Ocultos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510315308311729)
,p_name=>'CA.HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107516479743311734)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Home Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531721909311745)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eventos da P\00E1gina por Hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591621636311011)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Corpo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507135554311727)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503844113311725)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Em Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527966900311742)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir nos Forms'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527873487311742)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir nos Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107512563438311731)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'pt-br'
,p_message_text=>'Instalando scripts de objeto de suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714701622311109)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID da Inst\00E2ncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715906031311110)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Perman\00EAncia na Inst\00E2ncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486253574311712)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bem-vindo a esta visualiza\00E7\00E3o somente em nuvem de uma forma nova e aprimorada de criar um aplicativo com funcionalidades mais completas. O Assistente de Cria\00E7\00E3o de Aplicativo padr\00E3o s\00F3 permite que voc\00EA selecione p\00E1ginas para gera\00E7\00E3o, enquanto este')
||unistr(' assistente tamb\00E9m permite que voc\00EA pr\00E9-carregue rapidamente v\00E1rias funcionalidades adicionais para seu aplicativo.</p>'),
unistr('<p>Os aplicativos gerados usando este assistente ser\00E3o totalmente suportados e tamb\00E9m podem ter Objetos de Suporte para funcionalidades selecionadas, como Controle de Acesso, Estrutura de E-mail, Feedback e muito mais.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486485815311712)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Comece informando um nome de aplicativo. Em seguida, adicione uma ou mais p\00E1ginas ao seu aplicativo. Marque as funcionalidades que voc\00EA deseja incluir. Fa\00E7a escolhas em rela\00E7\00E3o \00E0 apar\00EAncia do aplicativo e, em seguida, verifique as defini\00E7\00F5es.<br>'),
'Pronto - Basta clicar em <strong>Criar Aplicativo</strong>.</p>',
unistr('<p>Clique em <strong>Exibir Blueprint</strong> para reutilizar o modelo de um aplicativo gerado anteriormente ou para replicar p\00E1ginas rapidamente.</p>'),
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> Cada se\00E7\00E3o e cada ''Adicionar P\00E1gina'' inclui ajuda detalhada para auxiliar voc\00EA ainda mais.</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486390044311712)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Como Usar Este Assistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519907029311736)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta \00E9 uma lista de problemas significativos na fase de lan\00E7amento:'),
'<ol>',
unistr('  <li>O Assistente de Cria\00E7\00E3o de Aplicativo com base em Blueprint n\00E3o est\00E1 traduzido.</li>'),
unistr('  <li>Os aplicativos traduzidos gerados com esse assistente est\00E3o apenas parcialmente traduzidos.</li>'),
unistr('  <li>O Drill Down de Relat\00F3rio s\00F3 permite uma coluna de drill down.</li>'),
unistr('  <li>N\00E3o \00E9 poss\00EDvel gerar as p\00E1ginas de relat\00F3rio de filtro.</li>'),
unistr('  <li>A funcionalidade de e-mail fornece a API de n\00EDvel baixo, mas ainda n\00E3o inclui funcionalidades de e-mail de n\00EDvel mais alto.</li>'),
unistr('  <li>A gera\00E7\00E3o de um aplicativo com base em um Blueprint que faz refer\00EAncia a tabelas ausentes falhar\00E1 de forma anormal.</li>'),
unistr('  <li>Defini\00E7\00F5es Avan\00E7adas - Formatos de Data n\00E3o s\00E3o aplicados ao aplicativo gerado.</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519803758311736)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Problemas Conhecidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486691036311712)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lan\00E7ado em %0.</p>'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486558630311712)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes da Release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107486168261311712)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Assistente de Cria\00E7\00E3o de Aplicativo de um Projeto {Visualiza\00E7\00E3o Somente em Nuvem}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497773182311720)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o IP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495922609311719)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa de IR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498908424311721)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisas IR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526351636311741)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718702658311112)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o do Job')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720235975311114)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'pt-br'
,p_message_text=>'Classe do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719322730311113)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Criador do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720402406311114)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716965061311111)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'pt-br'
,p_message_text=>'Prioridade do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713953718311109)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Jobs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754011113311142)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir status e executar detalhes de jobs que suportam este aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720598592311114)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Detalhes de Execu\00E7\00E3o do Job')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719450110311113)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719501059311113)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'pt-br'
,p_message_text=>'Subnome do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718851428311113)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715562557311110)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Peso do Job'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526899724311741)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Chaves'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528659101311742)
,p_name=>'CA.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527188937311741)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Labels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528891196311742)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Label no Plural'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528584420311742)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Label no Singular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485346762311711)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485497255311711)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o idioma principal para este aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519367254311736)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O idioma principal \00E9 aquele usado para exibir as p\00E1ginas e os componentes gerados no App Builder. A sele\00E7\00E3o de diversas tradu\00E7\00F5es permitir\00E1 que os usu\00E1rios escolham qual idioma usar na renderiza\00E7\00E3o do aplicativo de runtime.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851716173311225)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502372806311723)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Sobrenome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719606251311113)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o da \00DAltima Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719702481311113)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532114583311745)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Atividade Mais Recente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528092536311742)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523480566311739)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar Blueprint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722010333311115)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data do Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722130207311115)
,p_name=>'CA.LOG.ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716244831311111)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDvel de Log')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399412763311650)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489649488310932)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Colunas de Lookup</strong> - Expanda para ver atributos para definir um lookup para outra tabela. Use Colunas de Lookup para substituir identificadores por uma coluna de exibi\00E7\00E3o, como mostrar o nome do departamento em vez do n\00FAmero.<br>'),
unistr('<em><strong>Observa\00E7\00E3o:</strong> As Colunas de Lookup s\00F3 aparecer\00E3o se a p\00E1gina atual se basear em uma tabela ou view e tenha restri\00E7\00F5es de chave externa para outra tabela.'),
'  <ul>',
unistr('    <li><strong>Chave de Lookup</strong> - Selecione a coluna a ser alterada para produzir a coluna de exibi\00E7\00E3o.</li>'),
unistr('    <li><strong>Coluna de Exibi\00E7\00E3o</strong> - Selecione a coluna (na tabela de lookup) a ser exibida.</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>Observa\00E7\00E3o:</strong> S\00F3 selecione colunas que fa\00E7am refer\00EAncia a outra tabela (usando uma chave externa).</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506314720311726)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar Modelos de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504364796311725)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500420533311722)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar Acesso do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532774219311745)
,p_name=>'CA.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina Detalhe/Mestre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532815799311745)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que exiba uma p\00E1gina detalhe/mestre para permitir que os usu\00E1rios finais vejam e mantenham dados.<br>'),
'&nbsp;</p>',
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Informe um nome para essa p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o dessa p\00E1gina.</li>'),
unistr('  <li><strong>Tipo de P\00E1gina</strong> - Selecione o tipo de p\00E1gina [Lado a Lado; Empilhada].<br>'),
'    <strong>Lado a Lado</strong>: <br>',
unistr('<em>Um detalhe/mestre de uma \00FAnica p\00E1gina que utiliza regi\00F5es de layout e relat\00F3rios lado a lado com janelas de edi\00E7\00E3o.</em>'),
'    <ul>',
unistr('     <li><strong>Tabela</strong> (Obrigat\00F3rio) - Selecione a tabela mestra da p\00E1gina.</li>'),
unistr('      <li><strong>Coluna de Exibi\00E7\00E3o Principal</strong> (Obrigat\00F3rio) - Selecione a coluna a ser exibida na lista de registros mestres.</li>'),
unistr('      <li><strong>Coluna de Exibi\00E7\00E3o Secund\00E1ria</strong> (Obrigat\00F3rio) - Selecione a coluna descritiva a ser exibida na lista de registros mestres, sob a Coluna de Exibi\00E7\00E3o Principal.</li>'),
unistr('      <li><strong>Tabela Detalhada 1</strong> (Obrigat\00F3rio) - Selecione a primeira tabela detalhada da p\00E1gina.</li>'),
unistr('      <li><strong>Tabela Detalhada 2</strong> - Selecione a segunda tabela detalhada da p\00E1gina.</li>'),
unistr('      <li><strong>Tabela Detalhada 3</strong> - Selecione a terceira tabela detalhada da p\00E1gina.</li>'),
unistr('      <li><strong>Tabela Detalhada 4</strong> - Selecione a quarta tabela detalhada da p\00E1gina.</li>'),
'    </ul>',
'    <strong>Empilhada</strong>: <br>',
unistr('<em>Um detalhe/mestre de uma \00FAnica p\00E1gina que utiliza Grades Interativas edit\00E1veis.</em>'),
'    <ul>',
unistr('      <li><strong>Tabela</strong> (Obrigat\00F3rio) - Selecione a tabela mestra da grade interativa edit\00E1vel.</li>'),
unistr('      <li><strong>Tabela Detalhada</strong> (Obrigat\00F3rio) - Selecione a tabela detalhada da p\00E1gina.</li>'),
unistr('      <em><strong>Observa\00E7\00E3o:</strong> Somente uma tabela detalhada (grade interativa edit\00E1vel) pode ser adicionada com o assistente. Tabelas detalhadas adicionais podem ser facilmente inclu\00EDdas ap\00F3s a gera\00E7\00E3o.</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851643242311225)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'pt-br'
,p_message_text=>'Registros Mestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496627126311719)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1x. Decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716788734311111)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo de Falhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716319154311111)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o M\00E1xima da Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716818708311111)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo de Execu\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527008903311741)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530063681311743)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520678729311737)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521084827311737)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520509367311737)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521493964311737)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521510688311737)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'pt-br'
,p_message_text=>'Valor de Data 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520772714311737)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520131551311736)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520048167311736)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521187888311737)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520479632311736)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Registro Selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520323932311736)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Registro Encontrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520932772311737)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520884215311737)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 atualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107520211100311736)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521213054311737)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521375814311737)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496123500311719)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>'Mediano Decorrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505289286311725)
,p_name=>'CA.MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399298749311650)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Mensagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529585031311743)
,p_name=>'CA.METRIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9trica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497053013311720)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDn. Decorrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499827916311722)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'pt-br'
,p_message_text=>'Telefone Celular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495697530311719)
,p_name=>'CA.MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509458243311729)
,p_name=>'CA.MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Mais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499022081311721)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'pt-br'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531998949311745)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas Mais Ativas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489798676310932)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('V\00E1rios Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489862578310932)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Marque uma ou mais nomes de tabela ou view. Como alternativa, clique na caixa de sele\00E7\00E3o no cabe\00E7alho para selecionar ou cancelar a sele\00E7\00E3o de todos os objetos de banco de dados listados.</p>'),
unistr('<p>Uma p\00E1gina com um relat\00F3rio interativo ser\00E1 adicionada para cada objeto de banco de dados marcado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493055809311717)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um timestamp v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529363164311743)
,p_name=>'CA.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484578839311711)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484620075311711)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'<p>Selecione se o menu deve ser exibido na lateral do aplicativo ou na parte superior do aplicativo.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536089269311748)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Negativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535937107311748)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'pt-br'
,p_message_text=>'Neutro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522045916311738)
,p_name=>'CA.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716516172311111)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima Data de Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715480231311110)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'pt-br'
,p_message_text=>'Ambiente NLS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804416984311187)
,p_name=>'CA.NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503915147311725)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515506774311733)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 ajuda dispon\00EDvel para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488592409310931)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Existem Usu\00E1rios V\00E1lidos - Informa\00E7\00F5es da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523001294311738)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum novo usu\00E1rio v\00E1lido encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519152440311736)
,p_name=>'CA.NONE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500173663311722)
,p_name=>'CA.NOTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Observa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475609278311704)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474464151311704)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir notifica\00E7\00F5es na home page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475701966311705)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os administradores do aplicativo especifiquem alertas (amarelo) ou erros (vermelho) que s\00E3o exibidos a todos os usu\00E1rios finais na home page do aplicativo. Esta funcionalidade \00E9 \00FAtil para transmitir informa\00E7\00F5es importantes para sua com')
||unistr('unidade de usu\00E1rios finais.</p>'),
'<p>Inclui os seguintes componentes:<ul>',
unistr('<li>Capacidade de definir notifica\00E7\00F5es</li>'),
unistr('<li>Exibi\00E7\00E3o de notifica\00E7\00E3o na home page do aplicativo</li>'),
unistr('<li>Capacidade de controlar a janela de tempo da exibi\00E7\00E3o da notifica\00E7\00E3o</li>'),
unistr('<li>Suporte \00E0 codifica\00E7\00E3o de cores das notifica\00E7\00F5es, por tipo</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492354378311716)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495826282311719)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAm. de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718637100311112)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Argumentos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715294874311110)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero dos Destinos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527553598311741)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato de N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497317445311720)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorr\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536236375311748)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode executar esta a\00E7\00E3o, a menos que haja outro administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504197424311725)
,p_name=>'CA.OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477194812311705)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Organizando P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477484885311706)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Organize as p\00E1ginas na ordem em que deseja que elas apare\00E7am no seu aplicativo. <br>'),
unistr('Reordene as p\00E1ginas na lista clicando e mantendo pressionado o \00EDcone <em>Arrastar para reordenar a p\00E1gina</em> ( <span class="fa fa-bars" aria-hidden="true"></span> ) no fim de cada listagem de p\00E1gina e, em seguida, arraste e solte essa p\00E1gina para c')
||'ima ou para baixo.</p>',
unistr('<p>A home page sempre \00E9 exibida primeiro e n\00E3o pode ser reordenada..<br>'),
unistr('As p\00E1ginas administrativas s\00E3o sempre exibidas no final da lista e a ordem indicar\00E1 onde elas aparecem na lista Administra\00E7\00E3o de Aplicativos, na p\00E1gina Administra\00E7\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720700936311114)
,p_name=>'CA.OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721983631311115)
,p_name=>'CA.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495520197311719)
,p_name=>'CA.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498703812311721)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eventos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511278918311730)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497892489311720)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853431944311226)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Registro Mestre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853649474311226)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495137705311718)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510534569311729)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497275290311720)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desempenho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522177732311738)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de p\00E1gina "%0" n\00E3o \00E9 v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496550506311719)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477641746311706)
,p_name=>'CA.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477766339311706)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Defina p\00E1gina(s) para incluir em seu aplicativo inicial. \00C9 necess\00E1rio definir pelo menos uma p\00E1gina antes de criar seu aplicativo.</p>'),
unistr('<p>Voc\00EA pode esbo\00E7ar seu aplicativo criando qualquer n\00FAmero de p\00E1ginas que usam este assistente. Depois que criar seu aplicativo, use o Assistente de Cria\00E7\00E3o de P\00E1gina para adicionar mais p\00E1ginas.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527436264311741)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo de Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496819502311720)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views Parciais da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502657531311724)
,p_name=>'CA.PHOTO'
,p_message_language=>'pt-br'
,p_message_text=>'Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503213007311724)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foto exclu\00EDda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502734947311724)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502456881311724)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Upload de Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399365349311650)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507266667311727)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Texto sem Formata\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535858004311748)
,p_name=>'CA.POSITIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Positivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490053589311715)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107533444960311746)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528166336311742)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Exibi\00E7\00E3o Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529063752311743)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529144481311743)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela M\00E3e Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497442513311720)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'pt-br'
,p_message_text=>'Procedimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490689298311715)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia de e-mail atualizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853231388311226)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Extrair Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399595737311650)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Obter Detalhes do Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491896979311716)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Apar\00EAncia do Aplicativo Salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490550884311715)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia de fuso hor\00E1rio atualizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503018583311724)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Download da Foto de Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718920554311113)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Programa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719047277311113)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio do Programa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231938005310724)
,p_name=>'CA.PWA'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar Aplicativo Web Progressivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231825348310724)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Fornecer ao seu aplicativo a capacidade de ser instalado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232045268310724)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Os Aplicativos Web Progressivos s\00E3o aplicativos web projetados para serem capazes, confi\00E1veis e instal\00E1veis. Um Aplicativo Web Progressivo se parece com um aplicativo espec\00EDfico da plataforma.</p>'),
unistr('<p>A ativa\00E7\00E3o desta op\00E7\00E3o vai:</p>'),
'<ul>',
unistr('<li>Adicionar uma nova entrada da barra de navega\00E7\00E3o: Instalar Aplicativo</li>'),
unistr('<li>Permitir que os usu\00E1rios instalem este aplicativo APEX em dispositivos</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227961285310721)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528471310311742)
,p_name=>'CA.QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715794190311110)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Gerar Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357486220310830)
,p_name=>'CA.RATING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107500931602311722)
,p_name=>'CA.READERS'
,p_message_language=>'pt-br'
,p_message_text=>'Leitores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490361014311715)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Receber E-mails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532060794311745)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'Erros Recentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168128261311478)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168268021311478)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492568775311717)
,p_name=>'CA.RED'
,p_message_language=>'pt-br'
,p_message_text=>'Vermelho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107506144744311726)
,p_name=>'CA.REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>'Referenciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852309532311225)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar P\00E1gina Admin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469652869310912)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar ao Fechar a Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106853518437311226)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492013682311716)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o de Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491993273311716)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Itens do Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497947792311720)
,p_name=>'CA.REGION.ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509973027311729)
,p_name=>'CA.RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477294251311706)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Removendo P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107477376462311706)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Clique em <strong>Editar</strong> para selecionar a p\00E1gina; em seguida, clique em <strong>Excluir P\00E1gina</strong> para remover uma p\00E1gina de seu aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720350528311114)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Intervalo de Repeti\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592244834311012)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'pt-br'
,p_message_text=>'Responder Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107483004689311710)
,p_name=>'CA.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107482976559311710)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que seja exibida como relat\00F3rio interativo ou cl\00E1ssico.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tipo de Consulta</strong> - Selecione a origem do relat\00F3rio [<strong>Tabela ou View</strong> ou <strong>Consulta SQL</strong>]:<br>'),
'    <strong>Tabela ou View</strong>:',
'    <ul>',
unistr('      <li>Tabela ou View (Obrigat\00F3rio) - Selecione o objeto do banco de dados para o relat\00F3rio.</li>'),
unistr('      <li>Incluir Form - Selecione para incluir uma p\00E1gina do form vinculada para permitir que os usu\00E1rios mantenham os valores de tabela.</li>'),
'    </ul>',
'    <strong>Consulta SQL</strong>:',
'    <ul>',
unistr('      <li>Consulta SQL (Obrigat\00F3rio) - Informe uma instru\00E7\00E3o SQL v\00E1lida que retorne colunas distintas.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Tipo de Relat\00F3rio</strong> - Selecione o tipo de relat\00F3rio (<strong>Relat\00F3rio Interativo</strong> ou <strong>Relat\00F3rio Cl\00E1ssico</strong>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474733888311704)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'pt-br'
,p_message_text=>'%0 com Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357397660311620)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531126657311744)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529741227311743)
,p_name=>'CA.REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721715583311115)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio Solicitada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529936473311743)
,p_name=>'CA.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508083865311728)
,p_name=>'CA.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504040442311725)
,p_name=>'CA.RESOLVED'
,p_message_language=>'pt-br'
,p_message_text=>'Resolvido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503710823311724)
,p_name=>'CA.RESPONSE'
,p_message_language=>'pt-br'
,p_message_text=>'Resposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717003916311111)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>'Reiniciar ao Falhar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106717114475311111)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'pt-br'
,p_message_text=>'Reiniciar ao Recuperar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714384658311109)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reinicializ\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716639575311111)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Cont. Tentativas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524970246311740)
,p_name=>'CA.ROLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498148391311720)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507437094311727)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524388682311739)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'pt-br'
,p_message_text=>'HTML de Modelo de Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525661411311740)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498815500311721)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Extra\00EDdas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107527358006311741)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106719955355311113)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Contagem de Execu\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721597392311115)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o da Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716408870311111)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Limite de Programa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718473819311112)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da Programa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718577357311112)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Programa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718394388311112)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Programa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485578237311712)
,p_name=>'CA.SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485645774311712)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Selecione o esquema do banco de dados que armazena os objetos do banco de dados que voc\00EA deseja usar neste aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526459919311741)
,p_name=>'CA.SCOPE'
,p_message_language=>'pt-br'
,p_message_text=>'Escopo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508104753311728)
,p_name=>'CA.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508258556311728)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107508312506311728)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo Pesquisar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531329802311744)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros da Pesquisa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515003031311733)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta p\00E1gina se baseia na Lista de Componentes Compartilhados chamada Tabelas Pesquisadas.'),
'',
unistr('Qualquer p\00E1gina do Relat\00F3rio Interativo gerada inicialmente no assistente de Cria\00E7\00E3o de Aplicativo ser\00E1 adicionada automaticamente \00E0 lista. '),
unistr('Para adicionar suas pr\00F3prias tabelas \00E0 lista, navegue para Componentes Compartilhados, selecione Listas e, em seguida, clique em Tabelas Pesquisadas.'),
'  Informe os seguintes atributos:',
unistr('    Entrada: Label de Entrada da Lista - informe o nome para exibi\00E7\00E3o da tabela.'),
unistr('    Destino: P\00E1gina - selecione a p\00E1gina apropriada at\00E9 a qual navegar (preferencialmente, um Relat\00F3rio Interativo)'),
unistr('    Destino: Limpar Cache - informe as p\00E1ginas que precisam ser removidas (geralmente, o mesmo n\00FAmero informado em P\00E1gina).'),
unistr('       Se estiver navegando at\00E9 uma p\00E1gina de Relat\00F3rio Interativo, adicione CIR, RIR para remover qualquer filtro existente e assim por diante.'),
unistr('    Destino: Definir estes itens - selecione (ou informe) o item apropriado da p\00E1gina que deve ser preenchido.'),
unistr('       Se estiver navegando at\00E9 uma p\00E1gina do Relat\00F3rio Interativo, informe IR_[COLUMN_NAME].'),
'    Destino: Com estes valores - informe =PK=',
unistr('    Atributos Definidos pelo Usu\00E1rio: 1 - informe o nome da tabela a ser pesquisado em letras mai\00FAsculas.'),
unistr('    Atributos Definidos pelo Usu\00E1rio: 2 - informe o nome da coluna principal em letras mai\00FAsculas.'),
unistr('    Atributos Definidos pelo Usu\00E1rio: 3 (Opcional) - lista de colunas separadas por v\00EDrgulas a serem pesquisadas.'),
unistr('       Se nenhuma coluna for especificada, todas as colunas de texto (varchar2) e objeto grande de caractere (clob) ser\00E3o pesquisadas.'),
'',
unistr('Observa\00E7\00E3o: Uma lista de tabelas dispon\00EDveis para pesquisa s\00F3 ser\00E1 exibida aos usu\00E1rios se mais de uma tabela for listada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507865189311727)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados da Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528948459311742)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Exibi\00E7\00E3o Secund\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504403956311725)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo Selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591575693311011)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio do Envio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591971238311012)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem de Envios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591478545311011)
,p_name=>'CA.SEND.END'
,p_message_language=>'pt-br'
,p_message_text=>'Fim do Envio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591821265311012)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de Envio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534991601311747)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar E-mails'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107535044598311747)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Determina se os e-mails devem ser enviados quando um novo feedback for recebido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107531637675311744)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524156795311739)
,p_name=>'CA.SEND.TO'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509701014311729)
,p_name=>'CA.SERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721403396311115)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID da Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526615700311741)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prote\00E7\00E3o de Estado de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484901089311711)
,p_name=>'CA.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485026713311711)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique as defini\00E7\00F5es usadas na gera\00E7\00E3o do aplicativo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509350482311729)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469198463310912)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar/Ocultar Escopo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510449593311729)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Fuso Hor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107510228117311729)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'pt-br'
,p_message_text=>'Acessar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511413634311730)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'pt-br'
,p_message_text=>'Sair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721381892311115)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'pt-br'
,p_message_text=>'PID Escravo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715319092311110)
,p_name=>'CA.SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522298626311738)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de origem n\00E3o \00E9 v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107515182649311733)
,p_name=>'CA.SOURCES'
,p_message_language=>'pt-br'
,p_message_text=>'Origens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718245151311112)
,p_name=>'CA.START.DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398769951311650)
,p_name=>'CA.STARTED'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106720094929311114)
,p_name=>'CA.STATE'
,p_message_language=>'pt-br'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529844575311743)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107494176668311718)
,p_name=>'CA.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716030009311110)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Interromper Caso a Janela Seja Fechada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106716154294311111)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sa\00EDda do Armazenamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504632518311725)
,p_name=>'CA.SUBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Assunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107503383314311724)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398984985311650)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas com \00CAxito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107526926694311741)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Visualiza\00E7\00E3o Sugerida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518807065311735)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos de Suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518931080311735)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Digite o c\00F3digo no script de instala\00E7\00E3o, geralmente para criar ou manipular objetos de banco de dados ou fazer inser\00E7\00F5es/atualiza\00E7\00F5es/exclus\00F5es nos registros existentes. Digite o c\00F3digo na desinstala\00E7\00E3o, geralmente para remover (eliminar) objetos ')
||unistr('de banco de dados. Esses scripts ser\00E3o incorporados nos Objetos de Suporte para que, quando voc\00EA exportar o aplicativo, ele fa\00E7a essas mesmas atualiza\00E7\00F5es nos ambientes de teste e produ\00E7\00E3o.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519057729311735)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite instru\00E7\00F5es SQL e/ou PL/SQL v\00E1lidas no Script de Instala\00E7\00E3o que sejam executadas quando o aplicativo for importado.</p>'),
unistr('<p>Se voc\00EA quiser que essas instru\00E7\00F5es tamb\00E9m sejam executadas no ambiente atual e n\00E3o apenas quando o aplicativo for importado em outro ambiente, clique em <strong>Executar ao criar aplicativo</strong>.</p>'),
unistr('<p>Digite instru\00E7\00F5es SQL e/ou PL/SQL v\00E1lidas no Script de Desinstala\00E7\00E3o que sejam executadas quando o aplicativo for exclu\00EDdo do App Builder.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715669162311110)
,p_name=>'CA.SYSTEM'
,p_message_language=>'pt-br'
,p_message_text=>'Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107528365765311742)
,p_name=>'CA.TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485728588311712)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>'Prefixo de Objeto da Estrutura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107485800867311712)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe um prefixo de objeto a ser usado pelo aplicativo. Algumas funcionalidades adicionam este prefixo aos objetos do banco de dados que elas criam (inclusive pacotes e tabelas).</p>',
unistr('<p>Advert\00EAncia: Certifique-se de informar um prefixo exclusivo que n\00E3o \00E9 usado por outros aplicativos. Se n\00E3o for exclusivo, o aplicativo pode gerar erros ao ser criado e n\00E3o funcionar corretamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107529201166311743)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna da Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524218314311739)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107507703549311727)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este nome de modelo j\00E1 est\00E1 sendo utilizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107504538196311725)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493222803311717)
,p_name=>'CA.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591762381311011)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Corpo do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505713499311726)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491415984311716)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia de Tema do Usu\00E1rio Final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491687806311716)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se essa op\00E7\00E3o for marcada, os usu\00E1rios finais poder\00E3o escolher seu pr\00F3prio Estilo do Tema usando o link Personalizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107491535065311716)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite que os Usu\00E1rios Finais escolham o Estilo do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475848186311705)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Estilo do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107474246712311703)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar apar\00EAncia do aplicativo padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107475936732311705)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os administradores selecionem um esquema de cor padr\00E3o (estilo do tema) para o aplicativo. Os administradores tamb\00E9m podem optar por permitir que os usu\00E1rios finais escolham seu pr\00F3prio estilo de tema. Os usu\00E1rios finais podem simplesm')
||unistr('ente clicar no bot\00E3o <em>Personalizar</em> na parte inferior da home page e selecionar os estilos de tema dispon\00EDveis. Por exemplo, usu\00E1rios com defici\00EAncia visual talvez prefiram utilizar o estilo de tema do <em>Vista</em> que tem um contraste de co')
||'r muito maior.</p>',
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Permite que os administradores definam o estilo de tema padr\00E3o</li>'),
unistr('<li>Permite que os usu\00E1rios finais selecionem v\00E1rios estilos de tema</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484379216311711)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo do Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107484455247311711)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o estilo do tema padr\00E3o usado para exibir o aplicativo.</p>'),
unistr('<p>O estilo pode ser facilmente alterado para outro estilo predefinido, ou modificado ap\00F3s a gera\00E7\00E3o. Para alterar o estilo, execute o aplicativo e, em seguida, clique em <strong>Rolador do Tema</strong> na barra de ferramentas do Desenvolvedor.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107498452305311721)
,p_name=>'CA.TIME'
,p_message_language=>'pt-br'
,p_message_text=>'Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107490125089311715)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fuso Hor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476958019311705)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Suporte de Fuso Hor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473854028311703)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir fusos hor\00E1rios do usu\00E1rio e padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476663970311705)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os usu\00E1rios finais definam seus fusos hor\00E1rios locais. Isso \00E9 importante se suas tabelas de aplicativo utilizam fuso hor\00E1rio com foco em tipos de data (como, por exemplo, Timestamp com Fuso Hor\00E1rio Local) de forma que os relat\00F3rios e a')
||unistr(' entrada de dados reflitam onde os usu\00E1rios finais est\00E3o localizados.</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Permite que os administradores definam o fuso hor\00E1rio padr\00E3o</li>'),
unistr('<li>Permite que os usu\00E1rios finais selecionem a prefer\00EAncia do fuso hor\00E1rio</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532251468311745)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'pt-br'
,p_message_text=>'Prazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532565818311745)
,p_name=>'CA.TIMELINE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar P\00E1gina de Linha do Tempo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107532697755311745)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma p\00E1gina que exiba uma linha de tempo que seja especialmente \00FAtil para exibir atualiza\00E7\00F5es.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome da P\00E1gina</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Tabela ou View</strong> (Obrigat\00F3rio) - Selecione o objeto de banco de dados para a linha de tempo.</li>'),
unistr('  <li><strong>Nome do Usu\00E1rio</strong> (Obrigat\00F3rio) - Selecione a coluna da tabela ou view a ser usada como o usu\00E1rio exibido para as entradas de linha do tempo.</li>'),
unistr('  <li><strong>Data</strong> (Obrigat\00F3rio) - Selecione a coluna na tabela ou view a ser usada como a data para as entradas de linha de tempo.</li>'),
unistr('  <li><strong>Nome do Evento</strong> (Obrigat\00F3rio) - Selecione a coluna da tabela ou view a ser usada como o t\00EDtulo para as entradas de linha de tempo.</li>'),
unistr('  <li><strong>Descri\00E7\00E3o</strong> - Selecione a coluna na tabela ou view a ser usada como a descri\00E7\00E3o para as entradas de linha de tempo.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495391974311719)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'pt-br'
,p_message_text=>'Timestamp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499923075311722)
,p_name=>'CA.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592362126311012)
,p_name=>'CA.TO'
,p_message_language=>'pt-br'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499172348311721)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Principais Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499253714311721)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Principais Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496717696311720)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Total de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501181659311723)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o padr\00E3o para usu\00E1rios que n\00E3o est\00E3o na lista de controle de acesso:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493397934311717)
,p_name=>'CA.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803882925311187)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00F5es da Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803931190311187)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura padr\00F5es para defini\00E7\00F5es de interface de usu\00E1rio, como linhas por p\00E1gina, e adiciona a lista de defini\00E7\00F5es de valores. Essas defini\00E7\00F5es s\00E3o usadas ao gerar componentes dentro do aplicativo. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493541329311717)
,p_name=>'CA.UNTIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('At\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852118026311225)
,p_name=>'CA.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502969775311724)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493865593311718)
,p_name=>'CA.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107493938396311718)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107495253818311718)
,p_name=>'CA.USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521730465311737)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios - Etapa 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521855733311737)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios - Etapa 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521938465311738)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Diversos Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107497658025311720)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agente do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511033972311730)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Contagens do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499402703311721)
,p_name=>'CA.USER.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501965780311723)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Perfil do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476897448311705)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Perfis de Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473774168311703)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite que os usu\00E1rios atualizem seus perfis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107476719626311705)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que os usu\00E1rios finais especifiquem informa\00E7\00F5es adicionais sobre eles mesmos, incluindo uma foto ou avatar, para personalizar sua conta.</p>'),
'<p>Inclui os seguintes componentes:',
'<ul>',
unistr('<li>Defini\00E7\00E3o de p\00E1gina para usu\00E1rios finais definirem seus perfis</li>'),
'<li>Capacidade de fazer upload de foto ou avatar</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107502120939311723)
,p_name=>'CA.USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501251993311723)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de nome de usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522653306311738)
,p_name=>'CA.USERNAMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nomes de Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811387770311193)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Nome de Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523264196311738)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio(s) adicionado(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107524773950311739)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios por Atribui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107505364108311726)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Inclu\00EDdos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107522968196311738)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios a serem Adicionados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501494927311723)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de nome de usu\00E1rio atualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488332473310931)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Existem Usu\00E1rios V\00E1lidos - Informa\00E7\00F5es da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517069182311734)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo j\00E1 existe ou est\00E1 reservado para outro aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758647083311145)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o nome do aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525346098311740)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio informar os endere\00E7os de e-mail aos quais enviar o e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525184853311740)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio informar os endere\00E7os de e-mail ou selecionar um conjunto de usu\00E1rios aos quais enviar o e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525254692311740)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio selecionar um conjunto de usu\00E1rios para os quais enviar o e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517123683311734)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O prefixo de tabela n\00E3o deve ter mais de seis caracteres, deve come\00E7ar com letra e conter apenas letras, n\00FAmeros e sublinhados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517229139311734)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe outro Prefixo de Tabela. Os seguintes Objetos de Banco de Dados j\00E1 existem: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501824221311723)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome de usu\00E1rio n\00E3o est\00E1 em um formato de endere\00E7o de e-mail v\00E1lido. Observe o formato de nome de usu\00E1rio do aplicativo abaixo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107501771375311723)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Verificar Formato de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499393903311721)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107519691254311736)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Blueprint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107509253176311728)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes da View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107525528852311740)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107511321082311730)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Meu Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107496204657311719)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>'Desempenho Ponderado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107530160057311743)
,p_name=>'CA.WIDTH'
,p_message_language=>'pt-br'
,p_message_text=>'Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534320435311746)
,p_name=>'CA.WIZARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar P\00E1ginas de Assistente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488268844310931)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cont\00EAiner do Assistente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107534425932311747)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crie uma cole\00E7\00E3o de p\00E1ginas a serem usadas como assistente. Em geral os assistentes s\00E3o usados para inserir dados em v\00E1rias etapas.</p>'),
'<p>Informe os seguintes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nome do Assistente</strong> (Obrigat\00F3rio) - Digite um nome para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir \00CDcone</strong> - Selecione um \00EDcone a ser exibido no menu de navega\00E7\00E3o desta p\00E1gina.</li>'),
unistr('  <li><strong>Modo de P\00E1gina</strong> (Obrigat\00F3rio) - Selecione se as etapas do assistente s\00E3o exibidas como p\00E1ginas modais ou normais. Selecione <strong>P\00E1gina Modal</strong> ou <strong>P\00E1gina completa</strong>.</li>'),
unistr('  <li><strong>Etapa 1 ... 8</strong> - Digite o nome da p\00E1gina para as etapas do assistente.<br><em><strong>Observa\00E7\00E3o:</strong> As Etapas de 5 a 8 s\00E3o exibidas \00E0 medida que um nome \00E9 inserido para cada etapa anterior.</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107499735450311722)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'pt-br'
,p_message_text=>'Telefone comercial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107492419396311717)
,p_name=>'CA.YELLOW'
,p_message_language=>'pt-br'
,p_message_text=>'Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804395969311187)
,p_name=>'CA.YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357390549310830)
,p_name=>'CACHED'
,p_message_language=>'pt-br'
,p_message_text=>'No Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260592451310751)
,p_name=>'CACHE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Cache Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248175680310739)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A funcionalidade Excluir Dados est\00E1 desativada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233118620310725)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A funcionalidade de adi\00E7\00E3o de dados est\00E1 desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233275973310725)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A funcionalidade de atualiza\00E7\00E3o de dados est\00E1 desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386077047310850)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385956353310850)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272308295310764)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio F\00E1cil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290269068311572)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Entrada do Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221609255310715)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Popup de Calend\00E1rio para %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353056260310827)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O calend\00E1rio foi criado com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742689418311132)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Calend\00E1rio Legado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272227768310763)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605604422311022)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de calend\00E1rio ao tentar copiar do aplicativo %0 e ID de modelo %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744009688311134)
,p_name=>'CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228163298310721)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es do Cart\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976053132311326)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'pt-br'
,p_message_text=>'Folhas de Estilo em Cascata'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823431437311203)
,p_name=>'CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400574495311651)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alterar Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739306665311130)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar Tamanho do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739148859311130)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Altera\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952825214311308)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alterar Espa\00E7o de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712686704311108)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Conjunto de Caracteres'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434252113310886)
,p_name=>'CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216945446310711)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Consulta de gr\00E1fico inv\00E1lida: %0<br><br>'),
'Use a seguinte sintaxe:',
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
'<tr><td>LABEL</td><td>O texto que acompanha a barra</td></tr>',
unistr('<tr><td>VALUE</td><td>Coluna num\00E9rica que define o tamanho da barra</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381861134310847)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Consulta de gr\00E1fico inv\00E1lida.<br /><br /> Use a seguinte sintaxe: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>Coluna num\00E9rica que define o valor do quadrante.</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>Coluna num\00E9rica que define o Valor m\00E1ximo do quadrante.</td>'),
'</tr>',
'<tr>',
'<td>LOW (opcional)</td>',
unistr('<td>Coluna num\00E9rica que define o Valor m\00EDnimo do quadrante anterior.</td>'),
'</tr>',
'<tr>',
'<td>HIGH (opcional)</td>',
unistr('<td>Coluna num\00E9rica que define o Valor m\00E1ximo do quadrante anterior.</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448625158310896)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de gr\00E1fico inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216893329310711)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Falha ao fazer parsing da consulta SQL!',
'<p>%0</p>',
unistr('Algumas consultas s\00F3 podem ser executadas durante a execu\00E7\00E3o do aplicativo. Se a consulta estiver com a sintaxe correta, ser\00E1 poss\00EDvel salv\00E1-la sem valida\00E7\00E3o (consulte as op\00E7\00F5es abaixo da origem da consulta).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440161318311679)
,p_name=>'CHART_DEGREES'
,p_message_language=>'pt-br'
,p_message_text=>'graus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690172435311085)
,p_name=>'CHART_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248616091310740)
,p_name=>'CHART_SERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie de Gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735831870311127)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de s\00E9rie %0 no gr\00E1fico para %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344860928310821)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O gr\00E1fico foi criado com sucesso.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693996324311087)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527051246310963)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel da Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526969475310963)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526861115310962)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440969517311680)
,p_name=>'CHECK_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Marcar Tudo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679434652311076)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio Cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682178128311078)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380651543310847)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio Cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679822178311077)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Cl\00E1ssica')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677723098311075)
,p_name=>'CLEAN_UP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Limpar P\00E1gina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243437554310735)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'pt-br'
,p_message_text=>'Limpar Comando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687049557311082)
,p_name=>'CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Fechado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732684203311124)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fechados nos 7 \00DAltimos Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485766813310929)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar Janela'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221164188311518)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo de Acessibilidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517317305311734)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518366996311735)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518223796311735)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'pt-br'
,p_message_text=>'Completar Automaticamente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345912927311612)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'pt-br'
,p_message_text=>'Recuo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517653049311734)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Recuo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517894447311735)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inser\00E7\00F5es de Espa\00E7os na Tabula\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221283453311518)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item %0 n\00E3o existe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222300982311519)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'pt-br'
,p_message_text=>'Minimapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222219642311519)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'pt-br'
,p_message_text=>'Somente quando mais de 100 linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107521659258311737)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'Construtor de Consultas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518493597311735)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'pt-br'
,p_message_text=>'Refazer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518032337311735)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517954798311735)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar N\00FAmeros de Linha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517428331311734)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar R\00E9gua')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222117319311519)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Sugest\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517769861311735)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tamanho da Tabula\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107517505053311734)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222065446311519)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221947334311519)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'pt-br'
,p_message_text=>'Escuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221716848311518)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'pt-br'
,p_message_text=>'Escuro em Contraste Elevado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221850117311518)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Claro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221634025311518)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caso de C\00F3digo de Transforma\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518502962311735)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'pt-br'
,p_message_text=>'Desfazer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221413225311518)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221572472311518)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518121702311735)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Validar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107518654556311735)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o bem-sucedida')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221331111311518)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Whitespace'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624880467311036)
,p_name=>'COLLAPSE'
,p_message_language=>'pt-br'
,p_message_text=>'Contrair '
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256405077310747)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'pt-br'
,p_message_text=>'Paleta de Cores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445882338310894)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Anal\00F3gico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445494462310894)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'pt-br'
,p_message_text=>'Complementar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446093141310894)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'pt-br'
,p_message_text=>'Cores Complementares'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445966897310894)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mon\00F3tono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445597544310894)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'pt-br'
,p_message_text=>'Dividir complementar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445760531310894)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00E9trada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445678853310894)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tr\00EDade')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433867331311675)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome para Exibi\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617368109311030)
,p_name=>'COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Coluna'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805501003311188)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todos os usu\00E1rios autenticados podem acessar este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805687556311188)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente usu\00E1rios definidos na lista de controle de acesso do aplicativo podem acessar este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805784473311188)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Defini\00E7\00E3o de Controle de Acesso Inesperado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249552228310741)
,p_name=>'COMING_SOON'
,p_message_language=>'pt-br'
,p_message_text=>'Em Breve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617833029311031)
,p_name=>'COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486871633310930)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha de compila\00E7\00E3o; linha <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818057553311198)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A compila\00E7\00E3o falhou na linha %0 (%2). Os n\00FAmeros de linha associados a erros de compila\00E7\00E3o s\00E3o relativos \00E0 primeira instru\00E7\00E3o BEGIN. Isso s\00F3 afeta a compila\00E7\00E3o de triggers do banco de dados.<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486712564310930)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL compilado com sucesso (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684435309311080)
,p_name=>'COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691457711311086)
,p_name=>'COMPLETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698316207311091)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo / Sem problemas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733174282311125)
,p_name=>'COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861206976311232)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Componente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052230563311388)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Componente n\00E3o ativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348487589310823)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O componente foi criado com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431565439311673)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Resumo do Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296985182310783)
,p_name=>'COMPUTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755331569311143)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Componentes do aplicativo instalados com sucesso.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487340477310930)
,p_name=>'CONDITIONAL'
,p_message_language=>'pt-br'
,p_message_text=>'Condicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603090502311020)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677263477311075)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'pt-br'
,p_message_text=>'sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408897900310867)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>'existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408284802310866)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408385038310867)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'pt-br'
,p_message_text=>'item/coluna=valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408472550310867)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('item/coluna n\00E3o nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222449680311519)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'item / coluna nulo(a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408909042310867)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'pt-br'
,p_message_text=>'nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409060091310867)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'pt-br'
,p_message_text=>'nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408631825310867)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('p\00E1gina em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408717953310867)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('a p\00E1gina n\00E3o est\00E1 em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408598394310867)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('solicita\00E7\00E3o=e1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419973903310875)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Condi\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640225891311047)
,p_name=>'CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209377392310704)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Detalhe mestre em duas p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209218268310704)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Detalhe mestre em tr\00EAs p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394785613310857)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome Real'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684209293311080)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Agregar por Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684354775311080)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00F5es de Agrega\00E7\00E3o a Serem Usadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392155482310855)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405634581310865)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405702733310865)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Idioma Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405540188310865)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302548103310787)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore de Resultados para Relat\00F3rio Ativada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302631259310787)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros de Resultados para Relat\00F3rio Ativados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405829866310865)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859378371311230)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608596745311024)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Quebrar Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394567701310857)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o do Bot\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394491408310856)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto de Exibi\00E7\00E3o do Bot\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229885435310722)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativar Adi\00E7\00E3o de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229707607310722)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Arrastar e Soltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807808042311190)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cancelar Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859137861311230)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label do Bot\00E3o Cancelar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851265785311224)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485228141310928)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou altera\00E7\00E3o na consulta do Relat\00F3rio Interativo. Se voc\00EA removeu qualquer coluna da consulta, isso desativar\00E1 os filtros existentes, as regras de destaque e outras defini\00E7\00F5es de relat\00F3rio dessas colunas. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395627861310857)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eixo do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744400620311134)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744599323311134)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrante (Curva)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396382819310858)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barra Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396525163310858)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395834903310857)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396481633310858)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'pt-br'
,p_message_text=>'Pizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395583677310857)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395729412310857)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'pt-br'
,p_message_text=>'Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396619452310858)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispers\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396163182310858)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tamanho do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396066560310858)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395993511310858)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396228489310858)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barra Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302797516310788)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Conjunto de Resultados Tempor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392990705310855)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608332104311024)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alhos de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771002638311155)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808068069311190)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'pt-br'
,p_message_text=>'Nomes da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405219959310864)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Classifica\00E7\00E3o de Cabe\00E7alho de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529281063310965)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a c\00F3pia de um aplicativo com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403863104310863)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a c\00F3pia de uma p\00E1gina com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393431041310856)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um novo conjunto de guias "%0" ser\00E1 criado e usado por esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405454567310864)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um aplicativo com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397958700310859)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de calend\00E1rio com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401154415310861)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de relat\00F3rio de drill-down com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454082049310901)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de Relat\00F3rio Interativo com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404189646310863)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de relat\00F3rio com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412527872311660)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um aplicativo de Banco de Dados usando o mesmo ID de outro aplicativo de Banco de Dados existente no espa\00E7o de trabalho atual. O aplicativo de Banco de Dados existente ser\00E1 exclu\00EDdo e substitu\00EDdo pelo novo. Confirme suas s')
||unistr('ele\00E7\00F5es. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767919132311153)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de form e p\00E1ginas da view em lista com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683906181311080)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um form em uma p\00E1gina de relat\00F3rio com p\00E1ginas de an\00E1lise. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397540997310859)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um form na consulta SQL com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397482559310859)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um form em procedimento armazenado com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397317006310858)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um form em uma p\00E1gina de tabela com os atributos a seguir.   Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273007020310764)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um form em uma p\00E1gina de refer\00EAncia a Web service com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313295510310797)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um form e um relat\00F3rio em uma p\00E1gina de refer\00EAncia a Web service com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711546059311107)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de Mapa com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106206936993310702)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de p\00E1ginas detalhe mestre com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399112419310860)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma regi\00E3o e de uma op\00E7\00E3o de breadcrumb com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690268990311085)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397182745310858)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461501773311694)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461645746311695)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399911187310860)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de p\00E1ginas de relat\00F3rio e form com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408483089311657)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403956751310863)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de relat\00F3rio com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397603639310859)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma P\00E1gina de Gr\00E1fico de Barras HTML com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403537175310863)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de resumo com os atributos a seguir. Pressione o bot\00E3o "Adicionar Mais" para adicionar itens de outras p\00E1ginas e/ou regi\00F5es. Pressione "Finalizar" para criar os itens de resumo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397707958310859)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de gr\00E1fico SVG com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397005568310858)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de form tabular com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398213627310859)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma p\00E1gina de \00E1rvore com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106397298370310858)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um assistente com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412411458311660)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de um aplicativo de Websheet usando o mesmo ID de outro aplicativo de Websheet existente no espa\00E7o de trabalho atual. O aplicativo de Websheet existente ser\00E1 exclu\00EDdo e substitu\00EDdo pelo novo. Confirme suas sele\00E7\00F5es. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605052260311021)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Label do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349123781311614)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da Defini\00E7\00E3o de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419575766311665)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta Defini\00E7\00E3o de Carga de Dados ser\00E1 recreada com as pesquisas de tabela e regras de transforma\00E7\00E3o existentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851333913311224)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398026202310859)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690329241311085)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autentica\00E7\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396935389310858)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401859666310862)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas de Exibi\00E7\00E3o Detalhadas %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209738886310704)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna(s) de Exibi\00E7\00E3o Detalhada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403414705310863)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Detalhada do Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402621088310862)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela Detalhada %0 para Ordena\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401355279310861)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Detalhada %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209642217310704)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela Detalhada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401611097310862)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela Detalhada %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401494920310861)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhar Label da Guia %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808397237311190)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Upload da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395010374310857)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770710072311155)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Upload da Coluna 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770801541311155)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Upload da Coluna 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399341195310860)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469143338311700)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469225270311700)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594970113311014)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sa\00EDda em CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595658326311014)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imprimir Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596272896311015)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativar Classifica\00E7\00E3o de Cabe\00E7alho de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642139943311048)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma regi\00E3o ser\00E1 adicionada \00E0 P\00E1gina de Administra\00E7\00E3o existente:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807961724311190)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Finalizar Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400458206310861)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400525125310861)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400753945310861)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label da Guia da P\00E1gina de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400683325310861)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias da P\00E1gina de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690429999311085)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Importar Componentes Compartilhados de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037288648311376)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir Calend\00E1rio Personalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209972260310704)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir relat\00F3rio mestre?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403107650310863)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir um Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394243007310856)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394340569310856)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto Padr\00E3o para Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273271777310764)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens de Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302951881310788)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302894059310788)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da Regi\00E3o do Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396793382310858)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394027718310856)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808219087311190)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807171024311189)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna 1 de Chave de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807289018311189)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna-Chave 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807344143311190)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna-Chave 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398179248310859)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Labels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770906427311155)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808174622311190)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela de Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210067522310704)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Layout de Detalhe Mestre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209506401310704)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna(s) de Exibi\00E7\00E3o Mestra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209829895310704)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'pt-br'
,p_message_text=>'Navegar registro mestre por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106209463599310704)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela Mestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608472015311024)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero M\00E1ximo de Colunas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604867147311021)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461111133310906)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399660363310860)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403213623310863)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'pt-br'
,p_message_text=>'Raiz de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399426609310860)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399776795310860)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275799129310766)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou o upgrade do gr\00E1fico HTML para o novo gr\00E1fico HTML5. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428168423311671)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou o upgrade de jsTree para uma nova \00C1rvore. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385835194310850)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O gr\00E1fico SVG ser\00E1 submetido a upgrade com as seguintes restri\00E7\00F5es:  '),
'<ul>',
'<li>',
unistr('Somente os formatos de n\00FAmero definidos nas strings do formato do eixo ser\00E3o migradas. Os formatos de data e de hor\00E1rio ser\00E3o ignorados.'),
'</li>',
'<li>',
unistr('Os elementos do formato do n\00FAmero que cont\00EAm as seguintes op\00E7\00F5es ser\00E3o migrados:'),
'<br />',
unistr('0,9,D,G,, (v\00EDrgula),. (ponto final),$,C,L,FM'),
'</li>',
'<li>',
unistr('O label para cada s\00E9rie no gr\00E1fico em Flash ser\00E1 derivado de cada alias da coluna da s\00E9rie.  '),
unistr('Esse recurso difere dos gr\00E1ficos SVG, onde o label para cada s\00E9rie foi derivado do atributo do Nome da S\00E9rie.'),
'</li>',
'<li>',
unistr('Os gr\00E1ficos de Quadrantes em Flash exibem os valores reais em vez de percentuais.'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349849194310824)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou o upgrade do gr\00E1fico SVG para um gr\00E1fico HTML5. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408224590311657)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406164714310865)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019537939311363)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista do Menu de Navega\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701781508311093)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma nova p\00E1gina de Administra\00E7\00E3o ser\00E1 adicionada, P\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485493738310929)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Novas Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394857105310857)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858964797311230)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label do Bot\00E3o Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393309470310856)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum conjunto de guias foi selecionado para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393903994310856)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273326743310764)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens de Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395242553310857)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392251158310855)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405970904310865)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392386549310855)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393280890310856)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401711734310862)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas de Exibi\00E7\00E3o M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399807823310860)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403318682310863)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Breadcrumb Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401952803310862)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela Pai para Ordena\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401281449310861)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401565307310861)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393826854310856)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label da Guia M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393792923310856)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485151576310928)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema de Parsing'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491842476310933)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00E3o de P\00E1gina Parcial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859015714311230)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label do Bot\00E3o Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393183604310856)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Chave Prim\00E1ria %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400817670310861)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605149109311021)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608667874311024)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Imprimir Label do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605225336311021)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395135927310857)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Processo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604920473311021)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394141310310856)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392441484310855)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399252215310860)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485386732310928)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas Removidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400995804310861)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624941952311036)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Implementa\00E7\00E3o de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400093456310860)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400124081310861)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400373127310861)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label de Guia de P\00E1gina de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106400233876310861)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias da P\00E1gina de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303121881310788)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303048095310788)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da Regi\00E3o de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404211597310863)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305661284310790)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Vers\00E3o da Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404441260310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: HTML (padr\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404777537310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: Apar\00EAncia 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404878902310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: Apar\00EAncia 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484924985310928)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: Apar\00EAncia 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485065513310928)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: Apar\00EAncia 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303634934310788)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: Apar\00EAncia 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404573285310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: relat\00F3rio vertical')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404974664310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'pt-br'
,p_message_text=>'exportar: CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405054856310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'pt-br'
,p_message_text=>'exportar: XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404644009310864)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: relat\00F3rio vertical, apar\00EAncia 1 (incluir colunas nulas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484721456310928)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: relat\00F3rio vertical, apar\00EAncia 2 (excluir colunas nulas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484856822310928)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('padr\00E3o: relat\00F3rio vertical, apar\00EAncia 2 (incluir colunas nulas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808410572311190)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Regra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808658694311191)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808756960311191)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Regra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248387502310740)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a execu\00E7\00E3o do script a seguir. Confirme sua sele\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399576148310860)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404397315310864)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395465220310857)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491797857310933)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639832365311047)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('V\00E1rias p\00E1ginas ser\00E3o criadas, come\00E7ando pela P\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106395372575310857)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Procedimento Armazenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486699042310929)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio do Procedimento Armazenado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859219013311230)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label do Bot\00E3o Finalizar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423548966311668)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Inscrever Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394658716310857)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome Sugerido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684085718311080)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela/View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684154086311080)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Resumir Por Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870340613311239)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisas de Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392864769310855)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392776592310855)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970437442311322)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regra de Transforma\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808883224311191)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regras de Transforma\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485632157310929)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela / View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485534750310929)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Tabela/View')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406049888310865)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393630750310856)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia; as informa\00E7\00F5es do conjunto de guias est\00E1 incompleta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392633645310855)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label de Guia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106404086748310863)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Guia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392515464310855)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405192808310864)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'modelo:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398863770310860)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Com base no novo item com lista de valores popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398560552310859)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1x. de N\00EDveis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398366764310859)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398724691310859)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398918833310860)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Com Base em uma Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398673590310859)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Inicial:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106399095251310860)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106398413727310859)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406230210310865)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406357975310865)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'pt-br'
,p_message_text=>'Azul e Marrom-Amarelado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406416760310865)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'pt-br'
,p_message_text=>'Vermelho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406506650310865)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Marinho e Cinza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406629007310865)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'pt-br'
,p_message_text=>'Verde-oliva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406737902310865)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bord\00F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406801791310865)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'pt-br'
,p_message_text=>'Azul Simples e Marrom Amarelado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106406994507310866)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'pt-br'
,p_message_text=>'Azul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407039674310866)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393065218310855)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas Atualiz\00E1veis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106396865260310858)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106393583152310856)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina usar\00E1 o conjunto de guias existente "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273189628310764)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncia a Web Service, Opera\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106401067296310861)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cl\00E1usula Where')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674562281311073)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone de Confirma\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684833607311081)
,p_name=>'CONFIRMED'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685116499311081)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmado pelo Contr. Qualidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605409238311021)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Quebrar Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605354680311021)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Impress\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712764452311108)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Disposi\00E7\00E3o de Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745402948311135)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo Fornecido')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523644800311739)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'pt-br'
,p_message_text=>'Colaboradores'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438204360311678)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo ID Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484575722310928)
,p_name=>'COPY_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Copiar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349634676310824)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O seu aplicativo foi copiado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463963914310908)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a execu\00E7\00E3o de copy_button: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529831262310965)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar Atributos de Defini\00E7\00E3o do Objeto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324715932310806)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768730420311153)
,p_name=>'COPY_FEATURE'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Recurso: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529472730310965)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910313165311270)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Com Base na Aplicativo-Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529575168310965)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar de Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353475203310827)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464343070310908)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a execu\00E7\00E3o de copy_named_lov: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464253954310908)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID da Lista de Valores "%0" n\00E3o foi encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464145769310908)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID da Lista de Valores "%0" n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750249351311139)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar Da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750391074311139)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar Para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749371631311138)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Selecionar Autoriza\00E7\00E3o -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749231106311138)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Lista -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749152937311138)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Lista de Valores -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813570717311195)
,p_name=>'COPY_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar %0 para a tabela %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529610628310965)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Para Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529794039310965)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar para Nome'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436374173310887)
,p_name=>'CORE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('b\00E1sico')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879366705311246)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879423882311246)
,p_name=>'CREATE OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768426664311153)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criados(as) nos 7 \00FAltimos dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324853237310806)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'De um modelo de aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351904682311616)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos Candlestick')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351709076311616)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos de Barras e Empilhados, Colunas, 2D e 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352491927311617)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Quadrantes e Quadrante (Percentual)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351831440311616)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>'Setores Circular e Anel em 2D e 3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352127885311616)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos de Gantt do Projeto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352390543311616)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos de Faixa 2D e 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352228675311616)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos de Gantt do Recurso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352016064311616)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos do Marcador de Dispers\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429741539310882)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'pt-br'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429514790310882)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Seta para Baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429634120310882)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Seta para a Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429373681310882)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429483484310882)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429839982310882)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'pt-br'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429924945310882)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Visualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769115340311154)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no bot\00E3o Conceder Privil\00E9gios a seguir para conceder estes privil\00E9gios agora para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768924470311154)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o tem o privil\00E9gio CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE ou CREATE PROCEDURE e n\00E3o poder\00E1 instalar o aplicativo de demonstra\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769065467311154)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 n\00E3o tem privil\00E9gio de execu\00E7\00E3o em CTX_DOC e CTX_DDL e n\00E3o poder\00E1 instalar a demonstra\00E7\00E3o de discurso de posse do presidente. Fa\00E7a as seguintes concess\00F5es como um usu\00E1rio privilegiado: '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012935550311358)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Bot\00E3o - Caixa de Di\00E1logo Fechada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245755074310737)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Lista Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486477435310929)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar LOV Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223768105310717)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262884575310753)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Conta de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904073567311265)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o do Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769576790311154)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'pt-br'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408326017311657)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista do Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904172205311266)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903739166311265)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903883471311265)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um N\00EDvel de Guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769631660311154)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha de Sign-on \00DAnico (SSO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903901358311265)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dois N\00EDveis de Guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324605455310806)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Em uma planilha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218388371310712)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os componentes da p\00E1gina global ser\00E3o exibidos em todas as p\00E1ginas se o ponto de exibi\00E7\00E3o da regi\00E3o estiver dentro do modelo de p\00E1gina selecionado. Os atributos Exibi\00E7\00E3o Condicional podem ser usados para suprimir a exibi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455042045310902)
,p_name=>'CREATE_INDEX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar \00CDndice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628318559311038)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('nenhuma regi\00E3o associada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436070975310887)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar nova p\00E1gina de log-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431488221310884)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'pt-br'
,p_message_text=>'Voltar para Criar Assistente de Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430941844310883)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar Pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430808072310883)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'O pacote "%0" foi criado no esquema "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431572518310884)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'pt-br'
,p_message_text=>'Falha ao criar tabela "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431311471310884)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431164121310883)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431280949310883)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431003227310883)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'pt-br'
,p_message_text=>'Home do SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426648352310880)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum item encontrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426286077310880)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426570643310880)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Prompt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426392703310880)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426444340310880)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('clique para definir regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424370414310878)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424409680310878)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430716135310883)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430543788310883)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430488938310883)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430104827310883)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foi criado criar script de tabela para a tabela %0 no reposit\00F3rio de script SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430259396310883)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir Para o Reposit\00F3rio de Scripts')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430611237310883)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'SQL&nbsp;Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106430314856310883)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'pt-br'
,p_message_text=>'Home do SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859975262311231)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426147340311670)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Tarefa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814115328311195)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>'Criar trigger %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760475782311147)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos criados do banco de dados da websheet.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106714968369311110)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Credencial')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679305351311076)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602725584311019)
,p_name=>'CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671823952311071)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671528477311070)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Elemento de form atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446156626310895)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Ajuda do Item Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671692647311070)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Identifica\00E7\00E3o do Item Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671771141311070)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Label de Item Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727462947311119)
,p_name=>'CURRENT TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Guia Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412726827310870)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419559496310875)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953068750311308)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'pt-br'
,p_message_text=>'O ID que pode ser usado em um elemento de container que encapsula o campo atual, no atributo Label e Item Anteriores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430896421311673)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label da Ajuda do Item Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381293343310847)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'pt-br'
,p_message_text=>'Marco Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418663486310874)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696180227311089)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual Cont\00E9m N\00E3o Tem Itens.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667487241311067)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizar Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227063679311522)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos Personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244649086310736)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Desenvolvedor Definido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459808835310905)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro em %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381464786310847)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe qualquer string a ser usada como seu identificador de usu\00E1rio para esta sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381585087310847)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o %0 nome do usu\00E1rio e a senha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381620493310847)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do usu\00E1rio e a senha para verifica\00E7\00E3o pelo host LDAP: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381779764310847)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do usu\00E1rio e a senha do esquema de banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037577273311377)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>'Recarregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042529948311380)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042468257311380)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815078473311196)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando a A\00E7\00E3o Verdadeira for Definir Valor com Definir Tipo de Instru\00E7\00E3o de SQL, \00E9 necess\00E1rio definir os Elementos Afetados na mesma ordem da ordem da coluna de sua instru\00E7\00E3o SQL. A Instru\00E7\00E3o SQL definida foi:</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612640843311027)
,p_name=>'DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878974823311246)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'Data Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467755788310911)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as %0 colunas foram mapeadas automaticamente para a tabela %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468535435310912)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da tabela <code>%0</code> com <b id="incompl_success_row_count"></b> novas linhas anexadas.  <b class="u-danger-text" id="incompl_fail_row_count"></b> linhas rejeitadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468163138310911)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da tabela <code>%0</code> com <b id="success_row_count"></b> novas linhas anexadas!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468311750310911)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da tabela <code>%0</code> com <b id="err_success_row_count"></b> novas linhas anexadas. <b class="u-danger-text" id="err_fail_row_count"></b> linhas rejeitadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220803359310714)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Arquivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215456063310709)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'O mapeamento da coluna deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258472169310749)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o Salva!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220418731310714)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'pt-br'
,p_message_text=>'Perfil de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220531393310714)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas do Perfil de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219860134310713)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467810059310911)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Defina o mapeamento de coluna para carregar esses dados na tabela %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220378718310714)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220705120310714)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'pt-br'
,p_message_text=>'Arraste e solte o arquivo aqui ou'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220697771310714)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os formatos suportados s\00E3o csv, xlsx, txt, xml e json')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876952108311244)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A execu\00E7\00E3o do job de Carregamento de Dados foi interrompida inesperadamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819875050311200)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Job de Carregamento de Dados no Espa\00E7o de Trabalho %0: Carregar na Tabela %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220084871310713)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo Carregado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467962229310911)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 de %1 colunas foram mapeadas automaticamente para a tabela %2. Configure as %3 colunas restantes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858017880311229)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados Colados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468696253310912)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados da tabela <code>%0</code> substitu\00EDdos por <b id="incompl_success_row_count"></b> novas linhas.  <b class="u-danger-text" id="incompl_fail_row_count"></b> linhas rejeitadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468220120310911)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados da tabela <code>%0</code> substitu\00EDdos por <b id="success_row_count"></b> novas linhas!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468461453310911)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados da tabela <code>%0</code> substitu\00EDdos por <b id="err_success_row_count"></b> novas linhas. <b class="u-danger-text" id="err_fail_row_count"></b> linhas rejeitadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106468014179310911)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione as colunas a serem carregadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200962412310696)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'pt-br'
,p_message_text=>'Formatos suportados %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219906482310713)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Upload de um Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220151462310714)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Planilha XLSX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420286885311665)
,p_name=>'DATABASE'
,p_message_language=>'pt-br'
,p_message_text=>'Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879586522311246)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'pt-br'
,p_message_text=>'Browser do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365390755311626)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Banco de Dados de Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420354170311665)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264302658310757)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279960035310770)
,p_name=>'DATABASE_APPS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755185504311142)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo <strong>%0</strong> instalado com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657821286311060)
,p_name=>'DATABASE_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707300472311098)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Contagens de Objetos do Banco de Dados por Tipo de Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710584995311106)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios de Atribui\00E7\00E3o do Banco de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275625357310766)
,p_name=>'DATABASE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>'Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809389237311191)
,p_name=>'DATA_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355239368311619)
,p_name=>'DATA_GRIDS'
,p_message_language=>'pt-br'
,p_message_text=>'Grades de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355672929311619)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342113940311609)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es Avan\00E7adas de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355306404310828)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formatos de Data / N\00FAmero a serem usados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355426753310828)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha se vai fornecer m\00E1scaras de formato personalizado ou usar as de formato padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276025553310766)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Caracteres do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868734275311238)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'pt-br'
,p_message_text=>'Nomes de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753252145311141)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'pt-br'
,p_message_text=>'Aliases dos Nomes da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008158149311354)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Os dados foram submetidos a upload com sucesso para sua tabela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013647389311358)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar e Colar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002501067311349)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar e Colar Dados Delimitados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384612461311640)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00EDmbolo da Moeda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384767310311640)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se seus dados contiverem o s\00EDmbolo de moeda internacional, informe-o aqui. Por exemplo, se seus dados tiverem "&euro;1,234.56" ou "&yen;1,234.56", informe "&euro;" ou "&yen;". Do contr\00E1rio, os dados n\00E3o ser\00E3o carregados corretamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280728639310770)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342241199311609)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar m\00E1scaras de formato padr\00E3o do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342391872311609)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Fornecer formatos personalizados para colunas submetidas a upload'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385999514311641)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O caractere de decimal separa o inteiro e as partes decimais de um n\00FAmero.</p>'),
unistr('<p> Qualquer caractere pode ser o caractere de decimal. O caractere especificado deve ser monobyte, e o caractere de decimal deve ser diferente do separador de grupo. O caractere pode ser um espa\00E7o, mas n\00E3o pode ser um n\00FAmero ou um dos seguintes cara')
||'cteres:</p>',
'<ul class="noIndent">',
'<li>mais (+)</li>',
unistr('<li>h\00EDfen (-)</li> '),
'<li>sinal de menor que (<)</li>',
'<li>sinal de maior que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385044264311640)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Caractere de Decimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383925851310849)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O caractere decimal ser\00E1 necess\00E1rio se o separador de grupo for definido para a coluna de tabela %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753420583311141)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819957150311200)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Diversas colunas de origem foram mapeadas para a coluna da tabela %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151331173311465)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) com Falha:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366793511311627)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'pt-br'
,p_message_text=>'Registros com Falha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384277606311639)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do arquivo para upload'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010780522311356)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'A Primeira Linha tem Nomes de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384392012311639)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione esta caixa se seus dados contiverem nomes de coluna na primeira linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384551273311640)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Globaliza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384982700311640)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Um separador de grupo \00E9 um caractere que separa grupos de inteiros, por exemplo, para mostrar milhares e milh\00F5es.</p>'),
unistr('<p>Qualquer caractere pode ser o separador de grupo. O caractere especificado deve ser monobyte, e o separador de grupo deve ser diferente de qualquer outro caractere de decimal. O caractere pode ser um espa\00E7o, mas n\00E3o pode ser um n\00FAmero ou um dos se')
||'guintes:</p>',
'<ul class="noIndent">',
'<li>mais (+)</li>',
unistr('<li>h\00EDfen (-)</li> '),
'<li>sinal de menor que (<)</li>',
'<li>sinal de maior que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384820125311640)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Separador de Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151190075311465)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) Inserida(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381781041311638)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Essa consulta retorna mais de #MAX_ROW_COUNT# linhas. Filtre seus dados para garantir resultados completos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752109247311140)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Registros Alterados por Outro Usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375360424310843)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375282169310843)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974211887311324)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Falha ao Carregar Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974397181311324)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Processada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998313734311346)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Importar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807535824311190)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa 2 - Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432691702311674)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma visualiza\00E7\00E3o de arquivo dispon\00EDvel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383418564311639)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opcionalmente Inclu\00EDdo Por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345614822311612)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento do Assistente de Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807752936311190)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa 4 - Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753341942311141)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751643181311140)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas a Serem Revisadas:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865855844311235)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate);',
'',
'my_func(p_1  => :SAL,',
'        p_2  => :COMM);',
'',
unistr('onde SAL e COMM s\00E3o nomes de coluna de dados submetidos a upload'),
unistr('e   my_func \00E9 a fun\00E7\00E3o que retornar o valor que ser\00E1 o novo valor'),
unistr('da coluna para a qual esta regra de transforma\00E7\00E3o \00E9 definida.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866000188311236)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('O resultado retornado ser\00E1 o novo valor da coluna para a qual esta regra de transforma\00E7\00E3o \00E9 definida.'),
'',
'E :SAL e :COMM referem-se aos nomes das colunas SAL e COMM dos dados submetidos a upload.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865955046311235)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'',
'select depno',
'  from dept',
'  where dname = :DEPTNAME',
'  and   loc = :LOC',
'',
'onde :DEPNAME e :LOC referem-se aos nomes da coluna DEPNAME e LOC dos dados submetidos a upload.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106392060529310855)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Na coluna de tabela %0, o mesmo caractere n\00E3o pode ser definido ao mesmo tempo como separador de grupo e como caractere decimal. Insira caracteres distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383262338311639)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Identifique um caractere separador de coluna. Use <strong>\t</strong> para separadores de guia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383387366311639)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753522200311141)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341909047311609)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Defini\00E7\00F5es Avan\00E7adas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342090132311609)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir defini\00E7\00F5es avan\00E7adas para carregamento de dados: S\00EDmbolo de Moeda, Caracteres Decimais, Codifica\00E7\00E3o de Arquivo ou Formatos de Data')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018258710311362)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem da Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807442675311190)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa 1 - Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420589639311665)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'pt-br'
,p_message_text=>'(\t para a guia)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382061645311638)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Exclusiva %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151281326311465)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) Atualizada(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461844474311695)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Foi feito upload de um valor nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013541600311358)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivo obtido por upload, separado por v\00EDrgulas (*.csv) ou delimitado por tabula\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018460561311362)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados de Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018348893311362)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807638390311190)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa 3 - Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811713386311193)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As p\00E1ginas do assistente de carga de dados foram criadas com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974448393311325)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Falha de Mapeamento de Dados / Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974587775311325)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Processada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680527990311077)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Mapeamento de Coluna de Upload de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106405315020310864)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Coluna: Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267167890310759)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'pt-br'
,p_message_text=>'Caractere Decimal: Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267350110310759)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato: Coluna %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267243539310759)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Separador de Grupo: Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267557388310760)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Mapear para: Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454496697310901)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tamanho M\00E1ximo: Coluna %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267414572310760)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Coluna N\00E3o Mapeada -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800673685311184)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Data Real\00E7ada informado %0 para o item %1 n\00E3o corresponde ao formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805837194311188)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Data Real\00E7ada informado %0 para o item %1 n\00E3o \00E9 uma data relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800887510311184)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Data M\00E1xima informado %0 para o item %1 n\00E3o corresponde ao formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806098069311188)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Data M\00E1xima informado %0 para o item %1 n\00E3o \00E9 uma data relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218150591310712)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Est\00E1tico M\00E1ximo %0 informado para o item %1 n\00E3o corresponde ao formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800709287311184)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Data M\00EDnima informado %0 para o item %1 n\00E3o corresponde ao formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805953866311188)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Data M\00EDnima informado %0 para o item %1 n\00E3o \00E9 uma data relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218016135310712)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do atributo Est\00E1tico M\00EDnimo %0 informado para o item %1 n\00E3o corresponde ao formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907985512311268)
,p_name=>'DATE_ADDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de Adi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352604745311617)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Jobs do banco de dados do Oracle APEX com o hor\00E1rio da \00FAltima execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730487412311122)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('at\00E9 o marco final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730503567311122)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('at\00E9 o marco final da release %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805232504311188)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Classe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358026585311621)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'pt-br'
,p_message_text=>'Alerta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356893319311620)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358231640311621)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Limpar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358154641311621)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197557985310693)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cancelar Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197631384310693)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fechar Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349507545310824)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Desativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349459344310824)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349713085311615)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349345013310824)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725719860311118)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar C\00F3digo JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979934082311329)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805327941311188)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Classe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805461692311188)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962828976311316)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Foco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725689284311118)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349265621310824)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962976406311316)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Submeter P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944438640311301)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Contrair \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944394893311301)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Expandir \00C1rvore')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106246819732310738)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Conta de Banco de Dados'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722327800311115)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nomes de coluna e tabela de banco de dados fazem distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822075439311202)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('exce\00E7\00E3o na cria\00E7\00E3o de objeto de bd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260465008310751)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410758973311658)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407461265311656)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'pt-br'
,p_message_text=>'Todos os Mimes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410449018311658)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407792938311656)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar M\00E9todo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407573087311656)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407693060311656)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414635221311661)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3dulo de Servi\00E7os RESTful')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410330649311658)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'pt-br'
,p_message_text=>'Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415166179311662)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel de Bind do Handler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387593294311642)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo do Handler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415433036311662)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem do Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387647423311642)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Origem do Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407213320311656)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414765848311661)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do M\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415249666311662)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefixo de URI do M\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407889806311656)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407109215311656)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414981535311661)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servi\00E7os RESTful')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407316689311656)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415308077311662)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387476343311642)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'pt-br'
,p_message_text=>'URI (Uniform Resource Identifier)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414473813311661)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'pt-br'
,p_message_text=>'Prefixo de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414566408311661)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387751632311642)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Consultar Uma Linha'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631668838311041)
,p_name=>'DEBUG'
,p_message_language=>'pt-br'
,p_message_text=>'Depurar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738088648311129)
,p_name=>'DECLINED'
,p_message_language=>'pt-br'
,p_message_text=>'Recusado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460370498311694)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Bot\00E3o do Di\00E1logo Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460247355311694)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Conte\00FAdo do Di\00E1logo Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975130164311325)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617414187311030)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('tablespace padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619056374311032)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tablespace Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867599862311237)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo Padr\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242801293310734)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido por A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033897000311374)
,p_name=>'DEFINED_TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Este aplicativo tem %0 guias organizadas em %1 conjuntos de guias e %2 de guias pai definidas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486361253310929)
,p_name=>'DEFINE_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667539345311067)
,p_name=>'DEFINITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819719247311200)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Script de Desinstala\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338076749310816)
,p_name=>'DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354718194311618)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860058973311231)
,p_name=>'DELETE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106852266754311225)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270065502310762)
,p_name=>'DELETE_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gostaria de executar esta a\00E7\00E3o de exclus\00E3o?')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294338604310781)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Mostru\00E1rio de Cole\00E7\00F5es permite armazenar linhas de dados para usar dentro de uma sess\00E3o do Oracle APEX. Este aplicativo de banco de dados ilustra como usar PL/SQL para criar e gerenciar o estado da sess\00E3o com base na cole\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294142712310781)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294226154310781)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Portal de Produtos \00E9 um aplicativo de amostra que destaca conceitos de design comuns. Ele inclui p\00E1ginas dedicadas para clientes, produtos e pedidos, al\00E9m de demonstrar o uso de relat\00F3rios, gr\00E1ficos, calend\00E1rios, mapas e \00E1rvores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688483949311083)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Demonstr\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415191081310871)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplos de conceitos de relat\00F3rios robustos e de pagina\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414898806310871)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo de armazenamento on-line constru\00EDdo com o uso de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415595124310872)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'pt-br'
,p_message_text=>'Aprenda sobre o uso do Oracle Text com %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415952946310872)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo de aplicativo de rastreamento de status de projetos constru\00EDda com %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415348358310872)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'pt-br'
,p_message_text=>'Aprenda a usar os Web services com %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413779840310870)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411601464310869)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411329043310869)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'pt-br'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415087876310871)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia de Neg\00F3cios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413881798310871)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostru\00E1rio de Cole\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411458270310869)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'pt-br'
,p_message_text=>'CONTEXT INDEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410809439310868)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a criar o Aplicativo de Demonstra\00E7\00E3o de Exemplos B\00E1sicos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409430389310867)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a (re)criar o Aplicativo de Demonstra\00E7\00E3o de neg\00F3cios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410983080310868)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a criar a Aplicativo de Demonstra\00E7\00E3o de Mostru\00E1rio de Cole\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411092211310869)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'pt-br'
,p_message_text=>'criar ou recriar no esquema %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409332818310867)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>'Criar um exemplo de aplicativo de Web services.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409528723310867)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a criar o Aplicativo de Demonstra\00E7\00E3o de Mania de Copa do Mundo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250531261310742)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413506873310870)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo de Demonstra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411965311310869)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA tem cerca de %0 MB livres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414325227310871)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414062799310871)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'pt-br'
,p_message_text=>'Instalado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546084005310977)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a instalar Amostras de Aplicativos, o que demonstra os recursos-chave de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414998583310871)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar Agora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413904423310871)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Aprenda sobre conceitos de carrinho de compras %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855024405311227)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411753204310869)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Demonstra\00E7\00E3o do Discurso de Posse do Presidente requer cerca de 7 MB de espa\00E7o livre em disco e pode levar dois minutos para ser instalada no seu esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545713137310977)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o houve espa\00E7o suficiente para criar esta demonstra\00E7\00E3o. Solicite armazenamento adicional indo at\00E9 a p\00E1gina da administra\00E7\00E3o; l\00E1, v\00E1 para servi\00E7os de provisionamento e clique no link para solicitar armazenamento adicional. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414200460310871)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Instalado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410233268310868)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409115658310867)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>'existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410186490310868)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411207272310869)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409243519310867)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409811706310868)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os seguintes objetos de banco de dados ser\00E3o recriados, se existirem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410066764310868)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410788853310868)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414735479310871)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Loja de artigos para animais de estima\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415414761310872)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'pt-br'
,p_message_text=>'Discursos de Posse do Presidente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415779522310872)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'pt-br'
,p_message_text=>'Rastreamento do Projeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622956987311034)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>'Reinstalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414135783310871)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'pt-br'
,p_message_text=>'Executar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106409948676310868)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410562464310868)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413664907310870)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410301588310868)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413452099310870)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Status de Instala\00E7\00E3o do Aplicativo de Demonstra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410673293310868)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>'Trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855168115311227)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275891274310766)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00E3o Dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433462352311675)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os seguintes objetos inv\00E1lidos precisam ser corrigidos para que as Websheet sejam executadas adequadamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415260729310872)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>'Web Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412076826310869)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Poder\00E1 ocorrer erro se voc\00EA n\00E3o estiver recriando esta demonstra\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357016773310830)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o havia espa\00E7o suficiente para criar a demonstra\00E7\00E3o. Para solicitar um armazenamento adicional, v\00E1 para a p\00E1gina de administra\00E7\00E3o e clique no link "Solicitar Altera\00E7\00F5es no Servi\00E7o Atual".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356960234310829)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo de demonstra\00E7\00E3o %0 foi criada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012380534311357)
,p_name=>'DEPRECATED'
,p_message_language=>'pt-br'
,p_message_text=>'Obsoleto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308005212310792)
,p_name=>'DERIVED$'
,p_message_language=>'pt-br'
,p_message_text=>'coluna derivada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688336383311083)
,p_name=>'DESIRABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desej\00E1vel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761129701311147)
,p_name=>'DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817867390311198)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761219361311147)
,p_name=>'DETAIL_2'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhe 2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259446935310750)
,p_name=>'DEVELOPER'
,p_message_language=>'pt-br'
,p_message_text=>'Desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823278349311203)
,p_name=>'DEVELOPERS'
,p_message_language=>'pt-br'
,p_message_text=>'Desenvolvedores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707945478311098)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Resumo de Atividades do Desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731737936311123)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Resumo do Desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216265061310710)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplic. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725043370311117)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Personaliza\00E7\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881174789311247)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Limpar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881085915311247)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229487920311524)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907312293311268)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Depurar (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906882555311268)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDvel de Depura\00E7\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907094849311268)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es (padr\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907125331311268)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'pt-br'
,p_message_text=>'Rastreamento de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907246273311268)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'pt-br'
,p_message_text=>'Rastreamento Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216385465310710)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870236616311239)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um ou mais erros ocorrerem desde que a p\00E1gina foi carregada. Abra a console JavaScript do Browser para ver os erros.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870499072311239)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'pt-br'
,p_message_text=>'Erros de JavaScript'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229588993311524)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Logotipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944039324311301)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'Esta funcionalidade requer que a janela do Application Express App Builder esteja aberta. Deseja abrir o Builder nesta janela?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940170139311292)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es da Barra de Ferramentas do Desenvolvedor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941886321311294)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar Automaticamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942047102311294)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941987065311294)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Somente \00CDcones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942288438311299)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942110110311299)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'pt-br'
,p_message_text=>'Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942329061311299)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943612714311300)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876156533311243)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876374416311244)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tempo do Desempenho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940212008311293)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Edi\00E7\00E3o R\00E1pida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876215282311244)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Tempo da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441103157311680)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'pt-br'
,p_message_text=>'Rolador do Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941750398311294)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Barra de Ferramentas do Desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682692383311079)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefa de Desenvolvimento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850995912311224)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Alerta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850856458311224)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850731804311224)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor Baixo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200096874310695)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupos de Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282439535310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284819638310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284947729310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284038119310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283908438310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumbs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470528372311701)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283683176310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283857154310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284145126310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'pt-br'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284214989310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284355817310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233640094310726)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284427866310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284596759310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barras de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282585445310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283571555310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282900664310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657387108311059)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657522273311060)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'pt-br'
,p_message_text=>'Eixos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657457079311059)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283291490310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324171506310805)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324235955310805)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica - A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283007325310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es IR')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283126237310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282718009310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283412316310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'pt-br'
,p_message_text=>'Processos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282625009310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223645349311520)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106282841819310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405633714311655)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283344146310772)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284679277310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106283718767310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>'Processos do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431325930311673)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431678009311673)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00F5es SQL da Consulta de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431212628311673)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consultas de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380368383311637)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285037112310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'Atalhos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280599128310770)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286529208310775)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substitui\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470244726311701)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos de Suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470374863311701)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos de Suporte - Op\00E7\00F5es de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286353310310775)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos - Valida\00E7\00F5es de Suporte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286401643310775)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos - Scripts de Suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106284760779310773)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285436254310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285530768310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285679912310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348987094310824)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285712888310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285829535310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285943443310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286047478310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de LOV Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286146403310775)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106286287259310775)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285355146310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'pt-br'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273974558310765)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221728942310715)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'pt-br'
,p_message_text=>'Estilos de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713157413311108)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267762537310760)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tradu\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267862320310760)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto Traduz\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285282030310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106285163517310774)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'pt-br'
,p_message_text=>'Web Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397267517311649)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00F5es de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397300712311649)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios do Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752382533311140)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Designa\00E7\00E3o de Atribui\00E7\00E3o de Usu\00E1rio para Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210885982310705)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211068420310705)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00E3o - A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433151086311674)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos Concatenados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238360995310730)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'pt-br'
,p_message_text=>'Cargas de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664801172311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'pt-br'
,p_message_text=>'Perfis de Parsing de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664909161311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas de Perfis de Parsing de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448512522311685)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rios do Desenvolvedor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412262402311660)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970344930311321)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela de Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964653072311317)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'pt-br'
,p_message_text=>'Tabelas de Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964792844311317)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisas da Tabela de Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964800616311317)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regras de Transforma\00E7\00E3o da Tabela de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228216102310721)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas de Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227261980310720)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227320435310720)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es do Cart\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941274562311293)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es da Grade Interativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941362644311293)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941426755311293)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>'Grupos de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202234447310697)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'pt-br'
,p_message_text=>'Mapas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202327940310697)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'pt-br'
,p_message_text=>'Mapear Camadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300106798310785)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300213900310786)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711621543311107)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355126017310828)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302317430310787)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761463485311147)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Operadores de Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470481032311701)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Componentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411110870311659)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Metadados do Atributo Padr\00E3o do Plug-In')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664702162311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Servidores de SQL Ativados por REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223542072311520)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470112229311701)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupos de Op\00E7\00F5es de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386488490311641)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de Op\00E7\00F5es do Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439666805311679)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439777346311679)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353554471310827)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pontos de Exibi\00E7\00E3o do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280415421310770)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interfaces do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665494513311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros da Origem REST do Componente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665142652311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'pt-br'
,p_message_text=>'Origens de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665299875311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00F5es da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665357987311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665086493311065)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'pt-br'
,p_message_text=>'Servidores Remotos da Origem REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211382664310706)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapas da Sincroniza\00E7\00E3o REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211273651310705)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Log de Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211496151310706)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Log de Mensagens de Automa\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413879646311661)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Pr\00F3ximo Desativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413730961311661)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Anterior Desativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814455584311195)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>'Desativar trigger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419891580310875)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420051610310875)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Texto Condicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860157719311231)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ordem de Exibi\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306323826310790)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469825569311700)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Exibi\00E7\00E3o: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409141122311657)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas Distintas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409281890311657)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Distintos')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233308104310726)
,p_name=>'DML_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form DML'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527539884310963)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703748241311095)
,p_name=>'DOC_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impacto da Documenta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704926007311096)
,p_name=>'DOC_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Status da Documenta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705135116311096)
,p_name=>'DOC_WRITER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gravador da Documenta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592762856311012)
,p_name=>'DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Inativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712905095311108)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Link de Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527215968310963)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o atualizar itens do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527318984310963)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o atualizar itens de entrada de dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527492164310963)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o atualizar itens somente para exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527172704310963)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o atualizar p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527958375310964)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o atualizar itens de p\00E1gina')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389985799310853)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'pt-br'
,p_message_text=>'Arrastar e Soltar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297705160310783)
,p_name=>'DRILLDOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Drill-down'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297608496310783)
,p_name=>'DRILLUP'
,p_message_language=>'pt-br'
,p_message_text=>'Drill-up'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435214199310886)
,p_name=>'DRIVEN'
,p_message_language=>'pt-br'
,p_message_text=>'conduzido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814258972311195)
,p_name=>'DROP TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>'Eliminar trigger %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813318294311194)
,p_name=>'DROP_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Eliminar Coluna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960779706311314)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960533825311314)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da Vari\00E1vel de Bind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960930752311314)
,p_name=>'DS_HANDLER'
,p_message_language=>'pt-br'
,p_message_text=>'Handler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961308174311315)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens Por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961110722311314)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>'Tipos MIME Permitidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961202774311315)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>'Origens Permitidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960811661311314)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961416536311315)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Constraint de Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960609270311314)
,p_name=>'DS_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961022374311314)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961571695311315)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>'Prefixo de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960267948311314)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de URI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431723936311673)
,p_name=>'DUE'
,p_message_language=>'pt-br'
,p_message_text=>'Vencimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704784586311096)
,p_name=>'DUE_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data de Vencimento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685270683311081)
,p_name=>'DUPLICATE'
,p_message_language=>'pt-br'
,p_message_text=>'Duplicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409844572311658)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio duplicado na lista')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222166485310715)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222075022310715)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232255520310725)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Form din\00E2mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338172485310816)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTML Din\00E2mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388873465310852)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215201472310709)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncia Din\00E2mica')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484678294310928)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A condi\00E7\00E3o que voc\00EA est\00E1 adicionando invalidou a consulta.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226733293310720)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745365195311135)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA perder\00E1 as altera\00E7\00F5es n\00E3o salvas se selecionar OK.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258722248310749)
,p_name=>'EDIT_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485889162310929)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Edite todos os atributos da defini\00E7\00E3o de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740295966311131)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar todos os itens desta regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670989357311070)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759967118311146)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Atributo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354955082311618)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749712852311138)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760040819311146)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Defini\00E7\00E3o do Componente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851405205311224)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759883434311146)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Defini\00E7\00E3o da Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423701594311668)
,p_name=>'EDIT_LOCK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bloqueio de Edi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631437459311041)
,p_name=>'EDIT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487945252310930)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar atributos de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018884126311363)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036285242311376)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio 0% n\00E3o tem privil\00E9gios para atualizar as informa\00E7\00F5es de outro usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749515236311138)
,p_name=>'EDIT_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824034626311203)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Per\00EDodo de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749638868311138)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013096052311358)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Relat\00F3rio - Caixa de Di\00E1logo Fechada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739525923311130)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Mensagem do Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974914872311325)
,p_name=>'EDIT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Guia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761327741311147)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar este atributo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613709160311028)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'pt-br'
,p_message_text=>'Tempo Decorrido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692392219311086)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">Visitar Meu Aplicativo e gerenciar suas prefer\00EAncias de e-mail</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699259748311091)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'<b style="font-size: 24px;">Meu Aplicativo</b>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813752138311195)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>Ol\00E1 #INVITEE#,</strong><br>'),
'<br>',
unistr('Este \00E9 um lembrete de um evento futuro para o qual voc\00EA foi convidado. Veja os detalhes do evento abaixo:<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Organizador</th>',
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Data do Evento</th>',
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Hor\00E1rio de In\00EDcio</th>'),
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Dura\00E7\00E3o</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Local</th>',
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">Observa\00E7\00F5es</th>'),
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692297925311086)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>Ol\00E1 #CUSTOMER_NAME#</strong>,<br>'),
'<br>',
'Obrigado pelo seu pedido!<br>',
'<br>',
'<strong>Detalhes do Pedido</strong><br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Data do Pedido</th>',
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">N\00FAmero do Pedido</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Refer\00EAncia de Envio</th>'),
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">Endere\00E7o para Remessa</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Itens Pedidos</th>',
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Total do Pedido</th>',
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('Precisa fazer uma altera\00E7\00E3o no seu pedido? <a href="#ORDER_URL#">Gerencie seu pedido #ORDER_NUMBER# aqui.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013392209311358)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ol\00E1 #SERVICE_USER#,<br>'),
'<br>',
unistr('Fique ciente de que h\00E1 uma interrup\00E7\00E3o futura programada para seu servi\00E7o #SERVICE_NAME#.'),
unistr('A interrup\00E7\00E3o est\00E1 programada para come\00E7ar em #OUTAGE_START# e o tempo de indisponibilidade planejado \00E9 de #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.<br>'),
'<br>',
unistr('As seguintes a\00E7\00F5es ser\00E3o executadas durante esta interrup\00E7\00E3o programada:<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('Para quaisquer quest\00F5es relativas a esta interrup\00E7\00E3o, entre em contato com #OUTAGE_CONTACT#.<br>'),
'<br>',
unistr('Agradecemos sua compreens\00E3o,<br>'),
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012741983311358)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'pt-br'
,p_message_text=>'Lembrete de Evento: #EVENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012881107311358)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'pt-br'
,p_message_text=>'Pedido (#ORDER_NUMBER#) Confirmado!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813978995311195)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ol\00E1 #INVITEE#,'),
'',
unistr('Este e-mail \00E9 para lembr\00E1-lo de um evento futuro ao qual voc\00EA est\00E1 associado.'),
'',
'Data do Evento: #EVENT_DATE#',
unistr('Hor\00E1rio de In\00EDcio: #START_TIME#'),
unistr('Dura\00E7\00E3o:   #DURATION#'),
'Organizador:  #ORGANIZER#',
'Local:   #LOCATION#',
'URL:        #URL_NAME# (#URL_LINK#)',
unistr('Observa\00E7\00F5es:      #NOTES#'),
'',
'Veja outros detalhes do evento aqui: #EVENT_LINK#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813873569311195)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ol\00E1 #CUSTOMER_NAME#,'),
'',
'Obrigado pelo seu pedido!',
'',
'Detalhes do Pedido',
'--------------------------------------------------------------------------------',
'  Data do Pedido:       #ORDER_DATE#',
unistr('  N\00FAmero do Pedido:     #ORDER_NUMBER#'),
unistr('  Refer\00EAncia de Envio:          #SHIP_TO#'),
unistr('  Endere\00E7o para Remessa: #SHIPPING_ADDRESS_LINE_1#'),
'                    #SHIPPING_ADDRESS_LINE_2#',
'  Itens Pedidos:    #ITEMS_ORDERED#',
'  Total do Pedido:      #ORDER_TOTAL#',
'--------------------------------------------------------------------------------',
'',
unistr('Precisa fazer alguma altera\00E7\00E3o no seu pedido? Gerencie seu pedido #ORDER_NUMBER# aqui: #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013289238311358)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ol\00E1 #SERVICE_USER#,'),
'',
unistr('Fique ciente de que h\00E1 uma interrup\00E7\00E3o futura programada para seu servi\00E7o #SERVICE_NAME#.'),
unistr('A interrup\00E7\00E3o est\00E1 programada para come\00E7ar em #OUTAGE_START# e o tempo de indisponibilidade planejado \00E9 de #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.'),
'',
unistr('As seguintes a\00E7\00F5es ser\00E3o executadas durante esta interrup\00E7\00E3o programada:'),
'#OUTAGE_REASON#',
'',
unistr('Para quaisquer quest\00F5es relativas a esta interrup\00E7\00E3o, entre em contato com #OUTAGE_CONTACT#.'),
'',
unistr('Agradecemos sua compreens\00E3o,'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743574597311133)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativar Depura\00E7\00E3o Sim ou N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814395503311195)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar trigger %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260917575310751)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tamanho do valor a ser criptografado n\00E3o pode exceder 4000 bytes.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259584617310750)
,p_name=>'END_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio Final')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682346948311079)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Melhoria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036912533311376)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00F5es de Melhoria: %1 de %0 fechadas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684739569311080)
,p_name=>'ENTERED'
,p_message_language=>'pt-br'
,p_message_text=>'Registrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225926420310719)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>'Informar credenciais das Websheets.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672557320311071)
,p_name=>'ENTRY LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link da Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672487211311071)
,p_name=>'ENTRY TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto da Entrada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727858286311120)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590978871311011)
,p_name=>'ERRORPAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em P\00E1gina de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740528097311131)
,p_name=>'ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673730039311072)
,p_name=>'ERROR_ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430776835311673)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Erro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665917821311066)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<br><strong>Dados de Escape excederam o limite; os resultados ser\00E3o reduzidos a 32k</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434435652310886)
,p_name=>'ESCAPE_SC'
,p_message_language=>'pt-br'
,p_message_text=>'caracteres especiais de escape'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706154564311097)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esfor\00E7o Estimado em Horas')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960471413311314)
,p_name=>'ETAG_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta ETAG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960371465311314)
,p_name=>'ETAG_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo ETAG'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682831278311079)
,p_name=>'EVENT'
,p_message_language=>'pt-br'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017486289311361)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Depois da Atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017775952311362)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes da Submiss\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017314048311361)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes da Atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019921935311363)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'pt-br'
,p_message_text=>'Eventos do Browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481078717310921)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'pt-br'
,p_message_text=>'Toque Duplo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481214405310921)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'pt-br'
,p_message_text=>'Panorama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481105630310921)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Pressionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481367231310922)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'pt-br'
,p_message_text=>'Deslizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480941337310921)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016860462311361)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016117110311361)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'pt-br'
,p_message_text=>'Clicar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016288487311361)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'pt-br'
,p_message_text=>'Clique Duplo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015617748311360)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'pt-br'
,p_message_text=>'Elemento ativo selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015577315311360)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Elemento ativo n\00E3o selecionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017082565311361)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Pressionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017186540311361)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Pressionar Tecla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017217460311361)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'pt-br'
,p_message_text=>'Liberar Tecla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015744399311360)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016309749311361)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pressionamento do Bot\00E3o do Mouse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016640190311361)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada do Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016739608311361)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Retirada do Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016501003311361)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Movimenta\00E7\00E3o do Mouse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016486792311361)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Libera\00E7\00E3o do Bot\00E3o do Mouse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224950628310718)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00E3o da Orienta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023277996311366)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Carregamento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015897880311360)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Redimensionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107015958317311360)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'pt-br'
,p_message_text=>'Rolar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225012743310718)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'pt-br'
,p_message_text=>'Rolar para Iniciar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225138164310718)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'pt-br'
,p_message_text=>'Rolar para Interromper'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016996043311361)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224110048310717)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'pt-br'
,p_message_text=>'Deslizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224298848310717)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'pt-br'
,p_message_text=>'Deslizar para a Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224307810310717)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Deslizar para a Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223906121310717)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224034089310717)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar e Segurar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107016050702311360)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descarga da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224776918310718)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'pt-br'
,p_message_text=>'Clique Virtual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224833844310718)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar em Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224409641310717)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar em Iniciar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224560502310717)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar em Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106224612773310718)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'pt-br'
,p_message_text=>'Tocar em Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020161710311363)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>'Eventos do Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106220924610310714)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Evento Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221059623310714)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020077168311363)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'pt-br'
,p_message_text=>'Eventos da Estrutura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597350747311016)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo Fechada ou Cancelada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749413144311138)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo Fechada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438634020311678)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Depois da Atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438759216311678)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes da Submiss\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438572484311678)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes da Atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667639761311067)
,p_name=>'EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704880746311096)
,p_name=>'EVENT_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero do Marco')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745747854311135)
,p_name=>'EXACT_SUBS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substitui\00E7\00F5es Exatas')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859556290311231)
,p_name=>'EXAMPLE_1'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106859620081311231)
,p_name=>'EXAMPLE_2'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359777008311622)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este \00E9 um exemplo dos dados contidos em uma coluna do banco de dados XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409766444311658)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo de URI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815442162311196)
,p_name=>'EXCLUDE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795051015311175)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737049259311128)
,p_name=>'EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292366896310779)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL EXISTE'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007652546311353)
,p_name=>'EXPANDED'
,p_message_language=>'pt-br'
,p_message_text=>'Expandido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405539359311655)
,p_name=>'EXPAND_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir Tudo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106357540044310830)
,p_name=>'EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Expirado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671170617311070)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Plano de Explica\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667921536311067)
,p_name=>'EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>'Exportar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976240490311326)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reposit\00F3rio de Exporta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750089571311138)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exportada de outro espa\00E7o de trabalho ou aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750148831311138)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exportada do espa\00E7o de trabalho atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819432926311199)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Exportar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823636092311203)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Use esses links para fazer download deste aplicativo e do banco de dados correspondente que suporta objetos para implanta\00E7\00E3o em outra instala\00E7\00E3o do Oracle APEX. Os arquivos submetidos a download ser\00E3o Scripts SQL que podem ser executados no SQL*Plus,')
||' SQL Developer ou Scripts SQL dentro do Oracle APEX.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819502278311200)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Exportar Objetos de Suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668277244311068)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o de Aplicativo  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668446329311068)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o de Folhas de Estilo em Cascata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668653910311068)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o do Arquivo Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668512616311068)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o de Imagem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668328740311068)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668759088311068)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o do Arquivo de Script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664689384311065)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00F5es da Interface do Usu\00E1rio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595747760311014)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo de Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593702702311013)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595526627311014)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Processo de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106410486946310868)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os IDs de aplicativo 3000 a 8999 est\00E3o reservados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293571131310780)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este aplicativo foi exportado do espa\00E7o de trabalho atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293697003310780)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este aplicativo foi exportado de outro espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227339798311522)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Credenciais do Servidor de Impress\00E3o Remoto %0 do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227144587311522)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servidor de Impress\00E3o Remoto %0 do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595441675311014)
,p_name=>'F4000.BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609325445311024)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar a partir da p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609592246311024)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595003144311014)
,p_name=>'F4000.BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736032664311127)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348825404310823)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471302048310914)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609983089311025)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373995650311632)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome de coluna identificado \00E9 uma palavra reservada do Oracle. Escolha outro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737453070311128)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar entradas de lista: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623251033311035)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Din\00E2mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307753235310791)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293400341310780)
,p_name=>'F4000.EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>'Exportar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625405580311036)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'pt-br'
,p_message_text=>'Corrija-me'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622856313311034)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622786862311034)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o Para Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609696425311025)
,p_name=>'F4000.FROM'
,p_message_language=>'pt-br'
,p_message_text=>'de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411528963310869)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O cabe\00E7alho deve conter as tags <strong> &lt;head&gt;</strong> e <strong>&lt;/head&gt;</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411879744310869)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>#HEAD#</strong> a string de substitui\00E7\00E3o deve aparecer entre as tags <strong> &lt;head&gt;</strong> e <strong>&lt;/head&gt;</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680425579311077)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo "%0" tem um tipo inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594707249311014)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibi\00E7\00E3o do Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594897361311014)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Item Somente para Leitura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240112286310732)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Legada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763491688311149)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627940292311038)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596173149311015)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240014329310732)
,p_name=>'F4000.LOCAL'
,p_message_language=>'pt-br'
,p_message_text=>'Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596465264311015)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada da Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609786253311025)
,p_name=>'F4000.MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596310720311015)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639764126311047)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione, pelo menos, um para c\00F3pia ou inscri\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595801505311015)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada de Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526505905310962)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'pt-br'
,p_message_text=>'Navigation&nbsp;Bar&nbsp;Icon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593640098311013)
,p_name=>'F4000.NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623379943311035)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Referenciado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607814439311023)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados n\00E3o encontrados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433219350311675)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo %0 n\00E3o existe no espa\00E7o de trabalho atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034108811311374)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar Verifica\00E7\00E3o desativada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632594283311041)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da Guia M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296207170310782)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o do Bot\00E3o Cancelar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295892867310782)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto de Exibi\00E7\00E3o do Bot\00E3o Cancelar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296373211310782)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o do Bot\00E3o Finalizar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295942922310782)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto de Exibi\00E7\00E3o do Bot\00E3o Finalizar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296172010310782)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto de Exibi\00E7\00E3o do Bot\00E3o Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296016867310782)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto de Exibi\00E7\00E3o do Bot\00E3o Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632625604311041)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina da \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632757917311042)
,p_name=>'F4000.P119.GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632825042311042)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Usando os mesmos modelos como um aplicativo existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435735489311676)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437449843311677)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Esquemas de Autoriza\00E7\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437736756311678)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Breadcrumb:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437809947311678)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Bot\00F5es:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437938708311678)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Calend\00E1rio:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219569187310713)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 as seguintes Defini\00E7\00F5es de Carga de Dados:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437305468311677)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Label:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437190227311677)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Lista:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436833505311677)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 as seguintes Listas de Valores:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437683091311678)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 as seguintes Entradas da Barra de Navega\00E7\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436996899311677)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de P\00E1ginas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438019963311678)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Plug-ins:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438141487311678)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Listas de Valores Pop-up:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437065210311677)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Regi\00F5es:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437297637311677)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Modelos de Relat\00F3rios:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107437528523311678)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 os seguintes Atalhos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796170354311176)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a publica\00E7\00E3o de <strong>%0</strong>. Isso atualizar\00E1 as seguintes Origens de Dados REST:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640551841311047)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3pia de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435626532311676)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de Pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433339423311675)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106411102377310869)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deve ser especificado pelo menos um item para criar valida\00E7\00E3o que n\00E3o seja nula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345524860311612)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servidor de Impress\00E3o do Aplicativo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057383487311392)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar defini\00E7\00F5es de exporta\00E7\00E3o padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169031372311478)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'pt-br'
,p_message_text=>unistr('a\00E7\00E3o=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676752573311074)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'pt-br'
,p_message_text=>unistr('coment\00E1rio=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674867706311073)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usado para executar c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442183921311681)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo Concatenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675437782311073)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'pt-br'
,p_message_text=>'exibir valor='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442028131311681)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'pt-br'
,p_message_text=>'arquivo='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675118918311073)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de \00CDcones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675661513311073)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675391857311073)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675294804311073)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'pt-br'
,p_message_text=>'nome='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674790333311073)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usado para exibir p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676653699311074)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675744872311074)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675060518311073)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Usado para executar processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674917461311073)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675536614311073)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'pt-br'
,p_message_text=>'valor de retorno='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438340097311678)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar os Pais da Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470998393310913)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deve ser especificada pelo menos uma regi\00E3o a ser criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593386263311013)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Espa\00E7o de Trabalho n\00E3o ser\00E1 criado porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593494123311013)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho ser\00E1 criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439135288311679)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Bloqueio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471083513310913)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deve ser especificada pelo menos uma p\00E1gina a ser criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439227888311679)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina est\00E1 desbloqueada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002629234311349)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'LOV Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633276421311042)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'pt-br'
,p_message_text=>'Pos.1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633300645311042)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'pt-br'
,p_message_text=>'Pos.2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633456633311042)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'pt-br'
,p_message_text=>'Pos.3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633529196311042)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'pt-br'
,p_message_text=>'Pos.4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231444809310724)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'pt-br'
,p_message_text=>'Pos.5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800322449311184)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'pt-br'
,p_message_text=>'Pos. 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800481378311184)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'pt-br'
,p_message_text=>'Pos. 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800587222311184)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'pt-br'
,p_message_text=>'Pos. 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633664269311042)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os bot\00F5es DML e de pagina\00E7\00E3o requerem nomes de bot\00F5es espec\00EDficos; consulte o texto de ajuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435855614311676)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 (Correspond\00EAncias de Classes)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633793676311042)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'pt-br'
,p_message_text=>'gerenciar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442494597311681)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor Original'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633854398311042)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('String de Substitui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633967285311042)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Substitui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607278110311023)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">Esta regi\00E3o exibir\00E1 ajuda da p\00E1gina e do item para a p\00E1gina atual quando chamada com a seguinte sintaxe:<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634004099311043)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Form em %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634171435311043)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358251417310830)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'pt-br'
,p_message_text=>'Ramificar='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626397108311037)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248938260310740)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie de Gr\00E1ficos=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626542202311037)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625941817311037)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'pt-br'
,p_message_text=>unistr('Subtexto do \00CDcone=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625865794311037)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'pt-br'
,p_message_text=>'Imagem='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626439074311037)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'pt-br'
,p_message_text=>'Item='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626053804311037)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'pt-br'
,p_message_text=>'Lista='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358339294310830)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'pt-br'
,p_message_text=>'Entrada de Breadcrumb='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626247321311037)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626688278311037)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'pt-br'
,p_message_text=>'Processo='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248880925310740)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623435831311035)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Necess\00E1rio a todas as p\00E1ginas do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625569527311036)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625688014311036)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo de Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625767634311037)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Processo de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626827464311037)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Guia='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626919039311037)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Guias='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626132773311037)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'pt-br'
,p_message_text=>'Texto='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106626782089311037)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635837518311044)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636402556311044)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'pt-br'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635447465311043)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia Padr\00E3o 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635564590311044)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia Padr\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635618027311044)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia Padr\00E3o 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635769915311044)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia Padr\00E3o 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634522801311043)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar bot\00F5es de pagina\00E7\00E3o criados externamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635321856311043)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia padr\00E3o em HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636057157311044)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636169342311044)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636223030311044)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636350531311044)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635028104311043)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas de X a Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634762158311043)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixa de Linhas 1-15 16-30 na lista de sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635238315311043)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'pt-br'
,p_message_text=>'Mecanismo de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634843299311043)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mecanismo de Pesquisa 1,2,3,4 (pagina\00E7\00E3o baseada em conjunto)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635147915311043)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634389713311043)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('definir padr\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634457146311043)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('desativar pagina\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634998672311043)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar bot\00F5es de pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636520021311044)
,p_name=>'F4000.P420.XML'
,p_message_language=>'pt-br'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106635910058311044)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o de XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636631483311044)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Gerar Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634685518311043)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha X a Y (com os links Pr\00F3ximo e Anterior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461736073311695)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760614303311147)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de BD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760857140311147)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760905625311147)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760761268311147)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760522181311147)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('texto est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636736865311044)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os bot\00F5es DML requerem nomes de bot\00E3o espec\00EDficos, texto de ajuda de refer\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303389196310788)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O novo plug-in ser\00E1 criado no aplicativo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303287256310788)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O plug-in existente no aplicativo %0 ser\00E1 substitu\00EDdo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636841997311045)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'HTML com atalhos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637094932311045)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627754500311038)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Bot\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348785951310823)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Calend\00E1rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458055689311692)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Regi\00E3o do Gr\00E1fico Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348557910310823)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da P\00E1gina de Caixa de Di\00E1logo Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458170227311692)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Form Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458573594311692)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Relat\00F3rio Interativo Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627609360311038)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Label Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458225304311692)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o da Lista Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627554400311038)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Lista Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458739953311692)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Regi\00E3o do Breadcrumb Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627801444311038)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Breadcrumb Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457852428311692)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Lista da Barra de Navega\00E7\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457575703311692)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Lista do Menu de Navega\00E7\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457309554311692)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Label Opcional Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627249524311038)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627386582311038)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Regi\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458384506311692)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Relat\00F3rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627452873311038)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Relat\00F3rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457426090311692)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Label Obrigat\00F3rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457734988311692)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Lista Lateral do Menu de Navega\00E7\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458490148311692)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Regi\00E3o do Form Tabular Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457696747311692)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Lista Superior do Menu de Navega\00E7\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107458615050311692)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Regi\00E3o do Assistente Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627132227311038)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da P\00E1gina de Erros Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457907454311692)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da P\00E1gina de Login Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106627097563311037)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina no Modo de Impress\00E3o Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106634295138311043)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio em %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630804753311040)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('informa\00E7\00F5es de alerta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631024268311040)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('nova regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630782515311040)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA deve criar pelo menos uma regi\00E3o antes de criar um item de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630920860311040)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use um assistente para criar uma nova regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632221050311041)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ser\00E1 classificado alfabeticamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632491484311041)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo 4: Lista de valores com vari\00E1vel de bind')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632323946311041)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('classificado em ordem de cria\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631908097311041)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo 2: Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724729351311117)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo 5: A consulta cont\00E9m uma consulta interna. Verifique se a primeira cl\00E1usula FROM da instru\00E7\00E3o SQL n\00E3o faz parte da consulta interna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631839719311041)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo 1: Lista de valores com base em consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632110034311041)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo 3: Exemplos de lista est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632009868311041)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno, use um alias de coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302289734310787)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('mostrar Sim / N\00E3o, retornar S e N')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637642187311045)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Processamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637388213311045)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes dos C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637545250311045)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Processamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637419101311045)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes das Valida\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308609055310792)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637725592311045)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305585205310790)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637956145311045)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'pt-br'
,p_message_text=>'Finalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637888392311045)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638190578311045)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A pagina\00E7\00E3o ser\00E1 redefinida para todas as p\00E1ginas deste aplicativo quando este procedimento for executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650233862311054)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ADVERT\00CANCIA: Voc\00EA escolheu uma valida\00E7\00E3o do tipo Express\00E3o Regular. No entanto, sua vers\00E3o do banco de dados n\00E3o oferece suporte a ela. Essa valida\00E7\00E3o sempre retornar\00E1 uma condi\00E7\00E3o verdadeira.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387108483311641)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As tradu\00E7\00F5es deste aplicativo n\00E3o est\00E3o dispon\00EDveis atualmente. Consulte a defini\00E7\00E3o <em>Idioma do Aplicativo Derivado De</em> em <a href="%0">Atributos de Globaliza\00E7\00E3o</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449320466311686)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando o Tempo M\00E1ximo de Inatividade n\00E3o estiver definido, o valor do n\00EDvel do espa\00E7o de trabalho ou da inst\00E2ncia ser\00E1 usado (atualmente, %0 segundos).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449473669311686)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando a Dura\00E7\00E3o M\00E1xima da Sess\00E3o n\00E3o estiver definida, o valor do n\00EDvel do espa\00E7o de trabalho ou da inst\00E2ncia ser\00E1 usado (atualmente, %0 segundos).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439866509311679)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750955038311139)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Estes componentes foram exportados de outro aplicativo ou de um aplicativo de outro espa\00E7o de trabalho. Os componentes n\00E3o podem ser instalados neste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754922947311142)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Estes arquivos foram exportados de outro espa\00E7o de trabalho. Os arquivos n\00E3o podem ser instalados neste espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439926180311679)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Para Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440710627311680)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar Op\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440834080311680)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores Existente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691836186311086)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina foi exportada de outro aplicativo ou de um aplicativo de outro espa\00E7o de trabalho. A p\00E1gina n\00E3o pode ser instalada neste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593265573311012)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina foi exportada de um aplicativo em outro espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593154754311012)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina foi exportada de um aplicativo no espa\00E7o de trabalho atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012136425311357)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina est\00E1 bloqueada no momento. Voc\00EA n\00E3o pode importar uma p\00E1gina bloqueada. Desbloqueie a p\00E1gina e, em seguida, instale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438488073311678)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Entrada Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440243053311679)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecionar Par\00E2metro %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412199067310869)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>'Deve ser selecionado pelo menos um esquema para ser copiado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440438111311680)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor do Cabe\00E7alho HTTP %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440379955311680)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor do Par\00E2metro de Entrada %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440650973311680)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excluir Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440549880311680)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excluir Par\00E2metro: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639996260311047)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Folha de Estilo Obrigat\00F3ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609071471311024)
,p_name=>'F4000.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623615983311035)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595155873311014)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349925184310824)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210930940310705)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica da P\00E1gina - A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593882559311013)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213146718310707)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de Itens de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628005601311038)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('p\00E1gina(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609174838311024)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595265234311014)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623507543311035)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623706846311035)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596014482311015)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610059221311025)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista de Valores Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227298165311522)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Credenciais do Servidor de Impress\00E3o Remoto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610685279311025)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'pt-br'
,p_message_text=>'Publicar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594626446311014)
,p_name=>'F4000.REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223772650311520)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609252039311024)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina(s) e Componentes Relacionados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227406354311523)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724569096311117)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240207478310732)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610585236311025)
,p_name=>'F4000.SEED'
,p_message_language=>'pt-br'
,p_message_text=>'Implantar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595936987311015)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623149382311035)
,p_name=>'F4000.STATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609889505311025)
,p_name=>'F4000.TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Guia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610156726311025)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453932149310901)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O(s) Nome(s) de Modelo(s) %0 j\00E1 existe(m). Informe um novo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412239823310869)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o Nome do Modelo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610363391311025)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O novo tema ser\00E1 criado no aplicativo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610480935311025)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tema existente no aplicativo %0 ser\00E1 substitu\00EDdo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106609493763311024)
,p_name=>'F4000.TO'
,p_message_language=>'pt-br'
,p_message_text=>'para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596535618311015)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Elemento de Aplicativo Desconhecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610747743311025)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna Atualiz\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735982689311127)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Utilit\00E1rios incluem as p\00E1ginas da Grade de Edi\00E7\00E3o e Relat\00F3rios em todas as p\00E1ginas no aplicativo selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106595349195311014)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240383111310732)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227521417311523)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593564713311013)
,p_name=>'F4000.YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669600343311069)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'pt-br'
,p_message_text=>'Data MMDDAAAA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823301242311203)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375449416310843)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Como um aplicativo em uma tabela do banco de dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628434608311038)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'pt-br'
,p_message_text=>'Como aplicativo em tabelas de banco de dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640027964311047)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta posi\00E7\00E3o de bot\00E3o n\00E3o consta no seu modelo de regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376020826311634)
,p_name=>'F4000_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640351091311047)
,p_name=>'F4000_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656909850311059)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar e Inscrever'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640678206311047)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de data n\00E3o reconhecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308354026310792)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739701345311130)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822407616311202)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome(s) de Listas de Valores %0 j\00E1 existem. Informe outro nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663593850311064)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nada Foi Selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619825278311032)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Aplicativo Associado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251612774310743)
,p_name=>'F4000_OFF'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251520218310742)
,p_name=>'F4000_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311974829310796)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Calend\00E1rio referenciando este, modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692792643311087)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('exibir p\00E1ginas deste tipo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421267237310876)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o existe ajuda para este item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413217899310870)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('home de autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413153943310870)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar este modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428705692310882)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034249073311374)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina j\00E1 existe neste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308753502310792)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina deve ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308874280310792)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina deve ser n\00FAmeros positivos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308971369310792)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina deve ser n\00FAmeros inteiros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741018059311131)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Importar Esquema(s) de Autoriza\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690551905311085)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Importar Esquemas de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741171959311131)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Importar Barra(s) de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690630433311085)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Importar Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638552121311046)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669335892311069)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'pt-br'
,p_message_text=>'Autenticado!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669447165311069)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na autentica\00E7\00E3o!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661230760311062)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641876046311048)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este aplicativo n\00E3o est\00E1 dispon\00EDvel no momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390784330310854)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390870733310854)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data, flex\00EDvel: %0 com qualquer separador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391573662310854)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de data n\00E3o reconhecido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391490955310854)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'A data deve estar no formato %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390298868310853)
,p_name=>'F4000_P430_IP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o IP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391047230310854)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o IP Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390314760310854)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Telefone, EUA: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390459293310854)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Telefone, EUA flex\00EDvel: 999.999.9999, (999)-999-9999, 999 999 9999, etc...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391223742310854)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato do n\00FAmero de telefone n\00E3o reconhecido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391107141310854)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00FAmero de telefone deve estar no formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390189830310853)
,p_name=>'F4000_P430_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL: http(s)://dom\00EDnio/caminho/doc.(pdf)(html)(etc...)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390932236310854)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390503475310854)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo Postal: 99999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390699098310854)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'pt-br'
,p_message_text=>'ZIP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391378542310854)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O C\00F3digo Postal deve estar no formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321688192310804)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321717094310804)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" do esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321941111310804)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 inscritos neste esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321897927310804)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas que se inscrevem neste esquema de autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376645853310844)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>'- sem esquema -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637182638311045)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641959018311048)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'pt-br'
,p_message_text=>'Form em Procedimento Armazenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106637267917311045)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641252154311048)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641105392311048)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640834010311047)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Limpar Cache de Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640754788311047)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Limpar Cache de P\00E1gina(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663853132311064)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641099821311047)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir Item usando o corpo da fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640921624311047)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Designa\00E7\00E3o de Item Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638093299311045)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todos os itens de p\00E1gina que n\00E3o est\00E3o no cache no aplicativo atual ser\00E3o inicializados para nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641671565311048)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641338271311048)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item N\00E3o Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641465263311048)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'pt-br'
,p_message_text=>'Item Diferente de Zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641545059311048)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669848023311069)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'pt-br'
,p_message_text=>'Data DDMMAAAA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669736179311069)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero do Telefone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408177282311657)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Objeto de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638204167311045)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'No Browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638391647311046)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376890016310844)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(contendo a coluna da Data ou do Hor\00E1rio)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856610271311228)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>'Sintaxe: selecione id, nome, data de origem...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856935573311229)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo que usa a pseudocoluna ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857054189311229)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exemplo que usa a Chave Prim\00E1ria da tabela de origem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856735660311228)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('1. Voc\00EA deve incluir, pelo menos, duas colunas; uma delas deve ser a coluna DATA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856843600311228)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('2. A primeira coluna deve identificar a coluna da chave prim\00E1ria a ser usada para gerenciar a opera\00E7\00E3o de idioma de manipula\00E7\00E3o de dados (DML).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638446037311046)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Form 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751566692311140)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Manifesto de Exporta\00E7\00E3o do Componente    ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692609299311087)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir defini\00E7\00E3o de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638656001311046)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Resumo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657276822311059)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('clique para definir conjunto de tabula\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911364811311271)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O modelo de p\00E1gina d\00E1 suporte a guias de dois n\00EDveis, no entanto a guia padr\00E3o n\00E3o identifica uma guia m\00E3e definida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911285255311271)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 guias, esta p\00E1gina n\00E3o exibir\00E1 guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911016229311271)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina mostrar\00E1 um n\00EDvel de guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911442142311271)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas sem guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911501022311271)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um total de %0 p\00E1ginas n\00E3o t\00EAm guias definidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910917583311271)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibi\00E7\00E3o de Guia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911142106311271)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina mostrar\00E1 dois n\00EDveis de guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358881265311621)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>O Oracle APEX %0 est\00E1 dispon\00EDvel.</strong> O upgrade da sua inst\00E2ncia ser\00E1 feito automaticamente em <strong>%1</strong>. O administrador da sua Inst\00E2ncia pode iniciar o upgrade a qualquer momento antes dessa data no Administration Services')
||'.</p>',
unistr('<p>Veja o <a href="%2" target="_blank" rel="noreferrer">an\00FAncio</a> para saber mais sobre novas funcionalidades e aperfei\00E7oamentos no Oracle APEX %0.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358734890311621)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>O upgrade da sua inst\00E2ncia do %0 para uma release mais nova est\00E1 sendo feito.</strong> As altera\00E7\00F5es no seu aplicativo ser\00E3o desativadas por um per\00EDodo durante o processo de upgrade. O acesso aos seus aplicativos e ao ambiente de desenvolvime')
||unistr('nto do %0 ser\00E1 interrompido por at\00E9 %1 minutos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320516614310803)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321444767310803)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'pt-br'
,p_message_text=>'Tornar este esquema o atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321542255310803)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'pt-br'
,p_message_text=>'tornar atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376482407310844)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321289557310803)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar status para inativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320003569310802)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320115381310802)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00F3gica de gerenciamento de sess\00E3o incorporada, uma p\00E1gina de log-in incorporada e autentica\00E7\00E3o de usu\00E1rio no reposit\00F3rio de contas internas de "usu\00E1rio de cookie".'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320281777310803)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este m\00E9todo foi substitu\00EDdo pela autentica\00E7\00E3o SCHEME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374478336310842)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar atributos de autentica\00E7\00E3o obsoletos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374567831310842)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'pt-br'
,p_message_text=>'atributos obsoletos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374608626310842)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ou deixe-os no lugar at\00E9 estar pronto a alterar o m\00E9todo de autentica\00E7\00E3o para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374951313310842)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica um ou mais atributos de autentica\00E7\00E3o obsoletos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375126875310843)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ou migre-os para um esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374109818310842)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321129649310803)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar esquemas de autentica\00E7\00E3o usando o relat\00F3rio acima.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319987839310802)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376385774310843)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(N\00E3o Edit\00E1vel)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321374539310803)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'(atual)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374295544310842)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'pt-br'
,p_message_text=>'(obsoleto)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106321001098310803)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'pt-br'
,p_message_text=>'(nenhum)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320454773310803)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas P\00FAblicas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320651222310803)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'pt-br'
,p_message_text=>'Verificar ou editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320784749310803)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'pt-br'
,p_message_text=>'ou editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320801252310803)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('atributos de gerenciamento de sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106320942966310803)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('deste aplicativo na p\00E1gina de atributos deste aplicativo, ou use o relat\00F3rio abaixo para criar e gerenciar esquemas de autentica\00E7\00E3o usados quando voc\00EA altera o m\00E9todo de autentica\00E7\00E3o para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374782328310842)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Verificar ou editar atributos de gerenciamento de sess\00E3o'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375063196310842)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'pt-br'
,p_message_text=>'Verificar ou editar estes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374300501310842)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A autentica\00E7\00E3o %0 \00E9 um m\00E9todo obsoleto. Recomendamos que voc\00EA clique no link "tornar atual" (mostrado acima) em um dos esquemas de autentica\00E7\00E3o, ou crie em um novo esquema de autentica\00E7\00E3o e atualize-o. O esquema de autentica\00E7\00E3o INTERNAL-SETUP \00E9 funci')
||unistr('onalmente equivalente ao m\00E9todo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374850231310842)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usa esquemas de autentica\00E7\00E3o para controlar a autentica\00E7\00E3o do usu\00E1rio e todos os outros aspectos do gerenciamento de sess\00F5es para o seu aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638904773311046)
,p_name=>'F4000_P805_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA especificou uma fun\00E7\00E3o de sentinela de p\00E1gina na etapa anterior. Essa fun\00E7\00E3o ser\00E1 respons\00E1vel pela verifica\00E7\00E3o de sess\00E3o em cada p\00E1gina; portanto, uma fun\00E7\00E3o de verifica\00E7\00E3o de sess\00E3o n\00E3o pode ser especificada aqui. Se esse n\00E3o \00E9 o seu objetivo, ')
||unistr('reverta as etapas deste assistente e fa\00E7a as altera\00E7\00F5es desejadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377441044310844)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Incorporada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377824117310845)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377513508310844)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina deste Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377750319310844)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'pt-br'
,p_message_text=>'SSO do Oracle Application Server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377600895310844)
,p_name=>'F4000_P806_URL'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106377982278310845)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use a senha e o nome de usu\00E1rio da conta %0 para autenticar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263740035310757)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use o nome de usu\00E1rio e a senha da conta do banco de dados para autenticar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378096140310845)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o verificar credenciais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378208107310845)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar minha fun\00E7\00E3o personalizada para autenticar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378156844310845)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'pt-br'
,p_message_text=>'Usar um servidor LDAP para autenticar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642097088311048)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Sem nome de p\00E1gina -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322691534310804)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fun\00E7\00E3o de Autentica\00E7\00E3o'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323402722310805)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dom\00EDnio do Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323264125310805)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323398651310805)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'pt-br'
,p_message_text=>'Caminho do Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260897956310751)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'pt-br'
,p_message_text=>'Seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322442754310804)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Destino de Sess\00E3o Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322921441310804)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'pt-br'
,p_message_text=>'Base de Pesquisa LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323019857310805)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Edi\00E7\00E3o do Nome do Usu\00E1rio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322741599310804)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'pt-br'
,p_message_text=>'Host LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322850530310804)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'pt-br'
,p_message_text=>'Porta LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323504899310805)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'pt-br'
,p_message_text=>'URL de Log-out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322121010310804)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322092762310804)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'pt-br'
,p_message_text=>'(Incorporado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323621813310805)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(Autentica\00E7\00E3o de Banco de Dados)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322204960310804)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o Sentinela de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323169461310805)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processo de P\00F3s-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322520730310804)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processo de Pr\00E9-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106322370738310804)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Verifica\00E7\00E3o de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378410826310845)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Como c\00F3pia de um esquema de autentica\00E7\00E3o existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378570014310845)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Com base em um esquema pr\00E9-configurado da galeria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378327312310845)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Com base em um esquema pr\00E9-configurado da galeria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336253734310814)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao atualizar esquemas de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323855872310805)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391649379310855)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: Voc\00EA est\00E1 prestes a excluir o esquema de autentica\00E7\00E3o atual para este aplicativo!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324048383310805)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323732334310805)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106323989593310805)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379090586310845)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'pt-br'
,p_message_text=>'SSO do Oracle Application Server (Meu Aplicativo como Aplic. Parceiro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378602467310845)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar P\00E1gina de Log-in e Usar Credenciais da Conta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378724240310845)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar P\00E1gina de Log-in Incorporada e Usar Credenciais de Acesso Livre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378811971310845)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar P\00E1gina de Log-in e Usar Credenciais do Diret\00F3rio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106378980328310845)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'pt-br'
,p_message_text=>'SSO do Oracle Application Server (Mecanismo %0 como Aplicativo Parceiro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324317263310805)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9todo de Autentica\00E7\00E3o Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336392478310814)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sign-on \00DAnico (Somente para Uso do Oracle)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336445785310814)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'pt-br'
,p_message_text=>'SSO do Oracle Application Server (%0 como Aplicativo Parceiro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336569566310814)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'pt-br'
,p_message_text=>'SSO do Oracle Application Server (Minha Aplicativo como Aplicativo Parceiro)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336628658310815)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Incorporada: Usar Credenciais da Conta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359102709310831)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Rec\00E9m-criada: Usar Credenciais da Conta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359271615310831)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Existente: Usar Credenciais da Conta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336757195310815)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Incorporada: Credenciais de Acesso Livre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336802648310815)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Incorporada: Usar Credenciais do Diret\00F3rio LDAP')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358916620310831)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Rec\00E9m-criada: Usar Credenciais do Diret\00F3rio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359004787310831)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Existente: Usar Credenciais do Diret\00F3rio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336954286310815)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Com base no esquema de autentica\00E7\00E3o da galeria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379105320310845)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'pt-br'
,p_message_text=>'Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415817042310872)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'O recurso de %0 usa um recurso de banco de dados incorporado chamado "Consulta de Flashback", permitindo consultar dados relativos a uma determinada hora.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106415629455310872)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um hor\00E1rio ao qual deseja voltar e clique em "Aplicar" para registrar a origem de volta na p\00E1gina de edi\00E7\00E3o da regi\00E3o e fechar a caixa de di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416044118310872)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Com base no par\00E2metro de banco de dados "UNDO_RETENTION", voc\00EA pode apenas desfazer altera\00E7\00F5es ocorridas na(s) %0 \00FAltima(s) hora(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416587796310872)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirmar Cria\00E7\00E3o de Guia Padr\00E3o na Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416994468310873)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um novo conjunto de guias %0 ser\00E1 criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416831665310873)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina %0 usar\00E1 o conjunto de guias existente "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416618093310873)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia; as informa\00E7\00F5es do conjunto de guias est\00E1 incompleta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858325278311230)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'pt-br'
,p_message_text=>'Valor para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640495824311047)
,p_name=>'F4000_PREV'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628741269311039)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'pt-br'
,p_message_text=>'Clique em <strong>Finalizar</strong> para criar ou estender o seu aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628549304311039)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir aux\00EDlios de navega\00E7\00E3o por breadcrumbs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628661689311039)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocultar chave prim\00E1ria em p\00E1gina de relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774263188311158)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>'Atalho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534887618310969)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico SVG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106640108414311047)
,p_name=>'F4000_TOP'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739894440311130)
,p_name=>'F4000_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855201837311227)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292191587310779)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'pt-br'
,p_message_text=>'Documento de Resposta Inteiro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302109750310787)
,p_name=>'F400_P107_STEP'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272828814310764)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'pt-br'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856528994311228)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Aceito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726597530311119)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema ser\00E1 designado ao espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726632501311119)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema ser\00E1 designado ao espa\00E7o de trabalho pelos seguintes motivos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726139706311118)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema Adicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621389789311033)
,p_name=>'F4050.ADJUST'
,p_message_language=>'pt-br'
,p_message_text=>'Ajustar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620614757311033)
,p_name=>'F4050.ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856083427311228)
,p_name=>'F4050.APPROVED'
,p_message_language=>'pt-br'
,p_message_text=>'Aprovado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276645217310767)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de um espa\00E7o de trabalho foi aprovada e as credenciais foram enviadas para o endere\00E7o de e-mail fornecido durante o registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694736611311088)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de conta foi aprovada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694689381311088)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aprovada: solicita\00E7\00E3o de conta para %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695136775311088)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de %0 megabytes de armazenamento adicionais no espa\00E7o de trabalho %1 foi aprovada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855701653311228)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>'Designado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367089531311627)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855676187311228)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447271767311684)
,p_name=>'F4050.BROKEN'
,p_message_language=>'pt-br'
,p_message_text=>'Interrompido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447642385311685)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'pt-br'
,p_message_text=>'Cadeia Suspensa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695571708311089)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de altera\00E7\00E3o aprovada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695606222311089)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de altera\00E7\00E3o negada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447131149311684)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726235989311118)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema ser\00E1 criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856105320311228)
,p_name=>'F4050.DECLINED'
,p_message_language=>'pt-br'
,p_message_text=>'Recusado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695005184311088)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recusada: solicita\00E7\00E3o de conta para %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695425660311089)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de %0 megabytes de armazenamento adicionais no espa\00E7o de trabalho %1 foi negada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695226213311088)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de esquema de metadados %0 no espa\00E7o de trabalho %1 foi recusada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695310776311089)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o de encerrar o servi\00E7o para o espa\00E7o de trabalho %0 foi recusada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446835942311684)
,p_name=>'F4050.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272769352310764)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Clique no link abaixo para concluir o processo de aprova\00E7\00E3o. Uma vez conclu\00EDdo, voc\00EA receber\00E1 suas credenciais do espa\00E7o de trabalho em um e-mail de acompanhamento.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694982513311088)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Clique no link abaixo para come\00E7ar.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447363205311684)
,p_name=>'F4050.FAILED'
,p_message_language=>'pt-br'
,p_message_text=>'Falhou'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300490027310786)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique <a href=''%0''>aqui</a> para concluir o processo de aprova\00E7\00E3o e receber suas credenciais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610998683311025)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622116721311034)
,p_name=>'F4050.INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856281247311228)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Em Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620927546311033)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639095718311046)
,p_name=>'F4050.P23.USE'
,p_message_language=>'pt-br'
,p_message_text=>'Usar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450386635311687)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica\00E7\00E3o de Atualiza\00E7\00F5es desativada para toda a inst\00E2ncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639116658311046)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Aberto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726047172311118)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621278909311033)
,p_name=>'F4050.PROVISION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Provis\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694447192311088)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de altera\00E7\00E3o aprovada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694308872311088)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua solicita\00E7\00E3o para o esquema de banco de dados %0 no espa\00E7o de trabalho %1 foi aprovada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447496334311684)
,p_name=>'F4050.REMOTE'
,p_message_language=>'pt-br'
,p_message_text=>'Remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856322366311228)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'pt-br'
,p_message_text=>'Solicitado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620407252311033)
,p_name=>'F4050.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694502760311088)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O esquema solicitado \00E9 restrito porque \00E9 um esquema Oracle padr\00E3o ou em decorr\00EAncia de pol\00EDticas espec\00EDficas do site. Esquemas restritos n\00E3o podem ser designados a espa\00E7os de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446918762311684)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Repeti\00E7\00E3o Programada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726494218311119)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema existente ser\00E1 reutilizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447053801311684)
,p_name=>'F4050.RUNNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446755534311684)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'pt-br'
,p_message_text=>'Programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694162094311088)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O esquema solicitado j\00E1 foi designado a um ou mais espa\00E7os de trabalho. Certifique-se de possibilitar o acesso de v\00E1rios espa\00E7os de trabalho ao mesmo esquema \00E9 permitido pelas pol\00EDticas de seguran\00E7a do seu site antes de aprovar esta soli')
||unistr('cita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694068350311088)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O esquema solicitado j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726712309311119)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726994794311119)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema \00E9 reservado e n\00E3o pode ser designado a espa\00E7os de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694218248311088)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O esquema solicitado \00E9 restrito por que \00E9 um esquema padr\00E3o Oracle ou por causa de pol\00EDticas espec\00EDficas do site. Se designar este esquema ao espa\00E7o de trabalho ao continuar a opera\00E7\00E3o, voc\00EA permitir\00E1 que os desenvolvedores desse espa\00E7o ')
||unistr('de trabalho tenham acesso integral ao esquema. Certifique-se de que esta a\00E7\00E3o seja coerente com as pol\00EDticas de seguran\00E7a do seu site antes de aprovar esta solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106726889580311119)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema \00E9 restrito pelas pol\00EDticas de seguran\00E7a. Esquemas restritos n\00E3o podem ser designados a espa\00E7os de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695711428311089)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servi\00E7o encerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695895939311089)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O seu servi\00E7o de desenvolvimento "%0" foi encerrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447590664311685)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>'Bem-sucedido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855870036311228)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'pt-br'
,p_message_text=>'Suspenso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855975066311228)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'pt-br'
,p_message_text=>'Encerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106856416224311228)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'pt-br'
,p_message_text=>'Encerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446660127311684)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Encerramento em Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621599901311033)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de View')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621928295311034)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o de Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387978104310852)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Home do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388093176310852)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Log-in no Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691783254311086)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de trabalho n\00E3o ser\00E1 criado porque j\00E1 existe um espa\00E7o de trabalho com o mesmo ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691637002311086)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho n\00E3o ser\00E1 criado porque j\00E1 existe um espa\00E7o de trabalho com o mesmo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464587207310909)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho %0 foi criado em %1 e a confirma\00E7\00E3o foi enviada para o endere\00E7o de e-mail fornecido durante o registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293728078310780)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Espa\00E7o de Trabalho n\00E3o ser\00E1 criado porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293877952310780)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho ser\00E1 criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528991907310964)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Nova Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528820671310964)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha da conta foi alterada para o usu\00E1rio %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528720366310964)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>'Sua senha foi alterada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411829758311659)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina controla se %0 ser\00E1 submetido a upgrade imediatamente quando a pr\00F3xima release estiver dispon\00EDvel, ou se o upgrade ser\00E1 adiado por at\00E9 %1 dias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411945347311659)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique em Fazer Upgrade Agora para iniciar o upgrade agora, e n\00E3o em %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411557975311659)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O sistema est\00E1 atualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411659955311659)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 %1 est\00E1 <a href="%2" target="_blank" rel="noreferrer">dispon\00EDvel</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410683874311658)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Depois que uma nova release %0 ficar dispon\00EDvel, sua inst\00E2ncia ser\00E1 <strong>imediatamente</strong> submetida a upgrade.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411329044311659)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua inst\00E2ncia ser\00E1 submetida a upgrade automaticamente em <strong>%0</strong>. Clique no \00EDcone de engrenagem para fazer upgrade agora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410534306311658)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 upgrades de sua inst\00E2ncia est\00E3o <strong>adiados</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952530662311308)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('no momento, o upgrade de %0 para %1 est\00E1 sendo feito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280621167310770)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio de banco de dados %0 criado com o tablespace padr\00E3o %1 usando o arquivo de dados %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297403680310783)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de trabalho %0 provisionado com o administrador %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429251051310882)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Todos os Espa\00E7os de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420589845310875)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O comprimento da coluna n\00E3o pode ser nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420410526310875)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O comprimento da coluna n\00E3o pode ser zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420736452310875)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os nomes de colunas n\00E3o podem ter mais do que %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420831767310876)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os nomes de coluna n\00E3o podem ser nulos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421380747310876)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>%0</strong> j\00E1 est\00E1 sendo usado por um objeto existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421596783310876)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>%0</strong> n\00E3o \00E9 um nome de sequ\00EAncia v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420198136310875)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da tabela j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421114328310876)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>%0</strong> n\00E3o \00E9 um nome de chave prim\00E1ria v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639292241311046)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106610217072311025)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Importa\00E7\00E3o de Planilha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421007824310876)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'pt-br'
,p_message_text=>'Os nomes de tabelas devem ter menos do que %0 caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431778431310884)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A primeira linha cont\00E9m nomes de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757551951311144)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Importa\00E7\00E3o de Texto')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457512248310903)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620286620311033)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(dispon\00EDvel)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620071589311032)
,p_name=>'F4350.CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795128262311175)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 solicitando que o esquema existente %0 seja designado ao seu espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795289110311175)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 solicitando que o esquema %0 seja criado e designado ao seu espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619770859311032)
,p_name=>'F4350.CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463699424310908)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criando Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620111439311032)
,p_name=>'F4350.CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'(atual)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458072561310904)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'pt-br'
,p_message_text=>'Tempo Atual (no servidor):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457808314310904)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619909749311032)
,p_name=>'F4350.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464741168310909)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A cria\00E7\00E3o do espa\00E7o de trabalho foi desativada temporariamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457416622310903)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema do Host'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619427717311032)
,p_name=>'F4350.INSERTED'
,p_message_language=>'pt-br'
,p_message_text=>'Inserido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457946420310904)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia de Idioma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457343859310903)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio da \00DAltima DDL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941165865311293)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio do \00DAltimo Patch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264249140310757)
,p_name=>'F4350.MORE'
,p_message_language=>'pt-br'
,p_message_text=>'%0 mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941075353311293)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o do Patch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457149628310903)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o interna do produto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988937911311336)
,p_name=>'F4350.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457250039310903)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'pt-br'
,p_message_text=>'Compatibilidade do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264120057310757)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'(+%0 aplicativos traduzidos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619626660311032)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Desconhecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619545183311032)
,p_name=>'F4350.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457689330310903)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457753772310904)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165826893311476)
,p_name=>'F4350_AJAX'
,p_message_language=>'pt-br'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165708244311476)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Callback de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621160131311033)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Clique nas entradas de log:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621041125311033)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de log de atividade do desenvolvedor:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621646594311033)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Distintos em todas as sess\00F5es = %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622068515311034)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('nenhum usu\00E1rio selecionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622329025311034)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As prefer\00EAncias %0 existem para %1 usu\00E1rios no espa\00E7o de trabalho "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238500459310730)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Existem %0 Prefer\00EAncias para %1 usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620827688311033)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefina as suas prefer\00EAncias se quiser executar o seu aplicativo sem valores predefinidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295542212310782)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefina o estado da sess\00E3o se desejar executar o aplicativo sem nenhum valor predefinido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622411156311034)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio Selecionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621737374311034)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00F5es anteriores a %0 dia(s) = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621875406311034)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00F5es anteriores a %0 minuto(s) = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620367960311033)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua sess\00E3o \00E9 identificada por %0 e cont\00E9m %1 entradas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623001367311034)
,p_name=>'F4350_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622251604311034)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Resumo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106621446831311033)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Total de Sess\00F5es para o espa\00E7o de trabalho "%0" \00E9 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238492805310730)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Total de Sess\00F5es: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622553702311034)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio %0 tem %1 prefer\00EAncias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106620733040311033)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio atual %0 tem %1 prefer\00EAncias definidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106622695998311034)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas do Espa\00E7o de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625124953311036)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Seq. de Exibi\00E7\00E3o em Forms deve ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625205840311036)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Seq. de Exibi\00E7\00E3o em Relat\00F3rios deve ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428674456310882)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome do argumento <strong>%0</strong> \00E9 usado mais de uma vez nesta fun\00E7\00E3o.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628272479311038)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Ordem de Execu\00E7\00E3o deve ser especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628101324311038)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Ordem de Execu\00E7\00E3o deve ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611034558311026)
,p_name=>'F4500.FIND'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639495553311046)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611445126311026)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'pt-br'
,p_message_text=>'Ampliar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611303093311026)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Mover Coluna para Baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611289050311026)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'pt-br'
,p_message_text=>'Mover Coluna para Cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422390252310877)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe n\00FAmero da ordem de execu\00E7\00E3o \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223570586310717)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Novas Colunas a Serem Adicionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421919160310876)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>%0</strong> n\00E3o \00E9 um nome de objeto v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421722507310876)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>%0</strong> n\00E3o \00E9 um nome de tabela v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611175975311026)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611564573311026)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('anul\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724822089311117)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Execu\00E7\00F5es Anteriores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428148524310881)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os nomes de colunas <strong>%0</strong> s\00E3o usados mais de uma vez nesta tabela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428538163310881)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'pt-br'
,p_message_text=>'Deve ser informado o nome de pelo menos uma coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428400076310881)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna <strong>%0</strong> \00E9 inv\00E1lido.<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428218736310881)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A precis\00E3o para a coluna <strong>%0</strong> \00E9 inv\00E1lida.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428339370310881)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A escala para a coluna <strong>%0</strong> \00E9 inv\00E1lida.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278630226310769)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A escala para a coluna <strong>%0</strong> \00E9 obrigat\00F3ria.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639565979311046)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar sin\00F4nimo em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106639362690311046)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422076932310876)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela <strong>%0</strong> n\00E3o encontrada no esquema <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227626682310720)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00F5es de Advert\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624254645311035)
,p_name=>'F4500_BROKEN'
,p_message_language=>'pt-br'
,p_message_text=>'Interrompido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624752095311036)
,p_name=>'F4500_BYTES'
,p_message_language=>'pt-br'
,p_message_text=>'Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624687939311036)
,p_name=>'F4500_CARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624042024311035)
,p_name=>'F4500_CHECK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616524904311030)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Clique para preencher campo de consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624505520311036)
,p_name=>'F4500_COST'
,p_message_language=>'pt-br'
,p_message_text=>'Custo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615809849311029)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de cria\00E7\00E3o foi bem-sucedida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393980899311646)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos sem padr\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393851987311646)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos com padr\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615181434311029)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de elimina\00E7\00E3o foi bem-sucedida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267680188310760)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'pt-br'
,p_message_text=>'Estrangeira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529137577310965)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'pt-br'
,p_message_text=>'Chave Estrangeira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428948426310882)
,p_name=>'F4500_NATIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Formato de arquivo nativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614840238311029)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o dispon\00EDvel para edi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624365623311035)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('est\00E1 dispon\00EDvel para pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624118946311035)
,p_name=>'F4500_OF'
,p_message_language=>'pt-br'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106624403701311036)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'pt-br'
,p_message_text=>'Otimizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616860266311030)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o foi bem-sucedida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604542838311021)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Mensagem dos Espa\00E7os de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757401166311144)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os tipos de colunas VARCHAR n\00E3o existem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301831247310787)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'pt-br'
,p_message_text=>'Fazendo parsing de script - aguarde.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248575900310740)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Instru\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490319579310932)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'pt-br'
,p_message_text=>'em %0 por %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612289037311026)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se voc\00EA tiver par\00E2metros no script, defina-os antes da execu\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248402617310740)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490213925310932)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Script em Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486597422310929)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612411102311027)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771152428311155)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a importa\00E7\00E3o do(s) script(s) a seguir. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106771273675311155)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O script(s) solicitado para importa\00E7\00E3o excede o armazenamento m\00E1ximo permitido. Entre em contato com o administrador %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772242279311156)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Script para Importa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612954776311027)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612712021311027)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592643492311012)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673521147311072)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Procurar Sequ\00EAncias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673613972311072)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o da sequ\00EAncia de cria\00E7\00E3o n\00E3o foi bem-sucedida pelo seguinte motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673410942311072)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sequ\00EAncia "%0" foi criada no esquema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613107827311027)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673906305311072)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Procurar Sin\00F4nimos do Banco de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674169057311072)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de cria\00E7\00E3o de sin\00F4nimos n\00E3o foi bem-sucedida pelos seguinte motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673890968311072)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O sin\00F4nimo "%0" foi criado no esquema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674257676311072)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de cria\00E7\00E3o de pacotes n\00E3o foi bem-sucedida pelo seguinte motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674394230311072)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'O pacote "%0" foi criado no esquema "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455960446310902)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar na Planilha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613415637311027)
,p_name=>'F4500_P25_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613352601311027)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613270989311027)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269308250310761)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Expirado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269431211310761)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Expirado e Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269212924310761)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269195134310761)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Aberto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673313400311072)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o n\00E3o foi bem-sucedida pelos seguintes motivos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650428835311054)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o dispon\00EDvel para inserir dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673265015311072)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar View de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672904689311071)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de cria\00E7\00E3o de views n\00E3o foi bem-sucedida pelo seguinte motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673099758311071)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'pt-br'
,p_message_text=>'Home do SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106673100111311072)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'A view "%0" foi criada no esquema "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106641760285311048)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Coment\00E1rio de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799379913311179)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'pt-br'
,p_message_text=>'Identidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300358358310786)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 tipo de dados especificado para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614939015311029)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de tabela foi bem-sucedida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612038127311026)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este arquivo tem %0 instru\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612116048311026)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio definiu o(s) seguinte(s) %0 par\00E2metro(s):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429143246310882)
,p_name=>'F4500_PARSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer parsing neste script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623821581311035)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232701674310725)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'pt-br'
,p_message_text=>'Referencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106429001082310882)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir documento como texto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106623912525311035)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAnico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473365760311703)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 problemas com a configura\00E7\00E3o dos Arquivos Est\00E1ticos no seu ambiente. Consulte a se\00E7\00E3o "Configuring Static File Support" no Application Express Installation Guide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816721279311197)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'pt-br'
,p_message_text=>'Bem-vindo ao Oracle APEX! Acesse usando a senha do administrador (ADMIN) do seu Autonomous Database.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469469867311700)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 recebendo este e-mail porque solicitou um espa\00E7o de trabalho do Oracle APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469352595311700)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o obrigat\00F3ria: solicita\00E7\00E3o de a\00E7\00E3o para %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693092817311087)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'pt-br'
,p_message_text=>'(usado para o envio das suas credenciais por e-mail)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693231671311087)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use um esquema de banco de dados que exista no seu banco de dados Oracle. Por motivos de seguran\00E7a, n\00E3o \00E9 fornecida uma lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693190150311087)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do esquema de banco de dados Oracle que gostaria de criar para o seu espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692424650311086)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Na sua descri\00E7\00E3o abaixo, explique por que est\00E1 solicitando um esquema restrito.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692576350311086)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Na sua descri\00E7\00E3o abaixo, explique por que est\00E1 solicitando um esquema que j\00E1 est\00E1 sendo usado por um ou mais outros espa\00E7os de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692978306311087)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O esquema que voc\00EA est\00E1 solicitando \00E9 restrito por raz\00F5es de seguran\00E7a. O administrador %0 pode negar a sua solicita\00E7\00E3o de atribuir este esquema ao seu espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692831930311087)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O esquema que voc\00EA est\00E1 solicitando j\00E1 est\00E1 sendo usado por outro(s) espa\00E7o(s) de trabalho. O administrador %0 pode negar a sua solicita\00E7\00E3o de atribuir este esquema ao seu espa\00E7o de trabalho. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689862578311084)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O novo esquema solicitado para o seu espa\00E7o de trabalho \00E9 um esquema padr\00E3o Oracle ou pode ser especificamente restrito no seu site por motivos de seguran\00E7a e n\00E3o pode ser eleg\00EDvel para designa\00E7\00E3o a um espa\00E7o de trabalho. O administrador do site pode')
||unistr(' rejeitar a sua solicita\00E7\00E3o de provisionamento se ela violar uma pol\00EDtica de seguran\00E7a no seu site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689773345311084)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema solicitado para o seu espa\00E7o de trabalho j\00E1 foi atribu\00EDdo a %0 espa\00E7os de trabalho. O administrador do site pode rejeitar a sua solicita\00E7\00E3o de provisionamento se ela violar uma pol\00EDtica de seguran\00E7a no seu site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265048383310758)
,p_name=>'F4700P1_A'
,p_message_language=>'pt-br'
,p_message_text=>'O Oracle APEX fornece acesso a um banco de dados Oracle e a ferramentas de desenvolvimento baseadas em browser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265154814310758)
,p_name=>'F4700P1_B'
,p_message_language=>'pt-br'
,p_message_text=>'Construir aplicativos Web declarativamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265227826310758)
,p_name=>'F4700P1_C'
,p_message_language=>'pt-br'
,p_message_text=>'Criar e gerenciar objetos de banco de dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265397868310758)
,p_name=>'F4700P1_D'
,p_message_language=>'pt-br'
,p_message_text=>'Rastrear marcos, bugs, recursos e tarefas<'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403864738311654)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo foi instalada com sucesso. No entanto, para executar o aplicativo com a autentica\00E7\00E3o de conta do Application Express, deve ser configurada uma conta de usu\00E1rio do Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403901794311654)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Websheet foi instalado com sucesso. No entanto, para executar o Websheet com a autentica\00E7\00E3o de conta do Application Express, deve ser configurado um administrador com uma conta do Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757622323311144)
,p_name=>'F4750.VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427986447311671)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel redefinir amostras de dados de RESTful Services: o esquema <code>%0</code> n\00E3o existe.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002772511311349)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este aplicativo usa o esquema de autentica\00E7\00E3o %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037106665311376)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa Facetada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010580036311356)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O assistente n\00E3o pode criar uma pesquisa facetada usando a origem do relat\00F3rio. N\00E3o h\00E1 colunas a serem pesquisadas.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822334246311202)
,p_name=>'FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>'falha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613694896311028)
,p_name=>'FAILURES'
,p_message_language=>'pt-br'
,p_message_text=>'Falhas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688011590311083)
,p_name=>'FDASH1'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729507973311121)
,p_name=>'FEATURE'
,p_message_language=>'pt-br'
,p_message_text=>'Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448371316311685)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rios do Recurso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402025335310862)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Sobre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402786741310862)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sobre esta p\00E1gina do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402191839310862)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402862601310862)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incorpore a autentica\00E7\00E3o de usu\00E1rios baseada em atribui\00E7\00E3o no seu aplicativo e gerencie mapeamentos de nome de usu\00E1rio para atribui\00E7\00F5es do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402239100310862)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Atividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402979511310863)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inclua diversos relat\00F3rios e gr\00E1ficos sobre a atividade do usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402367681310862)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403786725310863)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir que os administradores de aplicativos ativem ou desativem funcionalidades espec\00EDficas, associadas a uma op\00E7\00E3o de build do Application Express, de dentro do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701828222311093)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A(s) seguinte(s) Op\00E7\00E3o(\00F5es) de Build ser\00E1(\00E3o) criada(s):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762563199311148)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera\00E7\00E3o de Relat\00F3rio de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762687359311148)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inclui um relat\00F3rio na fila de e-mails APEX_SEND().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819246377311199)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inclui um relat\00F3rio que exibe o e-mail a ser enviado, junto com o log de e-mails j\00E1 enviados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402448690310862)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403050768310863)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a um mecanismo para que os usu\00E1rios finais postem coment\00E1rios gen\00E9ricos para os administradores e desenvolvedores de aplicativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762773906311148)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios de Jobs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762848914311149)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inclui um relat\00F3rio nos jobs de banco de dados, com a capacidade de fazer drill-down em um job espec\00EDfico para ver detalhes adicionais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106402507326310862)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Estilo do Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106403695732310863)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir que os administradores selecionem um esquema de cores padr\00E3o (estilo de tema) para o aplicativo. Os administradores tamb\00E9m podem permitir que os usu\00E1rios finais escolham seu pr\00F3prio estilo de tema. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709701290311099)
,p_name=>'FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Funcionalidades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017853074311362)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos 100%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766966476311152)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos 100% (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732104993311124)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260149657310750)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'pt-br'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258904520310749)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recursos Conclu\00EDdos (%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260039633310750)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020345804311364)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos da Release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767139625311152)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'pt-br'
,p_message_text=>'Vencidos (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036478897311376)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Percentual de recursos conclu\00EDdos funcionalmente (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767053798311152)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'pt-br'
,p_message_text=>'Com datas (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799252227311179)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o de Recursos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705217589311096)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'pt-br'
,p_message_text=>'Colaborador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766832188311152)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem de Recursos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013860794311358)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 recurso(s), %1 totalmente conclu\00EDdo(s), em %2 release(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013975464311359)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 recurso(s) de n\00EDvel superior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014015272311359)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o tem(t\00EAm) data de vencimento, %1 est\00E1(\00E3o) vencido(s) e < 80% est\00E3o conclu\00EDdos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014152135311359)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 recurso(s) conclu\00EDdos funcionalmente, %1 n\00E3o conclu\00EDdo(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017584532311362)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0% dos recursos est\00E3o conclu\00EDdos 100%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703530656311095)
,p_name=>'FEATURE_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o do Recurso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704597600311096)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conveni\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435433895311676)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Recurso: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703177016311094)
,p_name=>'FEATURE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703274349311095)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio do Recurso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704286579311095)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'pt-br'
,p_message_text=>'Prioridade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704375573311095)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704173004311095)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448454910311685)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o designado')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450870271311687)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('registrados %0 e atribu\00EDdos a %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729442574311121)
,p_name=>'FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745001707311134)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a essas informa\00E7\00F5es para fazer log-in como feedback.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815544450311196)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709326234311099)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259283312310750)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'%2 Entradas de Feedback Abertas (%0 Fechadas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744869400311134)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe seu feedback e pressione o bot\00E3o submeter feedback.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036762023311376)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual de feedback fechado (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740077328311130)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744977348311134)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifique o tipo de feedback que voc\00EA est\00E1 fornecendo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907743322311268)
,p_name=>'FILENAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712497676311108)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Nome de Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955195367311310)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Arquivo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710942175311107)
,p_name=>'FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390412195311644)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'%0 arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710490106311106)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Arquivos, consumindo %1K'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435278922311676)
,p_name=>'FILE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106238141063310730)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este arquivo de texto \00E9 muito grande para ser editado. Para alterar o conte\00FAdo, voc\00EA dever\00E1 editar o arquivo na sua m\00E1quina local e carreg\00E1-lo novamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272535729310764)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o existe sess\00E3o v\00E1lida e um ou mais arquivos foram transferidos por upload.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272470610310764)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mais arquivos foram transferidos por upload nesta solicita\00E7\00E3o do que o n\00FAmero de tipos de item de arquivo definidos na p\00E1gina.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762954644311149)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localizar Meu Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243552880310735)
,p_name=>'FIND_TABLES'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar Tabelas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470653418311701)
,p_name=>'FINISH'
,p_message_language=>'pt-br'
,p_message_text=>'Finalizar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615576753311029)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Primeira Entrada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768611229311153)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'pt-br'
,p_message_text=>'Corrigir por data vencida'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685057798311081)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Corrigido no desenvolvimento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703365790311095)
,p_name=>'FOCUS_AREA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Foco')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486081492310929)
,p_name=>'FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto do Rodap\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225235082310718)
,p_name=>'FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433981271311675)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767294437311152)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Form e View em Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767367603311152)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio com Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603271218311020)
,p_name=>'FORM_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Form em %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344774565310820)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Form em uma Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746565786311136)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O form em uma consulta foi criado com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746891414311136)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O form e o relat\00F3rio em uma refer\00EAncia de Web service foram criados com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744168405311134)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O form foi criado com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746677155311136)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina de resumo foi criada com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746221975311135)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O form em uma tabela foi criado com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746751202311136)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O form em uma refer\00EAncia de Web service foi criado com sucesso.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293911778310780)
,p_name=>'FORWARD'
,p_message_language=>'pt-br'
,p_message_text=>'Encaminhar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803717154311187)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('do Dicion\00E1rio de Atributos')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432221901310884)
,p_name=>'FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693502651311087)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Funcionalmente conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683361054311079)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Implementa\00E7\00E3o Funcional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487664954310930)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433610669310885)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da fun\00E7\00E3o PL/SQL retornando consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743810757311133)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da fun\00E7\00E3o PL/SQL retornando Cursor Ref.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736976406311128)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL que retorna um booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292727087310780)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o PL/SQL que Retorna Booleano')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730686841311122)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'Marcos futuros'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383198942311639)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data da Linha de Base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383003884311639)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'pt-br'
,p_message_text=>'Fim da Linha de Base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382938328311638)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio da Linha de Base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736551817311127)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736478097311127)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970568806311322)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382695537311638)
,p_name=>'GANTT_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382505913311638)
,p_name=>'GANTT_END'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382713585311638)
,p_name=>'GANTT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382897219311638)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382386647311638)
,p_name=>'GANTT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382442156311638)
,p_name=>'GANTT_START'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167938131311478)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coletar Estat\00EDsticas da Tabela')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686136760311082)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rio Geral')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036822571311376)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rios Gerais: %1 de %0 fechado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297866366310784)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Esta tabela foi criada usando o assistente de tabela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382217937310848)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00F5es salvas.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106692117934311086)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar ou editar Lista de Valores est\00E1tica')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705453356311096)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Favorecido de Globaliza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703678081311095)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impacto da Globaliza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706424293311097)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Status da Globaliza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226425450310719)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Global')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751005526311139)
,p_name=>'GRAY_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto em Cinza'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725979699311118)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar Colunas de Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725848315311118)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Colunas de Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324554496310806)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Grade'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668088074311067)
,p_name=>'GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>'Grupos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860500946311231)
,p_name=>'GROUP_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106485983546310929)
,p_name=>'HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto do Cabe\00E7alho')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860394323311231)
,p_name=>'HEADING_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430945454311673)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo da Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434056862310886)
,p_name=>'HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'texto de ajuda'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529063487310965)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto e Protegido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687280607311082)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altamente desej\00E1vel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389933027311643)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'pt-br'
,p_message_text=>'Contraste Elevado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151539659311465)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altern\00E2ncia de Contraste Elevado')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667831591311067)
,p_name=>'HISTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hist\00F3rico')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743644967311133)
,p_name=>'HOME_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link da Home Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222306333310715)
,p_name=>'HOME_NAV'
,p_message_language=>'pt-br'
,p_message_text=>'Home Page do Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275191958310766)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461065867310906)
,p_name=>'HORIZONTAL'
,p_message_language=>'pt-br'
,p_message_text=>'horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207681752310702)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Horizontal em 2D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207763240310702)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Horizontal em 3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207847529310702)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 2D de Faixa Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106207910184310702)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 3D de Faixa Horizontal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430380810311673)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo Autom\00E1tico')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265599459310758)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Conta HR desbloqueada.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435103201310886)
,p_name=>'HTML'
,p_message_language=>'pt-br'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454190593310901)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'HTML com Atalhos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453806315310901)
,p_name=>'HTML_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296438406310782)
,p_name=>'HTML_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305801206310790)
,p_name=>'HTML_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486214443310929)
,p_name=>'HTML_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305950990310790)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'HTML/Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433764627310885)
,p_name=>'HTML_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306000318310790)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'Texto HTML com atalhos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430588133311673)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366269663311626)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('indica que o tema \00E9 compat\00EDvel com IE 6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773359874311157)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir Edi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773482497311157)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Leitura'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435306849310887)
,p_name=>'IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976198934311326)
,p_name=>'IMAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Imagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419716804310875)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743051633311133)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>'Prefixo de Imagem'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680925642311077)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Importar de aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442252441311681)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo Valor da String de Substitui\00E7\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910834173311271)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo importado est\00E1 localizado no <a href="%0">Reposit\00F3rio de Exporta\00E7\00E3o</a>. Voc\00EA deve remov\00EA-lo, exceto se pretende instal\00E1-lo novamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616443785311030)
,p_name=>'IN/OUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada/Sa\00EDda')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232913736310725)
,p_name=>'INACTIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Inativo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815362457311196)
,p_name=>'INCLUDE'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434829746311676)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432359334310884)
,p_name=>'INDEX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00EDndice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812783741311194)
,p_name=>'INDEX_NOUN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDndice')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376797037310844)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590730937311011)
,p_name=>'INLINE'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380280466311636)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Ajuda em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590618356311011)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Linha e com Notifica\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736629428311128)
,p_name=>'INPUT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Entrada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433062934310885)
,p_name=>'INSERT'
,p_message_language=>'pt-br'
,p_message_text=>'inserir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822166981311202)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('inserir na exce\00E7\00E3o wwv_flow_companies:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752757562311140)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'pt-br'
,p_message_text=>'CSS (Aplicativo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752540657311140)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem (Aplicativo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752946464311141)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivo Est\00E1tico (Aplicativo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261877427310752)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319371445310802)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 poss\00EDvel incluir as op\00E7\00F5es de build a seguir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261777394310752)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substitui\00E7\00F5es de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319243084310802)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 poss\00EDvel configurar os atributos a seguir do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262012562310752)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirma\00E7\00E3o de Instala\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319599595310802)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Confirme se deseja instalar os objetos de suporte deste aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262497594310752)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirma\00E7\00E3o de Desinstala\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106237038694310729)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Script de Desinstala\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262591527310753)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desinstala\00E7\00E3o Bem-sucedida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319899386310802)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desinstala\00E7\00E3o conclu\00EDda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606702960311023)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Erro ao executar a verifica\00E7\00E3o de instala\00E7\00E3o "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606815526311023)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Erro ao executar o script de instala\00E7\00E3o "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261677482310752)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Verifica\00E7\00E3o de Exist\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262288455310752)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha em P\00F3s-Instala\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319753872310802)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na instala\00E7\00E3o de objetos de banco de dados e dados pr\00E9-implantados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669125483311068)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'O instalador do aplicativo detectou que os objetos de suporte desse aplicativo foram instalados anteriormente. Os objetos devem ser removidos por meio do SQL Workshop para que esse aplicativo possa ser instalado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262347474310752)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Licen\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257550766310748)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Erros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257466842310748)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262114078310752)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-Instala\00E7\00E3o Bem-sucedida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319696817310802)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Os objetos de suporte do aplicativo foram instalados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358668466310831)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirme que voc\00EA deseja fazer upgrade dos objetos de suporte deste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358509601310831)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Falha no upgrade dos objetos de suporte deste aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358169928310830)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'O instalador do aplicativo detectou que os objetos de suporte deste aplicativo foram instalados anteriormente. Este assistente vai conduzi-lo durante o processo de upgrade desses objetos de suporte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358449453310831)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Os objetos de suporte do seu aplicativo tiveram upgrade.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261940053310752)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319448437310802)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As valida\00E7\00F5es a seguir ser\00E3o executadas para garantir que o sistema seja compat\00EDvel com este aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261529756310752)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'pt-br'
,p_message_text=>'Bem-vindo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106319164525310802)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Installer deste aplicativo vai ajud\00E1-lo no processo de cria\00E7\00E3o de objetos de banco de dados e dados pr\00E9-implantados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752633885311140)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('CSS (Espa\00E7o de Trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752490648311140)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagem (Espa\00E7o de Trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752891293311141)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivo Est\00E1tico (Espa\00E7o de Trabalho)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249819962310741)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753063911311141)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'pt-br'
,p_message_text=>'Instalar um aplicativo de amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150915058311465)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'pt-br'
,p_message_text=>'Home do Oracle APEX Administration Services'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800265312311184)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Inst\00E2ncias')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702249754311094)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta inst\00E2ncia est\00E1 executando no modo de provisionamento manual, portanto n\00E3o aceitar\00E1 solicita\00E7\00F5es de servi\00E7o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795305978311175)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o insuficiente para instalar este aplicativo.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683479196311079)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Integra\00E7\00E3o Conclu\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688635122311083)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aprova\00E7\00E3o de Integra\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679165706311076)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Grade Interativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454888725310901)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708669387311099)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pesquisas de Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273860921310765)
,p_name=>'INTERNAL'
,p_message_language=>'pt-br'
,p_message_text=>'Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226132290310719)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o Interna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275503238310766)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'pt-br'
,p_message_text=>'Interno'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602851391311020)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio informar um nome v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232808510310725)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo n\00E3o \00E9 um arquivo compactado de aplicativo v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603340100311020)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio informar um nome de grupo v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294651887310781)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Objeto %0 \00E9 Inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956582144311311)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio informar um nome de grupo de p\00E1ginas v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471108432311701)
,p_name=>'INVALID_POSITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o Inv\00E1lida [N\00E3o Renderizada]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821801072311201)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de esquema inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735661089311127)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada inv\00E1lida; valor deve ser um n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419997037311665)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Observe que %0 strings tinham nomes de usu\00E1rios inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821731313311201)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('nome do espa\00E7o de trabalho inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762330425311148)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos da Websheet Inv\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760224513311146)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos da Websheet inv\00E1lidos corrigidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762473281311148)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os objetos do banco de dados necess\00E1rios para criar os aplicativos de Websheet s\00E3o inv\00E1lidos ou n\00E3o existem. Entre em contato com o Administrador do Espa\00E7o de Trabalho.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208091521310703)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha em 2D Inversa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684945464311081)
,p_name=>'IN_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Em andamento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380781511310847)
,p_name=>'IR_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629105534311039)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'pt-br'
,p_message_text=>'Desenvolvedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629010465311039)
,p_name=>'IR_END_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio Final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629418896311039)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605510231311022)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pode-se exibir um relat\00F3rio interativo por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629237351311039)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Essa caixa de di\00E1logo s\00F3 \00E9 exibida para desenvolvedores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628960554311039)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio*')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629310478311039)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434471638311675)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo: %0, P\00E1gina: %1, Inscrito por: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748294061311137)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Relat\00F3rio Interativo foi criado com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106629598008311039)
,p_name=>'IR_UNITS'
,p_message_language=>'pt-br'
,p_message_text=>'Unidades'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169634184311479)
,p_name=>'ISSUES'
,p_message_language=>'pt-br'
,p_message_text=>'Problemas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617178664311030)
,p_name=>'IS_WRAPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('est\00E1 encapsulado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728321149311120)
,p_name=>'ITEM CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306255942310790)
,p_name=>'ITEM NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273503872310764)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es de Itens')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455190939311690)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo da Coluna do Item Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293052592310780)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Item da Express\00E3o 1 \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106293145967310780)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de item da Express\00E3o 1 N\00C3O \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292621990310779)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item da Express\00E3o 1 \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292593164310779)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item da Express\00E3o 1 \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433699723311675)
,p_name=>'ITEM_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Item: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350702129310825)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350809075310825)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693692033311087)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Campo de Texto com preenchimento autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979312361311329)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349055242311614)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Cores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808938990311191)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971540671311322)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Data (Cl\00E1ssico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218251107310712)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Data (HTML5)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107013798095311358)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973080635311323)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012505503311357)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Procura de Arquivo...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348831047311614)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019415698311363)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciador de Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035671176311375)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Editor de Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963483652311316)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Campo de N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964952075311317)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972249085311323)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'LOV Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979294537311328)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de R\00E1dio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725111290311118)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Editor de Formato Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971686801311322)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973609750311324)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'pt-br'
,p_message_text=>'Transporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239330491310731)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'pt-br'
,p_message_text=>'Controle Deslizante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350937806310825)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Interromper e Iniciar Layout da Grade (Obsoleto)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727121520311119)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348964044311614)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239053958310731)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sim/N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300537918310786)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351095933310825)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988351042311336)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o por Estrelas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351101603310825)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388589799311642)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00F3s-Texto do Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388422095311642)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Pr\00E9-Texto do Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753669708311141)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'pt-br'
,p_message_text=>'Linha 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753725339311141)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'pt-br'
,p_message_text=>'Linha 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753839766311141)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'pt-br'
,p_message_text=>'Linha 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753986089311141)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'pt-br'
,p_message_text=>'Linha 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963320481311316)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Valor M\00E1ximo Informado %0 para o item %1 n\00E3o \00E9 num\00E9rico. Se o valor contiver casas decimais, especifique um ponto como o separador decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963226674311316)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Valor M\00EDnimo Informado %0 para o item %1 n\00E3o \00E9 num\00E9rico. Se o valor contiver casas decimais, especifique um ponto como o separador decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239293222310731)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Valor da Etapa Informado %0 para o item %1 n\00E3o \00E9 num\00E9rico. Se o valor contiver casas decimais, especifique um ponto como o separador decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300915950310786)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301088358310786)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Procura de Arquivo...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301118241310786)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301227831310786)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto e Protegido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301362938310786)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor Popup de Cores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301482303310786)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301550355310787)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Campo de Texto (Desativado, n\00E3o salva o estado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301649929310787)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Texto (Desativado, salva o estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301792889310787)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Campo de Texto (sempre submete a p\00E1gina quando a tecla Enter \00E9 pressionada)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678946101311076)
,p_name=>'JET_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico JET')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614359149311028)
,p_name=>'JOB'
,p_message_language=>'pt-br'
,p_message_text=>'Job'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680138468311077)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altern\00E2ncia de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680016850311077)
,p_name=>'JQM REFLOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Reflow')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755687563311143)
,p_name=>'JQM_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755546223311143)
,p_name=>'JQM_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682099782311078)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View em Lista'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679237282311076)
,p_name=>'JSTREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Javascript')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705381044311096)
,p_name=>'JUSTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Justificativa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169756259311479)
,p_name=>'LABELS'
,p_message_language=>'pt-br'
,p_message_text=>'Labels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455091828311690)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo da Coluna com Label Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448614928311685)
,p_name=>'LABEL_ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Label de Item Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742108253311132)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407138491310866)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407246112310866)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" deste modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407417803310866)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 modelos inscritos neste modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106407397907310866)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de labels com inscri\00E7\00E3o neste modelo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250375250310741)
,p_name=>'LANGUAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Idiomas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708122708311098)
,p_name=>'LAST_CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Altera\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615670472311029)
,p_name=>'LAST_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Entrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711054064311107)
,p_name=>'LAST_LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo log-in')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227733046310720)
,p_name=>'LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264723236310757)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s Corpo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604018222311020)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s cabe\00E7alho de p\00E1gina de erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603785886311020)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670028737311069)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018624020311362)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item Posterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953211613311308)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Label')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953656673311309)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Label e Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355086629310828)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594590305311014)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Processamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603598166311020)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603886260311020)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s a Submiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264601473310757)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594218927311013)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604173685311020)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do rodap\00E9 da p\00E1gina de erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603672049311020)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594178347311013)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018586435311362)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953136549311308)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953542760311309)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Label e Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594437227311014)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Processamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603496475311020)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes das Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594301183311013)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes da Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663757664311064)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ramifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345790295310821)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'pt-br'
,p_message_text=>'Caixa Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345811715310821)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'pt-br'
,p_message_text=>'Caixa Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345926872310821)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346092525310821)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00E3o de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346129648310821)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechamento de Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346295223310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3pia de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346326200310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria\00E7\00E3o de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346400710310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exclus\00E3o de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346573049310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Edi\00E7\00E3o de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346655180310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Expans\00E3o de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346798480310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346884423310822)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106346976652310822)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586951873311008)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Alterar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657653868311060)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806433401311189)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586166141311007)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Fechar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586626039311008)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586344285311008)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Criar2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218415222310712)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o Personalizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806173353311189)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'pt-br'
,p_message_text=>'Falso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806254490311189)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'pt-br'
,p_message_text=>'Verdadeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586587863311008)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Excluir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023058754311366)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label Vazio - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430678699311673)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586205814311007)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Expandir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528277335310964)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o Que Retorna Consulta HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806566598311189)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Global: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586445512311008)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Ajuda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018756865311362)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link de Ajuda do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023104418311366)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528112624310964)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'pt-br'
,p_message_text=>'Caracteres Especiais de Escape do Texto em HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380115756311636)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto da Ajuda em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388729758311643)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-Texto do Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388677633311642)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00E9-Texto do Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586768171311008)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663623964311064)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma regi\00E3o no ponto de exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806650661311189)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens e Bot\00F5es de P\00E1gina sem Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696351525311089)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'pt-br'
,p_message_text=>'Ajax Callbacks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953443511311309)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Caso de Erro Ap\00F3s Label')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953334025311308)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Em Caso de Erro Antes do Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596684407311015)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Nova Inst\00E2ncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106596746546311015)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Na Submiss\00E3o e Antes do C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586873147311008)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806871360311189)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195889973310691)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806918400311189)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo (#0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106807069736311189)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806341355311189)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809240985311191)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'Executar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528371649310964)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico Simples')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528657186310964)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta Estruturada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809152777311191)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter como "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680656134311077)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sub-regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528555332310964)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico SVG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313344831310797)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos da Folha de Estilo em Cascata usados por &PRODUCT_NAME.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313732858310798)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os arquivos e c\00F3digo JavaScript usados por &PRODUCT_NAME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432709026311674)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos da Folha de Estilo em Cascata definidos no n\00EDvel da interface do usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313960295310798)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos JavaScript definidos no n\00EDvel da interface do usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759425956311146)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos da Caixa de Di\00E1logo, para definir atributos de caixa de di\00E1logo n\00E3o declarativamente suportados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381822949311638)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS da Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759086633311146)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altura da Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759272881311146)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00E1xima da Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759100977311146)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura da Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453591063311689)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label para Expandir / Recolher Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453655507311689)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'pt-br'
,p_message_text=>'Label para Expandir / Recolher Coluna Lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423003748311667)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo HTML dos Favicons')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313620568310798)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>'Folhas em Estilo em Cascata criadas pelos componentes dinamicamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314035718310798)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo JavaScript criado pelos componentes dinamicamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759311839311146)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modo da P\00E1gina de Caixa de Di\00E1logo (por exemplo ''verdadeiro'' quando modal, ''falso'' quando n\00E3o modal)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313508089310798)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos da Folha de Estilo em Cascata e estilo em linha definido em n\00EDvel de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307233917310791)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962671498311316)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os arquivos e c\00F3digo JavaScript definidos em n\00EDvel de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225430085310718)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID Est\00E1tico da P\00E1gina (por exemplo ''P100'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221845680310715)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Transi\00E7\00E3o usada para navegar para uma nova p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758959187311145)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221946489310715)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Transi\00E7\00E3o usada para abrir um popup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762143692311148)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URL da P\00E1gina que foi solicitada pelo browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432983481311674)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o (Lateral)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313400082310798)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos da Folha de Estilo em Cascata e estilo em linha usados no modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313880413310798)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os arquivos e c\00F3digo JavaScript definidos no modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314115634310798)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos da Folha de Estilo em Cascata definidos no n\00EDvel do tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441783449311680)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos JavaScript definidos em n\00EDvel do tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441856973311681)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos da Folha de Estilo em Cascata definidos no n\00EDvel do estilo do tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432837290311674)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o (Topo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759551843311146)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'pt-br'
,p_message_text=>'Elemento de Acionamento (por exemplo, o elemento DOM atual)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372566471310841)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('a\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962761032311316)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Elementos Afetados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369528424310839)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Guias do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365512103310836)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'inativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369120824310838)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Corpo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364978951310835)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365621570310836)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368262856310838)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367307890310837)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369605556310839)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagens do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364767621310835)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367935965310837)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367194604310837)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367262421310837)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367880568310837)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366974541310837)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367085867310837)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367666682310837)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechamento do Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367517994310837)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368746212310838)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367794197310837)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365768766310836)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'criar item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368578265310838)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368037744310838)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368636901310838)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369441733310839)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368155208310838)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364691842310835)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'criar processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364553177310835)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106367451347310837)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369232674310838)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366885545310837)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369385617310838)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368903206310838)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368861036310838)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369057074310838)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364874703310835)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364426820310835)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('advert\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809855943311192)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430137087311672)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'pt-br'
,p_message_text=>'Label de Breadcrumb (caracteres HTML de escape)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020406181311364)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Quando Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370058246310839)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257373324310748)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362845338310834)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811290825311193)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o de Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347350020310822)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para P\00E1gina de Retorno da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347469272310822)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para URL de Retorno da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347058355310822)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aceita\00E7\00E3o de Ramifica\00E7\00E3o para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347191691310822)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramificar para P\00E1gina Identificada Por Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373004572310841)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir Para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347590325310822)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>'Ramificar Para Procedimento PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347210859310822)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Ramificar para URL Identificado Por Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809931490311192)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361553237310833)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372921163310841)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810617123311192)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o do Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988802303311336)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar Valida\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366427765310836)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es sem regi\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811067574311193)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810987460311193)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429974352311672)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'pt-br'
,p_message_text=>'Classes de Componentes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361700902310833)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373663555310841)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361838395310833)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina 0 n\00E3o suporta c\00E1lculos. Os c\00E1lculos que devem ocorrer em cada p\00E1gina devem ser tratados por c\00E1lculos no n\00EDvel do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810325476311192)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372661144310841)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809697645311191)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809747495311192)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809540983311191)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359844897310832)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359623906310831)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428062526311671)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto derivado da mensagem de texto interna do <em>APEX.CURRENT_PROGRESS</em> (padr\00E3o definido em <em>Andamento Atual</em>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370594433310839)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372882367310841)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810764814311192)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361338135310833)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'pt-br'
,p_message_text=>'Display&nbsp;Point:&nbsp;'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358912765311621)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359751564310832)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257272805310748)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar p\00E1gina no Builder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344930446310821)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Atributos de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345547685310821)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372757505310841)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'pt-br'
,p_message_text=>'exp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364377018310835)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Ramifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364092225310835)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem c\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363898128310835)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma p\00E1gina selecionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364138308310835)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sem processos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363966831310835)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106364298112310835)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem valida\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370190501310839)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371462958310840)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechamento do Form HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370913351310840)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir Form HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370490885310839)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362327619310833)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina global n\00E3o suporta ramifica\00E7\00F5es, c\00E1lculos, processos ou valida\00E7\00F5es. Os c\00E1lculos e os processos que devem ocorrer em cada p\00E1gina devem ser tratados por c\00E1lculos e processos no n\00EDvel do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022816711311366)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741730203311132)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Extens\00E3o da Coluna de Grade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369993380310839)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345333442310821)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345217755310821)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Linha+Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360509608310832)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361678884310833)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693707389311087)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366766830310837)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A contagem de itens excede o m\00E1ximo de 200.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810849177311192)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231080058310723)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'pt-br'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414376241311661)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Id da Lista Exclusiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345615280310821)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389631990310853)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Listas de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230993745310723)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumbs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022944499311366)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373273390310841)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega para a p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363530786310834)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Navigation&nbsp;Bar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688702764311084)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347904606310823)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'pt-br'
,p_message_text=>'nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741482678311132)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciar Nova Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741673163311132)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciar Nova Coluna de Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741544210311132)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciar Nova Linha de Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369818254310839)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347648581310823)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'pt-br'
,p_message_text=>'nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345411364310821)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371019012310840)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mensagem de Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362936178310834)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem ramifica\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366573018310836)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem bot\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366650857310837)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem itens.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231226662310724)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma lista \00E9 usada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389762076310853)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o s\00E3o usadas listas de valores compartilhadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231385373310724)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram usados breadcrumbs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363655619310834)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo "%0" n\00E3o tem Barra de Navega\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362065609310833)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem c\00E1lculos de carga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362292431310833)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem processos de carga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362478796310833)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem c\00E1lculos para submiss\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362721913310834)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem processos para submiss\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359485904310831)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma p\00E1gina selecionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363136616310834)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 guias no n\00EDvel pai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361471899310833)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem regi\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363408375310834)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina %0 n\00E3o tem conjunto de guias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389802009310853)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o s\00E3o usados modelos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362674778310834)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina "%0" n\00E3o tem valida\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106345071885310821)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359502865310831)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360304444310832)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360924366310832)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360719760310832)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371258330310840)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371359872310840)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Corpo da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360864740310832)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370853008310840)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360192350310832)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360098756310832)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina n\00E3o encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370632287310839)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Carga de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361067285310832)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361153138310833)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360650273310832)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360430471310832)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106360233475310832)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370747649310839)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363022663310834)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362138119310833)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Processos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373579234310841)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'pt-br'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361984120310833)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina 0 n\00E3o suporta processos. Os processos que devem ocorrer em cada p\00E1gina devem ser tratados por processos no n\00EDvel do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811124163311193)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373195189310841)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir Para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370341085310839)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>'Referenciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430038794311672)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Referenciado de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106361234534310833)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373951889310842)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682223708311078)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221452536310715)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681086656311078)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Id da Regi\00E3o Exclusiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740323971311131)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371565020310840)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675902316311074)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676094900311074)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676114293311074)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676207341311074)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676375589311074)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676435635311074)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676558296311074)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371699874310840)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371717749310840)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371845993310840)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371975121310840)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372018109310840)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372140750310840)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372275479310841)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Regi\00E3o8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106675863877311074)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681152572311078)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Id da Regi\00E3o Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022709065311365)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347825169310823)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('condi\00E7\00E3o padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363289365310834)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o&nbsp;Guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106370292600310839)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substitui\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681876641311078)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sub-regi\00F5es - Modelo de Entrada de Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681947530311078)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sub-regi\00F5es - Modelo de Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681773462311078)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sub-regi\00F5es - Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681589746311078)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sub-regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681632394311078)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alhos da Sub-regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681441373311078)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de Cabe\00E7alho da Sub-regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681287904311078)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Id Est\00E1tico da Sub-regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106681385450311078)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da Sub-regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106371109710310840)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230701910310723)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363349105310834)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368379573310838)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388998117310853)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365473422310836)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365989073310836)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365119374310835)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366100025310836)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'criar item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365293164310836)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>'criar processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365051536310835)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365391463310836)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('criar valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366073376310836)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('editar bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366202393310836)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('editar item de bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106366329332310836)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'editar item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106365851689310836)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('t\00EDtulo de regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810500659311192)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando Condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810445035311192)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Quando Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106347717762310823)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'pt-br'
,p_message_text=>'Incondicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106362553281310834)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373461465310841)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988722739311336)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810110174311192)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de Valida\00E7\00E3o 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810281356311192)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de Valida\00E7\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106810026753311192)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359933005310832)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809443983311191)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando o Bot\00E3o For Pressionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106369797308310839)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528442797310964)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulte SQL Atualiz\00E1vel')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490423614310932)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106806723212311189)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487481804310930)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'pt-br'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530160440310965)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'pt-br'
,p_message_text=>'Executar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734644028311126)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Edi\00E7\00E3o do Nome do Usu\00E1rio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247047735310738)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'pt-br'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106265490422310758)
,p_name=>'LEARN MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Saiba Mais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383392061310848)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'pt-br'
,p_message_text=>'Saiba mais sobre Oracle APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383142537310848)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'Saiba mais sobre App Builder'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106391914710310855)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Saiba mais sobre o Designer de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383245078310848)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'pt-br'
,p_message_text=>'Saiba mais sobre Aplicativos de Produtividade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383032041310848)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'Saiba mais sobre SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988149339311335)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'pt-br'
,p_message_text=>'Clique aqui para saber mais sobre Websheets'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797257754311177)
,p_name=>'LEFT'
,p_message_language=>'pt-br'
,p_message_text=>'Esquerda'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441659510311680)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio Legado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272197128310763)
,p_name=>'LINES'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037467086311377)
,p_name=>'LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307979225310792)
,p_name=>'LINK$'
,p_message_language=>'pt-br'
,p_message_text=>'link de coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709117058311099)
,p_name=>'LINKS'
,p_message_language=>'pt-br'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435139181311676)
,p_name=>'LINK_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Link: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814701842311196)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'pt-br'
,p_message_text=>'Link para este %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106628830962311039)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('links a esse item de p\00E1gina %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434939689310886)
,p_name=>'LIST'
,p_message_language=>'pt-br'
,p_message_text=>'listar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733690695311125)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Item de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730173288311122)
,p_name=>'LIST OF VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303478138310788)
,p_name=>'LISTVIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767426385311152)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O Form e a View em Lista foram criados com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773819357311158)
,p_name=>'LIST_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada da Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473558942311703)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label de Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761971827311148)
,p_name=>'LIST_INITCAP'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878352612311245)
,p_name=>'LIST_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678855396311076)
,p_name=>'LIST_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742214180311132)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454665788310901)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490118101310932)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Utiliza\00E7\00E3o da Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767782258311153)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos da P\00E1gina da View em Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768096507311153)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da P\00E1gina da View em Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767663273311152)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina View em Lista')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420654357311666)
,p_name=>'LOAD_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar Dados'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817152694311198)
,p_name=>'LOCK'
,p_message_language=>'pt-br'
,p_message_text=>'Bloquear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905142148311266)
,p_name=>'LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602959063311020)
,p_name=>'LOCKED BY'
,p_message_language=>'pt-br'
,p_message_text=>'Bloqueado por: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423424894311668)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Bloqueado por %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423688314311668)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'Bloquear Script'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106615350625311029)
,p_name=>'LOG'
,p_message_language=>'pt-br'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743185619311133)
,p_name=>'LOGGING'
,p_message_language=>'pt-br'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811589700311193)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lembrar nome do usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811652234311193)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se voc\00EA marcar esta caixa de sele\00E7\00E3o, o aplicativo salvar\00E1 seu nome de usu\00E1rio em um cookie de browser persistente chamado "LOGIN_USERNAME_COOKIE".'),
unistr('Quando voc\00EA for at\00E9 a p\00E1gina de log-in na pr\00F3xima vez, '),
unistr('o campo de nome do usu\00E1rio ser\00E1 preenchido automaticamente com esse valor.'),
'</p>',
'<p>',
unistr('Se voc\00EA desmarcar esta caixa de sele\00E7\00E3o e o seu nome de usu\00E1rio j\00E1 estiver salvo no cookie,'),
unistr('o aplicativo o substituir\00E1 por um valor vazio.'),
unistr('Voc\00EA tamb\00E9m pode usar as ferramentas de desenvolvedor do seu browser para remover completamente o cookie.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742915942311133)
,p_name=>'LOGIN_URL'
,p_message_language=>'pt-br'
,p_message_text=>'URL de Log-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742893221311133)
,p_name=>'LOGO'
,p_message_language=>'pt-br'
,p_message_text=>'Logotipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229271531311524)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Imagem Definida.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229385753311524)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Logotipo do Aplicativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227732494311523)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Logotipo do Aplicativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228202889311523)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>'Este arquivo excede o limite permitido de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228772315311523)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A marca\00E7\00E3o de logotipo personalizado pode ser definida no Application Builder.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228627937311523)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'pt-br'
,p_message_text=>'Arraste e solte arquivos ou clique para selecionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228581593311523)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228840510311524)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum logotipo ser\00E1 mostrado para este Aplicativo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228451017311523)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228333508311523)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229084013311524)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1ria uma imagem de logotipo para este tipo de logotipo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229195929311524)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Logotipo Salvo com Sucesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228972789311524)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio um texto de logotipo para este tipo de logotipo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228183793311523)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente imagens s\00E3o permitidas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409564139311658)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Obrigado pelo seu feedback. Um bug foi criado para esse problema. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411044413311659)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigado por seu feedback. Essa solicita\00E7\00E3o ser\00E1 considerada para uma release futura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034300055311374)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Obrigado por seu feedback; Um problema foi registrado no nosso sistema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411292919311659)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Obrigado por seu feedback. Uma tarefa foi criada para resolver esse problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439045235311679)
,p_name=>'LOG_IN'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Log-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616259071311030)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo de Log'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730016618311122)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o do Item da Lista de Valores')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687990828311083)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'pt-br'
,p_message_text=>'Baixa prioridade'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231183519310724)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar Grupos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879815997311246)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar Servi\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879630947311246)
,p_name=>'MANAGE USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879063764311246)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823554995311203)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445193985310894)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerenciar N\00E3o Designados')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262644610310753)
,p_name=>'MANUAL'
,p_message_language=>'pt-br'
,p_message_text=>'Manual'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201017956310696)
,p_name=>'MAP_LAYER='
,p_message_language=>'pt-br'
,p_message_text=>'Camada='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202417615310697)
,p_name=>'MAP_LAYERS'
,p_message_language=>'pt-br'
,p_message_text=>'Mapear Camadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348361640310823)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O mapa foi criado com sucesso.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687126873311082)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recurso indispens\00E1vel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761044454311147)
,p_name=>'MASTER'
,p_message_language=>'pt-br'
,p_message_text=>'Mestre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746387313311135)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As p\00E1ginas detalhe mestre foram criadas com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199711877310695)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhe Mestre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199951948310695)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Detalhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199873934310695)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812899990311194)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View Materializada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708586658311099)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tempo M\00E1ximo de Renderiza\00E7\00E3o (Segundos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799710032311179)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tempo M\00E1ximo de Inatividade da Sess\00E3o em Segundos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799891664311179)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o M\00E1xima da Sess\00E3o em Segundos')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382897682310848)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A exclus\00E3o de marcos com recursos associados n\00E3o \00E9 permitida.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275058889310766)
,p_name=>'MEMORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mem\00F3ria:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433321602310885)
,p_name=>'MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733724598311125)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Item do Breadcrumb')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742513329311132)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Breadcrumb'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975687763311326)
,p_name=>'MIGRATION FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos de Migra\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729632698311121)
,p_name=>'MILESTONE'
,p_message_language=>'pt-br'
,p_message_text=>'Marco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709649848311099)
,p_name=>'MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'Marcos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165998055311476)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'pt-br'
,p_message_text=>'ms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712305796311108)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Coluna MIME'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685622232311081)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impacto M\00EDnimo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250154150310741)
,p_name=>'MIN_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vers\00E3o M\00EDnima')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410183145311658)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sinal de @ n\00E3o encontrado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633110475311042)
,p_name=>'MODEL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687329942311082)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Moderadamente desej\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685546855311081)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>'Impacto Moderado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372353809310841)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Indica atributo modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813127789311194)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Modificar Coluna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106612827512311027)
,p_name=>'MONITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Monitorar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879756269311246)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Monitorar Atividade'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738972201311130)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'pt-br'
,p_message_text=>'Mais...'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708091707311098)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Aplicativos Mais Ativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703048180311094)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro mais recente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003678744311350)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo mais recente \00E9 %0 submetido a upload por %1 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471426130310914)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'pt-br'
,p_message_text=>'Erro em MRU: linha= %0, %1, %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470324182310913)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna de chave prim\00E1ria identificada n\00E3o foi localizada na lista de sele\00E7\00E3o da consulta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471542470310914)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vers\00E3o atual dos dados no banco de dados foi alterada desde que o usu\00E1rio iniciou o processo de atualiza\00E7\00E3o. checksum atual = "%0", checksum de item = "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469883642310912)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 linhas a processar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387733211310852)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Certifique-se de que o tipo de arquivo do arquivo do layout de relat\00F3rios seja XSL-FO, usando ''.xsl'' como a extens\00E3o do arquivo.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296605482310783)
,p_name=>'MY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Minha P\00E1gina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409039071311657)
,p_name=>'NAMES'
,p_message_language=>'pt-br'
,p_message_text=>'Nomes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817064373311197)
,p_name=>'NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729809302311122)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Item da Barra de Navega\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412661735311660)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir para o In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727779618311120)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742755733311133)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230842885310723)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Navega\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222222646310715)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navegar at\00E9 a home page do Application Builder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448881056311685)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Implementa\00E7\00E3o: Lista %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448771134311685)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Implementa\00E7\00E3o: Cl\00E1ssica')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698053700311091)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Revis\00E3o necess\00E1ria')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691181468311085)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es necess\00E1rias')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709206940311099)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entradas de Not\00EDcias')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442509396311681)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo Valor da Vari\00E1vel de Bind %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452196326310899)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu novo endere\00E7o de e-mail da conta do Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686625211311082)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova solicita\00E7\00E3o de recurso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618836921311031)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'pt-br'
,p_message_text=>'Novo ou Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794925023311175)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702362903311094)
,p_name=>'NEW_SERVICE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo Servi\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433258704310885)
,p_name=>'NEW_TABSET'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Conjunto de Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427818714311671)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'pt-br'
,p_message_text=>'- Nenhum pai selecionado - '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739245950311130)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Solicita\00E7\00E3o de Espa\00E7o de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747479078311136)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 regi\00E3o correspondente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680733067311077)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A tabela n\00E3o tem chaves prim\00E1rias definidas. Uma chave prim\00E1ria \00E9 obrigat\00F3ria durante a cria\00E7\00E3o de relat\00F3rios com forms ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276884919310767)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivamento de Log: Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671965208311071)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada N\00E3o Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727520395311119)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia N\00E3o Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732030778311124)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum especificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419607816310875)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagem N\00E3o Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796616495311177)
,p_name=>'NON_PACKAGE'
,p_message_language=>'pt-br'
,p_message_text=>'-Aplicativo Diferente de Produtividade e Amostra-'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687811106311083)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'pt-br'
,p_message_text=>'Prioridade normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409697343311658)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435071853311676)
,p_name=>'NOTE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Observa\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590891668311011)
,p_name=>'NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684523818311080)
,p_name=>'NOT_A_BUG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 um bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441579810311680)
,p_name=>'NOT_CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687502243311083)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o desej\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737181859311128)
,p_name=>'NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292434303310779)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL N\00C3O EXISTE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106684628008311080)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel corrigir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816862673311197)
,p_name=>'NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448256526311685)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('80% ou menos conclu\00EDdos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749910170311138)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Instalado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433104733310885)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Est\00E1 no Dicion\00E1rio de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688213901311083)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o priorizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686066998311082)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o priorizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732235335311124)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o fornecido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007922395311354)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00C9 Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690902837311085)
,p_name=>'NOT_STARTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o iniciado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769454914311154)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<strong>%0</strong> n\00E3o \00E9 um nome de view v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249673828310741)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram encontrados aplicativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106753144939311141)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum aplicativo selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527795075310964)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Argumento Permitido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683633888311080)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma prioridade designada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295425193310782)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('sem esquema de autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732478882311124)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o h\00E1 processos da fila de jobs de banco de dados dispon\00EDveis. Entre em contato com o<br> administrador para que o par\00E2metro de inicializa\00E7\00E3o JOB_QUEUE_PROCESSES <br>'),
unistr('seja aumentado ou espere que outros jobs sejam conclu\00EDdos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606358128311022)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de breadcrumb no tema. \00C9 necess\00E1rio ao menos um modelo de breadcrumb.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606419542311022)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de bot\00E3o no tema. \00C9 necess\00E1rio ao menos um modelo de bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605979976311022)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de calend\00E1rio no tema. \00C9 necess\00E1rio ao menos um modelo de calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381952224310848)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma data especificada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631799768311041)
,p_name=>'NO_DEBUG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Depura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243858414310735)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Privil\00E9gio de Desenvolvedor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305204745310790)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Nenhuma Exibi\00E7\00E3o -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260367157310751)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum recurso de destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603975860311020)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 ajuda dispon\00EDvel para este item de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468986151311700)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum \00EDcone encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354139314310827)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagens n\00E3o encontradas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591167248311011)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 imagem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435584848310887)
,p_name=>'NO_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'sem item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797183685311177)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Os processos da fila de jobs do banco de dados n\00E3o est\00E3o ativados. Entre em contato com o<br>'),
unistr('administrador para definir o par\00E2metro de inicializa\00E7\00E3o JOB_QUEUE_PROCESSES.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606066758311022)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de label no tema. \00C9 necess\00E1rio ao menos um modelo de label.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337752509310815)
,p_name=>'NO_LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum Layout de Relat\00F3rio selecionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606231204311022)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de lista no tema. \00C9 necess\00E1rio ao menos um modelo de lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686865495311082)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 mais um problema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295246875310781)
,p_name=>'NO_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'sem Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730782305311122)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum marco definido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957407260311312)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o mostrar lista do menu de navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337605578310815)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O desenvolvedor n\00E3o possui privil\00E9gio para criar um componente nesta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606626402311022)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A tentativa de copiar o tema n\00E3o encontrou modelos de p\00E1gina no aplicativo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605722310311022)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de p\00E1gina no tema. \00C9 necess\00E1rio ao menos um modelo de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529358491310965)
,p_name=>'NO_PARENT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma entrada de breadcrumb pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977880932311327)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma guia m\00E3e foi definida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738809079311129)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma solicita\00E7\00E3o pendente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606581205311022)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de lista de valores popup no tema. \00C9 necess\00E1rio ao menos um modelo de lista de valores popup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688116587311083)
,p_name=>'NO_PRIORITY'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma prioridade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775173705311159)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta posi\00E7\00E3o de regi\00E3o n\00E3o consta no seu modelo de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106605859393311022)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de regi\00E3o no tema. \00C9 necess\00E1rio ao menos um modelo de regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606184597311022)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o encontrados modelos de relat\00F3rio no tema. \00C9 necess\00E1rio ao menos um modelo de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295357415310782)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>'sem atalho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690832465311085)
,p_name=>'NO_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 status')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739469872311130)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma mensagem do sistema definida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033772831311374)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma guia foi definida para este aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106978090570311328)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Guia Encontrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975222273311325)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma guia foi definida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106977916396311327)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Guia Selecionada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107409474685311658)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram encontradas tags')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435448651310887)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106527838433310964)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Acesso URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019760057311363)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes de usar as tags SQL \00E9 necess\00E1rio definir uma lista de tabelas permitidas, por motivos de seguran\00E7a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685371964311081)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma Solu\00E7\00E3o Alternativa Dispon\00EDvel')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431694110310884)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'pt-br'
,p_message_text=>'(nulo)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816270164311197)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769272077311154)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260290539310750)
,p_name=>'NUM_TOTAL'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667719646311067)
,p_name=>'OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963196246311316)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos sem Padr\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963065013311316)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos com Padr\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434662967311675)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Objeto: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756041209311143)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'em cascata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697328017311090)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A constraint de verifica\00E7\00E3o deve ser especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251444994310742)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Erros.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757164325311144)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Constraint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757252962311144)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna(s)/Verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697192643311090)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'pt-br'
,p_message_text=>'O Nome da Constraint deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697599405311090)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome de constraint j\00E1 \00E9 usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755752882311143)
,p_name=>'OB_FK_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Chave Estrangeira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696746604311090)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o Nome da Chave Estrangeira.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697468117311090)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da Chave Estrangeira j\00E1 foi usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755858984311143)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela Referenciada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755978936311143)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas Referenciadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697086918311090)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As colunas de refer\00EAncia de Chave Estrangeira devem ser selecionadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696990545311090)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Pelo menos uma tabela de Chaves Estrangeiras deve ser selecionada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696852402311090)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione Colunas de Chaves Estrangeiras.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817528086311198)
,p_name=>'OB_POSITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757355796311144)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Tipo de Dados -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756130732311143)
,p_name=>'OB_SET_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'definir nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697262199311090)
,p_name=>'OB_UK_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Devem ser especificadas colunas para a chave \00DAnica.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166179622311476)
,p_name=>'ODG.API.START'
,p_message_language=>'pt-br'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166062243311476)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Exce\00E7\00E3o N\00E3o Tratada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166247755311476)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('data_source incorporada n\00E3o tratada: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167051717311477)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Blueprint n\00E3o encontrado ou n\00E3o criado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218654089310712)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'pt-br'
,p_message_text=>'O Nome da Origem de Dados deve ter 26 caracteres ou menos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218591043310712)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao importar: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166966595311477)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar a instru\00E7\00E3o SQL INSERT-SELECT')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166407906311477)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'%0 obtendo dados JSON. URL:%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107167101103311477)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'Script INSERT INTO:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218826494310712)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem de dados incorporada inv\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166852917311477)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro: Os dados JSON s\00E3o nulos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166573603311477)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 um objeto v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166635311311477)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Erro. Nenhuma linha solicitada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166329727311476)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Muitas linhas solicitadas, o m\00E1ximo de linhas permitidas \00E9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107166702859311477)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro Inesperado ao carregar %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106218747963310712)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'pt-br'
,p_message_text=>'%0 deve ser S ou N'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296584653310783)
,p_name=>'ONE'
,p_message_language=>'pt-br'
,p_message_text=>'Um'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249161993310740)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Instalado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486192099310929)
,p_name=>'ON_LOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Ao Carregar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106686980572311082)
,p_name=>'OPEN'
,p_message_language=>'pt-br'
,p_message_text=>'Aberto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732508109311124)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Abertos nos 7 \00DAltimos Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731649681311123)
,p_name=>'OPEN_BUGS'
,p_message_language=>'pt-br'
,p_message_text=>'Bugs Abertos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731336107311123)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos Abertos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965125956311318)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Aberto, processando feedback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731518638311123)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefas Abertas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338708477310816)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir Websheet %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672710086311071)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Atributo Opcional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452995453311688)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS de \00CDcones Opcionais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672676969311071)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem Opcional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672884809311071)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos Opcionais da Imagem'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975737796311326)
,p_name=>'ORACLE FORMS'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380588375311637)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A impress\00E3o baseada no Oracle REST Data Services foi descontinuada no Oracle APEX 19.1 e n\00E3o h\00E1 mais suporte para ela.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230619723310723)
,p_name=>'OTHER'
,p_message_language=>'pt-br'
,p_message_text=>'Outro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976388971311326)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Outros Arquivos do Espa\00E7o de Trabalho')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725236350311118)
,p_name=>'OTN'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725393626311118)
,p_name=>'OTN_FORUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('F\00F3rum de Discuss\00E3o da Oracle Technology Network')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855343974311227)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de Substitui\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431415098311673)
,p_name=>'OVERVIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vis\00E3o Geral')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412978099310870)
,p_name=>'OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259951827310750)
,p_name=>'OWNERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rios')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106636970761311045)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Consulta SQL. Corpo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774541365311158)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387340368310851)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel excluir esta LOV. Ela \00E9 usada na(s) p\00E1gina(s) %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737245649311128)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Bind (informe o nome do item)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386028325311641)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Talvez seja necess\00E1rio atualizar.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388838026311643)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Servidor de Implanta\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663401876311064)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar Links do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659460983311061)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de cria\00E7\00E3o de link de banco de dados foi malsucedida pelo seguinte motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659552209311061)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'O link de banco de dados "%0" foi criado no esquema "%1".'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432490014310884)
,p_name=>'PACKAGE'
,p_message_language=>'pt-br'
,p_message_text=>'pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607042617311023)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Produtividade ou Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269799965310761)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos de Produtividade e Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818823257311199)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a instala\00E7\00E3o do Aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650121716311054)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796590820311176)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'pt-br'
,p_message_text=>'-Global-'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414487835310871)
,p_name=>'PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734840402311126)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de C\00E1lculo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815101897311196)
,p_name=>'PAGE HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727303155311119)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho, Corpo e Rodap\00E9 da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735160473311126)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o do Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735399007311127)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Exibi\00E7\00E3o do Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735519021311127)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de Valores do Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735202157311126)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-C\00E1lculo do Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735407942311127)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Exibi\00E7\00E3o Somente para Leitura do Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735027821311126)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem do Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650540201311054)
,p_name=>'PAGE ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728189687311120)
,p_name=>'PAGE PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728274695311120)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o do Processo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734917488311126)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Valida\00E7\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664469539311065)
,p_name=>'PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878550550311245)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709061022311099)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eventos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745279555311135)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Eventos de p\00E1gina: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461432952311694)
,p_name=>'PAGE_FINDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localizador de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223895297310717)
,p_name=>'PAGE_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744799610311134)
,p_name=>'PAGE_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica a p\00E1gina no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909914616311270)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina %0 bloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910043031311270)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina %0 desbloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755218811311142)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina do aplicativo instalada com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651094255311055)
,p_name=>'PAGE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('item de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861129862311232)
,p_name=>'PAGE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106695979449311089)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Bloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604495854311021)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina bloqueada por %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724976309311117)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('o nome da p\00E1gina \00E9 necess\00E1rio para todas as p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708819707311099)
,p_name=>'PAGE_POSTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Postagens da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878635705311245)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260624192310751)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746087286311135)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prote\00E7\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425925810310879)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426117055310879)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426019235310879)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425720053310879)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425897256310879)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425664331310879)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425596205310879)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425348676310879)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425131052310879)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425413078310879)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425281503310879)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348197424310823)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina %0 foi criada com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727294250311119)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106696011765311089)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Desbloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708996780311099)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106704686316311096)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero do Recurso Pai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814850666311196)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna do relat\00F3rio pai')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976567008311326)
,p_name=>'PARENT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974838660311325)
,p_name=>'PARENT_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419134173310874)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419224203310874)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo Conjunto de Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419391709310874)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto da Guia M\00E3e')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975533763311325)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias M\00E3es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263855154310757)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema de Parsing'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106260749007310751)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Parcial')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244048316310736)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Senha Expirada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231711951310724)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>'A senha desta conta deve ser alterada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243928724310735)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Senha V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251724798310743)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>'Senha (submetida ao pressionar Enter)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768520939311153)
,p_name=>'PAST_DUE'
,p_message_language=>'pt-br'
,p_message_text=>'Reservas Vencidas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858407438311230)
,p_name=>'PATH'
,p_message_language=>'pt-br'
,p_message_text=>'Caminho'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107017982785311362)
,p_name=>'PCT_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'% Fechado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014286986311359)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o gr\00E1fica para porcentagens, n\00FAmeros inteiros entre 0 e 100')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927053469311283)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927187805311283)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263642535311551)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263773704311551)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo de Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929035647311284)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Itens do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929106786311284)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263801736311551)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Processos do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263958338311553)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Processo de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929423453311285)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929557354311285)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929642086311285)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929751217311285)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164270937311475)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164319643311475)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400960091311651)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es de Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401093900311651)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o de Automa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933235675311287)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933363442311288)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929827957311285)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumbs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929994357311285)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264095711311554)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264149146311554)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928454221311284)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928564549311284)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929220461311285)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106929365293311285)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932003281311287)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932159843311287)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928082157311284)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928181406311284)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928632936311284)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Calend\00E1rio Legado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928799085311284)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Calend\00E1rio Legado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244421653311537)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244510080311537)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244679909311537)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244797739311537)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946688175311303)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946783028311303)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934871551311289)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934979509311289)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935086715311289)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935109904311289)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024275863311367)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024327514311367)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231210621311525)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231333866311525)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930816831311286)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es de Carga de Dados Legadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930984354311286)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de Carga de Dados Legada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932493320311287)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932524601311287)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932290990311287)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932309724311287)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488841488310931)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106488921057310931)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164552561311475)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164685621311475)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Faceta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235843075311528)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Grupos de Facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235931714311529)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236089242311529)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixas de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236181124311529)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927849404311284)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927905097311284)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775357035311159)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775415575311159)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775720393311159)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775819042311159)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775599357311159)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Grupos de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775624427311159)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775948505311159)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776033670311159)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242619138311536)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios Salvos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243316735311536)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Salvo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933410178311288)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933517353311288)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934087834311288)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934174094311288)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933834204311288)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Grupos de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933901175311288)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024097250311366)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024135265311366)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933602766311288)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios Salvos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933780163311288)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Salvo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822753401311202)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822837897311202)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822596531311202)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Eixos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822603534311202)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Eixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822944990311202)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823017436311202)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393330507311646)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393463993311646)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930094318311285)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930134662311285)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264208815311554)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264357467311554)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada da Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928203364311284)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928395851311284)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930276694311285)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Listas de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930348719311285)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264429746311554)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas da Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264597662311554)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada da Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170355404311479)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Camadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170444655311480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Camada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170570470311480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170600956311480)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170102291311479)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170271571311479)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931628775311286)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931750756311286)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932872110311287)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932964947311287)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931481261311286)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931555662311286)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630063659311040)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630108451311040)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933004302311287)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Processos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106933126243311287)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934697426311288)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros B\00E1sicos de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934701869311289)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro de Autentica\00E7\00E3o B\00E1sica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934285588311288)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros In')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934328756311288)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro In')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934491353311288)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros Out')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106934517035311288)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro Out')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927452117311283)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927575216311283)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265007393311554)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-ins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265130929311554)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931840699311286)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931972669311287)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223018909311519)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223124669311519)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159798469311471)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159825137311471)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927697177311283)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927717171311283)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870820903311239)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870998402311239)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651401177311055)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Bancos de Dados Remotos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651596639311055)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031253240311372)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031375133311372)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layout do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928864347311284)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de Relat\00F3rios Cl\00E1ssicos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106928971362311284)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Relat\00F3rio Cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597490287311016)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597550090311016)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597619272311016)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Filtrar Grupos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597700770311016)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597888271311016)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixas de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597977213311016)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264666486311554)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atalhos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264708063311554)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atalho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931066369311286)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjuntos de Guias Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931129016311286)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937018789311290)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937118833311290)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937245392311290)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937390877311290)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024423842311367)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024509789311367)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927250916311283)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106927352416311283)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264881003311554)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107264982128311554)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931201259311286)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interfaces do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106931342431311286)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932657532311287)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106932727341311287)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930439597311285)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias de Web Services')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930546504311285)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncia de Web Services')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930680842311286)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00F5es de Web Service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106930759934311286)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00E3o do Web Service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400043055311651)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros B\00E1sicos de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400173072311651)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro de Autentica\00E7\00E3o B\00E1sica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400224592311651)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros do Cabe\00E7alho HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400305499311651)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro do Cabe\00E7alho HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399683900311650)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros In')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399748546311650)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro In')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399813878311651)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros Out')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107399966318311651)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro Out')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764876971311150)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Origens de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764982856311150)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Origem de Dados REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875508464311243)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875616518311243)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870601569311239)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00F5es da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870789798311239)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00E3o da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875729257311243)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros de Opera\00E7\00E3o de Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875857649311243)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro de Opera\00E7\00E3o da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875920662311243)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metros da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876048485311243)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro da Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765050709311150)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta da Origem REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765121186311150)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta da Origem REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886406011311252)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401103986311652)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Execu\00E7\00E3o de C\00F3digo Adicional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547800245310978)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avan\00E7ado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548157738310979)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Elementos Afetados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825131048311204)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Anima\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549109205310979)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546380486310977)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196098772310691)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es de Auditoria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547936280310978)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265326704311554)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943983844311301)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00E3o Autom\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549073562310979)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'pt-br'
,p_message_text=>'Comportamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919082272311277)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245088864311537)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921331332311279)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o de Quebra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954079176311309)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens do Estado do Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244819666311537)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910547354311271)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores em Cascata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945576191311302)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415955739311662)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o do Cliente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401216176311652)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947297079311303)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'pt-br'
,p_message_text=>'Cores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024931618311367)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023372086311366)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881243951311248)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o de Colunas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024884718311367)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alhos de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824423871311204)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Mapeamento de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546469274310977)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547738264310978)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546647374310977)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Configura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458181739310904)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirma\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956692947311311)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'pt-br'
,p_message_text=>'Controles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546723967310978)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'pt-br'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643341669311049)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Personaliza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947061044311303)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio Di\00E1rio e Semanal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265464441311554)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o do Banco de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945699728311302)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'pt-br'
,p_message_text=>'Grade de dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824316911311203)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cursor de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548254962310979)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910450453311270)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Dependendo de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886502573311252)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886643349311252)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View Detalhada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955225112311310)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886702667311252)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947373141311303)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'pt-br'
,p_message_text=>'Arrastar e Soltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825087054311204)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'pt-br'
,p_message_text=>'Eixos Y Duplos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776273394311159)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908532182311269)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548376196310979)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776198807311159)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permitir que os Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954186022311309)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546538334310977)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546830087310978)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'pt-br'
,p_message_text=>'Tratamento de Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547638721310978)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914924635311274)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o/Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921461896311279)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento Externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169328564311479)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945406953311302)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha do Tempo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367185840311627)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'pt-br'
,p_message_text=>'Viewport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945076017311301)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'pt-br'
,p_message_text=>'Medidor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546948871310978)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho e Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921677876311279)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547001840310978)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548419799310979)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547153838310978)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245280253311538)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone e Emblema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886819741311252)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546196909310977)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547295518310978)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548579233310979)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549241388310979)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944577172311301)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'pt-br'
,p_message_text=>'Legenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824509923311204)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901664665311264)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008599044311354)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548663445310979)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947144525311303)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio de View da Agenda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376971762311634)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-Processamento Local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642749832311049)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento de Log-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824731617311204)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Marca\00E7\00F5es Principais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170851802311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDveis de Zoom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170757290311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171307747311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Janela de Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107170913740311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o e Zoom Iniciais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171106217311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clusteriza\00E7\00E3o de Pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171057411311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos de Ponto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171278700311480)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Designa\00E7\00E3o de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944634362311301)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'pt-br'
,p_message_text=>'Margem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824661985311204)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'pt-br'
,p_message_text=>'Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970106609311321)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhe Mestre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245343480311538)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDdia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921564093311279)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824842571311204)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Marca\00E7\00F5es Secund\00E1rias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946809554311303)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio Mensal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349102994310824)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Diversos Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678417210311076)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados do Gr\00E1fico de V\00E1rias S\00E9ries')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265524226311555)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689089887311084)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453014942311689)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032983473311373)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824247930311203)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vis\00E3o Geral')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024778311311367)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025105685311367)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Rodap\00E9 da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025010362311367)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886956804311252)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906963984311268)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776442214311160)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'pt-br'
,p_message_text=>'Desempenho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642883050311049)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL Ap\00F3s Log-out')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939414771311292)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107024680872311367)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265279566311554)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548798738310979)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00F5es R\00E1pidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547317247310978)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Leitura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642944803311049)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seguran\00E7a do Real Application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388145939310852)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas de Refer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908035911311269)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651642298311055)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'pt-br'
,p_message_text=>'Cache Remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867274149311236)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barra de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245161724311538)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo Secund\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547492252310978)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944713542311301)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cor da S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106547588352310978)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'pt-br'
,p_message_text=>'Cache do Servidor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415802169311662)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o do Servidor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265600440311555)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643099041311049)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos de Cookie de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643150942311049)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o N\00E3o V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106546234676310977)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887100096311252)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View de Uma Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887079473311252)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548849702310979)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643219345311049)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244971297311537)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Subt\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902561773311264)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598037861311016)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sugest\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453119824311689)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280820596310770)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'pt-br'
,p_message_text=>'Limites'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106824968208311204)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label de Marca\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159270779311471)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'pt-br'
,p_message_text=>'Escala de Tempo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945353899311302)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776310831311160)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barra de Ferramentas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945258564311302)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'pt-br'
,p_message_text=>'Dica de ferramenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938265984311291)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias Padr\00E3o de IU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548924266310979)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945145360311301)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946976079311303)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio Semanal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106548097482310978)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'pt-br'
,p_message_text=>'Quando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944882238311301)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'pt-br'
,p_message_text=>'Eixo X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944917803311301)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'pt-br'
,p_message_text=>'Eixo Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871093825311240)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'pt-br'
,p_message_text=>'Escala de Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778124666311161)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique um esquema de autoriza\00E7\00E3o para restringir quem pode adicionar linhas.'),
unistr('Para permitir que um usu\00E1rio final adicione linhas, esse esquema de autoriza\00E7\00E3o dever\00E1 ser avaliado como VERDADEIRO para esse usu\00E1rio.'),
unistr('Se nenhum esquema de autoriza\00E7\00E3o for fornecido, nenhum usu\00E1rio poder\00E1 adicionar linhas nessa grade interativa.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778023405311161)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781198818311164)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um label alternativo para o bot\00E3o Adicionar. O label padr\00E3o \00E9 <em>Adicionar Linha</em>.</p>'),
unistr('        <p>Por exemplo, insira <em>Adicionar Funcion\00E1rio</em> para uma grade interativa na qual os funcion\00E1rios s\00E3o mantidos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781023731311164)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label do Bot\00E3o Adicionar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779359901311162)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se uma nova linha ser\00E1 adicionada se a grade interativa atualmente n\00E3o tiver registros retornados.'),
unistr('        A mensagem <em>Dados N\00E3o Encontrados</em> nunca ser\00E1 exibida porque pelo menos um registro sempre ser\00E1 mostrado.</p>'),
unistr('        <p>Observa\00E7\00E3o - Se nenhuma atualiza\00E7\00E3o for feita no registro, ele n\00E3o ser\00E1 inserido quando a regi\00E3o for salva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779231841311162)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha Se Vazia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262826445311550)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a esta faceta. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237876982311532)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este grupo de facetas. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794565945311175)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes a serem adicionadas a este componente. Voc\00EA pode adicionar diversas classes separando-as com espa\00E7os.</p>'),
unistr('        <p>Observa\00E7\00E3o: Essa propriedade pode ser usada para fazer modifica\00E7\00F5es de estilo no item correspondente quando a Grade Interativa \00E9 edit\00E1vel.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239516797311533)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes a serem adicionadas a este componente. Voc\00EA pode adicionar diversas classes separando-as com espa\00E7os.</p>'),
unistr('        <p>Observa\00E7\00E3o: Essas classes CSS ser\00E3o aplicadas \00E0 tag de elemento de form HTML.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601421414311019)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este filtro. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602126990311019)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este grupo de filtros. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238965851311533)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Adicione as classes CSS <code>articlenumber</code> e <code>highlight</code> \00E0 tag HTML do componente</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238816983311533)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe as classes CSS delimitadas por espa\00E7os adicionais a serem inclu\00EDdas no componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238753959311533)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581289219311004)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o bot\00E3o a ser afetado por esta a\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581134935311004)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416803248311663)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe uma ou mais colunas que ser\00E3o afetadas por esta a\00E7\00E3o.'),
unistr('Para v\00E1rias colunas, separe o nome de cada coluna com uma v\00EDrgula.'),
unistr('<p>Voc\00EA pode digitar o nome ou escolher na lista de colunas dispon\00EDveis.'),
unistr('Se voc\00EA selecionar na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome da coluna retornado da lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416718282311663)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581697884311004)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um objeto DOM (<code>documento</code>, <code>janela</code>) ou o <em>id</em> de um objeto DOM (<code>myElementID</code>) como o elemento a ser afetado por esta a\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: o <em>Objeto DOM</em> est\00E1 obsoleto e deve ser substitu\00EDdo pela <em>Express\00E3o JavaScript</em> ou pelo <em>Seletor jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581566591311004)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Objeto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581494719311004)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe um ou mais itens de p\00E1gina que ser\00E3o afetados por esta a\00E7\00E3o.'),
unistr('Para v\00E1rios itens, separe o nome de cada item com uma v\00EDrgula.'),
unistr('<p>Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA selecionar na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome do item retornado da lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581378808311004)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413218100311660)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Retorna uma refer\00EAncia para o <code>objeto DOM</code> da janela do browser.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>Retorna uma refer\00EAncia para o <code>objeto DOM</code> do documento do browser.</dt>'),
'<dd>document</dd>',
'<dt>O seletor jQuery selecione todos os elementos DIV que possuem uma classe de ''alert'' e, em seguida, retorna um objeto jQuery contendo todos os seus pais.</dt>',
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413158208311660)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a Express\00E3o JavaScript a ser avaliada para retornar um \00FAnico objeto DOM, um array de objetos DOM ou um objeto jQuery como o(s) elemento(s) a ser(em) afetado(s) por esta a\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413075825311660)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071655424311405)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Para selecionar um elemento a p\00E1gina com um id DOM <code>my_id</code></dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>Para selecionar todos os elemento da p\00E1gina com uma classe <code>my_class</code></dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>Para selecionar todos os elementos da p\00E1gina que s\00E3o entradas</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581802459311004)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a sintaxe do Seletor jQuery para retornar um ou mais elementos de p\00E1gina que ser\00E3o afetados por esta a\00E7\00E3o. A biblioteca jQuery oferece uma sintaxe de seletor muito avan\00E7ada que fornece uma maneira de acessar facilmente um ou mais elementos')
||unistr(' de uma p\00E1gina.</p>'),
unistr('<p>Consulte a documenta\00E7\00E3o oficial dispon\00EDvel na <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">homepage do jQuery</a> para obter mais informa\00E7\00F5es sobre a sintaxe do seletor.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581777133311004)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581058338311004)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o a ser afetada por esta a\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580993533311004)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580822976311004)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como definir os componentes da p\00E1gina que ser\00E3o afetados quando essa a\00E7\00E3o for executada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070434039311404)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070597388311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta o bot\00E3o selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416183078311662)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416226223311662)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta uma ou mais colunas inseridas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070801418311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Objeto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070975457311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta o elemento de p\00E1gina identificado pelo objeto DOM ou ID DOM especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071406649311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Origem do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071569996311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A a\00E7\00E3o afeta o elemento de p\00E1gina no qual o evento foi originado, que pode ser diferente para o "Elemento de Acionamento" em alguns casos.</p>'),
unistr('<p>Nesta configura\00E7\00E3o avan\00E7ada, o elemento de acionamento \00E9 geralmente um elemento de cont\00EAiner (como uma regi\00E3o), que lida com eventos gerados por todos os seus subelementos (como itens de p\00E1gina na regi\00E3o).'),
unistr('Este tipo de sele\00E7\00E3o pode ser usado para agir de acordo com o subelemento que acionou o evento, em vez do elemento de cont\00EAiner.'),
unistr('Por exemplo, se voc\00EA tiver uma a\00E7\00E3o din\00E2mica que defina um evento <strong>''Alterar''</strong> em uma regi\00E3o de sua p\00E1gina, a a\00E7\00E3o afetar\00E1 o item real na regi\00E3o alterada.</p>'),
unistr('<p>Utilizar <em>''Origem do Evento''</em> pode ser uma maneira mais eficiente de definir comportamentos comuns que afetam muitos elementos da p\00E1gina.'),
unistr('A capacidade dos elementos de cont\00EAiner de capturar eventos gerados por subelementos \00E9 determinada pelo tipo de evento.'),
'Os seguintes tipos de eventos suportam isso:</p>',
'<ul>',
unistr('  <li><strong>Ap\00F3s Atualiza\00E7\00E3o</strong> (apexafterrefresh)</li>'),
unistr('  <li><strong>Antes da Atualiza\00E7\00E3o</strong> (apexbeforerefresh)</li>'),
'  <li><strong>Alterar</strong> (change)</li>',
'  <li><strong>Clicar</strong> (click)</li>',
'  <li><strong>Clique Duplo</strong> (dblclick)</li>',
'  <li><strong>Obter Foco</strong> (focus)</li>',
'  <li><strong>Pressionar</strong> (keydown)</li>',
'  <li><strong>Pressionar Tecla</strong> (keypress)</li>',
'  <li><strong>Liberar Tecla</strong> (keyup)</li>',
'  <li><strong>Perder Foco</strong> (blur)</li>',
unistr('  <li><strong>Pressionar Bot\00E3o do Mouse</strong> (mousedown)</li>'),
unistr('  <li><strong>Liberar Bot\00E3o do Mouse</strong> (mouseup)</li>'),
'  <li><strong>Mover Mouse</strong> (mousemove)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070235204311404)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070341036311404)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta um ou mais itens inseridos da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412887326311660)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412939393311660)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta o(s) elemento(s) da p\00E1gina retornados usando a Express\00E3o JavaScript especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071004476311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071197310311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta o(s) elemento(s) da p\00E1gina retornados usando a sintaxe do seletor jQuery especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070652348311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070778331311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta a regi\00E3o selecionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071228828311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Elemento Acionador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071332655311405)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A a\00E7\00E3o afeta o elemento ou o componente da p\00E1gina que acionou a a\00E7\00E3o din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580768196311003)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693372996311087)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Agrega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693437070311087)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Retorna a coluna de valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343681733311610)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como agregar a coluna de valores do gr\00E1fico associado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345162863311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem Aproximada de Itens Diferentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345232997311612)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna o n\00FAmero aproximado de valores distintos. Esta agrega\00E7\00E3o \00E9 significantemente mais r\00E1pida que <em>Contar Diferentes</em> ao processar grandes valores de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344105403311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344298259311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna a m\00E9dia da coluna de valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343756873311610)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343864140311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna o n\00FAmero de registros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344971746311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Contar Diferentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345088533311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna o n\00FAmero exato de valores distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344726899311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344865918311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna o valor m\00E1ximo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344350622311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Mediano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344445124311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna o n\00FAmero do meio, ignorando os nulos. Esta agrega\00E7\00E3o \00E9 melhor adaptada para um modelo de distribui\00E7\00E3o cont\00EDnua, pois ela retorna o n\00FAmero no centro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344581250311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344693505311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retorna o valor m\00EDnimo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343971472311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Soma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107344045447311611)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Retorna o total da coluna de valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343537962311610)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agrega\00E7\00E3o de Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560186033310987)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione se o usu\00E1rio final tem permiss\00E3o para submeter a mesma p\00E1gina mais de uma vez.'),
unistr('Use este recurso para evitar inser\00E7\00F5es duplicadas na mesma tabela.'),
unistr('Isto pode ocorrer quando um usu\00E1rio final clica no bot\00E3o Voltar do browser e, em seguida, submete a p\00E1gina novamente, ou se o usu\00E1rio final clica no bot\00E3o Recarregar do browser.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061711245311398)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o - Impedir a p\00E1gina de ser publicada novamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061867015311398)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sim - Permitir que a p\00E1gina seja publicada novamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560000693310987)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativar submiss\00F5es de p\00E1ginas duplicadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889924479311254)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se colunas nulas ser\00E3o ocultadas na View de Registro \00DAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889890715311254)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Valores Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890166472311254)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se apenas as colunas exibidas atualmente ser\00E3o mostradas na View de Registro \00DAnico. Se voc\00EA especificar <strong>Desativado</strong>, as colunas ocultas do relat\00F3rio tamb\00E9m poder\00E3o ser mostradas na View de Registro \00DAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890011333311254)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Colunas Exibidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884045707311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem agregar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883930632311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884427681311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem usar esta coluna em um gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884390914311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884228284311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem utilizar esta coluna em uma coluna computacional definida por eles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884188241311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883811423311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem utilizar essa coluna em uma quebra de controle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883734937311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Quebra de Controle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883405121311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem filtrar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883344949311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884639759311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem agrupar por esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884531167311250)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883075941311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem ocultar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882940494311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883634244311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem real\00E7ar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883585153311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196814925310692)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o usu\00E1rio final pode definir um detalhamento de piv\00F4 neste relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196704393310692)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Piv\00F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897995561311261)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios podem salvar suas defini\00E7\00F5es de relat\00F3rio atuais como um relat\00F3rio <em>P\00FAblico</em>.</p>'),
unistr('<p>Os relat\00F3rios p\00FAblicos s\00E3o exibidos em uma lista de sele\00E7\00E3o de relat\00F3rios dispon\00EDveis na Barra de Pesquisa e s\00E3o exibidos para todos.'),
unistr('A op\00E7\00E3o no menu A\00E7\00F5es est\00E1 dispon\00EDvel somente para usu\00E1rios autenticados e \00E9 ainda mais restrita se voc\00EA preencher a op\00E7\00E3o <strong>Salvar Autoriza\00E7\00E3o do Relat\00F3rio P\00FAblico</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897822573311261)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897783855311260)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem salvar suas defini\00E7\00F5es de relat\00F3rio atuais como um relat\00F3rio <em>Privado</em>.</p>'),
unistr('<p>Os relat\00F3rios privados s\00E3o exibidos em uma lista de sele\00E7\00E3o de relat\00F3rios dispon\00EDveis na Barra de Pesquisa e s\00E3o exibidos ao usu\00E1rio final que salvou o relat\00F3rio, contanto que estejam autenticados.'),
unistr('A op\00E7\00E3o no menu A\00E7\00F5es est\00E1 dispon\00EDvel somente para usu\00E1rios autenticados.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897620380311260)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898186967311261)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem salvar categorias de relat\00F3rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898003628311261)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Categorias de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883255317311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem classificar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106883131600311249)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784870404311167)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o label alternativo a ser usado nas caixas de di\00E1logo e na View de Uma Linha.'),
unistr('        Use um label alternativo quando o cabe\00E7alho contiver formata\00E7\00F5es extras, como tags HTML, que n\00E3o s\00E3o exibidas de forma apropriada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784734375311167)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661684313311063)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se esta valida\00E7\00E3o ser\00E1 sempre executada.'),
unistr('Se definido como <strong>Ativado</strong>, essa valida\00E7\00E3o sempre ser\00E1 avaliada, independentemente da defini\00E7\00E3o <em>Executar Valida\00E7\00F5es</em> especificada no bot\00E3o que submeteu a p\00E1gina.'),
unistr('Se definido como <strong>Desativado</strong>, essa valida\00E7\00E3o s\00F3 ser\00E1 avaliada se o bot\00E3o de acionamento tiver uma defini\00E7\00E3o <em>Executar Valida\00E7\00F5es</em> como <strong>Ativado</strong>.</p>'),
unistr('<p>Observa\00E7\00E3o: Esta valida\00E7\00E3o tamb\00E9m deve estar em conformidade com as condi\00E7\00F5es especificadas para poder ser avaliada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661542658311062)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827787391311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione se uma anima\00E7\00E3o ser\00E1 mostrada quando dados forem alterados no gr\00E1fico. Uma altera\00E7\00E3o de dados poder\00E1 ocorrer se o gr\00E1fico for automaticamente atualizado, se um comportamento para ocultar e mostrar for realizado com um clique em um item d')
||unistr('e legenda ou quando dados do gr\00E1fico forem atualizados de forma program\00E1tica por meio de algum c\00F3digo JavaScript personalizado ou de uma A\00E7\00E3o Din\00E2mica.</p>'),
unistr('        <p>As op\00E7\00F5es <strong>Deslizar \00E0 Esquerda</strong> e <strong>Deslizar \00E0 Direita</strong> n\00E3o se aplicam a gr\00E1ficos de Quadrantes</p>.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827823569311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958386959311312)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar ao gr\00E1fico as defini\00E7\00F5es de anima\00E7\00E3o padr\00E3o especificadas pelo Oracle JET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828161688311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967857584311320)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A anima\00E7\00E3o \00E9 aplicada ao gr\00E1fico quando os dados s\00E3o alterados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827975483311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deslizar \00E0 Esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967658038311319)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os elementos de dados se deslocam para a esquerda quando os dados s\00E3o alterados. Esta defini\00E7\00E3o n\00E3o se aplica aos gr\00E1ficos de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828065023311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deslizar \00E0 Direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967789548311319)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os elementos de dados se deslocam para a direita quando os dados s\00E3o alterados. Esta defini\00E7\00E3o n\00E3o se aplica aos gr\00E1ficos de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827671657311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Durante Altera\00E7\00E3o dos Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827141754311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de anima\00E7\00E3o usado durante a exibi\00E7\00E3o inicial do gr\00E1fico.</p>'),
unistr('        <p>As op\00E7\00F5es <strong>Esmaecimento Alfa</strong> e <strong>Zoom</strong> n\00E3o se aplicam a gr\00E1ficos de Quadrantes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827349391311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmaecimento Alfa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958078372311312)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esvanecer o gr\00E1fico gradualmente durante a exibi\00E7\00E3o inicial. Esta defini\00E7\00E3o n\00E3o se aplica aos gr\00E1ficos de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827204243311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957975293311312)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar ao gr\00E1fico as defini\00E7\00F5es de anima\00E7\00E3o padr\00E3o especificadas pelo Oracle JET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827581073311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958203957311312)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma anima\00E7\00E3o ser\00E1 aplicada ao gr\00E1fico durante a exibi\00E7\00E3o inicial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827477015311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958152342311312)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aumentar o zoom do gr\00E1fico durante a exibi\00E7\00E3o inicial. Esta defini\00E7\00E3o n\00E3o se aplica aos gr\00E1ficos de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106827002938311206)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ao Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239612880311534)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262792130311550)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240448100311534)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe as classes CSS delimitadas por espa\00E7os que ser\00E3o adicionadas ao relat\00F3rio. O modelo do relat\00F3rio dever\00E1 incluir a string de substitui\00E7\00E3o <code>#COMPONENT_CSS_CLASSES#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794379035311175)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes a serem adicionadas a este componente. Voc\00EA pode adicionar diversas classes separando-as com espa\00E7os.</p>'),
'',
unistr('        <p>Observa\00E7\00E3o: Essas classes CSS ser\00E3o aplicadas \00E0s c\00E9lulas na Grade Interativa. Para aplicar classes CSS ao item correspondente, consulte a propriedade de Classes CSS no grupo Avan\00E7ado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239330923311533)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239486777311533)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes a serem adicionadas a este item. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.<p/>'),
unistr('        <p>Essa propriedade pode ser usada para fazer modifica\00E7\00F5es de estilo no item, al\00E9m de op\00E7\00F5es de modelo, ou para fornecer uma maneira mais simples de selecionar esse item via JavaScript.</p>'),
unistr('        <p>Observa\00E7\00E3o: para aplicar classes CSS \00E0 tag do elemento de form HTML, veja a propriedade Classes CSS sob o grupo Avan\00E7ado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239701358311534)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240608759311534)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240512083311534)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe as classes CSS delimitadas por espa\00E7os que ser\00E3o adicionadas ao relat\00F3rio. O modelo do relat\00F3rio dever\00E1 incluir a string de substitui\00E7\00E3o <code>#COMPONENT_CSS_CLASSES#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239274473311533)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Adicione as classes CSS <code>articlenumber</code> e <code>highlight</code> ao componentes</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239199264311533)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239024542311533)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198378565310693)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o escopo do item deste aplicativo. Selecione <strong>Global</strong> se a sess\00E3o do &PRODUCT_NAME. for compartilhada por mais de um aplicativo e o valor do item tiver que ser igual para todos os aplicativos.'),
unistr('Caso contr\00E1rio, selecione <strong>Aplicativo</strong>, que \00E9 o escopo padr\00E3o.</p>'),
unistr('<p>Os aplicativos podem compartilhar a mesma sess\00E3o, se suas autentica\00E7\00F5es tiverem os mesmos <em>Atributos de Cookie de Sess\00E3o</em>.'),
unistr('O atributo do escopo, de itens de aplicativos, tamb\00E9m deve ser o mesmo nesses aplicativos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093550025311421)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093677622311421)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198230458310693)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escopo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844307572311219)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a s\00E9rie atual dever\00E1 ser designada ao eixo Y2 renderizado no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844238452311219)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Designado ao Eixo Y2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662213274311063)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna associada a este componente de processamento de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662186433311063)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Associada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662037294311063)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o item no qual essa mensagem de erro de valida\00E7\00E3o ser\00E1 exibida.'),
unistr('Se voc\00EA selecionar um item e o <em>Local de exibi\00E7\00E3o da mensagem de erro</em> incluir "Em Linha com Campo", a mensagem de erro ser\00E1 exibida abaixo do label do item especificado.'),
unistr('Se o <em>Local de exibi\00E7\00E3o da mensagem de erro</em> n\00E3o incluir "Em linha com Campo", esse atributo n\00E3o afetar\00E1 a exibi\00E7\00E3o da mensagem de erro.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661916260311063)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item Associado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265715798311555)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644077748311050)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589652620311010)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um esquema de autoriza\00E7\00E3o aplicado \00E0 p\00E1gina. Esquemas de autoriza\00E7\00E3o s\00E3o definidos em n\00EDvel de aplicativo e podem ser aplicados a v\00E1rios elementos do aplicativo.</p>'),
unistr('<p>Um esquema de autoriza\00E7\00E3o \00E9 avaliado uma vez para cada sess\00E3o do aplicativo (na cria\00E7\00E3o da sess\00E3o) ou uma vez para cada view de p\00E1gina. Se o esquema de autoriza\00E7\00E3o selecionado for avaliado como <strong>VERDADEIRO</strong>, a p\00E1gina ser\00E1 exibida e ')
||unistr('estar\00E1 sujeita a outras condi\00E7\00F5es definidas. Se ele for avaliado como <strong>FALSO</strong>, a p\00E1gina n\00E3o ser\00E1 exibida e aparecer\00E1 uma mensagem de erro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559319791310987)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um esquema de autoriza\00E7\00E3o para controlar este componente. A autoriza\00E7\00E3o deve ser avaliada como VERDADEIRA para que este componente seja renderizado ou executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559206714310987)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550254584310980)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o esquema de autoriza\00E7\00E3o que ser\00E1 aplicado. Os seguintes tipos de autoriza\00E7\00E3o s\00E3o suportados:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Dependendo da configura\00E7\00E3o do seu aplicativo, ser\00E1 poss\00EDvel encontrar plug-ins de tipos de autoriza\00E7\00E3o adicionais dispon\00EDveis aqui.'),
unistr('Estes s\00E3o exibidos como <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('Os seguintes plug-ins s\00E3o instalados nos componentes compartilhados deste aplicativo:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550117011310980)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402145288311652)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402448800311653)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402326105311652)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402211097311652)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402510222311653)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402092376311652)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Linguagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403364189311653)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a origem dos dados avaliados durante a execu\00E7\00E3o da automa\00E7\00E3o. As automa\00E7\00F5es podem se basear em tabelas, consultas SQL ou fun\00E7\00F5es PL/SQL que retornam uma consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403283009311653)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403192405311653)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403004077311653)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a origem dos dados avaliados durante a execu\00E7\00E3o da automa\00E7\00E3o. As automa\00E7\00F5es podem se basear em tabelas, consultas SQL ou fun\00E7\00F5es PL/SQL que retornam uma consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402924294311653)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402831209311653)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402713005311653)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a origem dos dados avaliados durante a execu\00E7\00E3o da automa\00E7\00E3o. As automa\00E7\00F5es podem se basear em tabelas, consultas SQL ou fun\00E7\00F5es PL/SQL que retornam uma consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107402697080311653)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403519072311653)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a origem dos dados avaliados durante a execu\00E7\00E3o da automa\00E7\00E3o. As automa\00E7\00F5es podem se basear em tabelas, consultas SQL ou fun\00E7\00F5es PL/SQL que retornam uma consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403435564311653)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401623401311652)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401528249311652)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401488233311652)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a origem dos dados avaliados durante a execu\00E7\00E3o da automa\00E7\00E3o. As automa\00E7\00F5es podem se basear em tabelas, consultas SQL ou fun\00E7\00F5es PL/SQL que retornam uma consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401375787311652)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401972463311652)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401894936311652)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de a\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107401747188311652)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700627647311093)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione se a interface de usu\00E1rio adequada deve ser detectada automaticamente.'),
unistr('Se a detec\00E7\00E3o autom\00E1tica estiver <strong>Ativada</strong>, o usu\00E1rio ser\00E1 automaticamente redirecionado para a p\00E1gina de log-in mais apropriada ou para a home page, com base no tamanho do dispositivo em uso.'),
unistr('Consultas de M\00EDdia s\00E3o utilizadas para determinar a interface de usu\00E1rio correspondente a ser exibida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700553304311092)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Detec\00E7\00E3o Autom\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846391178311220)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor m\00E1ximo do eixo. Utiliza como padr\00E3o um valor nulo para que haja um c\00E1lculo autom\00E1tico com base nos dados.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846241829311220)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846114749311220)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor m\00EDnimo do eixo. Utiliza como padr\00E3o o valor nulo para que haja um c\00E1lculo autom\00E1tico com base nos dados.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846075901311220)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847189020311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o dos labels a serem renderizados no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847221199311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847667198311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847461436311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847391699311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847586792311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847061073311221)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869567383311238)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a escala do eixo. Aplica-se apenas a eixos num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869653586311238)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869768353311238)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'pt-br'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869422003311238)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846944846311221)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o incremento entre as marca\00E7\00F5es principais. Utiliza como padr\00E3o um valor nulo para que haja um c\00E1lculo autom\00E1tico com base nos dados. S\00F3 se aplica a eixos num\00E9ricos e de tempo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846804573311221)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253815184311544)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione a coluna a ser usada como emblema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253719385311544)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Emblema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254000971311544)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253956491311544)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS de Emblema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254318107311544)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Para exibir classifica\00E7\00F5es de filmes</dt>'),
unistr('    <dd>A Coluna de Emblema pode ser a coluna CLASSIFICA\00C7\00C3O e o Label do Emblema pode ser "Estrelas"</dd>'),
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254298167311544)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o label do emblema para descrever o valor do emblema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254197175311544)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label do Emblema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949369496311305)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique quando o calend\00E1rio come\00E7ar\00E1. A sele\00E7\00E3o dessa op\00E7\00E3o cria um calend\00E1rio que se estende por um intervalo inteiro, como um m\00EAs.</p>'),
'<ul>',
unistr('  <li>Se a op\00E7\00E3o Come\00E7ar no in\00EDcio do intervalo for definida como <strong>Ativado</strong>, a data ser\00E1 15 de junho, a exibi\00E7\00E3o ser\00E1 mensal e o calend\00E1rio resultante abranger\00E1 de 1\00BA a 30 de junho.</li>'),
unistr('  <li>Se a op\00E7\00E3o Come\00E7ar no in\00EDcio do intervalo for definida como <strong>Desativado</strong>, a data ser\00E1 15 de junho, a exibi\00E7\00E3o ser\00E1 mensal e o calend\00E1rio resultante abranger\00E1 de 15 a 30 de junho.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949223158311305)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Come\00E7ar no In\00EDcio do Intervalo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920622737311278)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna de defini\00E7\00E3o de caractere na tabela que armazena o conte\00FAdo BLOB o qual voc\00EA deseja exibir. A imagem provavelmente n\00E3o ser\00E1 exibida se voc\00EA selecionar uma coluna com o tipo de dados errado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920582132311278)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Conjunto de Caracteres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919678108311277)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna BLOB na tabela que armazena o conte\00FAdo BLOB a qual voc\00EA deseja exibir. A imagem provavelmente n\00E3o ser\00E1 exibida se voc\00EA selecionar uma coluna com o tipo de dados errado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919587529311277)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920428683311278)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a coluna de nome de arquivo na tabela que armazena o conte\00FAdo BLOB o qual voc\00EA deseja exibir. A imagem provavelmente n\00E3o ser\00E1 exibida se voc\00EA selecionar uma coluna com o tipo de dados errado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920380694311278)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Nome de Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920895113311278)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a \00FAltima coluna atualizada da tabela que armazena o conte\00FAdo BLOB o qual voc\00EA deseja exibir. Se voc\00EA j\00E1 tiver uma coluna <code>UPDATED</code> com um trigger associado para manter a data, use essa coluna em vez de definir uma nova coluna esp')
||unistr('ecificamente para a \00FAltima atualiza\00E7\00E3o da imagem. No entanto, se colunas que n\00E3o forem de conte\00FAdo BLOB forem atualizadas regularmente, o armazenamento de imagem no cache ser\00E1 prejudicado. A imagem provavelmente n\00E3o ser\00E1 exibida se voc\00EA selecionar um')
||'a coluna com o tipo de dado errado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920702899311278)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna da \00DAltima Atualiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920296330311278)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna de tipo de mime na tabela a qual armazena o conte\00FAdo BLOB que voc\00EA deseja exibir. A imagem provavelmente n\00E3o ser\00E1 exibida se voc\00EA selecionar uma coluna com o tipo de dados errado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920196842311278)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Tipo de Mime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919898655311278)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna da primeira chave prim\00E1ria na tabela que armazena o conte\00FAdo BLOB que voc\00EA deseja exibir. Se a chave prim\00E1ria dessa tabela tiver mais de duas colunas, selecione a coluna <code>ROWID</code>. A imagem provavelmente n\00E3o aparecer\00E1 se v')
||unistr('oc\00EA selecionar uma coluna com o tipo de dado errado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919784489311278)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 1 de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920055384311278)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 selecione a coluna da segunda chave prim\00E1ria se a chave prim\00E1ria da sua tabela tiver duas colunas. Se voc\00EA selecionar <code>ROWID</code> para a coluna da primeira chave prim\00E1ria, n\00E3o preencha essa coluna. A imagem provavelmente n\00E3o ser\00E1 exibida se')
||unistr(' voc\00EA selecionar uma coluna com o tipo de dados errado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919905049311278)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 2 de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919446930311277)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o nome da tabela que armazena o conte\00FAdo BLOB que voc\00EA deseja exibir.'),
unistr('\00C9 poss\00EDvel digitar o nome da tabela ou escolher na lista de tabelas dispon\00EDveis.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919376874311277)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919299732311277)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o esquema que possui a tabela a qual armazena o conte\00FAdo BLOB que voc\00EA deseja exibir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106919191960311277)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249445544311540)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se este componente ser\00E1 exibido usando uma coluna ou formata\00E7\00E3o avan\00E7ada com o uso de express\00F5es HTML e strings de substitui\00E7\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249313023311540)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249627225311541)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione a coluna a ser usada como corpo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249592737311541)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250146254311541)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250046771311541)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558999695310987)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe um texto ou HTML que dever\00E1 ser exibido antes das regi\00F5es que s\00E3o exibidas na p\00E1gina em execu\00E7\00E3o.'),
unistr('O texto que voc\00EA digitar aqui aparecer\00E1 antes da string de substitui\00E7\00E3o <code>#BODY#</code> do modelo de p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558879400310986)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho do Corpo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249926951311541)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249825599311541)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>&COLUMN.</code> para mostrar valores de coluna em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249717648311541)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940525003311293)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a solicita\00E7\00E3o a ser inclu\00EDda no link da ramifica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940422064311293)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338830104311607)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339159164311607)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339030959311607)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338904345311607)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339279170311607)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338775511311607)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914205822311273)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item de p\00E1gina ou do aplicativo que cont\00E9m um n\00FAmero de p\00E1gina ou URL para redirecionamento.'),
unistr('Esse item pode ser definido pela p\00E1gina de chamada ou por um processo quando a p\00E1gina \00E9 carregada pela primeira vez.'),
unistr('Especificar um item oferece uma maneira f\00E1cil de definir de forma din\00E2mica a ramifica\00E7\00E3o para p\00E1ginas que s\00E3o chamadas de muitas outras p\00E1ginas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914178063311273)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340064533311608)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o Java que retorne um n\00FAmero de p\00E1gina ou URL para redirecionamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339997183311608)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339810157311608)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339766640311608)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o JavaScript que retorne um n\00FAmero de p\00E1gina ou URL para redirecionamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339619440311607)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660539408311062)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a p\00E1gina para a qual esta ramifica\00E7\00E3o ser\00E1 redirecionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660418611311062)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660762472311062)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o c\00F3digo PL/SQL executado pela ramifica\00E7\00E3o. Este procedimento PL/SQL \00E9 respons\00E1vel por chamar o URL necess\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660606716311062)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339587343311607)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339445642311607)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o PL/SQL que retorne um n\00FAmero de p\00E1gina ou URL para redirecionamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107339304555311607)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660102682311061)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione em que ponto da renderiza\00E7\00E3o ou processamento de p\00E1gina essa ramifica\00E7\00E3o ser\00E1 executada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082068312311413)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Processamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371682333311630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento: Ramifica ap\00F3s o processamento ser executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081702001311413)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s a Submiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371369346311630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento: Ramifica ap\00F3s submeter a p\00E1gina e antes de o c\00E1lculo, valida\00E7\00F5es e processos serem executados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082133776311413)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371733028311630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Ramifica antes de a p\00E1gina ser renderizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081944733311413)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371584361311630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento: Ramifica antes de o processamento ser executado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081865309311413)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'pt-br'
,p_message_text=>'Validando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371405795311630)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento: Ramifica antes de as valida\00E7\00F5es serem executadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660022458311061)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ponto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340228644311608)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o Python que retorne um n\00FAmero de p\00E1gina ou URL para redirecionamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340146777311608)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659962352311061)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de ramifica\00E7\00E3o da p\00E1gina a ser executada.</p>'),
'<dl>',
unistr('<dt>Redirecionar Ramifica\00E7\00F5es</dt>'),
unistr('<dd>O &PRODUCT_NAME. retorna a nova p\00E1gina ou o URL ao browser, que executa uma nova solicita\00E7\00E3o antes de mostrar a p\00E1gina resultante.'),
unistr('A principal vantagem \00E9 que os usu\00E1rios finais podem atualizar a p\00E1gina sem perder o contexto, como o endere\00E7o do browser que cont\00E9m o URL completo da p\00E1gina.'),
unistr('A desvantagem \00E9 que o browser executa uma solicita\00E7\00E3o adicional para mostrar a p\00E1gina.</dd>'),
unistr('<dt>Mostrar Somente ramifica\00E7\00F5es</dt>'),
unistr('<dd>O &PRODUCT_NAME. imediatamente renderiza a nova p\00E1gina como parte do processamento da p\00E1gina atual, sem executar outra solicita\00E7\00E3o.'),
unistr('Isso tem a vantagem de que o browser n\00E3o tem que executar uma solicita\00E7\00E3o adicional.'),
unistr('A principal desvantagem \00E9 que o endere\00E7o do browser ser\00E1 <code>wwv_flow.accept</code>.'),
unistr('Se os usu\00E1rios finais atualizarem a p\00E1gina, o browser solicitar\00E1 o reenvio dos dados, pois o endere\00E7o do browser n\00E3o ser\00E1 um URL completo da p\00E1gina.</dd>'),
'</dl>',
unistr('<p>A Oracle recomenda selecionar um dos tipos de ramifica\00E7\00F5es de redirecionamento para fornecer uma melhor experi\00EAncia ao usu\00E1rio final.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081142390311412)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o que Retorna uma P\00E1gina (Mostrar somente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081254352311412)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o que Retorna um URL (Redirecionar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081681334311413)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento de P\00E1gina {n\00E3o comum}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081437997311413)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Identificada por Item (Mostrar somente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081082684311412)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina (Mostrar somente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081517942311413)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'URL Identificado por Item (Redirecionar)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107081382929311412)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Procedure PL/SQL [Legado]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080957030311412)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina ou URL (Redirecionar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659893228311061)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198199693310693)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o modelo de breadcrumb utilizado com este breadcrumb.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198020667310693)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926297988311282)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto exibido ap\00F3s colunas de quebra ao exibir uma linha de quebra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926124443311282)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s a Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925836148311282)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto que ser\00E1 exibido antes de colunas de quebra ao exibir uma linha de quebra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925718188311282)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Antes da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936508464311290)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Quebras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937709491311291)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Quebras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925081748311281)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione quantas colunas do relat\00F3rio ser\00E3o incorporadas \00E0 formata\00E7\00E3o de quebra. As colunas devem ser consecutivas, come\00E7ando da primeira coluna exibida no relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104078435311429)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Primeira Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104153060311429)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Primeira e Segunda Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104249519311430)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'pt-br'
,p_message_text=>'Primeira, Segunda e Terceira Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924969660311281)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Quebrar Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925265074311282)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como as quebras afetam a formata\00E7\00E3o de exibi\00E7\00E3o do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104561526311430)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o de Quebra Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104618702311430)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As quebras s\00E3o exibidas em um \00FAnico relat\00F3rio sem repetir os cabe\00E7alhos para cada quebra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104392202311430)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Repetir Cabe\00E7alhos em Quebra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104422407311430)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio \00E9 exibido como v\00E1rios sub-relat\00F3rios com cabe\00E7alhos repetidos para cada quebra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925176572311282)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925677778311282)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto que ser\00E1 exibido nas quebras de relat\00F3rio. Utilize as substitui\00E7\00F5es <code>#SUM_COLUMN_HEADER#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925532351311282)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Quebra de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926090140311282)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto da coluna de quebra ao exibir uma quebra de relat\00F3rio. Voc\00EA pode utilizar as substitui\00E7\00F5es <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925922094311282)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato de Quebra de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925409744311282)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto dos cabe\00E7alhos repetitivos exibidos para as quebras de relat\00F3rio. Voc\00EA pode utilizar as substitui\00E7\00F5es <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106925361731311282)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Cabe\00E7alho Repetitivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935766525311289)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376841400311634)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usa a defini\00E7\00E3o estabelecida nos atributos de seguran\00E7a do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560998206310988)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se o cache estiver ativado, o browser poder\00E1 salvar o conte\00FAdo das p\00E1ginas do seu aplicativo em seu cache, tanto na mem\00F3ria quanto no disco.'),
unistr('Se um usu\00E1rio clica no bot\00E3o Voltar do browser, a p\00E1gina normalmente ser\00E1 carregada a partir do cache, n\00E3o do servidor.'),
unistr('Se o cache estiver desativado, o browser ser\00E1 instru\00EDdo para n\00E3o salvar o conte\00FAdo da p\00E1gina e solicitar\00E1 um novo do servidor.</p>'),
unistr('<p>A Oracle recomenda, de uma perspectiva de seguran\00E7a, que o cache seja desativado, assim, o browser n\00E3o armazenar\00E1 dados sens\00EDveis e sempre solicitar\00E1 p\00E1ginas se o URL mudar.'),
unistr('Caso contr\00E1rio, pode ser poss\00EDvel at\00E9 mesmo voltar no hist\00F3rico do browser ap\00F3s o log-out e ver o conte\00FAdo da sess\00E3o anterior armazenado no cache.'),
unistr('A desativa\00E7\00E3o do cache do browser impedir\00E1 problemas com o bot\00E3o Voltar em p\00E1ginas que usam atualiza\00E7\00F5es parciais como Relat\00F3rios Interativos.</p>'),
unistr('<p>Se o atributo for definido como <strong>Desativado</strong>, o &PRODUCT_NAME. enviar\00E1 o cabe\00E7alho HTTP <em>cache-control: no-store</em> que instrui o Browser a n\00E3o armazenar em cache o conte\00FAdo da p\00E1gina no disco nem na mem\00F3ria.'),
unistr('Se for definido como <strong>Padr\00E3o do Aplicativo</strong>, o valor no runtime ser\00E1 obtido do atributo <em>Cache do Browser</em> do aplicativo.</p>'),
unistr('<p>Observa\00E7\00E3o: Esse recurso requer browsers modernos que suportem a vari\00E1vel de resposta <code>cache-control</code> do controle HTTP.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064125785311400)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064073225311400)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560853277310988)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cache do Browser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445745601311683)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. Voc\00EA est\00E1 desenvolvendo um aplicativo que ter\00E1 muitas instala\00E7\00F5es.'),
unistr('                                        Al\00E9m disso, cada instala\00E7\00E3o poder\00E1 ativar ou desativar determinadas funcionalidades do aplicativo.'),
unistr('                                        Com as Op\00E7\00F5es de Build, voc\00EA pode desenvolver um aplicativo e, quando instaladas, as op\00E7\00F5es de build poder\00E3o ser configuradas para incluir ou excluir a funcionalidade do aplicativo associado.'),
unistr('                                        Voc\00EA tamb\00E9m pode usar a API para expor essa funcionalidade dentro do aplicativo.'),
unistr('                                        Isso permite que usu\00E1rios finais privilegiados ativem ou desativem de forma seletiva funcionalidades do aplicativo.</p>'),
unistr('                                      <p>2. Voc\00EA est\00E1 desenvolvendo uma funcionalidade que ainda n\00E3o est\00E1 completa. Portanto, voc\00EA n\00E3o quer exp\00F4-la aos usu\00E1rios finais.'),
unistr('									    O uso das Op\00E7\00F5es de Build permite que voc\00EA desative essa funcionalidade do aplicativo ela estiver incorporada nos ambientes de teste e produ\00E7\00E3o.'),
unistr('									    O benef\00EDcio desse m\00E9todo \00E9 que o aplicativo ainda pode ser implantado sem incluir a funcionalidade incompleta.</p>'),
unistr('                                      <p>3. Voc\00EA est\00E1 removendo uma funcionalidade que considera desnecess\00E1ria ao aplicativo, mas n\00E3o tem certeza de que esta seja uma opera\00E7\00E3o segura.'),
unistr('									    Nesse caso, voc\00EA pode usar as Op\00E7\00F5es de Build para "comentar" essencialmente a funcionalidade espec\00EDfica.'),
unistr('									    Se durante a implanta\00E7\00E3o a funcionalidade removida for considerada necess\00E1ria, ela poder\00E1 ser reintegrada.'),
unistr('									    Se essa funcionalidade for considerada desnecess\00E1ria, ela poder\00E1 ser removida do aplicativo com seguran\00E7a.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561130651310988)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione uma op\00E7\00E3o de build para este componente.</p>'),
unistr('                                     <p>As Op\00E7\00F5es de Build permitem que os componentes e funcionalidades do aplicativo sejam ativados ou desativados condicionalmente quando o aplicativo \00E9 instalado, ou durante o runtime via API (APEX_UTIL.SET_BUILD_O')
||'PTION_STATUS).<br>',
unistr('                                       As Op\00E7\00F5es de Build podem definir este componente para ser Inclu\00EDdo ou Exclu\00EDdo no aplicativo de runtime:</p>'),
unistr('                                     <p><strong>Inclu\00EDdo</strong> - Ativado e que faz parte do aplicativo.</p>'),
unistr('									 <p><strong>Exclu\00EDdo</strong> - Desativado e que n\00E3o faz parte do aplicativo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561051458310988)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00E3o de Build')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549652454310980)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um status de op\00E7\00E3o de build para este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058071140311393)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058169405311393)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O mecanismo do &PRODUCT_NAME. considera que este componente n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057888997311392)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057956138311392)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O mecanismo do &PRODUCT_NAME. considera este componente como parte da defini\00E7\00E3o do aplicativo durante o runtime.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549561715310980)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663288077311064)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a a\00E7\00E3o a ser executada ao clicar neste bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083826308311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido por A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083907494311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o submete a p\00E1gina ou redireciona para outra p\00E1gina. Em vez disso, o comportamento do bot\00E3o \00E9 definido pela A\00E7\00E3o Din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084206864311415)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084322719311415)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para a pr\00F3xima p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084447437311415)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084569477311415)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para a p\00E1gina anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083478827311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina em outro Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083594203311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Redireciona para uma p\00E1gina em um aplicativo diferente, com atributos adicionais opcionais para redefinir a pagina\00E7\00E3o, definir o valor da solicita\00E7\00E3o, limpar o cache e definir os valores de itens na p\00E1gina de destino.</p>'),
unistr('<p>Nota: o redirecionamento para uma p\00E1gina em um aplicativo diferente depende de haver um link profundo ativado no aplicativo de destino. Para ativar esse link, v\00E1 para os atributos de <em>Seguran\00E7a</em> do aplicativo e ative <em>Link Profundo</em>.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083228889311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina neste Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083329215311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redireciona para uma p\00E1gina no aplicativo atual, com atributos adicionais opcionais para redefinir a pagina\00E7\00E3o, definir o valor da solicita\00E7\00E3o, limpar o cache e definir os valores de itens na p\00E1gina de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083640719311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083762928311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para o URL de destino especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084030935311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084153110311415)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefine a p\00E1gina executando uma atualiza\00E7\00E3o de p\00E1gina completa, n\00E3o uma Atualiza\00E7\00E3o de P\00E1gina Parcial (PPR).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083046174311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Submeter P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107083169352311414)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Submete a p\00E1gina atual com um valor de REQUEST igual ao Nome do Bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663166014311064)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566546229310992)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o tipo de opera\00E7\00E3o SQL que \00E9 executada ao clicar neste bot\00E3o.'),
unistr('Esta sele\00E7\00E3o \00E9 usada para acionar a a\00E7\00E3o do banco de dados especificado no Processamento Autom\00E1tico de Linhas (DML) incorporado.'),
unistr('Se nenhum tipo for selecionado, o processamento do banco de dados ser\00E1 executado com base no valor REQUEST, que \00E9 informado com base no <strong>Nome do Bot\00E3o</strong> definido para este bot\00E3o.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078042741311410)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o SQL DELETE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077864367311410)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o SQL INSERT')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077932809311410)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o SQL UPDATE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566496482310992)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o do Banco de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261260014311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de exibi\00E7\00E3o de bot\00E3o para definir a apar\00EAncia desse bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261548743311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261697422311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe apenas um \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261375022311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261464132311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe apenas o label do bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261705558311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto com \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261807295311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe um \00EDcone junto ao label do bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261141800311549)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363053547311624)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os atributos adicionais exibidos ap\00F3s a c\00E9lula da tabela HTML que exibe cada op\00E7\00E3o individual em um grupo de bot\00F5es de op\00E7\00E3o ou um conjunto de caixas de sele\00E7\00E3o.'),
unistr('Voc\00EA pode incluir HTML, JavaScript e atalhos.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia \00E0s seguintes strings de substitui\00E7\00E3o:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do elemento do form HTML ao qual este item de p\00E1gina est\00E1 associado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do item da p\00E1gina atual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362940282311624)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-texto ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362849589311624)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os atributos adicionais exibidos antes da c\00E9lula da tabela HTML que exibe cada op\00E7\00E3o individual em um grupo de bot\00F5es de op\00E7\00E3o ou um conjunto de caixas de sele\00E7\00E3o.'),
unistr('Voc\00EA pode incluir HTML, JavaScript e atalhos.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia \00E0s seguintes strings de substitui\00E7\00E3o:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do elemento do form HTML ao qual este item de p\00E1gina est\00E1 associado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do item da p\00E1gina atual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362729914311624)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00E9-texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566330719310992)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se a p\00E1gina for submetida e esse atributo for definido como <strong>Ativado</strong>, todas as valida\00E7\00F5es definidas para a p\00E1gina e tamb\00E9m as valida\00E7\00F5es incorporadas ser\00E3o executadas (conforme necess\00E1rio, n\00FAmero v\00E1lido ou data v\00E1lida) no servidor.'),
unistr('Al\00E9m disso, se o <em>Modo de Compatibilidade</em> do aplicativo for definido como <strong>5.1</strong> ou acima, o &PRODUCT_NAME. tamb\00E9m executar\00E1 valida\00E7\00F5es no cliente, como item obrigat\00F3rio. Consulte "Modo de Compatibilidade" nas Notas da Release p')
||'ara obter detalhes adicionais.',
unistr('A p\00E1gina s\00F3 ser\00E1 submetida quando todos os problemas forem corrigidos.</p>'),
unistr('<p>Se definido como <strong>Desativado</strong>, nenhuma das valida\00E7\00F5es definidas nem as valida\00E7\00F5es incorporadas ser\00E3o executadas.'),
unistr('Se voc\00EA quiser que uma valida\00E7\00E3o espec\00EDfica seja executada independentemente dessa defini\00E7\00E3o, modifique a valida\00E7\00E3o e defina o atributo de valida\00E7\00E3o <strong>Sempre Executar</strong> como <strong>Ativado</strong>.</p>'),
unistr('<p>Esse atributo \00E9 particularmente \00FAtil para bot\00F5es como Excluir ou Cancelar, em que a maioria das valida\00E7\00F5es n\00E3o deve ser executada.'),
unistr('Os usu\00E1rios geralmente n\00E3o dever\00E3o ser impedidos de executar essas a\00E7\00F5es se um item for nulo ou do tipo incorreto.'),
unistr('No entanto, se a\00E7\00F5es, como Excluir, s\00F3 puderem ser executadas por usu\00E1rios autorizados, ser\00E1 importante definir o atributo de valida\00E7\00E3o correspondente <strong>Sempre Executar</strong> como <strong>Ativado</strong> ou verificar se h\00E1 uma condi\00E7\00E3o apro')
||unistr('priada definida no pr\00F3prio bot\00E3o; assim, o bot\00E3o s\00F3 ser\00E1 exibido para usu\00E1rios autorizados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566204451310992)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar Valida\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262693556311550)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja usar o bot\00E3o <strong>Normal</strong> ou <strong>Autom\00E1tico</strong> ao renderizar esse bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565962874310992)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja usar o modelo de bot\00E3o <strong>Normal</strong> ou <strong>Autom\00E1tico</strong> ao renderizar esse bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565866930310992)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262460414311550)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o texto a ser exibido no bot\00E3o. Se o tipo de exibi\00E7\00E3o do bot\00E3o for \00EDcone, esse texto se tornar\00E1 o texto ALT para a imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579239520311002)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se o bot\00E3o for de texto, informe o texto a ser exibido no bot\00E3o. Se o bot\00E3o for uma imagem, esse texto passar\00E1 a ser o texto ALT da imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579116015311002)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590188974311010)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome usado para fazer refer\00EAncia ao bot\00E3o clicado. Quando esta p\00E1gina for submetida, o valor de REQUEST ser\00E1 definido para este nome de bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579010375311002)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome usado para identificar este bot\00E3o no processamento de p\00E1gina subsequente.'),
unistr('Quando a p\00E1gina \00E9 submetida, pressionando este bot\00E3o, o valor de REQUEST \00E9 definido como o nome especificado.</p>'),
unistr('<p>O nome do bot\00E3o n\00E3o precisa ser \00FAnico, para os bot\00F5es na mesma p\00E1gina ou na mesma regi\00E3o.'),
unistr('\00C9 poss\00EDvel definir v\00E1rios bot\00F5es com o mesmo nome de bot\00E3o, que estabelece o mesmo valor de REQUEST quando pressionado.'),
unistr('Isso \00E9 \00FAtil para definir bot\00F5es com diferentes <strong>Labels de Bot\00E3o</strong> ou condi\00E7\00F5es que precisam executar o mesmo processamento de p\00E1gina, apenas avaliando o valor REQUEST em comum.</p>'),
unistr('<p>Se voc\00EA der ao bot\00E3o o nome <code>FLOW_RESET_BUTTON</code>, o bot\00E3o redefinir\00E1 a p\00E1gina atual sem fazer uma submiss\00E3o de p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578941610311002)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362457245311624)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando esse bot\00E3o for pressionado, a p\00E1gina ser\00E1 submetida e a solicita\00E7\00E3o de p\00E1gina ser\00E1 definida com esse valor. Se esse valor for nulo e o <em>Tipo de Origem de Solicita\00E7\00E3o</em> for <em>Valor Est\00E1tico</em>, o Nome do Bot\00E3o ser\00E1 usado como o valor ')
||unistr('da solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362375793311624)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem da Solicita\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360321719311622)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica o tipo de express\00E3o contido no atributo de origem da solicita\00E7\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362160021311624)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362244892311624)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360652078311622)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360705870311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna do Banco de Dados</em> que \00E9 recuperado de um processo de extra\00E7\00E3o de linha incorporado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361525017311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361689684311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor que resulta da execu\00E7\00E3o da <em>Express\00E3o PL/SQL</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361731136311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361883039311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o PL/SQL</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360836494311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361068436311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361929192311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362014204311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor da <em>Prefer\00EAncia</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361102700311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL (retornar valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361289904311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como o primeiro valor retornado da <em>Consulta SQL</em> informada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361307425311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL (retornar valor separado por dois-pontos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107361461656311623)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como um valor \00FAnico separado por v\00EDrgulas, que concatena cada valor de linha, retornado da <em>Consulta SQL</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360401635311622)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360580211311622)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o texto inserido no <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107360213512311622)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Origem da Solicita\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566153242310992)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no Destino para chamar uma caixa de di\00E1logo modal. Voc\00EA pode informar o destino a ser chamado ao clicar neste bot\00E3o. Informe um destino somente para bot\00F5es que n\00E3o devem chamar um processamento de p\00E1gina quando clicados (por exemplo, o bot\00E3o C')
||'ancelar)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566078065310992)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565729969310992)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um modelo de bot\00E3o para definir a apar\00EAncia desse bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565653759310992)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241944349311535)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107263076841311550)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verificar se h\00E1 altera\00E7\00F5es n\00E3o salvas quando o bot\00E3o for clicado, se a verifica\00E7\00E3o estiver ativada no n\00EDvel da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241609497311535)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o usu\00E1rio ser\00E1 avisado quando ele tentar navegar para fora da p\00E1gina clicando no bot\00E3o, e a p\00E1gina contiver altera\00E7\00F5es n\00E3o salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241766753311535)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Marcar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244367946311537)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A verifica\00E7\00E3o de altera\00E7\00F5es n\00E3o salvas n\00E3o ser\00E1 executada quando o bot\00E3o for clicado. Essa defini\00E7\00E3o deve ser usada para os bot\00F5es Cancelar, Excluir e Aplicar Altera\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241518317311535)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aviso sobre Altera\00E7\00F5es N\00E3o Salvas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292224905311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292623577311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292558354311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292402611311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292717064311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292393139311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292158213311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Linguagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294286122311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294526675311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294495926311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294384283311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294612081311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294112869311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567739959310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567622580310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569159361310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569095551310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293840732311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Java para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293785699311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295485146311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Java que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295394090311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293652134311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293559140311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o JavaScript para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293477442311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295285294311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295128388311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o JavaScript que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295068876311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567970386310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista de valores separada por dois-pontos (:) para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567892119310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568313360310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o N\00FAmero da P\00E1gina para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568240884310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568580866310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de N\00FAmeros de P\00E1ginas separada por v\00EDrgula para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568435007310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293331194311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293241134311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o PL/SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293143419311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294938890311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294865764311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o PL/SQL que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294794366311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568106514310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Prefer\00EAncia de Usu\00E1rio que se compare ao valor especificado para essa condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568022582310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107294034093311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Python para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293931012311575)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295631816311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Python que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295536430311576)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107293076731311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292959636311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292870963311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446279335311684)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando uma ou mais linhas existirem ao verificar se o funcion\00E1rio est\00E1 no departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para retornar valores com sucesso quando n\00E3o existirem linhas ao verificar se o funcion\00E1rio est\00E1 no departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567365912310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567251618310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568771240310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor de texto para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568653280310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569362575310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569278760310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649784209311054)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de condi\00E7\00E3o que deve ser atendida para que a regi\00E3o seja armazenado no cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567151994310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique uma condi\00E7\00E3o. Se a condi\00E7\00E3o retornar <strong>VERDADEIRO</strong>, a p\00E1gina ser\00E1 exibida no cache. Se a condi\00E7\00E3o retornar <strong>FALSO</strong>, a p\00E1gina ser\00E1 renderizada de forma din\00E2mica e n\00E3o ser\00E1 recuperada do cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132479936311451)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273945204311560)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O componente sempre ser\00E1 renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131018739311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Microsoft Internet Explorer 7.0 ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131106392311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 um browser compat\00EDvel com XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130986000311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Mozilla, Netscape 6.x/7x ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131297996311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Outros browsers (ou uma vers\00E3o mais antiga)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129626677311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131620985311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277548868311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131344323311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277717310311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131508567311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277684933311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131453661311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277809326311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento, o usu\00E1rio final n\00E3o est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128837043311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual - P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276383081311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129031537311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida na lista delimitada por v\00EDrgula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276518081311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128973432311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276482116311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129172472311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual N\00C3O est\00E1 contida na lista delimitada por v\00EDrgulas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276619110311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131721989311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131851087311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130572265311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277361810311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha \00E9 exibido na p\00E1gina, ap\00F3s uma submiss\00E3o de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129943683311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129727925311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129811210311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130096113311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto! = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126515056311446)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas retornadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274054607311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'A consulta SQL retorna uma ou mais linhas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291998672311573)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107292049147311574)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A express\00E3o \00E9 avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126753114311446)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274275051311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O corpo da fun\00E7\00E3o retorna VERDADEIRO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132130903311451)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132200478311451)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130231576311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o N\00C3O \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277006288311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina e a regi\00E3o m\00E3e, se apropriado, ser\00E3o exibidas normalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130148395311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276918742311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina ou a regi\00E3o m\00E3e, se apropriada, tem a condi\00E7\00E3o ''Somente para Leitura'' avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128079033311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275531299311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o tem espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128390559311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275805557311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 alfanum\00E9rico, cont\00E9m s\00F3 letras ou n\00FAmeros e n\00E3o cont\00E9m caracteres especiais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127577309311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275079932311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128290297311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275734715311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127740986311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275229389311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127467465311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274920312311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127844406311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275309963311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio ou \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128105395311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275635940311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127621358311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275116299311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127935639311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 NULO e N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275440830311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio ou n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130796777311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Avan\00E7ar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130890158311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Voltar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132316706311451)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130667524311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha N\00C3O exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277400545311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha n\00E3o \00E9 exibido na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126641667311446)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Linha retornada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274101679311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta SQL n\00E3o retorna linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129423615311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida no Modo para Impress\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276720428311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129564659311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina atual N\00C3O est\00E1 no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276893392311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126852352311446)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274380521311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127056576311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274572403311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126947201311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o != Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274421499311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127145826311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o N\00C3O est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274664917311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107131904527311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132093809311450)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130349177311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 Autenticado (n\00E3o p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277140864311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107130485127311449)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 o Usu\00E1rio P\00FAblico (o usu\00E1rio n\00E3o foi autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277248629311563)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128699242311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276134160311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128725256311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio! = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276283171311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128479757311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107275948437311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107128541279311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107276044797311562)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127255027311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274720571311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107127375043311447)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107274816091311561)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129368053311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual! = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107129246905311448)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567020971310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567562628310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor para comparar \00E0 condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106567494369310993)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568933745310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106568871786310994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386834235311641)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista separada por v\00EDrgulas dos itens dos quais o conte\00FAdo armazenado no cache depende.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386721196311641)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Depende do(s) Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380870131311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como o mecanismo do &PRODUCT_NAME. pode armazenar no cache o texto HTML do servidor. Se o cache puder ser usado, ele emitir\00E1 o resultado armazenado no cache em vez de calcul\00E1-lo novamente. Isso reduz o tempo de c\00E1lculo dispendioso no servid')
||unistr('or. Este recurso n\00E3o est\00E1 relacionado com recursos de armazenamento no cache do browser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381104209311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381222829311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conte\00FAdo \00E9 armazenado no cache e utilizado por todos os usu\00E1rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380911622311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381070302311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conte\00FAdo n\00E3o \00E9 armazenado no cache e calculado para cada solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381535661311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cache por Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381677504311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conte\00FAdo \00E9 armazenado no cache especificamente para cada sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381383680311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cache por Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107381436602311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conte\00FAdo \00E9 armazenado no cache especificamente para cada usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380790120311637)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Armazenamento no Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560778371310988)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione por quanto tempo uma p\00E1gina armazenada no cache \00E9 v\00E1lida. Solicita\00E7\00F5es de p\00E1ginas subsequentes n\00E3o utilizar\00E3o a p\00E1gina armazenada no cache, se o timeout expirar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062137801311398)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'pt-br'
,p_message_text=>'10 segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062716560311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'pt-br'
,p_message_text=>'3 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063632786311400)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'pt-br'
,p_message_text=>'2 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062857299311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'pt-br'
,p_message_text=>'4 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063287406311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'pt-br'
,p_message_text=>'2 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062478685311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'pt-br'
,p_message_text=>'30 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062910096311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'pt-br'
,p_message_text=>'6 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063721317311400)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'pt-br'
,p_message_text=>'4 Semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063369272311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'pt-br'
,p_message_text=>'3 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063905496311400)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'pt-br'
,p_message_text=>'1 Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063441138311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'pt-br'
,p_message_text=>'4 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062538204311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'pt-br'
,p_message_text=>'1 hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063010661311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'pt-br'
,p_message_text=>'12 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062253399311398)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'pt-br'
,p_message_text=>'1 minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062386989311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'pt-br'
,p_message_text=>'10 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063535970311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'pt-br'
,p_message_text=>'1 semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063806259311400)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'pt-br'
,p_message_text=>'10 Semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062691633311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'pt-br'
,p_message_text=>'2 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107063128581311399)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'pt-br'
,p_message_text=>'1 dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560694981310988)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Timeout de Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107788315311432)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Exibe valores de colunas</dt>',
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
unistr('<dt>Exibe uma imagem em um evento de calend\00E1rio.</dt>'),
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953980189311309)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto personalizado a ser exibido em c\00E9lulas de calend\00E1rio. Voc\00EA pode inserir express\00F5es HTML e usar a sintaxe <code>#COLUMN_NAME#</code> para mostrar valores de colunas. Esse tipo de exibi\00E7\00E3o permite inserir v\00E1rias colunas na exibi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953838311311309)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Exibi\00E7\00E3o Personalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948162018311304)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o item da p\00E1gina ou do aplicativo que cont\00E9m a data de in\00EDcio do calend\00E1rio que est\00E1 sendo exibida para o usu\00E1rio final.'),
unistr('Este item \00E9 usado pelo mecanismo do &PRODUCT_NAME. quando o usu\00E1rio final seleciona a op\00E7\00E3o para navegar para o per\00EDodo anterior ou para o pr\00F3ximo per\00EDodo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948063720311304)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948783976311305)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione os valores exibidos no calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107152499311432)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107297896311432)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usa o atributo <strong>Exibir Coluna</strong> para selecionar a coluna a ser exibida na c\00E9lula do calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107333552311432)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107435477311432)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite inserir um formato de coluna personalizado usando express\00F5es HTML e strings de substitui\00E7\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107525257311432)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum Valor de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107685904311432)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum dado \00E9 exibido nas c\00E9lulas do calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948617148311304)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948335549311304)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o item da p\00E1gina ou do aplicativo que cont\00E9m a data de t\00E9rmino do calend\00E1rio que est\00E1 sendo exibida para o usu\00E1rio final.'),
unistr('Este item \00E9 usado pelo mecanismo do &PRODUCT_NAME. quando o usu\00E1rio final seleciona a op\00E7\00E3o para navegar para o per\00EDodo anterior ou para o pr\00F3ximo per\00EDodo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948239677311304)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947518349311304)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um modelo a ser usado quando o calend\00E1rio \00E9 renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947490570311303)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948595811311304)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o item da p\00E1gina ou do aplicativo que cont\00E9m o tipo de calend\00E1rio que est\00E1 sendo exibido para o usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948470088311304)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260980095311549)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero de cart\00F5es a serem exibidas por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260892731311549)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cat\00F5es por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259778759311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determina onde o bot\00E3o est\00E1 posicionado no cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259826700311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259912473311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Secund\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259627633311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258517211311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de a\00E7\00E3o a ser adicionada ao componente do cart\00E3o.</p>'),
unistr('<p>Voc\00EA pode definir v\00E1rias a\00E7\00F5es do mesmo tipo. Contudo, s\00F3 a\00E7\00F5es de bot\00E3o s\00E3o renderizadas v\00E1rias vezes.'),
unistr('Para todos os outros tipos de a\00E7\00E3o, a primeira condi\00E7\00E3o de exibi\00E7\00E3o TRUE fica renderizada e o restante \00E9 ignorado.</p>'),
unistr('<p>As condi\00E7\00F5es de exibi\00E7\00E3o poder\00E3o ser definidas com base nos valores de coluna se a condi\00E7\00E3o de execu\00E7\00E3o estiver definida para verifica\00E7\00E3o de cada linha.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258643418311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258776633311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adiciona o bot\00E3o ao cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258862642311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00E3o Completo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258997164311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Adiciona um link ao cart\00E3o completo. Em geral, um desses tipos de a\00E7\00E3o devem ser definidos.'),
unistr('Se definir v\00E1rios, adicione a condi\00E7\00E3o de exibi\00E7\00E3o com base no valor da coluna e defina a verifica\00E7\00E3o para cada linha.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259465490311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDdia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259591813311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Adiciona um link \00E0 m\00EDdia do cart\00E3o. Em geral, um desses tipos de a\00E7\00E3o devem ser definidos.'),
unistr('Se definir v\00E1rios, adicione a condi\00E7\00E3o de exibi\00E7\00E3o com base no valor da coluna e defina a verifica\00E7\00E3o para cada linha.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259203883311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Subt\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259395065311548)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Adiciona um link ao subt\00EDtulo do cart\00E3o. Em geral, um desses tipos de a\00E7\00E3o devem ser definidos.'),
unistr('Se definir v\00E1rios, adicione a condi\00E7\00E3o de exibi\00E7\00E3o com base no valor da coluna e defina a verifica\00E7\00E3o para cada linha.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259037980311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107259194243311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Adiciona um link ao t\00EDtulo do cart\00E3o. Em geral, um desses tipos de a\00E7\00E3o devem ser definidos.'),
unistr('Se definir v\00E1rios, adicione a condi\00E7\00E3o de exibi\00E7\00E3o com base no valor da coluna e defina a verifica\00E7\00E3o para cada linha.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258481890311547)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247472606311539)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes CSS a serem aplicadas a cada cart\00E3o individual. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247395209311539)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252601356311543)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostre uma seta apontando para a direita</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252534925311543)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que deseja adicionar ao componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('        <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252434018311543)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353503919311617)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostre uma seta apontando para a direita</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353403000311617)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que deseja adicionar ao componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('        <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353356867311617)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245880254311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Essa propriedade determina como os cart\00F5es s\00E3o dispostos na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246170741311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Flutuante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246283368311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os cart\00F5es ser\00E3o ajustados quando n\00E3o couberem mais na dimens\00E3o horizontal da tela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245986409311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'pt-br'
,p_message_text=>'Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246059252311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Disp\00F5e os cart\00F5es em uma grade de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246392988311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Horizontal (Linha)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246461101311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os cart\00F5es ser\00E3o posicionados um em cima do outro.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245751379311538)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260170459311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a a\00E7\00E3o a ser executada quando houver um clique no tipo de a\00E7\00E3o especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260477030311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina em outro Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260588884311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Redireciona para uma p\00E1gina em um aplicativo diferente, com atributos adicionais opcionais para redefinir a pagina\00E7\00E3o, definir o valor da solicita\00E7\00E3o, limpar o cache e definir os valores de itens na p\00E1gina de destino.</p>'),
unistr('<p>Nota: o redirecionamento para uma p\00E1gina em um aplicativo diferente depende de haver um link profundo ativado no aplicativo de destino. Para ativar esse link, v\00E1 para os atributos de <em>Seguran\00E7a</em> do aplicativo e ative <em>Link Profundo</em>.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260202486311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina neste Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260398796311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redireciona para uma p\00E1gina no aplicativo atual, com atributos adicionais opcionais para redefinir a pagina\00E7\00E3o, definir o valor da solicita\00E7\00E3o, limpar o cache e definir os valores de itens na p\00E1gina de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260606477311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260781224311549)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para o URL de destino especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107260086522311548)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373233825311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a primeira coluna de chave prim\00E1ria na origem da regi\00E3o. Se a chave prim\00E1ria desta tabela tiver mais de duas colunas, voc\00EA dever\00E1 selecionar a coluna <code>ROWID</code>. Se a regi\00E3o estiver definida para exibir pagina\00E7\00E3o por rolagem, a chav')
||unistr('e prim\00E1ria ser\00E1 usada para evitar a exibi\00E7\00E3o de linhas duplicadas. Se a regi\00E3o exibir uma imagem de uma coluna BLOB, a chave prim\00E1ria ser\00E1 usada para obter a imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373148345311631)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 1 de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373622759311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a primeira coluna de chave prim\00E1ria na origem da regi\00E3o. Se a chave prim\00E1ria desta tabela tiver mais de duas colunas, voc\00EA dever\00E1 selecionar a coluna <code>ROWID</code>. Se a regi\00E3o estiver definida para exibir pagina\00E7\00E3o por rolagem, a chav')
||unistr('e prim\00E1ria ser\00E1 usada para evitar a exibi\00E7\00E3o de linhas duplicadas. Se a regi\00E3o exibir uma imagem de uma coluna BLOB, a chave prim\00E1ria ser\00E1 usada para obter a imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373519464311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 1 de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373400262311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 selecione a segunda coluna de chave prim\00E1ria se a chave prim\00E1ria da origem da sua regi\00E3o tiver duas colunas. Se voc\00EA selecionar <code>ROWID</code> para a primeira coluna de chave prim\00E1ria, n\00E3o dever\00E1 preencher esta coluna. Se a regi\00E3o estiver defi')
||unistr('nida para exibir pagina\00E7\00E3o por rolagem, a segunda chave prim\00E1ria ser\00E1 usada para evitar a exibi\00E7\00E3o de linhas duplicadas. Se a regi\00E3o exibir uma imagem de uma coluna BLOB, a segunda chave prim\00E1ria ser\00E1 usada para obter a imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373366279311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 2 de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373857859311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 selecione a segunda coluna de chave prim\00E1ria se a chave prim\00E1ria da origem da sua regi\00E3o tiver duas colunas. Se voc\00EA selecionar <code>ROWID</code> para a primeira coluna de chave prim\00E1ria, n\00E3o dever\00E1 preencher esta coluna. Se a regi\00E3o estiver defi')
||unistr('nida para exibir pagina\00E7\00E3o por rolagem, a segunda chave prim\00E1ria ser\00E1 usada para evitar a exibi\00E7\00E3o de linhas duplicadas. Se a regi\00E3o exibir uma imagem de uma coluna BLOB, a segunda chave prim\00E1ria ser\00E1 usada para obter a imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107373723050311632)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 2 de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261046332311549)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O cart\00E3o usa a coluna BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913799013311273)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o nome da coluna da Lista de Valores do banco de dados com distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas, que \00E9 utilizado para consult\00E1-lo usando o valor da faceta ou filtro pai.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913633166311273)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450646325311687)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as colunas que acionam a atualiza\00E7\00E3o dessa lista de valores.'),
unistr('Para v\00E1rias colunas, separe cada nome de coluna com uma v\00EDrgula.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de colunas dispon\00EDveis.'),
unistr('Se voc\00EA escolher na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no final do texto existente, seguida pelo nome da coluna retornado da lista.</p>'),
unistr('<p>Esta lista de valores \00E9 atualizada sempre que o valor de qualquer uma das colunas especificadas for alterado nesta p\00E1gina.</p>'),
unistr('<p>Use a(s) coluna(s) especificada(s) neste atributo na <em> cl\00E1usula where </em> dessa Instru\00E7\00E3o SQL de lista de valores de para restringir os valores retornados.</p>'),
unistr('<p>Por exemplo, se houver colunas para Marca e Modelo de Carro, voc\00EA poder\00E1 especificar a Marca como a Coluna M\00E3e da LOV na Lista de defini\00E7\00E3o de Valores de Modelo e usar a Marca na cl\00E1usula where para essa lista de valores.'),
unistr('Assim, sempre que a Marca for alterada, a LOV do Modelo ser\00E1 atualizada e a lista exibir\00E1 somente valores da Marca selecionada no momento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450556737311687)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna(s) M\00E3e(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913965134311273)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma Faceta que acione a atualiza\00E7\00E3o dessa lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913890657311273)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Faceta Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600300835311018)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um Filtro que acione a atualiza\00E7\00E3o dessa lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600227380311018)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565437647310991)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os itens da p\00E1gina ou do aplicativo que acionam a atualiza\00E7\00E3o dessa lista de valores.'),
unistr('Para v\00E1rios itens, separe cada nome de item com uma v\00EDrgula.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA escolher na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no final do texto existente, seguida pelo nome do item retornado da lista.</p>'),
unistr('<p>Esta lista de valores \00E9 atualizada sempre que o valor de qualquer um dos itens especificados for alterado nesta p\00E1gina.</p>'),
unistr('<p>Use o(s) item(ns) da p\00E1gina especificado neste atributo na <em> cl\00E1usula where </em> dessa lista de valores de instru\00E7\00E3o SQL para restringir os valores retornados.</p>'),
unistr('<p>Por exemplo, se houver itens de p\00E1gina para Marca e Modelo de Carro, voc\00EA poder\00E1 especificar a Marca como o Item Pai da LOV em Cascata na Lista de defini\00E7\00E3o de Valores de Modelo e usar a Marca na cl\00E1usula where para essa lista de valores.'),
unistr('Assim, sempre que a Marca for alterada, a LOV do modelo ser\00E1 atualizada e a lista exibir\00E1 somente valores da Marca selecionada no momento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565307817310991)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item(ns) Pai(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910739869311271)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique em quais condi\00E7\00F5es essa lista de valores \00E9 atualizada.</p>'),
unistr('<p>Se definido como <strong>Ativado</strong>, a chamada de atualiza\00E7\00E3o para obter novos valores s\00F3 ser\00E1 executada quando nenhum <em>Item Pai da LOV em Cascata</em> for nulo.'),
unistr('Se um item for nulo, ser\00E1 presumido que a Consulta LOV n\00E3o retornar\00E1 linhas.'),
unistr('Nesses casos, as entradas da lista de sele\00E7\00E3o ser\00E3o simplesmente apagadas no browser, sem fazer uma atualiza\00E7\00E3o.</p>'),
unistr('<p>Se definido como <strong>Desativado</strong>, a atualiza\00E7\00E3o sempre ser\00E1 executada.'),
unistr('Esta op\00E7\00E3o s\00F3 ser\00E1 usada se voc\00EA tiver um tratamento espec\00EDfico para <em>Item(ns) Pai(s) da LOV em Cascata</em> anul\00E1vel(eis) na <em>cl\00E1usula where</em> dessa lista de valores Consulta SQL.'),
unistr('Se os itens anul\00E1veis da p\00E1gina n\00E3o forem tratados corretamente, ser\00E3o executadas chamadas desnecess\00E1rias de atualiza\00E7\00E3o que nunca retornam linhas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910663878311271)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pai Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196240297310692)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe as credenciais de usu\00E1rio do desenvolvedor que atualizou este atributo pela \00FAltima vez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196166556310691)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alterado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196457775310692)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe quando este atributo foi atualizado pela \00FAltima vez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196369310310692)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alterado em'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946220134311302)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a altura do gr\00E1fico em pixels. A altura define uma altura fixa para a regi\00E3o do gr\00E1fico. Como alternativa, para permitir o redimensionamento autom\00E1tico da altura do gr\00E1fico, deixe este item vazio.'),
unistr('A altura ser\00E1, ent\00E3o, baseada na altura do browser.</p>'),
unistr('<p>Por padr\00E3o, um gr\00E1fico criado em uma p\00E1gina que usa a interface do usu\00E1rio de Smartphone jQuery Mobile n\00E3o tem valor definido para largura e \00E9 corretamente redimensionado para se ajustar ao dispositivo no qual est\00E1 sendo renderizado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946147780311302)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946323802311302)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970071594311321)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a largura m\00E1xima do gr\00E1fico em pixels. A largura m\00E1xima define uma largura fixa para a regi\00E3o do gr\00E1fico.'),
unistr('Como alternativa, para permitir o redimensionamento autom\00E1tico da largura do gr\00E1fico, deixe esse item vazio. A largura ser\00E1 automaticamente definida como 100% da regi\00E3o.</p>'),
unistr('<p>Por padr\00E3o, um gr\00E1fico criado em uma p\00E1gina que usa a interface do usu\00E1rio de Smartphone jQuery Mobile n\00E3o tem valor definido para largura e \00E9 corretamente redimensionado para se ajustar ao dispositivo no qual est\00E1 sendo renderizado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964476699311317)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964579602311317)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943163460311300)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um t\00EDtulo a ser exibido na parte superior do gr\00E1fico. Para gr\00E1ficos de Gantt, este valor somente \00E9 usado para definir o t\00EDtulo do gr\00E1fico acess\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943059124311300)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171596100311480)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a localiza\00E7\00E3o dos dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171651680311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Banco de Dados Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171797929311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados do banco de dados local.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172298657311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172382206311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados do local especificado na defini\00E7\00E3o de origem da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171810045311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171983454311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados de um banco de dados remoto, onde a conex\00E3o \00E9 definida usando SQL Ativada por REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172087367311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Origem REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172158914311481)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados de um servi\00E7o Web RESTful definido usando Origens de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107171406244311480)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936856859311290)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a base para esta coluna do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094680736311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'pt-br'
,p_message_text=>'* Seletor de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094503471311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('* Seletor de Data (Cl\00E1ssico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094461983311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'* Exibir como Texto (salva o estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094137929311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download do BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271509087311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como um link para fazer download do arquivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094364496311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Oculta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271739343311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o exibe a coluna, mas ela pode ser referenciada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095110974311423)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'pt-br'
,p_message_text=>'* Campo Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094034917311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271463927311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como uma imagem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093945290311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271378591311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como um link.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094251491311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Percentual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271605736311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe a coluna como um gr\00E1fico de porcentagem. O valor recuperado deve estar entre 0 e 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093741041311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto sem Formata\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271146349311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe o valor da coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093864304311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto sem Formata\00E7\00E3o (baseado na Lista de Valores)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271273976311559)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe o valor retornado da lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095262771311423)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'pt-br'
,p_message_text=>'* LOV Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095324183311423)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'pt-br'
,p_message_text=>'* LOV de Chave Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095073399311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('* Grupo de Bot\00F5es de Op\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342631511311610)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342732693311610)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Renderiza a coluna usando HTML ou Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095588918311423)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'* Seletor de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094987363311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>'* Selecionar Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095439340311423)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('* Caixa de Sele\00E7\00E3o Simples')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094750878311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'* Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107094828678311422)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('* \00C1rea de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936747212311290)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936486614311290)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem pagina\00E7\00E3o (Exibir Todas Linhas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937613347311291)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem pagina\00E7\00E3o (Exibir Todas Linhas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922800248311280)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de pagina\00E7\00E3o ser utilizado neste relat\00F3rio.'),
unistr('Geralmente, apenas um subconjunto dos resultados s\00E3o atualmente exibidos no relat\00F3rio.'),
unistr('A pagina\00E7\00E3o fornece ao usu\00E1rio informa\00E7\00F5es sobre o n\00FAmero de linhas e a posi\00E7\00E3o atual no resultado definido. A pagina\00E7\00E3o tamb\00E9m define o estilo de links ou bot\00F5es que s\00E3o usados para navegar at\00E9 a p\00E1gina anterior ou posterior.</p>'),
unistr('<p>A p\00E1gina \00E7\00E3o pode ser mostrada acima ou abaixo do relat\00F3rio (ou em ambos) e pode ser posicionada \00E0 esquerda ou \00E0 direita.</p>'),
unistr('<p>Tamb\00E9m \00E9 poss\00EDvel usar um estilo de pagina\00E7\00E3o simplificado para aprimorar o desempenho, como <strong>Faixas de Linha X a Y de Z (com os links Pr\00F3ximo e Anterior)</strong>.'),
unistr('Usar os tipos de pagina\00E7\00E3o do form "X a Y de Z", requer que o mecanismo do &PRODUCT_NAME. execute duas consultas para retornar os resultados.'),
unistr('Uma consulta recupera os registros atuais a serem exibidos e outra consulta obt\00E9m a contagem de registros total a serem exibidos no controle de pagina\00E7\00E3o.'),
unistr('Para relat\00F3rios baseados em conjuntos de dados excessivamente grandes ou com consultas muito intensivas da CPU, como diversas condi\00E7\00F5es caras ou de joins de tabela n\00E3o ideais, essa consulta adicional pode adicionar algum tempo de processamento, que p')
||unistr('ode fazer com que o relat\00F3rio demore mais para ser renderizado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103295116311429)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Bot\00F5es de Pagina\00E7\00E3o Criados Externamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103364358311429)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha X a Y (com os links Pr\00F3ximo e Anterior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102629600311428)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha X a Y (sem pagina\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102775747311428)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha X a Y de Z (sem pagina\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102971421311428)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha 1-15 16-30  (com pagina\00E7\00E3o definida)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103081126311429)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha 1-15 16-30 na lista de sele\00E7\00E3o (sem pagina\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102844115311428)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Faixas de Linha X a Y de Z (com pagina\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103131112311429)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mecanismo de Pesquisa 1,2,3,4 (pagina\00E7\00E3o baseada em conjunto)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922767725311280)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892355372311256)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o n\00FAmero de \00EDcones a serem exibidos por linha na View do \00CDcone. Um valor 5 exibe 5 \00EDcones por linha de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090742456311419)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090879846311419)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090926938311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'pt-br'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091098338311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'pt-br'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091166231311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'pt-br'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091283430311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'pt-br'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091322618311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'pt-br'
,p_message_text=>'7'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091438140311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091598968311420)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'pt-br'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892227761311256)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas por Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882833774311249)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o alinhamento de exibi\00E7\00E3o da coluna. Observe que a sele\00E7\00E3o de alinhamento deve ser suportada pelo modelo de relat\00F3rio selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086877158311417)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086799199311416)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('in\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086959726311417)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882740648311249)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939139121311292)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de valor de coluna padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106714474311431)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106658483311431)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939052523311292)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794074067311174)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto do cabe\00E7alho de grupo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882080302311248)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto do cabe\00E7alho da coluna do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881994007311248)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311711188310796)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 Classific\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220951534311518)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha a coluna que cont\00E9m a chave exclusiva para identificar uma linha. Use-a para fornecer o valor da chave prim\00E1ria para o c\00F3digo Javascript personalizado ou os handlers de eventos do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220828865311518)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881483548311248)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome da coluna para esta coluna do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881333909311248)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936650974311290)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938085319311291)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917194054311276)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esta coluna ser\00E1 classificada em ordem Decrescente. Se esse item n\00E3o for especificado, a coluna ser\00E1 classificada em ordem Crescente (o padr\00E3o).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099981409311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917059567311276)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dire\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916977607311275)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione a sequ\00EAncia de classifica\00E7\00E3o para esta coluna.'),
unistr('Cada coluna deve ter uma sequ\00EAncia exclusiva para ordenar corretamente a sa\00EDda do relat\00F3rio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099168801311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099231018311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099352023311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'pt-br'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099473605311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'pt-br'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099559020311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'pt-br'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099650761311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'pt-br'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099748511311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'pt-br'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099848912311426)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916848906311275)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881693767311248)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o tipo de dado para a coluna do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881509062311248)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915380278311274)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Informe a largura da coluna em pixels.',
unistr('Use este atributo ao exibir relat\00F3rios em um browser.'),
unistr('Observe que a defini\00E7\00E3o de largura da coluna deve ser suportada pelo modelo de relat\00F3rio selecionado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915292713311274)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura da C\00E9lula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945713878311302)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550036973310980)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coloque todos os coment\00E1rios ou notas do desenvolvedor aqui. Esses coment\00E1rios s\00E3o exibidos apenas no Application Builder e nunca ao executar o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549918553310980)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247272255311539)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes CSS a serem aplicadas a este componente. Essa classe se aplicar\00E1 ao cont\00EAiner de cart\00F5es. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247178777311539)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307249948311584)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307687955311585)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307572795311585)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307495946311585)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307753758311585)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307359847311584)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307114770311584)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309291080311586)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309502754311586)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309412277311586)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309371626311586)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309621760311586)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309116596311586)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554037139310983)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo preenchido por este c\00E1lculo. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553930067310983)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554860635310983)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item cujo valor \00E9 usado para preencher o item de c\00E1lculo. Voc\00EA pode digitar o nome ou selecionar na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554728048310983)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308882603311586)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Java que gere um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308712371311585)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310449092311587)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310354835311587)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308605132311585)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER"? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308576518311585)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o JavaScript que gere um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308433828311585)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310245915311587)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310169473311586)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310020925311586)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308388847311585)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308230309311585)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o PL/SQL que gere um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308119425311585)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309900890311586)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309820133311586)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309787442311586)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555427391310984)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione em qual ponto na renderiza\00E7\00E3o ou processamento da p\00E1gina este c\00E1lculo ser\00E1 executado.'),
unistr('O ponto de c\00E1lculo mais t\00EDpico \00E9 <strong>Ap\00F3s Submiss\00E3o</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067428578311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368843508311628)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada ap\00F3s a renderiza\00E7\00E3o das regi\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067652380311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369030498311629)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada ap\00F3s a renderiza\00E7\00E3o do cabe\00E7alho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067262263311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368617996311628)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada depois que a p\00E1gina \00E9 renderizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067767447311403)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s a Submiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369165722311629)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento: Executado depois que a p\00E1gina \00E9 enviada, mas antes do processamento da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067347531311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes das Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368751317311628)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada antes de as regi\00F5es serem renderizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067539857311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368968363311629)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada antes de o cabe\00E7alho ser renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067199689311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368594351311628)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada antes de a p\00E1gina ser renderizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067041817311402)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368472705311628)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executado quando uma nova sess\00E3o \00E9 gerada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555333695310984)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ponto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555049715310984)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Prefer\00EAncia de Usu\00E1rio que tenha um valor usado para preencher este item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554998402310984)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107309000463311586)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Python que gere um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308953284311586)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310636822311587)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310505791311587)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273857672311560)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL que fornece um valor usado para preencher o item de c\00E1lculo. Se o resultado contiver v\00E1rias linhas, o valor de cada linha ser\00E1 formado por um \00FAnico valor delimitado por dois-pontos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273785175311560)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107308076601311585)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'               from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307993064311585)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o SQL que gere um valor usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307899164311585)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554630280310983)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL que forne\00E7a um valor usado para preencher o item de c\00E1lculo. Se o resultado contiver v\00E1rias linhas, s\00F3 o valor da primeira linha ser\00E1 retornado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554552041310983)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554406104310983)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto que \00E9 usado para preencher o item de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554310723310983)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554234522310983)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de c\00E1lculo na lista a seguir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290329653311572)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290461472311572)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor que resulta da execu\00E7\00E3o da <em>Express\00E3o</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066563971311402)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268965550311557)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066837381311402)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268614619311557)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066657141311402)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL (retornar valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268782207311557)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como o primeiro valor retornado da <em>Consulta SQL</em> informada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066736021311402)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL (retornar valor separado por dois-pontos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268841539311557)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como um valor \00FAnico separado por v\00EDrgulas, que concatena cada valor de linha, retornado da <em>Consulta SQL</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066921126311402)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269019658311557)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor da <em>Prefer\00EAncia</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066491185311402)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268556975311557)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o texto inserido no <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106554100462310983)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915107120311274)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para esta coluna, especifique se a soma ser\00E1 calculada e exibida no final do relat\00F3rio.'),
unistr('Quando usada com colunas de quebra, a soma total e a soma de cada quebra ser\00E1 exibida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915006265311274)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular Soma'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299885008311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300262536311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300186356311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300062027311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300382745311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299984756311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299728031311579)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301885068311581)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302157399311581)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302080255311581)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301906072311581)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302296104311581)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301706573311580)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587543987311008)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587464186311008)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588942869311009)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588809859311009)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301471618311580)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Java para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301384461311580)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303004105311581)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Java que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302971217311581)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301228937311580)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301162913311580)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o JavaScript para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301086961311580)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302810812311581)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302742472311581)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o JavaScript que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302611225311581)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587723836311009)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista de valores separada por dois-pontos (:) para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587694548311008)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588177063311009)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o N\00FAmero da P\00E1gina para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588099347311009)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588392547311009)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de N\00FAmeros de P\00E1ginas separada por v\00EDrgula para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588222023311009)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300914216311580)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300822023311580)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o PL/SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300794299311580)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302533734311581)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302403740311581)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o PL/SQL que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107302349426311581)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587987188311009)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Prefer\00EAncia de Usu\00E1rio que se compare ao valor especificado para essa condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587844995311009)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301645801311580)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Python para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107301536924311580)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303200751311582)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Python que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303133958311581)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300660967311580)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300509829311580)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107300444017311580)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446426941311684)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando uma ou mais linhas existirem ao verificar se o funcion\00E1rio est\00E1 no departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para retornar valores com sucesso quando n\00E3o existirem linhas ao verificar se o funcion\00E1rio est\00E1 no departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587120827311008)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587056241311008)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588504596311009)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor de texto para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588414789311009)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589182884311010)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589085133311009)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962453931311315)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de condi\00E7\00E3o a ser atendida para que esta a\00E7\00E3o esteja ativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590069083311010)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de condi\00E7\00E3o a ser atendida para que esta a\00E7\00E3o din\00E2mica esteja ativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106586073391311007)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de condi\00E7\00E3o que deve ser atendida para que este componente seja convertido ou processado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144476521311460)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282052121311566)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O componente sempre ser\00E1 renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143082723311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Microsoft Internet Explorer 7.0 ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143132156311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 um browser compat\00EDvel com XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142996028311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Mozilla, Netscape 6.x/7x ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143285106311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Outros browsers (ou uma vers\00E3o mais antiga)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141618352311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143606858311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285654466311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143332754311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285875878311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143511483311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285752601311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143465897311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285904317311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento, o usu\00E1rio final n\00E3o est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140899014311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual - P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284420867311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141033086311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida na lista delimitada por v\00EDrgula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284606831311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140997014311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284518928311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141156889311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual N\00C3O est\00E1 contida na lista delimitada por v\00EDrgulas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284780861311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143721895311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143807965311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142566887311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285479747311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha \00E9 exibido na p\00E1gina, ap\00F3s uma submiss\00E3o de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141972384311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141703810311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141847853311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142087606311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto! = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138543257311455)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas retornadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282101998311566)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'A consulta SQL retorna uma ou mais linhas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299529368311579)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299618193311579)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A express\00E3o \00E9 avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138707452311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282329762311566)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O corpo da fun\00E7\00E3o retorna VERDADEIRO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144138150311460)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144223376311460)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142291242311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o N\00C3O \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285115172311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina e a regi\00E3o m\00E3e, se apropriado, ser\00E3o exibidas normalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142174307311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285040997311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina ou a regi\00E3o m\00E3e, se apropriada, tem a condi\00E7\00E3o ''Somente para Leitura'' avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140069969311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283649549311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o tem espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140329420311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283944145311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 alfanum\00E9rico, cont\00E9m s\00F3 letras ou n\00FAmeros e n\00E3o cont\00E9m caracteres especiais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139504218311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283142726311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140214595311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283891777311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139702955311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283365260311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139432216311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283000597311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139825363311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283468614311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio ou \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140120966311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283735354311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139697753311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283225671311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139957944311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 NULO e N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107283577558311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio ou n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142758761311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Avan\00E7ar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142833749311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Voltar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144368395311460)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nunca'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286066628311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>O componente nunca foi renderizado.</p>',
unistr('<p>Observa\00E7\00E3o: alterar uma condi\00E7\00E3o para <strong>Nunca</strong> remover\00E1 qualquer condi\00E7\00E3o existente. Para desativa\00E7\00E3o tempor\00E1ria de um componente, a Oracle recomenda usar o atributo <em>Op\00E7\00E3o de Build</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142689921311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha N\00C3O exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285511484311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha n\00E3o \00E9 exibido na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138666421311455)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Linha retornada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282205917311566)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta SQL n\00E3o retorna linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141414163311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284834637311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141526817311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina atual N\00C3O est\00E1 no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284931864311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138896936311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282483574311566)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139025604311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282638313311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138928903311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o != Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282548315311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139155892311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o N\00C3O est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282708127311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107143907739311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144053876311459)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142330439311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 Autenticado (n\00E3o p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285297211311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107142416846311458)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 o Usu\00E1rio P\00FAblico (o usu\00E1rio n\00E3o foi autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107285336865311569)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140632026311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284245758311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140793509311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio! = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284380407311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140460837311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284026994311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107140560799311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107284148629311568)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139293252311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282830196311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107139365748311456)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107282948670311567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141344344311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual! = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107141201978311457)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585967673311007)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587343119311008)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor para comparar \00E0 condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106587263138311008)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588715715311009)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106588614393311009)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458364453310904)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Protege o comportamento do bot\00E3o com um prompt de confirma\00E7\00E3o. Mostra uma caixa de di\00E1logo de confirma\00E7\00E3o ap\00F3s o clique no bot\00E3o, na qual o usu\00E1rio deve confirmar antes de o bot\00E3o executar sua a\00E7\00E3o.</p>'),
unistr('<p>Essa funcionalidade pode ser usada para garantir que o usu\00E1rio n\00E3o execute uma a\00E7\00E3o significativa por acidente, como excluir um registro.</p>'),
unistr('<p>Observa\00E7\00E3o: O bot\00E3o de confirma\00E7\00E3o na caixa de di\00E1logo deriva seu label do label do bot\00E3o principal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458213327310904)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Requer Confirma\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458692466310904)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<pre>&lt;strong&gt;Tem certeza&lt;&#x2F;strong&gt; de que deseja excluir o funcion\00E1rio &amp;P1_ENAME.?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458566564310904)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite a mensagem a ser exibida na caixa de di\00E1logo de confirma\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458429872310904)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459369525310905)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458888176310904)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o estilo da caixa de di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459127142310905)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Perigo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458925872310904)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459224198310905)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459043957310904)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106458758032310904)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921291475311279)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a disposi\00E7\00E3o de conte\00FAdo na lista dispon\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100101921311426)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100214653311426)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921169064311279)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Disposi\00E7\00E3o de Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646464351311051)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o atributo do dom\00EDnio de URL para o cookie de sess\00E3o.'),
unistr('Se a compara\00E7\00E3o da parte final do URL de solicita\00E7\00E3o n\00E3o corresponder ao dom\00EDnio especificado, o cookie n\00E3o ser\00E1 enviado ao browser.'),
unistr('O valor padr\00E3o \00E9 o nome do host do URL de solicita\00E7\00E3o.</p>'),
unistr('<p>Use esse atributo para especificar um dom\00EDnio menos restritivo quando voc\00EA desejar compartilhar cookies de sess\00E3o entre aplicativos que t\00EAm dom\00EDnios em comum.'),
unistr('Por exemplo, <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> e <code>finance.yahoo.com</code> podem acessar o mesmo cookie se um dom\00EDnio <code>yahoo.com</code> for especificado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646380323311051)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dom\00EDnio do Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646052973311051)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome do cookie da sess\00E3o, que \00E9 necess\00E1rio para identificar uma sess\00E3o do &PRODUCT_NAME., juntamente com o ID de sess\00E3o no URL.'),
unistr('Se voc\00EA n\00E3o especificar um nome de cookie da sess\00E3o, o &PRODUCT_NAME. utilizar\00E1 um valor padr\00E3o.</p>'),
unistr('<p> Ao especificar o mesmo nome de cookie em v\00E1rios aplicativos, cada um dos aplicativos poder\00E1 utilizar o mesmo cookie de sess\00E3o.'),
unistr('Portanto, uma chamada de URL do aplicativo do &PRODUCT_NAME. para outro aplicativo do &PRODUCT_NAME., com o mesmo nome de cookie, n\00E3o exige que o usu\00E1rio fa\00E7a outra autentica\00E7\00E3o, pois o novo aplicativo pode utilizar o cookie de sess\00E3o existente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645931974311051)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646247774311051)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o atributo de caminho do URL para o cookie de sess\00E3o.'),
unistr('Se no in\00EDcio do URL da solicita\00E7\00E3o n\00E3o corresponder ao caminho especificado, o cookie n\00E3o ser\00E1 enviado ao browser.'),
unistr('O valor padr\00E3o \00E9 o caminho do URL da solicita\00E7\00E3o.</p>'),
unistr('<p>Use este atributo para especificar um caminho menos restritivo, quando voc\00EA deseja compartilhar cookies de sess\00E3o entre aplicativos que inicialmente est\00E3o em conformidade com os caminhos do URL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646187275311051)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Caminho do Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066240809311401)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Refer\00EAncia do arquivo padr\00E3o</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>Refer\00EAncia do arquivo padr\00E3o que carrega o arquivo main.min.css de /mycss/minified/ minimizado para views de p\00E1gina regulares e main.css de /mycss/ no modo de depura\00E7\00E3o ou ao executar o aplicativo pelo Application Builder.</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
unistr('<dt>Consulta de m\00EDdia condicional</dt>'),
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>Refer\00EAncia do arquivo usando uma string de consulta no URL que faz refer\00EAncia \00E0 vers\00E3o do aplicativo, de modo que, quando houver o upgrade do aplicativo (e a vers\00E3o for incrementada), o browser seja instru\00EDdo para sempre carregar o novo arquivo e')
||' ignorar os arquivos armazenados no cache anteriormente.</dt>',
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552804883310982)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os URLs do arquivo da Folha de Estilo em Cascata (CSS) carregados nesta p\00E1gina. Cada URL deve ser gravado em uma nova linha.'),
unistr('Se voc\00EA fornecer uma vers\00E3o minimizada de seu arquivo, poder\00E1 usar a string de substitui\00E7\00E3o <code>#MIN#</code> para incluir <code>.min</code> ou <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> em seu URL de arquivo para uma view de p')
||unistr('\00E1gina regular e uma string vazia, se a p\00E1gina for exibida no modo de depura\00E7\00E3o, ou ao executar o aplicativo pelo Application Builder.'),
unistr('Voc\00EA tamb\00E9m pode ter acesso \00E0 string de substitui\00E7\00E3o <code>#APP_VERSION#</code> se quiser incluir a vers\00E3o do aplicativo no URL do arquivo.</p>'),
unistr('<p>Os URLs do arquivo que voc\00EA inserir aqui substituir\00E3o a string de substitui\00E7\00E3o <code>#PAGE_CSS#</code> no modelo da p\00E1gina.</p>'),
unistr('<p>Observa\00E7\00E3o: N\00E3o \00E9 necess\00E1rio incluir tags de abertura ou de fechamento <code>link</code>. Basta incluir o URL do arquivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552762569310982)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URLs do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107099044321311425)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Definir este atributo como <code>color:#FF0000;</code> Altera a cor do texto da coluna para vermelho e gera o seguinte HTML</dt>',
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916513257311275)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os estilos CSS a serem aplicados ao valor desta coluna. Voc\00EA pode digitar o estilo CSS ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916469217311275)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889530319311254)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um caractere delimitador para delinear o limite inicial e final de um valor de dados. O delimitador padr\00E3o \00E9 aspas duplas.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889496781311254)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inclu\00EDdo Por CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924428768311281)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem fazer download de conte\00FAdo de relat\00F3rios para um arquivo CSV. Para ativar <em>CSV Downloads</em>, use um modelo de relat\00F3rio com uma string de substitui\00E7\00E3o <code>#CSV_LINK#</code> e defina essa op\00E7\00E3o como <stro')
||'ng>Ativado</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924336858311281)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta\00E7\00E3o CSV Ativada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889379944311254)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um separador de coluna. Se nenhum valor for informado, uma v\00EDrgula ou um ponto-e-v\00EDrgula ser\00E1 usado, de acordo com as defini\00E7\00F5es atuais do NLS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889292219311254)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Separador CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557365039310985)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o cursor \00E9 focado quando \00E9 inserido na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059882940311394)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Primeiro item da p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059988875311394)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O foco do cursor \00E9 colocado no primeiro campo na p\00E1gina que usa o JavaScript, gerado pelo mecanismo do &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060081893311394)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o usar foco no cursor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060106145311394)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O cursor n\00E3o est\00E1 em foco e nenhum JavaScript foi gerado.<br>'),
unistr('Selecione esta op\00E7\00E3o se o JavaScript gerado estiver em conflito com o JavaScript personalizado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551953087310981)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Foco no Cursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650046697311054)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione se atributos de exibi\00E7\00E3o desta regi\00E3o podem ser personalizados pelo usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080888978311412)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Personaliz\00E1vel Pelo Usu\00E1rio Final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080769937311412)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Personaliz\00E1vel e Mostrado Por Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080646378311412)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Personaliz\00E1vel e N\00E3o Mostrado Por Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649903838311054)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Personaliz\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649064987311053)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite o label do link que ser\00E1 exibido sob esta regi\00E3o, que d\00E1 acesso \00E0 p\00E1gina de personaliza\00E7\00E3o da regi\00E3o.'),
unistr('Esse label ser\00E1 exibido apenas para regi\00F5es personaliz\00E1veis.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648923376311053)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954508320311309)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr(':informe o texto HTML a ser inclu\00EDdo para este bot\00E3o:'),
'<ul>',
unistr('  <li>Para bot\00F5es do tipo <strong>Bot\00E3o HTML</strong>, esse texto \00E9 adicionado \00E0 defini\00E7\00E3o de elemento HTML.</li>'),
unistr('  <li>Para bot\00F5es baseados em modelos, seu modelo dever\00E1 incluir a string de substitui\00E7\00E3o <code>#BUTTON_ATTRIBUTES#</code>.</li>'),
'</ul>',
unistr('<p>Voc\00EA pode usar esse atributo para controlar paradas de tabula\00E7\00E3o</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954704669311310)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A string de substitui\00E7\00E3o do modelo de relat\00F3rio <code>#REPORT_ATTRIBUTES#</code> \00E9 substitu\00EDda por este valor. A string de substitui\00E7\00E3o <code>#REPORT_ATTRIBUTES#</code> \00E9 substitu\00EDda somente no atributo das linhas anteriores do modelo de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794660713311175)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os atributos adicionais a serem inclu\00EDdos na tag HTML do elemento do form. Os atributos HTML de <code>tamanho</code> e <code>id</code> s\00E3o gerados e, portanto, n\00E3o devem ser fornecidos. Para o atributo HTML <code>classe</ code>, \00E9 melhor usar')
||' o atributo <em>Classes CSS</em> dedicadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954470316311309)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os atributos adicionais a serem inclu\00EDdos na tag HTML do elemento do form. Os atributos HTML de <code>tamanho</code> e <code>id</code> s\00E3o gerados e, portanto, n\00E3o devem ser fornecidos. Para o atributo HTML <code>classe</ code>, \00E9 melhor usar')
||' o atributo <em>Classes CSS</em> dedicadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954626484311309)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor substitu\00EDdo nos atributos de regi\00E3o. Os modelos de regi\00E3o que cont\00EAm a string de substitui\00E7\00E3o <code>#REGION_ATTRIBUTES#</code> s\00E3o substitu\00EDdos por este valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954888321311310)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A string de substitui\00E7\00E3o do modelo de relat\00F3rio <code>#REPORT_ATTRIBUTES#</code> \00E9 substitu\00EDda por este valor. A string de substitui\00E7\00E3o <code>#REPORT_ATTRIBUTES#</code> \00E9 substitu\00EDda somente no atributo das linhas anteriores do modelo de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954322094311309)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe os atributos adicionais delimitados por espa\00E7o a serem inclu\00EDdos na tag do item.'),
'Para o atributo HTML CLASS, a Oracle recomenda usar o atributo Classes CSS dedicadas.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954248122311309)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos Personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865642638311235)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o nome da coluna personalizado, que pode ser usado para definir uma dica de ferramenta personalizada ou as cores baseadas no banco de dados a serem usadas para os elementos do gr\00E1fico. No caso de um gr\00E1fico de Diagrama de Caixa, a coluna ')
||unistr('n\00E3o deve corresponder ao mapeamento da coluna Valor selecionada. A sele\00E7\00E3o de uma coluna que corresponde ao mapeamento da coluna Valor far\00E1 com que nenhuma coluna personalizada seja usada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865506427311235)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Personalizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555819769310984)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um nome de evento JavaScript personalizado, se os eventos declarativos fornecidos n\00E3o forem suficientes.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555784661310984)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Evento Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872383768311241)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a opera\00E7\00E3o de banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872876880311241)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872404759311241)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'pt-br'
,p_message_text=>'Extrair Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872521816311241)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Extrair Linha \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872677645311241)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872758383311241)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872281031311240)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00E3o de Banco de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110150237311434)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950739577311306)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada no plano de fundo dos dados exibidos neste calend\00E1rio.</p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950675940311306)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Plano de Fundo dos Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385557671310850)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o nome da coluna que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas usado como origem desse valor de item.</p>'),
unistr('<p>Esta coluna deve existir na origem de dados especificada na regi\00E3o Form.'),
unistr('\00C9 gerado um erro no runtime e a p\00E1gina n\00E3o \00E9 carregada, quando o nome da coluna n\00E3o existe na tabela referenciada.'),
unistr('Da mesma forma, se n\00E3o houver qualquer processo de extra\00E7\00E3o de linha incorporado definido e existir um item com o tipo de origem <strong>Coluna do Banco de Dados</strong>, ser\00E1 gerado um erro e a p\00E1gina n\00E3o ser\00E1 carregada durante a tentativa de rende')
||unistr('riz\00E1-la.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385403883310850)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385338262310850)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o do Form associada a esse item de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385236098310850)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150654929311464)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950957505311306)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para os dados deste calend\00E1rio.</p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950800900311306)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790559850311171)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tipo de dados da coluna de banco de dados subjacente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456948516311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'pt-br'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456708339311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'pt-br'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456651694311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'pt-br'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456086618311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'pt-br'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456525767311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'pt-br'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456489015311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'pt-br'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455902083311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'pt-br'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456829922311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'pt-br'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456209041310902)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'pt-br'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456163850311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'pt-br'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456327616311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'pt-br'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107456211316311691)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'pt-br'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455834051311690)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'pt-br'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790471452311171)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947717816311304)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna da tabela ou consulta que cont\00E9m as datas a serem inseridas no calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947646432311304)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947967733311304)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se voc\00EA deseja mostrar o valor de tempo ou apenas a data em seu calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106947837481311304)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Hor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915711341311275)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a m\00E1scara de formato para aplicar o seletor de data para esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096111963311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095918025311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096054097311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096769808311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096550003311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096664276311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096450741311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096287408311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096349020311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096874859311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097022762311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107096928771311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097191739311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097309711311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097291648311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097408446311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'pt-br'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097620373311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097568117311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097712935311424)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'pt-br'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097968413311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107097881034311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095648081311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Formato de Data do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095772251311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar M\00E1scara de Formato do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107095829633311423)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar M\00E1scara de Formato do Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098063066311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098206995311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098120286311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098386153311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098724744311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098888065311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098593527311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098641603311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098462373311425)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915619774311275)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952044979311307)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no destino para chamar uma caixa de di\00E1logo modal. Voc\00EA pode inserir o link de destino que o calend\00E1rio chamar\00E1 ao criar um evento clicando em uma c\00E9lula fora do calend\00E1rio de um evento existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951985936311307)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580257131311003)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique a a\00E7\00E3o que voc\00EA deseja executar. As seguintes a\00E7\00F5es s\00E3o suportadas:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Dependendo da configura\00E7\00E3o do aplicativo, tamb\00E9m \00E9 poss\00EDvel ter plug-ins de a\00E7\00E3o din\00E2mica adicionais dispon\00EDveis aqui.'),
unistr('Este s\00E3o exibidos como <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('Os seguintes plug-ins s\00E3o instalados nos componentes compartilhados deste aplicativo:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580148139311003)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903667241311265)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o evento de a\00E7\00E3o din\00E2mica adequado na lista dispon\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903527925311265)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266782231311555)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL de Limpeza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266679964311555)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL de Inicializa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935685063311289)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376757709311634)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usa a defini\00E7\00E3o estabelecida nos atributos de seguran\00E7a do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559731098310987)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione como solicita\00E7\00F5es de URL externos para esta p\00E1gina s\00E3o tratadas.'),
unistr('Solicita\00E7\00F5es de p\00E1gina desse aplicativo para esta p\00E1gina n\00E3o s\00E3o consideradas link profundo e n\00E3o s\00E3o administradas por esta defini\00E7\00E3o de atributo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060762035311397)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060878261311397)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se o URL n\00E3o contiver um ID de sess\00E3o v\00E1lido, o &PRODUCT_NAME. iniciar\00E1 uma nova sess\00E3o e redirecionar\00E1 o usu\00E1rio para a home page do aplicativo, em vez de redirecion\00E1-lo para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060545992311397)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060667934311397)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se esta p\00E1gina for especificada como a p\00E1gina de destino em um URL, ele redirecionar\00E1 para esta p\00E1gina.<br>'),
unistr('Se o usu\00E1rio ainda n\00E3o estiver autenticado e a p\00E1gina n\00E3o for p\00FAblica, o usu\00E1rio ser\00E1 solicitado a fazer log-in.'),
unistr('Depois de fazer log-in com sucesso no aplicativo, o usu\00E1rio ser\00E1 redirecionado para esta p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559630843310987)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Link Profundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700829918311093)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a interface do usu\00E1rio \00E9 a interface do aplicativo padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700713461311093)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549818372310980)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a op\00E7\00E3o de build padr\00E3o aplicada a este componente ao exportar. Esta op\00E7\00E3o pode ser substitu\00EDdas por op\00E7\00F5es de exporta\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058241180311393)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368272764311628)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desativado e n\00E3o faz parte do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058341298311393)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368387181311628)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado e faz parte do aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549704448310980)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o ao Exportar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791371348311172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como o valor padr\00E3o desta coluna ser\00E1 determinado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291348247311573)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291426178311573)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como valor retornado pela <em>Express\00E3o</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291579937311573)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291683714311573)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791672389311172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791770623311172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como o valor retornado pelo estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792234999311173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792381516311173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Defina como o valor retornado da <em>Sequ\00EAncia</em> informada. Este \00E9 um tipo padr\00E3o "especial": Ele \00E9 executado como parte do processo DML da Grade Interativa  e <em>n\00E3o</em> durante o carregamento da p\00E1gina. Use este tipo para valores de chave p')
||unistr('rim\00E1ria gerados automaticamente, quando <strong>Retornar Chave(s) Prim\00E1ria(s) ap\00F3s Inser\00E7\00E3o</strong> n\00E3o puder ser usado, por exemplo, ao trabalhar com views e gatilhos INSTEAD OF ou com links de banco de dados. O nome da sequ\00EAncia n\00E3o diferencia mai')
||unistr('\00FAsculas de min\00FAsculas; use aspas duplas para indicar um nome de sequ\00EAncia com letras mai\00FAsculas e min\00FAsculas ("mySequence").</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791833531311173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791927724311173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Defina como o valor retornado pela <em>Consulta SQL</em> informada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792091884311173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'pt-br'
,p_message_text=>'A Consulta SQL que retorna uma Lista Delimitada por Dois-Pontos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792135278311173)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defina a lista de valores delimitada por dois-pontos retornada pela <em>Consulta SQL</em> informada.</p>',
unistr('        <p>Observa\00E7\00E3o - s\00E3o necess\00E1rias listas delimitadas por dois-pontos quando a coluna \00E9 exibida como uma caixa de sele\00E7\00E3o, um grupo de bot\00F5es de r\00E1dio ou um bot\00E3o de vaiv\00E9m.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791442073311172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791513424311172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como o valor inserido no valor <em>Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791276536311172)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314405491311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314857983311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314725905311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314633638311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314943183311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314556794311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314376897311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316485677311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316773585311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316605673311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316550875311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316859652311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316334678311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939382652311292)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo que cont\00E9m o valor padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939221767311292)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316078641311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o Java que gere o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315943016311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317611087311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o Java que retorne o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317573543311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315808708311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER"? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315734412311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o JavaScript que gere o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315679993311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317413282311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317313756311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o JavaScript que retorne o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317289460311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315565034311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315497570311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o PL/SQL que gerar o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315338345311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317120494311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317002145311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o PL/SQL que retorna o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316980023311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316247200311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o Python que gere o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107316155276311591)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317823921311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo da fun\00E7\00E3o Python que retorne o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317762331311592)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792985871311173)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome da sequ\00EAncia de banco de dados que retorna o valor padr\00E3o para esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792865663311173)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315257254311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'               from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315108674311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o SQL que gere o valor para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107315011607311590)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792515955311173)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a consulta SQL que retorna o valor padr\00E3o para esta coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792482803311173)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792718888311173)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a consulta SQL que retorna a lista de valores delimitada por dois-pontos para esta coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106792691316311173)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dois-pontos na Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573409705310998)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um valor padr\00E3o para este item. O valor padr\00E3o \00E9 usado quando o valor do item n\00E3o deriva do estado da sess\00E3o e quando o valor de origem \00E9 nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573342795310998)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573273879310997)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de valor padr\00E3o para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290741424311573)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290898048311573)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como valor retornado pela <em>Express\00E3o</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290907168311573)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291061596311573)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384153116310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384259341310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como o valor retornado pelo estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384785925310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384861768310850)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Defina como o valor retornado da <em>Sequ\00EAncia</em> informada. Este \00E9 um tipo padr\00E3o "especial": ele \00E9 executado como parte do processo DML da Regi\00E3o de Form e <em>n\00E3o</em> durante o carregamento da p\00E1gina. Use este tipo para valores de chave prim')
||unistr('\00E1ria gerados automaticamente, quando a op\00E7\00E3o <strong>Retornar Chave(s) Prim\00E1ria(s) ap\00F3s Inser\00E7\00E3o</strong> n\00E3o puder ser usada, por exemplo, ao trabalhar com views e triggers INSTEAD OF ou com links de banco de dados. O nome da sequ\00EAncia diferencia ma')
||unistr('i\00FAsculas de min\00FAsculas.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384386903310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384426685310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Defina como o valor retornado pela <em>Consulta SQL</em> informada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384556599310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'pt-br'
,p_message_text=>'A Consulta SQL que retorna uma Lista Delimitada por Dois-Pontos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384669979310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defina a lista de valores delimitada por dois-pontos retornada pela <em>Consulta SQL</em> informada.</p>',
unistr('        <p>Observa\00E7\00E3o - s\00E3o necess\00E1rias listas delimitadas por dois-pontos quando a coluna \00E9 exibida como uma caixa de sele\00E7\00E3o, um grupo de bot\00F5es de r\00E1dio ou um bot\00E3o de vaiv\00E9m.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075565711311408)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384047062310849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como o valor inserido no valor <em>Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573191490310997)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802939634311186)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se os usu\00E1rios finais podem definir um gr\00E1fico para esta Grade Interativa.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802840950311186)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir View do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778553146311161)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione um esquema de autoriza\00E7\00E3o para restringir quem pode excluir linhas.'),
unistr('		Para permitir que um usu\00E1rio final exclua linhas, esse esquema de autoriza\00E7\00E3o deve ser avaliado como VERDADEIRO para esse usu\00E1rio.'),
unistr('		Se nenhum esquema de autoriza\00E7\00E3o for fornecido, nenhum usu\00E1rio poder\00E1 excluir linhas nesta grade interativa.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778490526311161)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911953445311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique uma condi\00E7\00E3o que verifica o valor de outra Faceta ou Filtro para controlar se a Faceta ou Filtro atual deve ser exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912051623311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'igual a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912155538311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor da depend\00EAncia de <em>Faceta ou Filtro</em> \00E9 igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912471250311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>'na lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912592764311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor da depend\00EAncia de <em>Faceta ou Filtro</em> est\00E1 na <em>Lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912246903311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'diferente de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912388408311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor da depend\00EAncia de <em>Faceta ou Filtro</em> n\00E3o \00E9 igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912697976311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 na lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912738420311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor da depend\00EAncia de <em>Faceta ou Filtro</em> n\00E3o est\00E1 na <em>Lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913077467311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o \00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913178485311273)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor da depend\00EAncia de <em>Faceta ou Filtro</em> n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912844501311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106912994925311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor da depend\00EAncia de <em>Faceta ou Filtro</em> est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911893660311272)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913558573311273)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de valores separados por v\00EDrgulas para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913468428311273)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913327683311273)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor desta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106913221773311273)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911715062311271)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione a Faceta associada que deve ser verificada para decidir se a Faceta atual deve ser exibida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106911602835311271)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Faceta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237225697311529)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a caixa de sele\00E7\00E3o associada que deve ser marcada para decidir se a caixa de sele\00E7\00E3o atual deve ser exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237101557311529)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599784567311017)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o Filtro associado que deve ser marcado para decidir se o Filtro atual deve ser exibido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599606441311017)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599995337311017)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a caixa de sele\00E7\00E3o associada que deve ser marcada para decidir se a caixa de sele\00E7\00E3o atual deve ser exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599832839311017)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151866488311465)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'$$$ DJP atualmente oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942740950311299)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Derivada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457258166311691)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma descri\00E7\00E3o para este Relat\00F3rio Interativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886388168311252)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma descri\00E7\00E3o do grupo de colunas. Esta descri\00E7\00E3o nunca \00E9 exibida aos usu\00E1rios finais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553845093310983)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma descri\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553728457310983)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092295083311420)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894594930311258)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o HTML a ser exibido ap\00F3s as linhas do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894465831311258)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s as Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092079576311420)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894157012311258)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o HTML a ser exibido antes das linhas do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894001300311258)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Antes das Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793843820311174)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a View Detalhada deve ficar ativada. A sele\00E7\00E3o de <strong>Ativado</strong> adiciona um \00EDcone de Detalhes de View \00E0 barra de Pesquisa para relat\00F3rios interativos, ou ao bot\00E3o View de grade interativa, permitindo aos usu\00E1rios acessar ess')
||'a view.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893962330311257)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a View Detalhada deve ficar ativada. A sele\00E7\00E3o de <strong>Ativado</strong> adiciona um \00EDcone de Detalhes de View \00E0 barra de Pesquisa para relat\00F3rios interativos, ou ao bot\00E3o View de grade interativa, permitindo aos usu\00E1rios acessar ess')
||'a view.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893890016311257)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454742826311690)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454887380311690)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o corpo das linhas do relat\00F3rio na View Detalhada.</p>'),
unistr('<p>As seguintes strings de substitui\00E7\00E3o est\00E3o dispon\00EDveis:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - strings de substitui\00E7\00E3o para nomes de coluna.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - strings de substitui\00E7\00E3o para labels de coluna.</li>'),
'<li><code>&APEX$ROW_ID.</code> - o identificador de registro para a linha.</li>',
unistr('<li><code>&APEX$ROW_INDEX.</code> - o n\00FAmero de sequ\00EAncia de exibi\00E7\00E3o de registro.</li>'),
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - o estado do registro, como <code>is-inserted</code> ou <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092136714311420)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894381460311258)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo das linhas do relat\00F3rio na View Detalhada. Use as strings de substitui\00E7\00E3o <code>#COLUMN_NAME#</ code> para os nomes e labels de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894240305311258)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Para Cada Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553673805310983)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O suporte \00E0 caixa de di\00E1logo no &PRODUCT_NAME. varia dependendo da interface de usu\00E1rio da p\00E1gina.'),
unistr('Um subconjunto de atributos de caixa de di\00E1logo s\00E3o declarativamente suportados: <em>altura, largura e largura m\00E1xima</em>.'),
unistr('Para definir qualquer atributo adicional para a caixa de di\00E1logo, informe os pares nome/valor em uma lista separada por v\00EDrgulas.</p>'),
unistr('<p>A string de substitui\00E7\00E3o <code>#DIALOG_ATTRIBUTES#</code> no c\00F3digo de inicializa\00E7\00E3o da caixa de di\00E1logo definida no n\00EDvel do modelo de p\00E1gina \00E9 substitu\00EDda por quaisquer valores informados nesse item.</p>'),
unistr('<p>Para p\00E1ginas que usam interface de usu\00E1rio de Desktop, o widget de caixa de di\00E1logo jQuery UI \00E9 utilizado.'),
unistr('Para p\00E1ginas que usam interface de usu\00E1rio de Smartphone jQuery Mobile, o widget dE caixa de di\00E1logo jQuery Mobile \00E9 utilizado.</p>'),
unistr('<p>Por exemplo, uma p\00E1gina de caixa de di\00E1logo que usa uma interface de usu\00E1rio de Desktop pode ter os seguintes atributos definidos: <code>resizable:true, draggable:true</code></p>'),
unistr('<p>Para obter mais informa\00E7\00F5es sobre atributos dispon\00EDveis, consulte a <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documenta\00E7\00E3o do widget de caixa de di\00E1logo jQuery UI</a> e a <a rel="noreferrer" target="_blank" href="h')
||unistr('ttp://api.jqueryui.com/dialog/">documenta\00E7\00E3o do widget de caixa de di\00E1logo jQuery Mobile</a>.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553583566310983)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244143806311537)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione <strong>Ativado</strong> se esta caixa de di\00E1logo for aberta por outra caixa de di\00E1logo e tiver que reutilizar a mesma janela da caixa de di\00E1logo.'),
unistr('Por exemplo, se essa caixa de di\00E1logo fizer parte de um assistente da caixa de di\00E1logo de v\00E1rias p\00E1ginas e voc\00EA quiser reutilizar a janela da caixa de di\00E1logo para cada etapa do assistente.<p><p>'),
unistr('Selecione <strong>Desativado</strong> se esta caixa de di\00E1logo for aberta por outra caixa de di\00E1logo e tiver que ser aberta em uma nova janela da caixa de di\00E1logo. Por exemplo, quando essa caixa de di\00E1logo \00E9 modal'),
unistr(' e voc\00EA quer abri-la em uma janela modal m\00E3e.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244004205311537)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Encadeado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955434753311310)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955394507311310)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643982275311050)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe a altura da caixa de di\00E1logo, em pixels, por exemplo, <strong><em>500</em></strong>.'),
unistr('A string de substitui\00E7\00E3o <code>#DIALOG_HEIGHT#</code> no c\00F3digo de inicializa\00E7\00E3o da caixa de di\00E1logo do modelo da p\00E1gina ser\00E1 substitu\00EDda pelo valor especificado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643860945311049)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553440616310982)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a largura m\00E1xima da caixa de di\00E1logo em pixels.'),
unistr('A string de substitui\00E7\00E3o <code>#DIALOG_MAX_WIDTH#</code> no c\00F3digo de inicializa\00E7\00E3o da caixa de di\00E1logo do modelo de p\00E1gina \00E9 substitu\00EDda pelo valor inserido neste item.</p>'),
unistr('<p>Para uma p\00E1gina que usa a interface de usu\00E1rio de Smartphone jQuery Mobile, a largura m\00E1xima \00E9 <strong><em>500</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553336110310982)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935323197311289)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688993847311084)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um modelo de caixa de di\00E1logo para definir a apar\00EAncia e o layout desta p\00E1gina.</p>'),
unistr('        <p>Os modelos de caixa de di\00E1logo s\00E3o definidos no tema do aplicativo.'),
unistr('        Quando uma p\00E1gina de caixa de di\00E1logo \00E9 criada, o modelo \00E9 automaticamente definido como <em>Padr\00E3o de Tema</em>, o qual converter\00E1 a p\00E1gina usando o modelo de p\00E1gina padr\00E3o definido no tema atual.'),
unistr('        O ato de fazer uma sele\00E7\00E3o aqui substitui o modelo de caixa de di\00E1logo padr\00E3o.</p>'),
unistr('        <p>O Universal Theme fornece os seguintes modelos de caixa de di\00E1logo:'),
'          <dl>',
unistr('            <dt>Caixa de Di\00E1logo Modal</dt>'),
unistr('              <dd>\00DAtil para a maioria dos casos de uso de caixa de di\00E1logo.</dd>'),
unistr('            <dt>Caixa de Di\00E1logo Modal de Assistente</dt>'),
unistr('              <dd>Fornece uma interface de usu\00E1rio agilizada e \00E9 bem adequada para assistentes, alertas, notifica\00E7\00F5es ou pequenos forms de caixa de di\00E1logo modal.</dd>'),
'          </dl>',
unistr('          Consulte Tamb\00E9m: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Amostra de Aplicativo do Universal Theme</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688807136311084)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo da Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553214255310982)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a largura da caixa de di\00E1logo, em pixels ou um percentual.'),
unistr('A string de substitui\00E7\00E3o <code>#DIALOG_WIDTH#</code> no c\00F3digo de inicializa\00E7\00E3o da caixa de di\00E1logo do modelo de p\00E1gina \00E9 substitu\00EDdo pelo valor inserido neste item.</p>'),
unistr('<p>Para uma p\00E1gina que usa uma interface de usu\00E1rio de Desktop, o valor \00E9 definido em pixels, como <strong><em>500</em></strong>.'),
unistr('No entanto, para uma p\00E1gina que usa a interface de usu\00E1rio de Smartphone jQuery Mobile, o valor \00E9 definido em percentual, como <strong><em>80%</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553159002310982)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871256038311240)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a dire\00E7\00E3o do par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871382723311240)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871520994311240)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada/Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871446498311240)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sa\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871136903311240)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dire\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917374525311276)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica se esta coluna pode ser usada pelo usu\00E1rio final para classificar o relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917224250311276)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classific\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948930086311305)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a \00FAnica coluna a ser exibida nas c\00E9lulas do calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106948832694311305)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564622920310991)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Um item pode ter um valor de estado de sess\00E3o que n\00E3o ocorre na lista de defini\00E7\00E3o valores especificada.'),
unistr('Selecione se essa lista de valores exibir\00E1 esse valor extra de estado de sess\00E3o.'),
unistr('Se voc\00EA optar por n\00E3o exibir esse valor extra de estado da sess\00E3o e n\00E3o houver valor correspondente na lista de defini\00E7\00E3o de valores, o primeiro valor da lista de valores ser\00E1 o valor selecionado e exibido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564555747310991)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Valores Extras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564864352310991)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a lista de valores usados para este item exibir\00E1 um valor NULO no topo da lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564736594310991)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Valor Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607450079311023)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o usada para exibir este componente. As posi\00E7\00F5es s\00E3o derivadas dos pontos de exibi\00E7\00E3o apropriados do modelo da p\00E1gina ou regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607321008311023)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262535871311550)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe a sequ\00EAncia de exibi\00E7\00E3o para essa a\00E7\00E3o.'),
unistr('Ela \00E9 usada para avaliar a condi\00E7\00E3o de exibi\00E7\00E3o e renderiza\00E7\00E3o na ordem definida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794231810311175)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a sequ\00EAncia de exibi\00E7\00E3o para esta coluna. A defini\00E7\00E3o de sequ\00EAncia determina onde esta coluna ser\00E1 exibida em rela\00E7\00E3o a outras colunas da regi\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: se duas colunas, da mesma regi\00E3o, tiverem o mesmo valor de sequ\00EAncia, elas poder\00E3o ser exibidas em outra ordem quando o aplicativo for exportado e importado em outro ambiente, como um ambiente de teste ou de produ\00E7\00E3o.'),
unistr('Para garantir a consist\00EAncia, a Oracle recomenda especificar n\00FAmeros de sequ\00EAncia \00FAnicos para cada item ou pelo menos para aqueles da mesma regi\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886236883311251)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a sequ\00EAncia de exibi\00E7\00E3o deste grupo de colunas. A sequ\00EAncia determina a ordem na qual os grupos de colunas s\00E3o exibidos na view detalhada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220047852311517)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a sequ\00EAncia de exibi\00E7\00E3o desta camada. A defini\00E7\00E3o da sequ\00EAncia determina a ordem em que as camadas do mapa s\00E3o exibidas umas sobre as outras. Camadas com n\00FAmeros maiores s\00E3o exibidas acima das camadas com n\00FAmeros menores.</p>'),
unistr('<p>Observa\00E7\00E3o: Se duas camadas do mapa tiverem o mesmo valor de sequ\00EAncia, elas poder\00E3o ser exibidas em outra ordem quando o aplicativo for exportado e importado para outro ambiente, como um ambiente de teste ou de produ\00E7\00E3o.'),
unistr('Para garantir a consist\00EAncia, a Oracle recomenda especificar n\00FAmeros de sequ\00EAncia exclusivos para cada camada, ou pelo menos para aquelas dentro da mesma regi\00E3o do mapa.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583088277311005)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a sequ\00EAncia de exibi\00E7\00E3o para este item. A sequ\00EAncia e outras defini\00E7\00F5es de layout determinam onde este item ser\00E1 exibido em rela\00E7\00E3o a outros itens da regi\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: Se dois itens, de uma mesma regi\00E3o, tiverem o mesmo valor de sequ\00EAncia, eles poder\00E3o ser exibidos em uma ordem diferente quando o aplicativo for exportado e importado para outro ambiente, como um ambiente de teste ou de produ\00E7\00E3o. Para ')
||unistr('garantir a consist\00EAncia, a Oracle recomenda especificar n\00FAmeros de sequ\00EAncia \00FAnicos para cada item ou pelo menos para aqueles na mesma regi\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582900950311005)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404195195311654)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um esquema de autoriza\00E7\00E3o para restringir quem pode fazer download.'),
unistr('		Para permitir que um usu\00E1rio final fa\00E7a download, esse esquema de autoriza\00E7\00E3o dever\00E1 ser avaliado como VERDADEIRO para esse usu\00E1rio.</p>'),
unistr('		<p>Observa\00E7\00E3o - Se nenhum esquema de autoriza\00E7\00E3o for fornecido, qualquer usu\00E1rio poder\00E1 fazer download.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404082836311654)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926779239311283)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um nome para o arquivo de download CSV. Se nenhum nome for especificado, o nome da regi\00E3o ser\00E1 usado seguido da extens\00E3o .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937810693311291)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um nome para o arquivo de download CSV. Se nenhum nome for especificado, o nome da regi\00E3o ser\00E1 usado seguido da extens\00E3o .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921871277311279)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome de arquivo para o documento quando submetido a download. N\00E3o especifique uma extens\00E3o de arquivo. A extens\00E3o ser\00E1 adicionada automaticamente. Se esse atributo ficar em branco, o nome da regi\00E3o ser\00E1 usado como o nome do arquivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921711127311279)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889105701311254)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Verifique quais formatos de download os usu\00E1rios podem utilizar para fazer download das colunas exibidas no momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089591807311419)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'pt-br'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089612652311419)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'pt-br'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089738656311419)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'pt-br'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164415252311475)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889002129311254)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formatos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924671203311281)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o texto do link para chamar o download de CSV.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924502822311281)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921098841311278)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto a ser usado para o link de download na p\00E1gina. Os usu\00E1rios finais usam este link para fazer download do conte\00FAdo BLOB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106920940155311278)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952446130311308)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione um esquema de autoriza\00E7\00E3o para limitar quem tem direitos de atualizar eventos de calend\00E1rio existentes usando arrastar e soltar.'),
unistr('Se especificado, esse esquema de autoriza\00E7\00E3o dever\00E1 ser avaliado como VERDADEIRO para que a a\00E7\00E3o arrastar e soltar seja processada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952392043311308)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111078750311435)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Processo personalzado</dt>',
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952229653311308)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina o processo a ser executado ao arrastar e soltar uma entrada do Calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952103466311308)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793171572311174)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a coluna dever\00E1 utilizar como padr\00E3o o valor de coluna existente durante a duplica\00E7\00E3o do registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793086216311174)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Duplica\00E7\00E3o Copia Valor Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106591015548311011)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Verifique se h\00E1 suporte para opera\00E7\00F5es de linguagem de manipula\00E7\00E3o de dados (DML). Este processo executar\00E1 opera\00E7\00F5es de DML com base no atributo <strong>A\00E7\00E3o de Banco de Dados</strong> do bot\00E3o para submeter a p\00E1gina. Se esse atributo n\00E3o for defi')
||unistr('nido, a opera\00E7\00E3o ser\00E1 determinada pelo valor de Solicita\00E7\00E3o do bot\00E3o, que \00E9 definido com base no Nome do Bot\00E3o, como se segue:</p>'),
'<ul>',
unistr('A op\00E7\00E3o <li><strong>Adicionar Linhas</strong> \00E9 acionada pelos Valores de Solicita\00E7\00E3o: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>'),
unistr('A op\00E7\00E3o <li><strong>Atualizar Linha</strong> \00E9 acionada pelos Valores de Solicita\00E7\00E3o: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>'),
unistr('A op\00E7\00E3o <li><strong>Excluir Linha</strong> \00E9 acionada pelos Valores de Solicita\00E7\00E3o: DELETE, REMOVE, DELETE ROW, DROP</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777443434311160)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifique quais opera\00E7\00F5es de manipula\00E7\00E3o de dados s\00E3o permitidas nesta grade interativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777729995311161)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777589535311161)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777689825311161)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777330095311160)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00F5es Permitidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777971573311161)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione uma coluna na qual seu valor indica se a linha pode ser atualizada e/ou exclu\00EDda. Os valores permitidos s\00E3o:'),
'        <dl>',
'          <dt>U</dt>',
'            <dd>Linha pode ser atualizada</dd>',
'          <dt>D</dt>',
unistr('            <dd>Linha pode ser exclu\00EDda</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>Linha pode ser atualizada ou exclu\00EDda</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777875252311161)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Opera\00E7\00F5es de Linha Permitidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569696360310995)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o alinhamento do item na c\00E9lula da tabela HTML que o cont\00E9m.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073291260311406)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado embaixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073366926311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073435664311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado em cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073141711311406)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073647727311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Embaixo \00E0 esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073759468311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Centralizado \00E0 esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073846556311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em cima \00E0 esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073520175311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074034134311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Embaixo \00E0 direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074154451311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Centralizado \00E0 direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074279034311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No alto \00E0 direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073978636311407)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565598257310992)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570256469310995)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a altura (n\00FAmero aproximado de linhas) para as \00E1reas de texto, shuttles, listas com v\00E1rias sele\00E7\00F5es e quaisquer tipos de itens de plug-in que suportem o atributo Tem Atributo de Altura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570163670310995)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955751904311310)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570015060310995)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero m\00E1ximo de caracteres que os usu\00E1rios podem digitar neste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569919394310995)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tamanho M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955873851311310)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'caracteres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570688991310995)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe atributos adicionais delimitados por espa\00E7o para a c\00E9lula da tabela HTML usada para exibir cada op\00E7\00E3o de um grupo de bot\00F5es de op\00E7\00E3o ou conjunto de caixas de sele\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570533261310995)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos HTML de Op\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571040840310996)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os atributos adicionais exibidos ap\00F3s a c\00E9lula da tabela HTML que exibe cada op\00E7\00E3o individual em um grupo de bot\00F5es de op\00E7\00E3o ou um conjunto de caixas de sele\00E7\00E3o.'),
unistr('Voc\00EA pode incluir HTML, JavaScript e atalhos.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia \00E0s seguintes strings de substitui\00E7\00E3o:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do elemento do form HTML ao qual este item de p\00E1gina est\00E1 associado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do item da p\00E1gina atual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570982276310996)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-texto ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570826445310996)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os atributos adicionais exibidos antes da c\00E9lula da tabela HTML que exibe cada op\00E7\00E3o individual em um grupo de bot\00F5es de op\00E7\00E3o ou um conjunto de caixas de sele\00E7\00E3o.'),
unistr('Voc\00EA pode incluir HTML, JavaScript e atalhos.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia \00E0s seguintes strings de substitui\00E7\00E3o:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do elemento do form HTML ao qual este item de p\00E1gina est\00E1 associado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obt\00E9m o nome do item da p\00E1gina atual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570741378310996)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00E9-texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570467340310995)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o texto de dica exibido neste item quando nenhum valor for especificado para esse item. Depois que qualquer texto \00E9 inserido no item, a dica \00E9 removida.</p>'),
unistr('<p>Este atributo de marcador de espa\00E7o especifica uma dica curta que pode ser usada para descrever o valor esperado do item de uma p\00E1gina.'),
unistr('Essas dicas s\00E3o \00FAteis para fornecer um valor de amostra, um exemplo do formato esperado ou instru\00E7\00F5es, como: Pesquisa sobre o t\00EDtulo, descri\00E7\00E3o e tag.'),
unistr('Por motivos de acessibilidade, este atributo n\00E3o deve ser utilizado como uma alternativa para um label significativo bem definido.</p>'),
unistr('<p><strong>Aten\00E7\00E3o:</strong> Este \00E9 um recurso do HTML5 e funcionar\00E1 somente em browsers modernos! Os browser antigos n\00E3o exibir\00E3o o texto especificado nesse atributo.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106570327030310995)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Marcador de Espa\00E7o de Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569804605310995)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a largura do elemento do form a ser usada para exibir este item.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569735706310995)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955617620311310)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'caracteres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090673631311419)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891927395311256)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um endere\00E7o de e-mail v\00E1lido a ser usado como o endere\00E7o <em>De</em> ao enviar um e-mail a partir deste relat\00F3rio. Os e-mails s\00E3o enviados a partir deste relat\00F3rio para Downloads do tipo E-mail e para Inscri\00E7\00F5es.</p>'),
unistr('<p>O valor pode ser uma string literal contendo um endere\00E7o de e-mail v\00E1lido ou uma refer\00EAncia de substitui\00E7\00E3o est\00E1tica definida no aplicativo usando a sintaxe de substitui\00E7\00E3o.'),
unistr('Usar uma substitui\00E7\00E3o de item da p\00E1gina ou do aplicativo N\00C3O \00E9 recomend\00E1vel, pois s\00F3 funciona no download de e-mail e faz com que qualquer e-mail de inscri\00E7\00E3o falhe, uma vez que esses itens n\00E3o podem ser acessados de fora de uma sess\00E3o v\00E1lida.'),
unistr('As inscri\00E7\00F5es s\00E3o enviadas diretamente do mecanismo do &PRODUCT_NAME. e n\00E3o de uma sess\00E3o de usu\00E1rio.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891860562311256)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o de E-mail - De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803500296311186)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais poder\00E3o usar esta coluna em quebras de controle e agrega\00E7\00F5es.</p>'),
unistr('        <p>Observa\00E7\00E3o - A permiss\00E3o dessas opera\00E7\00F5es pode levar a problemas de desempenho, especialmente em grandes conjuntos de dados ou onde n\00E3o haja \00EDndices de colunas apropriados dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803481084311186)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quebra de Controle/Agrega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781956006311164)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem fazer download do relat\00F3rio para um dos formatos de download especificados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781819427311164)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786010865311168)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem filtrar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785923777311168)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802774085311186)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem utilizar consultas de flashback para esta Grade Interativa.</p>'),
unistr('<p>As consultas de flashback utilizam a Tecnologia de Flashback e a Recupera\00E7\00E3o Pontual de Banco de Dados Oracle para exibir dados como existiam em um momento anterior. Os usu\00E1rios podem consultar esses dados apenas, mas n\00E3o podem reverter altera\00E7\00F5es')
||unistr(' de dados. O ponto passado at\00E9 onde eles podem executar uma consulta de flashback com sucesso \00E9 determinado por quando os arquivos de redo log foram alternados pela \00FAltima vez no banco de dados Oracle, pois essa tecnologia utiliza o backup RMAN.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802610851311186)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803370080311186)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem ocultar esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803269756311186)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782561320311165)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais poder\00E3o enviar um e-mail, com o download do relat\00F3rio inclu\00EDdo como um anexo.</p>'),
unistr('<p>O e-mail s\00F3 est\00E1 dispon\00EDvel para usu\00E1rios autenticados e requer que o SMTP seja configurado no aplicativo Administration Services (Servi\00E7os de Administra\00E7\00E3o) do &PRODUCT_NAME. por um Administrador de Inst\00E2ncias.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782462667311165)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar como E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031521316311372)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja ativar a impress\00E3o do relat\00F3rio. Ao selecionar <strong>Ativado</strong>, voc\00EA permite que os usu\00E1rios fa\00E7am download de um relat\00F3rio em v\00E1rios formatos, incluindo PDF, Microsoft Word, Microsoft Excel e HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031443785311372)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781333425311164)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais poder\00E3o salvar sua defini\00E7\00E3o de relat\00F3rio atual como um relat\00F3rio <em>P\00FAblico</em>.</p>'),
unistr('		<p>Os relat\00F3rios p\00FAblicos s\00E3o exibidos em uma lista de sele\00E7\00E3o de relat\00F3rios dispon\00EDveis na Barra de Ferramentas e s\00E3o exibidos para todos os usu\00E1rios.<p>'),
unistr('		<p>Observa\00E7\00E3o - Esta op\00E7\00E3o s\00F3 est\00E1 dispon\00EDvel para usu\00E1rios autenticados e ser\00E1 ainda mais restritiva se voc\00EA preencher <strong>Salvar Autoriza\00E7\00E3o de Relat\00F3rio P\00FAblico</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781237593311164)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791154323311172)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem utilizar essa coluna na classifica\00E7\00E3o.</p>'),
unistr('        <p>Observa\00E7\00E3o - A permiss\00E3o de uma opera\00E7\00E3o de classifica\00E7\00E3o pode levar a problemas de desempenho, especialmente em conjuntos de dados grandes ou onde \00EDndices de coluna apropriados n\00E3o est\00E3o dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106791081632311172)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781746252311164)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir configura\00E7\00F5es de inscri\00E7\00E3o para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781608604311164)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578447921311002)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se deseja criptografar este item quando armazenado no estado da sess\00E3o.'),
unistr('Se o conte\00FAdo de um item contiver dados confidenciais, criptografe o valor quando ele for armazenado nas tabelas de gerenciamento de estado de sess\00E3o do &PRODUCT_NAME.'),
unistr('Caso contr\00E1rio, qualquer pessoa com direitos para ler as tabelas de metadados do &PRODUCT_NAME. poder\00E1 gerar uma consulta para extrair esses dados confidenciais.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578321835311002)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Armazenar valor criptografado no estado da sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949925504311306)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o \00FAltimo dia da semana exibido no calend\00E1rio semanal.'),
unistr('Voc\00EA pode usar esse atributo em conjunto com <strong>Dia de In\00EDcio </strong> para restringir os dias da semana exibidos, ou selecione o dia anterior ao valor <strong>Dia de In\00EDcio</strong> para mostrar todos os sete dias.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109288475311433)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'pt-br'
,p_message_text=>'Domingo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109374471311433)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'pt-br'
,p_message_text=>'Segunda-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109431895311433)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ter\00E7a-feira')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109510991311434)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quarta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109666545311434)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quinta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109715372311434)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sexta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109862075311434)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E1bado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949846229311305)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dia de T\00E9rmino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950566023311306)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite a hora de t\00E9rmino para focar a exibi\00E7\00E3o do calend\00E1rio semanal e di\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950462281311306)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio de T\00E9rmino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951844117311307)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no alvo para chamar uma caixa de di\00E1logo modal. Voc\00EA pode inserir o link de destino que o calend\00E1rio chamar\00E1 para exibir os detalhes de um evento existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951755684311307)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alvo do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552094831310981)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome da fun\00E7\00E3o PL/SQL chamada quando um erro ocorre no aplicativo.'),
unistr('Voc\00EA pode usar essa fun\00E7\00E3o para agir em v\00E1rios c\00F3digos de erro incluindo aqueles provenientes do banco de dados Oracle e registrar esses erros em uma tabela personalizada que voc\00EA definir\00E1, se necess\00E1rio.'),
unistr('A fun\00E7\00E3o pode incluir l\00F3gica para modificar a mensagem de erro e exibir o local, transformando os erros do banco de dados Oracle em mensagens de f\00E1cil utiliza\00E7\00E3o.'),
unistr('Por exemplo, voc\00EA pode capturar uma viola\00E7\00E3o de chave \00FAnica em <code>DEMO_CUSTOMERS</code> e substituir a mensagem <code>ORA-00001</code> por este texto: O nome do Cliente deve ser exclusivo.'),
unistr('Instalar o Exemplo de Aplicativo de Banco de Dados, contido nos Aplicativos Empacotados, cria o pacote <code>SAMPLE_PKG</code>, que inclui a fun\00E7\00E3o <code>demo_error_handling</code>.'),
unistr('Esse exemplo de fun\00E7\00E3o de tratamento de erro inclui coment\00E1rios extensos para facilitar o uso como base para defini\00E7\00E3o de sua pr\00F3pria fun\00E7\00E3o.</p>'),
unistr('<p>O nome da fun\00E7\00E3o especificada pode fazer refer\00EAncia a uma fun\00E7\00E3o de pacote ou fun\00E7\00E3o stand-alone do banco de dados. Por exemplo:'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>Ao fazer refer\00EAncia a um pacote PL/SQL do banco de dados ou fun\00E7\00E3o stand-alone, voc\00EA pode usar a string de substitui\00E7\00E3o <code>#OWNER#</code> para fazer refer\00EAncia ao esquema de parse do aplicativo atual.Por exemplo:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>Se uma fun\00E7\00E3o de tratamento de erro for especificada em uma p\00E1gina, ela ser\00E1 utilizada em vez da defini\00E7\00E3o no n\00EDvel do aplicativo para esta p\00E1gina.</p>'),
unistr('<p>As Fun\00E7\00F5es de Tratamento de Erro devem implementar a seguinte interface:'),
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p>Consulte o manual de Refer\00EAncia da API para obter uma descri\00E7\00E3o do pacote <code>apex_error</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561610490310989)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o para Tratamento de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268246807311556)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite uma mensagem de erro que ser\00E1 exibida se esse c\00E1lculo falhar.'),
unistr('    Use <code>#SQLERRM#</code> como uma string de substitui\00E7\00E3o para a mensagem de erro SQL resultante de um c\00E1lculo com falha.</p>'),
unistr('    <p>Os c\00E1lculos s\00E3o projetados para sempre dar certo e s\00F3 falham devido a erros inesperados.'),
unistr('    N\00E3o \00E9 aconselh\00E1vel implementar um c\00E1lculo que falhe regularmente e que atue como uma pseudovalida\00E7\00E3o utilizando esta mensagem de erro.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589800732311010)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite uma mensagem de erro que ser\00E1 exibida se esse c\00E1lculo falhar.'),
unistr('    Use <code>#SQLERRM#</code> como uma string de substitui\00E7\00E3o para a mensagem de erro SQL resultante de um c\00E1lculo com falha.</p>'),
unistr('    <p>Os c\00E1lculos s\00E3o projetados para sempre dar certo e s\00F3 falham devido a erros inesperados.'),
unistr('    N\00E3o \00E9 aconselh\00E1vel implementar um c\00E1lculo que falhe regularmente e que atue como uma pseudovalida\00E7\00E3o utilizando esta mensagem de erro.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903464451311265)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a mensagem de erro para este processo.',
unistr('Essa mensagem \00E9 exibida se uma exce\00E7\00E3o n\00E3o tratada for gerada. Ap\00F3s a interrup\00E7\00E3o de qualquer processamento de erro, ser\00E1 emitido um rollback e uma mensagem de erro ser\00E1 exibida.</p>'),
unistr('<p>Observa\00E7\00E3o: a mensagem de erro SQL (sqlerrm) \00E9 exibida por padr\00E3o se <strong>Na P\00E1gina de Erro</strong> for definido como o local de exibi\00E7\00E3o do erro, n\00E3o \00E9 necess\00E1rio adicionar <code>#SQLERRM#</code> ao texto de erro.</p>'),
unistr('<p>As mensagens de erro podem incluir as seguintes strings de substitui\00E7\00E3o:</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>Texto da mensagem de erro sem o n\00FAmero do erro.</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
'  <dd>Mensagem de erro completa.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462698432311695)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ter algum valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550411784310980)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o texto a ser exibido caso a valida\00E7\00E3o n\00E3o seja aprovada.</p>'),
unistr('<p>Voc\00EA pode usar <code>#LABEL#</code> como marcador do label do item de p\00E1gina associado ou <code>#COLUMN_HEADER#</code> para o cabe\00E7alho da coluna de regi\00E3o edit\00E1vel associada. Os marcadores n\00E3o ser\00E3o suportados se o local de exibi\00E7\00E3o do erro estiv')
||unistr('er definido como Na P\00E1gina de Erro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550333232310980)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661880662311063)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione onde a mensagem de erro ser\00E1 exibida para essa valida\00E7\00E3o.'),
unistr('Mensagens de erro de valida\00E7\00E3o s\00E3o exibidas em uma p\00E1gina de erro separada ou em linha com a p\00E1gina existente.'),
unistr('Mensagens de erro em linha s\00E3o exibidas abaixo do label <em>Item Associado</em> e/ou em uma \00E1rea de Notifica\00E7\00E3o, definida como parte do modelo de p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082419157311413)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Linha com Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082325335311413)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha com Campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082206946311413)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Linha com Campo e em Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082580399311413)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em P\00E1gina de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661702866311063)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Local de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578695800311002)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Para impedir ataques de XSS (Cross-Site Scripting), defina sempre este atributo como <strong>Ativado</strong>.',
unistr('Se for necess\00E1rio renderizar tags HTML armazenadas no item da p\00E1gina ou nas entradas de uma lista de valores, voc\00EA poder\00E1 definir esse flag como <strong>Desativado</strong>.'),
unistr('Nesses casos, tome precau\00E7\00F5es adicionais para garantir que qualquer entrada do usu\00E1rio nesses campos tenha o escape correto quando especificada e antes de salvar.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578507177311002)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Caracteres especiais de escape'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550636533310980)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esquemas de autoriza\00E7\00E3o s\00E3o avaliados no primeiro uso em uma sess\00E3o.'),
unistr('Selecione o ponto de avalia\00E7\00E3o apropriado para determinar se o uso subsequente da autoriza\00E7\00E3o especificada obt\00E9m o resultado da mem\00F3ria ou reavalia o esquema de autoriza\00E7\00E3o.</p>'),
'#LOV_VALUES#',
unistr('<p>O valor padr\00E3o <em>Uma vez por sess\00E3o</em> \00E9 o mais eficiente.'),
unistr('Escolha outro valor se a verifica\00E7\00E3o de autoriza\00E7\00E3o depender de altera\00E7\00E3o de estado de sess\00E3o ou de outros fatores que n\00E3o sejam consistentes em uma sess\00E3o inteira.'),
unistr('As op\00E7\00F5es <em>Uma vez por componente</em> e <em>Sempre (Sem Armazenamento no Cache)</em> fornecem par\00E2metros adicionais que podem ser definidos para uso pelo esquema de autoriza\00E7\00E3o.'),
unistr('Em plug-ins de autoriza\00E7\00E3o, voc\00EA pode usar os atributos <em>component.type</em>, <em>component.id</em> e <em>component.name</em> do par\00E2metro <em>t_authorization</em>.'),
unistr('Para os tipos de esquema <em>Consulta SQL Existe</em> e <em>Corpo da Fun\00E7\00E3o</em> incorporados, as vari\00E1veis de bind equivalentes <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> e <em>:APP_COMPONENT_NAME</em> est\00E3o dispon\00EDveis.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058876557311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Uma vez por Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058957287311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 avaliado uma vez para cada componente que fazer refer\00EAncia ao esquema de autoriza\00E7\00E3o, nas salva o resultado na sess\00E3o. Outras solicita\00E7\00F5es para renderizar ou processar o esquema usam o resultado na mem\00F3ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058675502311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma vez por View de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058714276311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avalia uma vez para cada solicita\00E7\00E3o processada. Use o resultado na mem\00F3ria se o esquema de autoriza\00E7\00E3o for referenciado em mais de um componente na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058472347311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma vez por Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107058560968311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avalia apenas uma vez e, em seguida, usa o resultado na mem\00F3ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059082924311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre (Sem Armazenamento no Cache)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059172135311393)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema de autoriza\00E7\00E3o \00E9 sempre avaliado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550511030310980)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ponto de Avalia\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555601254310984)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o evento que aciona a a\00E7\00E3o din\00E2mica.'),
unistr('Para obter informa\00E7\00F5es sobre eventos espec\00EDficos, consulte a se\00E7\00E3o relevante no <em>Application Builder User''s Guide</em>.</p>'),
unistr('Os eventos s\00E3o categorizados nos seguintes tipos:'),
'<dl>',
'  <dt>Eventos de Browser</dt>',
unistr('    <dd>Eventos de browser padr\00E3o.</dd>'),
'  <dt>Eventos de Estrutura</dt>',
unistr('    <dd>Os eventos de estrutura s\00E3o acionados na estrutura do Application Express.</dd>'),
'  <dt>Eventos de Componentes</dt>',
unistr('    <dd>Dispon\00EDveis somente quando h\00E1 um componente dispon\00EDvel para o seu aplicativo que aciona um evento personalizado. Esses eventos s\00E3o acionados nos componentes nativos ou nos componentes de plug-in instalados no seu aplicativo.</dd>'),
'  <dt>Evento Personalizado</dt>',
'    <dd>Qualquer evento personalizado acionados no seu aplicativo.</dd>',
'</dl>',
unistr('<p>Observa\00E7\00E3o: Os eventos exibidos diferem com base no tipo de Interface de Usu\00E1rio atual da p\00E1gina.'),
unistr('Se quiser selecionar um evento que corresponda a um tipo diferente, voc\00EA poder\00E1 selecionar <strong>Mostrar n\00E3o suportado</strong>,'),
unistr('que exibe todos os eventos incluindo aqueles que n\00E3o correspondem ao tipo atual.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555515878310984)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579880024311003)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o escopo do evento, que determina quando o evento \00E9 avaliado uma segunda vez ou uma vez sucessiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069403911311404)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069514026311404)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Liga o handler do evento aos elementos acionadores durante a vida \00FAtil da p\00E1gina atual, mas n\00E3o ser\00E1 mais vinculado se um elemento acionador for atualizado via Atualiza\00E7\00E3o de P\00E1gina Parcial (PPR, Partial Page Refresh).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069644475311404)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Din\00E2mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069791014311404)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Liga o handler do evento aos elementos acionadores durante a vida \00FAtil da p\00E1gina atual, independentemente de qualquer elemento acionador ser recriado via Atualiza\00E7\00E3o de P\00E1gina Parcial (PPR, Partial Page Refresh).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069829415311404)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Uma vez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069944780311404)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Liga o handler do evento aos elementos acionadores somente uma vez. A a\00E7\00E3o din\00E2mica n\00E3o \00E9 acionada novamente at\00E9 a p\00E1gina ser totalmente atualizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579730333311003)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escopo do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387388560311642)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja excluir este t\00EDtulo da tradu\00E7\00E3o. Esse atributo n\00E3o tem nenhum efeito, a n\00E3o ser ao traduzir o aplicativo para outro idioma.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387243266311641)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excluir T\00EDtulo da Tradu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220575795311518)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione quantas vezes esta condi\00E7\00E3o de camada \00E9 executada.'),
unistr('Se voc\00EA fizer refer\00EAncia a <em>Colunas</em> em sua condi\00E7\00E3o, dever\00E1 especificar <strong>Para Cada Linha</strong> para que a condi\00E7\00E3o seja avaliada para cada linha da consulta de camada.'),
unistr('Caso contr\00E1rio, defina como <strong>Uma vez</strong> para avaliar as valida\00E7\00F5es uma vez para a regi\00E3o.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662698749311063)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione quantas vezes essa valida\00E7\00E3o de regi\00E3o edit\00E1vel ser\00E1 executada.'),
unistr('Se voc\00EA fizer refer\00EAncia \00E0s <em>Colunas</em> da sua condi\00E7\00E3o, dever\00E1 especificar <strong>Para Cada Linha</strong>, de modo que a condi\00E7\00E3o seja avaliada para cada linha da regi\00E3o edit\00E1vel.'),
unistr('Caso contr\00E1rio, defina como <strong>Uma Vez</strong> para avaliar as valida\00E7\00F5es uma vez para a regi\00E3o.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082917108311414)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Uma vez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082820697311414)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Para Cada Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662586391311063)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793376091311174)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione quando esta condi\00E7\00E3o somente para leitura ser\00E1 executada.</p>'),
unistr('        <p>Se voc\00EA fizer refer\00EAncia a <em>Colunas</em> na sua condi\00E7\00E3o somente para leitura, dever\00E1 especificar <strong>Para Cada Linha</strong> para que a condi\00E7\00E3o seja avaliada em rela\00E7\00E3o a cada linha da Grade Interativa.'),
unistr('		Caso contr\00E1rio, defina como <strong>Uma Vez</strong> para avaliar a condi\00E7\00E3o somente uma vez para a regi\00E3o.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793588743311174)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Uma vez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909389052311270)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avaliar a condi\00E7\00E3o somente para leitura uma vez para a regi\00E3o inteira.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793496062311174)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Para Cada Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909252675311269)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avaliar a condi\00E7\00E3o somente para leitura de forma independente para cada linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793297729311174)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Executar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662449204311063)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o escopo da execu\00E7\00E3o para essa valida\00E7\00E3o de regi\00E3o edit\00E1vel.'),
unistr('Selecione <strong>Para Linhas Criadas e Modificadas</strong>, se voc\00EA quiser que essa valida\00E7\00E3o seja avaliada pra linhas novas e atualizadas em sua regi\00E3o edit\00E1vel.'),
unistr('Se voc\00EA quiser que a sua valida\00E7\00E3o seja avaliada para cada linha submetida, selecione <strong>Todas as Linhas Submetidas</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082770264311414)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Linhas Submetidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107082696292311413)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Para Linhas Criadas e Modificadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662321703311063)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escopo de Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555299104310984)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique a sequ\00EAncia para este componente. A sequ\00EAncia determina a ordem da execu\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: Se dois componentes tiverem o mesmo valor de sequ\00EAncia, eles poder\00E3o ser executados em um ordem diferente quando o aplicativo for exportado e importado para outro ambiente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555120427310984)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378838499311636)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para um ORDS REST Service, filtre todos os registros com o atributo "sal" inferior a 3.000.</dt>',
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378731114311635)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a uma express\00E3o de filtro a ser especificada para o servi\00E7o REST externo. A express\00E3o ser\00E1 especificada ao servidor remoto no estado em que se encontra. A sintaxe depende do tipo de Origem de Dados REST. Por exemplo, o ORDS (Oracle REST Data Se')
||'rvices) espera a sintaxe JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378621020311635)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro Externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379134583311636)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para um ORDS REST Service, ordene pelo atributo "job" em ordem crescente, depois por "ename", em ordem decrescente.</dt>',
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379027503311636)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a uma express\00E3o ''ordenar por'' a ser especificada para o servi\00E7o REST externo. A express\00E3o ser\00E1 especificada ao servidor remoto no estado em que se encontra. A sintaxe depende do tipo de Origem de Dados REST. Por exemplo, o ORDS (Oracle REST Dat')
||'a Services) espera a sintaxe JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378912739311636)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Order By - Externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926990192311283)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o processamento posterior externo est\00E1 ativado para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926894853311283)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926632632311283)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto do link que os usu\00E1rios finais clicam para chamar o mecanismo de processamento externo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926541141311283)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926495215311283)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o URL de um servidor para o processamento posterior deste relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106926355832311282)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236447409311529)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o grupo de facetas ao qual esta caixa de sele\00E7\00E3o est\00E1 associada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236399960311529)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164812448311475)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tipo de lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165564065311476)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Valores Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165689457311476)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'A lista de valores se baseia em uma consulta gerada automaticamente que seleciona os valores de coluna distintos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291702882311573)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291894701311573)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores Din\00E2mica \00E9 baseada na Consulta SQL retornada pelo Corpo da Fun\00E7\00E3o especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164994571311475)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Componente Compartilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165051814311475)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores \00E9 baseado em uma lista de valores predefinidos, definida em Componentes Compartilhados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165196784311476)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165283067311476)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores Din\00E2mica \00E9 baseada na Consulta SQL especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165339857311476)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107165471074311476)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores Est\00E1tica \00E9 baseada no valor de texto especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164729789311475)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009745084311355)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se a faceta \00E9 recolh\00EDvel. Quando definido como <strong>Ativado</strong>, um controle de altern\00E2ncia \00E9 exibido \00E0 esquerda da faceta, para ocultar/mostrar suas entradas na lista. Quando definido como <strong>Desativado</strong>, a faceta')
||unistr(' e suas entradas na lista ficam sempre vis\00EDveis.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009647947311355)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recolh\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428404321311671)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se a contagem de entradas na lista da faceta ou filtro vai ser calculada. H\00E1 um impacto no desempenho associado ao uso dessa op\00E7\00E3o.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428319735311671)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular Contagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236689186311529)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique como combinar filtros dentro deste grupo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236957076311529)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('AND (Interse\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237037357311529)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os filtros ser\00E3o combinados usando "AND"; sendo assim, o resultado ser\00E1 a interse\00E7\00E3o de todos os filtros individuais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236754826311529)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('OR (Uni\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236872915311529)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os filtros ser\00E3o combinados usando "OR"; sendo assim, o resultado ser\00E1 o conjunto unido de filtros individuais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236527633311529)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Combinar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009179191311355)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se ser\00E1 permitida a filtragem das entradas da lista da faceta ou filtro no cliente. Quando a op\00E7\00E3o for definida como <strong>Ativado</strong>, um campo de pesquisa ser\00E1 renderizado acima das entradas da lista, para permitir que os usu\00E1')
||'rios finais filtrem a lista.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009011623311355)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtragem no Cliente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237636396311530)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se o gr\00E1fico dever\00E1 ser exibido inicialmente. Esta propriedade s\00F3 se aplica quando a propriedade de regi\00E3o de Pesquisa Facetada, Mostrar Gr\00E1ficos, for Seletor. As altera\00E7\00F5es nesta propriedade podem n\00E3o ser vistas imediatamente porque o')
||unistr(' conjunto de gr\00E1ficos que o usu\00E1rio mostrou persiste na sess\00E3o do browser. Para ver o efeito das altera\00E7\00F5es nesta propriedade, redefina o relat\00F3rio usando a op\00E7\00E3o de controle de cache do link Redefinir Regi\00F5es, como com o bot\00E3o Redefinir gerado pelo ')
||'assistente.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237562950311530)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Gr\00E1fico Inicialmente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009955546311355)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se a faceta deve ser inicialmente renderizada em um estado contra\00EDdo. As altera\00E7\00F5es nesta propriedade podem n\00E3o ser vistas imediatamente porque o estado de expans\00E3o persiste na sess\00E3o do browser. Para ver o efeito das altera\00E7\00F5es nesta ')
||unistr('propriedade, redefina o relat\00F3rio usando a op\00E7\00E3o de controle de cache do link Redefinir Regi\00F5es, como com o bot\00E3o Redefinir gerado pelo assistente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009837480311355)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Recolhido Inicialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242599265311536)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Determina se a faceta ser\00E1 exibida por padr\00E3o. As altera\00E7\00F5es nesta propriedade podem n\00E3o ser vistas imediatamente porque o estado de visibilidade persiste na sess\00E3o do browser. Para ver o efeito das altera\00E7\00F5es nesta propriedade, redefina o relat\00F3r')
||unistr('io usando a op\00E7\00E3o de controle de cache do link Redefinir Regi\00F5es, como com o bot\00E3o Redefinir gerado pelo assistente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242411562311536)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibido Inicialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010123648311356)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a altura m\00E1xima da faceta em pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010045085311355)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altura M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010234938311356)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352432800310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifica como combinar valores individuais ao filtrar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352735920310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('AND (Interse\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352864914310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores ser\00E3o combinados usando "AND"; sendo assim, o resultado ser\00E1 a interse\00E7\00E3o de todos os valores individuais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352568112310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('OR (Uni\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352604803310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores ser\00E3o combinados usando "OR"; sendo assim, o resultado ser\00E1 o conjunto unido de valores individuais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352305307310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Filtrar Combina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352044401310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Caracteres normais:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Caracteres de Controle:</dt>',
unistr('<dd>Tabula\00E7\00E3o (<em>ASCII: 9</em>) <pre>\005Ct</pre></dd>'),
unistr('<dd>Alimenta\00E7\00E3o de linha (<em>ASCII: 10</em>) <pre>\005Cn</pre></dd>'),
'<dt>Outros Caracteres:</dt>',
unistr('<dd>Use um valor de codifica\00E7\00E3o Unicode da forma \005Cxxxx'', em que ''xxxx'' \00E9 o valor hexadecimal de um caractere no formato de codifica\00E7\00E3o UCS-2.</dd>'),
unistr('<dd>In\00EDcio de Cabe\00E7alho (<em>ASCII: 1</em>) <pre>\005C0001</pre></dd>'),
unistr('<dd>S\00EDmbolo "@" (<em>ASCII: 64</em>) <pre>\005C0040</pre></dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351931110310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Identifica o caractere que separa valores uns dos outros. Observe que n\00E3o h\00E1 suporte para os caracteres <strong>"</strong> (aspas duplas) e <strong>\005C</strong> (barra invertida) como Separador de Valor, e tamb\00E9m n\00E3o no formato <strong>\005Cxxxx</strong')
||'>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351854385310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352242303310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indica se ser\00E1 removido o espa\00E7o \00E0 esquerda e \00E0 direita de valores individuais ap\00F3s a divis\00E3o.</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('A op\00E7\00E3o <dt>Remover Espa\00E7o em Branco<em>desativada</em> leva aos seguintes valores individuais contados:</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('A op\00E7\00E3o <dt>Remover Espa\00E7o em Branco<em>ativada</em> leva aos seguintes valores individuais contados:</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>Observe que a remo\00E7\00E3o de espa\00E7o em branco pode impactar significativamente o desempenho da consulta. Para conjuntos de dados maiores, considere em seu lugar a limpeza de dados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352121894310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reduzir Espa\00E7o em Branco')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353113676310827)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353242730310827)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna n\00E3o cont\00E9m v\00E1rios valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601607497311019)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601755947311019)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna n\00E3o cont\00E9m v\00E1rios valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351302039310825)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Determina se a Coluna de Origem cont\00E9m v\00E1rios valores e como eles s\00E3o codificados.</p><p><em>S\00F3 h\00E1 suporte para as Facetas com Diversos Valores nos bancos de dados Oracle 12.2 ou mais recentes. Em um banco de dados 12.1, o &PRODUCT_NAME. emitir\00E1 u')
||'m erro de runtime se uma faceta ou filtro com Diversos Valores for definido(a).</em></p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351651054310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Array JSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351753590310826)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>A coluna de Origem cont\00E9m um array JSON de valores escalares. O &PRODUCT_NAME. emitir\00E1 mensagens de erro se a coluna contiver sintaxe JSON inv\00E1lida.</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351493232310825)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Lista Delimitada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351506121310825)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>A coluna cont\00E9m valores na forma de uma lista delimitada.</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106351201655310825)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237428636311530)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se um bot\00E3o ser\00E1 mostrado ao lado da faceta para permitir ao usu\00E1rio mostrar um gr\00E1fico das contagens de entrada da lista de facetas. Esta propriedade s\00F3 se aplica quando a propriedade de regi\00E3o de Pesquisa Facetada, Mostrar Gr\00E1ficos, ')
||unistr('n\00E3o estiver definida como N\00E3o.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237338952311530)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008900005311355)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se a contagem de ocorr\00EAncias das entradas da lista da faceta ou filtro ser\00E3o contadas. Quando a op\00E7\00E3o \00E9 definida como <strong>Ativado</strong>, a contagem ser\00E1 exibida entre par\00EAnteses pr\00F3ximo \00E0 entrada da lista. Por exemplo, KING (3).')
||'</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008815478311354)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Contagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009558295311355)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique o n\00FAmero m\00E1ximo de entradas da lista a serem exibidas para a faceta. Quando um valor for especificado e a lista contiver mais do que esse n\00FAmero de entradas, um link <strong>Mostrar Mais</strong> ser\00E1 renderizado no final da lista. Qua')
||unistr('ndo nenhum valor for especificado, todas as entradas da lista ser\00E3o exibidas.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009418649311355)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo de Entradas Exibidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009362461311355)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se alguma entrada selecionada na lista ser\00E1 mostrada primeiro na lista da faceta ou filtro. Esse atributo n\00E3o se aplica nas situa\00E7\00F5es em que a lista de valores associada \00E0 faceta define grupos.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107009206081311355)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Selecionados Primeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638894610311046)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja classificar as entradas na lista da faceta ou filtro. Quando a op\00E7\00E3o est\00E1 definida como <strong>Ativado</strong>, as entradas na lista s\00E3o classificadas por contagem decrescente. Quando definida como <strong>Desativado</strong>,')
||unistr(' as entradas na lista s\00E3o exibidas na ordem definida pela Lista de Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106638756303311046)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por Maiores Contagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242315480311535)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se os usu\00E1rios finais podem mostrar ou ocultar a faceta. Quando pelo menos uma faceta tem esta op\00E7\00E3o ativada, um bot\00E3o "Mais Facetas" \00E9 adicionado, o qual \00E9 usado para escolher quais facetas ser\00E3o mostradas ou ocultas. N\00E3o h\00E1 custo de ')
||unistr('desempenho para calcular contagens para facetas que n\00E3o s\00E3o exibidas.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242275938311535)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altern\00E2ncia de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428614398311671)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique como as entradas da lista com contagem zerada ser\00E3o exibidas para a faceta ou filtro.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428949743311672)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429096144311672)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Mostrar todas as entradas, mas desativar aquelas que n\00E3o podem ser filtradas.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428794624311671)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428845106311671)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>S\00F3 mostrar entradas da lista filtr\00E1veis.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429163779311672)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar \00DAltima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429249805311672)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Mostra todas as entradas, mas desativa aquelas que n\00E3o podem ser filtradas, e as mostra por \00FAltimo na lista da faceta ou filtro. Essa op\00E7\00E3o ser\00E1 ignorada se a Lista de Valores Compartilhada associada fizer uso da funcionalidade de grupo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428565722311671)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas de Contagem Zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562020149310989)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe quaisquer atributos adicionais usados na c\00E9lula da tabela HTML que contenha este label.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561934260310989)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos de C\00E9lula da Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917908200311276)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha o modelo de campo que ser\00E1 usado ao renderizar o campo do form tabular. Quando nenhum modelo for selecionado, o campo ser\00E1 renderizado com o label padr\00E3o compat\00EDvel com a acessibilidade.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938130114311291)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha o modelo de campo que ser\00E1 usado ao renderizar o campo do form tabular. Quando nenhum modelo for selecionado, o campo ser\00E1 renderizado com o label padr\00E3o compat\00EDvel com a acessibilidade.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561884146310989)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um modelo de label para definir a apar\00EAncia e o layout deste label de item.</p>'),
unistr('        <p>Os modelos de label s\00E3o definidos no tema do aplicativo.'),
unistr('        Quando um item \00E9 criado, o modelo \00E9 automaticamente definido como o modelo de item padr\00E3o definido no tema atual.</p>'),
unistr('        <p>Muitos temas cont\00EAm modelos de label para exibir labels obrigat\00F3rios, opcionais e ocultos.<br>'),
'        O Universal Theme fornece os seguintes modelos de label:',
'          <dl>',
'            <dt>Oculto</dt>',
unistr('              <dd>Use quando o label n\00E3o tiver de ser exibido na tela. Observe que a Tecnologia Assistencial ainda poder\00E1 ler o label.'),
unistr('              Oculto \00E9 ignorado para itens de Caixa de Sele\00E7\00E3o porque um label deve ser mostrado ap\00F3s a caixa de sele\00E7\00E3o.</dd>'),
'            <dt>Opcional</dt>',
unistr('              <dd>Use para itens de form que sejam opcionais. O label ser\00E1 exibido ao lado do item.</dd>'),
'            <dt>Opcional - Acima</dt>',
unistr('              <dd>Use para itens de form que sejam opcionais. O label ser\00E1 exibido acima do item.</dd>'),
'            <dt>Opcional - Flutuante</dt>',
unistr('              <dd>Use para itens de form que sejam opcionais. O label ser\00E1 exibido dentro do item de entrada e ser\00E1 reduzido automaticamente quando o campo de entrada tiver um valor.</dd>'),
unistr('            <dt>Obrigat\00F3rio</dt>'),
unistr('              <dd>Este modelo de label exibe um asterisco vermelho pr\00F3ximo ao label e \00E9 usado para itens de form em que a entrada do usu\00E1rio \00E9 obrigat\00F3ria. O label ser\00E1 exibido ao lado do item.</dd>'),
unistr('<dt>Obrigat\00F3rio - Acima</dt>'),
unistr('              <dd>Esse modelo de label exibe um asterisco vermelho pr\00F3ximo ao label e \00E9 usado para itens de form em que a entrada do usu\00E1rio \00E9 obrigat\00F3ria. O label ser\00E1 exibido acima do item. Os modelos de item permitem que voc\00EA defina os atributos d')
||unistr('e interface de usu\00E1rio como parte de um tema e compartilhe essa defini\00E7\00E3o entre muitos itens de p\00E1gina.</dd>'),
unistr('            <dt>Obrigat\00F3rio - Flutuante</dt>'),
unistr('              <dd>Esse modelo de label exibe um asterisco vermelho pr\00F3ximo ao label e \00E9 usado para itens de form nos quais \00E9 obrigat\00F3ria a entrada do usu\00E1rio. O label ser\00E1 exibido dentro do item de entrada e ser\00E1 reduzido automaticamente quando o cam')
||unistr('po de entrada tiver um valor. Os modelos de item permitem que voc\00EA defina os atributos de interface de usu\00E1rio como parte de um tema e compartilhe essa defini\00E7\00E3o entre muitos itens de p\00E1gina.</dd>'),
'          </dl>',
unistr('          Consulte Tamb\00E9m: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561793396310989)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375067643311633)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtrar Tipo de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789094377311170)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se deseja executar uma pesquisa de correspond\00EAncia exata quando o usu\00E1rio final digitar texto em um filtro de coluna.'),
unistr('        Se definido como <strong>Desativado</strong>, o filtro executar\00E1 uma pesquisa com o crit\00E9rio "cont\00E9m", em vez de "igual a".</p>'),
unistr('        <p>Por exemplo, para uma coluna chamada TAGS, equivale a TAGS = ''<<valor>>''. Se Correspond\00EAncia Exata estiver definido como <strong>Desativado</strong>, ser\00E1 equivalente a TAGS LIKE ''%<<valor>>%''. ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788992888311170)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Correspond\00EAncia Exata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787444000311169)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se um filtro ser\00E1 sempre obrigat\00F3rio para esta coluna.</p>'),
unistr('        <p>Observa\00E7\00E3o - um filtro sempre ser\00E1 obrigat\00F3rio para que dados sejam retornados em rela\00E7\00E3o a esta coluna, independentemente da op\00E7\00E3o <strong>Filtro Obrigat\00F3rio</strong>nos atributos da grade interativa.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787390544311169)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787694206311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como a lista de valores ser\00E1 derivada para o filtro quando um usu\00E1rio clicar no cabe\00E7alho da coluna ou em caixas de di\00E1logo de filtro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787959079311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Distinta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788050552311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores de colunas distintas s\00E3o exibidos para as colunas VARCHAR2 e NUMBER. As colunas DATE e TIMESTAMP utilizam os intervalos de datas predefinidos internos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374026201311632)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374101306311632)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores s\00E3o derivados da lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787767320311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787824889311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Desative os valores que est\00E3o sendo exibidos no filtro.'),
unistr('        Esta op\00E7\00E3o ser\00E1 apropriada em colunas grandes, em geral, com a maioria dos valores ultrapassando 50 caracteres ou quando uma lista n\00E3o for muito \00FAtil para selecionar um registro espec\00EDfico.'),
unistr('        Em vez disso, o usu\00E1rio final poder\00E1 digitar apenas um valor parcial e exibir os resultados.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788723934311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788803700311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores s\00E3o derivados do corpo da fun\00E7\00E3o PL/SQL que retorna uma Consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788388206311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Componente Compartilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788446406311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores s\00E3o derivados de uma lista de valores existentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788174073311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788284820311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores s\00E3o derivados da defini\00E7\00E3o de consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788514369311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106788660437311170)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores s\00E3o derivados de uma lista de valores est\00E1ticos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787506005311169)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de LOV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786201791311168)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione quais operadores de filtro os usu\00E1rios finais poder\00E3o utilizar para esta coluna.</p>'),
unistr('        <p>Dependendo do tamanho do conjunto de dados e dos \00EDndices de coluna, voc\00EA poder\00E1 optar por desativar determinados operadores de filtro, a fim de evitar problemas de desempenho para os usu\00E1rios finais.'),
unistr('        Determinados operadores podem causar varreduras integrais de tabela, em vez de utilizar \00EDndices de coluna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957562689311312)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957631355311312)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A op\00E7\00E3o para filtrar retorna os resultados de valores de colunas que cont\00EAm o valor do filtro.'),
unistr('        O &PRODUCT_NAME. utilizar\00E1 uma <code>coluna LIKE <strong>%</strong>valor do filtro<strong>%</strong></code> na cl\00E1usula where.</p>'),
unistr('        <p>Observa\00E7\00E3o - este operador impedir\00E1 que \00EDndices de coluna sejam usados, o que pode resultar em uma varredura completa das tabelas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786449323311168)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Fazer Distin\00E7\00E3o Entre Mai\00FAsculas e Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909015927311269)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A op\00E7\00E3o para filtrar retorna os resultados de valores de colunas, independentemente das diferen\00E7as no uso de mai\00FAsculas/min\00FAsculas no valor da coluna e no valor do filtro.'),
unistr('        O &PRODUCT_NAME. utilizar\00E1 um operador <code>UPPER(coluna) <em> ou </em> UPPER(valor do filtro)</code> na cl\00E1usula where.</p>'),
unistr('        <p>Observa\00E7\00E3o - Em geral, a utiliza\00E7\00E3o de UPPER no valor da coluna e no valor do filtro impedir\00E1 o uso de \00EDndices de coluna, exceto para \00EDndices de colunas baseados em fun\00E7\00E3o que t\00EAm UPPER(<em>coluna</em>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786346053311168)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909183971311269)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A op\00E7\00E3o para filtrar retorna os resultados com base na express\00E3o regular informada.</p>'),
unistr('        <p>Observa\00E7\00E3o - a utiliza\00E7\00E3o de operadores REGEXP \00E9 complexa e, em geral, s\00F3 \00E9 usada por usu\00E1rios avan\00E7ados. Esses operadores podem resultar em um desempenho muito ruim.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957758603311312)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Come\00E7a Com')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957842568311312)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A op\00E7\00E3o para filtrar retorna os resultados de valores de colunas que come\00E7am com o valor do filtro.'),
unistr('        O &PRODUCT_NAME. utilizar\00E1 uma <code>coluna LIKE valor do filtro<strong>%</strong></code> na cl\00E1usula where.</p>'),
unistr('        <p>Observa\00E7\00E3o - este operador poder\00E1 utilizar \00EDndices de coluna dispon\00EDveis. {Verifique a op\00E7\00E3o <strong>N\00E3o Fazer Distin\00E7\00E3o Entre Mai\00FAsculas e Min\00FAsculas</strong> para obter as exce\00E7\00F5es}.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786138291311168)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Operadores que Impactam o Desempenho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786633996311168)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione com qual formata\00E7\00E3o de letras mai\00FAsculas/min\00FAsculas o texto do valor da coluna ser\00E1 armazenado.</p>'),
unistr('        <p>Se a coluna puder ser especificada como sempre come\00E7ando com letras mai\00FAsculas, como, por exemplo <em>Nome do usu\00E1rio</em> ou sempre come\00E7ando com letras min\00FAsculas, o desempenho da recupera\00E7\00E3o dos resultados do filtro ser\00E1 melhor.'),
unistr('          Se a op\00E7\00E3o <strong>Mai\00FAsculas</strong> ou <strong>Min\00FAsculas</strong> for selecionada, as pesquisas sempre far\00E3o distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas.</p>'),
unistr('        <p>Observa\00E7\00E3o - Se a op\00E7\00E3o Misto for selecionada, os usu\00E1rios finais poder\00E3o especificar<strong>Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas</strong> nas caixas de di\00E1logo de Pesquisa e Filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786967482311168)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787010357311169)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para situa\00E7\00F5es em que o valor da coluna dever\00E1 ser sempre armazenado em letras min\00FAsculas.'),
unistr('        O &PRODUCT_NAME. utilizar\00E1 um <code>operador de coluna<em></em> LOWER(valor do filtro)</code> na cl\00E1usula where.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787124231311169)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Misto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106787232142311169)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para situa\00E7\00F5es em que o valor da coluna dever\00E1 ser armazenado em letras min\00FAsculas e min\00FAsculas. A defini\00E7\00E3o do operador <strong>N\00E3o Fazer Distin\00E7\00E3o Entre Mai\00FAsculas e Min\00FAsculas</strong> determinar\00E1 a cl\00E1usula where a ser utilizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786723013311168)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mai\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786891002311168)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para situa\00E7\00F5es em que o valor da coluna dever\00E1 ser sempre armazenado em letras mai\00FAsculas.'),
unistr('        O &PRODUCT_NAME. utilizar\00E1 um <code>operador de<em>coluna</em> UPPER(valor do filtro)</code> na cl\00E1usula where.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106786526098311168)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o de Mai\00FAsculas/Min\00FAsculas do Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580657650311003)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica se a a\00E7\00E3o \00E9 acionada durante a inicializa\00E7\00E3o.</p>'),
unistr('        							<p>A inicializa\00E7\00E3o tem um significado ligeiramente diferente, dependendo de como a A\00E7\00E3o Din\00E2mica estiver definida. Para A\00E7\00F5es'),
unistr('        							Din\00E2micas definidas para serem acionadas nas colunas da Grade Interativa, a op\00E7\00E3o especifica se a a\00E7\00E3o \00E9 executada quando a linha da Grade'),
unistr('        							Interativa estiver ativada para edi\00E7\00E3o. Para todas as outras A\00E7\00F5es Din\00E2micas, a op\00E7\00E3o especifica se a a\00E7\00E3o \00E9 executada quando a'),
unistr('        							p\00E1gina \00E9 carregada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580553465311003)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acionar na Inicializa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580414719311003)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se essa a\00E7\00E3o ser\00E1 acionada quando a condi\00E7\00E3o do elemento de acionamento for atendida, selecionando <strong>Verdadeiro</strong> (A\00E7\00E3o Verdadeira), ou quando ela n\00E3o for atendida, selecionando <strong>Falso</strong> (A\00E7\00E3o Falsa).</p>'),
unistr('<p>Observa\00E7\00E3o: se nenhuma condi\00E7\00E3o for especificada, somente as a\00E7\00F5es com status <strong>Verdadeiro</strong> ser\00E3o acionadas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070146503311404)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Falso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107070001363311404)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Verdadeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580324536311003)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Quando o Resultado do Evento For'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454208649311689)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se voc\00EA gostaria de fixar os cabe\00E7alhos das colunas do relat\00F3rio na parte superior da <strong>P\00E1gina</strong> ou da <strong>Regi\00E3o</strong>, de modo que os cabe\00E7alhos permane\00E7am vis\00EDveis conforme o usu\00E1rio rola verticalmente o relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455226420311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455334697311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O cabe\00E7alho do relat\00F3rio n\00E3o est\00E1 fixo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454450038311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454670213311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fixa o cabe\00E7alho do relat\00F3rio na parte superior da p\00E1gina. Conforme o usu\00E1rio rolar verticalmente a p\00E1gina, o cabe\00E7alho permanecer\00E1 na parte superior. Os cabe\00E7alhos fixos no n\00EDvel da <strong>P\00E1gina</strong> s\00E3o \00FAteis quando o relat\00F3rio \00E9 o conte\00FAdo p')
||unistr('rincipal da p\00E1gina. N\00E3o h\00E1 suporte para essa defini\00E7\00E3o quando a regi\00E3o est\00E1 em uma caixa de di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454342852311689)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454551649311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fixa o cabe\00E7alho do relat\00F3rio na parte superior da regi\00E3o atual. Conforme o usu\00E1rio rolar verticalmente dentro da regi\00E3o, o cabe\00E7alho do relat\00F3rio permanecer\00E1 fixo na parte superior da regi\00E3o. Os cabe\00E7alhos fixos no n\00EDvel da<strong>Regi\00E3o</strong> po')
||unistr('dem ser \00FAteis em uma p\00E1gina que cont\00E9m diversas regi\00F5es, por exemplo, uma p\00E1gina de painel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454101458311689)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Corrigido para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455637904311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a altura m\00E1xima do relat\00F3rio em pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455525577311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altura M\00E1xima do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107455786284311690)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963681960311316)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a altura fixa do relat\00F3rio em pixels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963563968311316)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altura Fixa do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963767370311316)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780181496311163)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a grade interativa dever\00E1 ser exibida com altura de linha fixa.</p>'),
unistr('        <p>Se for definida como <em>Sim</em>, retic\00EAncias (...) ser\00E3o exibidas no final dos dados para colunas muito estreitas que n\00E3o permitem mostrar todos os dados.'),
unistr('        Se for definida como <em>N\00E3o</em> os dados ser\00E3o distribu\00EDdos entre v\00E1rias linhas, conforme necess\00E1rio.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780072162311163)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura de Linha Fixa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649551222311054)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um rodap\00E9 de regi\00E3o que seja exibido logo ap\00F3s o conte\00FAdo do corpo, depois de <code>#BODY#</code> no modelo da regi\00E3o.'),
unistr('Voc\00EA pode usar os atalhos, bem como a string de substitui\00E7\00E3o <code>#TIMING#</code>, para exibir o tempo consumido para renderizar a regi\00E3o.</p>'),
unistr('<p>Para regi\00F5es de relat\00F3rio voc\00EA pode usar as seguintes strings de substitui\00E7\00E3o de pagina\00E7\00E3o:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>Mostra o n\00FAmero de linhas extra\00EDdos pelo mecanismo de relat\00F3rio (o tamanho da p\00E1gina). Use essas strings de substitui\00E7\00E3o para exibir mensagens personalizadas ao usu\00E1rio.</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>Exibe o n\00FAmero total de linhas que satisfazem uma consulta SQL usada para um relat\00F3rio. Por exemplo, Z em linhas X - Y de Z</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>O X em linhas X - Y de Z</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>O Y em linhas X - Y de Z</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559124868310987)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto ou HTML que aparece antes do rodap\00E9 do modelo de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559053960310987)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto do Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107098949512311425)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Definir este atributo como <code>fielddatabold</code> gera o seguinte HTML</dt>',
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Sample Data&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916376563311275)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes CSS a serem aplicadas ao valor desta coluna. Voc\00EA pode digitar a classe CSS ou selecionar na lista de itens dispon\00EDveis.</p>'),
unistr('<p>Esta classe \00E9 inclu\00EDda por padr\00E3o em todas as p\00E1ginas do &PRODUCT_NAME. e tem a defini\00E7\00E3o <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916295158311275)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917840781311276)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a m\00E1scara de formato a ser aplicada a esta coluna.'),
unistr('    \00C9 poss\00EDvel digitar a m\00E1scara de formato ou escolher na lista predefinida, com base em uma amostra de representa\00E7\00E3o de como essa m\00E1scara de formato ser\00E1 exibida.</p>'),
unistr('    <p>\00C9 importante que as m\00E1scaras de formato de n\00FAmero sejam aplicadas somente a colunas que contenham n\00FAmeros e as m\00E1scaras de formato de data, aplicadas a colunas que cont\00EAm datas.'),
unistr('    Caso contr\00E1rio, um erro de runtime ser\00E1 gerado quando qualquer registro contiver um valor que n\00E3o possa ser convertido usando a m\00E1scara de formato especificada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937958734311291)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a m\00E1scara de formato a ser aplicada a esta coluna.'),
unistr('    \00C9 poss\00EDvel digitar a m\00E1scara de formato ou escolher na lista predefinida, com base em uma amostra de representa\00E7\00E3o de como essa m\00E1scara de formato ser\00E1 exibida.</p>'),
unistr('    <p>\00C9 importante que as m\00E1scaras de formato de n\00FAmero sejam aplicadas somente a colunas que contenham n\00FAmeros e as m\00E1scaras de formato de data, aplicadas a colunas que cont\00EAm datas.'),
unistr('    Caso contr\00E1rio, um erro de runtime ser\00E1 gerado quando qualquer registro contiver um valor que n\00E3o possa ser convertido usando a m\00E1scara de formato especificada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563893337310990)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma m\00E1scara de formato a ser aplicada a este componente.'),
unistr('    \00C9 poss\00EDvel digitar a m\00E1scara de formato ou escolher na lista predefinida, com base em uma amostra de representa\00E7\00E3o de como essa m\00E1scara de formato ser\00E1 exibida.</p>'),
unistr('    <p>\00C9 importante que as m\00E1scaras de formato de n\00FAmero sejam aplicadas somente a componentes que contenham n\00FAmeros e as m\00E1scaras de formato de data, aplicadas a componentes que contenham datas.'),
unistr('    Caso contr\00E1rio, um erro de runtime ser\00E1 gerado quando o componente contiver um valor que n\00E3o possa ser convertido usando a m\00E1scara de formato especificada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563776228310990)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564077499310990)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe uma m\00E1scara de formato de data a ser aplicada a este componente.'),
unistr('Voc\00EA pode digitar a m\00E1scara de formato ou escolher na lista de m\00E1scaras de formato predefinidas, com base em uma representa\00E7\00E3o de exemplo de como essa m\00E1scara de formato ser\00E1 exibida.'),
unistr('Voc\00EA tamb\00E9m pode usar a sintaxe de substitui\00E7\00E3o para fazer refer\00EAncia a uma m\00E1scara de formato din\00E2mico a partir de um item do aplicativo ou da p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563903239310990)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564203323310990)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe uma m\00E1scara de formato de n\00FAmero a ser aplicada a este componente.'),
unistr('Voc\00EA pode digitar a m\00E1scara de formato ou escolher na lista de m\00E1scaras de formato predefinidas, com base em uma representa\00E7\00E3o de exemplo de como essa m\00E1scara de formato ser\00E1 exibida.'),
unistr('Voc\00EA tamb\00E9m pode usar a sintaxe de substitui\00E7\00E3o para fazer refer\00EAncia a uma m\00E1scara de formato a partir de um item do aplicativo ou da p\00E1gina.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564137523310990)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560579189310988)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se a complementa\00E7\00E3o autom\00E1tica ser\00E1 desativada para esta p\00E1gina. Um valor <strong>Ativado</strong> n\00E3o tem efeito nesta p\00E1gina. Um valor <strong>Desativado</strong> gera o seguinte HTML na tag FORM:'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Browsers diferentes podem ter regras diferentes quando <code>autocomplete="off"</code> \00E9 respeitado ou ignorado. Portanto, tenha isso em mente especificamente ao definir essa op\00E7\00E3o como <strong>Desativado</strong>, e teste em seus brow')
||'sers de destino.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107062071081311398)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061981474311398)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560402040310988)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclus\00E3o Autom\00E1tica do Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271912085310763)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir os labels do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271834048310763)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914866057311274)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p> Informe o n\00FAmero m\00E1ximo de colunas gen\00E9ricas em relat\00F3rios.'),
unistr('Os relat\00F3rios que usam nomes de colunas gen\00E9ricos s\00E3o submetidos a parse somente durante o runtime; portanto, o n\00FAmero de colunas n\00E3o \00E9 conhecido durante a edi\00E7\00E3o do relat\00F3rio.</p>'),
unistr('<p>O n\00FAmero m\00E1ximo de colunas do relat\00F3rio deve corresponder ao n\00FAmero esperado de colunas de relat\00F3rio.'),
unistr('Se o n\00FAmero real for menor, o relat\00F3rio ser\00E1 renderizado com o n\00FAmero real de colunas.'),
unistr('No entanto, se o n\00FAmero real for maior que o m\00E1ximo, uma mensagem de erro ser\00E1 exibida no runtime.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914736185311274)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Contagem de Coluna Gen\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701659111311093)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a p\00E1gina global para a interface do usu\00E1rio atual, se n\00E3o houver uma definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701518782311093)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362521207311624)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935846241311289)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936162503311290)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562840111310989)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma coluna de layout espec\00EDfica. Use <strong>Autom\00E1tica</strong> para determinar automaticamente a pr\00F3xima coluna de layout dispon\00EDvel na qual o componente ser\00E1 exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562778589310989)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563657024310990)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe atributos adicionais definidos para a coluna de layout. Este valor substituir\00E1 o marcador de espa\00E7o de substitui\00E7\00E3o <code>#ATTRIBUTES#</code> no modelo de coluna do layout.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563542690310990)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262084689311549)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246616158311539)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione quantas colunas de layout s\00E3o ocupadas por este componente. Use Autom\00E1tico para balancear as colunas de layout dispon\00EDveis em todos os componentes da mesma linha.</p>'),
'<dl>',
'  <dt>Auto</dt>',
unistr('    <dd>Os cart\00F5es ter\00E3o uma largura inicial e ser\00E3o ajustados em uma nova linha quando n\00E3o puderem mais caber de modo uniforme.</dd>'),
'  <dt>2, 3, 4, 5 Colunas</dt>',
unistr('    <dd>Os cart\00F5es ser\00E3o organizados de modo a caber no n\00FAmero de colunas selecionado por linha. O layout pode reduzir o n\00FAmero de colunas com base na largura do viewport.</dd>'),
unistr('  <dt>Voc\00EA pode configurar a largura dos cart\00F5es definindo uma vari\00E1vel de CSS.</dt>'),
unistr('    <dd>Por exemplo, adicione o trecho de c\00F3digo a seguir para definir a largura do cart\00E3o como 320px: <pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246728669311539)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>'2 Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246889926311539)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'pt-br'
,p_message_text=>'3 Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246900417311539)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'pt-br'
,p_message_text=>'4 Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247007494311539)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'pt-br'
,p_message_text=>'5 Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107246526739311538)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas de Grade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457142634311691)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira as classes CSS que voc\00EA queira aplicar \00E0 coluna de layout que cont\00E9m essa regi\00E3o. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.</p>'),
unistr('        <p>Essa propriedade pode ser usada para fornecer um controle refinado sobre a capacidade de resposta e o layout da coluna de layout da regi\00E3o quando o tamanho do viewport for alterado.'),
unistr('        Para aplicativos Universal Theme, h\00E1 v\00E1rios modificadores de CSS que voc\00EA pode usar para estender os componentes da sua p\00E1gina. Revise a se\00E7\00E3o Refer\00EAncia do Aplicativo de Amostra Universal Theme para saber mais.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107457064196311691)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107362621291311624)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935956053311289)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936201729311290)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563295735310990)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione quantas colunas de layout este componente ocupa. Use <strong>Autom\00E1tica</strong> para equilibrar as colunas de layout dispon\00EDveis em todos os componentes na mesma linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563155479310990)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Extens\00E3o da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454026378311689)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o do Modelo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453923587311689)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione quantas colunas de layout o label ocupa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453824594311689)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo da Coluna com Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563056553310990)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se este componente ser\00E1 exibido na pr\00F3xima coluna ou na mesma coluna, como o componente anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562979026310990)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nova Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562415137310989)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esse componente ser\00E1 exibido em um novo layout ou no mesmo layout do componente anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562317804310989)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciar Novo Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562616038310989)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esse componente ser\00E1 exibido na pr\00F3xima linha ap\00F3s o componente anterior ou na mesma linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562531830310989)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciar Nova Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220733551311518)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira as classes CSS que deseja aplicar \00E0 linha de layout que cont\00E9m esta regi\00E3o. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.</p>'),
unistr('        <p>Esta propriedade pode ser usada para fornecer controle refinado sobre a capacidade de resposta e o layout da linha de layout da regi\00E3o conforme o tamanho do viewport \00E9 alterado.'),
unistr('        Para aplicativos Universal Theme, h\00E1 v\00E1rios modificadores CSS que voc\00EA pode usar para estender os componentes da p\00E1gina. Revise a se\00E7\00E3o Refer\00EAncia do Aplicativo de Amostra Universal Theme para saber mais.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220644140311518)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563430726310990)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe quantas linhas na tabela HTML este componente ocupa. Os componentes s\00E3o dispostos em tabelas HTML. Este atributo determina o valor a ser usado para o atributo <em>ROWSPAN</em> na c\00E9lula da tabela deste componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106563391376310990)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Expans\00E3o de Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839933858311216)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usado para definir uma dica de ferramenta personalizada descritiva curta no(s) nome(s) de s\00E9rie na legenda do gr\00E1fico. No caso de um gr\00E1fico de Diagrama de Caixa, a coluna n\00E3o deve corresponder ao mapeamento da coluna')
||unistr(' Valor selecionada. A sele\00E7\00E3o de uma coluna que corresponde ao mapeamento da coluna Valor far\00E1 com que a dica de ferramenta na legenda n\00E3o seja apresentada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839803901311216)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dica de Ferramenta de Legenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840183819311216)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usado para definir uma dica de ferramenta personalizada descritiva curta no(s) nome(s) o eixo x do gr\00E1fico. No caso de um gr\00E1fico de Diagrama de Caixa, a coluna n\00E3o deve corresponder ao mapeamento da coluna Valor sele')
||unistr('cionada. A sele\00E7\00E3o de uma coluna que corresponde ao mapeamento da coluna Valor far\00E1 com que a dica de ferramenta n\00E3o seja apresentada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840075621311216)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dica de Ferramenta de Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914619418311274)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se as defini\00E7\00F5es de coluna s\00E3o derivadas da consulta SQL.'),
unistr('Isso exige que o &PRODUCT_NAME. fa\00E7a parsing da consulta.'),
unistr('Caso n\00E3o queira o parsing da consulta neste momento, use nomes de coluna gen\00E9ricos, que geram defini\00E7\00F5es de colunas de marcador de espa\00E7o.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914572184311274)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Nomes de Coluna Gen\00E9ricos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649465971311054)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto HTML exibido na parte superior da regi\00E3o, antes do conte\00FAdo <code>#BODY#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558750137310986)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto ou HTML que dever\00E1 ser exibido imediatamente ap\00F3s o cabe\00E7alho de p\00E1gina e antes do conte\00FAdo do corpo do texto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558627486310986)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto do Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922023387311279)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como os cabe\00E7alhos s\00E3o definidos para o relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100780668311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alhos Personalizados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100836792311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite que voc\00EA insira seus pr\00F3prios cabe\00E7alhos. Os cabe\00E7alhos s\00E3o inicialmente padronizados, com base em uma consulta de nomes de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100965861311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101083814311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria cabe\00E7alhos com base em uma Fun\00E7\00E3o PL/SQL que retorna uma lista de nomes delimitadas por ponto-e-v\00EDrgula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101100343311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101256849311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio \00E9 exibido sem cabe\00E7alhos de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100358039311426)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nomes de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100408411311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera cabe\00E7alhos baseados em uma consulta dos nomes de coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100588544311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Nomes de Colunas (Iniciais em Mai\00FAsculas)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100674696311427)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera cabe\00E7alhos que s\00E3o convertidos em capitaliza\00E7\00E3o inicial com base em uma consulta dos nomes de coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106921955762311279)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882601038311249)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o alinhamento do cabe\00E7alho. Observe que a sele\00E7\00E3o de alinhamento deve ser suportada pelo modelo de relat\00F3rio selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086567349311416)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086471500311416)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('in\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086663815311416)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882557781311249)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101363782311427)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Forne\00E7a os cabe\00E7alhos para um relat\00F3rio com base na tabela DEPT</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922290922311279)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma fun\00E7\00E3o PL/SQL para retornar uma string de cabe\00E7alhos de coluna delimitada por dois-pontos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922171107311279)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793928944311174)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Use este atributo para informar o texto de ajuda a ser usado na grade interativa. O texto de ajuda informado ser\00E1 exibido juntamente com o conte\00FAdo da ajuda padr\00E3o, sob a ajuda do Menu A\00E7\00F5es.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794863898311175)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Informe o texto de ajuda desta coluna.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936919327311290)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o texto de ajuda para este item. O texto de ajuda pode ser usado para fornecer ajuda contextual para o campo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561533158310988)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este atributo para inserir texto de ajuda para a p\00E1gina atual. A ajuda em n\00EDvel da p\00E1gina suporta atalhos usando a seguinte sintaxe:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>O texto de ajuda da p\00E1gina n\00E3o \00E9 exibido por padr\00E3o. No entanto, voc\00EA pode facilmente desenvolver um sistema de ajuda que exponha esse texto.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561464786310988)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815961631311197)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este atributo para inserir texto de ajuda para a p\00E1gina atual. A ajuda em n\00EDvel da p\00E1gina suporta atalhos usando a seguinte sintaxe:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>O texto de ajuda da p\00E1gina n\00E3o \00E9 exibido por padr\00E3o. No entanto, voc\00EA pode facilmente desenvolver um sistema de ajuda que exponha esse texto.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815896336311196)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598112732311016)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223245318311520)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835832224311212)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selecione o comportamento para ocultar e mostrar quando houver um clique em um item de legenda.',
unistr('        Por exemplo, ao cancelar a sele\00E7\00E3o de um item de legenda, voc\00EA ocultar\00E1 a s\00E9rie de dados associada a esse item no gr\00E1fico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835914210311213)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959550423311313)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' O gr\00E1fico n\00E3o permitir\00E1 o uso do comportamento para ocultar e mostrar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836118652311213)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Reescalonamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959741854311313)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' Os eixos dos gr\00E1ficos n\00E3o ser\00E3o reescalonados. Isso \00E9 \00FAtil para manter o usu\00E1rio no contexto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836012912311213)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Reescalonar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959602241311313)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' Os eixos dos gr\00E1ficos ser\00E3o reescalonados como os valores m\00EDnimo e m\00E1ximo de aumento ou diminui\00E7\00E3o dos dados vis\00EDveis. Isso \00E9 \00FAtil para s\00E9ries com valores altamente vari\00E1veis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835732579311212)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Comportamento para Ocultar e Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916736899311275)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe as strings de texto que ser\00E3o destacadas em uma coluna do relat\00F3rio.'),
unistr('Para v\00E1rias palavras destacadas, use uma lista delimitada por v\00EDrgulas.'),
unistr('Voc\00EA tamb\00E9m pode fazer refer\00EAncia a itens da p\00E1gina ou do aplicativo usando a sintaxe <code>&amp;ITEM.</code>.'),
unistr('Por exemplo, voc\00EA pode destacar strings informadas em um campo de pesquisa.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916650891311275)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar Palavras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701065013311093)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a home page do aplicativo para a interface de usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700907084311093)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URL do Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579436941311002)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Selecione o alinhamento horizontal para este bot\00E3o nas posi\00E7\00E3o do modelo especificado.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077681395311410)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077797973311410)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579366637311002)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088595926311418)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica a partir da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>#COLUMN_CLASS#</code> e <code>#EMPLOYEE_STATUS#</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885290565311251)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>#COLUMN#</code> para mostrar valores de coluna em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885197116311251)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558369405310986)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o texto para substituir a string de substitui\00E7\00E3o <code>#HEAD#</code> no cabe\00E7alho do modelo da p\00E1gina.'),
unistr('Os valores informados aqui s\00E3o inseridos ap\00F3s a tag HTML <code>&lt;head&gt;</code>. Use este atributo de p\00E1gina para adicionar meta tags especificas da p\00E1gina.'),
'</p>',
unistr('<p>Observa\00E7\00E3o: o c\00F3digo JavaScript ou as Folhas de Estilo em Cascata devem ser adicionados aos atributos JavaScript e CSS dedicados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558261506310986)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252105819311542)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que retorna o BLOB para a origem da imagem do \00EDcone.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252008155311542)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251965831311542)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como origem da imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251868544311542)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600609629311018)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que voc\00EA deseja usar para identificar esta faceta. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('            <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600706957311018)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que voc\00EA deseja usar para identificar esta faceta. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('            <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600829863311018)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que voc\00EA deseja usar para identificar esta faceta. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('            <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379507008311636)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira as classes relativas ao \00EDcone que voc\00EA deseja adicionar ao componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.</p>'),
unistr('        <p>Caso o seu tema use a Fonte APEX, analise a <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Amostra de Aplicativo Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>'),
unistr('        <p>Observa\00E7\00E3o: Esse \00EDcone ser\00E1 exibido dentro do item, e n\00E3o como parte do label.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379412863311636)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira as classes relativas ao \00EDcone que voc\00EA deseja adicionar ao componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.</p>'),
unistr('        <p>Caso o seu tema use a Fonte APEX, analise a <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Amostra de Aplicativo Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>'),
unistr('        <p>Observa\00E7\00E3o: Esse \00EDcone ser\00E1 exibido dentro do item, e n\00E3o como parte do label.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601068038311018)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que voc\00EA deseja usar para identificar este filtro. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('            <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601916232311019)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que voc\00EA deseja usar para identificar este filtro. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('            <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602354146311019)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que voc\00EA deseja usar para identificar este filtro. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('            <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238646050311533)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostre uma seta apontando para a direita</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238564634311533)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que deseja adicionar ao componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('        <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238427315311532)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253691692311544)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este texto descreve o \00EDcone e pode ser usado para dicas de ferramentas e texto alternativo para imagens.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253524835311543)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252355136311543)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o URL da origem da imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252224289311543)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URL da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252842309311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determina a posi\00E7\00E3o do \00EDcone no cabe\00E7alho do cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253395671311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253440156311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alinha o \00EDcone \00E0 posi\00E7\00E3o final (em geral o lado direito) do cabe\00E7alho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253116117311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253294942311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alinha o \00EDcone \00E0 posi\00E7\00E3o inicial (em geral o lado esquerdo) do cabe\00E7alho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252998460311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107253076773311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe o \00EDcone no alto do cabe\00E7alho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107252764048311543)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262161463311550)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251299797311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem do \00EDcone que \00E9 exibido no cabe\00E7alho do componente do cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251765780311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de BLOB da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251519517311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Classe do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251315535311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251442647311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classe do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251608537311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'URL da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251142112311542)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782864167311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&&ENAME.!HTML.&lt;/&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782793079311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('</p>Digite o HTML da coluna personalizada para a View de \00CDcone.</p>'),
unistr('<p>As seguintes strings de substitui\00E7\00E3o est\00E3o dispon\00EDveis:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - strings de substitui\00E7\00E3o para nomes de coluna.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - strings de substitui\00E7\00E3o para labels de coluna.</li>'),
'<li><code>&APEX$ROW_ID.</code> - o identificador de registro para a linha.</li>',
unistr('<li><code>&APEX$ROW_INDEX.</code> - o n\00FAmero de sequ\00EAncia de exibi\00E7\00E3o de registro.</li>'),
unistr('<li><code>&APEX$ROW_URL.</code> - refer\00EAncia ao Destino do Link especificado.</li>'),
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - o estado do registro, como <code>is-inserted</code> ou <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782656491311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone Personalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091966746311420)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893713612311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o link da coluna para a View do \00CDcone. Use as strings de substitui\00E7\00E3o <code>#COLUMN_NAME#</code> para os nomes de coluna, conforme necess\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893606399311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizar Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793751835311174)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a View do \00CDcone deve ficar ativada. A sele\00E7\00E3o de <b>Ativado</b> adiciona um \00EDcone de \00CDcones de View \00E0 barra de Pesquisa para relat\00F3rios interativos, ou ao bot\00E3o View de grade interativa, permitindo aos usu\00E1rios acessar essa view.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892174181311256)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a View do \00CDcone deve ficar ativada. A sele\00E7\00E3o de <b>Ativado</b> adiciona um \00EDcone de \00CDcones de View \00E0 barra de Pesquisa para relat\00F3rios interativos, ou ao bot\00E3o View de grade interativa, permitindo aos usu\00E1rios acessar essa view.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892018055311256)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893364459311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o texto ALT HTML da imagem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893202181311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto ALT HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893524185311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a tag TITLE HTML da imagem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893453336311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto TITLE HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784008043311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os atributos da imagem do \00EDcone usados para a tag HTML IMG.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783998185311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783413166311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna da grande interativa que retorna o BLOB para a origem da imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783345996311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783825384311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna da grade interativa que retorna as classes CSS para a origem da imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783765796311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783082055311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo da coluna que armazenar\00E1 a origem da imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783216233311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783143596311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem em URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782970714311165)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783602555311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna da grade interativa que retorna o URL para a origem da imagem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106783552483311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893146633311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe os atributos da imagem usados para a tag HTML IMG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106893044273311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091720973311420)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar a coluna <code>IMAGEM</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892746445311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna do relat\00F3rio que retorna a origem da imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892685237311256)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Origem da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091861656311420)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar a coluna <code>ENAME</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892927039311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna do relat\00F3rio que retorna o label da imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892849554311257)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Labels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766192366311151)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examine a coluna <code>ENAME</code></dt>',
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766003294311151)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna do relat\00F3rio que retorna o label da imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765993673311151)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Labels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784480542311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os atributos HTML associados \00E0 exibi\00E7\00E3o de cada <strong>Destino do Link</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784388914311166)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107091635874311420)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar a coluna <code>LINK</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892582779311256)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna do relat\00F3rio que retorna o destino do link do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106892493147311256)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319664989311593)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319950683311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319885543311593)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319728039311593)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320018883311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319548717311593)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320802807311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o Java que retorne uma Consulta SQL para preencher esta lista de valores.</p>'),
unistr('<p>A Consulta SQL s\00F3 precisa retornar uma coluna. Se a consulta retornar v\00E1rias colunas, apenas a primeira coluna ser\00E1 usada na pesquisa de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320706500311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320640143311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exibe o nome do departamento, define o n\00FAmero do departamento</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320579624311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o JavaScript que retorne uma Consulta SQL para preencher esta lista de valores.</p>'),
unistr('<p>A Consulta SQL s\00F3 precisa retornar uma coluna. Se a consulta retornar v\00E1rias colunas, apenas a primeira coluna ser\00E1 usada na pesquisa de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320446688311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320370931311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Para retornar o nome do departamento:</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320222165311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o PL/SQL que retorna uma Consulta SQL para preencher esta lista de valores.</p>'),
unistr('<p>A Consulta SQL s\00F3 precisa retornar uma coluna. Se a consulta retornar v\00E1rias colunas, apenas a primeira coluna ser\00E1 usada na pesquisa de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320145689311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321057950311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o Python que retorne uma Consulta SQL para preencher esta lista de valores.</p>'),
unistr('<p>A Consulta SQL s\00F3 precisa retornar uma coluna. Se a consulta retornar v\00E1rias colunas, apenas a primeira coluna ser\00E1 usada na pesquisa de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107320985581311594)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789396695311170)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<pre>Vaca,C\00E3o,Gato,Le\00E3o</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789292102311170)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira uma lista de valores delimitados por v\00EDrgulas para esta lista est\00E1tica.</p>'),
unistr('        <p>Observa\00E7\00E3o - os Valores Est\00E1ticos sempre ser\00E3o exibidos na mesma ordem em que forem especificados, e n\00E3o em ordem alfab\00E9tica.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789164883311170)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785026833311167)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o grupo para esta coluna. Os grupos s\00E3o usados para associar colunas na grade e na View de Uma Linha.</p>'),
unistr('        <p>Observa\00E7\00E3o - Voc\00EA pode adicionar grupos expandindo a pasta Atributos na \00E1rvore Renderiza\00E7\00E3o e clicando com o bot\00E3o direito do mouse em Grupos de Colunas para criar um novo grupo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784949148311167)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789598809311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de origem no qual o valor desta coluna \00E9 baseado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789624193311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789751588311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna do Banco de Dados</em>, que ser\00E1 recuperado da Consulta SQL de origem da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790096965311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790116851311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor de coluna n\00E3o \00E9 recuperado de nenhuma origem. Por exemplo, as colunas APEX$ROW_SELECTOR e APEX$ROW_ACTION n\00E3o t\00EAm origem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789855411311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789942512311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina como o valor retornado pela <em>Express\00E3o SQL</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106789447663311171)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782154341311164)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Verifique quais formatos de download os usu\00E1rios podem utilizar para fazer download das colunas exibidas no momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782278129311165)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'pt-br'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782300566311165)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'pt-br'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940361374311293)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'pt-br'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225670467310719)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106782079009311164)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formatos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784273311311166)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no Destino do Link para chamar uma caixa de di\00E1logo modal. Voc\00EA pode inserir um destino personalizado a ser chamado quando o \00EDcone for clicado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784136336311166)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destino do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780363460311163)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de pagina\00E7\00E3o para este relat\00F3rio. Geralmente, nem todas as linhas s\00E3o exibidas no relat\00F3rio.'),
unistr('		Para incluir linhas adicionais, o usu\00E1rio final poder\00E1 usar a pagina\00E7\00E3o fornecida.<p/>'),
unistr('		<p>A pagina\00E7\00E3o fornece ao usu\00E1rio final informa\00E7\00F5es sobre o n\00FAmero de linhas exibidas e a posi\00E7\00E3o atual no conjunto de resultados.<p/>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780505090311163)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rolar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908929409311269)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Inicialmente, s\00E3o exibidas linhas suficientes para preencher a altura da Grade Interativa.'),
unistr('        \00C0 medida que o usu\00E1rio final rola a tela, linhas adicionais s\00E3o exibidas, obtendo mais dados do servidor conforme a necessidade.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780442941311163)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908827143311269)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('As primeiras linhas ser\00E3o exibidas, com base no n\00FAmero especificado em <em>Linhas por P\00E1gina</em>.'),
unistr('        Se houver linhas adicionais, controles ser\00E3o adicionados ao rodap\00E9 do relat\00F3rio, permitindo que os usu\00E1rios finais naveguem para a frente e para tr\00E1s entre os conjuntos de linhas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780252315311163)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450479580311687)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o da Grade Interativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243860414311537)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um alias para este relat\00F3rio salvo. Utilize este alias para definir um link de URL mais significativo para este relat\00F3rio salvo espec\00EDfico. Esse link pode ser usado para vincula\00E7\00E3o direta a partir de outro lugar no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242805227311536)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243932110311537)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exiba a categoria do relat\00F3rio salvo, que determina o local que este relat\00F3rio ser\00E1 exibido na Lista de sele\00E7\00E3o Relat\00F3rios. Esse atributo \00E9 somente exibi\00E7\00E3o e n\00E3o pode ser atualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243002219311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243529545311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts do relat\00F3rio subsequente salvos pelos desenvolvedores, que os usu\00E1rios finais podem selecionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242958713311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243465658311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio salvo pelos desenvolvedores, que \00E9 exibido por padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243241796311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Particular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243742530311537)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts do relat\00F3rio salvos pelos usu\00E1rios finais, que s\00F3 o usu\00E1rio final que salvou o relat\00F3rio pode selecionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243185785311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107243699634311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts do relat\00F3rio salvos pelos usu\00E1rios finais, que todos os outros usu\00E1rios finais podem selecionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242791536311536)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Visibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785298092311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione onde o grupo ser\00E1 usado para exibir esta coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785342262311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ambos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785498442311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O grupo ser\00E1 exibido no cabe\00E7alho do relat\00F3rio e na View de Uma Linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785717692311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785861453311168)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O grupo s\00F3 ser\00E1 exibido no cabe\00E7alho do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785509373311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'pt-br'
,p_message_text=>'View de Uma Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785687148311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O grupo s\00F3 ser\00E1 exibido na View de Uma Linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106785167745311167)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Grupo para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648854456311053)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os atributos da tag da imagem a serem inclu\00EDdos no HTML da imagem. Isso pode ser usado para atributos como altura, largura ou texto ALT da imagem (se a imagem n\00E3o for decorativa).</p>'),
unistr('<p>Observa\00E7\00E3o: se nenhum ALT for definido nos atributos de tag da imagem, o &PRODUCT_NAME. ser\00E1 assumido como padr\00E3o para renderizar a imagem como imagem decorativa, por exemplo, com uma tag ALT vazia.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648793265311053)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos de Tag de Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917520093311276)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esta coluna ser\00E1 inclu\00EDda quando o relat\00F3rio for exportado para CSV ou impresso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917420287311276)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir na Exporta\00E7\00E3o/Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429416570311672)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica se a lista de valores inclui uma op\00E7\00E3o NULA no topo da lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429379046311672)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir Op\00E7\00E3o Nula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769977747311154)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique se a pseudo coluna ROWID deve ser selecionada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769886037311154)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir Coluna ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887328272311252)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Uma barra de pesquisa \00E9 exibida acima do relat\00F3rio. Se voc\00EA incluir a barra de pesquisa, tamb\00E9m ser\00E1 poss\00EDvel personalizar totalmente as fun\00E7\00F5es a serem exibidas.</p>'),
'A barra de pesquisa pode incluir os seguintes componentes:',
'<dl>',
'  <dt>Campo de Pesquisa</dt>',
unistr('    <dd>Exibe um campo de texto na barra de pesquisa usado para inserir crit\00E9rios de pesquisa.</dd>'),
'  <dt>Localizador Drop-Down</dt>',
unistr('    <dd>Incorporado no <em>Campo de Pesquisa</em>, mostra uma lista drop-down de colunas exibidas. Se uma coluna for selecionado, a pesquisa ser\00E1 realizada somente com os valores da coluna selecionada.</dd>'),
unistr('  <dt>Lista de Sele\00E7\00E3o de Relat\00F3rios</dt>'),
unistr('    <dd>Exibe uma lista de todos os relat\00F3rios dispon\00EDveis para o usu\00E1rio, incluindo relat\00F3rios prim\00E1rios, alternativos, p\00FAblicos e privados. Esta lista ser\00E1 exibida somente se um relat\00F3rio, com exce\00E7\00E3o do relat\00F3rio prim\00E1rio, estiver acess\00EDvel ao usu')
||unistr('\00E1rio.</dd>'),
unistr('  <dt>Seletor de Linhas Por P\00E1gina</dt>'),
unistr('    <dd>Exibe uma lista de sele\00E7\00E3o utilizado para selecionar o n\00FAmero de linhas a serem exibidas por p\00E1gina.</dd>'),
unistr('  <dt>Menu A\00E7\00F5es</dt>'),
unistr('    <dd>Exibe o bot\00E3o do menu A\00E7\00F5es, que geralmente inclui um conjunto abrangente de op\00E7\00F5es. Essas op\00E7\00F5es permitem que o usu\00E1rio final personalize o relat\00F3rio com base nas fun\00E7\00F5es disponibilizadas.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887267998311252)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir Barra de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558115527310986)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O &PRODUCT_NAME. geralmente exige arquivos JavaScript e CSS espec\00EDficos.'),
unistr('Para alguns aplicativos, como aplicativos m\00F3veis, talvez voc\00EA queira suprimir a inclus\00E3o desses arquivos na p\00E1gina.</p>'),
unistr('<p>Para incluir os arquivos do &PRODUCT_NAME. e JavaScript padr\00E3o, selecione <strong>Ativado</strong>. A sele\00E7\00E3o de <strong>Desativado</strong> suprime a inclus\00E3o desses arquivos no Cabe\00E7alho HTML.</p>'),
unistr('<p>Suprimir a inclus\00E3o desses arquivos pode ter efeitos adversos em um aplicativo e pode fazer com que ele seja interrompido.'),
unistr('Portanto, a desativa\00E7\00E3o desse atributo s\00F3 \00E9 recomend\00E1vel para desenvolvedores avan\00E7ados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558006695310986)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir JavaScript e CSS Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179819313311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna contendo a posi\00E7\00E3o inicial do mapa como um objeto de ponto GeoJSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179718772311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179699682311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna SDO_GEOMETRY contendo a posi\00E7\00E3o inicial do mapa como um objeto de ponto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179589679311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178835224311486)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica o tipo de coluna a ser usado para a posi\00E7\00E3o inicial do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179104048311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'pt-br'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179250599311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'GeoJSON, como tipos de coluna VARCHAR2 ou CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179356837311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude/Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179473447311487)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude e Latitude, como duas colunas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178972015311486)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'pt-br'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179055638311486)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo Oracle SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178792908311486)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados da Coluna de Geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177769112311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Se o mapa ser\00E1 centralizado na localiza\00E7\00E3o atual do navegador. Se essa op\00E7\00E3o for ativada, e o browser puder acessar a localiza\00E7\00E3o atual, essa defini\00E7\00E3o prevalecer\00E1 sobre a posi\00E7\00E3o inicial determinada por Valores Est\00E1ticos, consulta SQL ou com base')
||unistr(' em Resultados Espaciais, conforme configurado acima.</p><p>Isso s\00F3 se aplica \00E0 primeira carga de p\00E1gina em uma sess\00E3o do APEX. Quando a p\00E1gina de mapa for revisitada na sess\00E3o do APEX, o mapa ser\00E1 centralizado em sua \00FAltima posi\00E7\00E3o.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177632995311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Posi\00E7\00E3o do Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180221233311487)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha a coluna que cont\00E9m a latitude da posi\00E7\00E3o inicial do mapa. O valor retornado deve estar entre -90 e 90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180149318311487)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Latitude Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178467932311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a latitude da posi\00E7\00E3o inicial do mapa. Use valores entre -90 (Sul) e 90 (Norte) e "." como o caractere decimal. Exemplo: <strong>45,5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178314777311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180042482311487)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha a coluna que cont\00E9m a longitude da posi\00E7\00E3o inicial do mapa. O valor retornado deve estar entre -180 e 180.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107179947349311487)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Longitude Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178238543311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a longitude da posi\00E7\00E3o inicial do mapa. Use valores entre -180 (Oeste) e 180 (Leste) e "." como o caractere decimal. Exemplo: <strong>100,5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178150578311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178040008311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consulta que retorna colunas NUMBER para determinar a posi\00E7\00E3o inicial do mapa e o n\00EDvel de zoom:</p>'),
'<pre>',
'select -133.5 longitude,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>Consulta que retorna uma coluna SDO_GEOMETRY para determinar a posi\00E7\00E3o inicial do mapa e uma coluna NUMBER para o n\00EDvel de zoom.</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177922778311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira a Consulta SQL para determinar a posi\00E7\00E3o inicial do mapa e o n\00EDvel de zoom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177883738311486)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176972570311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique como a posi\00E7\00E3o inicial do mapa e o n\00EDvel de zoom ser\00E3o determinados para uma nova sess\00E3o do APEX ou ap\00F3s uma opera\00E7\00E3o <strong>Limpar</strong> ou <strong>Redefinir</strong> da regi\00E3o do mapa. Em uma sess\00E3o do APEX, a regi\00E3o do mapa memoriz')
||unistr('a a posi\00E7\00E3o atual e o n\00EDvel de zoom nas solicita\00E7\00F5es da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177480444311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Com Base em Resultados Espaciais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177540727311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O mapa ser\00E1 posicionado de modo que os resultados da consulta da camada sejam vis\00EDveis.<em>Observe que isso n\00E3o \00E9 suportado se GeoJSON for escolhido como o tipo de coluna de geometria da camada</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177224648311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177334470311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a uma consulta SQL que retorne valores para a posi\00E7\00E3o inicial do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177003732311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107177110567311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a valores est\00E1ticos para a posi\00E7\00E3o inicial do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176803917311485)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180472482311488)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha a coluna que cont\00E9m o n\00EDvel de zoom inicial. O valor retornado deve estar entre 1 e 18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180347928311487)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de N\00EDvel de Zoom Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178679078311486)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o n\00EDvel de zoom inicial. Use valores inteiros entre 1 e 18.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107178537501311486)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00EDvel de Zoom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066367947311402)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Define a classe CSS <code>display_only</code> como negrito</dt>',
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106553080610310982)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o c\00F3digo da Folha de Estilo em Cascata (CSS) usado nesta p\00E1gina.'),
unistr('Se o CSS for necess\00E1rio em v\00E1rias p\00E1ginas, considere coloc\00E1-lo em um arquivo externo para evitar duplica\00E7\00E3o e para utilizar o armazenamento do browser de arquivos est\00E1ticos.</p>'),
unistr('<p>O c\00F3digo que voc\00EA inserir aqui substitui a string de substitui\00E7\00E3o <code>#PAGE_CSS#</code> no modelo de p\00E1gina.</p>'),
unistr('<p>Observa\00E7\00E3o: voc\00EA n\00E3o precisa incluir tags de abertura ou fechamento <code>style</code>. Apenas inclua o c\00F3digo da folha de estilo em cascata.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552974427310982)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561324113310988)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a mensagem de erro exibida quando ocorrer um erro nesta p\00E1gina. A mensagem de erro ser\00E1 substitu\00EDda por <code>#NOTIFICATION_MESSAGE#</code> no modelo da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106561239462310988)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto de Notifica\00E7\00E3o de Erro Em Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379361535311636)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o texto de ajuda em linha para este item. O texto de ajuda est\00E1 sendo exibido imediatamente com o item e pode ser usado para fornecer ajuda contextual no n\00EDvel do campo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379296476311636)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto da Ajuda em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644899065311050)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione para onde o &PRODUCT_NAME. dever\00E1 ser redirecionado se a sess\00E3o n\00E3o for v\00E1lida.'),
unistr('Isso acontecer\00E1 se a <strong>Fun\00E7\00E3o Sentinela</strong> ou a <strong>Fun\00E7\00E3o Verifica\00E7\00E3o</strong> retornar FALSO em solicita\00E7\00F5es de p\00E1ginas normais, mas n\00E3o em solicita\00E7\00F5es do Ajax.</p>'),
unistr('<p>Observa\00E7\00E3o: se o Tipo de Esquema de Autentica\00E7\00E3o <strong>''Personalizado''</strong> for utilizado, o atributo <strong>''Fun\00E7\00E3o Sentinela''</strong> no Esquema de Autentica\00E7\00E3o tamb\00E9m poder\00E1 ser usado.'),
unistr('Para Tipos de Esquema de Autentica\00E7\00E3o de plug-in, isso \00E9 definido pelo desenvolvedor de plug-in no callback <strong>''Nome da Fun\00E7\00E3o de Sentinela de Sess\00E3o''</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079396849311411)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in Incorporada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079432176311411)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redireciona para o URL definido em <code>wwv_flow_custom_auth_std.login_page</code>, fornecido pelo &PRODUCT_NAME..'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079132286311411)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Log-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079226182311411)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redireciona para o URL de log-in definido nos atributos do aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079509162311411)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079677350311411)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redireciona para o URL informado, como <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644723949311050)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionamento de Sess\00E3o Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645022918311050)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um URL para o qual o &PRODUCT_NAME. deve redirecionar se a fun\00E7\00E3o de sentinela da sess\00E3o retornar FALSO. Normalmente, esse URL corresponde a uma p\00E1gina de login ou um portal de single sign-on. Por exemplo, f?p=&amp;APP_ID.:101:&amp;SESSION')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644912655311050)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL de Sess\00E3o Inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886039983311251)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de exibi\00E7\00E3o de coluna relevante para definir como valores de coluna ser\00E3o exibidos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086020411311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download do BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270349547311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como um link para fazer download do arquivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086388825311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Oculta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270686893311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o exibe a coluna, mas ela pode ser referenciada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085961861311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270298616311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como uma imagem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085860882311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270152864311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como um link.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086140319311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Percentual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270426418311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe a coluna como um gr\00E1fico de porcentagem. O valor recuperado deve estar entre 0 e 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085684502311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto sem Formata\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269996536311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe o valor da coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085701924311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto sem Formata\00E7\00E3o (baseado na Lista de Valores)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270036144311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe o valor retornado da lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342453302311609)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342564268311610)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Renderiza a coluna usando HTML ou Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107086288285311416)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'pt-br'
,p_message_text=>'Remover HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270540677311558)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe o valor da coluna, ap\00F3s remover as tags HTML e os caracteres especiais de escape.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885999653311251)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970257010311321)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Para retornar o nome do departamento:</dt>',
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904355029311266)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma consulta SQL que precise retornar uma coluna. Se a consulta retornar v\00E1rias colunas, somente a primeira ser\00E1 usada na lista de valores.</p>'),
unistr('<p>A inser\00E7\00E3o de uma consulta SQL pode melhorar o desempenho em alguns relat\00F3rios, ou ser usada para limitar os valores exibidos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904261635311266)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023749321311366)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma lista de valores nomeada definida. O filtro da coluna usar\00E1 somente a primeira coluna da consulta da lista de valores din\00E2mica ou o valor de exibi\00E7\00E3o da lista de valores est\00E1tica para filtrar os dados do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023627126311366)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'LOV Nomeada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884848055311250)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como derivar os filtros fornecidos na lista drop-down da coluna de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087802271311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Nomeada para Filtrar Correspond\00EAncia Exata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087909162311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Deriva a lista de valores da lista de valores nomeada para criar um filtro igual a.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088052282311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Nomeada para Filtrar a Palavra Cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088137176311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deriva a lista de valores da lista de valores nomeada para criar um filtro cont\00E9m.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087606907311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Definida para Filtrar a Palavra Cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087737568311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deriva a lista de valores a partir de uma lista definida de consulta de valores SQL para criar um filtro cont\00E9m.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087248605311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Baseado no Tipo de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087308181311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'As colunas STRING e NUMBER derivam da lista de valores de valores de colunas distintos. As colunas de DATA derivam da lista de valores de intervalos de data predefinidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087042979311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087149000311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 filtro de coluna fornecido para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087451402311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Definida para Filtrar Correspond\00EAncia Exata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107087558343311417)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deriva a lista de valores a partir de uma lista definida de consulta de valores SQL para criar um filtro de correspond\00EAncia igual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884765318311250)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885864428311251)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o grupo para esta coluna. Os grupos s\00E3o usados para exibir colunas em grupos l\00F3gicos na View de Uma Linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885735326311251)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889772399311254)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o tipo de coluna de link para este relat\00F3rio.'),
unistr('Se voc\00EA selecionar a coluna de link, ela sempre ser\00E1 exibida como a primeira coluna no relat\00F3rio e n\00E3o poder\00E1 ser ocultada pelo usu\00E1rio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090059983311419)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'pt-br'
,p_message_text=>'Link para Alvo Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090145106311419)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final \00E9 direcionado para outra p\00E1gina com base no URL de destino informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090246447311419)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Coluna do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090358828311419)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna de link n\00E3o \00E9 exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089820466311419)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Link para View de Uma Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089940860311419)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final \00E9 direcionado para uma p\00E1gina que mostra os valores da coluna para a linha especificada. O que e como as colunas s\00E3o exibidas \00E9 determinado por v\00E1rios atributos de relat\00F3rio e coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106889688086311254)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936353761311290)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887538642311252)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de pagina\00E7\00E3o para este relat\00F3rio. Geralmente, apenas um determinado n\00FAmero de linhas de um relat\00F3rio \00E9 exibido em uma p\00E1gina.'),
unistr('Para incluir linhas adicionais, o usu\00E1rio final do aplicativo dever\00E1 navegar at\00E9 a pr\00F3xima p\00E1gina do relat\00F3rio.<p/>'),
unistr('<p>A pagina\00E7\00E3o fornece ao usu\00E1rio final informa\00E7\00F5es sobre o n\00FAmero de linhas e a posi\00E7\00E3o atual no conjunto de resultados.<p/>'),
unistr('<p>A pagina\00E7\00E3o pode ser mostrada acima ou abaixo do relat\00F3rio (ou em ambos) e pode ser posicionada \00E0 esquerda ou \00E0 direita.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088837873311418)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Faixas de Linha X a Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088738976311418)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'pt-br'
,p_message_text=>'Faixas de Linha X a Y de Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887456033311252)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902007715311264)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um alias para este relat\00F3rio salvo. Utilize este alias para definir um link de URL mais significativo para este relat\00F3rio salvo espec\00EDfico. Esse link pode ser usado para vincula\00E7\00E3o direta a partir de outro lugar no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901988121311264)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902491404311264)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exiba a categoria do relat\00F3rio salvo, que determina o local que este relat\00F3rio ser\00E1 exibido na Lista de sele\00E7\00E3o Relat\00F3rios. Esse atributo \00E9 somente exibi\00E7\00E3o e n\00E3o pode ser atualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092474955311421)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Alternativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270801420311558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts do relat\00F3rio subsequente salvos pelos desenvolvedores, que os usu\00E1rios finais podem selecionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092388540311421)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Prim\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270729432311558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio salvo pelos desenvolvedores, que \00E9 exibido por padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092624984311421)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Particular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271046644311558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts do relat\00F3rio salvos pelos usu\00E1rios finais, que s\00F3 o usu\00E1rio final que salvou o relat\00F3rio pode selecionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092561682311421)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107270993075311558)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layouts do relat\00F3rio salvos pelos usu\00E1rios finais, que todos os outros usu\00E1rios finais podem selecionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902393631311264)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Visibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736334308311127)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem editar essa regi\00E3o do Form.</p>'),
unistr('        <p>Observa\00E7\00E3o - Quando a regi\00E3o do Form \00E9 tornada edit\00E1vel, um processo \00E9 criado automaticamente para processar a linha.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777250414311160)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais poder\00E3o editar esta Grade Interativa.</p>'),
unistr('        <p>Observa\00E7\00E3o - Quando a Grade Interativa se torna edit\00E1vel, um processo \00E9 automaticamente criado para processar as linhas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777110885311160)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375164810311633)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790932670311172)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a coluna \00E9 um dos valores de chave prim\00E1ria para a(s) tabela(s) subjacente(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790889836311172)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790711997311172)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se deseja excluir a coluna das opera\00E7\00F5es DML.</p>'),
unistr('        <p>Se definido como <strong>Ativado</strong>, o &PRODUCT_NAME. n\00E3o utilizar\00E1 a coluna ao executar a Grade Interativa - Processamento Autom\00E1tico de Linha (DML).'),
unistr('        Por exemplo, exclua colunas cujas defini\00E7\00F5es incluam concatena\00E7\00F5es, sele\00E7\00F5es internas, chamadas de fun\00E7\00E3o ou uma coluna em uma view atualiz\00E1vel que se baseie em uma express\00E3o.</p>'),
unistr('        <p>Todas as colunas que precisarem ser inclu\00EDdas em quaisquer instru\00E7\00F5es INSERT ou UPDATE devem ter essa op\00E7\00E3o definida como <strong>Desativado</strong>.</p>'),
unistr('        <p>Observa\00E7\00E3o: As colunas do tipo <em>Somente para Exibi\00E7\00E3o</em> <u>tamb\00E9m</u> s\00E3o inclu\00EDdas no Processamento Autom\00E1tico de Linha, a menos que essa op\00E7\00E3o esteja definida como <strong>Ativado</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790673890311172)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871729098311240)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o par\00E2metro s\00F3 pode ser definido uma vez com um valor est\00E1tico ou ser substitu\00EDdo no n\00EDvel do componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871681926311240)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223441342311520)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esta coluna ficar\00E1 exibida ou oculta. Mesmo se ficar oculta, as colunas sempre podem ser referenciadas usando a sintaxe de substitui\00E7\00E3o, <code>&amp;COLUMN_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107223366268311520)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763808702311149)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser utilizada para definir o valor alto nesse gr\00E1fico. Quando nenhuma coluna for selecionada, o valor mais alto do gr\00E1fico de Diagrama de Caixa ser\00E1 baseado no conjunto de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763634671311149)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763737882311149)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser utilizada para definir o valor baixo nesse gr\00E1fico. Quando nenhuma coluna for selecionada, o valor mais baixo do gr\00E1fico de Diagrama de Caixa ser\00E1 baseado no conjunto de dados. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763554975311149)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838743269311215)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor de fechamento neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838614487311215)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fechamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838384467311214)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor m\00E1ximo neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838249365311214)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840360853311216)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usado para definir o(s) label(s) do eixo x no gr\00E1fico. Para um gr\00E1fico de A\00E7\00F5es, a coluna dever\00E1 ser do tipo de dados marca\00E7\00E3o de Data / Hora, para representar as informa\00E7\00F5es de a\00E7\00F5es no eixo do tempo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840222119311216)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669522733311069)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845702893311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Digite uma string de estilo CSS que defina o estilo dos labels neste gr\00E1fico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845653603311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869944233311239)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para s\00E9ries de intervalos, se um array de dois valores for fornecido, o primeiro e o segundo valores ser\00E3o aplicados aos pontos m\00EDnimo e m\00E1ximo, respectivamente. O valor <strong>Fatia Externa</strong> s\00F3 se aplica a gr\00E1ficos de pizza.'),
unistr('        Os valores <strong>Acima do Marcador</strong>, <strong>Abaixo do Marcador</strong>, <strong>Antes do Marcador</strong> e <strong>Depois do Marcador</strong> se aplicam somente a s\00E9ries de linhas, \00E1reas, dispers\00E3o e bolhas. Os valores <strong>')
||unistr('Borda Interna da Barra</strong> e <strong>Borda Externa da Barra</strong> s\00F3 se aplicam'),
unistr('        a s\00E9ries de barras n\00E3o polares. Barras empilhadas n\00E3o suportam o valor <strong>Borda Externa da Barra</strong>. O valor <strong>Iniciar</strong> s\00F3 se aplica a gr\00E1ficos de Gauge de Medi\00E7\00E3o de Status. Atualmente, o gr\00E1fico n\00E3o ajusta o layout ')
||unistr('para encaixar labels na \00E1rea de plotagem nem \00E9 capaz de lidar com sobreposi\00E7\00F5es entre labels.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844715863311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o dos labels a serem renderizados no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844953224311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Acima do Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845213313311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Depois do Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845530513311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845156177311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Antes do Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845000196311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Abaixo do Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844896112311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845328728311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borda da Barra Interna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869386291311238)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845478339311220)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borda da Barra Externa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869292850311238)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fatia Externa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305157459310789)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844603497311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844533285311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os labels dever\00E3o ser renderizados no gr\00E1fico. Essa defini\00E7\00E3o se aplica \00E0 visibilidade do valor de m\00E9trica em um gr\00E1fico de Quadrantes. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844446276311219)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838181573311214)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor m\00EDnimo neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838032640311214)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839793329311215)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor m\00E1ximo neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839623765311215)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941682567311294)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor m\00EDnimo neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106941541841311293)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838593090311215)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor de abertura neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838433481311214)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Abertura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840563548311216)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usado para definir uma dica de ferramenta personalizada descritiva curta nos pontos de dados do gr\00E1fico. Para renderizar uma dica de ferramenta nos pontos de dados do gr\00E1fico, verifique se o atributo de dica de ferram')
||unistr('enta do gr\00E1fico <strong>Mostrar</strong> est\00E1 definido como <strong>Ativado</strong>. No caso de um gr\00E1fico de Diagrama de Caixa, a coluna n\00E3o deve corresponder ao mapeamento da coluna Valor selecionada. A sele\00E7\00E3o de uma coluna que corresponde ao map')
||unistr('eamento da coluna Valor far\00E1 com que nenhuma dica de ferramenta personalizada seja renderizada no gr\00E1fico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840498143311216)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dica de Ferramenta Personalizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839527892311215)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor de destino neste gr\00E1fico. Quando esta op\00E7\00E3o \00E9 definida, o atributo de valor define a \00E1rea preenchida na fatia, e isso representa o valor da fatia inteira. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839430545311215)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837991878311214)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir um valor neste gr\00E1fico. Para um Diagrama de Caixa, essa coluna ser\00E1 usada para definir os valores m\00EDnimos, quartis, m\00E9dios e m\00E1ximos do conjunto de dados num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837878491311214)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838918912311215)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor de volume neste gr\00E1fico. Quando valores s\00E3o fornecidos, o volume \00E9 exibido no eixo y2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106838898953311215)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Volume'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839135768311215)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor x neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839057588311215)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839315565311215)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor y neste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106839214254311215)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836782560311213)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o valor z neste gr\00E1fico. O valor z define o raio da bolha para um gr\00E1fico de bolhas, a largura de um item do gr\00E1fico de caixa e a largura da barra para um gr\00E1fico de barras ou de combina\00E7\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836672941311213)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648260970311053)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione se os componentes da regi\00E3o (sub-regi\00F5es, itens, bot\00F5es) s\00E3o exibidos acima ou abaixo do conte\00FAdo da regi\00E3o principal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080482803311412)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acima do Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080563938311412)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Abaixo do Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648116417311053)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Renderizar Componentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582849315311005)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome deste item. Os nomes de item devem ser identificadores Oracle v\00E1lidos. \00C9 recomend\00E1vel que os nomes de item tenham at\00E9 30 bytes, para que possam ser usados como vari\00E1veis de bind em Consultas SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582727738311005)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794141854311174)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como esta coluna ser\00E1 renderizada. Os seguintes tipos de colunas s\00E3o suportados:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Dependendo da configura\00E7\00E3o do aplicativo, tamb\00E9m poder\00E1 haver plug-ins de tipo de coluna adicionais dispon\00EDveis aqui.'),
unistr('Eles ser\00E3o exibidos como <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('Os seguintes plug-ins s\00E3o instalados nos componentes compartilhados deste aplicativo:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582464574311005)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique como este item ser\00E1 renderizado. Os seguintes tipos de itens s\00E3o suportados:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Dependendo da configura\00E7\00E3o do aplicativo, tamb\00E9m \00E9 poss\00EDvel ter plug-ins de tipos de itens adicionais dispon\00EDveis aqui.'),
unistr('Estes s\00E3o exibidos como <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('Os seguintes plug-ins s\00E3o instalados nos componentes compartilhados deste aplicativo:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582377173311005)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241881644311535)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262912144311550)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir item na verifica\00E7\00E3o de altera\00E7\00F5es n\00E3o salvas, se a verifica\00E7\00E3o estiver ativada no n\00EDvel da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241337449311535)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o item de p\00E1gina \00E9 inclu\00EDdo na verifica\00E7\00E3o de altera\00E7\00F5es n\00E3o salvas, que avisa o usu\00E1rio quando ele tenta navegar para fora da p\00E1gina e ela cont\00E9m altera\00E7\00F5es n\00E3o salvas. Talvez n\00E3o seja necess\00E1rio verificar alguns itens (por exemplo, e')
||unistr('les n\00E3o se baseiam em uma coluna de banco de dados, como um item de pesquisa); portanto, \00E9 poss\00EDvel definir que eles sejam ignorados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241435078311535)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ignorar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107244236980311537)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As altera\00E7\00F5es no item s\00E3o ignoradas pela verifica\00E7\00E3o de altera\00E7\00F5es n\00E3o salvas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241226822311535)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aviso sobre Altera\00E7\00F5es N\00E3o Salvas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386141523311641)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('fun\00E7\00E3o( op\00E7\00F5es ) {'),
'    options.toolbar = false;',
unistr('    retorna op\00E7\00F5es;'),
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804659859311187)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira uma fun\00E7\00E3o JavaScript que tome um objeto de configura\00E7\00E3o para a Grade Interativa, modifique o objeto e o retorne. Essa op\00E7\00E3o permite uma personaliza\00E7\00E3o avan\00E7ada da apar\00EAncia, funcionalidades e comportamento da Grade Interativa, inclusive barra')
||unistr(' de ferramentas, menus e a\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386203226311641)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('fun\00E7\00E3o( op\00E7\00F5es ) {'),
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940987506311293)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira uma fun\00E7\00E3o JavaScript que utiliza um objeto de configura\00E7\00E3o para a coluna, modifique o objeto e o retorne. Essa op\00E7\00E3o permite uma personaliza\00E7\00E3o avan\00E7ada da apar\00EAncia, funcionalidades e comportamento da coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386386129311641)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('fun\00E7\00E3o( op\00E7\00F5es ){'),
unistr('    // Configura uma fun\00E7\00E3o de callback que \00E9 chamada quando os dados s\00E3o recuperados; ela permite manipular a s\00E9rie'),
unistr('    options.dataFilter = fun\00E7\00E3o( dados ) {'),
'        data.series[ 0 ].color = "#00FF00";',
'        retorna dados;',
'    };',
unistr('    // Definir op\00E7\00F5es de inicializa\00E7\00E3o do gr\00E1fico'),
'    options.type = "line";',
unistr('    retorna op\00E7\00F5es;'),
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850357764311224)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe o c\00F3digo JavaScript para personalizar o gr\00E1fico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386982752311641)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('fun\00E7\00E3o( op\00E7\00F5es ) {'),
'  options.advancedOption = true;',
unistr('    retorna op\00E7\00F5es;'),
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784696215311167)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Insira uma fun\00E7\00E3o JavaScript que tome um objeto de configura\00E7\00E3o para o componente, modifique o objeto e o retorne. Essa op\00E7\00E3o permite uma personaliza\00E7\00E3o avan\00E7ada da apar\00EAncia, funcionalidades e comportamento do componente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106784530499311166)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo de Inicializa\00E7\00E3o de JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155655380311468)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a posi\00E7\00E3o dos eixos principal e secund\00E1rio no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156369525311469)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156247746311469)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155536539311468)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o do Eixo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159159598311471)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a escala de tempo a ser usada para o eixo no gr\00E1fico. \00C9 obrigat\00F3rio para que o Gantt seja renderizado corretamente. A escala de tempo selecionada ser\00E1 usada para aplicar zoom, quando nenhuma op\00E7\00E3o de Escala de Zoom tiver sido selecionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157269940311469)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157196355311469)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156824083311469)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157608803311470)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157837297311470)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trimestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156741785311469)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157484374311470)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158032943311470)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159068031311471)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825337178311204)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de gr\00E1fico. O tipo de gr\00E1fico determina a visualiza\00E7\00E3o usada para renderizar o gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825478826311204)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966111553311318)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de \00E1reas s\00E3o \00FAteis para comparar tend\00EAncias de valores cumulativos com o passar do tempo, tais como detalhamentos de tend\00EAncias de vendas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825555849311204)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966202663311318)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de barras s\00E3o \00FAteis para comparar valores entre categorias ou com o passar do tempo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747030681311136)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Diagrama de Caixa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747112895311136)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os diagramas de caixa s\00E3o \00FAteis para analisar a distribui\00E7\00E3o de dados, exibir os valores m\00EDnimos, quartis, m\00E9dios e m\00E1ximos de grupos de dados num\00E9ricos. Eles tamb\00E9m s\00E3o chamados de diagramas de Caixa e Whisker.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825686862311204)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bolha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966317449311318)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de bolhas definem itens de dados usando x, y e z, tornando-os \00FAteis para exibir relacionamentos entre 3 dimens\00F5es. A terceira dimens\00E3o \00E9 representada pelo tamanho da bolha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825734354311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Combina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966409419311318)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de combina\00E7\00E3o permitem que s\00E9ries de barras, linhas e \00E1reas sejam exibidas no mesmo gr\00E1fico. O caso de uso mais comum \00E9 linhas com barras ou linhas com barras sobrepostas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825853832311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Gauge do Medidor de Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966587291311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gauges de Medi\00E7\00E3o de Status s\00E3o usados para exibir um valor de m\00E9trica em rela\00E7\00E3o aos valores m\00EDnimo e m\00E1ximo poss\00EDveis para essa m\00E9trica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860907376311232)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rosca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966611708311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de rosca s\00E3o gr\00E1ficos de pizza com um buraco no meio. Eles s\00E3o \00FAteis para visualizar partes de um todo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825957939311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Funil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966743020311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de funil s\00E3o \00FAteis para exibir dados de est\00E1gios de um processo, como os est\00E1gios de um processo de venda. A \00E1rea de uma fatia do funil \00E9 proporcional ao valor do est\00E1gio correspondente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156035375311469)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Gantt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156106566311469)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de Gantt s\00E3o \00FAteis para exibir programa\00E7\00F5es do projeto, exibindo barras que indicam as datas de in\00EDcio e de t\00E9rmino das tarefas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826038646311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966869036311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de linhas s\00E3o \00FAteis para visualizar tend\00EAncias em um conjunto de valores com o passar do tempo e comparar esses valores entre s\00E9ries.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826199399311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966932760311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de Linhas com \00C1reas s\00E3o iguais aos gr\00E1ficos de linhas, com a \00E1rea abaixo de cada linha preenchida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826240653311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967051748311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de pizza s\00E3o \00FAteis para visualizar partes de um todo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860641321311231)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Polar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967115994311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos polares t\00EAm um eixo y radial e um eixo x tangencial. Os gr\00E1ficos polares podem ser renderizados como os tipos de s\00E9ries de gr\00E1ficos de barras, linhas, combina\00E7\00E3o, dispers\00E3o ou bolhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659654741311061)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pir\00E2mide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659724236311061)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de pir\00E2mide s\00E3o \00FAteis para visualizar relacionamentos, etapas de processos, camadas organizacionais ou interconex\00F5es de t\00F3picos hier\00E1rquicos, proporcionais e baseados em fundamentos. A \00E1rea de uma fatia da pir\00E2mide \00E9 proporcional a seu va')
||unistr('lor para o est\00E1gio correspondente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860766918311231)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Radar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967212815311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de radar s\00E3o gr\00E1ficos polares com uma forma de grade poligonal, em vez de uma forma circular. Eles s\00E3o suportados pelos tipos de s\00E9ries de gr\00E1ficos de \00E1reas e de linhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860824186311231)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967393544311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de intervalos exibem um m\00E1ximo e um m\00EDnimo (valores mais altos / mais baixos) para cada entrada, usando barras ou \00E1reas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826380167311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispers\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967436938311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de dispers\00E3o definem itens de dados usando valores x e y, tornando-os \00FAteis para exibir relacionamentos entre 2 dimens\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826447382311205)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967528335311319)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os gr\00E1ficos de a\00E7\00F5es s\00E3o \00FAteis para exibir informa\00E7\00F5es sobre uma a\00E7\00E3o em um eixo de tempo. A propriedade <strong>Renderizar A\00E7\00E3o Como</strong>, para casti\00E7ais, \00E9 exclusiva em gr\00E1ficos de a\00E7\00F5es e permite exibir informa\00E7\00F5es sobre valores m\00EDnimos, m\00E1xim')
||unistr('os, de abertura e de fechamento para o pre\00E7o da a\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106825216958311204)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764092740311150)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se as lacunas nos dados do seu gr\00E1fico com v\00E1rias s\00E9ries dever\00E3o ser definidas com o valor zero ou nulo.</p>'),
unistr('        <p>Quando definido como <strong>Ativado</strong>, as lacunas nos dados s\00E3o tratadas como zero. Em um gr\00E1fico de linhas, isso garante que a linha seja renderizada como uma linha cont\00EDnua. Em um gr\00E1fico de barras empilhadas com o Label de Pilha')
||' definido como Ativado, isso garante que o label de pilha seja renderizado para cada pilha.</p>',
unistr('        <p>Quando definido como <strong>Desativado</strong>, as lacunas nos dados s\00E3o tratadas como um valor nulo. Em um gr\00E1fico de linhas, a linha ser\00E1 renderizada como uma linha quebrada, com as lacunas representando pontos de dados nulos.<p>'),
unistr('        <p>Essa defini\00E7\00E3o ser\00E1 aplicada a tipos de gr\00E1ficos com v\00E1rias s\00E9ries que suportem a renderiza\00E7\00E3o na forma de barras e linhas, como Barras, Linhas, Linhas com \00C1reas, Combina\00E7\00E3o, \00C1reas, Polar, Radar e Dispers\00E3o. O padr\00E3o \00E9 <strong>Ativado</str')
||'ong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106763996563311149)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Renderizar Lacuna como Zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828323320311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione se o cursor de dados ser\00E1 ativado no gr\00E1fico.'),
unistr('        O cursor de dados \00E9 uma alternativa \00FAtil \00E0s dicas de ferramentas quando os itens de dados t\00EAm navega\00E7\00E3o dif\00EDcil, especialmente em dispositivos de toque.'),
unistr('        <p/>Se esta op\00E7\00E3o for definida como <strong>Autom\00E1tico</strong>, o cursor de dados ser\00E1 mostrado somente para gr\00E1ficos de linha ou de \00E1reas em dispositivos de toque.<p/>'),
unistr('        <p>Observa\00E7\00E3o - O cursor de dados n\00E3o \00E9 mostrado quando a dica de ferramenta \00E9 nula, e n\00E3o \00E9 suportado em gr\00E1ficos polares.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828411663311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106967962382311320)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplique ao gr\00E1fico a exibi\00E7\00E3o de cursor de dados padr\00E3o definida para o Oracle JET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828645933311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968153489311320)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O cursor de dados n\00E3o \00E9 exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828597879311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968040517311320)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O cursor de dados \00E9 sempre exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828265016311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828849124311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o comportamento do cursor de dados no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828902227311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958497520311312)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar ao gr\00E1fico o comportamento de cursor de dados padr\00E3o definido pelo Oracle JET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829099041311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'pt-br'
,p_message_text=>'Suavizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968228523311320)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O cursor de dados segue a movimenta\00E7\00E3o do toque/mouse suavemente, exibindo a dica de ferramenta sempre que percorre qualquer parte de um elemento de dados, e n\00E3o apenas pontos de dados espec\00EDficos. Um indicador identifica o elemento de dados selec')
||'ionado no momento.</p>',
unistr('        <p>Observa\00E7\00E3o - Defina o <strong>Cursor</strong> como <strong>Sim</strong> para que esta visualiza\00E7\00E3o funcione completamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829136024311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Deslocar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968369014311320)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O cursor de dados se desloca (pula) para um elemento de dados quando ocorre uma movimenta\00E7\00E3o de toque ou do mouse no gr\00E1fico, exibindo a dica de ferramenta sempre que percorre qualquer parte de um elemento de dados. Um indicador identifica o eleme')
||'nto de dados selecionando no momento.</p>',
unistr('        <p>Observa\00E7\00E3o - Defina <strong>Cursor</strong> como <strong>Sim</strong> para que esta visualiza\00E7\00E3o funcione completamente.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106828706697311207)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Comportamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678693489311076)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se as lacunas nos dados do seu gr\00E1fico com v\00E1rias s\00E9ries devem ser preenchidas automaticamente. Essa defini\00E7\00E3o n\00E3o se aplica a gr\00E1ficos de s\00E9rie \00FAnica ou a estes tipos de gr\00E1fico: Bolhas, Rosca, Funil, Gantt, Pizza, Pir\00E2mide, Dispers\00E3o e ')
||unistr('A\00E7\00F5es. Quando definido como <strong>Ativado</strong>, a l\00F3gica de densifica\00E7\00E3o de dados apresentada no Oracle Application Express 5.1.3 ser\00E1 aplicada aos dados do gr\00E1fico. Quando definido como <strong>Desativado</strong>, as lacunas nos dados n\00E3o ser')
||unistr('\00E3o preenchidas e poder\00E3o resultar em renderiza\00E7\00E3o imprecisa do gr\00E1fico. O padr\00E3o \00E9 <strong>Ativado</strong>.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678553082311076)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Preencher Lacunas nos Dados do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392532073311645)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe as classes CSS a serem aplicadas a barras de linha de base no gr\00E1fico de Gantt. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os. Voc\00EA pode utilizar substitui\00E7\00F5es de <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392490960311645)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS de Linha de Base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162787711311474)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de t\00E9rmino da linha de base no gr\00E1fico de Gantt. Uma data de t\00E9rmino de linha de base \00E9 a data de t\00E9rmino planejada original da tarefa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162633033311474)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de T\00E9rmino da Linha de Base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162550218311473)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de in\00EDcio da linha de base no gr\00E1fico de Gantt. Uma data de in\00EDcio de linha de base \00E9 a data de in\00EDcio planejada original da tarefa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162411102311473)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio da Linha de Base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160917068311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de t\00E9rmino do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160878185311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161180931311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o item de p\00E1gina ou do aplicativo a ser usado para definir a data de t\00E9rmino do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161099814311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160145884311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem a ser usada para definir a data de t\00E9rmino do gr\00E1fico de Gantt. Uma data de t\00E9rmino \00E9 obrigat\00F3ria para renderizar o gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160385337311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160429108311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna de Data de T\00E9rmino</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160629879311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160785622311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item de Data de T\00E9rmino</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160200417311472)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Origem da Data de T\00E9rmino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162968587311474)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o andamento da tarefa no gr\00E1fico de Gantt. O valor do andamento deve estar entre 0 e 1. Se o valor for inv\00E1lido, nenhum andamento ser\00E1 mostrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162820860311474)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392366249311645)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe as classes CSS a serem aplicadas a barras de andamento no gr\00E1fico de Gantt. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os. Voc\00EA pode utilizar substitui\00E7\00F5es de <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392268377311645)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS de Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161383943311472)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o ID de linha no gr\00E1fico de gantt. Um ID de linha ser\00E1 necess\00E1rio se voc\00EA desejar renderizar diversas tarefas for linha. Quando nenhum mapeamento de coluna de ID de linha for definido, cada tarefa s')
||unistr('er\00E1 renderizada como tarefa \00FAnica por linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161223709311472)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'ID da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161514102311473)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o nome da linha no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161473734311473)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160068935311472)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de in\00EDcio do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159991371311471)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Data Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169503540311479)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o item de p\00E1gina ou do aplicativo a ser usado para definir a data de in\00EDcio do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107160527486311472)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156590831311469)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem a ser usada para definir a data de in\00EDcio do gr\00E1fico de Gantt. Uma data de in\00EDcio \00E9 obrigat\00F3ria para renderizar o gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159374371311471)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159421374311471)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna de Data de In\00EDcio</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159510722311471)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107159656107311471)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item de Data de In\00EDcio</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156450869311469)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Origem da Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392164222311645)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe as classes CSS a serem aplicadas a barras de tarefa no gr\00E1fico de Gantt. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os. Voc\00EA pode utilizar substitui\00E7\00F5es de <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392062515311645)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS da Tarefa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162341476311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de t\00E9rmino da tarefa no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162246475311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de T\00E9rmino da Tarefa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161723539311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir o ID da tarefa no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161637799311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'ID da Tarefa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161948361311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usado para definir o nome da tarefa no gr\00E1fico de gantt. Quando nenhum mapeamento de coluna de nome de linha for definido, o nome da tarefa ser\00E1 usado como label de linha no eixo de linha do gr\00E1fico. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107161837913311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tarefa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162129578311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de in\00EDcio da tarefa no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107162061801311473)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data de In\00EDcio da Tarefa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372777812311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de t\00E9rmino do viewport do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367777430311628)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372820284311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o item de p\00E1gina ou do aplicativo a ser usado para definir a data de t\00E9rmino do viewport do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367527107311627)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372408206311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem a ser usada para definir a data de t\00E9rmino do viewport do gr\00E1fico de Gantt. Um viewport \00E9 uma faixa de datas que quando definida pode controlar o zoom inicial de um gr\00E1fico quando renderizado. O gr\00E1fico ser\00E1 ampliado para uma faixa')
||' de datas especificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367903579311628)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372505014311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna de Data de T\00E9rmino</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368154367311628)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372669686311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item de Data de T\00E9rmino</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367434917311627)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Origem da Data de T\00E9rmino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372271311311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a data de in\00EDcio do viewport do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367604308311628)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Data Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372318798311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o item de p\00E1gina ou do aplicativo a ser usado para definir a data de in\00EDcio do viewport do gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367311743311627)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371912815311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem a ser usada para definir a data de in\00EDcio do viewport do gr\00E1fico de Gantt. Um viewport \00E9 uma faixa de datas que quando definida pode controlar o zoom inicial de um gr\00E1fico quando renderizado. O gr\00E1fico ser\00E1 ampliado para uma faixa ')
||'de datas especificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367818899311628)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372091500311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna de Data de In\00EDcio</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107368083821311628)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107372106885311631)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item de Data de In\00EDcio</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107367261602311627)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Origem da Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271541646310763)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a extens\00E3o do \00E2ngulo em graus para o gr\00E1fico Gauge de Medi\00E7\00E3o de Status com orienta\00E7\00E3o circular. A Extens\00E3o do \00C2ngulo \00E9 o \00E2ngulo da orienta\00E7\00E3o circular. Os valores positivos indicam um \00E2ngulo inicial no sentido hor\00E1rio. Os valores negativos i')
||unistr('ndicam um \00E2ngulo inicial no sentido anti-hor\00E1rio. Voc\00EA pode desenhar o gauge circular em qualquer \00E2ngulo desejado e alterar sua forma de acordo com o \00E2ngulo escolhido. A forma do gauge depende de 2 defini\00E7\00F5es: <strong>\00C2ngulo Inicial</strong> e <stron')
||unistr('g>Extens\00E3o do \00C2ngulo</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271388024310763)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Extens\00E3o do \00C2ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270901953310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a propor\00E7\00E3o de espessura relativa do indicador em rela\00E7\00E3o \00E0 \00E1rea de plotagem. O padr\00E3o \00E9 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270810886310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271011796310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o raio interno de um gr\00E1fico de gauge de Medi\00E7\00E3o de Status com orienta\00E7\00E3o circular, definido pela dist\00E2ncia entre o centro do gauge at\00E9 a borda interna do indicador e a \00E1rea de plotagem. Os valores v\00E1lidos s\00E3o um percentual ou uma propor\00E7')
||unistr('\00E3o entre 0 e 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271180035310763)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Raio Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270520220310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de gr\00E1fico de Gauge de Medi\00E7\00E3o de Status a ser renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270237044310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Circular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270386584310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270465940310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270186550310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270747011310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione se a \00E1rea de plotagem de um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status deve ser renderizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106270647028310762)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar \00C1rea de Plotagem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106384906023310850)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281160955310771)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor a ser exibida para a \00E1rea de plotagem de um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status. Voc\00EA pode utilizar substitui\00E7\00F5es de <code>&COLUMN_VALUE.</code>. Essa cor s\00F3 \00E9 aplicada quando n\00E3o h\00E1 valores-limite definidos para o gr\00E1fico.</p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um n\00FAmero seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os val')
||'ores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281022119310771)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cor da \00C1rea de Plotagem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271498617310763)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o \00E2ngulo inicial em graus para o gr\00E1fico Gauge de Medi\00E7\00E3o de Status com orienta\00E7\00E3o circular. Os valores positivos indicam um \00E2ngulo inicial no sentido hor\00E1rio. Os valores negativos indicam um \00E2ngulo inicial no sentido anti-hor\00E1rio. Voc\00EA pode ')
||unistr('desenhar o gauge circular em qualquer \00E2ngulo desejado e alterar sua forma de acordo com o \00E2ngulo escolhido. A forma do gauge depende de 2 defini\00E7\00F5es: <strong>\00C2ngulo Inicial</strong> e <strong>Extens\00E3o do \00C2ngulo</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271260826310763)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C2ngulo Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155907573311468)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir linhas de grade horizontais no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155289492311468)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Grade Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829387070311207)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique o comportamento a ser aplicado ao passar o mouse sobre itens de dados do gr\00E1fico.<p/>'),
unistr('        Selecione <strong>Ativado</strong> para escurecer todos os itens de dados n\00E3o focados pelo mouse e destacar apenas o item de dados atual focado pelo mouse.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829225971311207)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escurecer Fora do Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417006301311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a dire\00E7\00E3o de zoom inicial do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417124591311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417280408311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inicialmente, aproxima at\00E9 os primeiros pontos de dados que podem se ajustar na \00E1rea de plotagem do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417370550311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417400779311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inicialmente, aproxima at\00E9 os \00FAltimos pontos de dados que podem se ajustar na \00E1rea de plotagem do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417566852311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417609163311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Para desativar o zoom inicial.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416914252311663)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dire\00E7\00E3o de Zoom Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802541001311186)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545271146310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir a fonte do atributo especificado.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542223242310974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543878288310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a fam\00EDlia de fontes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542427121310974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542331988310974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542569311310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542616832310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542812095310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542713906310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542997246310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543047799310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543142383310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543299627310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543336738310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543503763310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543489657310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543697498310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543746527310975)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541942847310974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fam\00EDlia de Fontes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544350748310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tamanho da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544541251310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'pt-br'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544604811310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'pt-br'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544796317310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'pt-br'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544894105310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'pt-br'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544913374310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'pt-br'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545078407310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'pt-br'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545185120310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'pt-br'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544468565310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542143657310974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106543979352310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o estilo da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544161550310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544096945310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106544247128310976)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obl\00EDquo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106542048986310974)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106352918456310827)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique como os labels devem ser exibidos nas fatias do gr\00E1fico de pizza. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396565294311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Label - Percentual (Valor)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397007276311649)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Os labels exibir\00E3o as informa\00E7\00F5es de label, valor e percentual no seguinte formato: label - percentual ( valor ). Por exemplo, <strong>Bugs - 15% ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396601763311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual (Valor)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397121739311649)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Os labels aparecer\00E3o na forma de valores num\00E9ricos, com base no mapeamento selecionado para a coluna Valor. Por exemplo, <strong>15% ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396281334311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396756777311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Os labels aparecer\00E3o nas fatias do gr\00E1fico, com base no mapeamento selecionado para a coluna Label. Por exemplo, <strong>Bugs</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740853034311131)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Label - Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740923876311131)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Os labels exibir\00E3o as informa\00E7\00F5es de label e valor no seguinte formato: label - valor. Por exemplo, <strong>Bugs - 18</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396373359311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396851885311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Os labels aparecer\00E3o na forma de valores entre 0% e 100%, com base no mapeamento selecionado para a coluna Valor. O valor \00E9 um percentual do total de valores representado no gr\00E1fico. Por exemplo, <strong>15%</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396445116311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396953849311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Os labels aparecer\00E3o na forma de valores num\00E9ricos, com base no mapeamento selecionado para a coluna Valor.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396151908311648)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802476078311185)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539223141310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir a fonte do atributo especificado.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538804428310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538902731310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a fam\00EDlia de fontes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539463115310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539395444310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539598253310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539648785310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539864806310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539767891310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539946927310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540017235310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540188568310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540246901310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540342700310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540590717310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540446165310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540691480310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540786127310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538507273310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fam\00EDlia de Fontes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539199972310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tamanho da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541258187310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'pt-br'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541392155310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'pt-br'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541416086310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'pt-br'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541563142310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'pt-br'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541608288310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'pt-br'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541704473310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'pt-br'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541829026310974)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'pt-br'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541173173310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538760228310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106539046863310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o estilo da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540980736310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106540853130310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106541004787310973)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obl\00EDquo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538680574310972)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388756530310852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m cores:</dt>'),
'<dd><pre>',
'<strong>vermelho,amarelo,azul</strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m itens de p\00E1gina ou de aplicativo e que retorna cores, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;ITEM.</code>. Por exemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m colunas e retorna valores num\00E9ricos, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;ITEM.</code>. Por exemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m colunas e retorna cores, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;COLUMN_NAME.</code>. Por exemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388626094310852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe as cores que ser\00E3o usadas para identificar as linhas de refer\00EAncia a serem renderizadas em um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status.'),
unistr('Para v\00E1rias linhas de refer\00EAncia, use uma lista delimitada por v\00EDrgulas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388303312310852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388523369310852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m valores num\00E9ricos est\00E1ticos:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m itens de p\00E1gina ou de aplicativo e que retorna valores num\00E9ricos, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;ITEM.</code>. Por exemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m colunas e retorna valores num\00E9ricos, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;COLUMN_NAME.</code>. Por exemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388490907310852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe os n\00FAmeros que ser\00E3o usados para identificar as linhas de refer\00EAncia a serem renderizadas em um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status.'),
unistr('Para v\00E1rias linhas de refer\00EAncia, use uma lista delimitada por v\00EDrgulas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106388237255310852)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155767902311468)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja renderizar os labels de linhas no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155435117311468)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Eixo de Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840897353311216)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840768901311216)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor a ser exibida para os itens de dados associados a esta s\00E9rie do gr\00E1fico. Voc\00EA pode utilizar substitui\00E7\00F5es <code>&COLUMN_VALUE.</code>. Para um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status, essa cor ser\00E1 aplicada ao indicador, com a exce\00E7\00E3o ')
||unistr('de quando os limites s\00E3o definidos e o atributo <strong>Exibi\00E7\00E3o de Limite</strong> \00E9 definido como <strong>No Indicador</strong></p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um n\00FAmero seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os val')
||'ores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840673015311216)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766666093311152)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766404666311152)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor a ser exibida para o segmento q2 da s\00E9rie de gr\00E1ficos de Diagrama de Caixa. Voc\00EA pode utilizar substitui\00E7\00F5es de <code>&COLUMN_VALUE.</code></p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um n\00FAmero seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os val')
||'ores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766258515311151)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Q2 Cor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766741708311152)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766535951311152)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor a ser exibida para o segmento q3 da s\00E9rie de gr\00E1ficos de Diagrama de Caixa. Voc\00EA pode utilizar substitui\00E7\00F5es de <code>&COLUMN_VALUE.</code></p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um n\00FAmero seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os val')
||'ores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106766338440311151)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Q3 Cor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106761522605311148)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de s\00E9rie do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748486054311137)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748592502311137)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748362313311137)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Diagrama de Caixa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748652809311137)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748713290311137)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748825752311137)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862832237311233)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapeamento da Coluna de Tipo de S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863063668311233)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de s\00E9rie de gr\00E1ficos. Tamb\00E9m \00E9 poss\00EDvel criar um gr\00E1fico que combine diferentes tipos de s\00E9ries na mesma plotagem de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863161102311233)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863615172311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Intervalo de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863236604311233)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863590791311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo de Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863346605311233)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863417430311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862938236311233)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864254412311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de s\00E9rie do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864361492311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864942669311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Intervalo de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864475116311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864842249311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo de Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864799307311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bolha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864590285311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152013156311466)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864661336311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispers\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864102473311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865194472311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de s\00E9rie do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865202315311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865377067311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Intervalo de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865424620311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106865095476311235)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863865918311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de s\00E9rie do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106864059540311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Intervalo de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863994840311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo de Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106863779039311234)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845980896311220)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o eixo dever\00E1 ser renderizado no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106845863774311220)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Eixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387216772310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir informa\00E7\00F5es da linha de base na dica de ferramenta do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386692880310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Linha de Base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387080710310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir a data final na dica de ferramenta do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386422143310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387154014310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir o andamento na dica de ferramenta do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386587202310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386758560310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir informa\00E7\00F5es sobre a linha na dica de ferramenta do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386176982310850)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386923365310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir a data inicial na dica de ferramenta do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386337606310851)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Data Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271716672310763)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o valor dever\00E1 ser renderizado no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106271685056310763)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386863067310851)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir o label na dica de ferramenta do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106386205051310851)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834116143311211)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se uma dica de ferramenta dever\00E1 ser renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834046060311211)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834715447311212)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se valores ser\00E3o exibidos na dica de ferramentas do seu gr\00E1fico. Os valores s\00E3o derivados da consulta do gr\00E1fico e s\00E3o exibidos pr\00F3ximos aos dados do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834661873311211)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169406538311479)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a ordem de classifica\00E7\00E3o dos dados de um gr\00E1fico multisseriado, com base no valor ou label do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154015534311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Label - Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154466378311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Define a ordem do gr\00E1fico com base nos r\00F3tulos do eixo-x na ordem crescente. Esta \00E9 a ordem de classifica\00E7\00E3o padr\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154110147311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Label - Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154518225311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Define a ordem do gr\00E1fico com base nos r\00F3tulos do eixo-x na ordem decrescente. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153861313311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Valor - Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154290951311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Define a classifica\00E7\00E3o do gr\00E1fico com base nos valores na ordem crescente (1, 2, 3, ...). Esta defini\00E7\00E3o s\00F3 deve ser usada para gr\00E1ficos de pizza, gr\00E1ficos de barra/linha/\00E1rea com uma s\00E9rie ou gr\00E1ficos de \00E1rea/barras empilhadas. A classifica\00E7\00E3o n\00E3o s')
||unistr('er\00E1 aplicada ao usar um eixo do grupo hier\00E1rquico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153967053311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Valor - Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154342127311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Define a classifica\00E7\00E3o do gr\00E1fico com base nos valores na ordem decrescente (10, 9, 8, ...). Esta defini\00E7\00E3o s\00F3 deve ser usada para gr\00E1ficos de pizza, gr\00E1ficos de barra/linha/\00E1rea com uma s\00E9rie ou gr\00E1ficos de \00E1rea/barras empilhadas. A classifica\00E7\00E3o n\00E3')
||unistr('o ser\00E1 aplicada ao usar um eixo do grupo hier\00E1rquico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153784928311467)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ordem de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999256926311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999106375311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir a fonte do atributo especificado.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998797169311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998803282311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a fam\00EDlia de fontes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000589766311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000407790311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000644604311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000783608311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000920301311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000894215311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001091652311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001146317311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001249731311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001332187311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001443736311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001678237311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001538727311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001786175311348)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001804717311349)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998487320311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fam\00EDlia de Fontes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999026895311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tamanho da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999481784311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'pt-br'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999588991311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'pt-br'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999668390311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'pt-br'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999784278311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'pt-br'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999838674311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'pt-br'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999942316311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'pt-br'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000030384311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'pt-br'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106999335605311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998654400311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998985798311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o estilo da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000251419311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000148572311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107000365623311347)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obl\00EDquo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998500660311346)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163120876311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o dos r\00F3tulos da tarefa no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163464305311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163809317311475)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O r\00F3tulo da tarefa \00E9 renderizado no fim da barra de tarefas no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163556608311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centro Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163986651311475)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O r\00F3tulo da tarefa \00E9 renderizado no centro interno da barra de tarefas no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163787313311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164123026311475)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O r\00F3tulo da tarefa \00E9 renderizado no fim interno da barra de tarefas no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163665004311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio Interno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107164028931311475)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O r\00F3tulo da tarefa \00E9 renderizado no in\00EDcio interno da barra de tarefas no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163274284311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163326610311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O r\00F3tulo da tarefa \00E9 renderizado no in\00EDcio da barra de tarefas no gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107163048788311474)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o do R\00F3tulo da Tarefa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300023252310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m cores:</dt>'),
'<dd><pre>',
'<strong>vermelho,amarelo,azul</strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m itens de p\00E1gina ou de aplicativo e que retorna cores, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;ITEM.</code>. Por exemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m colunas e retorna valores num\00E9ricos, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;ITEM.</code>. Por exemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m colunas e retorna cores, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;COLUMN_NAME.</code>. Por exemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299940137310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe as cores que ser\00E3o usadas para identificar os limites superiores a serem renderizados em um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status.'),
unistr('Para v\00E1rios limites, use uma lista delimitada por v\00EDrgulas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281302242310771)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385035943310850)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique como os limites dever\00E3o ser exibidos no gr\00E1fico de Gauge de Medi\00E7\00E3o de Status. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299480846310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299564262310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todos os limites, definidos com o atributo <strong>Valores-Limite </strong>, s\00E3o exibidos na \00E1rea de plotagem do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299764719310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Limite Atual Apenas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299846895310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O limite atual, definido com o atributo <strong>Valores-Limite </strong>, \00E9 exibido na \00E1rea de plotagem do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299687675310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'No Indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385172325310850)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O limite atual, definido com o atributo <strong>Valores-Limite </strong>, \00E9 exibido no indicador do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299363007310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106299275327310785)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m valores num\00E9ricos est\00E1ticos:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m itens de p\00E1gina ou de aplicativo e que retorna valores num\00E9ricos, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;ITEM.</code>. Por exemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Uma lista delimitada por v\00EDrgulas que cont\00E9m colunas e retorna valores num\00E9ricos, usando:</dt>'),
'<dd><pre>',
'a sintaxe <code>&amp;COLUMN_NAME.</code>. Por exemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281267631310771)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe os n\00FAmeros que ser\00E3o usados para identificar os limites superiores a serem renderizados em um gr\00E1fico de Gauge de Medi\00E7\00E3o de Status.'),
unistr('Para v\00E1rios limites, use uma lista delimitada por v\00EDrgulas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280994861310770)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802326945311185)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538426538310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir a fonte do atributo especificado.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535485458310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537095397310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a fam\00EDlia de fontes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535644651310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535550917310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535737647310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535897650310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536096794310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535932205310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536164941310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536277943310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536300402310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536450902310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536599240310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536715221310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536645826310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536897195310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106536945914310970)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535178280310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fam\00EDlia de Fontes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537574574310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tamanho da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537799458310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'pt-br'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537824317310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'pt-br'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537957444310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'pt-br'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538060205310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'pt-br'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538125805310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'pt-br'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538247671310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'pt-br'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106538387912310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'pt-br'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537616104310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535340122310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537175429310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o estilo da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537370633310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537251346310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106537458230310971)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obl\00EDquo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106535251023310969)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829568768311208)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de eixo de tempo a ser exibido no gr\00E1fico. Essa defini\00E7\00E3o produzir\00E1 automaticamente os dados do gr\00E1fico em ordem cronol\00F3gica, e n\00E3o dever\00E1 ser usada caso voc\00EA queira que seus dados sejam apresentados em ordem cronol\00F3gica inversa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829665428311208)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958591846311312)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar ao gr\00E1fico a defini\00E7\00E3o de eixo de tempo padr\00E3o especificada pelo Oracle JET, com base nos dados que est\00E3o sendo renderizados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829733673311208)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958643208311313)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o aplicar ao gr\00E1fico uma defini\00E7\00E3o de tipo de eixo de tempo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829824932311208)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958724215311313)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar ao gr\00E1fico uma defini\00E7\00E3o de tipo de eixo de tempo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829938016311208)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Frequ\00EAncia Mista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868867433311238)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores de tempo exibidos no eixo do gr\00E1fico em frequ\00EAncia mista. Como o valor de tempo dos dados pode variar, n\00E3o h\00E1 suporte para empilhamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868958264311238)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ignorar Lacunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869010960311238)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores de tempo exibidos no eixo do gr\00E1fico ser\00E3o renderizados em um intervalo regular, independentemente das lacunas de tempo que poder\00E3o existir nos dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106829455431311207)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Eixo de Tempo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802269894311185)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534602777310969)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir a fonte do atributo especificado.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534596470310969)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534217934310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a fam\00EDlia de fontes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532800150310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532728987310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532901183310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533064080310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533258296310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533154029310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533381259310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533492664310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533518199310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533609308310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533738526310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533900286310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106533876364310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534060564310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534171466310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531310552310966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fam\00EDlia de Fontes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534472841310969)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tamanho da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532089274310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'pt-br'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532110875310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'pt-br'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532211568310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'pt-br'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532354221310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'pt-br'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532446570310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'pt-br'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532593762310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'pt-br'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106532638342310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'pt-br'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531963766310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'pt-br'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531576675310966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534380700310968)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o estilo da fonte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531701877310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531611217310966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531810504310967)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obl\00EDquo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531498475310966)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155892869311468)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja exibir linhas de grade verticais no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155337114311468)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Grade Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869887750311239)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o comportamento de zoom e rolagem do gr\00E1fico. O comportamento <strong>Ativo</strong> significa que o gr\00E1fico ser\00E1 atualizado \00E0 medida que est\00E1 sendo manipulado,'),
unistr('        enquanto <strong>Atrasado</strong> significa que a atualiza\00E7\00E3o aguardar\00E1 at\00E9 que a a\00E7\00E3o de zoom/rolagem seja executada. Apesar de o comportamento de zoom e rolagem <strong>Ativo</strong> fornecer a melhor experi\00EAncia do usu\00E1rio, n\00E3o h\00E1 garant')
||'ias',
unistr('        em rela\00E7\00E3o ao desempenho da renderiza\00E7\00E3o, \00E0 usabilidade de grandes conjuntos de dados ou a ambientes clientes lentos. Se o desempenho for muito importante, o comportamento de zoom e rolagem <strong>Atrasado</strong> dever\00E1 ser usado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830194650311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique o comportamento de zoom e rolagem do gr\00E1fico.'),
unistr('        O recurso de zoom e rolagem permite que o usu\00E1rio final utilize gestos, como arrastar dados na \00E1rea de plotagem, usar a roda do mouse ou utilizar pin\00E7agens com dois dedos, para redimensionar os valores exibidos e navegar no gr\00E1fico para exibi')
||'r diferentes valores.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830371857311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Atrasada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909570925311270)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A altera\00E7\00E3o na exibi\00E7\00E3o dos dados aguardar\00E1 at\00E9 que a a\00E7\00E3o de zoom/rolagem seja realizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830456896311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rolagem Atrasada Somente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909666657311270)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A altera\00E7\00E3o na exibi\00E7\00E3o dos dados aguardar\00E1 at\00E9 que a a\00E7\00E3o de rolagem seja realizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830523492311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909798383311270)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A op\00E7\00E3o Ativa significa que o comportamento do gr\00E1fico ser\00E1 atualizado continuamente porque est\00E1 sendo manipulado.'),
unistr('        Para grandes conjuntos de dados ou ambientes clientes lentos, recomenda-se selecionar a op\00E7\00E3o <strong>Atrasada</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830680257311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rolagem Ativa Somente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909825205311270)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O comportamento Rolagem Ativa Somente significa que o gr\00E1fico ser\00E1 atualizado continuamente \00E0 medida que a tela do gr\00E1fico for rolada.'),
unistr('        Para grandes conjuntos de dados ou ambientes clientes lentos, considere a sele\00E7\00E3o de <strong>Rolagem Atrasada Somente</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830242290311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106909427092311270)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As opera\00E7\00F5es de zoom e rolagem s\00E3o desativadas para o gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830019276311208)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Zoom e Rolagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374323779311632)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a dire\00E7\00E3o de zoom do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374490955311632)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ambos os Eixos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374503262311632)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aproxima o zoom na dire\00E7\00E3o de ambos os eixos x e y.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374699918311633)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'pt-br'
,p_message_text=>'Eixo X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374779831311633)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aproxima apenas na dire\00E7\00E3o do eixo x.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374826121311633)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>'Eixo Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374984451311633)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aproxima apenas na dire\00E7\00E3o do eixo y.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107374200556311632)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dire\00E7\00E3o de Zoom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158526430311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de dias no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157373010311469)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158478076311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de horas no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157063818311469)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158395966311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de minutos no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156982448311469)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158756772311471)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de meses no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157779025311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158876111311471)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de trimestres no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157962339311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Trimestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158245676311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de segundos no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107156657196311469)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158667651311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de semanas no gr\00E1fico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107157572271311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158974210311471)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se deseja permitir zoom para uma escala de anos no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107158197763311470)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962113633311315)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique uma condi\00E7\00E3o do cliente para controlar se a a\00E7\00E3o \00E9 disparada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557228736310985)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique uma condi\00E7\00E3o de cliente para controlar se as a\00E7\00F5es Verdadeiro ou Falso s\00E3o acionadas. Se a condi\00E7\00E3o'),
unistr('                                  for avaliada como Verdadeiro, as a\00E7\00F5es com essa condi\00E7\00E3o ser\00E3o acionadas; se a condi\00E7\00E3o for avaliada como Falso, as a\00E7\00F5es com essa condi\00E7\00E3o ser\00E3o acionadas.'),
unistr('                                  Se nenhuma condi\00E7\00E3o for especificada, somente as a\00E7\00F5es com a condi\00E7\00E3o Verdadeiro ser\00E3o acionadas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068394057311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425038708311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado \00E9 igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068549383311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item > Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425246345311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado \00E9 maior que o <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068675177311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item >= Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425309872311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado \00E9 maior ou igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069171365311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item est\00E1 na lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425809117311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado est\00E1 na <em>Lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069333136311404)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426028949311670)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avalia a Express\00E3o JavaScript especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068764500311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item < Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425438598311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado \00E9 menor que o <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068862612311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item <= Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425517113311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado \00E9 menor ou igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068474811311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425106632311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado n\00E3o \00E9 igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069281772311404)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o est\00E1 na lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425958405311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> selecionado n\00E3o est\00E1 na <em>Lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107069014947311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o \00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425718133311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o <em>Item</em> selecionado n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068980576311403)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107425689507311669)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o <em>Item</em> selecionado est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557151774310985)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426429670311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna usada nesta condi\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: Na maioria dos casos, deve ser a coluna especificada acima, na op\00E7\00E3o<em>Quando - Coluna(s)</em>,'),
unistr('e portanto adota como padr\00E3o esse valor. Contudo, talvez voc\00EA queira basear a condi\00E7\00E3o em outra coluna,'),
unistr('por exemplo, com uma Grade Interativa baseada na tabela EMP, se quiser acionar uma a\00E7\00E3o din\00E2mica'),
unistr('sempre que <code>SAL</code> for alterado, mas somente se o <code>JOB</code> for igual a <em>SALESMAN</em>; ent\00E3o, voc\00EA alteraria esse atributo para <code>JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421089217311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427786622311671)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione se um <em>Item</em> ou <em>Coluna</em> \00E9 usado(a) nesta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416597716311663)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416446176311663)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416397628311662)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962280382311315)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe o item da p\00E1gina usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962066383311315)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Informe o item da p\00E1gina usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426530256311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o item de p\00E1gina usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou selecionar na lista de itens dispon\00EDveis.</p>'),
unistr('<p>Observa\00E7\00E3o: Na maioria dos casos, deve ser o item especificado acima, na op\00E7\00E3o<em>Quando Item(ns)</em>,'),
unistr('e portanto adota como padr\00E3o esse valor. Contudo, talvez voc\00EA queira basear a condi\00E7\00E3o em outro item de p\00E1gina,'),
unistr('por exemplo, com um form baseado na tabela EMP, se quiser acionar uma a\00E7\00E3o din\00E2mica sempre que <code>P2_SAL</code> for alterado, mas somente se o <code>P2_JOB</code> for igual a <em>SALESMAN</em>; ent\00E3o, voc\00EA alteraria esse atributo para <code>P2_JOB')
||'</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416603281311663)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426309458311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420985458311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106962376447311315)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique uma condi\00E7\00E3o do cliente para controlar se a a\00E7\00E3o \00E9 disparada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421209905311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique uma condi\00E7\00E3o de cliente para controlar se as a\00E7\00F5es Verdadeiro ou Falso s\00E3o acionadas. Se a condi\00E7\00E3o'),
unistr('                                  for avaliada como Verdadeiro, as a\00E7\00F5es com essa condi\00E7\00E3o ser\00E3o acionadas; se a condi\00E7\00E3o for avaliada como Falso, as a\00E7\00F5es com essa condi\00E7\00E3o ser\00E3o acionadas.'),
unistr('                                  Se nenhuma condi\00E7\00E3o for especificada, somente as a\00E7\00F5es com a condi\00E7\00E3o Verdadeiro ser\00E3o acionadas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421383847311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426641045311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) \00E9 igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421508431311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna > Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426885108311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) \00E9 maior que o <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421612805311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna > = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426991417311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) \00E9 maior ou igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422106912311667)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O(A) Item / Coluna est\00E1 na lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427447712311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) est\00E1 na <em>Lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422376213311667)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427688467311671)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avalia a Express\00E3o JavaScript especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421750281311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna < Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427010124311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) \00E9 menor que o <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421870116311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna <= Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427191457311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) \00E9 menor ou igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421417005311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna ! = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107426726440311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) n\00E3o \00E9 igual ao <em>Valor</em> especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422204344311667)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O(A) Item / Coluna n\00E3o est\00E1 na lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427597692311671)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o valor do <em>Item</em> ou <em>Coluna</em> selecionado(a) n\00E3o est\00E1 na <em>Lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422007951311667)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O(A) Item / Coluna n\00E3o \00E9 nulo(a)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427308328311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o <em>Item</em> ou <em>Coluna</em> especificado(a) n\00E3o est\00E1 vazio(a).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421947242311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item / Coluna nulo(a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107427268851311670)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica se o <em>Item</em> ou <em>Coluna</em> especificado(a) est\00E1 vazio(a).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107421181852311666)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961901457311315)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique a Express\00E3o JavaScript a ser avaliada para esta condi\00E7\00E3o.'),
unistr('O c\00F3digo tem acesso aos seguintes atributos relacionados \00E0 a\00E7\00E3o din\00E2mica:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>Uma refer\00EAncia ao objeto DOM do elemento que acionou a a\00E7\00E3o din\00E2mica.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>O objeto do evento que acionou o evento. Observa\00E7\00E3o: No carregamento \00E9 igual a ''carregar''.</dd>'),
'  <dt>this.data</dt>',
'    <dd>Dados adicionais opcionais que podem ser informados no handler de eventos.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961864438311315)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422908581311667)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique a Express\00E3o JavaScript a ser avaliada para esta condi\00E7\00E3o.'),
unistr('O c\00F3digo tem acesso aos seguintes atributos relacionados \00E0 a\00E7\00E3o din\00E2mica:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>Uma refer\00EAncia ao objeto DOM do elemento que acionou a a\00E7\00E3o din\00E2mica.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>O objeto do evento que acionou o evento. Observa\00E7\00E3o: No carregamento \00E9 igual a ''carregar''.</dd>'),
'  <dt>this.data</dt>',
'    <dd>Dados adicionais opcionais que podem ser informados no handler de eventos.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422852732311667)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420841201311666)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de valores separados por v\00EDrgulas para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420748025311666)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422710289311667)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de valores separados por v\00EDrgulas da condi\00E7\00E3o a ser testada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422600723311667)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461325271311694)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor desta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461252063311694)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422578111311667)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor da condi\00E7\00E3o para testar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107422404040311667)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557995328310986)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o c\00F3digo JavaScript que ser\00E1 executado quando a p\00E1gina for carregada. O c\00F3digo \00E9 executado ap\00F3s a gera\00E7\00E3o do c\00F3digo JavaScript pelo &PRODUCT_NAME.</p>'),
unistr('<p>O c\00F3digo que voc\00EA informar aqui substituir\00E1 a string de substitui\00E7\00E3o <code>#GENERATED_JAVASCRIPT#</code> no modelo de p\00E1gina.</p>'),
unistr('<p>Observa\00E7\00E3o: Voc\00EA n\00E3o precisa adicionar nenhuma tag de abertura ou de fechamento <code>script</code>, apenas o c\00F3digo JavaScript.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557867773310986)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar quando a P\00E1gina For Carregada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060221545311394)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Refer\00EAncia de arquivo padr\00E3o</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>Refer\00EAncia de arquivo padr\00E3o que carrega o arquivo minimizado <code>main.min.js</code> de <code>/myjs/minified/</code> para views de p\00E1gina regulares e <code>main.js</code> de <code>/myjs/</code> no modo de depura\00E7\00E3o ou ao executar o aplicativo n')
||'o App Builder.</dt>',
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>Use essa sintaxe se a biblioteca tamb\00E9m for usada de uma chamada require RequireJS. O nome define deve corresponder ao que \00E9 usado nos caminhos requirejs.config e o valor deve ser o s\00EDmbolo global exposto pela biblioteca. S\00F3 se aplica ao usar Req')
||'uireJS. Isso evita que RequireJS carregue essa biblioteca pela segunda vez.</dt>',
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>Use essa sintaxe se o arquivo tiver uma depend\00EAncia de RequireJS. Isso carregar\00E1 automaticamente RequireJS antes desse arquivo.</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>Use essa sintaxe se o arquivo depender do Oracle JET. Isso carregar\00E1 automaticamente RequireJS e a configura\00E7\00E3o Oracle JET RequireJS antes desse arquivo.</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>Refer\00EAncia do arquivo usando uma string de consulta no URL que faz refer\00EAncia \00E0 vers\00E3o do aplicativo, de modo que, quando houver o upgrade do aplicativo (e a vers\00E3o for incrementada), o browser seja instru\00EDdo para sempre carregar o novo arquivo e')
||' ignorar os arquivos armazenados no cache anteriormente.</dt>',
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557551126310986)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os URLs do arquivo JavaScript para o c\00F3digo carregado nesta p\00E1gina. Cada URL deve ser gravado em uma nova linha.'),
unistr('Se voc\00EA fornecer uma vers\00E3o minimizada de seu arquivo, poder\00E1 usar a string de substitui\00E7\00E3o <code>#MIN#</code> para incluir <code>.min</code> ou <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> no URL do seu arquivo para uma view de p')
||unistr('\00E1gina regular e uma string vazia se a p\00E1gina for exibida no modo de depura\00E7\00E3o, ou ao executar o aplicativo pelo Application Builder.'),
unistr('Voc\00EA tamb\00E9m tem acesso \00E0 string de substitui\00E7\00E3o <code>#APP_VERSION#</code> se quiser incluir a vers\00E3o do aplicativo no URL do arquivo.</p>'),
unistr('<p>Os URLs de arquivo JavaScript inseridos aqui substituem a string de substitui\00E7\00E3o <code>#PAGE_JAVASCRIPT#</code> no modelo de p\00E1gina.</p>'),
unistr('<p>Observa\00E7\00E3o: N\00E3o \00E9 necess\00E1rio incluir tags de abertura ou de fechamento <code>script</code>. Basta especificar o URL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557464094310985)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URLs do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557767572310986)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o c\00F3digo JavaScript como fun\00E7\00F5es ou declara\00E7\00F5es de vari\00E1vel global referenciadas nesta p\00E1gina.'),
unistr('Para fazer refer\00EAncia a um atalho, use <code>"SHORTCUTNAME"</code>.'),
unistr('Se o mesmo JavaScript for necess\00E1rio em v\00E1rias p\00E1ginas, considere colocar o c\00F3digo em um arquivo JavaScript externo para evitar duplica\00E7\00E3o e para utilizar o armazenamento do browser de arquivos est\00E1ticos.</p>'),
unistr('<p>O c\00F3digo inserido aqui substituir\00E1 a string de substitui\00E7\00E3o <code>#PAGE_JAVASCRIPT#</code> no modelo de p\00E1gina.</p>'),
unistr('<p>Observa\00E7\00E3o: N\00E3o \00E9 necess\00E1rio incluir tags de abertura ou de fechamento <code>script</code>. Basta incluir o c\00F3digo JavaScript.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557619119310986)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o e Declara\00E7\00E3o de Vari\00E1vel Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398353916311649)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe o label para a faceta.',
unistr('    O label s\00F3 ser\00E1 exibido na p\00E1gina se a faceta aparecer. O label do tipo <strong>Pesquisar</strong> \00E9 visualmente oculto, mas fica dispon\00EDvel para a tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237708025311530)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'~Informe o label do grupo de facetas.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107237912408311532)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe o label para a faceta.',
unistr('    O label s\00F3 ser\00E1 exibido na p\00E1gina se a faceta aparecer. O label do tipo <strong>Pesquisar</strong> \00E9 visualmente oculto, mas fica dispon\00EDvel para a tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600967645311018)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe o label para o filtro.',
unistr('    O label s\00F3 ser\00E1 exibido na p\00E1gina se o filtro aparecer. O label do tipo <strong>Pesquisar</strong> \00E9 visualmente oculto, mas fica dispon\00EDvel para a tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601887665311019)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'~Informe o label do grupo de filtros.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602227929311019)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe o label para o filtro.',
unistr('    O label s\00F3 ser\00E1 exibido na p\00E1gina se o filtro aparecer. O label do tipo <strong>Pesquisar</strong> \00E9 visualmente oculto, mas fica dispon\00EDvel para a tecnologia assistiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583486502311005)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o label do campo para o item da p\00E1gina.'),
unistr('O label ser\00E1 exibido na p\00E1gina somente se o item for exibido.'),
unistr('Dependendo do alinhamento e da exibi\00E7\00E3o da p\00E1gina, o label ser\00E1 exibido em sua  pr\00F3pria c\00E9lula da tabela HTML ou na mesma c\00E9lula.</p>'),
'<p>Labels de itens podem incluir atalhos usando a sintaxe <code>"SHORTCUT_NAME"</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583352481311005)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583642573311006)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o alinhamento do label. Labels podem ser exibidos acima, abaixo ou \00E0 esquerda do item.'),
unistr('Quando o label \00E9 exibido ao lado de um elemento de form, ele ocupa sua pr\00F3pria c\00E9lula da tabela HTML.'),
unistr('Ao alterar o alinhamento do label, voc\00EA controla a posi\00E7\00E3o do mesmo na c\00E9lula da tabela.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071759357311405)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Acima '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071845933311405)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Abaixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072009381311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado embaixo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072176175311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072218856311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado em cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107071969299311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072410099311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Embaixo \00E0 esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072536967311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Centralizado \00E0 esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072649505311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em cima \00E0 esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072334322311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072846576311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Embaixo \00E0 direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072979279311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Centralizado \00E0 direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107073024616311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No alto \00E0 direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107072734192311406)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583594739311005)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400884303311651)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a regi\00E3o dever\00E1 ser carregada independentemente dos dados da regi\00E3o.</p>'),
unistr('        <p>Quando o carregamento lento \00E9 especificado, a p\00E1gina \00E9 renderizada imediatamente, mostrando uma regi\00E3o vazia, at\00E9 que os dados sejam carregados.'),
unistr('        Em geral, a p\00E1gina n\00E3o \00E9 exibida at\00E9 ser totalmente carregada e estar pronta para ser renderizada.'),
unistr('        Portanto, se forem necess\00E1rios 5 segundos para carregar todos os dados de uma regi\00E3o, sem o carregamento lento, o usu\00E1rio final ter\00E1 de esperar 5 segundos at\00E9 a p\00E1gina come\00E7ar a ser renderizada.</p>'),
unistr('		<p>Observa\00E7\00E3o - O Carregamento Lento s\00F3 dever\00E1 ser utilizado em conjuntos de dados cujo carregamento demora significativamente, pois esse recurso acrescenta um overhead de processamento desnecess\00E1rio ao banco de dados para regi\00F5es que s\00E3o rapidamen')
||'te carregadas.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779778933311162)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a regi\00E3o dever\00E1 ser carregada independentemente dos dados da regi\00E3o.</p>'),
unistr('        <p>Quando o carregamento lento \00E9 especificado, a p\00E1gina \00E9 renderizada imediatamente, mostrando uma regi\00E3o vazia, at\00E9 que os dados sejam carregados.'),
unistr('        Em geral, a p\00E1gina n\00E3o \00E9 exibida at\00E9 ser totalmente carregada e estar pronta para ser renderizada.'),
unistr('        Portanto, se forem necess\00E1rios 5 segundos para carregar todos os dados de uma regi\00E3o, sem o carregamento lento, o usu\00E1rio final ter\00E1 de esperar 5 segundos at\00E9 a p\00E1gina come\00E7ar a ser renderizada.</p>'),
unistr('		<p>Observa\00E7\00E3o - O Carregamento Lento s\00F3 dever\00E1 ser utilizado em conjuntos de dados cujo carregamento demora significativamente, pois esse recurso acrescenta um overhead de processamento desnecess\00E1rio ao banco de dados para regi\00F5es que s\00E3o rapidamen')
||'te carregadas.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779641696311162)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Carregamento Lento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219463443311517)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique se a visibilidade da camada pode ser alternada clicando em seu nome na legenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219346653311517)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar para Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219642811311517)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o \00CDcone a ser exibido para esta camada na legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219561413311517)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835149684311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o de uma legenda no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835298108311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835514131311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835476372311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835337982311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835662077311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106835044279311212)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834941267311212)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se uma legenda dever\00E1 ser renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834852845311212)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219834813311517)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o t\00EDtulo da legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946082595311302)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um t\00EDtulo a ser exibido na parte superior da legenda do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945916434311302)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841068553311216)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o estilo da linha a ser renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841258467311217)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tracejado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841137292311217)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pontilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841306056311217)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106840947603311216)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841842286311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o tipo da linha a ser renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841992611311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842281654311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Segmentado Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842062182311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Escalonado Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842172832311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Curvado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842534545311218)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842403986311218)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Segmentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842311149311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Escalonado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842662321311218)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha Reta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841733329311217)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841597806311217)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a largura da linha a ser renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841488778311217)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106841664911311217)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088698989311418)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Abrir o link em uma nova janela</dt>',
'<dd><pre>target="_blank"</pre></dd>',
unistr('<dt>Mostrar uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'<dd><pre>title="Clique para editar"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885697827311251)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe atributos de link da coluna adicional a serem inseridos na tag <code>&lt;a href=...&gt;</code>, incluindo destino de link, classes ou estilos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885596470311251)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891350002311255)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um esquema de autoriza\00E7\00E3o a ser associado \00E0 Coluna de Links. Esse esquema de autoriza\00E7\00E3o deve ser avaliado como VERDADEIRO para que a Coluna de Links seja renderizada no relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891296630311255)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303639590311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304023359311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303951936311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303824140311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304184413311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303723603311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303597924311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305679029311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305910996311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305892321311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305790154311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306019929311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305521293311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899955918311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899836941311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901315095311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901292574311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305277201311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Java para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305197607311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306862195311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Java que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306702372311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305006067311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304949757311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o JavaScript para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304868642311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306602395311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306555332311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o JavaScript que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306419501311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900116992311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista de valores separada por dois-pontos (:) para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900067423311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900598762311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o N\00FAmero da P\00E1gina para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900456662311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900790684311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de N\00FAmeros de P\00E1ginas separada por v\00EDrgula para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900694842311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304755158311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304653414311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o PL/SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304539742311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306396706311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306290082311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o PL/SQL que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306116752311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900387581311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Prefer\00EAncia de Usu\00E1rio que se compare ao valor especificado para essa condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900216449311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305439206311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Python para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107305379643311583)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107307002127311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Python que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107306999356311584)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304440757311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304319077311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107304279744311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446534057311684)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando uma ou mais linhas existirem ao verificar se o funcion\00E1rio est\00E1 no departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para retornar valores com sucesso quando n\00E3o existirem linhas ao verificar se o funcion\00E1rio est\00E1 no departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899524082311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899481567311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900906433311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor de texto para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106900857213311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901588864311264)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901443027311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899377558311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de condi\00E7\00E3o na lista que precisa ser atendida para que link seja renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150478245311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286124018311569)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O componente sempre ser\00E1 renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149004781311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Microsoft Internet Explorer 7.0 ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149130417311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 um browser compat\00EDvel com XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148934446311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Mozilla, Netscape 6.x/7x ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149215803311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Outros browsers (ou uma vers\00E3o mais antiga)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147634738311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149606414311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289798834311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149336503311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289921672311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149500275311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289809126311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149484088311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual N\00C3O est\00E1 contido no Valor')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290004532311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento, o usu\00E1rio final n\00E3o est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146846711311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual - P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288541561311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147051242311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida na lista delimitada por v\00EDrgula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288709456311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146956246311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288682902311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147152503311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual N\00C3O est\00E1 contida na lista delimitada por v\00EDrgulas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288821326311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149757916311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149867632311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148532690311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289536906311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha \00E9 exibido na p\00E1gina, ap\00F3s uma submiss\00E3o de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147984985311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147778614311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147802666311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148042701311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto! = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144596718311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas retornadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286223034311569)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'A consulta SQL retorna uma ou mais linhas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303399937311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107303426651311582)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A express\00E3o \00E9 avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144707471311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286454558311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O corpo da fun\00E7\00E3o retorna VERDADEIRO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150155540311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150249070311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148236460311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o N\00C3O \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289251303311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina e a regi\00E3o m\00E3e, se apropriado, ser\00E3o exibidas normalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148169773311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289154556311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina ou a regi\00E3o m\00E3e, se apropriada, tem a condi\00E7\00E3o ''Somente para Leitura'' avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146058598311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287791844311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o tem espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146373382311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288017620311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 alfanum\00E9rico, cont\00E9m s\00F3 letras ou n\00FAmeros e n\00E3o cont\00E9m caracteres especiais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145564686311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287260948311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146205688311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287920325311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145722125311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287472722311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145412873311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287119655311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145818791311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287529417311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio ou \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146180762311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287806728311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145680958311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287379372311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145936055311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 NULO e N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287636352311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio ou n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148755878311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Avan\00E7ar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148810667311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Voltar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150346456311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290132936311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>O componente nunca foi renderizado.</p>',
unistr('<p>Observa\00E7\00E3o: alterar uma condi\00E7\00E3o para <strong>Nunca</strong> remover\00E1 qualquer condi\00E7\00E3o existente. Para desativa\00E7\00E3o tempor\00E1ria de um componente, a Oracle recomenda usar o atributo <em>Op\00E7\00E3o de Build</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148694830311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha N\00C3O exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289632270311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha n\00E3o \00E9 exibido na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144625746311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Linha retornada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286358089311569)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta SQL n\00E3o retorna linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147470937311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288956044311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147597641311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina atual N\00C3O est\00E1 no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289087135311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144880007311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286567147311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145029794311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286715775311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107144980998311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o != Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286646745311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145199210311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o N\00C3O est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286899474311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107149996288311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150026792311464)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148351099311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 Autenticado (n\00E3o p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289382694311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107148450965311463)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 o Usu\00E1rio P\00FAblico (o usu\00E1rio n\00E3o foi autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107289491976311572)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146666184311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288318141311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146770615311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio! = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288429294311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146422421311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288140010311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107146522754311461)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107288260565311571)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145211862311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107286953878311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107145307790311460)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107287011643311570)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147342107311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual! = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107147259304311462)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899222968311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Condi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899708162311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor para comparar \00E0 condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899668981311262)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901147699311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901005927311263)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032859189311373)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As regi\00F5es do relat\00F3rio podem ser impressas usando o link padr\00E3o de impress\00E3o, mostrado abaixo da regi\00E3o do relat\00F3rio, ou usando um bot\00E3o. Para usar um bot\00E3o, remova o label do link e crie um bot\00E3o na sua p\00E1gina, usando o URL mostrado em Imprimir ')
||unistr('URL como o bot\00E3o de destino.</p>'),
unistr('<p>Usar bot\00F5es para imprimir regi\00F5es do relat\00F3rio permite definir o estado da sess\00E3o. Isso \00E9 \00FAtil quando se pretende oferecer suporte \00E0 impress\00E3o em diversos formatos diferentes (Word, Excel, PDF etc.) e se deseja exibir um bot\00E3o, link ou imagem para')
||unistr(' cada op\00E7\00E3o. Para essa implementa\00E7\00E3o, use o formato de sa\00EDda derivado de uma op\00E7\00E3o de item e inclua o nome e o valor do item em Imprimir URL.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107261937851311549)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exiba o link de URL para este relat\00F3rio salvo. Esse atributo \00E9 somente exibi\00E7\00E3o e n\00E3o pode ser atualizado.</p>'),
unistr('    <p>Esse atributo permite que voc\00EA copie rapidamente o URL exibido. Esse URL pode ser usado para vincula\00E7\00E3o direta a esse determinado relat\00F3rio salvo a partir de outro local do aplicativo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033490165311374)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As regi\00F5es do relat\00F3rio podem ser impressas usando o link padr\00E3o de impress\00E3o, mostrado abaixo da regi\00E3o do relat\00F3rio, ou usando um bot\00E3o. Para usar um bot\00E3o, remova o label do link e crie um bot\00E3o na sua p\00E1gina, usando o URL mostrado em Imprimir ')
||unistr('URL como o bot\00E3o de destino.</p>'),
unistr('<p>Usar bot\00F5es para imprimir regi\00F5es do relat\00F3rio permite definir o estado da sess\00E3o. Isso \00E9 \00FAtil quando se pretende oferecer suporte \00E0 impress\00E3o em diversos formatos diferentes (Word, Excel, PDF etc.) e se deseja exibir um bot\00E3o, link ou imagem para')
||unistr(' cada op\00E7\00E3o. Para essa implementa\00E7\00E3o, use o formato de sa\00EDda derivado de uma op\00E7\00E3o de item e inclua o nome e o valor do item em Imprimir URL.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902270541311264)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exiba o link de URL para este relat\00F3rio salvo. Esse atributo \00E9 somente exibi\00E7\00E3o e n\00E3o pode ser atualizado.</p>'),
unistr('<p>Esse atributo permite que voc\00EA copie rapidamente o URL exibido. Esse URL pode ser usado para vincula\00E7\00E3o direta a esse determinado relat\00F3rio salvo a partir de outro local do aplicativo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902144755311264)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891191245311255)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o HTML a ser usado para o link. Use uma tag de imagem para exibir imagens ou fa\00E7a uma sele\00E7\00E3o na lista de imagens padr\00E3o. Se n\00E3o estiver definida, <code>#IMAGE_PREFIX#ws/small_page.gif</code> ser\00E1 usada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891048762311255)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone do Link')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901819810311264)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Clique no Alvo para chamar uma caixa de di\00E1logo modal. Voc\00EA pode inserir um alvo personalizado a ser chamado quando a Coluna do Link for clicada.</p>'),
'        <p>Selecione o tipo apropriado no Link Builder - Alvo baseado nos seus requisitos:',
'        <dl>',
unistr('        <dt>P\00E1gina deste aplicativo</dt>'),
'        <dd>Digite o seguinte:',
'        <ul>',
unistr('        <li>P\00E1gina - digite o n\00FAmero da p\00E1gina ou alias da p\00E1gina de destino da navega\00E7\00E3o. Voc\00EA tamb\00E9m pode selecionar o n\00FAmero da p\00E1gina na lista de op\00E7\00F5es.</li>'),
unistr('        <li>Definir Itens: Nome - digite ou selecione itens de p\00E1gina (<code>P3_ID</code>), itens de aplicativo (<code>LAST_PAGE</code>) ou filtros de relat\00F3rio interativo (<code>IR_EMPNO</code>) a serem definidos no estado de sess\00E3o.</li>'),
unistr('        <li>Definir Itens: Valor - digite ou selecione uma coluna de relat\00F3rio (<code>#ID#</code>), insira um item de aplicativo ou p\00E1gina (<code>&P2_EMPNO.</code>) ou insira um valor est\00E1tico (<code>2</code>).</li>'),
unistr('        <li>Limpar Cache - insira uma lista de n\00FAmeros de p\00E1ginas delimitado por v\00EDrgulas (<code>2,3</code>), itens (<code>P3_EMPNO,LAST_PAGE</code>) e defini\00E7\00F5es de relat\00F3rio a serem removidos. Para redefinir a pagina\00E7\00E3o de um relat\00F3rio, digite <cod')
||unistr('e>RP</code>. Para limpar ou redefinir configura\00E7\00F5es do relat\00F3rio interativo, digite <code>CIR</code> ou <code>RIR</code>.</li>'),
unistr('        <li>Redefinir Pagina\00E7\00E3o - selecione Sim para redefinir a pagina\00E7\00E3o, de volta at\00E9 o primeiro conjunto de registros, para relat\00F3rios na p\00E1gina de destino. Essa op\00E7\00E3o tem o mesmo efeito que especificar <code>RP</code> em Limpar Cache.</li>'),
unistr('        <li>Avan\00E7ado: Solicita\00E7\00E3o - informe a solicita\00E7\00E3o a ser usada.</li>'),
'        </ul>',
'        </dd>',
unistr('        <dt>P\00E1gina de outro aplicativo</dt>'),
unistr('        <dd>Insira os mesmos atributos listados para a P\00E1gina deste aplicativo, sendo que, al\00E9m deles, voc\00EA precisa incluir o ID ou o alias do Aplicativo.</dd>'),
'        <dt>URL</dt>',
'        <dd>Insira o URL</dd>',
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106901708987311264)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220263917311517)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a a\00E7\00E3o a ser executada quando um objeto no mapa for clicado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836931738311213)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a a\00E7\00E3o a ser executada quando houver um clique no gr\00E1fico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796238107311176)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecione para o URL retornado pela Primeira Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796348463311176)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecione para o URL de destino retornado pela primeira coluna da consulta SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837241342311214)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina em outro Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837318750311214)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Redireciona para uma p\00E1gina em um aplicativo diferente, com atributos adicionais opcionais para redefinir a pagina\00E7\00E3o, definir o valor da solicita\00E7\00E3o, limpar o cache e definir os valores de itens na p\00E1gina de destino.</p>'),
unistr('<p>Nota: o redirecionamento para uma p\00E1gina em um aplicativo diferente depende de haver um link profundo ativado no aplicativo de destino. Para ativar esse link, v\00E1 para os atributos de <em>Seguran\00E7a</em> do aplicativo e ative <em>Link Profundo</em>.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837047553311213)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina neste Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837153743311213)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redireciona para uma p\00E1gina no aplicativo atual, com atributos adicionais opcionais para redefinir a pagina\00E7\00E3o, definir o valor da solicita\00E7\00E3o, limpar o cache e definir os valores de itens na p\00E1gina de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837427056311214)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837508984311214)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para o URL de destino especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836889420311213)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885411151311251)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto HTML a ser mostrado como link. Use uma tag de imagem para exibir imagens ou fa\00E7a uma sele\00E7\00E3o na lista de imagens padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885327467311251)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197919283310693)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um modelo para definir a apar\00EAncia e o layout dessa lista.</p>'),
unistr('        <p>Os modelos de lista s\00E3o definidos no tema do aplicativo.'),
unistr('        Quando uma regi\00E3o de lista \00E9 criada, o modelo \00E9 especificado automaticamente como o modelo de lista padr\00E3o definido no tema atual.</p>'),
'        <p>O Tema Universal fornece os seguintes modelos de lista:',
'          <dl>',
'            <dt>Lista de Emblemas</dt>',
unistr('            <dt>Cart\00F5es</dt>'),
'            <dt>Lista de Links</dt>',
unistr('            <dt>Lista de M\00EDdia</dt>'),
'            <dt>Barra de Menus</dt>',
'            <dt>Menu Pop-up</dt>',
unistr('            <dt>Barra de Navega\00E7\00E3o</dt>'),
unistr('            <dt>Menu de Navega\00E7\00E3o Lateral</dt>'),
'            <dt>Guias</dt>',
unistr('            <dt>Menu de Navega\00E7\00E3o Superior</dt>'),
'            <dt>Andamento do Assistente</dt>',
'          </dl>',
unistr('          Consulte Tamb\00E9m: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra de Tema Universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197890066310693)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265941135311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tipo de lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266410185311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266532222311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista Din\00E2mica se baseia na Consulta SQL retornada pelo Corpo da Fun\00E7\00E3o PL/SQL especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266225799311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266311218311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista Din\00E2mica se baseia na Consulta SQL especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266074380311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266155348311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista Est\00E1tica se baseia no valor de texto especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107265813365311555)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951381794311307)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero total de dias a serem exibidos na View da Agenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951213389311307)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951498795311307)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951147673311307)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione os dias a serem exibidos para a View em Lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110632256311434)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110780431311434)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe as entradas de calend\00E1rio com base no n\00FAmero de dias informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110241622311434)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EAs Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110313911311434)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe as entradas de calend\00E1rio do m\00EAs atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110455096311434)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ano Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110518959311434)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe as entradas de calend\00E1rio do ano atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951047772311307)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701276618311093)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a p\00E1gina de log-in do aplicativo para a interface do usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701178294311093)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URL de Log-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645680327311051)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe para onde o &PRODUCT_NAME. ser\00E1 redirecionado ap\00F3s o log-out.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079772117311411)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'pt-br'
,p_message_text=>'Home Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079820329311411)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redireciona para o valor Link da Home Page especificado nos atributos do aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079953895311411)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080099099311411)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Redireciona para o URL informado, como <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645514832311051)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Yipo de Log-out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778748179311162)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como proteger dados em rela\00E7\00E3o a atualiza\00E7\00F5es perdidas.'),
unistr('		H\00E1 perda de atualiza\00E7\00F5es quando duas ou mais pessoas tentam atualizar os mesmos dados, e a \00FAltima atualiza\00E7\00E3o substitui as atualiza\00E7\00F5es feitas pelo primeiro usu\00E1rio a salvar altera\00E7\00F5es.'),
unistr('		Para impedir que isso aconte\00E7a, as atualiza\00E7\00F5es podem verificar os valores de colunas existentes no banco de dados em rela\00E7\00E3o aos valores recuperados quando o registro foi originalmente consultado.</p>'),
'		<p>Por exemplo:',
'          <ol>',
unistr('            <li>O Usu\00E1rio A consulta registros de funcion\00E1rios (EMP).</li>'),
unistr('		    <li>O Usu\00E1rio B consulta os mesmos registros de funcion\00E1rios.</li>'),
unistr('		    <li>O Usu\00E1rio B atualiza os detalhes do funcion\00E1rio EMPNO = 7839 e aplica (faz o commit) das altera\00E7\00F5es no banco de dados.</li>'),
unistr('		    <li>O Usu\00E1rio A atualiza os detalhes do funcion\00E1rio EMPNO = 7839 e est\00E1 tentando aplicar as altera\00E7\00F5es ao banco de dados.</li>'),
'          </ol>',
unistr('          Se o Usu\00E1rio A atualizar o mesmo registro com sucesso, as altera\00E7\00F5es feitas pelo Usu\00E1rio B ser\00E3o perdidas.'),
unistr('         <p>Quando o Usu\00E1rio A estiver tentando salvar o registro do funcion\00E1rio, os dados no banco de dados ser\00E3o diferentes dos originalmente consultados por ele.'),
unistr('		  Na etapa 1 acima, os valores das colunas originalmente consultados pelo Usu\00E1rio A podem ser capturados.'),
'		  Na Etapa 4 acima, os valores podem ser comparados com os valores atuais no banco de dados.',
unistr('		  Essa compara\00E7\00E3o gerar\00E1 um erro para o Usu\00E1rio A, pois os valores do banco de dados foram atualizados pelo Usu\00E1rio B na Etapa 3.'),
unistr('          Isso impede um usu\00E1rio de substituir altera\00E7\00F5es feitas por outro usu\00E1rio na mesma linha.</p>'),
unistr('		  <p>Observa\00E7\00E3o - O Tipo de Atualiza\00E7\00E3o Perdida s\00F3 ser\00E1 usado se o processo correspondente, Grade Interativa - Processamento Autom\00E1tico de Linhas (DML), tiver a op\00E7\00E3o <strong>Impedir Perda de Atualiza\00E7\00F5es</strong> ativada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778925067311162)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Vers\00E3o da Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908761338311269)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se a sua tabela de banco de dados incluir uma coluna que \00E9 incrementada sempre que um registro \00E9 atualizado, preferencialmente por um trigger de banco de dados, esta coluna poder\00E1 ser usada, em vez de calcular somas de verifica\00E7\00E3o.'),
unistr('        Esta op\00E7\00E3o n\00E3o dever\00E1 ser usada se a sua grade interativa atualizar dados em v\00E1rias tabelas.</p>'),
unistr('        <p>Observa\00E7\00E3o - A coluna de vers\00E3o da linha dever\00E1 ser inclu\00EDda no C\00F3digo-Fonte SQL da regi\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778882095311162)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Valores das Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908638541311269)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Um valor de soma de verifica\00E7\00E3o ser\00E1 calculado para cada linha, durante a consulta inicial dos dados.'),
unistr('        A soma de verifica\00E7\00E3o \00E9 calculada por meio da concatena\00E7\00E3o das colunas atualiz\00E1veis em uma string e da gera\00E7\00E3o de um valor exclusivo.'),
unistr('        Durante o commit do registro atualizado, esta soma de verifica\00E7\00E3o ser\00E1 comparada com o valor de soma de verifica\00E7\00E3o do registro de banco de dados atual.'),
unistr('        Se os valores n\00E3o forem iguais, um erro ser\00E1 gerado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778687530311161)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Atualiza\00E7\00E3o Perdida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318022870311592)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318310906311592)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318263558311592)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318139897311592)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318474961311592)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107317921561311592)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319221237311593)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o Java que retorne uma Consulta SQL para preencher esta lista de valores. Geralmente, a lista de consultas de valores tem a seguinte forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias \00FAnico. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319198922311593)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319091001311593)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exibe o nome do departamento, define o n\00FAmero do departamento</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318948843311593)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o JavaScript que retorne uma Consulta SQL para preencher esta lista de valores. Geralmente, a lista de consultas de valores tem a seguinte forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias \00FAnico. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318824380311593)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914443197311274)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o nome desta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914369694311273)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643585589311049)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os itens da coluna, p\00E1gina ou aplicativo para definir em estado de sess\00E3o quando o valor de qualquer (quaisquer) Item(ns) Pai(s) da LOV em Cascata especificado(s) for(em) alterado(s) nesta p\00E1gina.'),
unistr('Para v\00E1rios itens, separe cada nome de item com uma v\00EDrgula.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA escolher na lista e j\00E1 houver texto inserido, ser\00E1 colocada uma v\00EDrgula no final do texto existente, seguida do nome do item retornado da lista.</p>'),
unistr('<p>Use o(s) item(ns) de p\00E1gina especificado(s) neste atributo na <em>cl\00E1usula where</em> dessa Consulta SQL da lista de valores para restringir os valores retornados.</p>'),
unistr('<p>Observa\00E7\00E3o: Os itens de p\00E1gina definidos em <em>Item(ns) Pai(s) da LOV em Cascata</em> s\00E3o automaticamente transmitidos e n\00E3o precisam ser inseridos neste atributo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643443076311049)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Itens a Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318757108311593)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exibir nome do departamento, definir n\00FAmero do departamento</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318661075311593)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o PL/SQL que retorne uma Consulta SQL para preencher esta lista de valores. Geralmente, a lista de consultas de valores \00E9 do form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias \00FAnico. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107318598528311593)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319400293311593)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o Python que retorne uma Consulta SQL para preencher esta lista de valores. Geralmente, a lista de consultas de valores tem a seguinte forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias \00FAnico. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107319316621311593)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382239809311638)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a defini\00E7\00E3o da consulta SQL para preencher esta lista de valores. Em geral, a lista de consultas de valor t\00EAm esta forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias exclusivo. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>'),
unistr('<p>Observa\00E7\00E3o: Ao definir um tipo de item LOV Popup, se voc\00EA quiser exibir v\00E1rias colunas no popup, dever\00E1, em vez disso, definir sua Lista de Valores em Componentes Compartilhados,'),
unistr('com os metadados adicionais necess\00E1rios. A lista de valores em linha s\00F3 pode ser usada para exibir colunas simples para LOVs de Popups.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238093253311532)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a defini\00E7\00E3o da consulta SQL para preencher esta lista de valores. Em geral, a lista de consultas de valor t\00EAm esta forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias exclusivo. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>'),
unistr('<p>Observa\00E7\00E3o: Ao definir um tipo de item LOV Popup, se voc\00EA quiser exibir v\00E1rias colunas no popup, dever\00E1, em vez disso, definir sua Lista de Valores em Componentes Compartilhados,'),
unistr('com os metadados adicionais necess\00E1rios. A lista de valores em linha s\00F3 pode ser usada para exibir colunas simples para LOVs de Popups.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107398265169311649)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a defini\00E7\00E3o da consulta SQL para preencher esta lista de valores. Em geral, a lista de consultas de valor t\00EAm esta forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias exclusivo. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>'),
unistr('<p>Observa\00E7\00E3o: Ao definir um tipo de item LOV Popup, se voc\00EA quiser exibir v\00E1rias colunas no popup, dever\00E1, em vez disso, definir sua Lista de Valores em Componentes Compartilhados,'),
unistr('com os metadados adicionais necess\00E1rios. A lista de valores em linha s\00F3 pode ser usada para exibir colunas simples para LOVs de Popups.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107382186838311638)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a defini\00E7\00E3o da consulta SQL para preencher esta lista de valores. Em geral, a lista de consultas de valor t\00EAm esta forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias exclusivo. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>'),
unistr('<p>Observa\00E7\00E3o: Ao definir um tipo de item LOV Popup, se voc\00EA quiser exibir v\00E1rias colunas no popup, dever\00E1, em vez disso, definir sua Lista de Valores em Componentes Compartilhados,'),
unistr('com os metadados adicionais necess\00E1rios. A lista de valores em linha s\00F3 pode ser usada para exibir colunas simples para LOVs de Popups.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601191292311018)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a defini\00E7\00E3o da consulta SQL para preencher esta lista de valores. Em geral, a lista de consultas de valor t\00EAm esta forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias exclusivo. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>'),
unistr('<p>Observa\00E7\00E3o: Ao definir um tipo de item LOV Popup, se voc\00EA quiser exibir v\00E1rias colunas no popup, dever\00E1, em vez disso, definir sua Lista de Valores em Componentes Compartilhados,'),
unistr('com os metadados adicionais necess\00E1rios. A lista de valores em linha s\00F3 pode ser usada para exibir colunas simples para LOVs de Popups.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602445828311019)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a defini\00E7\00E3o da consulta SQL para preencher esta lista de valores. Em geral, a lista de consultas de valor t\00EAm esta forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias exclusivo. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>'),
unistr('<p>Observa\00E7\00E3o: Ao definir um tipo de item LOV Popup, se voc\00EA quiser exibir v\00E1rias colunas no popup, dever\00E1, em vez disso, definir sua Lista de Valores em Componentes Compartilhados,'),
unistr('com os metadados adicionais necess\00E1rios. A lista de valores em linha s\00F3 pode ser usada para exibir colunas simples para LOVs de Popups.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153564433311467)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exibe o nome do departamento, define p n\00FAmero do departamento</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904510328311266)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a defini\00E7\00E3o de consulta de SQL para preencher esta lista de valores. Geralmente, a lista de consultas de valores \00E9 do form:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada coluna selecionada deve ter um nome ou alias \00FAnico. A Oracle recomenda usar um alias em qualquer coluna que inclua uma express\00E3o SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904459586311266)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904977496311266)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os valores desta lista de valores est\00E1tica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904825971311266)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904731762311266)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o tipo de lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291124187311573)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107291210528311573)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores Din\00E2mica \00E9 baseada na Consulta SQL retornada pelo Corpo da Fun\00E7\00E3o especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776551145311160)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Componente Compartilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776619058311160)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores \00E9 baseado em uma lista de valores predefinidos, definida em Componentes Compartilhados.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776746524311160)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776877575311160)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores Din\00E2mica \00E9 baseada na Consulta SQL especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093392091311421)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093450269311421)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A lista de valores Est\00E1tica \00E9 baseada no valor de texto especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106904619461311266)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573082224310997)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como o estado da sess\00E3o \00E9 mantido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530522847310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Solicita\00E7\00E3o (Apenas Mem\00F3ria)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530602931310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o salva o estado no banco de dados. O estado s\00F3 est\00E1 dispon\00EDvel ao processar a solicita\00E7\00E3o atual. Quando as solicita\00E7\00F5es AJAX precisarem usar um item, certifique-se de especificar o nome do item via "Itens de P\00E1gina a Serem Submetidos".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075468978311408)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Usu\00E1rio (Disco)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369969242311629)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mant\00E9m para um usu\00E1rio, armazenando o valor no banco de dados, para acessar nas sess\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075312097311408)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Sess\00E3o (Disco)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369858179311629)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mant\00E9m para cada sess\00E3o, armazenando o valor no banco de dados, para acessar nas solicita\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572926194310997)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Manter Estado de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530836771310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como o estado da sess\00E3o \00E9 mantido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530987855310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Solicita\00E7\00E3o (Apenas Mem\00F3ria)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531026939310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o salva o estado no banco de dados. O estado s\00F3 est\00E1 dispon\00EDvel ao processar a solicita\00E7\00E3o atual. Quando as solicita\00E7\00F5es AJAX precisarem usar um item, certifique-se de especificar o nome do item via "Itens de P\00E1gina a Serem Submetidos".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531175996310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Sess\00E3o (Disco)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106531293328310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mant\00E9m para cada sess\00E3o, armazenando o valor no banco de dados, para acessar nas solicita\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530741727310966)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Manter Estado de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847828108311222)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione se as marca\00E7\00F5es principais dever\00E3o ser renderizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847939202311222)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848189867311222)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848067764311222)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106847795923311222)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192979031311497)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192898080311497)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique a cor de preenchimento para exibir um cluster de pontos.',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul, respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB (xxx, xxx, xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise na internet ''C\00F3digos de Cores HTML'' para encontrar o c\00F3digo hexadecimal ou o c\00F3digo RGB equivalente para a cor que deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192775949311497)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Preenchimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192146116311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique as classes CSS do \00EDcone a serem usadas para exibir um cluster de pontos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192074523311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191933346311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o URL da imagem a ser usada para exibir um cluster de pontos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191853765311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192383694311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a forma SVG para exibir um cluster de pontos. Escolha uma das formas predefinidas ou insira o nome de uma <em>forma SVG personalizada</em>, especificada no atributo da regi\00E3o do mapa <strong>Estilos SVG Personalizados</strong>. Quando o n')
||unistr('ome especificado n\00E3o estiver na lista de estilos SVG padr\00E3o ou personalizados, o <strong>Marcador Padr\00E3o</strong> ser\00E1 usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225887950311521)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E2mera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233630353311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230487652311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234964907311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225948934311521)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alternativa de C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233867844311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192506075311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233771265311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225798111311521)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233527576311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226016791311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cara Triste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233905383311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226165526311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cara Sem Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234027274311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226280985311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cara com Sorriso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234134754311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230979757311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Flag Pennant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235430436311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231069925311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Flag Swallowtail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235588710311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226604607311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cora\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234624905311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230592535311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235088003311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226708691311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pent\00E1gono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234721950311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226420360311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fixar C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234475399311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226551160311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fixar Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234543468311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230780631311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Brilho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235235765311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230675816311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235121368311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226309851311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Alternativa de Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234310024311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192483802311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234273979311527)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230851371311525)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Street View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107235337161311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192693818311497)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tri\00E2ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107234869751311528)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107192241045311496)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226981658311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o fator de escalonamento para a forma SVG para exibir um cluster de pontos. A escala m\00E1xima \00E9 <strong>10</strong>, e o componente do mapa arredondar\00E1 o valor para o primeiro d\00EDgito decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107226895530311522)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escala de Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196156016311499)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O raio do cluster em pixels. Se o valor <strong>80</strong> for especificado, os pontos dentro de 80 pixels um do outro ser\00E3o'),
'agregados a um cluster de ponto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196092192311499)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Raio de Clusteriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196295487311499)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216978699311515)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira express\00F5es HTML a serem mostradas como dica de ferramenta ao passar o mouse sobre um marcador de cluster no mapa. Use os marcadores de espa\00E7o <strong>&LAYER.</strong> e <strong>&COUNT.</strong> para fazer refer\00EAncia ao nome da camada e \00E0 quant')
||'idade de objetos de mapa no cluster.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216866980311515)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dica de ferramenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182448132311489)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fornece o aviso de copyright a ser colocado no rodap\00E9 do mapa. Se estiver vazio, ser\00E1 gerado um aviso para o mapa de fundo usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182366482311489)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Aviso de Copyright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184140573311490)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184073088311490)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Forne\00E7a defini\00E7\00F5es para formas SVG personalizadas, que possam ser usadas como marcadores de mapa. Os estilos definidos aqui podem ser usados como o atributo <strong>SVG Shape</strong> em uma camada de Ponto.</p>'),
unistr('<p>A forma SVG deve ter largura e altura de <strong>20</strong>. O marcador ser\00E1 posicionado no mapa, de modo que o centro da parte inferior da forma (coordenada SVG <strong>10</strong>, <strong>20</strong>) aponte para o objeto do mapa.</p>'),
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">Os marcadores SVG t\00EAm largura e altura de 20 e apontam para o local do mapa na posi\00E7\00E3o x=10 e y=20.</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183979225311490)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilos SVG Personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214629510311513)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que retorna um valor para determinar a altura do pol\00EDgono extrudado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214563992311513)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Valor de Extrus\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216395021311514)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a unidade que determinar\00E1 a altura do pol\00EDgono extrudado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216609658311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216511702311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quil\00F4metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216499060311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'pt-br'
,p_message_text=>'Metro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216780755311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Milha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216226972311514)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Unidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188859931311494)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188762247311494)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique a cor de preenchimento.',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul, respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB (xxx, xxx, xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise na internet ''C\00F3digos de Cores HTML'' para encontrar o c\00F3digo hexadecimal ou o c\00F3digo RGB equivalente para a cor que deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188603508311493)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Preenchimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197603688311500)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se ser\00E1 usado um <em>Esquema de Cores</em> para esta camada. Um esquema de cores \00E9 uma lista de cores. Com base em um valor e nos valores m\00EDnimo e m\00E1ximo, o widget de mapa escolher\00E1 na lista a cor de exibi\00E7\00E3o real para este objeto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197531684311500)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Esquema de Cores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350415264311615)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Lista de cores que variam do vermelho ao branco</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Lista de cores que varia do azul ao preto</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197888239311500)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se ser\00E1 usado um <em>esquema de cores</em> personalizado para esta camada. Um esquema de cores \00E9 uma lista de cores. Com base em um valor e nos valores m\00EDnimo e m\00E1ximo, o widget de mapa escolher\00E1 na lista a cor de exibi\00E7\00E3o real para este ')
||'objeto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197732692311500)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Cores Personalizadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198045466311501)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que retorna um valor para determinar a cor de exibi\00E7\00E3o com base no esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197981266311500)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Valor de Cor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189019411311494)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique a opacidade do preenchimento. Varia de zero (totalmente transparente) a 1,0 (opaco).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188972960311494)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Opacidade do Preenchimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198224185311501)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que retorna o valor para determinar a cor de exibi\00E7\00E3o com base no esquema. Se nenhuma coluna for selecionada, a cor de exibi\00E7\00E3o ser\00E1 determinada apenas com base na densidade do ponto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198154504311501)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194046848311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a janela de informa\00E7\00F5es ser\00E1 exibida usando colunas ou formata\00E7\00E3o avan\00E7ada com express\00F5es HTML e strings de substitui\00E7\00E3o suportadas. A janela de informa\00E7\00F5es ser\00E1 exibida como um pop-up ao clicar em um objeto no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193975277311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194438338311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como corpo da janela de informa\00E7\00F5es. A janela de informa\00E7\00F5es ser\00E1 exibida como um pop-up ao clicar em um objeto no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194336519311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194924587311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe classes CSS a serem usadas ao renderizar o pop-up da janela de informa\00E7\00F5es. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194882516311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194712236311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194681669311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira express\00F5es HTML a serem mostradas como pop-up de informa\00E7\00F5es ao clicar em um objeto espacial. Use a sintaxe <code>&COLUMN.</code> para mostrar os valores das colunas em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194510022311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194222929311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como t\00EDtulo da janela de informa\00E7\00F5es. A janela de informa\00E7\00F5es ser\00E1 exibida como um pop-up ao clicar em um objeto no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107194130349311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217864447311516)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label a ser usado para exibi\00E7\00E3o na legenda ou nas dicas de ferramentas. Se n\00E3o for especificado, o atributo <strong>Name</strong> ser\00E1 usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217690258311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o label a ser usado para esta camada na legenda e nas dicas de ferramentas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217518554311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217413599311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217315138311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique a cor de preenchimento do marcador.',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul, respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB (xxx, xxx, xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise na internet ''C\00F3digos de Cores HTML'' para encontrar o c\00F3digo hexadecimal ou o c\00F3digo RGB equivalente para a cor que deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217265097311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Preenchimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217116012311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique a opacidade do preenchimento. Varia de zero (totalmente transparente) a 1,0 (opaco).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217096079311515)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Opacidade do Preenchimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214934419311513)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214845538311513)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique a cor do tra\00E7o.'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul, respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB (xxx, xxx, xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise na internet ''C\00F3digos de Cores HTML'' para encontrar o c\00F3digo hexadecimal ou o c\00F3digo RGB equivalente para a cor que deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214786623311513)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cor do Tra\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215176036311514)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a largura do tra\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215069660311514)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura do Tra\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195129036311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada para designar linhas da origem da regi\00E3o a esta camada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195014200311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195387576311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a o <em>valor</em> <strong>Coluna de Designa\00E7\00E3o de Linhas</strong> que designa linhas da origem da regi\00E3o a esta camada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195279536311498)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor para esta Camada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188387403311493)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188262649311493)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique a cor do tra\00E7o.'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul, respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB (xxx, xxx, xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise na internet ''C\00F3digos de Cores HTML'' para encontrar o c\00F3digo hexadecimal ou o c\00F3digo RGB equivalente para a cor que deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188148050311493)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cor do Tra\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195500446311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o estilo do tra\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195842205311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tracejado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195761251311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pontilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195937095311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ponto e Tra\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195697271311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107195488785311499)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Estilo do Tra\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188546938311493)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a largura do tra\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188493213311493)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura do Tra\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193177819311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a dica de ferramenta ser\00E1 exibida usando uma coluna ou formata\00E7\00E3o avan\00E7ada com express\00F5es HTML e strings de substitui\00E7\00E3o suportadas. A dica de ferramenta \00E9 exibida quando se passa o cursor do mouse sobre um objeto no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193053338311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193301611311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione a coluna a ser usada como dica de ferramenta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193242545311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193868547311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe classes CSS a serem usadas ao renderizar a dica de ferramenta. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193776142311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193680648311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193521683311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira express\00F5es HTML a serem mostradas como dica de ferramenta ao passar o mouse sobre um objeto no mapa. Use a sintaxe <code>&COLUMN.</code> para mostrar os valores das colunas em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107193446002311497)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187489940311493)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna que retorna objetos GeoJSON para serem exibidos no mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187397185311493)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187682415311493)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna SDO_GEOMETRY, retornando objetos geom\00E9tricos a serem exibidos no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187504762311493)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186029067311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica o tipo de dados da coluna geom\00E9trica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186390212311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'pt-br'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186415316311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'GeoJSON, como tipos VARCHAR2 ou CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186576215311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude/Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186604385311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude e Latitude, como duas colunas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186126332311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'pt-br'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186273232311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo Oracle SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185934358311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados da Coluna de Geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186833564311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica o tipo de dados da coluna geom\00E9trica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186993987311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'pt-br'
,p_message_text=>'GeoJSON'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187041711311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'GeoJSON, como tipos VARCHAR2 ou CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187167593311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude/Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187226939311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude e Latitude, como duas colunas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107186779119311492)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados da Coluna de Geometria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185859968311492)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ative essa op\00E7\00E3o, se a tabela subjacente tiver um \00EDndice espacial e o widget de mapa precisar us\00E1-lo ao extrair linhas do banco de dados. Neste caso, o widget extrair\00E1 <em>somente</em> linhas para a janela do mapa atual do banco de dados. Isso for')
||unistr('nece um benef\00EDcio de desempenho quando a origem de dados cont\00E9m uma grande quantidade de linhas.</p><p>Um \00EDndice espacial pode ser criado em uma coluna SDO_GEOMETRY no SQL Workshop.</p>'),
unistr('<p>Observe que um \00CDndice Espacial <em>n\00E3o</em> ser\00E1 usado nas seguintes situa\00E7\00F5es:</p>'),
'<ul>',
unistr('<li>Mais de uma camada fizer refer\00EAncia \00E0 <strong>Origem da Regi\00E3o</strong> como a respectiva origem de dados.</li>'),
'<li>A janela do mapa for muito grande, ou seja, abranger mais da metade do mundo.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185750528311491)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar \00CDndice Espacial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107188017753311493)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna NUMBER, contendo a latitude dos objetos espaciais a serem exibidos no mapa. Os valores retornados devem estar entre -90 e 90.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187904388311493)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Latitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203669859311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha um dos esquemas de cores divergentes predefinidos. Eles s\00E3o adequados para visualizar valores divergentes, variando de um extremo a outro. Esquemas de cores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" targ')
||'et="_blank">CARTOcolor no GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203730828311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('"Ex\00E9rcito" a Rosa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203885258311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204970276311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cores da Terra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205084022311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203994636311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cores de Outono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204074111311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204136708311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('G\00EAiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204276845311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204560160311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa a Rosa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204695728311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204329102311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204485833311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204781815311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cores Tropicais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107204831869311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203562350311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205256738311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha um dos esquemas de cores qualitativos predefinidos. Eles s\00E3o adequados para visualizar valores distintos. Esquemas de cores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor no GitHub)')
||'</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205314371311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Antigo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205463187311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205538884311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205636840311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205779806311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205850145311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205979497311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Prisma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206082002311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206198620311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206298740311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206355223311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('V\00EDvido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206424787311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107205124884311506)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199613475311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha um dos esquemas de cores sequenciais predefinidos. Eles s\00E3o adequados para visualizar valores sequenciais, variando de um valor baixo a um valor alto. Esquemas de cores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cart')
||'ocolor" target="_blank">CARTOcolor no GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201117977311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul a Verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201200769311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201752361311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201844119311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203397195311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Marrom a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203475391311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199743598311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borgonha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199899134311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199947697311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borgonha a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200024838311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201356765311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Menta Escuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201494222311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201504801311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmeralda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201672986311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202961709311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203019426311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200953878311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Menta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201065572311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200358709311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Laranja a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200428910311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200512165311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00EAssego')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200611246311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200796571311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rosa a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200808844311503)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202315384311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Roxo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202469212311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202564214311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Roxo a Laranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202628485311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200137730311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Vermelho a Laranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107200261601311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202726710311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F4r do Sol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202826385311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203150679311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F4r do Sol Escuro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107203262407311505)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107201904557311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202010405311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202188952311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa a Verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107202293726311504)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199554464311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218213054311516)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218365240311516)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique uma lista de cores HTML (#rrggbb), separadas por v\00EDrgulas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198845710311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha o tipo de esquema de cores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199109230311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'pt-br'
,p_message_text=>'Divergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199273148311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de cores \00E9 adequado para visualizar valores divergentes, variando de um extremo a outro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199338210311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Qualitativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199454886311502)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de cores \00E9 adequado para visualizar valores distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198968755311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sequencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107199011908311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de cores \00E9 adequado para visualizar valores sequenciais, variando de um valor baixo a um valor alto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198782189311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema de Cores:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350897810311615)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Lista de cores que variam do vermelho ao branco</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Lista de cores que varia do azul ao preto</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214405230311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um <em>esquema de cores</em> personalizado para esta camada de mapa de calor. Um esquema de cores \00E9 uma lista de cores. Com base em um valor e nos valores m\00EDnimo e m\00E1ximo, o widget de mapa escolher\00E1 na lista a cor de exibi\00E7\00E3o real para es')
||'te objeto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214374819311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Cores Personalizadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211435498311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha um dos esquemas de cores divergentes predefinidos. Eles s\00E3o adequados para visualizar valores divergentes, variando de um extremo a outro. Esquemas de cores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" targ')
||'et="_blank">CARTOcolor no GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211535455311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('"Ex\00E9rcito" a Rosa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211621794311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212756083311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cores da Terra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212868675311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211711262311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cores de Outono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211814974311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211971078311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('G\00EAiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212082495311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212369320311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa a Rosa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212479827311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212161253311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212270811311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212532164311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cores Tropicais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212694801311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211355701311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213057412311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha um dos esquemas de cores qualitativos predefinidos. Eles s\00E3o adequados para visualizar valores distintos. Esquemas de cores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor no GitHub)')
||'</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213120265311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Antigo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213261228311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213306809311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213460024311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213561157311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213669942311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213786038311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Prisma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213808679311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107213941148311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214069843311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214118101311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('V\00EDvido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107214233293311513)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107212904148311512)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207428219311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha um dos esquemas de cores sequenciais predefinidos. Eles s\00E3o adequados para visualizar valores sequenciais, variando de um valor baixo a um valor alto. Esquemas de cores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cart')
||'ocolor" target="_blank">CARTOcolor no GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208997463311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul a Verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209001887311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209560867311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209698046311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211188248311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Marrom a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211210448311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207510521311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borgonha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207687301311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207758602311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borgonha a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207855132311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209191492311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Menta Escuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209255814311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209371386311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmeralda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209490138311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210748798311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210852055311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208742564311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Menta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208800336311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208107147311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Laranja a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208250062311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208316636311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00EAssego')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208487479311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208588254311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Rosa a Amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208602872311509)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210121933311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Roxo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210267966311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210312698311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Roxo a Laranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210405856311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207973855311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Vermelho a Laranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107208003467311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210531990311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F4r do Sol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210608647311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210929585311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F4r do Sol Escuro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107211044594311511)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209709017311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209842936311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107209999370311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa a Verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107210039969311510)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207320722311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218483824311516)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218586167311516)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique uma lista de cores HTML (#rrggbb), separadas por v\00EDrgulas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206668587311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha o tipo de esquema de cores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206963795311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'pt-br'
,p_message_text=>'Diverging'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207032347311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de cores \00E9 adequado para visualizar valores divergentes, variando de um extremo a outro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207122256311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Qualitativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107207237860311508)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de cores \00E9 adequado para visualizar valores distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206747338311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sequencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206817537311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de cores \00E9 adequado para visualizar valores sequenciais, variando de um valor baixo a um valor alto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107206563418311507)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema de Cores:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196445945311499)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Identifique o tipo desta camada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197183104311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa de Calor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197213519311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos do Ponto, exibidos como um Mapa de Calor. Os mapas de calor s\00E3o \00FAteis para visualizar a densidade dos objetos do ponto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196727812311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196875941311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos da Linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196564269311499)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pontos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196643924311499)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos de Ponto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196936878311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pol\00EDgonos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197013265311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Objetos do Pol\00EDgono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197376378311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pol\00EDgonos Extrudados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107197408951311500)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pol\00EDgonos "Extrudados" como objetos 3D. A altura \00E9 baseada em um valor de coluna de resultados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107196340524311499)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Camada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198627096311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o n\00EDvel m\00E1ximo de zoom para que esta camada permane\00E7a vis\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198512966311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198482070311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o n\00EDvel m\00EDnimo de zoom para que esta camada se torne vis\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107198392437311501)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187841743311493)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna NUMBER, contendo a longitude dos objetos espaciais a serem exibidos no mapa. Os valores retornados devem estar entre -180 e 180.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107187735730311493)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Longitude'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191756925311496)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Se os pontos colocalizados no mapa devem ser agrupados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191675482311496)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189207281311494)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica como objetos de ponto ser\00E3o exibidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189544742311494)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189634489311494)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe como \00CDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189302122311494)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'pt-br'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189415592311494)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe como forma SVG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189115829311494)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191272581311495)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a forma SVG para exibir objetos de ponto. Escolha uma das formas predefinidas ou insira o nome de uma <em>Forma SVG Personalizada</em>, especificada no atributo da regi\00E3o do mapa <strong>Estilos SVG Personalizados</strong>. Quando nenhum ')
||unistr('nome for especificado, ou o nome especificado n\00E3o estiver na lista de formas SVG padr\00E3o ou personalizadas, a forma <strong>Padr\00E3o</strong> ser\00E1 usada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224546186311520)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E2mera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231563846311525)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229732207311524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232816848311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224665195311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alternativa de C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231765707311525)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191470450311496)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231646296311525)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224451870311520)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231446745311525)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224718734311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cara Triste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231840709311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224846619311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cara Sem Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107231982637311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107224981043311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Cara com Sorriso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232007139311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230280144311524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Flag Pennant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233386159311527)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230300185311525)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Flag Swallowtail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233431596311527)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225356176311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cora\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232590034311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229862596311524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232987308311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225489462311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pent\00E1gono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232629417311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225149556311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fixar C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232371829311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225204176311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fixar Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232422293311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230015270311524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Brilho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233154571311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229929754311524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233073637311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225062962311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Alternativa de Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232221927311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191369678311496)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232157183311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107230190671311524)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Street View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107233297792311527)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191538818311496)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tri\00E2ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107232745972311526)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191175271311495)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225653542311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o fator de escalonamento para a forma SVG. A escala m\00E1xima \00E9 <strong>10</strong>. Se uma substitui\00E7\00E3o de coluna for usada e o valor for maior que <strong>10</strong>, uma mensagem ser\00E1 gravada na console Javascript e o marcador ser\00E1 exibi')
||unistr('do com um fator de escala <strong>10</strong>. O componente do mapa arredondar\00E1 o valor para o primeiro d\00EDgito decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107225504118311521)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escala de Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190653157311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que cont\00E9m classes CSS do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190526403311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107191033131311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS a serem usadas como origem do \00EDcone.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190959585311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190827287311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o URL da origem da imagem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190749626311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URL da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189826852311494)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem do \00EDcone para exibir o ponto no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190198711311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Classe do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190266559311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Use classes CSS individuais para cada linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189960836311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classe do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190084404311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use uma classe CSS Est\00E1tica para todas as linhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190399136311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'URL da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107190429553311495)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL para uma imagem a ser usada para exibi\00E7\00E3o de pontos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107189702522311494)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Origem do \00CDcone')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180605066311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ativa ou desativa diversos recursos do widget de mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181794108311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Localiza\00E7\00E3o do Browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181811080311489)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obt\00E9m a localiza\00E7\00E3o atual do usu\00E1rio do browser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181964368311489)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ferramenta de C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182077799311489)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Ferramenta C\00EDrculo permite que os usu\00E1rios finais desenhem um c\00EDrculo no mapa. Quando a a\00E7\00E3o \00E9 encerrada, um evento \00E9 acionado, de forma que o c\00EDrculo possa ser processado por A\00E7\00F5es Din\00E2micas ou c\00F3digo JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182134734311489)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ferramenta de Dist\00E2ncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182263567311489)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite que os usu\00E1rios finais me\00E7am dist\00E2ncias entre pontos no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181531718311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa Infinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181616059311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Rolagem de mapa infinito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180720181311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar Zoom com o Bot\00E3o de Rolagem do Mouse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180861200311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aumenta ou diminui o zoom usando o bot\00E3o de rolagem do mouse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181306741311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapa de Vis\00E3o Geral')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181484736311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe um mapa de vis\00E3o geral no canto inferior direito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180922048311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Zoom com Ret\00E2ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181039254311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplica zoom no mapa em uma \00E1rea desenhando um ret\00E2ngulo no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181167854311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barra de Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107181234757311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe uma barra de escala no mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107180516673311488)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185509635311491)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a altura da regi\00E3o do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185443525311491)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185690528311491)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183894187311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe classes CSS para adicionar \00E0 legenda. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183726025311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183666368311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor jQuery do elemento no qual a legenda ser\00E1 exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183586666311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182808217311489)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica a posi\00E7\00E3o da legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183192913311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183297236311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostra a legenda na posi\00E7\00E3o final (normalmente abaixo do mapa).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183300522311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183428766311490)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um seletor jQuery do elemento no qual a legenda ser\00E1 mostrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182975746311489)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107183021437311489)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostra a legenda na posi\00E7\00E3o inicial (normalmente acima do mapa).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182793601311489)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217719115311516)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350666484311615)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o mostrar mensagens da camada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184322595311490)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique onde mostrar as mensagens Dados N\00E3o Encontrados ou Mais Dados Encontrados da camada de mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184488303311490)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Acima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184506215311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Mostra mensagens acima do mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184690242311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Abaixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184778181311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Mostra mensagens abaixo do mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184843359311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184904015311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um seletor jQuery do elemento no qual as mensagens ser\00E3o exibidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107184243699311490)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o das Mensagens')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185167913311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor jQuery do elemento no qual as mensagens ser\00E3o exibidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185070507311491)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Mensagens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182672236311489)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica se ser\00E1 mostrada uma legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107182594211311489)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185319444311491)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se um item da p\00E1gina for escolhido, a regi\00E3o do mapa sempre manter\00E1 a caixa delimitadora do mapa atual, no formato GeoJSON, como o valor desse item. Isso \00E9 \00FAtil para conectar o mapa a outro componente do APEX (por exemplo, um relat\00F3rio cl\00E1ssico ou')
||unistr(' interativo): o conte\00FAdo do item da caixa delimitadora pode ser usado pelo outro componente para realizar uma consulta espacial e exibir apenas dados vis\00EDveis no mapa.</p>'),
unistr('<p>Exemplo de conte\00FAdo do Item da Caixa Delimitadora ap\00F3s algum movimento do mapa ou altera\00E7\00E3o do n\00EDvel de zoom:</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('Usando uma A\00E7\00E3o Din\00E2mica <strong>Atualizar</strong> o mapa pode ser conectado a uma regi\00E3o do relat\00F3rio. A regi\00E3o do relat\00F3rio pode aplicar um filtro espacial para mostrar apenas os resultados que tamb\00E9m s\00E3o vis\00EDveis no mapa.</p>'),
unistr('<p>Exemplo de consulta de relat\00F3rio:</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column], ',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] ) ',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107185214492311491)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item da Caixa Delimitadora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215376859311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o sistema de unidade a ser usado para a barra de escala e ferramenta de dist\00E2ncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215653155311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Imperial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215776046311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Use o sistema imperial.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215891888311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Derivar do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215969847311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Derive o sistema de unidade do valor de uma p\00E1gina ou um item de aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215479357311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9trica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215518476311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use o sistema m\00E9trico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107215214285311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Sistema de Unidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216140269311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma p\00E1gina ou um item de aplicativo contendo o valor a ser usado como sistema de unidade do mapa: <strong>M\00C9TRICO</strong> (<strong>M</strong>) ou <strong>IMPERIAL</strong> (<strong>I</strong>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107216096392311514)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item do Sistema de Unidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842811755311218)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se um marcador dever\00E1 ser renderizado no item de dados do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842906906311218)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843166281311218)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843036824311218)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106842753728311218)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843327109311218)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a forma do marcador a ser renderizado nos itens de dados do gr\00E1fico. Somente a op\00E7\00E3o <strong>autom\00E1tico</strong> \00E9 suportada para s\00E9ries de intervalo. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843426103311218)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843513342311218)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843621952311218)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Losango'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843736487311219)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Humano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843858733311219)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Mais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843916992311219)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106869176062311238)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Asterisco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844095007311219)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tri\00E2ngulo para Baixo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106844156102311219)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tri\00E2ngulo para Cima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106843207791311218)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959270290311313)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se esta coluna for uma coluna de chave estrangeira para a regi\00E3o de grade interativa mestra, conforme especificado por <strong>Regi\00E3o Mestra</strong> nas defini\00E7\00F5es da regi\00E3o, selecione a coluna de chave prim\00E1ria correspondente na tabela mestra.</')
||'p>',
unistr('        <p>Por exemplo, se a regi\00E3o mestra fosse DEPT e esta grade interativa fosse EMP, voc\00EA selecionaria a coluna DEPTNO na grade interativa EMP e selecionaria a coluna DEPTNO na lista de colunas DEPT para a Coluna Mestra.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959136127311313)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Mestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106777025234311160)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a regi\00E3o mestra \00E0 qual esta regi\00E3o de detalhe pertence.<br>'),
unistr('        Esta op\00E7\00E3o dever\00E1 ser definida quando esta regi\00E3o for a regi\00E3o de detalhe em um relacionamento mestre/detalhe com outra regi\00E3o nesta p\00E1gina.</p>'),
unistr('        <p>Para que o relacionamento mestre/detalhe funcione corretamente, selecione as colunas nesta regi\00E3o que s\00E3o as chaves estrangeiras da regi\00E3o mestra e especifique a <strong>Coluna Mestra</strong> adequada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106776929212311160)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o Mestra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888963504311254)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero m\00E1ximo a ser exibido no seletor Linhas por P\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888892150311253)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo de Linhas Por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220470475311517)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero m\00E1ximo de linhas que podem ser processadas para esta camada. Isso pode ser usado como uma medida quando houver muitos objetos espaciais sendo submetidos a download e exibidos no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888169059311253)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o n\00FAmero m\00E1ximo de linhas que podem ser processadas pela consulta. Se o n\00FAmero m\00E1ximo de linhas a serem processadas exceder o limite, uma mensagem de erro ser\00E1 exibida, em vez de dados.'),
'Uma mensagem personalizada pode ser definida especificando-se uma mensagem em <strong>Mais Dados Encontrados</strong>.</p>',
unistr('<p>Esse atributo serve como salvaguarda contra a\00E7\00F5es executadas pelos usu\00E1rios finais, como classifica\00E7\00F5es ou agrega\00E7\00F5es, em todos os registros de tabelas ou views muito grandes, que talvez n\00E3o estejam tendo um bom desempenho.'),
unistr('Em vez disso, o n\00FAmero de registros sendo processados deve ser reduzido primeiro, adicionando filtros.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888089660311253)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo de Linhas a Processar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254530098311544)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se este componente ser\00E1 exibido usando uma coluna ou formata\00E7\00E3o avan\00E7ada com o uso de express\00F5es HTML e strings de substitui\00E7\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254459336311544)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262395184311550)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256966570311546)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Determina a raz\00E3o altura/largura da m\00EDdia.'),
unistr('<strong>Auto</strong> Usa o melhor ajuste para preservar o tamanho da m\00EDdia original.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257007626311546)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257158851311546)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplica uma raz\00E3o altura/largura quadrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257226934311546)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tela Larga'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257312214311546)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplica uma raz\00E3o altura/largura de tela larga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256884439311546)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255959456311545)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que retorna o BLOB para a origem da m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255856979311545)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258152330311547)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258063046311547)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258346064311547)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este texto descreve a m\00EDdia e pode ser usado para dicas de ferramentas e texto alternativo para imagens.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107258251144311547)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o da Imagem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256155065311545)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determina onde o componente de m\00EDdia est\00E1 posicionado no cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256647927311546)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Como Imagem de Fundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256738027311546)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe a m\00EDdia como o fundo do cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256493803311545)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256573727311546)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe a m\00EDdia dentro do corpo do cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256241225311545)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256302959311545)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe a m\00EDdia antes do cabe\00E7alho do cart\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107256034537311545)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254808292311544)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254739695311544)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>&COLUMN.</code> para mostrar valores de coluna em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254671354311544)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257533560311546)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determina como a m\00EDdia \00E9 dimensionada dentro do componente de m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257882665311546)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Abranger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257952731311546)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajusta o dimensionamento de forma que a m\00EDdia preencha a \00E1rea de exibi\00E7\00E3o da m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257600169311546)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ajustar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257781739311546)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajusta o dimensionamento de forma que a m\00EDdia fique contida dentro da \00E1rea de exibi\00E7\00E3o da m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107257451634311546)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dimensionamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107262223790311550)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma M\00EDdia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255033401311544)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de origem de m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255312198311545)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255242834311545)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255165340311545)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'pt-br'
,p_message_text=>'URL da Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107254984102311544)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552666122310982)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o tipo de m\00EDdia da Internet. Este \00E9 um identificador de duas partes para formatos de arquivos da Internet.'),
unistr('Um tipo de m\00EDdia \00E9 composto por, pelo menos, duas partes: um tipo, um subtipo e um ou mais par\00E2metros opcionais.'),
unistr('Esse tipo de m\00EDdia \00E9 usado no cabe\00E7alho HTTP de Tipo de Conte\00FAdo ao renderizar a p\00E1gina.</p>'),
unistr('<p>O tipo de M\00EDdia no n\00EDvel da p\00E1gina substitui o tipo de m\00EDdia no n\00EDvel do aplicativo.'),
unistr('Se os valores de n\00EDvel da p\00E1gina e n\00EDvel do aplicativo forem <code>NULL</code>, o tipo de M\00EDdia <code>text/html</code> ser\00E1 usado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552558703310982)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de M\00EDdia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255594725311545)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o URL da origem da m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255433658311545)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255748160311545)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como origem da m\00EDdia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107255621399311545)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848730675311222)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o incremento entre as marca\00E7\00F5es secund\00E1rias. Utiliza como padr\00E3o um valor nulo para que haja um c\00E1lculo autom\00E1tico com base nos dados. S\00F3 se aplica a eixos num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848653009311222)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848566513311222)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se as marca\00E7\00F5es secund\00E1rias dever\00E3o ser renderizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848432757311222)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848325478311222)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o incremento m\00EDnimo entre marca\00E7\00F5es principais. Em geral, esse valor \00E9 usado para impedir valores de eixo fracionais para medidas discretas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848227700311222)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa M\00EDnima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268303470311556)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do processo de aplicativo para facilitar a identifica\00E7\00E3o por parte dos desenvolvedores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649817927311054)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome usado pelos desenvolvedores do aplicativo para fazer refer\00EAncia a esse esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589300815311010)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome \00FAnico que identifique este esquema de autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663072672311064)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome da ramifica\00E7\00E3o para facilitar a identifica\00E7\00E3o por desenvolvedores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699938120311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um nome descritivo para este modelo de breadcrumb.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589204923311010)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome para esta op\00E7\00E3o de build. As op\00E7\00F5es de build s\00E3o defini\00E7\00F5es pr\00E9-configuradas que determinam se os componentes de um aplicativo est\00E3o ou n\00E3o ativados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699606516311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome descritivo para este modelo de bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700045446311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome descritivo para este modelo de calend\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589976267311010)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome da a\00E7\00E3o din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699756947311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um nome descritivo para este modelo de item.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106886169844311251)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do grupo de coluna. Este nome ser\00E1 exibido como um cabe\00E7alho de regi\00E3o na view detalhada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699858737311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um nome descritivo para este modelo de lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219965756311517)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira um nome descritivo para este componente. Use o atributo <strong>Label</strong>, se HTML ou substitui\00E7\00F5es forem necess\00E1rios para a exibi\00E7\00E3o do label na regi\00E3o do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589468204311010)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome da p\00E1gina atual. Esse nome \00E9 usado em v\00E1rias p\00E1ginas e relat\00F3rios do &PRODUCT_NAME., junto com o n\00FAmero e o t\00EDtulo da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589763847311010)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do grupo de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590594695311011)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome do processo da p\00E1gina para facilitar a identifica\00E7\00E3o por parte dos desenvolvedores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699463532311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome descritivo para este modelo de p\00E1gina espec\00EDfico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699534388311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome descritivo para este modelo de regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700154458311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome descritivo para este modelo de relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699329658311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um breve nome descritivo para este tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700232055311092)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome para esta interface de usu\00E1rio. O nome \00E9 exibido nos assistentes, como o Assistente de Cria\00E7\00E3o de Tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662724309311063)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome para a valida\00E7\00E3o. Esse nome deve ser descritivo para que os desenvolvedores possam facilmente identificar as condi\00E7\00F5es que est\00E3o sendo verificadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549487463310980)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um nome descritivo para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106549372149310979)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564438976310991)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o nome de uma lista de valores existentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564322819310991)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176382316311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolha a posi\00E7\00E3o da barra de navega\00E7\00E3o no mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176624151311485)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176799276311485)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostra a barra de navega\00E7\00E3o na posi\00E7\00E3o final (normalmente no lado direito) do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176404287311485)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176583278311485)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostra a barra de navega\00E7\00E3o na posi\00E7\00E3o inicial (normalmente no lado esquerdo) do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176201910311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175540423311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de barra de navega\00E7\00E3o a ser usada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176009426311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Zoom e B\00FAssola')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107176175102311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Controles de zoom e b\00FAssola para controlar a orienta\00E7\00E3o do mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175651419311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175799883311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma barra de navega\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175893293311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175912580311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Somente controles de aumentar e diminuir o zoom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175430332311484)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432596710311674)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o mostrar lista do menu de navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689494981311084)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a lista do menu de navega\00E7\00E3o utilizada para a navega\00E7\00E3o nesta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689336829311084)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432048064311674)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o para a lista de menus de navega\00E7\00E3o nesta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432234270311674)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432149161311674)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107431953289311674)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o da Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689673693311084)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o modelo da lista do menu de navega\00E7\00E3o utilizado com a lista do menu de navega\00E7\00E3o nesta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689558446311084)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432427950311674)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Selecione as op\00E7\00F5es de modelo para personalizar a interface de usu\00E1rio desta lista de navega\00E7\00E3o.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107432347194311674)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245649852311538)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostre uma seta apontando para a direita</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245519637311538)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe as classes para o \00EDcone que deseja adicionar ao componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as por espa\00E7os.</p>'),
unistr('        <p>Caso seu tema use a Fonte APEX, analise o <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a> para ver os \00EDcones e modificadores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107245452958311538)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone de Dados N\00E3o Encontrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429737003311672)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o texto a ser exibido dentro da op\00E7\00E3o NULL da lista no alto desta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238168031311532)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o texto a ser exibido dentro da op\00E7\00E3o NULL da lista no alto desta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601242631311018)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o texto a ser exibido dentro da op\00E7\00E3o NULL da lista no alto desta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602595599311019)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o texto a ser exibido dentro da op\00E7\00E3o NULL da lista no alto desta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565050187310991)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto a ser exibido na op\00E7\00E3o NULO da lista, no topo dessa lista. Esse valor tamb\00E9m ser\00E1 exibido ao renderizar o item se o valor for nulo. Se voc\00EA n\00E3o inserir qualquer texto, ele ser\00E1 exibido como uma linha em branco na lista e um item em br')
||'anco quando renderizado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106564935656310991)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Exibi\00E7\00E3o Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565260980310991)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor a ser retornado se o valor NULO for selecionado na lista de valores. Se voc\00EA n\00E3o fornecer um valor, o valor do item ser\00E1 deixado como nulo quando a op\00E7\00E3o NULO for selecionada nessa lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106565135278310991)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor de Retorno Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923414908311280)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero de linhas de relat\00F3rio a serem exibidas por p\00E1gina do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923375785311280)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923610532311280)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o item cujo valor especifica o n\00FAmero de linhas do relat\00F3rio a serem exibidas por p\00E1gina do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923555753311280)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923290726311280)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como o n\00FAmero de linhas ser\00E1 informado para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103597480311429)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Baseado no Valor de Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103470102311429)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923132777311280)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Tipos de Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560353643310988)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite um destino de URL para quando um usu\00E1rio final tentar executar uma segunda submiss\00E3o de p\00E1gina. O &PRODUCT_NAME. exibe uma mensagem de erro e um link para este URL para permitir que o usu\00E1rio continue.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106560294024310987)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em caso de submiss\00F5es de p\00E1ginas duplicadas, ir para este URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951665807311307)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a p\00E1gina ou o URL substitui a p\00E1gina atual ou \00E9 aberta em uma caixa de di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110986995311435)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110860990311435)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'pt-br'
,p_message_text=>'Mesma Janela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106951577008311307)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir Link em'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875438773311243)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Opera\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764342064311150)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Ao acessar a tabela, o <code>funcion\00E1rio</code> tenta usar o \00EDndice <code>emp_department_ix</code></dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>Ative o uso da cl\00E1usula <code>WITH plsql_declarations</code> dentro da consulta SQL</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764217239311150)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite a dica do Oracle Optimizer que \00E9 adicionada \00E0 instru\00E7\00E3o de n\00EDvel superior ao executar a consulta SQL.'),
unistr('        Uma dica \00E9 uma instru\00E7\00E3o para o Optimizer. Ao escrever a SQL, voc\00EA pode saber informa\00E7\00F5es sobre os dados que s\00E3o desconhecidas do Optimizer. As dicas permitem que voc\00EA tome decis\00F5es normalmente tomadas pelo Optimizer,'),
'        por vezes fazendo com que ele selecione um plano visto por ele como de custo mais alto.</p>',
unistr('        <p>Por exemplo, voc\00EA poder\00E1 saber que um determinado \00EDndice \00E9 mais seletivo para determinadas consultas. Com base nessa informa\00E7\00E3o, poder\00E1 escolher um plano de execu\00E7\00E3o mais eficiente do que o Optimizer.'),
unistr('        Nesse caso, use dicas para for\00E7ar o Optimizer a usar o plano de execu\00E7\00E3o ideal.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764178892311150)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Dica do Otimizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436771408311677)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione uma coluna que seja indexada por um \00EDndice do Oracle Text.</p>'),
unistr('<p>A Pesquisa de Linha retorna os resultados com base no operador do Oracle Text digitado, desde que o \00EDndice do Oracle Text correspondente tenha sido criado para a coluna.'),
unistr('Essa op\00E7\00E3o s\00F3 dever\00E1 ser ativada se existir o \00EDndice necess\00E1rio e os usu\00E1rios finais tiverem sido treinados sobre como utilizar os operadores de pesquisa do Oracle Text.'),
unistr('Para simplificar a sintaxe do Oracle Text para os usu\00E1rios finais, voc\00EA pode especificar uma fun\00E7\00E3o para o <em>Nome da Fun\00E7\00E3o PL/SQL do Oracle Text</em> - Defini\00E7\00E3o de Componente de Grades Interativas em Componentes Compartilhados.<br>'),
'Consulte o <a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Oracle Text Application Developers Guide</a>.</p>',
unistr('<p>Observa\00E7\00E3o - Quando os usu\00E1rios finais informarem corretamente os operadores do Oracle Text, o desempenho da pesquisa dever\00E1 ser bem melhor.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436675854311677)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de \00CDndice do Oracle Text')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268048776311556)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo de Limpeza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267993464311556)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo de Inicializa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826671577311205)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a orienta\00E7\00E3o deste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826744964311205)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957306196311312)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe os itens de dados do gr\00E1fico horizontalmente. Por exemplo, as barras em um gr\00E1fico de Barras ser\00E3o exibidas horizontalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957193141311311)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957212587311311)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe os itens de dados do gr\00E1fico verticalmente. Por exemplo, as barras em um gr\00E1fico de Barras ser\00E3o exibidas verticalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826586495311205)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836576214311213)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a altura da barra de rolagem, em pixels (por exemplo, 50px) ou percentual (por exemplo, 15%), a ser renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836408574311213)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836377814311213)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se uma barra de rolagem de vis\00E3o geral dever\00E1 ser renderizada no gr\00E1fico.'),
unistr('        Atualmente, esta op\00E7\00E3o s\00F3 \00E9 suportada para gr\00E1ficos de barra vertical, linha, \00E1rea, linha com \00E1rea, a\00E7\00F5es e combina\00E7\00E3o.</p>'),
unistr('        <p>Observa\00E7\00E3o - A op\00E7\00E3o <strong>Zoom e Rolagem</strong> dever\00E1 estar ativada para que a barra de rolagem de vis\00E3o geral seja exibida.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106836294029311213)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689215299311084)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a navega\00E7\00E3o no n\00EDvel da Interface de Usu\00E1rio padr\00E3o ser\00E1 substitu\00EDda. Essa op\00E7\00E3o pode ser usada para n\00E3o haver navega\00E7\00E3o na p\00E1gina atual ou para escolher uma navega\00E7\00E3o alternativa na p\00E1gina atual (por exemplo, para proporcionar uma nav')
||unistr('ega\00E7\00E3o espec\00EDfica em uma subse\00E7\00E3o do seu aplicativo).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106689113372311084)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substituir N\00EDvel da Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559935794310987)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de prote\00E7\00E3o de estado de sess\00E3o que ser\00E1 implementado para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061108995311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'pt-br'
,p_message_text=>'Argumentos Devem Ter Checksum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061269739311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se os argumentos Solicita\00E7\00E3o, Limpar Cache ou Nome/Valor aparecerem no URL, uma checksum tamb\00E9m dever\00E1 ser fornecida.<br>'),
unistr('O tipo de checksum deve ser compat\00EDvel com o atributo <em>Prote\00E7\00E3o de Estado da Sess\00E3o</em> mais restritivo de todos os itens especificados como argumentos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061512432311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Acesso URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061656768311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A p\00E1gina n\00E3o pode ser acessada por meio de um URL.<br>'),
unistr('No entanto, a p\00E1gina pode ser o destino de um tipo de ramifica\00E7\00E3o <em>Ramificar para P\00E1gina</em>, j\00E1 que este n\00E3o executa um redirecionamento de URL.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060943570311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Irrestrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061031057311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina pode ser solicitada por meio de um URL, com ou sem argumentos do estado da sess\00E3o, e sem precisar de uma checksum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061341024311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 Suporte para os Argumentos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107061497921311398)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um URL pode ser usado para solicitar a p\00E1gina, mas ele n\00E3o pode conter os argumentos Solicita\00E7\00E3o, Limpar Cache ou Pares de Nome/ Valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559845834310987)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prote\00E7\00E3o de Acesso a P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550849569310981)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe um alias alfanum\00E9rico para esta p\00E1gina. Voc\00EA pode usar esse alias para fazer refer\00EAncia \00E0 p\00E1gina, em vez de ao n\00FAmero da p\00E1gina.'),
unistr('Por exemplo, se estivesse trabalhando na p\00E1gina 1 do aplicativo 100, voc\00EA poderia criar um alias chamado <code>home</code>.'),
unistr('Em seguida, voc\00EA poderia acessar esta p\00E1gina a partir de outras p\00E1ginas usando a seguinte sintaxe f?p:'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550755324310980)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alias da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559544565310987)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se esta p\00E1gina \00E9 p\00FAblica ou exige autentica\00E7\00E3o.'),
unistr('Se uma p\00E1gina for identificada como p\00FAblica, ela poder\00E1 ser exibida por qualquer usu\00E1rio que a acesse.'),
unistr('A fun\00E7\00E3o de sentinela de p\00E1gina do aplicativo pode acessar esse atributo de p\00E1gina para identificar as p\00E1ginas que n\00E3o exigem autentica\00E7\00E3o para exibi\00E7\00E3o.'),
unistr('A implementa\00E7\00E3o da fun\00E7\00E3o de sentinela de p\00E1gina do esquema de autentica\00E7\00E3o determina se esse atributo tem efeito.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060345967311394)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Requer Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107060422293311397)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina \00C9 P\00FAblica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106559428926310987)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551024967310981)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique o grupo de p\00E1ginas a ser associado a esta p\00E1gina.'),
unistr('Grupos de p\00E1ginas n\00E3o afetam a funcionalidade; eles ajudam desenvolvedores a gerenciar as p\00E1ginas de um aplicativo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106550960820310981)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558506577310986)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o texto substitu\00EDdo pela string de substitui\00E7\00E3o <code>#ONLOAD#</code> do modelo da sua p\00E1gina.'),
unistr('Para usar este recurso, seu modelo de p\00E1gina deve incluir a string de substitui\00E7\00E3o <code>#ONLOAD#</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106558412910310986)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributo de Corpo HTML de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551247330310981)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o modo desta p\00E1gina.</p>'),
'#LOV_VALUES#',
unistr('<p>Observe que as op\00E7\00F5es <em>Modal</em> e <em>Caixa de Di\00E1logo N\00E3o Modal</em> s\00F3 estar\00E3o dispon\00EDveis para sele\00E7\00E3o quando o tema do aplicativo atual contiver um <em>Modelo de P\00E1gina de Caixa de Di\00E1logo</em> padr\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059454188311394)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Di\00E1logo Modal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059544859311394)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A p\00E1gina \00E9 apresentada como uma caixa de di\00E1logo modal.<br>'),
unistr('Uma caixa de di\00E1logo modal \00E9 uma janela de sobreposi\00E7\00E3o posicionada no visor, que permanece ativa e em foco at\00E9 que o usu\00E1rio final a descarte (feche a mesma).'),
unistr('A p\00E1gina subjacente \00E9 esmaecida e o usu\00E1rio final \00E9 impedido de interagir com o restante da p\00E1gina at\00E9 que a caixa de di\00E1logo seja fechada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059675689311394)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Di\00E1logo N\00E3o-Modal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059704628311394)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A p\00E1gina \00E9 apresentada como uma caixa de di\00E1logo n\00E3o modal.<br>'),
unistr('Uma caixa de di\00E1logo n\00E3o modal \00E9 uma janela de sobreposi\00E7\00E3o posicionado no visor, na qual o usu\00E1rio final pode interagir com a caixa de di\00E1logo e o conte\00FAdo da p\00E1gina que iniciou a caixa de di\00E1logo.'),
unistr('Uma caixa de di\00E1logo n\00E3o modal pode ser usada quando as informa\00E7\00F5es solicitadas n\00E3o s\00E3o essenciais para continuar, o trabalho pode continuar em outro lugar enquanto a janela ainda estiver aberta.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059236282311393)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107059301878311393)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina \00E9 apresentada como uma p\00E1gina normal de aplicativo do &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551183926310981)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400758531311651)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759785748311146)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o tipo de processo que ser\00E1 executado. Os seguintes tipos de processo s\00E3o suportados:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Dependendo da configura\00E7\00E3o do aplicativo, tamb\00E9m \00E9 poss\00EDvel ter plug-ins de tipo de processo adicionais dispon\00EDveis aqui.'),
unistr('Estes s\00E3o exibidos como <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('Os seguintes plug-ins s\00E3o instalados nos componentes compartilhados deste aplicativo:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582655027311005)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383860913311639)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383758867311639)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383651958311639)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item da p\00E1gina ou do aplicativo usado como origem para este par\00E2metro.'),
unistr('\00C9 poss\00EDvel digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383552165311639)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107384088748311639)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um ou mais itens no n\00EDvel do aplicativo ou da p\00E1gina usados como o destino deste par\00E2metro. Para v\00E1rios itens, separe o nome de cada item com uma v\00EDrgula.</p>.'),
unistr('<p>Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA selecionar na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome do item retornado da lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107383913709311639)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385225685311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a origem do par\00E2metro na lista dispon\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385745147311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385821694311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o PL/SQL</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385369935311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385466893311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385516512311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385634416311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o texto inserido no <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107385102592311640)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907573245311268)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor para este par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907403425311268)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935279925311289)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551438765310981)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um modelo de p\00E1gina para definir a apar\00EAncia e o layout desta p\00E1gina.</p>'),
unistr('        <p>Os modelos de p\00E1gina s\00E3o definidos no tema do aplicativo.'),
unistr('        Quando uma p\00E1gina \00E9 criada, o modelo \00E9 automaticamente definido como <em>Padr\00E3o de Tema</em>, que converter\00E1 a p\00E1gina usando o modelo de p\00E1gina padr\00E3o definido no tema atual.'),
unistr('        O ato de fazer uma sele\00E7\00E3o aqui substitui o modelo de p\00E1gina padr\00E3o.</p>'),
unistr('        <p>Muitos temas cont\00EAm modelos de p\00E1gina com finalidades espec\00EDficas, como exibir conte\00FAdo com colunas laterais, p\00E1gina de log-in, p\00E1ginas de caixa de di\00E1logo e assim por diante.<br>'),
unistr('        O Universal Theme fornece os seguintes modelos de p\00E1gina:'),
'          <dl>',
unistr('            <dt>Padr\00E3o</dt>'),
unistr('              <dd>O modelo de p\00E1gina padr\00E3o. Ideal para home pages, pain\00E9is de controle, relat\00F3rios grandes e outros layouts em que se deseja o m\00E1ximo de espa\00E7o na tela.</dd>'),
'            <dt>Coluna Esquerda</dt>',
unistr('              <dd>Fornece uma posi\00E7\00E3o de exibi\00E7\00E3o esquerda que \00E9 \00FAtil para pesquisar e filtrar p\00E1ginas.</dd>'),
'            <dt>Coluna Direita</dt>',
unistr('              <dd>Fornece uma posi\00E7\00E3o de exibi\00E7\00E3o contra\00EDvel \00E0 direita que \00E9 \00FAtil para exibir controles orientados a a\00E7\00F5es como bot\00F5es ou listas.</dd>'),
'            <dt>Colunas Esquerda e Direita</dt>',
unistr('              <dd>Fornecem colunas \00E0 esquerda e contra\00EDveis \00E0 direita que s\00E3o bem adequadas para p\00E1ginas muito complexas.</dd>'),
'            <dt>Log-in</dt>',
unistr('              <dd>Usado exclusivamente para a p\00E1gina de log-in do aplicativo.</dd>'),
'            <dt>Letreiro</dt>',
unistr('              <dd>Fornece uma coluna lateral contra\00EDvel e uma \00E1rea de barra de t\00EDtulos que cont\00E9m informa\00E7\00F5es principais.'),
unistr('              Este modelo de p\00E1gina \00E9 bem adequado para exibir um registro \00FAnico que tem v\00E1rios relat\00F3rios ou dados relacionados.'),
unistr('              O letreiro \00E9 usado comumente para exibir relacionamentos Mestre-Detalhe em que um \00FAnico registro mestre \00E9 selecionado primeiro em um relat\00F3rio. </dd>'),
unistr('            <dt>M\00EDnimo (Sem Navega\00E7\00E3o)</dt>'),
unistr('              <dd>\00DAtil para p\00E1ginas muito simples, textos de isen\00E7\00E3o de responsabilidade, aplicativos de p\00E1gina \00FAnica, ou situa\00E7\00F5es em que a navega\00E7\00E3o n\00E3o \00E9 necess\00E1ria.</dd>'),
'          </dl>',
unistr('          Consulte Tamb\00E9m: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra Universal Theme</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551360948310981)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935465002311289)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376422079311634)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usa a defini\00E7\00E3o estabelecida nos padr\00F5es do tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552233344310982)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique a transi\00E7\00E3o utilizada ao navegar para uma nova p\00E1gina ou quando a p\00E1gina est\00E1 sendo submetida.</p>'),
unistr('<p>Browsers mais antigos, que n\00E3o suportam transforma\00E7\00F5es em 3D, n\00E3o podem utilizar a maioria das transa\00E7\00F5es.'),
unistr('Por padr\00E3o, os dispositivos que n\00E3o t\00EAm suporte a 3D (como Android 2.x) sofrer\00E3o fallback para todos os tipos de transi\00E7\00E3o.'),
unistr('Consulte a documenta\00E7\00E3o do jQuery Mobile para obter detalhes adicionais.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064323282311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmaecimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064452891311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Girar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064584190311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fluxo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064250891311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064605864311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064725744311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Slide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064864569311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Slide para baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107064949571311400)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmaecimento do Slide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065063885311401)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Slide para cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065106655311401)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Virar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552195250310981)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Transi\00E7\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240343289311534)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se o usu\00E1rio ser\00E1 avisado quando tentar navegar para fora da p\00E1gina, se houver altera\00E7\00F5es n\00E3o salvas.'),
unistr('        Os Itens e Bot\00F5es da P\00E1gina tamb\00E9m oferecem um controle mais detalhado sobre quando essa verifica\00E7\00E3o \00E9 executada e o que ela inclui.'),
unistr('        No caso dos Bot\00F5es, voc\00EA pode especificar se um clique no bot\00E3o executar\00E1 a verifica\00E7\00E3o.'),
unistr('        No caso de Itens de P\00E1gina, voc\00EA pode especificar se as altera\00E7\00F5es no item ser\00E3o inclu\00EDdas ou ignoradas pela verifica\00E7\00E3o (consulte o atributo <em>Avisar sobre Altera\00E7\00F5es N\00E3o Salvas</em> para ambos os casos).</p>'),
unistr('        <p>Observa\00E7\00E3o: isso n\00E3o se aplica a um usu\00E1rio final que est\00E1 fechando uma p\00E1gina da caixa de di\00E1logo Modal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240260745311534)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aviso sobre Altera\00E7\00F5es N\00E3o Salvas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887769754311253)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione onde a pagina\00E7\00E3o do relat\00F3rio ser\00E1 exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088982195311418)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior - Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089047411311418)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior - Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089361327311418)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior e Inferior - Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089498163311418)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior e Inferior - Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089124668311418)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior - Esquerda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107089277977311418)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Superior - Direita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887638388311253)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107400428334311651)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Id do Par\00E2metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871923939311240)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o par\00E2metro \00E9 obrigat\00F3rio e deve ser sempre definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106871812066311240)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872100337311240)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um valor padr\00E3o ou est\00E1tico para esse par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872035657311240)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607781271311023)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Pai'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566713406310992)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o m\00E3e na qual a regi\00E3o ser\00E1 exibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566638443310992)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923079277311280)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a Atualiza\00E7\00E3o de P\00E1gina Parcial (PPR) ser\00E1 usada para atualizar a exibi\00E7\00E3o do relat\00F3rio.</p>'),
unistr('Se o usu\00E1rio final executar uma a\00E7\00E3o, como uma solicita\00E7\00E3o de pagina\00E7\00E3o ou sele\00E7\00E3o de uma nova coluna de classifica\00E7\00E3o, as linhas do relat\00F3rio atuais dever\00E3o ser atualizadas. A defini\00E7\00E3o desse atributo como <strong>Ativado</strong> atualiza apenas a ')
||unistr('regi\00E3o do relat\00F3rio. A defini\00E7\00E3o como <strong>Desativado</strong> atualiza a p\00E1gina inteira.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922983712311280)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00E3o de P\00E1gina Parcial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107100014474311426)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918538994311277)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada no plano de fundo deste gr\00E1fico.</p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918458771311277)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Fundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918929542311277)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a largura em pixels para este gr\00E1fico de barras.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918809570311277)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Largura da Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106945897816311302)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'pixels'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150546795311464)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918735917311277)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada no primeiro plano deste gr\00E1fico.</p>'),
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918600360311277)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Primeiro Plano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830872784311209)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a fra\00E7\00E3o do gr\00E1fico de pizza inteiro, abaixo da qual as fatias ser\00E3o agregadas em "Outra" fatia. Os valores v\00E1lidos variam de 0 (padr\00E3o) a 1</p>'),
'        <p>Por exemplo, um valor de 0.15 faria com que todas as fatias menores que 15% da pizza fossem agregadas na "Outra" fatia.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830716414311208)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Outro Limite para Gr\00E1fico de Pizza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861452726311232)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o efeito aplicado quando um segmento da pizza for selecionado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861562785311232)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Explodir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861792228311232)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861626160311232)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar e Explodir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861332332311232)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Efeito de Sele\00E7\00E3o de Pizza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939895218311292)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o de PL/SQL que forne\00E7a um valor para a chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939725383311292)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940002794311292)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome para a chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939931638311292)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939618847311292)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de origem da chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106929310311432)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107094536311432)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106858371311432)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'pt-br'
,p_message_text=>'Trigger existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106939530156311292)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023958406311366)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL a ser usada em vez de uma consulta gerada automaticamente que seleciona os valores distintos de coluna. A consulta SQL precisa retornar uma coluna. Informar uma consulta SQL pode melhorar o desempenho em alguns relat\00F3rios. Es')
||unistr('sa lista de valores ser\00E1 exibida quando um usu\00E1rio clicar em um cabe\00E7alho de coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023896561311366)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023515849311366)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como a lista de valores ser\00E1 derivada para o filtro na lista drop-down da coluna do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111984410311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Nomeada para Filtrar Correspond\00EAncia Exata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112057189311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Deriva a lista de valores da lista de valores nomeada para criar um filtro igual a.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112121170311436)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Nomeada para Filtrar a Palavra Cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112270356311436)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deriva a lista de valores da lista de valores nomeada para criar um filtro cont\00E9m.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111786962311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Definida para Filtrar a Palavra Cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111897185311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deriva a lista de valores a partir de uma lista definida de consulta de valores SQL para criar um filtro cont\00E9m.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111360131311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Baseado no Tipo de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111423373311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'As colunas STRING e NUMBER derivam da lista de valores de valores de colunas distintos. As colunas de DATA derivam da lista de valores de intervalos de data predefinidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111135480311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111216506311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Desativa o filtro na lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111530975311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Lista de Valores Definida para Filtrar Correspond\00EAncia Exata')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107111673290311435)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deriva a lista de valores a partir de uma lista definida de consulta de valores SQL para criar um filtro de correspond\00EAncia igual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107023433293311366)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268499914311557)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo PL/SQL a ser executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877793008311245)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo PL/SQL a ser executado no banco de dados remoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877643253311245)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo PL/SQL para gerar a sa\00EDda HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644462884311050)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a origem PL/SQL usada neste esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644335153311050)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877154198311244)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione onde o processo \00E9 executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877203755311244)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Banco de Dados Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877313283311244)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O c\00F3digo PL/SQL \00E9 executado no banco de dados local.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877498788311245)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877583299311245)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O c\00F3digo PL/SQL \00E9 executado em um banco de dados remoto, onde a conex\00E3o \00E9 definida usando SQL Ativada por REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877008313311244)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758863437311145)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione em qual categoria o plug-in ser\00E1 exibido na interface do usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084899093311415)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084900769311415)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Efeito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085079979311415)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Executar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085170894311415)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Inicializar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085209992311415)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'pt-br'
,p_message_text=>'Diversos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085336152311415)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085472057311416)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107085586343311416)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758721529311145)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410973047311659)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Insira um c\00F3digo JavaScript que possa ser executado. Observa\00E7\00E3o: A natureza exata do que ele faz vai depender do plug-in atual.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410831940311659)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo de Inicializa\00E7\00E3o de JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106935576026311289)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376572759311634)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usa a defini\00E7\00E3o estabelecida nos padr\00F5es do tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552467876310982)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique a transi\00E7\00E3o usada quando um popup \00E9 aberto.</p>'),
unistr('<p>Browsers mais antigos, que n\00E3o suportam transforma\00E7\00F5es em 3D, n\00E3o podem utilizar a maioria das transi\00E7\00F5es.'),
unistr('Por padr\00E3o, dispositivos que n\00E3o t\00EAm suporte a 3D (como Android 2.x) sofrer\00E3o esmaecimento para todos os tipos de transa\00E7\00E3o.'),
unistr('Consulte a documenta\00E7\00E3o do jQuery Mobile para obter detalhes adicionais.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065394019311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmaecimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065437846311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Girar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065574018311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fluxo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065216705311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065659434311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065799334311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Slide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065859023311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Slide para baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107065920240311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Esmaecimento do Slide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066012383311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'pt-br'
,p_message_text=>'Slide para cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107066166836311401)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Virar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106552304605310982)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Transi\00E7\00E3o de Popup')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645444657311051)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o nome de um procedimento a ser executado pelo procedimento de log-in do &PRODUCT_NAME. (API de log-in) ap\00F3s a etapa de autentica\00E7\00E3o (verifica\00E7\00E3o das credenciais de log-in).'),
unistr('O procedimento de log-in executar\00E1 este c\00F3digo ap\00F3s executar as opera\00E7\00F5es de procedimento normais, que incluem a defini\00E7\00E3o de um cookie e o registro da sess\00E3o, mas antes ele redirecionar\00E1 para p\00E1gina do aplicativo desejado.'),
unistr('O procedimento pode ser definido no atributo "C\00F3digo PL/SQL" ou no banco de dados.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645339808311051)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Procedimento de P\00F3s-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572829929310997)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma express\00E3o PL/SQL para refinar o valor do item.</p>'),
unistr('<p> Por exemplo, se o item se chamar <code>P1_X</code>, voc\00EA poder\00E1 usar as express\00F5es p\00F3s-c\00E1lculo, como <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X,:P2_Y-200)</code>, <code>NVL(:P1_X,:P2_Y)</code> ou uma chamada de fun\00E7\00E3o')
||', como <code>return my_func(:P1_X);</code> para definir o valor final do item.',
unistr('Observe que estes exemplos demonstram que as express\00F5es podem fazer refer\00EAncia ao item atual ou que elas tamb\00E9m podem fazer refer\00EAncia a qualquer outro item no estado de sess\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572743217310997)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00F3s-c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645863243311051)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o URL para onde o aplicativo ser\00E1 redirecionado ap\00F3s o &PRODUCT_NAME. limpar a sess\00E3o do usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645706457311051)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL Ap\00F3s Log-out')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322850046311596)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323186744311596)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323036696311596)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322940319311596)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323264248311596)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322747938311595)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324099830311596)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira um corpo de fun\00E7\00E3o Java, na qual a consulta SQL retornada transforme os dados recuperados na Origem Web. A consulta SQL retornada pelo corpo da fun\00E7\00E3o Java deve fazer a sele\00E7\00E3o na pseudotabela #APEX$SOURCE_DATA# e ler as colunas dispon\00EDveis no')
||unistr(' perfil de dados. N\00E3o h\00E1 suporte para o fatoramento de subconsulta usando a cl\00E1usula SQL WITH. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323929939311596)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323873080311596)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selecione as colunas EMPNO, ENAME e SAL e filtre todas as linhas com um SAL inferior a 3.000.</dt>',
'<dd><pre>',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA  where SAL < 3000'';',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323793039311596)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira um corpo de fun\00E7\00E3o JavaScript, na qual a consulta SQL retornada transforme os dados recuperados na Origem Web. A consulta SQL retornada pelo corpo da fun\00E7\00E3o JavaScript deve fazer a sele\00E7\00E3o na pseudotabela #APEX$SOURCE_DATA# e ler as colunas di')
||unistr('spon\00EDveis no perfil de dados. N\00E3o h\00E1 suporte para o fatoramento de subconsulta usando a cl\00E1usula SQL WITH. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323600157311596)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378372675311635)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para mostrar as contrata\00E7\00F5es mais recentes primeiro e aquelas que n\00E3o foram contratadas por \00FAltimo. Se a data for igual, classifique-as pelo n\00FAmero do departamento.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378282949311635)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um ou mais nomes de coluna separados por v\00EDrgulas, incluindo diretivas, para definir a ordem na qual os registros s\00E3o recuperados.</p>'),
'        <p>As diretivas incluem:',
'          <ul>',
'            <li>ASC - Coluna de retorno em ordem crescente</li>',
'            <li>DESC - Coluna de retorno em ordem decrescente</li>',
'            <li>NULLS FIRST - Coluna de retorno sem valor antes desses valores</li>',
'            <li>NULLS LAST - Coluna de retorno com valores antes daqueles sem valores</li>',
'          </ul>',
'        </p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378151012311635)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ordenar Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323584744311596)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selecione as colunas EMPNO, ENAME e SAL e filtre todas as linhas com um SAL inferior a 3.000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323467281311596)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira um corpo de fun\00E7\00E3o PL/SQL, na qual a consulta SQL retornada transforme os dados recuperados na Origem Web. A consulta SQL retornada pelo corpo da fun\00E7\00E3o PL/SQL deve fazer a sele\00E7\00E3o na pseudotabela #APEX$SOURCE_DATA# e ler as colunas dispon\00EDvei')
||unistr('s no perfil de dados. N\00E3o h\00E1 suporte para o fatoramento de subconsulta usando a cl\00E1usula SQL WITH. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107323310104311596)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324275268311597)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira um corpo de fun\00E7\00E3o Python, no qual a consulta SQL retornada transforme os dados recuperados na Origem Web. A consulta SQL retornada pelo corpo da fun\00E7\00E3o Python deve fazer a sele\00E7\00E3o na pseudotabela #APEX$SOURCE_DATA# e ler as colunas dispon\00EDvei')
||unistr('s no perfil de dados. N\00E3o h\00E1 suporte para o fatoramento de subconsulta usando a cl\00E1usula SQL WITH. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324186962311596)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379862981311636)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selecione as colunas EMPNO, ENAME e SAL e filtre todas as linhas com um SAL inferior a 3.000.</dt>',
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378516617311635)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Consulta SQL para transformar os dados recuperados na Origem de Dados REST. Fa\00E7a a sele\00E7\00E3o na pseudotabela #APEX$SOURCE_DATA# e especifique as colunas dispon\00EDveis no perfil de dados. N\00E3o h\00E1 suporte para o fatoramento da Subconsulta usando')
||unistr(' a cl\00E1usula SQL WITH.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378478668311635)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107378047870311635)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00F3 inclua aqueles funcion\00E1rios que tenham um gerente ou que sejam vendedores.</dt>'),
'<dd><pre>',
unistr('( MGR n\00E3o \00E9 nulo ou JOB = ''SALESMAN'' )'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377908790311635)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma condi\00E7\00E3o where de SQL v\00E1lida, usada para limitar os registros recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377808735311635)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cl\00E1usula Where')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645234645311051)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome de um procedimento a ser executado depois que a p\00E1gina de log-in for submetida e antes da execu\00E7\00E3o da verifica\00E7\00E3o de credenciais.'),
unistr('O procedimento pode ser definido no atributo "C\00F3digo PL/SQL" ou no banco de dados.</p>'),
unistr('<p>Os esquemas de autentica\00E7\00E3o nos quais a verifica\00E7\00E3o de credenciais do usu\00E1rio \00E9 feita fora do &PRODUCT_NAME., geralmente, n\00E3o s\00E3o executados no procedimento de Pr\00E9-Autentica\00E7\00E3o.'),
unistr('Os exemplos s\00E3o <em>Vari\00E1vel do Cabe\00E7alho HTTP</em>, <em>Oracle Application Server Single Sign-On</em> e esquemas de autentica\00E7\00E3o personalizados que usam <code>apex_authentication.post_login</code> em vez de <code>apex_authentication.login</code>.</p')
||'>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106645129172311050)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Procedimento de Pr\00E9-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949126127311305)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que cont\00E9m a chave prim\00E1ria para a tabela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949030295311305)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna da Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113768474311437)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026712105311368)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir a borda do atributo especificado.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026654522311368)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Borda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026589268311368)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a largura em pixels das bordas da tabela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026490464311368)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Largura da Borda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150881587311465)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029935839311371)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir o plano de fundo deste componente.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029817904311371)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Fundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115886270311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029790293311371)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir este componente.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029601840311371)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029136651311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma face de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115536838311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115311984311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115445729311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029019179311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029523610311371)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um tamanho de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029480454311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029380459311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma espessura de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115744220311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115676522311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107029246449311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Espessura da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107150780318311465)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028969437311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir o plano de fundo deste componente.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028824993311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Fundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115209144311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028796710311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir este componente.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028603609311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028159321311369)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma face de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114935471311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114771443311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114802600311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028046547311369)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028532929311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um tamanho de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028483060311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028394319311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma espessura de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115187369311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115080671311438)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107028268486311370)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Espessura da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917787143311276)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a largura da coluna usada para dimensionar esta coluna quando o relat\00F3rio for impresso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106917667963311276)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura da Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032514227311373)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione as unidades usadas para definir os valores de largura da coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117341287311439)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117499253311440)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ponto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032477735311373)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Unidades de Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031719100311372)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe um nome para o documento obtido por download. Se esse campo for deixado em branco, o nome da regi\00E3o ser\00E1 usado como o nome do arquivo.'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031689976311372)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026376782311368)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a altura desta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026249210311368)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033172802311373)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o texto do link de download. Para substituir o link por um componente de navega\00E7\00E3o diferente, como um bot\00E3o, deixe esse campo em branco. \00C9 poss\00EDvel definir outro componente para iniciar o processo de impress\00E3o usando um URL com a seguinte ')
||'sintaxe como o destino: </p>',
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('<p><strong>Observa\00E7\00E3o</strong>: Substitua <code>[REGION_ID]</code> na string acima pelo ID da regi\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033061646311373)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025730060311368)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a orienta\00E7\00E3o da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113208219311436)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Paisagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113162294311436)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Retrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025647351311368)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032684534311373)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Derivar do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033205562311373)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Derivar do Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031932007311372)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o formato de sa\00EDda do relat\00F3rio. O formato de sa\00EDda tamb\00E9m pode ser especificado por um item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117189195311439)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'pt-br'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116876700311439)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'pt-br'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116922645311439)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'pt-br'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117062951311439)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117202428311439)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'pt-br'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031815596311372)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032179938311373)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o item da p\00E1gina ou do aplicativo que cont\00E9m o valor do formato. Voc\00EA pode incluir um item de p\00E1gina <em>Selecionar Lista</em> para os usu\00E1rios selecionarem o formato da sa\00EDda no runtime. Os valores v\00E1lidos s\00E3o</p>'),
'<dl>',
'<dt>PDF</dt>',
'<dd>Abre o documento em um Visualizador PDF</dd>',
'<dt>RTF</dt>',
'<dd>Abre o documento no Microsoft Word</dd>',
'<dt>XLS</dt>',
'<dd>Abre o documento no Microsoft Excel</dd>',
'<dt>HTM</dt>',
'<dd>Faz download do documento como um arquivo HTML</dd>',
'<dt>XML</dt>',
'<dd>Faz download do documento como um arquivo XML</dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032002272311372)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030973987311372)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o alinhamento para o rodap\00E9 da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116695566311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116507284311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('in\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116719299311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030823649311372)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116495789311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030753829311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir este componente.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030659896311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030187840311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma face de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116115985311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107115925337311438)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116042809311438)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030074203311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030511727311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um tamanho de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030496758311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030319099311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma espessura de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116322496311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107116209282311439)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107030223210311371)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Espessura da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031154309311372)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto a ser exibido na se\00E7\00E3o do rodap\00E9 do documento. Para mostrar valores de itens da p\00E1gina ou do aplicativo, use a sintaxe <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107031019254311372)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto do Rodap\00E9 da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027790935311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um alinhamento para o cabe\00E7alho da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114596316311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114454424311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('in\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114650624311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027611726311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114310513311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem -'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027526175311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a cor usada para exibir este componente.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||'hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.',
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise ''C\00F3digos de Cores HTML'' na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027437703311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Cor da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026981032311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma face de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114019649311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113847393311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113930037311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026824933311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027339168311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um tamanho de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027288505311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027187690311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione uma espessura de fonte para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114208344311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107114119825311437)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027006206311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Espessura da Fonte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027917221311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto a ser exibido na se\00E7\00E3o do cabe\00E7alho do documento. Para mostrar valores de itens da p\00E1gina ou do aplicativo, use a sintaxe <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107027873821311369)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto do Cabe\00E7alho da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025505766311368)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tamanho da p\00E1gina de relat\00F3rios. Para digitar a largura e a altura da p\00E1gina, selecione <strong>Personalizar</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112972656311436)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'pt-br'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112850271311436)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'pt-br'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113080244311436)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112642980311436)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Of\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112525137311436)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Carta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112790017311436)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tabloide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025489056311368)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025928689311368)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione as unidades usadas para especificar a largura e altura da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113585796311437)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cent\00EDmetros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113373140311436)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'pt-br'
,p_message_text=>'Polegadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113459354311437)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mil\00EDmetros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107113623358311437)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Pontos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025857351311368)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Unidades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025361087311367)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a disposi\00E7\00E3o-conte\00FAdo do documento de impress\00E3o. A disposi\00E7\00E3o-conte\00FAdo \00E9 uma extens\00E3o do protocolo MIME que orienta o browser sobre como exibir o documento. Selecionar <strong>Anexo</strong> orienta o browser a salvar um arquivo em disco em')
||' vez de exibi-lo em linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112335438311436)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107112485035311436)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Em Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107025280213311367)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Arquivo Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026144839311368)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a largura desta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107026056644311368)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385748696310850)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o do Form associada a esse item de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106385650594310850)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o de Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903001935311265)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione onde esta mensagem de erro do processo ser\00E1 exibida, quando o processo n\00E3o for conclu\00EDdo com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092952890311421)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em Linha com Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093087370311421)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A mensagem de erro do processo \00E9 exibida na \00E1rea de "Notifica\00E7\00E3o" (definida como parte do modelo de p\00E1gina)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093102815311421)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em P\00E1gina de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107093237395311421)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A mensagem de erro do processo \00E9 exibida na p\00E1gina de erro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902945335311265)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Local de Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566950735310993)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione em que ponto da renderiza\00E7\00E3o ou processamento de p\00E1gina esse processo ser\00E1 executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078534130311410)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370449284311630)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada ap\00F3s a renderiza\00E7\00E3o das regi\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078705137311411)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370600914311630)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada ap\00F3s a renderiza\00E7\00E3o da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078336627311410)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370206122311629)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada depois que a p\00E1gina \00E9 renderizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078932357311411)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370820321311630)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento: Executado ap\00F3s as valida\00E7\00F5es e c\00E1lculos serem executados, quando o processamento da p\00E1gina for executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078433396311410)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes das Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370337720311629)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada antes de as regi\00F5es serem renderizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078612793311410)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370554083311630)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada antes de o rodap\00E9 ser renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078228099311410)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370144446311629)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renderiza\00E7\00E3o: Executada antes de a p\00E1gina ser renderizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107079095708311411)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Ajax Callback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370945607311630)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Executado quando chamado pelas APIs de JavaScript do apex.server.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078112399311410)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370028550311629)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executado quando uma nova sess\00E3o \00E9 gerada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107078838219311411)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s a Submiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107370755062311630)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento: Executado depois que a p\00E1gina \00E9 enviada, mas antes de os c\00E1lculos, valida\00E7\00F5es e processos da p\00E1gina serem executados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106566856609310993)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ponto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903233452311265)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o a ser associada a este processo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903140229311265)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o Edit\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781578550311164)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um esquema de autoriza\00E7\00E3o para restringir quem pode salvar defini\00E7\00F5es de relat\00F3rio p\00FAblico.'),
unistr('		Para permitir que um usu\00E1rio final salve um relat\00F3rio p\00FAblico, esse esquema de autoriza\00E7\00E3o dever\00E1 ser avaliado como VERDADEIRO para esse usu\00E1rio.</p>'),
unistr('        <p>Note - Se nenhum esquema de autoriza\00E7\00E3o for fornecido, relat\00F3rios p\00FAblicos poder\00E3o ser salvos por qualquer usu\00E1rio.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106781497997311164)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Autoriza\00E7\00E3o do Relat\00F3rio P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151758591311465)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'$$$ DJP atualmente oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942406419311299)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Id de Consulta da Coluna do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574068606310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a primeira <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573962271310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574454742310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a segunda <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574375895310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574888885310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a terceira <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574711566310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575266612310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a quarta <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575179938310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575632628310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a quinta <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575540364310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576069421311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a sexta <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575996802311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576439770311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a s\00E9tima <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576320210311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576882458311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a oitava <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576713552311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577213165311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a nona <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577147230311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577691226311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o label para a d\00E9cima <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse label \00E9 o texto que o usu\00E1rio final do aplicativo v\00EA.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577553835311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573887448310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os atributos HTML associados \00E0 exibi\00E7\00E3o de cada link de <strong>Sele\00E7\00F5es R\00E1pidas</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573708624310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574260325310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 primeira <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574175089310998)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574616426310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 segunda <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574563546310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575059921310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 terceira <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106574970177310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575456342310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 quarta <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575347414310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575835047311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 quinta <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106575729206310999)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576285661311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 sexta <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576172740311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576617845311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 s\00E9tima <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576545801311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577090829311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 oitava <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106576953225311000)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577475745311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 nona <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577340322311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577820228311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor associado \00E0 d\00E9cima <strong>Sele\00E7\00E3o R\00E1pida</strong>. Esse valor substitui o valor do item existente quando o usu\00E1rio clica nessa sele\00E7\00E3o r\00E1pida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577719558311001)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915937798311275)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o n\00FAmero de colunas a serem exibidas para esta coluna de bot\00F5es de op\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915856590311275)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero de Colunas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647054197311052)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma lista separada por dois-pontos de Atribui\00E7\00F5es Din\00E2micas de Seguran\00E7a do Aplicativo Real, como:'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>O &PRODUCT_NAME. ativa essas atribui\00E7\00F5es no log-in, informando-as por meio do par\00E2metro <em>enable_dynamic_roles</em> de <em>sys.dbms_xs_sessions.assign_user</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646978394311052)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00F5es Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646811189311052)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como o Oracle Real Application Security (RAS) \00E9 usado neste aplicativo.</p>'),
unistr('<p>Se voc\00EA ativar o Modo RAS, certifique-se de que os usu\00E1rios t\00EAm privil\00E9gios para acessar os objetos do esquema do aplicativo.'),
unistr('Por exemplo, com <strong>Usu\00E1rios Externos</strong> voc\00EA pode conceder privil\00E9gios do banco de dados para uma <em>Atribui\00E7\00E3o Din\00E2mica de Aplicativo RAS</em> e configur\00E1-la neste esquema de autentica\00E7\00E3o como uma <em>Atribui\00E7\00E3o Din\00E2mica</em>.'),
unistr('Voc\00EA tamb\00E9m pode ativar as atribui\00E7\00F5es atrav\00E9s de uma chamada para <em>apex_authorization.enable_dynamic_groups</em>, como um procedimento de P\00F3s-Autentica\00E7\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080110644311412)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371020004311630)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Seguran\00E7a do Real Application n\00E3o \00E9 usada no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080292653311412)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Externos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371137981311630)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O &PRODUCT_NAME. presume que todos os usu\00E1rios s\00E3o internos e informa <em>falso</em> por meio do par\00E2metro <em>is_external</em> para <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107080385232311412)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios Internos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371246954311630)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O &PRODUCT_NAME. informa <em>verdadeiro</em> por meio do par\00E2metro <em>is_external</em> para <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646761618311052)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modo RAS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647204780311052)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma lista separada por dois-pontos de Modelos de Namespace de Seguran\00E7a do Aplicativo Real, como:'),
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>O &PRODUCT_NAME. ativa esses namespaces no log-in, informando-os por meio do par\00E2metro <em>namespaces</em> de <em>sys.dbms_xs_sessions.assign_user</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647195757311052)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Namespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296054166311576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296434700311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296336685311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296255717311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296590168311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296130500311576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295907976311576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298074928311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298398270311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298261182311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298152054311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298465916311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297973135311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584263705311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584184111311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585663510311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado nesta condi\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585558693311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297681805311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Java para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297593674311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299257914311579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Java que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299117498311579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297455937311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297356863311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o JavaScript para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297227176311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299094265311579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298948279311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o JavaScript que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298877137311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584430606311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista de valores separada por dois-pontos (:) para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584355273311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584810426311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o N\00FAmero da P\00E1gina para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584714844311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585053428311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a lista de N\00FAmeros de P\00E1ginas separada por v\00EDrgula para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584949325311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297134518311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297018204311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o PL/SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296988608311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298787156311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para um retorno bem-sucedido quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298641354311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o PL/SQL que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107298567236311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584694993311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Prefer\00EAncia de Usu\00E1rio que se compare ao valor especificado para essa condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584558925311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297848095311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o Python para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107297746858311578)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299447924311579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o Python que retorne um valor booliano para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107299350234311579)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296871223311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296767084311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Express\00E3o SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107296619712311577)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446350078311684)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar valores com sucesso quando uma ou mais linhas existirem ao verificar se o funcion\00E1rio est\00E1 no departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para retornar valores com sucesso quando n\00E3o existirem linhas ao verificar se o funcion\00E1rio est\00E1 no departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583849752311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583779428311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585279668311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor de texto para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585144951311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585835289311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585734585311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794775608311175)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um tipo de condi\00E7\00E3o que deve ser atendida para que este componente seja renderizado como somente leitura.'),
unistr('N\00E3o selecionar uma causa faz com que o item seja renderizado normalmente.'),
unistr('Um item somente leitura \00E9 renderizado com as mesmas defini\00E7\00F5es que um item Somente Exibi\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: defina o tipo de condi\00E7\00E3o como <strong>Nunca</strong> para sempre renderizar o item como um campo edit\00E1vel.'),
unistr('Essa defini\00E7\00E3o substitui qualquer defini\00E7\00E3o de condi\00E7\00E3o somente leitura em n\00EDvel de regi\00E3o ou p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198744541310694)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um tipo de condi\00E7\00E3o que deve ser atendida para que este componente seja renderizado como somente leitura.'),
unistr('N\00E3o selecionar uma causa faz com que o item seja renderizado normalmente.'),
unistr('Um item somente leitura \00E9 renderizado com as mesmas defini\00E7\00F5es que um item Somente Exibi\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: defina o tipo de condi\00E7\00E3o como <strong>Nunca</strong> para sempre renderizar o item como um campo edit\00E1vel.'),
unistr('Essa defini\00E7\00E3o substitui qualquer defini\00E7\00E3o de condi\00E7\00E3o somente leitura em n\00EDvel de regi\00E3o ou p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649645143311054)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um tipo de condi\00E7\00E3o que deve ser atendida para esta regi\00E3o renderizar itens de p\00E1gina como somente para leitura.'),
unistr('N\00E3o selecionar uma condi\00E7\00E3o far\00E1 com que os itens de p\00E1gina sejam renderizados normalmente.</p>'),
unistr('</p>Observa\00E7\00E3o: Se voc\00EA quiser que um item de p\00E1gina desta regi\00E3o (por exemplo, um campo de pesquisa) sempre seja renderizado como um item de p\00E1gina edit\00E1vel, independentemente de como esta condi\00E7\00E3o for avaliada, defina a condi\00E7\00E3o somente para leitur')
||unistr('a desse item de p\00E1gina como "Nunca" para substituir a defini\00E7\00E3o da regi\00E3o.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569522837310995)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um tipo de condi\00E7\00E3o da lista que deve ser atendida para que esta p\00E1gina renderize os itens de p\00E1gina como somente leitura. A falta de sele\00E7\00E3o de uma condi\00E7\00E3o far\00E1 com que os itens da p\00E1gina sejam renderizados normalmente.'),
unistr('A condi\00E7\00E3o somente leitura \00E9 avaliada ap\00F3s a execu\00E7\00E3o dos processos, com um ponto de processamento <em>Antes do Cabe\00E7alho</em>.</p>'),
unistr('<p>Observa\00E7\00E3o: se voc\00EA n\00E3o quiser que alguns itens da p\00E1gina (por exemplo, um campo de pesquisa) ou todos os itens da p\00E1gina de uma regi\00E3o espec\00EDfica sejam sempre renderizados como itens de p\00E1gina edit\00E1veis, independentemente de como esta condi\00E7\00E3o se')
||unistr('r\00E1 avaliada, defina a condi\00E7\00E3o somente leitura dessas regi\00F5es/itens de p\00E1gina como <strong>Nunca</strong> para substituir a defini\00E7\00E3o m\00E3e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138409785311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107277983439311563)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O componente sempre ser\00E1 renderizado como somente leitura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137084501311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Microsoft Internet Explorer 7.0 ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137143224311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 um browser compat\00EDvel com XHTML/CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136950051311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Mozilla, Netscape 6.x/7x ou uma vers\00E3o mais recente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137280238311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Browser do Cliente \00E9 Outros browsers (ou uma vers\00E3o mais antiga)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135640497311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137605435311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual = Valor'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281559559311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137308707311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281714116311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137543780311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma Atual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281645313311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o est\00E1 executando o aplicativo no idioma inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137409299311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Idioma Atual N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281868233311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento, o usu\00E1rio final n\00E3o est\00E1 executando o aplicativo em um dos idiomas inseridos no atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134840174311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual - P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280360153311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135090345311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida na lista delimitada por v\00EDrgula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280548953311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134939002311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280429053311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o \00E9 igual ao valor inserido na <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135158372311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual N\00C3O est\00E1 contida na lista delimitada por v\00EDrgulas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280661234311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o est\00E1 na lista separada por v\00EDrgulas inserida nas <em>P\00E1ginas</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137753902311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137843533311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136539909311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281318057311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha \00E9 exibido na p\00E1gina, ap\00F3s uma submiss\00E3o de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135985712311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135797386311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135832114311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O texto N\00C3O est\00E1 contido no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136006859311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Texto! = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132502935311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas retornadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278035567311563)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'A consulta SQL retorna uma ou mais linhas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295777263311576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107295837985311576)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A express\00E3o \00E9 avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132734929311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278242203311563)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O corpo da fun\00E7\00E3o retorna VERDADEIRO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138160401311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138225518311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136211082311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o N\00C3O \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281012625311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina e a regi\00E3o m\00E3e, se apropriado, ser\00E3o exibidas normalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136137091311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina/Regi\00E3o \00E9 Somente para Leitura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280962373311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina ou a regi\00E3o m\00E3e, se apropriada, tem a condi\00E7\00E3o ''Somente para Leitura'' avaliada como VERDADEIRA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134089229311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279575378311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o tem espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134372198311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279818571311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 alfanum\00E9rico, cont\00E9m s\00F3 letras ou n\00FAmeros e n\00E3o cont\00E9m caracteres especiais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133530387311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279052993311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134243511311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279797747311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133767191311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279266955311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133453285311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278918346311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133851025311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 NULO ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279308452311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 vazio ou \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134101347311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279657782311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133622280311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279133660311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133953941311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 NULO e N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279486273311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 vazio ou n\00E3o \00E9 zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136755571311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Avan\00E7ar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136826679311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios SQL (OK para mostrar o bot\00E3o Voltar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138353781311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281902878311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O componente \00E9 renderizado normalmente, independentemente da condi\00E7\00E3o somente leitura dos componentes pai.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136652928311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erros de Valida\00E7\00E3o em Linha N\00C3O exibidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281461982311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um erro de valida\00E7\00E3o em linha n\00E3o \00E9 exibido na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132679882311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Linha retornada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278114249311563)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta SQL n\00E3o retorna linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135455359311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina Atual est\00E1 contida no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280715236311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135573486311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina atual N\00C3O est\00E1 no Modo para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280887396311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina atual n\00E3o foi alternada para o ''Modo para Impress\00E3o'' pelo usu\00E1rio final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132846151311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278385167311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133012792311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278596132311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107132986574311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o != Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278452675311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133166876311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o N\00C3O est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278665987311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A solicita\00E7\00E3o de p\00E1gina n\00E3o est\00E1 contida no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107137943302311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107138091145311455)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'pt-br'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136312812311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 Autenticado (n\00E3o p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281104336311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107136414955311454)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio \00E9 o Usu\00E1rio P\00FAblico (o usu\00E1rio n\00E3o foi autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107281294966311566)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio final n\00E3o fez log-in no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134618657311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280176734311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134770788311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia do Usu\00E1rio! = Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280277878311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor da <em>Prefer\00EAncia</em> informado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134457374311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107279941411311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107134562921311452)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O est\00E1 contido na lista delimitada por dois-pontos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107280036917311565)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o est\00E1 completamente contido no texto inserido no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133276228311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278734953311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107133380633311451)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107278894447311564)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor do <em>Item</em> selecionado n\00E3o \00E9 igual ao texto informado no atributo <em>Value</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135301678311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual! = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107135241650311453)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina Atual = P\00E1gina Submetida (publicada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106569465616310995)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106584066146311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor para comparar \00E0 condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583987311311006)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585489535311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor, incluindo strings de substitui\00E7\00E3o de <code>&ITEM.</code>, para esta condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106585340571311007)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075643457311408)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578081347311001)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe os atributos inclu\00EDdos na tag da c\00E9lula da tabela HTML <code>&lt;td&gt;</code>, quando exibidos no modo somente leitura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106577986585311001)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atributos HTML Somente Leitura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862665851311233)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o intervalo em segundos entre as atualiza\00E7\00F5es de gr\00E1fico. Intervalos de atualiza\00E7\00E3o muito pequenos, como a cada 2 segundos, n\00E3o s\00E3o recomendados, pois pode causar s\00E9rios problemas de desempenho de banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862518541311233)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862754803311233)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590314469311010)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o na qual o bot\00E3o deve ser exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607630550311023)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198681252310694)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o na qual o item deve ser exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607519886311023)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Pai'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583235181311005)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o \00E0 qual este componente est\00E1 associado. Se o componente for exibido, ele ser\00E1 exibido na regi\00E3o especificada e em rela\00E7\00E3o a outros componentes dessa regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106583196427311005)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648418652311053)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique <strong>Ativado</strong> se quiser que esta regi\00E3o seja inclu\00EDda no Seletor de Exibi\00E7\00E3o de Regi\00E3o.'),
unistr('Esse atributo s\00F3 ser\00E1 utilizado se um tipo de regi\00E3o do <em>Seletor de Exibi\00E7\00E3o de Regi\00E3o</em> for definido e ficar vis\00EDvel na p\00E1gina.</p>'),
unistr('<p>Quando um usu\00E1rio clica no nome de uma regi\00E3o, inclu\00EDdo no Seletor de Exibi\00E7\00E3o de Regi\00E3o, somente a regi\00E3o selecionada \00E9 exibida e todas as outras regi\00F5es listadas ficam ocultas.'),
unistr('A primeira entrada do Seletor de Exibi\00E7\00E3o de Regi\00E3o \00E9 <em>Mostrar Tudo</em>, que permite ao usu\00E1rio mostrar todas as regi\00F5es dispon\00EDveis em vez de somente a regi\00E3o selecionada anteriormente.</p>'),
unistr('<p>Se uma regi\00E3o n\00E3o puder ser exibida, com base nas condi\00E7\00F5es da regi\00E3o, ela n\00E3o ser\00E1 inclu\00EDda nas listas de regi\00F5es do Seletor de Exibi\00E7\00E3o de Regi\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648399667311053)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Exibi\00E7\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649229872311053)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Fun\00E7\00E3o PL/SQL que retorne uma consulta SQL que ser\00E1 usada como base para esta regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649129200311053)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647497208311052)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a origem ou o conte\00FAdo da regi\00E3o, dependendo do <em>Tipo de Regi\00E3o</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647384683311052)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo HTML')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648603200311053)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma refer\00EAncia a uma imagem que ser\00E1 exibida no canto superior esquerdo da regi\00E3o. N\00E3o h\00E1 controle sobre a tag de tabela usada para exibir esta imagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648539153311053)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagem da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942696018311299)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a origem de texto deste componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942521297311299)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643734029311049)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a origem SQL deste componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106643617509311049)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106648017573311053)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um modelo de regi\00E3o para definir a apar\00EAncia e o layout dessa regi\00E3o.</p>'),
unistr('        <p>Os modelos de regi\00E3o s\00E3o definidos no tema do aplicativo.'),
unistr('        Quando uma regi\00E3o \00E9 criada, o modelo \00E9 definido automaticamente como modelo de regi\00E3o padr\00E3o definido no tema atual.</p>'),
unistr('        <p>Muitos temas cont\00EAm modelos de regi\00E3o para exibir relat\00F3rios, forms, alertas, bot\00F5es, conte\00FAdo contra\00EDvel (ocultar / mostrar), forms de log-in etc.<br>'),
unistr('        Tema Universal fornece os seguintes modelos de regi\00E3o:'),
'          <dl>',
'            <dt>Alerta</dt>',
'            <dt>Em Branco com Atributos</dt>',
unistr('            <dt>Cont\00EAiner de Bot\00F5es</dt>'),
unistr('            <dt>Cont\00EAiner de Carrossel</dt>'),
unistr('            <dt>Contra\00EDvel</dt>'),
unistr('            <dt>Bloco de Conte\00FAdo</dt>'),
'            <dt>Hero</dt>',
unistr('            <dt>Caixa de Di\00E1logo em Linha</dt>'),
'            <dt>Pop-up em Linha</dt>',
unistr('            <dt>Relat\00F3rio Interativo</dt>'),
'            <dt>Log-in</dt>',
unistr('            <dt>Padr\00E3o</dt>'),
unistr('            <dt>Cont\00EAiner de Guias</dt>'),
unistr('            <dt>Barra de T\00EDtulo</dt>'),
unistr('            <dt>Cont\00EAiner de Assistentes</dt>'),
'          </dl>',
unistr('          Consulte Tamb\00E9m: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicativo de Amostra de Tema Universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647992151311052)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106759607363311146)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique como esta regi\00E3o ser\00E1 renderizada. Os seguintes tipos de regi\00E3o s\00E3o suportados:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Dependendo da configura\00E7\00E3o do aplicativo, tamb\00E9m \00E9 poss\00EDvel ter plug-ins de tipo de regi\00E3o adicionais dispon\00EDveis aqui.'),
unistr('Estes s\00E3o exibidos como <em>&lt;My Plug-in&gt; [Plug-in]</em>.'),
unistr('Os seguintes plug-ins s\00E3o instalados nos componentes compartilhados deste aplicativo:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582585119311005)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021640610311365)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de igualdade a ser testada para esta valida\00E7\00E3o. Dependendo da sua sele\00E7\00E3o, um ou mais atributos adicionais ser\00E3o necess\00E1rios para definir completamente essa valida\00E7\00E3o.</p>'),
unistr('<p>Se a valida\00E7\00E3o passar no teste de igualdade ou for avaliada como VERDADEIRA, a mensagem de erro de valida\00E7\00E3o n\00E3o ser\00E1 exibida.'),
unistr('Mensagens de erro de valida\00E7\00E3o s\00E3o exibidas quando h\00E1 falha na valida\00E7\00E3o do teste de igualdade, quando a valida\00E7\00E3o \00E9 avaliada como FALSA ou quando uma string de texto n\00E3o vazia \00E9 retornada.</p>'),
unistr('<p>Uma falha de valida\00E7\00E3o n\00E3o interrompe a execu\00E7\00E3o das valida\00E7\00F5es subsequentes; portanto, cada valida\00E7\00E3o subsequente pode gerar uma mensagem de erro de valida\00E7\00E3o adicional. Se voc\00EA quiser interromper a execu\00E7\00E3o das valida\00E7\00F5es subsequentes, acrescent')
||unistr('e l\00F3gica \00E0 primeira valida\00E7\00E3o em que houve falha, definindo um item de p\00E1gina com um valor espec\00EDfico e, em seguida, refor\00E7ando a l\00F3gica condicional das valida\00E7\00F5es subsequentes, conforme necess\00E1rio. Os processos e ramifica\00E7\00F5es subsequentes n\00E3o ser\00E3o ')
||unistr('executados se houver falha na avalia\00E7\00E3o de uma ou mais valida\00E7\00F5es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122321539311443)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas retornadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122411546311443)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se a consulta SQL retornar uma ou mais linhas.<br>'),
unistr('Falhar\00E1 se a consulta SQL n\00E3o retornar linhas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329710789311600)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329874329311600)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se a express\00E3o for avaliada como VERDADEIRA.<br>'),
unistr('Falhar\00E1 se a express\00E3o for avaliada como FALSA.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122967188311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o (que retorna um valor booliano)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123020271311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o corpo da Fun\00E7\00E3o retornar VERDADEIRO.<br>'),
unistr('Falhar\00E1 se o corpo da Fun\00E7\00E3o retornar FALSO.<br>'),
unistr('Observa\00E7\00E3o: O resultado retornado pela fun\00E7\00E3o deve ser um valor booliano.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123154746311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o (que retorna um Texto de Erro)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123217179311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o corpo da Fun\00E7\00E3o retornar uma string vazia.<br>'),
unistr('Falhar\00E1 se o corpo da Fun\00E7\00E3o retornar uma string n\00E3o vazia. A string retornada \00E9 exibida como a mensagem de erro para a valida\00E7\00E3o.<br>'),
unistr('Observa\00E7\00E3o: O resultado retornado pela fun\00E7\00E3o deve ser uma string de texto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123982711311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124002945311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna n\00E3o contiver espa\00E7os.<br>'),
unistr('Falhar\00E1 se o valor Coluna contiver espa\00E7os.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125923915311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna cont\00E9m pelo menos um dos caracteres no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126020958311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna incluir pelo menos um caractere do texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o incluir caracteres do texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126130639311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna N\00C3O cont\00E9m nenhum dos caracteres no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126221706311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna n\00E3o incluir caracteres do texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna incluir pelo menos um caractere do texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125762178311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna cont\00E9m somente caracteres especificados no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125810021311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna contiver somente caracteres encontrados no texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna contiver qualquer caractere que n\00E3o esteja no texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124906894311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125092686311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna for igual ao texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o for igual ao texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125392253311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125465510311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna estiver completamente contido no texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o estiver totalmente contido no texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125188557311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125218928311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna n\00E3o for igual ao texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o for igual ao texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125504220311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna N\00C3O est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107125631585311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna n\00E3o estiver completamente contido no texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Coluna estiver totalmente contido no texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124183057311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna \00E9 alfanum\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124202704311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna for alfanum\00E9rico, contendo apenas letras e n\00FAmeros e nenhum caractere especial.<br>'),
unistr('Falhar\00E1 se o valor Coluna tiver caracteres especiais.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124583817311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna \00E9 uma data v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124639604311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna for uma data v\00E1lida.<br>'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o for uma data v\00E1lida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124326575311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna \00E9 num\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124415589311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna for num\00E9rico.<br>'),
unistr('Falhar\00E1 se o valor Coluna contiver caracteres n\00E3o num\00E9ricos, incluindo espa\00E7os, com exce\00E7\00E3o de espa\00E7os \00E0 esquerda.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124735169311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna \00E9 um timestamp v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107124805145311445)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna for um timestamp v\00E1lido.<br>'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o for um timestamp v\00E1lido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123320110311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna N\00C3O \00C9 NULA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123471728311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informa se o valor Coluna n\00E3o est\00E1 vazio.<br>'),
'Falha se o valor Coluna estiver vazio.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123578732311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna N\00C3O \00C9 NULA ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123621256311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna n\00E3o estiver vazio e n\00E3o for o n\00FAmero zero.<br>'),
unistr('Falhar\00E1 se o valor Coluna estiver vazio ou for o n\00FAmero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123795994311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Coluna N\00C3O \00E9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107123833912311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna n\00E3o for o n\00FAmero zero.<br>'),
unistr('Falhar\00E1 se o valor Coluna for o n\00FAmero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122520093311443)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Linha retornada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122690713311443)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se a consulta SQL n\00E3o retornar linhas.<br>'),
unistr('Falhar\00E1 se a consulta SQL retornar uma ou mais linhas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122772165311443)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122844131311444)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o c\00F3digo PL/SQL for executado sem gerar erro.<br>'),
unistr('Falhar\00E1 se a express\00E3o PL/SQL gerar erro ao ser executada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126365262311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna corresponde \00E0 Express\00E3o Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107126494877311446)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Coluna corresponder \00E0 express\00E3o regular inserida no atributo <em>Value</em>.'),
unistr('Falhar\00E1 se o valor Coluna n\00E3o corresponder \00E0 express\00E3o regular inserida no atributo <em>Value</em>.<br>'),
unistr('Observa\00E7\00E3o: as express\00F5es regulares permitem a voc\00EA pesquisar padr\00F5es nos dados de string usando conven\00E7\00F5es de sintaxe padronizadas, em vez de apenas compara\00E7\00F5es de caracteres.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021539913311365)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022254529311365)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um nome de coluna que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas para esta valida\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de colunas dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022163879311365)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331662390311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332041278311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331918079311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331806932311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332133061311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331779545311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331511952311602)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333626265311603)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333925761311603)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333864678311603)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333720402311603)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334004822311603)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333562787311603)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330033750311601)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330306131311601)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330249254311601)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330187890311601)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330422794311601)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329971114311601)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333248191311603)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Java para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333167440311603)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334852810311604)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334751175311604)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331200130311601)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331111017311601)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333048524311603)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332942278311603)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o JavaScript para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332816932311603)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334613091311604)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334524860311604)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334484526311604)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331016744311601)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar a mensagem de erro especificada, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330943739311601)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330855750311601)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446129750311684)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar o erro especificado, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022029225311365)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o PL/SQL que gere um erro como base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021965354311365)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL que gera o Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332725652311602)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332659765311602)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o PL/SQL para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332514989311602)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334375973311604)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334217866311604)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334196243311604)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330703154311601)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar a mensagem de erro especificada, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330635251311601)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107330566564311601)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333409287311603)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Python para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107333329079311603)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335033580311604)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107334966312311604)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331416548311602)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107331337904311602)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022692037311365)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o regular usada para corresponder \00E0 coluna especificada para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022514214311365)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332488897311602)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio for um gerente ou o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332308191311602)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o SQL para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107332213328311602)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107446096785311683)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Em <strong>Linhas Retornadas</strong>, para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Em <strong>Nenhuma Linha Retornada</strong, para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021866832311365)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL para definir esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021742520311365)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022436575311365)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor usado para comparar ao valor da coluna especificada para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107022309360311365)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036097779311375)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376658419311634)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Herda a defini\00E7\00E3o estabelecida no aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035941456311375)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use este atributo para controlar se o &PRODUCT_NAME. deve suportar URLs do aplicativo que n\00E3o cont\00EAm IDs de sess\00E3o.'),
unistr('Quando a op\00E7\00E3o entrar novamente nas sess\00F5es for ativada, o &PRODUCT_NAME. tentar\00E1 usar o cookie da sess\00E3o para entrar em uma sess\00E3o existente, quando um URL n\00E3o contiver um ID da sess\00E3o.'),
'</p>',
unistr('<p>Uma defini\00E7\00E3o no n\00EDvel da inst\00E2ncia mais restritivo substitui este valor no n\00EDvel da p\00E1gina.'),
'</p>',
unistr('<p><em><strong>Observa\00E7\00E3o:</em></strong> Permitir entrar novamente nas sess\00F5es exp\00F5e o seu aplicativo a poss\00EDveis viola\00E7\00F5es de seguran\00E7a, '),
unistr('pois ela pode permitir que hackers controlem as sess\00F5es existentes de um usu\00E1rio final. '),
unistr('Para obter mais informa\00E7\00F5es, consulte as se\00E7\00F5es <em>Entrar Novamente nas Sess\00F5es</em> em "Managing Application Security" no Application Builder User''s Guide.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117519668311440)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117644745311440)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se o URL n\00E3o contiver um ID da sess\00E3o, o &PRODUCT_NAME. criar\00E1 uma nova sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117781399311440)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativado para Sess\00F5es P\00FAblicas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117887907311440)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se o URL for para uma p\00E1gina p\00FAblica e n\00E3o contiver um ID da sess\00E3o, o &PRODUCT_NAME. tentar\00E1 utilizar o cookie da sess\00E3o existente para esse aplicativo.'),
unistr('Para aplicativos com p\00E1ginas p\00FAblicas e autenticadas, um ID de sess\00E3o ser\00E1 definido depois que o usu\00E1rio final for autenticado.'),
unistr('O &PRODUCT_NAME. realiza jun\00E7\00F5es por meio do cookie, quando a sess\00E3o ainda n\00E3o tiver sido autenticada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107117947086311440)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ativado para Todas as Sess\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118057228311440)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se o URL n\00E3o contiver uma sess\00E3o, o ID &PRODUCT_NAME. tenta utilizar o cookie da sess\00E3o existente estabelecido para esse aplicativo, desde que as seguintes condi\00E7\00F5es sejam atendidas:</p>'),
'<p><ul>',
unistr('  <li>A Prote\00E7\00E3o de Estado de Sess\00E3o esteja ativada para o aplicativo e o URL inclua uma checksum v\00E1lida.'),
unistr('    Para marca\00E7\00F5es p\00FAblicas, a prote\00E7\00E3o em n\00EDvel de item mais restritiva deve ser <em>Irrestrito</em> ou <em>Checksum Obrigat\00F3ria - N\00EDvel do Aplicativo</em>.</li>'),
unistr('  <li>OU, o URL n\00E3o contenha payload (um par\00E2metro de solicita\00E7\00E3o, cache limpo ou pares de valores de dados).</li>'),
'</ul></p>',
unistr('<p>Esta defini\00E7\00E3o tamb\00E9m exige que <em>Incorporar em Quadros</em> seja definido como <em>Permitir da mesma origem</em> ou como <em>Negar</em> para o aplicativo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035812749311375)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrar Novamente nas Sess\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963910953311317)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione esta op\00E7\00E3o quando a p\00E1gina tiver de ser recarregada ap\00F3s uma submiss\00E3o de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964056897311317)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964165036311317)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sempre recarregar a p\00E1gina para exibir os erros e a mensagem de opera\00E7\00E3o bem-sucedida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964273819311317)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'pt-br'
,p_message_text=>'Apenas em Caso de Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106964379884311317)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar erros dinamicamente sem recarregar a p\00E1gina, mas recarreg\00E1-la ap\00F3s um processamento bem-sucedido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106963858724311317)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Recarregar ao Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345319738311612)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345492794311612)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados n\00E3o s\00E3o armazenados no cache e sempre s\00E3o solicitados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218052624311516)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218163334311516)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados n\00E3o s\00E3o armazenados no cache e sempre s\00E3o solicitados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655417418311058)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655530278311058)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O resultado n\00E3o \00E9 armazenado no cache. Os dados s\00E3o extra\00EDdos do banco de dados remoto de cada solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653643605311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selecione como o mecanismo do &PRODUCT_NAME. pode armazenar no cache os dados local.',
unistr('        Se armazenamento no cache puder ser usado, o componente ser\00E1 renderizado com base nos resultados armazenados no cache, em vez de extra\00EDdos do banco de dados remoto.'),
unistr('        Os resultados armazenados no cache aumentar\00E3o muito o desempenho, principalmente se houver lat\00EAncia entre o banco de dados local e remoto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653752261311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para Todos os Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653855326311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O resultado \00E9 armazenado no cache e utilizados por todos os usu\00E1rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654181249311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654263890311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O resultado \00E9 armazenado no cache especificamente para cada sess\00E3o do usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653973929311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654036672311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O resultado \00E9 armazenado no cache especificamente para cada usu\00E1rio nas sess\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653514266311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Armazenamento no Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654507360311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Expira os dados 15 minutos depois que eles forem armazenados no cache</dt>',
'  <dd><pre>15</pre></dd>',
unistr('<dt>Expira os dados no in\00EDcio da hora</dt>'),
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
unistr('<dt>Expira os dados \00E0 meia-noite</dt>'),
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654403520311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe quando os dados armazenados no cache devem ser invalidados.',
unistr('        Forne\00E7a o valor de minutos ou uma String de Calend\00E1rio DBMS_SCHEDULER.</p>'),
unistr('        <p>Para a String do Calend\00E1rio DBMS_SCHEDULER \00E9 necess\00E1rio definir se esses dados armazenados no cache s\00E3o invalidados no in\00EDcio da hora, \00E0 meia-noite ou em outro per\00EDodo espec\00EDfico recorrente.'),
unistr('        Consulte a documenta\00E7\00E3o em DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING para obter mais detalhes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654354510311057)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Timeout de Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891540710311256)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe um alias alfanum\00E9rico para esta regi\00E3o do relat\00F3rio interativo.'),
'O alias deve ser exclusivo no aplicativo.',
unistr('Voc\00EA pode usar um alias para fazer refer\00EAncia a uma regi\00E3o do relat\00F3rio interativo na chamada de API personalizada.'),
unistr('Por exemplo, voc\00EA pode gravar uma fun\00E7\00E3o para retornar o <code>INTERACTIVE_REPORT_ID</code> consultando a coluna <code>ALIAS</code> na view <code>APEX_APPLICATION_PAGE_IR</code>.'),
unistr('Como o valor <code>INTERACTIVE_REPORT_ID</code> pode ser alterado ao exportar ou importar o aplicativo para outras inst\00E2ncias, talvez seja prefer\00EDvel referenciar regi\00F5es do relat\00F3rio interativo usando um alias.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891465666311255)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alias da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106885033824311250)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione as restri\00E7\00F5es de data da lista de valores.'),
unistr('Para as colunas de data, a lista de valores pode exibir o passado, futuro ou ambos no filtro da lista drop-down da coluna do relat\00F3rio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088215817311418)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088429718311418)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Futuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107088390949311418)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'pt-br'
,p_message_text=>'Passado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106884955993311250)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Faixas de Datas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891757281311256)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione um item de p\00E1gina ou de aplicativo cujo valor armazenar\00E1 o ID de relat\00F3rio salvo.'),
unistr('O relat\00F3rio interativo utiliza este item de valor para estabelecer um v\00EDnculo com um relat\00F3rio salvo.'),
unistr('Por exemplo, voc\00EA pode definir uma lista de relat\00F3rios salvos contendo links com um nome de item definido e um ID de relat\00F3rio salvo como seu valor para vincula\00E7\00E3o com relat\00F3rios padr\00E3o salvos, al\00E9m de relat\00F3rios p\00FAblicos ou privados.'),
unistr('Os IDs de relat\00F3rios salvos podem ser recuperados da view <code>APEX_APPLICATION_PAGE_IR_RPT</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106891684997311256)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item do ID de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032774593311373)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layout de Relat\00F3rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033306044311373)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layout de Relat\00F3rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032396413311373)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o layout do relat\00F3rio a ser utilizado ao imprimir o relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107032293922311373)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Layout'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922634151311280)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um modelo de relat\00F3rio predefinido para controlar a exibi\00E7\00E3o deste relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101839734311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTML (padr\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101978442311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria uma tabela HTML padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102053055311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Vertical')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102135403311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Mostra cada coluna em uma linha separada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102245785311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'pt-br'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102393431311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta o relat\00F3rio como um arquivo CSV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102414411311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'pt-br'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107102561990311428)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exporta o relat\00F3rio como um arquivo XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922506216311280)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924837870311281)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto exibido ao lado dos valores da soma do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924761516311281)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label de Soma do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918189673311276)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um modelo de relat\00F3rio para definir a apar\00EAncia e o layout desse relat\00F3rio cl\00E1ssico.</p>'),
unistr('        <p>Os modelos de relat\00F3rio s\00E3o definidos no tema do aplicativo.'),
unistr('        Quando um relat\00F3rio cl\00E1ssico \00E9 criado, o modelo \00E9 automaticamente definido para o modelo de relat\00F3rio padr\00E3o definido no tema atual.</p>'),
unistr('        <p>Muitos temas cont\00EAm modelos de relat\00F3rio cl\00E1ssico para exibir dados em uma tabela, pares de valor de chave, resultados de pesquisa, cart\00F5es e assim por diante.'),
unistr('        Observe que alguns modelos de relat\00F3rio, como cart\00F5es e resultados de pesquisa, s\00E3o "baseados em linha" e esperam que sua consulta SQL retorne um determinado conjunto de aliases de coluna que s\00E3o substitu\00EDdos no modelo.<br>'),
unistr('        O Universal Theme fornece os seguintes modelos de relat\00F3rio:'),
'          <dl>',
'            <dt>Alertas</dt>',
unistr('              <dd>Exibe qualquer n\00FAmero de alertas ou notifica\00E7\00F5es horizontais na sua p\00E1gina.</dd>'),
'            <dt>Lista de Emblemas</dt>',
unistr('              <dd>Exibe pares de valor de chave em uma interface de usu\00E1rio semelhante a painel de controle.</dd>'),
unistr('            <dt>Cart\00F5es</dt>'),
unistr('              <dd>Exibe dados de relat\00F3rio em cart\00F5es, ou pequenos blocos, e \00E9 \00FAtil para apresentar uma variedade de informa\00E7\00F5es. Os cart\00F5es podem ser altamente personalizados via Op\00E7\00F5es de Modelos.</dd>'),
unistr('            <dt>Coment\00E1rios</dt>'),
unistr('              <dd>Exibe coment\00E1rios e outras mensagens.</dd>'),
'            <dt>Resultados da Pesquisa</dt>',
'              <dd>Exibe resultados de pesquisa no estilo de mecanismo de busca</dd>',
unistr('            <dt>Padr\00E3o</dt>'),
unistr('              <dd>Este \00E9 o modelo de relat\00F3rio padr\00E3o para exibir dados em uma tabela e pode ser altamente personalizado via Op\00E7\00F5es de Modelo.</dd>'),
'            <dt>Linha do Tempo</dt>',
unistr('              <dd>Exibe uma linha do tempo de a\00E7\00F5es. \00C9 bem adequada para home pages, logs de altera\00E7\00E3o e outras \00E1reas nas quais \00E9 necess\00E1rio um feed de atividades de a\00E7\00F5es recentes.</dd>'),
'            <dt>Pares de Atributos de Valor- Coluna</dt>',
unistr('              <dd>Exibe pares de valores chave para consultas baseadas em colunas. Usa o cabe\00E7alho da coluna como o label de cada item.</dd>'),
'            <dt>Pares de Atributos de Valor - Linha</dt>',
'              <dd>Exibe pares de valores chave para consultas baseadas em linhas. Usa a primeira coluna para labels e a segunda coluna para valores.</dd>',
'          </dl>',
unistr('          Consulte Tamb\00E9m: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Amostra de Aplicativo do Universal Theme</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918011335311276)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779906865311163)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a grade interativa ser\00E1 impedida de exibir dados, a menos que pelo menos um filtro seja definido em uma das colunas do relat\00F3rio.'),
unistr('		Esta op\00E7\00E3o \00E9 designada para limitar os dados carregados de um conjunto de dados muito grande, restringindo as linhas retornadas com base em um filtro.</p>'),
unistr('		<p>Colunas individuais podem ter a op\00E7\00E3o <strong>Filtro de Coluna Obrigat\00F3rio</strong> ativada, garantindo que um filtro seja obrigat\00F3rio para essa coluna; al\00E9m disso, esta op\00E7\00E3o s\00F3 requer um filtro para todas as colunas.</p>'),
unistr('		<p> Observa\00E7\00E3o - Quando esta op\00E7\00E3o est\00E1 definida e n\00E3o h\00E1 filtros definidos no momento, uma mensagem \00E9 exibida solicitando que os usu\00E1rios informem um filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779848652311162)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Requer Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106936002558311289)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Todos os caracteres podem ser salvos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578816213311002)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como restringir os caracteres que podem ser salvos no estado de sess\00E3o.'),
unistr('O &PRODUCT_NAME. exibir\00E1 uma mensagem de erro se um usu\00E1rio tentar salvar dados que n\00E3o que n\00E3o estejam em conformidade com a restri\00E7\00E3o de caracteres selecionada.</p>'),
unistr('<p>Restringir os caracteres refor\00E7a a seguran\00E7a do aplicativo e \00E9 uma medida poss\00EDvel contra ataques de cross-site scripting (XSS).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077123155311409)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de bloqueios &<>"/;,*|=% e --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077254284311409)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os caracteres a seguir: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % e "--" (coment\00E1rio PL/SQL) N\00C3O podem ser salvos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077347258311410)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de bloqueios &<>"/;,*|=% ou -- e nova linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077434729311410)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os seguintes caracteres: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, %, "--", e caracteres de nova linha N\00C3O podem ser salvos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076745052311409)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de permiss\00F5es para a-Z, 0-9 e espa\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076864021311409)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente caracteres a-z, A-Z, 0-9 e espa\00E7o podem ser salvos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076903596311409)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Caracteres de comando HTML da lista de bloqueios (<>")'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077074314311409)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caracteres HTML reservados N\00C3O podem ser salvos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107077525207311410)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578720499311002)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Caracteres Restritos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342988993311610)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o formato de entrada para o conte\00FAdo renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343061232311610)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'pt-br'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343142279311610)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conte\00FAdo cont\00E9m tags HTML e ser\00E1 renderizado sem a aplica\00E7\00E3o de escape de caracteres especiais. Verifique se os dados est\00E3o seguros e n\00E3o cont\00EAm dados informados pelo usu\00E1rio final para evitar vulnerabilidades de XSS (Cross-Side Scripting).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343261129311610)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remarca\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343316965311610)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conte\00FAdo cont\00E9m tags Markdown que ser\00E3o convertidas em tags HTML seguras antes da renderiza\00E7\00E3o. A convers\00E3o de tags Markdown conhecidas <strong>impedir\00E1</strong> vulnerabilidades de XSS (Cross-Side Scripting).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107342891686311610)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779187376311162)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna que armazenar\00E1 o n\00FAmero da vers\00E3o da linha para a tabela que est\00E1 sendo atualizada. Essa coluna ser\00E1 usada na verifica\00E7\00E3o de atualiza\00E7\00F5es perdidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779006697311162)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Vers\00E3o da Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902710393311264)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a frequ\00EAncia com que esse processo \00E9 executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092839402311421)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma Vez Por Visita \00E0 P\00E1gina (padr\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107092749397311421)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma Vez Por Sess\00E3o ou Quando Redefinido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902646035311264)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888528637311253)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione um esquema de autoriza\00E7\00E3o para restringir quem pode salvar defini\00E7\00F5es de relat\00F3rio p\00FAblico.'),
unistr('Para permitir que um usu\00E1rio final salve um relat\00F3rio p\00FAblico, esse esquema de autoriza\00E7\00E3o deve ser avaliado como VERDADEIRO.'),
unistr('Se nenhum esquema de autoriza\00E7\00E3o for fornecido, os relat\00F3rios poder\00E3o ser salvos por qualquer usu\00E1rio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888476470311253)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Autoriza\00E7\00E3o do Relat\00F3rio P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660943925311062)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se os valores no estado da sess\00E3o ser\00E3o salvos no banco de dados antes da execu\00E7\00E3o da ramifica\00E7\00E3o.'),
unistr('\00C9 importante definir esse atributo como <strong>Ativado</strong> se voc\00EA estiver navegando para um aplicativo diferente que precise acessar os valores de estado da sess\00E3o usando esse aplicativo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660828896311062)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar Estado antes de Ramificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647805340311052)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o item da p\00E1gina ou do aplicativo a ser usado como o esquema de parse de substitui\00E7\00E3o. Somente para aplicativos internos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647739193311052)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de Substitui\00E7\00E3o de Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267746743311556)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267620268311556)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266971778311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Selecione como esse esquema de autoriza\00E7\00E3o ser\00E1 aplicado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267071115311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267118860311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A autoriza\00E7\00E3o \00E9 aprovada quando a consulta retorna um valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267499702311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o PL/SQL que Retorna Booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267513295311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um Corpo de Fun\00E7\00E3o PL/SQL que retorne um valor booliano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267230533311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL N\00C3O Existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267382459311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A autoriza\00E7\00E3o \00E9 aprovada quando a query n\00E3o retorna valores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107266808275311556)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888786226311253)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto para o label do bot\00E3o de pesquisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888646637311253)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label do Bot\00E3o Pesquisar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250369347311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se este componente ser\00E1 exibido usando uma coluna ou formata\00E7\00E3o avan\00E7ada com o uso de express\00F5es HTML e strings de substitui\00E7\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250258151311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250528473311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como corpo secund\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250463978311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107251071180311542)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250965553311542)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250893067311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250728746311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>&COLUMN.</code> para mostrar valores de coluna em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107250676711311541)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646623677311052)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique <strong>Ativado</strong> para permitir que o cookie de gerenciamento de sess\00E3o seja enviado do browser apenas quando o protocolo for HTTPS.'),
unistr('Selecione <strong>Desativado</strong> para permitir que o cookie de gerenciamento de sess\00E3o seja enviado do browser quando o protocolo for HTTP ou HTTPS.</p>'),
unistr('<p>Se a SSL estiver configurada no seu servidor web, selecione <strong>Ativado</strong> para fortalecer a seguran\00E7a do seu aplicativo impedindo tr\00E1fego HTTP decriptografado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106646548486311051)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803161035311186)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique se a primeira linha deve ser selecionada automaticamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803019842311186)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Primeira Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943292131311300)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Gr\00E1fico de S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837787745311214)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome da coluna a ser usada para definir a consulta din\00E2mica multiss\00E9rie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106837658563311214)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome da S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578281300311002)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um n\00EDvel de Prote\00E7\00E3o de Estado de Sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075993800311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076019955311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item pode ser definido especificando-se o item em um URL que inclua uma checksum espec\00EDfica para o espa\00E7o de trabalho e o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076506391311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Restrito - N\00E3o pode ser definido no browser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076617658311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O item n\00E3o pode ser alterado usando o URL ou POSTDATA.'),
unistr('Selecione esta op\00E7\00E3o para restringir o que pode definir o valor do item para os processos internos, c\00E1lculos e assim por diante.'),
unistr('Este atributo s\00F3 se aplica aos itens que n\00E3o s\00E3o usados como itens de entrada de dados e \00E9 sempre observado, mesmo que a Prote\00E7\00E3o de Estado de Sess\00E3o esteja desativada.'),
unistr('Use este atributo para itens da p\00E1gina ou do aplicativo que t\00EAm os seguintes tipos <strong>Exibir Como</strong>:'),
'<ul>',
unistr('  <li>Exibir Apenas (Salvar Estado=N\00E3o)</li>'),
unistr('  <li>Campo de Texto (Desativado, n\00E3o salva o estado)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075737513311408)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Irrestrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075877553311408)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item pode ser definido especificando-se o item em um URL ou em um form. Nenhuma checksum \00E9 necess\00E1ria no URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076128196311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076267520311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item pode ser definido especificando-se o item em um URL que inclua uma checksum espec\00EDfica para o espa\00E7o de trabalho, o aplicativo e o usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076338301311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Checksum Obrigat\00F3ria - N\00EDvel da Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107076496894311409)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item pode ser definido especificando-o em um URL que inclua uma checksum espec\00EDfica da sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106578112169311001)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prote\00E7\00E3o de Estado de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600112459311018)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o grupo de filtros ao qual esta caixa de sele\00E7\00E3o est\00E1 associada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600065869311018)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363416069311624)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107267808004311556)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363500187311625)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898981180311261)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o menu <em>A\00E7\00F5es</em> ser\00E1 inclu\00EDdo na Barra de Pesquisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898811590311261)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Incluir Menu de A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896138686311259)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir agregados para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896088638311259)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881841285311248)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esta coluna ser\00E1 exibida por padr\00E3o no relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106881774870311248)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar por Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896327262311259)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir gr\00E1ficos para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896230637311259)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895939520311259)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir colunas computacionais para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895827442311259)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895500561311259)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir quebras de controle para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895447678311259)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Quebra de Controle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600568232311018)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se ser\00E1 mostrado o label da faceta pr\00F3ximo ao(s) seu(s) valor(es) selecionado(s) na lista de facetas atuais. Oculte o label se o valor selecionado for autoexplicativo, por exemplo, o status de um pedido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106600430226311018)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Label para a Faceta Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898555177311261)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se uma linha drop down separada ser\00E1 inclu\00EDda na barra de pesquisa.'),
unistr('Voc\00EA n\00E3o deve selecionar esse atributo e <strong>Linhas por P\00E1gina</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898425123311261)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Linhas Por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897359837311260)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem fazer download do relat\00F3rio para um dos formatos de download especificados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897235705311260)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894739668311258)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir filtros para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894625651311258)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898348364311261)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se o Localizador drop down est\00E1 inclu\00EDdo no in\00EDcio do campo Pesquisa na barra de pesquisa.'),
unistr('O Localizador drop down \00E9 uma lista de colunas que permite aos usu\00E1rios limitar suas pesquisas a uma coluna espec\00EDfica.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898236865311261)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Localizador Drop Down'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896916116311260)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem utilizar consultas de flashback para este relat\00F3rio.</p>'),
unistr('<p>As consultas de flashback utilizam a Tecnologia de Flashback e a Recupera\00E7\00E3o Pontual de Banco de Dados Oracle para exibir dados como eram em um determinado momento anterior. Os usu\00E1rios podem apenas consultar esses dados, mas n\00E3o podem reverter al')
||unistr('tera\00E7\00F5es de dados. O ponto passado at\00E9 onde eles podem executar uma consulta de flashback com sucesso \00E9 determinado por quando os arquivos de redo log foram alternados pela \00FAltima vez no banco de dados Oracle, pois essa tecnologia utiliza o backup RM')
||'AN.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896898771311260)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896799245311260)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir detalhamentos do tipo Agrupar por para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896623136311260)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834595550311211)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o nome do grupo dever\00E1 ser exibido na dica de ferramenta renderizada no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834426095311211)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Nome do Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897557062311260)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem chamar a caixa di\00E1logo modal de ajuda incorporada para relat\00F3rios interativos.</p>'),
unistr('<p>A caixa de di\00E1logo de ajuda s\00F3 descreve as op\00E7\00F5es dispon\00EDveis para o usu\00E1rio atual.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897491549311260)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895715594311259)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir realces para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895662352311259)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219203176311517)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se esta camada est\00E1 sendo mostrada na legenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219121960311517)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896557933311259)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir configura\00E7\00F5es de inscri\00E7\00E3o para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106896434193311259)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887989642311253)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o texto que deseja exibir para colunas nulas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106887848600311253)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Valores Nulos como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196648047310692)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir detalhamentos de piv\00F4 para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196510872310692)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Piv\00F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573632950310998)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se as sele\00E7\00F5es r\00E1pidas ser\00E3o exibidas para este item da p\00E1gina.'),
unistr('As Sele\00E7\00F5es r\00E1pidas permitem aos usu\00E1rios selecionar valores predefinidos com apenas um clique, em vez de digitar o texto ou escolher em uma lista de op\00E7\00F5es dispon\00EDveis.</p>'),
unistr('<p>Especifique sele\00E7\00F5es r\00E1pidas quando houver um conjunto relativamente pequeno, discreto de valores de entrada <em>em comum</em>.'),
unistr('H\00E1 um m\00E1ximo de dez sele\00E7\00F5es r\00E1pidas que podem ser definidas para um item.'),
unistr('Esses aux\00EDlios ao usu\00E1rio s\00E3o especialmente \00FAteis quando definidos para um item que tem uma longa lista de sele\00E7\00E3o de valores dispon\00EDveis.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106573538435310998)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Sele\00E7\00F5es R\00E1pidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899159889311262)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a lista de sele\00E7\00E3o Relat\00F3rios ser\00E1 exibida na barra de pesquisa.</p>'),
unistr('<p>A lista de sele\00E7\00E3o Relat\00F3rios ser\00E1 exibida somente se um relat\00F3rio, diferente do relat\00F3rio prim\00E1rio, estiver acess\00EDvel ao usu\00E1rio.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106899054041311262)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de Sele\00E7\00E3o de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897185261311260)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os usu\00E1rios finais podem redefinir seus relat\00F3rios a partir do menu A\00E7\00F5es.</p>'),
unistr('<p>Redefinir o relat\00F3rio reverte todas as personaliza\00F5es feitas pelo usu\00E1rio, ou especificadas pelo URL de chamada, e exibe o Relat\00F3rio Prim\00E1rio.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106897029121311260)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895101557311258)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem alterar o n\00FAmero de linhas exibidas para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895018433311258)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898757387311261)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o campo de pesquisa ser\00E1 inclu\00EDdo na barra de pesquisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106898699924311261)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894984768311258)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem usar <strong>Selecione Colunas</strong> no menu A\00E7\00F5es para alterar as colunas exibidas neste relat\00F3rio. O usu\00E1rio pode selecionar (ou mostrar), desmarcar (ou ocultar) e reordenar v\00E1rias colunas usando esta op\00E7\00E3')
||'o.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106894886871311258)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834368869311211)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se o nome da s\00E9rie dever\00E1 ser exibido na dica de ferramenta no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106834238793311211)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Nome da S\00E9rie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895303047311259)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os usu\00E1rios finais podem definir as colunas de classifica\00E7\00E3o para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106895261951311258)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599516263311017)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se ser\00E1 mostrado o label do filtro ou apenas o valor no Chip de Sugest\00E3o. Oculte o label se o valor sugerido for autoexplicativo, por exemplo, o status de um pedido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599458438311017)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780999753311163)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se uma barra de ferramentas ser\00E1 exibida acima do relat\00F3rio. A barra de ferramentas poder\00E1 incluir as funcionalidade de pesquisa, tipo de relat\00F3rio, relat\00F3rios salvos, a\00E7\00F5es, altera\00E7\00E3o e redefini\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780870550311163)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780747555311163)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se a contagem total de linhas ser\00E1 exibida no rodap\00E9 do relat\00F3rio.<p/>'),
unistr('        <p>Observa\00E7\00E3o - Uma consulta adicional \00E9 realizada para obter a contagem total de linhas, o que pode prejudicar o desempenho, especialmente em conjuntos de dados muito grandes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106780603329311163)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Contagem Total de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916151045311275)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para o tipo de exibi\00E7\00E3o Caixa de Sele\00E7\00E3o Simples, informe um ou dois valores separados por v\00EDrgula.'),
unistr('O primeiro valor ser\00E1 submetido se a caixa de sele\00E7\00E3o for marcada. O segundo valor, se definido, ser\00E1 submetido se a caixa de sele\00E7\00E3o for desmarcada.'','),
'        p_examples           => q''~<dl>',
unistr('<dt>Submeta Sim quando marcada e N\00E3o quando desmarcada</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106916039651311275)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores da Caixa de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882468279311248)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe o label da coluna a ser usado na View de Uma Linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882383701311248)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924086104311281)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para colunas de relat\00F3rios que permitem classifica\00E7\00E3o de cabe\00E7alho de coluna, selecione como voc\00EA deseja que os registros com valores nulos sejam classificados em rela\00E7\00E3o aos registros com valores n\00E3o nulos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103682104311429)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103726502311429)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os registros com valor nulo s\00E3o exibidos antes de qualquer coluna com valores n\00E3o nulos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103858566311429)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107103997382311429)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os registros com valores n\00E3o nulos s\00E3o exibidos antes de qualquer coluna com um valor nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923982736311281)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197366266310693)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a lista de breadcrumbs associada a esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197267622310692)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429846142311672)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Insira o nome da coluna de banco de dados com distin\00E7\00E3o entre mai\00FAsculas/min\00FAsculas usada como a origem desta faceta.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107238209662311532)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Insira o nome da coluna de banco de dados com distin\00E7\00E3o entre mai\00FAsculas/min\00FAsculas usada como a origem desta faceta.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601546395311019)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Insira o nome da coluna de banco de dados com distin\00E7\00E3o entre mai\00FAsculas/min\00FAsculas usado como a origem deste filtro.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602657431311019)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Insira o nome da coluna de banco de dados com distin\00E7\00E3o entre mai\00FAsculas/min\00FAsculas usado como a origem deste filtro.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572487363310997)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome da coluna que distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas usada como a origem para este valor do item.</p>'),
unistr('<p>Esta coluna deve existir na tabela especificada no processo de extra\00E7\00E3o de linha incorporado definido nesta p\00E1gina.'),
unistr('\00C9 gerado um erro e a p\00E1gina n\00E3o \00E9 carregada, se o nome da coluna do banco de dados n\00E3o existir na tabela de refer\00EAncia.'),
unistr('Da mesma forma, se n\00E3o houver um processe de extra\00E7\00E3o de linha incorporado \00E9 definido e existir um item com um tipo de origem <strong>Coluna do Banco de Dados</strong>, ser\00E1 gerado um erro e a p\00E1gina n\00E3o ser\00E1 carregada ao tentar renderiz\00E1-la.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572301095310997)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310868707311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311265387311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311130518311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311062007311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311310057311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310929605311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107310724969311587)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008746522311354)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o associada a esta regi\00E3o de Pesquisa Facetada ou Filtro Inteligente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008609749311354)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o Filtrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312838422311588)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313194279311589)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313018654311589)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312905553311589)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313264386311589)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312758556311588)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572272531310997)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item da p\00E1gina ou do aplicativo usado como origem para o valor deste item.'),
unistr('\00C9 poss\00EDvel digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572199575310997)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341684386311609)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo Java a ser executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341548373311609)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312461824311588)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Java que gere um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312321293311588)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314047945311589)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313949638311589)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341465271311609)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Aumenta o sal\00E1rio em 3% para os funcion\00E1rios que est\00E3o qualificados para um aumento salarial:</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
unistr('    // placeholder para alguma l\00F3gica complicada calcular se o funcion\00E1rio precisa de um aumento'),
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341396586311609)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo JavaScript a ser executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341241408311609)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312288731311588)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER"? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312114818311588)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o JavaScript que gere um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312053915311588)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313858186311589)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313773857311589)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313647172311589)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197192749310692)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione a origem desta lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197048333310692)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654705721311058)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a localiza\00E7\00E3o dos dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654804989311058)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Banco de Dados Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654922738311058)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados do banco de dados local.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655037274311058)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Ativada REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655156334311058)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados de um banco de dados remoto, onde a conex\00E3o \00E9 definida usando SQL Ativada por REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765259382311150)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Origem REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107371895174311631)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o originados de um servi\00E7o Web RESTful definido usando Origens de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106654648526311057)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localiza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850482619311224)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista de itens de p\00E1gina separada por v\00EDrgula na p\00E1gina atual a ser definida no estado da sess\00E3o quando os dados do gr\00E1fico forem lidos em uma solicita\00E7\00E3o separada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107217986911311516)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista separada por v\00EDrgulas dos itens de p\00E1gina na p\00E1gina atual a ser definida no estado da sess\00E3o quando os dados do mapa forem extra\00EDdos com uma solicita\00E7\00E3o separada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647626273311052)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os itens da p\00E1gina ou do aplicativo a serem definidos no estado da sess\00E3o quando a regi\00E3o for atualizada por uma atualiza\00E7\00E3o de p\00E1gina parcial.'),
unistr('Para v\00E1rios itens, separe cada nome de item com uma v\00EDrgula.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista d itens dispon\00EDveis.'),
unistr('Se voc\00EA escolher na lista e j\00E1 houver texto digitado, ser\00E1 colocada uma v\00EDrgula no final do texto existente, seguida do nome do item retornado da lista.</p>'),
unistr('<p>A regi\00E3o pode ser atualizada com a atualiza\00E7\00E3o de p\00E1gina parcial, durante a pagina\00E7\00E3o, se <em>Ativar Atualiza\00E7\00E3o de P\00E1gina Parcial</em> estiver definido como <strong>Ativado</strong>) ou com a a\00E7\00E3o Atualizar em uma A\00E7\00E3o Din\00E2mica.</p>'),
unistr('Esses itens de p\00E1gina podem ser usados na <em>condi\00E7\00E3o where</em> da Consulta SQL de Origem da Regi\00E3o para restringir o resultado da consulta.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106647516539311052)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens de P\00E1gina a Submeter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341116757311609)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Aumenta o sal\00E1rio em 3% para os funcion\00E1rios que est\00E3o qualificados para um aumento salarial:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341078546311608)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo PL/SQL a ser executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340970815311608)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311914376311588)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311876932311588)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o PL/SQL que gere um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311799652311588)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313598604311589)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313463230311589)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107313341697311589)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377156198311634)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como p\00F3s-processar os dados da Origem REST recuperados no banco de dados local.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377610864311635)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377795667311635)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL, no qual a consulta SQL retornada transforma os dados recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377407726311635)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377530219311635)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe uma Consulta SQL para transformar os dados recuperados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377274802311634)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cl\00E1usulas Where/Order By')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377354021311634)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a cl\00E1usula where e/ou order by para restringir e ordenar os dados recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107377083631311634)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572661669310997)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a Prefer\00EAncia de Usu\00E1rio a ser usada como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572502179310997)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341870655311609)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o c\00F3digo Python a ser executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107341758757311609)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312664767311588)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Python que gere um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107312584510311588)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314293455311589)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107314198213311589)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571819485310996)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a Consulta SQL usada como origem para este valor do item. Se mais do que uma linha for retornada, o valor da primeira linha ser\00E1 usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571706910310996)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106572013941310997)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a Consulta SQL que retorna uma ou mais linhas a serem usadas como origem para este valor do item. Se o resultado contiver v\00E1rias linhas, o valor de cada linha ser\00E1 formado por um \00FAnico valor delimitado por dois-pontos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571920405310997)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321274151311594)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321505892311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321435173311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321363516311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321672545311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321178787311594)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322463846311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne uma Consulta SQL para a s\00E9rie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322310628311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322220741311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selecione as colunas EMPNO, ENAME e SAL e filtre todas as linhas com um SAL inferior a 3.000.</dt>',
'<dd><pre>',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322190063311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne uma Consulta SQL para a s\00E9rie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322070179311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653295470311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para mostrar as contrata\00E7\00F5es mais recentes primeiro e aquelas que n\00E3o foram contratadas por \00FAltimo. Se a data for igual, classifique-as pelo n\00FAmero do departamento.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653109641311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um ou mais nomes de coluna separados por v\00EDrgulas, incluindo diretivas, para definir a ordem na qual os registros s\00E3o recuperados.</p>'),
'        <p>As diretivas incluem:',
'          <ul>',
'            <li>ASC - Coluna de retorno em ordem crescente</li>',
'            <li>DESC - Coluna de retorno em ordem decrescente</li>',
'            <li>NULLS FIRST - Coluna de retorno sem valor antes desses valores</li>',
'            <li>NULLS LAST - Coluna de retorno com valores antes daqueles sem valores</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653050765311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Ordenar Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652461460311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o esquema que possui a tabela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652341101311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765827630311151)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma Fun\00E7\00E3o PL/SQL que retorne uma consulta SQL que ser\00E1 usada como base para esta regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765700795311151)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321903497311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Selecione as colunas EMPNO, ENAME e SAL e filtre todas as linhas com um SAL inferior a 3.000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321878025311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorna uma Consulta SQL para a s\00E9rie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107321764666311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322643078311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne uma Consulta SQL para a s\00E9rie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107322577421311595)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652613490311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652582102311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652063187311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como os dados s\00E3o consultados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765342513311151)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o retornando Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765401060311151)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o recuperados com base na Consulta SQL retornada executando um Corpo da Fun\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655279319311058)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655307598311058)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o recuperados com base em uma Consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652153349311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela/View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652253469311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados s\00E3o recuperados com base em uma tabela ou view.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651904103311055)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652956084311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>S\00F3 inclua aqueles funcion\00E1rios que tenham um gerente ou que sejam vendedores.</dt>'),
'<dd><pre>',
unistr('( MGR n\00E3o \00E9 nulo ou JOB = ''SALESMAN'' )'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652855108311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma condi\00E7\00E3o where de SQL v\00E1lida, usada para limitar os registros recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106652771019311056)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cl\00E1usula Where')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651883896311055)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o servidor de banco de dados remoto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651784396311055)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Servidor Remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340449926311608)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o c\00F3digo informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340772169311608)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340620541311608)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340532312311608)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340850958311608)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107340368617311608)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106966004678311318)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Para concatenar duas colunas:</dt>',
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>Inclua uma sele\00E7\00E3o interna:</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790372813311171)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106790214703311171)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311642189311588)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'               from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311571043311588)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o SQL que gere um valor usado como a origem para o valor deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107311433331311587)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220177857311517)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consulta retornando valores de longitude e latitude como colunas NUMBER:</p>',
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>Consulta que retorna a localiza\00E7\00E3o do cliente como coluna SDO_GEOMETRY:</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653462705311057)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a origem SQL deste componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106653344543311057)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571634579310996)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o valor est\00E1tico usado como origem para este valor do item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571557393310996)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571432351310996)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selecione o tipo de origem no qual se baseie o valor desse item.</p>',
unistr('<p>Observa\00E7\00E3o: Se a op\00E7\00E3o <strong>Origem: Usado</strong> estiver definida como <em>Apenas quando o valor atual em estado de sess\00E3o for nulo</em>, a origem n\00E3o ser\00E1 utilizada se um valor tiver sido definido no estado de sess\00E3o para este item.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074537977311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269819260311558)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como nulo, pois n\00E3o foi especificado um valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074796141311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269229087311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido para o valor de coluna inserido na <em>Coluna do Banco de Dados</em> que \00E9 recuperado de um processo de extra\00E7\00E3o de linha incorporado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290501609311572)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107290650766311573)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor que resulta da execu\00E7\00E3o da <em>Express\00E3o</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075039114311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269633568311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075146551311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269390570311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107075248436311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269747801311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor da <em>Prefer\00EAncia</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074897036311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL (retornar valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269483381311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como o primeiro valor retornado da <em>Consulta SQL</em> informada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074961547311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL (retornar valor separado por dois-pontos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269580718311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como um valor \00FAnico separado por v\00EDrgulas, que concatena cada valor de linha, retornado da <em>Consulta SQL</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074664189311408)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107269142784311557)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o texto inserido no <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571318225310996)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571278214310996)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o valor tem preced\00EAncia o valor do estado da sess\00E3o ou o valor de origem do item.</p>'),
unistr('<p>Para itens com o tipo de origem <strong>Coluna do Banco de Dados</strong>, selecione <strong>Sempre, substituindo qualquer valor existente em estado de sess\00E3o</strong>, a menos que n\00E3o deseje que a opera\00E7\00E3o de extra\00E7\00E3o de linha associada preencha ')
||unistr('o item se a p\00E1gina for ramificada de volta para ele.'),
unistr('Para outros tipos de origem, decida, com base na forma como a p\00E1gina \00E9 usada, se o valor de origem anterior deve ser exibido ou se o tipo de origem deve ser aplicado novamente para cada view de p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074330473311407)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sempre, substituindo qualquer valor existente em estado de sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107074418447311407)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apenas quando o valor atual em estado de sess\00E3o for nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106571123872310996)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Usado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765689377311151)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a Origem de Dados REST que suporta a extra\00E7\00E3o de um conjunto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106765567380311151)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Origem REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850262115311223)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em um gr\00E1fico de eixo Y duplo dividido, especifique a fra\00E7\00E3o do espa\00E7o a ser atribu\00EDdo ao subgr\00E1fico de eixo Y. Os valores v\00E1lidos s\00E3o n\00FAmeros entre 0 e 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850138775311223)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o do Divisor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849756619311223)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se a \00E1rea de plotagem dever\00E1 ser dividida em duas se\00E7\00F5es, de modo que os conjuntos de dados designados ao diferentes eixos Y sejam exibidos em diferentes partes da \00E1rea de plotagem. Os gr\00E1ficos de a\00E7\00F5es n\00E3o suportam a op\00E7\00E3o <strong>N\00E3o</s')
||'trong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849806411311223)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850043131311223)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849980788311223)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849639376311223)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826907267311205)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se os itens de dados ser\00E3o empilhados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106826813664311205)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Pilha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451024267310899)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o nome da categoria de pilha \00E0 qual esta s\00E9rie ser\00E1 designada. Por padr\00E3o, todas as s\00E9ries de um gr\00E1fico empilhado s\00E3o agrupadas na mesma pilha. Para agrupar esta s\00E9rie em uma pilha separada, defina uma categoria de pilha. Voc\00EA pode utili')
||unistr('zar substitui\00E7\00F5es <code>&COLUMN_VALUE.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450956942310898)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Categoria de Pilha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450861284310898)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Especifique se os valores totais dos itens de dados empilhados devem ser exibidos. S\00F3 se aplica a gr\00E1ficos de barras.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450778900310898)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Label de Pilha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551684415310981)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um conjunto de guias padr\00E3o a ser usado para esta p\00E1gina. Um conjunto de guias padr\00E3o \00E9 associado a um determinado n\00FAmero de p\00E1gina. Voc\00EA pode usar guias padr\00E3o para vincular usu\00E1rios a uma p\00E1gina espec\00EDfica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551573295310981)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949770175311305)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o primeiro dia da semana exibido no calend\00E1rio semanal.'),
unistr('Voc\00EA pode usar esse atributo em conjunto com <strong>Fim do Dia</strong> para restringir os dias da semana exibidos ou simplesmente determinar o primeiro dia da semana exibido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108558595311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'pt-br'
,p_message_text=>'Domingo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108666018311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'pt-br'
,p_message_text=>'Segunda-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108746940311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ter\00E7a-feira')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108816004311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quarta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108949717311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quinta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109098650311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sexta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109111050311433)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E1bado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949611774311305)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dia de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949546138311305)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determina o dia da semana em que o calend\00E1rio mensal inicia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107806731311432)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'pt-br'
,p_message_text=>'Domingo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107107909585311432)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'pt-br'
,p_message_text=>'Segunda-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108002476311432)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ter\00E7a-feira')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108104825311433)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quarta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108219691311433)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'pt-br'
,p_message_text=>'Quinta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108308974311433)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sexta-feira'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107108497597311433)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E1bado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106949486910311305)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dia de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950398293311306)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite a hora de in\00EDcio para focar a exibi\00E7\00E3o do calend\00E1rio semanal e di\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950290716311306)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106580048838311003)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o cont\00EAiner est\00E1tico, de um Seletor jQuery, a ser usado por esta a\00E7\00E3o din\00E2mica.'),
unistr('\00C9 poss\00EDvel melhorar o desempenho de a\00E7\00F5es din\00E2micas que t\00EAm um escopo de evento <strong>Din\00E2mico</strong>.'),
unistr('Este \00E9 um elemento da p\00E1gina que ele pr\00F3prio n\00E3o recria, mas cont\00E9m os elementos de acionamento que s\00E3o recriados por meio da Atualiza\00E7\00E3o de P\00E1gina Parcial (PPR).'),
unistr('Esta refer\00EAncia do elemento deve ser definida como um seletor jQuery.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579995612311003)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Container Est\00E1tico (Seletor jQuery)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590216329311010)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o ID do est\00E1tico para o bot\00E3o. Se definido, o ID est\00E1tico ser\00E1 usado como o ID do bot\00E3o. O ID est\00E1tica pode ser \00FAtil ao desenvolver o comportamento JavaScript personalizado para o bot\00E3o. Se o ID est\00E1tico n\00E3o for definido, o bot\00E3o gerar\00E1 um ID')
||' interno.</p>',
unistr('<p>Observa\00E7\00E3o: O modelo deve incluir a string de substitui\00E7\00E3o <code>#BUTTON_ID#</code> para que ele possa usar o ID est\00E1tico especificado.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106794445392311175)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o ID est\00E1tico da coluna. O ID est\00E1tico pode ser \00FAtil ao desenvolver o comportamento de JavaScript personalizado, ou o estilo personalizado da coluna. Se o ID est\00E1tico n\00E3o for definido, o ID interno ser\00E1 usado para o ID do item da coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471647953311702)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o ID est\00E1tico da coluna. Se definido, o ID est\00E1tico \00E9 usado como o ID da c\00E9lula TH (cabe\00E7alho de tabela) correspondente e como o valor HEADERS das c\00E9lulas TD (dados de tabela) correspondentes. O ID est\00E1tico pode ser \00FAtil ao desenvolver o comp')
||unistr('ortamento de JavaScript personalizado, ou o estilo personalizado da coluna. Se o ID est\00E1tico n\00E3o for definido, a tabela gerar\00E1 um ID interno para esses valores de atributo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850621818311224)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o ID est\00E1tico para o eixo do gr\00E1fico. O ID est\00E1tico poder\00E1 ser \00FAtil durante o desenvolvimento de um comportamento JavaScript personalizado para o eixo do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106850561453311224)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o ID est\00E1tico para a s\00E9rie do gr\00E1fico. O ID est\00E1tico poder\00E1 ser \00FAtil durante o desenvolvimento de um comportamento JavaScript personalizado para a s\00E9rie do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106649324465311053)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o ID est\00E1tico para esta regi\00E3o. Se definido, este ser\00E1 usado como o ID da regi\00E3o, usando a string de substitui\00E7\00E3o <code>#REGION_STATIC_ID#</code>, que pode ser \00FAtil ao desenvolver o comportamento JavaScript personalizado para a regi\00E3o. Se ')
||unistr('o ID n\00E3o for definido, a regi\00E3o gerar\00E1 um ID interno.</p>'),
unistr('<p>Observa\00E7\00E3o: O modelo deve incluir a string de substitui\00E7\00E3o <code>#REGION_STATIC_ID#</code> para que a regi\00E3o utilize o ID est\00E1tico especificado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579625446311003)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o ID est\00E1tico para esse componente. Se definido, esse ID poder\00E1 ser \00FAtil ao desenvolver um comportamento JavaScript personalizado para o componente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106579538440311003)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861938677311232)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de s\00E9rie a ser aplicado ao gr\00E1fico de a\00E7\00F5es renderizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862058109311232)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862121172311232)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862276150311233)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Casti\00E7al')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862396292311233)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106862475249311233)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861881499311232)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Renderizar Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582097944311004)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se o processamento de todas as outras a\00E7\00F5es pendentes ser\00E1 interrompido quando ocorrer um erro durante a execu\00E7\00E3o da a\00E7\00E3o atual.</p>'),
unistr('<p>Observa\00E7\00E3o: A ordem de execu\00E7\00E3o de a\00E7\00F5es espec\00EDficas \00E9 determinada pela sequ\00EAncia especificada para cada a\00E7\00E3o. Para garantir que as a\00E7\00F5es sejam executadas na mesma ordem, a Oracle recomenda que os n\00FAmeros da sequ\00EAncia sejam \00FAnicos para todas as A\00E7')
||unistr('\00F5es Verdadeiras e todas as A\00E7\00F5es Falsas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106581910358311004)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interromper Execu\00E7\00E3o no Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659238779311061)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Defini\00E7\00E3o de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659328622311061)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna usar\00E1 a Defini\00E7\00E3o de Relat\00F3rio <strong>Extens\00E3o</strong> para definir se a coluna deve ou n\00E3o ser estendida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658777660311060)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique se a coluna deve ser estendida se houver propriedades suficientes na tela. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659075765311061)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'pt-br'
,p_message_text=>'Sempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106659123700311061)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna sempre ser\00E1 estendida, n\00E3o importando a Defini\00E7\00E3o de Relat\00F3rio <strong>Extens\00E3o</strong> configurada pelo Usu\00E1rio Final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658806561311061)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658951353311061)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna n\00E3o ser\00E1 estendida e usar\00E1 sempre a largura especificada. Isso \00E9 \00FAtil para colunas com conte\00FAdo curto, como Sim/N\00E3o ou N\00FAmeros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658699801311060)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Extens\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923841822311281)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se as tags HTML ser\00E3o removidas dos valores de coluna originais.'),
unistr('Isso \00E9 particularmente importante para colunas que utilizam express\00F5es HTML, s\00E3o usadas em links de colunas ou s\00E3o exportadas para arquivos CSV.</p>'),
unistr('<p>Se voc\00EA selecionar a partir do banco de dados que j\00E1 cont\00E9m tags HTML, essas tags poder\00E3o causar conflitos com o HTML gerado para suas express\00F5es HTML ou o URL gerado para links de coluna.'),
unistr('Ao exportar esses valores, as tags HTML existentes s\00E3o inclu\00EDdas como texto sem formata\00E7\00E3o no arquivo CSV gerado.'),
unistr('Quando essa op\00E7\00E3o est\00E1 ativada, somente a parte de dados reais de valor da coluna \00E9 usada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106923780094311281)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Faixa HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779553450311162)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se deseja incluir as linhas selecionadas no processamento de p\00E1ginas, geralmente iniciadas por um bot\00E3o personalizado, como <strong>Marcar Conclu\00EDdos</strong>.'),
unistr('        Essas linhas selecionadas podem ser utilizadas em um processo personalizado para executar a a\00E7\00E3o necess\00E1ria.</p>'),
unistr('        <p>Observa\00E7\00E3o - As linhas selecionadas ser\00E3o processadas mesmo que nada tenha sido atualizado nelas. Em geral, apenas as linhas inseridas, atualizadas ou exclu\00EDdas s\00E3o processadas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106779452861311162)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento Inclui Linhas Selecionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644283138311050)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um aplicativo em cujo esquema de autentica\00E7\00E3o este esquema dever\00E1 se basear.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644164955311050)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Inscrito de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248519164311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se este componente ser\00E1 exibido usando uma coluna ou formata\00E7\00E3o avan\00E7ada com o uso de express\00F5es HTML e strings de substitui\00E7\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248452383311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248752950311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como subt\00EDtulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248675134311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249268302311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249124519311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107249018192311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248973242311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>&COLUMN.</code> para mostrar valores de coluna em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248867696311540)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106903398768311265)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Informe a mensagem de sucesso desse processo.',
unistr('Se o processo for executado e n\00E3o gerar um erro, essa mensagem de sucesso do processo ser\00E1 exibida na se\00E7\00E3o de notifica\00E7\00E3o da p\00E1gina resultante exibida.'),
unistr('Se voc\00EA estiver ramificando para a pr\00F3xima p\00E1gina por meio de um redirecionamento de URL, talvez seja necess\00E1rio verificar o atributo <em>preservar mensagem de sucesso</em>.</p>'','),
unistr('<p>Para processos com v\00E1rias linhas, a seguinte string de substitui\00E7\00E3o pode ser usada para obter o n\00FAmero de registros processados:</p>'),
'<ul>',
'  <li>Insert: <code>#MRI_COUNT#</code></li>',
'  <li>Update: <code>#MRU_COUNT#</code></li>',
'  <li>Delete: <code>#MRD_COUNT#</code></li>',
'</ul>',
unistr('<p>Para o tipo de processo Enviar E-Mail a string de substitui\00E7\00E3o <code>#TO#</code> pode ser usada para obter os endere\00E7os do e-mail.</p>'),
unistr('<p>Plug-ins tamb\00E9m podem ter outras strings de substitui\00E7\00E3o. Consulte a documenta\00E7\00E3o do Plug-in para obter detalhes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057774223311392)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o texto a ser exibido na \00E1rea "Notifica\00E7\00E3o" (definida como parte do modelo de p\00E1gina), quando esse processo for conclu\00EDdo com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106902885325311265)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599314486311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a Consulta SQL usada como a origem para as sugest\00F5es.</p>'),
unistr('<p>Observa\00E7\00E3o: A ordem na qual os valores s\00E3o retornados \00E9 usada para determinar a ordem na qual eles dever\00E3o ser exibidos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599229974311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599155200311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira uma lista de valores est\00E1ticos delimitados por v\00EDrgulas usados como a origem para as sugest\00F5es.</p>'),
unistr('<p>Observa\00E7\00E3o: A ordem na qual os valores s\00E3o especificados \00E9 usada para determinar a ordem em que eles dever\00E3o ser exibidos.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106599053266311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106601378812311018)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106602034832311019)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598318639311016)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como as sugest\00F5es s\00E3o determinadas para este filtro.</p>'),
unistr('<p>Observa\00E7\00E3o: Os valores fornecidos ainda s\00E3o verificados em rela\00E7\00E3o \00E0s entradas vis\00EDveis da Lista de Valores e s\00F3 ser\00E3o usados se houver uma correspond\00EAncia.'),
unistr('Se um valor n\00E3o for encontrado, ele ser\00E1 ignorado e o pr\00F3ximo ser\00E1 verificado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598495253311016)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Din\00E2mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598502841311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seleciona a <strong>primeira</strong> entrada vis\00EDvel na Lista de Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598807095311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598924153311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores s\00E3o retornados da <em>Consulta SQL</em> inserida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598662239311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598797335311017)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de valores delimitados por v\00EDrgulas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106598254372311016)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867038822311236)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o texto que aparece na parte superior dos arquivos de download. Voc\00EA pode digitar mensagens de classifica\00E7\00E3o de dados, avisos legais ou advert\00EAncia sobre os dados no arquivo.</p>'),
unistr('        <p> Observa\00E7\00E3o - O texto digitado ser\00E1 inclu\00EDdo em todos os formatos de download de relat\00F3rio. Se estiver ativado o download de CSV, o texto definido invalidar\00E1 o formato de arquivo CSV.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866948113311236)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto Complementar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882275224311248)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique este atributo se desejar usar o texto do cabe\00E7alho da coluna como o label na View Detalhada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106882183192311248)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Cabe\00E7alho de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937517791311291)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selecione a base para esta coluna de Form Tabular.</p>',
unistr('<p>A sele\00E7\00E3o determina se esta coluna \00E9 atualiz\00E1vel no Form Tabular.'),
unistr('As atualiza\00E7\00F5es s\00F3 podem ser feitas se uma atualiza\00E7\00E3o de v\00E1rias linhas for definida ou se um processo de PL/SQL for implementado para processar os dados atualizados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104941636311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273378858311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a data ou utilize o selecionador de datas para selecionar a data.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104804254311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Data (Cl\00E1ssico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273474155311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a data ou utilize o selecionador de datas para selecionar a data.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107104748373311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto Sem Formata\00E7\00E3o (salva o estado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272012227311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe o valor da coluna e salva o valor no estado da sess\00E3o. Esta coluna pode ser utilizada no processamento da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106451442311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download do BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272484312311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como um link para fazer download do arquivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105900015311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Oculta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273596755311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o exibe a coluna, mas ela pode ser referenciada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105415146311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Oculta (salva o estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273606290311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o exibe a coluna, mas ela pode ser referenciada. Esta coluna pode ser utilizada no processamento da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106363119311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Imagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272398187311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como uma imagem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106272325311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'pt-br'
,p_message_text=>'Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272265355311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe a coluna como um link.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106574337311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Percentual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272536974311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe a coluna como um gr\00E1fico de porcentagem. O valor recuperado deve estar entre 0 e 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106085749311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto sem Formata\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271959319311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe o valor da coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107106166305311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto sem Formata\00E7\00E3o (baseado na Lista de Valores)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272137981311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibe o valor retornado da lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105550942311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'pt-br'
,p_message_text=>'LOV Popup (mostra valor de retorno)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273004361311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um valor no popup. Ser\00E1 exibido o valor de retorno da lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105667372311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('LOV Popup (mostra valor para exibi\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272949896311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um valor no popup. Ser\00E1 exibido o valor para exibi\00E7\00E3o da lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105393268311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grupo de R\00E1dio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273170282311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um grupo de r\00E1dio \00FAnico na lista de valores especificados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105892743311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107271869312311559)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem uma caixa de sele\00E7\00E3o no in\00EDcio de cada linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105282856311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272851572311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione um valor da lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105706068311431)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Sele\00E7\00E3o Simples')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107273270977311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Marque ou desmarque a caixa de sele\00E7\00E3o \00FAnica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105049092311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272661867311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um valor em um campo de texto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107105122776311430)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107272711998311560)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um valor em um campo de \00E1rea de texto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106937426572311290)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660317833311062)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique no Destino para chamar uma caixa de di\00E1logo modal. \00C9 poss\00EDvel inserir um destino que seja chamado quando esta ramifica\00E7\00E3o for chamada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106660247971311062)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240854757311534)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione op\00E7\00F5es de modelo para personalizar a interface de usu\00E1rio deste componente.</p>'),
unistr('<p>Voc\00EA tamb\00E9m pode modificar as op\00E7\00F5es de modelo ao executar o aplicativo usando <strong>Op\00E7\00F5es de Modelo On-line</strong>.'),
unistr('Essa op\00E7\00E3o permite personalizar o aplicativo em tempo real, capacitando a visualiza\00E7\00E3o e o aplicativo de v\00E1rias op\00E7\00F5es.'),
unistr('Para acessar as Op\00E7\00F5es de Modelo On-line, execute o aplicativo pelo Application Builder e clique em <em>Edi\00E7\00E3o R\00E1pida</em> na barra de ferramentas do desenvolvedor.'),
unistr('Passe o mouse sobre um componente da p\00E1gina, como uma regi\00E3o, e clique no \00EDcone de chave de boca ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) exibido no canto superior esquerdo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240735394311534)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241050872311535)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione op\00E7\00F5es de modelo para personalizar a interface de usu\00E1rio deste componente.</p>'),
unistr('<p>Voc\00EA tamb\00E9m pode modificar as op\00E7\00F5es de modelo ao executar o aplicativo usando <strong>Op\00E7\00F5es de Modelo On-line</strong>.'),
unistr('Essa op\00E7\00E3o permite personalizar o aplicativo em tempo real, capacitando a visualiza\00E7\00E3o e o aplicativo de v\00E1rias op\00E7\00F5es.'),
unistr('Para acessar as Op\00E7\00F5es de Modelo On-line, execute o aplicativo pelo Application Builder e clique em <em>Edi\00E7\00E3o R\00E1pida</em> na barra de ferramentas do desenvolvedor.'),
unistr('Passe o mouse sobre um componente da p\00E1gina, como uma regi\00E3o, e clique no \00EDcone de chave de boca ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) exibido no canto superior esquerdo.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240982466311534)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489130465310931)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Placeholders dentro de um modelo de e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489088706310931)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Placeholders do Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922415911311280)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de modelo para este relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101675804311428)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'pt-br'
,p_message_text=>'Predefinido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101749504311428)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de relat\00F3rios predefinidos que n\00E3o est\00E3o diretamente associados a qualquer tema. Como n\00E3o existe correla\00E7\00E3o entre esses modelos predefinidos e seu tema atual, o layout do relat\00F3rio permanece o mesmo, ainda que voc\00EA altere o tema do aplicativo')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101498646311427)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107101535208311427)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos dispon\00EDveis de relat\00F3rio no tema correspondente, baseados no tema atual da interface de usu\00E1rio desta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106922335162311279)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429670863311672)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Dependendo do <strong>Tipo de Pesquisa</strong> especificado, insira um nome ou uma lista de nomes de coluna de banco de dados que sejam usados para a pesquisa de texto.</p>',
'<ul>',
unistr('  <li><strong>Pesquisa de Linha</strong>: Insira uma lista delimitada por v\00EDrgulas de nomes de coluna de banco de dados com distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas do tipo VARCHAR2 usada para pesquisa de texto. Se nenhuma coluna for especificada, tod')
||unistr('as as colunas VARCHAR2 ser\00E3o usadas automaticamente.</li>'),
unistr('  <li><strong>Oracle Text</strong>: Insira o nome da coluna de banco de dados com distin\00E7\00E3o entre mai\00FAsculas/min\00FAsculas que contenha o \00EDndice do Oracle Text.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107429551604311672)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna(s) do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701485713311093)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tema a ser associado \00E0 interface do usu\00E1rio atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106701352495311093)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849313652311223)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a posi\00E7\00E3o dos labels de marca\00E7\00E3o em rela\00E7\00E3o \00E0 \00E1rea plotada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849552614311223)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Dentro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849421473311223)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Fora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849230022311223)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848965630311222)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se os labels de marca\00E7\00E3o dever\00E3o ser renderizados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106848826307311222)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849124304311223)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique se o gr\00E1fico rotacionar\00E1 os labels automaticamente em 90 graus para encaixar mais labels no gr\00E1fico.'),
unistr('        A rota\00E7\00E3o s\00F3 ser\00E1 aplicada a labels categ\00F3ricos para um eixo horizontal.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106849071316311223)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Rota\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107219758027311517)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Igual ao Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350585074311615)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Use o mesmo mapa de plano de fundo para o modo claro e escuro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174327955311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha a camada de mosaico a ser usada como mapa de fundo quando o modo escuro estiver ativado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175253459311484)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapa M\00FAndi do Oracle BI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175388389311484)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base n\00E3o invasivo baseado em dados de Mapa HERE. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o para seus dados e acentua a visualiza\00E7\00E3o de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo da Oracle, EUA.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174825062311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'OpenStreetMap Bright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174911111311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Mapa base de uso geral baseado em dados do OpenStreetMap. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o detalhado para seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174423822311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'OpenStreetMap Dark'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174571803311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Mapa base leve n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abrigo da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174649471311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'pt-br'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174712621311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base escuro n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175009463311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapa M\00FAndi Oracle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107175150939311483)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso geral baseado em dados de Mapa HERE. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o para seus dados e acentua a visualiza\00E7\00E3o de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo da Oracle, EUA.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174281391311482)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Modo Escuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173115546311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha a camada de mosaico a ser usada como o mapa de fundo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174017581311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapa M\00FAndi do Oracle BI')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107174161165311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base n\00E3o invasivo baseado em dados de Mapa HERE. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o para seus dados e acentua a visualiza\00E7\00E3o de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo da Oracle, EUA.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173669464311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'pt-br'
,p_message_text=>'OpenStreetMap Bright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173788895311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Mapa base de uso geral baseado em dados do OpenStreetMap. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o detalhado para seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173476404311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'OpenStreetMap Dark'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173548557311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base escuro n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173210446311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'pt-br'
,p_message_text=>'OpenStreetMap Positron'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173357474311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base leve n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abrigo da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173852352311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mapa M\00FAndi Oracle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173921695311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso geral baseado em dados de Mapa HERE. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o para seus dados e acentua a visualiza\00E7\00E3o de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo da Oracle, EUA.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107173038375311482)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172517946311481)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione o mapa de fundo a ser usado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172849570311481)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172957430311481)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha as camadas de mosaico do mapa a serem usadas no mapa de fundo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172689625311481)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172704983311481)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use as defini\00E7\00F5es padr\00E3o de mapa de fundo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107172482314311481)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Segundo Plano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950193666311306)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como o formato de hora ser\00E1 exibido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107109983883311434)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'pt-br'
,p_message_text=>'12 Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107110066073311434)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'pt-br'
,p_message_text=>'24 Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106950019290311306)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Hor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107438852689311678)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um t\00EDtulo para o eixo. Esse t\00EDtulo descreve as informa\00E7\00F5es que est\00E3o sendo representadas no eixo do seu gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106589573944311010)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um t\00EDtulo a ser exibido na barra de t\00EDtulo da janela do browser. O mecanismo do &PRODUCT_NAME. usa o t\00EDtulo especificado aqui no lugar da string de substitui\00E7\00E3o <code>#TITLE#</code> usada no modelo da p\00E1gina. Esse t\00EDtulo \00E9 inserido entre as t')
||'ags HTML <code>&lt;TITLE&gt;</code> e <code>&lt;/TITLE&gt;</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106590444107311010)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um t\00EDtulo da regi\00E3o. Ele s\00F3 \00E9 exibido quando est\00E1 definido no modelo da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551889484310981)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o t\00EDtulo da p\00E1gina. O t\00EDtulo da p\00E1gina \00E9 exibido na barra de t\00EDtulo da janela do browser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106551782711310981)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247626813311539)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se este componente ser\00E1 exibido usando uma coluna ou formata\00E7\00E3o avan\00E7ada com o uso de express\00F5es HTML e strings de substitui\00E7\00E3o suportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247571761311539)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formata\00E7\00E3o Avan\00E7ada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247896554311539)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a coluna a ser usada como t\00EDtulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247705966311539)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248369954311540)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira classes a serem adicionadas a este componente. Voc\00EA pode adicionar v\00E1rias classes, separando-as com espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248282073311540)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Classes CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248157819311540)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica da consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>&COLUMN_CLASS.</code> e <code>&EMPLOYEE_STATUS.</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL do relat\00F3rio.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107248045977311539)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>&COLUMN.</code> para mostrar valores de coluna em HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107247988191311539)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801117079311184)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Marque os controles adicionais que dever\00E3o ser exibidos na barra de ferramentas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801693993311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801744887311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe o bot\00E3o do menu A\00E7\00F5es, que geralmente inclui um conjunto abrangente de op\00E7\00F5es. Essas op\00E7\00F5es permitem que o usu\00E1rio final personalize o relat\00F3rio com base nas fun\00E7\00F5es dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801889353311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Redefinir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801973110311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe o bot\00E3o Redefinir. Quando esse bot\00E3o \00E9 pressionado, todas as personaliza\00E7\00F5es, como filtros, largura da coluna e ordena\00E7\00E3o, ser\00E3o removidas e a defini\00E7\00E3o de relat\00F3rio ser\00E1 recarregada do servidor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802001316311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o Salvar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106802124822311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exibe o bot\00E3o Salvar. Quando esse bot\00E3o for pressionado, somente as altera\00E7\00F5es feitas nessa Grade Interativa ser\00E3o salvas, sem precisar salvar a p\00E1gina inteira.'),
unistr('        <p>O bot\00E3o Salvar s\00F3 ser\00E1 exibido quando a Grade Interativa for edit\00E1vel e o usu\00E1rio final tiver autoriza\00E7\00E3o para adicionar, atualizar ou excluir.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801258654311184)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Coluna de Pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801312075311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe uma lista drop-down de colunas n\00E3o num\00E9ricas exibidas. Se uma coluna for selecionada, a pesquisa s\00F3 ser\00E1 executada conforme os valores na coluna selecionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801463930311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801535634311185)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe um campo de texto na barra de pesquisa usado para digitar os crit\00E9rios da pesquisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106801072598311184)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Controles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363656560311625)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107268190807311556)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363753350311625)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905514158311267)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Indica se essa coluna \00E9 baseada em fuso hor\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905498646311267)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Baseada em Fuso Hor\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938842109311291)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o nome da coluna a que esta coluna do relat\00F3rio faz refer\00EAncia.'),
unistr('Esse atributo \00E9 usado para comparar refer\00EAncias a colunas em aplicativos usando Padr\00F5es de Interface do Usu\00E1rio.'),
unistr('Esta refer\00EAncia \00E9 mantida manualmente ap\00F3s ser inicializada por um assistente, sempre que poss\00EDvel.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938708673311291)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938668408311291)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione a tabela ou view a que esta coluna faz refer\00EAncia.'),
unistr('Esse atributo \00E9 usado para comparar refer\00EAncias a colunas em aplicativos usando Padr\00F5es de Interface do Usu\00E1rio.'),
unistr('Esta refer\00EAncia \00E9 mantida manualmente ap\00F3s ser inicializada por um assistente, sempre que poss\00EDvel.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938526044311291)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938427033311291)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o esquema que possui a tabela de refer\00EAncia.'),
unistr('Esse atributo \00E9 usado para comparar refer\00EAncias a colunas em aplicativos usando Padr\00F5es de Interface do Usu\00E1rio.'),
unistr('Esta refer\00EAncia \00E9 mantida manualmente ap\00F3s ser inicializada por um assistente, sempre que poss\00EDvel.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938342935311291)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890307907311255)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selecione o tipo de coluna usada para identificar a linha atual ao utilizar a coluna de links.',
unistr('Por padr\00E3o, <strong>ROWID</strong> ser\00E1 usada para identificar exclusivamente linhas de um relat\00F3rio. No entanto, voc\00EA tamb\00E9m pode utilizar outra coluna selecionando <strong>Coluna \00DAnica</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090592836311419)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107090440552311419)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'pt-br'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890232217311255)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Identificar Exclusivamente as Linhas por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890573351311255)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Selecione a primeira coluna usada para identificar exclusivamente linhas para este componente.</p>',
unistr('<p><strong>ROWID</strong> tamb\00E9m ser\00E1 inclu\00EDda na lista de colunas dispon\00EDveis para compatibilidade com vers\00F5es anteriores.</p>'),
unistr('<p>Observa\00E7\00E3o: Para um relat\00F3rio interativo com o atributo <em>Coluna de Links</em> definido como <strong>Link para View de Uma Linha</strong>, somente uma coluna pode ser selecionada. Outros componentes suportam a sele\00E7\00E3o de at\00E9 tr\00EAs colunas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890415620311255)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890712084311255)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a segunda coluna a ser usada para identificar unicamente linhas para este componente. Use este atributo quando sua tabela tiver uma chave prim\00E1ria de duas partes.</p>'),
unistr('<p><strong>ROWID</strong> tamb\00E9m ser\00E1 inclu\00EDda na lista de colunas dispon\00EDveis para  compatibilidade com vers\00F5es anteriores.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890659635311255)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Exclusiva 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890966954311255)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a terceira coluna a ser usada para identificar unicamente linhas para este componente. Use este atributo quando sua tabela tiver uma chave prim\00E1ria de tr\00EAs partes.</p>'),
unistr('<p><strong>ROWID</strong> tamb\00E9m ser\00E1 inclu\00EDda na lista de colunas dispon\00EDveis para compatibilidade com vers\00F5es anteriores.</p>'),
unistr('<p>Observa\00E7\00E3o: Se a chave prim\00E1ria da sua tabela tiver mais de tr\00EAs colunas, ser\00E1 necess\00E1rio identificar exclusivamente linhas por <strong>ROWID</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106890867265311255)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Exclusiva 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778396938311161)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione um esquema de autoriza\00E7\00E3o para restringir quem pode atualizar linhas.'),
unistr('Para permitir que um usu\00E1rio final atualize linhas, esse esquema de autoriza\00E7\00E3o dever\00E1 ser avaliado como VERDADEIRO para esse usu\00E1rio.'),
unistr('Se nenhum esquema de autoriza\00E7\00E3o for fornecido, nenhum usu\00E1rio poder\00E1 atualizar linhas nesta grade interativa.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106778260710311161)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665860553311066)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostra a interface do usu\00E1rio desta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665708278311066)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700428936311092)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de interface de usu\00E1rio para esta p\00E1gina. Selecione <strong>Desktop</strong> para p\00E1ginas criadas inicialmente para uso em desktop. Para outras interfaces, como smartphones ou tablets, selecione a interface de usu\00E1rio correspondente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084671295311415)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107084782790311415)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Smartphone do jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106700366365311092)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915559969311274)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se esta coluna tamb\00E9m ser\00E1 exibida no Cabe\00E7alho da Linha.'),
unistr('Incluir o valor da coluna pode melhorar significativamente a acessibilidade dos campos de form renderizados em um relat\00F3rio.'),
unistr('Quando esta op\00E7\00E3o \00E9 especificada, isso faz com que o Cabe\00E7alho da Linha seja usado com o Cabe\00E7alho da Coluna para renderizar os labels dos campos de form no relat\00F3rio, usando o formato <code>''&lt;Cabe\00E7alho da Coluna; : &lt;Cabe\00E7alho da Linha&gt;''</co')
||'de>.</p>',
unistr('<p>Por exemplo, suponha que voc\00EA tem um relat\00F3rio na tabela EMP e deseja definir a coluna ENAME como o Cabe\00E7alho da Linha. Para uma linha onde ENAME \00E9 ''JONES'', o label para o campo Sal\00E1rio dessa linha seria "Sal\00E1rio : JONES".'),
unistr('Isso permite que um usu\00E1rio de leitor de tela seja capaz de navegar pelos campos de Form no relat\00F3rio e ainda mantenha uma compreens\00E3o de quais campos de form se relacionam a quais linhas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106915463649311274)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Como Cabe\00E7alho da Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943847126311300)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique se voc\00EA deseja definir um link personalizado para a View de \00CDcone. Esta op\00E7\00E3o oferece uma maior flexibilidade na defini\00E7\00E3o do conte\00FAdo da View de \00CDcone, incluindo a capacidade de utilizar mais de uma coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943784242311300)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662934542311064)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione a regi\00E3o associada a essa valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106662807658311063)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o Edit\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661404938311062)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o tipo de igualdade a ser testada para esta valida\00E7\00E3o. Dependendo da sua sele\00E7\00E3o, um ou mais atributos adicionais ser\00E3o necess\00E1rios para definir completamente essa valida\00E7\00E3o.</p>'),
unistr('<p>Se a valida\00E7\00E3o passar no teste de igualdade ou for avaliada como VERDADEIRA, a mensagem de erro de valida\00E7\00E3o n\00E3o ser\00E1 exibida.'),
unistr('Mensagens de erro de valida\00E7\00E3o s\00E3o exibidas quando h\00E1 falha na valida\00E7\00E3o do teste de igualdade, quando a valida\00E7\00E3o \00E9 avaliada como FALSA ou quando uma string de texto n\00E3o vazia \00E9 retornada.</p>'),
unistr('<p>Uma falha de valida\00E7\00E3o n\00E3o interrompe a execu\00E7\00E3o das valida\00E7\00F5es subsequentes; portanto, cada valida\00E7\00E3o subsequente pode gerar uma mensagem de erro de valida\00E7\00E3o adicional. Se voc\00EA quiser interromper a execu\00E7\00E3o das valida\00E7\00F5es subsequentes, acrescent')
||unistr('e l\00F3gica \00E0 primeira valida\00E7\00E3o em que houve falha, definindo um item de p\00E1gina com um valor espec\00EDfico e, em seguida, refor\00E7ando a l\00F3gica condicional das valida\00E7\00F5es subsequentes, conforme necess\00E1rio. Os processos e ramifica\00E7\00F5es subsequentes n\00E3o ser\00E3o ')
||unistr('executados se houver falha na avalia\00E7\00E3o de uma ou mais valida\00E7\00F5es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118137902311440)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas retornadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118279792311440)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se a consulta SQL retornar uma ou mais linhas.<br>'),
unistr('Falhar\00E1 se a consulta SQL n\00E3o retornar linhas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324369286311597)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324445935311597)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se a express\00E3o for avaliada como VERDADEIRA.<br>'),
unistr('Falhar\00E1 se a express\00E3o for avaliada como FALSA.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118794892311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o (que retorna um valor booliano)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118882046311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o corpo da Fun\00E7\00E3o retornar VERDADEIRO.<br>'),
unistr('Falhar\00E1 se o corpo da Fun\00E7\00E3o retornar FALSO.<br>'),
unistr('Observa\00E7\00E3o: O resultado retornado pela fun\00E7\00E3o deve ser um valor booliano.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118988119311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o (que retorna um Texto de Erro)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119080524311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o corpo da Fun\00E7\00E3o retornar uma string vazia.<br>'),
unistr('Falhar\00E1 se o corpo da Fun\00E7\00E3o retornar uma string n\00E3o vazia. A string retornada \00E9 exibida como a mensagem de erro para a valida\00E7\00E3o.<br>'),
unistr('Observa\00E7\00E3o: O resultado retornado pela fun\00E7\00E3o deve ser uma string de texto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119743405311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119863955311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o contiver espa\00E7os.<br>'),
unistr('Falhar\00E1 se o valor Item contiver espa\00E7os.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121719005311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item cont\00E9m pelo menos um dos caracteres no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121848125311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item incluir pelo menos um caractere do texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item n\00E3o incluir caracteres do texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121948253311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O cont\00E9m nenhum dos caracteres no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122025171311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o incluir caracteres do texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item incluir pelo menos um caractere do texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121555224311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item cont\00E9m somente caracteres especificados no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121603781311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item contiver somente caracteres encontrados no texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item contiver qualquer caractere que n\00E3o esteja no texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120716821311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120860785311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item for igual ao texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item n\00E3o for igual ao texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121199271311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121264231311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item estiver completamente contido no texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item n\00E3o estiver totalmente contido no texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120977674311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121045166311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o for igual ao texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item for igual ao texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121361691311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O est\00E1 contida no Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107121446426311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o estiver completamente contido no texto inserido no atributo <em>Value</em>.<br>'),
unistr('Falhar\00E1 se o valor Item estiver totalmente contido no texto inserido no atributo <em>Value</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119981984311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item \00E9 alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120094482311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item \00E9 alfanum\00E9rico, contendo apenas letras e n\00FAmeros e nenhum caractere especial.<br>'),
unistr('Falhar\00E1 se o valor Item incluir caracteres especiais.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120358110311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 uma data v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120422570311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item for uma data v\00E1lida.<br>'),
unistr('Falhar\00E1 se o valor Item n\00E3o for uma data v\00E1lida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120156506311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120221407311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item for num\00E9rico.<br>'),
unistr('Falhar\00E1 se o valor Item contiver caracteres n\00E3o num\00E9ricos, incluindo espa\00E7os, com exce\00E7\00E3o de espa\00E7os \00E0 esquerda.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120563678311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 um timestamp v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107120699380311442)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item for um timestamp v\00E1lido.<br>'),
unistr('Falhar\00E1 se o valor Item n\00E3o for um timestamp v\00E1lido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119194520311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 N\00C3O NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119202586311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o estiver vazio.<br>'),
unistr('Falhar\00E1 se o valor Item estiver vazio.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119359472311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item \00E9 N\00C3O NULO ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119411433311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o estiver vazio e n\00E3o \00E9 o n\00FAmero zero.<br>'),
unistr('Falhar\00E1 se o valor Item estiver vazio ou for o n\00FAmero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119507629311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item N\00C3O \00C9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107119660839311441)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item n\00E3o for o n\00FAmero zero.<br>'),
unistr('Falhar\00E1 se o valor Item for o n\00FAmero zero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118355192311440)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Linha retornada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118422109311440)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se a consulta SQL n\00E3o retornar linhas.<br>'),
unistr('Falhar\00E1 se a consulta SQL retornar uma ou mais linhas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118598929311440)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107118658417311440)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o c\00F3digo PL/SQL for executado sem gerar erro.<br>'),
unistr('Falhar\00E1 se a express\00E3o PL/SQL gerar erro ao ser executada.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122163969311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Item corresponde \00E0 Express\00E3o Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107122200795311443)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Passar\00E1 se o valor Item corresponder \00E0 express\00E3o regular inserida no atributo <em>Value</em>.'),
unistr('Falhar\00E1 se o valor Item n\00E3o corresponder \00E0 express\00E3o regular inserida no atributo <em>Value</em>.<br>'),
unistr('Observa\00E7\00E3o: as express\00F5es regulares permitem a voc\00EA pesquisar padr\00F5es nos dados de string usando conven\00E7\00F5es de sintaxe padronizadas, em vez de apenas compara\00E7\00F5es de caracteres.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661394858311062)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846583350311221)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione se a linha de base do eixo come\00E7ar\00E1 no valor m\00EDnimo dos dados ou no valor zero. S\00F3 se aplica a eixos de dados num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846665624311221)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846797931311221)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'pt-br'
,p_message_text=>'Zero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106846492135311221)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Escalonamento da Linha de Base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878287232311245)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o nome do Conjunto. A origem desse valor de par\00E2metro ser\00E1 baseada no valor da coluna CLOB da primeira linha do conjunto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878135806311245)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832868579311210)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe a moeda que ser\00E1 usada ao formatar o valor no gr\00E1fico.'),
unistr('        O valor dever\00E1 ser um c\00F3digo de moeda alfab\00E9tico ISO 4217. Se o formato for definido como moeda e nenhuma moeda for definida na propriedade <strong>Moeda</strong>, a moeda ser\00E1 automaticamente derivada do idioma do aplicativo quando o gr\00E1fico')
||' for renderizado.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832792214311210)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Moeda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958941637311313)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o n\00FAmero de casas decimais a serem aplicadas ao valor num\00E9rico no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946569178311303)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o n\00FAmero de casas decimais a ser usado nos labels de valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106946489838311303)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Casas Decimais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335203644311604)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335659017311605)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335503149311604)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335483578311604)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335727937311605)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335369058311604)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335119190311604)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833290272311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o comportamento do escalonamento do valor no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833439236311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833757885311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bilh\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833612884311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Milh\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833367325311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833922407311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quatrilh\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833589235311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'pt-br'
,p_message_text=>'Milhar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833894102311211)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Trilh\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833110235311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formatar Escalonamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106958828366311313)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o tipo de formata\00E7\00E3o a ser aplicado ao valor no gr\00E1fico.'),
unistr('        Os formatos <strong>Decimal</strong>,<strong>Percentual</strong> ou <strong>Moeda</strong> s\00F3 se aplicam a valores num\00E9ricos.'),
unistr('        Os formatos <strong>Data</strong>,<strong>Hor\00E1rio</strong> e <strong>Data/Hor\00E1rio</strong> s\00F3 ser\00E3o aplicados aos valores desse tipo de dados no gr\00E1fico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831255715311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um tipo de formata\00E7\00E3o num\00E9rico, de data e/ou hora a ser aplicado ao valor no gr\00E1fico. Para formata\00E7\00E3o de data e/ou hora, certifique-se de que o atributo de gr\00E1fico <strong>Tipo de Eixo de Tempo</strong> esteja definido com um dos seguintes ')
||unistr('valores, dependendo dos dados do seu gr\00E1fico: <strong>Ativado</strong>, <strong>Frequ\00EAncia Mista</strong> ou <strong>Ignorar Intervalos</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832503108311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'pt-br'
,p_message_text=>'Moeda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969848591311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando um n\00FAmero \00E9 formatado como moeda, a propriedade Moeda deve ser obrigatoriamente definida para especificar a moeda que ser\00E1 usada durante a formata\00E7\00E3o do n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831693844311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Data - Completa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968746551311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatada como completa, uma data conter\00E1 dia da semana longo (EEEE), ano (a), m\00EAs longo (MMMM), dia (d). Por exemplo, Quarta-feira, Janeiro 6, 2016.'),
unistr('        Para alguns idiomas, n\00E3o s\00E3o usados meses longos; por exemplo, em japon\00EAs, o m\00EAs num\00E9rico \00E9 usado em padr\00F5es.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831578849311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'pt-br'
,p_message_text=>'Data - Longa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968652573311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando formatada como longa, uma data conter\00E1 ano, m\00EAs longo, dia. Por exemplo, Janeiro, 6, 2016.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831458293311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data - M\00E9dia')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968551842311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatada como m\00E9dia, uma data conter\00E1 ano, m\00EAs abreviado (MMM), dia. Por exemplo, Jan 6, 2016.'),
unistr('        Para alguns idiomas, n\00E3o s\00E3o usados meses abreviados; nesse caso, o formato m\00E9dio conter\00E1 o formato num\00E9rico (MM/M).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831366642311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Data - Curta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968400599311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando formatada como curta, uma data conter\00E1 ano, m\00EAs num\00E9rico (MM/M), dia. Por exemplo, 1/6/16.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969556638311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data/Hor\00E1rio - Formato Completo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969642622311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como completo, um elemento de data/hor\00E1rio conter\00E1 dia da semana longo, (EEEE), ano (a), m\00EAs longo (MMMM), dia (d), hora (h/H), minuto (mm), segundo (ss) e fuso hor\00E1rio (ffff). Por exemplo, Quarta-feira, Janeiro 6, 2016 7 h 30 min 21')
||' s.',
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832359641311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data/Hor\00E1rio - Longo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969427368311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como longo, um elemento de data/hor\00E1rio conter\00E1 ano, minuto, m\00EAs longo, dia, hora, minuto, segundo e fuso hor\00E1rio (f). Por exemplo, Jan 6, 2016 7:30:21 AM.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832205433311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data/Hor\00E1rio - M\00E9dio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969368571311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como m\00E9dio, um elemento de data/hor\00E1rio conter\00E1 ano, minuto, m\00EAs abreviado (MMM), dia, hora, minuto, segundo e fuso hor\00E1rio (f). Por exemplo, Jan 6, 2016 7:30:21 AM.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832140609311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Data/Hor\00E1rio - Curto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969217277311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como curto, um elemento de data/hor\00E1rio conter\00E1 ano, m\00EAs num\00E9rico (MM/M), dia, hora, minuto. Por exemplo, 1/6/16 7:30 AM.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832400264311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Decimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969741446311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando um n\00FAmero \00E9 formatado como um decimal, o caractere decimal \00E9 substitu\00EDdo pelo s\00EDmbolo mais apropriado para a configura\00E7\00E3o regional. Em ingl\00EAs, trata-se do ponto decimal ("."), enquanto em muitas outras configura\00E7\00F5es regionais, a v\00EDrgula decima')
||unistr('l (",") \00E9 utilizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832626547311210)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969927219311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando um n\00FAmero \00E9 formatado como um percentual, os valores no gr\00E1fico s\00E3o multiplicados por 100 para serem formatados como percentuais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832070078311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio - Integral')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969175742311321)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como completo, um hor\00E1rio conter\00E1 hora (h/H), minuto (mm), segundo (ss) e fuso hor\00E1rio (ffff). Por exemplo, 7 h 30 min 21 s.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831949811311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio - Longo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106969082386311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como longo, um hor\00E1rio conter\00E1 hora, minuto, segundo e fuso hor\00E1rio (f). Por exemplo, 7:30:21 AM.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831828353311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio - M\00E9dio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968942411311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como m\00E9dio, um hor\00E1rio conter\00E1 hora, minuto, segundo. Por exemplo, 7:30:21 AM.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831716933311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hor\00E1rio - Curto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106968892928311320)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Quando formatado como curto, um hor\00E1rio conter\00E1 hora, minuto. Por exemplo, 7:30 AM.'),
unistr('        O formato da hora depender\00E1 do fato de o idioma do aplicativo usar ou n\00E3o a op\00E7\00E3o de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831138692311209)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337239531311606)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337576373311606)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337429641311606)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337383672311606)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337607878311606)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337128937311606)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875109892311243)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item da p\00E1gina ou do aplicativo usado como origem para este valor de par\00E2metro.'),
unistr('\00C9 poss\00EDvel digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875075331311243)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336823755311605)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o Java que gere um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336721549311605)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338406816311607)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo de fun\00E7\00E3o Java que retorne um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338329437311606)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336631036311605)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER"? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336540578311605)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o JavaScript que gere um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336421827311605)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338276149311606)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338147509311606)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo de fun\00E7\00E3o JavaScript que retorne um valor usado como a origem para este valor de par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338040104311606)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106831032018311209)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique um valor m\00EDnimo para o gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106830951123311209)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959029165311313)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o padr\00E3o num\00E9rico a ser aplicado ao valor num\00E9rico no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450795016311687)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Padr\00E3o Num\00E9rico para representar temperaturas em Farenheit, por exemplo, 15&deg;F:</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>Padr\00E3o num\00E9rico para representar n\00FAmeros em formato espec\00EDfico, por exemplo, 12,30,00:</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>Padr\00E3o num\00E9rico para representar n\00FAmeros em mil\00EDmetros:</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>Padr\00E3o de data para representar a data como M\00EAs Ano, por exemplo, Jul 2016:</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>Padr\00E3o de data para representar a data como M\00EAs, por exemplo, Julho:</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106833082078311210)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite um padr\00E3o num\00E9rico ou de data opcional localizado, em que os caracteres usados no padr\00E3o estejam em conformidade com o Unicode CLDR para formatos de data e hora.'),
unistr('        Quando presente, isso substituir\00E1 o Formato selecionado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106832984169311210)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336328042311605)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336268964311605)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o PL/SQL que gere um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336180838311605)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337977188311606)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337828038311606)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo de fun\00E7\00E3o PL/SQL que retorne um valor usado como a origem para este valor de par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337716596311606)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304494730310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique a posi\00E7\00E3o em que o valor dever\00E1 ser exibido no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303852585310788)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304547845310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido na posi\00E7\00E3o padr\00E3o do gr\00E1fico, que \00E9 fora da \00E1rea de plotagem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303921882310788)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304635389310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido no centro do indicador no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304081064310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borda Interna do Indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304702489310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido dentro da borda do indicador no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304130386310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'pt-br'
,p_message_text=>'Borda Externa do Indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304803187310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido fora da borda do indicador no gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304200182310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea Externa de Plotagem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304975289310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido fora da \00E1rea de plotagem do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106304307285310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Com Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305063333310789)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Se o label for renderizado, o valor ser\00E1 exibido na mesma posi\00E7\00E3o que o label. Se o label n\00E3o for renderizado, o valor ser\00E1 exibido fora da \00E1rea de plotagem do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303734160310788)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875309893311243)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a Prefer\00EAncia de Usu\00E1rio a ser usada como a origem para este valor de par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106875287565311243)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107337096865311606)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o Python que gere um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336989031311605)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338648390311607)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o corpo de fun\00E7\00E3o Python que retorne um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107338574267311607)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874990388311243)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite a Consulta SQL usada como origem para este valor de par\00E2metro. Se mais de uma linha for retornada, o valor da primeira linha ser\00E1 usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874857159311242)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562273705310989)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se definido como <strong>Ativado</strong> e o item da p\00E1gina estiver vis\00EDvel, o &PRODUCT_NAME. executar\00E1 automaticamente uma valida\00E7\00E3o N\00C3O NULA quando a p\00E1gina for submetida.</p>'),
unistr('<p>Ao definir uma mensagem chamada <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> em Componentes Compartilhados> Mensagens de Texto, o texto do erro predefinido poder\00E1 ser substitu\00EDdo por uma mensagem de erro espec\00EDfica do aplicativo.</p>'),
unistr('<p>O local de exibi\00E7\00E3o da mensagem ser\00E1 estabelecido pela defini\00E7\00E3o no n\00EDvel do aplicativo <strong>Local de exibi\00E7\00E3o do erro padr\00E3o</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106562134082310989)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Necess\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107336068848311605)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para retornar SIM quando o funcion\00E1rio for um gerente e o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'               from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335966741311605)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o SQL que gere um valor usado como a origem para o valor deste par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107335867407311605)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874779655311242)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite o valor est\00E1tico usado como origem para este valor de par\00E2metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874642612311242)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106957018075311311)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique como o valor dever\00E1 ser exibido no gr\00E1fico: como um n\00FAmero ou como um percentual do valor total.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956885469311311)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959344341311313)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido como n\00FAmero no gr\00E1fico.</p> <p>Observa\00E7\00E3o: o atributo <strong>Formato</strong> deve ser usado somente para aplicar formata\00E7\00E3o decimal ou monet\00E1ria personalizada ao label e ao valor exibidos no gr\00E1fico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956968641311311)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106959463052311313)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O valor ser\00E1 exibido como percentual entre 0% e 100%.</p> <p>Observa\00E7\00E3o: quando a op\00E7\00E3o <strong>Formato</strong> est\00E1 definida como <strong>Percentual</strong>, os valores no gr\00E1fico s\00E3o multiplicados por 100 para serem formatados como percentual.')
||unistr(' Se voc\00EA quiser usar o atributo de Formato, certifique-se de que o Tipo de Label seja definido como n\00FAmero.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956708599311311)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873142820311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione como esse par\00E2metro \00E9 preenchido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106877973659311245)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cole\00E7\00E3o (CLOB)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878013490311245)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Defina o valor da coluna CLOB da primeira linha do <em>Conjunto</em> digitado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155043358311468)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de Origem REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107155102832311468)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use o valor definido como padr\00E3o na Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873474283311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873565852311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor mantido no estado da sess\00E3o para o <em>Item</em> selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874433757311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874593972311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como nulo, pois n\00E3o foi especificado um valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873831727311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873908175311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor que resulta da execu\00E7\00E3o da <em>Express\00E3o PL/SQL</em> informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874084849311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874150961311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor retornado do <em>Corpo de Fun\00E7\00E3o PL/SQL</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874248113311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106874337638311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o valor da <em>Prefer\00EAncia</em> informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873649889311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta SQL (retornar valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873764469311242)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como o primeiro valor retornado da <em>Consulta SQL</em> informada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873268137311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873305349311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir como o texto inserido no <em>Valor Est\00E1tico</em>.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106873066764311241)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326251165311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para avaliar a express\00E3o informada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326658040311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326546292311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326486916311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326781314311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326385456311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326129287311598)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328236684311599)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328537847311600)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328433976311599)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328330464311599)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328615651311600)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328131913311599)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324676053311597)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma linguagem que seja usada para executar o corpo da fun\00E7\00E3o informado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324916354311597)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'pt-br'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324841560311597)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'pt-br'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324728697311597)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325090577311597)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'pt-br'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107324534596311597)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021021995311364)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um item da p\00E1gina ou do aplicativo usado nesta valida\00E7\00E3o. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020957543311364)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327888533311599)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Java para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327749706311599)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329467720311600)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329388606311600)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325837203311598)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Java que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325764509311598)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Java que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327618265311599)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327571770311599)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o JavaScript para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327421507311599)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329230013311600)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329172007311600)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329000042311600)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325660840311598)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar a mensagem de erro especificada, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325506121311597)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o JavaScript que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325430701311597)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o JavaScript que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445979154311683)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar o erro especificado, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020858925311364)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o PL/SQL que gere um erro como base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020771863311364)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo PL/SQL que gera o Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327316885311599)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30 ou for um gerente:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327299748311599)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o PL/SQL para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327179959311599)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328985602311600)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328899382311600)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328721157311600)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325338293311597)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar a mensagem de erro especificada, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325296174311597)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o PL/SQL que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325198579311597)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o PL/SQL que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107328026260311599)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o Python para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327903030311599)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329665973311600)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne um valor BOOLIANO como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107329531559311600)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326032101311598)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um corpo de fun\00E7\00E3o Python que retorne o texto da mensagem de erro como a base para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107325950788311598)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo da Fun\00E7\00E3o Python que Retorna um Texto de Erro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021459080311364)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a express\00E3o regular usada para corresponder ao item especificado para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021382207311364)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107327029610311599)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio for um gerente ou o departamento se localizar em Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326945322311598)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma express\00E3o SQL para definir a valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107326874464311598)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445872929311683)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Em <strong>Linhas Retornadas</strong>, para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Em <strong>Nenhuma Linha Retornada</strong, para passar na valida\00E7\00E3o, e n\00E3o provocar uma mensagem de erro, quando o funcion\00E1rio estiver no departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020675186311364)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta SQL para definir esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020556068311364)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021232728311364)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe o valor usado para comparar ao valor da coluna de item especificada para esta valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107021123500311364)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151940974311465)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Restringe o uso de um aplicativo para o hor\00E1rio comercial espec\00EDfico</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644635596311050)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o nome de uma fun\00E7\00E3o que seja chamada ap\00F3s a sentinela de sess\00E3o ser retornada com sucesso.'),
unistr('A fun\00E7\00E3o pode ser definida no atributo "C\00F3digo PL/SQL" ou no banco de dados.'),
unistr('O resultado deve ser um valor booliano, com "Verdadeiro" representando o usu\00E1rio verificado e "Falso" representando o usu\00E1rio cuja verifica\00E7\00E3o falhou.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106644565445311050)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verificar Nome da Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582211928311005)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se todas as a\00E7\00F5es pendentes aguardar\00E3o o resultado da a\00E7\00E3o atual.'),
unistr('Defina este atributo como <strong>Ativado</strong>, se as a\00E7\00F5es pendentes forem dependentes do resultado dessa a\00E7\00E3o'),
unistr('ou como <strong>Desativado</strong> se n\00E3o houver depend\00EAncia e elas puderem ser executadas de forma ass\00EDncrona, sem espera.</p>'),
unistr('<p>Observa\00E7\00E3o: A ordem de execu\00E7\00E3o de a\00E7\00F5es espec\00EDficas \00E9 determinada pela sequ\00EAncia especificada para cada a\00E7\00E3o.'),
unistr('Para garantir que as a\00E7\00F5es sejam executadas na mesma ordem, a Oracle recomenda que os n\00FAmeros da sequ\00EAncia sejam exclusivos para todas as A\00E7\00F5es Verdadeiras e todas as A\00E7\00F5es Falsas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106582148445311004)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Aguardar Resultado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670257227311069)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica se a Origem de Dados REST tem uma tabela de sincroniza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670157161311069)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Origem de Dados REST tem uma tabela de Sincroniza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106872966468311241)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670454385311069)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Ative essa op\00E7\00E3o para usar a tabela local, que est\00E1 configurada na se\00E7\00E3o <strong>Sincroniza\00E7\00E3o</strong> da Origem de Dados REST, em vez de recorrer ao servi\00E7o REST externo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670309057311069)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar tabela de Sincroniza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556439637310985)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o bot\00E3o para acionar a a\00E7\00E3o din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556354390310985)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661116915311062)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se voc\00EA quiser que o componente de processamento desta p\00E1gina seja executado somente quando o bot\00E3o especificado for clicado, selecione um bot\00E3o da lista. Voc\00EA pode incorporar a condi\00E7\00E3o desse bot\00E3o a outras condi\00E7\00F5es para refinar ainda mais quando o')
||unistr(' componente de processamento desta p\00E1gina ser\00E1 executado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106661053923311062)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando o Bot\00E3o For Pressionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417836725311664)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite uma ou mais colunas para acionar a a\00E7\00E3o din\00E2mica.'),
unistr('Para v\00E1rias colunas, separe o nome de cada item com uma v\00EDrgula.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de colunas dispon\00EDveis.'),
unistr('Se voc\00EA selecionar na lista e j\00E1 houver texto digitado, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome da coluna retornado da lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417753207311663)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556849254310985)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um objeto DOM (<code>documento</code>, <code>janela</code>) ou o <em>id</em> de um objeto DOM (<code>myElementID</code>) como o elemento para acionar a a\00E7\00E3o din\00E2mica.</p>'),
unistr('<p>Observa\00E7\00E3o: o <em>Objeto DOM</em> est\00E1 obsoleto e deve ser substitu\00EDdo pela <em>Express\00E3o JavaScript</em> ou pelo <em>Seletor jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556736552310985)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Objeto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556642974310985)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe os itens da p\00E1gina ou do aplicativo para acionar a a\00E7\00E3o din\00E2mica.'),
unistr('Para v\00E1rios itens, separe o nome de cada item com uma v\00EDrgula.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA selecionar na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome do item retornado da lista.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556597238310985)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413534024311660)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Retorna uma refer\00EAncia para o <code>objeto DOM</code> da janela do browser.</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>Retorna uma refer\00EAncia para o <code>objeto DOM</code> do documento do browser.</dt>'),
'<dd><code>document</code></dd>',
'<dt>O seletor jQuery selecione todos os elementos DIV que possuem uma classe de ''alert'' e, em seguida, retorna um objeto jQuery contendo todos os seus pais.</dt>',
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413492448311660)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a Express\00E3o JavaScript a ser avaliada para retornar um \00FAnico objeto DOM, um array de objetos DOM ou um objeto jQuery como o(s) elemento(s) para acionar a a\00E7\00E3o din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413317549311660)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068291141311403)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Para selecionar um elemento a p\00E1gina com um id DOM <code>my_id</code></dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>Para selecionar todos os elemento da p\00E1gina com uma classe <code>my_class</code></dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>Para selecionar todos os elementos da p\00E1gina que s\00E3o entradas</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106557079150310985)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a sintaxe do Seletor jQuery para retornar um ou mais elementos de p\00E1gina para acionar a a\00E7\00E3o din\00E2mica. A biblioteca jQuery oferece uma sintaxe de seletor muito avan\00E7ada que fornece uma maneira de acessar facilmente um ou mais elementos de ')
||unistr('uma p\00E1gina.</p>'),
unistr('<p>Consulte a documenta\00E7\00E3o oficial dispon\00EDvel na <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">homepage do jQuery</a> para obter mais informa\00E7\00F5es sobre a sintaxe do seletor.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556952176310985)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106793633260311174)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite a mensagem de texto que ser\00E1 exibida quando o limite <strong>M\00E1ximo de Linhas a Processar</strong> for excedido.'),
unistr('A mensagem padr\00E3o instrui os usu\00E1rios finais a adicionar filtros para limitar o n\00FAmero de registros a serem processados.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106938920497311292)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe a mensagem de texto que ser\00E1 exibida quando forem retornadas mais linhas da consulta do que a contagem m\00E1xima de linhas inserida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107220315552311517)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Insira a mensagem de texto exibida na \00E1rea <strong>Mensagens</strong>, quando o limite <strong>M\00E1ximo de Linhas a Processar</strong> for excedido para a camada. Use a substitui\00E7\00E3o <strong>#MAX_ROW_COUNT#</strong> para a quantidade de linhas realmente')
||unistr(' extra\00EDdas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924298924311281)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a mensagem de texto que ser\00E1 exibida quando houver mais linhas de relat\00F3rio.'),
unistr('Use essa abordagem como uma alternativa para a pagina\00E7\00E3o, em especial se um relat\00F3rio geralmente tiver apenas um conjunto registros discretos.'),
unistr('Se a consulta do relat\00F3rio retornar linhas adicionais, essa mensagem poder\00E1 ser usada para alertar o usu\00E1rio final para a anomalia, em vez de simplesmente exibir controles de pagina\00E7\00E3o com poucas diferen\00E7as.'),
unistr('Sua mensagem de texto pode facilmente incorporar uma "Chamada \00E0 a\00E7\00E3o" para que os usu\00E1rios finais sejam orientados sobre como responder a este resultado de consulta incomum e pode incluir links de p\00E1gina ou URL.</p>'),
unistr('<p>As seguintes strings de substitui\00E7\00E3o de pagina\00E7\00E3o podem ser utilizadas em sua mensagem:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>O n\00FAmero de linhas exibidas (tamanho da p\00E1gina)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>O "Z" em "linhas X - Y de Z"</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>O "X" em "linhas X - Y de Z"</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>O "Y" em "linhas X - Y de Z"</dd>',
'  <dt><code>#ROW_RANGES"</code></dt>',
'    <dd>Mostra: A(s) linha(s) 1-15 16-30 30-32</dd>',
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>Mesmo que faixas de linhas, mas em uma lista de sele\00E7\00E3o<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
unistr('    <dd>Conjuntos de P\00E1ginas: 1 2 3 4 5 6</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106924178810311281)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Quando Mais dados Encontrados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107397945375311649)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite uma mensagem de texto para exibir se a consulta do gr\00E1fico n\00E3o retornar linhas. Se for deixada vazia, o Oracle JET usar\00E1 automaticamente a mensagem padr\00E3o "Sem dados para exibi\00E7\00E3o".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350730556311615)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Digite a mensagem de texto exibida na \00E1rea <strong>Mensagens</strong> quando a consulta da camada n\00E3o retornar nenhuma linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888329516311253)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma mensagem de texto a ser exibida se a consulta n\00E3o retornar nenhuma linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106888293422311253)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Quando Nenhum Dado for Encontrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556251296310985)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o nome da regi\00E3o que aciona a a\00E7\00E3o din\00E2mica.'),
unistr('Por exemplo, esta pode ser uma regi\00E3o de ''Relat\00F3rio Interativo'', usada em conjunto com um evento "Ap\00F3s Atualizar'', para definir uma a\00E7\00E3o din\00E2mica que \00E9 acionada sempre que o relat\00F3rio \00E9 atualizado.</p>'),
unistr('<p>Fazer com que a regi\00E3o acione uma a\00E7\00E3o din\00E2mica pode ser \00FAtil quando se deseja definir um comportamento semelhante para v\00E1rios itens de p\00E1gina de uma regi\00E3o. No entanto, isso s\00F3 \00E9 poss\00EDvel para determinados eventos que s\00E3o gerados por itens nessa ')
||unistr('regi\00E3o.'),
unistr('Para obter uma lista de eventos que suportam esse tipo de defini\00E7\00E3o e um exemplo de como eles podem ser utilizados, consulte o item Ajuda de <em>Elementos Afetados</em> &gt; <em>Tipo de Sele\00E7\00E3o</em> do Escopo de Eventos na p\00E1gina A\00E7\00E3o.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556148967310984)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106556055333310984)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o tipo de elemento de p\00E1gina ou constru\00E7\00E3o a ser usada para acionar o evento. Para exemplos de uso de um tipo espec\00EDfico de sele\00E7\00E3o, consulte a Ajuda no atributo associado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067988344311403)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369393509311629)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acionado por um bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107416096755311662)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369513899311629)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Acionado por uma ou mais colunas.'' );',
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
'        p_help_text     => q''~<p>Acionado pelo objeto DOM (<code>document</code>, <code>window</code>) ou o <em>id</em> de um objeto DOM (<code>myElementID</code>).</p>',
unistr('        <p>Observa\00E7\00E3o: O <em>Objeto DOM</em> est\00E1 obsoleto e deve ser substitu\00EDdo pe\00E7a <em>Express\00E3o JavaScript</em> ou pelo <em>Seletor de jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107067851093311403)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Item(ns)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369241673311629)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acionado por um ou mais itens de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412709193311660)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369753086311629)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acionado pelos elementos de p\00E1gina retornados pela express\00E3o JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068106532311403)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'pt-br'
,p_message_text=>'Seletor jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369614459311629)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acionado por um ou mais elementos de p\00E1gina retornados pelo Seletor de jQuery.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107068052459311403)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107369428543311629)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acionado por uma regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106555998388310984)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106611722466311026)
,p_name=>'PENDING'
,p_message_language=>'pt-br'
,p_message_text=>'pendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702199689311094)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas Pendentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710847392311107)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00F5es Pendentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732989006311124)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual Fechado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730806355311122)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Percentual Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733015549311124)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual de Aberturas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690034121311085)
,p_name=>'PIE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Pizza')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712144872311108)
,p_name=>'PKC1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 1 de Chave Prim\00E1ria')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106712292877311108)
,p_name=>'PKC2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna 2 de Chave Prim\00E1ria')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404416614311654)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispon\00EDvel para Instalar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404585647311654)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispon\00EDveis para Upgrade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404611425311654)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'pt-br'
,p_message_text=>'Eventos do Aplicativo de Produtividade/Amostra: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408012179311657)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Usu\00E1rios - %1 Views')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447705488311685)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Falha nas seguintes verifica\00E7\00F5es de pr\00E9-requisito. A instala\00E7\00E3o deste aplicativo e dos objetos de suporte do aplicativo n\00E3o podem continuar at\00E9 que esses problemas sejam resolvidos.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447929491311685)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Objeto Existe: <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107447882905311685)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios Necess\00E1rios: <br /> %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433014941311674)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use esta p\00E1gina para controlar o acesso dos desenvolvedores de aplicativos, administradores de espa\00E7os de trabalho e usu\00E1rios finais ao Application Express.</p>'),
'',
unistr('<p><strong>Administradores de espa\00E7os de trabalho</strong> podem instalar, remover ou fazer upgrade de aplicativos, assim como gerenciar contas de usu\00E1rios, grupos e servi\00E7os de desenvolvimento.</p>'),
'',
'<p><strong>Desenvolvedores</strong> podem instalar, remover ou fazer upgrade de aplicativos.</p>',
'',
unistr('<p><strong>Usu\00E1rios finais</strong> n\00E3o t\00EAm privil\00E9gios de desenvolvimento e podem acessar somente os aplicativos que n\00E3o usam um esquema externo de autentica\00E7\00E3o.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404388082311654)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um espa\00E7o de trabalho da lista abaixo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106674042620311072)
,p_name=>'PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487868727310930)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o PLSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740798972311131)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de valores baseada no corpo da fun\00E7\00E3o PL/SQL que retorna uma instru\00E7\00E3o SQL que cont\00E9m erros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433808482310885)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680330555311077)
,p_name=>'PLSQL_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o PL/SQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975351333311325)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos de Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106953723748311309)
,p_name=>'PLUGIN'
,p_message_language=>'pt-br'
,p_message_text=>'Plug-in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357923844311621)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357632023311620)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'pt-br'
,p_message_text=>'Efeito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357825002311620)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Executar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408785079311657)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'pt-br'
,p_message_text=>'Inicializar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357433851311620)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'pt-br'
,p_message_text=>'Diversos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107348787243311614)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357712929311620)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357509376311620)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106907685021311268)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'pt-br'
,p_message_text=>' [Obsoleto]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106693890377311087)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'pt-br'
,p_message_text=>' [Plug-in]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240141136311534)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'pt-br'
,p_message_text=>' [Legado]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860297179311231)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Esquema de Autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239913705310732)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307611455310791)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307043075310791)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005210651311351)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Processo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307130654310791)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724400939311117)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469673409311700)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se voc\00EA estiver informando um URL, use as strings de substitui\00E7\00E3o <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> e <code>&amp;DEBUG.</code> e a sintaxe <code>&amp;COLUMN_NAME.</code> para definir o ID da linha ou a chave prim\00E1ria na p\00E1gina ')
||'de destino, ou para definir valores de atributo adicionais.</p>',
'<p><strong>Exemplos</strong></p>',
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
'<p>Para obter mais detalhes sobre a sintaxe <code>f?p</code>, consulte o Application Express Builder User''s Guide.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725538445311118)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O plug-in foi criado com sucesso.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057293524311392)
,p_name=>'PNONUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Percentual de funcion\00E1rios fora dos Estados Unidos')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435606151310887)
,p_name=>'POPUP_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774144011311158)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista de Valores Popup'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734568175311126)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processo de P\00F3s-autentica\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734312275311126)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processo de Pr\00E9-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617693547311031)
,p_name=>'PRECISION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Precis\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106954908662311310)
,p_name=>'PREFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426716346310880)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('aplicar permiss\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427352758310881)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o \00E9 necess\00E1ria uma a\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427031960310880)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('revogar permiss\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292817808310780)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Prefer\00EAncia em Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292945164310780)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Prefer\00EAncia da Express\00E3o 1 N\00C3O \00C9 Igual \00E0 Express\00E3o 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106394900943310857)
,p_name=>'PRESENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apresenta\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454540339310901)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento, a impress\00E3o do relat\00F3rio n\00E3o est\00E1 dispon\00EDvel. N\00E3o h\00E1 um servidor de impress\00E3o configurado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702556413311094)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avan\00E7ado (exige o Oracle BI Publisher)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702657641311094)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687762799311083)
,p_name=>'PRIORITIZED'
,p_message_language=>'pt-br'
,p_message_text=>'Priorizado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698200626311091)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Problemas corrigidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698102208311091)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'Problemas identificados'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432563676310884)
,p_name=>'PROCEDURE'
,p_message_language=>'pt-br'
,p_message_text=>'procedimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107346090652311612)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210178383310704)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar C\00F3digo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106210249625310705)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296801194310783)
,p_name=>'PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>'Processos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230317867310723)
,p_name=>'PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processando a sua solicita\00E7\00E3o. Aguarde')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019810352311363)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Queda de Produ\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420183358311665)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'pt-br'
,p_message_text=>'Portal de Produtos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434946172311676)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Prompt: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249955344310741)
,p_name=>'PROVIDER'
,p_message_language=>'pt-br'
,p_message_text=>'Provedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250034227310741)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail do Provedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706941548311097)
,p_name=>'PROVISIONED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provisionado',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821405978311201)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o provisionado existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702735501311094)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Solicita\00E7\00E3o do Usu\00E1rio com verifica\00E7\00E3o de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702945415311094)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'pt-br'
,p_message_text=>'Manual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702808817311094)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por Solicita\00E7\00E3o do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441185033310891)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es sobre o Administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442154804310892)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tablespace ser\00E1 criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442395339310892)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo de dados para tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440926133310891)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441394116310891)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442270752310892)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'pt-br'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440627922310890)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440456241310890)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou o provisionamento de um novo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441967691310891)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441708924310891)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Reutilizar Esquema Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441615544310891)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es do Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442009473310892)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440785640310891)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440889738310891)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sistema Atribu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441471839310891)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441245567310891)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440509235310890)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441802564310891)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745907670311135)
,p_name=>'PROXY_SERVER'
,p_message_language=>'pt-br'
,p_message_text=>'Servidor Proxy'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427883926310881)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a atualiza\00E7\00E3o da ajuda do seguinte item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427942661310881)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se estiver correto, clique em Atualizar Tudo. Caso contr\00E1rio, clique em Cancelar.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051679460311388)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'pt-br'
,p_message_text=>'Administradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047328799311384)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Iniciar exclus\00E3o do espa\00E7o de trabalho %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047172743311384)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Iniciar elimina\00E7\00E3o do tablespace %0 do espa\00E7o de trabalho %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046756384311383)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Iniciar elimina\00E7\00E3o do usu\00E1rio %0 do espa\00E7o de trabalho %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046364024311383)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Iniciar expurga\00E7\00E3o do espa\00E7o de trabalho %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051520460311388)
,p_name=>'PURGE.BYTES'
,p_message_language=>'pt-br'
,p_message_text=>'Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047608539311384)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao excluir o espa\00E7o de trabalho %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047295952311384)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao eliminar o espa\00E7o de trabalho %0 do espa\00E7o de trabalho %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047065036311384)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao eliminar o usu\00E1rio %0 do espa\00E7o de trabalho %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046107595311383)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Prezado(a) Usu\00E1rio(a) do Oracle APEX,'),
'',
unistr('O Espa\00E7o de Trabalho %0 em %1 n\00E3o mostrou nenhuma atividade recente.  Seu espa\00E7o de trabalho inativo est\00E1 programado no momento para ser expurgado em ou ap\00F3s %2.'),
'',
unistr('Para evitar que seu espa\00E7o de trabalho seja removido, clique no URL abaixo e especifique que voc\00EA n\00E3o deseja que seu espa\00E7o de trabalho seja expurgado.  Voc\00EA deve fazer isso dentro do(s) pr\00F3ximo(s) %3 dia(s).  Se n\00E3o precisar mais deste espa\00E7o de tra')
||unistr('balho, nenhuma a\00E7\00E3o \00E9 necess\00E1ria.'),
'',
unistr('Link de confirma\00E7\00E3o:  %4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046291931311383)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho do Oracle APEX a ser Expurgado:   Workspace %0 em %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047451086311384)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Finalizar exclus\00E3o do espa\00E7o de trabalho %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107358313197311621)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Finalizar elimina\00E7\00E3o do tablespace %0 para o espa\00E7o de trabalho %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046968185311384)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Finalizar elimina\00E7\00E3o do usu\00E1rio %0 do espa\00E7o de trabalho %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044298506311382)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionando espa\00E7o de trabalho %0 \00E0 lista de expurga\00E7\00E3o, dias inativos pelo menos %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044320296311382)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Removendo o espa\00E7o de trabalho %0 da lista de expurga\00E7\00E3o devido \00E0 atividade recente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044487238311382)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail enviado para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044869655311382)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de trabalho movido %0 da lista retida para a lista de expurga\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050770079311387)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'pt-br'
,p_message_text=>'Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048164502311385)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050662383311387)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050368091311386)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'pt-br'
,p_message_text=>'Esquemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048056740311385)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048495364311385)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Removido da Lista de Expurga\00E7\00E3o (em decorr\00EAncia da atividade recente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049161030311385)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionado Novamente \00E0 lista de Expurga\00E7\00E3o (anteriormente retido, mas nenhuma atividade ocorreu em %0 dias)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048806955311385)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Rec\00E9m-Adicionado \00E0 Lista de Expurga\00E7\00E3o (nenhuma atividade em %0 dias)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049788769311386)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'pt-br'
,p_message_text=>'Expurgado Hoje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048693570311385)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retido (o administrador solicitou que o espa\00E7o de trabalho n\00E3o seja expurgado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049372128311386)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'pt-br'
,p_message_text=>'A Ser Expurgado em %0 dia(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050408845311386)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'pt-br'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050221950311386)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049856643311386)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho Restantes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044616520311382)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'pt-br'
,p_message_text=>'Resposta gravada do e-mail %0 valor de: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051316427311387)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046488297311383)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definindo o status do esquema %0 para o status %1 para o espa\00E7o de trabalho %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046528935311383)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o do status do tablespace %0 para status %1 para o espa\00E7o de trabalho %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056825283311392)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resumo de Expurga\00E7\00E3o do Espa\00E7o de Trabalho Di\00E1rio do Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051468856311387)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051997173311388)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho Adicionados Novamente \00E0 lista de Expurga\00E7\00E3o (anteriormente retidos, mas nenhuma atividade ocorreu em %0 dias)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051857649311388)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho Rec\00E9m-Adicionados \00E0 Lista de Expurga\00E7\00E3o (nenhuma atividade em %0 dias)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050862265311387)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resumo de Espa\00E7os de Trabalho Expurgados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051097939311387)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho Expurgados Hoje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052037293311388)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho Removidos da Lista de Expurga\00E7\00E3o (em decorr\00EAncia da atividade recente)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052185858311388)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho Retidos (o administrador solicitou que o espa\00E7o de trabalho n\00E3o seja expurgado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051706542311388)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho a Serem Expurgados em %0 Dia(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051233514311387)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047975344311384)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Expurga\00E7\00E3o do espa\00E7o de trabalho %0 conclu\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349879122311615)
,p_name=>'PURGED'
,p_message_language=>'pt-br'
,p_message_text=>'Expurgado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434553259311675)
,p_name=>'PURGE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Expurgar: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812050184311193)
,p_name=>'QB_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('&nbsp;A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489244414310931)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma consulta v\00E1lida para ver os resultados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811838669311193)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este nome j\00E1 est\00E1 sendo usado por uma consulta existente no Query Builder ou no Processador de Comandos SQL.<br> '),
'Selecione outro nome e salve novamente.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670575473311070)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Nada para salvar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650747599311055)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta Salva.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817318075311198)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es da Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817495175311198)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770140967311155)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O Visual Query Builder n\00E3o pode abrir a consulta atual.<br>'),
'Clique em Criar para substituir a sua consulta atual por uma nova consulta ou clique em Retornar para manter a consulta atual.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770006139311154)
,p_name=>'QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295193693310781)
,p_name=>'QUERY BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'Construtor de Consultas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462035847310907)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('consulta inv\00E1lida, n\00E3o foi encontrada instru\00E7\00E3o selecionada')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294947398310781)
,p_name=>'QUESTIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Perguntas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014306110311359)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de formato num\00E9rico: 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820350062311200)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Sobre o Quick SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820486993311200)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O Quick SQL fornece uma forma r\00E1pida de gerar a SQL necess\00E1ria para criar um modelo de dados relacional com base em um documento de texto endentado. Essa ferramenta foi projetada para reduzir o tempo e o esfor\00E7o necess\00E1rios para criar tabelas SQL,')
||unistr(' triggers e estruturas de \00EDndice. Essa ferramenta n\00E3o foi projetada para ser um substituto da modelagem de dados; ela \00E9 simplesmente uma forma r\00E1pida de desenvolver um script para tabelas e views simples. Quando a instru\00E7\00E3o SQL \00E9 gerada, ela pode ser')
||' ajustada e expandida.</p>',
'',
'<p>Principais Casos de Uso:',
'<ul>',
unistr('  <li>Cria\00E7\00E3o r\00E1pida de modelos de dados robustos</li>'),
unistr('  <li>Salve a sintaxe resumida do Quick SQL como um modelo para itera\00E7\00E3o por meio de altera\00E7\00F5es no modelo ou se como um modelo para acelerar o pr\00F3ximo projeto de modelo</li>'),
unistr('  <li>Gera\00E7\00E3o f\00E1cil de dados aleat\00F3rios</li>'),
'  <li>Aprendizado da sintaxe SQL: create table, select, insert, index, trigger, PL/SQL package e view usando os exemplos fornecidos</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713270380311108)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta defini\00E7\00E3o controla a sintaxe gerada para suportar colunas de auditoria. Especificamente, se as colunas de auditoria forem reativadas, ser\00E3o gerados triggers para manter o usu\00E1rio que criar uma linha e o usu\00E1rio que atualizou uma linha pela \00FAltim')
||unistr('a vez. Quando ativada, a seguinte fun\00E7\00E3o \00E9 usada:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713360196311108)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando n\00E3o ativada, a seguinte fun\00E7\00E3o \00E9 usada:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713401194311108)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>'Gera APIs PL/SQL em todas as tabelas para criar, inserir, atualizar, excluir e consultar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713572279311109)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'pt-br'
,p_message_text=>'Adiciona colunas criado, criado_por, atualizado e atualizado_por a cada tabela criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713697302311109)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando ativada, cria todas as tabelas compactadas. O padr\00E3o \00E9 n\00E3o compactado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713708940311109)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando as Colunas de Auditoria est\00E3o ativadas, a coluna padr\00E3o usada para rastrear o usu\00E1rio que criou uma linha \00E9 CREATED_BY. Use esta defini\00E7\00E3o para substituir o nome de coluna de auditoria padr\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106713891010311109)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quando as Colunas de Auditoria est\00E3o ativadas, a coluna padr\00E3o usada para rastrear o usu\00E1rio que criou uma linha \00E9 CREATED. Use esta defini\00E7\00E3o para substituir o nome de coluna de auditoria padr\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106715843559311110)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por padr\00E3o, todas as colunas de DATA criadas usando o tipo de dados DATA da Oracle. Use essa defini\00E7\00E3o para substituir o padr\00E3o. Os valores v\00E1lidos s\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106718199139311112)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica a vers\00E3o do banco de dados com a qual a sintaxe deve ser compat\00EDvel. Os valores v\00E1lidos s\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722597407311115)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390162424311644)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Departamentos e Funcion\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390703358311644)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sintaxe SQL resumida que cria uma tabela DEPARTAMENTOS e FUNCION\00C1RIOS com uma VIEW de jun\00E7\00E3o SQL. Tamb\00E9m s\00E3o gerados dados aleat\00F3rios usando a sintaxe /INSERT. /NN adiciona uma restri\00E7\00E3o de coluna SQL NOT NULL. Listas endentadas s\00E3o usadas para def')
||unistr('inir tabelas, colunas e tabelas filhos. As colunas de chave prim\00E1ria e externa s\00E3o adicionadas automaticamente. Voc\00EA n\00E3o precisa fornecer nenhuma coluna de chave prim\00E1ria ou externa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642663424311049)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106721272273311114)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>'Inclua comandos SQL para soltar cada objeto de dados criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390310230311644)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Habilidades do Funcion\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390546706311644)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria uma tabela de DEPARTAMENTOS, FUNCION\00C1RIOS e HABILIDADES usando a endenta\00E7\00E3o para identificar tabelas pais e filhos. A sintaxe VC255 resumida \00E9 usada para especificar um tipo de dados SWL. A sintaxe /INSERT \00E9 usada para gerar dados aleat\00F3rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642404311311048)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820771386311201)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723288808311116)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gere automaticamente uma coluna de chave prim\00E1ria de ID para cada tabela.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820557872311200)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conceitos B\00E1sicos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820694003311200)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite nomes de tabela m\00E3e sem endenta\00E7\00E3o. Insira colunas de tabela com uma endenta\00E7\00E3o uniforme de 2 ou mais espa\00E7os. Em geral, \00E9 melhor n\00E3o especificar chaves prim\00E1rias. O sistema vai ger\00E1-las para voc\00EA. Os relacionamentos m\00E3e/filho s\00E3o criados s')
||unistr('implesmente endentando tabelas filhas sob as tabelas m\00E3es.</p>'),
'',
unistr('<p>Os tipos de dados em geral adotam o padr\00E3o VARCHAR2; caso voc\00EA queira uma coluna de outro tipo de dados, adicione um espa\00E7o NUM, INT, DATE ao final de um nome de coluna. Com base no texto em ingl\00EAs contido no nome da coluna, e na aus\00EAncia de algum')
||unistr(' tipo de dados especificado, o sistema deduzir\00E1 alguns nomes de coluna. Por exemplo, se o nome da coluna contiver a palavra DATA, trata-se de um tipo de dados de data; se o nome da coluna contiver a palavra N\00DAMERO ou NUM, ser\00E1 um tipo de dados num\00E9ri')
||unistr('co. Caso queira especificar um tamanho espec\00EDfico para VARCHAR2, digite VCn, em que "n" \00E9 o tamanho de VARCHAR2. Clique no bot\00E3o Sintaxe para mostrar a sintaxe dispon\00EDvel. Os nomes de objeto ser\00E3o formatados automaticamente, substituindo espa\00E7os por ')
||unistr('caracteres de sublinhado, para que voc\00EA possa usar espa\00E7os em nomes de coluna e tabela.</p>'),
'',
unistr('<p>Clique no bot\00E3o Defini\00E7\00F5es para ver muitas op\00E7\00F5es de gera\00E7\00E3o. Voc\00EA pode adicionar automaticamente "Colunas Quem", por exemplo, quem criou ou atualizou por \00FAltimo uma determinada linha e quando. Voc\00EA pode adicionar uma coluna de sequ\00EAncia de linhas')
||unistr(' que seja automaticamente incrementada em 1 unidade em cada atualiza\00E7\00E3o de linha. Uma sequ\00EAncia de linhas pode ser \00FAtil para simplificar a detec\00E7\00E3o de atualiza\00E7\00E3o perdida. Tamb\00E9m \00E9 poss\00EDvel gerar uma API PL/SQL, a qual forne\00E7a um pacote por tabela e ')
||'procedimentos para consultar, inserir, atualizar e excluir linhas.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395417058311647)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'pt-br'
,p_message_text=>'Gera a API do package PL/SQL para consultar, inserir, atualizar e excluir dados de uma tabela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395507138311647)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adiciona a auditoria da Oracle, por padr\00E3o AUDIT ALL ON [NOME DA TABELA].')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395601890311648)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adiciona automaticamente as colunas ATUALIZADO, ATUALIZADO_POR, INSERIDO e INSERIDO_POR e a l\00F3gica do trigger para definir valores de coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394887243311647)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adiciona uma restri\00E7\00E3o CHECK do tipo ''between'' na coluna, por exemplo, /between 1 and 100')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394212872311646)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria uma restri\00E7\00E3o de marca\00E7\00E3o com valores delimitados por v\00EDrgulas ou espa\00E7os em branco, por exemplo, /check Yes, No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724308100311117)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefixa todas as colunas de uma determinada tabela com esse valor. Adiciona automaticamente um caractere de sublinhado, se um prefixo n\00E3o for fornecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106764458469311150)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395210001311647)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coloca os coment\00E1rios entre colchetes ou usa a sintaxe dash dash')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395792046311648)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A tabela ser\00E1 criada na forma compactada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394317104311646)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'pt-br'
,p_message_text=>'Ao gerar dados, definia esta coluna para um valor constante. Por exemplo, /constant NYC.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227679700311523)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adiciona um valor padr\00E3o se a coluna tiver um valor nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724253221311117)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Adiciona uma coluna BLOB e colunas _FILENAME, _CHARSET, _MIMETYPE, _LASTUPD que aprimorem a capacidade de download de arquivos via browser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395051449311647)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias de chave externa, por exemplo, /references table_name. Observe que voc\00EA pode fazer refer\00EAncia a tabelas que n\00E3o fazem parte do seu modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394917745311647)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As colunas ocultas n\00E3o s\00E3o exibidas usando select * from table.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106988204658311336)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ser\00E1 criado um \00EDndice n\00E3o exclusivo na coluna associada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395815277311648)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera <strong>NN</strong> instru\00E7\00E3o(\00F5es) SQL INSERT com dados aleat\00F3rios, por exemplo: /INSERT 20. (Maximum = 1000)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394662841311647)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imp\00F5e o uso de min\00FAsculas nos valores de coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395358017311647)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('NNN identifica um n\00FAmero entre 1 e 32.767.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394790633311647)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adiciona uma restri\00E7\00E3o n\00E3o nula na coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395115609311647)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identifica a coluna como a chave prim\00E1ria da tabela. Recomenda-se n\00E3o especificar manualmente chaves prim\00E1rias e permitir que este aplicativo crie automaticamente as colunas de chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107396092348311648)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera a capacita\00E7\00E3o de REST da tabela usando o ORDS (Oracle REST Data Services)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107395915216311648)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gera a instru\00E7\00E3o SQL SELECT ap\00F3s gerar dados para cada tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106529994780310965)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerar restri\00E7\00E3o exclusiva no n\00EDvel da tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394160531311646)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria uma restri\00E7\00E3o exclusiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394573034311647)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imp\00F5e o uso de mai\00FAsculas nos valores de coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394427359311647)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de valores separados por v\00EDrgulas a ser usada ao gerar dados. Por exemplo, /values 1, 2, 3, 4 ou /values Yes, No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106823159494311202)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Criando os Objetos de Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851091844311224)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quando tiver acabado de inserir o Resumo do Quick SQL e aplicar as defini\00E7\00F5es apropriadas, voc\00EA estar\00E1 pronto para usar a SQL para criar os objetos de banco de dados, e potencialmente preencher as tabelas com dados aleat\00F3rios. Siga estas etapas:<b')
||'r>',
'<ol>',
unistr('  <li>Clique em <strong>Salvar Modelo</strong> para salvar a sintaxe resumida do Quick SQL como um modelo, para reutiliz\00E1-lo no futuro.</li>'),
'  <li>Digite um nome para o modelo.</li>',
unistr('  <li>Clique em <strong>Salvar Script SQL</strong> para salvar a sa\00EDda na forma de script.</li>'),
'  <li>Digite um nome de script.</li>',
unistr('  <li>Clique em <strong>Revisar e Executar</strong> para navegar at\00E9 o Editor de Script.</li>'),
unistr('  <li>No Editor de Script, analise o conte\00FAdo do script para ver se est\00E1 correto.</li>'),
'  <li>Clique em <strong>Executar</strong> para criar os objetos de banco de dados.</li>',
unistr('  <li>Na p\00E1gina de confirma\00E7\00E3o do script, clique em <strong>Executar Agora</strong>.</li>'),
unistr('  <li>Na p\00E1gina de resultados, analise as instru\00E7\00F5es processadas, bem-sucedidas e com erros.<br>'),
unistr('  Se algum erro for reportado, navegue pelas p\00E1ginas de resultado para ver as mensagens de erro espec\00EDficas da Oracle.</li>'),
unistr('  <li>Opcionalmente, clique em <strong>Criar Aplicativo Usando Script</strong> para ir at\00E9 o Assistente de Cria\00E7\00E3o de Aplicativo e fazer com que as p\00E1ginas sejam geradas automaticamente com base nas tabelas e views especificadas no script.</li>'),
'</ol>',
'</p>',
'',
unistr('<p><em><strong>Observa\00E7\00E3o:</strong> A Oracle recomenda fazer download da SQL resumida para o seu computador, caso queira atualizar essa SQL resumida no futuro. Se voc\00EA tiver especificado alguma defini\00E7\00E3o, navegue at\00E9 a parte inferior do painel Sa\00EDda ')
||unistr('do Oracle SQL e copie a linha que come\00E7a com <code># settings =</code> para a parte superior do painel Resumo do Quick SQL.<br>'),
'Clique em <strong>Fazer Download</strong> para salvar o arquivo SQL no seu computador.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722211732311115)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gere dados usados para instru\00E7\00F5es insert usando este idioma. O padr\00E3o \00E9 ingl\00EAs. Os idiomas suportados incluem: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722493611311115)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica identificadores de uso mais longos a serem usados para nomes de objetos de banco de dados. Quanto ativados, os identificadores mais longos permitem que os nomes de objeto tenham at\00E9 128 caracteres. Quando n\00E3o ativados, o tamanho m\00E1ximo de ')
||unistr('um objeto \00E9 de 30 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722648850311116)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Permite que identificadores mais longos sejam usados para nomes de objeto de banco de dados. Os identificadores mais longos permitem que o tamanho m\00E1ximo de um tipo de dados de coluna VARCHAR2 seja de 32.767 caracteres. Quando n\00E3o ativado, o tamanho ')
||unistr('m\00E1ximo de um tipo de dados de coluna VARCHAR2 ser\00E1 de 4.000 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722717619311116)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta defini\00E7\00E3o controla defini\00E7\00F5es ON DELETE da chave externa. Os valores v\00E1lidos incluem: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722857441311116)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Quanto ativada, todas as defini\00E7\00F5es do aplicativo configuradas via console de interface de usu\00E1rio s\00E3o ignoradas e somente as defini\00E7\00F5es configuradas no script s\00E3o usadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106722972836311116)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determina como a chave prim\00E1ria ser\00E1 definida. As chaves prim\00E1rias podem ser definidas usando SYS_GUID, coluna de identidade ou sequ\00EAncia. Os valores v\00E1lidos incluem:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723133392311116)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use o nome da tabela como prefixo para as colunas da tabela de banco de dados de chave prim\00E1ria. Por exemplo, a chave prim\00E1ria da tabela FUNCION\00C1RIO seria ID_FUNCION\00C1RIO. Sem a defini\00E7\00E3o, o nome da chave prim\00E1ria criada implicitamente seria ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723013960311116)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefixo do objeto de banco de dados. Um caractere de sublinhado ser\00E1 anexado, se o prefixo n\00E3o for fornecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390215319311644)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'pt-br'
,p_message_text=>'Vendas do Produto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390809573311644)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sintaxe resumida que cria um esquema em estrela com as tabelas PRODUTOS, CLIENTES, CANAIS, PROMO\00C7\00D5ES e VENDAS. A tabela VENDAS cont\00E9m refer\00EAncias de chave externa \00E0s outras tabelas. Uma VIEW SQL tamb\00E9m \00E9 criada, a qual junta todas as 5 tabelas. Tamb\00E9')
||unistr('m s\00E3o geradas amostras de dados aleat\00F3rios. Colunas num\00E9ricas s\00E3o identificadas com a sintaxe NUM.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390057891311643)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciamento de Projetos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390689616311644)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria uma tabela PROJECT_MANAGEMENT e quatro tabelas detalhadas. Duas views s\00E3o criadas usando a sintaxe /VIEW. As restri\00E7\00F5es CHECK do banco de dados tamb\00E9m s\00E3o adicionadas usando a sintaxe /CHECK. Tamb\00E9m usa #APEX para configurar defini\00E7\00F5es que contr')
||unistr('olam a gera\00E7\00E3o da sintaxe SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723382849311116)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reconfigura todas as defini\00E7\00F5es do aplicativo aos valores padr\00E3o. Quando inclu\00EDda, todas as defini\00E7\00F5es do aplicativo ativas no momento para sua sess\00E3o s\00E3o ignoradas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723433736311116)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para cada tabela criada, adicione uma coluna ROW_KEY que gere um identificador alfanum\00E9rico. Os valores da coluna ROW_KEY ser\00E3o definidos pela l\00F3gica do trigger da tabela de banco de dados gerada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723629109311116)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para cada tabela gerada, adicione uma coluna ROW_VERSION que seja incrementada em 1 unidade para cada atualiza\00E7\00E3o. Quanto ativada, a l\00F3gica de trigger de tabela de banco de dados ser\00E1 gerada para incrementar as vers\00F5es de linha quando houver atualiza')
||unistr('\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723735218311116)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefixe os nomes de objeto com um nome de esquema. O padr\00E3o \00E9 sem prefixo de esquema para nomes de objeto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723573463311116)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para cada tabela, adicione uma coluna TENANT_ID para suportar aplicativos multitenant. O valor desta coluna \00E9 simplesmente adicionado \00E0 tabela; a manuten\00E7\00E3o desse valor precisar\00E1 ser fornecida pelo desenvolvedor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724121105311117)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode optar por n\00E3o haver sem\00E2ntica de coluna, ou pela sem\00E2ntica BYTE ou CHAR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642532676311049)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705794144311096)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voc\00EA pode inserir defini\00E7\00F5es em linha para definir explicitamente op\00E7\00F5es de gera\00E7\00E3o de sintaxe SQL. Como alternativa, voc\00EA pode clicar em <strong>Defini\00E7\00F5es</strong> no alto do painel direito para definir de forma declarativa as op\00E7\00F5es de gera\00E7\00E3o.')
||'</p>',
'',
'<p>Entering settings directly into the Quick SQL Shorthand pane ensures the same SQL generation options are utilized even if you download the script and later paste it back. For example, enter the following to prefix all table names with TEST and gen'
||'erate for schema OBE:<br>',
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
'Alternatively, enter each setting on a separate line for the same result:<br>',
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
'<p><em><strong>Note:</strong> The settings must start on a new line and begin with <code># settings = </code> to enter multiple settings, or <code># </code> to enter a single setting per line. All values are case insensitive. Brackets, spaces, and co'
||'mmas can be added for clarity but are ignored.  To have all settings generated use <code># verbose: true</code>.</em> ',
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642221912311048)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'pt-br'
,p_message_text=>'Sintaxe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412023141311659)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412125893311659)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria tabelas de FAVORECIDOS e TAREFAS. Isso \00E9 designado como um ponto inicial para ativar a cria\00E7\00E3o de um sistema de Tarefas personalizado em quest\00E3o de minutos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723894768311116)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ao ativar colunas de auditoria, use esta defini\00E7\00E3o para substituir o nome da coluna de auditoria padr\00E3o. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106723903908311117)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ao ativar colunas de auditoria, use esta defini\00E7\00E3o para substituir o nome da coluna de auditoria padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106724009155311117)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibe todas as defini\00E7\00F5es, n\00E3o apenas aquelas que sejam diferentes do padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106642309886311048)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Certifique-se de que o nome da view e os nomes de tabelas n\00E3o contenham espa\00E7os. Delimite os nomes de tabela com um espa\00E7o ou v\00EDrgula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106851106017311224)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Carga de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490543564310932)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('An\00E1lise')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698489103311091)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373893303310842)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Por %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490957033310933)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373749536310842)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico por %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106372463805310841)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View Detalhada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490815483310933)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106698530738311091)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'pt-br'
,p_message_text=>'Soma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866472706311236)
,p_name=>'QUICK_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208151001310703)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Faixa em 2D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208261856310703)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Faixa em 3D'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107523750321311739)
,p_name=>'READERS'
,p_message_language=>'pt-br'
,p_message_text=>'Leitores'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107440002092311679)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Reatribuir Item: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231506559310724)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Designar P\00E1ginas Novamente')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106616919705311030)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'pt-br'
,p_message_text=>'Lixeira'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820855586311201)
,p_name=>'REDIRECT'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821069835311201)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este bot\00E3o ser\00E1 redirecionado a um URL. \00C9 prov\00E1vel que ele n\00E3o cause a submiss\00E3o da p\00E1gina. Para que o bot\00E3o submeta a p\00E1gina, n\00E3o identifique uma p\00E1gina de redirecionamento ou um URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487280676310930)
,p_name=>'REDIRECT_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952961357311308)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para o aplicativo %0, p\00E1gina %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487101382310930)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para p\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294716756310781)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina neste Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294818122310781)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106668162736311068)
,p_name=>'REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>'Referenciado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295712430310782)
,p_name=>'REGEN_VER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gerar novamente c\00F3digo de verifica\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670742227311070)
,p_name=>'REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815231363311196)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00F5es do Bot\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734795561311126)
,p_name=>'REGION CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727999304311120)
,p_name=>'REGION CONTENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273649484310765)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106296720256310783)
,p_name=>'REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106454721380310901)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Substitui\00E7\00E3o de Modelo de Lista de Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679011004311076)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Exibi\00E7\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197455987310693)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'pt-br'
,p_message_text=>'Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943369309311300)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215611300310709)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cart\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663384924311064)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239845090310732)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Mapeamento de Coluna de Upload de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677460000311075)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de Exibi\00E7\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008010300311354)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa Facetada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797352719311177)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198544554310694)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto de Ajuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804542905311187)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'pt-br'
,p_message_text=>'Grade Interativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918246519311276)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657714618311060)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376129501311634)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Altern\00E2ncia de Colunas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239769384310732)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View em Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107376258095311634)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Reflow')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943509858311300)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106196974056310692)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380029563311636)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018025433311362)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942911511311300)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico (HTML - LEGADO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106914055141311273)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018162303311362)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106942886164311299)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico (SVG - LEGADO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106918350591311277)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106943417299311300)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Cl\00E1ssica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106197704644310693)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106363741277310834)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Modelo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682733091311079)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'pt-br'
,p_message_text=>'Rejeitado ou Duplicata'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703433679311095)
,p_name=>'RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'Release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250290860310741)
,p_name=>'RELEASED'
,p_message_language=>'pt-br'
,p_message_text=>'Liberado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733356359311125)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Resumo da Release'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733211820311125)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resumo da release para o espa\00E7o de trabalho: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408670743311657)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mais Informa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449700978311686)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Kit de Ferramentas da Web PL/SQL %0 necess\00E1rio <a href="%1" target="_blank">[Mais Informa\00E7\00F5es]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449592113311686)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conjunto de patches %0 est\00E1 dispon\00EDvel <a href="%1" target="_blank">[Mais informa\00E7\00F5es]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449698481311686)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Oracle APEX %0 est\00E1 dispon\00EDvel <a href="%1" target="_blank">[Mais informa\00E7\00F5es]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107408571618311657)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O sistema est\00E1 atualizado')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350045373311615)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Removido por Atividade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106249728970310741)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107241127136311535)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A defini\00E7\00E3o do aplicativo ser\00E1 removida, assim como todos os objetos de suporte que foram criados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106749001402311138)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho foi removido com sucesso.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813206431311194)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Renomear a coluna %0 como %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813404129311194)
,p_name=>'RENAME_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Renomear a tabela %0 como %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530376869310965)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reordenar Bot\00F5es de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545499682310977)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reordenar Entradas da Barra de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530406166310966)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reordenar Regi\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530076270310965)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reordenar Itens de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545353239310977)
,p_name=>'REORDER_TABS'
,p_message_language=>'pt-br'
,p_message_text=>'Reordenar Guias'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650628352311054)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433707900311675)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alias do Relat\00F3rio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650955747311055)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('coluna de relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767515540311152)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742360506311132)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Coluna de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741963684311132)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Form e o Relat\00F3rio foram criados com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706744862311097)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Gerado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774419580311158)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Layout do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106603192253311020)
,p_name=>'REPORT_ON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio em %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106767875301311153)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atributos da P\00E1gina do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106359360202310831)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta \00E9 v\00E1lida. Foi feito o parse das vari\00E1veis de bind.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774329097311158)
,p_name=>'REPORT_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106607928426311023)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa 1 - Fazer Download de arquivo XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608053755311023)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Etapa 2 - Criar layout de relat\00F3rio e salvar como arquivo RTF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608228804311024)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa 2 - Fazer upload do arquivo XSL-FO'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608140899311024)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'pt-br'
,p_message_text=>'Etapa 3 - Fazer upload do arquivo RTF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740415024311131)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas do Relat\00F3rio Extra\00EDdas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106808522860311190)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio foi criado com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106742444406311132)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747632892311136)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina Relat\00F3rio de Resultado de Web Service foi criada com sucesso.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664211884311065)
,p_name=>'REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737945032311129)
,p_name=>'REQUESTED'
,p_message_language=>'pt-br'
,p_message_text=>'Solicitado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002111688311349)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 do espa\00E7o de trabalho "%1" solicitou altera\00E7\00E3o do tamanho do banco de dados para %2 adicionais')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002070835311349)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 solicitou um novo esquema para o espa\00E7o de trabalho "%1" com %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107001967603311349)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 solicita um novo espa\00E7o de trabalho "%1" com tamanho de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251957897310743)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 solicita\00E7\00F5es para o novo espa\00E7o de trabalho "%1"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691080456311085)
,p_name=>'RESEARCHING'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisando novamente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226538369310719)
,p_name=>'RESET_4000'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273437910310764)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir como valor nulo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258320144310749)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo de Consumidores do Resource Manager'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956108528311311)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Acesso Restrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526616092310962)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Restrito - N\00E3o pode ser definido no browser')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744262106311134)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Refer\00EAncia de Web Service foi adicionada ao Aplicativo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356259959310829)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'pt-br'
,p_message_text=>'Com Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154860524311468)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Os Servi\00E7os RESTful do APEX est\00E3o no modo somente para leitura.</p>'),
'',
unistr('<p>Voc\00EA pode usar os servi\00E7os RESTful com base no APEX, conforme eles s\00E3o definidos. Por\00E9m, a Oracle incentiva a migra\00E7\00E3o desses servi\00E7os para o ORDS, clicando em <strong>Migrar para Servi\00E7os RESTful do ORDS</strong>.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151441755311465)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel encontrar a vers\00E3o atualmente em execu\00E7\00E3o do ORDS. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355674386310829)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154725136311468)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta a\00E7\00E3o cancelar\00E1 o registro e remover\00E1 todas as defini\00E7\00F5es de Servi\00E7o REST do ORDS do esquema selecionado. Esta a\00E7\00E3o n\00E3o pode ser desfeita.</p>'),
'',
'<p>Tem certeza de que deseja cancelar o registro deste esquema?</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106604715487311021)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um Prefixo de Caminho APEX com esse valor j\00E1 foi definido para outro espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666090467311066)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este alias de esquema j\00E1 est\00E1 sendo usado por outro esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355572885310828)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391243896311644)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Total de Objetos Ativados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339333071310817)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O caractere Glob (*) s\00F3 pode ser exibido em um Padr\00E3o de Rota como o \00FAltimo caractere e s\00F3 pode ser precedido por um Par\00E2metro Nomeado ou por uma barra comum (/).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004389221311351)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Identificador Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004597240311351)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Identificador Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974032322311324)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Esperava um ID do Identificador e recebeu NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004471220311351)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'Identificador Atualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339223372310816)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caracteres inv\00E1lidos foram encontrados nas partes literais do Padr\00E3o de Rota.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376138386310843)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o Necess\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424159777311668)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">Clicar no bot\00E3o Migrar copiar\00E1 os metadados de todos os servi\00E7os REST Baseados no APEX para o ORDS. As defini\00E7\00F5es dos servi\00E7os Baseados no APEX existentes permanecer\00E3o intactas, mas n\00E3o ser\00E3o executadas a ')
||unistr('n\00E3o ser que um servi\00E7o correspondente exista no ORDS. '),
'',
unistr('\00C9 sugerido que, ap\00F3s a migra\00E7\00E3o, voc\00EA valide e teste os servi\00E7os Baseados no ORDS migrados. Uma vez verificado, exporte e exclua os servi\00E7os baseados no APEX.</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107424040816311668)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>O APEX detectou que seu espa\00E7o de trabalho cont\00E9m 2 ou mais m\00F3dulos REST Baseados no APEX com Prefixos de URI NULOS. O ORDS n\00E3o permite que mais de um M\00F3dulo tenha o mesmo Prefixo de URI base. </p>'),
'',
unistr('<p>Para migrar esses servi\00E7os para o ORDS, as seguintes regras ser\00E3o aplicadas: </p>'),
'',
'<ul>',
unistr('<li>Todos os m\00F3dulos afetados ser\00E3o contra\00EDdos em um \00FAnico m\00F3dulo do ORDS chamado <em><strong>merged.apex.rest.services</strong></em>.</li>'),
unistr('<li>Se <strong><em>qualquer</em></strong> um dos m\00F3dulos baseados no APEX que est\00E3o sendo mesclados for publicado, o novo m\00F3dulo mesclado <strong><em>ser\00E1 publicado</em></strong>.</li>'),
unistr('<li>Se <strong><em>nenhum</em></strong> dos m\00F3dulos baseados no APEX que est\00E3o sendo mesclados for publicado, o novo m\00F3dulo mesclado <strong><em>n\00E3o ser\00E1 publicado</em></strong>.</li>'),
unistr('<li><strong><em>Todas as atribui\00E7\00F5es</em></strong> associadas aos m\00F3dulos baseados no APEX que est\00E3o sendo mesclados <strong><em>ser\00E3o designadas ao novo m\00F3dulo mesclado</em></strong>.</li>'),
unistr('<li>O <strong><em>tamanho da pagina\00E7\00E3o</em></strong> do m\00F3dulo mesclado ser\00E1 definido como o <strong><em>tamanho da pagina\00E7\00E3o maior</em></strong> dentre os m\00F3dulos que est\00E3o sendo mesclados.</li>'),
unistr('<li>Se houver m\00F3dulos do APEX com URIs base NULOS que tamb\00E9m t\00EAm URIs modelo duplicados, ocorrer\00E1 o seguinte:'),
'',
'<ul>',
unistr('<li>O modelo atualizado mais recentemente manter\00E1 o URI duplicado</li>'),
unistr('<li>Todos os outros modelos ser\00E3o prefixados com dup001_*</li>'),
unistr('<li>O coment\00E1rio para o modelo conter\00E1 o nome do m\00F3dulo original do qual ele foi migrado e o URI do modelo original</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423926528311668)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>O APEX detectou que seu espa\00E7o de trabalho cont\00E9m 2 ou mais m\00F3dulos REST Baseados no APEX com Prefixos de URI NULOS. O ORDS n\00E3o permite que mais de um M\00F3dulo tenha o mesmo Prefixo de URI base. </p>'),
'',
unistr('<p>No momento, n\00E3o \00E9 poss\00EDvel migrar seus Servi\00E7os REST Baseados no APEX para o ORDS. A migra\00E7\00E3o estar\00E1 dispon\00EDvel no ORDS vers\00E3o 18.2 em diante.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107390911648311644)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Total de M\00F3dulos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003757831311350)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3dulo Criado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003985990311350)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3dulo Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973892335311324)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperava um ID do M\00F3dulo e recebeu NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003836141311350)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3dulo Atualizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339063135310816)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um par\00E2metro nomeado no Padr\00E3o de Rota cont\00E9m caracteres inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107221037960311518)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema n\00E3o foi registrado com os Servi\00E7os de Dados de RESTful do ORDS. Para registrar este esquema, clique em <strong>Registrar Esquema com ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339479662310817)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URI n\00E3o corresponde ao padr\00E3o de estilo ROUTE ou URI.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339541872310817)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 permitido ter mais de 1 barra normal consecutiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338921246310816)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o tem permiss\00E3o para ter uma string de consulta em um Padr\00E3o de Rota.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106242981065310734)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Atualmente, o APEX est\00E1 sendo executado no CDB. Voc\00EA n\00E3o pode definir Servi\00E7os REST baseados no ORDS no CDB.</p><p>Voc\00EA pode continuar usando os Servi\00E7os RESTful Baseados no APEX.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107154622826311468)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A vers\00E3o de ORDS atualmente instalada (%0) n\00E3o suporta toda funcionalidade necess\00E1ria para ativar os Servi\00E7os RESTful Baseados no ORDS no Application Express. Uma vers\00E3o m\00EDnima de %1 deve ser instalada.</p>'),
unistr('<p>Voc\00EA pode continuar usando os Servi\00E7os RESTful Baseados no APEX.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339156209310816)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O caractere Opcional (?) s\00F3 pode ser exibido em um Padr\00E3o de Rota como o \00FAltimo caractere e deve ser precedido por um Par\00E2metro Nomeado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337975028310816)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>O sistema n\00E3o p\00F4de localizar o esquema ORDS_METADATA, que \00E9 exigido para ativar o ORDS REST Workshop. Consulte as etapas de instala\00E7\00E3o no Oracle REST Data Services Installation Guide.</p> <p>Voc\00EA pode continuar a usar os Servi\00E7os RESTful Baseados ')
||'no APEX.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356188183310829)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'pt-br'
,p_message_text=>'Parcialmente Protegido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337872194310815)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Este sistema atualmente est\00E1 usando o Oracle Embedded PL/SQL Gateway. Instale a vers\00E3o %0 ou mais recente do Oracle REST Data Services para permitir o acesso ao ORDS REST Workshop.</p> <p>Voc\00EA pode continuar a usar os Servi\00E7os RESTful Baseados no ')
||'APEX.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391097195311644)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Total de Privil\00E9gios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004998174311351)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gio Criado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005195146311351)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gio Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005078284311351)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gio Atualizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355774121310829)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'pt-br'
,p_message_text=>'Publicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356817096310829)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta a\00E7\00E3o eliminar\00E1 e recriar\00E1 o m\00F3dulo <strong>oracle.example.hr</strong> e os objetos relacionados do banco de dados no esquema selecionado atualmente. Quaisquer altera\00E7\00F5es ou adi\00E7\00F5es que tenham sido feitas ser\00E3o perdidas e n\00E3o poder\00E3o ser desfe')
||'itas.</p>',
unistr('<p>Tem certeza de que deseja redefinir o servi\00E7o de amostra?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391137954311644)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Total de Atribui\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004629004311351)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o Criada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004861434311351)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o Exclu\00EDda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004703792311351)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o Atualizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376002738310843)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Status de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106376222266310843)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Alias do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151602630311465)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O script submetido a upload \00E9 muito grande. O Application Express tem um limite de 32MB (32767 bytes).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355985763310829)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'pt-br'
,p_message_text=>'Protegido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973922414311324)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperava um ID de Sequ\00EAncia do Par\00E2metro e recebeu NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391485630311644)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>'Falha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391396220311644)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391546218311645)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004035093311350)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004294650311351)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo Exclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974156646311324)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Esperava um ID do Modelo e recebeu NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274163050310765)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Modelo de URI n\00E3o pode ser nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107004105498311350)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo Atualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356432639310829)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos Ativados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356552277310829)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3dulos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356684020310829)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356744298310829)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107379918292311636)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servi\00E7os de Dados RESTful')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356342531310829)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355890704310829)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Publicado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106356037439310829)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Protegido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338861267310816)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma ou mais vari\00E1veis de URI t\00EAm um erro de sintaxe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955052371311310)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O script que voc\00EA est\00E1 tentando carregar \00E9 uma exporta\00E7\00E3o de Servi\00E7o RESTful baseada no APEX. Ele n\00E3o pode ser carregado usando a p\00E1gina de importa\00E7\00E3o de Servi\00E7os RESTFUL do ORDS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218639077311516)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O script que voc\00EA est\00E1 tentando carregar \00E9 uma exporta\00E7\00E3o de Servi\00E7o RESTful baseada no ORDS. Ele n\00E3o pode ser carregado usando a p\00E1gina de importa\00E7\00E3o de Servi\00E7os RESTFUL do APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391658295311645)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar para \00E1rea de transfer\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107391724767311645)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar URL Completo para a \00C1rea de Transfer\00EAncia')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349950944311615)
,p_name=>'RETAINED'
,p_message_language=>'pt-br'
,p_message_text=>'Retido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464696009310909)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voltar para a P\00E1gina de Log-in %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469963604311700)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'pt-br'
,p_message_text=>'Valor de Retorno: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691337021311086)
,p_name=>'REVIEWING'
,p_message_language=>'pt-br'
,p_message_text=>'Verificando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106952743480311308)
,p_name=>'ROLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470889714310913)
,p_name=>'ROLLBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00E3o de rollback n\00E3o aplic\00E1vel. Todas as instru\00E7\00F5es t\00EAm commit autom\00E1tico.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814673356311195)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linhas retornadas em %1 segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294543076310781)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'pt-br'
,p_message_text=>'linhas retornadas em'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905375480311266)
,p_name=>'RUN'
,p_message_language=>'pt-br'
,p_message_text=>'Executar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219697898310713)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'pt-br'
,p_message_text=>'Executar e Desenvolver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106670837432311070)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908189989311269)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Aplicativo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467539242310911)
,p_name=>'RUN_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Executar Somente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910123720311270)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executar P\00E1gina: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106273704384310765)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos de Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867924616311237)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pa\00EDses')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868233506311237)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Listagem de pa\00EDses, popula\00E7\00E3o e capital.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455314658310902)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'pt-br'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455417638310902)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As tabelas FUNC e DEPT gen\00E9ricas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868087577311237)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('F\00F3rmula 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868424845311237)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Campe\00F5es Mundiais de F\00F3rmula 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349264498311614)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00F5es de Sa\00FAde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349337861311614)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00F5es de status de sa\00FAde simplificadas reportadas pelo paciente, no caso de provedores de assist\00EAncia m\00E9dica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455531847310902)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'pt-br'
,p_message_text=>'Dados de RH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455641217310902)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As tabelas RH gen\00E9ricas comumente usadas pelo Oracle Education.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908282845311269)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'pt-br'
,p_message_text=>'Pedidos de Clientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908321050311269)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um conjunto de clientes, hist\00F3rias, produtos e pedidos. Esse conjunto de dados inclui dados de JSON da descri\00E7\00E3o do produto e da longitude/latitude das hist\00F3rias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455199316310902)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Dados do Projeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455246628310902)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma cole\00E7\00E3o de projetos, marcos, tarefas e muito mais. Este conjunto de dados inclui relacionamentos mestre-detalhe-detalhe e uma visualiza\00E7\00E3o \00FAtil para cria\00E7\00E3o de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455751211310902)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'pt-br'
,p_message_text=>'Planilha de Tarefas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106455804081310902)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma tabela \00FAnica com dados n\00E3o normalizados que cont\00EAm tarefas, datas, status, designado a, e or\00E7amento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867811081311237)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EAnis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868317511311237)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Vencedores e segundos colocados Masculinos e Femininos de eventos de Grand Slam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868174261311237)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'pt-br'
,p_message_text=>'Copa do Mundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868548579311238)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados da Copa do Mundo de Futebol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751708938311140)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Websheet de Amostra'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738549411311129)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>'Alias do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738699591311129)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738726437311129)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mais Relat\00F3rios Salvos...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738261439311129)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Prim\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737589417311128)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'pt-br'
,p_message_text=>'Particular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106737651924311128)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00E3o Particular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738163462311129)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738490366311129)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106738396737311129)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Relat\00F3rio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382524778310848)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada de navega\00E7\00E3o estrutural exclu\00EDda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382775397310848)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada de navega\00E7\00E3o estrutural criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382600439310848)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada da trilha de navega\00E7\00E3o atualizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382435839310848)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Trilha de navega\00E7\00E3o exclu\00EDda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382339931310848)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Trilha de navega\00E7\00E3o atualizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354374079310828)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Grade Interativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354280030310827)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710731535311107)
,p_name=>'SCHEMAS'
,p_message_language=>'pt-br'
,p_message_text=>'Esquemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106822285129311202)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('exce\00E7\00E3o de inser\00E7\00E3o do esquema wwv_flow_companies')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821210148311201)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema "%0" est\00E1 dispon\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821349839311201)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema "%0" N\00C3O est\00E1 dispon\00EDvel no momento e n\00E3o pode ser criado pois est\00E1 em conflito com um usu\00E1rio existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106618959412311032)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435711843310887)
,p_name=>'SCHEMES'
,p_message_language=>'pt-br'
,p_message_text=>'esquemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389852177311643)
,p_name=>'SCREEN_READER'
,p_message_language=>'pt-br'
,p_message_text=>'Leitor de Tela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741831920311132)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altern\00E2ncia do Leitor de Tela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772433959311156)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este arquivo foi exportado por outro espa\00E7o de trabalho (%0); possivelmente em outro banco de dados %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414057129311661)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Script %0 bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413908546311661)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'Script %0 desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423127832311667)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O script n\00E3o est\00E1 bloqueado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106699154873311091)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'Para descobrir um tipo de objeto, digite <br><br> ',
'',
'DESCRIBE &lt nome do objeto &gt no painel de comando acima e clique em Executar.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728612937311120)
,p_name=>'SC_NAME_NN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome da Consulta n\00E3o pode ser nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740697297311131)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
unistr('Objeto a ser descrito n\00E3o p\00F4de ser encontrado.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731291799311123)
,p_name=>'SC_SC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta N\00E3o Visual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106665643961311066)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00E3o SQL em Execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731185012311123)
,p_name=>'SC_VQ'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta Visual'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353692681311617)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es da Barra de Pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773602384311157)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'pt-br'
,p_message_text=>'Campo de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619326460311032)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o existem colunas varchar nessa consulta. N\00E3o \00E9 poss\00EDvel ativar a pesquisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106608737854311024)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o existem colunas varchar para pesquisar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773531992311157)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar Aplicativos de Produtividade e Amostra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107168075346311478)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados da Pesquisa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107355526689311619)
,p_name=>'SECTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se\00E7\00F5es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414520871310871)
,p_name=>'SECURITY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705822752311097)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Favorecido de Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056763586311392)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Grupo de Seguran\00E7a (sua identidade de espa\00E7o de trabalho) inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703939385311095)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impacto de Seguran\00E7a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745848056311135)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732302395311124)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Deve Ser Usu\00E1rio P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706294128311097)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Status de Seguran\00E7a')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731851098311123)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulte o relat\00F3rio anexo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267096801310759)
,p_name=>'SELECT_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613064532311027)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221541266310715)
,p_name=>'SELECT_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione uma data na tabela. M\00EAs Atual = %0, Ano Atual = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107240041903311534)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecionar a\00E7\00E3o din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424183247310878)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424023562310878)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423913792310878)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423819219310878)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424204428310878)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441019006311680)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Linha: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876465482311244)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione um espa\00E7o de trabalho a seguir para abrir o ambiente de desenvolvimento do Application Express.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800047081311179)
,p_name=>'SELF_SERVICE'
,p_message_language=>'pt-br'
,p_message_text=>'Autoatendimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799903050311179)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoatendimento com Verifica\00E7\00E3o de E-mail')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107413651231311661)
,p_name=>'SEPARATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Separador'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432696296310885)
,p_name=>'SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106861092086311232)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297939821310784)
,p_name=>'SERIES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702401067311094)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00E3o de Servi\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245533543310737)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o de Site')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682527158311079)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Servi\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440273260310890)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe um C\00F3digo de Verifica\00E7\00E3o que fa\00E7a distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas e clique em <strong>Enviar Solicita\00E7\00E3o</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439128748310889)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es sobre o Administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440132275310890)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho do Banco de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439064976310889)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439459569310890)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439212515310889)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438832717310889)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Justificativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439326442310889)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Sobrenome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438705962310889)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439932683310890)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439546289310890)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'pt-br'
,p_message_text=>'Telefone'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439728016310890)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Reutilizar Esquema Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439620038310890)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es do Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440049661310890)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438612804310889)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106439874491310890)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631576829311041)
,p_name=>'SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106734244593311126)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Verifica\00E7\00E3o de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106275209648310766)
,p_name=>'SESSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797922635311178)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'pt-br'
,p_message_text=>'Buffer:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797740869311177)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'pt-br'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797432448311177)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797879206311177)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'pt-br'
,p_message_text=>'Disco:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797665452311177)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>'Decorrido:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106797571180311177)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358868331310831)
,p_name=>'SET_BINDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores de todas as vari\00E1veis de bind devem ser definidos ao testar uma consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261040442310751)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Defina a data de vencimento dos %0 recurso(s) incompleto(s) designado(s) a %1 para a release %2 na data do marco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380809930310847)
,p_name=>'SET_MILESTONE'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Marco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261305670310751)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina os recursos com marcos ausentes para o marco (%3) com rela\00E7\00E3o aos %0 recurso(s) incompleto(s) designados a %1 para a release %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106261256530310751)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Altere o marco dos %0 recursos incompleto(s) designado(s) a %1 para a release %2 que correspondem a um marco vencido para o marco (%3).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380494456310846)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 recurso(s) aberto(s) ser\00E1(\00E3o) atribu\00EDdo(s) ao marco selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106380918974310847)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A data de vencimento de %0 recurso(s) aberto(s) ser\00E1 definida para a data do marco.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418164115311664)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir Prefer\00EAncias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381131413310847)
,p_name=>'SET_RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Release'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796720933311177)
,p_name=>'SHARED'
,p_message_language=>'pt-br'
,p_message_text=>'Compartilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975943303311326)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Componentes Compartilhados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733960094311125)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de Valores Din\00E2mica Compartilhada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106230446480310723)
,p_name=>'SHARED POOL'
,p_message_language=>'pt-br'
,p_message_text=>'Shared Pool'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106733855283311125)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o da Lista de Valores Est\00E1tica Compartilhada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305422855310790)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'pt-br'
,p_message_text=>'Componente Compartilhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973210342311324)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o Compartilhada')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435864571310887)
,p_name=>'SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>'atalho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878411738311245)
,p_name=>'SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'Atalhos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106685484129311081)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>'Impacto Significativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106688549475311083)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Progresso Significativo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434308428310886)
,p_name=>'SIMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'simples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679947892311077)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico Simples')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757070308311144)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('16 horas atr\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816541685311197)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 1 dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816479590311197)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 1 hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436455144311677)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'pt-br'
,p_message_text=>'em 16h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816618698311197)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 1 semana')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272034747310763)
,p_name=>'SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392813257311645)
,p_name=>'SL.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388980964311643)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar P\00E1gina %0 no aplicativo %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389055050311643)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Ir para o aplicativo %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218834477311516)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('1 correspond\00EAncia encontrada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107218986442311516)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 correspond\00EAncias encontradas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107236201056311529)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma correspond\00EAncia foi encontrada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392974923311646)
,p_name=>'SL.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106910220658311270)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106955583028311310)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar %0 em todos os aplicativos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389373832311643)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar %0 neste Aplicativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107151007868311465)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Informe pelo menos duas letras para pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389206883311643)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Procurar %0 na P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389491247311643)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar %0 na Equipe de Desenvolvimento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389576913311643)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pesquisar usu\00E1rio%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389655370311643)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Procurar % no Espa\00E7o de Trabalho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107389197967311643)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Componentes Compartilhados do Aplicativo %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682427647311079)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'pt-br'
,p_message_text=>'Defeito de Software'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687421868311083)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um pouco desej\00E1vel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014893731311360)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'pt-br'
,p_message_text=>'Identificador de Origem'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821588454311201)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Utiliza\00E7\00E3o do espa\00E7o existente')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671088869311070)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('SQL n\00E3o dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106878815986311246)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106814566350311195)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'pt-br'
,p_message_text=>'Comandos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709817346311100)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hist\00F3rico de Comandos SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487730057310930)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748181729311137)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747814706311137)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747947314311137)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'pt-br'
,p_message_text=>'Procedimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747701948311137)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106748002191311137)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033589472311374)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O acesso de SQL e PL/SQL n\00E3o est\00E1 ativado para este aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033644246311374)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O acesso de SQL e PL/SQL n\00E3o est\00E1 ativado para esta inst\00E2ncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433496997310885)
,p_name=>'SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239419408310731)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta inv\00E1lida, n\00E3o foi encontrada instru\00E7\00E3o selecionada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534907269310969)
,p_name=>'SQL_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338325612310816)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'pt-br'
,p_message_text=>'Anexar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427115781310880)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427661608310881)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desativar Coluna de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426839334310880)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor para Exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427226674310880)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Classifica\00E7\00E3o Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338253901310816)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>'Substituir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106426995825310880)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor de Retorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427450914310881)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de Classifica\00E7\00E3o Secund\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427586788310881)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710046136311106)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'pt-br'
,p_message_text=>'Scripts SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709934033311106)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados do Script SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019622656311363)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>'Os seguintes objetos do banco de dados precisam ser definidos na lista de tabelas permitidas: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710195885311106)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>'SQL Workshop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106490017712310932)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O alias especificado j\00E1 est\00E1 sendo usado por outro objeto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106489916066310932)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O alias de Objeto que voc\00EA forneceu \00E9 inv\00E1lido. Aliases v\00E1lidos s\00F3 podem conter letras, n\00FAmeros, sublinhados e tra\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106803677344311186)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema n\00E3o foi registrado nos Servi\00E7os de Dados RESTful do ORDS. Para registr\00E1-lo, navegue at\00E9 <strong> Servi\00E7os RESTful >  Servi\00E7os Restful do ORDS</strong> e clique no bot\00E3o <strong>Registrar Esquema no ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818636415311199)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O APEX est\00E1 sendo executado atualmente no CDB. Voc\00EA n\00E3o pode definir Servi\00E7os REST baseados no ORDS no CDB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818478139311199)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vers\00E3o do ORDS instalada atualmente (%0) n\00E3o suporta toda a funcionalidade exigida para ativar objetos de banco de dados REST. Uma vers\00E3o m\00EDnima %1 deve ser instalada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818259039311198)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O sistema n\00E3o p\00F4de localizar o esquema ORDS_METADATA, que \00E9 exigido para ativar os servi\00E7os RESTful do ORDS. Consulte as etapas de instala\00E7\00E3o no Oracle REST Data Services Installation Guide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818536701311199)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ORDS Vers\00E3o <strong>%0</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106818355436311199)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este sistema atualmente est\00E1 usando o Oracle Embedded PL/SQL Gateway. Instale a vers\00E3o %0 ou mais recente do Oracle REST Data Services para ativar objetos de banco de dados REST')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208301375310703)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 2D Sobreposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208464965310703)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 3D Sobreposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208549379310703)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 2D Horizontal Sobreposta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106208674376310703)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna em 3D Horizontal Sobreposta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974786132311325)
,p_name=>'STANDARD _TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guias Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106976452220311326)
,p_name=>'STANDARD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106414682915310871)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto de Guias Padr\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300809359310786)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos de Aplicativo Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300724046310786)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivos de Espa\00E7o de Trabalho Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471471898311702)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'pt-br'
,p_message_text=>'Informe pelo menos uma palavra-chave que tenha pelo menos dois caracteres. '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471526828311702)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar resultados correspondentes \00E0 consulta de pesquisa. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487565482310930)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Designa\00E7\00E3o Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820023991311200)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Aplicativo Associado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106231680190310724)
,p_name=>'STATIC_HTML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('HTML Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215174307310709)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncia Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678727578311076)
,p_name=>'STATIC_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743371906311133)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Strings de Substitui\00E7\00E3o Est\00E1ticas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434177520311675)
,p_name=>'STATUS_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Status: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614551947311028)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'Status Modificado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729957529311122)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de Guia Padr\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423261314311668)
,p_name=>'STEAL_LOCK'
,p_message_language=>'pt-br'
,p_message_text=>'Roubar Bloqueio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274950216310766)
,p_name=>'STORAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Armazenamento:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106433598760310885)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'consulta associada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106534767809310969)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Estruturado')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106820947459311201)
,p_name=>'SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614420928311028)
,p_name=>'SUBMITTED'
,p_message_language=>'pt-br'
,p_message_text=>'Submetido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106530247521310965)
,p_name=>'SUBMIT_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106740182396311131)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter Feedback'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672286762311071)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entrada Atual Subordinada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106672374450311071)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entrada Atual N\00E3o Subordinada')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449084556311686)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mestre N\00E3o Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449292082311686)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449156110311686)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reposit\00F3rio de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416736791310873)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417081553310873)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" deste esquema de autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417286036310873)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 esquemas de autoriza\00E7\00E3o inscritos neste esquema de autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417170446310873)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas de autoriza\00E7\00E3o inscritos neste esquema de autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219105424310713)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219427355310713)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" desta Defini\00E7\00E3o de Carga de Dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219318085310713)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma Defini\00E7\00E3o de Carga de Dados est\00E1 inscrita nesta defini\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219289477310713)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de Carga de Dados com inscri\00E7\00E3o nesta defini\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416145250310872)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416257072310872)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" da ajuda deste item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416408058310872)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 itens inscritos neste texto de ajuda do item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106416377475310872)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Itens com inscri\00E7\00E3o neste texto de ajuda do item')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418752856310874)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418827825310874)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "matriz" desta Lista de Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419095211310874)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 Lista de Valores inscrita nesta Lista de Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418925158310874)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Listas de Valores com inscri\00E7\00E3o nesta Lista de Valores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306876875310791)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420380098310875)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" desta Barra de Navega\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420983366310876)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 Barras de Navega\00E7\00E3o inscritas nesta Barra de Navega\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106420663655310875)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barras de Navega\00E7\00E3o inscritas nesta Barra de Navega\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306401616310790)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306570606310791)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestre" deste plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306788015310791)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum plug-in inscrito neste plug-in.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306680298310791)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Plug-ins com inscri\00E7\00E3o neste plug-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417556585310873)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417731982310873)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" deste atalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418036275310873)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 atalhos inscritos neste atalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417912526310873)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atalhos com inscri\00E7\00E3o neste atalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412373337310869)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412538943310870)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" deste modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412676009310870)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 modelos inscritos neste modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106412478190310870)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo de Lista de Valores Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423414786310877)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos com inscri\00E7\00E3o neste modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387851461311642)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Inscrito no Tema do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107430473476311673)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscrito no Tema Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388245024311642)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" deste tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388156476311642)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum tema faz inscri\00E7\00E3o a este tema. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387995008311642)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Tema da Lista de Valores da Popup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107388044827311642)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Temas com inscri\00E7\00E3o neste tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795777521311176)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795879147311176)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" desta Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796051536311176)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma Origem de Dados REST est\00E1 inscrita nesta Origem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106795936451311176)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>'Origens de Dados REST inscritas nesta Origem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422405268310877)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Copiado do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423294465310877)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta \00E9 a c\00F3pia "mestra" deste modelo de bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423676200310878)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 modelos inscritos neste modelo de bot\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423502605310877)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelos de bot\00E3o inscritos neste modelo de bot\00E3o.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106250498575310741)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uso de String de Substitui\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651166257311055)
,p_name=>'SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00EAxito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727657073311119)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106613521555311027)
,p_name=>'SUCCESSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CAxitos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480284619310921)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'pt-br'
,p_message_text=>'Cluster truncado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476564918310917)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'pt-br'
,p_message_text=>'Comando executado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479304103310920)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Contexto eliminado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479506205310920)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Link de Banco de Dados criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479493684310920)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Link de Banco de Dados eliminado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480488543310921)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o alterada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475430931310917)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478344144310919)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o eliminada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480064987310920)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de \00EDndice alterado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479229149310920)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de \00EDndice eliminado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475865079310917)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDndice criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478606087310919)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDndice eliminado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476189917310917)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'View Materializada criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478785674310919)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'View materializada eliminada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480378609310921)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>'Pacote alterado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475605122310917)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Pacote criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475724632310917)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Pacote criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477666523310918)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Pacote eliminado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480597841310921)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>'Procedimento alterado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475533392310917)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Procedimento criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478438999310919)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Procedimento eliminado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476265004310917)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478836352310919)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atribui\00E7\00E3o eliminada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477078147310918)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 linha(s) exclu\00EDda(s).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476814364310918)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linha(s) inserida(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476724363310918)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linha(s) atualizada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480637447310921)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia alterada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476373609310917)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478095551310919)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia eliminada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202085777310697)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Linha criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201988328310697)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha exclu\00EDda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201863320310697)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'Linha atualizada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236866564310729)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00E3o processada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476403429310917)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sin\00F4nimo criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478991596310919)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sin\00F4nimo eliminado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478141395310919)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela alterada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475063387310916)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477526250310918)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela eliminada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479641729310920)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela renomeada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480118007310920)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela truncada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479936647310920)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>'Trigger alterado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475385497310917)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Trigger criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479041293310920)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Trigger eliminado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479800423310920)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo alterado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475975057310917)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo criado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479138847310920)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo eliminado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480774992310921)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio alterado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476078955310917)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio criado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477717496310918)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio eliminado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106479728638310920)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'pt-br'
,p_message_text=>'View alterada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475133584310916)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'View criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477815685310919)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'pt-br'
,p_message_text=>'View eliminada.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819658533311200)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Objetos de Suporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356313132311619)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de objeto alterada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356479639311619)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O objeto n\00E3o existe mais.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680254998311077)
,p_name=>'SVG CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico SVG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106769772169311154)
,p_name=>'SVG PLUGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instale o SVG Viewer para exibir o gr\00E1fico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200324312310695)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel editar um script vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200422799310696)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode editar um script com mais de 30.000 bytes.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432715337310885)
,p_name=>'SYNONYM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('sin\00F4nimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034087498311374)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(sin\00F4nimo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812953050311194)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sin\00F4nimo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944167862311301)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem do Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614665178311028)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status do Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106614763049311028)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'Status do Sistema Modificado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432830044310885)
,p_name=>'TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106680849047311077)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 um nome de tabela nem de view v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710625093311106)
,p_name=>'TABLESPACES'
,p_message_language=>'pt-br'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431826348310884)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'pt-br'
,p_message_text=>'(tabela)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106727095634311119)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>'O Nome da Tabela %0 excede o tamanho permitido.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739919747311130)
,p_name=>'TABULAR_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746452248311136)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'O form tabular foi criado com sucesso.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106427793351310881)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O destino da guia m\00E3e "%0" parece referenciar uma p\00E1gina que n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106419404374310875)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia de Guias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418391335310874)
,p_name=>'TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto de Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106974606105311325)
,p_name=>'TAB_SETS'
,p_message_language=>'pt-br'
,p_message_text=>'Conjuntos de Guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418560164310874)
,p_name=>'TAB_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto da Guia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435339251311676)
,p_name=>'TAG_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Tag: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259899606310750)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'pt-br'
,p_message_text=>'Recursos de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473491976311703)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID da P\00E1gina de Destino ou URL personalizado')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683533976311080)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclus\00E3o da Tarefa')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707719227311098)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Team Development'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106413316326310870)
,p_name=>'TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462538751311695)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667271821311067)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667382339311067)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462212639311695)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Modelo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462461281311695)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Modelo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106195980140310691)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo do Modelo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666904590311067)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo do Modelo de P\00E1gina (1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667050352311067)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo do Modelo de P\00E1gina (2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106667145963311067)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Corpo do Modelo de P\00E1gina (3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462307303311695)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar Modelo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666198508311066)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666261751311066)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666366784311066)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666441875311066)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666522666311066)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666684730311066)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666723359311066)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106666803127311067)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Posi\00E7\00E3o de Regi\00E3o 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107169810863311479)
,p_name=>'TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>'Modelos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800171731311184)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos-Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106229929445310722)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a cria\00E7\00E3o de um aplicativo baseado em um Aplicativo Modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867133417311236)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'pt-br'
,p_message_text=>'Baseado em Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798205449311178)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avan\00E7ado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798179011311178)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'pt-br'
,p_message_text=>'Comum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107242122518311535)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798038721311178)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'pt-br'
,p_message_text=>'Geral'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359279015311621)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma op\00E7\00E3o de modelo correspondente definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366974317311627)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Nenhuma Op\00E7\00E3o Selecionada -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107343443936311610)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Padr\00F5es de Modelo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449898696311686)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo N\00E3o Correspondem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470904085311701)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este modelo \00E9 inscrito no modelo correspondente no tema mestre. Para modificar esse modelo, edite o modelo mestre e, em seguida, atualize o tema. Como alternativa, voc\00EA pode criar uma c\00F3pia local e sem inscri\00E7\00E3o desse modelo. Os modelos sem inscri\00E7\00E3o')
||unistr(' s\00E3o edit\00E1veis e n\00E3o ser\00E3o substitu\00EDdos por uma atualiza\00E7\00E3o de tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107470800354311701)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esse modelo \00E9 local para esse aplicativo e n\00E3o tem assinatura. '),
unistr('N\00E3o \00E9 poss\00EDvel assinar modelos individuais quando o tema associado \00E9 assinado.'),
unistr('Como alternativa \00E0 defini\00E7\00E3o de modelos locais, voc\00EA poderia adicionar novos modelos ao tema mestre e depois submet\00EA-los ou obt\00EA-los facilmente nesse aplicativo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424523665310878)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Referenciado como modelo padr\00E3o do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424766033310878)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Referenciado como modelo de erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424943011310878)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este modelo de p\00E1gina N\00C3O \00E9 referenciado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106425053940310879)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este modelo de p\00E1gina n\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424862875310878)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Referenciado na(s) p\00E1gina(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106424674634310878)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Referenciado como modelo para impress\00E3o.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106619101974311032)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tablespace Tempor\00E1rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106480891237310921)
,p_name=>'TEST'
,p_message_language=>'pt-br'
,p_message_text=>'Testar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705657493311096)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'pt-br'
,p_message_text=>'Favorecido de Teste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106703887506311095)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>'Impacto de Teste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706020881311097)
,p_name=>'TESTING_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status de Teste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772311162311156)
,p_name=>'TEST_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Testar Consulta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975894770311326)
,p_name=>'TEXT FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos de Texto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106374028271310842)
,p_name=>'THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106300607375310786)
,p_name=>'THEME FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975484030311325)
,p_name=>'THEME IMAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Imagens do Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436583042311677)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Compat\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227809637311523)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106368462468310838)
,p_name=>'THEMES'
,p_message_language=>'pt-br'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471076115311701)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode cancelar a assinatura de modelos individuais que fazem parte de um tema, o qual n\00E3o tem assinatura de outro tema no n\00EDvel do tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471318878311701)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esse aplicativo n\00E3o pode ser convertido em um tema que usa navega\00E7\00E3o baseada em guias, uma vez que utiliza navega\00E7\00E3o baseada em listas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471229219311701)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esse aplicativo n\00E3o pode ser convertido em um tema que usa navega\00E7\00E3o baseada em lista, uma vez que ele usa dois n\00EDveis de guias. Atualize o aplicativo e estabele\00E7a as defini\00E7\00F5es atuais de guias para que s\00F3 usem um n\00EDvel de guias antes da altern\00E2ncia ')
||'do tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106687698877311083)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um tema de Desktop n\00E3o pode ser trocado para um tema de Dispositivo M\00F3vel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106594002725311013)
,p_name=>'THEME_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Tema'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434789636311676)
,p_name=>'TITLE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106682924164311079)
,p_name=>'TO DO'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729760251311121)
,p_name=>'TODO'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106709424362311099)
,p_name=>'TODOS'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259007424310749)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tarefa conclu\00EDda (%0 / %1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014458166311359)
,p_name=>'TODO_DASH_1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 entradas, %1 abertas, %2 conclu\00EDdas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014591293311359)
,p_name=>'TODO_DASH_2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 das entradas est\00E3o conclu\00EDdas parcialmente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014617566311359)
,p_name=>'TODO_DASH_3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 das entradas est\00E3o conclu\00EDdas parcialmente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708246918311098)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Tabelas Principais por Contagem de Linhas, Reportado pelo Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732806964311124)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'pt-br'
,p_message_text=>'Total de Fechamentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730320280311122)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'pt-br'
,p_message_text=>'Total de marcos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106732707256311124)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'pt-br'
,p_message_text=>'Total de Aberturas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708380168311098)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tempo Total de Renderiza\00E7\00E3o (Segundos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350219033311615)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A ser expurgado (nos pr\00F3ximos 7 dias)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731415316311123)
,p_name=>'TO_DOS'
,p_message_language=>'pt-br'
,p_message_text=>'Tarefas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036577828311376)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Percentual de conclus\00E3o da Tarefa (%0/%1):')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434839671310886)
,p_name=>'TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00E1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857608755311229)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Inicial com Base no Item Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857745186311229)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Inicial com Base na Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857932179311229)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Valor da \00C1rvore Inicial \00E9 NULO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106857849170311229)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore Inicial com base no Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348099719310823)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A \00E1rvore foi criada com sucesso.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106432995252310885)
,p_name=>'TRIGGER'
,p_message_language=>'pt-br'
,p_message_text=>'trigger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309732624310793)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os nomes de bot\00F5es n\00E3o devem ser iguais ao nome de uma guia existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815742483311196)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo e o ID do grupo de seguran\00E7a atual n\00E3o s\00E3o consistentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309684795310793)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID de grupo de seguran\00E7a 20 est\00E1 reservado para o espa\00E7o de trabalho ''ORACLE''')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106813661960311195)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Truncar a Tabela %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106858509915311230)
,p_name=>'TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106860470300311231)
,p_name=>'TYPE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106809054977311191)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Item Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106815606964311196)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Defini\00E7\00E3o de Coluna do Banco de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106702099868311094)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ir para Conte\00FAdo Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222831785310716)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rea de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222940540310716)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223019543310716)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'pt-br'
,p_message_text=>'Tablet do jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223177289310716)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'pt-br'
,p_message_text=>'Smartphone do jQuery Mobile para PhoneGap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106223244535310716)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'pt-br'
,p_message_text=>'Tablet do jQuery para PhoneGap'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106381011269310847)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel determinar a data do marco')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752212668311140)
,p_name=>'UNASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o designado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775239296311159)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio N\00E3o Autenticado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956317164311311)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Dispon\00EDvel (Redirecionar para URL)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106956214042311311)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Dispon\00EDvel (Status Mostrado com PL/SQL)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106690732225311085)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Em considera\00E7\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305730177310790)
,p_name=>'UNEXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o-expirado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817253138311198)
,p_name=>'UNLOCK'
,p_message_language=>'pt-br'
,p_message_text=>'Desbloquear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905279185311266)
,p_name=>'UNLOCKED'
,p_message_language=>'pt-br'
,p_message_text=>'desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269878734310762)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos Desbloqueados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106266838735310759)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Desbloquear'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526767743310962)
,p_name=>'UNRESTRICTED'
,p_message_language=>'pt-br'
,p_message_text=>'Irrestrito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481588422310922)
,p_name=>'UP'
,p_message_language=>'pt-br'
,p_message_text=>'Ativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434688817310886)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('relat\00F3rio atualiz\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107014799371311360)
,p_name=>'UPDATED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464821324310909)
,p_name=>'UPDATED_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado em'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867362044311237)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar para a Vers\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867446344311237)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualizar para a Vers\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366894518311627)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o \00E9 um formato de data suportado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037630668311377)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de data n\00E3o suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107417997211311664)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o upgrade, certifique-se de que o atributo de s\00E9ria Coluna de Label est\00E1 mapeado para uma coluna de Data / Timestamp.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434792182310886)
,p_name=>'URL'
,p_message_language=>'pt-br'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106671201219311070)
,p_name=>'URL LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link de URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106694808055311088)
,p_name=>'USERID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID do Usu\00E1rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711122185311107)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Usu\00E1rios, Usu\00E1rio criado mais recentemente %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816063144311197)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma P\00E1gina Global Definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705512815311096)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Favorecido de Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106705045874311096)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Impacto na Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706565873311097)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Status da Interface do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324495708310806)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use esta p\00E1gina para controlar o acesso dos administradores de espa\00E7os de trabalho, desenvolvedores de aplicativos e usu\00E1rios finais do Application Express.</p>'),
'',
unistr('<p><strong>Administradores de espa\00E7os de trabalho</strong> podem criar e modificar aplicativos e objetos de banco de dados, assim como gerenciar contas de usu\00E1rio, grupos e servi\00E7os de desenvolvimento.</p>'),
'',
'<p><strong>Desenvolvedores</strong> podem criar e modificar aplicativos e objetos de banco de dados.</p>',
'',
unistr('<p><strong>Usu\00E1rios finais</strong> n\00E3o t\00EAm privil\00E9gios de desenvolvimento e s\00F3 podem acessar aplicativos que n\00E3o usam um esquema de autentica\00E7\00E3o externo.</p>'),
'',
'<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">Saiba Mais...</a></p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348621156310823)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta p\00E1gina para controlar o acesso dos usu\00E1rios finais ao Application Express.<p>'),
'',
unistr('Os <p><strong>usu\00E1rios finais</strong> n\00E3o t\00EAm privil\00E9gios de desenvolvimento e s\00F3 podem acessar aplicativos que n\00E3o utilizam um esquema de autentica\00E7\00E3o externo.</p>'),
'',
unistr('Os <p><strong>administradores de espa\00E7os de trabalho</strong> e os <strong>desenvolvedores</strong> s\00E3o gerenciados com a Console de Identidades. Sempre que um administrador de espa\00E7os de trabalho ou um desenvolvedor faz log-in no Application Express')
||unistr(', uma conta "sombra" \00E9 criada. Esses usu\00E1rios "sombras" podem ser removidos, se necess\00E1rio.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436189732310887)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar p\00E1gina de log-in incorporada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106435964220310887)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar a p\00E1gina %0 como p\00E1gina de log-in.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798983030311178)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Use o atributo <strong>limpar cache</strong> para remover o estado da sess\00E3o de uma lista de p\00E1ginas separadas por v\00EDrgulas. A sintaxe de remo\00E7\00E3o de cache a seguir tamb\00E9m ficar\00E1 dispon\00EDvel:'),
'<ul>',
unistr('<li>RIR - Redefinir Relat\00F3rio Interativo</li>'),
unistr('<li>CIR - Limpar Relat\00F3rio Interativo</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106821996062311201)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>'usando esquema existente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443652001311682)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443950965311682)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editor de C\00F3digos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443879733311682)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Maximizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443778407311682)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Minimizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445009764311683)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A altera\00E7\00E3o do Estilo do Tema redefinir\00E1 as altera\00E7\00F5es n\00E3o salvas. Essa opera\00E7\00E3o n\00E3o pode ser desfeita. Deseja continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472377134311702)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443541837311682)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443321909311682)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442773312311681)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>'Confirmar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472032099311702)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443186376311681)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443252017311682)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'pt-br'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471911591311702)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' Voc\00EA fez altera\00E7\00F5es em um tema somente para leitura. Se voc\00EA o tornar o tema atual, as altera\00E7\00F5es ser\00E3o apagadas. Tem certeza de que deseja continuar? ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443454332311682)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442830519311681)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472195660311702)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107443055811311681)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468616649311700)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cole a seguinte linha de c\00F3digo na console JS para carregar a configura\00E7\00E3o atual no Rolador de Tema:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468765452311700)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Rolador de Tema deve estar aberto e o estilo atual deve ser v\00E1lido para gerar a configura\00E7\00E3o.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356771038311620)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Taxa de Contraste:'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450138136311686)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'pt-br'
,p_message_text=>'Falhou'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452569444311688)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'pt-br'
,p_message_text=>'Para texto acima de 18pt ou negrito acima de 14pt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450233079311686)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As valida\00E7\00F5es s\00E3o feitas de acordo com as diretrizes WCAG (Web Content Accessibility Guidelines) 2.0 em Contraste de Cores para fontes de tamanho normal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107450087661311686)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'pt-br'
,p_message_text=>'Aprovado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107449923147311686)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es de Contraste de Cor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471871251311702)
,p_name=>'UTR.CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'Atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444856993311683)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'pt-br'
,p_message_text=>'CSS Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444978494311683)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este c\00F3digo ser\00E1 inclu\00EDdo no final da folha de estilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453774976311689)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este c\00F3digo CSS oculta a caixa de di\00E1logo Rolador de Tema. Ele n\00E3o est\00E1 sendo aplicado \00E0 p\00E1gina.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034559782311374)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034827155311375)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'pt-br'
,p_message_text=>'Arraste e solte arquivos ou clique para selecionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035064413311375)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ativar Compila\00E7\00E3o LESS')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442973299311681)
,p_name=>'UTR.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445473729311683)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o estilo do tema.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453493523311689)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao carregar um ou mais URLs de Arquivos CSS.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445291897311683)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O c\00F3digo LESS desse estilo de tema \00E9 inv\00E1lido.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445698850311683)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel carregar o estilo do tema. Certifique-se de que a janela Application Builder ainda esteja aberta e a sess\00E3o seja v\00E1lida.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472274426311702)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel usar o tema selecionado como o tema atual do aplicativo!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445151858311683)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este estilo de tema n\00E3o suporta a personaliza\00E7\00E3o do Rolador de Tema')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445364469311683)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esse tema n\00E3o tem estilos. Selecione um tema com estilos para usar o Rolador de Tema.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107445579089311683)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar o estilo do tema.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345731459311612)
,p_name=>'UTR.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452646672311688)
,p_name=>'UTR.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452718468311688)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Rolador de Tema permite f\00E1cil personaliza\00E7\00E3o da interface do usu\00E1rio do seu aplicativo, possibilitando a voc\00EA selecionar cores e definir estilos para v\00E1rios componentes de aplicativo. Um aplicativo pode ter qualquer n\00FAmero de estilos de tema defini')
||unistr('do; entretanto, somente o estilo ''Atual'' \00E9 usado para exibir o aplicativo para os usu\00E1rios finais.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107452846681311688)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Depois de fazer altera\00E7\00F5es, os atributos podem ser restaurados facilmente, para o estilo de tema completo pressionando o bot\00E3o Redefinir ou pressionando o \00EDcone de redefini\00E7\00E3o do grupo. '),
'',
unistr('No caso de atributos que permitem a sele\00E7\00E3o de cores de primeiro plano e plano de fundo, a caixa de sele\00E7\00E3o que vem antes das duas sele\00E7\00F5es de cores indica informa\00E7\00F5es de contraste de cores com base nas diretrizes WCAG (Web Content Accessibility Guid')
||unistr('elines) 2.0. Uma pontua\00E7\00E3o de contraste calculada mais alta indica que a combina\00E7\00E3o de cores \00E9 mais acess\00EDvel.')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107229606916311524)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Editor em linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754331961311142)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464479277311697)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna de A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467993153311699)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Ativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468504917311699)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'pt-br'
,p_message_text=>'Estado ativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466476070311698)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'pt-br'
,p_message_text=>'Segundo Plano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106754424826311142)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'pt-br'
,p_message_text=>'Distintivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464394408311696)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo do Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464284043311696)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'pt-br'
,p_message_text=>'Acento no Corpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468807149311700)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00E1xima do Conte\00FAdo do Corpo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465074982311697)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'pt-br'
,p_message_text=>'Raio da Borda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463139656311696)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bot\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466664217311698)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467423248311699)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 10'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107435963358311676)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 11'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436099191311676)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 12'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436126749311677)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 13'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436202406311677)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 14'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107436314145311677)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 15'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466728570311698)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467519889311699)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466857107311698)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466955108311698)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 5'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467065614311698)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 6'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467189994311698)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 7'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467272642311699)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 8'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467389104311699)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'pt-br'
,p_message_text=>'Cor 9'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463205314311696)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'pt-br'
,p_message_text=>'Containers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467628369311699)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'pt-br'
,p_message_text=>'Raio da Borda do Container'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465435705311697)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'pt-br'
,p_message_text=>'Perigo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465803465311698)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464748486311697)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esbo\00E7o em Foco')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466284793311698)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro Plano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473073702311703)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'pt-br'
,p_message_text=>'Forms'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462964782311695)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'pt-br'
,p_message_text=>'Cores Globais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466599234311698)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464155579311696)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acento no Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756847653311144)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altura do Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465263298311697)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468286580311699)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'pt-br'
,p_message_text=>'Cursor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468358148311699)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'pt-br'
,p_message_text=>'Estado do cursor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467862458311699)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465911343311698)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464058239311696)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios Interativos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473158599311703)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107473230509311703)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463342843311696)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Layout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464992850311697)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna do Lado Esquerdo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464651823311697)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cor do Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466112837311698)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107459108922311693)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'pt-br'
,p_message_text=>'Menus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106800918657311184)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'pt-br'
,p_message_text=>'Estado do Cursor do Item de Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463449368311696)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107467741545311699)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvore de Navega\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465135984311697)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'pt-br'
,p_message_text=>'Normal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468023221311699)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o ativo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463722439311696)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'pt-br'
,p_message_text=>'Paleta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465337082311697)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prim\00E1ria')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630243069311040)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463084151311696)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464851416311697)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448005397311685)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios e Grades')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365299847311626)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'pt-br'
,p_message_text=>'Segundo Plano do Corpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365129449311626)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho do Corpo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365947334311626)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modo de Exibi\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366150168311626)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'pt-br'
,p_message_text=>'Compacto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366020846311626)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Standard (Padr\00E3o)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349613513311615)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Layout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353239245311617)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'pt-br'
,p_message_text=>'Contido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353009673311617)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Borda a Borda (Padr\00E3o)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107353180246311617)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'pt-br'
,p_message_text=>'Flutuante'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349512359311615)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Modo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352853317311617)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'pt-br'
,p_message_text=>'Escuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352967200311617)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo Escuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366393288311627)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escuro (Padr\00E3o)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107352724004311617)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Claro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366486586311627)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Claro (Padr\00E3o)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107349422323311614)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'pt-br'
,p_message_text=>'Pilar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364902564311626)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'pt-br'
,p_message_text=>'Bege'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364568056311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lil\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363920447311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Neutro (Padr\00E3o)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364494231311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'pt-br'
,p_message_text=>'Oceano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364085395311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'pt-br'
,p_message_text=>'Seixo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364270629311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'pt-br'
,p_message_text=>'Pinho'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364886328311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'pt-br'
,p_message_text=>'Ameixa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364603896311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'pt-br'
,p_message_text=>'Rosa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364793885311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'pt-br'
,p_message_text=>'Siena'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364116638311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ard\00F3sia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107364386015311625)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'pt-br'
,p_message_text=>'Azul-Turquesa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365094044311626)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363884886311625)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es Redwood')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106545607433310977)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'pt-br'
,p_message_text=>'Escala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106630359600311040)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Estilo Secund\00E1rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468149116311699)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107468400756311699)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'pt-br'
,p_message_text=>'Estado selecionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465789823311697)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Simples'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463541484311696)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'pt-br'
,p_message_text=>'Estados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465620441311697)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107466367987311698)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107464582316311697)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Barra de T\00EDtulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107465579279311697)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107345848170311612)
,p_name=>'UTR.LOADING'
,p_message_language=>'pt-br'
,p_message_text=>'Carregando...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106348295297310823)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto Alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997947825311345)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997846474311345)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode editar a marca\00E7\00E3o do logotipo no Application Builder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035525400311375)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel carregar os dados do logotipo. Certifique-se de que a janela Application Builder ainda esteja aberta e a sess\00E3o seja v\00E1lida.')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997748193311345)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037705214311377)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma Imagem Carregada.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997660686311345)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem e Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035116343311375)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione um arquivo com menos de %0KB'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997557050311345)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035200822311375)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente arquivos de imagem s\00E3o permitidos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034425134311374)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar Logotipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035395360311375)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel salvar o logotipo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107035456651311375)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Logotipo salvo com sucesso.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997415557311345)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997265235311345)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997120359311345)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Arraste e solte arquivos ou clique para selecionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107227970474311523)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Logotipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034936198311375)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente arquivos JSON s\00E3o permitidos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460717036311694)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'pt-br'
,p_message_text=>'Adjacente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460536497311694)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'pt-br'
,p_message_text=>'Base RGB'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472841296311702)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'pt-br'
,p_message_text=>'Duplo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460632125311694)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Monocrom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461184968311694)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Separa\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460978369311694)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00E9trada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460845452311694)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tr\00EDade')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107461027500311694)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Com Complemento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756294951311143)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o salvou suas altera\00E7\00F5es de logotipo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106756373005311143)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o salvou suas altera\00E7\00F5es de tema.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463994368311696)
,p_name=>'UTR.REDO'
,p_message_language=>'pt-br'
,p_message_text=>'Refazer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444698333311683)
,p_name=>'UTR.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444743910311683)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem certeza de que deseja redefinir o CSS? Todas as suas altera\00E7\00F5es ser\00E3o perdidas. Essa op\00E7\00E3o n\00E3o pode ser desfeita.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472407099311702)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444303134311682)
,p_name=>'UTR.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444450682311682)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Atualize o nome para renomear o estilo de tema atual.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444501566311682)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo de tema atualizado com sucesso!'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444013512311682)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar como'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444156479311682)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Informe um nome para o novo estilo de tema.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107444241741311682)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo de tema criado com sucesso!'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107460488900311694)
,p_name=>'UTR.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107228098989311523)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107471770391311702)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como Atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472532641311702)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Definir como o estilo de tema atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472624247311702)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tema selecionado agora \00E9 o tema atual do aplicativo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472795308311702)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA fez altera\00E7\00F5es em um tema somente para leitura. Se voc\00EA o tornar o tema "atual" do aplicativo, as altera\00E7\00F5es ser\00E3o apagadas. Tem certeza de que deseja continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997044920311345)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'pt-br'
,p_message_text=>'Logotipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106996959995311344)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo do Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442678471311681)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'pt-br'
,p_message_text=>'Rolador do Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453315986311689)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107453227126311689)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Comum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469585191311700)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Roda de Cores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463821791311696)
,p_name=>'UTR.UNDO'
,p_message_language=>'pt-br'
,p_message_text=>'Desfazer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034648326311374)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Upload'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107034793898311374)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fazer Upload do Arquivo de Configura\00E7\00E3o')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444582312310893)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'ERR-1812 Erro inesperado ao converter alias do aplicativo (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107433567317311675)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225759358310719)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Todos os Grupos de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225894501310719)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Todos os Tipos de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106373394677310841)
,p_name=>'VIEWS2'
,p_message_language=>'pt-br'
,p_message_text=>'Views'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973782517311324)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Depura\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106248721379310740)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhes da View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817972730311198)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243763363310735)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir para Impress\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002263131311349)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir hist\00F3rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107392613974311645)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106431986514310884)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'pt-br'
,p_message_text=>'(view)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423382614311668)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Hist\00F3rico de Bloqueios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354172012311618)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta consulta SQL \00E9 usada para gerar o XML exibido ap\00F3s clicar no bot\00E3o <strong>Exibir XML</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226348461310719)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir p\00E1ginas deste tipo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106997325635311345)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir "%0" - hist\00F3rico de altera\00E7\00E3o de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338535225310816)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir atividade para: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746161248311135)
,p_name=>'VPD'
,p_message_language=>'pt-br'
,p_message_text=>'VPD (Virtual Private Database)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758150774311145)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'pt-br'
,p_message_text=>'Instalando Aplicativo...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439304445311679)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'pt-br'
,p_message_text=>'Removendo Aplicativo...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439532650311679)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'pt-br'
,p_message_text=>'Desbloqueando Aplicativo...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107439436331311679)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizando Aplicativo...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758235952311145)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processando Solicita\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758386061311145)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'pt-br'
,p_message_text=>'Instalando Objetos de Suporte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867710985311237)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma classe de correspond\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106867607801311237)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('V\00E1rias correspond\00EAncias')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213046961310707)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Servi\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214093339310708)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A ser adicionado do Cat\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213812065310708)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover Servi\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106679761755311077)
,p_name=>'WEBSHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710372190311106)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Anexos da Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419747985311665)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Departamento de TI AnyCo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419607278311665)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Departamento de TI AnyCo destaca como usar os recursos das Websheets para o compartilhar conte\00FAdo baseado na Web e gerar relat\00F3rios sobre dados cr\00EDticos para os neg\00F3cios. Este aplicativo de Websheet de amostra cont\00E9m v\00E1rias grades de dados e demons')
||unistr('tra como incluir dados em relat\00F3rios e grades incorporados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365427630311626)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'pt-br'
,p_message_text=>'Felinos de Grande Porte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365791986311626)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E3o destacados em Felinos de Grande Porte muitos recursos de Websheets, inclusive a incorpora\00E7\00E3o de imagens e links de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279836738310770)
,p_name=>'WEBSHEETS'
,p_message_language=>'pt-br'
,p_message_text=>'Websheets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056232002311391)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um aplicativo de Websheet consiste em p\00E1ginas Web que combinam texto com dados. Esses aplicativos s\00E3o altamente din\00E2micos e definidos pelos usu\00E1rios. Os aplicativos incluem controles de navega\00E7\00E3o, recursos de pesquisa e a capacidade de adicionar anot')
||unistr('a\00E7\00F5es, como, por exemplo, arquivos, observa\00E7\00F5es e tags. Os aplicativos podem ser protegidos usando-se as listas de controle de acesso e v\00E1rios modelos de autentica\00E7\00E3o incorporados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056327769311391)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os aplicativos de Websheet permitem que um grupo de colaboradores criem p\00E1ginas informativas rapidamente, incluindo relat\00F3rios e gr\00E1ficos, usando somente um Web browser. Os usu\00E1rios podem manter o texto e os dados locais facilmente (denominadas grade')
||unistr('s de dados), e tamb\00E9m exibir dados das consultas SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056461373311391)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os aplicativos de Websheet t\00EAm funcionalidade semelhante \00E0 dos WIKIs, mas s\00E3o otimizadas para integra\00E7\00E3o e exibi\00E7\00E3o de dados. Por exemplo, voc\00EA pode definir uma grade de dados para armazenar informa\00E7\00F5es tabulares, definir um relat\00F3rio com tabelas exi')
||unistr('stentes ou apenas usar uma tag SQL para exibir os dados do banco de dados em uma p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056556356311391)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grades de dados s\00E3o componentes da Websheet semelhantes \00E0 planilhas, que permitem manter facilmente informa\00E7\00F5es tabulares. Uma diferen\00E7a importante \00E9 que, em vez de serem armazenados localmente em arquivos, todos os dados da Websheet s\00E3o armazenados ')
||unistr('centralmente dentro do banco de dados Oracle. Usando as grades de dados voc\00EA pode adicionar anota\00E7\00F5es a cada linha de dados, inclusive arquivos, observa\00E7\00F5es, tags e links. Como vantagem adicional, todos os dados s\00E3o pesquis\00E1veis usando-se a pesquisa ')
||'do aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056900426311392)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('As tags SQL permitem que os usu\00E1rios incorporem facilmente relat\00F3rios em uma p\00E1gina, com base em instru\00E7\00F5es SQL gravadas em tabelas de banco de dados. Usando SQL, os usu\00E1rios podem facilmente recuperar dados, diretamente de suas tabelas favoritas. Po')
||'r exemplo, para ver quaisquer bugs abertos vencidos, use a seguinte tag: ',
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('Esta consulta \00E9 executada cada vez que a p\00E1gina \00E9 exibida, fornecendo dados din\00E2micos em vez de um snapshot mais comum em determinado momento.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056644641311391)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os aplicativos de websheet facilitam o compartilhamento de conte\00FAdo e possibilitam a gera\00E7\00E3o de relat\00F3rios b\00E1sicos e informativos. Toda a estrutura e o conte\00FAdo de um aplicativo de websheet s\00E3o controlados pelos usu\00E1rios (ou seja, colaboradores e adm')
||unistr('inistradores). Por outro lado, os aplicativos de banco de dados s\00E3o usados para manuten\00E7\00E3o de dados e gera\00E7\00E3o de relat\00F3rios mais formais, sofisticados e especializados. A estrutura de um aplicativo de banco de dados \00E9 controlada pelos desenvolvedores')
||unistr(', mas o conte\00FAdo geralmente \00E9 controlado pelos usu\00E1rios finais.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055788741311391)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O que \00E9 Websheet?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055941459311391)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'pt-br'
,p_message_text=>'Por que eu quero criar um aplicativo de Websheet?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056035275311391)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'pt-br'
,p_message_text=>'Como um aplicativo de Websheet se diferencia de um WIKI?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107056152187311391)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os aplicativos de Websheet s\00E3o planilhas on-line?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057041116311392)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O que \00E9 tag SQL?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055885581311391)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'pt-br'
,p_message_text=>'Como um aplicativo de Websheet se diferencia de um aplicativo de banco de dados?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106338616103310816)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Componente n\00E3o instalado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441427821311680)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso do Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107420434755311665)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo de Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264436048310757)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativos de Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107007883812311354)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo %0 n\00E3o est\00E1 dispon\00EDvel no momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711441495311107)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Anexos da Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002357118311349)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo atualizado %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002478216311349)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina criada %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365833461311626)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 prestes a instalar uma amostra do aplicativo de Websheet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107434362230311675)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Websheet: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106994749286311343)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina atualizada %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106710245565311106)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Websheet sem dados BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405419754311655)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os objetos de planilha n\00E3o s\00E3o v\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755018182311142)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo %0 de websheet instalado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019301621311363)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os seguintes objetos s\00E3o pesquis\00E1veis utilizando-se a tag de marca\00E7\00E3o SQL ou a dispon\00EDvel nos Relat\00F3rios. As aspas duplas s\00E3o usadas para identificar os nomes de objeto que distinguem mai\00FAsculas e min\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106708782139311099)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Views de P\00E1gina da Websheet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739613478311130)
,p_name=>'WEB_SERVICE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Servi\00E7o Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434139957310886)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'pt-br'
,p_message_text=>'Resultado do Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199520262310695)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Cloud Applications (SaaS) REST Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199344869310694)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'pt-br'
,p_message_text=>'HTTP simples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199643042310695)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'pt-br'
,p_message_text=>'OCI (Oracle Cloud Infrastructure)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199490506310695)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259604423310750)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclua este assistente de registro para solicitar um espa\00E7o de trabalho do Oracle APEX.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751166081311139)
,p_name=>'WHITE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto em Branco'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292211294310779)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'pt-br'
,p_message_text=>'No dia seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107359192227311621)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dentro dos pr\00F3ximos %0 dias')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711222400311107)
,p_name=>'WITH_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('como op\00E7\00E3o de admin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106434592458310886)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'pt-br'
,p_message_text=>'com atalhos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816904387311197)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O N\00FAmero da P\00E1gina j\00E1 existe neste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106816314941311197)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O N\00FAmero de P\00E1gina est\00E1 reservado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467667970310911)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Marcado(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344630701310820)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'pt-br'
,p_message_text=>'Comentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106202148991310697)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239999576311534)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas de Cart\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215592105310709)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Cart\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043089181311381)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Relat\00F3rio Cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008269679311354)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Pesquisa Facetada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043566325311381)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Form e View em Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043992380311381)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Form em Procedimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043831242311381)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Form sobre Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043706636311381)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418044774311664)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Form em Web Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222480369310716)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'pt-br'
,p_message_text=>'Faceta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042973714311381)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Grade Interativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107042843355311381)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213795622310708)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar P\00E1gina de Mapa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043167347311381)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Detalhe Mestre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043367774311381)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043410575311381)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Relat\00F3rio com Form')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221343683310715)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Filtros Inteligentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106222558614310716)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043681160311381)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Form Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107043245381311381)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Relat\00F3rio sobre Web Service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387603448310852)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Este assistente requer um aplicativo baseado no Universal Theme.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201601377310697)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Processar o form %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106201564273310697)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Inicializar o form %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798498386311178)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798383384311178)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812193720311193)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - Salvar Dados da Grade Interativa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804983338311188)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Cl\00E1ssico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804853011311188)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Grade Interativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804725053311187)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805163045311188)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106805075829311188)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Web Service')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106408127572310866)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ter algum valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728814983311121)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorreu um erro de valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728778197311120)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'#COLUMN_HEADER# deve ter um valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106762229500311148)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As p\00E1ginas do assistente foram criadas com sucesso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469096773311700)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento do Assistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747547694311136)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Relat\00F3rio do Assistente foi criado com sucesso.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436222616310887)
,p_name=>'WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('espa\00E7o de trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106736147798311127)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagem do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798617987311178)
,p_name=>'WORKSPACES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7os de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707505846311098)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativos de Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707828000311098)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resumo de Atividades do Aplicativo do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350344040311615)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Contagem do Espa\00E7o de Trabalho Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706875888311097)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107018984141311363)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagens do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106799185932311179)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106617544407311030)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276588647310767)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de Trabalho: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106245609164310737)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Log-in no Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106944238482311301)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mensagem do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106706617159311097)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106855583895311227)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de Substitui\00E7\00E3o do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106739082730311130)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o de Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707423032311098)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esquemas do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106295695684310782)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA receber\00E1 um e-mail para ativar seu espa\00E7o de trabalho depois que esta solicita\00E7\00E3o for aprovada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798849075311178)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rios do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711320136311107)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Websheets do Espa\00E7o de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106707181721311098)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resumo do espa\00E7o de trabalho %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683165598311079)
,p_name=>'WORK_INITIATED'
,p_message_language=>'pt-br'
,p_message_text=>'Trabalho Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106683283862311079)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Trabalho em Andamento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691225992311085)
,p_name=>'WRITING'
,p_message_language=>'pt-br'
,p_message_text=>'Gravando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354581379311618)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'pt-br'
,p_message_text=>'Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107354459251311618)
,p_name=>'WS.READER'
,p_message_language=>'pt-br'
,p_message_text=>'Leitor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106746935823311136)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Refer\00EAncia de Web Service foi adicionada ao Aplicativo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236073639310728)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Controle de Acesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980031410311329)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418232354311664)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o houve espa\00E7o suficiente para adicionar o arquivo. Solicite armazenamento adicional indo at\00E9 a p\00E1gina da administra\00E7\00E3o; l\00E1, v\00E1 para servi\00E7os de gerenciamento e clique na solicita\00E7\00E3o de armazenamento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003472017311350)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038380603311377)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003595966311350)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Observa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002920621311350)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003384551311350)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047522789311384)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235875788310728)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Administra\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979602100311329)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'O alias deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106228387209310721)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O alias deve ser alfanum\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239561920310731)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O alias \00E9 muito grande. O limite \00E9 255 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044533847311382)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038475782311377)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Anota\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235934962310728)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'pt-br'
,p_message_text=>'Propriedades do Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053082347311389)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de exibi\00E7\00E3o selecionado n\00E3o pode usar a Lista de Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055488250311391)
,p_name=>'WS_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>'Alterado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039872725311378)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar Tipo de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055625027311391)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou altera\00E7\00E3o na consulta do relat\00F3rio. Se voc\00EA adicionou colunas \00E0 consulta, elas n\00E3o ser\00E3o exibidas ao executar o relat\00F3rio. Voc\00EA tem de usar o menu A\00E7\00F5es e selecionar as colunas ou clicar em <strong>Redefinir</strong>. Se voc\00EA removeu q')
||unistr('ualquer coluna da consulta, isso desativar\00E1 os filtros existentes, regras de destaque e outras defini\00E7\00F5es de relat\00F3rio que referenciam essas colunas. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233491272310726)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040333889311379)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Alinhamento da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003210125311350)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'pt-br'
,p_message_text=>'Grupos de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414834917311661)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da Coluna j\00E1 existe. Informe outro nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003151564311350)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'pt-br'
,p_message_text=>'Propriedades da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041331955311379)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirme para executar esta a\00E7\00E3o de exclus\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052867604311389)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'O label da coluna deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054180864311390)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'pt-br'
,p_message_text=>'A coluna deve ser selecionada para alterar o valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054342671311390)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'pt-br'
,p_message_text=>'A coluna deve ser selecionada para substituir o valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053437200311389)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'O nome da coluna deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052717062311389)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna deve ser selecionada para edi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053559383311389)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A(s) coluna(s) deve ser selecionada para remo\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039347324311378)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('lista separada por v\00EDrgulas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041006009311379)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma lista separada por v\00EDrgulas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052458075311388)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirme a exclus\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107428268470311671)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Controle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351387479311616)
,p_name=>'WS_COPY'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965969260311318)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova P\00E1gina como uma C\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989015444311336)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a cria\00E7\00E3o de uma Websheet com os atributos a seguir. Confirme suas sele\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965341553311318)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Se\00E7\00E3o do Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106744318102311134)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965478396311318)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Se\00E7\00E3o de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039593707311378)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965623357311318)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Se\00E7\00E3o de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965821306311318)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106269544998310761)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Se\00E7\00E3o PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965247123311318)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Se\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965585673311318)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Criar Se\00E7\00E3o de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039655045311378)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio Atual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235616568310728)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'pt-br'
,p_message_text=>'Painel de Controle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212945731310707)
,p_name=>'WS_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106725460780311118)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O n\00FAmero m\00E1ximo de colunas dispon\00EDveis para o tipo de coluna atingido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107415038957311662)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Foram encontrados nomes de colunas duplicados. O nome da coluna deve ser exclusivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107380441842311637)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da Grade de Dados j\00E1 existe. Informe outro nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039727289311378)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039450685311378)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441964585311681)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Colunas de Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041158240311379)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106975059593311325)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045568731311383)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041219253311379)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione a(s) coluna(s) a serem removidas permanentemente com os dados:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258597922310749)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A primeira coluna deve ser a chave prim\00E1ria da Grade de Dados para exibir o link de edi\00E7\00E3o ou adi\00E7\00E3o de linha. Adicione a substitui\00E7\00E3o "APXWS_DATA_GRID_PK" como primeira coluna da instru\00E7\00E3o select para incluir a chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106251829977310743)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta deve referenciar a Grade de Dados somente uma vez para exibir o link de edi\00E7\00E3o ou adi\00E7\00E3o de linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258643949310749)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta cont\00E9m mais de uma instru\00E7\00E3o select. Adicione a substitui\00E7\00E3o "APXWS_DATA_GRID_PK" como primeira coluna da instru\00E7\00E3o select para exibir o link de edi\00E7\00E3o ou adi\00E7\00E3o de linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107057164119311392)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Sintaxe de Tag SQLVALUE:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106804277980311187)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Sintaxe de Tag SQL:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038918810311378)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038851420311378)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Documento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979567170311329)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel escolher a mesma coluna para a chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038157824311377)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351440858311616)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234744409310727)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234343598310726)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Observa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106965709045311318)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351582614311616)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972974403311323)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Se\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107036372323311376)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Se\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234822484310727)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Tag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298629263310784)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274821404310766)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Enviar P\00E1gina por E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041778311311380)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Esvaziar linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973584536311324)
,p_name=>'WS_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107051188664311387)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054871294311390)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'A mensagem de erro deve ser especificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005381963311351)
,p_name=>'WS_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981100159311330)
,p_name=>'WS_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107463696485311696)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'O arquivo deve ter um valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045121702311382)
,p_name=>'WS_FILL'
,p_message_language=>'pt-br'
,p_message_text=>'Preencher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045201424311382)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Preencher os valores da coluna nulo com os valores da coluna da c\00E9lula acima.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044981572311382)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960096798311314)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Usando aplicativos de Websheet, os usu\00E1rios finais podem gerenciar dados estruturados e n\00E3o estruturados, sem precisar do desenvolvedor. Os recursos permitem aos usu\00E1rios:'),
'',
'<ul>',
unistr('<li>Criar e compartilhar o conte\00FAdo pela web usando apenas um Web browser.</li>'),
unistr('<li>Organizar p\00E1ginas em uma hierarquia e p\00E1ginas de links cruzados.</li>'),
'<li>Criar e gerenciar dados tabulares usando um recurso incorporado denominado grades de dados.</li>',
unistr('<li>Criar relat\00F3rios interativos usando SQL nas estruturas de dados existentes dentro do banco de dados.</li>'),
unistr('<li>Expor dados da grade de dados e de relat\00F3rio nas p\00E1ginas como gr\00E1ficos ou relat\00F3rios.</li>'),
unistr('<li>Anotar p\00E1ginas com arquivos, tags e observa\00E7\00F5es. As imagens associadas podem ser mostradas alinhadas dentro do conte\00FAdo da p\00E1gina (usando a sintaxe).</li>'),
unistr('<li>Pesquisar conte\00FAdo da p\00E1gina (usando a fun\00E7\00E3o de pesquisa incorporada).</li>'),
unistr('<li>Gerenciar quem pode fazer log-in. Ap\00F3s o log-in, gerenciar quem pode ler, gravar ou administrar o aplicativo (autentica\00E7\00E3o e autoriza\00E7\00E3o).</li>'),
'</ul>',
unistr('<p>Clique em Ajuda para obter mais informa\00E7\00F5es.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039989833311378)
,p_name=>'WS_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045980060311383)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053860136311389)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'O nome do grupo deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040247018311379)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alinhamento do Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040606816311379)
,p_name=>'WS_HEIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054075694311389)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('coluna inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052625111311388)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de coluna inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010864857311356)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de Grade de Dados ou Alias Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981381755311330)
,p_name=>'WS_LINKS'
,p_message_language=>'pt-br'
,p_message_text=>'Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046664311311383)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Link'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979893099311329)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Link para esta p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045472533311383)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>'ordem de carga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053238907311389)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da lista de valores j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039216436311378)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o de Lista de Valores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053383498311389)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A defini\00E7\00E3o da lista de valores deve ser especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040805618311379)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As listas de valores s\00E3o usadas para restringir os valores de coluna que um usu\00E1rio pode informar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040965834311379)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode associar a Lista de Valores definidos para uma coluna em Editar Propriedades da coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052907638311389)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Lista de Valores deve ser definida para o tipo de exibi\00E7\00E3o selecionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053154537311389)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'O nome da Lista de Valores deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039155520311378)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome da Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980912337311330)
,p_name=>'WS_MAP'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040589047311379)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812573486311194)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Largura M\00E1xima n\00E3o pode ser maior que 4000.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038288411311377)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'pt-br'
,p_message_text=>'minimizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107003052884311350)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Mover Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365600449311626)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o corresponde ao formato de data de %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053955443311389)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'O novo nome da Grade de Dados deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979471855311329)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'O nome deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041515400311380)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Valor da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235473166310727)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Nova Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045780246311383)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Nome da Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045826479311383)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107039002613311378)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Nova Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040774588311379)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'pt-br'
,p_message_text=>'Nova Lista de Valores com Base nos Valores Atuais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235272297310727)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235554211310728)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235144265310727)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Se\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047780375311384)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055275632311390)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Novo Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940702976311293)
,p_name=>'WS_NOTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Observa\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981207005311330)
,p_name=>'WS_NOTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Observa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940829103311293)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Observa\00E7\00E3o deve conter algum valor. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235085249310727)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma coluna encontrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234647625310727)
,p_name=>'WS_NO_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Arquivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233592331310726)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum arquivo escolhido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234441396310727)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Observa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234960082310727)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038738557311378)
,p_name=>'WS_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055101566311390)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Antigo Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045393067311382)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Ordenar Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005582135311352)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alias da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274682891310765)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina criada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005675898311352)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235326193310727)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Diret\00F3rio de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106235747620310728)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Hist\00F3rico de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403705807311653)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista Hier\00E1rquica de P\00E1ginas com P\00E1ginas Filhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351077120311616)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'pt-br'
,p_message_text=>'Propriedades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052355815311388)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'pt-br'
,p_message_text=>'Esta consulta retorna mais de 10.000 linhas. Filtre seus dados para garantir resultados completos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019245914311363)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta sobre objetos do aplicativo interno n\00E3o permitida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040198601311379)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Leitura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054926005311390)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00F5es recentes listadas abaixo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351295056311616)
,p_name=>'WS_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>'Substituir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045049863311382)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'pt-br'
,p_message_text=>'Substituir Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055058212311390)
,p_name=>'WS_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107045639915311383)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas com Colunas Vazias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363248348311624)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0 criada em %1 por %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363198834311624)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'pt-br'
,p_message_text=>'Chave da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107363372089311624)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo atualizado %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054272620311390)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'pt-br'
,p_message_text=>'Uma linha deve ser selecionada para definir o valor da coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981010527311330)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>'Ordem da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107052527349311388)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma linha deve ser selecionada para exclus\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989159022311336)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A home page de amostra ser\00E1 criada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107002814069311349)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar e Adicionar Outro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404723965311654)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Pesquisa %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107005455108311352)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo da se\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106274555847310765)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se\00E7\00E3o criada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106989297069311336)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo da Se\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041670050311380)
,p_name=>'WS_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107044736985311382)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas Selecionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040071070311378)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Grupo de Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106961631409311315)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione o nome do relat\00F3rio para exibir as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053726773311389)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sequ\00EAncia deve ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107053643813311389)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sequ\00EAncia deve ser especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107041428534311380)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Valores de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107411710488311659)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Pol\00EDtica de Privacidade da Oracle</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404283259311654)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ao clicar em "Pr\00F3ximo" abaixo, voc\00EA reconhece e concorda que o uso do Web site da Oracle est\00E1 sujeito aos <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Termos de Uso do Oracle.com</a>. Detalhes adicionais referentes \00E0 colet')
||unistr('a e ao uso de suas informa\00E7\00F5es pessoais por parte da Oracle, incluindo informa\00E7\00F5es sobre acesso, reten\00E7\00E3o, retifica\00E7\00E3o, exclus\00E3o, seguran\00E7a, transfer\00EAncias entre fronteiras e outros t\00F3picos, est\00E3o dispon\00EDveis na <a href="https://www.oracle.com/legal/')
||unistr('privacy/index.html" target="_new">Pol\00EDtica de Privacidade da Oracle.</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038679489311377)
,p_name=>'WS_STRING'
,p_message_language=>'pt-br'
,p_message_text=>'String'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054434382311390)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'A string a ser localizada deve ser especificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106981472469311330)
,p_name=>'WS_TAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107351181983311616)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alternar Caixas de Sele\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107047813476311384)
,p_name=>'WS_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046022550311383)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas N\00E3o Designadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038548920311377)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'pt-br'
,p_message_text=>'Identificador Exclusivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107046862061311384)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>'Destino do URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054577034311390)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>'Especifique o destino do URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055369656311390)
,p_name=>'WS_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107410046768311658)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do usu\00E1rio muito longo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107365585529311626)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 deve ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106940638986311293)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(Valor Obrigat\00F3rio)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050925258311387)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de Valida\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054612781311390)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifique o nome da valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048741141311385)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada N\00C3O \00E9 igual a literal da string na Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107054769511311390)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sequ\00EAncia de valida\00E7\00E3o deve ser especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048392850311385)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada cont\00E9m pelo menos um dos caracteres da Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050015064311386)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada \00E9 alfanum\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049478825311386)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada est\00E1 contida na Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049537491311386)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada N\00C3O \00E9 zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049240225311385)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada N\00C3O est\00E1 contida na Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049984010311386)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada N\00C3O \00C9 NULA ou zero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049665523311386)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada n\00E3o cont\00E9m espa\00E7os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050125715311386)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada \00E9 num\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107050511289311386)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada \00E9 uma data v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107049071169311385)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada \00E9 igual a literal da string na Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048949213311385)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada n\00E3o cont\00E9m nenhum dos caracteres na Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048229058311385)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada N\00C3O \00C9 NULA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107048588720311385)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna especificada cont\00E9m somente caracteres na Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107055565340311391)
,p_name=>'WS_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107403697253311653)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037803217311377)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107038092148311377)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Observa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107037939462311377)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106979764854311329)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O alias j\00E1 existe. Informe outro alias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107350994444311616)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'pt-br'
,p_message_text=>'Propriedades da Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106960133790311314)
,p_name=>'WS_WELCOME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Bem-vindo \00E0s Websheets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107040497018311379)
,p_name=>'WS_WIDTH'
,p_message_language=>'pt-br'
,p_message_text=>'Largura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980264403311329)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980650931311330)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980864489311330)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980440442311329)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sem Observa\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980188564311329)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Com Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980571588311329)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'pt-br'
,p_message_text=>'Com Links'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980739750311330)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'pt-br'
,p_message_text=>'Com Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106980323099311329)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Com Observa\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731923866311123)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>'<p>A consulta deve conter pelo menos uma coluna de data ou timestamp; verifique a sua consulta. (%0) </p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467266345310911)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'A chave deve ter 8, 16 ou 24 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236452157310728)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo  %0 n\00E3o existe neste espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236606782310729)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha ao carregar a tabela %0. Erros registrados em log na tabela %1. Essa tabela deve ser eliminada antes da nova execu\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236341257310728)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'pt-br'
,p_message_text=>'nenhum arquivo gerado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236288538310728)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'pt-br'
,p_message_text=>'linhas exportadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236723045310729)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A tabela de erro %0 j\00E1 existe. Essa tabela deve ser eliminada antes da nova execu\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106236560257310729)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todas as colunas inclu\00EDdas s\00E3o tipos de dados n\00E3o suportados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213659272310708)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema %0 precisa dos privil\00E9gios READ e WRITE no diret\00F3rio DATA_PUMP_DIR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106217977626310712)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo de armazenamento de objeto escolhido \00E9 muito grande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205093282310700)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro interno durante o processamento da solicita\00E7\00E3o DBMS_CLOUD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106205136708310700)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de credencial inv\00E1lido para uma refer\00EAncia de armazenamento de objeto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213516676310708)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema %0 precisa de privil\00E9gios de acesso para o diret\00F3rio DATA_PUMP_DIR.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216509224310710)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O pacote DBMS_CLOUD n\00E3o est\00E1 dispon\00EDvel neste sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213411144310707)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema %0 precisa do privil\00E9gio EXECUTE no pacote DBMS_CLOUD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448983756310897)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('erro de parse: O corpo da fun\00E7\00E3o n\00E3o pode ser nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449090319310897)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'erro de parse: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441538846310891)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('aplicativo=%0 espa\00E7o de trabalho atual=%1 espa\00E7o de trabalho solicitado=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106441072671310891)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1014 Aplicativo n\00E3o encontrado. Espa\00E7o de trabalho inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443103003310892)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('aplicativo=%0 p\00E1gina=%1 solicita\00E7\00E3o=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437195020310888)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1082 Erro ao executar c\00F3digo de esquema de autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437992863310888)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1007 Ponto de ramifica\00E7\00E3o n\00E3o pode ser nulo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438020565310889)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1008 Erro ao executar ramifica\00E7\00E3o para a p\00E1gina %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198403759310694)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-7746 N\00E3o \00E9 poss\00EDvel processar a ramifica\00E7\00E3o de uma p\00E1gina de Caixa de Di\00E1logo para uma p\00E1gina de um modo de p\00E1gina diferente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446337520310895)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao extrair id de modelo de bot\00E3o=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436747876310888)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>'<p>Clique <a href="%0">aqui</a> para fazer log-in</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437450875310888)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1030 Erro ao executar express\00E3o de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437584773310888)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1004 N\00E3o foi poss\00EDvel calcular fun\00E7\00E3o. computation_point=%0 computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437382788310888)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1003 Erro ao executar consulta de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437249517310888)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'ERR-1001 Erro inesperado ao criar item: FSP_PROCESS_STATE_%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436908672310888)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1001 Erro inesperado em make_deeplinking_item para a sess\00E3o=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438519998310889)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperando que o cookie p_company ou wwv_flow_company contenha o id de grupo de seguran\00E7a do propriet\00E1rio do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442840343310892)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-7621 N\00E3o foi poss\00EDvel determinar o espa\00E7o de trabalho do aplicativo (%0) ao aceitar o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442902639310892)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperando que o cookie p_company ou wwv_flow_company contenha o id de grupo de seguran\00E7a do propriet\00E1rio do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438390865310889)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1011 Tipo de avalia\00E7\00E3o inv\00E1lido: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446205451310895)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro do aplicativo em fetch_value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437043208310888)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1902 O ID do item \00E9 nulo na rotina find_item_name.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437870286310888)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1021 N\00E3o foi poss\00EDvel executar valida\00E7\00E3o de "booleano de retorno do corpo da fun\00E7\00E3o".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437781324310888)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1024 N\00E3o foi poss\00EDvel executar valida\00E7\00E3o de "texto de retorno do corpo da fun\00E7\00E3o".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438432260310889)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'ERR-1812 Erro inesperado ao designar G_FLOW_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443064386310892)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-9988 Informa\00E7\00F5es insuficientes fornecidas para esta solicita\00E7\00E3o. Provavelmente, voc\00EA n\00E3o aguardou que a p\00E1gina anterior fosse totalmente carregada. Pressione os bot\00F5es Voltar e Recarregar do browser ou navegue para a home page do aplicativo para ')
||'continuar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438979331310889)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1555 N\00E3o foi feito log-in no Oracle Log-in Server. N\00E3o foi identificado usu\00E1rio p\00FAblico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442583123310892)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Log-out'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436659771310887)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi feito log-in. Cookie necess\00E1rio \00E0 autentica\00E7\00E3o ausente ou inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443533079310893)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1777: A p\00E1gina %0 n\00E3o forneceu p\00E1gina de destino da ramifica\00E7\00E3o. Reporte este erro ao administrador do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442661952310892)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1013 N\00E3o h\00E1 privil\00E9gio para a opera\00E7\00E3o tentada pelo usu\00E1rio %0. \00C9 necess\00E1ria a atribui\00E7\00E3o %1; entre em contato com o administrador do seu aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268404637310760)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina pode ser solicitada com argumentos se uma checksum for especificada para o procedimento de exibi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268679681310760)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina s\00F3 pode ser acessada com uma ramifica\00E7\00E3o do tipo "Ramificar para P\00E1gina", a partir de outra p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268554620310760)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina s\00F3 pode ser acessada sem argumentos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268824710310761)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os argumentos foram especificados para uma p\00E1gina que n\00E3o aceita argumentos (solicita\00E7\00E3o, limpar cache, valores de item).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268394559310760)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina n\00E3o tem prote\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442405868310892)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regra necess\00E1ria n\00E3o ativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443628825310893)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'pt-br'
,p_message_text=>'<a href="f?p=%0">Reiniciar Aplicativo</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106436822086310888)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'ERR-1001 Erro inesperado em Salvar Rotina.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106438254340310889)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1910 Erro ao avaliar express\00E3o SQL no texto do cabe\00E7alho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469430650310912)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel direcion\00E1-lo \00E0 home page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106442771614310892)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1512 N\00E3o foi poss\00EDvel resolver o alias da p\00E1gina (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446572096310895)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel definir timed_statistics: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446435630310895)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel rastrear: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106440366939310890)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1444 Esquema de autentica\00E7\00E3o n\00E3o suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106437669308310888)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1006 Erro na rotina de valida\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449122567310897)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'pt-br'
,p_message_text=>'Obsoleto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477330121310918)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao excluir atribui\00E7\00E3o de desenvolvedor. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477246788310918)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel extrair informa\00E7\00F5es de localiza\00E7\00E3o do usu\00E1rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677318935311075)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: O usu\00E1rio %0 n\00E3o tem nenhum privil\00E9gio de desenvolvedor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344401295310820)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('COMPAT\00CDVEL (Voc\00EA deve poder executar a importa\00E7\00E3o sem dificuldades.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222612162311519)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERT\00CANCIA para a credencial "%0" (ID Est\00E1tico):'),
'',
unistr('- Os arquivos de exporta\00E7\00E3o do Application Express n\00E3o cont\00EAm informa\00E7\00F5es da credencial.'),
'- Use o procedimento APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL para definir as',
unistr('- credenciais depois que o aplicativo for importado. A credencial est\00E1 sendo'),
unistr('- mencionada com seu ID est\00E1tico "%0"')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339911088310817)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua Vers\00E3o Atual:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812437444311194)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel excluir o aplicativo %0, pois ele est\00E1 instalado em outro espa\00E7o de trabalho!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344020631310820)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o nome do esquema de autentica\00E7\00E3o=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342639858310819)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o id da ramifica\00E7\00E3o="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343891809310820)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id de bug="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341159253310818)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o nome da op\00E7\00E3o de build=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341271916310818)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao definir o id da op\00E7\00E3o de build="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342523218310819)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o nome do bot\00E3o="%0" id="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697994373311091)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o nome da suba\00E7\00E3o da a\00E7\00E3o din\00E2mica="%0" id="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697896719311090)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar a p\00E1gina de a\00E7\00E3o din\00E2mica="%0" nome="%1" id="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106382066613310848)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de erro=%0 o item="%1" id="%2" tem o mesmo nome que um item no n\00EDvel do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341731627310818)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar item de c\00E1lculo de aplicativo="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341632951310818)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id de item de aplicativo="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298981509310784)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id de atributo do plug-in ="%0"	'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106711811246311107)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id do valor de atributo do plug-in="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298899710310784)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id do plug-in="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106355242299310828)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id de evento do plug-in="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341444941310818)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id de processo do aplicativo="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386693849311641)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o id="%0" da op\00E7\00E3o de modelo do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107386516326311641)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o id="%0" do grupo de op\00E7\00F5es de modelo do aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343669309310820)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Form adicionado \00E0 p\00E1gina existente %0 .')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318605138310801)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel importar id de atributos de instala\00E7\00E3o de objeto de banco de dados="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318712479310801)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar id de script de instala\00E7\00E3o="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343352741310819)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de relat\00F3rio inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343167020310819)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar mapa de tradu\00E7\00E3o de aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106240960255310733)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id da coluna da lista valores="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342126097310819)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id da lista de valores="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341370206310818)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o id do item da barra de navega\00E7\00E3o="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342809232310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar a p\00E1gina de c\00E1lculo de p\00E1gina=%0 item=%1 id="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342222063310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o nome da p\00E1gina="%0" id="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106752028930311140)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar grupo de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343579641310820)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina %0 j\00E1 tem bot\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342378850310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o texto de ajuda da p\00E1gina %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342770065310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de erro=%0 item="%1" id="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342473755310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao atualizar o nome da p\00E1gina="%0" id="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343237205310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina na tabela "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343046536310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar a p\00E1gina de processo de p\00E1gina=%0 nome=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342958814310819)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar a p\00E1gina de valida\00E7\00E3o de p\00E1gina=%0 nome=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106342098575310819)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o id da p\00E1gina m\00E3e="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341579781310818)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao definir o ID da instru\00E7\00E3o SQL do processo="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343491538310820)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina de relat\00F3rio %0 existe, a regi\00E3o de relat\00F3rio foi adicionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343756525310820)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina %0 n\00E3o foi criada porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106343915256310820)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o id de atalho="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341834475310818)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar o id da guia-padr\00E3o="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341917241310818)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao renomear o conjunto de guias %1 como %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106341026867310818)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o nome do modelo=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106339814412310817)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Extens\00E3o da API:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344380221310820)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esse arquivo de exporta\00E7\00E3o \00E9 incompat\00EDvel com a vers\00E3o do Application Express para o qual voc\00EA est\00E1 tentando importar o arquivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340824327310818)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>'O procedimento %0 foi chamado sem um valor para p_id -- deve ser fornecido um ID para o aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200186848310695)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo "%0" n\00E3o est\00E1 na faixa permitida (%1 - %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106811926343311193)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo "%0" n\00E3o pode ser usado; a faixa (%1 - %2) est\00E1 reservada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344272816310820)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo %0 est\00E1 reservado para a Oracle Corporation ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106200207533310695)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo "%0" est\00E1 reservado para outro espa\00E7o de trabalho e n\00E3o pode ser usado aqui')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340916899310818)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo %0 n\00E3o foi exclu\00EDdo. N\00E3o haver\00E1 tentativa de importa\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340015179310817)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta importa\00E7\00E3o \00E9 compat\00EDvel com a vers\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770445643311155)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel importar o script. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340584017310817)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do usu\00E1rio, senha ou combina\00E7\00E3o de espa\00E7o de trabalho inv\00E1lida(o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340134553310817)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A importa\00E7\00E3o do seu aplicativo n\00E3o forneceu uma vers\00E3o de exporta\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222500144311519)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum valor foi fornecido para o servidor remoto com o ID est\00E1tico "%0". Use APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER antes de instalar o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770315095311155)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344519111310820)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('NOT COMPATIBLE (Sua exporta\00E7\00E3o pode conter chamadas n\00E3o suportadas por sua vers\00E3o do %0.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222972427311519)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERT\00CANCIA para o servidor remoto "%0" (ID Est\00E1tico).'),
'',
'- Os atributos deste servidor remoto foram definidos com o APEX_APPLICATION_INSTALL.',
unistr('- Observe que os outros aplicativos tamb\00E9m usam este objeto do servidor remoto.'),
'',
'Dessa forma, os atributos do servidor remoto foram atualizados.',
'- URL Base:      %1',
'- Host de HTTPS:    %2',
unistr('- Fuso hor\00E1rio de ORDS: %3')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222872265311519)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERT\00CANCIA para o servidor remoto "%0" (ID Est\00E1tico).'),
'',
unistr('- O atributo PROMPT_ON_INSTALL \00E9 definido como YES.'),
'- Nenhum atributo foi fornecido com APEX_APPLICATION_INSTALL.',
'',
unistr('Dessa forma, as defini\00E7\00F5es do servidor remoto do espa\00E7o de trabalho permanecem inalteradas.'),
'- URL Base:      %1',
'- Host de HTTPS:    %2',
unistr('- Fuso hor\00E1rio de ORDS: %3'),
'',
'Use APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER para alterar os atributos.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107222747880311519)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERT\00CANCIA para o servidor remoto "%0" (ID Est\00E1tico).'),
'',
unistr('- O atributo PROMPT_ON_INSTALL \00E9 definido como NO.'),
unistr('- As defini\00E7\00F5es do arquivo de importa\00E7\00E3o do aplicativo s\00E3o diferentes para os atributos existentes.'),
unistr('- Este servidor remoto tamb\00E9m \00E9 usado por outros aplicativos neste espa\00E7o de trabalho.'),
'',
unistr('Dessa forma, as defini\00E7\00F5es do servidor remoto do espa\00E7o de trabalho permanecem inalteradas.'),
'- URL Base:      %1',
'- Host de HTTPS:    %2',
unistr('- Fuso hor\00E1rio de ORDS: %3'),
'',
'Use APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER para alterar os atributos.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770227454311155)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'substituir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008442502311354)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode importar feedback para o mesmo sistema!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106770530986311155)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tamanho do script de %0 bytes excede o tamanho m\00E1ximo permitido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106344157173310820)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vari\00E1vel de pacote g_security_group_id deve ser definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340739792310818)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vari\00E1vel g_security_group_id do pacote deve ser definida para importar um aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340323920310817)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel estabelecer a \00FAltima vers\00E3o da API do mecanismo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340231961310817)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel estabelecer a vers\00E3o do seu mecanismo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106340427136310817)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA precisar\00E1 fazer upgrade para importar este aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107008316209311354)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O feedback n\00E3o foi exportado para este sistema de implanta\00E7\00E3o!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212721430310707)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As automa\00E7\00F5es que fazem refer\00EAncia a Origens de Dados REST n\00E3o podem ser copiadas de outro aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211168265310705)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389292462310853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Corpo de Fun\00E7\00E3o PL/SQL que Retorna uma consulta SQL \00E9 obrigat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389190213310853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta SQL \00E9 obrigat\00F3ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389341572310853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Servi\00E7o SQL Ativado por REST \00E9 obrigat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389075886310853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome da Tabela \00E9 obrigat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389465270310853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Origem de Dados REST \00E9 obrigat\00F3ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106389573277310853)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A cl\00E1usula WHERE ou ORDER BY \00E9 obrigat\00F3ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444610754310893)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicativo:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460952499310906)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum aplicativo selecionado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444948151310894)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<span class="tiny">Nenhuma p\00E1gina encontrada.</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444755397310893)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445089529310894)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 <font size=-2>P\00E1ginas</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631227231311041)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('contagem de p\00E1ginas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106631352115311041)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('lista de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444866047310894)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('PL/SQL %0 %1 cont\00E9m %2 linhas de c\00F3digo-fonte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879953088311247)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O preenchimento de c\00F3digo n\00E3o \00E9 suportado para SQL Remota.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106879292054311246)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Query Builder n\00E3o \00E9 suportado para SQL Remota.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477454404310918)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de parse de relat\00F3rio atualiz\00E1vel: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107412355421311660)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel redirecionar de uma p\00E1gina da Caixa de Di\00E1logo para uma p\00E1gina Normal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449372469310897)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'pt-br'
,p_message_text=>'obsoleto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449255730310897)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Expurgadas %0 sess\00F5es duplicadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417628715310873)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode alterar somente sua senha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417828831310873)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro inesperado ao processar sua solicita\00E7\00E3o de altera\00E7\00E3o de senha: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417352162310873)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Devem ser fornecidas a senha e a confirma\00E7\00E3o da senha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106417406084310873)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As senhas n\00E3o correspondem; tente novamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418439231310874)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'pt-br'
,p_message_text=>'Erro Oracle: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106418165346310874)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1025 Erro ao Processar Express\00E3o PLSQL.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309059344310793)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O atributo de membro especificado n\00FAmero %0 \00E9 inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449750778310898)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de exist\00EAncia/n\00E3o exist\00EAncia inv\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449550900310897)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de corpo da fun\00E7\00E3o inv\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449492171310897)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de express\00E3o PL/SQL inv\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449603233310898)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o de express\00E3o SQL inv\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463811186310908)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a execu\00E7\00E3o de wwv_flow_copy: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198827146310694)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Aplicativo traduzido \00E9 inv\00E1lido. Esse ID est\00E1 sendo usado por um aplicativo existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463793515310908)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Grupo de Seguran\00E7a (sua identidade de espa\00E7o de trabalho) n\00E3o est\00E1 definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106751433919311139)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O modo de compatibilidade do aplicativo "%0" deve ser de pelo menos 21.2 para uma atualiza\00E7\00E3o de tema. O modo de compatibilidade pode ser alterado pela Defini\00E7\00E3o do Aplicativo, em Propriedades.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107448180566311685)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tema atual n\00E3o \00E9 compat\00EDvel com o tema mestre selecionado; os identificadores de tema n\00E3o correspondem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106876850742311244)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar modelo; modelo pai n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317069509310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar o esquema de autentica\00E7\00E3o. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316413544310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar o modelo de bot\00E3o. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470618847310913)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar o modelo de calend\00E1rio. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316278737310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar o modelo de campo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317126308310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar a ajuda do item. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316022681310799)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar o modelo de lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316907608310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar a lista de valores. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316508036310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar o modelo de Breadcrumb. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316852861310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar a barra de navega\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315837907310799)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar o modelo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316352112310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel publicar modelo de Lista de Valores popup. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315943507310799)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar o modelo de regi\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316187257310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar o modelo de relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316668963310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel publicar o esquema de seguran\00E7a. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106316750955310800)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel publicar o atalho. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314279524310798)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia do esquema de autentica\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313157902310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia do modelo de bot\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106470533051310913)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel fazer inscri\00E7\00E3o no modelo de calend\00E1rio. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312437341310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia do campo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314395874310798)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia da ajuda do item. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312204906310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia da lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312851743310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel remover o id de refer\00EAncia da Lista de Valores. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106313081213310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel remover o id de refer\00EAncia do modelo de Breadcrumb. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312765311310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia da barra de navega\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312000754310796)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia da p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312984340310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel remover o id de refer\00EAncia do modelo de Lista de Valores popup. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312112447310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia da regi\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312315320310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia do relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312533723310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia do esquema de seguran\00E7a. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106312672688310797)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o id de refer\00EAncia do atalho. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315685685310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no esquema de autentica\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315169686310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de bot\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407918261311656)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel fazer inscri\00E7\00E3o no modelo de calend\00E1rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314841961310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de campo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315777016310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o na ajuda do item. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314622980310798)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315541808310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o na Lista de Valores. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315038367310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de breadcrumb. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315432254310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o na barra de navega\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314443793310798)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314973361310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no Modelo de Lista de Valores Popup. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314574046310798)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de regi\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106314790748310798)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no modelo de relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315260354310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no esquema de seguran\00E7a. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106315398128310799)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel fazer inscri\00E7\00E3o no atalho. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107387047656311641)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel inscrever as op\00E7\00F5es do tema. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477935814310919)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a execu\00E7\00E3o de wwv_flow_copy_page: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464053420310908)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a execu\00E7\00E3o de wwv_flow_copy_page_item: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337054481310815)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel localizar %0 (%1) para c\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664397022311065)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('j\00E1 existe um atalho com o nome %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106464408762310908)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar atalho (%0) para c\00F3pia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465480897310909)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (criar modelos de relat\00F3rio): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466092029310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (calcular destinos de guia): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469387457310912)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar esquemas de autentica\00E7\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469289771310912)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar esquemas de autoriza\00E7\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466878816310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar modelos de bot\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466327229310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (modelo do campo de c\00F3pia): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466611576310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (copiar modelos de lista): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467091130310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (copiar Lista de Valores): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466771340310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (copiar modelos de breadcrumb): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466970480310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar Barra de Navega\00E7\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466235449310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar modelo de p\00E1gina): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466529138310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar modelos de regi\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466420903310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar modelos de relat\00F3rio): %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467143242310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (copiar esquema de seguran\00E7a): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465336197310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (criar modelo de campo): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465629112310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (criar modelos de lista): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465725087310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (criar modelos de breadcrumb): %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465179081310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (criar p\00E1gina): %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106466117400310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (criar guias m\00E3es): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465275316310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (criar modelo de p\00E1gina): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465806945310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar aplicativo atual (criar modelo de Lista de Valores Popup): %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465521940310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (criar modelos de regi\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465981549310910)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar aplicativo atual (criar guias padr\00E3o): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106465076097310909)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Verificar erro %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664195633311064)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106664007940311064)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar MRD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106663995083311064)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar MRU'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651295952311055)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728933539311121)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina de form. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106755422429311143)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina global.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107239848408311534)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina Relat\00F3rio Interativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729149740311121)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de cria\00E7\00E3o de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729049070311121)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar p\00E1gina de form tabular. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729235936311121)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Extrair Linha de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772607078311157)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Cookie de Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106868647867311238)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106728515094311120)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina do Menu %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106729376585311121)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Processar Linha de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106817629851311198)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'pt-br'
,p_message_text=>'release %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656887030311059)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir itens ocultos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650311094311054)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir pesquisa de relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106745188935311135)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Linha por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741291138311131)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Script em Execu\00E7\00E3o:%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106772507244311156)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definir Cookie de Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106658069784311060)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este procedimento deve ser chamado a partir de uma sess\00E3o de aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106219759180310713)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A credencial n\00E3o pode ser usada para este ponto final de URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213299062310707)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os URLs na lista devem come\00E7ar com http:// ou https://')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758501875311145)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'pt-br'
,p_message_text=>'Credenciais para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467376736310911)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover css: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773298149311157)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o recurso de arrastar e soltar nas Origens de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448870105310896)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar Altera\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330326319310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A fun\00E7\00E3o de sentinela de p\00E1gina retornar\00E1 o resultado booleano da verifica\00E7\00E3o de sess\00E3o incorporada ao mecanismo. Se o resultado for verdadeiro, o mecanismo continuar\00E1 a mostrar ou aceitar a p\00E1gina. Se for falso, o mecanismo redirecionar\00E1 para o URL ')
||unistr('ou p\00E1gina de sess\00E3o inv\00E1lida especificados no esquema de autentica\00E7\00E3o (veja a seguir).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331645088310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se a fun\00E7\00E3o de sentinela de p\00E1gina retornar TRUE, a convers\00E3o ou o processamento da p\00E1gina continuar\00E1. Se o resultado for FALSE, o mecanismo dever\00E1 ser encerrado, pois n\00E3o h\00E1 um destino de sess\00E3o inv\00E1lida especificado no esquema de autentica\00E7\00E3o. Ness')
||unistr('e caso, sup\00F5e-se que a fun\00E7\00E3o de sentinela de p\00E1gina fornecida pelo usu\00E1rio redirecionou para uma p\00E1gina de log-in fora do ambiente %0, possivelmente um portal com autentica\00E7\00E3o externa. A fun\00E7\00E3o tamb\00E9m deve ter definido a vari\00E1vel global g_unrecovera')
||unistr('ble_error := true para instruir o mecanismo a encerrar sem mostrar uma p\00E1gina de erro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331742464310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O mecanismo executar\00E1 o seguinte c\00F3digo especificado como o processo pr\00E9-autentica\00E7\00E3o do esquema de autentica\00E7\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331822623310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executado como um bloco an\00F4nimo que n\00E3o retorna valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331948574310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum c\00F3digo de pr\00E9-autentica\00E7\00E3o foi especificado neste esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332136257310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Qualquer combina\00E7\00E3o de nome do usu\00E1rio/senha informada no form de log-in ser\00E1 considerada v\00E1lida. O nome do usu\00E1rio ser\00E1 usado como o nome do usu\00E1rio que fez log-in para vida da sess\00E3o. Esta t\00E9cnica pode ser usada enquanto voc\00EA est\00E1 desenvolvendo o s')
||unistr('eu aplicativo, mas antes de as contas de usu\00E1rio serem estabelecidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332231823310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifique o nome do usu\00E1rio e a senha informada no form de log-in nas contas do Application Builder (usu\00E1rio do cookie). Estas s\00E3o as mesmas contas usadas no seu espa\00E7o de trabalho para fazer log-in no %0. Esta t\00E9cnica poder\00E1 ser \00FAtil quando os usu\00E1r')
||unistr('ios do seu aplicativo forem desenvolvedores com %0 contas nos mesmos banco de dados e espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264553693310757)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifique o nome de usu\00E1rio e a senha informados no form de log-in para as contas do banco de dados Oracle. Essa t\00E9cnica \00E9 conveniente quando o usu\00E1rio tem contas no banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332365663310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifique o nome de usu\00E1rio e a senha informados no form de log-in usando o diret\00F3rio LDAP especificado nesse esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332433776310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os par\00E2metros de LDAP est\00E3o definidos como:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333111502310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Execute o seguinte c\00F3digo personalizado para verificar credenciais:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333304418310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulte na tabela de sess\00F5es incorporadas a sess\00E3o usada pela p\00E1gina de log-in incorporada. Se a sess\00E3o existir e n\00E3o pertencer a outro usu\00E1rio, marque-a como agora sendo pertencente ao usu\00E1rio autenticado (usando o nome de usu\00E1rio indicado no form ')
||'de log-in).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330464373310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A fun\00E7\00E3o de sentinela de p\00E1gina retornar\00E1 ao mecanismo o resultado booleano da verifica\00E7\00E3o de sess\00E3o incorporada complementado (com a fun\00E7\00E3o AND) com o resultado da verifica\00E7\00E3o de sess\00E3o fornecida pelo usu\00E1rio. Se o resultado for verdadeiro, o mecani')
||unistr('smo continuar\00E1 a mostrar ou aceitar a p\00E1gina. Se for falso, o mecanismo redirecionar\00E1 para o destino de sess\00E3o inv\00E1lida especificado no esquema de autentica\00E7\00E3o (veja a seguir).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333444641310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina o cookie chamado %0 como um valor que localize a linha na tabela de sess\00F5es internas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333522826310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Determine o URL para redirecionar ao pr\00F3ximo. Se um "link profundo" tiver sido registrado no estado da sess\00E3o pelo mecanismo de renderiza\00E7\00E3o, use-o como URL para o qual ir. Caso contr\00E1rio, v\00E1 para o URL especificado como atributo de link inicial do a')
||'plicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333743797310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s a verifica\00E7\00E3o de credenciais, o mecanismo executar\00E1 o seguinte c\00F3digo, que est\00E1 especificado no processo p\00F3s-autentica\00E7\00E3o desse esquema de autentica\00E7\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333888625310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Executado como um bloco an\00F4nimo que n\00E3o retorna valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333979848310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 um c\00F3digo p\00F3s-autentica\00E7\00E3o personalizado especificado neste esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334049967310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecione para o URL determinado acima. Isso marca o final do processamento de log-in usando a p\00E1gina de log-in incorporada e as APIs que ele chama.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330524832310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use a l\00F3gica personalizada para executar tarefas de sentinela de p\00E1gina. Para cada solicita\00E7\00E3o de p\00E1gina, o mecanismo executar\00E1 o seguinte c\00F3digo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330673789310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O resultado booleano do bloco acima ser\00E1 retornado ao mecanismo. Se o resultado for verdadeiro, o mecanismo continuar\00E1 a mostrar ou aceitar a p\00E1gina. Se for falso, o mecanismo redirecionar\00E1 para o destino de sess\00E3o inv\00E1lida especificado no esquema de')
||unistr(' autentica\00E7\00E3o (veja a seguir).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330745888310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O m\00E9todo incorporado para verifica\00E7\00E3o de sess\00E3o est\00E1 dispon\00EDvel para o desenvolvedor %0 atrav\00E9s da chamada da API:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330893731310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O resultado desta fun\00E7\00E3o booleana pode ser combinado com outras verifica\00E7\00F5es na fun\00E7\00E3o de sentinela de p\00E1gina fornecida pelo usu\00E1rio especificada em um esquema de autentica\00E7\00E3o. Se esta API for chamada, verificar\00E1 o cookie denominado %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330993309310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se o cookie existir e seu valor decodificado localizar uma linha na tabela de sess\00F5es internas, a sess\00E3o ser\00E1 considerada v\00E1lida e um valor TRUE ser\00E1 retornado para a fun\00E7\00E3o de sentinela de p\00E1gina que a chamou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331158238310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se a fun\00E7\00E3o de sentinela de p\00E1gina retornar TRUE, a convers\00E3o ou o processamento da p\00E1gina prosseguir\00E1. Se o resultado for FALSE, o mecanismo mostrar\00E1 a p\00E1gina %0, considerada como a p\00E1gina de log-in deste aplicativo com base em sua designa\00E7\00E3o neste ')
||unistr('esquema de autentica\00E7\00E3o como a p\00E1gina da sess\00E3o inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331522375310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A fun\00E7\00E3o de sentinela de p\00E1gina retorna um resultado booleano para o mecanismo. Se o resultado for TRUE, a convers\00E3o ou o processamento da p\00E1gina prosseguir\00E1. Se o resultado for FALSE, o mecanismo redirecionar\00E1 para %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334104715310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma abordagem t\00EDpica \00E9 que a p\00E1gina contenha um form de log-in para capturar as credenciais do usu\00E1rio. Dessa forma, os processos ap\00F3s a submiss\00E3o da p\00E1gina chamariam um m\00F3dulo de autentica\00E7\00E3o para verificar as credenciais. Ap\00F3s a autentica\00E7\00E3o, a p\00E1g')
||unistr('ina faria o registro de uma sess\00E3o e executaria tarefas de defini\00E7\00E3o de cookie. Por \00FAltimo, redirecionaria para a p\00E1gina inicial do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334247814310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A %0 API: wwv_flow_custom_auth_std pode ser chamada por esses processos ap\00F3s a submiss\00E3o para executar qualquer uma das etapas que acabaram de ser descritas. H\00E1 dois pontos de entrada dispon\00EDveis:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334357384310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Chame o procedimento de log-in para que o mecanismo execute todas as etapas para voc\00EA. Ele usar\00E1 a tabela de sess\00F5es incorporadas e executar\00E1 o registro de sess\00E3o e a defini\00E7\00E3o de cookie para voc\00EA. Qualquer c\00F3digo personalizado fornecido nesse esquem')
||unistr('a de autentica\00E7\00E3o ser\00E1 executado nos pontos de pr\00E9-autentica\00E7\00E3o, autentica\00E7\00E3o e p\00F3s-autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334470088310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Chame o procedimento post_log-in se voc\00EA mesmo estiver executando a autentica\00E7\00E3o, mas gostaria de que o %0 gerenciasse todo o processo p\00F3s-autentica\00E7\00E3o. Com esses dois pontos de entrada, voc\00EA pode seguir qualquer uma das etapas de processamento de lo')
||unistr('g-in incorporado em combina\00E7\00E3o com sua pr\00F3pria p\00E1gina de log-in e quaisquer processos executados nela. Lembre-se de que, se usar o processamento p\00F3s-autentica\00E7\00E3o incorporado, voc\00EA tamb\00E9m poder\00E1 se beneficiar do processamento de verifica\00E7\00E3o de sess\00E3o ')
||unistr('e da fun\00E7\00E3o de sentinela de p\00E1gina incorporada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331283970310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('a p\00E1gina de log-in incorporada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334504008310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'pt-br'
,p_message_text=>'Processamento de Log-in Externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335334673310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URL de log-in %0 aparentemente n\00E3o especifica uma p\00E1gina do aplicativo %1 como destino da sess\00E3o inv\00E1lida. Al\00E9m disso, n\00E3o h\00E1 valores de processamento de log-in no esquema de autentica\00E7\00E3o. Esta p\00E1gina \00E9 respons\00E1vel pelo desempenho das seguintes tar')
||'efas:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335494130310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Observe que, a menos que os servi\00E7os chamados neste URL usem a API %0 wwv_custom_auth_std para ajudar nas tarefas de registro de sess\00E3o, o seu aplicativo n\00E3o poder\00E1 usar a sentinela de p\00E1gina incorporada ou processamento de verifica\00E7\00E3o de sess\00E3o. Voc')
||unistr('\00EA dever\00E1 fazer este trabalho usando os seus pr\00F3prios meios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335749398310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URL de log-in %0 aparentemente n\00E3o especifica uma p\00E1gina do aplicativo %1 como destino da sess\00E3o inv\00E1lida. Esta p\00E1gina \00E9 respons\00E1vel pelo desempenho das seguintes tarefas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335835649310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores definidos para o processamento de log-in no esquema de autentica\00E7\00E3o s\00E3o mostrados abaixo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335963631310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A p\00E1gina de log-in especificada neste esquema \00E9 a p\00E1gina [%0] neste aplicativo. Esta p\00E1gina \00E9 respons\00E1vel por executar as seguintes etapas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336035188310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Entretanto, n\00E3o h\00E1 valores de processamento de log-in no esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106336131102310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Como esta \00E9 a p\00E1gina de log-in designada para o aplicativo, n\00E3o \00E9 poss\00EDvel executar certas a\00E7\00F5es aqui quando ela \00E9 exibida pela primeira vez, pois ainda n\00E3o ocorreu a autentica\00E7\00E3o do usu\00E1rio. Al\00E9m disso, certas vari\00E1veis de estado de sess\00E3o e de iden')
||unistr('tifica\00E7\00E3o de sess\00E3o n\00E3o est\00E3o dispon\00EDveis para c\00E1lculos ou processos de p\00E1gina, o que ocorreria em p\00E1ginas normais processadas ap\00F3s a autentica\00E7\00E3o. Por esses motivos, a especifica\00E7\00E3o de uma p\00E1gina de log-in por n\00FAmero de p\00E1gina em um esquema de auten')
||unistr('tica\00E7\00E3o \00E9 adequada somente a p\00E1ginas que t\00EAm pouca ou nenhuma funcionalidade diferente de processamento de form de log-in. Se voc\00EA preferir que sua p\00E1gina de log-in fique mais ativa, use a designa\00E7\00E3o do URL de log-in no assistente de esquema de auten')
||unistr('tica\00E7\00E3o ou na p\00E1gina de edi\00E7\00E3o. Desde que voc\00EA se lembre de definir o atributo de p\00E1gina p\00FAblica como ''Sim - Esta p\00E1gina \00E9 p\00FAblica'' usando o form de atributos da p\00E1gina no Builder, a p\00E1gina de log'),
unistr('in pode usar toda a faixa de recursos de %0 al\00E9m de funcionar como a p\00E1gina de log-in no seu aplicativo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334638785310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de autentica\00E7\00E3o n\00E3o especifica que uma p\00E1gina de log-in nem um URL seja usado para o alvo da sess\00E3o inv\00E1lida. Isso implica que a fun\00E7\00E3o de sentinela de p\00E1gina trate o caso. Talvez ela redirecione para um portal de sign-on \00FAnico ou para o')
||unistr('utro servidor de log-in. Al\00E9m disso, n\00E3o h\00E1 valores de processamento de log-in no esquema de autentica\00E7\00E3o. Se esta n\00E3o for a sua inten\00E7\00E3o, edite este esquema de autentica\00E7\00E3o e forne\00E7a uma p\00E1gina ou URL da sess\00E3o inv\00E1lida e, em seguida, examine novame')
||unistr('nte o view deste gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334728920310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este esquema de autentica\00E7\00E3o n\00E3o especifica uma p\00E1gina de log-in nem um URL a ser usado para o destino de sess\00E3o inv\00E1lida. Isso deve ser resolvido pela fun\00E7\00E3o de sentinela de p\00E1gina. Talvez ela redirecione para um portal de sign-on \00FAnico ou outro ser')
||unistr('vidor de log-in. No entanto, existem valores definidos para o processamento de log-in no esquema de autentica\00E7\00E3o, conforme abaixo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334848596310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URL de log-in %0 aparentemente especifica uma p\00E1gina do aplicativo %1 como destino da sess\00E3o inv\00E1lida. No entanto, n\00E3o h\00E1 valores de processamento de log-in no esquema de autentica\00E7\00E3o. Esta p\00E1gina \00E9 respons\00E1vel pelo desempenho das seguintes tarefas')
||':'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106334983073310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para que o mecanismo %0 possa mostrar ou aceitar a p\00E1gina de log-in no seu aplicativo, voc\00EA dever\00E1 selecionar o atributo de p\00E1gina ''Sim - Esta p\00E1gina \00E9 p\00FAblica'' na p\00E1gina Atributos de P\00E1gina do Application Builder. Se voc\00EA n\00E3o fizer isto, o mecanismo')
||unistr(' tentar\00E1 executar a fun\00E7\00E3o de sentinela de p\00E1gina antes de mostrar a p\00E1gina. Se voc\00EA ainda n\00E3o tiver feito log-in, ser\00E1 tentado um redirecionamento para o mesmo URL. Isto causar\00E1 um loop bastante desagrad\00E1vel. Se voc\00EA codificar sua pr\00F3pria fun\00E7\00E3o de ')
||unistr('sentinela de p\00E1gina, talvez precise reconhecer quando a p\00E1gina atual for esta p\00E1gina de log-in e trat\00E1-la de modo diferente daquele de outras p\00E1ginas. Se voc\00EA puder identific\00E1-la pelo n\00FAmero da p\00E1gina, isso ser\00E1 \00F3timo. Uma t\00E9cnica mais gen\00E9rica \00E9 usa')
||unistr('r a fun\00E7\00E3o booliana wwv_flow_custom_auth.current_page_is_public para reconhecer este atributo p\00FAblico da p\00E1gina de log-in ou de qualquer outra p\00E1gina do seu aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335052344310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URL de log-in %0 aparentemente especifica uma p\00E1gina do aplicativo %1 como destino da sess\00E3o inv\00E1lida. Esta p\00E1gina \00E9 respons\00E1vel pelo desempenho das seguintes tarefas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335142809310813)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os valores definidos para o processamento de log-in no esquema de autentica\00E7\00E3o s\00E3o mostrados abaixo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335235380310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Servidor SSO do Oracle Application Server redirecionar\00E1 de volta para este aplicativo ap\00F3s a autentica\00E7\00E3o do usu\00E1rio. O ponto de entrada \00E9 o procedimento wwv_flow_custom_auth_sso.process_success no esquema %0. %0 \00E9 registrado como um aplicativo par')
||unistr('ceiro no SSO do Oracle Application Server e pode gerenciar para voc\00EA todas as interfaces com o servidor de log-in. Se, no entanto, voc\00EA preferir registrar o aplicativo no seu pr\00F3prio esquema, poder\00E1 faz\00EA-lo. Voc\00EA pode criar sua pr\00F3pria sentinela de p')
||unistr('\00E1gina ou simplesmente criar um esquema de autentica\00E7\00E3o com base no esquema Portal-SSO (meu aplicativo como aplic. parceiro) da galeria de esquemas de autentica\00E7\00E3o. O esquema resultante chamar\00E1 a sentinela de p\00E1gina incorporada do SSO wwv_flow_custom_')
||unistr('auth_std.portal_sso_sentry_v1. Essa fun\00E7\00E3o requer que o esquema de autentica\00E7\00E3o atual saiba o nome do aplicativo parceiro como registrado no SSO do Oracle Application Server. O assistente para criar esquema de autentica\00E7\00E3o perguntar\00E1 o nome do aplica')
||unistr('tivo parceiro ou o nome poder\00E1 ser adicionado ou alterado editando-se o esquema ap\00F3s sua cria\00E7\00E3o. O nome deve ser informado exatamente como registrado, observando-se o uso de mai\00FAsculas/min\00FAsculas. Voc\00EA tamb\00E9m deve criar seu pr\00F3prio procedimento rece')
||unistr('ptor de URLC e chamar a API wwv_flow_custom_auth_sso.process_success a partir dele, passando o nome do aplicativo como registrado no SSO do Oracle Application Server. Isso registrar\00E1 a sess\00E3o em %0 ap\00F3s a autentica\00E7\00E3o. Se voc\00EA criar sua pr\00F3pria senti')
||unistr('nela de p\00E1gina, ela poder\00E1 chamar a API wwv_flow_custom_auth_sso.portal_sso_redirect para redirecionar ao servidor de log-in quando for detectada a necessidade de autentica\00E7\00E3o. Passe ao procedimento o nome registrado do aplicativo parceiro. Consulte ')
||unistr('a documenta\00E7\00E3o do %0 e do %1 para obter detalhes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335692723310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento p\00F3s-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106335570601310814)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento pr\00E9-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330006916310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usando a l\00F3gica incorporada, verifique o cookie nomeado [%0]. Se ele existir e seu valor decodificado localizar uma linha na tabela de sess\00F5es internas, considere a sess\00E3o v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330222376310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular Valor de Retorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332071162310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica\00E7\00E3o de Credenciais (Autentica\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333675368310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento P\00F3s-autentica\00E7\00E3o Personalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326785176310807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Argumento de ponto de entrada inv\00E1lido para wwv_flow_custom_auth_std.log-in--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.  ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326613220310807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'pt-br'
,p_message_text=>'Argumento p_session_id nulo para wwv_flow_custom_auth_std.log-in--p_flow_page:%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326520818310807)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel executar a fun\00E7\00E3o de verifica\00E7\00E3o de credenciais de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331064850310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Destino de Sess\00E3o Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332730199310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'pt-br'
,p_message_text=>'Base de Pesquisa LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332819434310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O bloco a seguir \00E9 usado para chamar uma fun\00E7\00E3o antes da chamada a DBMS_LDAP.SIMPLE_BIND_S. O nome de usu\00E1rio indicado no form de log-in \00E9 passado para a fun\00E7\00E3o, que retorna um valor usado para substituir %LDAP_USER% na Base de Pesquisa LDAP (consult')
||'e acima).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332926254310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este bloco de c\00F3digo deve ter esta inscri\00E7\00E3o:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333060718310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este recurso permite transformar o nome de usu\00E1rio informado no form de log-in em qualquer formato que corresponda \00E0 entrada do diret\00F3rio LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332534860310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'pt-br'
,p_message_text=>'Host LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106332687458310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'pt-br'
,p_message_text=>'Porta LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329532165310809)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este aplicativo (%0) usa a p\00E1gina %1 como p\00E1gina de log-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329652956310809)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sempre que a p\00E1gina %0 for solicitada, n\00E3o ser\00E1 feita nenhuma outra verifica\00E7\00E3o de autentica\00E7\00E3o e a p\00E1gina ser\00E1 mostrada ou aceita. Com isso, a p\00E1gina de log-in \00E9 mostrada antes de ocorrer a autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329412162310809)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tratamento da P\00E1gina de Log-in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329775857310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o Sentinela de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329818317310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use a l\00F3gica incorporada para executar tarefas de sentinela de p\00E1gina. Para cada solicita\00E7\00E3o de p\00E1gina, a fun\00E7\00E3o de sentinela de p\00E1gina faz a verifica\00E7\00E3o da sess\00E3o e calcula um valor de retorno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106333221966310812)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Processamento P\00F3s-autentica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106330195757310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use o c\00F3digo adicional fornecido pelo usu\00E1rio para determinar se a sess\00E3o \00E9 v\00E1lida. Depois de obter um resultado TRUE da verifica\00E7\00E3o de sess\00E3o incorporada acima, execute o seguinte c\00F3digo e anote seu valor de retorno booleano:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329992328310810)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o de Verifica\00E7\00E3o de Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331370432310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'pt-br'
,p_message_text=>'o servidor SSO do Oracle Application Server'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106331422428310811)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'pt-br'
,p_message_text=>'o URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478262671310919)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216643664310710)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'pt-br'
,p_message_text=>'Job de Carregamento de Dados iniciado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387522686310851)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 arquivos maiores que %1 MB n\00E3o s\00E3o suportados para carregamento de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106773125150311157)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o SQL inv\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306983618310791)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Analisar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307386471310791)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106467418239310911)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de data inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447062623310895)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'pt-br'
,p_message_text=>'Depurar:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447130840310895)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recurso n\00E3o suportado por esta vers\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444261601310893)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1101 N\00E3o foi poss\00EDvel processar consulta de retorno do corpo da fun\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447320212310895)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro 4323- A solicita\00E7\00E3o de ajuda n\00E3o forneceu um ID de p\00E1gina num\00E9rica cuja ajuda ser\00E1 mostrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444032205310893)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1025 Erro ao Processar Express\00E3o PLSQL.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444151543310893)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo=%0 P\00E1gina=%1 SQLERRM=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446838478310895)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel imprimir atalho: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444310853310893)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1108 N\00E3o foi poss\00EDvel processar a condi\00E7\00E3o atual do item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446991124310895)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao converter gr\00E1fico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106597135710311015)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel converter componente: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106241215905310733)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao renderizar a regi\00E3o Lista Din\00E2mica: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447244256310895)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro 4322- A solicita\00E7\00E3o de ajuda n\00E3o usa a sintaxe adequada. A solicita\00E7\00E3o era nula ao esperar um n\00FAmero de p\00E1gina v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473846042310915)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel associar %0. Use aspas para itens com v\00E1rios bytes ou verifique se o comprimento do item tem 30 bytes ou menos. Use a sintaxe v() para referenciar itens com mais de 30 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011981067311357)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperando nome da coluna BLOB na m\00E1scara de formato da coluna do relat\00F3rio DOWNLOAD:TABLE_NAME:BLOB_COLUMN...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366573252311627)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna %0 n\00E3o encontrada na tabela %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106469591811310912)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro em DML: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106303538016310788)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel executar a opera\00E7\00E3o de inser\00E7\00E3o.  %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106625068413311036)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor num\00E9rico inv\00E1lido %0 para a coluna %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310293938310794)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o %0 inv\00E1lida neste objeto. (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011038593311356)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Propriet\00E1rio da tabela inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011192465311356)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010980568311356)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A \00FAltima atualiza\00E7\00E3o da coluna de dados "%0" tipo de dados "%1" usada para rastrear atualiza\00E7\00F5es em "%2" deve ser um tipo de dados de data ou timestamp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011215721311356)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro: Deve ser chamada a p\00E1gina do form que cont\00E9m o nome do item do tipo ARQUIVO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011510904311357)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma M\00E1scara de Formato Encontrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012087257311357)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperando nome da coluna da chave prim\00E1ria 1 na m\00E1scara de formato da coluna do relat\00F3rio DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107366649249311627)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela ou view %0 n\00E3o encontrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011868420311357)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esperando nome da tabela na m\00E1scara de formato da coluna do relat\00F3rio DOWNLOAD:TABLE_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011728770311357)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A m\00E1scara de formato deve incluir pelo menos 4 argumentos separados por v\00EDrgulas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011637400311357)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A m\00E1scara de formato deve come\00E7ar com DOWNLOAD ou IMAGEM')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657149760311059)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" \00E9 inv\00E1lido para a consulta SQL. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302496652310787)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta opera\00E7\00E3o n\00E3o \00E9 permitida para a Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657040904311059)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero incorreto de colunas selecionadas na consulta SQL. Consulte a Ajuda do atributo para obter detalhes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212574546310707)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 tem um tipo de dados incorreto na instru\00E7\00E3o SQL. A coluna #  %1 \00E9 %2 mas esperava %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758045554311145)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" j\00E1 \00E9 usado na consulta SQL. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757979264311145)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" \00E9 inv\00E1lido para a consulta SQL da LOV. Use nomes de alias v\00E1lidos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757704029311145)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de parsing retornou resultados da consulta em "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106757863560311145)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero incorreto de colunas selecionadas na consulta SQL. Consulte a Ajuda do atributo para obter detalhes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106212032370310706)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o Tipo de Origem de Dados REST %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106213950567310708)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome de arquivo duplicado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406321157311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>'Item de Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406197375311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'pt-br'
,p_message_text=>'Constante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405810530311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406933227311656)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Palavra-chave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406825013311656)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View Materializada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406423892311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Pacote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406231687311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405715723311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'pt-br'
,p_message_text=>'Procedimento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406548426311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406698675311656)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'pt-br'
,p_message_text=>'Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107407087395311656)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107405962373311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406002285311655)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vari\00E1vel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107406714834311656)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970909226311322)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Falha ao fazer parsing de consulta SQL da LOV! %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106735767189311127)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Filtro de consulta inv\00E1lido submetido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971843965311323)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" j\00E1 \00E9 usado na consulta SQL da LOV. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971715734311323)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" \00E9 inv\00E1lido para a consulta SQL da LOV. Use nomes de alias v\00E1lidos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106970883223311322)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero incorreto de colunas selecionado na consulta SQL da LOV. Veja exemplos de instru\00E7\00F5es v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310013421310793)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'O servidor encontrou um erro ao tentar remover o arquivo "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310163361310793)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel remover o arquivo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309898592310793)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorreu um erro ao gravar no diret\00F3rio de arquivo f\00EDsico "%0". (%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445371657310894)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excedeu o limite m\00E1ximo de tamanho para os arquivos do espa\00E7o de trabalho n\00E3o internos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309925401310793)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 um arquivo para grava\00E7\00E3o com o id %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106445207202310894)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excedeu o limite m\00E1ximo de tamanho para todos os arquivos do espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106478539726310919)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao excluir atribui\00E7\00E3o de desenvolvedor. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354513203310828)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio n\00E3o foi criado pelo seguinte motivo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107019126231311363)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00E9 um endere\00E7o de e-mail inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472273120310914)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item %0 da lista de sele\00E7\00E3o do tipo c/js de redire\00E7\00E3o n\00E3o tem consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472111227310914)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item %0 da lista de sele\00E7\00E3o do tipo n\00E3o tem consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472344860310914)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item %0 da lista de sele\00E7\00E3o do tipo c/URL de redire\00E7\00E3o n\00E3o tem consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472484352310914)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item %0 da lista de sele\00E7\00E3o do tipo c/URL de redire\00E7\00E3o para p\00E1gina n\00E3o tem consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446711686310895)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar item %0 - %1 , Sequ\00EAncia: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443875391310893)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1904 N\00E3o foi poss\00EDvel calcular padr\00E3o do item: tipo = Corpo da Fun\00E7\00E3o computation_type= %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443722345310893)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1020 Erro ao processar item PLSQL (fun\00E7\00E3o).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106443966469310893)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verifica\00E7\00E3o Ortogr\00E1fica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106446685693310895)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel utilizar valor em cast "%0" para m\00E1scara de formato de data %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211768554310706)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para itens do tipo de dados BLOB para SQL Ativada por REST ou Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211913782310706)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel extrair metadados para o ID da regi\00E3o %s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106691961800311086)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O processo de DML ou Inicializa\00E7\00E3o de Form n\00E3o pode ter uma regi\00E3o de form designada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697696269311090)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao migrar a p\00E1gina Form Legado para a Regi\00E3o do Form: n\00E3o \00E9 poss\00EDvel descrever a tabela referenciada no processo DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106428848481310882)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma checksum foi encontrada para a detec\00E7\00E3o de atualiza\00E7\00E3o perdida. S\00F3 \00E9 poss\00EDvel executar UPDATE ou DELETE para linhas existentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106998282194311346)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel executar a DML do form em uma Origem REST com a Sincroniza\00E7\00E3o ativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211634227310706)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 item de Chave Prim\00E1ria definido para a regi\00E3o de form %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106211894074310706)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'O item %0 tem um tipo de dados incorreto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106379873671310846)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 \00EDndice de dom\00EDnio no %0 selecionado. A gera\00E7\00E3o da DDL n\00E3o pode gerar DDL para \00EDndice de dom\00EDnio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318359466310801)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Rem n\00E3o p\00F4de gerar a DDL para %0 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106349089504310824)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum %0 encontrado para gerar a DDL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318574747310801)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro Save_ddl %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106306115139310790)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel salvar a DDL como um arquivo de script. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318447118310801)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao fazer parsing do script de DDL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472550177310914)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro, o nome do pakage: %0 \00E9 inv\00E1lido ou j\00E1 foi usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453616297310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>'-- API da tabela para o aplicativo %0, gerou %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452398488310899)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Criar pacote PL/SQL %0 com os seguintes procedimentos:',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453238311310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('use para inserir dados em %0; deve ser fornecida a chave prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453355416310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('use para atualizar dados em %0 identificado por chave(s) prim\00E1ria(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453449776310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('use para excluir dados de %0 com base em chave(s) prim\00E1ria(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453558142310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'pt-br'
,p_message_text=>unistr('use para recuperar dados de %0 com base na(s) chave(s) prim\00E1ria(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453186943310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452949723310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download do Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452859358310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Especifica\00E7\00E3o de Download')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452728542310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452560980310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocultar Especifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526367410310962)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>'-- corpo do pacote'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526454268310962)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('-- especifica\00E7\00E3o de pacote')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452666977310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452446411310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Especifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106453019494310900)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'pt-br'
,p_message_text=>'Subprograma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525807749310961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>'-- criar procedimento para tabela "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526078746310962)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>'-- excluir procedimento para tabela "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526197685310962)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>'-- obter procedimento para tabela "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106526283508310962)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('-- construir fun\00E7\00E3o MD5 para tabela "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106525900434310961)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'pt-br'
,p_message_text=>'-- atualizar procedimento para tabela "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472604709310915)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010377339311356)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O identificador de origem do espa\00E7o de trabalho deve ser definido!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010422835311356)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O sistema de implanta\00E7\00E3o deve ser especificado!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350669867310825)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O <p>Componente <strong>%0</strong> n\00E3o pode ser renderizado na <strong>Coluna %1</strong>, pois j\00E1 existe outro componente nesta coluna.</p>'),
unistr('<p>A defini\00E7\00E3o da Coluna e do Per\00EDodo da Coluna para <strong>Autom\00E1tico</strong> para todos os componentes normalmente corrige esse problema.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107454946385311690)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<p>Label do Item da P\00E1gina <strong>%0</strong> n\00E3o pode ser renderizado, pois a configura\00E7\00E3o de grade de per\00EDodo da coluna do label deste item de p\00E1gina \00E9 inv\00E1lida. Ela \00E9 definida para ser exibida com um <strong>Per\00EDodo da Coluna do Label de %1</stro')
||unistr('ng>. Isso n\00E3o \00E9 suportado, pois o item de p\00E1gina s\00F3 tem <strong>%2 Coluna(s)</strong> dispon\00EDveis.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350420751310825)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O <p>Componente <strong>%0</strong> n\00E3o pode ser renderizado, pois as configura\00E7\00F5es de grade deste componente s\00E3o inv\00E1lidas. Ele \00E9 definido para ser exibido na <strong>Coluna %1</strong> com um <span>Per\00EDodo de Coluna de %2</strong>. Isso n\00E3o \00E9 supor')
||unistr('tado, pois a grade nesta p\00E1gina suporta somente at\00E9 <strong>%3 Colunas</strong>.</p>'),
unistr('<p>A defini\00E7\00E3o da Coluna e do Per\00EDodo da Coluna para <strong>Autom\00E1tico</strong> para todos os componentes normalmente corrige esse problema.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350596156310825)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O <p>Componente <strong>%0</strong> n\00E3o pode ser renderizado, pois as configura\00E7\00F5es de grade deste componente s\00E3o inv\00E1lidas. Ele \00E9 definido para ser exibido na <strong>Coluna %1</strong> com um <strong>Per\00EDodo de Coluna de %2</strong>. Isso n\00E3o \00E9 sup')
||unistr('ortado, pois a grade nesta p\00E1gina suporta somente at\00E9 <strong>%3 Colunas</strong>.</p>'),
unistr('<p>A defini\00E7\00E3o da Coluna e do Per\00EDodo da Coluna para <strong>Autom\00E1tico</strong> para todos os componentes normalmente corrige esse problema.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232675655310725)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'pt-br'
,p_message_text=>'DBA: 2 Dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232566992310725)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'pt-br'
,p_message_text=>'2 Day + Developer''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106198997039310694)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia de Administra\00E7\00E3o de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199072575310694)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncia API')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774882283311158)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106768815090311153)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Sobre: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774965268311158)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106232410949310725)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'pt-br'
,p_message_text=>'App Builder User''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880869369311247)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('a cria\00E7\00E3o inicial de \00EDndice pode levar alguns segundos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199191068310694)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia de Migra\00E7\00E3o de Aplicativos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106774651873311158)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo de mapeamento da documenta\00E7\00E3o n\00E3o foi encontrado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106775060113311158)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pontua\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106199249250310694)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia do SQL Workshop e Utilit\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481761229310922)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao criar normaliza\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106657909192311060)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o possui acesso ao esquema que est\00E1 importando. Falha ao importar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481676123310922)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'remove_table_hint foi chamado sem p_table_id; deve ser fornecida uma tabela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387445813310851)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foi encontrada a segunda chamada create_company durante a instala\00E7\00E3o do espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350224547310825)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de GET_BLOCK. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350131465310824)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de GET_STMT. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350382822310825)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar o arquivo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216442995310710)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Arquivo compactado Zip inv\00E1lido, nenhum arquivo de manifesto de instala\00E7\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353705299310827)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o tem privil\00E9gios no esquema %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106350054858310824)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A execu\00E7\00E3o da instru\00E7\00E3o n\00E3o foi bem-sucedida. %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106390039394310853)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Chamada API para procedimento remove_page detectada em grande bloco em arquivo de exporta\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106651354396311055)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 label para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268146902310760)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 um problema com o seu ambiente porque os arquivos do Application Express n\00E3o est\00E3o atualizados! Os arquivos da vers\00E3o #LOADED_VERSION# foram carregados, mas \00E9 esperada a vers\00E3o %0. Verifique se copiou o diret\00F3rio de imagens para o seu servidor de ')
||unistr('aplicativos, conforme instru\00EDdo no Guia de Instala\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106268068890310760)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 um problema com o seu ambiente porque os arquivos do Application Express n\00E3o foram carregados. Verifique se voc\00EA copiou o diret\00F3rio de imagens para o servidor de aplicativos conforme instru\00EDdo no Guia de Instala\00E7\00E3o. Al\00E9m disso, verifique se o seu ')
||unistr('caminho de prefixo de imagem est\00E1 correto. O seu caminho atual \00E9 %0 (que deve conter barras finais e iniciais, como no padr\00E3o /i/). Utilize o script SQL reset_image_prefix.sql se precisar alterar esse caminho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471664759310914)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tentativa n\00E3o autorizada de execu\00E7\00E3o do job %0 pelo esquema: %1 no aplicativo: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482206382310926)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar coleta: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481885701310922)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106481924380310922)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao localizar tipo de dados: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482150386310926)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao obter tipo de dados: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482068240310922)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao obter tamanho m\00E1ximo da coluna1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669956502311069)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel inserir mais de 32KB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482305892310926)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio %0 n\00E3o tem privil\00E9gios no esquema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473356711310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel fazer upgrade do tipo de condi\00E7\00E3o de ramifica\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473268406310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar tipo de condi\00E7\00E3o do bot\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473068311310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar o tipo de c\00E1lculo do Aplicativo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472961892310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel atualizar o tipo de condi\00E7\00E3o ''quando'' do processo de Aplicativo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473738647310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro durante a atualiza\00E7\00E3o de palavras com grafia incorreta. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472894281310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar tipo de condi\00E7\00E3o de exibi\00E7\00E3o da Barra de Navega\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473485603310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel atualizar tipo de c\00E1lculo da p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473659478310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar tipo de processo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473127212310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar tipo de subt\00EDtulo da p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473509290310915)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel atualizar tipo de valida\00E7\00E3o de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107020266369311364)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'pt-br'
,p_message_text=>'%0: "Item(ns) Pai(s) da LOV em Cascata" somente pode(m) ser usado(s), se o "Carregamento Lento" for definido como Sim.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011443549311357)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro: Pelo menos um processo DML pode ser declarado por p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107011307197311356)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro: Nenhum processo DML correspondente encontrado para a p\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107012442948311357)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 deve ter uma coluna BLOB v\00E1lida como origem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973197997311324)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um c\00F3digo PL/SQL que emite HTML deve ser especificado para o item %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483289812310927)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel avolumar a coleta: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482905660310927)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel verificar se foi ou n\00E3o feito parsing do c\00F3digo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483070916310927)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel executar o arquivo de controle: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483712588310927)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel verificar estat\00EDsticas de arquivo de controle: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483639371310927)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel excluir informa\00E7\00F5es submetidas a parse: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483505950310927)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A execu\00E7\00E3o da instru\00E7\00E3o n\00E3o foi bem-sucedida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482445066310926)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar o arquivo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482657792310927)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel obter instru\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448734567310896)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tamanho da linha %0 excede o m\00E1ximo de %1 na linha %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483442062310927)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: Corpo do Pacote criado com erros de compila\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483125617310927)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel executar o c\00F3digo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483307385310927)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel executar a instru\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482724211310927)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel salvar o par\00E2metro no banco de dados: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482566015310926)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel obter o bloco do c\00F3digo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106482825605310927)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel validar o arquivo "%0". %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483883974310927)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel fazer parsing do arquivo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866271260311236)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma fun\00E7\00E3o de autentica\00E7\00E3o foi definida para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866311296311236)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma fun\00E7\00E3o ap\00F3s o log-out foi definida para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106866129906311236)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma fun\00E7\00E3o de sentinela da sess\00E3o foi definida para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419429217311665)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418677713311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Definido por A\00E7\00E3o Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418396311311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redirecionar para P\00E1gina neste Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418504786311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'pt-br'
,p_message_text=>'Redirecionar para URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418457463311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Submeter P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419047568311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'pt-br'
,p_message_text=>'Limpar Cache'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971032055311322)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta LOV \00E9 inv\00E1lida e s\00E3o necess\00E1rios um valor de exibi\00E7\00E3o e um valor de retorno. Os nomes de coluna devem ser diferentes. Se a consulta contiver uma consulta em linha, a primeira cl\00E1usula FROM na instru\00E7\00E3o SQL n\00E3o dever\00E1 pertencer \00E0 consulta e')
||'m linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972768961311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha ao fazer parsing da consulta de origem da regi\00E3o! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353891786310827)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'pt-br'
,p_message_text=>'Falha ao fazer parsing de consulta SQL! %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107442388914311681)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971193562311322)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A LOV est\00E1tica \00E9 inv\00E1lida. S\00E3o necess\00E1rios um valor de exibi\00E7\00E3o e um valor de retorno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106906785261311268)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os itens Tabela, View ou Sin\00F4nimo n\00E3o existem!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353393192310827)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971421569311322)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma consulta de lista de valores (LOV) ou uma lista de valores Nomeados deve ser especificada para itens com este tipo de exibi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971359290311322)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O uso de uma lista de valores (LOV) nomeada s\00F3 \00E9 suportado para os tipos de item que requerem pelo menos duas colunas da LOV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354002823310827)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valo deve ser um n\00FAmero inteiro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106353901357310827)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor deve ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418703793311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279642896310769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'A coluna tem tipos de dados incorretos. Este atributo requer que a coluna tenha um dos seguintes tipos de dados: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106267912350310760)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna n\00E3o existe ou a consulta de origem da regi\00E3o \00E9 inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279752997310770)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'tipos de dados incorretos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972328655311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma origem de regi\00E3o deve ser especificada para regi\00F5es com este tipo de regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972409462311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" j\00E1 \00E9 usado na consulta de origem da regi\00E3o. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972525501311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" \00E9 inv\00E1lido para a consulta de origem da regi\00E3o. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972641352311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero incorreto de colunas selecionado na consulta de origem da regi\00E3o. Veja exemplos de instru\00E7\00F5es v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418934055311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107418890803311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir pagina\00E7\00E3o desta p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419151985311664)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Definir Estes Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106972055205311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" j\00E1 \00E9 usado na consulta SQL. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971929426311323)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome da coluna "%0" \00E9 inv\00E1lido para a consulta SQL. Certifique-se de usar nomes de alias exclusivos para as colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106354992388310828)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero incorreto de colunas selecionadas na consulta SQL. Consulte a Ajuda do atributo para obter detalhes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106971268891311322)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Listas de valores (LOVs) est\00E1ticas s\00F3 s\00E3o suportadas para os tipos de item que requerem pelo menos duas colunas da LOV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419304697311665)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>'Destino do URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107419231791311665)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Com Estes Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106473963289310915)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1711 N\00E3o \00E9 poss\00EDvel converter id de lov popup na solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474031501310916)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1721 N\00E3o \00E9 poss\00EDvel encontrar item para lov popup na solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106247886090310739)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel chegar ao mecanismo de impress\00E3o porque o URL especificado est\00E1 incorreto ou ent\00E3o \00E9 necess\00E1rio especificar um URL de proxy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152431277311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acima da Regi\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152873832311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Abaixo da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152900413311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Base da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152540314311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C0 Esquerda do T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152116031311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Direita da Barra de Pesquisa do Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152615596311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C0 Direita do T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152777851311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152255569311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107152378771311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio e Base da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153081585311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ap\00F3s o Cabe\00E7alho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153104595311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Antes do Rodap\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375619505311633)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Componente n\00E3o encontrado! Talvez ele tenha sido exclu\00EDdo por outro usu\00E1rio. Recarregue a p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375527050311633)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel excluir, pois o componente ''%0'' faz refer\00EAncia a este componente!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375432843311633)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel excluir, pois o componente ''%0'' na p\00E1gina %1 faz refer\00EAncia a este componente!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375775920311633)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O atributo j\00E1 foi alterado por outro usu\00E1rio! Recarregue a p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375939185311633)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O atributo n\00E3o est\00E1 dispon\00EDvel neste contexto!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107375893910311633)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O componente foi alterado por outro usu\00E1rio e este atributo n\00E3o existe mais! Recarregue a p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870168076311239)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A opera\00E7\00E3o de parsing retornou resultados da consulta em "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462761007311695)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O parse retornou os resultados da consulta em "%0". Se voc\00EA cr\00EA que sua consulta est\00E1 sintaticamente correta, marque a caixa de sele\00E7\00E3o "Usar Nomes de Coluna Gen\00E9ricos" abaixo para continuar sem fazer parse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107414128495311661)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>'Deve ser exclusivo!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153213997311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>'Sem Modelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870018669311239)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma consulta foi retornada pelo bloco pl/sql.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107462891957311695)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma consulta foi retornada pelo bloco pl/sql. Se voc\00EA cr\00EA que o c\00F3digo est\00E1 sintaticamente correto, marque a caixa de sele\00E7\00E3o "Usar Nomes de Coluna Gen\00E9ricos" abaixo para continuar sem fazer parse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153464397311467)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina bloqueada por outro usu\00E1rio!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107153351377311466)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A P\00E1gina foi bloqueada por %0! N\00E3o \00E9 poss\00EDvel salvar as altera\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106760381002311147)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel estender o tablespace pois n\00E3o h\00E1 mais esquemas para este %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474160843310916)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro em drop_tablespace p_name \00E9 nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474373412310916)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro em drop_user;  l_username n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107469792853311700)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A wallet de criptografia n\00E3o est\00E1 aberta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106272997690310764)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha da string de senha ilegal para wwv_flow_provision.create_user.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474944347310916)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro em remove_provisioned_company.  O espa\00E7o de trabalho \00E9 nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474778925310916)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar tablespace. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474651250310916)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar usu\00E1rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474246644310916)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel eliminar tablespace. Erro: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474480050310916)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel eliminar usu\00E1rio. Erro: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474897316310916)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel conceder privil\00E9gios iniciais. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106239172217310731)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o tablespace neste momento. Tente novamente mais tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106474576058310916)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro com: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317510651310801)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha de provisionamento autom\00E1tico durante a fase "MAKE_REQUEST"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337106722310815)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel determinar ID do grupo de seguran\00E7a para o espa\00E7o de trabalho especificado = "%0"'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317885421310801)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho %0 \00E9 um nome reservado, solicita\00E7\00E3o negada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317692227310801)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorreu um erro ao adicionar usu\00E1rio ao espa\00E7o de trabalho %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106475221720310916)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106457034837310903)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o implementado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317372596310800)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi encontrado espa\00E7o de trabalho com ID de espa\00E7o de trabalho: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317477517310800)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 esquema atribu\00EDdo ao ID de espa\00E7o de trabalho: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337244286310815)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel usar este recurso para remover o \00FAltimo esquema de um espa\00E7o de trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318201678310801)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o %0 n\00E3o encontrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318062282310801)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel processar a solicita\00E7\00E3o %0.  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317784271310801)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta solicita\00E7\00E3o foi ou est\00E1 sendo processada. O status deve ser igual a "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337557745310815)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome do usu\00E1rio %0 n\00E3o existe no espa\00E7o de trabalho %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337483599310815)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 permitido redefinir senha para um esquema que n\00E3o esteja associado ao seu espa\00E7o de trabalho.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106337391540310815)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel redefinir a senha do esquema %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318127964310801)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel processar a solicita\00E7\00E3o %0 porque o esquema %1 existe na tabela %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317966555310801)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome do esquema %0 \00E9 um esquema reservado e n\00E3o pode ser provisionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106317281367310800)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O usu\00E1rio %0 n\00E3o tem privil\00E9gio no esquema %1.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277245301310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 An\00E1lise')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280093877310770)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'pt-br'
,p_message_text=>'Analisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106262904472310753)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Credenciais da conta de banco de dados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106294093832310781)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use credenciais de contas %0 internas e a p\00E1gina de log-in neste aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106973355991311324)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'pt-br'
,p_message_text=>'Usar SSO do Oracle Application Server.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277302393310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277155431310767)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher uma Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279336521310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel limpar o cache.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107356993919311620)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'#COLUMN_HEADER# deve ter um valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307451552310791)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar p\00E1gina de an\00E1lise. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325631461310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o modelo de bot\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326446137310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina de gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325011631310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar um aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326862163310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a home page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326281876310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o form de inser\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325267404310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o modelo de label. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326903505310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327066535310808)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o item de lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106324967925310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o modelo de lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326023680310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o breadcrumb.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325551373310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o modelo de breadcrumb. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327463772310808)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar os m\00F3dulos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325998130310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a barra de navega\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277509349310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Novo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280226560310770)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'pt-br'
,p_message_text=>'Criar Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325180229310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o modelo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325432620310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o modelo de regi\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326127345310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina de relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325348074310806)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o modelo de relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327108914310808)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina de sucesso. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325827301310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar guias padr\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106326340753310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o form de atualiza\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279242287310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Planilha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357118368311620)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#COLUMN_HEADER# deve ser uma data v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327220291310808)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defina modelos padr\00E3o para criar o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281776573310771)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel exibir a regi\00E3o da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278717430310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina exibe a ajuda para uma p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279084530310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277450095310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir Form'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278287834310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir Outro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279536403310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel inserir uma linha em %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278101548310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Os dados foram inseridos com sucesso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106741372142311131)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser uma data v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277901501310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677512637311075)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um timestamp v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278965598310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Breadcrumb'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277873103310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'%0 precisa ter algum valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357042554311620)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#COLUMN_HEADER# deve ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106325795088310807)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar Modelo de Lista de Valores Popup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106280195868310770)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Reportar e Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279164449310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel mostrar o relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106279459886310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel redefinir a pagina\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278489603310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar Home'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278802926310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Retornar \00E0 p\00E1gina anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276930195310767)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107394077674311646)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar Todos os Aplicativos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393280289311646)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar Aplicativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393039828311646)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar o Team Development'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107393708411311646)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pesquisar Usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277033736310767)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Gr\00E1fico Por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106281404898310771)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel mostrar o breadcrumb.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278535893310769)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Sucesso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278000283310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina de Sucesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107357253613311620)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#COLUMN_HEADER# deve ser um valor de timestamp v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277758629310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106277630948310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327353493310808)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA s\00F3 pode criar o aplicativo usando uma guia de n\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106278365558310768)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308415654310792)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'pt-br'
,p_message_text=>'Sobre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106308573834310792)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ramifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472752077310915)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298787957310784)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma lista aninhada s\00F3 suporta "Do Cliente" como tipo de pesquisa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460884897310906)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro inesperado %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106444451779310893)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: ID da raiz da \00E1rvore "%0" n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656731719311059)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro no c\00F3digo PLSQL emitido durante o processamento da SQL remota.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216799903310710)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina de cart\00F5es. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106798514472311178)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O acesso RESTful n\00E3o est\00E1 ativado para esta inst\00E2ncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796857691311177)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A regi\00E3o n\00E3o foi encontrada ou o REST n\00E3o est\00E1 ativado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106796975067311177)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum m\00E9todo de sa\00EDda foi especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447441605310895)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Espa\00E7o de trabalho obrigat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447580583310896)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo obrigat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447604408310896)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do usu\00E1rio "%0" ou senha inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676948836311074)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 atributos novos inseridos; talvez eles requeiram tradu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677055847311075)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 atributos expurgados; eles n\00E3o requerem mais tradu\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309385424310793)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de exclus\00E3o de semente: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309205918310793)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de inser\00E7\00E3o de semente: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677114697311075)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um total de %0 atributos, talvez eles requeiram tradu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309131697310793)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar a tradu\00E7\00E3o %0 do aplicativo %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106676889946311074)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 atributos existentes atualizados, talvez eles requeiram tradu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106483989819310927)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106747374211311136)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 \00EDndice para %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678030769311075)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da coleta <code>%0</code> anexados com <b id="incompl_success_row_count"></b> novos documentos. <b class="u-danger-text" id="incompl_fail_row_count"></b> documentos rejeitados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677840067311075)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Dados da coleta <code>%0</code> anexados com <b id="success_row_count"></b> novos documentos!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215864149310710)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conte\00FAdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678296488311075)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216008571310710)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215750456310710)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'pt-br'
,p_message_text=>'Chave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106216105155310710)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Modifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215928715310710)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de M\00EDdia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221142507310714)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia de Dados n\00E3o dispon\00EDvel. A coleta n\00E3o cont\00E9m dados ou nenhum \00EDndice de pesquisa JSON foi criado ainda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106215092956310709)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fa\00E7a upload dos arquivos JSON, TXT ou ZIP.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106221237535310715)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Metadados da coleta n\00E3o dispon\00EDveis. Verifique o nome da coleta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678139363311075)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados da coleta <code>%0</code> substitu\00EDdos por <b id="incompl_success_row_count"></b> novos documentos. <b class="u-danger-text" id="incompl_fail_row_count"></b> documentos rejeitados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106677951181311075)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados da coleta <code>%0</code> substitu\00EDdos por <b id="success_row_count"></b> novos documentos!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461717658310906)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O intervalo dos eixos deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461543519310906)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O eixo m\00E1ximo deve ser superior ao eixo m\00EDnimo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461985572310907)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O eixo m\00E1ximo deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461878035310906)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O eixo m\00EDnimo deve ser superior ou igual a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461620115310906)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: A largura das barras deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461224456310906)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463295894310907)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de extra\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463097844310907)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o retornando consulta SQL: A consulta n\00E3o pode ser submetida a parsing no Application Builder. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462154187310907)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: As lacunas entre as barras devem ser superiores ou iguais a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461393032310906)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O m\00E1ximo de linhas para exibi\00E7\00E3o deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463534592310908)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foram encontrados mais dados, mas n\00E3o \00E9 poss\00EDvel exibir mais do que 30 valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463124341310907)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de parse: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463478799310908)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de Gr\00E1fico SVG: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106463316253310908)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel calcular a posi\00E7\00E3o da ancoragem do gr\00E1fico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462956755310907)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel obter cor: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462392438310907)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o:O intervalo do Eixo X deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462778587310907)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o:O Eixo X m\00E1ximo deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462545941310907)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O Eixo X m\00EDnimo deve ser superior ou igual a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462411230310907)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O intervalo do Eixo Y deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462256253310907)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O Eixo Y m\00E1ximo deve ser superior ao eixo m\00EDnimo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462868555310907)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O Eixo Y m\00E1ximo deve ser superior a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106462613959310907)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na Valida\00E7\00E3o: O Eixo Y m\00EDnimo deve ser superior ou igual a zero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459480663310905)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao Adicionar Membro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263646232310756)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 comando bloqueado. N\00E3o \00E9 poss\00EDvel executar do SQL Workshop.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456358180310902)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio %0 n\00E3o tem privil\00E9gios no esquema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276334359310767)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema %0 n\00E3o tem privil\00E9gios de sele\00E7\00E3o na tabela ou view %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459696489310905)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao criar o script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456495500310903)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('tabela de plano criada para facilitar instru\00E7\00E3o do plano de execu\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456945794310903)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de cria\00E7\00E3o de arquivo de script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456539024310903)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'pt-br'
,p_message_text=>'Erro na linha %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456711535310903)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao inserir script em tabelas de arquivos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107404830009311654)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de Linha Inv\00E1lido:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456856006310903)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao fazer parsing do script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106456696155310903)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema "%0" n\00E3o existe no banco de dados. Entre em contato com o administrador do espa\00E7o de trabalho para definir o esquema padr\00E3o correto para voc\00EA.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257126939310748)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro em run_sql_arr. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459537169310905)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao atualizar membro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106276286454310767)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'pt-br'
,p_message_text=>'A linha de script excede 32767 bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243110592310735)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491995385310933)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244107276310736)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244580672310736)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243205018310735)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'pt-br'
,p_message_text=>'Executando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106302079728310787)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a execu\00E7\00E3o de um script contendo instru\00E7\00E3o(\00F5es) desconhecida(s). Remova a(s) instru\00E7\00E3o(\00F5es) a seguir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244213649310736)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Em Andamento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106301930181310787)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero da Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263552242310756)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1004 Scripts n\00E3o podem ser aninhados mais de %0 n\00EDveis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264804672310757)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1005 A sa\00EDda do script atingiu o limite de tamanho m\00E1ximo. Altere o seu script para gerar menos sa\00EDda ou entre em contato com o administrador para aumentar o tamanho m\00E1ximo do resultado do script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593094196311012)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O script excede o tamanho m\00E1ximo permitido de %0 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106264918316310758)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1005 A sa\00EDda do script atingiu o limite m\00E1ximo de tamanho para resultado do espa\00E7o de trabalho. Exclua os resultados existentes ou entre em contato com o administrador para aumentar o tamanho m\00E1ximo do resultado do espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106528096987310964)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 instru\00E7\00E3o a ser executada no buffer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106258838720310749)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A instru\00E7\00E3o SELECT n\00E3o pode ser maior que 32KB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244317499310736)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linha.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106244404206310736)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linhas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106259722197310750)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linhas selecionadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106487005922310930)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a execu\00E7\00E3o de um script que n\00E3o cont\00E9m instru\00E7\00F5es execut\00E1veis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106256998104310747)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel executar script. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106257045514310748)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro em run_statement. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106486956194310930)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA solicitou a execu\00E7\00E3o de um script contendo instru\00E7\00E3o(\00F5es) que o SQL Workshop ignorar\00E1. Confirme sua solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106263429556310756)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1001 Script n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243067285310735)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'pt-br'
,p_message_text=>'Submetido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491412266310933)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Instru\00E7\00E3o Desconhecida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106491259189310933)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'pt-br'
,p_message_text=>'%0% usado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476929983310918)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na cria\00E7\00E3o do pacote por causa de sintaxe SQL inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106476667235310918)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na cria\00E7\00E3o de tabela devido \00E0 sintaxe SQL inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309561440310793)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de sincroniza\00E7\00E3o: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106633067259311042)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'referenciado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106632920309311042)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('refer\00EAncias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106307887088310792)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tentou acessar a coluna do form tabular que ser\00E1 mapeada para o array PL/SQL apex_application.g_f%0, mas s\00F3 as colunas %1 que salvam o estado s\00E3o suportadas. Reduza o n\00FAmero de colunas que salvam o estado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106870591484311239)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Nova Guia M\00E3e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655907807311058)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Nova Guia Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656522319311059)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo Conjunto de Tabula\00E7\00F5es (permite que voc\00EA crie uma Guia Padr\00E3o em um novo conjunto de tabula\00E7\00F5es)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484242759310928)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel encontrar novo conjunto de guias para id de guia m\00E3e = %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484165251310928)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel localizar antigo conjunto de guias para id de guia = %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484332686310928)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O id de p\00E1gina: %0 n\00E3o \00E9 um n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656054723311058)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia de Guias M\00E3es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656490356311059)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 associada a uma guia m\00E3e. Ela est\00E1 sendo exibida como uma Pseudotab M\00E3e a fim de que voc\00EA possa editar as Guias Padr\00E3o neste conjunto de guias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656641525311059)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecionar Guia Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656217892311059)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia m\00E3e Selecionada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656159993311059)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pseudotab m\00E3e selecionada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484088573310928)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O id de grupo de seguran\00E7a deve ser definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106484451751310928)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Deve ser especificado um novo conjunto de guias para o id de guia = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655861172311058)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia de Guias Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655739448311058)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia Atual Tamb\00E9m para P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106655610168311058)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Guia Atual para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106656306748311059)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'pt-br'
,p_message_text=>'O conjunto de guias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310780915310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar o modelo de bot\00E3o (%0) no aplicativo "%1" espa\00E7o de trabalho "%2" para c\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311637181310796)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo de bot\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106477136022310918)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310428922310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar modelo do campo (%0) no aplicativo "%1" espa\00E7o de trabalho "%2" para c\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311301317310796)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo de campo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311202691310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo de lista. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310663520310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel encontrar o modelo de breadcrumb (%0) no aplicativo "%1" no espa\00E7o de trabalho "%2" para c\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311487286310796)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel substituir o modelo de breadcrumb. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310954684310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311584503310796)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel substituir o Modelo de Lista de Valores Popup. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106593997878311013)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel encontrar o modelo popup (%0) no aplicativo "%1" \00E1rea de trabalho "%2" para c\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311092446310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo de regi\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106311106921310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo de relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310339548310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel localizar o modelo (%0) para c\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106310849958310794)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel substituir o modelo %0. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107423842714311668)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Estilo do Tema n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441328011311680)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel atualizar estilo. \00C9 somente leitura!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107441265059311680)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome j\00E1 est\00E1 sendo usado por um estilo existente!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106309443409310793)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de atualiza\00E7\00E3o de semente: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106758483126311145)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Est\00E1 sendo feito o upgrade do Application Express para uma vers\00E3o mais nova. As altera\00E7\00F5es nos aplicativos ficar\00E3o desativadas at\00E9 que o upgrade seja conclu\00EDdo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421621232310876)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226932577310720)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo %0 n\00E3o encontrado registrado o comoo usu\00E1rio %1 do banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106227022289310720)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo %0, p\00E1gina %1, n\00E3o encontrado registrado como o %2 do banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422677147310877)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450633876310898)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao avaliar consulta da caixa de sele\00E7\00E3o: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422768827310877)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450201721310898)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro: As listas de valores do tipo Exibir Somente devem selecionar duas colunas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421402303310876)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel determinar Lista de Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423065951310877)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106472090342310914)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao gerar Lista de Valores Popup.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449910525310898)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao gerar consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450013175310898)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao inicializar Lista de Valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450574985310898)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel inicializar consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375863137310843)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta da Lista de Valores Popup \00E9 inv\00E1lida; s\00E3o necess\00E1rios uma exibi\00E7\00E3o e um valor de retorno; os nomes das colunas devem ser diferentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423118451310877)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('JavaScript n\00E3o suportado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423343054310877)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106423762053310878)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao executar consulta da Lista de Valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422509422310877)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422145039310876)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 correspond\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422846799310877)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'pt-br'
,p_message_text=>'Ok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471799544310914)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Lista de Valores Popup deve come\00E7ar com "selecionar".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106449817218310898)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel gerar Lista de Valores Popup com o filtro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471952208310914)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao inicializar a Lista de Valores Popup com filtro: %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106471820582310914)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao inicializar Lista de Valores Popup.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450346627310898)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o da Lista de Valores Popup falhou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450445424310898)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na verifica\00E7\00E3o de checksum da Lista de Valores Popup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422223287310877)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106421827525310876)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106422994725310877)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Caixa de Di\00E1logo Pesquisar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107033932962311374)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao mostrar a imagem. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451135067310899)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451511386310899)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista com Bullets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451909081310899)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recuo \00E0 Esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452063003310899)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recuar \00E0 Direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451243142310899)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451777580310899)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'pt-br'
,p_message_text=>'Justificar Centralizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451672511310899)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Justificar \00E0 Esquerda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451829471310899)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Justificar \00E0 Direita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451480563310899)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista Numerada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106451323261310899)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'pt-br'
,p_message_text=>'Sublinhado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106450109698310898)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel associar "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106226866434310720)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo de Websheet %0 n\00E3o encontrado registrado como o usu\00E1rio do banco de dados %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106650830686311055)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O webservice estava inacess\00EDvel porque o URL fornecido era inv\00E1lido, seu ambiente requer um endere\00E7o de servidor proxy v\00E1lido para solicita\00E7\00F5es HTTP, a solicita\00E7\00E3o sofreu time-out ou uma wallet precisa ser configurada para solicita\00E7\00F5es HTTPS. SQLERRM')
||': %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106297552169310783)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O documento WSDL era irrecuper\00E1vel pois o URL fornecido era inv\00E1lido, seu ambiente requer um endere\00E7o de servidor proxy v\00E1lido para solicita\00E7\00F5es HTTP e voc\00EA n\00E3o definiu um para este aplicativo, ou uma wallet precisa ser configurada para a inst\00E2ncia d')
||unistr('o &PRODUCT_NAME. para solicita\00E7\00F5es HTTPS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298276343310784)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00E3o Processada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880225548311247)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel adicionar linhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106292084531310779)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o bot\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328541148310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina de calend\00E1rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328265438310808)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina de gr\00E1fico. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107010693754311356)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel concluir o processo de carga de dados. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328907131310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o gr\00E1fico do Excel. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328652378310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o form na equijoin. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327885601310808)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o form em sp. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327991733310808)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o form na tabela. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328060290310808)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o form de inser\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106812305482311194)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o gr\00E1fico do Oracle JET. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106214933977310709)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar p\00E1gina detalhe mestre. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106697725697311090)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a\00E7\00E3o din\00E2mica. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328163542310808)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina de consulta e atualiza\00E7\00E3o. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328497710310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar a p\00E1gina de relat\00F3rio. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329015642310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina de resumo. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329181179310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a p\00E1gina Gr\00E1fico SVG. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328850255310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar a \00E1rvore. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327763885310808)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o relat\00F3rio atualiz\00E1vel. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328742879310809)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel criar o assistente de cria\00E7\00E3o de assistente. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880102737311247)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel processar a exclus\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880589518311247)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha(s) #MRD_COUNT# exclu\00EDdas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233938356310726)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obter Pr\00F3ximo Valor de Chave Prim\00E1ria/Obter Valor Anterior de Chave Prim\00E1ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233824131310726)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este bot\00E3o \00E9 necess\00E1rio para o processo Obter Pr\00F3ximo Valor de Chave Prim\00E1ria/Obter Valor Anterior de Chave Prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106233704098310726)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este item \00E9 necess\00E1rio para o processo Obter Pr\00F3ximo Valor de Chave Prim\00E1ria/Obter Valor Anterior de Chave Prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106234597303310727)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel executar o processo Obter Pr\00F3ximo Valor de Chave Prim\00E1ria / Obter Valor Anterior de Chave Prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106243630025310735)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem certeza de que deseja sair desta p\00E1gina sem salvar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592955569311012)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel obter valor de item de chave secund\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106592852928311012)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel obter valor de item de chave prim\00E1ria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106328395552310809)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de relat\00F3rio inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106606950913311023)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio interativo j\00E1 existe. S\00F3 \00E9 poss\00EDvel adicionar um relat\00F3rio interativo por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106318856342310801)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel criar o processo obter pr\00F3ximo valor de chave prim\00E1ria/obter valor anterior de chave prim\00E1ria. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880000203311247)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 ajuda dispon\00EDvel para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327650388310808)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de Parsing: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106327564097310808)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'pt-br'
,p_message_text=>'erro2 de parse %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880663761311247)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao enviar solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880992324311247)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880730506311247)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Raiz da \00C1rvore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298036246310784)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel extrair a linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106298147054310784)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel processar a linha da tabela %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106329282930310809)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Consulta SQL Atualiz\00E1vel j\00E1 existe. Voc\00EA s\00F3 pode adicionar uma consulta SQL atualiz\00E1vel por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880317904311247)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Atualiza\00E7\00E3o aplicada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106880420758311247)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'pt-br'
,p_message_text=>'Linha(s) #MRU_COUNT# atualizada(s); linha(s) #MRI_COUNT# inserida(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750874304311139)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar Esquema de Autoriza\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750667550311139)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750487634311139)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750796188311139)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Lista Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106750554587311139)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Lista de Valores Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106452208917310899)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao converter relat\00F3rio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106908452222311269)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'pt-br'
,p_message_text=>'%0 GB totais | %1 GB usados | %2 por cento usados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225593537310718)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao definir novo alvo agregado PGA. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106225337291310718)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao definir um novo alvo SGA. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107472951305311703)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao processar %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447938324310896)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447897108310896)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'pt-br'
,p_message_text=>'Eixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448449542310896)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448508806310896)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448328847310896)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448193675310896)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448279491310896)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106447777671310896)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106448014716310896)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'pt-br'
,p_message_text=>'Soma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383475372310849)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta n\00E3o pode ser submetida a parse; o cursor ainda n\00E3o est\00E1 aberto ou uma fun\00E7\00E3o retornando uma consulta SQL retornou sem nenhum valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106743903601311134)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua consulta cont\00E9m nomes de aliases duplicados; consultas usadas para relat\00F3rios exigem nomes de aliases \00FAnicos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106375579412310843)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('n\00E3o foi poss\00EDvel processar o corpo da fun\00E7\00E3o que retorna a consulta:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106461463776310906)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00FAmero inv\00E1lido de colunas definido na consulta; h\00E1 %0 necess\00E1rias para este tipo de regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383513661310849)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fun\00E7\00E3o retornando consulta SQL: A consulta n\00E3o pode ser submetida a parse no Builder. Se voc\00EA considerar sua consulta sintaticamente correta, marque a caixa de sele\00E7\00E3o <strong>colunas gen\00E9ricas</strong> abaixo da regi\00E3o de origem para continuar sem p')
||'arse.',
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106383667600310849)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A consulta n\00E3o pode ser submetida a parse no Builder. Se voc\00EA considerar sua consulta sintaticamente correta, marque a caixa de sele\00E7\00E3o de ''''colunas gen\00E9ricas'''' abaixo da origem da regi\00E3o para continuar sem parse.'),
'%0</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106459961077310905)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Palavra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460558145310906)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar a Dicion\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460431943310905)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicar Altera\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460341482310905)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460245188310905)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conclu\00EDdo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106819139847311199)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>'Submeter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460105818310905)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 j\00E1 est\00E1 no seu dicion\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460760094310906)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'pt-br'
,p_message_text=>'Informe a nova palavra.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460666846310906)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha uma Palavra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106678311422311076)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Verificador Ortogr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106460027477310905)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionado %0 ao seu dicion\00E1rio.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106305370990310790)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de carga de XML.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106730205579311122)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>'Existe uma tag %0 adicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106731005932311123)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 bugs n\00E3o possuem corre\00E7\00E3o por datas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106905097144311266)
,p_name=>'YEARLY'
,p_message_language=>'pt-br'
,p_message_text=>'Ano'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106358792111310831)
,p_name=>'YES_BY_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sim, Pelo Usu\00E1rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106387851538310852)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seu endere\00E7o de e-mail est\00E1 registrado comum usu\00E1rio nos seguintes espa\00E7os de trabalho:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(106669222525311069)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 desconectado agora.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4416)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>'Breadcrumb'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe a trilha de breadcrumb da p\00E1gina atual.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>'Lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe valores com base em uma lista est\00E1tica ou din\00E2mica. Geralmente, estes s\00E3o usados para navegar nas p\00E1ginas do aplicativo.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('Cancelar Caixa de Di\00E1logo')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Cancela a p\00E1gina da caixa de di\00E1logo atual.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('Fechar Caixa de Di\00E1logo')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Fecha a p\00E1gina da caixa de di\00E1logo atual.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4416)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Itens para Retorno'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome de um ou mais itens de p\00E1gina a serem retornados pelo di\00E1logo. No caso de v\00E1rios itens, separe cada nome de item com uma v\00EDrgula.</p>'),
unistr('<p>Voc\00EA pode acessar os valores de itens retornados definindo uma A\00E7\00E3o Din\00E2mica para acionar no evento <strong>Di\00E1logo Fechado</strong> do elemento que abre o di\00E1logo, como uma a\00E7\00E3o de <strong>Definir Valor</strong> e um <em>Tipo de Conjunto</em> de ')
||unistr('<strong>Item de Retorno do Di\00E1logo</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('Seletor de Exibi\00E7\00E3o de Regi\00E3o')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe nomes de regi\00E3o em uma lista horizontal, permitindo que os usu\00E1rios finais selecionem uma regi\00E3o para ser exibida e ocultem outras regi\00F5es. S\00F3 ser\00E3o exibidas nesta regi\00E3o as regi\00F5es da p\00E1gina com o <em>Seletor de Exibi\00E7\00E3o de Regi\00E3o</em> definid')
||'o como <strong>Sim</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4416)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Incluir Controle Deslizante'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Adicione dinamicamente um controle deslizante \00E0 regi\00E3o se os nomes de regi\00E3o implantados excederem a largura da regi\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4416)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Modo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como as regi\00F5es com a op\00E7\00E3o <em>Seletor de Exibi\00E7\00E3o de Regi\00E3o</em> definida como <strong>Sim</strong> ser\00E3o exibidas na p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Exibir Regi\00E3o \00DAnica')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('Mostre as regi\00F5es como guias. A sele\00E7\00E3o de uma guia tornar\00E1 vis\00EDvel a regi\00E3o correspondente e ocultar\00E1 as outras sele\00E7\00F5es.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4416)
,p_display_sequence=>20
,p_display_value=>'Rolar Janela'
,p_return_value=>'JUMP'
,p_help_text=>unistr('Exiba sempre todas as regi\00F5es na p\00E1gina. A sele\00E7\00E3o de uma guia rolar\00E1 a janela para a regi\00E3o correspondente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4416)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Incluir ''Mostrar Tudo'''
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('Inicie uma guia "Mostrar Tudo" que, quando selecionada, exiba todas as regi\00F5es da p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4416)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Lembrar \00DAltima Sele\00E7\00E3o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('No carregamento da p\00E1gina, a regi\00E3o selecionada por \00FAltimo ser\00E1 exibida.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe o conte\00FAdo remoto proveniente de um URL.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4416)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Informe um URL para o conte\00FAdo remoto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4416)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Modo de Inclus\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como o conte\00FAdo remoto do URL est\00E1 inclu\00EDdo na p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4416)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>unistr('Incorporar conte\00FAdo remoto como um iframe.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4416)
,p_display_sequence=>20
,p_display_value=>'Em linha (caracteres especiais de escape)'
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('Leia o conte\00FAdo remoto no momento da convers\00E3o da p\00E1gina e incorpore-o, mas identifique os caracteres HTML especiais para evitar cross-site scripting.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4416)
,p_display_sequence=>30
,p_display_value=>'Em linha (sem escape)'
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('Leia o conte\00FAdo remoto no momento da convers\00E3o da p\00E1gina e incorpore-o. Esta op\00E7\00E3o s\00F3 deve ser selecionada se o conte\00FAdo remoto for totalmente confi\00E1vel, j\00E1 que o conte\00FAdo HTML n\00E3o ser\00E1 identificado. Isso pode tornar a regi\00E3o vulner\00E1vel a cross-site ')
||'scripting.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4416)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos do IFrame'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>'Informe os atributos do elemento HTML adicional para a tag iframe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4416)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Descartar HTML at\00E9')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Use este atributo ao recortar uma se\00E7\00E3o de HTML de um documento maior. Informe uma string que identifique o in\00EDcio da se\00E7\00E3o de destino ou o ponto at\00E9 o qual o HTML deve ser descartado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4416)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Descartar HTML ap\00F3s')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Use este atributo para recortar uma se\00E7\00E3o de HTML de um documento HTML maior. Informe uma string que identifique o final da se\00E7\00E3o de destino ou o ponto a partir do qual o HTML restante deve ser descartado. Essa string que identifica o fim da se\00E7\00E3o de')
||unistr(' destino n\00E3o ser\00E1 inclu\00EDda no texto retornado.')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>'Texto de Ajuda'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma regi\00E3o de Ajuda especial utilizada na p\00E1gina de Ajuda dedicada.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>'Pesquisa Facetada'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>Uma regi\00E3o baseada na origem de uma Pesquisa Facetada associada, que fornece aos usu\00E1rios finais numerosas facetas que s\00E3o usadas para restringir os resultados da pesquisa no run-time. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Altera\00E7\00F5es de Faceta em Batch')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione se a aplica\00E7\00E3o ser\00E1 feita em batch ou individualmente nas facetas selecionadas, no relat\00F3rio de Pesquisa Facetada. Quando a op\00E7\00E3o \00E9 Sim, a filtragem do Relat\00F3rio \00E9 executada quando um bot\00E3o Aplicar \00E9 clicado. Quando a op\00E7\00E3o \00E9 N\00E3o, a filtrag')
||unistr('em do Relat\00F3rio \00E9 executada logo que qualquer valor de faceta se altera.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mostrar Facetas Atuais'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique se a \00E1rea de facetas atuais ser\00E1 exibida. A \00E1rea de facetas atual lista as facetas que est\00E3o selecionadas no momento e oferece um jeito f\00E1cil de remov\00EA-las individualmente ou todas de uma vez.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4416)
,p_display_sequence=>10
,p_display_value=>'Sim'
,p_return_value=>'Y'
,p_help_text=>unistr('A lista de facetas atuais \00E9 exibida no in\00EDcio da regi\00E3o Pesquisa Facetada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00E3o')
,p_return_value=>'N'
,p_help_text=>unistr('A lista de facetas atuais n\00E3o \00E9 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor'
,p_return_value=>'E'
,p_help_text=>unistr('A \00E1rea de facetas atuais \00E9 exibida dentro do elemento especificado por este seletor. Isso permite que voc\00EA coloque a \00E1rea de facetas atuais praticamente em qualquer lugar da p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Seletor de Facetas Atual'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('Este \00E9 o seletor de um elemento na p\00E1gina em que a regi\00E3o de pesquisa facetada exibir\00E1 as facetas atuais.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Mostrar Contagem Total de Linhas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique onde a contagem total de linhas ser\00E1 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4416)
,p_display_sequence=>10
,p_display_value=>unistr('N\00E3o')
,p_return_value=>'N'
,p_help_text=>unistr('A contagem total de linhas n\00E3o \00E9 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4416)
,p_display_sequence=>20
,p_display_value=>'Sim'
,p_return_value=>'Y'
,p_help_text=>unistr('A contagem total de linhas \00E9 exibida na parte superior da \00E1rea de facetas atual ou, se a op\00E7\00E3o Mostrar Facetas Atuais estiver definida como N\00E3o, na parte superior da regi\00E3o Pesquisa Facetada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor'
,p_return_value=>'E'
,p_help_text=>unistr('A contagem total de linhas (sem qualquer label) \00E9 exibida dentro do elemento especificado por este seletor. Isso permite que voc\00EA coloque a contagem total de linhas praticamente em qualquer lugar da p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Label da Contagem Total de Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Label a ser usado para a contagem total de linhas. Se nenhum label for informado aqui, o APEX utilizar\00E1 a mensagem de texto APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Seletor da Contagem Total de Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Este \00E9 o seletor de um elemento na p\00E1gina em que a regi\00E3o de pesquisa facetada exibir\00E1 a contagem total de linhas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('Limite de N\00FAmeros Compactos')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Especifique um valor de limite, acima do qual as contagens de facetas sejam exibidas usando um formato de n\00FAmero compacto. Com esse formato, um valor <strong>1,234</strong> ser\00E1 exibido como <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Mostrar Gr\00E1ficos')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique onde os gr\00E1ficos de valor de faceta ser\00E3o mostrados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Caixa de Di\00E1logo')
,p_return_value=>'Y'
,p_help_text=>unistr('Os gr\00E1ficos de valor de faceta s\00E3o exibidos em uma caixa de di\00E1logo n\00E3o modal.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00E3o')
,p_return_value=>'N'
,p_help_text=>unistr('N\00E3o h\00E1 bot\00E3o para os usu\00E1rios mostrarem gr\00E1ficos de valor de faceta.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor'
,p_return_value=>'E'
,p_help_text=>unistr('Os gr\00E1ficos de valor de faceta s\00E3o adicionados ao elemento especificado por este seletor. Isso permite colocar os gr\00E1ficos em qualquer lugar da p\00E1gina, criando um painel de controle de gr\00E1ficos de valor de faceta.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Seletor de Gr\00E1ficos')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('Este \00E9 o seletor de um elemento na p\00E1gina em que a regi\00E3o de pesquisa facetada exibir\00E1 os gr\00E1ficos de faceta.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Exibir Gr\00E1fico para N Principais Valores')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('Forne\00E7a o n\00FAmero de valores a serem exibidos no gr\00E1fico para cada faceta. O valor <strong>10</strong> significa que os gr\00E1ficos de faceta exibir\00E3o os <em>10 primeiros</em> itens ordenados sob a faceta. Quando a propriedade de faceta Classificar por M')
||unistr('aiores Contagens estiver Ativada ser\00E3o os <em>10 maiores</em> itens com base nas contagens de ocorr\00EAncias. As altera\00E7\00F5es nesta propriedade podem n\00E3o ser vistas imediatamente nas sess\00F5es do browser atualmente ativas. Este valor, bem como a escolha do ')
||unistr('usu\00E1rio do gr\00E1fico de pizza ou de barras, \00E9 salvo na sess\00E3o do browser. Para ver o efeito das altera\00E7\00F5es nesta propriedade, redefina o relat\00F3rio usando a op\00E7\00E3o de controle de cache do link Redefinir Regi\00F5es, como com o bot\00E3o Redefinir gerado pelo ass')
||'istente.'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('Depois de Remover Gr\00E1fico')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('Antes de Adicionar Gr\00E1fico')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4416)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4416)
,p_name=>'facetschange'
,p_display_name=>unistr('Altera\00E7\00E3o de Facetas')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>unistr('Acesso \00E0 SAML')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('Armazenamento de Credenciais para Solicita\00E7\00F5es de Assinatura')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o armazenamento de credenciais que cont\00E9m o certificado p\00FAblico e a chave privada usada para assinar mensagens para o provedor de identidades.'),
unistr('Voc\00EA precisa registrar o certificado no provedor de identidades.'),
unistr('O &PRODUCT_NAME. usa a chave privada para assinar solicita\00E7\00F5es.'),
unistr('Embora esse atributo seja opcional, recomenda-se assinar solicita\00E7\00F5es por motivos de seguran\00E7a.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Usar Atributos SAML de'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('Especifique se ser\00E1 usada uma configura\00E7\00E3o em n\00EDvel de inst\00E2ncia ou SAML espec\00EDfica do aplicativo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Inst\00E2ncia')
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Use a configura\00E7\00E3o de SAML compartilhada em toda a inst\00E2ncia do &PRODUCT_NAME.'),
unistr('Isso requer que o administrador da inst\00E2ncia tenha configurado atributos SAML no n\00EDvel da inst\00E2ncia.'),
unistr('Se n\00E3o for esse o caso, voc\00EA vai se deparar com erros de runtime.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_display_sequence=>20
,p_display_value=>'Aplicativo'
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('Use uma configura\00E7\00E3o de SAML espec\00EDfica do aplicativo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'URL de SSO Single Sign-On do Provedor de Identidades'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>'Selecione o URL POST Single Sign-On do provedor de identidades.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'URL de Single Sign-Out do Provedor de Identidades'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selecione o URL POST Single Sign-Out do provedor de identidades.',
unistr('Se estiver vazio, o URL de Single Sign-On ser\00E1 usado.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Emissor do Provedor de Identidades'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Selecione o valor do "Emissor" do provedor de identidades.',
unistr('O &PRODUCT_NAME. verificar\00E1 esse valor em mensagens do provedor de identidades.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Atributo do Nome do Usu\00E1rio')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O atributo SAML que cont\00E9m o nome de usu\00E1rio.'),
unistr('Adota como padr\00E3o o valor do n\00F3 "Asser\00E7\00E3o/Assunto/ID do Nome".')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>'Certificado de Assinatura do Provedor de Identidades'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Informe o nome do certificado que o provedor de identidades usa para assinar mensagens.',
'O &PRODUCT_NAME. usa esse certificado para verificar mensagens de resposta do provedor de identidades.',
unistr('Embora esse atributo seja opcional, \00E9 recomendado verificar as respostas por motivos de seguran\00E7a.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4416)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Converter o Nome do Usu\00E1rio para Mai\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Configure se os valores de atributo para o nome do usu\00E1rio devem ser convertidos para letras mai\00FAsculas.')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>'Campo de Entrada'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4416)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Operador de Compara\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>10
,p_display_value=>'Igual a'
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>30
,p_display_value=>'Menor que'
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>40
,p_display_value=>'Menor ou Igual A'
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>50
,p_display_value=>'Maior que'
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>60
,p_display_value=>'Maior ou Igual A'
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>70
,p_display_value=>unistr('Come\00E7a Com')
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_display_sequence=>80
,p_display_value=>unistr('Cont\00E9m')
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4416)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4416)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Caso de Valores'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Se todos os valores de dados j\00E1 estiverem em letras min\00FAsculas ou mai\00FAsculas, isso pode ser declarado aqui. O filtro, fornecido pelo usu\00E1rio final, ser\00E1 automaticamente convertido para o tipo de letra declarado, de modo que o usu\00E1rio final experiment')
||unistr('e pesquisas que n\00E3o fa\00E7am distin\00E7\00E3o entre mai\00FAsculas ou min\00FAsculas, ao passo que o banco de dados realmente executa uma pesquisa normal que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Letras Mai\00FAsculas e Min\00FAsculas Combinadas')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Min\00FAsculas')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Mai\00FAsculas')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4416)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Label Atual'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'Filtragem para %0'
,p_help_text=>unistr('Forne\00E7a o texto a ser exibido para esta faceta na \00E1rea de facetas atual. O valor atual pode ser referenciado com o placeholder <strong>%0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4416)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Texto do Prefixo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Forne\00E7a o texto a ser exibido antes do campo de entrada de dados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4416)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Texto do Sufixo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Forne\00E7a o texto a ser exibido ap\00F3s o campo de entrada de dados.')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>unistr('Cart\00F5es')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Relat\00F3rio baseado em uma Consulta SQL que exibe dados para cada linha em cart\00F5es. Com os cart\00F5es, voc\00EA pode facilmente visualizar os dados em blocos de conte\00FAdo. Voc\00EA pode personalizar Cabe\00E7alho, M\00EDdia, Corpo ou A\00E7\00F5es de forma declarativa.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4416)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4416)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4416)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('Altera\00E7\00E3o de P\00E1gina')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4416)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tipo de Pagina\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Sem Pagina\00E7\00E3o')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Tamanho da P\00E1gina e Defasagem de Extra\00E7\00E3o')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pagina\00E7\00E3o flex\00EDvel em que a API REST permite solicitar um conjunto espec\00EDfico de linhas, usando os par\00E2metros <em>page size</em> e <em>offset</em> ("come\00E7ar na linha"). O URL em geral se parece com o exemplo a seguir, que ignora <strong>20</strong')
||unistr('> e extrai as pr\00F3ximas <strong>100</strong> linhas:</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Tamanho e N\00FAmero da P\00E1gina')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pagina\00E7\00E3o em que a API REST permite solicitar um conjunto de linhas, usando os par\00E2metros <em>page size</em> e <em>page number</em>. Os URLs em geral se parecem com o exemplo a seguir, que solicita o n\00FAmero de p\00E1gina <strong>2</strong> com um tama')
||unistr('nho de p\00E1gina de <strong>100</strong>, que leva ao retorno das linhas 101 a 200.'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_display_sequence=>30
,p_display_value=>unistr('N\00FAmero da P\00E1gina')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pagina\00E7\00E3o em que a API REST permite solicitar um conjunto de linhas, usando um par\00E2metro <em>page</em>. O Tamanho da P\00E1gina \00E9 fixo e determinado pela API REST. Os URLs em geral se parecem com o exemplo a seguir, que solicita o n\00FAmero de p\00E1gina <st')
||unistr('rong>2</strong>. Se  API REST usar um tamanho de p\00E1gina fixo de <strong>20</strong>, as linhas 21 a 40 ser\00E3o retornadas.'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Par\00E2metro de URL de Tamanho de P\00E1gina')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Forne\00E7a o par\00E2metro de URL para especificar o <em>tamanho de p\00E1gina</em> a ser solicitado da API REST. Os valores t\00EDpicos s\00E3o <strong>limit</strong>, <strong>page_size</strong> ou </strong>per_page</strong>.</p>'),
unistr('<p><em>N\00E3o adicione esse par\00E2metro dentro de <strong>Par\00E2metros</strong></em> da Origem de Dados REST. O &PRODUCT_NAME. o adicionar\00E1 automaticamente ao executar a solicita\00E7\00E3o HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Tamanho M\00E1ximo da P\00E1gina')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>'linhas'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Forne\00E7a a quantidade m\00E1xima de linhas por p\00E1gina que a API REST permite extrair. O &PRODUCT_NAME. n\00E3o tentar\00E1 solicitar mais linhas por p\00E1gina.</p>'),
unistr('<p>Certifique-se de que a API REST <em>realmente retorne</em> essa quantidade de linhas, pois o &PRODUCT_NAME. partir\00E1 do pressuposto de que uma p\00E1gina solicitada \00E9 a \00FAltima p\00E1gina, se a resposta contiver menos linhas do que o solicitado.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Par\00E2metro de URL de N\00FAmero de P\00E1gina')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Forne\00E7a o par\00E2metro de URL para especificar o <em>N\00FAmero da P\00E1gina</em> a ser solicitado da API REST. Um valor t\00EDpico \00E9 <strong>page</strong>.</p>'),
unistr('<p><em>N\00E3o adicione esse par\00E2metro dentro de <strong>Par\00E2metros</strong></em> da Origem de Dados REST. O &PRODUCT_NAME. o adicionar\00E1 automaticamente ao executar a solicita\00E7\00E3o HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\00CDndice da Primeira P\00E1gina')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Especifique se a API REST come\00E7a a contar p\00E1ginas no \00EDndice <strong>"0"</strong> ou <strong>"1"</strong>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4416)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('A API REST se refere \00E0 primeira p\00E1gina como p\00E1gina <strong>1</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4416)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('A API REST se refere \00E0 primeira p\00E1gina como p\00E1gina <strong>0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Tamanho de P\00E1gina Fixo')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>'linhas'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Forne\00E7a o <em>tamanho da p\00E1gina</em> (n\00FAmero de linhas por p\00E1gina), que \00E9 determinado pela API REST.</p>'),
unistr('<p>Em geral, essas informa\00E7\00F5es podem ser encontradas na documenta\00E7\00E3o da API REST. Certifique-se de especificar o valor correto aqui: se o valor n\00E3o for preciso, faltar\00E3o linhas ou elas ser\00E3o duplicadas quando o &PRODUCT_NAME. extrair dados da API RES')
||'T.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Par\00E2metro de URL de Deslocamento de Linha')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>'linhas'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Forne\00E7a o par\00E2metro de URL para especificar o <em>deslocamento</em>, que denota as linhas a serem ignoradas antes de a primeira linha ser retornada.</p>'),
unistr('<p><em>N\00E3o adicione esse par\00E2metro dentro de <strong>Par\00E2metros</strong></em> da Origem de Dados REST. O &PRODUCT_NAME. o adicionar\00E1 automaticamente ao executar a solicita\00E7\00E3o HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Tipo de Deslocamento de Linha'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Escolha se o par\00E2metro <strong>Offset</strong> especifica a <em>Quantidade de Linhas a Serem Ignoradas</em> ou a <em>Primeira Linha a Ser Extra\00EDda</em>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4416)
,p_display_sequence=>10
,p_display_value=>'Linhas a Serem Ignoradas'
,p_return_value=>'OFFSET'
,p_help_text=>unistr('O valor do deslocamento indica as linhas a serem ignoradas. Por exemplo, se um valor de 100 for fornecido, a API REST retornar\00E1 linhas que come\00E7am no \00EDndice 101.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Primeira Linha para Extra\00E7\00E3o')
,p_return_value=>'START'
,p_help_text=>unistr('O valor do deslocamento indica a linha na qual come\00E7ar\00E1 a extra\00E7\00E3o. Por exemplo, se um valor de 100 for fornecido, os retornos da API REST retornar\00E3o 99 linhas e come\00E7ar\00E3o a extra\00E7\00E3o no \00EDndice 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Seletor Tem Mais Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se uma API REST retornar a seguinte resposta JSON:</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('O <strong>Seletor Tem Mais Linhas</strong> \00E9 <strong>metadata.pagination.moreRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se a API REST de resposta retornar informa\00E7\00F5es sobre se h\00E1 p\00E1ginas adicionais, forne\00E7a o <em>seletor</em> para extrair esse atributo aqui.</p>'),
unistr('N\00E3o \00E9 obrigat\00F3rio <p>especificar o <strong>Seletor Tem Mais Linhas</strong>, mas ele ajuda o &PRODUCT_NAME. a salvar solicita\00E7\00F5es HTTP adicionais (que n\00E3o retornariam dados) quando todos os dados j\00E1 foram extra\00EDdos.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Valor Tem Mais Linhas Quando'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Escolha como interpretar o valor do atributo de resposta referenciado pelo <strong>Seletor Tem Mais Linhas</strong>.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4416)
,p_display_sequence=>10
,p_display_value=>'Igual a'
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('Presume a disponibilidade de mais linhas quando o atributo de resposta referenciado pelo <strong>Seletor Tem Mais Linhas</strong> \00E9 igual a um valor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00E3o \00C9 Nulo')
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('Presume a disponibilidade de mais linhas quando o atributo de resposta referenciado pelo <strong>Seletor Tem Mais Linhas</strong> existe e n\00E3o est\00E1 vazio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Valor do Atributo Tem Mais Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('O <p>&PRODUCT_NAME. pressup\00F5e a disponibilidade de mais linhas se o atributo de resposta referenciado pelo <strong>Seletor Tem Mais Linhas</strong> contiver esse valor.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4416)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Seletor de Total de Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se a API REST retornar a seguinte resposta JSON ...</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('... o <strong>Seletor Tem Mais Linhas</strong> \00E9 <strong>metadata.pagination.totalRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se a API REST retornar a <em>quantidade total de linhas</em> (em todas as p\00E1ginas) como parte da resposta, forne\00E7a o <em>seletor</em> para extrair esse atributo aqui.</p>'),
unistr('N\00E3o \00E9 obrigat\00F3rio <p>especificar um <strong>Seletor Tem Mais Linhas</strong>; ele permite exibir a quantidade total de linhas nos componentes do &PRODUCT_NAME., <em>desde que os dados n\00E3o sejam mais filtrados</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('Endere\00E7o Geocodificado')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esse tipo de item oferece a funcionalidade de Geocodifica\00E7\00E3o (a transforma\00E7\00E3o de um endere\00E7o postal em uma coordenada).<p>'),
unistr('<p>A geocodifica\00E7\00E3o \00E9 executada pelo <em>browser</em> fazendo uma solicita\00E7\00E3o REST ao <strong>Oracle Elocation</strong> Geocoding Service (elocation.oracle.com). Portanto, o browser deve estar conectado \00E0 internet para que a geocodifica\00E7\00E3o funcione.<')
||'/p>',
unistr('<p>Os dados de entrada de geocodifica\00E7\00E3o v\00EAm de outros itens de p\00E1gina, que s\00E3o mapeados para partes de endere\00E7o como Rua, N\00FAmero da Casa, C\00F3digo Postal ou Cidade. O Geocodificador mostrar\00E1 uma janela popup com uma lista de poss\00EDveis correspond\00EAncias')
||unistr('. Ap\00F3s escolher uma correspond\00EAncia, o valor de estado da sess\00E3o do item ser\00E1 a coordenada de endere\00E7o no formato GeoJSON. Se a op\00E7\00E3o <strong>Sanear Endere\00E7o</strong> estiver ativada, os itens de p\00E1gina da parte de endere\00E7o ser\00E3o substitu\00EDdos pelos v')
||unistr('alores saneados recebidos do servi\00E7o de Geocodifica\00E7\00E3o.</p>'),
unistr('<p>Para casos de uso mais simples, o modo <strong>Endere\00E7o N\00E3o Estruturado</strong> permite mapear apenas um campo ou \00E1rea de texto na qual os usu\00E1rios finais inserem partes de endere\00E7o, separadas por v\00EDrgulas. Nesse caso, o modo <strong>Sanear Ender')
||unistr('e\00E7o</strong> n\00E3o estar\00E1 dispon\00EDvel.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Modo de Correspond\00EAncia do Geocodificador')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>O <strong>Modo de Correspond\00EAncia</strong> determina o grau de correspond\00EAncia que os atributos de um endere\00E7o de entrada devem ter com os dados que est\00E3o sendo usados para geocodifica\00E7\00E3o.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4416)
,p_display_sequence=>10
,p_display_value=>'Exato'
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>Todas as partes de endere\00E7o fornecidas devem ser correspondentes. Por\00E9m, se o n\00FAmero da casa, o nome da rua ou o tipo de rua n\00E3o forem <em>todos</em> correspondentes, a primeira correspond\00EAncia nos seguintes itens ser\00E1 retornada: c\00F3digo postal, ci')
||unistr('dade ou munic\00EDpio e estado. Por exemplo, se o nome da rua estiver incorreto, mas um c\00F3digo postal v\00E1lido for especificado, uma localiza\00E7\00E3o no c\00F3digo postal ser\00E1 retornada.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Tipo de Rua sem Correspond\00EAncia Exata')
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>O <em>tipo de rua</em> fornecido pode diferir dos dados usados para geocodifica\00E7\00E3o. Por exemplo, <strong>Main Street</strong> ou <strong>Main Blvd</strong> corresponder\00E3o a <strong>Main St</strong>, se n\00E3o houver outro <strong>Main Blvd</strong> o')
||unistr('u outra <strong>Main Street</strong> na \00E1rea relevante.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4416)
,p_display_sequence=>30
,p_display_value=>unistr('N\00FAmero da Casa sem Correspond\00EAncia Exata')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>O n\00FAmero da casa e o tipo de rua podem diferir dos dados usados para geocodifica\00E7\00E3o. Por exemplo, <strong>123 Main St</strong> corresponde a <strong>123 Main Lane</strong> e <strong>124 Main St</strong>, desde que n\00E3o haja ambiguidades ou outras c')
||unistr('orrespond\00EAncias.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Nome de Rua sem Correspond\00EAncia Exata')
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>O <em>nome base</em> da rua, o n\00FAmero da casa e o tipo de rua podem ser distintos dos dados usados para geocodifica\00E7\00E3o. Por exemplo, <strong>Pleasant Vale</strong> corresponde a <strong>Pleasant Valley</strong>, desde que n\00E3o haja ambiguidades ou ')
||unistr('outras correspond\00EAncias nos dados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4416)
,p_display_sequence=>50
,p_display_value=>unistr('C\00F3digo Postal sem Correspond\00EAncia Exata')
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>O c\00F3digo postal (se fornecido), o nome da rua, o tipo de rua e o n\00FAmero da casa poder\00E3o diferir dos dados usados para geocodifica\00E7\00E3o.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4416)
,p_display_sequence=>60
,p_display_value=>unistr('Todas as Op\00E7\00F5es sem Correspond\00EAncia Exata')
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>O endere\00E7o poder\00E1 ser fora da cidade especificada, desde que ele esteja dentro do mesmo munic\00EDpio. Tamb\00E9m inclui as caracter\00EDsticas de <strong>C\00F3digo Postal sem Correspond\00EAncia Exata</strong>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostrar Coordenadas em Pop-Up'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>Determine se as coordenadas de endere\00E7o (longitude, latitude) ser\00E3o exibidas na caixa de di\00E1logo popup de resultados da geocodifica\00E7\00E3o.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Visualiza\00E7\00E3o do Mapa')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Indica se ser\00E1 permitida a visualiza\00E7\00E3o do endere\00E7o geocodificado em um mapa.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4416)
,p_display_sequence=>10
,p_display_value=>'Popup de Resultados'
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mostra o mapa no popup de resultados da Geocodifica\00E7\00E3o, de modo que os usu\00E1rios possam analisar a posi\00E7\00E3o antes de selecionar um resultado.</p>'),
unistr('<p>S\00F3 h\00E1 suporte para esse recurso quando a op\00E7\00E3o "Exibir como - View de Grade" est\00E1 ativada.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4416)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>unistr('Mostre um mapa visualizando a localiza\00E7\00E3o do endere\00E7o na posi\00E7\00E3o do item.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Segundo Plano'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione o mapa de fundo no qual ser\00E3o mostrados os resultados da geocodifica\00E7\00E3o.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4416)
,p_display_sequence=>5
,p_display_value=>unistr('Padr\00E3o')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use o plano de fundo de mapa padr\00E3o.</p>'),
'<p>Ele usa "OpenStreetMap Bright" ou "OpenStreetMap Dark" para temas escuros.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4416)
,p_display_sequence=>10
,p_display_value=>'OpenStreetMap Bright'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso geral baseado em dados do OpenStreetMap. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o detalhado para seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4416)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap Dark'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base escuro n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4416)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base leve n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abrigo da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Mapa M\00FAndi Oracle')
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso geral baseado em dados de Mapa HERE. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o para seus dados e acentua a visualiza\00E7\00E3o de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo da Oracle, EUA.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Altura'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixels'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique a altura (em pixels) do mapa exibido.</p>',
unistr('<p>A altura padr\00E3o do mapa \00E9 calculada com base em sua largura, com uma raz\00E3o altura/largura de 3:2.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Exibir Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione como os resultados da geocodifica\00E7\00E3o ser\00E3o exibidos.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4416)
,p_display_sequence=>10
,p_display_value=>'View em Lista'
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>Os resultados ser\00E3o mostrados em uma exibi\00E7\00E3o de lista.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4416)
,p_display_sequence=>20
,p_display_value=>'View de Grade'
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>Os resultados ser\00E3o mostrados em uma exibi\00E7\00E3o em grade.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('Endere\00E7o Estruturado')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indica se as partes de endere\00E7o s\00E3o fornecidas ao servi\00E7o de geocodifica\00E7\00E3o de modo <em>estruturado</em> ou <em>n\00E3o estruturado</em>.</p>'),
unistr('<p>Estruturado significa que itens de p\00E1gina expl\00EDcitos s\00E3o mapeados para partes de endere\00E7o como Rua, C\00F3digo Postal, Cidade ou Regi\00E3o. Isso leva a resultados de geocodifica\00E7\00E3o mais precisos, e tamb\00E9m permite alimentar os '),
unistr('endere\00E7os corrigidos de volta aos itens de p\00E1gina.</p>'),
unistr('<p>N\00E3o estruturado significa que apenas um item \00E9 usado para todo o endere\00E7o; as partes s\00E3o separadas por v\00EDrgulas. Esse modo n\00E3o permite alimentar endere\00E7os corrigidos de volta ao item de p\00E1gina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('Tipo de Pa\00EDs')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Escolha se deseja usar um pa\00EDs est\00E1tico para a geocodifica\00E7\00E3o ou se vai derivar o pa\00EDs de um item.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>Use um pa\00EDs est\00E1tico de uma lista de sele\00E7\00E3o.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4416)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>Obtenha o pa\00EDs em um aplicativo ou item de p\00E1gina. O item deve conter o c\00F3digo ISO de 2 d\00EDgitos para um pa\00EDs. </p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Pa\00EDs')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US</strong>: Estados Unidos</li>',
'<li><strong>UK</strong>: Reino Unido</li>',
'<li><strong>DE</strong>: Alemanha</li>',
unistr('<li><strong>AT</strong>: \00C1ustria</li>'),
'</ul>'))
,p_help_text=>unistr('<p>Selecione um item de p\00E1gina ou aplicativo de onde obter o pa\00EDs para a geocodifica\00E7\00E3o. O item deve conter o c\00F3digo ISO de dois d\00EDgitos para um pa\00EDs.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('Pa\00EDs')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione o pa\00EDs a ser usado para a geocodifica\00E7\00E3o.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>10
,p_display_value=>'Estados Unidos'
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>20
,p_display_value=>'Reino Unido'
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>30
,p_display_value=>'Alemanha'
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Fran\00E7a')
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>50
,p_display_value=>unistr('It\00E1lia ')
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>60
,p_display_value=>unistr('Canad\00E1')
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>70
,p_display_value=>'Holanda'
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>80
,p_display_value=>unistr('B\00E9lgica')
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>90
,p_display_value=>unistr('\00C1ustria')
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>100
,p_display_value=>unistr('Su\00ED\00E7a')
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>110
,p_display_value=>'Espanha'
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>120
,p_display_value=>'Portugal'
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>130
,p_display_value=>unistr('Federa\00E7\00E3o Russa')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>140
,p_display_value=>unistr('Est\00F4nia')
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>150
,p_display_value=>unistr('\00CDndia')
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>160
,p_display_value=>unistr('M\00E9xico')
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>170
,p_display_value=>unistr('Austr\00E1lia')
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>180
,p_display_value=>'Brasil'
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>190
,p_display_value=>'Chile'
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>200
,p_display_value=>unistr('Rep\00FAblica Tcheca')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>210
,p_display_value=>'Noruega'
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>220
,p_display_value=>unistr('Finl\00E2ndia')
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>230
,p_display_value=>'Dinamarca'
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>240
,p_display_value=>'Hong Kong'
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>250
,p_display_value=>'Irlanda'
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>260
,p_display_value=>unistr('Let\00F4nia')
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>270
,p_display_value=>unistr('Rom\00EAnia')
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>280
,p_display_value=>unistr('Col\00F4mbia')
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>290
,p_display_value=>unistr('Pol\00F4nia')
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>300
,p_display_value=>unistr('Emirados \00C1rabes Unidos')
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>310
,p_display_value=>'Hungria'
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>320
,p_display_value=>unistr('Ar\00E1bia Saudita')
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4416)
,p_display_sequence=>330
,p_display_value=>unistr('\00C1frica do Sul')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('Item de Endere\00E7o')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m partes de endere\00E7o n\00E3o estruturadas, separadas por v\00EDrgulas.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>'Item de Rua'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m a parte de <em>Rua</em> do endere\00E7o.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('Item de N\00FAmero da Casa')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m a parte de <em>N\00FAmero da Casa</em> do endere\00E7o.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('Item de Sub\00E1rea da Cidade')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m a parte de <em>Sub\00E1rea (dentro de uma Cidade)</em> do endere\00E7o.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>'Item de Cidade'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m a parte de <em>Cidade</em> do endere\00E7o.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Item de C\00F3digo Postal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m a parte de <em>C\00F3digo Postal</em> do endere\00E7o.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('Item da Regi\00E3o')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Selecione o item que cont\00E9m a parte de <em>Regi\00E3o (Estado)</em> do endere\00E7o.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('Sanear Endere\00E7o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Ative essa chave para alimentar dados de endere\00E7o do servi\00E7o de geocodifica\00E7\00E3o de volta aos itens mapeados.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('Item de Vetor de Correspond\00EAncia')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione um item de p\00E1gina para a qual o Geocodificador retornar\00E1 o <em>Vetor de Correspond\00EAncia</em>. O vetor de correspond\00EAncia \00E9 uma string de 17 d\00EDgitos com informa\00E7\00F5es detalhadas sobre como cada atributo de endere\00E7o foi correlacionado com os')
||unistr(' dados usados para geocodifica\00E7\00E3o.</p>'),
unistr('<p><strong>Os d\00EDgitos do Vetor de Correspond\00EAncia podem ter os seguintes valores:</strong></p>'),
'<ul>',
unistr('<li><p>0: O atributo de entrada n\00E3o \00E9 nulo e \00E9 correlacionado a um valor n\00E3o nulo.</p></li>'),
unistr('<li><p>1: O atributo de entrada \00E9 nulo e \00E9 correlacionado a um valor nulo.</p></li>'),
unistr('<li><p>2: O atributo de entrada n\00E3o \00E9 nulo e \00E9 substitu\00EDdo por outro valor n\00E3o nulo.</p></li>'),
unistr('<li><p>3: O atributo de entrada n\00E3o \00E9 nulo e \00E9 substitu\00EDdo por um valor nulo.</p></li>'),
unistr('<li><p>4: O atributo de entrada \00E9 nulo e \00E9 substitu\00EDdo por um valor n\00E3o nulo.</p></li>'),
'</ul>',
'<br>',
unistr('<p><strong>D\00EDgitos do Vetor de Correspond\00EAncia e o atributo de endere\00E7o correspondente a cada um:</strong></p>'),
'<ul>',
unistr('<li><p>3: Ponto de Endere\00E7o (endere\00E7o exato correlacionado nos dados usados para geocodifica\00E7\00E3o)</p></li>'),
'<li><p>4: Nome do Ponto de Interesse</p></li>',
unistr('<li><p>5: N\00FAmero da Casa</p></li>'),
'<li><p>6: Prefixo da Rua</p></li>',
'<li><p>7: Nome da Rua</p></li>',
'<li><p>8: Sufixo da Rua</p></li>',
'<li><p>9: Tipo de Rua</p></li>',
unistr('<li><p>10: Unidade Secund\00E1ria</p></li>'),
'<li><p>11: Cidade</p></li>',
unistr('<li><p>14: Regi\00E3o</p></li>'),
unistr('<li><p>15: Pa\00EDs</p></li>'),
unistr('<li><p>16: C\00F3digo Postal</p></li>'),
unistr('<li><p>17: C\00F3digo Postal Suplementar</p></li>'),
unistr('<li><p><em>outros d\00EDgitos ainda n\00E3o s\00E3o utilizados.</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Acionar Geocodifica\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Determine quando acionar a geocodifica\00E7\00E3o. Isso inclui o browser fazendo a solicita\00E7\00E3o REST ao servi\00E7o de geocodifica\00E7\00E3o e mostrando a janela popup com as poss\00EDveis correspond\00EAncias.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Autom\00E1tico')
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A geocodifica\00E7\00E3o \00E9 acionada automaticamente antes da submiss\00E3o da p\00E1gina.</p>'),
unistr('<p>Se o valor de um item dependente tiver sido alterado, como, por exemplo, o valor de <em>P1_STREET</em>, e a geocodifica\00E7\00E3o n\00E3o tiver sido executada at\00E9 o momento, ou um endere\00E7o v\00E1lido n\00E3o tiver sido selecionado, temos certeza de que a geocodifica')
||unistr('\00E7\00E3o ser\00E1 acionada automaticamente. Nesse caso, interrompemos o fluxo da submiss\00E3o da p\00E1gina atual e mostramos uma janela popup com poss\00EDveis correspond\00EAncias primeiro. Se o usu\00E1rio tiver selecionado um resultado correspondente, a p\00E1gina poder\00E1 ser su')
||unistr('bmetida novamente, sem qualquer outra interrup\00E7\00E3o.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4416)
,p_display_sequence=>20
,p_display_value=>unistr('A\00E7\00E3o Din\00E2mica')
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>A geocodifica\00E7\00E3o deve ser acionada pela adi\00E7\00E3o da A\00E7\00E3o Din\00E2mica <em>Acionar Geocodifica\00E7\00E3o</em> \00E0 p\00E1gina.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor jQuery'
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>A geocodifica\00E7\00E3o \00E9 acionada com base em um evento no elemento DOM visado pelo seletor. Se um campo de entrada for referenciado, a Geocodifica\00E7\00E3o ser\00E1 acionada ao <em>alterar</em> o elemento; se um bot\00E3o for referenciado, a Geocodifica\00E7\00E3o ser\00E1 acio')
||'nada <em>ao clicar</em>.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Seletor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Executar o processo quando os itens <em>P1_STREET</em> e <em>P1_ZIP_CODE</em> forem alterados; selector da jQuery:</p>',
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>Forne\00E7a o seletor jQuery que faz refer\00EAncia ao elemento que aciona a geocodifica\00E7\00E3o. Os bot\00F5es acionar\00E3o a geocodifica\00E7\00E3o <em>ao serem clicados</em>; outros elementos ser\00E3o acionados <em>ao serem alterados</em>.</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('Resposta de Geocodifica\00E7\00E3o')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4416)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4416)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('Sele\00E7\00E3o Resultante')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>'Filtros Inteligentes'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>Uma regi\00E3o baseada na origem de Filtros Inteligentes associados, que fornece aos usu\00E1rios finais numerosos filtros que s\00E3o usados para restringir os resultados da pesquisa no run-time. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('M\00E1ximo de Chips de Sugest\00E3o')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Especifique o n\00FAmero m\00E1ximo de Chips de Sugest\00E3o a serem exibidos. Se n\00E3o for especificado, o valor padr\00E3o 5 ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Chip de Sugest\00E3o de Mais Filtros')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se os Filtros que n\00E3o s\00E3o exibidos como Chips de Sugest\00E3o podem ser selecionados por meio do bot\00E3o do menu drop-down Mais Filtros.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Limite de N\00FAmeros Compactos')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Especifique um valor de limite, acima do qual as contagens sejam exibidas usando um formato de n\00FAmero compacto. Com esse formato, um valor <strong>1.234</strong> ser\00E1 exibido como <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar Contagem Total de Linhas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique onde a contagem total de linhas ser\00E1 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4416)
,p_display_sequence=>10
,p_display_value=>unistr('N\00E3o')
,p_return_value=>'N'
,p_help_text=>unistr('A contagem total de linhas n\00E3o \00E9 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4416)
,p_display_sequence=>20
,p_display_value=>'Sim'
,p_return_value=>'Y'
,p_help_text=>unistr('A contagem total de linhas \00E9 exibida abaixo dos chips de sugest\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor'
,p_return_value=>'E'
,p_help_text=>unistr('A contagem total de linhas (sem qualquer label) \00E9 exibida dentro do elemento especificado por este seletor. Isso permite que voc\00EA coloque a contagem total de linhas praticamente em qualquer lugar da p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Label da Contagem Total de Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Label a ser usado para a contagem total de linhas. Se nenhum label for informado aqui, o APEX utilizar\00E1 a mensagem de texto APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Seletor da Contagem Total de Linhas'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Este \00E9 o seletor de um elemento na p\00E1gina em que a regi\00E3o Filtros Inteligentes exibir\00E1 a contagem total de linhas.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4416)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4416)
,p_name=>'facetschange'
,p_display_name=>unistr('Altera\00E7\00E3o de Filtros')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4416)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4416)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4416)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4416)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Retorna ORDS JSON legado'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Ative essa op\00E7\00E3o se o servi\00E7o REST do ORDS retornar dados na <em>representa\00E7\00E3o JSON do ORDs legada</em>.')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>'Pesquisar'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um campo de texto, permitindo que o usu\00E1rio final pesquise as entradas da lista das facetas na regi\00E3o Pesquisa Facetada. Uma regi\00E3o Pesquisa Facetada suporta uma faceta de Pesquisa, que sempre estar\00E1 no topo da lista de Facetas, n\00E3o importando ')
||unistr('sua sequ\00EAncia.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4416)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo de Pesquisa'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4416)
,p_display_sequence=>10
,p_display_value=>'Pesquisa de Linha'
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4416)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4416)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Campo de Entrada'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4416)
,p_display_sequence=>10
,p_display_value=>unistr('In\00EDcio da Regi\00E3o de Pesquisa Facetada')
,p_return_value=>'FACET'
,p_help_text=>unistr('Um campo de pesquisa ser\00E1 renderizado no in\00EDcio da regi\00E3o Pesquisa Facetada, acima das facetas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Item de P\00E1gina Externo')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('\00C9 poss\00EDvel selecionar um item de p\00E1gina usando o atributo Item de P\00E1gina Externa, a ser usado como o campo de pesquisa para a regi\00E3o Pesquisa Facetada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4416)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Item de P\00E1gina Externo')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4416)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Campo de Pesquisa Contra\00EDdo')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o campo de pesquisa dos Filtros Inteligentes s\00E3o recolhidos inicialmente.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>'Mapa'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4416)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4416)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4416)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4416)
,p_name=>'spatialmapchanged'
,p_display_name=>'Mapa Alterado'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4416)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4416)
,p_name=>'spatialmapclick'
,p_display_name=>'Mapa Clicado'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4416)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4416)
,p_name=>'spatialmapinitialized'
,p_display_name=>'Mapa Inicializado'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4416)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4416)
,p_name=>'spatialmapobjectclick'
,p_display_name=>'Objeto do Mapa Clicado'
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>'Form'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Regi\00E3o do form que suporta diferentes origens de dados. Essa regi\00E3o do form armazena informa\00E7\00F5es sobre a origem de dados (que pode ser um servi\00E7o local, remoto ou REST) e tem itens de p\00E1gina atribu\00EDdos a ela. Cada item \00E9 designado a uma regi\00E3o do for')
||unistr('m e a uma regi\00E3o de exibi\00E7\00E3o.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4416)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4416)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>unistr('Form - Processamento Autom\00E1tico de Linhas (DML)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo para inserir, atualizar ou excluir linhas de uma regi\00E3o do form.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo de Alvo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione qual t\00E9cnica de processamento ser\00E1 executada para salvar as altera\00E7\00F5es de dados feitas na Regi\00E3o do Form.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Origem da Regi\00E3o')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inser\00E7\00F5es, atualiza\00E7\00F5es e exclus\00F5es utilizam a Consulta SQL de origem da regi\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o - Certifique-se de que as colunas n\00E3o inser\00EDveis ou atualiz\00E1veis t\00EAm a op\00E7\00E3o <strong>Somente Consulta</strong> definida como <code>Sim</code>, para exclu\00ED-las do processamento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_display_sequence=>20
,p_display_value=>'Tabela/View'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inser\00E7\00F5es, atualiza\00E7\00F5es e exclus\00F5es utilizam uma tabela ou view diferente da definida na Consulta SQL de origem da regi\00E3o.'),
unistr('Por exemplo, a Consulta SQL recupera dados de uma view de jun\00E7\00E3o de tabelas ou de uma view n\00E3o atualiz\00E1vel, e o processamento DML precisa ser executado para uma \00FAnica tabela base ou view atualiz\00E1vel.</p>'),
unistr('<p>Observa\00E7\00E3o - Certifique-se de que as colunas n\00E3o inser\00EDveis ou atualiz\00E1veis t\00EAm a op\00E7\00E3o <strong>Somente Consulta</strong> definida como <code>Sim</code>, para exclu\00ED-las do processamento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O processamento se baseia em c\00F3digo PL/SQL personalizado. Esta op\00E7\00E3o permite executar qualquer c\00F3digo PL/SQL para implementar manipula\00E7\00E3o de dados no banco de dados subjacente.</p>'),
unistr('<p>Esta op\00E7\00E3o deve ser utilizada com pacotes de bancos de dados, como APIs de tabelas ou chamadas para Web Services RESTful, para implementar uma l\00F3gica de neg\00F3cios.</p>'),
unistr('<p>Observa\00E7\00E3o - O C\00F3digo PL/SQL ser\00E1 chamado para cada linha inserida, atualizada ou exclu\00EDda.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4416)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('C\00F3digo PL/SQL para Inserir/Atualizar/Excluir')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o c\00F3digo PL/SQL para processar cada linha de dados manipulados na Regi\00E3o do Form.</p>'),
unistr('<p>Use o nome da coluna como vari\00E1vel de bind para acessar o valor de uma coluna. A vari\00E1vel de sistema <code>APEX$ROW_STATUS</code> retorna o status de uma linha e pode ser usada para verificar se a linha foi criada, atualizada ou exclu\00EDda (veja o e')
||'xemplo abaixo para saber como verificar isso).</p>',
unistr('<p><em>Observa\00E7\00E3o:</em> se as colunas de chave prim\00E1ria forem preenchidas por um trigger ou no c\00F3digo PL/SQL, ser\00E1 exigido que os novos valores sejam designados \00E0s vari\00E1veis de bind das colunas de chave prim\00E1ria, porque o &PRODUCT_NAME. usa esses val')
||unistr('ores para extrair a linha ap\00F3s uma inser\00E7\00E3o ou atualiza\00E7\00E3o.</p>'),
unistr('<p>A Oracle recomenda chamar procedimentos ou fun\00E7\00F5es dentro de um pacote PL/SQL, para facilitar a reutiliza\00E7\00E3o e a capacidade de manuten\00E7\00E3o.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Impedir Perda de Atualiza\00E7\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se o processamento dever\00E1 garantir que as atualiza\00E7\00F5es n\00E3o ser\00E3o perdidas quando diversos usu\00E1rios atualizarem o mesmo registro do banco de dados.</p> '),
unistr('<p>H\00E1 perda de atualiza\00E7\00F5es quando duas ou mais pessoas tentam atualizar os mesmos dados, e a \00FAltima atualiza\00E7\00E3o substitui as atualiza\00E7\00F5es feitas pelo primeiro usu\00E1rio a salvar altera\00E7\00F5es. Para impedir que isso aconte\00E7a, as atualiza\00E7\00F5es podem verific')
||unistr('ar os valores de colunas existentes no banco de dados em rela\00E7\00E3o aos valores recuperados quando a linha foi originalmente consultada.</p>'),
'<p>Por exemplo:',
'  <ol>',
unistr('    <li>O Usu\00E1rio A consulta registros de funcion\00E1rios (EMP).</li>'),
unistr('    <li>O Usu\00E1rio B consulta os mesmos registros de funcion\00E1rios.</li>'),
unistr('    <li>O Usu\00E1rio B atualiza os detalhes do funcion\00E1rio EMPNO = 7839 e aplica (faz o commit) das altera\00E7\00F5es no banco de dados.</li>'),
unistr('    <li>O Usu\00E1rio A atualiza os detalhes do funcion\00E1rio EMPNO = 7839 e est\00E1 tentando aplicar as altera\00E7\00F5es ao banco de dados.</li>'),
'  </ol>',
unistr('Se o Usu\00E1rio A atualizar a mesma linha com sucesso, as altera\00E7\00F5es feitas pelo Usu\00E1rio B ser\00E3o perdidas.'),
unistr('Quando o Usu\00E1rio A estiver tentando salvar a linha do funcion\00E1rio, os dados no banco de dados ser\00E3o diferentes dos originalmente consultados por ele. Na etapa 1 acima, os valores de colunas originalmente consultados pelo Usu\00E1rio A podem ser capturado')
||unistr('s. Na Etapa 4 acima, os valores podem ser comparados com os valores atuais no banco de dados. Essa compara\00E7\00E3o identificar\00E1 um erro para o Usu\00E1rio A, pois os valores do banco de dados foram atualizados pelo Usu\00E1rio B na Etapa 3. Isso impede um usu\00E1rio')
||unistr(' de substituir altera\00E7\00F5es feitas por outro usu\00E1rio na mesma linha.</p>'),
unistr('<p>Observa\00E7\00E3o - A forma como as atualiza\00E7\00F5es perdidas s\00E3o detectadas \00E9 especificada para a regi\00E3o Grade Interativa, com base na defini\00E7\00E3o para <strong>Tipo de Atualiza\00E7\00E3o Perdida</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Bloquear Linha'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione se cada linha a ser atualizada ou exclu\00EDda ser\00E1 bloqueada na tabela subjacente antes do processamento da linha.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4416)
,p_display_sequence=>10
,p_display_value=>'Sim'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As linhas a serem atualizadas ou exclu\00EDdas ser\00E3o bloqueadas com SELECT ... FOR UPDATE para impedir que outras transa\00E7\00F5es sejam executadas na linha at\00E9 que seja feito o commit da transa\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o - Se ocorrer um erro, como views atualiz\00E1veis que n\00E3o suportam bloqueio, talvez voc\00EA n\00E3o consiga utilizar c\00F3digo PL/SQL para bloquear a tabela orientadora.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00E3o')
,p_return_value=>'N'
,p_help_text=>unistr('As linhas n\00E3o ser\00E3o bloqueadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4416)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('Instru\00E7\00F5es de c\00F3digo PL/SQL personalizadas ser\00E3o usadas para bloquear as linhas at\00E9 que o commit da transa\00E7\00E3o ocorra.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('C\00F3digo PL/SQL para Bloquear Linha')
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Informe o c\00F3digo PL/SQL para bloquear as linhas da tabela do banco de dados a serem atualizadas ou exclu\00EDdas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4416)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Retornar Chave(s) Prim\00E1ria(s) ap\00F3s Inser\00E7\00E3o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione se as colunas de chave prim\00E1ria dever\00E3o ser retornadas para os itens de regi\00E3o correspondentes assim que a linha for inserida no banco de dados.'),
unistr('Em geral, esta op\00E7\00E3o dever\00E1 ser usada quando as colunas de chave prim\00E1ria forem preenchidas com base em um trigger de banco de dados ou em uma coluna de Identidade do Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Observa\00E7\00E3o - se um erro for gerado, especificando que a cl\00E1usula RETURNING INTO n\00E3o \00E9 permitida, voc\00EA dever\00E1 especificar esta op\00E7\00E3o como N\00E3o e pr\00E9-preencher as colunas de chave prim\00E1ria.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>unistr('Form - Inicializa\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo para inicializar itens de regi\00E3o do form. A inicializa\00E7\00E3o pode extrair dados da origem da regi\00E3o, pode usar os valores de chave prim\00E1ria ou pode ser uma simples inicializa\00E7\00E3o dos itens da regi\00E3o do form.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4416)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Pr\00F3ximos Itens da Chave Prim\00E1ria')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4416)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Itens Anteriores da Chave Prim\00E1ria')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4416)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Linha Atual/Total do Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>'Carga de Dados'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo para carregar dados na tabela ou cole\00E7\00E3o de destino, com base na defini\00E7\00E3o de carga de dados fornecida.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Defini\00E7\00E3o de Carga de Dados')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a <strong>Defini\00E7\00E3o de Carga de Dados</strong> de Componentes Compartilhados. Entre outros atributos, a defini\00E7\00E3o de carga de dados define a tabela ou cole\00E7\00E3o de destino, o m\00E9todo de carga e o <em>Perfil de Dados</em>. Todas as informa\00E7\00F5es ')
||unistr('de nome de coluna, mapeamento de coluna e tipo de dados s\00E3o armazenadas no perfil de dados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tipo de Dados de Origem'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Especifique a origem dos dados a serem carregados.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Item de Navega\00E7\00E3o do Arquivo')
,p_return_value=>'FILE'
,p_help_text=>unistr('Escolha o nome de um item de navega\00E7\00E3o de arquivo na p\00E1gina atual. O APEX carregar\00E1 os dados do arquivo escolhido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Nome do item da \00E1rea de texto')
,p_return_value=>'TEXT'
,p_help_text=>unistr('Escolha o nome de um item da \00E1rea de texto que contenha os dados a serem carregados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4416)
,p_display_sequence=>30
,p_display_value=>'Consulta SQL'
,p_return_value=>'SQL_QUERY'
,p_help_text=>'Fornece uma Consulta SQL que retorna um CLOB ou um BLOB contendo os dados a serem carregados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Item de Navega\00E7\00E3o do Arquivo')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('Selecione o item de navega\00E7\00E3o em arquivos dos quais os dados ser\00E3o carregados. O item deve usar <strong>APEX_APPLICATION_TEMP_FILES</strong> como seu <strong>Tipo de Armazenamento</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Item da \00C1rea de Texto')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>'Escolha o nome de um item textarea que contenha os dados a serem carregados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('Forne\00E7a uma consulta SQL que retorne uma linha e uma coluna, que contenha um BLOB ou CLOB do qual os dados ser\00E3o carregados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Item da p\00E1gina contendo o Nome da Planilha XLSX')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Uma lista de sele\00E7\00E3o ou item LOV popup para exibir planilhas dispon\00EDveis no arquivo XLSX que sofreu upload usaria a <em>Consulta SQL de Lista de Valores</em> (<strong>PX_FILE</strong> \00E9 o item de navega\00E7\00E3o de arquivo usado para fazer o upload do a')
||'rquivo XLSX) a seguir.</p><p>Observe que o atributo <strong>SHEET_FILE_NAME</strong>deve ser usado como a coluna de retorno de LOV.</p>',
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>Forne\00E7a um item de p\00E1gina contendo um nome de planilha para carga de arquivos XLSX. Os dados ser\00E3o carregados da planilha especificada. Se n\00E3o for fornecido, o APEX carregar\00E1 dados da primeira planilha do arquivo XLSX.</p><p>Em geral, itens <em>se')
||unistr('lecionar lista</em> s\00E3o usados para essa finalidade: Na <em>consulta da Lista de Valores</em>, use <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> para recuperar nomes internos e para exibi\00E7\00E3o da planilha.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Item da Contagem de Linhas Processadas'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Selecione um item de p\00E1gina no qual armazenar o valor de linhas submetidas a upload (e processadas). O valor est\00E1 dispon\00EDvel ap\00F3s a conclus\00E3o do processo de Carga de Dados e pode ser usado para exibi\00E7\00E3o em mensagens.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4416)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Item da Contagem de Linhas com Erro'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Selecione um item de p\00E1gina no qual armazenar a quantidade de linhas de erro. O valor fica dispon\00EDvel ap\00F3s a conclus\00E3o do processo de Carga de Dados e pode ser usado para exibi\00E7\00E3o em mensagens.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>'Intervalo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Exibe um item com uma lista incorporada de seletor de valores. A faceta suporta sele\00E7\00E3o \00FAnica ou m\00FAltipla, al\00E9m de entrada manual. Para suporte a sele\00E7\00E3o \00FAnica, exibe v\00E1rios valores como um grupo de bot\00F5es de op\00E7\00E3o, permitindo que o usu\00E1rio final ')
||unistr('selecione um valor \00FAnico. Para suporte a sele\00E7\00E3o m\00FAltipla, exibe v\00E1rios valores na forma de caixas de sele\00E7\00E3o, permitindo que o usu\00E1rio final selecione v\00E1rios valores. Para suporte a entrada manual, os campos de texto ser\00E3o renderizados abaixo da fac')
||unistr('eta, permitindo que o usu\00E1rio final insira manualmente a faixa de valores que desejam usar para filtrar a regi\00E3o Filtrado.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Selecionar V\00E1rios Arquivos')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se a faceta suporta a sele\00E7\00E3o de v\00E1rias entradas da lista. Quando definido como <strong>Ativado</strong>, a faceta ser\00E1 renderizada na forma de caixas de sele\00E7\00E3o para suportar sele\00E7\00E3o m\00FAltipla. Quando definido como <strong>Desativado</str')
||unistr('ong>, a faceta ser\00E1 renderizada na forma de grupo de bot\00F5es de op\00E7\00E3o, para suportar a sele\00E7\00E3o \00FAnica.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Entrada Manual'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se a faceta Faixa suporta entrada manual. Quando definido como <strong>Ativado</strong>, os campos de texto ser\00E3o renderizados abaixo da faceta, permitindo que o usu\00E1rio final insira manualmente a faixa de valores que desejam usar para fi')
||unistr('ltrar a regi\00E3o Filtrada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Texto do Intervalo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Digite o texto a ser exibido entre os campos de texto de Entrada Manual.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Label Atual'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'De 0% a %1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Label Atual - Abertura na Alta'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Acima de %0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Label Atual - Abertura na Baixa'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Abaixo de %0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4416)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4416)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>unistr('Mapa de Exibi\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Exibe um mapa baseado em coordenadas no formato de ponto GeoJSON.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Segundo Plano'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selecione o mapa de fundo a ser usado.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Padr\00E3o')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use o plano de fundo de mapa padr\00E3o.</p>'),
'<p>Ele usa "OpenStreetMap Bright" ou "OpenStreetMap Dark" para temas escuros.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4416)
,p_display_sequence=>20
,p_display_value=>'OpenStreetMap Bright'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso geral baseado em dados do OpenStreetMap. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o detalhado para seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4416)
,p_display_sequence=>30
,p_display_value=>'OpenStreetMap Dark'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base escuro n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abriga da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4416)
,p_display_sequence=>40
,p_display_value=>'OpenStreetMap Positron'
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base leve n\00E3o invasivo baseado em dados do OpenStreetMap. Este estilo de mapa base acentua as visualiza\00E7\00F5es de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo dos colaboradores da KlokanTech.com e OpenMapTiles, derivados de "Estilos Abertos do Mapbox". Licenciado ao abrigo da licen\00E7a BSD/CC-BY. A cartografia da Stamen Design est\00E1 licenciada ao abrigo da licen\00E7a CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver no GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4416)
,p_display_sequence=>50
,p_display_value=>unistr('Mapa M\00FAndi Oracle')
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso geral baseado em dados de Mapa HERE. Este estilo de mapa base fornece contexto de localiza\00E7\00E3o para seus dados e acentua a visualiza\00E7\00E3o de seus dados.</p>'),
unistr('<p>Esquema e defini\00E7\00F5es de estilo da Oracle, EUA.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('N\00EDvel de Zoom')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o n\00EDvel de zoom para que esta camada fique vis\00EDvel.</p>'),
'<p>',
unistr('Valor m\00EDnimo: 1<br>'),
unistr('Valor m\00E1ximo: 18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Mostrar Marcador'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>'<p>Especifique se um marcador deve ser exibido.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cor do Marcador'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique a cor de preenchimento do marcador.</p>',
unistr('<p>A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML. A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores ')
||unistr('hexadecimais de dois caracteres para vermelho, verde e azul, respectivamente. Os c\00F3digos RGB s\00E3o definidos como RGB (xxx, xxx, xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e az')
||'ul, respectivamente.</p>',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Dica de ferramenta'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique o texto de dica de ferramenta para um marcador exibido.</p>',
'<p>O atributo de dica de ferramenta suporta diretivas de modelo HTML e APEX.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mostrar Controles de Mapa'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique se os controles de mapa devem ser exibidos.</p>',
unistr('<p>Essa op\00E7\00E3o adiciona zoom e controles de rota\00E7\00E3o ao mapa.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Mapa Interativo'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique se o mapa deve ser interativo.</p>',
unistr('<p>Se for definido como "N\00E3o", criar\00E1 um mapa est\00E1tico sem interatividade.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4416)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Altura'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'pixels'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique a altura (em pixels) do mapa exibido.</p>',
unistr('<p>A altura padr\00E3o do mapa \00E9 calculada com base em sua largura, com uma raz\00E3o altura/largura de 3:2.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>'Consulta SQL Existe'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uma consulta que faz com que o esquema de autoriza\00E7\00E3o seja aprovado se retornar pelo menos uma linha e faz com que ele falhe se n\00E3o retornar nenhuma linha.'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4416)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uma consulta que faz com que o esquema de autoriza\00E7\00E3o seja aprovado se retornar pelo menos uma linha e faz com que ele falhe se n\00E3o retornar nenhuma linha.'),
''))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>unistr('Consulta SQL N\00C3O Existe')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Uma consulta que faz com que o esquema de autoriza\00E7\00E3o seja aprovado se ele n\00E3o retornar nenhuma linha e faz com que o sistema falhe se ele retornar uma ou mais linhas.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4416)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('Uma consulta que faz com que o esquema de autoriza\00E7\00E3o falhe se retornar pelo menos uma linha e faz com que ele seja bem-sucedido se n\00E3o retornar nenhuma linha.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('O Item \00E9 NULO')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('O valor do item \00E9 nulo.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4416)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('A autoriza\00E7\00E3o ser\00E1 bem-sucedida se o valor desse item for nulo e falhar de outra forma.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('O Item \00E9 N\00C3O NULO')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('O valor do item \00E9 n\00E3o nulo.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4416)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('A autoriza\00E7\00E3o ser\00E1 bem-sucedida se o valor desse item n\00E3o for nulo e falhar de outra forma.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('Fun\00E7\00E3o PL/SQL que Retorna Booleano')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('O corpo de uma fun\00E7\00E3o PL/SQL que retorna verdadeiro ou falso. Um valor falso faz com que o esquema de autoriza\00E7\00E3o falhe. Um valor verdadeiro faz com que ele seja aprovado.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4416)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O corpo de uma fun\00E7\00E3o PL/SQL que retorna verdadeiro ou falso. Um valor falso faz com que o esquema de autoriza\00E7\00E3o falhe. Um valor verdadeiro significa que ele foi aprovado.'),
'<p/>',
'Exemplo:',
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>unistr('A Prefer\00EAncia \00E9 igual ao Valor')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('O valor de prefer\00EAncia \00E9 igual ao valor.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4416)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nome da Prefer\00EAncia')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('A autoriza\00E7\00E3o ser\00E1 bem-sucedida se o valor dessa prefer\00EAncia for igual ao valor do campo abaixo e falhar\00E1 se forem diferentes')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4416)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'veja acima'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>unistr('A Prefer\00EAncia N\00C3O \00E9 igual ao Valor')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('O valor de prefer\00EAncia n\00E3o \00E9 igual ao valor.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4416)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nome da Prefer\00EAncia')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('A autoriza\00E7\00E3o ser\00E1 bem-sucedida se o valor dessa prefer\00EAncia for diferente do valor do campo abaixo e falhar\00E1 se forem iguais')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4416)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'veja acima'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>unistr('O Item \00E9 igual ao Valor')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('O valor do item \00E9 igual ao valor.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4416)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('A autoriza\00E7\00E3o ser\00E1 bem-sucedida se o valor desse item for igual ao valor do campo abaixo e falhar\00E1 se forem diferentes')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4416)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'veja acima'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>unistr('O Item N\00C3O \00E9 igual ao Valor')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O valor do item n\00E3o \00E9 igual ao valor.</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4416)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('A autoriza\00E7\00E3o ser\00E1 bem-sucedida se o valor desse item for diferente do valor do campo abaixo e falhar\00E1 se forem iguais')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4416)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'veja acima'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('Acionar Geocodifica\00E7\00E3o')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Acione manualmente a pesquisa de geocodifica\00E7\00E3o de um item de <em>Endere\00E7o Geocodificado</em>.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>'Acesso Social'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Suporta autentica\00E7\00E3o com Google, Facebook, OpenID Connect gen\00E9rico e Provedores de Identidades OAuth2 gen\00E9ricos.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Armazenamento de Credenciais'
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o armazenamento de credenciais que cont\00E9m o ID e Segredo do Cliente para o Provedor de Autentica\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Provedor de Autentica\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_display_sequence=>10
,p_display_value=>'Provedor OpenID Connect'
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('Use um provedor de autentica\00E7\00E3o baseado no OpenID Connect. Informe a seguir o URL de Descoberta do OpenID do provedor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Provedor OAuth2 Gen\00E9rico')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('Use um provedor de autentica\00E7\00E3o do OAuth2. Digite abaixo os URLs de pontos finais de autoriza\00E7\00E3o, token e informa\00E7\00F5es do usu\00E1rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('Use as defini\00E7\00F5es pr\00E9vias para Log-in no Google.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('Use as defini\00E7\00F5es pr\00E9vias para Log-in no Facebook.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL de descoberta'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Digite o URL de descoberta do provedor do OpenID Connect.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('URL do Ponto Final de Autoriza\00E7\00E3o')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('Digite o URL do ponto final de utiliza\00E7\00E3o do provedor do OAuth2.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'URL do Ponto Final de Token'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Digite o URL do ponto final de token do provedor do OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('URL do Ponto Final de Informa\00E7\00F5es do Usu\00E1rio')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('Digite o URL do ponto final de informa\00E7\00F5es do usu\00E1rio do provedor do OAuth2.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Escopo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'e-mail,perfil'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Digite uma lista de permiss\00F5es separadas por v\00EDrgulas para solicita\00E7\00E3o ao usu\00E1rio que est\00E1 fazendo log-in.'),
unistr('Os valores aceit\00E1veis dependem do provedor de autentica\00E7\00E3o.'),
'Para OpenID Connect e Google, o Application Express adiciona automaticamente o escopo "openid".',
unistr('O provedor de autentica\00E7\00E3o retorna os atributos do usu\00E1rio com base nessas permiss\00F5es.'),
unistr('Voc\00EA pode mapear os atributos para itens do aplicativo ou usar um procedimento de P\00F3s-Autentica\00E7\00E3o para process\00E1-los, usando as fun\00E7\00F5es APEX_JSON.GET_%.'),
'</p><p>',
unistr('Os escopos e atributos (tamb\00E9m chamados de reivindica\00E7\00F5es) do OpenID Connect est\00E3o listados aqui: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Par\00E2metros do URI de Autentica\00E7\00E3o')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('Digite par\00E2metros opcionais para o URI de autentica\00E7\00E3o. Consulte a documenta\00E7\00E3o do provedor de autentica\00E7\00E3o para obter os par\00E2metros suportados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Nome do Usu\00E1rio')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Informe o atributo que cont\00E9m o nome do usu\00E1rio ou digite um texto livre com uma ou mais substitui\00E7\00F5es de atributo, colocando-as entre "#".'),
unistr('Voc\00EA pode fazer refer\00EAncia ao nome do esquema de autentica\00E7\00E3o com #APEX_AUTH_NAME#.'),
unistr('Por exemplo, "#email# (#APEX_AUTH_NAME#)" resultar\00E1 em um nome de usu\00E1rio que consiste no endere\00E7o de e-mail, seguido de " (", seguido pelo nome do esquema de autentica\00E7\00E3o, seguido de ")", como "jane.doe@example.com (Google)".'),
'</p><p>',
unistr('Consulte a documenta\00E7\00E3o do provedor de autentica\00E7\00E3o para saber os atributos suportados.'),
unistr('Observe que voc\00EA precisa definir o Escopo necess\00E1rio, caso contr\00E1rio o provedor de autentica\00E7\00E3o n\00E3o enviar\00E1 todos os atributos.'),
unistr('Os escopos e atributos (tamb\00E9m chamados de reivindica\00E7\00F5es) do OpenID s\00E3o listados aqui: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Atributos Adicionais do Usu\00E1rio')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'link,foto,e-mail'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Informe uma lista separada por v\00EDrgulas dos atributos de dados adicionais do usu\00E1rio.'),
'</p><p>',
unistr('Consulte a documenta\00E7\00E3o do provedor de autentica\00E7\00E3o para saber os atributos suportados.'),
unistr('Observe que voc\00EA precisa definir o Escopo necess\00E1rio, caso contr\00E1rio o provedor de autentica\00E7\00E3o n\00E3o enviar\00E1 todos os atributos.'),
unistr('Os escopos e atributos (tamb\00E9m chamados de reivindica\00E7\00F5es) do OpenID Connect est\00E3o listados aqui: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('Converter o Nome do Usu\00E1rio para Mai\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Configure se os valores de atributo para o nome do usu\00E1rio devem ser convertidos para letras mai\00FAsculas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('M\00E9todo de Autentica\00E7\00E3o de Token')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Informe como o ID e o segredo do cliente da credencial devem ser transmitidos ao servidor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Autentica\00E7\00E3o B\00E1sica')
,p_return_value=>'BASIC'
,p_help_text=>unistr('Envie o id e o segredo do cliente em um cabe\00E7alho de Autentica\00E7\00E3o B\00E1sica.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4416)
,p_display_sequence=>22
,p_display_value=>unistr('Autentica\00E7\00E3o B\00E1sica e ID do Cliente no Corpo')
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('Envie o id e o segredo do cliente em um cabe\00E7alho de Autentica\00E7\00E3o B\00E1sica, mas tamb\00E9m envie o id do cliente no corpo da solicita\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4416)
,p_display_sequence=>30
,p_display_value=>'ID e Segredo do Cliente no Corpo'
,p_return_value=>'BODY'
,p_help_text=>unistr('Envie o id e o segredo do cliente no corpo da solicita\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4416)
,p_display_sequence=>40
,p_display_value=>'ID do Cliente no Corpo'
,p_return_value=>'CLID'
,p_help_text=>unistr('Envia s\00F3 o id do cliente no corpo da solicita\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>'Verificar Atributos'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se ativada, o &PRODUCT_NAME. procurar\00E1 um atributo "#name#_verified" (por exemplo, "email_verified" para o Atributo "email").'),
unistr('OpenID define que o provedor de identidades envia <code>"#name#_verified":false</code> para atributos "email" e "phone_number" n\00E3o verificados.'),
unistr('O &PRODUCT_NAME. ignora esses atributos n\00E3o verificados.'),
unistr('Isso resultar\00E1 em uma falha na autentica\00E7\00E3o se "#name#" for o atributo Username.'),
'</p><p>',
unistr('Se o provedor de identidades permitir que hackers insiram dados n\00E3o verificados que o aplicativo usa para autentica\00E7\00E3o,'),
unistr('eles poder\00E3o se passar por outros usu\00E1rios no aplicativo.'),
unistr('A verifica\00E7\00E3o "Verificar Atributos" impede que isso aconte\00E7a.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4416)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('Mapear Atributos Adicionais de Usu\00E1rio para')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Forne\00E7a uma lista separada por v\00EDrgulas dos nomes de item de aplicativo para os quais os <em>Atributos Adicionais de Usu\00E1rio</em> ser\00E3o mapeados. Por exemplo, se voc\00EA definir'),
'<ul>',
unistr('<li>Atributos Adicionais de Usu\00E1rio: email,profile,picture</li>'),
unistr('<li>Mapeie os Atributos Adicionais de Usu\00E1rio para: G_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>',
unistr('em seguida, o APEX salvar\00E1 automaticamente os valores de atributo no estado da sess\00E3o para os itens correspondentes.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>'View em Lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe os dados em uma lista de f\00E1cil navega\00E7\00E3o. Voc\00EA tamb\00E9m pode incorporar v\00E1rios recursos para aprimorar a view da lista.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Funcionalidades'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione os recursos que s\00E3o ativados para a view em lista.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>5
,p_display_value=>unistr('Formata\00E7\00E3o Avan\00E7ada')
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>10
,p_display_value=>'Mostrar Imagem'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>20
,p_display_value=>'Mostrar Divisor da Lista'
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>50
,p_display_value=>unistr('Tem o Bot\00E3o de Divis\00E3o')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>55
,p_display_value=>'Ativar Pesquisa'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>65
,p_display_value=>unistr('\00C9 View em Lista Aninhada')
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_display_sequence=>70
,p_display_value=>unistr('Lista de Inser\00E7\00E3o')
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Coluna de Texto'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('Selecione a coluna do banco de dados que cont\00E9m o conte\00FAdo principal da entrada da view em lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos da Lista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>O cliente cria divisores com base no texto de item de lista</dt>',
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>Alterar o \00EDcone</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>Alterar o \00EDcone do bot\00E3o de divis\00E3o</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Informe atributos adicionais a serem definidos no elemento de lista. Veja os exemplos de alguns atributos que afetam a view em lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Atributos de Entrada da Lista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Defina o \00EDcone do link de entrada da lista a ser deletado.</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Informe atributos adicionais a serem definidos no elemento de item de lista. Veja os exemplos de alguns atributos que afetam a view em lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Formata\00E7\00E3o do Texto')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exiba o nome e, abaixo, a data de contrata\00E7\00E3o de um funcion\00E1rio</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
'&lt;p&gt;Hire date: &amp;HIREDATE.&lt;/p&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a marca\00E7\00E3o HTML para renderizar o conte\00FAdo principal de uma entrada da view em lista.</p>'),
unistr('<p>Para fazer refer\00EAncia a valores de coluna de sua instru\00E7\00E3o SQL de view em lista, use a sintaxe de substitui\00E7\00E3o.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Coluna de Informa\00E7\00F5es Complementares')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('Selecione a coluna do banco de dados que cont\00E9m informa\00E7\00F5es complementares da entrada da view em lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Formata\00E7\00E3o de Informa\00E7\00F5es Complementares')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exiba o sal\00E1rio em negrito</dt>'),
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a marca\00E7\00E3o HTML para renderizar informa\00E7\00F5es suplementares para uma entrada da view em lista.</p>'),
unistr('<p>Para fazer refer\00EAncia a valores de coluna de sua instru\00E7\00E3o SQL de view em lista, use a sintaxe de substitui\00E7\00E3o.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Coluna do Contador'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna do banco de dados que cont\00E9m o valor a ser exibido no \00EDcone de contagem.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Tipo de Imagem'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione o tipo de imagem que ser\00E1 exibido e de onde ser\00E1 lido. A imagem exibida pode ser um \00EDcone com o tamanho 16x16 ou uma miniatura com um tamanho de 80x80. A origem da imagem pode ser uma coluna BLOB do banco de dados ou um URL para um arquivo ')
||unistr('est\00E1tico.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_display_sequence=>20
,p_display_value=>unistr('\00CDcone armazenado no BLOB')
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_display_sequence=>30
,p_display_value=>unistr('\00CDcone lido do URL')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_display_sequence=>40
,p_display_value=>'Imagem armazenada no BLOB'
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_display_sequence=>50
,p_display_value=>'Imagem lida do URL'
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Coluna de BLOB da Imagem'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('Selecione a coluna do banco de dados dos tipos de dados BLOB que cont\00E9m a imagem.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Coluna 1 da Chave Prim\00E1ria da Imagem')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('Selecione a coluna de chave prim\00E1ria ou uma coluna de um \00FAnico banco de dados usada para procurar a imagem.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Coluna 2 da Chave Prim\00E1ria da Imagem')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Selecione uma segunda coluna de chave prim\00E1ria ou uma coluna de um \00FAnico banco de dados usada para procurar a imagem.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Coluna de URL da Imagem'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('Selecione a coluna do banco de dados que cont\00E9m o URL para o \00EDcone/a imagem.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Coluna do Divisor da Lista'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('Selecione a coluna de banco de dados que cont\00E9m o divisor. Toda vez que o valor do divisor mudar, um novo divisor ser\00E1 exibido entre as entradas da view em lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Formata\00E7\00E3o do Divisor da Lista')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exibir o nome do departamento e o n\00FAmero de funcion\00E1rios em um emblema</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="ui-li-count"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira a marca\00E7\00E3o HTML para renderizar o divisor de uma view em lista.</p>'),
unistr('<p>Para fazer refer\00EAncia a valores de coluna de sua instru\00E7\00E3o SQL de view em lista, use a sintaxe de substitui\00E7\00E3o.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Destino do Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Informe uma p\00E1gina de destino a ser chamada quando o usu\00E1rio clicar em uma entrada da lista.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('Alvo do Bot\00E3o de Divis\00E3o')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Informe uma p\00E1gina de destino a ser chamada quando o usu\00E1rio clicar em uma entrada da lista.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'Tipo de Pesquisa'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como a pesquisa ser\00E1 executada.</p>'),
unistr('<p>Uma pesquisa do cliente ser\00E1 executada imediatamente assim que o usu\00E1rio come\00E7ar a digitar. Para todas as pesquisas baseadas no servidor, o usu\00E1rio dever\00E1 pressionar Enter para mostrar os resultados da pesquisa. Somente pesquisas baseadas no servi')
||unistr('dor levam em conta os atributos de globaliza\00E7\00E3o Compara\00E7\00E3o de Valor do Caractere definidos para o aplicativo.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4416)
,p_display_sequence=>20
,p_display_value=>'Do Cliente'
,p_return_value=>'CLIENT'
,p_help_text=>unistr('Para realizar uma pesquisa baseada no browser, todas as entradas de view da lista devem ser carregadas no browser (observe que o atributo "N\00FAmero de Linhas Extra\00EDdas" \00E9 ignorado nesse caso). Use essa op\00E7\00E3o de pesquisa somente para um pequeno n\00FAmero d')
||unistr('e entradas na lista para evitar carregamentos de p\00E1ginas longos desnecessariamente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Servidor: Exato e Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>'A pesquisa usa LIKE [valor de pesquisa]% para consultar o resultado.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Servidor: Exato e Ignorar Mai\00FAsculas/Min\00FAsculas')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('A pesquisa usa LIKE UPPER( [valor de pesquisa] )% para consultar o resultado. Os \00EDndices existentes na coluna n\00E3o ser\00E3o usados, a menos que seja um \00EDndice baseado em fun\00E7\00E3o que use uma express\00E3o UPPER.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4416)
,p_display_sequence=>50
,p_display_value=>unistr('Servidor: Como e Faz Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('A pesquisa usa LIKE %[valor de pesquisa]% para consultar o resultado. Isso impedir\00E1 o uso de um \00EDndice existente nessa coluna.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4416)
,p_display_sequence=>60
,p_display_value=>unistr('Servidor: Como e Ignorar Mai\00FAsculas/Min\00FAsculas')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('A pesquisa usa LIKE %UPPER([valor de pesquisa] )% para consultar o resultado. Isso impedir\00E1 o uso de um \00EDndice existente nessa coluna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Pesquisar Coluna'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Selecione uma coluna do banco de dados alternativa usada para a pesquisa. Se nada for especificado, a Coluna de Texto ser\00E1 usada.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('Marcador de Espa\00E7o da Caixa de Pesquisa')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Selecione o texto que ser\00E1 exibido na caixa de pesquisa. Se nenhum valor for especificado, o valor da mensagem do sistema <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong> ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>'Coluna da Lista Aninhada'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('Selecione a coluna de banco de dados que cont\00E9m o n\00EDvel de hierarquia de uma consulta aninhada. Se voc\00EA usar uma consulta CONNECT BY use a pseudocoluna <code>LEVEL</code>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4416)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exiba todos os funcion\00E1rios ordenados por nome</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>Exiba todos os funcion\00E1rios do departamento atual ordenados por nome</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Ao usar vari\00E1veis de bind para fazer a itens de p\00E1gina, especifique-os como <strong>Itens de P\00E1gina a Submeter</strong>.</p>'),
'</dd>',
unistr('<dt>Use ROWID como coluna de chave prim\00E1ria</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
unistr('<p>Ao usar ROWID, um alias de coluna \00E9 obrigat\00F3rio.</p>'),
'</dd>',
unistr('<dt>Consulta aninhada retornando todos os funcion\00E1rios</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('Fechar Regi\00E3o')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Fecha uma regi\00E3o, como caixa de di\00E1logo em linha, popup em linha ou contra\00EDvel, que suporte ser aberta e esteja aberta.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('Abrir Regi\00E3o')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Abre uma regi\00E3o, como caixa de di\00E1logo em linha, popup em linha ou contra\00EDvel, que suporte ser aberta.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('Est\00E1 na Atribui\00E7\00E3o ou Grupo')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4416)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome(s)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Digite um ou mais nomes de grupos separados por v\00EDrgulas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4416)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Atribui\00E7\00E3o do Aplicativo')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Grupo de Espa\00E7o de Trabalho')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4416)
,p_display_sequence=>30
,p_display_value=>'Personalizado'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4416)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('N\00E3o Est\00E1 na Atribui\00E7\00E3o ou Grupo')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4416)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome(s)'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Digite um ou mais nomes de grupos separados por v\00EDrgulas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4416)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Atribui\00E7\00E3o do Aplicativo')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Grupo de Espa\00E7o de Trabalho')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4416)
,p_display_sequence=>30
,p_display_value=>'Personalizado'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>'Seletor de Data'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe um campo de texto com um \00EDcone de calend\00E1rio. Os usu\00E1rios finais podem digitar a data diretamente no item de texto ou clicar no \00EDcone do calend\00E1rio para selecionar uma data, e, opcionalmente, um hor\00E1rio, no popup do calend\00E1rio.</p>'),
unistr('<p>O hor\00E1rio s\00F3 ser\00E1 exibido no popup do calend\00E1rio se a <em>M\00E1scara de Formato</em> desse item incluir componentes de hora.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Apar\00EAncia')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Controla a apar\00EAncia do calend\00E1rio usado para selecionar datas.</p>'),
unistr('<p>Observa\00E7\00E3o: S\00F3 \00E9 usado quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4416)
,p_display_sequence=>10
,p_display_value=>'Mostrar Semana'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Se a semana do ano ser\00E1 mostrada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Seletor de M\00EAs')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Se o m\00EAs deve ser renderizado como um bot\00E3o para permitir a sele\00E7\00E3o, em vez de texto.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor de Ano'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Se o ano deve ser renderizado como um bot\00E3o para permitir a sele\00E7\00E3o, em vez de texto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Dias Fora do M\00EAs')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina o comportamento dos dias fora do m\00EAs de visualiza\00E7\00E3o atual.</p>'),
unistr('<p>Observa\00E7\00E3o: S\00F3 \00E9 usado quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4416)
,p_display_sequence=>10
,p_display_value=>'Oculto'
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Os dias fora do m\00EAs da visualiza\00E7\00E3o atual ser\00E3o ocultos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Selecion\00E1vel')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Os dias fora do m\00EAs de visualiza\00E7\00E3o atual ficar\00E3o vis\00EDveis e poder\00E3o ser selecionados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Vis\00EDvel')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('Os dias fora do m\00EAs da visualiza\00E7\00E3o atual ficar\00E3o vis\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Incremento de Hora'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>'minutos'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incremento de tempo, em minutos, usado pelo controle de sele\00E7\00E3o de tempo. Observa\00E7\00E3o: Ele apenas monitora o controle usado para selecionar o tempo; qualquer tempo fora desses incrementos ainda podem ser inseridos e salvos manualmente.</p>'),
unistr('<p>Observa\00E7\00E3o: S\00F3 \00E9 usado quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha'' e, al\00E9m disso, quando a op\00E7\00E3o ''Mostrar Tempo'' est\00E1 ativada.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controla quando o popup de calend\00E1rio \00E9 exibido. Observa\00E7\00E3o: Essa op\00E7\00E3o s\00F3 \00E9 usada quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha''.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4416)
,p_display_sequence=>10
,p_display_value=>'Foco do Item'
,p_return_value=>'FOCUS'
,p_help_text=>unistr('Quando o item recebe o foco ou o \00EDcone do calend\00E1rio \00E9 clicado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Clique do \00CDcone')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('Somente quando o \00EDcone de calend\00E1rio \00E9 clicado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Mostrar Hor\00E1rio')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Se informa\00E7\00F5es de tempo devem ou n\00E3o ser inclu\00EDdas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Exibir Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione o modo de exibi\00E7\00E3o do seletor de data.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4416)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>unistr('O calend\00E1rio \00E9 exibido em um popup quando o item recebe o foco ou o \00EDcone do calend\00E1rio \00E9 clicado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4416)
,p_display_sequence=>20
,p_display_value=>'Em Linha'
,p_return_value=>'INLINE'
,p_help_text=>unistr('O calend\00E1rio sempre \00E9 exibido em linha na p\00E1gina. Nenhum campo de texto \00E9 exibido e a sele\00E7\00E3o de data atual \00E9 mostrada destacada no calend\00E1rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4416)
,p_display_sequence=>30
,p_display_value=>'HTML Nativo'
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Renderize usando os tipos de dados de entrada HTML nativos, se forem suportados pelo browser. Quando a op\00E7\00E3o ''Mostrar Tempo'' est\00E1 desativada, um tipo ''data'' \00E9 renderizado; quando a op\00E7\00E3o ''Mostrar Tempo'' est\00E1 ativada, um tipo ''data/hora-local'' \00E9 re')
||unistr('nderizado. Observa\00E7\00E3o: A exibi\00E7\00E3o exata desses tipos de dados depende do browser. O HTML nativo pode ser a op\00E7\00E3o preferencial quando o aplicativo est\00E1 sendo usado em um dispositivo m\00F3vel.</p>'),
unistr('<p>Observe, ao usar ''HTML Nativo'', porque os tipos de data nativos s\00E3o muito espec\00EDficos sobre o formato de dados que requerem, que a ''M\00E1scara de Formato'' do item ser\00E1 automaticamente definida pelo APEX, e voc\00EA n\00E3o poder\00E1 alter\00E1-la. Contudo, esse n\00E3o')
||unistr(' ser\00E1 o formato exibido para o usu\00E1rio final. O usu\00E1rio final ver\00E1 a data no formato apropriado \00E0 sua configura\00E7\00E3o regional.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Data M\00EDnima')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique se este item tem uma data m\00EDnima.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4416)
,p_display_sequence=>10
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
,p_help_text=>unistr('Sem data m\00EDnima definida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4416)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>unistr('A data m\00EDnima deriva de forma din\00E2mica do valor de outro item.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('A data m\00EDnima \00E9 um valor est\00E1tico, definido como um valor absoluto ou valor relativo \00E0 data de hoje.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Valor Est\00E1tico M\00EDnimo')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a data m\00EDnima que pode ser informada ou selecionada.</p>'),
unistr('<p>O valor da data pode ser um valor absoluto no formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, um valor relativo referente \00E0 data de hoje, como <code>+7d</code> ou um valor din\00E2mico usando a sintaxe de substitui\00E7\00E3o, c')
||unistr('ontanto que a substitui\00E7\00E3o retorne o formato de data correto ou o valor relativo.</p>'),
'<p>Os valores de data relativos incluem:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anos a partir da data de hoje</dd>',
'  <dt>m</dt>',
'    <dd>+ / - meses a partir da data de hoje</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir da data de hoje</dd>',
'  <dt>d</dt>',
'    <dd>+ / - dias a partir da data de hoje</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('M\00EDnimo de Itens')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>O item que determina o valor m\00EDnimo permitido. Ele deve ser um item de p\00E1gina que esteja na p\00E1gina atual ou global.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Data M\00E1xima')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique se este item tem uma data m\00E1xima.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4416)
,p_display_sequence=>10
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
,p_help_text=>unistr('Sem data m\00E1xima definida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4416)
,p_display_sequence=>20
,p_display_value=>'Item'
,p_return_value=>'ITEM'
,p_help_text=>unistr('A data m\00E1xima deriva de forma din\00E2mica do valor de outro item.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('A data m\00E1xima \00E9 um valor est\00E1tico, definido como um valor absoluto ou valor relativo \00E0 data de hoje.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Valor Est\00E1tico M\00E1ximo')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a data m\00E1xima que pode ser especificada ou selecionada.</p>'),
unistr('<p>O valor da data pode ser um valor absoluto no formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, um valor relativo referente \00E0 data de hoje, como <code>+7d</code> ou um valor din\00E2mico usando a sintaxe de substitui\00E7\00E3o, c')
||unistr('ontato que a substitui\00E7\00E3o retorne o formato de data correto ou o valor relativo.</p>'),
'<p>Os valores de data relativos incluem:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anos a partir da data de hoje</dd>',
'  <dt>m</dt>',
'    <dd>+ / - meses a partir da data de hoje</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir da data de hoje</dd>',
'  <dt>d</dt>',
'    <dd>+ / - dias a partir da data de hoje</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('M\00E1ximo de Itens')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>O item que determina o valor m\00E1ximo permitido. Ele deve ser um item de p\00E1gina que esteja na p\00E1gina atual ou global.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('V\00E1rios Meses')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('Se o calend\00E1rio exibir\00E1 v\00E1rios meses.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('N\00FAmero de Meses')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('O n\00FAmero de meses a serem mostrados de uma vez.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Usar Padr\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Se os padr\00F5es definidos para este componente ser\00E3o ou n\00E3o usados, em Componentes Compartilhados > Defini\00E7\00F5es de Componentes ou defini\00E7\00F5es personalizadas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Apar\00EAncia')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Controla a apar\00EAncia do calend\00E1rio usado para selecionar datas.</p>'),
unistr('<p>Observa\00E7\00E3o: S\00F3 \00E9 usado quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4416)
,p_display_sequence=>10
,p_display_value=>'Mostrar Semana'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Se a semana do ano ser\00E1 mostrada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Seletor de M\00EAs')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Se o m\00EAs deve ser renderizado como um bot\00E3o para permitir a sele\00E7\00E3o, em vez de texto.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4416)
,p_display_sequence=>30
,p_display_value=>'Seletor de Ano'
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Se o ano deve ser renderizado como um bot\00E3o para permitir a sele\00E7\00E3o, em vez de texto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Dias Fora do M\00EAs')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina o comportamento dos dias fora do m\00EAs de visualiza\00E7\00E3o atual.</p>'),
unistr('<p>Observa\00E7\00E3o: S\00F3 \00E9 usado quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha''.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4416)
,p_display_sequence=>10
,p_display_value=>'Oculto'
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Os dias fora do m\00EAs da visualiza\00E7\00E3o atual ser\00E3o ocultos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Selecion\00E1vel')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Os dias fora do m\00EAs de visualiza\00E7\00E3o atual ficar\00E3o vis\00EDveis e poder\00E3o ser selecionados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Vis\00EDvel')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('Os dias fora do m\00EAs da visualiza\00E7\00E3o atual ficar\00E3o vis\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Incremento de Hora'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>'minutos'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incremento de tempo, em minutos, usado pelo controle de sele\00E7\00E3o de tempo. Observa\00E7\00E3o: Ele apenas monitora o controle usado para selecionar o tempo; qualquer tempo fora desses incrementos ainda podem ser inseridos e salvos manualmente.</p>'),
unistr('<p>Observa\00E7\00E3o: S\00F3 \00E9 usado quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha'' e, al\00E9m disso, quando a op\00E7\00E3o ''Mostrar Tempo'' est\00E1 ativada.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4416)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Mostrar em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controla quando o popup de calend\00E1rio \00E9 exibido. Observa\00E7\00E3o: Essa op\00E7\00E3o s\00F3 \00E9 usada quando ''Exibir como'' \00E9 ''Popup'' ou ''Em linha''.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4416)
,p_display_sequence=>10
,p_display_value=>'Foco do Item'
,p_return_value=>'FOCUS'
,p_help_text=>unistr('Quando o item recebe o foco ou o \00EDcone do calend\00E1rio \00E9 clicado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Clique do \00CDcone')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('Somente quando o \00EDcone de calend\00E1rio \00E9 clicado.')
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('Caixa de Sele\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma caixa de sele\00E7\00E3o \00FAnica que o usu\00E1rio pode marcar ou desmarcar. O valor marcado ou desmarcado definido \00E9 armazenado no estado da sess\00E3o quando submetido.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4416)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valor Verificado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Digite o valor armazenado no item da p\00E1gina se o usu\00E1rio final marcar a caixa de sele\00E7\00E3o. O valor pode ter at\00E9 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4416)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor Desmarcado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Digite o valor armazenado no item de p\00E1gina se o usu\00E1rio desmarcar a caixa de sele\00E7\00E3o. Esse atributo tamb\00E9m poder\00E1 ser deixado em branco se voc\00EA quiser armazenar <code>NULL</code> quando a op\00E7\00E3o for marcada. O valor pode ter at\00E9 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4416)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Usar Padr\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Se os padr\00F5es definidos para este componente ser\00E3o ou n\00E3o usados, em Componentes Compartilhados > Defini\00E7\00F5es de Componentes ou defini\00E7\00F5es personalizadas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4416)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor Verificado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Digite o valor armazenado no item de p\00E1gina se o usu\00E1rio marcar a caixa de sele\00E7\00E3o. O valor pode ter at\00E9 255 caracteres.</p>'),
'<p>',
unistr('Em uma p\00E1gina de Pesquisa Facetada, se a faceta filtrar uma coluna de consulta <em>baseada em uma Lista de Valores</em>, esse valor dever\00E1 corresponder a <em>ambos</em> os valores, de exibi\00E7\00E3o e de retorno da LOV. Se os valores de exibi\00E7\00E3o e retorno ')
||unistr('diferirem, voc\00EA n\00E3o poder\00E1 usar esse tipo de faceta para esta coluna - use em seu lugar a faceta <strong>Grupo de Caixa de Sele\00E7\00E3o</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4416)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valor Desmarcado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o valor armazenado no item da p\00E1gina se o usu\00E1rio desmarcar a caixa de sele\00E7\00E3o. Esse atributo tamb\00E9m poder\00E1 ser deixado em branco se voc\00EA quiser armazenar <code>NULL</code> quando a op\00E7\00E3o for desmarcada. O valor pode ter at\00E9 255 caracteres.')
||'</p>',
unistr('<p><em>Observa\00E7\00E3o: Esse valor ser\00E1 usado se o item da p\00E1gina for preenchido com um valor que n\00E3o corresponda a <strong>Valor Ativado</strong> ou <strong>Valor Desativado</strong>.</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>'Grade Interativa'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Regi\00E3o on-line abrangente multilinha baseada em uma Consulta SQL que fornece aos usu\00E1rios finais diversos recursos para personaliza\00E7\00E3o durante o runtime. '),
unistr('A regi\00E3o pode ser definida como edit\00E1vel ou somente para leitura.</p>'),
unistr('<p> Voc\00EA pode definir uma \00FAnica Grade Interativa e permitir que os usu\00E1rios finais manipulem os dados exibidos para atender a seus requisitos espec\00EDficos, em vez de desenvolver diversas regi\00F5es semelhantes com diferentes crit\00E9rios para atender a esse')
||'s mesmos requisitos.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'apexbeginrecordedit'
,p_display_name=>unistr('Inicializa\00E7\00E3o de Linha')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'gridpagechange'
,p_display_name=>unistr('Altera\00E7\00E3o de P\00E1gina')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('Altera\00E7\00E3o de Modo')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('Reportar Altera\00E7\00E3o')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'interactivegridsave'
,p_display_name=>'Salvar'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('Altera\00E7\00E3o de Sele\00E7\00E3o')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4416)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4416)
,p_name=>'interactivegridviewchange'
,p_display_name=>unistr('Exibir Altera\00E7\00E3o')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>'Seletor de Linhas'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe uma caixa de sele\00E7\00E3o em cada linha de uma Grade Interativa, permitindo a sele\00E7\00E3o de linhas espec\00EDficas para manipula\00E7\00E3o.</p>'),
unistr('<p>Por padr\00E3o, a coluna APEX$ROW_SELECTOR \00E9 definida com o tipo Seletor de Linha. Essa coluna \00E9 adicionada automaticamente quando a Grade Interativa se torna edit\00E1vel.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4416)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Ativar Sele\00E7\00E3o M\00FAltipla')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Permita a sele\00E7\00E3o de v\00E1rias linhas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4416)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostrar Selecionar Tudo'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Permita que o usu\00E1rio selecione todas as linhas usando Ctrl+A ou, se <em>Ocultar Controles</em> for <em>N\00E3o</em>, usando uma caixa de sele\00E7\00E3o no cabe\00E7alho da coluna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4416)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Ocultar Controle'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Oculte a caixa de sele\00E7\00E3o ou o controle de r\00E1dio exibido em cada linha.')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('Menu A\00E7\00F5es')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe o \00EDcone de a\00E7\00F5es (hamb\00FArguer) em cada linha de uma Grade Interativa. '),
unistr('O menu de a\00E7\00F5es inclui op\00E7\00F5es como View de Uma Linha, Adicionar Linha, Excluir Linha e Atualizar Linha etc., dependendo dos atributos da grade e das autoriza\00E7\00F5es do usu\00E1rio final. Essas op\00E7\00F5es de menu permitem que os usu\00E1rios finais executem a\00E7\00F5es es')
||unistr('pec\00EDficas na linha atual na grade.</p>'),
unistr('<p>O menu de a\00E7\00F5es pode ser usado em Grades Interativas edit\00E1veis e n\00E3o edit\00E1veis, mas as op\00E7\00F5es de menu v\00E3o diferir, dependendo do caso. Para Grades Interativas n\00E3o edit\00E1veis, o menu ter\00E1 um subconjunto de op\00E7\00F5es, por exemplo, View de Uma Linha e At')
||unistr('ualizar Linha, e n\00E3o incluir\00E1 a\00E7\00F5es edit\00E1veis espec\00EDficas como Adicionar Linha, Excluir Linha etc.</p>'),
unistr('<p>Quando uma Grade Interativa se tornar edit\00E1vel, a coluna APEX$ROW_ACTION ser\00E1 adicionada automaticamente e definida como um tipo de Menu A\00E7\00F5es. Para Grades Interativas n\00E3o edit\00E1veis, essa coluna deve ser adicionada manualmente.</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>unistr('Gr\00E1fico')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe dados usando v\00E1rios tipos de gr\00E1ficos incorporados.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4416)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4416)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>'Ocultar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Oculta os elementos afetados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4416)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Ocultar todos os itens de p\00E1gina na mesma linha')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se todos os itens e labels de p\00E1gina na mesma linha que os elementos afetados ser\00E3o ocultos.</p>'),
unistr('<p>Observa\00E7\00E3o: Este atributo n\00E3o funcionar\00E1 para itens de p\00E1ginas que n\00E3o usarem uma grade de tabela para exibir itens de form. Isso inclui qualquer p\00E1gina que use um modelo de p\00E1gina m\00F3vel.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>'Ativar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Ativa os elementos afetados.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>'Desativar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Desativa os elementos afetados. A desativa\00E7\00E3o torna esses elementos n\00E3o edit\00E1veis para que eles n\00E3o retenham valores de itens quando a p\00E1gina for submetida.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>'Definir Valor'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Define o valor dos elementos afetados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definir Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Selecione como derivar o(s) valor(es) a serem definidos.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Designa\00E7\00E3o Est\00E1tica')
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('Defina um \00FAnico valor est\00E1tico.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_display_sequence=>15
,p_display_value=>unistr('Express\00E3o JavaScript')
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>'Defina um ou mais valores derivados ou calculados no JavaScript.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Instru\00E7\00E3o SQL')
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>'Defina um ou mais valores, com base no resultado de uma consulta SQL.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Express\00E3o PL/SQL')
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('Defina um valor \00FAnico, com base no resultado de uma express\00E3o PL/SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_display_sequence=>50
,p_display_value=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('Defina um valor \00FAnico, com base no resultado de um corpo de fun\00E7\00E3o PL/SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_display_sequence=>60
,p_display_value=>unistr('Item de Retorno do Di\00E1logo')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Defina um \00FAnico valor, com base no item de retorno de um di\00E1logo. Observa\00E7\00E3o: esse tipo funciona somente se a a\00E7\00E3o din\00E2mica for acionada para o evento <strong>Di\00E1logo Fechado</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('Informe um valor est\00E1tico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Instru\00E7\00E3o SQL')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>Nesse exemplo, informe <code>P1_DEPTNO</code> em <strong>Itens de P\00E1gina a Submeter</strong>. Selecione tamb\00E9m dois <em>Elementos Afetados</em> para as colunas <code>loc</code> e <code>dname</code> respectivamente, por exemplo P1_LOC e P1_DNAME.</')
||'p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma instru\00E7\00E3o SQL que retorna entre 1 e 100 colunas. As colunas selecionadas com a instru\00E7\00E3o SQL devem corresponder, por posi\00E7\00E3o, aos Itens da P\00E1gina selecionados em <strong>Elementos Afetados</strong>.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia a itens da p\00E1gina ou do aplicativo usando a sintaxe de bind, contanto que voc\00EA os inclua em <strong>Itens de P\00E1gina a Submeter</strong></p>'),
unistr('<p><em>Observa\00E7\00E3o: Se a instru\00E7\00E3o SQL retornar apenas uma \00FAnica linha, esta ser\00E1 definida como os valores. Se ela retornar m\00FAltiplas linhas, o valor definido ser\00E1 uma string de todas as linhas separada por v\00EDrgula, para cada valor.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Express\00E3o PL/SQL')
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>Nesse exemplo, informe <code>P1_SAL</code> em <strong>Itens de P\00E1gina a Submeter</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma express\00E3o PL/SQL usada para definir o valor.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia a itens da p\00E1gina ou do aplicativo, contato que voc\00EA os inclua em <strong>Itens de P\00E1gina a Submeter</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Express\00E3o JavaScript')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este c\00F3digo tem acesso aos seguintes atributos relacionados \00E0 a\00E7\00E3o din\00E2mica:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>Uma refer\00EAncia ao objeto DOM do elemento que ativou a a\00E7\00E3o din\00E2mica.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>Um objeto jQuery que cont\00E9m todos os elementos afetados.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>O objeto da a\00E7\00E3o que cont\00E9m detalhes como o nome da a\00E7\00E3o e valores de atributos adicionais.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>O objeto do evento que acionou o evento. Observa\00E7\00E3o: Ao carregar, isso \00E9 igual a ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
'    <dd>Dados adicionais opcionais que podem ser informados do handler do evento.</dd>',
'</dl>'))
,p_help_text=>unistr('Informe uma express\00E3o JavaScript que ser\00E1 usada para definir o valor. Essa express\00E3o pode resultar em um valor \00FAnico ou em um array de valores (quando o item que est\00E1 sendo definido suporta diversos valores, como, por exemplo, um Shuttle).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Corpo da Fun\00E7\00E3o PL/SQL')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>Nesse exemplo, informe <code>P1_SAL</code> e <code>P1_JOB</code> em <strong>Itens de P\00E1gina a Submeter</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um corpo de fun\00E7\00E3o PL/SQL usado para definir o valor.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia a itens da p\00E1gina ou do aplicativo, contanto que voc\00EA os inclua em <strong>Itens de P\00E1gina a Submeter</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Itens a Submeter'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Informe os itens da p\00E1gina ou do aplicativo a serem submetidos ao executar esta a\00E7\00E3o. Para v\00E1rios itens, separe o nome de cada item com uma v\00EDrgula. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis. Se voc\00EA selecionar na lista e j\00E1 ')
||unistr('houver texto inserido, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome do item retornado da lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Caracteres Especiais de Escape'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Especifique se os caracteres especiais HTML ser\00E3o de escape. A Oracle recomenda definir esse atributo como <strong> Sim </strong>, para impedir ataques CSS (Cross-Site Scripting).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Suprimir Evento de Altera\00E7\00E3o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o evento de altera\00E7\00E3o ser\00E1 suprimido nos itens especificados em <strong>Itens de P\00E1gina a Serem Retornados</strong>. Isso impede que A\00E7\00F5es Din\00E2micas subsequentes baseadas em <em>Alterar</em> sejam ativadas para esses itens.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4416)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>'Item de Retorno'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Informe o nome de um item de p\00E1gina retornado pelo di\00E1logo usado para definir o valor.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('Executar C\00F3digo JavaScript')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permite definir ou chamar um c\00F3digo JavaScript personalizado espec\00EDfico da p\00E1gina a ser usado na estrutura da a\00E7\00E3o din\00E2mica. Se estiver definindo um c\00F3digo JavaScript espec\00EDfico para apenas uma p\00E1gina, voc\00EA poder\00E1 usar o atributo em n\00EDvel de p\00E1gina <')
||unistr('em>Fun\00E7\00E3o e Instru\00E7\00E3o de Vari\00E1vel Global</em> para defini-lo. As fun\00E7\00F5es e vari\00E1veis definidas a\00ED poder\00E3o ser referenciadas a partir desta a\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4416)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('C\00F3digo')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este c\00F3digo tem acesso aos seguintes atributos relacionados \00E0 a\00E7\00E3o din\00E2mica:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>Uma refer\00EAncia ao objeto DOM do elemento que ativou a a\00E7\00E3o din\00E2mica.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>Um objeto jQuery que cont\00E9m todos os elementos afetados.</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>O objeto da a\00E7\00E3o que cont\00E9m detalhes como o nome da a\00E7\00E3o e valores de atributos adicionais.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>O objeto do evento que acionou o evento. Observa\00E7\00E3o: Ao carregar, isso \00E9 igual a ''load''.</dd>'),
'  <dt><code>this.data</code></dt>',
'    <dd>Dados adicionais opcionais que podem ser informados do handler do evento.</dd>',
'</dl>'))
,p_help_text=>unistr('Informe qualquer JavaScript personalizado que seja espec\00EDfico para a p\00E1gina ou a\00E7\00E3o din\00E2mica.')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>unistr('Grade Interativa - Processamento Autom\00E1tico de Linhas (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo para inserir, atualizar ou excluir linhas da Grade Interativa.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo de Alvo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione qual t\00E9cnica de processamento ser\00E1 executada para salvar as altera\00E7\00F5es de dados feitas na Grade Interativa.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Origem da Regi\00E3o')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inser\00E7\00F5es, atualiza\00E7\00F5es e exclus\00F5es utilizam a Consulta SQL de origem da regi\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o - Certifique-se de que as colunas n\00E3o inser\00EDveis ou atualiz\00E1veis t\00EAm a op\00E7\00E3o <strong>Somente Consulta</strong> definida como <code>Sim</code>, para exclu\00ED-las do processamento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_display_sequence=>20
,p_display_value=>'Tabela/View'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inser\00E7\00F5es, atualiza\00E7\00F5es e exclus\00F5es utilizam uma tabela ou view diferente da definida na Consulta SQL de origem da regi\00E3o.'),
unistr('Por exemplo, a Consulta SQL recupera dados de uma view de jun\00E7\00E3o de tabelas ou de uma view n\00E3o atualiz\00E1vel, e o processamento DML precisa ser executado para uma \00FAnica tabela base ou view atualiz\00E1vel.</p>'),
unistr('<p>Observa\00E7\00E3o - Certifique-se de que as colunas n\00E3o inser\00EDveis ou atualiz\00E1veis t\00EAm a op\00E7\00E3o <strong>Somente Consulta</strong> definida como <code>Sim</code>, para exclu\00ED-las do processamento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O processamento se baseia em c\00F3digo PL/SQL personalizado. Esta op\00E7\00E3o permite executar qualquer c\00F3digo PL/SQL para implementar manipula\00E7\00E3o de dados no banco de dados subjacente.</p>'),
unistr('<p>Esta op\00E7\00E3o deve ser utilizada com pacotes de bancos de dados, como APIs de tabelas ou chamadas para Web Services RESTful, para implementar uma l\00F3gica de neg\00F3cios.</p>'),
unistr('<p>Observa\00E7\00E3o - O C\00F3digo PL/SQL ser\00E1 chamado para cada linha inserida, atualizada ou exclu\00EDda.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4416)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('C\00F3digo PL/SQL para Inserir/Atualizar/Excluir')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o c\00F3digo PL/SQL para processar cada linha de dados manipulados na Grade Interativa.</p>'),
unistr('<p>Use o nome da coluna como vari\00E1vel de bind para acessar o valor de uma coluna. A vari\00E1vel de sistema <code>APEX$ROW_STATUS</code> retorna o status de uma linha e pode ser usada para verificar se a linha foi criada, atualizada ou exclu\00EDda (veja o e')
||'xemplo abaixo para saber como verificar isso).</p>',
unistr('<p><em>Observa\00E7\00E3o:</em> Se as colunas de chave prim\00E1ria forem preenchidas por um trigger ou no c\00F3digo PL/SQL, ser\00E1 exigido que os novos valores sejam designados \00E0s vari\00E1veis de bind das colunas de chave prim\00E1ria, porque o &PRODUCT_NAME. usa esses val')
||unistr('ores para extrair a linha ap\00F3s uma inser\00E7\00E3o ou atualiza\00E7\00E3o.</p>'),
unistr('<p>A Oracle recomenda chamar procedimentos ou fun\00E7\00F5es dentro de um pacote PL/SQL, para facilitar a reutiliza\00E7\00E3o e a capacidade de manuten\00E7\00E3o.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Impedir Perda de Atualiza\00E7\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se o processamento dever\00E1 garantir que as atualiza\00E7\00F5es n\00E3o ser\00E3o perdidas quando diversos usu\00E1rios atualizarem o mesmo registro do banco de dados.</p> '),
unistr('<p>H\00E1 perda de atualiza\00E7\00F5es quando duas ou mais pessoas tentam atualizar os mesmos dados, e a \00FAltima atualiza\00E7\00E3o substitui as atualiza\00E7\00F5es feitas pelo primeiro usu\00E1rio a salvar altera\00E7\00F5es. Para impedir que isso aconte\00E7a, as atualiza\00E7\00F5es podem verific')
||unistr('ar os valores de colunas existentes no banco de dados em rela\00E7\00E3o aos valores recuperados quando a linha foi originalmente consultada.</p>'),
'<p>Por exemplo:',
'  <ol>',
unistr('    <li>O Usu\00E1rio A consulta registros de funcion\00E1rios (EMP).</li>'),
unistr('    <li>O Usu\00E1rio B consulta os mesmos registros de funcion\00E1rios.</li>'),
unistr('    <li>O Usu\00E1rio B atualiza os detalhes do funcion\00E1rio EMPNO = 7839 e aplica (faz o commit) das altera\00E7\00F5es no banco de dados.</li>'),
unistr('    <li>O Usu\00E1rio A atualiza os detalhes do funcion\00E1rio EMPNO = 7839 e est\00E1 tentando aplicar as altera\00E7\00F5es ao banco de dados.</li>'),
'  </ol>',
unistr('Se o Usu\00E1rio A atualizar a mesma linha com sucesso, as altera\00E7\00F5es feitas pelo Usu\00E1rio B ser\00E3o perdidas.'),
unistr('Quando o Usu\00E1rio A estiver tentando salvar a linha do funcion\00E1rio, os dados no banco de dados ser\00E3o diferentes dos originalmente consultados por ele. Na etapa 1 acima, os valores de colunas originalmente consultados pelo Usu\00E1rio A podem ser capturado')
||unistr('s. Na Etapa 4 acima, os valores podem ser comparados com os valores atuais no banco de dados. Essa compara\00E7\00E3o identificar\00E1 um erro para o Usu\00E1rio A, pois os valores do banco de dados foram atualizados pelo Usu\00E1rio B na Etapa 3. Isso impede um usu\00E1rio')
||unistr(' de substituir altera\00E7\00F5es feitas por outro usu\00E1rio na mesma linha.</p>'),
unistr('<p>Observa\00E7\00E3o - A forma como as atualiza\00E7\00F5es perdidas s\00E3o detectadas \00E9 especificada para a regi\00E3o Grade Interativa, com base na defini\00E7\00E3o para <strong>Tipo de Atualiza\00E7\00E3o Perdida</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Bloquear Linha'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione se cada linha a ser atualizada ou exclu\00EDda ser\00E1 bloqueada na tabela subjacente antes do processamento da linha.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4416)
,p_display_sequence=>10
,p_display_value=>'Sim'
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>As linhas a serem atualizadas ou exclu\00EDdas ser\00E3o bloqueadas com SELECT ... FOR UPDATE para impedir que outras transa\00E7\00F5es sejam executadas na linha at\00E9 que seja feito o commit da transa\00E7\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o - Se ocorrer um erro, como views atualiz\00E1veis que n\00E3o suportam bloqueio, talvez voc\00EA n\00E3o consiga utilizar c\00F3digo PL/SQL para bloquear a tabela orientadora.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00E3o')
,p_return_value=>'N'
,p_help_text=>unistr('As linhas n\00E3o ser\00E3o bloqueadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4416)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('Instru\00E7\00F5es de c\00F3digo PL/SQL personalizadas ser\00E3o usadas para bloquear as linhas at\00E9 que o commit da transa\00E7\00E3o ocorra.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('C\00F3digo PL/SQL para Bloquear Linha')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Informe o c\00F3digo PL/SQL para bloquear as linhas da tabela do banco de dados a serem atualizadas ou exclu\00EDdas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4416)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Retornar Chave(s) Prim\00E1ria(s) ap\00F3s Inser\00E7\00E3o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione se as colunas de chave prim\00E1ria dever\00E3o ser retornadas \00E0 linha da Grade Interativa correspondente assim que a linha for inserida no banco de dados.'),
unistr('Em geral, esta op\00E7\00E3o dever\00E1 ser usada quando as colunas de chave prim\00E1ria forem preenchidas com base em um trigger de banco de dados ou em uma coluna de Identidade do Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Observa\00E7\00E3o - Se um erro for gerado, especificando que a cl\00E1usula RETURNING INTO n\00E3o \00E9 permitida, voc\00EA dever\00E1 especificar esta op\00E7\00E3o como N\00E3o e pr\00E9-preencher as colunas de chave prim\00E1ria.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>'Adicionar Classe'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Adiciona uma ou mais classes CSS aos elementos afetados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4416)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Classe'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Adicione as classes CSS <code>articlenumber</code> e <code>highlight</code> \00E0 tag HTML dos elementos afetados:'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('Especifique uma ou mais classes que ser\00E3o aplicadas aos elementos afetados. Se voc\00EA especificar mais de um, separe os nomes de classes com um espa\00E7o.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>'Remover Classe'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Remove uma ou mais classes CSS dos elementos afetados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4416)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Classe'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>Especifique um ou mais nomes de classe que ser\00E3o removidos dos elementos afetados. Se voc\00EA estiver especificando mais de um, separe os nomes de classe com um espa\00E7o. Deixe em branco para remover todos os nomes de classe dos elementos afetados.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>'Definir Estilo'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Define uma propriedade (CSS) de estilo para os elementos afetados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4416)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome do Estilo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o nome da propriedade de estilo (CSS) que voc\00EA deseja definir para os elementos afetados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4416)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Informe o valor para definir a propriedade de estilo para os elementos afetados. Deixe em branco para remover a propriedade de estilo dos elementos afetados.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>'Personalizado'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Um esquema de autentica\00E7\00E3o que permite definir suas pr\00F3prias Fun\00E7\00F5es PL/SQL para determinar a autentica\00E7\00E3o do usu\00E1rio.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nome da Fun\00E7\00E3o Sentinela')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o c\00F3digo PL/SQL que retorna um valor booliano, no ''C\00F3digo PL/SQL'' -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>Especifique uma fun\00E7\00E3o de Banco de Dados PL/SQL - </p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome de uma fun\00E7\00E3o que seja executada pelo mecanismo do &PRODUCT_NAME. no in\00EDcio de qualquer solicita\00E7\00E3o feita ao mecanismo, como antes de cada p\00E1gina ser exibida ou processada ou uma solicita\00E7\00E3o do AJAX ser emitida. '),
unistr('Isso pode ser definido no C\00F3digo PL/SQL da autentica\00E7\00E3o, dentro de um pacote ou como uma fun\00E7\00E3o armazenada.</p>'),
unistr('<p>Se essa fun\00E7\00E3o retornar o valor falso (indicado que talvez o usu\00E1rio n\00E3o esteja conectado), isso marcar\00E1 a sess\00E3o como inv\00E1lida e o <em>Procedimento de Sess\00E3o Inv\00E1lido</em> ser\00E1 chamado.'),
unistr('Depois disso, o &PRODUCT_NAME. redirecionar\00E1 para o URL definido em ''Sess\00E3o N\00E3o V\00E1lida > Ir Para''.'),
'Se o valor desse campo estiver vazio,',
unistr('uma fun\00E7\00E3o de sentinela padr\00E3o interna ser\00E1 chamada para tentar estabelecer uma sess\00E3o v\00E1lida comparando o ID da sess\00E3o no URL e as informa\00E7\00F5es da sess\00E3o no cookie do esquema de autentica\00E7\00E3o com um fallback para o cookie do Builder do &PRODUCT_NAME.,')
||' em caso de falha).</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Nome de Procedimento de Sess\00E3o Inv\00E1lido')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome de um procedimento PL/SQL que ser\00E1 chamado se uma sess\00E3o inv\00E1lida for detectada.</p>'),
'',
unistr('<p>Ele pode fazer refer\00EAncia a uma fun\00E7\00E3o do bloco de c\00F3digo PL/SQL an\00F4nimo, uma fun\00E7\00E3o de pacote ou uma fun\00E7\00E3o stand-alone no banco de dados. Por exemplo: <code>invalid_session_basic_auth</code></p>'),
'',
unistr('<p>Ao fazer refer\00EAncia a uma fun\00E7\00E3o de pacote PL/SQL do banco de dados ou fun\00E7\00E3o stand-alone, voc\00EA pode usar a string de substitui\00E7\00E3o <code>#OWNER#</code> para fazer refer\00EAncia ao esquema de parse do aplicativo atual. Por exemplo: <code>#OWNER#.inval')
||'id_session_basic_auth</code></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Nome da Fun\00E7\00E3o de Autentica\00E7\00E3o')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o seguinte c\00F3digo na \00E1rea de texto ''C\00F3digo PL/SQL''</p>'),
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
unistr('<p>e <code>my_authentication</code> como ''Fun\00E7\00E3o de Autentica\00E7\00E3o''.')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o nome da fun\00E7\00E3o que verificar\00E1 o nome e a senha do usu\00E1rio, depois que eles forem informados em uma p\00E1gina de log-in.'),
unistr('Se voc\00EA n\00E3o informar nada, qualquer nome de usu\00E1rio/senha ser\00E1 bem-sucedido.'),
unistr('A fun\00E7\00E3o pode ser definida na \00E1rea de texto "C\00F3digo PL/SQL" da autentica\00E7\00E3o, dentro de um pacote ou como fun\00E7\00E3o armazenada.</p>'),
'',
unistr('<p>Essa fun\00E7\00E3o deve retornar um booliano para o procedimento de log-in que a chama. Ela tem 2 par\00E2metros de entrada, ''p_username'' e ''p_password'', que podem ser usados para acessar os valores que um usu\00E1rio final informou na p\00E1gina de log-in.<p/>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Nome do Procedimento de P\00F3s-logout')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o seguinte c\00F3digo na \00E1rea de texto do ''C\00F3digo PL/SQL''</p>'),
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
unistr('<p>e <code>my_post_logout</code> como ''Procedimento de P\00F3s-Log-out''.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O nome do procedimento chamado ap\00F3s o usu\00E1rio final clicar no URL de log-out. Ele pode ser usado para log-in.'),
unistr('O procedimento pode ser definido na \00E1rea de texto "C\00F3digo PL/SQL" da autentica\00E7\00E3o, dentro de um pacote ou como uma fun\00E7\00E3o armazenada.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Ativar Atributos de Autentica\00E7\00E3o Legada')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Os atributos de autentica\00E7\00E3o adicionais tornam-se vis\00EDveis, se esta lista de sele\00E7\00F5es for definida como "Sim".'),
unistr('Eles s\00E3o muito relevantes para as autentica\00E7\00F5es personalizadas que foram obtidas de &PRODUCT_NAME. 4.0 e anteriores.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Nome do Aplicativo Parceiro SSO'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se voc\00EA for autenticado no SSO do Oracle Application Server e o aplicativo for um aplicativo parceiro registrado no SSO, informe exatamente o mesmo nome que voc\00EA usou ao registrar o aplicativo parceiro no SSO.'),
'',
unistr('Se voc\00EA estiver usando o Application Express como aplicativo parceiro registrado, deixe o campo em branco.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Host LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('O nome do host do seu servidor de diret\00F3rios LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Porta LDAP'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('O n\00FAmero da porta do seu host do diret\00F3rio LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Usar SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione se a SSL deve ser usada para fazer bind ao diret\00F3rio LDAP. Se a op\00E7\00E3o SSL com Autentica\00E7\00E3o for selecionada, uma wallet deve ser configurada para a inst\00E2ncia do Application Express.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4416)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4416)
,p_display_sequence=>20
,p_display_value=>unistr('SSL com Autentica\00E7\00E3o')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4416)
,p_display_sequence=>30
,p_display_value=>'Sem SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'String DN do LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Exact DN</dt>',
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
'  <dt>Non-Exact DN (Search Base)</dt>',
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('Informe o padr\00E3o usado para construir a string de nome distinto (DN) totalmente qualificado para DBMS_LDAP.SIMPLE_BIND_S se usar o DN exato ou a base de pesquisa se usar o DN n\00E3o exato. Use <strong>%LDAP_USER%</strong> como um marcador de espa\00E7o para')
||unistr(' o nome do usu\00E1rio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Usar Nome Distinto (DN) Exato'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Selecione se a String do Nome Distinto (DN) do LDAP \00E9 exata ou n\00E3o exata. Se for n\00E3o exata, o Nome Distinto (DN) ser\00E1 a base de pesquisa e voc\00EA dever\00E1 fornecer um Filtro de Pesquisa.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Filtro de Pesquisa'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('Informe o filtro de pesquisa quando n\00E3o estiver usando o nome distinto (DN) exato. Use <code>%LDAP_USER%</code> como um marcador de espa\00E7o do nome de usu\00E1rio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Fun\00E7\00E3o de Edi\00E7\00E3o do Nome do Usu\00E1rio LDAP')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O seguinte c\00F3digo chama uma fun\00E7\00E3o que substitui todos os "."''s por "_"''s na string de DN:</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('Voc\00EA pode fornecer c\00F3digos adicionais a serem executados para transformar o nome do usu\00E1rio em um formato perfeitamente adequado \00E0 entrada do diret\00F3rio LDAP ou para o nome do usu\00E1rio LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4416)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Escape do Nome do Usu\00E1rio')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Antes de substituir <code><strong>%LDAP_USER%</strong></code> no nome distinto de LDAP e na string de pesquisa,',
unistr('o &PRODUCT_NAME. pode criar escape de caracteres especiais automaticamente no nome do usu\00E1rio.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Padr\00E3o')
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Cria escape de caracteres especiais com base em RFC 4514 (para nomes distintos) e RFC 4515 (para strings de pesquisa).',
unistr('Al\00E9m disso, cria escape de caracteres unicode.'),
unistr('Esta \00E9 a defini\00E7\00E3o mais segura, mas pode causar problemas com alguns servidores LDAP.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4416)
,p_display_sequence=>20
,p_display_value=>'Somente caracteres especiais'
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Cria escape de caracteres especiais com base em RFC 4514 (para nomes distintos) e RFC 4515 (para strings de pesquisa).',
unistr('N\00E3o cria escape de caracteres unicode.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4416)
,p_display_sequence=>30
,p_display_value=>'Sem Escape'
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o cria escape de caracteres. Essa defini\00E7\00E3o n\00E3o \00E9 segura,'),
unistr('a menos que seja utilizada uma <strong>Fun\00E7\00E3o de Edi\00E7\00E3o do Nome do Usu\00E1rio</strong> que j\00E1'),
unistr('crie escape do nome do usu\00E1rio (por exemplo com <code>apex_escape.ldap_dn</code> ou <code>apex_escape.ldap_search_filter</code>).')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('Executar C\00F3digo')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Processo para executar o c\00F3digo PL/SQL.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('Fechar Caixa de Di\00E1logo')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Processo para fechar a p\00E1gina da caixa de di\00E1logo modal ou n\00E3o modal atual.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4416)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Itens para Retorno '
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome de um ou mais itens de p\00E1gina a serem retornados pelo di\00E1logo. No caso de v\00E1rios itens, separe cada nome de item com uma v\00EDrgula.</p>'),
unistr('<p>Voc\00EA pode acessar os valores de itens retornados definindo uma A\00E7\00E3o Din\00E2mica para acionar no evento <strong>Di\00E1logo Fechado</strong> do elemento que abre o di\00E1logo, como uma a\00E7\00E3o de <strong>Definir Valor</strong> e um <em>Tipo de Conjunto</em> de ')
||unistr('<strong>Item de Retorno do Di\00E1logo</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('Limpar Estado da Sess\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Processo para limpar o estado da sess\00E3o armazenada no &PRODUCT_NAME.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4416)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione o tipo de estado da sess\00E3o a ser removido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_display_sequence=>1
,p_display_value=>unistr('Limpar todos os Itens da P\00E1gina Atual')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_display_sequence=>3
,p_display_value=>unistr('Limpar Todos os Itens da(s) P\00E1gina(s)')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_display_sequence=>5
,p_display_value=>'Limpar Itens'
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_display_sequence=>7
,p_display_value=>unistr('Limpar Sess\00E3o Atual')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_display_sequence=>9
,p_display_value=>'Limpar Aplicativo Atual'
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_display_sequence=>10
,p_display_value=>'Limpar Aplicativos'
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4416)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Aplicativo(s)'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('Informe uma lista de IDs de aplicativo separada por v\00EDrgulas, como <code>100,101,105</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4416)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Item(ns)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('Selecione itens de p\00E1gina a serem removidos do estado da sess\00E3o, como <code>P1_EMPNO,P1_ENAME</code>. Para v\00E1rios itens, separe o nome de cada item com uma v\00EDrgula. Voc\00EA pode digitar o nome ou selecionar na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4416)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('P\00E1gina(s)')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('Informa uma lista de n\00FAmeros de p\00E1ginas separada por v\00EDrgula, como <code>1,2,5</code>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('Redefinir Pagina\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo para redefinir a pagina\00E7\00E3o de relat\00F3rios na p\00E1gina atual.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4416)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Destino'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione se a pagina\00E7\00E3o de todas as p\00E1ginas, algumas p\00E1ginas ou na p\00E1gina atual deve ser redefinida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Esta P\00E1gina')
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4416)
,p_display_sequence=>20
,p_display_value=>unistr('P\00E1gina(s)')
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Todas as P\00E1ginas')
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4416)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('P\00E1gina(s)')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('Informe uma lista de n\00FAmeros de p\00E1ginas separada por v\00EDrgula.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>'Form Tabular - Adicionar Linhas'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processo para adicionar uma linha em uma regi\00E3o de Form Tabular.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4416)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Linhas')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>unistr('Informe o n\00FAmero de linhas.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('Form Tabular - Atualiza\00E7\00E3o de V\00E1rias Linhas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processo para atualizar v\00E1rias linhas de uma regi\00E3o de Form Tabular. Este processo tamb\00E9m inserir\00E1 registros adicionados \00E0 regi\00E3o.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4416)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4416)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4416)
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4416)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4416)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria. Para tabelas com chaves prim\00E1rias com mais de duas partes, selecione<strong>ROWID</strong>.</p>'),
unistr('<p>A chave prim\00E1ria \00E9 usada para identificar linhas a serem atualizadas e n\00E3o pode ser editada no form tabular. Para novas linhas, o valor da chave prim\00E1ria deve ficar vazio.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4416)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Coluna de Chave Secund\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da segunda chave prim\00E1ria. Este atributo s\00F3 deve ser preenchido se a sua chave prim\00E1ria for composta por duas colunas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4416)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Cl\00E1usula Where de Runtime')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limite os departamentos usando:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Informe a cl\00E1usula SQL WHERE a ser anexada a todas as instru\00E7\00F5es INSERT e UPDATE geradas. Use este atributo para limitar os registros usados nas chamadas SQL geradas automaticamente.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>unistr('Extra\00E7\00E3o Autom\00E1tica de Linhas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processo para recuperar registros de uma tabela ou view de um \00FAnico banco de dados. Este processo \00E9 usado para preencher itens de form com uma origem de Tipo <strong>Coluna Banco de dados</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4416)
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Item da Chave Prim\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o valor da coluna da chave prim\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria ')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria. Para tabelas com chaves prim\00E1rias com mais de duas partes, selecione <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Item da Chave Secund\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o valor da coluna da segunda chave prim\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('Coluna de Chave Secund\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4416)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da segunda chave prim\00E1ria. Este atributo s\00F3 deve ser preenchido se a sua chave prim\00E1ria for composta por duas colunas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Coluna de Vers\00E3o da Linha')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4416)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que identifica a vers\00E3o da linha. Esta coluna n\00E3o precisa estar presente na p\00E1gina. Deixe esse atributo em branco para usar a checksum incorporada.</p>'),
unistr('<p>O bloqueio oportuno utiliza a detec\00E7\00E3o de atualiza\00E7\00E3o perdida para garantir a integridade dos dados em aplicativos em que os dados podem ser acessados simultaneamente. O &PRODUCT_NAME. pode usar uma checksum incorporada para executar a detec\00E7\00E3o de')
||unistr(' atualiza\00E7\00E3o perdida e determinar a vers\00E3o da linha. A checksum \00E9 uma fun\00E7\00E3o hash de todos os valores da coluna para a linha da tabela espec\00EDfica. Ela \00E9 recuperada quando o registro \00E9 consultado no banco de dados e, depois, comparado ao hash do regis')
||unistr('tro atual no banco de dados como parte do <em>Processamento Autom\00E1tico de Linhas</em>. Se os dois valores forem iguais, a atualiza\00E7\00E3o prosseguir\00E1, caso contr\00E1rio, um erro ser\00E1 gerado pelo Processamento Autom\00E1tico de Linhas.</p>'),
unistr('<p>Este atributo permite especificar uma \00FAnica coluna que cont\00E9m a vers\00E3o da linha, como uma alternativa ao uso do processamento de checksum incorporado. Esta coluna deve ser atualizada sempre que um registro no banco de dados for atualizado. A Oracl')
||unistr('e recomenda implementar um trigger de banco de dados "Antes da Atualiza\00E7\00E3o" na tabela a ser incrementada ou atualizar a coluna da vers\00E3o da linha. Presume-se que as colunas N\00DAMERO contenham um n\00FAmero de sequ\00EAncia para a linha. No entanto, as colunas ')
||unistr('DATA e TIMESTAMP tamb\00E9m podem ser usadas. A vantagem de usar uma \00FAnica coluna \00E9 que o mecanismo do &PRODUCT_NAME. n\00E3o precisa executar o hash da linha completa, em vez disso, ele pode apenas comparar um \00FAnico valor de linha.</p>'),
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Cl\00E1usula Where de Runtime')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limite os departamentos usando:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Informe a cl\00E1usula SQL WHERE a ser anexada a todas a instru\00E7\00E3o SELECT gerada. Use este atributo para limitar os registros usados nas chamadas SQL geradas automaticamente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4416)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Modo de Extra\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Esta op\00E7\00E3o existe somente para compatibilidade com vers\00F5es anteriores.'),
unistr('As novos aplicativos devem sempre deixar essa defini\00E7\00E3o vazia.'),
unistr('A op\00E7\00E3o "Definir Cache de Mem\00F3ria na Exibi\00E7\00E3o" \00E9 obsoleta e n\00E3o \00E9 utilizada em processo gerados com esta release do &PRODUCT_NAME..'),
'</p>',
'<p>',
unistr('Quando um processo Extra\00E7\00E3o Automatizada de Linhas seleciona uma linha, os itens de p\00E1gina correspondentes s\00E3o definidos para os valores de coluna extra\00EDdos. A defini\00E7\00E3o do Modo de Extra\00E7\00E3o DML determina quando isso ocorre. O modo padr\00E3o \00E9 atualizado')
||unistr(' no estado de sess\00E3o da mem\00F3ria imediatamente quando a linha \00E9 extra\00EDda. O modo ''Definir Cache de Mem\00F3ria na Exibi\00E7\00E3o'' atualiza este estado de sess\00E3o somente quando (e se) o item for renderizado. Se voc\00EA precisar fazer refer\00EAncia ao valor extra\00EDdo do')
||unistr(' item usando a vari\00E1vel ou a sintaxe de bind <code>v(''ITEM_NAME'')</code> entre o momento da extra\00E7\00E3o da linha e o momento da renderiza\00E7\00E3o do item, use o modo de extra\00E7\00E3o padr\00E3o. Ao criar um novo processo Extra\00E7\00E3o Autom\00E1tica de Linhas, o modo de extra')
||unistr('\00E7\00E3o \00E9 definido para esse modo padr\00E3o. A menos que a l\00F3gica da sua p\00E1gina dependa do comportamento ''Ao Exibir'', sugerimos que voc\00EA atualize este processo para usar o comportamento padr\00E3o, a fim de obter o m\00E1ximo de flexibilidade para referenciar valor')
||unistr('es de coluna extra\00EDdos durante a renderiza\00E7\00E3o da p\00E1gina.'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Definir Cache da Mem\00F3ria na Exibi\00E7\00E3o [Obsoleto]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>unistr('Servi\00E7o Web')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo para consumir o Web service especificado.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4416)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Opera\00E7\00E3o do Web Service')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('Selecione uma Opera\00E7\00E3o do Web Service.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4416)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Armazenar Resultado em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4416)
,p_display_sequence=>10
,p_display_value=>'Item(ns)'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Cole\00E7\00E3o')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4416)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome de Coleta'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>unistr('Pagina\00E7\00E3o de Form')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Processo para recuperar o registro anterior ou posterior de uma tabela ou view do banco de dados. Esse processo pode ser usado para fornecer pagina\00E7\00E3o nas p\00E1ginas do Form, assim, os usu\00E1rios finais podem recuperar o registro anterior e o posterior')
||unistr(' sem navegar novamente at\00E9 um relat\00F3rio.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Se o form permitir que dados sejam atualizados, geralmente, voc\00EA dever\00E1 verificar se o processamento de form apropriado \00E9 realizado antes da execu\00E7\00E3o desse processo de pagina\00E7\00E3o. Caso contr\00E1rio, as atualiza\00E7\00F5es feitas pelo usu\00E1rio ')
||unistr('final ser\00E3o perdidas quando eles navegarem para outro registro.</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4416)
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Item da Chave Prim\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da chave prim\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria. Para tabelas com chaves prim\00E1rias com mais de duas partes, selecione <strong>ROWID>/strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('Item da Chave Secund\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da segunda chave prim\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Coluna de Chave Secund\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4416)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da segunda chave prim\00E1ria. Este atributo s\00F3 deve ser preenchido se a sua chave prim\00E1ria for composta por duas colunas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Coluna da Ordem de Navega\00E7\00E3o')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4416)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que cont\00E9m o valor da ordem de navega\00E7\00E3o.</p>'),
unistr('<p>Esta coluna \00E9 usada para determinar as linhas anteriores e posteriores. Portanto, uma coluna como <code>DISPLAY_SEQ</code> \00E9 uma coluna ideal para ser usada. Se desejar ordenar registros na sequ\00EAncia em que foram criados, voc\00EA poder\00E1 usar uma colu')
||unistr('na como <code>CREATED</code> ou <code>ID</code>, quando preenchidos a partir de uma sequ\00EAncia ou com base em uma coluna de Identidade do Oracle Database 12<em>c</em>. No entanto, voc\00EA tem a flexibilidade de ordenar registros em quaisquer duas colunas')
||', por exemplo <code>JOB</code> e <code>DEPTNO</code></p>',
unistr('<p><em>Observa\00E7\00E3o: As colunas de ordem de navega\00E7\00E3o devem corresponder \00E0s colunas padr\00E3o usadas para ordenar o relat\00F3rio do qual os usu\00E1rios finais de relat\00F3rio navegaram para chegar a este form. Como alternativa, voc\00EA deve certificar-se de que os us')
||unistr('u\00E1rios finais entenderam como as linhas anteriores e posteriores s\00E3o determinadas, por exemplo, utilizando labels de bot\00F5es ou texto de ajuda.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Coluna da Ordem de Navega\00E7\00E3o Secund\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da segunda ordem de navega\00E7\00E3o. Este atributo s\00F3 deve ser preenchido se a sua chave de navega\00E7\00E3o for composta por duas colunas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Item da Pr\00F3xima Chave Principal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da chave prim\00E1ria para o registro <em>pr\00F3ximo</em>. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Item da Chave Prim\00E1ria Anterior')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da chave prim\00E1ria para o registro <em>anterior</em>. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Item da Pr\00F3xima Chave Secund\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da segunda chave prim\00E1ria para o registro <eme>pr\00F3ximo</em>. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Item da Chave Secund\00E1ria Anterior')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da segunda chave prim\00E1ria para o registro <em>anterior</em>. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Item da Contagem de Linhas Atuais'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o item da p\00E1gina ou do aplicativo para armazenar o valor da contagem total de registros. Voc\00EA pode digitar o nome ou escolher na lista.</p>'),
unistr('<p>Se o seu conjunto de resultados contiver mais de 10.000 linhas, definir este item poder\00E1 diminuir o desempenho.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4416)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Cl\00E1usula Where de Runtime')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('Informe uma instru\00E7\00E3o SQL para restringir os registros retornados pela consulta.')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>'Web Service Legado'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Processo para consumir o Web service especificado. A Oracle recomenda atualizar esse processo para <strong>Web Service</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4416)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Refer\00EAncia de Web Services')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Insira o n\00FAmero de refer\00EAncia do Web service.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4416)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Armazenar Resultado em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4416)
,p_display_sequence=>10
,p_display_value=>'Item(ns)'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Cole\00E7\00E3o')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4416)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome de Coleta'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>unistr('\00C1rea de Texto')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma \00E1rea de texto com v\00E1rias linhas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4416)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Redimension\00E1vel')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o redimensionamento da \00E1rea de texto usando o mouse est\00E1 habilitado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4416)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Altura Autom\00E1tica')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se a altura da \00E1rea de texto varia de acordo com a quantidade de texto exibida. Use esta op\00E7\00E3o para dimensionar a \00E1rea de texto com a quantidade de dados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4416)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Contador de Caracteres'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se um contador ser\00E1 exibido abaixo da \00E1rea de texto. O contador exibe o n\00FAmero de caracteres digitados no campo e o total de caracteres permitido, como <code>123 de 4000</ code>. O atributo Tamanho M\00E1ximo dever\00E1 ser especificado quando es')
||unistr('sa op\00E7\00E3o estiver ativada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4416)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Remover Espa\00E7os')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como o valor do item \00E9 reduzido depois de submeter a p\00E1gina. Esta configura\00E7\00E3o remove espa\00E7os, tabula\00E7\00F5es e novas linhas do texto digitado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4416)
,p_display_sequence=>10
,p_display_value=>unistr('\00C0 Esquerda')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4416)
,p_display_sequence=>20
,p_display_value=>unistr('\00C0 Direita')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4416)
,p_display_sequence=>30
,p_display_value=>unistr('\00C0 Direita e \00E0 Esquerda')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4416)
,p_display_sequence=>40
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>unistr('Relat\00F3rio Cl\00E1ssico')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Relat\00F3rio simplificado com base em uma consulta SQL. Os Relat\00F3rios Cl\00E1ssicos s\00E3o semelhantes aos Relat\00F3rios Interativos, mas n\00E3o incluem as diversas op\00E7\00F5es de personaliza\00E7\00E3o dispon\00EDveis para o usu\00E1rio final nos Relat\00F3rios Interativos.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4416)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>'Form Tabular'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Exibe v\00E1rias linhas de dados em um layout de grade, no qual os usu\00E1rios finais podem atualizar valores diretamente em um elemento da grade.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4416)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4416)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>unistr('Relat\00F3rio Interativo')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Relat\00F3rio on-line abrangente baseado em uma Consulta SQL que fornece aos usu\00E1rios finais diversos recursos para personalizar o layout do relat\00F3rio no runtime. Voc\00EA pode controlar os recursos do usu\00E1rio final ativando ou desativando as diversas op\00E7')
||unistr('\00F5es de personaliza\00E7\00E3o de relat\00F3rio.</p>'),
unistr('<p> Voc\00EA pode definir um \00FAnico Relat\00F3rio Interativo e ter usu\00E1rios finais manipulando os dados exibidos para atender aos seus requisitos de relat\00F3rios espec\00EDficos, em vez de ter que desenvolver diversos relat\00F3rios semelhantes com diferentes crit\00E9rios')
||' para atender aos mesmos requisitos.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4416)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Estrutura do Menu de A\00E7\00F5es')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique se a estrutura do menu A\00E7\00F5es ser\00E1 consistente com o componente de Grade Interativa, ou se usar\00E1 a estrutura legada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4416)
,p_display_sequence=>10
,p_display_value=>'Legado'
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4416)
,p_display_sequence=>20
,p_display_value=>'Grade Interativa'
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4416)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>unistr('Conte\00FAdo Est\00E1tico')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Exibe o conte\00FAdo de texto ou um cont\00EAiner de regi\00E3o para itens de p\00E1gina. Para gerar a marca\00E7\00E3o HTML e o conte\00FAdo n\00E3o ter escape, defina <em>Formato do Relat\00F3rio</em> como <strong>HTML</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4416)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>'Expandir Atalhos'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('Especifique se o &PRODUCT_NAME. expandir\00E1 Atalhos no corpo HTML.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4416)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('Formato do Relat\00F3rio')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como o conte\00FAdo do texto ser\00E1 exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4416)
,p_display_sequence=>10
,p_display_value=>'Texto (caracteres especiais de escape)'
,p_return_value=>'TEXT'
,p_help_text=>unistr('O &PRODUCT_NAME. identifica caracteres HTML especiais, como <code>"<", ">", "&"</code>, ao emitir a origem da regi\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4416)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('O &PRODUCT_NAME. inclui marca\00E7\00E3o HTML ao emitir a origem da regi\00E3o. Isso pode tornar a regi\00E3o vulner\00E1vel a cross-site scripting.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4416)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Mostrar Quebras de Linha'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('Especifique se as quebras de linha na origem da regi\00E3o causar\00E3o quebras de linha na sa\00EDda da regi\00E3o.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4416)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4416)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('Conte\00FAdo Din\00E2mico PL/SQL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe a sa\00EDda HTML do c\00F3digo PL/SQL.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4416)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4416)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>unistr('Gr\00E1fico SVG')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Exibe dados em um gr\00E1fico SVG. Este tipo de regi\00E3o est\00E1 obsoleto. Utilize o tipo de regi\00E3o <em>Gr\00E1fico</em> para as novas regi\00F5es do gr\00E1fico. A Oracle recomenda que voc\00EA use <em>Fazer Upgrade do Aplicativo</em> para atualizar essas regi\00F5es para a reg')
||unistr('i\00E3o equivalente do Gr\00E1fico.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4416)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4416)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>unistr('Gr\00E1fico Simples')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Exibe dados em um gr\00E1fico HTML. Este tipo de regi\00E3o est\00E1 obsoleto. Utilize o tipo de regi\00E3o <em>Gr\00E1fico</em> para as novas regi\00F5es do gr\00E1fico. A Oracle recomenda que voc\00EA use <em>Fazer Upgrade do Aplicativo</em> para atualizar essas regi\00F5es para a re')
||unistr('gi\00E3o equivalente do Gr\00E1fico.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>unistr('\00C1rvore')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe os dados em uma estrutura hier\00E1rquica, com base nos relacionamentos pai-filho entre os registros.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>unistr('Ativar Link do N\00F3 com')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione a a\00E7\00E3o necess\00E1ria para ativar links do n\00F3 em sua \00E1rvore. Uma \00E1rvore pode ser usada principalmente para sele\00E7\00E3o/exibi\00E7\00E3o ou navega\00E7\00E3o. Se usada para sele\00E7\00E3o e navega\00E7\00E3o, recomendamos definir como Clique Duplo, de forma que um clique \00FAnico')
||unistr(' apenas selecionar\00E1 o n\00F3.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Clique \00DAnico')
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4416)
,p_display_sequence=>20
,p_display_value=>'Clique Duplo'
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('Item de P\00E1gina de N\00F3 Selecionado')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a p\00E1gina ou o item do aplicativo cujo valor de n\00F3 selecionado voc\00EA deseja manter. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.</p>'),
unistr('<p>Este item \00E9 usado para salvar o estado da \00E1rvore, retendo o valor do \00FAltimo n\00F3 selecionado. O valor do n\00F3 selecionado pode ser salvo para o item selecionado por meio do atributo de link do n\00F3 ou por meio de um processo de p\00E1gina. Quando a p\00E1gina \00E9')
||unistr(' recarregada, ela \00E9 aberta para o valor do n\00F3 selecionado.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>'Dica de ferramenta'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione se as dicas de ferramentas e suas origens ser\00E3o exibidas. Se uma dica de ferramenta for definida, ela ser\00E1 exibida quando o usu\00E1rio final focalizar ou passar o mouse sobre um r\00F3tulo do n\00F3 da \00E1rvore.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4416)
,p_display_sequence=>10
,p_display_value=>'Nenhum'
,p_return_value=>'N'
,p_help_text=>unistr('Nenhuma dica de ferramenta ser\00E1 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4416)
,p_display_sequence=>20
,p_display_value=>'Modelo Legado'
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('Use um valor de dica de ferramenta est\00E1tica com as seguintes substitui\00E7\00F5es de coluna de origem: #VALUE#, #TITLE#, #LINK# e #TOOLTIP#')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Express\00E3o HTML')
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('Forne\00E7a uma Express\00E3o HTML para usar como dica de ferramenta. As substitui\00E7\00F5es est\00E3o sendo executadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4416)
,p_display_sequence=>40
,p_display_value=>'Coluna do Banco de Dados'
,p_return_value=>'DB'
,p_help_text=>'Use o valor da <strong>Coluna de Dica de Ferramenta</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>'Valor da Dica de Ferramenta'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('Digite o texto exibido quando um usu\00E1rio final passar o ponteiro do mouse sobre um elemento da \00E1rvore.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>unistr('ID da \00C1rvore Est\00E1tica')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Um identificador exclusivo opcional da \00E1rvore.</p>'),
unistr('<p>\00C9 melhor fornecer \00E0 regi\00E3o um ID Est\00E1tico e usar a API apex.region("<i>static-id</i>").widget() para acessar o elemento da \00E1rvore.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>unistr('Classe CSS de Tipo de \00CDcone')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Uma classe CSS usada para especificar o tipo de \00EDcone usado para todos os n\00F3s. Esta classe \00E9 usada nas regras de CSS para especificar propriedades para todos os \00EDcones deste tipo. O tipo de \00EDcone junto com o valor da coluna do \00EDcone da origem da r')
||unistr('egi\00E3o determina o \00EDcone das classes de CSS usado para cada n\00F3.</p>'),
unistr('<p>Os valores comuns s\00E3o:</p>'),
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong> Isso permite o uso de um n\00FAmero pequeno de \00EDcones do APEX incorporados, como <code>icon-circle</code> ou <code>icon-tree-folder</code>.</li>'),
unistr('<li><strong><code>fa</code></strong> Permite usar os \00EDcones Fonte APEX ou Fonte Awesome. O Universal Theme torna uma dessas biblioteca de \00EDcones dispon\00EDveis.</li>'),
'</ul>',
unistr('<p>Se nenhum valor for fornecido, n\00E3o h\00E1 tipo de \00EDcone. A classe CSS do tipo de \00EDcone, se necess\00E1rio, pode ser inclu\00EDda na coluna do \00EDcone. Por exemplo, o valor da coluna do \00EDcone pode ser "fa fa-user".'),
unistr('Para uma \00E1rvore sem \00EDcones, defina os atributos Tipo de \00CDcone e \00CDcone Padr\00E3o como vazios e a coluna de origem da Consulta SQL deve ser nula.'),
unistr('Temas personalizados ou de terceiros podem ter sua pr\00F3pria fonte ou biblioteca de \00EDcones sprite de CSS e usar uma classe de tipo/prefixo de \00EDcones diferente que voc\00EA pode especificar aqui.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>unistr('Classe CSS de \00CDcones Padr\00E3o')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>Se o Tipo de \00CDcone for <code>fa</code> para Fonte APEX, voc\00EA pode usar valores como: <code>fa-user-circle-o</code>, <code>fa-file-o</code> ou <code>fa-arrow-circle-right</code>. Consulte o aplicativo Universal Theme para obter uma lista de todos o')
||unistr('s \00EDcones.</p>')
,p_help_text=>unistr('O \00EDcone padr\00E3o a ser usado quando a coluna do \00EDcone Consulta SQL for nula. O valor \00E9 um nome de classe CSS que especifica qual \00EDcone ser\00E1 visto. Os valores poss\00EDveis dependem do Tipo de \00CDcone.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>unistr('Coluna do Label do N\00F3')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor do label do n\00F3. O valor n\00E3o pode conter marca\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('Coluna de N\00EDvel da Hierarquia')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para o n\00EDvel de hierarquia do n\00F3. Necess\00E1rio quando o atributo <strong>Hierarquia</strong> est\00E1 definido como <strong>N\00E3o Calculado</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>unistr('Coluna de Classe CSS do \00CDcone')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para a classe CSS de \00EDcone a ser aplicada ao n\00F3.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>unistr('Coluna de ID do N\00F3')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o ID para um n\00F3. Isso \00E9 necess\00E1rio quando a hierarquia est\00E1 sendo calculada pelo Application Express. Em geral, uma coluna de chave prim\00E1ria \00E9 escolhida aqui.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('Coluna da Chave M\00E3e')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para a chave pai de um n\00F3. Necess\00E1rio quando o Application Express calcula a hierarquia.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>unistr('Coluna de Status do N\00F3')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para o status do n\00F3. Necess\00E1rio quando o atributo <strong>Hierarquia</strong> est\00E1 definido como <strong>N\00E3o Calculado</strong>. A coluna deve conter <strong>0</strong> para n\00F3s folha e <strong')
||unistr('>1</strong> para n\00F3s com filhos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('Iniciar \00C1rvore com')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Este atributo determina como a raiz da \00E1rvore \00E9 calculada. Os n\00F3s cuja coluna <strong>Chave Pai</strong> cont\00E9m o valor definido aqui ser\00E3o considerados como n\00F3s-raiz. V\00E1rias ra\00EDzes s\00E3o poss\00EDveis.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_display_sequence=>10
,p_display_value=>'Com Base no Item Existente'
,p_return_value=>'ITEM'
,p_help_text=>unistr('Use um valor de item para iniciar a \00E1rvore.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_display_sequence=>20
,p_display_value=>'Com Base na Consulta SQL'
,p_return_value=>'SQL'
,p_help_text=>unistr('Use o valor retornado por uma consulta SQL para iniciar a \00E1rvore.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Com Base no Valor Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('Use um valor est\00E1tico para iniciar a \00E1rvore.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_display_sequence=>40
,p_display_value=>unistr('O valor \00E9 NULL')
,p_return_value=>'NULL'
,p_help_text=>unistr('Use SQL NULL para iniciar a \00E1rvore.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('Escolha o item que cont\00E9m o valor com o qual a \00E1rvore ser\00E1 iniciada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('Especifique a Consulta SQL para determinar o valor com o qual a \00E1rvore ser\00E1 iniciada. A Consulta SQL est\00E1 sempre sendo executada no <em>banco de dados local</em> e deve retornar exatamente uma coluna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>unistr('Valor Est\00E1tico')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('Valor est\00E1tico com o qual a \00E1rvore ser\00E1 iniciada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>unistr('Coluna de Valor do N\00F3')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para o n\00F3 "valor". Esse valor n\00E3o \00E9 exibido, mas \00E9 adicionado \00E0 propriedade do id do n\00F3 do adaptador em \00E1rvore que pode ser acessada usando Javascript.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>'Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique o link a ser executado quando um n\00F3 for clicado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>'Coluna da Dica de ferramenta'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para a dica de ferramenta do n\00F3.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>'Hierarquia'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indique se o Application Express deve calcular a hierarquia de \00E1rvore com base nos dados ou se os dados j\00E1 cont\00EAm todas as informa\00E7\00F5es de hierarquia.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_display_sequence=>10
,p_display_value=>'Calculado com SQL'
,p_return_value=>'SQL'
,p_help_text=>unistr('A hierarquia \00E9 calculada usando a cl\00E1usula SQL START WITH CONNECT BY. \00C9 obrigat\00F3rio fornecer uma <strong>Coluna de Chave M\00E3e</strong>. S\00F3 use esta op\00E7\00E3o se sua consulta SQL <em>n\00E3o</em> contiver uma cl\00E1usula START WITH CONNECT BY.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00E3o Calculado')
,p_return_value=>'LEVEL'
,p_help_text=>unistr('Todas as informa\00E7\00F5es de hierarquia j\00E1 est\00E3o contidas nos dados. O mapeamento das colunas <strong>N\00EDvel de N\00F3</strong> e <strong>Status do N\00F3</strong> s\00E3o obrigat\00F3rias para esta op\00E7\00E3o. O <strong>N\00EDvel do N\00F3</strong> deve conter o n\00EDvel hier\00E1rquico com')
||unistr('o um valor num\00E9rico; o <strong>Status do N\00F3</strong> deve conter <strong>0</strong> para um n\00F3 folha e <strong>1</strong> para um n\00F3 n\00E3o folha.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>'Coluna do Link'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('Selecione a coluna da origem de dados que cont\00E9m o valor para o link a ser executado quando um n\00F3 for clicado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>unistr('Cl\00E1usula Order Siblings By')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('Selecione a coluna da origem de dados a ser usada para ordenar os filhos em um n\00F3 pai.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('fun\00E7\00E3o( op\00E7\00F5es ) {'),
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma fun\00E7\00E3o JavaScript que utiliza um objeto de op\00E7\00F5es para a \00C1rvore, modifique o objeto e retorne-o. Isso permite personaliza\00E7\00F5es avan\00E7adas da \00C1rvore durante a inicializa\00E7\00E3o do widget treeView. Consulte o widget treeView da documenta\00E7\00E3o da')
||unistr(' API de JavaScript para obter as op\00E7\00F5es dispon\00EDveis.<p>'),
unistr('<p>Op\00E7\00F5es adicionais definidas pela regi\00E3o da \00E1rvore:</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong> Usado para definir um nodeAdapter personalizado. \00C9 uma fun\00E7\00E3o que utiliza os mesmos argumentos de makeDefaultNodeAdapter e deve retornar uma interface treeNodeAdapter.</li>'),
unistr('<li><strong>initialSelectedNodeId</strong> O valor de um n\00F3 a ser selecionado. \00C9 definido de acordo com o atributo Item da P\00E1gina do N\00F3 Selecionado.</li>'),
unistr('<li><strong>nodeHasTooltip</strong> \00C9 definido de acordo com o atributo Dica de Ferramenta. \00C9 verdadeiro se o n\00F3 tiver uma dica de ferramenta, caso contr\00E1rio, \00E9 falso.</li>'),
unistr('<li><strong>regionStaticId</strong> Este \00E9 o id do elemento usado para esta regi\00E3o .</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Quando o atributo Hierarquia est\00E1 definido como Calculado com SQL</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>Especificar EMPNO para a Coluna de ID do N\00F3, MGR como atributos de Coluna de Chave M\00E3e</p>'),
'</dd>',
unistr('<dt>Quando o atributo Hierarquia est\00E1 definido como N\00E3o Calculado</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>Especifique STATUS para a Coluna de Status do N\00F3, N\00CDVEL para os atributos de Coluna de N\00EDvel de Hierarquia.</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4416)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4416)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('Altera\00E7\00E3o de Sele\00E7\00E3o')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>unistr('Calend\00E1rio')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe dados com base em entradas e uma variedade de views do calend\00E1rio.</p>'),
unistr('<p>Use <em>Calend\00E1rio</em> em vez desse tipo de regi\00E3o ao criar novas regi\00F5es. As regi\00F5es do Calend\00E1rio Cl\00E1ssico s\00E3o geralmente aquelas criadas no &PRODUCT_NAME. Release 4.2 ou anteriores.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4416)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4416)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>unistr('\00C1rvore Cl\00E1ssica')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe dados em uma estrutura hier\00E1rquica, com base nos relacionamentos pai-filho entre os registros.</p>'),
unistr('<p>Use <em>\00C1rvore</em> em vez desse tipos de regi\00E3o ao criar novas regi\00F5es. </p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4416)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('ID do Componente de \00C1rvore')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('Expandir \00C1rvore')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Expande o n\00F3 atual de uma regi\00E3o de \00E1rvore.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('Contrair \00C1rvore')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Contrai o n\00F3 atual de uma regi\00E3o de \00E1rvore.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>'Senha'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um elemento de form da senha HTML. Conforme o usu\00E1rio final insere o texto um ponto preto \00E9 exibido para esse caractere, em vez do caractere real especificado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4416)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Submeter ao pressionar Enter'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se pressionar a tecla <em>Enter</em> nesse campo submete a p\00E1gina automaticamente.')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>'Interromper e Iniciar Layout da Grade'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O item legado Usado para interromper a tabela HTML anterior e iniciar uma nova tabela HTML. Antes de o <em>Layout de Grade</em> ser introduzido no &PRODUCT_NAME. Release xx, esse tipo de item era amplamente usado para personalizar a exibi\00E7\00E3o dos i')
||unistr('tens da p\00E1gina.</p>'),
unistr('<p>A Oracle recomenda excluir esses tipos de itens legados e atualizar a op\00E7\00E3o <em>Iniciar Nova Grade</em> para <strong>Sim</strong> para o pr\00F3ximo item da p\00E1gina exibido nessa regi\00E3o. Isso \00E9 funcionalmente equivalente a usar um item Interromper e In')
||'iciar Layout da Grade.</p>'))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>'Atualizar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Dispara uma atualiza\00E7\00E3o dos elementos afetados. Nem todos os elementos suportam a a\00E7\00E3o de atualiza\00E7\00E3o. Voc\00EA pode usar essa a\00E7\00E3o para atualizar o conte\00FAdo de Relat\00F3rios Interativos, Relat\00F3rios Cl\00E1ssicos e todos os tipos de itens com suporte de LOV em ')
||'cascata.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>'Mostrar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Mostra os elementos afetados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4416)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar tudo na mesma linha'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se todos os itens e labels de p\00E1gina na mesma linha que os elementos afetados ser\00E3o mostrados.</p>'),
unistr('<p>Observa\00E7\00E3o: Este atributo n\00E3o funcionar\00E1 para itens de p\00E1ginas que n\00E3o usarem uma grade de tabela para exibir itens de form. Isso inclui qualquer p\00E1gina que use um modelo de p\00E1gina m\00F3vel.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>unistr('Vari\00E1vel de Cabe\00E7alho HTTP')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Autenticar externamente, em que o nome de usu\00E1rio \00E9 armazenado em um conjunto de vari\00E1veis de cabe\00E7alho HTTP pelo servidor Web.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4416)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nome da Vari\00E1vel de Cabe\00E7alho HTTP')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica o nome da vari\00E1vel de cabe\00E7alho HTTP que cont\00E9m o nome do usu\00E1rio. Se n\00E3o for especificada, ser\00E1 usado REMOTE_USER.</p>'),
'',
unistr('<p>A vari\00E1vel de cabe\00E7alho HTTP \00E9 definida pelo servidor Web.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4416)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('A\00E7\00E3o se o Nome de Usu\00E1rio Estiver Vazio')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica a a\00E7\00E3o a ser executada se o nome de usu\00E1rio armazenado na vari\00E1vel de cabe\00E7alho HTTP estiver vazio. As seguintes op\00E7\00F5es est\00E3o dispon\00EDveis:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Redirecionar para URL Incorporado</strong> para iniciar um log-in pelo servidor Web. Este URL Incorporado deve ser configurado para ser protegido pelo servidor Web, para for\00E7ar um log-in quando chamado. Ap\00F3s o log-in, o servidor Web dev')
||unistr('e armazenar o nome de usu\00E1rio validado na vari\00E1vel de cabe\00E7alho HTTP, para que esteja dispon\00EDvel para o esquema de autentica\00E7\00E3o. O URL Incorporado \00E9'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('O prefixo <code>/apex/</code> depende da configura\00E7\00E3o do servidor.'),
'</li>',
unistr('  <li><strong>Redirecionar para URL</strong> para iniciar um log-in em um servidor externo que, em seguida, define o nome de usu\00E1rio validado na vari\00E1vel de cabe\00E7alho HTTP. O servidor externo deve redirecionar de volta para o aplicativo usando o URL ')
||unistr('gerado pelo marcador <code>#CALLBACK#</code> para concluir a autentica\00E7\00E3o no aplicativo.</li>'),
unistr('  <li><strong>Exibir Erro</strong> exibir\00E1 a mensagem de erro especificada e e n\00E3o ocorrer\00E1 log-in no aplicativo.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4416)
,p_display_sequence=>10
,p_display_value=>'Redirecionar para URL Incorporado'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4416)
,p_display_sequence=>20
,p_display_value=>'Redirecionar para URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4416)
,p_display_sequence=>30
,p_display_value=>'Exibir Erro'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4416)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('Especifica o URL de um servidor de log-in externo que define o nome do usu\00E1rio validado na vari\00E1vel de cabe\00E7alho HTTP. O servidor externo deve redirecionar de volta para o aplicativo usando o URL gerado pelo marcador de espa\00E7o <code>#CALLBACK#</code>')
||unistr(' para concluir a autentica\00E7\00E3o no aplicativo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4416)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mensagem de Erro'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('Especifica a mensagem de erro a ser exibida se a vari\00E1vel de cabe\00E7alho HTTP n\00E3o contiver um valor ou n\00E3o existir.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4416)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Verificar Nome de Usu\00E1rio')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica a frequ\00EAncia de verifica\00E7\00E3o do nome de usu\00E1rio armazenado na vari\00E1vel de cabe\00E7alho HTTP. As seguintes op\00E7\00F5es est\00E3o dispon\00EDveis:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Cada Solicita\00E7\00E3o</strong> espera que a vari\00E1vel CGI seja sempre definida logo que o log-in seja feito pelo servidor Web. Se o nome de usu\00E1rio n\00E3o for id\00EAntico \00E0quele armazenado na sess\00E3o do &PRODUCT_NAME. atual, a sess\00E3o ser\00E1 invalidada')
||unistr(' e um novo log-in ser\00E1 iniciado. Esta \00E9 a op\00E7\00E3o mais segura, pois detecta log-outs ou altera\00E7\00F5es de nome de usu\00E1rio.'),
'  </li>',
unistr('  <li><strong>Ap\00F3s Log-in</strong> s\00F3 verifica e armazena o nome do usu\00E1rio na sess\00E3o &PRODUCT_NAME. ap\00F3s o servidor Web executar o log-in e chamar o callback para concluir a autentica\00E7\00E3o no aplicativo. Para o callback, consulte a configura\00E7\00E3o de "A\00E7')
||unistr('\00E3o se o Nome de Usu\00E1rio Estiver Vazio".'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Cada Solicita\00E7\00E3o')
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Ap\00F3s Log-in')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4416)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'URL de Log-out do Servidor de SSO'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Para o Oracle Access Manager baseado em SSO, informe, por exemplo:</p>',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se o esquema de autentica\00E7\00E3o for baseado no Oracle Access Manager ou em servidores semelhantes,'),
unistr('voc\00EA pode usar este atributo para especificar um URL para fazer log-out do servidor de sign-on \00FAnico central.</p>'),
'',
unistr('<p>O par\00E2metro de substitui\00E7\00E3o <code>%POST_LOGOUT_URL%</code> ser\00E1 substitu\00EDdo por um URL codificado para a p\00E1gina de log-in do seu aplicativo.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>unistr('Express\00E3o HTML')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um item que n\00E3o pode ser inserido com base em uma express\00E3o HTML.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4416)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Express\00E3o HTML')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Alterar as cores de fundo e do texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>Usar Cabe\00E7alho 2</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar uma classe din\00E2mica com base na consulta SQL</dt>'),
'    <dd><pre>&lt;span class="COLUMN_CLASS!ATTR&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    As substitui\00E7\00F5es <code>#COLUMN_CLASS#</code> e <code>#EMPLOYEE_STATUS#</code> deste exemplo s\00E3o colunas selecionadas na consulta SQL.</dd>'),
unistr('  <dt>Mostrar uma imagem e uma dica de ferramenta ao passar o mouse sobre a op\00E7\00E3o</dt>'),
'    <dd><pre>&lt;img src="IMAGE_NAME!ATTR title="EMPLOYEE"&gt;NAME!ATTR</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Especifique express\00F5es HTML a serem mostradas nesta coluna. Use a sintaxe <code>&amp;COLUMN.</code> para mostrar valores de coluna em HTML.')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>'Link'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe na forma de link um item que n\00E3o pode ser inserido.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>'Limpar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Limpa os elementos afetados.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>'Alerta'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma mensagem de alerta, com um \00FAnico bot\00E3o <em>Ok</em>. Use para exibir informa\00E7\00F5es que devem ser respondidas, ao pressionar o bot\00E3o, mas continue executando o evento.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4416)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Mensagem'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>N\00E3o foi poss\00EDvel excluir o funcion\00E1rio &amp;P1_ENAME. &lt;strong&gt;&lt;&#x2F;strong&gt;.</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite a mensagem a ser exibida na caixa de di\00E1logo de alerta.</p>'),
unistr('<p>As substitui\00E7\00F5es de item ser\00E3o executadas no cliente no momento em que a caixa de di\00E1logo for mostrada.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4416)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('T\00EDtulo')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>Opcionalmente, forne\00E7a um t\00EDtulo para a caixa de di\00E1logo.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4416)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Estilo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Padr\00E3o')
,p_help_text=>unistr('Especifique o estilo da caixa de di\00E1logo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Informa\00E7\00F5es')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4416)
,p_display_sequence=>20
,p_display_value=>'Perigo'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Advert\00EAncia')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4416)
,p_display_sequence=>40
,p_display_value=>'Sucesso'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4416)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\00CDcone')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Especifique um \00EDcone de caixa de di\00E1logo opcional.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4416)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Informe as classes CSS opcionais a serem aplicadas ao cont\00EAiner da caixa de di\00E1logo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4416)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Label OK'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Insira o label do bot\00E3o OK. Se nenhum for fornecido, o valor da mensagem de texto <code>APEX.DIALOG.OK</code> ser\00E1 usado.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>'Confirmar'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma caixa de di\00E1logo de confirma\00E7\00E3o, com os bot\00F5es Cancelar e Confirmar. Se o usu\00E1rio escolher <em>Cancelar</em>, as a\00E7\00F5es precedentes n\00E3o ser\00E3o executadas e o evento atual ser\00E1 cancelado.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Mensagem'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;Tem certeza&lt;&#x2F;strong&gt; de que deseja excluir o funcion\00E1rio &amp;P1_ENAME.?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite a mensagem a ser exibida na caixa de di\00E1logo de confirma\00E7\00E3o.</p>'),
unistr('<p>As substitui\00E7\00F5es de item ser\00E3o executadas no cliente no momento em que a caixa de di\00E1logo for mostrada.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('T\00EDtulo')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>Opcionalmente, forne\00E7a um t\00EDtulo para a caixa de di\00E1logo.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Estilo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Padr\00E3o')
,p_help_text=>unistr('Especifique o estilo da caixa de di\00E1logo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Informa\00E7\00F5es')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Advert\00EAncia')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4416)
,p_display_sequence=>30
,p_display_value=>'Perigo'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4416)
,p_display_sequence=>40
,p_display_value=>'Sucesso'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\00CDcone')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Especifique um \00EDcone de caixa de di\00E1logo opcional.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Informe as classes CSS opcionais a serem aplicadas ao cont\00EAiner da caixa de di\00E1logo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Confirmar Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Insira o label do bot\00E3o de confirma\00E7\00E3o. Se nenhum for fornecido, o valor da mensagem de texto <code>APEX.DIALOG.OK</code> ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4416)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Cancelar Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Insira o label do bot\00E3o Cancelar. Se nenhum for fornecido, o valor da mensagem de texto <code>APEX.DIALOG.CANCEL</code> ser\00E1 usado.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>'Fazer Parsing de Dados Submetidos a Upload'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processo para fazer parsing dos dados da planilha na prepara\00E7\00E3o para o carregamento para uma tabela existente. Esse tipo de processo \00E9 gerado pelo Assistente de Cria\00E7\00E3o de P\00E1gina para <em>Carga de Dados</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Defini\00E7\00E3o de Carga de Dados')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a Defini\00E7\00E3o de Carga de Dados, nos Componentes Compartilhados, que define a tabela a ser carregada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Importar de Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar a op\00E7\00E3o <em>Importar de</em> escolhida pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Item Separador'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto do <em>Separador</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Item Inclu\00EDdo Por')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto <em>Opcionalmente Inclu\00EDdo por</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Item da Primeira Linha'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o valor da caixa de sele\00E7\00E3o <em>A Primeira Linha tem Item de Nomes de Coluna</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Item de S\00EDmbolo da Moeda')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto <em>S\00EDmbolo da Moeda</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Item Separador de Grupo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto <em>Separador de Grupos</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Item de Caractere de Decimal'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto <em>Caractere Decimal</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Item de Nome de Arquivo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o valor <em>Nome do Arquivo</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Copiar e Colar Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto <em>Copiar e Colar Data Delimitada</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Item do Conjunto de Caracteres'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o <em>Conjunto de Caracteres do Arquivo</em> selecionado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4416)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Item do Formato de Data'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Informe o item de p\00E1gina para armazenar o texto do <em>Formato de Data</em> especificado pelo usu\00E1rio final. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>'Mapeamento de Coluna de Upload de Dados'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Mapeie as colunas da planilha submetidas a upload para as colunas da tabela. Esse tipo de regi\00E3o \00E9 gerado pelo Assistente Criar P\00E1gina do <em>Carregamento de Dados</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4416)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Defini\00E7\00E3o de Carga de Dados')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a Defini\00E7\00E3o de Carga de Dados definida no processo <em>Carga de Dados</em>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>'Preparar Dados Submetidos a Upload'
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processo para preparar dados da planilha para fazer upload para uma tabela existente. Este tipo de processo \00E9 gerado pelo Assistente de Cria\00E7\00E3o de P\00E1gina para <em> Carga de Dados </em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4416)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Defini\00E7\00E3o de Carga de Dados')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a Defini\00E7\00E3o de Carga de Dados, nos Componentes Compartilhados, que define a tabela a ser carregada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4416)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Item da Contagem de Erros'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o n\00FAmero de registros a serem inseridos. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4416)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atualizar Item da Contagem'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o n\00FAmero de registros a serem atualizados. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4416)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Item da Contagem de Erros'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o n\00FAmero de registros com erros. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4416)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Revisar Item de Contagem'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o n\00FAmero de registros revisados.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>'Carregar Dados Submetidos a Upload'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processo para carregar os dados da planilha submetidos a parse em uma tabela ou view existente. Esse tipo de processo \00E9 gerado pelo Assistente de Cria\00E7\00E3o de P\00E1gina para <em>Carga de Dados</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4416)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Defini\00E7\00E3o de Carga de Dados')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a Defini\00E7\00E3o de Carga de Dados, nos Componentes Compartilhados, que define a tabela a ser carregada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4416)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Item da Contagem de Erros'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item da p\00E1gina ou do aplicativo para armazenar o n\00FAmero de registros inseridos.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4416)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atualizar Item da Contagem'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item da p\00E1gina ou do aplicativo para armazenar o n\00FAmero de registros atualizados.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4416)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Item da Contagem de Erros'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o item da p\00E1gina ou do aplicativo para armazenar o n\00FAmero de registros com erros.'),
unistr(' Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4416)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Revisar Item de Contagem'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o n\00FAmero de registros revisados.'),
unistr('Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>'Contas do Application Express'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('	Informe seus nome de usu\00E1rio e senha da conta &PRODUCT_NAME. Cada espa\00E7o de trabalho tem seu pr\00F3prio reposit\00F3rio de contas de usu\00E1rios. O aplicativo no qual voc\00EA est\00E1 fazendo log-in pertence ao espa\00E7o de trabalho &amp;F4155_WORKSPACE_NAME. Lembre-se')
||unistr(' de que as senhas fazem distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas.</p>'),
''))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>'Credenciais de Acesso Livre'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permite que qualquer pessoa acesse seu aplicativo. Informe qualquer identificador que o identificar\00E1 como o usu\00E1rio do aplicativo durante esta sess\00E3o. Essa a\00E7\00E3o definir\00E1 o valor da vari\00E1vel APP_USER.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>'Contas de Banco de Dados'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Esse esquema de autentica\00E7\00E3o requer que o usu\00E1rio de um banco de dados (esquema) exista no banco de dados local. Ao usar esse m\00E9todo, o nome e a senha do usu\00E1rio da conta do banco de dados s\00E3o usados para autenticar o usu\00E1rio.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>unistr('Diret\00F3rio LDAP')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Autentica\00E7\00E3o de usu\00E1rio/senha com uma solicita\00E7\00E3o de autentica\00E7\00E3o a um servidor LDAP.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('O nome do host do seu servidor de diret\00F3rios LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Porta'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('O n\00FAmero da porta do host do diret\00F3rio LDAP. O padr\00E3o \00E9 389.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Usar SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione se a SSL deve ser usada para vincular ao diret\00F3rio LDAP. Se a op\00E7\00E3o SSL com Autentica\00E7\00E3o for selecionada, uma wallet deve ser configurada para a inst\00E2ncia &PRODUCT_NAME.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4416)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4416)
,p_display_sequence=>20
,p_display_value=>unistr('SSL com Autentica\00E7\00E3o')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4416)
,p_display_sequence=>30
,p_display_value=>'Sem SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'String de Nome Distinto (DN)'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o padr\00E3o usado para construir a string de nome distinto (DN) completo para DBMS_LDAP.SIMPLE_BIND_S, se estiver usando DN exato, ou a base de pesquisa, se estiver usando DN n\00E3o exato. Utilize <strong>%LDAP_USER%</strong> como marcador para o n')
||unistr('ome do usu\00E1rio. Por exemplo:'),
'<p>',
'<strong>DN Exato</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
unistr('<strong>DN N\00E3o-Exato (Base de Pesquisa)</strong>'),
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Usar Nome Distinto (DN) Exato'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione se a String do Nome Distinto (DN) do LDAP \00E9 exata ou n\00E3o exata. Se for n\00E3o exata, o Nome Distinto (DN) ser\00E1 a base de pesquisa e voc\00EA dever\00E1 fornecer um Filtro de Pesquisa.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Filtro de Pesquisa'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o filtro de pesquisa quando n\00E3o estiver usando um nome distinto (DN) exato. Use <strong>%LDAP_USER%</strong> como marcador para o nome do usu\00E1rio. Por exemplo:'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Fun\00E7\00E3o de Edi\00E7\00E3o do Nome do Usu\00E1rio LDAP')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Voc\00EA pode fornecer c\00F3digo adicional a ser executado para transformar o nome do usu\00E1rio em um formato perfeitamente adequado para a entrada do diret\00F3rio LDAP ou o nome do usu\00E1rio do LDAP.'),
unistr('A vari\00E1vel de bind :USERNAME cont\00E9m o nome que o usu\00E1rio final especificou.'),
unistr('Por exemplo, o c\00F3digo a seguir chama uma fun\00E7\00E3o que substitui todos os "."''s por "_"''s na string do DN:</p>'),
'',
'<p><pre>',
'retornar apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'<pre></p>',
'',
unistr('<p>&PRODUCT_NAME. far\00E1 escape do nome do usu\00E1rio retornado com base no atributo de autentica\00E7\00E3o <strong>Escape do Nome do Usu\00E1rio</strong>.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4416)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Escape do Nome do Usu\00E1rio')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Antes de substituir <strong>%LDAP_USER%</strong> no nome distinto de LDAP e na string de pesquisa,',
unistr('&PRODUCT_NAME. pode criar escape de caracteres especiais automaticamente no nome do usu\00E1rio.'),
'<p/>',
unistr('As poss\00EDveis regras para criar escape s\00E3o:'),
'<ul>',
unistr('<li><strong>Padr\00E3o</strong>:'),
'Os caracteres especiais de escape com base na RFC 4514 (para nomes distintos) e RFC 4515 (para strings de pesquisa).',
unistr('Al\00E9m disso, caracteres unicode de escape.'),
unistr('Esta \00E9 a defini\00E7\00E3o mais segura, mas pode causar problemas com alguns servidores LDAP.</li>'),
'<li><strong>Somente caracteres especiais</strong>:',
'Caracteres especiais de escape com base em RFC 4514 (para nomes distintos) e RFC 4515 (para strings de pesquisa).',
unistr('N\00E3o criar escape de caracteres unicode.</li>'),
'<li><strong>Sem escape</strong>:',
unistr('N\00E3o cria escape de caracteres.'),
unistr('Esta defini\00E7\00E3o n\00E3o \00E9 segura,'),
unistr('a menos que uma <strong>Fun\00E7\00E3o de Edi\00E7\00E3o do Nome do Usu\00E1rio</strong> seja utilizada, que j\00E1 crie escape do nome do usu\00E1rio (por exemplo com apex_escape.ldap_dn ou apex_escape.ldap_search_filter).</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Padr\00E3o')
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4416)
,p_display_sequence=>20
,p_display_value=>'Somente caracteres especiais'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4416)
,p_display_sequence=>30
,p_display_value=>'Sem Escape'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'SSO do Oracle Application Server'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Isso delega autentica\00E7\00E3o ao Servidor Oracle como SSO (Single Sign-On). Para usar esse esquema de autentica\00E7\00E3o, seu site deve ter sido registrado como aplicativo parceiro no servidor SSO.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4416)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nome do Aplicativo Parceiro'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se voc\00EA for autenticado no SSO do Oracle Application Server e o aplicativo for um aplicativo parceiro registrado no SSO, informe exatamente o mesmo nome que voc\00EA usou ao registrar o aplicativo parceiro no SSO.'),
'</p>',
'<p>',
unistr('Se voc\00EA estiver usando o &PRODUCT_NAME. como aplicativo parceiro registrado, deixe o campo em branco.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4416)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'URL de Log-out do Servidor de SSO'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Informe o caminho de log-out do Servidor de Sign-On \00DAnico, por exemplo'),
'<em>https://login.example.com/sso/logout</em>.',
unistr('No log-out do seu aplicativo, o &PRODUCT_NAME. usar\00E1 esse valor, concatenar\00E1 ''?p_done_url='' e o url de log-in do aplicativo e usar\00E1 o URL resultante para fazer log-out do Sign-on \00DAnico antes de redirecionar novamente para o aplicativo.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4416)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>unistr('Sem Autentica\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Adota o usu\00E1rio de banco de dados atual. Pode ser usada em combina\00E7\00E3o com uma configura\00E7\00E3o mod_plsql DAD que usa autentica\00E7\00E3o b\00E1sica para definir o usu\00E1rio da sess\00E3o do banco de dados.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4416)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nome do Usu\00E1rio')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('Digite o nome do usu\00E1rio para a sess\00E3o do &PRODUCT_NAME. Se essa op\00E7\00E3o ficar vazia, o &PRODUCT_NAME. usar\00E1 o usu\00E1rio da sess\00E3o do banco de dados (em geral, APEX_PUBLIC_USER).')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>unistr('Calend\00E1rio')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Data de exibi\00E7\00E3o baseada em entradas de diversas views de calend\00E1rio. Com a inclus\00E3o de uma data final, o calend\00E1rio pode exibir eventos baseados na dura\00E7\00E3o. Os calend\00E1rios tamb\00E9m podem atualizar registros diretamente se a op\00E7\00E3o "Arrastar e Soltar" e')
||'stiver habilitada.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Chave de API do Google Calendar [Obsoleta]'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Informe a chave de API do Google Calendar para permitir que os calend\00E1rios dessa aplicativo se integrem aos dados de calend\00E1rio do Google.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>'Coluna Data Inicial'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna que cont\00E9m a data de in\00EDcio dos eventos exibidos neste calend\00E1rio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Coluna de Data Final'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna que cont\00E9m a data de t\00E9rmino dos eventos exibidos neste calend\00E1rio. Se este atributo for especificado, a dura\00E7\00E3o do calend\00E1rio ser\00E1 exibida com base nos eventos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>unistr('Coluna de Exibi\00E7\00E3o')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o texto exibido dos eventos desse calend\00E1rio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria para eventos de calend\00E1rio. Se a tabela tiver uma chave prim\00E1ria com v\00E1rias partes, selecione <strong>ROWID</strong>.</p>'),
unistr('<p>O valor dessa coluna \00E9 retornado na vari\00E1vel de substitui\00E7\00E3o <code>APEX$PK_VALUE</code>. Utilize essa vari\00E1vel no atributo <em>Arrastar e Soltar C\00F3digo</em> para identificar o registro a ser atualizado, ap\00F3s a opera\00E7\00E3o de arrastar e soltar no cale')
||unistr('nd\00E1rio.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>'Link Exibir/Editar'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Informe uma p\00E1gina de destino a ser chamada quando o usu\00E1rio clicar em uma entrada existente.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Criar Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma p\00E1gina de destino a ser chamada quando o usu\00E1rio clicar em uma c\00E9lula vazia ou fora de uma entrada de calend\00E1rio existente.</p>'),
unistr('<p>Voc\00EA precisa usar as vari\00E1veis de substitui\00E7\00E3o de calend\00E1rio especiais <pre>&APEX$NEW_START_DATE.</pre> e <pre>&APEX$NEW_END_DATE.</pre> para transmitir as datas selecionadas do calend\00E1rio \00E0 p\00E1gina de destino.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>'Arrastar e Soltar'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se as opera\00E7\00F5es de arrastar e soltar s\00E3o permitidas neste calend\00E1rio.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Se as opera\00E7\00F5es de arrastar e soltar estiverem ativadas, qualquer usu\00E1rio final que tiver direitos para exibir este calend\00E1rio, tamb\00E9m ter\00E1 direitos e atualizar entradas do calend\00E1rio.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('Arrastar e Soltar C\00F3digo PL/SQL')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exemplo somente com Data de In\00EDcio (para eventos n\00E3o baseados na dura\00E7\00E3o)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>Exemplo com Datas de In\00EDcio e de T\00E9rmino. (para eventos baseados na dura\00E7\00E3o)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o c\00F3digo PL/SQL para atualizar as tabelas subjacentes ou as views atualiz\00E1veis quando uma entrada do calend\00E1rio for atualizada usando as opera\00E7\00F5es arrastar e soltar.</p>'),
unistr('<p>Se esse calend\00E1rio mostrar eventos baseados na dura\00E7\00E3o (selecionando uma coluna por Data de T\00E9rmino), o c\00F3digo PL/SQL tamb\00E9m precisar\00E1 atualizar esse valor. Se todo o evento for arrastado, a Data de T\00E9rmino manter\00E1 a dura\00E7\00E3o atual. Se o fim do eve')
||unistr('nto for arrastado, a dura\00E7\00E3o do evento ser\00E1 atualizada. Nesses casos a data de in\00EDcio permanecer\00E1 inalterada, mas a data de t\00E9rmino ser\00E1 atualizada para refletir a dura\00E7\00E3o revisada.</p>'),
unistr('<p>As vari\00E1veis de substitui\00E7\00E3o do calend\00E1rio incluem:</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>Retorna a data de in\00EDcio revisada. O formato da data \00E9 <code>''YYYYMMDDHH24MISS''</code> mesmo que o <em>Mostrar Hora</em> desse calend\00E1rio seja <strong>N\00E3o</strong>.</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>Retorna a data de t\00E9rmino revisada para eventos baseados na dura\00E7\00E3o. O formato da data \00E9 <code>''YYYYMMDDHH24MISS''</code> mesmo que o <em>Mostrar Hora</em> desse calend\00E1rio seja <strong>N\00E3o</strong>.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>Retorna o valor da coluna especificada na coluna de chave prim\00E1ria.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('Views de Calend\00E1rio Adicionais')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione quais views adicionais do calend\00E1rio ser\00E3o exibidas. A view de m\00EAs \00E9 sempre a padr\00E3o.</p>'),
unistr('<p>Observa\00E7\00E3o: As views Semanais e Di\00E1rias n\00E3o estar\00E3o dispon\00EDveis se a op\00E7\00E3o Mostrar Hora estiver especificada como <strong>N\00E3o</strong>.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4416)
,p_display_sequence=>40
,p_display_value=>'Lista'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4416)
,p_display_sequence=>50
,p_display_value=>unistr('Navega\00E7\00E3o')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Exportar'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Escolha os links de exporta\00E7\00E3o que ser\00E3o fornecidos na parte inferior do calend\00E1rio.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Isso exporta todas as entradas do calend\00E1rio atualmente exibidas, n\00E3o apenas uma \00FAnica entrada.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4416)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4416)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4416)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>unistr('Views e Navega\00E7\00E3o do Calend\00E1rio')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione quais views do calend\00E1rio ser\00E3o exibidas. Pelo menos uma entre <strong>Dia</strong>, <strong>Semana</strong> ou <strong>M\00EAs</strong> deve ser selecionada. Caso contr\00E1rio, o calend\00E1rio exibir\00E1 automaticamente a view de <strong>m\00EAs</strong')
||'>.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4416)
,p_display_sequence=>10
,p_display_value=>unistr('M\00EAs')
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4416)
,p_display_sequence=>20
,p_display_value=>'Semana'
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4416)
,p_display_sequence=>30
,p_display_value=>'Dia'
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4416)
,p_display_sequence=>35
,p_display_value=>'Lista'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Navega\00E7\00E3o')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'ID do Google Calendar'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>'<p>ID do Google Calendar: abc123@group.calendar.google.com</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o ID do Google Calendar para o feed de dados do calend\00E1rio que voc\00EA gostaria de exibir nesse calend\00E1rio.</p>'),
unistr('<p>Por causa da restri\00E7\00E3o de seguran\00E7a dos Google Calendars, esses calend\00E1rios devem ser p\00FAblicos ou estar dispon\00EDveis para todos os usu\00E1rios finais desse calend\00E1rio.</p>'),
unistr('<p><em>Observa\00E7\00E3o: A Chave de API do Google Calendar deve ser informada para que os calend\00E1rios do Google funcionem corretamente. V\00E1 para Componentes Compartilhados > Defini\00E7\00F5es de Componentes > Calend\00E1rio para definir a chave do aplicativo.</em</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>unistr('Mostrar Hor\00E1rio')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione se a parte do hor\00E1rio da data deve ser exibida. </p>'),
unistr('<p>As views Semana e Dia s\00F3 ser\00E3o exibidas quando Mostrar Hor\00E1rio estiver definido como <strong>Sim</strong>. Se as colunas de data inicial e final n\00E3o inclu\00EDrem componentes de hor\00E1rio, elas ser\00E3o mostradas como 12:00 am.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>'Classe CSS'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Criando o estilo do calend\00E1rio com base no status do projeto</p>'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione a coluna que cont\00E9m a Classe CSS para criar o estilo dos eventos exibidos nesse calend\00E1rio. <br>'),
unistr('H\00E1 v\00E1rias classes padr\00E3o dispon\00EDveis:'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('Consulte a documenta\00E7\00E3o sobre como adicionar mais classes CSS.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'REST Web service (JSON)'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o URL para um feed do Web Service RESTful a ser exibido neste calend\00E1rio. O calend\00E1rio pode renderizar dados JSON recuperados de origens externas, por exemplo o Oracle REST Data Services. Esses Web services devem ser p\00FAblicos ou estar disp')
||unistr('on\00EDveis para todos os usu\00E1rios finais deste calend\00E1rio.</p>'),
'<p>O feed de JSON deve ser formatado para incluir:</p>',
'<ol>',
'<li>A lista de array de eventos contendo - <code>itens</code></li>',
unistr('<li>Cada objeto de evento contendo - <code>{ id, t\00EDtulo, in\00EDcio, o dia todo, fim, descri\00E7\00E3o}</code><br>Os atributos t\00EDtulo e in\00EDcio s\00E3o obrigat\00F3rios.</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('Informa\00E7\00F5es Complementares')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique HTML adicional exibido na View de Lista e Dica de Ferramenta. Use a sintaxe &COLUMN. para mostrar valores de coluna em HTML. </p>',
unistr('<p>Observa\00E7\00E3o: Mostrar Dica de Ferramenta deve ser definido como <strong>Sim</strong> para que essas informa\00E7\00F5es complementares sejam exibidas nas views M\00EAs, Semana e Dia.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>'Mostrar Fim de Semana'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione se s\00E1bado e domingo ser\00E3o exibidos para este calend\00E1rio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>unistr('Formato de Hor\00E1rio')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Selecione o formato de hora usado para exibir a parte de tempo de um evento para este calend\00E1rio.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Padr\00E3o')
,p_return_value=>'00'
,p_help_text=>unistr('Utiliza o formato de timestamp do aplicativo especificado na Globaliza\00E7\00E3o. Se esse atributo n\00E3o for preenchido, ele usar\00E1 a defini\00E7\00E3o de NLS de banco de dados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4416)
,p_display_sequence=>20
,p_display_value=>'12 Horas'
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe a hora usando o rel\00F3gio de 12 horas, incluindo a.m. (do latim <em>ante meridiem</em>, que significa "antes do meio-dia") e p.m. (<em>p\00F3s meridiem</em>, "depois do meio-dia"), como 8:00 e 16:00.</p>'),
unistr('<p>O formato de exibi\00E7\00E3o real para a.m./p.m., como capitaliza\00E7\00E3o e pontos, \00E9 derivado do Formato de Timestamp.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4416)
,p_display_sequence=>30
,p_display_value=>'24 Horas'
,p_return_value=>'24'
,p_help_text=>unistr('Exibe o tempo usando o rel\00F3gio de 24 horas, como 08:00 e 16:00')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>'Mostrar Dica de Ferramentas'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione se uma dica de ferramenta \00E9 exibida quando os usu\00E1rios passam o mouse sobre um evento neste calend\00E1rio.</p>'),
unistr('<p><em>O di\00E1logo drop down exibir\00E1 o nome do evento, informa\00E7\00F5es complementares e detalhes de data.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>'Primeira Hora'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Informe um n\00FAmero inteiro entre 0 e 23 para especificar a primeira hora exibida nos calend\00E1rios de Semana e Dia.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('M\00E1ximo de Eventos/Dias')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o n\00FAmero m\00E1ximo de eventos exibidos para cada dia na view M\00EAs. </p>'),
unistr('<p>Se houver mais do que o n\00FAmero especificado de eventos em um dia espec\00EDfico, esse dia incluir\00E1  <strong>Mais ...</strong>. Clique neste item para exibir uma janela pop-up com todos os eventos desse dia espec\00EDfico.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('Eventos de V\00E1rias Linhas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione <strong>Sim</strong> para exibir os eventos em v\00E1rias linhas, com base no tamanho do texto da Coluna de Exibi\00E7\00E3o. </p>'),
unistr('<p>Selecione <strong>N\00E3o</strong> se voc\00EA desejar apenas que cada evento seja exibido em uma \00FAnica linha e truncar o texto que n\00E3o se ajusta \00E0 exibi\00E7\00E3o. O texto completo ser\00E1 exibido na dica de ferramenta.</p>'),
unistr('<p>Observa\00E7\00E3o: a defini\00E7\00E3o de eventos em v\00E1rias linhas s\00F3 \00E9 usada na view M\00EAs. Nas views Semanal e Di\00E1rio, a dura\00E7\00E3o do evento determina a altura do evento exibido.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>unistr('Vers\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>O FullCalendar 3 foi descontinuado e logo ser\00E1 substitu\00EDdo pelo FullCalendar 5. \00C9 recomend\00E1vel fazer essa troca agora, para n\00E3o correr o risco de seu aplicativo deixar de funcionar em futuras vers\00F5es. Se voc\00EA tiver usado qualquer C\00F3digo JavaScript')
||unistr(' de Inicializa\00E7\00E3o personalizado, observe que a API do FullCalendar foi alterada e seu c\00F3digo muito provavelmente ter\00E1 que ser ajustado.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4416)
,p_display_sequence=>10
,p_display_value=>'FullCalendar 3 [Obsoleto]'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
'    pOptions.titleFormat      = "[Conference Schedule]";                                // custom title',
'    pOptions.slotMinTime      = "07:00:00";                                             // hide slots before minTime',
'    pOptions.slotMaxTime      = "18:00:00";                                             // hide slots after maxTime',
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // week view column headings',
'    pOptions.slotDuration     = "00:15:00";                                             // custom slot duration',
'    pOptions.weekNumbers      = true;                                                   // show week numbers',
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('Insira uma fun\00E7\00E3o JavaScript para substituir os atributos de inicializa\00E7\00E3o padr\00E3o do FullCalendar. A fun\00E7\00E3o deve retornar um Objeto contendo os atributos de inicializa\00E7\00E3o do calend\00E1rio como par\00E2metros.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Criando o estilo do calend\00E1rio com base no status do projeto</p>,'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que cont\00E9m a Classe CSS para criar o estilo dos eventos exibidos nesse calend\00E1rio. '),
unistr('H\00E1 v\00E1rias classes padr\00E3o dispon\00EDveis:</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>Consulte a documenta\00E7\00E3o sobre como adicionar mais classes CSS.</p>')))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_name=>'apexcalendardateselect'
,p_display_name=>'Data selecionada'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_name=>'apexcalendareventselect'
,p_display_name=>'Evento selecionado'
);
end;
/
begin
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4416)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4416)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('Exibir altera\00E7\00F5es')
);
null;
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('Form Tabular - Exclus\00E3o de V\00E1rias Linhas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processo para excluir v\00E1rias linhas da regi\00E3o de um Form Tabular.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4416)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4416)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4416)
,p_help_text=>unistr('Informe o nome da tabela ou da view atualiz\00E1vel. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4416)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4416)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria. Para tabelas com chaves prim\00E1rias com mais de duas partes, selecione<strong>ROWID</strong>.</p>'),
unistr('<p>A chave prim\00E1ria \00E9 usada para identificar linhas a serem deletadas e n\00E3o pode ser editada no form tabular. Para novas linhas, o valor da chave prim\00E1ria deve ficar vazio.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4416)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Coluna de Chave Secund\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da segunda chave prim\00E1ria. Este atributo s\00F3 deve ser preenchido se a sua chave prim\00E1ria for composta por duas colunas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4416)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Cl\00E1usula Where de Runtime')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limite os departamentos usando:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Informe a cl\00E1usula SQL WHERE a ser anexada a todas a instru\00E7\00E3o DELETE gerada. Use este atributo para limitar os registros usados nas chamadas SQL geradas automaticamente.')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>unistr('Prefer\00EAncias do Usu\00E1rio')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Processo para definir as Prefer\00EAncias de Usu\00E1rio do usu\00E1rio final.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4416)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione um tipo de processo para redefinir ou definir as prefer\00EAncias de usu\00E1rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Redefinir Prefer\00EAncias (remove todas as prefer\00EAncias do usu\00E1rio atual)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4416)
,p_display_sequence=>20
,p_display_value=>'Definir como Valor de Item'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Definir como Valor de Item se N\00E3o Nulo')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4416)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Nome da Prefer\00EAncia')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('Informe um nome de prefer\00EAncia.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4416)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('Selecione um item de p\00E1gina ou do aplicativo que cont\00E9m o valor preferencial. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>unistr('Processamento Autom\00E1tico de Linhas (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Processo para inserir, atualizar ou excluir registros de uma tabela com um \00FAnico banco de dados ou view atualiz\00E1vel. Esse processo \00E9 usado para processar itens do form com uma origem de Tipo <strong>Coluna do Banco de Dados</strong>. Os atributos ins')
||unistr('eridos nesse processo devem estar correlacionados aos atributos inseridos no processo <em>Extra\00E7\00E3o Autom\00E1tica de Linhas</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4416)
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Item da Chave Prim\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da chave prim\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria ')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria. Para tabelas com chaves prim\00E1rias com mais de duas partes, selecione <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('Item da Chave Secund\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Informe o item da p\00E1gina ou do aplicativo que cont\00E9m o valor da coluna da chave secund\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('Coluna de Chave Secund\00E1ria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4416)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da segunda chave prim\00E1ria. Este atributo s\00F3 deve ser preenchido se a sua chave prim\00E1ria for composta por duas colunas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Coluna de Vers\00E3o da Linha')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione a coluna que identifica a vers\00E3o da linha. Essa coluna n\00E3o precisa estar presente na p\00E1gina. Deixe esse atributo em branco para usar a checksum incorporada.</p>'),
unistr('<p>O bloqueio oportunista utiliza a detec\00E7\00E3o de atualiza\00E7\00E3o perdida para garantir a integridade dos dados em aplicativos em que os dados podem ser acessados simultaneamente. O &PRODUCT_NAME. pode usar uma checksum incorporada para executar a detec\00E7\00E3o')
||unistr(' de atualiza\00E7\00E3o perdida e determinar a vers\00E3o da linha. A checksum \00E9 uma fun\00E7\00E3o hash de todos os valores de colunas da linha da tabela espec\00EDfica. Ela \00E9 recuperada quando o registro \00E9 consultado no banco de dados em <em>Extra\00E7\00E3o Automatizada de Linha')
||unistr('s</em>, e \00E9 comparada ao hash do registro atual no banco de dados como parte desse processo. Se dois valores forem iguais, a atualiza\00E7\00E3o prosseguir\00E1, do contr\00E1rio, esse processo gerar\00E1 um erro.</p>'),
unistr('<p>Esse atributo permite especificar uma \00FAnica coluna que cont\00E9m a vers\00E3o da linha, como alternativa ao uso do processamento de checksum incorporada. Essa coluna deve ser atualizada sempre que um registro do banco de dados for atualizado. A Oracle re')
||unistr('comenda implementar um trigger de banco de dados <em>Antes da Atualiza\00E7\00E3o</en> na tabela a ser incrementada ou atualizar a coluna da vers\00E3o da linha. Sup\00F5e-se que as colunas N\00DAMERO contenham uma sequ\00EAncia num\00E9rica da linha. No entanto, as colunas DAT')
||unistr('E e TIMESTAMP tamb\00E9m podem ser usadas. A vantagem de usar uma \00FAnica coluna \00E9 que o mecanismo do &PRODUCT_NAME. n\00E3o precisa executar o hash da linha completa, em vez disso, ele pode apenas comparar o valor de uma \00FAnica linha.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Cl\00E1usula Where de Runtime')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limite os departamentos:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Informe a cl\00E1usula SQL WHERE a ser anexada a todas as instru\00E7\00F5es INSERT, UPDATE e DELETE geradas. Use este atributo para limitar os registros usados nas chamadas SQL geradas automaticamente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Retornar Chave no Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o item da p\00E1gina ou do aplicativo para armazenar o valor da coluna da chave prim\00E1ria retornada de uma instru\00E7\00E3o SQL INSERT. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.</p>'),
unistr('<p>Especifique esta coluna para obter os campos de chave prim\00E1ria preenchidos por sequ\00EAncias ou triggers de banco de dados. Esse valor \00E9 definido no estado de sess\00E3o pelo processo. </p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Retornar Chave Secund\00E1ria no Item')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo para armazenar o valor da coluna da segunda chave prim\00E1ria retornada de uma instru\00E7\00E3o SQL INSERT. Voc\00EA pode digitar o nome ou escolher na lista de itens dispon\00EDveis.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Opera\00E7\00F5es Suportadas')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Verifique se as opera\00E7\00F5es de linguagem de manipula\00E7\00E3o de dados (DML) s\00E3o suportadas. Este processo de manipula\00E7\00E3o de dados executar\00E1 uma DML quando o valor da solicita\00E7\00E3o for um dos valores listados. Quando voc\00EA utiliza um bot\00E3o para submeter esta p\00E1')
||unistr('gina, o valor da solicita\00E7\00E3o \00E9 definido pelo bot\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4416)
,p_display_sequence=>10
,p_display_value=>'Inserir'
,p_return_value=>'I'
,p_help_text=>unistr('Acionado por Valores de Solicita\00E7\00E3o: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4416)
,p_display_sequence=>20
,p_display_value=>'Atualizar'
,p_return_value=>'U'
,p_help_text=>unistr('Acionado por Valores de Solicita\00E7\00E3o: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4416)
,p_display_sequence=>30
,p_display_value=>'Excluir'
,p_return_value=>'D'
,p_help_text=>unistr('Acionado por Valores de Solicita\00E7\00E3o: DELETE, REMOVE, DELETE ROW, DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4416)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>'Bloquear Linha'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Selecione se cada linha a ser atualizada ou exclu\00EDda ser\00E1 bloqueada na tabela subjacente antes do processamento da linha.</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>'Definir Foco'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Define o foco para os elementos afetados. Ser\00E1 padronizado como o 1\00BA. elemento afetado, se houver v\00E1rios. Isso pode ser especialmente \00FAtil quando usado em conjunto com as a\00E7\00F5es <em>Mostrar</em> e <em>Ativar</em> para encaminhar o usu\00E1rio diretamente ')
||'para o item apropriado.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>unistr('Submeter P\00E1gina')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Submete a p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4416)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nome da Solicita\00E7\00E3o / do Bot\00E3o')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Informe o valor da solicita\00E7\00E3o usado para submeter a p\00E1gina. Defina isso para o nome do bot\00E3o, se um bot\00E3o disparar a A\00E7\00E3o Din\00E2mica. Isso garante que o atributo <em>Executar Valida\00E7\00F5es</em> do bot\00E3o seja respeitado durante o processamento da p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4416)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostrar Processamento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se a p\00E1gina atual ficar\00E1 esmaecida e uma anima\00E7\00E3o de estilo "em processamento" ser\00E1 exibida durante a submiss\00E3o da p\00E1gina. Isso pode ser \00FAtil para impedir a a\00E7\00E3o do usu\00E1rio final durante opera\00E7\00F5es de longa execu\00E7\00E3o como, por exemplo, tent')
||unistr('ar clicar novamente no bot\00E3o de pesquisa quando o relat\00F3rio demorar para er atualizado.')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>unistr('Campo de N\00FAmero')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Exibe um campo de n\00FAmero. Esse tipo de item valida automaticamente que o valor \00E9 um n\00FAmero.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4416)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valor M\00EDnimo')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Digite o valor m\00EDnimo permitido. O valor pode ser um valor est\00E1tico ou um valor din\00E2mico usando uma sintaxe de substitui\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4416)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valor M\00E1ximo')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Digite o valor m\00E1ximo permitido. O valor pode ser um valor est\00E1tico ou um valor din\00E2mico usando uma sintaxe de substitui\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4416)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Alinhamento de N\00FAmero')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione o modo de alinhamento do n\00FAmero exibido. Esse defini\00E7\00E3o n\00E3o se aplica quando o item \00E9 renderizado como <em>Somente Leitura</em> ou quando <strong>Atributos de Elemento do Form HTML</strong> s\00E3o especificados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4416)
,p_display_sequence=>10
,p_display_value=>'Esquerda'
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4416)
,p_display_sequence=>20
,p_display_value=>'Centralizado'
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4416)
,p_display_sequence=>30
,p_display_value=>'Direita'
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>'Controle Deslizante'
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um tipo de item de controle deslizante, que permite aos usu\00E1rios atualizar o valor do item, deslizando o controle para a esquerda ou para a direita.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4416)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valor M\00EDnimo')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Digite o valor m\00EDnimo permitido. O valor pode ser um valor est\00E1tico ou um valor din\00E2mico usando uma sintaxe de substitui\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4416)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valor M\00E1ximo')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Digite o valor m\00E1ximo permitido. O valor pode ser um valor est\00E1tico ou um valor din\00E2mico usando uma sintaxe de substitui\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4416)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Incremento da Etapa'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('Informe um valor para for\00E7ar o controle deslizante a mudar para um incremento espec\00EDfico. O valor pode ser um valor est\00E1tico ou um valor din\00E2mico usando a sintaxe de substitui\00E7\00E3o.')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4416)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Destaque Selecionado'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o controle deslizante destacar\00E1 o rastreamento at\00E9 a posi\00E7\00E3o de handle do controle deslizante atual.')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>'Enviar E-mail'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Processo para enviar um e-mail e, opcionalmente, um ou mais anexos, a partir do aplicativo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'De'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('Digite o endere\00E7o de e-mail a ser exibido como o remetente do e-mail. Este endere\00E7o de e-mail deve ser um endere\00E7o v\00E1lido. Caso contr\00E1rio, a mensagem n\00E3o ser\00E1 enviada. Use a sintaxe de substitui\00E7\00E3o, se desejar usar um valor din\00E2mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Para'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Informe os destinat\00E1rios de e-mail, especificando um ou mais endere\00E7os de e-mail. Para v\00E1rios endere\00E7os de e-mail, use uma lista separada por v\00EDrgula. Use a sintaxe de substitui\00E7\00E3o, se desejar usar um valor din\00E2mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Informe os destinat\00E1rios de e-mail de c\00F3pia oculta, especificando um ou mais endere\00E7os de e-mail. Para v\00E1rios endere\00E7os de e-mail, use uma lista separada por v\00EDrgula. Use a sintaxe de substitui\00E7\00E3o, se desejar usar um valor din\00E2mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cco'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Informe os destinat\00E1rios de e-mail de c\00F3pia oculta, especificando um ou mais endere\00E7os de e-mail. Para v\00E1rios endere\00E7os de e-mail, use uma lista separada por v\00EDrgula. Use a sintaxe de substitui\00E7\00E3o, se desejar usar um valor din\00E2mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Responder Para'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Digite o endere\00E7o de e-mail ao qual a resposta deve ser enviada. Se n\00E3o for especificado o endere\00E7o de e-mail informado em <strong>De</strong> ser\00E1 usado. Use a sintaxe de substitui\00E7\00E3o, se quiser usar um valor din\00E2mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Assunto'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4416)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('Informe o assunto do e-mail. Use a sintaxe de substitui\00E7\00E3o, como <code>&amp;P6_PRODUCT_NAME.</code>, se voc\00EA desejar incluir um valor din\00E2mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>unistr('Texto Sem Formata\00E7\00E3o do Corpo')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o texto do e-mail. A vers\00E3o de texto sem formata\00E7\00E3o \00E9 usada se o cliente de e-mail recipient&#39 n\00E3o suportar a exibi\00E7\00E3o rich text. Use uma sintaxe de substitui\00E7\00E3o, <code>&amp;P6_PRODUCT_NAME.</code>, se quiser incluir conte\00FAdo din\00E2mico em')
||' seu texto.</p>',
unistr('<p><em>Observa\00E7\00E3o:A especifica\00E7\00E3o SMTP/MIME informa que nenhuma linha \00FAnica deve exceder 1000 caracteres. Para cumprir esta restri\00E7\00E3o, \00E9 necess\00E1rio adicionar um retorno de carro ou caracteres de alimenta\00E7\00E3o de linha para quebrar seu texto em partes d')
||unistr('e 1000 caracteres ou menos. Se voc\00EA n\00E3o fizer isso, ser\00E3o geradas mensagens de e-mail com erro, incluindo mensagens parciais ou mensagens com pontos de exclama\00E7\00E3o incorretos.</em></p>'),
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>'HTML do Corpo'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4416)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o texto que produz uma mensagem HTML em v\00E1rias partes, incluindo texto simples e conte\00FAdo HTML. As defini\00E7\00F5es e os recursos do cliente de e-mail do destinat\00E1rio determinar\00E3o o que ser\00E1 exibido. Embora a maioria dos clientes de e-mail modern')
||unistr('os possa ler um e-mail em formato HTML, lembre-se que alguns usu\00E1rios desativam essa funcionalidade para tratar problemas de seguran\00E7a. Use a sintaxe de substitui\00E7\00E3o, como <code>&amp;P6_PRODUCT_NAME.</code>, se desejar incluir conte\00FAdo din\00E2mico no te')
||'xto.</p>',
unistr('<p>Ao fazer refer\00EAncia a imagens usando a tag &lt;img /&gt;, lembre-se de que as imagens devem estar acess\00EDveis ao cliente de e-e-mail do destinat\00E1rio para que ele possa v\00EA-las. Por exemplo, suponha que voc\00EA fa\00E7a refer\00EAncia a uma imagem de sua rede c')
||'hamada hello.gif da seguinte forma:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>Neste exemplo, a imagem n\00E3o foi anexado ao e-mail, mas \00E9 referenciada pelo e-mail. Para o destinat\00E1rio v\00EA-la, ele deve poder acessar a imagem usando um Web browser. Se a imagem estiver dentro de um firewall e o destinat\00E1rio estiver fora do firewal')
||unistr('l, a imagem n\00E3o ser\00E1 exibida. Por esse motivo, evite usar imagens. Se for necess\00E1rio incluir imagens, inclua o atributo ALT para fornecer uma descri\00E7\00E3o textual caso a imagem n\00E3o esteja acess\00EDvel.</p>'),
unistr('<p><em>Observa\00E7\00E3o: A especifica\00E7\00E3o SMTP/MIME informa que nenhuma linha \00FAnica deve exceder 1000 caracteres. Para ficar em conformidade com essa restri\00E7\00E3o, adicione um retorno de linha ou caracteres de alimenta\00E7\00E3o de linha para quebrar seu texto em par')
||unistr('tes de 1000 caracteres ou menos. Se voc\00EA n\00E3o fizer isso, ser\00E3o geradas mensagens de e-mail com erro, incluindo mensagens parciais ou mensagens estranhas com pontos de exclama\00E7\00E3o.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'SQL do Anexo'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A instru\00E7\00E3o SQL deve estar no seguinte formato:</p>'),
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>As colunas mime_type e content_id s\00E3o opcionais. Se content_id estiver presente, o arquivo ser\00E1 anexado em linha e o valor de content_id ser\00E1 usado para o CID do anexo.</p>'),
unistr('<p>Se a coluna content_id contiver o valor ''my_inline_content'', essa imagem poder\00E1 ser incorporada no e-mail usando o seguinte HTML:</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Insira uma instru\00E7\00E3o SQL que retorne um ou mais BLOBs que sejam anexados ao e-mail na forma de arquivos.</p>'),
unistr('<p>Se a coluna content_id contiver um valor nulo, os arquivos associados ser\00E3o anexos regulares. Arquivos como documentos ou arquivos compactados zip em geral s\00E3o anexados dessa forma.</p>'),
unistr('<p>Se o valor de content_id n\00E3o for nulo, o arquivo associado ser\00E1 marcado como sendo anexado em linha. O valor da coluna content_id ser\00E1 usado como o CID (Content ID) do anexo. Esse valor de CID pode ser usado no c\00F3digo HTML do e-mail para incorpora')
||unistr('r imagens diretamente no conte\00FAdo do e-mail. Observe que alguns clientes de e-mail podem n\00E3o exibir automaticamente anexos em linha. Observe tamb\00E9m que os padr\00F5es de e-mail imp\00F5em v\00E1rios requisitos para o formato de identificadores de conte\00FAdo. O Ora')
||unistr('cle Application Express n\00E3o imp\00F5e a conformidade com esses padr\00F5es.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Enviar Imediatamente'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se este e-mail ser\00E1 enviado imediatamente. Tamb\00E9m ser\00E3o enviados todos os e-mails atualmente na tabela de fila de e-mail do &PRODUCT_NAME. Por padr\00E3o, o &PRODUCT_NAME. armazena as mensagens de e-mail n\00E3o enviadas em uma tabela e, periodic')
||'amente, os entrega para obter melhor desempenho do sistema.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>'Modelo de E-mail'
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Escolha um modelo de e-mail a ser usado.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>'Valores de Placeholder'
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Nomes de placeholder do modelo, juntamente com os valores, a serem substitu\00EDdos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4416)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>unistr('Substitui\00E7\00E3o de Idioma')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se um c\00F3digo de idioma for especificado, o processo pesquisar\00E1 o  modelo de uma tradu\00E7\00E3o de aplicativo para esse idioma. Se n\00E3o existir uma tradu\00E7\00E3o, o processo usar\00E1 o idioma principal do aplicativo. H\00E1 suporte para a sintaxe de substitui\00E7\00E3o.</p>'),
unistr('<p>H\00E1 suporte para a hierarquia de c\00F3digo de idioma. Se um valor "fr-ca" (Franc\00EAs - Canad\00E1) for especificado, mas s\00F3 existir uma tradu\00E7\00E3o para "fr" (franc\00EAs), \00E9 porque essa tradu\00E7\00E3o est\00E1 sendo usada.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>'Procura de Arquivo...'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um campo de texto com um bot\00E3o <em>Procurar...</em>. O bot\00E3o Procurar permite ao usu\00E1rio localizar e fazer upload de um arquivo a partir de um sistema de arquivos local.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Tipo de Armazenamento'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a tabela de banco de dados na qual o arquivo submetido a upload ser\00E1 armazenado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_display_sequence=>10
,p_display_value=>'A coluna BLOB especificada no atributo da Origem do Item'
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('Armazena o arquivo submetido a upload na tabela usada pelo processo <strong>Processamento Autom\00E1tico de Linhas (DML)</strong> e a coluna especificada no atributo de origem do item. A coluna deve ser do tipo de dados BLOB. Se o arquivo for submetido a')
||unistr(' download, o nome da tabela do processo <strong>Extra\00E7\00E3o Automatizada de Linhas</strong> ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_display_sequence=>20
,p_display_value=>'Tabela APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Armazena o(s) arquivo(s) submetido(s) a upload em um local tempor\00E1rio que voc\00EA pode acessar com a view APEX_APPLICATION_TEMP_FILES. O &PRODUCT_NAME. excluir\00E1 automaticamente o(s) arquivo(s) no final da sess\00E3o ou no final da solicita\00E7\00E3o de upload, ')
||unistr('dependendo de se voc\00EA optar por <strong>Expurgar Arquivo em</strong>.</p>'),
unistr('<p>Para acessar um arquivo se a op\00E7\00E3o <strong>Permitir V\00E1rios Arquivos</strong> estiver definida como <strong>N\00E3o</strong>:</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
unistr(' where name = :<em>nome do item de p\00E1gina</em>;'),
'</pre>',
unistr('<p>Para acessar arquivos se a op\00E7\00E3o <strong>Permitir V\00E1rios Arquivos</strong> estiver definida como <strong>Sim</strong>:</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
unistr('                        p_str => :<em>nome do item de p\00E1gina</em>,'),
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
'        -- add code here to store the uploaded file in your own table',
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_display_sequence=>30
,p_display_value=>'Tabela WWV_FLOW_FILES'
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Armazena o arquivo submetido a upload na tabela <code>WWV_FLOW_FILES</code> do &PRODUCT_NAME.</p>',
'<p>Para acessar o arquivo use:</p>',
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Tipo de Coluna MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAscula para armazenar o tipo mime do arquivo obtido por upload. O tipo mime \00E9 utilizado pelo browser para identificar o aplicativo usado para exibir o conte\00FAdo do BLOB quando o arquivo \00E9 obtido ')
||'por download.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>'Coluna do Nome de Arquivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o item da p\00E1gina ou do aplicativo usado para armazenar o nome do arquivo submetido a upload.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>'Coluna do Conjunto de Caracteres'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAsculas usado para armazenar o conjunto de caracteres do arquivo submetido a upload. O conjunto de caracteres do BLOB n\00E3o \00E9 definido automaticamente no upload. Os usu\00E1rios finais devem definir o')
||unistr(' conjunto de caracteres para o documento que est\00E3o submetendo a upload.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('Coluna da \00DAltima Atualiza\00E7\00E3o do BLOB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAscula usado para armazenar o timestamp atual, quando um arquivo \00E9 submetido a upload. Este valor de data \00E9 usado para armazenamento do browser no cache.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>'Exibir Link de Download'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Especifique se o link de download ser\00E1 exibido quando houver um BLOB n\00E3o vazio associado a este item.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>'Texto do Link de Download'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Informe o texto a ser exibido como parte do link de download. Se o texto n\00E3o for especificado, o texto armazenado na Mensagem de Texto para <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code>, nos Componentes Compartilhados, ser\00E1 exibido.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>unistr('Disposi\00E7\00E3o de Conte\00FAdo')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como o browser trata o conte\00FAdo ao fazer download.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Nem todo conte\00FAdo pode ser exibido em linha. O suporte para a exibi\00E7\00E3o de conte\00FAdo em linha depende se o tipo mime espec\00EDfico \00E9 suportado pelo navegador.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4416)
,p_display_sequence=>10
,p_display_value=>'Em Linha'
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4416)
,p_display_sequence=>20
,p_display_value=>'Anexo'
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Expurgar Arquivo em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Defina quando o &PRODUCT_NAME. deve remover o arquivo tempor\00E1rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Fim da Sess\00E3o')
,p_return_value=>'SESSION'
,p_help_text=>unistr('Exclui o arquivo no fim da sess\00E3o &PRODUCT_NAME. atual.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Final da Requisi\00E7\00E3o')
,p_return_value=>'REQUEST'
,p_help_text=>unistr('Exclui o arquivo no fim da solicita\00E7\00E3o HTTP atual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('Permitir V\00E1rios Arquivos')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se \00E9 poss\00EDvel fazer upload de v\00E1rios arquivos de uma vez.</p>'),
'',
unistr('<p>Observa\00E7\00E3o - V\00E1rios nomes de arquivo ser\00E3o armazenados na forma de lista delimitada por v\00EDrgulas no item de p\00E1gina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Tipos de Arquivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt>Indica que somente arquivos de imagem devem ser aceitos</dt>',
'<dd><pre>image/*</pre></dd>',
unistr('<dt>Indica que somente arquivos de imagem e v\00EDdeo devem ser aceitos</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
'<dt>Indica que somente arquivos de imagem PNG devem ser aceitos</dt>',
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('Especifique uma lista de tipos de arquivos, delimitados por v\00EDrgulas, que possa ser usada pelo browser para restringir os arquivos dos quais se pode fazer upload.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Exibir Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione um estilo de exibi\00E7\00E3o para a forma pela qual o item de navega\00E7\00E3o do arquivo dever\00E1 ser exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Navega\00E7\00E3o de Arquivo em Linha')
,p_return_value=>'INLINE'
,p_help_text=>unistr('Exibe o campo de entrada da navega\00E7\00E3o de arquivo de modo semelhante a outros campos de texto e itens na p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4416)
,p_display_sequence=>20
,p_display_value=>'Zona de Soltura em Linha'
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('Exibe o campo de entrada de navega\00E7\00E3o de arquivo como uma zona de soltura em linha que apresenta um t\00EDtulo e uma descri\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4416)
,p_display_sequence=>30
,p_display_value=>'Zona de Soltura em Blocos'
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('Exibe o campo de entrada de navega\00E7\00E3o de arquivo como uma zona de soltura no estilo de assistente que apresenta um t\00EDtulo, uma descri\00E7\00E3o e um bot\00E3o para selecionar arquivos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Navega\00E7\00E3o de Arquivo Nativa')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Use a formata\00E7\00E3o nativa do browser para exibir o item de navega\00E7\00E3o de arquivo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('T\00EDtulo da Zona de Soltura')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique o t\00EDtulo para a Zona de Soltura.'),
unistr('Se esse campo for deixado em branco, as Mensagens de Texto <code>APEX.ITEM.FILE.DROP_FILE</code> ou <code>APEX.ITEM.FILE.DROP_FILES</code> ser\00E3o usadas como padr\00E3o.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('Descri\00E7\00E3o da Zona de Soltura')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique o texto da descri\00E7\00E3o da Zona de Soltura.</p>'),
unistr('<p>Se esse campo for deixado em branco, as Mensagens de Texto a seguir ser\00E3o usadas como padr\00E3o, dependendo da propriedade Exibir como.</p>'),
'<p><strong>Zona de Soltura de Bloco</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
'<p><strong>Zona de Soltura em Linha</strong><br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4416)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Tamanho M\00E1ximo do Arquivo')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>unistr('Informe o tamanho m\00E1ximo do arquivo (em KB) que deve ser aceito para upload de arquivos por meio deste item.')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>'Gerenciador de Listas'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe um item de texto com uma lista popup de \00EDcones de valores, os bot\00F5es <em>Adicionar</em> e <em>Remover</em> e uma lista de valores selecionados.</p>'),
unistr('<p>Voc\00EA pode digitar o valor ou escolher na lista de itens dispon\00EDveis. Voc\00EA pode utilizar os bot\00F5es para gerenciar os valores selecionados. Os valores selecionados s\00E3o armazenados em uma \00FAnica string delimitada por dois pontos.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4416)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Extrair'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como os dados ser\00E3o exibidos quando o LOV Popup for aberto.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Nenhuma Extra\00E7\00E3o')
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4416)
,p_display_sequence=>20
,p_display_value=>'Extrair Primeiro Conjunto de Linhas'
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4416)
,p_display_sequence=>30
,p_display_value=>'Extrair Primeiro Conjunto de Linhas e Filtrar Valor Atual'
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4416)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Preservar Mai\00FAsculas/Min\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o valor permanecer\00E1 conforme informado ou se ser\00E1 convertido em mai\00FAsculas.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4416)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('Processamento Autom\00E1tico de Linhas Legadas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Processo para inserir, atualizar ou excluir registros de uma tabela com um \00FAnico banco de dados ou view atualiz\00E1vel. Esse processo \00E9 usado para processar itens do form com uma origem de Tipo <strong>Coluna do Banco de Dados</strong>. A Oracle recomen')
||unistr('da atualizar esse tipo de processo para <strong>Processamento Autom\00E1tico de Linhas (DML)</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4416)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione quais opera\00E7\00F5es DML (data manipulation language - linguagem de manipula\00E7\00E3o de dados) s\00E3o suportadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4416)
,p_display_sequence=>10
,p_display_value=>'Inserir'
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4416)
,p_display_sequence=>20
,p_display_value=>'Atualizar'
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4416)
,p_display_sequence=>30
,p_display_value=>'Excluir'
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4416)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Propriet\00E1rio da Tabela')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('Selecione o nome do propriet\00E1rio (esquema) da tabela.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4416)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nome da Tabela'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4416)
,p_help_text=>unistr('Informe o nome da tabela ou da view que faz distin\00E7\00E3o entre mai\00FAsculas e min\00FAsculas. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4416)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('Item da Chave Prim\00E1ria')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Informe a p\00E1gina ou o item do aplicativo que cont\00E9m o valor da coluna da chave prim\00E1ria. Voc\00EA pode digitar o nome ou escolher na lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4416)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('Coluna da Chave Prim\00E1ria ')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4416)
,p_help_text=>unistr('Selecione a coluna que cont\00E9m o valor da chave prim\00E1ria. Se a tabela tem uma chave prim\00E1ria com v\00E1rias partes, selecione <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4416)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Cl\00E1usula Where de Runtime')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limite o departamento:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Informe a cl\00E1usula SQL WHERE a ser anexada a todas as instru\00E7\00F5es SELECT, UPDATE e DELETE geradas. Use este atributo para limitar os registros usados nas chamadas SQL geradas automaticamente.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>'Cancelar Evento'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Cancela o evento atual.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>'Seletor de Data (jQuery)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe um campo de texto com um \00EDcone de calend\00E1rio. Os usu\00E1rios finais podem digitar a data diretamente no item de texto ou clicar no \00EDcone do calend\00E1rio para selecionar uma data, e, opcionalmente, um hor\00E1rio, no popup do calend\00E1rio.</p>'),
unistr('<p>O hor\00E1rio s\00F3 ser\00E1 exibido no popup do calend\00E1rio se a <em>M\00E1scara de Formato</em> desse item incluir componentes de hora.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Data Real\00E7ada')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o valor de data padr\00E3o a ser real\00E7ado quando o popup do calend\00E1rio for chamado. Se o valor n\00E3o for especificado, o calend\00E1rio real\00E7ar\00E1 a data e a hora atuais.</p>'),
unistr('<p>O valor pode ser um valor absoluto no formato <code>''YYYYMMDDHH24MI''</code>, um valor relativo referente \00E0 data de hoje, como <code>+7d</code> ou um valor din\00E2mico usando a sintaxe de substitui\00E7\00E3o, contato que a substitui\00E7\00E3o retorne o formato de d')
||'ata correto ou o valor relativo.</p>',
'<p>Os valores de data relativos incluem:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anos a partir da data de hoje</dd>',
'  <dt>m</dt>',
'    <dd>+ / - meses a partir da data de hoje</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir da data de hoje</dd>',
'  <dt>d</dt>',
'    <dd>+ / - dias a partir da data de hoje</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Data M\00EDnima')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a data m\00EDnima que pode ser informada ou selecionada.</p>'),
unistr('<p>O valor da data pode ser um valor absoluto no formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, um valor relativo referente \00E0 data de hoje, como <code>+7d</code> ou um valor din\00E2mico usando a sintaxe de substitui\00E7\00E3o, c')
||unistr('ontanto que a substitui\00E7\00E3o retorne o formato de data correto ou o valor relativo.</p>'),
'<p>Os valores de data relativos incluem:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anos a partir da data de hoje</dd>',
'  <dt>m</dt>',
'    <dd>+ / - meses a partir da data de hoje</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir da data de hoje</dd>',
'  <dt>d</dt>',
'    <dd>+ / - dias a partir da data de hoje</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Data M\00E1xima')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a data m\00E1xima que pode ser especificada ou selecionada.</p>'),
unistr('<p>O valor da data pode ser um valor absoluto no formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> ou <code>''YYYYMMDDHH24MI''</code>, um valor relativo referente \00E0 data de hoje, como <code>+7d</code> ou um valor din\00E2mico usando a sintaxe de substitui\00E7\00E3o, c')
||unistr('ontato que a substitui\00E7\00E3o retorne o formato de data correto ou o valor relativo.</p>'),
'<p>Os valores de data relativos incluem:</p>',
'<dl>',
'  <dt>y</dt>',
'    <dd>+ / - anos a partir da data de hoje</dd>',
'  <dt>m</dt>',
'    <dd>+ / - meses a partir da data de hoje</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir da data de hoje</dd>',
'  <dt>d</dt>',
'    <dd>+ / - dias a partir da data de hoje</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione quando o calend\00E1rio popup do seletor de data ser\00E1 exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4416)
,p_display_sequence=>10
,p_display_value=>'Em foco'
,p_return_value=>'focus'
,p_help_text=>unistr('O popup de calend\00E1rio \00E9 exibido assim que o item recebe foco.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Clique no \00EDcone')
,p_return_value=>'button'
,p_help_text=>unistr('O popup de calend\00E1rio \00E9 exibido quando o \00EDcone \00E9 clicado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4416)
,p_display_sequence=>30
,p_display_value=>'Ambos'
,p_return_value=>'both'
,p_help_text=>unistr('O popup de calend\00E1rio \00E9 exibido assim que o item recebe foco e subsequentemente quando o \00EDcone \00E9 clicado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4416)
,p_display_sequence=>40
,p_display_value=>'Em Linha'
,p_return_value=>'inline'
,p_help_text=>unistr('O calend\00E1rio sempre \00E9 exibido em linha na p\00E1gina. Nenhum campo de texto \00E9 exibido e a sele\00E7\00E3o de data atual \00E9 mostrada destacada no calend\00E1rio.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Mostrar outros Meses'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se as principais datas \00E0 esquerda do m\00EAs anterior e as datas \00E0 direita do pr\00F3ximo m\00EAs ser\00E3o exibidas. As datas \00E0 direita e \00E0 esquerda preenchem totalmente a primeira e a \00FAltima linha do calend\00E1rio. Por exemplo, se o primeiro dia da semana')
||unistr(' for domingo, e o primeiro dia do m\00EAs atual exibido cair em uma quarta-feira, ent\00E3o, domingo, segunda e ter\00E7a-feira mostrar\00E3o os \00FAltimos tr\00EAs dias do m\00EAs anterior.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('N\00FAmero de Meses')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
unistr('    <dd>Exibe tr\00EAs meses horizontalmente.</dd>'),
'  <dt>[2,3]</dt>',
unistr('    <dd>Exibe seis meses, duas linhas em tr\00EAs colunas.</dd>'),
'  <dt>[4,3]</dt>',
unistr('    <dd>Exibe doze meses, quatro linhas em tr\00EAs colunas.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe quantos meses ser\00E3o mostrados no popup do calend\00E1rio.</p>'),
unistr('<p>Voc\00EA pode informar um valor inteiro ou uma array bidimensional usando <code>[<em>row,column</em>]</code>, para definir o n\00FAmero de linhas e colunas a serem exibidos</p>'),
unistr('<p><em>Observa\00E7\00E3o: Meses ap\00F3s a <strong>Data Real\00E7ada</strong> ser\00E3o exibidos.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Lista de Navega\00E7\00E3o para')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione se as listas de sele\00E7\00E3o ser\00E3o fornecidos no popup do calend\00E1rio para o m\00EAs e/ou ano.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4416)
,p_display_sequence=>5
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4416)
,p_display_sequence=>10
,p_display_value=>unistr('M\00EAs')
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4416)
,p_display_sequence=>20
,p_display_value=>'Ano'
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4416)
,p_display_sequence=>30
,p_display_value=>unistr('M\00EAs e Ano')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4416)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Faixa de Anos'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
'    <dd>Usa anos absolutos para restringir anos permitidos para estar entre 2000 e 2010.</dd>',
'  <dt>-05:+05</dt>',
'    <dd>Usa datas relativas para limitar anos permitidos a +/- cinco anos a partir do ano atual.</dd>',
'  <dt>+01:+03</dt>',
unistr('    <dd>Usa datas relativas para limitar anos permitidos para o pr\00F3ximo ano por mais dois anos.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe um intervalo de anos permitidos mostrado na lista de sele\00E7\00E3o <strong>Ano</strong> no popup do calend\00E1rio.</p>'),
unistr('<p>O valor do ano pode ser um valor absoluto no formato <code>''YYYY:YYYY''</code> ou valores relativos, usando o formato <code>''-nn:+nn''</code>, no qual <code>nn</code> s\00E3o valores inteiros.')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>'Campo de Texto'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Exibe um campo de texto.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4416)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Submeter ao pressionar Enter'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se pressionar a tecla <em>Enter</em> nesse campo submete a p\00E1gina automaticamente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4416)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Desativado'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se este item ser\00E1 desativado, o que impedir\00E1 que os usu\00E1rios finais alterem seu valor.</p>'),
unistr('<p>Um item de texto desativado ainda \00E9 exibido com a mesma formata\00E7\00E3o HTML, diferentemente de um tipo de item <em>Somente Exibi\00E7\00E3o</em>, que remove a formata\00E7\00E3o HTML. Os itens de texto desativados fazem parte da origem da p\00E1gina, o que permite que se')
||unistr('us estados de sess\00E3o sejam avaliados. Por outro lado, os itens somente exibi\00E7\00E3o n\00E3o s\00E3o armazenados no estado da sess\00E3o.</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4416)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Enviar ao Submeter P\00E1gina')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Especifique se o valor do item atual deve ser enviado quando a p\00E1gina for submetida.')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4416)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Subtipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecione o subtipo de texto HTML5. Isso permite que dispositivos com teclados na tela mostrem um layout de teclado otimizado espec\00EDfico para o subtipo, para facilitar a entrada de dados. A sele\00E7\00E3o do subtipo tamb\00E9m ser\00E1 usada para renderizar um link')
||unistr(' apropriado com o valor do item de p\00E1gina, se ele for renderizado somente para leitura. Esse atributo n\00E3o altera o item do texto ou a entrada de dados, ao usar um teclado f\00EDsico.  '),
'</p>',
unistr('<p><strong><em>Observa\00E7\00E3o:</strong> Esse recurso HTML5 funciona somente em browsers modernos. Browsers mais antigos, n\00E3o compat\00EDveis com o HTML5, ignoram esse atributo e renderizam o item da p\00E1gina como um campo de texto normal.</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4416)
,p_display_sequence=>5
,p_display_value=>'Texto'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4416)
,p_display_sequence=>10
,p_display_value=>'E-Mail'
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4416)
,p_display_sequence=>20
,p_display_value=>unistr('N\00FAmero do Telefone')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4416)
,p_display_sequence=>25
,p_display_value=>'Pesquisar'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4416)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4416)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>unistr('Remover Espa\00E7os')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como o valor do item \00E9 reduzido depois de submeter a p\00E1gina. Esta configura\00E7\00E3o remove espa\00E7os, tabula\00E7\00F5es e novas linhas do texto digitado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4416)
,p_display_sequence=>10
,p_display_value=>unistr('\00C0 Esquerda')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4416)
,p_display_sequence=>20
,p_display_value=>unistr('\00C0 Direita')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4416)
,p_display_sequence=>30
,p_display_value=>unistr('\00C0 Direita e \00E0 Esquerda')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4416)
,p_display_sequence=>40
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4416)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('Formata\00E7\00E3o de Mai\00FAsculas/Min\00FAsculas do Texto')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Sem Altera\00E7\00E3o')
,p_help_text=>unistr('Selecione como as letras mai\00FAsculas/min\00FAsculas do texto do valor do item ser\00E3o transformadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Min\00FAsculas')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Mai\00FAsculas')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>'Oculto'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Os itens que est\00E3o inclu\00EDdos na origem da p\00E1gina, mas n\00E3o s\00E3o renderizados. Os valores de itens ocultos s\00E3o salvos no estado da sess\00E3o. Eles geralmente s\00E3o usados para armazenar valores exigidos pelo processamento de p\00E1gina ou outros itens da p\00E1gina,')
||unistr(' mas n\00E3o devem ser exibidos ao usu\00E1rio final.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4416)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valor Protegido'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especificar se o item ser\00E1 protegido, impedindo que o valor seja manipulado quando a p\00E1gina for  postada.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>'Exibir Imagem'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Exibe uma imagem armazenada nas colunas BLOB de um banco de dados ou com base em um URL de imagem.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Com Base Em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione de onde a imagem ser\00E1 recuperada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_display_sequence=>10
,p_display_value=>unistr('URL da Imagem armazenado no Valor do Item da P\00E1gina')
,p_return_value=>'URL'
,p_help_text=>unistr('O URL da imagem \00E9 lido a partir do valor armazenado no estado da sess\00E3o para o item de p\00E1gina especificado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_display_sequence=>20
,p_display_value=>'Coluna BLOB especificada na Origem do Item'
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('L\00EA a imagem da coluna BLOB especificada no atributo <strong>Origem do Item</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Coluna BLOB retornada pela instru\00E7\00E3o SQL')
,p_return_value=>'SQL'
,p_help_text=>unistr('Exibe a imagem baseada na coluna BLOB que \00E9 retornada pela instru\00E7\00E3o SQL especificada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Texto Alternativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>unistr('Digite o texto que ser\00E1 lido por leitores de tela quando um usu\00E1rio final navegar at\00E9 este item.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Coluna de Texto Alternativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAscula que cont\00E9m o texto alternativo para esta imagem. Este texto \00E9 lido por leitores de tela quando um usu\00E1rio final navega at\00E9 este item.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Coluna do Nome de Arquivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAscula que cont\00E9m o valor da coluna de nome de arquivo associado \00E0 coluna BLOB.')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('Coluna da \00DAltima Atualiza\00E7\00E3o do BLOB')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAscula que cont\00E9m o valor da coluna de data de quando o BLOB associado foi atualizado pela \00FAltima vez.</p>'),
unistr('<p>Este valor \00E9 usado para armazenamento do browser no cache e para identificar se a imagem foi alterado desde a \00FAltima solicita\00E7\00E3o do browser. Se a imagem n\00E3o for atualizada, ela ser\00E1 recuperada do cache do browser, se dispon\00EDvel.</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('Instru\00E7\00E3o SQL')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>unistr('Informe a instru\00E7\00E3o SQL para retornar a coluna BLOB que cont\00E9m a imagem.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4416)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>'Tipo de Coluna MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Informe o nome do item da p\00E1gina ou do aplicativo em mai\00FAscula para armazenar o tipo mime do arquivo obtido por upload. O tipo mime \00E9 utilizado pelo browser para identificar o aplicativo usado para exibir o conte\00FAdo do BLOB quando o arquivo \00E9 obtido ')
||'por download.'
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('Campo de Texto com preenchimento autom\00E1tico')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um campo de texto que exibe uma lista de valores poss\00EDveis, com base no texto j\00E1 informado pelo usu\00E1rio final, em linha com o item de texto. A lista \00E9 ainda mais refinada conforme o usu\00E1rio final insere mais texto.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Pesquisar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione como a pesquisa ser\00E1 executada de acordo com o valor inserido. Ao usar <em>Carregamento Lento</em> essa defini\00E7\00E3o pode ter um impacto no desempenho da consulta.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Selecionar <strong>Cont\00E9m e Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas</strong> ou <strong>Cont\00E9m e Ignorar Mai\00FAsculas/Min\00FAsculas</strong> impede o uso de \00EDndices de colunas.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Cont\00E9m e Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Exato e Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Cont\00E9m e Ignorar Mai\00FAsculas/Min\00FAsculas')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4416)
,p_display_sequence=>40
,p_display_value=>unistr('Exato e Ignorar Mai\00FAsculas/Min\00FAsculas')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Carregamento Lento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se os valores correspondentes ser\00E3o recuperados do banco de dados usando as t\00E9cnicas de <em>Carregamento Lento</em>. O carregamento lento recupera registros correspondentes do banco de dados cada vez que o usu\00E1rio digita um caractere. ')
||unistr('Do contr\00E1rio, todos os valores da lista s\00E3o carregados no carregamento da p\00E1gina.</p>'),
unistr('<p>A Oracle recomenda usar o <em>Carregamento Lento</em> quando voc\00EA tiver uma lista de sele\00E7\00E3o grande, pois carregar um grande n\00FAmero de registros pode afetar o tempo de carregamento da p\00E1gina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Valores M\00E1ximos na Lista')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o n\00FAmero m\00E1ximo de itens a serem exibidos na caixa de sele\00E7\00E3o.</p> '),
unistr('<p>Esse valor pode ajudar a evitar problemas de desempenho, retornando muitas linhas e tamb\00E9m pode ajudar a evitar um retorno muito grande definido quando somente algumas letras foram informadas.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Pesquisa M\00EDnima')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>'caracteres'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Especifique o n\00FAmero m\00EDnimo de caracteres que deve ser digitado antes da execu\00E7\00E3o da pesquisa.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>'Cache'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Especifique se os resultados da pesquisa est\00E3o armazenados no cache ao usar o Carregamento Lento para recuperar os registros correspondentes.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exiba e armazene o mesmo valor no item de p\00E1gina</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
unistr('<dt>Exiba os funcion\00E1rios de um departamento espec\00EDfico usando uma vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4416)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4416)
,p_name=>'ojupdate'
,p_display_name=>'Atualizar'
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>'Editor de Formato Rich Text'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma \00E1rea de texto com op\00E7\00F5es de formata\00E7\00E3o de texto abrangentes. Os usu\00E1rios finais podem aumentar o conte\00FAdo exibido de uma forma semelhante ao uso de um processador de texto, como o Microsoft Word. Os usu\00E1rios finais tamb\00E9m podem <em>cortar e')
||' colar</em> documentos no formato RTF (Rich Text Format) nesse item.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Responsivo [Obsoleto]'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o editor RTF deve se ajustar automaticamente ao tamanho da regi\00E3o do cont\00EAiner. Isso requer que o Aplicativo use o Universal Theme ou outro tema responsivo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Barra de Ferramentas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione o n\00FAmero de op\00E7\00F5es de formata\00E7\00E3o de texto dispon\00EDveis no editor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4416)
,p_display_sequence=>10
,p_display_value=>unistr('B\00E1sico')
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Intermedi\00E1rio')
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4416)
,p_display_sequence=>30
,p_display_value=>'Completo'
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Barra de Ferramentas Expandida'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('Especifique se o editor ser\00E1 inicialmente expandido na \00E1rea de texto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Skin'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>'Selecione a skin do editor usada para estilizar o editor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4416)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4416)
,p_display_sequence=>2
,p_display_value=>'Moono Color'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4416)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Posi\00E7\00E3o da Barra de Ferramentas')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique em que lugar da \00E1rea de texto o editor ser\00E1 exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4416)
,p_display_sequence=>10
,p_display_value=>'Superior'
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4416)
,p_display_sequence=>20
,p_display_value=>'Inferior'
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>unistr('Vers\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CK Editor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>O CKEditor 4 foi descontinuado e logo ser\00E1 substitu\00EDdo pelo CKEditor 5. \00C9 uma boa ideia fazer essa troca agora, para n\00E3o correr o risco de seu aplicativo quebrar em futuras vers\00F5es. Se voc\00EA tiver usado qualquer C\00F3digo JavaScript de Inicializa\00E7\00E3o p')
||unistr('ersonalizado, observe que a API do CKEditor foi alterada e seu c\00F3digo muito provavelmente ter\00E1 que ser ajustado.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4416)
,p_display_sequence=>10
,p_display_value=>'CK Editor 4 [Obsoleto]'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Altura M\00EDnima')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>unistr('Defina a altura m\00EDnima em pixels da \00E1rea edit\00E1vel.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Altura M\00E1xima')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>unistr('Defina a altura m\00E1xima em pixels da \00E1rea edit\00E1vel. Se voc\00EA deixar esse atributo vazio, o editor aumentar\00E1 indefinidamente \00E0 medida que voc\00EA digitar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>'Formato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique o formato de sa\00EDda do conte\00FAdo informado no editor RTF.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4416)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('Use HTML para a origem e sa\00EDda deste editor de formato rich text.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Remarca\00E7\00E3o')
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('Use o formato Markdown para a origem e sa\00EDda deste editor de formato rich text.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4416)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4416)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
unistr('    // desativar o recurso Autoformata\00E7\00E3o'),
'    options.editorOptions.removePlugins.push(''Autoformat'');',
'    // aplicar uma barra de ferramentas personalizada',
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('Insira uma fun\00E7\00E3o JavaScript para substituir a configura\00E7\00E3o padr\00E3o do editor. As op\00E7\00F5es espec\00EDficas do CKEditor5 devem ser aplicadas a <code>options.editorOptions</code>. Consulte os documentos da API do CKEditor5 API para obter mais informa\00E7\00F5es.')
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>'Seletor de Cores'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permite aos usu\00E1rios escolher ou inserir uma cor. As cores podem ser selecionadas de um espectro de cores.')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Modo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a quantidade de informa\00E7\00F5es mostradas no seletor de cores.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4416)
,p_display_sequence=>10
,p_display_value=>'Simples'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Mostra apenas os controles do espectro de cores e predefini\00E7\00F5es de cores, se houver alguma definida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4416)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>unistr('Mostra campos adicionais para exibir ou inserir cores como valores hexadecimais, HSL ou RGB com valor Alfa opcional dependendo do que estiver definido na op\00E7\00E3o Retornar Valor Como. Tamb\00E9m mostra as cores Inicial e Atual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Exibir Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como o seletor de cores ser\00E1 exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4416)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'Uma cor pode ser informada no campo de texto ou escolhida no seletor de cores popup.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4416)
,p_display_sequence=>20
,p_display_value=>'Em Linha'
,p_return_value=>'INLINE'
,p_help_text=>unistr('Um seletor de cores \00E9 mostrado em linha.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4416)
,p_display_sequence=>30
,p_display_value=>'Popup somente de cor'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('Um bot\00E3o abre um seletor de cores popup.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4416)
,p_display_sequence=>40
,p_display_value=>'Seletor de Cores Nativas'
,p_return_value=>'NATIVE'
,p_help_text=>'Uma entrada de cor do browser nativo. A IU depende do browser.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Usar Padr\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Se os padr\00F5es definidos para este componente ser\00E3o ou n\00E3o usados, em Componentes Compartilhados > Defini\00E7\00F5es de Componentes ou defini\00E7\00F5es personalizadas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Modo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Selecione o valor das informa\00E7\00F5es mostradas no seletor de cor.</p>'),
unistr('<p>Observe que isso n\00E3o se aplica quando a op\00E7\00E3o Exibir como \00E9 Seletor de Cor Nativa.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4416)
,p_display_sequence=>10
,p_display_value=>'Simples'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Mostra apenas os controles do espectro de cores e predefini\00E7\00F5es de cores, se houver alguma definida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4416)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>unistr('Mostra campos adicionais para exibir ou inserir cores como valores hexadecimais, HSL ou RGB com valor Alfa opcional dependendo do que estiver definido na op\00E7\00E3o Retornar Valor Como. Tamb\00E9m mostra as cores Inicial e Atual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Exibir Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como o seletor de cores ser\00E1 exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_display_sequence=>10
,p_display_value=>'Popup'
,p_return_value=>'POPUP'
,p_help_text=>'Uma cor pode ser informada no campo de texto ou escolhida no seletor de cores popup.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_display_sequence=>20
,p_display_value=>'Em Linha'
,p_return_value=>'INLINE'
,p_help_text=>unistr('Um seletor de cores \00E9 mostrado em linha.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_display_sequence=>30
,p_display_value=>'Popup somente de cor'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('Um bot\00E3o abre um seletor de cores popup.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_display_sequence=>40
,p_display_value=>'Seletor de Cores Nativas'
,p_return_value=>'NATIVE'
,p_help_text=>'Uma entrada de cor do browser nativo. A IU depende do browser.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Predefini\00E7\00E3o de Cor')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione se o seletor de cores deve mostrar um conjunto de cores predefinidas e, em caso afirmativo, se elas s\00E3o do tema ou personalizadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4416)
,p_display_sequence=>10
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4416)
,p_display_sequence=>20
,p_display_value=>'Cores do Estilo do Tema'
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4416)
,p_display_sequence=>30
,p_display_value=>'Cores Personalizadas'
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Cores'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lista de cores predefinidas a serem exibidas na caixa de di\00E1logo do seletor de cores.'),
unistr('Separe as cores usando um ponto e v\00EDrgula.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Contraste com'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite comparar a cor deste item com a cor de outro item ou um valor est\00E1tico e exibir o \00EDndice de contraste entre eles na IU do seletor de cores.  '),
unistr('Isso pode ajudar o usu\00E1rio a escolher cores com contraste suficiente para serem acess\00EDveis a todos.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4416)
,p_display_sequence=>10
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Item de P\00E1gina')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Cor Est\00E1tica')
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Item de Contraste'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('Item a ser usado para compara\00E7\00E3o de contraste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Cor de Contraste'
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('Cor a ser usada para compara\00E7\00E3o de contraste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4416)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Valor de Retorno Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique o formato do valor da cor retornado por este item. Mesmo se a cor for inserida em outro formato v\00E1lido, ela ser\00E1 apresentada, retornada e enviada ao servidor nesse formato.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4416)
,p_display_sequence=>10
,p_display_value=>'Hexadecimal'
,p_return_value=>'HEX'
,p_help_text=>unistr('Valor da cor hexadecimal. Nenhum valor alfa \00E9 permitido. Por exemplo #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4416)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>unistr('Vermelho, Verde, Azul na nota\00E7\00E3o de fun\00E7\00E3o rgb. Exemplo rgb(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4416)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vermelho, Verde, Azul, com Alfa opcional (transpar\00EAncia) na nota\00E7\00E3o de fun\00E7\00E3o rgb/rgba.'),
unistr('Se a cor n\00E3o tiver alfa (alfa \00E9 igual a 1), ser\00E1 usado um formato rgb.'),
unistr('Se a cor tiver um alfa, ser\00E1 usado um formato rgba.'),
'Exemplo de rgba(34,68,238,0,5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4416)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('Matiz, Satura\00E7\00E3o, Luminosidade na nota\00E7\00E3o de fun\00E7\00E3o hsl. Exemplo hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4416)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Matiz, Satura\00E7\00E3o, Luminosidade com alfa opcional (transpar\00EAncia) na nota\00E7\00E3o de fun\00E7\00E3o hsl/hsla. '),
unistr('Se a cor n\00E3o tiver alfa (alfa \00E9 igual a 1), ser\00E1 usado um formato hsl.'),
unistr('Se a cor tiver um alfa, ser\00E1 usado um formato hsla.'),
'Exemplo de hsla(230,86,53,0,5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4416)
,p_display_sequence=>60
,p_display_value=>'Qualquer Valor CSS'
,p_return_value=>'CSS'
,p_help_text=>unistr('Qualquer formato de cor CSS v\00E1lido, incluindo nomes de cores ou uma vari\00E1vel CSS.')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>'LOV Popup'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe um item de texto com uma lista popup de \00EDcones de valores. Quando o usu\00E1rio final clica no \00EDcone, uma janela popup aparece com um campo de pesquisa e uma lista de valores suportados.</p>'),
unistr('<p>O LOV popup \00E9 o mais adequado para listas grandes, pois os usu\00E1rios finais podem inserir crit\00E9rios de pesquisa para reduzir os valores dispon\00EDveis exibidos. Para listas relativamente pequenas <em>Selecionar Lista</em> \00E9 geralmente a op\00E7\00E3o mais ade')
||'quada.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Exibir Como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como a lista pop-up de valores \00E9 exibida.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Di\00E1logo Modal')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('A lista de valores ser\00E1 mostrada em uma caixa de di\00E1logo modal.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4416)
,p_display_sequence=>20
,p_display_value=>'Pop-up em Linha'
,p_return_value=>'POPUP'
,p_help_text=>unistr('A lista de valores ser\00E1 mostrada em uma pop-up em linha sob o campo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Extra\00E7\00E3o Inicial')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como os dados s\00E3o inicialmente extra\00EDdos na lista de valores. Isso s\00F3 se aplica na primeira vez que a pop-up \00E9 aberta ap\00F3s a p\00E1gina ser carregada ou o item ser atualizado, como em cascata. Consulte tamb\00E9m o atributo M\00EDnimo de Caracteres.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Na Solicita\00E7\00E3o do Usu\00E1rio')
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('Inicialmente, nenhuma lista de valores \00E9 extra\00EDda at\00E9 que o usu\00E1rio pesquise com ou sem um termo de pesquisa.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Autom\00E1tico')
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>'Inicialmente, extraia a lista de valores sem um termo de pesquisa.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Autom\00E1tico com Valor Atual')
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>'Inicialmente, extraia a lista de valores com o valor atual como termo de pesquisa.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Diversos Valores'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se esse item pode ter diversos valores ou um \00FAnico valor. Diversos valores s\00E3o retornados como lista separada por v\00EDrgulas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Entrada Manual'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Selecione se a entrada ser\00E1 ou n\00E3o permitida. Se a op\00E7\00E3o for Sim, o usu\00E1rio poder\00E1 selecionar valores existentes na lista de valores popup ou inserir um valor manualmente. Isso funciona como uma Caixa de combina\00E7\00E3o. Se a op\00E7\00E3o for N\00E3o, o usu\00E1rio s\00F3 p')
||unistr('oder\00E1 selecionar valores da lista popup de valores. Isso funciona como uma Lista de Sele\00E7\00E3o. Quando a entrada manual \00E9 permitida, esse \00E9 o valor de retorno da Lista de Valores correspondente que deve ser inserido.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Pesquisar ao Digitar'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Quando Sim, a lista de valores \00E9 filtrada conforme voc\00EA digita no campo de pesquisa. Quando N\00E3o, a lista de valores n\00E3o \00E9 filtrada at\00E9 que o usu\00E1rio pressione Enter ou o bot\00E3o do \00EDcone Pesquisar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('M\00EDnimo de Caracteres')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique o n\00FAmero m\00EDnimo de caracteres necess\00E1rio no termo de pesquisa para que a lista de valores seja extra\00EDda. Isso pode ser \00FAtil para reduzir o volume de pesquisas feitas quando a consulta LOV \00E9 dispendiosa. Todos os valores de exibi\00E7\00E3o na lis')
||unistr('ta devem ser maiores que esse valor m\00EDnimo; caso contr\00E1rio, n\00E3o poder\00E3o ser encontrados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Sem m\00EDnimo (0)')
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4416)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4416)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4416)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4416)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4416)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('T\00EDtulo')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('O t\00EDtulo da caixa de di\00E1logo pop-up. Se for deixado em branco, o t\00EDtulo padr\00E3o ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Largura da Pop-up'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('A largura da pop-up. Se for deixado em branco, um padr\00E3o ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Altura da Pop-up'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('A altura da pop-up. Se for deixado em branco, um padr\00E3o ser\00E1 usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Sa\00EDdas Adicionais')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Retorne colunas de Lista de Valores (LOV) adicionais para outros itens da p\00E1gina e colunas de Grade Interativa. Defina um mapeamento de nome de coluna LOV para o nome do item da p\00E1gina ou ID Est\00E1tico da coluna de Grade Interativa.</p>'),
unistr('<p>Observa\00E7\00E3o: isso s\00F3 se aplica quando a defini\00E7\00E3o de LOV inclui colunas adicionais.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>'Separador'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe uma fun\00E7\00E3o JavaScript que pressuponha um objeto de op\00E7\00F5es para o item LOV Popup, modifique o objeto e retorne-o. Isso permite a personaliza\00E7\00E3o avan\00E7ada da caixa de di\00E1logo do item LOV Popup e de seu conte\00FAdo durante a inicializa\00E7\00E3o.</p>'),
'',
unistr('<p>Essas op\00E7\00F5es s\00E3o especificadas para o widget <code>popup</code> ou widget <code>dialog</code> da Interface de Usu\00E1rio da jQuery:<br>'),
'draggable, resizable, width, height, minWidth, minHeight, maxWidth e maxHeight<br>',
unistr('Consulte a documenta\00E7\00E3o do widget de caixa de di\00E1logo da Interface de usu\00E1rio da JQuery para ver detalhes.</p>'),
'',
unistr('<p>Quando os resultados s\00E3o exibidos em uma lista simples, a op\00E7\00E3o <code>defaultIconListOptions</code> \00E9 um objeto especificado para o widget <code>tableModelView</code>. Consulte a documenta\00E7\00E3o do widget tableModelView do APEX para ver as op\00E7\00F5es dis')
||unistr('pon\00EDveis.</p>'),
'',
unistr('<p>Quando os resultados s\00E3o exibidos em uma grade, a op\00E7\00E3o <code>defaultGridOptions</code> \00E9 um objeto especificado para o widget <code>grid</code>.'),
unistr('Consulte a documenta\00E7\00E3o do widget grid do APEX para ver as op\00E7\00F5es dispon\00EDveis.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4416)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('C\00F3digo de Execu\00E7\00E3o do Servidor')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Executa c\00F3digo no servidor.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4416)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('C\00F3digo PL/SQL')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Aumenta o sal\00E1rio em 3% para os funcion\00E1rios que est\00E3o qualificados para um aumento salarial:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>Neste exemplo, voc\00EA precisa inserir <code>P2_DEPTNO</code> em <strong>Itens a Submeter</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique uma execu\00E7\00E3o somente de bloco an\00F4nimo PL/SQL, que seja executada no servidor.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia a outros itens da p\00E1gina ou do aplicativo a partir da sua p\00E1gina usando a sintaxe de bind (por exemplo <code>:P1_MY_ITEM</code>). Qualquer item referenciado tamb\00E9m precisar\00E1 estar inclu\00EDdo em <strong>Itens de P\00E1gina a Su')
||'bmeter</strong>.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4416)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>unistr('C\00F3digo JavaScript')
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Aumenta o sal\00E1rio em 3% para os funcion\00E1rios que est\00E3o qualificados para um aumento salarial:</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
unistr('  // placeholder para alguma l\00F3gica complicada calcular se o funcion\00E1rio precisa de um aumento'),
'    return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>Neste exemplo, voc\00EA precisa inserir <code>P2_DEPTNO</code> em <strong>Itens a Submeter</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique um bloco JavaScript somente para execu\00E7\00E3o, que seja executado no servidor.</p>'),
unistr('<p>Voc\00EA pode fazer refer\00EAncia a outros itens da p\00E1gina ou do aplicativo com base em seu aplicativo usando a sintaxe de bind (por exemplo, <code>apex.env.P1_MY_ITEM</code>). Qualquer item referenciado tamb\00E9m precisar\00E1 estar inclu\00EDdo em <strong>Itens d')
||unistr('e P\00E1gina a Submeter</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4416)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Itens a Submeter'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os itens de p\00E1gina em mai\00FAsculas para o servidor e, portanto, dispon\00EDveis para uso em seu <strong>C\00F3digo PL/SQL</strong>.</p>'),
unistr('<p>Voc\00EA pode digitar o nome do item ou selecionar na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA selecion\00E1-lo na lista e j\00E1 houver texto inserido, ser\00E1 colocada uma v\00EDrgula no final do texto existente, seguida pelo nome do item retornado da lista.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4416)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Itens para Retorno'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
unistr('<p>Nesse exemplo, informe <code>P1_MY_ITEM</code> nesse atributo para que o ''Novo Valor'' seja exibido nesse item em sua p\00E1gina.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe os itens de p\00E1gina em mai\00FAsculas definidos quando a chamada para o servidor \00E9 retornada com base em seus valores atuais no estado da sess\00E3o. Se o seu <strong>C\00F3digo PL/SQL</strong> definir um ou mais valores de item de p\00E1gina no estado da ')
||unistr('sess\00E3o, ser\00E1 necess\00E1rio definir esses itens nesse atributo.</p>'),
unistr('<p>Voc\00EA pode digitar o nome do item ou escolher na lista de itens dispon\00EDveis.'),
unistr('Se voc\00EA selecionar na lista e j\00E1 houver texto inserido, uma v\00EDrgula ser\00E1 colocada no fim do texto existente, seguida pelo nome do item retornado da lista.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4416)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Suprimir Evento de Altera\00E7\00E3o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Especifique se o evento de altera\00E7\00E3o ser\00E1 suprimido nos itens especificados em <strong>Itens de P\00E1gina a Serem Retornados</strong>. Isso impede que A\00E7\00F5es Din\00E2micas subsequentes baseadas em <em>Alterar</em> sejam ativadas para esses itens.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4416)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Idioma'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>unistr('Somente Exibi\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Exibe um item de texto n\00E3o edit\00E1vel.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4416)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>unistr('Enviar ao Submeter P\00E1gina')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o valor do item atual deve ser enviado quando a p\00E1gina for submetida.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4416)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Com Base Em'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como ser\00E1 determinado o valor exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4416)
,p_display_sequence=>10
,p_display_value=>'Valor do Item'
,p_return_value=>'VALUE'
,p_help_text=>unistr('O valor atual do item \00E9 exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Valor de Exibi\00E7\00E3o da Lista de Valores')
,p_return_value=>'LOV'
,p_help_text=>unistr('O valor atual do item de p\00E1gina \00E9 mapeado para um valor de exibi\00E7\00E3o diferente usando uma Lista de Valores.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Sa\00EDda de C\00F3digo PL/SQL')
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('O c\00F3digo PL/SQL especificado emite a sa\00EDda exibida.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4416)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('C\00F3digo PL/SQL')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe o c\00F3digo PL/SQL usando <code>sys.htp.p</code> ou <code>sys.htp.prn</code> para emitir o c\00F3digo HTML.</p>'),
'<p>A Oracle recomenda usar <code>sys.htf.escape_sc</code> para inserir um caractere de escape nos dados recuperados do banco de dados pra garantir que as tags HTML contenham caracteres de escape.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4416)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar Quebras de Linha'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique se as quebras de linhas ser\00E3o preservadas na sa\00EDda.</p>'),
unistr('<p>Como a exibi\00E7\00E3o \00E9 renderizada como HTML, quando definidas como <strong>Sim</strong>, as quebras de linha no valor da exibi\00E7\00E3o ser\00E3o convertidas em quebras de linha, para que sejam exibidas corretamente.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4416)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>'Formato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Texto sem Formata\00E7\00E3o')
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4416)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Remarca\00E7\00E3o')
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4416)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4416)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Exemplo 1: Lista de valores baseada na consulta SQL.</strong>',
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
unistr('<strong>Exemplo 2: Exemplos de listas est\00E1ticas</strong>'),
'<ul>',
'<li>STATIC:Yes;Y,No;N (mostra Yes/No, em vez de Y e N)</li>',
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>Exemplo 3: Lista de valores com restri\00E7\00E3o adicional usando vari\00E1vel de bind</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('Classifica\00E7\00E3o por Estrelas')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Item da Classifica\00E7\00E3o por Estrelas Moderna</strong></p>'),
unistr('<p>Este item exibe um valor num\00E9rico como um n\00FAmero de estrelas ou outros \00EDcones. O usu\00E1rio final altera o valor selecionando o n\00FAmero desejado de estrelas. O valor pode ser ajustado clicando-se no n\00FAmero de estrelas com o mouse ou usando o teclado.<')
||'/p>',
unistr('<p>O \00EDcone a ser exibido e as cores de fundo e de primeiro plano podem ser ajustados nas defini\00E7\00F5es do componente ou nas defini\00E7\00F5es de itens individuais. Para usar itens e cores individuais, defina o atributo <strong>Usar Padr\00F5es do Componente</stron')
||unistr('g> como <strong>N\00E3o</strong>.</p>'),
unistr('<p>Como \00EDcones, voc\00EA pode usar qualquer \00EDcone da Fonte de \00CDcone dispon\00EDvel no seu aplicativo. Para aplicativos de Tema Universal, use um \00EDcone da biblioteca <em>Font APEX</em>.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\00CDcone Padr\00E3o')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('Escolha o \00EDcone padr\00E3o a ser usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Cor Ativa'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Escolha a cor padr\00E3o para as estrelas ativas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cor Inativa'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Escolha a cor padr\00E3o para as estrelas inativas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Dica de ferramenta'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('Classifica\00E7\00E3o: #VALUE# estrelas.')
,p_help_text=>unistr('Especifique o modelo para a dica de ferramenta. A substitui\00E7\00E3o #VALUE# est\00E1 sendo trocada pelo valor de classifica\00E7\00E3o atual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Estrelas')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('N\00FAmero total de estrelas a ser exibido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4416)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Usar Padr\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Se os padr\00F5es definidos para este componente ser\00E3o ou n\00E3o usados, em Componentes Compartilhados > Defini\00E7\00F5es de Componentes ou defini\00E7\00F5es personalizadas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\00CDcone')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('Especifique o \00EDcone a ser usado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cor Ativa'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Escolha a cor padr\00E3o para as estrelas ativas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Cor Inativa'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Escolha a cor padr\00E3o para as estrelas inativas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Dica de ferramenta'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('Classifica\00E7\00E3o: #VALUE# estrelas.')
,p_help_text=>unistr('Especifique o modelo para a dica de ferramenta. A substitui\00E7\00E3o #VALUE# est\00E1 sendo trocada pelo valor de classifica\00E7\00E3o atual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Mostrar Bot\00E3o Limpar')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Escolha se o bot\00E3o Limpar ser\00E1 ou n\00E3o mostrado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Mostrar Valor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('escolha se o valor ser\00E1 ou n\00E3o exibido junto \00E0s estrelas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4416)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Exibi\00E7\00E3o Somente para Leitura')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Escolha o que ser\00E1 exibido quando o item for somente para leitura.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4416)
,p_display_sequence=>20
,p_display_value=>'Estrelas'
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4416)
,p_display_sequence=>30
,p_display_value=>'Valor'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4416)
,p_display_sequence=>40
,p_display_value=>'Estrelas e Valor'
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4416)
,p_display_sequence=>50
,p_display_value=>unistr('Estrela \00DAnica e Valor')
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('Grupo da Caixa de Sele\00E7\00E3o')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Exibe v\00E1rios valores como caixas de sele\00E7\00E3o, permitindo que o usu\00E1rio final selecione diversos valores. \00C9 necess\00E1ria uma lista de valores para itens exibidos como caixas de sele\00E7\00E3o. Os valores correspondentes \00E0s caixas de sele\00E7\00E3o marcadas s\00E3o armazen')
||unistr('adas em uma \00FAnica string delimitado por dois pontos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4416)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Colunas')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Informe o n\00FAmero de colunas de layout usadas para exibir as caixas de sele\00E7\00E3o. Por exemplo, um valor 2 exibir\00E1 duas colunas de caixas de sele\00E7\00E3o. Por padr\00E3o, todos os valores exibidos em uma coluna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4416)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('Exibir Orienta\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione como as caixas de sele\00E7\00E3o ser\00E3o renderizadas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4416)
,p_display_sequence=>10
,p_display_value=>'Vertical'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4416)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4416)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>'Selecionar Lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exibe um item com uma lista incorporada de seletor de valores. Quando o usu\00E1rio final clica no item, a lista de valores suportados \00E9 exibida diretamente em linha com o item atual.</p>'),
unistr('<p>Selecionar Lista \00E9 a op\00E7\00E3o mais adequada para listas relativamente pequenas e discretas. Os usu\00E1rios finais podem rapidamente selecionar um valor da lista sem precisar mudar o foco para uma caixa de di\00E1logo popup. Para listas grandes <em>LOV Popup')
||unistr('</em> \00E9, geralmente, a op\00E7\00E3o mais adequada.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('A\00E7\00E3o da P\00E1gina na Sele\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a a\00E7\00E3o que ser\00E1 executada quando um valor da lista for selecionado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_display_sequence=>1
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
,p_help_text=>unistr('Nenhuma a\00E7\00E3o imediata \00E9 executada quando o valor \00E9 alterado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_display_sequence=>5
,p_display_value=>unistr('Submeter P\00E1gina')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('A p\00E1gina \00E9 submetida com a defini\00E7\00E3o REQUEST da p\00E1gina para o nome de item da p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_display_sequence=>7
,p_display_value=>'Redirecionar e Definir Valor'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('O browser \00E9 redirecionado para a p\00E1gina atual e o estado da sess\00E3o para o item atual \00E9 definido como o valor selecionado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_display_sequence=>9
,p_display_value=>unistr('Redirecionar para a P\00E1gina')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('O browser \00E9 redirecionado para a p\00E1gina contida no valor selecionado. Os valores de retorno na lista devem incluir n\00FAmeros de p\00E1gina v\00E1lidos ou aliases de p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_display_sequence=>10
,p_display_value=>'Redirecionar para URL'
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('O browser \00E9 redirecionado para o URL contido no valor selecionado. Os valores de retorno na lista devem incluir URLs v\00E1lidos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4416)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Permitir Sele\00E7\00E3o M\00FAltipla')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('Especifique se v\00E1rios valores ou apenas um \00FAnico valor pode ser selecionado na lista de valores. V\00E1rios valores s\00E3o retornados como uma lista separada por v\00EDrgula.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4416)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Executar Valida\00E7\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Especifique se as valida\00E7\00F5es ser\00E3o executadas quando a p\00E1gina for submetida, com base na defini\00E7\00E3o de a\00E7\00E3o da p\00E1gina <strong>Submeter P\00E1gina</strong>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4416)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('Relat\00F3rio de Altern\00E2ncia de Colunas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um relat\00F3rio no qual os usu\00E1rios finais podem selecionar as colunas a serem exibidas no runtime. Os usu\00E1rios finais podem alterar as colunas com base na largura e na orienta\00E7\00E3o da tela que est\00E3o usando para exibir o relat\00F3rio.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a base para esta coluna do relat\00F3rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Texto sem Formata\00E7\00E3o')
,p_return_value=>'PLAIN'
,p_help_text=>'Exibe o valor da coluna.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_display_sequence=>20
,p_display_value=>'Link'
,p_return_value=>'LINK'
,p_help_text=>'Exibe a coluna como um link.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Gr\00E1fico de Percentual')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('Exibe a coluna como um gr\00E1fico de porcentagem. O valor recuperado deve estar entre 0 e 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destino'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Informe uma p\00E1gina de destino a ser chamada quando o usu\00E1rio clicar em uma entrada existente.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Texto do Link'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Informe o texto HTML a ser mostrado como link. Use uma tag de imagem para exibir imagens ou fa\00E7a uma sele\00E7\00E3o na lista de imagens padr\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Atributos do Link'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Especifique os atributos de link da coluna adicional a serem inclu\00EDdos na <code>&lt;a href=...&gt;</code> tag, incluindo destino, classes ou estilos de link.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Cor de Fundo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o fundo deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor um \00FAnico byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Cor de Primeiro Plano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o primeiro plano deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Largura da Barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Informe a largura em pixels para este gr\00E1fico de barras.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Usar Como Cabe\00E7alho da Linha')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Usado para fins de acessibilidade, para identificar a coluna que melhor representa o conte\00FAdo da linha.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>'Prioridade'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O relat\00F3rio funciona ocultando e mostrando colunas com base em duas entradas: largura da tela dispon\00EDvel e marca\00E7\00E3o e desmarca\00E7\00E3o do usu\00E1rios de colunas que ser\00E3o exibidas em um menu selecionador de colunas. Selecione um valor de prioridade para c')
||unistr('ada coluna que voc\00EA deseja exibir de forma r\00E1pida. Toda coluna que tiver prioridade ficar\00E1 dispon\00EDvel no menu selecionador de colunas.<p>'),
'',
unistr('<p>Para tornar uma coluna persistente, de forma que ela nunca fique oculta, selecione <strong>Sempre Exibida</strong>, que tamb\00E9m remove a coluna do menu selecionador de colunas.<p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>5
,p_display_value=>'Sempre Exibido'
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>10
,p_display_value=>unistr('1 - Ocultar \00DAltimo')
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4416)
,p_display_sequence=>60
,p_display_value=>'6 - Ocultar Primeiro'
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Op\00E7\00F5es de Layout')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Marque as op\00E7\00F5es adicionais de layout do relat\00F3rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Divis\00F5es')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('Adicione divis\00F5es de linha alternativas em cada linha.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Tra\00E7o')
,p_return_value=>'STROKE'
,p_help_text=>'Adicione linhas horizontais em cada linha.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Informe as classes CSS delimitadas por espa\00E7os adicionais a serem inclu\00EDdas no componente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos Personalizados'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Insira atributos adicionais a serem inclu\00EDdos na tag HTML da tabela. O atributo HTML da classe \00E9 gerado e, portanto, n\00E3o deve ser fornecido. Em seu lugar, use o atributo <em>CSS Classes</em> dedicado.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Texto do Bot\00E3o da Coluna')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('Este \00E9 o label a ser usado para o bot\00E3o que abre o popup de sele\00E7\00E3o de coluna. Se nenhum texto for fornecido, um label padr\00E3o ser\00E1 usado.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4416)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exiba todos os funcion\00E1rios ordenados por nome</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>Exiba todos os funcion\00E1rios do departamento atual ordenados por nome</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Ao usar vari\00E1veis de bind para fazer refer\00EAncia a itens de p\00E1gina, especifique-os como <strong>Itens de P\00E1gina a Submeter<strong>.</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>'Transporte'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C9 exibido como uma lista com v\00E1rias sele\00E7\00F5es que inclui duas caixas contendo listas. A lista \00E0 esquerda exibe a lista de origem de valores que n\00E3o foram selecionados e a lista da direita exibe os valores atualmente selecionados. Os usu\00E1rios finais')
||' podem selecionar um ou mais valores em uma lista, em seguida, utilizar os controles de shuttle para mover os valores selecionados ou todos os valores.</p>',
unistr('<p>Os valores atuais s\00E3o armazenados em uma \00FAnica string delimitada por dois-pontos.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4416)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar Controles'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione o movimento de dados que controla as exibi\00E7\00F5es no meio do shuttle.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4416)
,p_display_sequence=>10
,p_display_value=>'Tudo'
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Apenas Movimenta\00E7\00E3o')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Apenas Ordena\00E7\00E3o')
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4416)
,p_display_sequence=>40
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4416)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4416)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4416)
,p_name=>'shuttlechangeorder'
,p_display_name=>'Alterar Ordem'
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>unistr('Grupo de R\00E1dio')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe v\00E1rios valores como um grupo de bot\00F5es de op\00E7\00E3o, permitindo que o usu\00E1rio final selecione um \00FAnico valor.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4416)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Colunas')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Digite o n\00FAmero de colunas de grupo de bot\00F5es de op\00E7\00E3o a serem exibidos. Por exemplo, um valor <code>2</code> exibir\00E1 duas colunas, portanto, se havia cinco valores, ser\00E3o exibidas mais tr\00EAs linhas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4416)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('A\00E7\00E3o da P\00E1gina na Sele\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a a\00E7\00E3o que ser\00E1 executada quando um valor de grupo de bot\00F5es de op\00E7\00E3o for selecionado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4416)
,p_display_sequence=>10
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
,p_help_text=>unistr('Nenhuma a\00E7\00E3o imediata \00E9 executada quando o valor \00E9 alterado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Submeter P\00E1gina')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('A p\00E1gina \00E9 submetida com a defini\00E7\00E3o REQUEST da p\00E1gina para o nome de item da p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4416)
,p_display_sequence=>30
,p_display_value=>'Redirecionar e Definir Valor'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('O browser redireciona para a p\00E1gina atual e o estado da sess\00E3o para o item atual \00E9 definido como o valor selecionado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4416)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Executar Valida\00E7\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Especifique se as valida\00E7\00F5es ser\00E3o executadas quando a p\00E1gina for submetida, devido \00E0 defini\00E7\00E3o de a\00E7\00E3o da p\00E1gina <strong>Submeter P\00E1gina</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4416)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>unistr('Exibir Orienta\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a orienta\00E7\00E3o para exibir valores de grupo de bot\00F5es de op\00E7\00E3o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4416)
,p_display_sequence=>10
,p_display_value=>'Vertical'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4416)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4416)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Ocultar Bot\00F5es de Op\00E7\00E3o')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4416)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4416)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores baseada na consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores com o mesmo valor de exibi\00E7\00E3o e de retorno</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Ao selecionar a mesma coluna para os valores de exibi\00E7\00E3o e de retorno use um alias de coluna.</p>'),
'</dd>',
unistr('<dt>Lista de valores com vari\00E1vel de bind</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Observa\00E7\00E3o: Defina o atributo <em>Item(ns) Pai(s) da LOV em Cascata</em> como <code>P3_DEPTNO</code> se <code>P3_DEPTNO</code> for um item de p\00E1gina modific\00E1vel da mesma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>unistr('Relat\00F3rio Reflow')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe um relat\00F3rio adapt\00E1vel que transforma desde colunas at\00E9 linhas para exibir relat\00F3rios em browsers (telas) menores.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Selecione a base para esta coluna do relat\00F3rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Texto sem Formata\00E7\00E3o')
,p_return_value=>'PLAIN'
,p_help_text=>'Exibe o valor da coluna.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_display_sequence=>20
,p_display_value=>'Link'
,p_return_value=>'LINK'
,p_help_text=>'Exibe a coluna como um link.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_display_sequence=>30
,p_display_value=>unistr('Gr\00E1fico de Percentual')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('Exibe a coluna como um gr\00E1fico de porcentagem. O valor recuperado deve estar entre 0 e 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destino'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Informe uma p\00E1gina de destino a ser chamada quando o usu\00E1rio clicar em uma entrada existente.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Texto do Link'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Informe o texto HTML a ser mostrado como link. Use uma tag de imagem para exibir imagens ou fa\00E7a uma sele\00E7\00E3o na lista de imagens padr\00E3o.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Atributos do Link'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Especifique os atributos de link da coluna adicional a serem inclu\00EDdos na <code>&lt;a href=...&gt;</code> tag, incluindo destino, classes ou estilos de link.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Cor de Fundo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o fundo deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor um \00FAnico byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Cor de Primeiro Plano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Exemplos dos principais c\00F3digos de cores HTML incluem - '),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o primeiro plano deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Largura da Barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Informe a largura em pixels para este gr\00E1fico de barras.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Usar Como Cabe\00E7alho da Linha')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Usado para fins de acessibilidade, para identificar a coluna que melhor representa o conte\00FAdo da linha.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Op\00E7\00F5es de Layout')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Marque as op\00E7\00F5es adicionais de layout do relat\00F3rio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Divis\00F5es')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('Adicione divis\00F5es de linha alternativas em cada linha.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4416)
,p_display_sequence=>20
,p_display_value=>unistr('Tra\00E7o')
,p_return_value=>'STROKE'
,p_help_text=>'Adicione linhas horizontais em cada linha.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Classes CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Informe as classes CSS delimitadas por espa\00E7os adicionais a serem inclu\00EDdas no componente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos Personalizados'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Insira atributos adicionais a serem inclu\00EDdos na tag HTML da tabela. O atributo HTML da classe \00E9 gerado e, portanto, n\00E3o deve ser fornecido. Em seu lugar, use o atributo <em>CSS Classes</em> dedicado.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4416)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4416)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Exiba todos os funcion\00E1rios ordenados por nome</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>Exiba todos os funcion\00E1rios do departamento atual ordenados por nome</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Ao usar vari\00E1veis de bind para fazer refer\00EAncia a itens de p\00E1gina, especifique-os como <strong>Itens de P\00E1gina a Submeter<strong>.</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('Gr\00E1fico de Percentual')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe o valor como gr\00E1fico de porcentagem. O valor recuperado deve estar entre 0 e 100.')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4416)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar Valor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique se o valor de porcentagem ficar\00E1 vis\00EDvel.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4416)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Cor de Fundo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o fundo deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor um \00FAnico byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4416)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cor de Primeiro Plano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o primeiro plano deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor \00FAnico de byte de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4416)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cor do Texto'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe a cor usada para o texto deste gr\00E1fico.'),
unistr('A cor \00E9 especificada usando nota\00E7\00E3o hexadecimal (hex), c\00F3digos de cores RGB ou nomes de cores HTML.</p>'),
unistr('<p>A nota\00E7\00E3o hexadecimal \00E9 definida como #xxyyzz (um # seguido por 3 n\00FAmeros hexadecimais de dois d\00EDgitos), em que xx, yy e zz representam os valores hexadecimais de dois caracteres para vermelho, verde e azul respectivamente.'),
unistr('Os c\00F3digos RGB s\00E3o definidos como RGB(xxx,xxx,xxx), em que xxx \00E9 um n\00FAmero entre 0 e 255, cada um representando o valor de byte \00FAnico de 8 bits para vermelho, verde e azul, respectivamente.</p>'),
unistr('<p>Pesquise "C\00F3digos de Cores HTML" na Internet para encontrar o c\00F3digo hexadecimal equivalente ou o c\00F3digo RGB para a cor que voc\00EA deseja utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4416)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Largura da Barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>'pixels'
,p_is_translatable=>false
,p_help_text=>unistr('Informe a largura em pixels para este gr\00E1fico de barras.')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>'Editor de Markdown'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Exibe uma \00E1rea de texto que suporta entrada de markdown, com op\00E7\00F5es de formata\00E7\00E3o de texto, suporte para incluir imagens e uma op\00E7\00E3o de visualiza\00E7\00E3o para ver o texto formatado. O Editor de Markdown permite que voc\00EA escreva usando texto sem formata\00E7\00E3o')
||unistr(' f\00E1cil de ler e de escrever, depois o converta em HTML estruturalmente v\00E1lida usando as diversas op\00E7\00F5es fornecidas e a sintaxe suportada.')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4416)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Barra de Ferramentas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Oferece v\00E1rias op\00E7\00F5es para configurar a barra de ferramentas para o editor de markdown')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4416)
,p_display_sequence=>10
,p_display_value=>'Simples'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Exibe controles de formata\00E7\00E3o b\00E1sicos na barra de ferramentas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4416)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>unistr('Exibe um conjunto completo de controles de formata\00E7\00E3o na barra de ferramentas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4416)
,p_display_sequence=>40
,p_display_value=>'Nenhum'
,p_return_value=>'NONE'
,p_help_text=>'Oculta a barra de ferramentas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4416)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destaque de Sintaxe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se deve ser aplicado destaque de sintaxe para elementos de Markdown espec\00EDficos, como negrito, it\00E1lico, blocos de c\00F3digo, etc.</p>'),
unistr('<p>O destaque s\00F3 ocorrer\00E1 para conte\00FAdo com menos de 4.000 caracteres.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4416)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4416)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>Insira uma fun\00E7\00E3o JavaScript que tome um objeto de configura\00E7\00E3o para o Editor de Markdown, modifique o objeto e o retorne. Essa op\00E7\00E3o permite uma personaliza\00E7\00E3o avan\00E7ada da apar\00EAncia, funcionalidades e comportamento do Editor de Markdown, inclusiv')
||unistr('e barra de ferramentas, menus e a\00E7\00F5es.<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4416)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4416)
,p_name=>'markdownified'
,p_display_name=>'markdownified'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>'Alternar'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\00C9 exibido como uma op\00E7\00E3o de altern\00E2ncia.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valor Ativo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Digite o valor armazenado no item da p\00E1gina se o usu\00E1rio final selecionar a op\00E7\00E3o <strong>Ativado</strong>. O valor pode ter at\00E9 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Label Ativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite o texto exibido para a op\00E7\00E3o <strong>Ativado</strong>. Se nenhum texto for inserido, o label padr\00E3o do sistema ser\00E1 usado.'),
unistr('<p>Observa\00E7\00E3o: Se o ''Estilo de Exibi\00E7\00E3o'' da Defini\00E7\00E3o de Componente for <strong>Chave</strong>, esse atributo s\00F3 ser\00E1 usado como o valor de exibi\00E7\00E3o para colunas de Grade Interativa. Ele n\00E3o ser\00E1 exibido para itens de p\00E1gina normais.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valor Inativo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite o valor armazenado no item da p\00E1gina se o usu\00E1rio selecionar a op\00E7\00E3o <strong>Desativado</strong>. O valor pode ter at\00E9 255 caracteres.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Esse valor ser\00E1 usado se o item da p\00E1gina for preenchido com um valor que n\00E3o corresponda a <strong>Valor Ativado</strong> ou <strong>Valor Desativado</strong>.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Label Inativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite o texto exibido para a op\00E7\00E3o <strong>Desativado</strong>. Se nenhum texto for inserido, o label padr\00E3o do sistema ser\00E1 usado.'),
unistr('<p>Observa\00E7\00E3o: Se o ''Estilo de Exibi\00E7\00E3o'' da Defini\00E7\00E3o de Componente for <strong>Chave</strong>, esse atributo s\00F3 ser\00E1 usado como o valor de exibi\00E7\00E3o para colunas de Grade Interativa. Ele n\00E3o ser\00E1 exibido para itens de p\00E1gina normais.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>unistr('Estilo de exibi\00E7\00E3o')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4416)
,p_display_sequence=>5
,p_display_value=>'Alternar'
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4416)
,p_display_sequence=>10
,p_display_value=>unistr('Bot\00E3o Pill')
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4416)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4416)
,p_display_sequence=>20
,p_display_value=>'Selecionar Lista'
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Usar Padr\00F5es')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Se os padr\00F5es definidos para este componente ser\00E3o ou n\00E3o usados, em Componentes Compartilhados > Defini\00E7\00F5es de Componentes ou defini\00E7\00F5es personalizadas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor Ativo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Digite o valor armazenado no item da p\00E1gina se o usu\00E1rio selecionar a op\00E7\00E3o <strong>Ativado</strong>. O valor pode ter at\00E9 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Label Ativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite o texto exibido para a op\00E7\00E3o <strong>Ativado</strong>.'),
unistr('<p>Observa\00E7\00E3o: Se o ''Estilo de Exibi\00E7\00E3o'' da Defini\00E7\00E3o de Componente for <strong>Chave</strong>, esse atributo n\00E3o ter\00E1 efeito.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Valor Inativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Digite o valor armazenado no item da p\00E1gina se o usu\00E1rio selecionar a op\00E7\00E3o <strong>Desativado</strong>. Esse atributo tamb\00E9m poder\00E1 ser deixado em branco se voc\00EA quiser armazenar <code>NULL</code> quando a op\00E7\00E3o Desativado for selecionada. O valo')
||unistr('r pode ter at\00E9 255 caracteres.</p>'),
unistr('<p><em>Observa\00E7\00E3o: Esse valor ser\00E1 usado se o item da p\00E1gina for preenchido com um valor que n\00E3o corresponda a <strong>Valor Ativado</strong> ou <strong>Valor Desativado</strong>.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4416)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4416)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Label Inativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4416)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Digite o texto exibido para a op\00E7\00E3o <strong>Desativado</strong>.'),
unistr('<p>Observa\00E7\00E3o: Se o ''Estilo de Exibi\00E7\00E3o'' da Defini\00E7\00E3o de Componente for <strong>Chave</strong>, esse atributo n\00E3o ter\00E1 efeito.</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4416)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\00C1rea de Trabalho')
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4416
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4416)
,p_name=>'Mensagens'
,p_step_title=>'Mensagens'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4416)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
