prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4475
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4475 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4475
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103141504403761')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'pt-br'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4475)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113352'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4475)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4475)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4475)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4475)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4475)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4475)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.pt-br'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4475)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4475)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4475)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4475)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4475)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4475)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.pt-br'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4475)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4475)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4475)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4475)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4475)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4475)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.pt-br'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4475)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4475)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.pt-br'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4475)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4475)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.pt-br'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4475)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4475)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.pt-br'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4475)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4475)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4475)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.pt-br'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4475
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4475)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4475)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4475)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4475)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4475)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4475)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4475)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4475)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4475
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4475)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4475)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4475)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4475)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4475)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4475)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4475)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4475)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4475)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4475)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4475)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4475)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4475)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4475)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4475)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4475)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4475)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4475)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4475)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4475)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4475)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4475)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4475
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4475)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4475)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4475)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4475)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4475)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4475
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4475)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4475
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4475)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4475
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4475)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4475
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4475)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4475
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4475)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4475
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4475)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4475)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4475)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4475)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4475)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4475)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4475)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4475)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4475)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4475
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4475)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4475)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4475)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4475)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4475)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4475)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4475)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4475
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4475)
,p_page_name=>'winlov'
,p_page_title=>unistr('Caixa de Di\00E1logo Pesquisar')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Pesquisar'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Fechar'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('Pr\00F3ximo &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Anterior'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Linha(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4475
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4475)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4475
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4475)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4475)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4475)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4475)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4475)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4475)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4475)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4475)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4475)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4475)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4475)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4475)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4475)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4475)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4475)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4475)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4475)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4475)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4475)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4475)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4475)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4475)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4475)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4475)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4475)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4475)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4475)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4475)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4475)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4475)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4475)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4475)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4475)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4475)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4475)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4475)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4475)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4475)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4475)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4475)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4475)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4475)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4475)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4475)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4475)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4475)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4475)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4475)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4475)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4475)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4475)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4475)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4475)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4475)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4475)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4475)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4475)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4475)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4475)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4475)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4475)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4475)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4475)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4475)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4475)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4475)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4475)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4475)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4475)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4475)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4475)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4475)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4475)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4475)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4475)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4475)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4475)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4475)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4475)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4475)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4475)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4475)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4475)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4475)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4475)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4475)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4475)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4475)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4475)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4475)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4475)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4475)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4475)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4475)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4475)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4475)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4475)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4475)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4475)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4475)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4475)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4475)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4475)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4475)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4475)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4475)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4475)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4475)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4475)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4475)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4475)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4475)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4475)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4475)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4475)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4475)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4475)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4475)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4475)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4475)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4475)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4475)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4475)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4475)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4475)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4475)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4475)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4475)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4475)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4475)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4475)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4475)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4475)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4475)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4475)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4475)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4475)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4475)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4475)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4475)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4475)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4475)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4475)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4475)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4475)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4475)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4475)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4475)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4475)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4475)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4475)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4475)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4475)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4475)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4475)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4475)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4475)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4475)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4475)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4475)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4475)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4475)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4475)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4475)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4475)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4475)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4475)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4475)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4475)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4475)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4475)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4475)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973675493401350)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960736902401341)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>'Administrador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960643762401341)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017920367401382)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Acesso Negado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977689695401353)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Sua conta %0 foi criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963276610401343)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A conta est\00E1 bloqueada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953195143401335)
,p_name=>'AM_PM'
,p_message_language=>'pt-br'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087560816401433)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095673361401439)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'pt-br'
,p_message_text=>'(Ativo)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065142313401417)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'A chamada do Ajax retornou o erro de servidor %0 para %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995934832401366)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O alias do aplicativo "%0" n\00E3o pode ser convertido em um ID de aplicativo \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996086930401367)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O aplicativo com o alias "%0" n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985675699401359)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'ERR-1816 Erro inesperado ao converter o alias de aplicativo p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078598596401426)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A soma de verifica\00E7\00E3o do aplicativo fornece uma maneira f\00E1cil de determinar se o mesmo aplicativo \00E9 implantado nos espa\00E7os de trabalho. Voc\00EA pode comparar essa soma de verifica\00E7\00E3o para determinar se h\00E1 uma correspond\00EAncia. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971431392401349)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar fun\00E7\00E3o de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956876660401338)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar fun\00E7\00E3o de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120335220401457)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome do Tenant %0 retornado pelo Oracle Cloud Identity Management n\00E3o foi autorizado pelo dom\00EDnio %1!<br/><a href="&LOGOUT_URL.">Fa\00E7a log-in novamente</a> e especifique um nome de tenant autorizado ou altere seu URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954570362401336)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua conta "%0" n\00E3o tem os privil\00E9gios de desenvolvimento necess\00E1rios (DB_DEVELOPER ou DB_ADMINISTRATOR)<br/> para o espa\00E7o de trabalho "%1"! <a href="&LOGOUT_URL.">Fa\00E7a log-in novamente</a> ap\00F3s os privil\00E9gios serem fornecidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953673240401336)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome do Tenant retornado pelo Oracle Cloud Identity Management n\00E3o foi autorizado pelo espa\00E7o de trabalho atual! <br/><a href="&LOGOUT_URL.">re-login</a> e especifique um nome de tenant autorizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954672309401337)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Por motivos de seguran\00E7a, n\00E3o s\00E3o permitidos aplicativos em execu\00E7\00E3o deste espa\00E7o de trabalho por meio do dom\00EDnio do URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971184025401348)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pe\00E7a ao DBA que execute $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971015850401348)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O pacote SYS.DBMS_LDAP n\00E3o existe ou \00E9 inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970963056401348)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar fun\00E7\00E3o de edi\00E7\00E3o do usu\00E1rio LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971239363401348)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar autentica\00E7\00E3o LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972011766401349)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'pt-br'
,p_message_text=>'Erro no argumento p_flow_page para o procedimento log-in_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971639147401349)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('p_session inv\00E1lido em wwv_flow_custom_auth_std.log-in--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019576638401384)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'pt-br'
,p_message_text=>'Argumento incorreto para wwv_flow_custom_auth_std.log-in--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971788617401349)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome de usu\00E1rio nulo passado para o procedimento de log-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960546723401341)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'pt-br'
,p_message_text=>'Aguarde <span id="apex_login_throttle_sec">%0</span> segundos para acessar o sistema novamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961885096401342)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'A tentativa de log-in foi bloqueada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017329302401382)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autentica\00E7\00E3o "%0" n\00E3o encontrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962164556401342)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do grupo se seguran\00E7a \00E9 nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971592717401349)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao executar o processo de p\00F3s-autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971316752401349)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao executar o processo de pr\00E9-autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972556573401349)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Abra o URL no mesmo  browser em que iniciou a solicita\00E7\00E3o de Redefini\00E7\00E3o de Senha.  Se voc\00EA clicar no URL de Redefini\00E7\00E3o de Senha e for redirecionado para'),
unistr('a p\00E1gina de log-in, inicie a Redefini\00E7\00E3o de Senha novamente e saia do'),
'browser aberto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117802540401455)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir URL da Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954851986401337)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O grupo de consumidores do Resource Manager %0 n\00E3o foi concedido para %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954920678401337)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Use DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP para conceder o privil\00E9gio n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982954684401357)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar fun\00E7\00E3o de sentinela da sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983061333401357)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar fun\00E7\00E3o de verifica\00E7\00E3o da sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983290604401357)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pe\00E7a ao administrador do %0 que configure o mecanismo para o SSO do Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992794160401364)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'pt-br'
,p_message_text=>'%0 ilegal no token %1 retornado por sso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971993745401349)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Edite o esquema de autentica\00E7\00E3o e adicione o nome do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992439210401364)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'pt-br'
,p_message_text=>'Chamador ilegal do procedimento %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992607918401364)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o de aplicativo inv\00E1lida em token de urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992278460401364)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro em portal_sso_redirect: faltando informa\00E7\00F5es de registro do aplicativo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983194028401357)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O pacote WWSEC_SSO_ENABLER_PRIVATE n\00E3o existe ou \00E9 inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113971841362401349)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel localizar no esquema de autentica\00E7\00E3o o nome do aplicativo parceiro registrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992364587401364)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Registre este aplicativo conforme descrito no guia de instala\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983371947401357)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar autentica\00E7\00E3o SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092746816401437)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('URL N\00E3o Autorizado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982758856401357)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954716525401337)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Espa\00E7o de Trabalho "%0" est\00E1 inativo. Entre em contato com o administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955155225401337)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'pt-br'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961595095401341)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso negado pela verifica\00E7\00E3o de seguran\00E7a do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961608569401341)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso negado pela verifica\00E7\00E3o de seguran\00E7a da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961746224401342)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025126184401387)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'pt-br'
,p_message_text=>'Criado com %0 usando %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025225729401388)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'pt-br'
,p_message_text=>'amor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083010886401430)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o do Evento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082857179401429)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'pt-br'
,p_message_text=>'Data Final'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083157865401430)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'pt-br'
,p_message_text=>'ID do Evento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082727712401429)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'pt-br'
,p_message_text=>'Data Inicial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082931512401430)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Evento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973563892401350)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro no conte\00FAdo da soma de verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973424417401350)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro no formato da soma de verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037445802401397)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiado para a \00E1rea de transfer\00EAncia.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037178727401396)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este browser n\00E3o suporta c\00F3pia de um bot\00E3o ou menu. Tente Ctrl+C ou Comando+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025679574401388)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fechar Notifica\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081676720401429)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'pt-br'
,p_message_text=>'Contraste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076190849401425)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'pt-br'
,p_message_text=>'Atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076069310401425)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'pt-br'
,p_message_text=>'Inicial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080262448401428)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser uma cor v\00E1lida. Exemplo: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075963458401425)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Escolha uma cor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076266977401425)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar o formato da cor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115456933401453)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115532796401453)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de abertura para: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095728160401439)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(Conclu\00EDdo)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988062338401361)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'pt-br'
,p_message_text=>'Entre em contato com o administrador do seu aplicativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002477443401371)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Entre em contato com o administrador do seu aplicativo.',
unistr('Os detalhes sobre este incidente est\00E3o dispon\00EDveis via id de depura\00E7\00E3o "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080550169401428)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'pt-br'
,p_message_text=>'Corrija os erros antes de salvar.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026552066401389)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 correspond\00EAncias encontradas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026416755401388)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma correspond\00EAncia encontrada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096230239401439)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Andamento Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080907946401428)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo especificado no item %0 n\00E3o existe em APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069425184401420)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vers\00E3o atual dos dados contidos no banco de dados foi alterada desde que o usu\00E1rio iniciou o processo de atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038573399401397)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Carregar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085588652401431)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de pr\00E9-processamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085346361401431)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099437998401442)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia: A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085482805401431)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026956180401389)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Calend\00E1rio Popup: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949500645401333)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949680110401333)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085765475401432)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ter algum valor.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085688854401431)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser uma data v\00E1lida, por exemplo, %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953264936401336)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve estar entre %0 e %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953395100401336)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ser igual ou posterior a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953433386401336)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ser igual ou anterior a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030406276401391)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# \00E9 posterior \00E0 data m\00E1xima especificada %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030864525401392)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o corresponde ao formato %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030307615401391)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# \00E9 anterior \00E0 data m\00EDnima especificada %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030590142401392)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o est\00E1 na faixa v\00E1lida de %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030701359401392)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o est\00E1 dentro da faixa de anos v\00E1lida de %0 e %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080807099401428)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108041705401448)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110063129401449)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080660054401428)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'pt-br'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080755138401428)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986943868401360)
,p_name=>'APEX.ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954313020401336)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>'Ocorreu o seguinte erro ao executar o callback de tratamento de erro: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963056507401342)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorreu erro durante a pintura da p\00E1gina de erro: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955025420401337)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'pt-br'
,p_message_text=>'Erro Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094856931401438)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Entre em contato com o administrador.',
unistr('Os detalhes sobre este incidente est\00E3o dispon\00EDveis via id de depura\00E7\00E3o "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089101778401434)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O banco de dados est\00E1 aberto para acesso somente para leitura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119779467401457)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ORA-28353: Falha ao abrir a wallet. Dados do aplicativo n\00E3o acess\00EDveis atualmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089281579401434)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desculpe, esta p\00E1gina n\00E3o est\00E1 dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956715255401338)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es T\00E9cnicas (vis\00EDvel somente para desenvolvedores)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052870068401408)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Erro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066727419401418)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato esperado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033497465401394)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O usu\00E1rio j\00E1 est\00E1 na Lista de Controle de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033312998401394)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Confirme a adi\00E7\00E3o do(s) seguinte(s) %0 usu\00E1rio(s) \00E0 lista de controle de acesso <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033812843401394)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio duplicado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033500972401394)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falta uma arroba (@) no Endere\00E7o de e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033611984401394)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falta um ponto (.) no Endere\00E7o de e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033703519401394)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do usu\00E1rio muito longo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034073280401394)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Somente usu\00E1rios definidos na lista de controle de acesso do aplicativo podem acessar este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034117765401394)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Defini\00E7\00E3o de Controle de Acesso Inesperado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033976189401394)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todos os usu\00E1rios autenticados podem acessar este aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076751186401425)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076622246401425)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076967222401425)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0: Est\00E1 Desativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076864964401425)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0: Est\00E1 Ativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076593332401425)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o identificado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069650490401420)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026128267401388)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro Aplicado %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067211406401418)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952194317401335)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Barras')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079942166401427)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'pt-br'
,p_message_text=>'Outros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952292385401335)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico de Pizza')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078617432401427)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951913816401335)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067765750401419)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067840072401419)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067925624401419)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085179498401431)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna %1, referenciada pela faceta %0, est\00E1 indispon\00EDvel ou n\00E3o est\00E1 autorizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942344475401328)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Filtros a serem mostrados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024375533401387)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 resultados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024488301401387)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>'%0 selecionado(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027042440401389)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros atuais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943890641401329)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083624105401430)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>'Limite de valor distinto (%0) excedido para a faceta %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069237788401420)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para a faceta %0 em colunas DATE ou TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067357363401418)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtrar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067439253401418)
,p_name=>'APEX.FS.GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068834031401419)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'igual a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952930846401335)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('cont\00E9m %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952614069401335)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'pt-br'
,p_message_text=>'maior que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952771001401335)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'pt-br'
,p_message_text=>'maior ou igual a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952491177401335)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'pt-br'
,p_message_text=>'menor que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952505081401335)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'pt-br'
,p_message_text=>'menor ou igual a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952843868401335)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('come\00E7a com %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955338204401337)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o tipo de dados %0 (%1) na faceta Campo de Entrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945571874401330)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'pt-br'
,p_message_text=>'As facetas multivalor requerem bancos de dados 12.2 ou mais recentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069037205401419)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma coluna de pesquisa foi fornecida para a faceta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942434629401328)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'pt-br'
,p_message_text=>'Mais Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024589424401387)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio do Intervalo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068587589401419)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'%0 a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068617244401419)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'pt-br'
,p_message_text=>'Acima de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068768602401419)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'pt-br'
,p_message_text=>'Abaixo de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024647157401387)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'pt-br'
,p_message_text=>'Fim da Faixa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087460960401433)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O item #%2 ("%1") da LOV para a faceta de intervalo %0 \00E9 inv\00E1lido (falta o separador "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068911277401419)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento n\00E3o h\00E1 suporte para Entrada Manual para a faceta de Faixa %0, pois a coluna \00E9 DATE ou TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068275263401419)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952092570401335)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021197383401385)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067645370401418)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067554623401418)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068446250401419)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951835908401334)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mostrar Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068019289401419)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Menos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068169544401419)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Mais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114068328001401419)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'%0 estrelas ou mais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026059098401388)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Filtrar sugest\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069154716401420)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('No momento, s\00F3 h\00E1 suporte para a faceta %0 em colunas NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942210690401327)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem Total de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085232601401431)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o tipo de dados %0 (%1) na pesquisa facetada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077178528401425)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Ir para o erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034789605401395)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Agregar.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042398445401400)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'pt-br'
,p_message_text=>'Contrair controle de quebra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034888714401395)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Control-break.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042237700401400)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir controle de quebra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120942962401457)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042021368401400)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 linhas exclu\00EDdas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112470307401451)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'pt-br'
,p_message_text=>'Identidade duplicada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031763694401392)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035020595401395)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho do grupo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034997214401395)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031845809401393)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo(a)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051871738401407)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar Mais Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031532654401392)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035119667401395)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031944681401393)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032046402401393)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - %1 de %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088026890401433)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031612646401392)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112280575401451)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112328727401451)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>'Alterado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120718287401457)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0, Coluna %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120822295401457)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112173762401451)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exclu\00EDdo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035395882401395)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho de linha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030990087401392)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 c\00E9lulas selecionadas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032112588401393)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'%0 linhas selecionadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072493445401422)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042141958401400)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00E1gina %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035291714401395)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035496386401395)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Classificado em Ordem Crescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035576501401395)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Classificado em Ordem Decrescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031018600401392)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por Ordem Crescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031358398401392)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar em Ordem Crescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031136520401392)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por Ordem Decrescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031429955401392)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar em Ordem Decrescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114031283363401392)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Classificar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041959239401400)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Total %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968319878401346)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Houve falha na solicita\00E7\00E3o HTTP para "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109658474401449)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de Sele\00E7\00E3o de Grade %0 colunas %1 linhas. Use as teclas de seta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041837562401400)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista de Sele\00E7\00E3o %0 linhas. Use as teclas de seta.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120576001401457)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Grade Interativa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028639220401390)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029675925401391)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029506527401391)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114052649401452)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'pt-br'
,p_message_text=>'Agregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099510871401442)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agrega\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101231721401443)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057698805401411)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Colunas de Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058863210401412)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059989801401413)
,p_name=>'APEX.IG.AND'
,p_message_language=>'pt-br'
,p_message_text=>'e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079318342401427)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem Aproximada de Itens Diferentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115002707401453)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem Geral Aproximada de Itens Distintos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098181116401441)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1reas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100022043401442)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Crescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058958183401412)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114189676401452)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Autom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079732173401427)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114739111401453)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia Geral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097658552401440)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Eixo de Label')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097810284401440)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'pt-br'
,p_message_text=>'Casas Decimais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097721132401440)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Eixo de Valor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103820234401445)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Fundo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098211499401441)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054208179401409)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'pt-br'
,p_message_text=>'entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105078696401446)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'pt-br'
,p_message_text=>'Ambos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098324717401441)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'pt-br'
,p_message_text=>'Bolhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029819717401391)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059867674401413)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115651946401454)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('(Distin\00E7\00E3o entre Mai\00FAsculas e Min\00FAsculas)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086584174401432)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Altera\00E7\00F5es salvas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030260959401391)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060961145401414)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057439387401411)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua consulta ultrapassa o n\00FAmero m\00E1ximo de %0 pontos de dados por gr\00E1fico. Aplique um filtro para reduzir o n\00FAmero de registros de sua consulta base.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028591648401390)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View de Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035883481401395)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097172098401440)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Fechamento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104093253401445)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'pt-br'
,p_message_text=>'Cores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080104648401428)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059215353401412)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028720333401390)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105876114401446)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Finalidade da Coluna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059304924401412)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'pt-br'
,p_message_text=>'Complexo(a)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028927171401390)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054871423401409)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('cont\00E9m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061135993401414)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'pt-br'
,p_message_text=>'Quebra de Controle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035696207401395)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Copiar para \00C1rea de Transfer\00EAncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035734793401395)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Copiar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079158925401427)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079288999401427)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'pt-br'
,p_message_text=>'Contar Diferentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114962598401453)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem Geral de Itens Distintos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114888170401453)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem Global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112536859401451)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'pt-br'
,p_message_text=>'Criar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057847056401411)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105679426401446)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105259954401446)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086307156401432)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de Data Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055578800401410)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'pt-br'
,p_message_text=>'dias'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058588354401412)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es Padr\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058311230401412)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo Padr\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029717520401391)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106880826401447)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tem certeza de que deseja excluir este relat\00F3rio?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062961824401415)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061779173401414)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100185012401442)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Decrescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060686916401413)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Detalhe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028210868401390)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibi\00E7\00E3o Detalhada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088807560401434)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dire\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060340054401413)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054946538401409)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o cont\00E9m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055193919401409)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o come\00E7a com')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098436529401441)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'pt-br'
,p_message_text=>'Rosca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061349066401414)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960050938401340)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>'Somente Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107876881401448)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972605236401349)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Formato de Download %0 n\00E3o est\00E1 ativado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100862420401443)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agrega\00E7\00E3o Duplicada')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100928875401443)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'pt-br'
,p_message_text=>'Quebra de Controle Duplicada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062862351401415)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha Duplicada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061635723401414)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas Duplicadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029347413401391)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099997941401442)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111411782401450)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Grupo por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107402381401447)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3pia Oculta (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107698486401448)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107303832401447)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3pia (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107027364401447)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail enviado.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107516319401447)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Assunto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107283104401447)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Destinat\00E1rio (para)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060080838401413)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053251912401408)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'pt-br'
,p_message_text=>'igual a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106400280401447)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060128868401413)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106391433401447)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072378484401422)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'pt-br'
,p_message_text=>'Arquivo preparado. Iniciando o download.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114035962467401395)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'pt-br'
,p_message_text=>'Preencher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037020231401396)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de preenchimento com')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036952400401396)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Preenchimento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028873349401390)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059495673401413)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114445687401453)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtrar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100327715401442)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'pt-br'
,p_message_text=>'Primeiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029097228401390)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057916137401411)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104964053401446)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106730499401447)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'pt-br'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106674780401447)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'pt-br'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019495932401383)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'pt-br'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958715662401339)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'pt-br'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062570422401415)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'pt-br'
,p_message_text=>'Congelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060287591401413)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00F5es e Operadores')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098556364401441)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'pt-br'
,p_message_text=>'Funil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079054478401427)
,p_name=>'APEX.IG.GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053801593401408)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'pt-br'
,p_message_text=>'maior que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053918786401408)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'pt-br'
,p_message_text=>'Maior ou igual a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060571774401413)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'pt-br'
,p_message_text=>'Grade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028022033401390)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibi\00E7\00E3o em Grade')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101131736401443)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060797961401413)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028381740401390)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View Agrupar Por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105584208401446)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Condi\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104483371401445)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104697372401445)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alinhamento do Cabe\00E7alho')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114357528401453)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109800355401449)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voc\00EA pode inserir, atualizar e excluir dados diretamente dentro desta grade interativa.</p>'),
'',
unistr('<p>Insira uma nova linha clicando no bot\00E3o Adicionar Linha.</p>'),
'',
unistr('<p>Edite dados existentes clicando duas vezes em uma c\00E9lula espec\00EDfica. Para um trabalho de edi\00E7\00E3o de maior porte, clique em Editar para entrar no modo de edi\00E7\00E3o. No modo de edi\00E7\00E3o, voc\00EA pode clicar uma vez ou usar o teclado para editar c\00E9lulas espec')
||unistr('\00EDficas.</p>'),
'',
unistr('<p>Use o menu Alterar para duplicar e excluir linhas. Para ativar o menu Alterar, use as caixas de sele\00E7\00E3o para selecionar uma ou mais linhas.</p>'),
'',
'<p>Duplique uma linha selecionada clicando no menu Alterar e selecionando Duplicar Linhas. Exclua uma linha selecionada clicando no menu Alterar e selecionando Excluir Linha.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111993039401451)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recursos de Edi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112029890401451)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Uma grade interativa apresenta um conjunto de dados em um relat\00F3rio personaliz\00E1vel que pode ser pesquisado. Voc\00EA pode executar v\00E1rias opera\00E7\00F5es para limitar os registros retornados, e alterar a forma de exibi\00E7\00E3o dos dados.</p>'),
'',
unistr('<p>Use o campo Pesquisar para filtrar os registros retornados. Clique em A\00E7\00F5es para acessar v\00E1rias op\00E7\00F5es de modifica\00E7\00E3o do layout do relat\00F3rio, ou use os menus Cabe\00E7alho de Coluna nas colunas exibidas.</p>'),
'',
unistr('<p>Use Defini\00E7\00F5es de Relat\00F3rio para salvar suas personaliza\00E7\00F5es em um relat\00F3rio. Voc\00EA tamb\00E9m pode fazer download dos dados do relat\00F3rio para um arquivo externo ou enviar os dados por e-mail para voc\00EA mesmo ou outras pessoas.</p>'),
'',
'<p>Para saber mais, consulte "Using Interactive Grids" no <em>Oracle Application Express End User''s Guide</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111738742401451)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Vis\00E3o Geral')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109768716401449)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voc\00EA pode personalizar a grade interativa para exibir dados de v\00E1rias formas diferentes, usando os recursos incorporados.</p>'),
'',
unistr('<p>Use os menus de Cabe\00E7alho de Coluna ou o menu A\00E7\00F5es para determinar quais colunas ser\00E3o exibidas, em que sequ\00EAncia e as que ser\00E3o congeladas. Voc\00EA tamb\00E9m pode definir v\00E1rios filtros de dados e classificar os dados retornados.</p>'),
'',
unistr('<p>Use o bot\00E3o Exibir (adjacente ao campo Pesquisar) para acessar outras views de dados que podem ter sido definidas pelo desenvolvedor do aplicativo. Voc\00EA tamb\00E9m pode criar um gr\00E1fico ou ver um existente.</p>  '),
'',
unistr('<p><em>Observa\00E7\00E3o: Clique em <strong>Ajuda</strong> nas caixas de di\00E1logo da grade interativa para obter mais informa\00E7\00F5es detalhadas sobre a fun\00E7\00E3o selecionada.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111845193401451)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Recursos de Gera\00E7\00E3o de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061529174401414)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda da Grade Interativa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108651474401448)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para agregar colunas. Os valores agregados aparecem na parte inferior dos dados, ou ent\00E3o, caso as Quebras de Controle estejam definidas, na parte de baixo de cada quebra.</p>'),
'',
unistr('<p><strong>Lista de Agrega\00E7\00E3o</strong><br>'),
unistr('A lista de Agrega\00E7\00E3o exibe as agrega\00E7\00F5es definidas. Desative uma agrega\00E7\00E3o existente desmarcando-a.<br>'),
unistr('Clique em Adicionar ( &plus; ) para criar uma nova agrega\00E7\00E3o, ou em Excluir ( &minus; ) para remover uma agrega\00E7\00E3o existente.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de Agrega\00E7\00E3o</strong><br>'),
unistr('Use o form \00E0 direita para definir a agrega\00E7\00E3o.<br>'),
unistr('Selecione o nome da Coluna e o tipo de Agrega\00E7\00E3o.<br>'),
unistr('Opcionalmente, digite uma dica de ferramenta para a agrega\00E7\00E3o.<br>'),
unistr('Caso voc\00EA tenha definido uma Interrup\00E7\00E3o de Controle, a sele\00E7\00E3o de <strong>Mostrar Valor Geral</strong> exibir\00E1 o valor m\00E9dio, total ou similar geral, na parte de baixo dos dados.</p>'),
'',
unistr('<p><em>Observa\00E7\00E3o: Acesse a caixa de di\00E1logo Agrega\00E7\00E3o no menu A\00E7\00F5es ou clicando no cabe\00E7alho e na soma da coluna ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110823948401450)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda de Agrega\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109306835401449)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para definir um gr\00E1fico exibido como uma view de dados separada.<br>'),
unistr('Selecione um Tipo de gr\00E1fico e os atributos do gr\00E1fico.</p>'),
unistr('<p><strong>Atributos do Gr\00E1fico</strong></br>'),
unistr('Os atributos de gr\00E1fico dispon\00EDveis variam, dependendo do tipo de gr\00E1fico.</p>'),
'<p>',
'<ul>',
unistr('  <li>Selecione a coluna que cont\00E9m o valor para o atributo:'),
'    <ul>',
'      <li>Label - O texto para cada ponto de dados.</li>',
'      <li>Valor - Os dados a serem plotados.</li>',
unistr('      <li>S\00E9rie - Para definir sua consulta din\00E2mica multiss\00E9rie.</li>'),
unistr('      <li>Abertura - O pre\00E7o das a\00E7\00F5es na abertura do dia (Apenas a\00E7\00F5es).</li>'),
unistr('      <li>Fechamento - O pre\00E7o das a\00E7\00F5es no fechamento do dia (Apenas a\00E7\00F5es).</li>'),
unistr('      <li>Alta - O valor na alta (Apenas Intervalos e A\00E7\00F5es).</li>'),
unistr('      <li>Baixa - O valor na baixa (Apenas Intervalos e A\00E7\00F5es).</li>'),
unistr('      <li>Volume - O volume de a\00E7\00F5es di\00E1rio (Apenas a\00E7\00F5es).</li>'),
'      <li>Destino - O valor de destino (Apenas funil).</li>',
unistr('      <li>X - O valor do eixo x (Apenas Bolhas e Dispers\00E3o).</li>'),
unistr('      <li>Y - O valor do eixo y (Apenas Bolhas e Dispers\00E3o).'),
'      <li>Z - A largura da barra ou o raio da bolha (Apenas Barras, Bolhas e Intervalo).</li>',
'    </ul>',
'  </li>',
unistr('  <li>Orienta\00E7\00E3o - Vertical ou Horizontal.</li>'),
unistr('  <li>Agrega\00E7\00E3o - Selecione como agregar os valores do gr\00E1fico.</li>'),
unistr('  <li>Pilha - Especifique se os itens de dados s\00E3o empilhados.</li>'),
'  <li>Classificar por - Classificar pelo label ou pelo(s) valor(es).',
'    <ul>',
unistr('      <li>Dire\00E7\00E3o - Classificar em valores crescentes ou decrescentes.</li>'),
unistr('      <li>Nulos - Especifique como classificar registros com valores nulos em rela\00E7\00E3o a registros com valores n\00E3o nulos.</li>'),
'    </ul>',
'  </li>',
'  <li>Casas Decimais</li>',
unistr('  <li>T\00EDtulo do Eixo do Label</li>'),
unistr('  <li>T\00EDtulo do Eixo de Valores</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111264254401450)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda de Gr\00E1ficos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108362076401448)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para escolher quais colunas aparecer\00E3o e em que ordem.</p>'),
'',
unistr('<p>Oculte uma coluna cancelando sua sele\00E7\00E3o.<br>'),
'Reordene colunas clicando em Mover para Cima ( &uarr; ) ou Mover para Baixo ( &darr; ).<br>',
unistr('Use o seletor drop down para listar Todas as colunas, Colunas exibidas ou Colunas n\00E3o exibidas.</p>'),
'',
unistr('<p>Opcionalmente, use o form para especificar a largura m\00EDnima de uma coluna em pixels.</p>'),
'',
unistr('<p><em>Observa\00E7\00E3o: Voc\00EA tamb\00E9m pode reordenar colunas exibidas, clicando na al\00E7a de arrastar (no in\00EDcio do t\00EDtulo da coluna) e arrastando a coluna para a esquerda ou para a direita. Tamb\00E9m \00E9 poss\00EDvel alterar a largura de colunas exibidas, selecionand')
||unistr('o o separador de coluna, entre os t\00EDtulos, e movendo-o para a esquerda ou para a direita.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111168595401450)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108764697401448)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para definir colunas adicionais com base em c\00E1lculos matem\00E1ticos e funcionais executados com colunas existentes.</p>'),
'',
unistr('<p><strong>Lista de C\00E1lculos</strong><br>'),
unistr('A lista de C\00E1lculos exibe c\00E1lculos definidos. Desative um c\00E1lculo existente desmarcando-o.<br>'),
unistr('Clique em Adicionar ( &plus; ) para adicionar um novo c\00E1lculo ou em Excluir ( &minus; ) para remover um c\00E1lculo existente.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de C\00E1lculo</strong><br>'),
unistr('Use o form para definir o c\00E1lculo.<br>'),
unistr('Informe os detalhes da coluna, como cabe\00E7alho e label, e selecione as defini\00E7\00F5es de alinhamento.<br> '),
unistr('Use a \00E1rea de texto Express\00E3o para inserir a(s) coluna(s) e fun\00E7\00F5es associadas para o c\00E1lculo.<br>'),
unistr('Selecione o tipo de dados apropriado e, opcionalmente, uma m\00E1scara de formato, para a nova coluna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110721201401450)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda de C\00E1lculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109048449401449)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use esta caixa de di\00E1logo para definir uma quebra de controle em uma ou mais colunas.</p>'),
'',
'<p><strong>Lista de Quebras de Controle</strong><br>',
'A lista de Quebras de Controle exibe as quebras de controle definidas. Desative uma coluna de quebra de controle existente desmarcando-a.<br>',
'Clique em Adicionar ( &plus; ) para incluir uma nova coluna na quebra de controle ou em Excluir ( &minus; ) para remover uma coluna existente da quebra de controle.<br>',
unistr('Para reordenar colunas, clique em Mover para Cima ( &uarr; ) ou Mover para Baixo ( &darr; ) para mover a coluna selecionada para cima e para baixo em rela\00E7\00E3o \00E0s outras colunas.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es da Quebra de Controle</strong><br>'),
'Use o form para definir a coluna de quebra de controle.<br>',
unistr('Selecione uma coluna de quebra de controle, a dire\00E7\00E3o de classifica\00E7\00E3o e como ordenar colunas nulas (colunas sem valor).</p>'),
'',
unistr('<p><em>Observa\00E7\00E3o: Ao visualizar a grade interativa, voc\00EA pode definir uma quebra de controle clicando em um Cabe\00E7alho de Coluna e selecionando o \00EDcone de quebra de controle.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110427757401450)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Quebra de Controle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109216315401449)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para fazer download de todas as linhas atuais para um arquivo externo. O arquivo s\00F3 conter\00E1 as colunas exibidas no momento, usando quaisquer filtros e classifica\00E7\00F5es aplicados aos dados.</p>'),
'',
'<p>Selecione o formato do arquivo e clique em Fazer Download.<br>',
unistr('Observa\00E7\00E3o: O arquivo CSV n\00E3o inclui formata\00E7\00E3o de texto como agregados e quebras de controle.</p>'),
'',
unistr('<p>Para enviar o arquivo por e-mail, selecione Enviar como E-mail e digite os detalhes do e-mail (Destinat\00E1rio, Assunto e Mensagem).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110278279401449)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108437795401448)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para configurar filtros de dados que limitem as linhas retornadas.</p>'),
'',
'<p><strong>Lista de Filtros</strong><br>',
'A lista de Filtros exibe os filtros definidos. Desative um filtro existente desmarcando-o.<br>',
'Clique em Adicionar ( &plus; ) para criar um novo filtro, ou em Excluir ( &minus; ) para remover um filtro existente.</p>',
'',
unistr('<p><strong>Defini\00E7\00F5es de Filtro</strong><br>'),
'Use o form para definir as propriedades do filtro.<br>',
'Selecione o tipo de filtro apropriado:<br>',
unistr('&nbsp;&nbsp;&nbsp;Linha - filtra um termo em qualquer coluna filtr\00E1vel.<br>'),
'&nbsp;&nbsp;&nbsp;Coluna - filtra uma determinada coluna com um operador e valor especificados.<br>',
'',
unistr('<p><em>Observa\00E7\00E3o: ao exibir a grade interativa, voc\00EA pode definir filtros de linha digitando diretamente no campo Pesquisar. Clique em Selecionar Colunas a Serem Pesquisadas para limitar a pesquisa a uma coluna espec\00EDfica. Como alternativa, abra um ')
||unistr('menu Cabe\00E7alho da Coluna e selecione um valor para criar um filtro de coluna.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111079914401450)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108827830401448)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para ver os dados conforme existiam em um momento passado.</p>'),
unistr('<p>Insira o n\00FAmero de minutos no passado para executar a consulta de flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110619737401450)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111363120401450)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Grupamento por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108915168401449)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para destacar linhas ou colunas de dados com base na condi\00E7\00E3o informada.</p>'),
'',
'<p><strong>Lista de Destaque</strong><br>',
'A lista de Destaque exibe destaques definidos. Desative um destaque existente desmarcando-o.<br>',
'Clique em Adicionar ( &plus; ) para criar um novo destaque ou em Excluir ( &minus; ) para remover um destaque existente.</p>',
'',
unistr('<p><strong>Defini\00E7\00F5es de Destaque</strong><br>'),
'Use o form para definir as propriedades de destaque.<br>',
unistr('Informe o nome, selecione Linha ou Coluna e selecione os c\00F3digos de cor HTML para o plano de fundo e o texto.<br>'),
unistr('Selecione o <strong>Tipo de Condi\00E7\00E3o</strong> apropriado para destacar dados espec\00EDficos:<br>'),
'&nbsp;&nbsp;&nbsp;Linha - destaca o termo em qualquer coluna.<br>',
unistr('&nbsp;&nbsp;&nbsp;Coluna - destaca dentro de uma coluna espec\00EDfica com base no operador e valor especificados.<br>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110564549401450)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda de Destaque'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109192868401449)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para salvar altera\00E7\00F5es feitas no layout e na configura\00E7\00E3o da grade atual.<br>'),
unistr('Os desenvolvedores de aplicativos podem definir v\00E1rios layouts de relat\00F3rio alternativos. Onde for permitido, voc\00EA e outros usu\00E1rios finais podem salvar um relat\00F3rio como P\00FAblico, o que o disponibiliza para todos os outros usu\00E1rios da grade. Voc\00EA tam')
||unistr('b\00E9m pode salvar um relat\00F3rio como Privado, o qual somente voc\00EA possa ver.</p>'),
unistr('<p>Selecione entre os tipos dispon\00EDveis e digite um nome para o relat\00F3rio salvo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110353953401450)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ajuda de Relat\00F3rio'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108527821401448)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Use essa caixa de di\00E1logo para definir a ordem de exibi\00E7\00E3o.</p>'),
'',
unistr('<p><strong>Lista de Classifica\00E7\00E3o</strong><br>'),
unistr('A caixa de di\00E1logo Classificar exibe uma lista de regras de classifica\00E7\00E3o configuradas.<br>'),
unistr('Clique em Adicionar ( &plus; ) para criar uma coluna de classifica\00E7\00E3o ou em Excluir ( &minus; ) para remover uma coluna de classifica\00E7\00E3o.<br>'),
unistr('Clique em Mover para Cima ( &uarr; ) e Mover para Baixo ( &darr; ) para mover a coluna de classifica\00E7\00E3o selecionada para cima e para baixo em rela\00E7\00E3o \00E0s outras colunas de classifica\00E7\00E3o.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de Classifica\00E7\00E3o</strong><br>'),
unistr('Selecione uma coluna de classifica\00E7\00E3o, a dire\00E7\00E3o de classifica\00E7\00E3o e como ordenar as colunas nulas (colunas sem valor).</p>'),
'',
unistr('<p><em>Observa\00E7\00E3o: Os dados podem ser classificados por colunas que n\00E3o s\00E3o exibidas; todavia, nem todas as colunas podem ser classific\00E1veis.</em><br>'),
unistr('<em>As colunas exibidas podem ser classificadas pressionando as setas para cima (crescente) ou para baixo (decrescente) no final dos cabe\00E7alhos de coluna. Para adicionar uma coluna subsequente a uma classifica\00E7\00E3o existente, mantenha a tecla Shift pre')
||'ssionada e clique na seta para cima ou para baixo.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110981522401450)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda de Classifica\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114110167331401449)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda de Inscri\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062460938401415)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029214603401391)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097251393401440)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Alta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098051233401441)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'pt-br'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055432683401410)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'pt-br'
,p_message_text=>'horas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060470102401413)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028147150401390)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View do \00CDcone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053645237401408)
,p_name=>'APEX.IG.IN'
,p_message_language=>'pt-br'
,p_message_text=>'em'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062058317401414)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o Inativa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062147510401414)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es Inativas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069756704401420)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro interno durante o processamento da solicita\00E7\00E3o da Grade Interativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965548595401344)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o Tipo de Filtro de Coluna "%0" na coluna "%1".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109994003401449)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Data Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084192911401430)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Grade Interativa n\00E3o suporta a defini\00E7\00E3o de um filtro na coluna %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084013605401430)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 um tipo de filtro v\00E1lido para definir um filtro de Grade Interativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970676824401348)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de N\00FAmero Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112619650401451)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00E3o Inv\00E1lida')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112711239401451)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es Inv\00E1lidas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103768342401445)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A op\00E7\00E3o Classificar por foi definida como %0, mas nenhuma coluna foi selecionada para %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101018046401443)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096164325401439)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Exibido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054414955401409)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('no/a(s) \00FAltimo/a(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054698763401409)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('no(s) pr\00F3ximo(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053572484401408)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 vazio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053496689401408)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('est\00E1 vazio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104585382401445)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096540201401439)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100466316401442)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo(a)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043769264401401)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo Dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043950411401401)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044464720401402)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo Minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043433228401401)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EAs Passado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043521888401401)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'pt-br'
,p_message_text=>'Semana Passada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043648783401401)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimos %0 Dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043848233401401)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimas %0 Horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044560014401402)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00DAltimos Minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044397913401401)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00DAltimos Meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044232817401401)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00DAltimas Semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043224403401401)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimos %0 Anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043393824401401)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Ano Passado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104717376401445)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Alinhamento de C\00E9lulas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104871183401446)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'pt-br'
,p_message_text=>'Usar Grupo para'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054045342401409)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'pt-br'
,p_message_text=>'menor que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054100963401409)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'pt-br'
,p_message_text=>'Menor ou igual a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098661953401441)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098795737401441)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105130319401446)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'pt-br'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097381130401440)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Baixa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107715983401448)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Separe v\00E1rios endere\00E7os com v\00EDrgulas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055238261401409)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('corresponde \00E0 express\00E3o regular')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079685690401427)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115299270401453)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo Geral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079894292401427)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'pt-br'
,p_message_text=>'Mediano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115333195401453)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>'Mediano Geral'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079504782401427)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055347857401409)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>'minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080382907401428)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Minutos atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115195493401453)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo Geral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055766203401410)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>'meses'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062386467401415)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados cont\00EAm mais de %0 linhas, o que ultrapassa o m\00E1ximo permitido. Aplique filtros adicionais para ver os resultados.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089090653401434)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID Est\00E1tico da Regi\00E3o deve ser especificado porque a p\00E1gina cont\00E9m diversas Grades Interativas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058456387401412)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058637815401412)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Nomeado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042637190401400)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042402194401400)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima Hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044694758401402)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042927359401400)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo M\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042868573401400)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima Semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042767867401400)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximos %0 Dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114042565617401400)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximas %0 Horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044724336401402)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Pr\00F3ximos Minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044053394401401)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Pr\00F3ximos Meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044193982401401)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 Pr\00F3ximas Semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043128034401401)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximos %0 Anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114043052872401401)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054306091401409)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 entre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053388797401408)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o igual a')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119542462401456)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A regi\00E3o com o ID %0 n\00E3o \00E9 uma regi\00E3o de Grade Interativa ou n\00E3o existe no aplicativo %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053723936401408)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o contido em')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054568487401409)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 no/a(s) \00FAltimo/a(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114054769543401409)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 no(s) pr\00F3ximo(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062221720401414)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum dado encontrado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100200611401442)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'pt-br'
,p_message_text=>'Nulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105334389401446)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Num\00E9rico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100588711401442)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100644411401442)
,p_name=>'APEX.IG.ON'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052538167401407)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 1 minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108255650401448)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'pt-br'
,p_message_text=>'Abrir Seletor de Cores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097026923401440)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Abertura'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059523792401413)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Operador'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096410960401439)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098800110401441)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'pt-br'
,p_message_text=>'Pizza'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114060844768401414)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114028436605401390)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibi\00E7\00E3o de Tabela Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114108177155401448)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'pt-br'
,p_message_text=>'Separe os valores com por "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114098909472401441)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'pt-br'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104272962401445)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'pt-br'
,p_message_text=>'Centro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104368971401445)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'pt-br'
,p_message_text=>'Fim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114104118831401445)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058723522401412)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059030832401412)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Prim\00E1rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075579622401424)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Prim\00E1rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957707598401339)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir Tags de Acessibilidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956461870401338)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Paisagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956504970401338)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'pt-br'
,p_message_text=>'Retrato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956376770401338)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956201669401338)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'pt-br'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956104968401338)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'pt-br'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957883265401339)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955990619401337)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Of\00EDcio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955818992401337)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'pt-br'
,p_message_text=>'Carta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956076358401338)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'pt-br'
,p_message_text=>'Tabloide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955778468401337)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tamanho da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945914997401330)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'pt-br'
,p_message_text=>'Remover RTF (Rich Text Format)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099009175401441)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'pt-br'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099138593401441)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'pt-br'
,p_message_text=>'Intervalo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109411525401449)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063028530401415)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061841515401414)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067011150401418)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A regi\00E3o da Grade Interativa n\00E3o existe no aplicativo %0, p\00E1gina %1 e regi\00E3o %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029905199401391)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'pt-br'
,p_message_text=>'Remover %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058186970401412)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118782373401456)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio exclu\00EDdo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118460581401456)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio alternativo salvo para todos os usu\00E1rios')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118302224401456)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio padr\00E3o salvo para todos os usu\00E1rios')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118655670401456)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio privado salvo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118527831401456)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio p\00FAblico salvo para todos os usu\00E1rios')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114067150426401418)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Grade Interativa salva com o nome %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052442742401407)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados do relat\00F3rio %0 minutos atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052382951401407)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados do relat\00F3rio h\00E1 1 minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992035997401364)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Relat\00F3rio da Grade Interativa n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111649371401451)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio - Editar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066931255401418)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Grade Interativa salva com o ID %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114111559640401450)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio - Salvar como')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030003991401391)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119609625401457)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Grade Interativa salva com o ID est\00E1tico %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114536707401453)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View de Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029163611401391)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063137910401415)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reverter Altera\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061906642401414)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Reverter Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059175220401412)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058020568401412)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Por P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119208932401456)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es de Linha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120405125401457)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es da linha %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114029419552401391)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072151587401422)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'pt-br'
,p_message_text=>'salvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027630787401389)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios Salvos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027796043401389)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002202154401371)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('J\00E1 existe um relat\00F3rio salvo chamado %0. Digite um novo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027830710401390)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'pt-br'
,p_message_text=>'Privado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027941565401390)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00FAblico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114232004401452)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar como'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061213389401414)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Defini\00E7\00F5es do Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099246886401441)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dispers\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027524992401389)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106527279401447)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa: Todas as Colunas de Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027471466401389)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105760402401446)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisa: Texto Completo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052253568401407)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'pt-br'
,p_message_text=>'Procurar ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095833472401439)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036096161401396)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088798607401434)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecione 1 linha na regi\00E3o mestra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027351762401389)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar colunas para pesquisa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118901346401456)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es de Sele\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036206912401396)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de C\00E9lula')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036162910401396)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sele\00E7\00E3o de Linhas')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107113643401447)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar como E-mail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099699221401442)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00E9rie ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025398777401388)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077953081401426)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Valor Geral'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062737159401415)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View de Uma Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061024658401414)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099755087401442)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119384864401456)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA s\00F3 pode definir uma classifica\00E7\00E3o por coluna.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119175402401456)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114100743399401443)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'pt-br'
,p_message_text=>'Pilha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055029247401409)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('come\00E7a com')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099304073401442)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020391960401384)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Estender Largura de Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114061473291401414)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114079441474401427)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'pt-br'
,p_message_text=>'Soma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120606062401457)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Grade Interativa. Relat\00F3rio: %0, View: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114114687257401453)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'pt-br'
,p_message_text=>'Soma Geral'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097541483401440)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Destino'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103947512401445)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cor do Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030152500401391)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077842525401426)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'pt-br'
,p_message_text=>'Dica de Ferramenta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114058235911401412)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114062628989401415)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'pt-br'
,p_message_text=>'Descongelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059728739401413)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'pt-br'
,p_message_text=>'Unidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106956501401447)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Existem altera\00E7\00F5es n\00E3o salvas. Deseja continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114059665729401413)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096614248401439)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101509494401443)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 obrigat\00F3rio um valor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086427014401432)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor (o fuso hor\00E1rio n\00E3o pode ser alterado)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105415835401446)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'pt-br'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097937441401440)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'pt-br'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057784773401411)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095976723401439)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'pt-br'
,p_message_text=>'Exibido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114097426365401440)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055628791401410)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>'semanas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096012686401439)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Largura M\00EDnima da Coluna (Pixel)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046827806401403)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'pt-br'
,p_message_text=>'%0 entre %1 e %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046500049401403)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 cont\00E9m %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046644902401403)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o cont\00E9m %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024748272401387)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o come\00E7a com %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045343146401402)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'pt-br'
,p_message_text=>'%0 igual a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045583613401402)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'pt-br'
,p_message_text=>'%0 maior que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045652094401402)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'pt-br'
,p_message_text=>'%0 maior que ou igual a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046389768401403)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'pt-br'
,p_message_text=>'%0 em %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047552094401404)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 \00FAltimos dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047372638401404)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nas %1 \00FAltimas horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047129890401403)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 \00FAltimos minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047994563401404)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 \00FAltimos meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047788721401404)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nas %1 \00FAltimas semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048181030401404)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 \00FAltimos anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047492875401404)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no \00FAltimo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047200199401404)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 na \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047069792401403)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no \00FAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047886766401404)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no \00FAltimo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114047671386401404)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 na \00FAltima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048023542401404)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no \00FAltimo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049972665401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 pr\00F3ximos dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049704863401405)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nas %1 pr\00F3ximas horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049527285401405)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 pr\00F3ximos minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050328001401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 pr\00F3ximos meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050181297401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nas %1 pr\00F3ximas semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050578493401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 nos %1 pr\00F3ximos anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049862792401405)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no pr\00F3ximo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049661471401405)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 na pr\00F3xima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049439528401405)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050252332401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no pr\00F3ximo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050009428401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 na pr\00F3xima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050475378401406)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 no pr\00F3ximo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046098047401403)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 vazio(a)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045982289401403)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 est\00E1 vazio(a)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045741418401402)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'pt-br'
,p_message_text=>'%0 menor que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045876768401403)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'pt-br'
,p_message_text=>'%0 menor que ou igual a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046118643401403)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00E9 semelhante a %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046737428401403)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 corresponde \00E0 express\00E3o regular %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052684770401407)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 %0 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046999736401403)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 entre %1 e %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045409731401402)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00E9 diferente de %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046443951401403)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o em %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048779426401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 \00FAltimos dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048599913401404)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas %1 \00FAltimas horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048338665401404)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 \00FAltimos minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049195974401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 \00FAltimos meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048913374401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas %1 \00FAltimas semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049333141401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 \00FAltimos anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048635927401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048454238401404)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048232018401404)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049009873401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114048817620401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na \00FAltima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114049209502401405)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051145713401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 pr\00F3ximos dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050989660401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas %1 pr\00F3ximas horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050747674401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 pr\00F3ximos minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051591571401407)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 pr\00F3ximos meses ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051378377401407)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas %1 pr\00F3ximas semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051706489401407)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos %1 pr\00F3ximos anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051073746401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050880785401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114050630426401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051495610401407)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051234075401406)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na pr\00F3xima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051640596401407)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114046270778401403)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 semelhante a %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053163675401408)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 come\00E7a com %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096768791401440)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055884007401410)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'pt-br'
,p_message_text=>'anos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096851869401440)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096959750401440)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114105927022401446)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'pt-br'
,p_message_text=>'Segunda-feira, 12 de janeiro de 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106046012401446)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'pt-br'
,p_message_text=>'Janeiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106171408401446)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('16 horas atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114106293765401447)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'pt-br'
,p_message_text=>'em 16h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961249596401341)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de arquivo inv\00E1lido. Tipos de arquivos suportados: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088147901401433)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'pt-br'
,p_message_text=>'Navegar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087889296401433)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Arquivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087960253401433)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Arquivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961053549401341)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Arrastar e Soltar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961428390401341)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Arrastar e Soltar Arquivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962649791401342)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione um arquivo ou solte um aqui.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962712276401342)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione ou solte arquivos aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962880109401342)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione um arquivo ou solte um aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962994690401342)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'pt-br'
,p_message_text=>'Selecione ou solte arquivos aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961384029401341)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'%0 arquivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961161037401341)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo \00E9 muito grande. O tamanho m\00E1ximo \00E9 de %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948984728401332)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o obrigat\00F3rio.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947887563401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'pt-br'
,p_message_text=>'Cidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948295598401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo do Pa\00EDs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947981517401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero da Casa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948809177401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'pt-br'
,p_message_text=>'Latitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948747680401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'pt-br'
,p_message_text=>'Longitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948671651401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar no Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948336389401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pontua\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948008461401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo Postal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948155397401332)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'pt-br'
,p_message_text=>'Estado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947772542401331)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'pt-br'
,p_message_text=>'Rua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947683827401331)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Resultados da Geocodifica\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960217498401341)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'pt-br'
,p_message_text=>'Geocodificado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960340568401341)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Geocodificado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948525077401332)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113948441625401332)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhum endere\00E7o foi encontrado.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949029116401332)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 \00E9 obrigat\00F3rio.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118860358401456)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Texto da Ajuda: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012203825401378)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'pt-br'
,p_message_text=>'Marcado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012326644401378)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'pt-br'
,p_message_text=>'Desmarcado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958201303401339)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o est\00E1 na faixa v\00E1lida de %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958370497401339)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o \00E9 m\00FAltiplo de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957944555401339)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve corresponder aos valores %0 e %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958166528401339)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036435437401396)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036522378401396)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958038392401339)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941428809401327)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Entrada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070605592401421)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070774044401421)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941557365401327)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'pt-br'
,p_message_text=>'Entradas selecionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074417725401423)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Avan\00E7ado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074726103401424)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074568844401424)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'pt-br'
,p_message_text=>'Comum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074886227401424)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo ao Vivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075414910401424)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As Op\00E7\00F5es de Modelo n\00E3o est\00E3o dispon\00EDveis porque este componente n\00E3o foi processado na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074372903401423)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma Op\00E7\00E3o de Modelo encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074662329401424)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949952560401333)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover C\00EDrculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951798025401334)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os Estilos Personalizados n\00E3o s\00E3o JSON v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950219972401333)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ferramenta de Dist\00E2ncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950038094401333)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Desenhar C\00EDrculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942620558401328)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Pesquisa Facetada requer uma Origem de Dados no n\00EDvel de regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945209190401330)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Localiza\00E7\00E3o Atual')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946378204401330)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As coordenadas da posi\00E7\00E3o inicial s\00E3o inv\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943725287401329)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A posi\00E7\00E3o inicial deve ser uma geometria de ponto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946187764401330)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'pt-br'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944701970401329)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'pt-br'
,p_message_text=>'Camada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078012566401426)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Camada: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949343697401333)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'pt-br'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942511585401328)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagens'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946205087401330)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'pt-br'
,p_message_text=>'milhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077094022401425)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados cont\00EAm mais de %0 linhas, o que ultrapassa o m\00E1ximo permitido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944537755401329)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Termos</a> &nbsp;&nbsp; Dados do mapa &copy; 2017 AQUI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943478592401328)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de dados SDO_GEOMETRY n\00E3o est\00E1 dispon\00EDvel neste banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944667812401329)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Colaboradores OpenStreetMap </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944858234401329)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'pt-br'
,p_message_text=>'Pontos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078178347401426)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'%0 Pontos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950138415401333)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Zoom com Ret\00E2ngulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949806608401333)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945146964401330)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir Dire\00E7\00E3o para Norte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025449706401388)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternar para o modo 2D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025553947401388)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternar para o modo 3D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949794758401333)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Alternar Aviso de Copyright'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950333579401333)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dist\00E2ncia Total')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944900051401329)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'pt-br'
,p_message_text=>'Ampliar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945091205401330)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'pt-br'
,p_message_text=>'Reduzir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072556795401422)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'pt-br'
,p_message_text=>'Negrito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073448177401423)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Imagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073011081401422)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00F3digo em Linha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086672607401432)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir Imagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086722600401432)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Inserir Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072601182401422)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('It\00E1lico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087313757401433)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'pt-br'
,p_message_text=>'Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073381617401423)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073261374401423)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista Ordenada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072748620401422)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072854008401422)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>'Nada a Ser Visualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072959891401422)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'pt-br'
,p_message_text=>'Tachado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073117206401422)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Lista N\00E3o Ordenada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052022208401407)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'pt-br'
,p_message_text=>'atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114109589019401449)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Mais...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114051963438401407)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Carregando'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083733490401430)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Mensagem de Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057056358401411)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero menor ou igual a %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057171081401411)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero v\00E1lido.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057289241401411)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# n\00E3o corresponde ao formato de n\00FAmero %0 (Exemplo: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056981685401411)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero maior ou igual a %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056853986401411)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero entre %0 e %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052103031401407)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'pt-br'
,p_message_text=>'aberta em nova janela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005314525401373)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina j\00E1 foi submetida e n\00E3o pode ser ressubmetida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987909228401361)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo "%0" P\00E1gina "%1" n\00E3o encontradas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021795004401385)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'#LABEL# deve ter algum valor.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965026751401344)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071026396401421)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070991699401421)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'pt-br'
,p_message_text=>'Localizar%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071264665401421)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071191656401421)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957124189401338)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'pt-br'
,p_message_text=>'Digite um termo de pesquisa com pelo menos %0 caracteres.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026688099401389)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Lista de Valores Popup: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957213783401338)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'pt-br'
,p_message_text=>'Digite um termo para pesquisa.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957008317401338)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum resultado encontrado.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956985289401338)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044886026401402)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar Termo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070810882401421)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081585475401429)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'pt-br'
,p_message_text=>'Processando'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955500037401337)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar \00E0 Tela Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951504341401334)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Parece que, no momento, seu dispositivo ou browser n\00E3o suporta a instala\00E7\00E3o de Aplicativos Web Progressivos.</p>'),
unistr('    <p class="a-pwaDialog-intro">Se esse aplicativo j\00E1 estiver instalado no seu dispositivo, abra-o pela tela inicial.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951132276401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo. Adicione-o \00E0 sua tela inicial para us\00E1-lo em tela cheia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Menu</strong> na \00E1rea de navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque em <strong>Instalar</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong>Adicionar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951245544401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo, cuja experi\00EAncia melhor \00E9 no Chrome ou Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Menu</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque em <strong>Instalar</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950809377401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo, cuja experi\00EAncia melhor \00E9 no Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Compartilhar</strong> na \00E1rea de navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque em <strong>Abrir no Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950595323401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo. Adicione-o \00E0 sua tela inicial para obter a melhor experi\00EAncia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Compartilhar</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Toque em <strong>Adicionar \00E0 Tela Inicial</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong style="color:#007AE1;">Adicionar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950407793401333)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo. Adicione-o \00E0 sua tela inicial para obter a melhor experi\00EAncia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Compartilhar</strong> na \00E1rea de navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Role para baixo e toque em <strong>Adicionar \00E0 Tela Inicial</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong style="color:#007AE1;">Adicionar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945430108401330)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo. Adicione-o \00E0 sua tela inicial para obter a melhor experi\00EAncia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Mais</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Toque em <strong>Adicionar \00E0 Tela Inicial</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong style="color:#007AE1;">Adicionar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950769136401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo. Adicione-o \00E0 sua tela inicial para obter a melhor experi\00EAncia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Toque no \00EDcone <strong>Compartilhar</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toque em <strong>Abrir no Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950627860401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo. Adicione-o \00E0 sua tela inicial para obter a melhor experi\00EAncia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Toque no \00EDcone <strong>Compartilhar</strong> na \00E1rea de navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toque em <strong>Abrir no Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951408141401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo, cuja experi\00EAncia melhor \00E9 no Chrome .</p>'),
unistr('    <p class="a-pwaDialog-intro">No momento, o Firefox n\00E3o suporta a instala\00E7\00E3o de aplicativos Web.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113950928276401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo, cuja experi\00EAncia melhor \00E9 no Chrome ou Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">No momento, o Firefox n\00E3o suporta a instala\00E7\00E3o de aplicativos Web no macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951040886401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo, cuja experi\00EAncia melhor \00E9 no Chrome ou Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">No momento, o Safari n\00E3o suporta a instala\00E7\00E3o de aplicativos Web no macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951336148401334)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este site tem funcionalidade de aplicativo, cuja experi\00EAncia melhor \00E9 no Chrome ou Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">No momento, o Firefox n\00E3o suporta a instala\00E7\00E3o de aplicativos Web no Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953881957401336)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>N\00E3o \00E9 poss\00EDvel estabelecer conex\00E3o</h1>'),
unistr('    <p>Voc\00EA precisa de uma conex\00E3o \00E0 internet para usar este aplicativo.</p>'),
'    <button type="button">Tentar Novamente</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953791011401336)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel estabelecer conex\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093575055401437)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037983973401397)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'pt-br'
,p_message_text=>'Um Dia Inteiro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116838045401455)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar Convite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116681682401454)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039765015401398)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View di\00E1ria para o dia todo ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039590523401398)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View Di\00E1ria de dados com hora ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084445491401431)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'pt-br'
,p_message_text=>'Dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078894088401427)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969435530401347)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'pt-br'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969259023401347)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'pt-br'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969124621401347)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'pt-br'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969389648401347)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'pt-br'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968853203401347)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969017850401347)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116703173401454)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'pt-br'
,p_message_text=>'Convite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084510822401431)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084285810401430)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087057231401432)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101394564401443)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117028161401455)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'pt-br'
,p_message_text=>'Edite um Evento Existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116993663401455)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'pt-br'
,p_message_text=>'Enviando um convite por e-mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087110602401433)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095142904401438)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094948101401438)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117760580401455)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Todos os campos s\00E3o obrigat\00F3rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117644086401455)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar Convite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116529494401454)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Assunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095006984401438)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'pt-br'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968954715401347)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092864368401437)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'pt-br'
,p_message_text=>'Form em %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039371066401398)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'pt-br'
,p_message_text=>'Tempo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087231913401433)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'pt-br'
,p_message_text=>'Hoje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085099147401431)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084349097401431)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'pt-br'
,p_message_text=>'Semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039608765401398)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'pt-br'
,p_message_text=>'View semanal para o dia todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039470722401398)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'pt-br'
,p_message_text=>'View Semanal de dados com hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084971655401431)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084604994401431)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084789189401431)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016859775401382)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'pt-br'
,p_message_text=>'Voltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963181230401343)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965214379401344)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114084873723401431)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'pt-br'
,p_message_text=>'Carregar mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086950398401432)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID de Regi\00E3o %0 n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965122083401344)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados N\00E3o Encontrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989277423401362)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel redefinir pagina\00E7\00E3o de regi\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957492471401339)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao definir pagina\00E7\00E3o da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078296251401426)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086841303401432)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o Tipo de Regi\00E3o %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957372391401338)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao renderizar a regi\00E3o "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021800229401385)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'#COLUMN_HEADER# deve ter algum valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116186021401454)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'%0, editor RTF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023949508401387)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A marca\00E7\00E3o HTML Rich Text excede o tamanho m\00E1ximo do item (real %0, permitido %1 caracteres)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083808963401430)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075601141401424)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'pt-br'
,p_message_text=>'Duplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073947301401423)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas Exibidas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073864128401423)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Valores Nulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083950610401430)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037553975401397)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Mover para Baixo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037679210401397)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'pt-br'
,p_message_text=>'Mover para Cima'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073652798401423)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074281334401423)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Outras Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073722669401423)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074039473401423)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074133715401423)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0 de %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075705838401424)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075856484401424)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Reverter Altera\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114073522040401423)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu Defini\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034542345401394)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Por exemplo, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942056675401327)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'pt-br'
,p_message_text=>'Acessar Novamente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941977670401327)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('sua sess\00E3o foi finalizada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942121569401327)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'pt-br'
,p_message_text=>'Estender'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941732584401327)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua sess\00E3o vai terminar \00E0s %0. Deseja estend\00EA-la?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941895789401327)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua sess\00E3o vai terminar \00E0s %0 e n\00E3o pode ser estendida. Salve todos os trabalhos agora para evitar perda de dados.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094768202401438)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar c\00F3digo de limpeza de sess\00E3o do banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987818823401361)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar c\00F3digo de configura\00E7\00E3o de sess\00E3o do banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113961968226401342)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('sua sess\00E3o foi finalizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093639400401437)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Feche esta caixa de di\00E1logo e pressione o bot\00E3o de recarregar o seu browser para obter uma nova sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112941642401451)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Clique <a href="%0">aqui</a> para criar uma nova sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999587322401369)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sess\00E3o N\00E3o V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039065182401398)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma Atribui\00E7\00E3o Din\00E2mica poder ser ativada na sess\00E3o Seguran\00E7a Real do Aplicativo para o usu\00E1rio "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985768474401359)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-99900 N\00E3o foi poss\00EDvel criar ID de sess\00E3o \00FAnico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002004257401371)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Viola\00E7\00E3o de prote\00E7\00E3o de estado de sess\00E3o. Isso pode ser causado por uma altera\00E7\00E3o manual do item %0 de p\00E1gina protegido. Se n\00E3o estiver certo quanto ao que causou este erro, entre em contato com o administrador da publica\00E7\00E3o para obter ajuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121147170401458)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Viola\00E7\00E3o de prote\00E7\00E3o da p\00E1gina: isso pode ser causado pela submiss\00E3o de uma p\00E1gina que ainda n\00E3o tinha terminado de carregar ou pela altera\00E7\00E3o manual de itens de p\00E1gina protegidos. Para obter ajuda, entre em contato com o administrador do aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120116615401457)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 cont\00E9m um dos seguintes caracteres inv\00E1lidos &<>"/;,*|=% ou --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120273997401457)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 cont\00E9m um dos seguintes caracteres inv\00E1lidos &<>"/;,*|=% ou -- ou nova linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119909724401457)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 cont\00E9m caracteres especiais. Somente os caracteres de a-Z, 0-9 e espa\00E7os s\00E3o permitidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114120047468401457)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 cont\00E9m <, > ou " que s\00E3o caracteres inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964195478401343)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi fornecida uma checksum para o procedimento de exibi\00E7\00E3o de uma p\00E1gina que requer uma checksum quando um ou mais valores de solicita\00E7\00E3o, limpeza de cache ou argumento s\00E3o especificados como argumentos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996938386401367)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Viola\00E7\00E3o de prote\00E7\00E3o de estado de sess\00E3o. Isso pode ser causado por uma altera\00E7\00E3o manual de um URL que cont\00E9m uma checksum ou pela utiliza\00E7\00E3o de um link com uma checksum incorreta ou que n\00E3o foi encontrada. Se n\00E3o estiver certo quanto ao que causou e')
||unistr('ste erro, entre em contato com o administrador da publica\00E7\00E3o para obter ajuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114074934677401424)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'pt-br'
,p_message_text=>'Desativar Modo de Contraste Elevado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075014947401424)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Modo de Contraste Elevado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993670800401365)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993860952401365)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Para Baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993926452401365)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994064207401365)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Mover Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994190329401365)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994298268401365)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994373279401365)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993577665401365)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993735694401365)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'pt-br'
,p_message_text=>'Para Cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102641880401444)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103338270401444)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102507680401444)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103433415401444)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102386836401444)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103505623401445)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102974662401444)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103162057401444)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102423672401444)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103281456401444)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102700775401444)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103624821401445)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102872370401444)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114103019850401444)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'em %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942961402401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'pt-br'
,p_message_text=>'[Linha]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943379250401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('[V\00E1rias Linhas]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943145011401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('[V\00E1rios Pontos]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943550297401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('[V\00E1rios Pol\00EDgonos]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943677385401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'pt-br'
,p_message_text=>'[Objeto de Geometria]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942817222401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'pt-br'
,p_message_text=>'[Ponto (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943081172401328)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('[Pol\00EDgono]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020293390401384)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Contrair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020185429401384)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Restaurar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066633705401418)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apagar Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056579156401410)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na faixa de classifica\00E7\00E3o v\00E1lida de 1 a %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056612466401410)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052713053401408)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'pt-br'
,p_message_text=>'Mensagem de Sucesso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115834602401454)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115770523401454)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101443456401443)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barra de Ferramentas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116240197401454)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Expandir / Recolher Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116321200401454)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir / Recolher Coluna Lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025989860401388)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Navega\00E7\00E3o Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032936649401393)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'pt-br'
,p_message_text=>'1 dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032735424401393)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'pt-br'
,p_message_text=>'1 hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033007955401393)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032823324401393)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032610479401393)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>'%0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033294521401393)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114033126007401393)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'pt-br'
,p_message_text=>'1 semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119452137401456)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('In\00EDcio da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981411059401356)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955232300401337)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao processar solicita\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034654719401395)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117595916401455)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aguarde at\00E9 a p\00E1gina ser totalmente carregada e tente novamente.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077757834401426)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina tem altera\00E7\00F5es n\00E3o salvas.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958620700401339)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A pasta de trabalho n\00E3o tem uma planilha ativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958507152401339)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A pasta de trabalho n\00E3o foi inicializada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958492423401339)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro interno ao criar o arquivo XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960923152401341)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'pt-br'
,p_message_text=>'Folha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092626983401436)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010177232401377)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005852203401374)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005750838401374)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Grupo por Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039904674401398)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar Coluna Piv\00F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040063061401398)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Adicionar Coluna de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980262919401355)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'pt-br'
,p_message_text=>'Agregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016322235401381)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agrega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997447504401368)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001715628401371)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997567634401368)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997740877401368)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'pt-br'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997665554401368)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997316820401367)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'pt-br'
,p_message_text=>'Soma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998411663401368)
,p_name=>'APEXIR_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979531940401355)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962029009401342)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Todas as Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089689693401434)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091285028401435)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Alternativo: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992152210401364)
,p_name=>'APEXIR_AND'
,p_message_language=>'pt-br'
,p_message_text=>'e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981639492401356)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'pt-br'
,p_message_text=>'Aplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975350432401351)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994999169401366)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'pt-br'
,p_message_text=>'A partir de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091840622401436)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E9dia %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083219972401430)
,p_name=>'APEXIR_BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981004784401356)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'pt-br'
,p_message_text=>'entre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974173759401351)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cor de Fundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976087452401352)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'pt-br'
,p_message_text=>'azul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007714883401375)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976697150401352)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'pt-br'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982554542401357)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'pt-br'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974035817401350)
,p_name=>'APEXIR_CELL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E9lula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998324792401368)
,p_name=>'APEXIR_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008611782401376)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'pt-br'
,p_message_text=>'Inicializando...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114044957597401402)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar o label do gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057385192401411)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sua consulta ultrapassa o n\00FAmero m\00E1ximo de %0 pontos de dados por gr\00E1fico. Aplique um filtro para reduzir o n\00FAmero de registros de sua consulta base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056289598401410)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A contagem m\00E1xima de linha de uma consulta do Gr\00E1fico limita o n\00FAmero de linhas na consulta-base, n\00E3o o n\00FAmero de linhas exibidas. Sua consulta-base excede a contagem de linhas m\00E1xima de %0. Aplique um filtro para reduzir o n\00FAmero de registros em sua')
||' consulta-base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979668827401355)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114052905800401408)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Marcar Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995329995401366)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Escolher formato do relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002767893401371)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'pt-br'
,p_message_text=>'remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976549411401352)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013992046401380)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086260094401432)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtrar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004747804401373)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Menu de Cabe\00E7alho de Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008484176401376)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informa\00E7\00F5es da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088584040401434)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label de Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006148654401374)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990261547401362)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991151852401363)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975052636401351)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'pt-br'
,p_message_text=>'em'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991358389401363)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 no \00FAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999804796401369)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o est\00E1 no pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991271305401363)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('est\00E1 no \00FAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999729766401369)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('est\00E1 no pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974924836401351)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o \00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974870660401351)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974658219401351)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'pt-br'
,p_message_text=>'como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975190215401351)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o contido em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974705839401351)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('n\00E3o \00E9 semelhante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990599521401363)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('corresponde \00E0 express\00E3o regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995284785401366)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114055934844401410)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014272122401380)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Cria um c\00E1lculo usando aliases de coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014341826401380)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'pt-br'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014454922401380)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'pt-br'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014539585401380)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'pt-br'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960465261401341)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'pt-br'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999112150401369)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Calcular'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006767896401374)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'pt-br'
,p_message_text=>'Quebra de Controle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009724752401376)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Interrup\00E7\00F5es de Controle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094170959401438)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas de Quebra de Controle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957561542401339)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'pt-br'
,p_message_text=>'Contar Diferentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092368489401436)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'pt-br'
,p_message_text=>'Contar Diferentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092223140401436)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064340058401416)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'pt-br'
,p_message_text=>'Diariamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119021453401456)
,p_name=>'APEXIR_DATA'
,p_message_language=>'pt-br'
,p_message_text=>'Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008519351401376)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dados do relat\00F3rio %0 minutos atr\00E1s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082032730401429)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda da Grade de Dados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980314085401355)
,p_name=>'APEXIR_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012470447401378)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089490760401434)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de Relat\00F3rio Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976759361401352)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980660237401355)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deseja excluir essas defini\00E7\00F5es de relat\00F3rio?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075398910401424)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excluir Relat\00F3rio Padr\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006481450401374)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Excluir Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975450686401352)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982697087401357)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004604432401373)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'View de Uma Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012966962401379)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dire\00E7\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013832536401379)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976284038401352)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'pt-br'
,p_message_text=>'Exibido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979449397401355)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas Exibidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012899912401379)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir no Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007666940401375)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Para Baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999241988401369)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012710850401379)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Exibir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078721599401427)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('J\00E1 existe um destaque com a mesma condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094391379401438)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna piv\00F4 duplicada. A lista de colunas piv\00F4 deve ser exclusiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094594712401438)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008702708401376)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Defini\00E7\00F5es de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015322035401381)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015748210401381)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070168084401420)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Grupo por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015653336401381)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040211680401399)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Editar Tabela Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089767757401434)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968476415401346)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Endere\00E7o de E-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090068577401435)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'pt-br'
,p_message_text=>'Cco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090209326401435)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'pt-br'
,p_message_text=>'Corpo '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089963933401435)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'pt-br'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090788093401435)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Frequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972194731401349)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O e-mail n\00E3o foi configurado para este aplicativo. Entre em contato com o administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063619741401415)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Endere\00E7o de E-mail deve ser especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090307623401435)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'pt-br'
,p_message_text=>'Consulte anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090172391401435)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'pt-br'
,p_message_text=>'Assunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064636325401416)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'O Assunto do E-mail deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089839303401434)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973879695401350)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'pt-br'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015590521401381)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar/Desativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015072011401380)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014633010401380)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015465561401381)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'pt-br'
,p_message_text=>'Exemplos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979364567401354)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'pt-br'
,p_message_text=>'Excluir Valores Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016038791401381)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir/Contrair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013635351401379)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998779861401368)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009639339401376)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'pt-br'
,p_message_text=>'Filtros '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019987793401384)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de Filtro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116457478401454)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A express\00E3o de filtro \00E9 muito longa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019807980401384)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016271426401381)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar colunas para pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999049082401369)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013489895401379)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>'Uma consulta de flashback permite exibir os dados conforme existiam em um momento anterior.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064038755401416)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Dura\00E7\00E3o do Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065437036401417)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>'Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995158450401366)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1scara de Formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006324494401374)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014104613401380)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00F5es %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089303323401434)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00F5es / Operadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006018293401374)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Fun\00E7\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998583432401368)
,p_name=>'APEXIR_GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974354660401351)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'pt-br'
,p_message_text=>'verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113957612872401339)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090463985401435)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Agrupar por Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045036718401402)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a coluna Agrupar por.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056120815401410)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A contagem m\00E1xima de linha de uma consulta Agrupar por limita o n\00FAmero de linhas na consulta-base, n\00E3o o n\00FAmero de linhas exibidas. Sua consulta-base excede a contagem de linhas m\00E1xima de %0. Aplique um filtro para reduzir o n\00FAmero de registros em su')
||'a consulta-base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036730663401396)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agrupar por Classifica\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094237635401438)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Agrupar por Ordem de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979764455401355)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011321038401378)
,p_name=>'APEXIR_HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003146098401372)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Os relat\00F3rios interativos permitem que os usu\00E1rios finais personalizem os relat\00F3rios. Os usu\00E1rios podem alterar o layout de dados do relat\00F3rio, selecionando colunas, aplicando filtros, destacando e classificando. Os usu\00E1rios tamb\00E9m podem definir queb')
||unistr('ras, agrega\00E7\00F5es, gr\00E1ficos, agrupar por e adicionar seus pr\00F3prios c\00E1lculos. Os usu\00E1rios tamb\00E9m podem configurar uma inscri\00E7\00E3o, de forma que uma vers\00E3o HTML do relat\00F3rio seja enviada por e-mail para eles em um intervalo designado. Os usu\00E1rios podem cri')
||unistr('ar varia\00E7\00F5es de um relat\00F3rio e salv\00E1-las como relat\00F3rios nomeados, para visualiza\00E7\00E3o p\00FAblica ou privada.'),
'<p/>',
unistr('As se\00E7\00F5es a seguir resumem formas de personalizar um relat\00F3rio interativo. Para saber mais, consulte "Using Interactive Reports" no <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010207050401377)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O menu A\00E7\00F5es aparece \00E0 direita do bot\00E3o Ir na barra de Pesquisa. Use este menu para personalizar um relat\00F3rio interativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003921687401372)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agregados s\00E3o c\00E1lculos matem\00E1ticos realizados em uma coluna. Os agregados s\00E3o exibidos depois de cada interrup\00E7\00E3o de controle e no final do relat\00F3rio na coluna onde s\00E3o definidos. As op\00E7\00F5es incluem:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agrega\00E7\00E3o</strong> permite selecionar uma agrega\00E7\00E3o previamente definida para editar.</li>'),
unistr('<li><strong>Fun\00E7\00E3o</strong> \00E9 a fun\00E7\00E3o a realizar (por exemplo, SUM, MIN).</li>'),
unistr('<li><strong>Coluna</strong> \00E9 usado para selecionar a coluna \00E0 qual aplicar a fun\00E7\00E3o'),
unistr(' matem\00E1tica. S\00F3 s\00E3o exibidas colunas num\00E9ricas.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004072697401372)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Voc\00EA pode definir um gr\00E1fico por relat\00F3rio salvo. Depois'),
unistr(' de definido, voc\00EA pode alternar entre as views de gr\00E1fico e de relat\00F3rio, usando os \00EDcones de view da barra de Pesquisa.'),
unistr('As op\00E7\00F5es incluem:'),
'<p>',
'</p><ul>',
unistr('O <li><strong>Tipo de Gr\00E1fico</strong> identifica o tipo de gr\00E1fico a incluir.'),
'Selecione entre barras horizontais barras verticais, pizza ou linhas.</li>',
'<li><strong>Label</strong> permite selecionar a coluna a ser usada como label.</li>',
unistr('<li><strong>T\00EDtulo do Eixo do Label</strong> \00E9 o t\00EDtulo exibido no eixo associado \00E0 coluna selecionada para'),
unistr(' o Label. Essa op\00E7\00E3o n\00E3o est\00E1 dispon\00EDvel para gr\00E1fico de pizza.</li>'),
'<li><strong>Valor</strong> permite selecionar a coluna a usar como o valor. Se sua',
unistr(' fun\00E7\00E3o for COUNT, n\00E3o \00E9 necess\00E1rio selecionar um Valor.</li>'),
unistr('<li><strong>T\00EDtulo do Eixo do Valor</strong> \00E9 o t\00EDtulo exibido no eixo associado \00E0'),
unistr(' coluna selecionada para Valor. Indispon\00EDvel para gr\00E1fico de pizza.</li>'),
unistr('<li><strong>Fun\00E7\00E3o</strong> \00E9 uma fun\00E7\00E3o opcional a ser executada na coluna selecionada para Valor.</li>'),
unistr('<li><strong>Classifica\00E7\00E3o</strong> permite classificar o conjunto de resultados.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003357303401372)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Clicar em qualquer cabe\00E7alho de coluna exp\00F5e um menu do cabe\00E7alho de coluna. As op\00E7\00F5es incluem:'),
'<p></p>',
'<ul>',
unistr('O \00EDcone <li><strong>Classificar por Ordem Crescente</strong> ordena o relat\00F3rio pela coluna em ordem crescente.</li>'),
unistr('O \00EDcone <li><strong>Classificar por Ordem Decrescente</strong> ordena o relat\00F3rio pela coluna em ordem decrescente.</li>'),
unistr('A op\00E7\00E3o <li><strong>Ocultar Coluna</strong> oculta a coluna. Nem todas as colunas podem ser ocultadas. Se uma coluna n\00E3o puder ser ocultada, n\00E3o haver\00E1 \00EDcone Ocultar Coluna.</li>'),
unistr('A op\00E7\00E3o <li><strong>Quebrar Coluna</strong> cria um grupo de quebra na coluna. Com isso, a coluna \00E9 retirada do relat\00F3rio como um registro-mestre.</li>'),
unistr('A op\00E7\00E3o <li><strong>Informa\00E7\00F5es da Coluna</strong> exibe texto de ajuda sobre a coluna, se dispon\00EDvel.</li>'),
unistr('A op\00E7\00E3o <li><strong>\00C1rea de Texto</strong> \00E9 usada para informar crit\00E9rios de pesquisa que n\00E3o diferenciam mai\00FAsculas de min\00FAsculas'),
unistr('(n\00E3o h\00E1 necessidade de caracteres curinga). A inser\00E7\00E3o de um valor reduz a lista de'),
unistr('valores na parte inferior do menu. Voc\00EA pode ent\00E3o selecionar um valor na'),
unistr('parte inferior e o valor selecionado ser\00E1 criado como um filtro usando ''='''),
unistr('(por exemplo, <code>column = ''ABC''</code>). Como alternativa, voc\00EA poder\00E1 clicar no \00EDcone da Lanterna e informar um valor que ser\00E1 criado como um filtro com o modificador ''LIKE'''),
'(por exemplo, <code>column LIKE ''%ABC%''</code>).</li>',
unistr('A op\00E7\00E3o <li><b>Lista de Valores \00DAnicos</b> cont\00E9m os 500 primeiros valores \00FAnicos'),
unistr('que atendem a seus crit\00E9rios de filtro. Se a primeira coluna for uma data, ser\00E1'),
unistr('exibida uma lista de faixas de datas. Se voc\00EA selecionar um valor, ser\00E1 criado um'),
'filtro usando ''='' (por exemplo, <code>column = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003830256401372)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite que voc\00EA adicione colunas calculadas a seu relat\00F3rio. Podem ser c\00E1lculos matem\00E1ticos (por exemplo, <code>NBR_HOURS/24</code>) ou fun\00E7\00F5es padr\00E3o do sistema Oracle'),
unistr('aplicadas a colunas existentes. Algumas s\00E3o exibidas como exemplo; outras (como <code>TO_DATE)</code>, tamb\00E9m podem ser usadas). As op\00E7\00F5es incluem:'),
'<p></p>',
'<ul>',
unistr('<li><strong>C\00E1lculo</strong> permite selecionar um c\00E1lculo previamente definido para editar.</li>'),
unistr('<li><strong>Cabe\00E7alho da Coluna</strong> \00E9 o cabe\00E7alho da nova coluna.</li>'),
unistr('<li><strong>M\00E1scara de Formato</strong> \00E9 uma m\00E1scara de formato do sistema Oracle a ser aplicada \00E0 coluna (por exemplo,S9999).</li>'),
unistr('<li><strong>C\00E1lculo</strong> \00E9 o c\00E1lculo a ser feito, no qual as colunas s\00E3o referenciadas usando os aliases exibidos.</li>'),
'</ul>',
unistr('<p>Abaixo do c\00E1lculo, as colunas em sua consulta s\00E3o exibidas com'),
unistr('seus aliases associados. Clicar no nome ou no alias da coluna a incluir\00E1'),
unistr('no C\00E1lculo. Junto \00E0s Colunas est\00E1 um teclado. Ele funciona como'),
unistr('um atalho para as teclas mais usadas. \00C0 extrema direita est\00E3o as Fun\00E7\00F5es.</p>'),
unistr('<p>O seguinte exemplo de c\00E1lculo demonstra como exibir a remunera\00E7\00E3o total:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(em que A \00E9 ORGANIZATION, B \00E9 SALARY e C \00E9 COMMISSION)</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010353852401377)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usado para criar um grupo de interrup\00E7\00E3o em uma ou mais colunas. Isso retira as colunas do relat\00F3rio interativo e as exibe como um registro mestre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004586671401373)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Para exibir os detalhes de uma linha por vez, clique no \00EDcone view de uma linha na linha que deseja exibir. Se estiver dispon\00EDvel, a view de uma linha sempre ser\00E1 a primeira coluna. Dependendo da personaliza\00E7\00E3o do relat\00F3rio interativo, a view de uma ')
||unistr('linha poder\00E1 ser a view padr\00E3o ou uma p\00E1gina personalizada que permita atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004409330401373)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Permite que o conjunto de resultados atual seja obtido por download. Os formatos',
unistr('de download dependem da instala\00E7\00E3o e da defini\00E7\00E3o do relat\00F3rio mas'),
'podem incluir CSV, HTML, E-mail, XLS, PDF ou RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003509515401372)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Foca o relat\00F3rio adicionando ou modificando a cl\00E1usula <code>WHERE</code> na consulta. Voc\00EA pode filtrar por coluna ou por linha.  '),
unistr('<p>Se filtrar por coluna, selecione uma coluna (n\00E3o precisa ser a que est\00E1 exibida), selecione um operador Oracle padr\00E3o  (=, !=, n\00E3o em, entre) e informe uma express\00E3o a ser comparada. As express\00F5es n\00E3o diferenciam mai\00FAsculas e min\00FAsculas. Use  % co')
||'mo curinga (por exemplo, <code>STATE_NAME',
'like A%)</code>.</p>',
unistr('<p>Se voc\00EA filtrar por linha, voc\00EA pode criar cl\00E1usulas <code>WHERE</code> complexas usando aliases da coluna e quaisquer fun\00E7\00F5es ou operadores Oracle (por exemplo, <code>G = ''VA'' ou G = ''CT''</code>, onde'),
unistr('<code>G</code> \00E9 o alias de <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004181101401373)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Uma consulta de flashback permite exibir os dados conforme existiam em um momento anterior. O per\00EDodo padr\00E3o de flashback \00E9 de 3 horas (ou 180 minutos) mas o valor real difere de cada banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065303233401417)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O formato permite personalizar a exibi\00E7\00E3o do relat\00F3rio.'),
unistr('O formato cont\00E9m o seguinte submenu:</p>'),
'<ul><li>Classificar</li>',
'<li>Quebras de Controle</li>',
'<li>Destaque</li>',
'<li>Calcular</li>',
'<li>Agregar</li>',
unistr('<li>Gr\00E1fico</li>'),
'<li>Agrupar por</li>',
unistr('<li>Piv\00F4</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063516693401415)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Voc\00EA pode definir uma view Agrupar por para cada relat\00F3rio salvo.'),
unistr('Depois de definido, \00E9 poss\00EDvel alternar entre as views e relat\00F3rios Agrupar por'),
unistr('usando \00EDcones de views da barra de Pesquisa. Para criar uma view Agrupar por,'),
'selecione:',
'<p></p><ul>',
unistr('<li>as colunas nas quais ser\00E3o agrupadas</li>'),
unistr('<li>as colunas a serem agregadas com a fun\00E7\00E3o a ser executada (m\00E9dia, soma, contagem etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003701482401372)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite que voc\00EA defina um filtro. As linhas que atendem ao crit\00E9rio do filtro s\00E3o destacadas usando as caracter\00EDsticas associadas ao filtro. As op\00E7\00F5es incluem:</p>'),
'<ul>',
unistr('<li><strong>Nome</strong> \00E9 usado apenas para exibi\00E7\00E3o.</li>'),
unistr('<li><strong>Sequ\00EAncia</strong> identifica a sequ\00EAncia na qual as regras s\00E3o avaliadas.</li>'),
unistr('<li><strong>Ativado</strong> identifica se uma regra est\00E1 ativada ou desativada.</li>'),
unistr('<li><strong>Tipo de Destaque</strong> identifica se a linha ou c\00E9lula deve ser'),
unistr('destacada. Se a C\00E9lula for selecionada, a coluna referenciada na'),
unistr('Condi\00E7\00E3o de Destaque ser\00E1 destacada.</li>'),
unistr('<li><strong>Cor de Fundo</strong> \00E9 a nova cor do fundo da \00E1rea destacada.</li>'),
unistr('<li><strong>Cor do Texto</strong> \00E9 a nova cor do texto na \00E1rea destacada.</li>'),
unistr('<li><strong>Condi\00E7\00E3o de Destaque</strong> define sua condi\00E7\00E3o de filtro.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941310227401327)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Voc\00EA pode definir uma view Piv\00F4 por relat\00F3rio salvo. Depois de definido, \00E9 poss\00EDvel alternar entre as views de relat\00F3rio e piv\00F4 usando \00EDcones de views da barra de Pesquisa. Para criar uma view Piv\00F4, selecione:'),
'<p></p>',
'<ul>',
unistr('<li>as colunas para criar uma view din\00E2mica</li>'),
'<li>as colunas a serem exibidas como linhas</li>',
unistr('<li>as colunas a serem agregadas com a fun\00E7\00E3o a ser executada (m\00E9dia, soma, contagem etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014840077401380)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se voc\00EA personalizar um relat\00F3rio interativo, as configura\00E7\00F5es do relat\00F3rio ser\00E3o exibidas'),
unistr('abaixo da barra de Pesquisa e acima do relat\00F3rio. Essa \00E1rea pode ser contra\00EDda e expandida usando o \00EDcone \00E0 esquerda.'),
'<p>',
unistr('Para cada defini\00E7\00E3o de relat\00F3rio, \00E9 poss\00EDvel:'),
'</p><ul>',
unistr('<li>Editar uma defini\00E7\00E3o clicando no nome.</li>'),
unistr('<li>Desativar/Ativar uma defini\00E7\00E3o, desmarcando ou marcando a caixa de sele\00E7\00E3o Ativar/Desativar. Isso \00E9 usado para ativar/desativar temporariamente uma defini\00E7\00E3o.</li>'),
unistr('<li>Remover uma defini\00E7\00E3o clicando no \00EDcone Remover.</li>'),
'</ul>',
unistr('<p>Se voc\00EA criou um gr\00E1fico ou agrupamento, poder\00E1 alternar entre eles'),
unistr(' e o relat\00F3rio de base usando os links View de Relat\00F3rio, View de Gr\00E1fico, Piv\00F4 e'),
unistr(' Agrupar por mostrados \00E0 direita. Se estiver exibindo um gr\00E1fico ou'),
unistr(' agrupamento, tamb\00E9m poder\00E1 usar o link Editar para editar as defini\00E7\00F5es.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004311730401373)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefine o relat\00F3rio \00E0s configura\00E7\00F5es padr\00E3o, removendo qualquer personaliza\00E7\00E3o realizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065635420401417)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Define o n\00FAmero de registros para exibi\00E7\00E3o por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004245107401373)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Salva o relat\00F3rio personalizado para uso futuro. Voc\00EA fornece um nome e uma descri\00E7\00E3o opcional e pode tornar o relat\00F3rio acess\00EDvel ao p\00FAblico (isto \00E9, todos os usu\00E1rios que podem acessar o relat\00F3rio padr\00E3o). Voc\00EA pode salvar quatro tipos de relat\00F3')
||'rios interativos:</p>',
'<ul>',
unistr('<li><strong>Padr\00E3o Principal</strong> (Somente Desenvolvedor). O Padr\00E3o Principal \00E9 o relat\00F3rio que \00E9 exibido inicialmente. Os relat\00F3rios Padr\00E3o Principal n\00E3o podem ser renomeados ou exclu\00EDdos.</li>'),
unistr('<li><strong>Relat\00F3rio Alternativo</strong> (Somente Desenvolvedor). Permite que os desenvolvedores criem v\00E1rios layouts de relat\00F3rio. Somente os desenvolvedores podem salvar, renomear ou excluir um Relat\00F3rio Alternativo.</li>'),
unistr('<li><strong>Relat\00F3rio P\00FAblico</strong> (Usu\00E1rio final). Pode ser salvo, renomeado ou exclu\00EDdo pelo usu\00E1rio final que o criou. Outros usu\00E1rios podem exibir e salvar o relat\00F3rio como outro relat\00F3rio.</li>'),
unistr('<li><strong>Relat\00F3rio Privado</strong> (Usu\00E1rio final). Somente o usu\00E1rio final que criou o relat\00F3rio pode exibir, salvar, renomear ou excluir o relat\00F3rio.</li>'),
'</ul>',
unistr('<p>Se voc\00EA salvar os relat\00F3rios personalizados, um selector de Relat\00F3rios \00E9 exibido na barra de Pesquisa \00E0 esquerda do selector de Linhas (se este recurso for ativado).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003273186401372)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Na parte superior de cada p\00E1gina do relat\00F3rio, h\00E1 uma regi\00E3o de pesquisa. A regi\00E3o (ou barra de Pesquisa) apresenta os seguintes recursos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066213331401417)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<li><strong>Menu A\00E7\00F5es</strong> permite que voc\00EA personalize um relat\00F3rio. Consulte as se\00E7\00F5es as seguir.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065748099401417)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<li><strong>\00CDcone Selecionar colunas</strong> permite que voc\00EA identifique qual coluna pesquisar (ou todas).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066087542401417)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<li><strong>Relat\00F3rios</strong> exibe relat\00F3rios privados ou p\00FAblicos padr\00E3o e salvos alternativos.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065978827401417)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<li><strong>Linhas</strong> define o n\00FAmero de registros para exibi\00E7\00E3o por p\00E1gina.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065874571401417)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\00C1rea de texto</strong> permite que voc\00EA digite os crit\00E9rios de pesquisa que n\00E3o distinguem mai\00FAsculas e min\00FAsculas (caracteres curinga s\00E3o utilizados).</li>'),
unistr('<li><strong>Bot\00E3o Ir</strong> executa a pesquisa. Pressione a tecla Enter para executar tamb\00E9m a pesquisa quando o cursor estiver na \00E1rea de texto da pesquisa.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066153512401417)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<li><strong>\00CDcones de Exibi\00E7\00E3o</strong> alternam entre as exibi\00E7\00F5es de \00EDcone, relat\00F3rio, detalhes, gr\00E1ficos, agrupar por e piv\00F4 do relat\00F3rio, caso tenham sido definidos.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082175344401429)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('<li><strong>Gerenciar</strong> permite que voc\00EA gerencie as propriedades, colunas, linhas e exiba o hist\00F3rico do relat\00F3rio ou da grade de dados.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003465190401372)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usado para modificar as colunas exibidas. As colunas \00E0 direita s\00E3o exibidas. As colunas \00E0 esquerda s\00E3o ocultas. Voc\00EA poder\00E1 reordenar as colunas exibidas usando as setas na extremidade direita. As colunas calculadas recebem o prefixo <strong>**</stro')
||'ng>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003634922401372)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Usado para alterar a(s) coluna(s) a classificar e determina se',
unistr(' a classifica\00E7\00E3o ser\00E1 em ordem crescente ou decrescente. Tamb\00E9m \00E9 poss\00EDvel especificar como tratar'),
unistr(' os <code>NULOs</code>. A configura\00E7\00E3o padr\00E3o sempre exibe os <code>NULOs</code> por \00FAltimo ou primeiro. A classifica\00E7\00E3o resultante \00E9 exibida \00E0 direita'),
unistr(' dos cabe\00E7alhos das colunas no relat\00F3rio.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063373323401415)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ao adicionar uma assinatura, voc\00EA fornece um endere\00E7o de e-mail (ou diversos endere\00E7os de e-mail, separados por v\00EDrgula), o assunto do e-mail, a frequ\00EAncia e as datas inicial e final. Os e-mails resultantes incluem uma vers\00E3o HTML do relat\00F3rio intera')
||unistr('tivo que cont\00E9m os dados atuais que usam a defini\00E7\00E3o de relat\00F3rio que estava presente quando a assinatura foi adicionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081963027401429)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Grades de dados basicamente s\00E3o relat\00F3rios edit\00E1veis que s\00E3o altamente personaliz\00E1veis. Os usu\00E1rios podem alterar o layout dos dados do relat\00F3rio, selecionando colunas, aplicando filtros, destacando e classificando. Os usu\00E1rios tamb\00E9m podem definir q')
||unistr('uebras, agrega\00E7\00F5es, gr\00E1ficos, agrupar por e adicionar seus pr\00F3prios c\00E1lculos. Podem criar diversas varia\00E7\00F5es de um relat\00F3rio e salv\00E1-las como relat\00F3rios nomeados para exibi\00E7\00E3o privadas.'),
'<p/>',
unistr('Uma grade de Dados pode ser personalizada usando-se a barra de Pesquisa, o menu A\00E7\00F5es, o menu Gerenciar ou o Cabe\00E7alho da Coluna.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093771446401437)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O menu A\00E7\00F5es aparece \00E0 direita do bot\00E3o Ir na barra de Pesquisa. Use este menu para personalizar um relat\00F3rio de grade de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082415064401429)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Adicionar/Editar P\00E1gina da Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082533828401429)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para adicionar uma linha \00E0 grade de dados, clique em Adicionar Linha. Para editar os detalhes de uma linha, clique no \00EDcone da linha de edi\00E7\00E3o (primeira coluna) da linha que voc\00EA deseja editar. A p\00E1gina Adicionar/Editar Linha ser\00E1 exibida mostrand')
||'o as colunas da grade de dados. </p>',
'',
unistr('<p>Ao editar uma linha voc\00EA pode:</p>'),
'',
'<p><ul>',
'<li><strong>Excluir</strong> a linha.</li>',
unistr('<li><strong>Aplicar Altera\00E7\00F5es</strong> para salvar as altera\00E7\00F5es feitas na linha.</li>'),
unistr('<li>Em <strong>A\00E7\00F5es</strong>, adicione uma linha, adicionar arquivos, observa\00E7\00F5es, links ou tags e revise o hist\00F3rico.</li>'),
unistr('<li>Navegue at\00E9 as linhas <strong>Pr\00F3xima e Anterior</strong>.</li>'),
unistr('<li>Em <strong>Gerenciar</strong>, defina as propriedades da coluna, valida\00E7\00F5es e lista de valores.</li>'),
'</ul></p>',
'',
unistr('<p>A regi\00E3o Anota\00E7\00F5es nap arte inferior da p\00E1gina exibir\00E1 os arquivos, observa\00E7\00F5es, links ou tags que n\00E3o est\00E3o associados \00E0 linha atual.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093844804401437)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usado para criar um grupo de interrup\00E7\00E3o em uma ou mais colunas. Isso retira as colunas da grade de dados e as exibe como um registro mestre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082303980401429)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Permite que o conjunto de resultados atual seja obtido por download. Os formatos',
'de download incluem CSV, HTML ou E-mail.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093978241401437)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se voc\00EA personalizar um relat\00F3rio de grade de dados, as defini\00E7\00F5es do relat\00F3rio ser\00E3o exibidas'),
unistr('abaixo da barra de Pesquisa e acima do relat\00F3rio. Essa \00E1rea pode ser contra\00EDda e expandida usando-se o \00EDcone \00E0 esquerda.'),
'<p>',
unistr('Para cada defini\00E7\00E3o de relat\00F3rio, voc\00EA pode:'),
'</p><ul>',
unistr('<li>Editar uma defini\00E7\00E3o clicando no nome.</li>'),
unistr('<li>Desativar/Ativar uma defini\00E7\00E3o desmarcando ou marcando a caixa de sele\00E7\00E3o Ativar/Desativar. Use esse controle para ativar/desativar temporariamente uma defini\00E7\00E3o.</li>'),
unistr('<li>Remover uma defini\00E7\00E3o clicando no \00EDcone Remover.</li>'),
'</ul>',
unistr('<p>Se voc\00EA criou um gr\00E1fico ou agrupamento, poder\00E1 alternar entre eles'),
unistr('e o relat\00F3rio de base usando os links View de Relat\00F3rio, View de Gr\00E1fico e Agrupar por'),
unistr('mostrados \00E0 direita. Se estiver exibindo um gr\00E1fico ou agrupamento,'),
unistr('tamb\00E9m poder\00E1 usar o link Editar para editar as defini\00E7\00F5es.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082243298401429)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Salva o relat\00F3rio da grade de dados personalizado para uso futuro. Voc\00EA fornece um nome e uma descri\00E7\00E3o opcional.  Voc\00EA pode salvar tr\00EAs tipos de layouts de relat\00F3rio da grade de dados:</p>'),
'<ul>',
unistr('<li><strong>Padr\00E3o Principal</strong> (Somente Administrador). O Padr\00E3o Principal \00E9 o layout que \00E9 exibido inicialmente. Os relat\00F3rios Padr\00E3o Principal n\00E3o podem ser renomeados ou exclu\00EDdos.</li>'),
unistr('<li><strong>Relat\00F3rio Alternativo</strong> (Somente Administrador). Permite que os administradores criem v\00E1rios layouts de relat\00F3rio. Somente os administradores podem salvar, renomear ou excluir um Relat\00F3rio Alternativo.</li>'),
unistr('<li><strong>Relat\00F3rio P\00FAblico</strong> (Todos os usu\00E1rios). O usu\00E1rio que criou o layout do relat\00F3rio pode exibir, salvar, renomear ou excluir o relat\00F3rio.</li>'),
'</ul>',
unistr('<p>Se voc\00EA salvar os relat\00F3rios personalizados, um seletor de Relat\00F3rios \00E9 exibido na barra de Pesquisa \00E0 esquerda do seletor de Linhas (se este recurso estiver ativado).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008329365401375)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Ocultar Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998997229401369)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Destacar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009865299401377)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'pt-br'
,p_message_text=>'Destaques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014917313401380)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Condi\00E7\00E3o do Destaque')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063903748401416)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>'Estilo do Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973967734401350)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083470785401430)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'pt-br'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113022732401452)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('1 defini\00E7\00E3o inativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113177513401452)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 defini\00E7\00F5es inativas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004962900401373)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ajuda de Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015977506401381)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009317610401376)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de c\00E1lculo inv\00E1lida. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968718338401347)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A data de t\00E9rmino deve ser posterior \00E0 data de in\00EDcio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023696797401386)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Express\00E3o de filtro inv\00E1lida. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091425020401436)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Consulta de filtro inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113216671401452)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('1 defini\00E7\00E3o inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113331987401452)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 defini\00E7\00F5es inv\00E1lidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064147642401416)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>'(em minutos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081167476401428)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 est\00E1 no/a(s) \00FAltimo/a(s) %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081385323401428)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 est\00E1 no/a(s) pr\00F3ximo/a(s) %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081243530401428)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no/a(s) \00FAltimo/a(s) %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081441430401428)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014056953401380)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'pt-br'
,p_message_text=>'Teclado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980135406401355)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007940580401375)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Eixo para Label')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000482308401370)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimo Dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000607860401370)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltima Hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000144672401370)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EAs Passado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000255502401370)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>'Semana Passada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000369733401370)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimos %0 Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000507085401370)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimas %0 Horas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999964234401369)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00DAltimos %0 Anos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000026323401369)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Ano Passado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980028894401355)
,p_name=>'APEXIR_LINE'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976826133401353)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091334328401436)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'pt-br'
,p_message_text=>'Mapear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008840354401376)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta \00E9 prevista para exceder os recursos m\00E1ximos permitidos. Modifique as configura\00E7\00F5es do relat\00F3rio e tente novamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991044236401363)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A contagem m\00E1xima de linhas deste relat\00F3rio \00E9 %0 linhas. Aplique um filtro para reduzir o n\00FAmero de registros em sua consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091927305401436)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00E1ximo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092147618401436)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'pt-br'
,p_message_text=>'Mediana %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995054171401366)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 %0 minutos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092029227401436)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091013508401435)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064598005401416)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'pt-br'
,p_message_text=>'Mensalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007170018401375)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007020895401375)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Mover Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118218601401456)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID Est\00E1tico da Regi\00E3o deve ser especificado porque a p\00E1gina cont\00E9m diversos relat\00F3rios interativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975519607401352)
,p_name=>'APEXIR_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002998657401372)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Agrega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113927298401452)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Nova Categoria'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114003017045401372)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Novo C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997821289401368)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000941822401370)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000733745401370)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima Hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001224713401370)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001156692401370)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3xima Semana')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001065040401370)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximos %0 Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114000876739401370)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximas %0 Horas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001484870401370)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximos %0 Anos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001381767401370)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Ano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975820751401352)
,p_name=>'APEXIR_NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016131147401381)
,p_name=>'APEXIR_NONE'
,p_message_language=>'pt-br'
,p_message_text=>'- Nenhum -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063782635401416)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 um endere\00E7o de e-mail v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012651553401379)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'pt-br'
,p_message_text=>'Nulos Sempre em Primeiro'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012513092401379)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'pt-br'
,p_message_text=>'Nulos Sempre no Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013033783401379)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o Nula %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009480511401376)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tempo de flashback deve ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009053175401376)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sequ\00EAncia deve ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013593221401379)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Operador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974455727401351)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'pt-br'
,p_message_text=>'laranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083370957401430)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976393841401352)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'pt-br'
,p_message_text=>'Outro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959185112401340)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Orienta\00E7\00E3o da p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959838650401340)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'pt-br'
,p_message_text=>'Paisagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959986943401340)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'pt-br'
,p_message_text=>'Retrato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959009594401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tamanho da p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959615359401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'pt-br'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959544028401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'pt-br'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959773689401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959318757401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Of\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959225532401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'pt-br'
,p_message_text=>'Carta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113959456171401340)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'pt-br'
,p_message_text=>'Tabloide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092439461401436)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual da Contagem Total %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091641713401436)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual da Soma Total %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090603509401435)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual da Contagem Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090566211401435)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual da Soma Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979938193401355)
,p_name=>'APEXIR_PIE'
,p_message_language=>'pt-br'
,p_message_text=>'Pizza'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039889912401398)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tabela Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041311218401399)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a coluna Agregados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041561467401399)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel agregar em uma coluna selecionada como coluna de linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040729455401399)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Colunas Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040500180401399)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna Din\00E2mica %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041150269401399)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a coluna Piv\00F4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941287638401327)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A contagem m\00E1xima de linhas de uma consulta de Piv\00F4 limita o n\00FAmero de linhas na consulta-base, n\00E3o o n\00FAmero de linhas exibidas. Sua consulta-base excede a contagem de linhas m\00E1xima de %0. Aplique um filtro para reduzir o n\00FAmero de registros em sua c')
||'onsulta-base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041083654401399)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classifica\00E7\00E3o Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010436562401377)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna din\00E2mica cont\00E9m muitos valores distintos - n\00E3o \00E9 poss\00EDvel gerar SQL din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063864761401416)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'pt-br'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997950552401368)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114089598081401434)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'pt-br'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064848733401416)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Prim\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958968066401340)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'pt-br'
,p_message_text=>'Incluir Tags de Acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945858804401330)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'pt-br'
,p_message_text=>'Remover RTF (Rich Text Format)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022666491401386)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'pt-br'
,p_message_text=>'Privado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980514795401355)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'pt-br'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976147952401352)
,p_name=>'APEXIR_RED'
,p_message_language=>'pt-br'
,p_message_text=>'vermelho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118142898401455)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID Est\00E1tico %0 da Regi\00E3o n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007233129401375)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Remover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007366152401375)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113442226401452)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006824390401374)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover Interrup\00E7\00E3o de Controle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006533360401374)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006605126401374)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113596946401452)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Grupo Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006962447401374)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Remover Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113617419401452)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover Tabela Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094653831401438)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Remover Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075225638401424)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renomear Relat\00F3rio Padr\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016416000401381)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Renomear Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998233275401368)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092532931401436)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972784059401350)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio Interativo salvo com o alias %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022928302401386)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972856665401350)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID do Relat\00F3rio Interativo Salvo %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114014757179401380)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Defini\00E7\00F5es do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995516179401366)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('View de Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999442238401369)
,p_name=>'APEXIR_RESET'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980739910401355)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Restaurar o relat\00F3rio para as configura\00E7\00F5es padr\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975926382401352)
,p_name=>'APEXIR_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088620045401434)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA n\00E3o pode usar ROWID como a coluna de chave prim\00E1ria para uma Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005942328401374)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065539199401417)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Linhas Por P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040836467401399)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas de Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040619445401399)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Linha %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041250860401399)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a coluna Linhas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041462568401399)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna de linhas deve ser diferente da coluna de piv\00F4s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020094597401384)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>'Filtro de Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995685653401366)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0 de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999620653401369)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Texto da linha cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975230913401351)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010078355401377)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Salvo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009961865401377)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Salvo = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012121359401378)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As configura\00E7\00F5es atuais do relat\00F3rio ser\00E3o usadas como padr\00E3o para todos os usu\00E1rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114075175665401424)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio Padr\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113999303295401369)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113800559401452)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Salvar Relat\00F3rio*')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066510260401418)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114004880680401373)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'pt-br'
,p_message_text=>'Barra de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114113735015401452)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072074630401422)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio de Pesquisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056012745401410)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Colunas Selecionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976957133401353)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Coluna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998652138401368)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980480671401355)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Selecionar Fun\00E7\00E3o -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005687828401374)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Grupo por Coluna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040343372401399)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('- Selecionar Coluna por Piv\00F4 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091509999401436)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040485759401399)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'- Selecionar Coluna de Linha -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949126634401333)
,p_name=>'APEXIR_SEND'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955420714401337)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Enviar como E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975681365401352)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998868383401369)
,p_name=>'APEXIR_SORT'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008177463401375)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por Ordem Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008288903401375)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por Ordem Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094031771401438)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ordem de Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002693178401371)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('espa\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013722674401379)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'pt-br'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064294635401416)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090955367401435)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'pt-br'
,p_message_text=>'Terminando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945356383401330)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'pt-br'
,p_message_text=>'Ignorar se Nenhum Dado For Encontrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114090864623401435)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Iniciando de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091732177401436)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'pt-br'
,p_message_text=>'Soma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081790143401429)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o = %0, Relat\00F3rio = %1, View = %2, In\00EDcio das Linhas Exibidas = %3, Fim das Linhas Exibidas = %4, Total de Linhas = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002353131401371)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o = %0, Relat\00F3rio = %1, View = %2, In\00EDcio das Linhas Exibidas = %3, Fim das Linhas Exibidas = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974535818401351)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>'Cor do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991636932401363)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>'dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991519573401363)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>'horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991438096401363)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'pt-br'
,p_message_text=>'minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991857322401364)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>'meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991781729401363)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>'semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113991968294401364)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'pt-br'
,p_message_text=>' anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114094445181401438)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'pt-br'
,p_message_text=>'Alternar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007478759401375)
,p_name=>'APEXIR_TOP'
,p_message_language=>'pt-br'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087637796401433)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coluna N\00E3o Agrupada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008933047401376)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'pt-br'
,p_message_text=>'O Nome do Destaque deve ser exclusivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979236208401354)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('tipo de dados n\00E3o suportado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007550826401375)
,p_name=>'APEXIR_UP'
,p_message_language=>'pt-br'
,p_message_text=>'Para Cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009194885401376)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma cor v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009254445401376)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Informe uma m\00E1scara de formato v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113976448408401352)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114008047252401375)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo do Eixo para Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015891598401381)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979871386401355)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114083524214401430)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'pt-br'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015138407401380)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070338939401420)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Detalhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114115909511401454)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O relat\00F3rio n\00E3o tem a view %0 definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070405760401421)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Grupo Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070217309401420)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir \00CDcones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040193443401398)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Tabela Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114015251140401380)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibir Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064436428401416)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'pt-br'
,p_message_text=>'Semanalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998123984401368)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Funcional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093167130401437)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093082371401437)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114092943080401437)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093396644401437)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093298269401437)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114093454616401437)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'pt-br'
,p_message_text=>'%0 anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114091146029401435)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'pt-br'
,p_message_text=>'Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113974256873401351)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'pt-br'
,p_message_text=>'amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113975748009401352)
,p_name=>'APEXIR_YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114007815056401375)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 cont\00E9m < ou > que s\00E3o caracteres inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114030636808401392)
,p_name=>'APEX_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Regi\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113958872089401340)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00E9-condi\00E7\00E3o da API violada')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978306471401354)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel obter o valor para a Defini\00E7\00E3o de Aplicativo %0, pois a op\00E7\00E3o de build est\00E1 desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978227940401354)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel definir o valor para a Defini\00E7\00E3o de Aplicativo %0, pois a op\00E7\00E3o de build est\00E1 desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085986359401432)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor %0 da Defini\00E7\00E3o de Aplicativo \00E9 inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114085867674401432)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Defini\00E7\00E3o %0 de Aplicativo Solicitada n\00E3o foi configurada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086083863401432)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Defini\00E7\00E3o de Aplicativo %0 n\00E3o pode ser definido como um valor nulo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966948831401345)
,p_name=>'BACK'
,p_message_language=>'pt-br'
,p_message_text=>'Voltar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953940804401336)
,p_name=>'BUILDER'
,p_message_language=>'pt-br'
,p_message_text=>'Builder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018017992401382)
,p_name=>'BUTTON LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Label de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953026431401335)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Classes CSS do Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982208183401357)
,p_name=>'BUTTON_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID de bot\00E3o gerado ser\00E1 o ID Est\00E1tico do bot\00E3o, se definido; sen\00E3o, ser\00E1 um ID gerado internamente no formato ''B'' || [ID de Bot\00E3o Interno]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945714639401330)
,p_name=>'CANDLESTICK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Casti\00E7al')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027207510401389)
,p_name=>'CENTER'
,p_message_language=>'pt-br'
,p_message_text=>'Centro'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977225780401353)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Solicita\00E7\00E3o %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968655001401347)
,p_name=>'CHECK$'
,p_message_language=>'pt-br'
,p_message_text=>'seletor de linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114087799570401433)
,p_name=>'CHECKED'
,p_message_language=>'pt-br'
,p_message_text=>'marcado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063249858401415)
,p_name=>'COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023787064401386)
,p_name=>'COMMENTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Coment\00E1rios')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005284743401373)
,p_name=>'CONTINUE'
,p_message_language=>'pt-br'
,p_message_text=>'Continuar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967272926401346)
,p_name=>'COPYRIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Copyright &copy; %0, Oracle.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010911363401377)
,p_name=>'COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017640799401382)
,p_name=>'CREATE'
,p_message_language=>'pt-br'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069995063401420)
,p_name=>'CREATED'
,p_message_language=>'pt-br'
,p_message_text=>'Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070068537401420)
,p_name=>'CREATED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Criado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994801222401366)
,p_name=>'CREATED_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Criado em'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005496337401373)
,p_name=>'CUSTOM'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016651111401381)
,p_name=>'CUSTOMIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Personalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018222922401383)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncias de p\00E1gina redefinidas para o usu\00E1rio %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018376172401383)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncias alteradas para o usu\00E1rio %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018119508401383)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Prefer\00EAncias de p\00E1gina redefinidas para o usu\00E1rio %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981904730401356)
,p_name=>'DAILY'
,p_message_language=>'pt-br'
,p_message_text=>'Diariamente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113953559012401336)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo transferido por upload \00E9 inv\00E1lido ou sua extens\00E3o est\00E1 incorreta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977496432401353)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Seletor de XML ou JSON inv\00E1lido utilizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946768794401331)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O perfil de dados e o arquivo submetido a upload n\00E3o cont\00EAm nenhuma coluna da tabela de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032485166401393)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum dado encontrado no arquivo submetido a upload.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032519091401393)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhum dado encontrado na planilha "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113952379111401335)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo especificado n\00E3o \00E9 um arquivo XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113942725554401328)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de dados finalizada: %0 linhas processadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943908591401329)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de dados finalizada: %0 linhas processadas com 1 erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944247186401329)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de dados finalizada: %0 linhas processadas com %1 erros.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944032049401329)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de dados finalizada: 1 linha processada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947002390401331)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de dados finalizada: 1 linha processada com erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944122919401329)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>'Carga de dados finalizada: 1 linha processada sem erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037784660401397)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037810952401397)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'pt-br'
,p_message_text=>'Coluna de Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038663531401397)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Data/N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102042437401443)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>'Falha ao recuperar o valor de consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114070588098401421)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'pt-br'
,p_message_text=>'Mapeamento de Dados / Tabela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038782797401397)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034282387401394)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na regra de transforma\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010504229401377)
,p_name=>'DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984633484401358)
,p_name=>'DAY'
,p_message_language=>'pt-br'
,p_message_text=>'dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984771985401358)
,p_name=>'DAYS'
,p_message_language=>'pt-br'
,p_message_text=>'dias'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023442784401386)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A depura\00E7\00E3o n\00E3o est\00E1 ativada para este aplicativo.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114072298769401422)
,p_name=>'DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985443924401359)
,p_name=>'DELETE'
,p_message_language=>'pt-br'
,p_message_text=>'excluir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113945667368401330)
,p_name=>'DIAL_PCT'
,p_message_language=>'pt-br'
,p_message_text=>'Quadrante (Percentual)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960182807401340)
,p_name=>'DOWNLOAD'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Download'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071352015401421)
,p_name=>'DUP_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio Duplicado na lista.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967773748401346)
,p_name=>'EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977101223401353)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O endere\00E7o de e-mail "%0" n\00E3o foi encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962261150401342)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Este e-mail foi enviado por %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071534823401421)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Endere\00E7o de E-mail \00E9 muito longo. O limite \00E9 240 caracteres.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005154851401373)
,p_name=>'ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034388136401394)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel definir o valor de origem do item de p\00E1gina para atualiza\00E7\00E3o parcial da regi\00E3o da p\00E1gina')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996687218401367)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'pt-br'
,p_message_text=>'Criado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962583203401342)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Senha Expirada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113956670186401338)
,p_name=>'FILE_EMPTY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O arquivo est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036822073401396)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tamanho do arquivo submetido a upload era maior que %0 MB. Fa\00E7a upload de um arquivo menor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964696318401344)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na autentica\00E7\00E3o do usu\00E1rio e um ou mais arquivos n\00E3o foram transferidos por upload.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964709937401344)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta inst\00E2ncia n\00E3o permite que usu\00E1rios n\00E3o autenticados fa\00E7am upload de arquivos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017736332401382)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Ocorreu 1 erro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016999443401382)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'%0 erros ocorreram'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967188075401346)
,p_name=>'FORM_OF'
,p_message_language=>'pt-br'
,p_message_text=>'%0 de %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001831254401371)
,p_name=>'GO'
,p_message_language=>'pt-br'
,p_message_text=>'Ir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101608829401443)
,p_name=>'HELP'
,p_message_language=>'pt-br'
,p_message_text=>'Ajuda'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954023294401336)
,p_name=>'HOME'
,p_message_language=>'pt-br'
,p_message_text=>'Home'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984408025401358)
,p_name=>'HOUR'
,p_message_language=>'pt-br'
,p_message_text=>'hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984512313401358)
,p_name=>'HOURS'
,p_message_language=>'pt-br'
,p_message_text=>'horas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968570080401346)
,p_name=>'ICON'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00CDcone %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018588449401383)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Credenciais de Log-in Inv\00E1lidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114118055578401455)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor inv\00E1lido para o par\00E2metro: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013285482401379)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Como Configura\00E7\00F5es Padr\00E3o do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013321051401379)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Como Relat\00F3rio Nomeado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995722983401366)
,p_name=>'IR_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro de %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995421651401366)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel calcular navega\00E7\00E3o do form. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973033107401350)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio Interativo n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972447577401349)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A regi\00E3o do relat\00F3rio Interativo n\00E3o existe no aplicativo %0, p\00E1gina %1 e regi\00E3o %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114013178967401379)
,p_name=>'IR_STAR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('S\00F3 exibido para desenvolvedores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001571230401370)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta do relat\00F3rio precisa de uma chave exclusiva para identificar cada linha. A chave fornecida n\00E3o pode ser usada para esta consulta. Defina uma coluna para a chave exclusiva. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001663269401371)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A consulta do relat\00F3rio precisa de uma chave exclusiva para identificar cada linha. A chave fornecida n\00E3o pode ser usada para esta consulta. Edite os atributos de relat\00F3rio para definir uma coluna para a chave exclusiva. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038967228401398)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'pt-br'
,p_message_text=>'Escolher Arquivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038871147401398)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'pt-br'
,p_message_text=>'Arraste e solte o arquivo aqui ou'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967413856401346)
,p_name=>'ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996864680401367)
,p_name=>'ITEM_VALUE'
,p_message_language=>'pt-br'
,p_message_text=>'Valor do Item'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011281196401378)
,p_name=>'LABEL'
,p_message_language=>'pt-br'
,p_message_text=>'Label'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023361139401386)
,p_name=>'LANGUAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Idioma'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985121083401359)
,p_name=>'LAST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00FAltimo(a)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964593892401344)
,p_name=>'LENGTH'
,p_message_language=>'pt-br'
,p_message_text=>'Tamanho'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017828797401382)
,p_name=>'LOGIN'
,p_message_language=>'pt-br'
,p_message_text=>'Fazer Log-in'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056445713401410)
,p_name=>'MANAGE'
,p_message_language=>'pt-br'
,p_message_text=>'Gerenciar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121031500401458)
,p_name=>'MAXIMIZE'
,p_message_language=>'pt-br'
,p_message_text=>'Maximizar'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984261445401358)
,p_name=>'MINUTE'
,p_message_language=>'pt-br'
,p_message_text=>'minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984320597401358)
,p_name=>'MINUTES'
,p_message_language=>'pt-br'
,p_message_text=>'minutos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071707624401421)
,p_name=>'MISSING_AT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('"@" N\00E3o Encontrado no Endere\00E7o de E-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071905839401422)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia: Nenhum modelo de P\00E1gina da Caixa de Di\00E1logo foi definido para a p\00E1gina de Caixa de Di\00E1logo %0 no aplicativo %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071673868401421)
,p_name=>'MISSING_DOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('"." N\00E3o Encontrado no dom\00EDnio do Endere\00E7o de E-mail.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020842098401384)
,p_name=>'MODULE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00F3dulo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977920525401353)
,p_name=>'MONTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981775335401356)
,p_name=>'MONTHLY'
,p_message_language=>'pt-br'
,p_message_text=>'Mensalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978023598401353)
,p_name=>'MONTHS'
,p_message_language=>'pt-br'
,p_message_text=>'meses'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010812833401377)
,p_name=>'MOVE'
,p_message_language=>'pt-br'
,p_message_text=>'Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078336029401426)
,p_name=>'MOVE_FROM'
,p_message_language=>'pt-br'
,p_message_text=>'Mover de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078444123401426)
,p_name=>'MOVE_TO'
,p_message_language=>'pt-br'
,p_message_text=>'Mover para'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113998023989401368)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro na opera\00E7\00E3o de exclus\00E3o de v\00E1rias linhas: linha= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997089220401367)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Deve Ser Usu\00E1rio P\00FAblico')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954285798401336)
,p_name=>'NAME'
,p_message_language=>'pt-br'
,p_message_text=>'Nome'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011051330401377)
,p_name=>'NEW'
,p_message_language=>'pt-br'
,p_message_text=>'Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977773116401353)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode fazer log-in para %0 indo para:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977872689401353)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nova Notifica\00E7\00E3o de Conta %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101858558401443)
,p_name=>'NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020717671401384)
,p_name=>'NO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114116078420401454)
,p_name=>'NOBODY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ningu\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985527306401359)
,p_name=>'NOT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026337418401388)
,p_name=>'NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997180507401367)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016755417401382)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('dados n\00E3o encontrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025844063401388)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram encontrados relat\00F3rios atualiz\00E1veis. As opera\00E7\00F5es de exclus\00E3o e v\00E1rias linhas atualizadas s\00F3 podem ser executadas em forms tabulares do tipo ''Relat\00F3rio Atualiz\00E1vel''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026705961401389)
,p_name=>'OK'
,p_message_language=>'pt-br'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022497263401386)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'pt-br'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114119886693401457)
,p_name=>'ORA_06550'
,p_message_language=>'pt-br'
,p_message_text=>'ORA-06550: linha %0, coluna %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069316490401420)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 usando um web browser desatualizado. Para obter uma lista de browsers suportados, consulte o Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970712498401348)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Conjunto inv\00E1lido de linhas solicitado. Os dados de origem do relat\00F3rio foram modificados.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990837648401363)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Deve ser especificado um n\00FAmero de p\00E1gina v\00E1lido, por exemplo p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994450450401365)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994572657401365)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Pr\00F3ximo Conjunto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994692998401366)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113994765736401366)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'pt-br'
,p_message_text=>'Conjunto Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101736642401443)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Selecionar Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032382884401393)
,p_name=>'PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977088233401353)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>'Sua senha para %0 foi alterada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966816687401345)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha n\00E3o \00E9 compat\00EDvel com as regras de complexidade de senha deste site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965957788401345)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'A nova senha deve ser diferente da antiga senha em pelo menos %0 caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966529447401345)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha n\00E3o deve conter o nome do usu\00E1rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966790955401345)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha cont\00E9m uma palavra simples proibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966629322401345)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha n\00E3o deve conter o nome do espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965835696401345)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'A senha deve conter pelo menos %0 caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966026746401345)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha deve conter pelo menos uma caractere alfab\00E9tico (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966477244401345)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha deve conter pelo menos um caractere de letra min\00FAscula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966111922401345)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha deve conter pelo menos um caractere num\00E9rico (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966290504401345)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha deve conter pelo menos caractere de pontua\00E7\00E3o (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113966302849401345)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha deve conter pelo menos um caractere em mai\00FAscula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977587151401353)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Notifica\00E7\00E3o de Redefini\00E7\00E3o de Senha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964841028401344)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A senha n\00E3o pode ser usada porque ela foi usada nos %0 \00FAltimos dias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045180223401402)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'pt-br'
,p_message_text=>'Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114045289116401402)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'pt-br'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022258655401385)
,p_name=>'PERCENT'
,p_message_language=>'pt-br'
,p_message_text=>'Percentual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992554331401364)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'pt-br'
,p_message_text=>'Entre em contato com o administrador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114101964132401443)
,p_name=>'PREVIOUS'
,p_message_language=>'pt-br'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037363231401396)
,p_name=>'PRINT'
,p_message_language=>'pt-br'
,p_message_text=>'Imprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021084693401385)
,p_name=>'PRIVILEGES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990989786401363)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Refer\00EAncias de Regi\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011161308401378)
,p_name=>'REPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020963367401385)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Per\00EDodo do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102126401401444)
,p_name=>'REPORT_LABEL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Relat\00F3rio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021688404401385)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Total do Relat\00F3rio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970851875401348)
,p_name=>'RESET'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996763611401367)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Redefinir Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025732697401388)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Redefinir Senha'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002529662401371)
,p_name=>'RESTORE'
,p_message_language=>'pt-br'
,p_message_text=>'Restaurar'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114034480914401394)
,p_name=>'RESULTS'
,p_message_language=>'pt-br'
,p_message_text=>'Resultados'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026863995401389)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'pt-br'
,p_message_text=>'Retornar ao aplicativo.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114027180544401389)
,p_name=>'RIGHT'
,p_message_language=>'pt-br'
,p_message_text=>'Direita'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056754949401411)
,p_name=>'ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Linha %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010761484401377)
,p_name=>'ROW_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>'Contagem de Linhas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114026231461401388)
,p_name=>'SAVE'
,p_message_language=>'pt-br'
,p_message_text=>'Salvar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022862584401386)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Alternativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023262371401386)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022703253401386)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o Prim\00E1rio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023571707401386)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 mais de %0 linhas dispon\00EDveis. Aumente o seletor de linhas para ver mais linhas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088927473401434)
,p_name=>'SEARCH'
,p_message_language=>'pt-br'
,p_message_text=>'Pesquisar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984192541401358)
,p_name=>'SECONDS'
,p_message_language=>'pt-br'
,p_message_text=>'segundos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022343339401385)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'pt-br'
,p_message_text=>'Consulte anexo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080036023401427)
,p_name=>'SELECT_ROW'
,p_message_language=>'pt-br'
,p_message_text=>'Selecionar Linha'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022066033401385)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'pt-br'
,p_message_text=>'Desativar Modo de Leitor de Tela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022142575401385)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'pt-br'
,p_message_text=>'Ativar Modo de Leitor de Tela'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018409283401383)
,p_name=>'SHOW'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081869372401429)
,p_name=>'SHOW_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Mostrar Tudo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114107974966401448)
,p_name=>'SIGN_IN'
,p_message_language=>'pt-br'
,p_message_text=>'Acessar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114057520913401411)
,p_name=>'SIGN_OUT'
,p_message_language=>'pt-br'
,p_message_text=>'Sair'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011718188401378)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 dias atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018998753401383)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 dias a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011626874401378)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 horas atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018823663401383)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 horas a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011551075401378)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('H\00E1 %0 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018747576401383)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 minutos a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011904130401378)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 meses atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019189980401383)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 meses a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019329468401383)
,p_name=>'SINCE_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'Agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011436180401378)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 segundos atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114018600275401383)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 segundos a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114011802071401378)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 semanas atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019036847401383)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 semanas a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114012022084401378)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 anos atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019275027401383)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'pt-br'
,p_message_text=>'%0 anos a partir de agora'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005508987401373)
,p_name=>'STANDARD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021916559401385)
,p_name=>'START_DATE'
,p_message_language=>'pt-br'
,p_message_text=>'Data Inicial'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962445656401342)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA est\00E1 recebendo este e-mail da inscri\00E7\00E3o de relat\00F3rio Interativo criada por %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117182165401455)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Inscri\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065259774401417)
,p_name=>'TAB'
,p_message_language=>'pt-br'
,p_message_text=>'Guia'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984035990401358)
,p_name=>'TITLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('T\00EDtulo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967047477401345)
,p_name=>'TODAY'
,p_message_language=>'pt-br'
,p_message_text=>'Hoje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021517286401385)
,p_name=>'TOTAL'
,p_message_language=>'pt-br'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968077711401346)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C9 poss\00EDvel selecionar no m\00E1ximo %0 colunas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946563082401331)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Contrair Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946896868401331)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'pt-br'
,p_message_text=>'Contrair Todos os Itens a Seguir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946412686401331)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946647336401331)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'pt-br'
,p_message_text=>'Expandir Todos os Itens a Seguir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946942622401331)
,p_name=>'TREE.REPARENT'
,p_message_language=>'pt-br'
,p_message_text=>'Alterar os pais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039146411401398)
,p_name=>'TREES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('\00C1rvores')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114082646036401429)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Obrigat\00F3rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114006287420401374)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr(' N\00E3o Autorizado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114053008490401408)
,p_name=>'UNAVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Indispon\00EDvel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019768692401384)
,p_name=>'UNKNOWN'
,p_message_language=>'pt-br'
,p_message_text=>'Desconhecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963326979401343)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Ocorreu um erro de autentica\00E7\00E3o n\00E3o reconhecido.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965309859401344)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se voc\00EA n\00E3o quiser mais receber e-mails, clique em <a href="%0">cancelar inscri\00E7\00E3o</a> para gerenciar sua inscri\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113962334119401342)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Se voc\00EA n\00E3o quiser mais receber e-mails, v\00E1 para o seguinte URL para gerenciar sua inscri\00E7\00E3o:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113997282145401367)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('tipo de dados n\00E3o suportado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985345604401359)
,p_name=>'UPDATE'
,p_message_language=>'pt-br'
,p_message_text=>'atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983959738401358)
,p_name=>'UPDATED'
,p_message_language=>'pt-br'
,p_message_text=>'Atualizado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990660181401363)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'pt-br'
,p_message_text=>'O URL solicitado foi proibido. Entre em contato com o administrador.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114010686376401377)
,p_name=>'USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114032269128401393)
,p_name=>'USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do Usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071837781401422)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome do usu\00E1rio \00E9 muito grande. O limite \00E9 de %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017422295401382)
,p_name=>'USERS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('usu\00E1rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114071474921401421)
,p_name=>'USER_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Nome do usu\00E1rio j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114086158587401432)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Imagem de perfil do usu\00E1rio %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973700525401350)
,p_name=>'VALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967372830401346)
,p_name=>'VALIDATIONS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valida\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023063403401386)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'pt-br'
,p_message_text=>'O valor deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066451766401418)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'pt-br'
,p_message_text=>'O valor deve ser especificado para %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992974596401364)
,p_name=>'VERTICAL'
,p_message_language=>'pt-br'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985215248401359)
,p_name=>'VIEW'
,p_message_language=>'pt-br'
,p_message_text=>'exibir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017583239401382)
,p_name=>'VIEWS'
,p_message_language=>'pt-br'
,p_message_text=>'views'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023862920401387)
,p_name=>'VIEW_ALL'
,p_message_language=>'pt-br'
,p_message_text=>'Exibir Tudo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114005098663401373)
,p_name=>'WARNING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Advert\00EAncia')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984856577401358)
,p_name=>'WEEK'
,p_message_language=>'pt-br'
,p_message_text=>'semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981816087401356)
,p_name=>'WEEKLY'
,p_message_language=>'pt-br'
,p_message_text=>'Semanalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113984938964401358)
,p_name=>'WEEKS'
,p_message_language=>'pt-br'
,p_message_text=>'semanas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114023158668401386)
,p_name=>'WELCOME_USER'
,p_message_language=>'pt-br'
,p_message_text=>'Bem-vindo: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021399063401385)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foi encontrado valor inv\00E1lido. Verifique os dados informados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021439666401385)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foi encontrado valor inv\00E1lido. Verifique os dados informados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964405097401343)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor de data inv\00E1lido encontrado. Verifique o formato da data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114021200013401385)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foi encontrado valor de n\00FAmero inv\00E1lido. Verifique o formato do n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973331169401350)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foi encontrado um valor de timestamp inv\00E1lido. Verifique o formato do timestamp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113995895421401366)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel associar %0. Use aspas para itens com v\00E1rios bytes ou verifique se o comprimento do item tem 30 bytes ou menos. Use a sintaxe v() para referenciar itens com mais de 30 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986350759401359)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso negado pela verifica\00E7\00E3o de seguran\00E7a %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988833325401361)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo N\00E3o Dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987260771401360)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1014 Aplicativo n\00E3o encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987318653401360)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('aplicativo=%0  espa\00E7o de trabalho=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987768163401360)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O acesso a este aplicativo \00E9 restrito; tente novamente mais tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987674919401360)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O acesso a este aplicativo \00E9 restrito a desenvolvedores de aplicativos; tente novamente mais tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986850603401360)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-7744 N\00E3o foi poss\00EDvel processar ramifica\00E7\00E3o para URL de retorno da fun\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986741100401360)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-7744 N\00E3o foi poss\00EDvel processar ramifica\00E7\00E3o para p\00E1gina de retorno da fun\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987010093401360)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1430 Chamada para mostrar usando processo de p\00E1gina n\00E3o suportada: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988186485401361)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'ERR-1018 Erro ao limpar cache da etapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986573882401360)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1005 Tipo de c\00E1lculo desconhecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987407958401360)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1201 ID de sess\00E3o n\00E3o definido na autentica\00E7\00E3o da sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987553090401360)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('p\00E1gina=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113987151362401360)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-7620 N\00E3o foi poss\00EDvel determinar o espa\00E7o de trabalho do aplicativo (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969514720401347)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'pt-br'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986264299401359)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1802 N\00E3o foi poss\00EDvel encontrar id do item "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985915592401359)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1002 N\00E3o foi poss\00EDvel localizar o ID do item "%0" no aplicativo "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986019507401359)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro inesperado, n\00E3o foi poss\00EDvel localizar o nome do item no n\00EDvel do aplicativo ou p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986463701401360)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA j\00E1 est\00E1 na primeira p\00E1gina de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114001940134401371)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O ID de item (%0) n\00E3o \00E9 um item definido na p\00E1gina atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964071581401343)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item n\00E3o pode ser definido por meio da especifica\00E7\00E3o de argumentos para o aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964352103401343)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'pt-br'
,p_message_text=>'(Nenhuma checksum foi fornecida)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963825328401343)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item pode ser definido quando acompanhado por uma checksum de "marcador de n\00EDvel de usu\00E1rio".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963705120401343)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item pode ser definido quando acompanhado por uma checksum de "marcador de n\00EDvel de aplicativo".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963921266401343)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item pode ser definido quando acompanhado por uma checksum de "sess\00E3o".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963670065401343)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Item n\00E3o tem prote\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988270475401361)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 ajuda da p\00E1gina dispon\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113977338473401353)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho %0 n\00E3o possui privil\00E9gios para fazer parsing como o esquema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986626603401360)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1010 Excedido limite de recurs\00E3o no processamento de aceita\00E7\00E3o de ramifica\00E7\00E3o para p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964245766401343)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina n\00E3o pode ser chamada com um URL ou com um comando GET ou POST pelo procedimento de exibi\00E7\00E3o; ela deve ser chamada com um tipo de ramifica\00E7\00E3o "Ramificar para P\00E1gina"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114040947730401399)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao tentar salvar valor n\00E3o num\00E9rico no item %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979030216401354)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema de parsing "%0" do aplicativo n\00E3o existe no banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113979132465401354)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As contas no espa\00E7o de trabalho INTERNO s\00F3 podem ser usadas para acessar os <a href="%0">Servi\00E7os de Administra\00E7\00E3o</a> do &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985830454401359)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-1029 N\00E3o foi poss\00EDvel armazenar informa\00E7\00F5es sobre a sess\00E3o.  sess\00E3o=%0 item=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988950980401361)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel interromper rastreamento: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113986192940401359)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro inesperado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996167458401367)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro em update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989018107401361)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Aplicativo e p\00E1gina devem ser fornecidas para exibir a ajuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114009553433401376)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Automa\00E7\00E3o n\00E3o encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990142528401362)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Foram expurgadas %0 sess\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949433198401333)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel executar o c\00F3digo %0! N\00E3o h\00E1 suporte para ele no banco de dados ou ele n\00E3o foi ativado pelo par\00E2metro de inst\00E2ncia MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113949251243401333)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Multi Lingual Engine n\00E3o est\00E1 dispon\00EDvel nesta vers\00E3o do banco de dados!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970078462401348)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O array do conjunto de aplicativos n\00E3o deve ser nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969826132401347)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O atributo de membro especificado n\00FAmero %0 \00E9 inv\00E1lido. O n\00FAmero do atributo deve estar entre 1 e %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970383684401348)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>'O conjunto de aplicativos existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970100766401348)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome do conjunto n\00E3o pode ser nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970288497401348)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O nome do conjunto n\00E3o pode ter mais de 255 caracteres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969641041401347)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O conjunto de aplicativos %0 n\00E3o existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970409761401348)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O cursor ainda n\00E3o est\00E1 aberto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969722055401347)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A sequ\00EAncia de membros %0 n\00E3o existe no conjunto de Aplicativos %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113969943553401348)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A sequ\00EAncia de membros %0 n\00E3o existe no conjunto de aplicativos "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041705904401400)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A fun\00E7\00E3o de criptografia "% 0" n\00E3o \00E9 compat\00EDvel com este sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095238256401438)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'pt-br'
,p_message_text=>'Acessibilidade Testada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989688607401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'pt-br'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989736509401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Op\00E7\00F5es de Personaliza\00E7\00E3o de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989879581401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Padr\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989922736401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'pt-br'
,p_message_text=>'Exibido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990081988401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'pt-br'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989410336401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Marque as regi\00F5es que voc\00EA deseja que sejam inclu\00EDdas nesta p\00E1gina. As regi\00F5es marcadas poder\00E3o n\00E3o ser exibidas se voc\00EA n\00E3o estiver no contexto do aplicativo correto ou se n\00E3o tiver os privil\00E9gios adequados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989556751401362)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta p\00E1gina n\00E3o \00E9 personaliz\00E1vel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095525615401439)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA pode personalizar a apar\00EAncia desse aplicativo alterando o Estilo do Tema. Selecione um Estilo de Tema na lista abaixo e clique em Aplicar Altera\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114096363828401439)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Exibi\00E7\00E3o de Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095493736401439)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Usar Estilo Padr\00E3o do Aplicativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114095339554401438)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Apar\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038301276401397)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O \00EDndice de coluna referenciado no agregado %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941608013401327)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para a sa\00EDda do CLOB no formato %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038019748401397)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A quebra de coluna precisa estar no in\00EDcio do array de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038197209401397)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O \00EDndice do grupo de colunas referenciado em %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113955612862401337)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('exporta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113960888389401341)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O formato de exporta\00E7\00E3o deve ser XML usando o ORDS como Servidor de Impress\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038403960401397)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O \00EDndice de coluna referenciado no destaque %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954183563401336)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Formato de Exporta\00E7\00E3o Inv\00E1lido: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114038210805401397)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O \00EDndice do grupo pai referenciado em %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114063445053401415)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna %1 da tabela %0 \00E9 uma coluna de identidade "GENERATED ALWAYS". Certifique-se de que nenhuma coluna de origem seja mapeada para a coluna %1 na caixa de di\00E1logo Configurar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980874160401356)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O intervalo de confirma\00E7\00E3o especificado \00E9 muito baixo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113980925310401356)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma coluna foi informada para carregamento de dados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982192181401356)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foram encontradas colunas para o seletor de linha "%0". Tente detectar automaticamente ou revise a estrutura de JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990499396401362)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma planilha encontrada no arquivo XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990349052401362)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A planilha especificada n\00E3o existe no arquivo XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113970527956401348)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A vers\00E3o atual dos dados contidos no banco de dados foi alterada desde que o usu\00E1rio iniciou o processo de atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972928135401350)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao atualizar colunas do relat\00F3rio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077605401401426)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel converter %0 em SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017162870401382)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna %0 que \00E9 do tipo de dados %1 n\00E3o pode ser convertida em VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024170195401387)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna "%0" especificada para o atributo "%1" n\00E3o foi encontrada na origem de dados!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965404810401344)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o tipo de filtro %0 em colunas com diversos valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114081065856401428)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Filtro "entre" inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947508878401331)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de LOV inv\00E1lido especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947436369401331)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Tipo de consulta inv\00E1lido. O tipo de consulta deve ser Tabela, consulta SQL ou Fun\00E7\00E3o PL/SQL que retorne uma Consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017279286401382)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Falha ao fazer parsing de consulta SQL!',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024239874401387)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A posi\00E7\00E3o especificada %0 da coluna para o atributo "%1" n\00E3o foi encontrada na instru\00E7\00E3o SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113946096449401330)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'pt-br'
,p_message_text=>'Muitos itens usados no filtro Diversos Valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024027315401387)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma coluna especificada para o atributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947331931401331)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O corpo da fun\00E7\00E3o PL/SQL n\00E3o retornou um valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114037206358401396)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Origem de Dados REST n\00E3o cont\00E9m uma Opera\00E7\00E3o para tratar a a\00E7\00E3o do DML solicitada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113943244878401328)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A convers\00E3o de GeoJSON em SDO_GEOMETRY (coluna %0) n\00E3o est\00E1 dispon\00EDvel neste banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944399383401329)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A convers\00E3o SDO_GEOMETRY (coluna %0) n\00E3o \00E9 suportada para origens de dados XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113951667758401334)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 suporte para o caractere %0 como um separador de v\00E1rios valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114078948498401427)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Esta fun\00E7\00E3o n\00E3o pode ser usada em um Contexto de Consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113944462129401329)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'Incompatibilidade de Tipo de Dados da Coluna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947237925401331)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>'Limites de Binding ORDS OUT excedidos. Reduza a quantidade de linhas DML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114025086103401387)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel fazer parsing da resposta JSON do servidor remoto: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113947115599401331)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Tipo de contexto desconhecido ou incorreto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114041630133401400)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este tipo de arquivo n\00E3o \00E9 suportado pelo parser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996239258401367)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso n\00E3o autorizado (wwv_flow_api.set_credentials n\00E3o definido).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973278358401350)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O espa\00E7o de trabalho n\00E3o foi criado porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113973137691401350)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O grupo de usu\00E1rios n\00E3o foi criado porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983474891401357)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Encontrado nome de usu\00E1rio duplicado para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983516231401357)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao carregar usu\00E1rios. Falha no usu\00E1rio %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993422532401365)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Teriam carregado %0 usu\00E1rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993276088401365)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'pt-br'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993353406401365)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Privil\00E9gios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993026752401364)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nome do usu\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069535472401420)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao renderizar o item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989167356401362)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel exibir o item de p\00E1gina porque o form HTML n\00E3o foi aberto ainda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113954413886401336)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao calcular o valor padr\00E3o do item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988465404401361)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro de p\00F3s-c\00E1lculo do item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988388721401361)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao calcular o valor de origem do item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968188650401346)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Acesso n\00E3o autorizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988622930401361)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('JavaScript n\00E3o suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988733957401361)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'pt-br'
,p_message_text=>'Listar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113989390540401362)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel inicializar consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996511223401367)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A atualiza\00E7\00E3o de %0 n\00E3o \00E9 suportada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113990716532401363)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ID do item inv\00E1lido: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114017033796401382)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o h\00E1 ajuda para este item.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981505627401356)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na gera\00E7\00E3o de consultas do gr\00E1fico. Verifique as configura\00E7\00F5es de Mapeamento da Origem e da Coluna.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076316408401425)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tamanho %0 MB do anexo excede o tamanho m\00E1ximo para anexos de %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982400404401357)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor inv\00E1lido para o par\00E2metro p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114099820778401442)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA excedeu o n\00FAmero m\00E1ximo de mensagens de e-mail por espa\00E7o de trabalho. Entre em contato com seu administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963491822401343)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este procedimento deve ser chamado a partir de uma sess\00E3o de aplicativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982300294401357)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Valor nulo fornecido para o par\00E2metro %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036325762401396)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Modelo de e-mail "%0" n\00E3o encontrado no aplicativo %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114112817804401451)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O par\00E2metro da inst\00E2ncia SMTP_HOST_ADDRESS deve ser definido para enviar e-mails.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982092655401356)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Forne\00E7a um destinat\00E1rio da mensagem para enviar o e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114102275142401444)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel estabelecer conex\00E3o SMTP com o servidor de e-mail configurado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114076436383401425)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Chamada do Ajax inv\00E1lida!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967862158401346)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma fun\00E7\00E3o do Ajax foi definida para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066886388401418)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma fun\00E7\00E3o de execu\00E7\00E3o foi definida para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967938380401346)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Nenhuma fun\00E7\00E3o de renderiza\00E7\00E3o foi definida para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077328682401426)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o "Recursos".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077225868401425)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077479411401426)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o de execu\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114077599357401426)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o de extra\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965681163401344)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro no c\00F3digo PLSQL emitido durante o processamento do plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972225648401349)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'O valor deve ser especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002898596401372)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O tipo de dados %0 n\00E3o pode ser convertido em VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088475956401433)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A coluna "%0" especificada para o atributo "%1" n\00E3o foi encontrada na instru\00E7\00E3o SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064753756401416)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'pt-br'
,p_message_text=>'Uma consulta de lista de valores (LOV) ou uma lista de valores Nomeados deve ser especificada para %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114066326977401417)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00FAmero incorreto de colunas selecionado na consulta SQL da LOV para %0. Veja exemplos de instru\00E7\00F5es v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088215508401433)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'pt-br'
,p_message_text=>'Nenhuma coluna especificada para o atributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117946674401455)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O valor informado %0 do atributo "%1" n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114069823522401420)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('%0 tem um tipo de dados incorreto na instru\00E7\00E3o SQL. A coluna #  %1 \00E9 %2 mas esperava %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114088367975401433)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'pt-br'
,p_message_text=>'A coluna "%0" especificada para o atributo "%1" tem o tipo de dados %2, mas deveria ter %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113964973276401344)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel encontrar o layout do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024936700401387)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A funcionalidade Calcular Soma n\00E3o pode ser usada em relat\00F3rios baseados em uma Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113988529609401361)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('ERR-2904 N\00E3o foi poss\00EDvel definir valor de atalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113992817436401364)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro: Tipo de atalho desconhecido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113982880850401357)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel extrair authentication_scheme no aplicativo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114056313833401410)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O id do tenant j\00E1 existe para a sess\00E3o atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113993156066401364)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'pt-br'
,p_message_text=>'E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117361476401455)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Falha na autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114019652955401384)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Um ou mais cookies definidos em apex_util.g_request_cookies cont\00EAm um valor inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114002151157401371)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A resposta do registro UDDI foi inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113965768310401344)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O URL fornecido n\00E3o retornou um documento WSDL v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113968260609401346)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O documento WSDL cont\00E9m v\00E1rias associa\00E7\00F5es SOAP. O &PRODUCT_NAME. suporta somente WSDL''s com uma associa\00E7\00E3o SOAP. Clique em Criar Refer\00EAncia de Web Service Manualmente para configurar a cria\00E7\00E3o de uma refer\00EAncia para esse servi\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114036655930401396)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A resposta do servi\00E7o n\00E3o era XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117221688401455)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Token de acesso do OAuth n\00E3o dispon\00EDvel ou expirado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114080408796401428)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Voc\00EA excedeu o n\00FAmero m\00E1ximo de mensagens de solicita\00E7\00F5es de servi\00E7o Web por espa\00E7o de trabalho. Entre em contato com seu administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114117471981401455)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O servidor respondeu com um tipo de token OAuth n\00E3o suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967618088401346)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O documento WSDL n\00E3o continha um bind para SOAP que \00E9 necess\00E1rio para adicionar a refer\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113963584205401343)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este WSDL requer credenciais de autentica\00E7\00E3o. Forne\00E7a o nome de usu\00E1rio e a senha abaixo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113972340794401349)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O documento WSDL n\00E3o p\00F4de ser compreendido pelo mecanismo de convers\00E3o. Clique em Criar Refer\00EAncia de Web Service Manualmente para continuar criando uma refer\00EAncia para esse servi\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114039273824401398)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel processar a atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114065030807401417)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'pt-br'
,p_message_text=>unistr('As colunas de retorno e de exibi\00E7\00E3o da Lista de Valores s\00E3o iguais!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114064905778401416)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>unistr('A Lista de Valores n\00E3o possui uma coluna de retorno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996428150401367)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'pt-br'
,p_message_text=>'Erro ao extrair valor de coluna: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020471370401384)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Os dados atuais do form tabular s\00E3o muito antigos.<br/> Clique <strong><a href="%0">aqui</a></strong> para descartar suas altera\00E7\00F5es e recarregue os dados do banco de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978534390401354)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao determinar string de pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978408407401354)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('n\00E3o foi poss\00EDvel determinar cabe\00E7alhos de consulta:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978637216401354)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'pt-br'
,p_message_text=>unistr('erro ao executar substitui\00E7\00F5es de rodap\00E9 de relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978743422401354)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'falha ao fazer parsing de consulta SQL:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983715059401358)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'pt-br'
,p_message_text=>unistr('M\00EDnimo de linhas solicitado: %0, linhas encontradas mas n\00E3o exibidas: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981299111401356)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('a coluna #%0 (%1) da consulta \00E9 inv\00E1lida; as colunas que usam HTML necessitam de nomes de aliases')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113996355908401367)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Erro ao obter cabe\00E7alhos de consulta: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978861340401354)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'reportar erro:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114016518748401381)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'pt-br'
,p_message_text=>'Classificar por esta coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981352095401356)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'pt-br'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>A consulta n\00E3o pode ser submetida a parse; verifique a sintaxe de sua consulta.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020596082401384)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'pt-br'
,p_message_text=>unistr('Este form cont\00E9m altera\00E7\00F5es n\00E3o salvas. Pressione "Ok" para prosseguir sem salvar suas altera\00E7\00F5es. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114024843860401387)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'pt-br'
,p_message_text=>unistr('O esquema de pagina\00E7\00E3o do relat\00F3rio (%0) n\00E3o \00E9 suportado com a origem de dados escolhida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113981101376401356)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'pt-br'
,p_message_text=>unistr('a coluna #%0 (%1) da consulta \00E9 inv\00E1lida, use alias de coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983810045401358)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'pt-br'
,p_message_text=>'linha(s) %0 - %1 de mais do que %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114022519107401386)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - %1 de mais de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113983606510401358)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'pt-br'
,p_message_text=>'linha(s) %0 - %1 de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113967542010401346)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'pt-br'
,p_message_text=>'%0 - %1 de %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978933347401354)
,p_name=>'Y'
,p_message_language=>'pt-br'
,p_message_text=>'S'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113985024574401359)
,p_name=>'YEAR'
,p_message_language=>'pt-br'
,p_message_text=>'ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113978123687401353)
,p_name=>'YEARS'
,p_message_language=>'pt-br'
,p_message_text=>'anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114020668578401384)
,p_name=>'YES'
,p_message_language=>'pt-br'
,p_message_text=>'Sim'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4475)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4475)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\00C1rea de Trabalho')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4475
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4475)
,p_name=>'Mensagens'
,p_alias=>'MESSAGES'
,p_step_title=>'Mensagens'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
