prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4495
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4495 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4495
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103094659403743')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'pt'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4495)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113352'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4495)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4495)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4495)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4495)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4495)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4495)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.pt'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4495)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4495)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4495)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4495)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4495)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4495)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.pt'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4495)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4495)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4495)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4495)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4495)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4495)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.pt'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4495)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4495)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.pt'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4495)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4495)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.pt'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4495)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4495)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.pt'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4495)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4495)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4495)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.pt'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4495
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4495)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4495)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4495)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4495
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4495)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4495
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4495)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4495
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4495)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4495
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4495)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4495
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4495)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4495
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4495
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4495)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4495)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4495)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4495)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4495)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4495)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4495)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4495)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4495)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4495)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4495)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4495)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4495)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4495)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4495)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4495)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4495)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4495)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4495)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4495)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4495)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4495)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4495
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4495)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4495)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4495)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4495)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4495)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4495
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4495)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4495
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4495)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4495
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4495)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4495
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4495)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4495
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4495)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4495
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4495)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4495)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4495)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4495)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4495)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4495)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4495)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4495)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4495)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4495
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4495)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4495)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4495)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4495)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4495)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4495)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4495)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4495
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4495)
,p_page_name=>'winlov'
,p_page_title=>unistr('Caixa de Di\00E1logo Pesquisar')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Pesquisar'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Fechar'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Seguinte &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Anterior'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Linha(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4495
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4495)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4495
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4495)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4495)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4495)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4495)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4495)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4495)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4495)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4495)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4495)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4495)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4495)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4495)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4495)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4495)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4495)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4495)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4495)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4495)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4495)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4495)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4495)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4495)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4495)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4495)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4495)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4495)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4495)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4495)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4495)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4495)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4495)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4495)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4495)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4495)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4495)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4495)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4495)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4495)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4495)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4495)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4495)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4495)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4495)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4495)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4495)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4495)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4495)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4495)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4495)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4495)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4495)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4495)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4495)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4495)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4495)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4495)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4495)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4495)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4495)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4495)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4495)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4495)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4495)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4495)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4495)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4495)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4495)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4495)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4495)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4495)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4495)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4495)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4495)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4495)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4495)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4495)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4495)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4495)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4495)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4495)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4495)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4495)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4495)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4495)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4495)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4495)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4495)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4495)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4495)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4495)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4495)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4495)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4495)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4495)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4495)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4495)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4495)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4495)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4495)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4495)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4495)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4495)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4495)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4495)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4495)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4495)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4495)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4495)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4495)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4495)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4495)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4495)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4495)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4495)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4495)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4495)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4495)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4495)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4495)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4495)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4495)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4495)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4495)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4495)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4495)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4495)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4495)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4495)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4495)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4495)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4495)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4495)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4495)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4495)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4495)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4495)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4495)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4495)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4495)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4495)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4495)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4495)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4495)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4495)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4495)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4495)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4495)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4495)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4495)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4495)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4495)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4495)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4495)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4495)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4495)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4495)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4495)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4495)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4495)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4495)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4495)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4495)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4495)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4495)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4495)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4495)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4495)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4495)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4495)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4495)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4495)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4495)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793613770401214)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'pt'
,p_message_text=>'Coluna %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780728058401204)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'pt'
,p_message_text=>'Administrador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780624967401204)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'pt'
,p_message_text=>'Nome de Utilizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837946598401245)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'pt'
,p_message_text=>'Acesso Recusado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797643769401216)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'pt'
,p_message_text=>'A sua conta %0 foi criada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783282053401206)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'pt'
,p_message_text=>unistr('A conta est\00E1 bloqueada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773149151401199)
,p_name=>'AM_PM'
,p_message_language=>'pt'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907528045401296)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'pt'
,p_message_text=>'Alternar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915645248401301)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'pt'
,p_message_text=>'(Ativo)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885144263401280)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'pt'
,p_message_text=>'A chamada de Ajax devolveu o erro do servidor %0 para %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815905130401229)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'pt'
,p_message_text=>unistr('O pseud\00F3nimo da aplica\00E7\00E3o "%0" n\00E3o pode ser convertido numa ID da aplica\00E7\00E3o exclusiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816036848401230)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('A aplica\00E7\00E3o com o pseud\00F3nimo "%0" n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805695310401222)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1816 Erro inesperado ao converter o pseud\00F3nimo da aplica\00E7\00E3o p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898544097401289)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('A soma de verifica\00E7\00E3o da aplica\00E7\00E3o proporciona uma forma f\00E1cil de determinar se a mesma aplica\00E7\00E3o \00E9 implementada em todos os espa\00E7os de trabalho. Pode comparar esta soma de verifica\00E7\00E3o para determinar se existe uma correspond\00EAncia. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791423804401212)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a fun\00E7\00E3o de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776821393401201)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a fun\00E7\00E3o de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940335685401319)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'pt'
,p_message_text=>unistr('O Nome do Tenant %0 devolvido pelo Oracle Cloud Identity Management n\00E3o est\00E1 autorizado para o dom\00EDnio %1!<br/><a href="&LOGOUT_URL.">Entre novamente em sess\00E3o</a> e especifique um nome de tenant autorizado ou altere o seu URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774548722401200)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua conta "%0" n\00E3o tem os privil\00E9gios de desenvolvimento necess\00E1rios (DB_DEVELOPER ou DB_ADMINISTRATOR)<br/>para o espa\00E7o de trabalho "%1"! <a href="&LOGOUT_URL.">Entre novamente em sess\00E3o</a> ap\00F3s os privil\00E9gios terem sido fornecidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773668615401199)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'pt'
,p_message_text=>unistr('O Nome do Tenant devolvido pelo Oracle Cloud Identity Management n\00E3o est\00E1 autorizado para o espa\00E7o de trabalho atual!<br/><a href="&LOGOUT_URL.">Entre novamente em sess\00E3o</a> e especifique um nome de tenant autorizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774654819401200)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'pt'
,p_message_text=>unistr('Por motivos de seguran\00E7a, n\00E3o \00E9 permitido executar aplica\00E7\00F5es deste espa\00E7o de trabalho atrav\00E9s do dom\00EDnio no URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791136254401212)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Pe\00E7a ao DBA para executar $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791003908401212)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'pt'
,p_message_text=>unistr('O pacote SYS.DBMS_LDAP n\00E3o existe ou \00E9 inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790997769401212)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a fun\00E7\00E3o de edi\00E7\00E3o de utilizador de LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791232489401212)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a autentica\00E7\00E3o de LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792048655401212)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'pt'
,p_message_text=>'Erro no argumento p_flow_page para o procedimento login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791630334401212)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'pt'
,p_message_text=>unistr('p_session inv\00E1lido em wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839501643401247)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'pt'
,p_message_text=>'Argumento incorreto para wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791787976401212)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'pt'
,p_message_text=>unistr('Nome de utilizador nulo transmitido ao procedimento de entrada em sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780533690401204)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'pt'
,p_message_text=>unistr('Aguarde <span id="apex_login_throttle_sec">%0</span> segundos para entrar em sess\00E3o novamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781886081401205)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('A tentativa de entrada em sess\00E3o foi bloqueada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837390242401245)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('Autentica\00E7\00E3o "%0" n\00E3o encontrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782153832401205)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID do grupo de seguran\00E7a \00E9 nula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791505225401212)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao executar o processo de p\00F3s-autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791353723401212)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar o processo de pr\00E9-autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792590297401213)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Abra o URL no mesmo browser onde iniciou o pedido Redefinir Senha. Se clicar no URL de Redefini\00E7\00E3o da Senha e for redirecionado para'),
unistr('a p\00E1gina de entrada em sess\00E3o, inicie novamente a Redefini\00E7\00E3o da Senha e deixe o'),
'browser aberto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937844042401318)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'pt'
,p_message_text=>unistr('URL de Redefini\00E7\00E3o da Senha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774860279401200)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'pt'
,p_message_text=>unistr('O grupo de consumidores do Gestor de Recursos %0 n\00E3o foi concedido a %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774954299401200)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'pt'
,p_message_text=>unistr('Utilize DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP para conceder o privil\00E9gio em falta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802971660401220)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a fun\00E7\00E3o de sentinela da sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803042145401220)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a fun\00E7\00E3o de verifica\00E7\00E3o da sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803235355401220)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Pe\00E7a ao administrador do %0 para configurar o mecanismo para o Acesso \00DAnico do Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812799809401227)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'pt'
,p_message_text=>'%0 ilegal no token %1 devolvido pelo SSO.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791950060401212)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'pt'
,p_message_text=>unistr('Edite o esquema de autentica\00E7\00E3o e acrescente o nome da aplica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812472824401227)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'pt'
,p_message_text=>'Chamador ilegal do procedimento %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812612497401227)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('Sess\00E3o da aplica\00E7\00E3o inv\00E1lida no token de URLC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812276000401227)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro em portal_sso_redirect: informa\00E7\00F5es de registo da aplica\00E7\00E3o em falta: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803150355401220)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'pt'
,p_message_text=>unistr('O pacote WWSEC_SSO_ENABLER_PRIVATE n\00E3o existe ou \00E9 inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113791808749401212)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel encontrar o nome da aplica\00E7\00E3o de parceiro registada no esquema de autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812380682401227)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'pt'
,p_message_text=>unistr('Registe esta aplica\00E7\00E3o conforme descrito no manual de instala\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803367305401220)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a autentica\00E7\00E3o de SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912799269401299)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'pt'
,p_message_text=>unistr('URL N\00E3o Autorizado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802773404401220)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774709353401200)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'pt'
,p_message_text=>unistr('O espa\00E7o de trabalho "%0" est\00E1 inativo. Contacte o administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775181595401200)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'pt'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781532554401205)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Acesso recusado pela verifica\00E7\00E3o de seguran\00E7a da Aplica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781680778401205)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Acesso recusado pela verifica\00E7\00E3o de seguran\00E7a da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781786254401205)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar a autoriza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845106974401251)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'pt'
,p_message_text=>'Criado com %0 utilizando %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845223812401251)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'pt'
,p_message_text=>'amor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903083987401292)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Descri\00E7\00E3o do Evento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902867067401292)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'pt'
,p_message_text=>'Data de Fim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903198766401293)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'pt'
,p_message_text=>'ID do Evento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902746172401292)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'pt'
,p_message_text=>unistr('Data de In\00EDcio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902913307401292)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo do Evento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793504073401213)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro no conte\00FAdo da soma de verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793494335401213)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro no formato da soma de verifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857427298401260)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'pt'
,p_message_text=>unistr('Copiado para a \00E1rea de transfer\00EAncia.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857127349401259)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'pt'
,p_message_text=>unistr('Este browser n\00E3o suporta a c\00F3pia a partir de um bot\00E3o ou menu. Tente Ctrl+C ou Comando+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845620004401251)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Fechar Notifica\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901658386401291)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'pt'
,p_message_text=>'Contraste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896146476401287)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'pt'
,p_message_text=>'Atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896019972401287)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'pt'
,p_message_text=>'Inicial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900249435401290)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# deve ser uma cor v\00E1lida. Exemplo: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895945446401287)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'pt'
,p_message_text=>'Escolher cor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896273112401287)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'pt'
,p_message_text=>'Alterar formato da cor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935497708401316)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'pt'
,p_message_text=>'Lista de Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935571147401316)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'pt'
,p_message_text=>'Abrir lista para: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915701982401302)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'pt'
,p_message_text=>unistr('(Conclu\00EDdo)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808058293401224)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'pt'
,p_message_text=>unistr('Contacte o administrador da aplica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822402787401234)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Contacte o administrador da aplica\00E7\00E3o.'),
unistr('Existem detalhes sobre este incidente dispon\00EDveis atrav\00E9s da ID de depura\00E7\00E3o "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900530019401291)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'pt'
,p_message_text=>'Corrija os erros antes de gravar.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846546922401252)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 correspond\00EAncias encontradas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846482828401252)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontradas correspond\00EAncias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916257508401302)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'pt'
,p_message_text=>'Progresso Atual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900996362401291)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O ficheiro especificado no item %0 n\00E3o existe em in APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889409649401283)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'pt'
,p_message_text=>unistr('A vers\00E3o atual dos dados na base de dados foi alterada desde que o utilizador iniciou o processo de atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858542592401260)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Carregar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905534052401294)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro de pr\00E9-processamento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905308202401294)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'pt'
,p_message_text=>'Inserir linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919421298401304)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Sequ\00EAncia: A\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905497369401294)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'pt'
,p_message_text=>'Atualizar linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846981097401252)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Calend\00E1rio Sobreposto: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769559170401196)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769616875401196)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905715755401294)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'pt'
,p_message_text=>'#LABEL# deve ter um valor.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905674868401294)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# deve ser uma data v\00E1lida; por exemplo, %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773200528401199)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'pt'
,p_message_text=>'#LABEL# deve estar entre %0 e %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773359152401199)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'pt'
,p_message_text=>'#LABEL# deve ser igual ou posterior a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773417238401199)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'pt'
,p_message_text=>'#LABEL# deve ser igual ou anterior a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850443529401254)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# \00E9 posterior \00E0 data m\00E1xima especificada %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850868166401255)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# n\00E3o corresponde ao formato %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850332620401254)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# \00E9 anterior \00E0 data m\00EDnima especificada %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850553137401254)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# n\00E3o est\00E1 no intervalo v\00E1lido de %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850771293401255)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# n\00E3o est\00E1 no intervalo de anos v\00E1lido de %0 e %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900847516401291)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'pt'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928016114401310)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'pt'
,p_message_text=>'Fechar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930057197401312)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900655512401291)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'pt'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900788670401291)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'pt'
,p_message_text=>'Gravar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806987206401223)
,p_name=>'APEX.ERROR'
,p_message_language=>'pt'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774307251401200)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'pt'
,p_message_text=>'Ocorreu o erro seguinte ao executar a callback de tratamento de erros: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783087815401206)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Ocorreu um erro ao pintar a p\00E1gina de erro: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775074389401200)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'pt'
,p_message_text=>'Erro Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914807246401301)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contacte o administrador.',
unistr('Existem detalhes sobre este incidente dispon\00EDveis atrav\00E9s da ID de depura\00E7\00E3o "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909107686401297)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'pt'
,p_message_text=>unistr('A base de dados est\00E1 aberta para acesso s\00F3 de leitura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939746063401319)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'pt'
,p_message_text=>unistr('ORA-28353: Falha ao abrir o wallet. Dados da aplica\00E7\00E3o n\00E3o acess\00EDveis atualmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909260212401297)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta p\00E1gina n\00E3o est\00E1 dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776763908401201)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'pt'
,p_message_text=>unistr('Informa\00E7\00F5es t\00E9cnicas (apenas vis\00EDveis para programadores)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872822849401271)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'pt'
,p_message_text=>'Mensagem de Erro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886791293401281)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'pt'
,p_message_text=>'Formato esperado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853498185401257)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'pt'
,p_message_text=>unistr('O Utilizador j\00E1 existe na Lista de Controlo de Acesso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853307567401257)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'pt'
,p_message_text=>unistr('Confirme a adi\00E7\00E3o do(s) seguinte(s) %0 utilizador(es) \00E0 lista de controlo de acesso <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853841829401257)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'pt'
,p_message_text=>'Existe um utilizador duplicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853545640401257)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'pt'
,p_message_text=>unistr('Falta o sinal de arroba (@) no endere\00E7o de Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853646190401257)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Falta o ponto final (.) no endere\00E7o de Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853786708401257)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'pt'
,p_message_text=>unistr('O nome de utilizador \00E9 demasiado longo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854053379401257)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'pt'
,p_message_text=>unistr('Apenas os utilizadores definidos na lista de controlo de acesso podem aceder a esta aplica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854188227401257)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor de Defini\00E7\00E3o de Controlo de Acesso Inesperado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853972159401257)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'pt'
,p_message_text=>unistr('Todos os utilizadores autenticados podem aceder a esta aplica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896763994401288)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'pt'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896696619401288)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'pt'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896995499401288)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'pt'
,p_message_text=>unistr('%0: Est\00E1 Desativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896802336401288)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'pt'
,p_message_text=>unistr('%0: Est\00E1 Ativado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896540807401288)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o identificado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889685131401283)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'pt'
,p_message_text=>'Descarregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846156441401251)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'pt'
,p_message_text=>'Filtro %0 Aplicado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887228320401281)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'pt'
,p_message_text=>'Aplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772142178401198)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'pt'
,p_message_text=>unistr('Gr\00E1fico de Barras')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899975253401290)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'pt'
,p_message_text=>'Outros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772222366401198)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'pt'
,p_message_text=>'Sectograma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898600105401289)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'pt'
,p_message_text=>'Diagrama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771978256401198)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Contagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887764801401281)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'pt'
,p_message_text=>'Limpar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887899272401281)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'pt'
,p_message_text=>'Limpar Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887913364401282)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'pt'
,p_message_text=>'Limpar %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905198580401294)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna %1, referenciada pela faceta %0, n\00E3o est\00E1 dispon\00EDvel ou n\00E3o est\00E1 autorizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762336777401191)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'pt'
,p_message_text=>'Escolher Filtros para mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844383172401250)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'pt'
,p_message_text=>'%0 resultados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844460770401250)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'pt'
,p_message_text=>'%0 selecionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847028321401252)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'pt'
,p_message_text=>'Filtros atuais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763808141401192)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'pt'
,p_message_text=>'Lista de filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903621123401293)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'pt'
,p_message_text=>'Limite de valor distinto (%0) excedido para a faceta %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889277654401282)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>unistr('A faceta %0 n\00E3o \00E9 suportada para colunas DATE ou TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887392732401281)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'pt'
,p_message_text=>'Filtrar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887438789401281)
,p_name=>'APEX.FS.GO'
,p_message_language=>'pt'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888881928401282)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'pt'
,p_message_text=>'igual a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772981058401199)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'pt'
,p_message_text=>unistr('cont\00E9m %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772637650401198)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'pt'
,p_message_text=>'maior que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772748265401199)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'pt'
,p_message_text=>'maior que ou igual a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772471734401198)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'pt'
,p_message_text=>'menor que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772505618401198)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'pt'
,p_message_text=>'menor que ou igual a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772808840401199)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'pt'
,p_message_text=>unistr('come\00E7a por %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775380315401200)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('O tipo de dados %0 (%1) n\00E3o \00E9 suportado para a faceta Campo de Entrada de Dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765587747401193)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'pt'
,p_message_text=>unistr('As facetas de V\00E1rios Valores requerem uma base de dados 12.2 ou superior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889041961401282)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram fornecidas colunas de pesquisa para a faceta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762424729401191)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'pt'
,p_message_text=>'Mais Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844508311401250)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'pt'
,p_message_text=>unistr('In\00EDcio do Intervalo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888524233401282)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'pt'
,p_message_text=>'%0 a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888644965401282)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'pt'
,p_message_text=>'Acima de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888748626401282)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'pt'
,p_message_text=>'Abaixo de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844667252401250)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'pt'
,p_message_text=>'Fim do Intervalo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907458568401296)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('O item da LDV #%2 ("%1") para a faceta de intervalo %0 \00E9 inv\00E1lido (separador "|" em falta).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888934414401282)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'pt'
,p_message_text=>unistr('A Entrada de Dados Manual para a faceta Intervalo %0 n\00E3o \00E9 suportada atualmente, uma vez que a coluna \00E9 DATE ou TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888298034401282)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'pt'
,p_message_text=>'para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772068996401198)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'pt'
,p_message_text=>'Retirar Diagrama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841105543401248)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'pt'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887630590401281)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887501948401281)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888403944401282)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'pt'
,p_message_text=>'- Selecionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771843405401198)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'pt'
,p_message_text=>unistr('Mostrar Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888072975401282)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'pt'
,p_message_text=>'Mostrar Menos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888165804401282)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'pt'
,p_message_text=>'Mostrar Mais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113888371043401282)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'pt'
,p_message_text=>'%0 estrelas e mais'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846046780401251)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('Filtrar sugest\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889170119401282)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>unistr('A faceta Campo de Texto %0 atualmente s\00F3 \00E9 suportada para colunas NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762253159401191)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00FAmero Total de Linhas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905251782401294)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('O tipo de dados %0 (%1) n\00E3o \00E9 suportado para a pesquisa facetada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897142139401288)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Ir para o erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854718836401258)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Agrega\00E7\00E3o.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862358566401263)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'pt'
,p_message_text=>unistr('Contrair controlo de interrup\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854866597401258)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Controlo de interrup\00E7\00E3o.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862245773401263)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'pt'
,p_message_text=>unistr('Expandir controlo de interrup\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940961864401320)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>'Coluna %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862091114401263)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'pt'
,p_message_text=>'%0 linhas apagadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932427686401314)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'pt'
,p_message_text=>'Identidade duplicada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851709758401255)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'pt'
,p_message_text=>'Primeiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855037295401258)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Cabe\00E7alho do grupo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854944332401258)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Cabe\00E7alho.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851896645401255)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871810195401270)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'pt'
,p_message_text=>'Carregar Mais Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851555429401255)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855175469401258)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Linhas da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851977705401256)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'pt'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852034445401256)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'pt'
,p_message_text=>'%0 - %1 de %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908065305401296)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Sele\00E7\00E3o de P\00E1ginas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851618651401255)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932221390401313)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'pt'
,p_message_text=>'Acrescentado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932321677401314)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'pt'
,p_message_text=>'Alterado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940760283401320)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>'Linha %0, Coluna %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940839309401320)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>'Linha %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932165968401313)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'pt'
,p_message_text=>'Apagado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855378642401258)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'pt'
,p_message_text=>unistr('Cabe\00E7alho da linha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850956111401255)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 c\00E9lulas selecionadas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852158059401256)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'pt'
,p_message_text=>'%0 linhas selecionadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892424729401285)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'pt'
,p_message_text=>'Selecionar Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862192432401263)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'pt'
,p_message_text=>unistr('P\00E1gina %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855226434401258)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'pt'
,p_message_text=>'Selecionar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855407391401258)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'pt'
,p_message_text=>'Ordenado por Ordem Crescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855593965401258)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'pt'
,p_message_text=>'Ordenado por Ordem Decrescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851054005401255)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'pt'
,p_message_text=>'Ordem Crescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851324486401255)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'pt'
,p_message_text=>'Ordem Crescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851107853401255)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'pt'
,p_message_text=>'Ordem Decrescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851409853401255)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'pt'
,p_message_text=>'Ordem Decrescente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113851245032401255)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Ordenar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861972019401263)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'pt'
,p_message_text=>'Total de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788335491401210)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'pt'
,p_message_text=>'Falha no pedido de HTTP para "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929612267401312)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'pt'
,p_message_text=>unistr('Linhas %1 das colunas %0 da Lista de Sele\00E7\00E3o de Grelha. Utilize as teclas de seta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861807807401263)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'pt'
,p_message_text=>'Selecione %0 linhas da Lista. Utilize as teclas de seta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940550509401319)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Grelha Interativa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848603496401253)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849611703401254)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849505509401254)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934083770401315)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'pt'
,p_message_text=>'Agregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919569181401304)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Agrega\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921270417401306)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'pt'
,p_message_text=>'Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877685874401274)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Todas as Colunas de Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878827472401275)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'pt'
,p_message_text=>'Alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879907948401276)
,p_name=>'APEX.IG.AND'
,p_message_language=>'pt'
,p_message_text=>'e'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899388555401290)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'pt'
,p_message_text=>'Contagem Distinta Aprox.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935042341401316)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'pt'
,p_message_text=>'Contagem Distinta Global Aprox.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918145421401303)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C1rea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920093377401305)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'pt'
,p_message_text=>'Crescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878930349401275)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Autoriza\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934144158401315)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'pt'
,p_message_text=>unistr('Autom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899771865401290)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E9dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934787960401315)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E9dia Global')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917631574401303)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo do Eixo da Etiqueta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917845549401303)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'pt'
,p_message_text=>'Casas Decimais'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917797386401303)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo do Eixo do Valor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923864457401307)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'pt'
,p_message_text=>'Cor de Segundo Plano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918230121401303)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'pt'
,p_message_text=>'Barra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874295356401272)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'pt'
,p_message_text=>'entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925067096401308)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'pt'
,p_message_text=>'Ambos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918387538401303)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'pt'
,p_message_text=>'Bolhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849899716401254)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'pt'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879831599401276)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'pt'
,p_message_text=>unistr('Sens\00EDvel a Mai\00FAsculas/Min\00FAsculas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935640892401316)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'pt'
,p_message_text=>unistr('(Sens\00EDvel a Mai\00FAsculas/Min\00FAsculas)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906571839401295)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'pt'
,p_message_text=>unistr('Altera\00E7\00F5es gravadas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850234010401254)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Alterar Visualiza\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880914142401277)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'pt'
,p_message_text=>'Diagrama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877459978401274)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua consulta excede o m\00E1ximo de %0 pontos de dados por diagrama. Aplique um filtro para reduzir o n\00FAmero de registos na sua consulta base.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848531577401253)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o do Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855832732401258)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'pt'
,p_message_text=>'Limpar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917112977401303)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Fecho'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924048720401308)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'pt'
,p_message_text=>'Cores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900185597401290)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00E9-visualizar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879232253401275)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Coluna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848708158401253)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925821091401309)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'pt'
,p_message_text=>'Finalidade da Coluna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879357459401275)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'pt'
,p_message_text=>'Complexo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848972957401253)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'pt'
,p_message_text=>'Calcular'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874870656401272)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'pt'
,p_message_text=>unistr('cont\00E9m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881152888401277)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'pt'
,p_message_text=>unistr('Controlo de Interrup\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855634863401258)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'pt'
,p_message_text=>unistr('Copiar para \00C1rea de Transfer\00EAncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855769980401258)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'pt'
,p_message_text=>'Copiar Abaixo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899141561401290)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'pt'
,p_message_text=>'Contagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899249719401290)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'pt'
,p_message_text=>'Contagem Distinta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934974596401315)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'pt'
,p_message_text=>'Contagem Distinta Global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934896372401315)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'pt'
,p_message_text=>'Contagem Global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932584808401314)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'pt'
,p_message_text=>'Criar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877862784401274)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'pt'
,p_message_text=>'Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925663150401309)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>'Tipo de Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925292154401308)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'pt'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906313640401295)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor da Data Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875515715401273)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'pt'
,p_message_text=>'dias'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878553487401275)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00F5es por Omiss\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878339410401275)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Tipo por Omiss\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849738045401254)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'pt'
,p_message_text=>'Apagar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926898662401310)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'pt'
,p_message_text=>unistr('Tem a certeza de que pretende apagar este relat\00F3rio?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882982121401278)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'pt'
,p_message_text=>'Apagar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881779291401277)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'pt'
,p_message_text=>'Apagar Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920124943401305)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'pt'
,p_message_text=>'Decrescente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880621760401276)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'pt'
,p_message_text=>'Detalhe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848258647401253)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o de Detalhe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908892175401297)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Dire\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880331014401276)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'pt'
,p_message_text=>'Desativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874902604401272)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o cont\00E9m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875143571401272)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o come\00E7a por')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918476735401303)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'pt'
,p_message_text=>'Anel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881376835401277)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'pt'
,p_message_text=>'Descarregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780048932401204)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'pt'
,p_message_text=>'Apenas Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927891752401310)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'pt'
,p_message_text=>'Escolher Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792633712401213)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'pt'
,p_message_text=>unistr('O Formato de Descarregamento %0 n\00E3o est\00E1 ativado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920836841401305)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Agrega\00E7\00E3o Duplicada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920937899401305)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'pt'
,p_message_text=>unistr('Controlo de Interrup\00E7\00E3o Duplicado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882827554401278)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'pt'
,p_message_text=>'Duplicar Linha'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881672831401277)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'pt'
,p_message_text=>'Duplicar Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849303645401254)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'pt'
,p_message_text=>'Editar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919901966401305)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'pt'
,p_message_text=>unistr('Editar Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931495299401313)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>'Editar Grupo por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927417421401310)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00F3pia oculta (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927605337401310)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'pt'
,p_message_text=>'Mensagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927384510401310)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00F3pia (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927088786401310)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'pt'
,p_message_text=>unistr('Mensagem de correio eletr\00F3nico enviada.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927536268401310)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'pt'
,p_message_text=>'Assunto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927207929401310)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'pt'
,p_message_text=>unistr('Destinat\00E1rio (para)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880056932401276)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'pt'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873202526401271)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'pt'
,p_message_text=>'igual a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926415476401309)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'pt'
,p_message_text=>'Exemplo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880187775401276)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('Express\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926343462401309)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'pt'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892301491401285)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'pt'
,p_message_text=>'Ficheiro preparado. A iniciar descarregamento.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113855926056401258)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'pt'
,p_message_text=>'Preencher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857063756401259)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('Sele\00E7\00E3o de preenchimento com')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856927817401259)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Sele\00E7\00E3o de Preenchimento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848854073401253)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'pt'
,p_message_text=>'Filtrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879482160401275)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'pt'
,p_message_text=>'Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934495496401315)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'pt'
,p_message_text=>'Filtrar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920361522401305)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'pt'
,p_message_text=>'Primeiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849073332401253)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'pt'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877921964401274)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'pt'
,p_message_text=>'Formatar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924918118401308)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1scara de Formato')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926792039401309)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'pt'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926601685401309)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'pt'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839411069401246)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'pt'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778746529401203)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'pt'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882506862401278)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'pt'
,p_message_text=>'Congelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880274458401276)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'pt'
,p_message_text=>unistr('Fun\00E7\00F5es e Operadores')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918543031401304)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'pt'
,p_message_text=>'Funil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899010241401290)
,p_name=>'APEX.IG.GO'
,p_message_language=>'pt'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873839837401271)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'pt'
,p_message_text=>'maior que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873983340401272)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'pt'
,p_message_text=>'maior que ou igual a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880566284401276)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'pt'
,p_message_text=>'Grelha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848086971401253)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o de Grelha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921188721401306)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'pt'
,p_message_text=>'Agrupar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880738235401276)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>'Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848350765401253)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o Agrupar Por')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925575795401309)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Tipo de Condi\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924447067401308)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924628380401308)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'pt'
,p_message_text=>unistr('Alinhamento do T\00EDtulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934367329401315)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929888978401312)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pode inserir, atualizar e apagar dados diretamente nesta grelha interativa.</p>',
'',
unistr('<p>Insira uma nova linha clicando no bot\00E3o Acrescentar Linha.</p>'),
'',
unistr('<p>Edite os dados existentes clicando duas vezes numa c\00E9lula espec\00EDfica. Para edi\00E7\00F5es maiores, clique em Editar para entrar no modo de edi\00E7\00E3o. No modo de edi\00E7\00E3o, pode clicar uma vez ou utilizar o teclado para editar c\00E9lulas espec\00EDficas.</p>'),
'',
unistr('<p>Utilize o menu Alterar para duplicar e apagar linhas. Para ativar o menu Alterar, utilize as caixas de sele\00E7\00E3o para selecionar uma ou mais linhas.</p>'),
'',
'<p>Duplique uma linha selecionada clicando no menu Alterar e selecionando Duplicar Linhas. Apague uma linha selecionada clicando no menu Alterar e selecionando Apagar Linha.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931948071401313)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'pt'
,p_message_text=>unistr('Capacidades de Edi\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932007421401313)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Uma grelha interativa apresenta um conjunto de dados num relat\00F3rio pesquis\00E1vel e customiz\00E1vel. Pode efetuar diversas opera\00E7\00F5es para limitar os registos devolvidos e alterar a forma como os dados s\00E3o apresentados.</p>'),
'',
unistr('<p>Utilize o campo Pesquisar para filtrar os registos devolvidos. Clique em A\00E7\00F5es para aceder a diversas op\00E7\00F5es para modificar a disposi\00E7\00E3o do relat\00F3rio ou utilize os menus de T\00EDtulo da Coluna nas colunas apresentadas.</p>'),
'',
unistr('<p>Utilize as Defini\00E7\00F5es do Relat\00F3rio para gravar as suas customiza\00E7\00F5es num relat\00F3rio. Tamb\00E9m pode descarregar os dados do relat\00F3rio para um ficheiro externo ou enviar os dados por correio eletr\00F3nico para si pr\00F3prio ou para outras pessoas.</p>'),
'',
unistr('<p>Para saber mais, consulte o t\00F3pico sobre como Utilizar Grelhas Interativas no <em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931723505401313)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'pt'
,p_message_text=>'Perspetiva Geral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929702140401312)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Pode customizar a grelha interativa para apresentar os dados de formas diferentes utilizando as capacidades integradas.</p>',
'',
unistr('<p>Utilize os menus de T\00EDtulo da Coluna ou o menu A\00E7\00F5es para determinar as colunas a apresentar, por que sequ\00EAncia e congelar colunas. Tamb\00E9m pode definir v\00E1rios filtros de dados e ordenar os dados devolvidos.</p>'),
'',
unistr('<p>Utilize o bot\00E3o Visualizar (adjacente ao campo Pesquisar) para aceder a outras visualiza\00E7\00F5es de dados que possam ter sido definidas pelo programador da aplica\00E7\00E3o. Tamb\00E9m pode criar um diagrama ou visualizar um diagrama existente.</p>  '),
'',
unistr('<p><em>Nota: Clique em <strong>Aux\00EDlio</strong> nas caixas de di\00E1logo da grelha interativa para obter informa\00E7\00F5es mais detalhadas sobre a fun\00E7\00E3o selecionada.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931897456401313)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'pt'
,p_message_text=>unistr('Capacidades de Gera\00E7\00E3o de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881524583401277)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio da Grelha Interativa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928645695401311)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para agregar colunas. Os valores agregados s\00E3o apresentados na parte inferior dos dados ou, se existirem Controlos de Interrup\00E7\00E3o definidos, na parte inferior de cada interrup\00E7\00E3o.</p>'),
'',
unistr('<p><strong>Lista Agrega\00E7\00E3o</strong><br>'),
unistr('A lista Agrega\00E7\00E3o apresenta as agrega\00E7\00F5es definidas. Desative uma agrega\00E7\00E3o existente anulando a respetiva sele\00E7\00E3o.<br>'),
unistr('Clique em Acrescentar (&plus;) para criar uma nova agrega\00E7\00E3o ou em Apagar (&minus;) para retirar uma agrega\00E7\00E3o existente.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de Agrega\00E7\00E3o</strong><br>'),
unistr('Utilize o formul\00E1rio \00E0 direita para definir a agrega\00E7\00E3o.<br>'),
unistr('Selecione o nome da Coluna e o tipo de Agrega\00E7\00E3o.<br>'),
unistr('Opcionalmente, introduza uma nota informativa para a agrega\00E7\00E3o.<br>'),
unistr('Se tiver definido um Controlo de Interrup\00E7\00E3o, a sele\00E7\00E3o de <strong>Mostrar Valor Global</strong> apresenta o valor m\00E9dio global, total ou semelhante na parte inferior dos dados.</p>'),
'',
unistr('<p><em>Nota: Aceda \00E0 caixa de di\00E1logo Agrega\00E7\00E3o no menu A\00E7\00F5es ou clicando no t\00EDtulo da coluna e em soma (&sum;).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930809041401312)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio da Agrega\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929392566401311)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para definir um diagrama que apresenta uma visualiza\00E7\00E3o de dados separada.<br> '),
'Selecione um Tipo de diagrama e atributos do diagrama.</p>',
'<p><strong>Atributos do Diagrama</strong></br>',
unistr('Os atributos do diagrama dispon\00EDveis variam consoante o tipo de diagrama.</p>'),
'<p>',
'<ul>',
unistr('  <li>Selecione a coluna que cont\00E9m o valor para o atributo:'),
'<ul>',
'      <li>Etiqueta - O texto para cada ponto de dados.</li>',
unistr('      <li>Valor - Os dados a tra\00E7ar.</li>'),
unistr('      <li>S\00E9rie - Para definir a sua consulta din\00E2mica de v\00E1rias s\00E9ries.</li>'),
unistr('      <li>Abertura - O pre\00E7o de abertura di\00E1rio da a\00E7\00E3o (apenas para A\00E7\00F5es).</li>'),
unistr('      <li>Fecho - O pre\00E7o de fecho di\00E1rio da a\00E7\00E3o (apenas para A\00E7\00F5es).</li>'),
unistr('      <li>M\00E1ximo - O valor m\00E1ximo (apenas para Intervalos e A\00E7\00F5es).</li>'),
unistr('      <li>M\00EDnimo - O valor m\00EDnimo (apenas para Intervalos e A\00E7\00F5es).</li>'),
unistr('      <li>Volume - O volume di\00E1rio de a\00E7\00F5es (apenas para A\00E7\00F5es).</li>'),
'      <li>Alvo - O valor-alvo (apenas para Funil).</li>',
unistr('      <li>X - O valor do eixo X (apenas para Bolhas e Dispers\00E3o).</li>'),
unistr('      <li>Y - O valor do eixo Y (apenas para Bolhas e Dispers\00E3o).</li>'),
'      <li>Z - A largura da barra ou o raio da bolha (apenas para Barras, Bolhas e Intervalos).</li>',
'    </ul>',
'  </li>',
unistr('  <li>Orienta\00E7\00E3o - Vertical ou horizontal.</li>'),
unistr('  <li>Agrega\00E7\00E3o - Selecione como agregar os valores de diagrama.</li>'),
unistr('  <li>Pilha - Especifique se os itens de dados s\00E3o empilhados.</li>'),
'  <li>Ordenar Por - Selecione pela etiqueta ou pelo(s) valor(es).',
'<ul>',
unistr('      <li>Dire\00E7\00E3o - Ordene por valores crescentes ou decrescentes.</li>'),
unistr('      <li>Nulos - Especifique como ordenar os registos com valores nulos em rela\00E7\00E3o aos registos com valores n\00E3o nulos.</li>'),
'    </ul>',
'  </li>',
'  <li>Casas Decimais</li>',
unistr(' <li>T\00EDtulo do Eixo da Etiqueta</li>'),
unistr('  <li>T\00EDtulo do Eixo do Valor</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931204258401313)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Diagrama')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928384426401311)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para escolher quais as colunas apresentadas e por que ordem.</p>'),
'',
unistr('<p>Oculte uma coluna anulando a respetiva sele\00E7\00E3o.<br>'),
'Reordene as colunas clicando em Deslocar para Cima (&uarr;) ou Deslocar para Baixo (&darr;).<br>',
unistr('Utilize o seletor pendente para listar Todas as colunas, as Colunas apresentadas ou as Colunas n\00E3o apresentadas.</p>'),
'',
unistr('<p>Opcionalmente, utilize o formul\00E1rio para especificar a largura m\00EDnima de uma coluna em p\00EDxeis.</p>'),
'',
unistr('<p><em>Nota: Tamb\00E9m pode reordenar as colunas apresentadas clicando na al\00E7a para arrastar (no in\00EDcio do t\00EDtulo da coluna) e arrastando a coluna para a esquerda ou direita. Tamb\00E9m pode alterar a largura das colunas apresentadas selecionando o separado')
||unistr('r da coluna, entre os t\00EDtulos, e deslocando-o para a esquerda ou direita.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931175468401313)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio das Colunas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928717411401311)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para definir colunas adicionais com base em c\00E1lculos matem\00E1ticos e funcionais efetuados em rela\00E7\00E3o \00E0s colunas existentes.</p>'),
'',
unistr('<p><strong>Lista C\00E1lculo</strong><br>'),
unistr('A lista C\00E1lculo apresenta os c\00E1lculos definidos. Desative um c\00E1lculo existente anulando a respetiva sele\00E7\00E3o.<br>'),
unistr('Clique em Acrescentar (&plus;) para acrescentar um novo c\00E1lculo ou em Apagar (&minus;) para retirar um c\00E1lculo existente.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de C\00E1lculo</strong><br>'),
unistr('Utilize o formul\00E1rio para definir o c\00E1lculo.<br>'),
unistr('Introduza os detalhes da coluna, como o t\00EDtulo ou etiqueta, e selecione as defini\00E7\00F5es de alinhamento.<br> '),
unistr('Utilize a \00E1rea de texto Express\00E3o para introduzir a(s) coluna(s) e as fun\00E7\00F5es associadas para o c\00E1lculo.<br>'),
unistr('Selecione o tipo de dados adequado e, opcionalmente, uma m\00E1scara de formato para a nova coluna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930756527401312)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do C\00E1lculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929086335401311)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para definir um controlo de interrup\00E7\00E3o numa ou mais colunas.</p>'),
'',
unistr('<p><strong>Lista Controlo de Interrup\00E7\00E3o</strong><br>'),
unistr('A lista Controlo de Interrup\00E7\00E3o apresenta os controlos de interrup\00E7\00E3o definidos. Desative uma coluna de controlo de interrup\00E7\00E3o existente anulando a respetiva sele\00E7\00E3o.<br>'),
unistr('Clique em Acrescentar (&plus;) para incluir uma nova coluna no controlo de interrup\00E7\00E3o ou em Apagar (&minus;) para retirar uma coluna existente do controlo de interrup\00E7\00E3o.<br>'),
unistr('Para reordenar colunas, clique em Deslocar para Cima (&uarr;) ou Deslocar para Baixo (&darr;) para deslocar a coluna selecionada para cima e para baixo relativamente \00E0s outras colunas.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de Controlo de Interrup\00E7\00E3o</strong><br>'),
unistr('Utilize o formul\00E1rio para definir a coluna de controlo de interrup\00E7\00E3o.<br>'),
unistr('Selecione uma coluna de controlo de interrup\00E7\00E3o, a dire\00E7\00E3o de ordena\00E7\00E3o e o modo de ordena\00E7\00E3o das colunas nulas (colunas sem valores).</p>'),
'',
unistr('<p><em>Nota: Ao visualizar a grelha interativa, pode definir um controlo de interrup\00E7\00E3o clicando num T\00EDtulo da Coluna e selecionando o \00EDcone de controlo de interrup\00E7\00E3o.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930401498401312)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Controlo de Interrup\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929228922401311)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para descarregar todas as linhas atuais para um ficheiro externo. O ficheiro ir\00E1 conter apenas as colunas apresentadas atualmente, utilizando os filtros e ordena\00E7\00F5es aplicados nos dados.</p>'),
'',
'<p>Selecione o formato do ficheiro e clique em Descarregar.<br>',
unistr('Nota: o CSV n\00E3o incluir\00E1 formata\00E7\00E3o de texto, como agrega\00E7\00F5es e controlos de interrup\00E7\00E3o.</p>'),
'',
unistr('<p>Para enviar o ficheiro por correio eletr\00F3nico, selecione Enviar como Mensagem de Correio Eletr\00F3nico e introduza os detalhes de correio eletr\00F3nico (Destinat\00E1rio, Assunto e Mensagem).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930228047401312)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Descarregamento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928480790401311)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para configurar filtros de dados que limitam as linhas devolvidas.</p>'),
'',
'<p><strong>Lista Filtro</strong><br>',
unistr('A lista Filtro apresenta os filtros definidos. Desative um filtro existente anulando a respetiva sele\00E7\00E3o.<br>'),
'Clique em Acrescentar (&plus;) para criar um novo filtro ou em Apagar (&minus;) para retirar um filtro existente.</p>',
'',
unistr('<p><strong>Defini\00E7\00F5es de Filtro</strong><br>'),
unistr('Utilize o formul\00E1rio para definir as propriedades do filtro.<br>'),
'Selecione o tipo de filtro adequado:<br>',
unistr('&nbsp;&nbsp;&nbsp;Linha - filtra um termo em qualquer coluna filtr\00E1vel.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Coluna - filtra uma coluna espec\00EDfica com um operador e valor especificados.</p>'),
'',
unistr('<p><em>Nota: Ao visualizar a grelha interativa, pode definir filtros de linha escrevendo diretamente no campo Pesquisar. Clique em Selecionar Colunas para Pesquisar para limitar a pesquisa a uma coluna espec\00EDfica. Em alternativa, abra um menu de T\00EDtu')
||'lo da Coluna e selecione um valor para criar um filtro de coluna.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931074638401313)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Filtro')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928848220401311)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para visualizar os dados tal como existiam num per\00EDodo anterior.</p>'),
unistr('<p>Introduza o n\00FAmero de minutos no passado para executar a consulta de flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930619048401312)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Flashback')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931349907401313)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio de Agrupar Por')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928992015401311)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para destacar linhas ou colunas de dados com base na condi\00E7\00E3o introduzida.</p>'),
'',
'<p><strong>Lista Destaque</strong><br>',
unistr('A lista Destaque apresenta os destaques definidos. Desative um destaque existente anulando a respetiva sele\00E7\00E3o.<br>'),
'Clique em Acrescentar (&plus;) para criar um novo destaque ou em Apagar (&minus;) para retirar um destaque existente.</p>',
'',
unistr('<p><strong>Defini\00E7\00F5es de Destaque</strong><br>'),
unistr('Utilize o formul\00E1rio para definir as propriedades de destaque.<br>'),
unistr('Introduza o nome, selecione Linha ou Coluna e selecione os c\00F3digos de cor de HTML para o fundo e o texto.<br>'),
unistr('Selecione o <strong>Tipo de Condi\00E7\00E3o</strong> adequado para destacar dados espec\00EDficos:<br>'),
'&nbsp;&nbsp;&nbsp;Linha - destaca o termo em qualquer coluna.<br>',
unistr('&nbsp;&nbsp;&nbsp;Coluna - destaca numa coluna espec\00EDfica com base no operador e valor especificados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930564768401312)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Destaque')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929134997401311)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para gravar as altera\00E7\00F5es que efetuou na disposi\00E7\00E3o e configura\00E7\00E3o da grelha atual.<br>'),
unistr('Os programadores de aplica\00E7\00F5es podem definir v\00E1rias disposi\00E7\00F5es de relat\00F3rio alternativas. Onde for permitido, o utilizador e outros utilizadores finais poder\00E3o gravar um relat\00F3rio como P\00FAblico, disponibilizando o relat\00F3rio para todos os outros utili')
||unistr('zadores da grelha. Tamb\00E9m pode gravar um relat\00F3rio como Privado que s\00F3 pode ser visualizado por si.</p>'),
unistr('<p>Selecione um dos tipos dispon\00EDveis e introduza um nome para o relat\00F3rio gravado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930393549401312)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aux\00EDlio do Relat\00F3rio'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928538088401311)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilize esta caixa de di\00E1logo para definir a ordem de apresenta\00E7\00E3o.</p>'),
'',
unistr('<p><strong>Lista de Ordena\00E7\00E3o</strong><br>'),
unistr('A caixa de di\00E1logo Ordenar apresenta uma lista das regras de ordena\00E7\00E3o configuradas.<br>'),
unistr('Clique em Acrescentar (&plus;) para criar uma coluna de ordena\00E7\00E3o ou em Apagar (&minus;) para retirar uma coluna de ordena\00E7\00E3o.<br>'),
unistr('Clique em Deslocar para Cima (&uarr;) e Deslocar para Baixo (&darr;) para deslocar a coluna de ordena\00E7\00E3o selecionada para cima e para baixo relativamente \00E0s outras colunas de ordena\00E7\00E3o.</p>'),
'',
unistr('<p><strong>Defini\00E7\00F5es de Ordena\00E7\00E3o</strong><br>'),
unistr('Selecione uma coluna de ordena\00E7\00E3o, a dire\00E7\00E3o de ordena\00E7\00E3o e o modo de ordena\00E7\00E3o das colunas nulas (colunas sem valores).</p>'),
'',
unistr('<p><em>Nota: Os dados podem ser ordenados por colunas que n\00E3o s\00E3o apresentadas; contudo, \00E9 poss\00EDvel que nem todas as colunas sejam orden\00E1veis.</em><br>'),
unistr('<em>As colunas apresentadas podem ser ordenadas premindo as setas para cima (crescente) ou para baixo (decrescente) no fim dos t\00EDtulos da coluna. Para acrescentar uma coluna subsequente a uma ordena\00E7\00E3o existente, mantenha a tecla Shift premida e cliq')
||'ue na seta para cima ou para baixo.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930933662401312)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio da Ordena\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113930182689401312)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio da Subscri\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882400859401278)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'pt'
,p_message_text=>'Ocultar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849232375401254)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'pt'
,p_message_text=>'Destacar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917282749401303)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918080427401303)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'pt'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875403493401273)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'pt'
,p_message_text=>'horas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880451982401276)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'pt'
,p_message_text=>unistr('\00CDcone')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848175234401253)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o de \00CDcones')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873649863401271)
,p_name=>'APEX.IG.IN'
,p_message_language=>'pt'
,p_message_text=>'em'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882008336401277)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00E3o Inativa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882191726401277)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00F5es Inativas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889717089401283)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Ocorreu um erro interno ao processar o pedido da Grelha Interativa.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785578917401208)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('O Tipo de Filtro da Coluna "%0" n\00E3o \00E9 suportado para a coluna "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929975090401312)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'pt'
,p_message_text=>unistr('Formato de Data Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904176329401293)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('A Grelha Interativa n\00E3o suporta a defini\00E7\00E3o de um filtro na coluna %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904035952401293)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o \00E9 um tipo de filtro v\00E1lido para definir um filtro da Grelha Interativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790639269401211)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'pt'
,p_message_text=>unistr('Formato de N\00FAmero Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932637819401314)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00E3o Inv\00E1lida')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932727113401314)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00F5es Inv\00E1lidas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923795803401307)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'pt'
,p_message_text=>unistr('Ordenar Por foi definido como %0, mas n\00E3o foi selecionada nenhuma coluna para %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921027526401305)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Inv\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916133505401302)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Apresentado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874499205401272)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('no(s) \00FAltimo(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874633565401272)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'pt'
,p_message_text=>'seguinte(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873582283401271)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 vazio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873446472401271)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('est\00E1 vazio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924503808401308)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'pt'
,p_message_text=>'Etiqueta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916551021401302)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Etiqueta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920452978401305)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863740839401264)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo Dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863952037401264)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltima Hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864424693401265)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo Minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863443236401264)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo M\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863586360401264)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltima Semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863620651401264)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimos %0 Dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863812350401264)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimas %0 Horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864560315401265)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimos %0 Minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864356596401265)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimos %0 Meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864205107401264)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimas %0 Semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863205889401264)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimos %0 Anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863353291401264)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo Ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924758933401308)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'pt'
,p_message_text=>unistr('Ajustamento das C\00E9lulas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924847287401308)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'pt'
,p_message_text=>'Utilizar Grupo Para'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874050570401272)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'pt'
,p_message_text=>'menor que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874104617401272)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'pt'
,p_message_text=>'menor que ou igual a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918641886401304)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'pt'
,p_message_text=>'Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918701694401304)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'pt'
,p_message_text=>unistr('Linha com \00C1rea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925108979401308)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'pt'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917384601401303)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EDnimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927743141401310)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'pt'
,p_message_text=>unistr('Separar v\00E1rios endere\00E7os com v\00EDrgulas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875258026401272)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('corresponde \00E0 express\00E3o regular')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899684094401290)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935257048401316)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1ximo Global')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899854109401290)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'pt'
,p_message_text=>'Mediano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935306222401316)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'pt'
,p_message_text=>'Mediano Global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899555914401290)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EDnimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875319093401273)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'pt'
,p_message_text=>'minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900325815401290)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('H\00E1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935126155401316)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EDnimo Global')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875728071401273)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'pt'
,p_message_text=>'meses'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882319389401278)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('Os dados cont\00EAm mais de %0 linhas, o que excede o m\00E1ximo permitido. Aplique filtros adicionais para visualizar os resultados.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909030120401297)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID Est\00E1tica da Regi\00E3o deve ser especificada dado que a p\00E1gina cont\00E9m v\00E1rias Grelhas Interativas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878454510401275)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'pt'
,p_message_text=>'Nome'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878669134401275)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio Nomeado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862628800401263)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'pt'
,p_message_text=>'Dia Seguinte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862491342401263)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3xima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864669018401265)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximo Minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862934278401264)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EAs Seguinte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862853784401263)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3xima Semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862711891401263)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximos %0 Dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113862541475401263)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximas %0 Horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864706566401265)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximos %0 Minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864095195401264)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximos %0 Meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864171588401264)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximas %0 Semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863125996401264)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximos %0 Anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113863087164401264)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'pt'
,p_message_text=>'Ano Seguinte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874345797401272)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o entre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873347605401271)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'pt'
,p_message_text=>'diferente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939502344401319)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A regi\00E3o com a ID %0 n\00E3o \00E9 uma regi\00E3o da Grelha Interativa ou n\00E3o existe na aplica\00E7\00E3o %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873788196401271)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 em')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874553550401272)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 no(s) \00FAltimo(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113874748317401272)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 no(s) pr\00F3ximo(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882258844401277)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontrados dados')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920241873401305)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'pt'
,p_message_text=>'Nulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925339774401309)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'pt'
,p_message_text=>unistr('Num\00E9rico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920597025401305)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'pt'
,p_message_text=>'Desativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920686832401305)
,p_name=>'APEX.IG.ON'
,p_message_language=>'pt'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872519660401271)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('H\00E1 1 minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928254387401311)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'pt'
,p_message_text=>'Abrir Seletor de Cores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917069440401302)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Abertura'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879543778401276)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'pt'
,p_message_text=>'Operador'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916418378401302)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Orienta\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918888648401304)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'pt'
,p_message_text=>'Sectograma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113880876070401276)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113848448802401253)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113928127424401310)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'pt'
,p_message_text=>'Separar valores com "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113918923722401304)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'pt'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924242615401308)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'pt'
,p_message_text=>'Centro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924376650401308)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'pt'
,p_message_text=>'Fim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113924133704401308)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'pt'
,p_message_text=>unistr('In\00EDcio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878782820401275)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'pt'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879045280401275)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o Principal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895577898401287)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio Principal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777740733401202)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'pt'
,p_message_text=>'Incluir Identificadores de Acessibilidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776464160401201)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'pt'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776531299401201)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'pt'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776364270401201)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'pt'
,p_message_text=>unistr('Orienta\00E7\00E3o da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776250707401201)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'pt'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776185219401201)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'pt'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777827733401202)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'pt'
,p_message_text=>'Customizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775987813401201)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'pt'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775889430401201)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'pt'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776013798401201)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'pt'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775727263401201)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'pt'
,p_message_text=>unistr('Tamanho da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765984195401194)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'pt'
,p_message_text=>'Retirar RTF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919030800401304)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'pt'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919139349401304)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'pt'
,p_message_text=>'Intervalo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929422984401311)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'pt'
,p_message_text=>'Renovar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883009238401278)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'pt'
,p_message_text=>'Renovar Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881862305401277)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'pt'
,p_message_text=>'Renovar Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887093355401281)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A regi\00E3o da Grelha Interativa n\00E3o existe na aplica\00E7\00E3o %0, p\00E1gina %1 e regi\00E3o %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849948834401254)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'pt'
,p_message_text=>'Retirar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878100433401275)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938778381401318)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio apagado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938408120401318)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio alternativo gravado para todos os utilizadores')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938304124401318)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio por omiss\00E3o gravado para todos os utilizadores')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938668191401318)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio privado gravado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938529200401318)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio p\00FAblico gravado para todos os utilizadores')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113887170225401281)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A Grelha Interativa gravada com o nome %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872494306401270)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('Comunicar dados de h\00E1 %0 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872348700401270)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('Comunicar dados de h\00E1 1 minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812020664401227)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O Relat\00F3rio da Grelha Interativa n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931609180401313)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio - Editar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886922965401281)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A Grelha Interativa gravada com a ID %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113931500116401313)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio - Gravar Como')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850081216401254)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00F5es do Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939643130401319)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A Grelha Interativa gravada com a ID est\00E1tica %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934584610401315)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o do Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849158577401253)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'pt'
,p_message_text=>'Redefinir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883157109401278)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'pt'
,p_message_text=>unistr('Reverter Altera\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881921108401277)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'pt'
,p_message_text=>'Reverter Linhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879119976401275)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'pt'
,p_message_text=>'Linha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878042003401274)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Linhas por P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939244206401319)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('A\00E7\00F5es da Linha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940494382401319)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'pt'
,p_message_text=>unistr('A\00E7\00F5es para a linha %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113849461366401254)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'pt'
,p_message_text=>'Gravar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892183326401285)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'pt'
,p_message_text=>'gravado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847655579401252)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rios Gravados')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847772657401252)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822291310401234)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'pt'
,p_message_text=>unistr('J\00E1 existe um relat\00F3rio gravado com o nome %0. Introduza um novo nome.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847851508401253)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'pt'
,p_message_text=>'Privado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847961924401253)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'pt'
,p_message_text=>unistr('P\00FAblico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934275286401315)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'pt'
,p_message_text=>'Gravar Como'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881242990401277)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('Gravar Defini\00E7\00F5es do Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919297435401304)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'pt'
,p_message_text=>unistr('Dispers\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847573373401252)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926593998401309)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar: Todas as Colunas de Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847493680401252)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925725801401309)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'pt'
,p_message_text=>'Pesquisa: Texto Integral'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872250731401270)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915822638401302)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'pt'
,p_message_text=>'- Selecionar -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856093594401258)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Sele\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908733358401297)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'pt'
,p_message_text=>unistr('Selecionar 1 linha na regi\00E3o mestre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847328896401252)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Selecionar colunas para pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938916014401318)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('A\00E7\00F5es de Sele\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856231087401259)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'pt'
,p_message_text=>unistr('Sele\00E7\00E3o de C\00E9lulas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856151428401259)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'pt'
,p_message_text=>unistr('Sele\00E7\00E3o de Linhas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927100285401310)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'pt'
,p_message_text=>unistr('Enviar como Mensagem de Correio Eletr\00F3nico')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919699345401304)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('S\00E9rie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845353942401251)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'pt'
,p_message_text=>'Mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897906581401289)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'pt'
,p_message_text=>'Mostrar Valor Global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882706285401278)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o de Linha \00DAnica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881098928401277)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'pt'
,p_message_text=>'Ordenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919734332401304)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'pt'
,p_message_text=>'Ordenar Por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939313283401319)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('S\00F3 pode definir uma ordena\00E7\00E3o por coluna.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939122880401318)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'pt'
,p_message_text=>'Alterar Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113920770333401305)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'pt'
,p_message_text=>'Pilha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875068261401272)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'pt'
,p_message_text=>unistr('come\00E7a por')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919305532401304)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'pt'
,p_message_text=>unistr('A\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840335008401247)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Alongar Larguras das Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113881455339401277)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Subscri\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113899401093401290)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'pt'
,p_message_text=>'Soma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940622167401320)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'pt'
,p_message_text=>unistr('Grelha Interativa. Relat\00F3rio: %0, Visualiza\00E7\00E3o: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113934656515401315)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'pt'
,p_message_text=>'Soma Global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917595144401303)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Alvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923937600401308)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'pt'
,p_message_text=>'Cor do Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850116117401254)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'pt'
,p_message_text=>'Alternar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897892010401289)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'pt'
,p_message_text=>'Nota Informativa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113878225671401275)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'pt'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113882621032401278)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'pt'
,p_message_text=>'Descongelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879765403401276)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'pt'
,p_message_text=>'Unidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926938446401310)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'pt'
,p_message_text=>unistr('Existem altera\00E7\00F5es n\00E3o gravadas. Continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113879656279401276)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'pt'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916627001401302)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921509596401306)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio um valor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906412343401295)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor (o fuso hor\00E1rio n\00E3o pode ser alterado)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925406187401309)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'pt'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917973047401303)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'pt'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877771323401274)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'pt'
,p_message_text=>'Visualizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915982028401302)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'pt'
,p_message_text=>'Apresentado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113917492316401303)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875615218401273)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'pt'
,p_message_text=>'semanas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916091973401302)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'pt'
,p_message_text=>unistr('Largura M\00EDnima da Coluna (P\00EDxel)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866874376401266)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'pt'
,p_message_text=>'%0 entre %1 e %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866549957401266)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 cont\00E9m %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866623261401266)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o cont\00E9m %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844758759401250)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o come\00E7a por %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865339199401265)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 \00E9 igual a %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865592320401265)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'pt'
,p_message_text=>'%0 maior que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865634837401266)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'pt'
,p_message_text=>'%0 maior que ou igual a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866336544401266)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'pt'
,p_message_text=>'%0 em %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867544392401267)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos \00FAltimos %1 dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867308109401267)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nas \00FAltimas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867130404401267)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos \00FAltimos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867920665401267)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos \00FAltimos %1 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867756488401267)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nas \00FAltimas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868169831401267)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos \00FAltimos %1 anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867472180401267)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no \00FAltimo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867251073401267)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 na \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867012811401267)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no \00FAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867806754401267)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no \00FAltimo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113867629732401267)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 na \00FAltima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868036985401267)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no \00FAltimo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869975493401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos pr\00F3ximos %1 dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869734957401268)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nas pr\00F3ximas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869568255401268)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos pr\00F3ximos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870300267401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos pr\00F3ximos %1 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870183911401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nas pr\00F3ximas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870580918401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 nos pr\00F3ximos %1 anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869859721401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no pr\00F3ximo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869692907401268)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 na pr\00F3xima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869432872401268)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870206707401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no pr\00F3ximo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870031777401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 na pr\00F3xima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870452350401269)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 no pr\00F3ximo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866049205401266)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 vazio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865938331401266)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 est\00E1 vazio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865777054401266)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'pt'
,p_message_text=>'%0 menor que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865810414401266)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'pt'
,p_message_text=>'%0 menor que ou igual a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866181450401266)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'pt'
,p_message_text=>'%0 semelhante a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866770817401266)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 corresponde \00E0 express\00E3o regular %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872646213401271)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866937373401266)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o entre %1 e %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865418264401265)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 \00E9 diferente de %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866452702401266)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 em %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868721038401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos \00FAltimos %1 dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868511202401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas \00FAltimas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868380476401267)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos \00FAltimos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869137465401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos \00FAltimos %1 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868980060401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas \00FAltimas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869312887401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos \00FAltimos %1 anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868675487401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868421106401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868240631401267)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869022935401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113868885461401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na \00FAltima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113869221722401268)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871121406401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos pr\00F3ximos %1 dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870968849401269)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas pr\00F3ximas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870751152401269)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos pr\00F3ximos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871522067401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos pr\00F3ximos %1 meses ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871348712401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nas pr\00F3ximas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871752551401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 nos pr\00F3ximos %1 anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871054071401269)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo dia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870821298401269)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na pr\00F3xima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113870645416401269)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871499178401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo m\00EAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871258628401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 na pr\00F3xima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871630230401270)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113866227291401266)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o \00E9 semelhante a %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873169498401271)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 come\00E7a por %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916720222401302)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875850891401273)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'pt'
,p_message_text=>'anos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916893773401302)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916921258401302)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113925932137401309)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'pt'
,p_message_text=>'Segunda-feira, 12 de janeiro de 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926091079401309)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'pt'
,p_message_text=>'Janeiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926112160401309)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'pt'
,p_message_text=>unistr('16 horas atr\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113926282006401309)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'pt'
,p_message_text=>'em 16 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781214489401205)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'pt'
,p_message_text=>unistr('Tipo de ficheiro inv\00E1lido. Tipos de ficheiros suportados %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908101652401296)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'pt'
,p_message_text=>'Percorrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907818135401296)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'pt'
,p_message_text=>'Escolher Ficheiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907991464401296)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'pt'
,p_message_text=>'Escolher Ficheiros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781006788401204)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'pt'
,p_message_text=>'Arrastar e Largar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781495505401205)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'pt'
,p_message_text=>'Arrastar e Largar Ficheiros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782650275401206)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'pt'
,p_message_text=>'Selecionar um ficheiro ou largar um aqui.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782766572401206)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'pt'
,p_message_text=>'Selecionar ou largar ficheiros aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782813792401206)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'pt'
,p_message_text=>'Selecionar um ficheiro ou largar um aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782998501401206)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'pt'
,p_message_text=>'Selecionar ou largar ficheiros aqui.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781301824401205)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'pt'
,p_message_text=>'%0 ficheiros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781189753401205)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'pt'
,p_message_text=>unistr('O ficheiro \00E9 demasiado grande. O tamanho m\00E1ximo do ficheiro \00E9 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768961405401196)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('O endere\00E7o \00E9 obrigat\00F3rio.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767848217401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'pt'
,p_message_text=>'Localidade'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768219796401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00F3digo do Pa\00EDs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767914856401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00FAmero da Porta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768833649401196)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'pt'
,p_message_text=>'Latitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768729637401196)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'pt'
,p_message_text=>'Longitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768649322401196)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'pt'
,p_message_text=>'Mostrar no Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768348719401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'pt'
,p_message_text=>unistr('Pontua\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768097608401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00F3digo Postal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768143185401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'pt'
,p_message_text=>'Distrito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767784520401195)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'pt'
,p_message_text=>'Rua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767605837401195)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Resultados da Codifica\00E7\00E3o Geogr\00E1fica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780206261401204)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'pt'
,p_message_text=>'Codificado geograficamente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780319420401204)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Codificado Geograficamente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768561301401195)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'pt'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113768406976401195)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontradas moradas.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769013182401196)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 \00E9 obrigat\00F3rio(a).')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938868475401318)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Texto do Aux\00EDlio: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832217430401241)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'pt'
,p_message_text=>'Selecionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832354244401241)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Selecionado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778212517401202)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# n\00E3o est\00E1 no intervalo v\00E1lido de %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778375478401203)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# n\00E3o \00E9 um m\00FAltiplo de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777963068401202)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'pt'
,p_message_text=>'#LABEL# deve corresponder aos valores %0 e %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778161296401202)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856455934401259)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856514064401259)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778084861401202)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761414929401190)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890616841401283)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890789263401284)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'pt'
,p_message_text=>'Retirar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761567681401190)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'pt'
,p_message_text=>'Entradas selecionadas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894441404401286)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'pt'
,p_message_text=>unistr('Avan\00E7adas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894780162401286)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'pt'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894550270401286)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'pt'
,p_message_text=>'Comum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894819311401286)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('Op\00E7\00F5es de Modelo Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895430141401287)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'pt'
,p_message_text=>unistr('As Op\00E7\00F5es de Modelo n\00E3o est\00E3o dispon\00EDveis porque este componente n\00E3o \00E9 apresentado na p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894344120401286)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontradas Op\00E7\00F5es de Modelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894686500401286)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'pt'
,p_message_text=>'Gravar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769935161401197)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Limpar C\00EDrculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771780097401198)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'pt'
,p_message_text=>unistr('Os Estilos Customizados n\00E3o s\00E3o JSON v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770295372401197)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'pt'
,p_message_text=>unistr('Ferramenta de Dist\00E2ncia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770074945401197)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Desenhar C\00EDrculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762643103401191)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'pt'
,p_message_text=>unistr('A Pesquisa Facetada requer uma Origem de Dados ao n\00EDvel da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765252666401193)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Localiza\00E7\00E3o Atual')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766383798401194)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('As coordenadas da posi\00E7\00E3o inicial s\00E3o inv\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763720009401192)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('A posi\00E7\00E3o inicial deve ser uma geometria de pontos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766131084401194)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'pt'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764724258401193)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'pt'
,p_message_text=>'Camada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898025562401289)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'pt'
,p_message_text=>'Camada: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769310441401196)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'pt'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762593899401191)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'pt'
,p_message_text=>'Mensagens'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766260148401194)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'pt'
,p_message_text=>'milhas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897077020401288)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('Os dados cont\00EAm mais de %0 linhas, o que excede o m\00E1ximo permitido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764500038401193)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'pt'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Termos</a> &nbsp;&nbsp; Dados do mapa &copy; 2017 AQUI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763411520401192)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'pt'
,p_message_text=>unistr('O tipo de dados SDO_GEOMETRY n\00E3o est\00E1 dispon\00EDvel nesta base de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764652774401193)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'pt'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Contribuidores de OpenStreetMap </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764844052401193)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'pt'
,p_message_text=>'Pontos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898160407401289)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'pt'
,p_message_text=>'%0 Pontos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770189060401197)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'pt'
,p_message_text=>unistr('Zoom de Ret\00E2ngulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769865684401196)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'pt'
,p_message_text=>'Retirar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765129056401193)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'pt'
,p_message_text=>unistr('Redefinir Orienta\00E7\00E3o para Norte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845413466401251)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'pt'
,p_message_text=>'Alternar para modo 2D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845585100401251)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'pt'
,p_message_text=>'Alternar para modo 3D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769768622401196)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'pt'
,p_message_text=>'Alternar Aviso de Direitos de Autor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770312115401197)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'pt'
,p_message_text=>unistr('Dist\00E2ncia Total')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764960922401193)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'pt'
,p_message_text=>'Aproximar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765048935401193)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'pt'
,p_message_text=>'Afastar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892506381401285)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'pt'
,p_message_text=>'Negrito'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893495715401285)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'pt'
,p_message_text=>'Imagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893066888401285)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00F3digo Inline')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906628924401295)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'pt'
,p_message_text=>'Inserir Imagem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906754684401295)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'pt'
,p_message_text=>unistr('Inserir Liga\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892692524401285)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'pt'
,p_message_text=>unistr('It\00E1lico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907331823401296)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'pt'
,p_message_text=>'Ligar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893350095401285)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'pt'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893289210401285)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'pt'
,p_message_text=>'Lista Ordenada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892724583401285)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00E9-visualizar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892887079401285)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'pt'
,p_message_text=>unistr('Nada para Pr\00E9-Visualizar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892966438401285)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'pt'
,p_message_text=>'Riscado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893125080401285)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'pt'
,p_message_text=>unistr('Lista N\00E3o Ordenada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872024794401270)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'pt'
,p_message_text=>'atual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113929550716401312)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Mais...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113871929963401270)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'pt'
,p_message_text=>'A carregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903772436401293)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'pt'
,p_message_text=>unistr('Mensagem de Notifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877053983401274)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero menor que ou igual a %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877126423401274)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero v\00E1lido.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877290244401274)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# n\00E3o corresponde ao formato de n\00FAmero %0 (Exemplo: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876907368401274)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero maior que ou igual a %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876879621401274)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'pt'
,p_message_text=>unistr('#LABEL# deve ser um n\00FAmero entre %0 E %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872165723401270)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'pt'
,p_message_text=>unistr('\00E9 aberto numa nova janela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825327084401236)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta p\00E1gina j\00E1 foi submetida e n\00E3o pode ser submetida novamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807944407401224)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('Aplica\00E7\00E3o "%0", P\00E1gina "%1", n\00E3o encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841747789401248)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>'#LABEL# deve ter um valor.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785090870401207)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891016663401284)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'pt'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890932737401284)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'pt'
,p_message_text=>'Encontrar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891247109401284)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891144587401284)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777140293401202)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'pt'
,p_message_text=>'Introduza um termo de pesquisa com, pelo menos, %0 caracteres.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846663479401252)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'pt'
,p_message_text=>'Lista de Valores Sobreposta: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777227027401202)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'pt'
,p_message_text=>'Introduza um termo de pesquisa.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777001683401202)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontrados resultados.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776914602401202)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'pt'
,p_message_text=>'Retirar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864875571401265)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Termo de Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890807865401284)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901572696401291)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'pt'
,p_message_text=>'A processar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775511922401201)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Acresc. ao Ecr\00E3 Pg. Princ.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771547884401198)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Aparentemente, o seu dispositivo ou browser n\00E3o suporta a instala\00E7\00E3o de Aplica\00E7\00F5es Web Progressivas de momento.</p>'),
unistr('    <p class="a-pwaDialog-intro">Se esta aplica\00E7\00E3o j\00E1 estiver instalada no seu dispositivo, abra a partir do ecr\00E3 da p\00E1gina principal.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771144861401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o. Acrescente-o ao seu ecr\00E3 da p\00E1gina principal para o utilizar em ecr\00E3 completo.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Menu</strong> na navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque em <strong>Instalar</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong>Acrescentar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771204376401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o e proporciona a melhor experi\00EAncia poss\00EDvel quando utilizado no Chrome ou Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Menu</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque em <strong>Instalar</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770806828401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o e proporciona a melhor experi\00EAncia poss\00EDvel quando utilizado no Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Partilhar</strong> na navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque em <strong>Abrir no Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770516141401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o. Acrescente-o ao seu ecr\00E3 da p\00E1gina principal para beneficiar da melhor experi\00EAncia poss\00EDvel.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Partilhar</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Toque em <strong>Acrescentar ao Ecr\00E3 da P\00E1gina Principal</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong style="color:#007AE1;">Acrescentar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770464275401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o. Acrescente-o ao seu ecr\00E3 da p\00E1gina principal para beneficiar da melhor experi\00EAncia poss\00EDvel.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Partilhar</strong> na navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Desloque-se para baixo e toque em <strong>Acrescentar ao Ecr\00E3 da P\00E1gina Principal</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong style="color:#007AE1;">Acrescentar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765498993401193)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o. Acrescente-o ao seu ecr\00E3 da p\00E1gina principal para beneficiar da melhor experi\00EAncia poss\00EDvel.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque no \00EDcone <strong>Mais</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Toque em <strong>Acrescentar ao Ecr\00E3 da P\00E1gina Principal</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque em <strong style="color:#007AE1;">Acrescentar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770752697401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o. Acrescente-o ao seu ecr\00E3 da p\00E1gina principal para beneficiar da melhor experi\00EAncia poss\00EDvel.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Toque no \00EDcone <strong>Partilhar</strong> junto \00E0 barra de endere\00E7o</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toque em <strong>Abrir no Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770683139401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o. Acrescente-o ao seu ecr\00E3 da p\00E1gina principal para beneficiar da melhor experi\00EAncia poss\00EDvel.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Toque no \00EDcone <strong>Partilhar</strong> na navega\00E7\00E3o inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toque em <strong>Abrir no Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771447221401198)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o e proporciona a melhor experi\00EAncia poss\00EDvel quando utilizado no Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">De momento, o Firefox n\00E3o suporta a instala\00E7\00E3o de aplica\00E7\00F5es web.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113770951276401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o e proporciona a melhor experi\00EAncia poss\00EDvel quando utilizado no Chrome ou Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">De momento, o Firefox n\00E3o suporta a instala\00E7\00E3o de aplica\00E7\00F5es web no macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771099698401197)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o e proporciona a melhor experi\00EAncia poss\00EDvel quando utilizado no Chrome ou Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">De momento, o Safari n\00E3o suporta a instala\00E7\00E3o de aplica\00E7\00F5es web no macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771387824401198)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este website tem funcionalidade de aplica\00E7\00E3o e proporciona a melhor experi\00EAncia poss\00EDvel quando utilizado no Chrome ou Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">De momento, o Firefox n\00E3o suporta a instala\00E7\00E3o de aplica\00E7\00F5es web no Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773880384401199)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>N\00E3o \00E9 poss\00EDvel ligar</h1>'),
unistr('    <p>Necessita de uma liga\00E7\00E3o \00E0 Internet para utilizar esta aplica\00E7\00E3o.</p>'),
'    <button type="button">Repetir</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773721250401199)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel ligar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913536744401300)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857944639401260)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'pt'
,p_message_text=>'Todo o Dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936802496401317)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'pt'
,p_message_text=>'Enviar Convite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936630873401317)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Op\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859762088401261)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o di\00E1ria para todo o dia ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859589993401261)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o di\00E1ria para dados com hora ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904455042401293)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'pt'
,p_message_text=>'Dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898828552401289)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789475360401211)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'pt'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789276536401210)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'pt'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789173953401210)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'pt'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789344782401210)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'pt'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788803017401210)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'pt'
,p_message_text=>'Data de Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789009309401210)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'pt'
,p_message_text=>'Nome do Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936798785401317)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'pt'
,p_message_text=>'Convite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904580892401293)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'pt'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904209471401293)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907058922401295)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921373268401306)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'pt'
,p_message_text=>'Sem Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937029710401317)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'pt'
,p_message_text=>'Edite um Evento Existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936940075401317)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'pt'
,p_message_text=>unistr('Envie um Convite por Correio Eletr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907198723401295)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915140214401301)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'pt'
,p_message_text=>unistr('Enviar Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914997866401301)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'pt'
,p_message_text=>unistr('Enviar Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937799825401317)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('Todos os campos s\00E3o obrigat\00F3rios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937677433401317)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'pt'
,p_message_text=>'Enviar Convite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936575533401317)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'pt'
,p_message_text=>'Assunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915064813401301)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'pt'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788995125401210)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'pt'
,p_message_text=>unistr('Data de In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912807500401299)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'pt'
,p_message_text=>unistr('Formul\00E1rio em %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859314581401261)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'pt'
,p_message_text=>'Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907288841401295)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'pt'
,p_message_text=>'Hoje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905019845401294)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'pt'
,p_message_text=>'Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904300346401293)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'pt'
,p_message_text=>'Semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859613403401261)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o semanal para todo o dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859403947401261)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o semanal para dados com hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904939313401294)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'pt'
,p_message_text=>'Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904648155401294)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904751845401294)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'pt'
,p_message_text=>'Carregar mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836857927401245)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783106120401206)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'pt'
,p_message_text=>'Carregar mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785277265401207)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113904871133401294)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'pt'
,p_message_text=>'Carregar mais...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906978155401295)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('ID da Regi\00E3o %0 n\00E3o encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785143838401207)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Foram Encontrados Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809258205401225)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel redefinir a pagina\00E7\00E3o da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777415057401202)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao definir a pagina\00E7\00E3o da regi\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898201601401289)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906864241401295)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'pt'
,p_message_text=>unistr('O Tipo de Regi\00E3o %0 n\00E3o \00E9 suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777333951401202)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro durante a apresenta\00E7\00E3o da regi\00E3o "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841871811401248)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>'#COLUMN_HEADER# deve ter um valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936137898401316)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'pt'
,p_message_text=>'%0, editor de RTF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843904999401250)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'pt'
,p_message_text=>unistr('A markup de HTML RTF excede o comprimento m\00E1ximo do item (real %0, %1 caracteres permitidos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903853769401293)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'pt'
,p_message_text=>'Apagar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895676635401287)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'pt'
,p_message_text=>'Duplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893912730401286)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'pt'
,p_message_text=>'Colunas Apresentadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893851936401286)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'pt'
,p_message_text=>'Excluir Valores Nulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903918861401293)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857599719401260)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'pt'
,p_message_text=>'Deslocar para Baixo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857632072401260)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'pt'
,p_message_text=>'Deslocar para Cima'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893691534401286)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894263919401286)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Outras Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893793011401286)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894073137401286)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'pt'
,p_message_text=>'Linha %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894100993401286)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'pt'
,p_message_text=>'Linha %0 de %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895773541401287)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'pt'
,p_message_text=>'Renovar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895801285401287)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'pt'
,p_message_text=>unistr('Reverter Altera\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113893538846401285)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'pt'
,p_message_text=>unistr('Menu Defini\00E7\00F5es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854524139401257)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'pt'
,p_message_text=>'Por exemplo, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762008527401191)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Entrar Novamente em Sess\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761960701401191)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua sess\00E3o terminou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762103786401191)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'pt'
,p_message_text=>'Prolongar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761784321401190)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua sess\00E3o vai terminar \00E0s %0. Pretende prolong\00E1-la?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761896471401191)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua sess\00E3o vai terminar \00E0s %0 e n\00E3o pode ser prolongada. Grave o trabalho agora para evitar perder dados')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914775221401301)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar o c\00F3digo de limpeza da sess\00E3o da base de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807822696401224)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao processar o c\00F3digo de configura\00E7\00E3o da sess\00E3o da base de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113781904448401205)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua sess\00E3o terminou')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913619592401300)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'pt'
,p_message_text=>unistr('Feche esta caixa de di\00E1logo e prima o bot\00E3o de recarregamento do seu browser para obter uma nova sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932919766401314)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('Clique <a href="%0">aqui</a> para criar uma nova sess\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819515012401232)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'pt'
,p_message_text=>unistr('Sess\00E3o N\00E3o V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859082146401261)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi poss\00EDvel ativar nenhum Perfil de Grupo Din\00E2mico na sess\00E3o de Real Application Security para o utilizador "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805738131401222)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-99900 N\00E3o foi poss\00EDvel criar a ID da sess\00E3o exclusiva: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822081040401234)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Viola\00E7\00E3o de prote\00E7\00E3o do estado da sess\00E3o: Isto pode ser causado pela altera\00E7\00E3o manual do item de p\00E1gina protegido %0. Se n\00E3o tiver a certeza sobre a causa deste erro, contacte o administrador da aplica\00E7\00E3o para obter assist\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941199066401320)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Viola\00E7\00E3o de prote\00E7\00E3o da p\00E1gina: Isto pode ser causado pela submiss\00E3o de uma p\00E1gina cujo carregamento ainda n\00E3o terminou ou pela altera\00E7\00E3o manual de itens da p\00E1gina protegidos. Para obter mais assist\00EAncia, contacte o administrador da aplica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940122742401319)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 cont\00E9m um dos seguintes caracteres inv\00E1lidos &<>"/;,*|=% ou --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940296459401319)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 cont\00E9m um dos seguintes caracteres inv\00E1lidos &<>"/;,*|=% ou -- ou nova linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939950786401319)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 cont\00E9m caracteres especiais. S\00F3 s\00E3o permitidos os caracteres a-Z, 0-9 e espa\00E7os.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113940037982401319)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 cont\00E9m <, > ou " que s\00E3o caracteres inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784121693401207)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi fornecida uma soma de verifica\00E7\00E3o para mostrar o processamento de uma p\00E1gina que requer uma soma de verifica\00E7\00E3o quando um ou mais valores de pedido, limpeza da cache ou argumento s\00E3o transmitidos como par\00E2metros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816970556401230)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Viola\00E7\00E3o de prote\00E7\00E3o do estado da sess\00E3o: Isto pode ser causado pela altera\00E7\00E3o manual de um URL que cont\00E9m uma soma de verifica\00E7\00E3o ou pela utiliza\00E7\00E3o de uma liga\00E7\00E3o com uma soma de verifica\00E7\00E3o incorreta ou em falta. Se n\00E3o tiver a certeza sobre a cau')
||unistr('sa deste erro, contacte o administrador da aplica\00E7\00E3o para obter assist\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113894969548401287)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'pt'
,p_message_text=>'Desativar Modo de Contraste Alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895023559401287)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'pt'
,p_message_text=>'Ativar Modo de Contraste Alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813675842401228)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'pt'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813824738401228)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'pt'
,p_message_text=>'Para Baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813902296401228)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'pt'
,p_message_text=>'Deslocar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814013810401228)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'pt'
,p_message_text=>'Deslocar Todos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814168995401228)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'pt'
,p_message_text=>'Retirar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814255991401228)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'pt'
,p_message_text=>'Retirar Todos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814399601401228)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'pt'
,p_message_text=>'Redefinir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813536898401228)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'pt'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813771772401228)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'pt'
,p_message_text=>'Para Cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922684561401307)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923318763401307)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922507532401307)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923439126401307)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922387922401306)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923557795401307)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922997139401307)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923189133401307)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922475069401306)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923230519401307)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922712603401307)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923679232401307)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922855910401307)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'pt'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113923038851401307)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'em %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762930651401191)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'pt'
,p_message_text=>'[Linha]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763339959401192)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'pt'
,p_message_text=>unistr('[V\00E1rias Linhas]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763151767401192)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'pt'
,p_message_text=>unistr('[V\00E1rios Pontos]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763560631401192)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'pt'
,p_message_text=>unistr('[V\00E1rios Pol\00EDgonos]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763694261401192)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'pt'
,p_message_text=>'[Objeto de Geometria]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762812148401191)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'pt'
,p_message_text=>'[Ponto (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763087564401191)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'pt'
,p_message_text=>unistr('[Pol\00EDgono]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840262671401247)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'pt'
,p_message_text=>'Contrair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840180332401247)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'pt'
,p_message_text=>'Repor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886622080401281)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'pt'
,p_message_text=>unistr('Limpar Classifica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876562824401273)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no intervalo de classifica\00E7\00E3o v\00E1lido de 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876671205401273)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o \00E9 num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872724244401271)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'pt'
,p_message_text=>unistr('Mensagem de \00CAxito')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935830030401316)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935771933401316)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921470715401306)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'pt'
,p_message_text=>'Barra de Ferramentas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936221521401316)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('Expandir/Contrair Navega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936321356401316)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Expandir/Contrair Coluna Lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845999623401251)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('Navega\00E7\00E3o Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852901936401256)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'pt'
,p_message_text=>'1 dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852723643401256)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'pt'
,p_message_text=>'1 hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853028593401256)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'pt'
,p_message_text=>'%0 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852880849401256)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'pt'
,p_message_text=>'%0 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852668970401256)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'pt'
,p_message_text=>'%0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853274012401256)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'pt'
,p_message_text=>'%0 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113853178314401256)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'pt'
,p_message_text=>'1 semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939401120401319)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'pt'
,p_message_text=>unistr('In\00EDcio da p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801456219401219)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'pt'
,p_message_text=>'Ativado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775278633401200)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Erro ao processar o pedido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854688075401257)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937519280401317)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'pt'
,p_message_text=>unistr('Aguarde at\00E9 a p\00E1gina ficar totalmente carregada e tente novamente.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897752550401289)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta p\00E1gina tem altera\00E7\00F5es n\00E3o gravadas.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778612257401203)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'pt'
,p_message_text=>unistr('O livro n\00E3o tem nenhuma folha de c\00E1lculo ativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778540198401203)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'pt'
,p_message_text=>unistr('O livro n\00E3o foi inicializado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778403108401203)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Ocorreu um erro interno ao criar o ficheiro XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780971858401204)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'pt'
,p_message_text=>'Folha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912623723401299)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830160600401240)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'pt'
,p_message_text=>unistr('Menu A\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825840718401237)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Acrescentar Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825780438401237)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar Agrupar por Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859907822401261)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('Acrescentar Coluna Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860057456401261)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Acrescentar Coluna da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800289380401218)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'pt'
,p_message_text=>'Agregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836332988401244)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Agrega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817426972401231)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E9dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821750229401234)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'pt'
,p_message_text=>'Contagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817542678401231)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817748519401231)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'pt'
,p_message_text=>'Mediano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817681677401231)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817389683401230)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'pt'
,p_message_text=>'Soma %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818482847401231)
,p_name=>'APEXIR_ALL'
,p_message_language=>'pt'
,p_message_text=>'Tudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799509068401218)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Todas as Colunas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782025829401205)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'pt'
,p_message_text=>'Todas as Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909668419401297)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'pt'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911208687401298)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o Alternativo: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812125917401227)
,p_name=>'APEXIR_AND'
,p_message_language=>'pt'
,p_message_text=>'e'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801663925401219)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'pt'
,p_message_text=>'Aplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795323357401215)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'pt'
,p_message_text=>'Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814975795401229)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'pt'
,p_message_text=>'A partir de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911820866401299)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E9dia %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903227851401293)
,p_name=>'APEXIR_BAR'
,p_message_language=>'pt'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801013074401219)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'pt'
,p_message_text=>'entre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794191261401214)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'pt'
,p_message_text=>'Cor de Segundo Plano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796015960401215)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'pt'
,p_message_text=>'azul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827748353401238)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'pt'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796678367401216)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'pt'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802599792401220)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'pt'
,p_message_text=>'Categoria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794052309401214)
,p_name=>'APEXIR_CELL'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00E9lula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818390941401231)
,p_name=>'APEXIR_CHART'
,p_message_language=>'pt'
,p_message_text=>'Diagrama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828682307401239)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'pt'
,p_message_text=>'A Inicializar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113864934303401265)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a etiqueta do diagrama.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877376521401274)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'pt'
,p_message_text=>unistr('A sua consulta excede o m\00E1ximo de %0 pontos de dados por diagrama. Aplique um filtro para reduzir o n\00FAmero de registos na sua consulta base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876270366401273)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O n\00FAmero m\00E1ximo de linhas para uma consulta de Diagrama limita o n\00FAmero de linhas na consulta base e n\00E3o o n\00FAmero de linhas apresentadas.  '),
unistr('A sua consulta base excede o n\00FAmero m\00E1ximo de linhas de %0. Aplique um filtro para reduzir o n\00FAmero de registos na sua consulta base.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799635753401218)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'pt'
,p_message_text=>'Tipo de Diagrama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113872954653401271)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'pt'
,p_message_text=>'Selecionar Tudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815360609401229)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'pt'
,p_message_text=>unistr('Escolher formato do relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822768225401234)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'pt'
,p_message_text=>'limpar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796547536401216)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833973691401243)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906292710401295)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'pt'
,p_message_text=>'Filtrar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824747828401236)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'pt'
,p_message_text=>unistr('Menu T\00EDtulo da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828442343401239)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'pt'
,p_message_text=>unistr('Informa\00E7\00F5es da Coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908521001401296)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Etiqueta da Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826146808401237)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'pt'
,p_message_text=>'Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810298752401225)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'pt'
,p_message_text=>unistr('cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811113135401226)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795061419401214)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'pt'
,p_message_text=>'em'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811310762401226)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 no \00FAltimo intervalo de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819864353401232)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 no pr\00F3ximo intervalo de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811231765401226)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('est\00E1 no \00FAltimo intervalo de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819732378401232)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('est\00E1 no pr\00F3ximo intervalo de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794932740401214)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o \00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794808660401214)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('\00E9 nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794619791401214)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'pt'
,p_message_text=>'semelhante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795106939401215)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o est\00E1 em')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794774809401214)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o semelhante')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810523333401226)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'pt'
,p_message_text=>unistr('corresponde \00E0 express\00E3o regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815215770401229)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'pt'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113875971225401273)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('Express\00E3o de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834246263401243)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'pt'
,p_message_text=>unistr('Crie um c\00E1lculo com pseud\00F3nimos de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834379588401243)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'pt'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834486062401243)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'pt'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834575276401243)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'pt'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780464255401204)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'pt'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819185381401232)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'pt'
,p_message_text=>'Calcular'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826765243401237)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'pt'
,p_message_text=>unistr('Controlo de Interrup\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829771988401239)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'pt'
,p_message_text=>unistr('Controlos de Interrup\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914128738401300)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>unistr('Colunas de Controlo de Interrup\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777549452401202)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'pt'
,p_message_text=>'Contagem Distinta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912346544401299)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'pt'
,p_message_text=>'Contagem Distinta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912287851401299)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'pt'
,p_message_text=>'Contagem %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884357434401279)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'pt'
,p_message_text=>unistr('Di\00E1rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939015485401318)
,p_name=>'APEXIR_DATA'
,p_message_language=>'pt'
,p_message_text=>'Dados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828535605401239)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'pt'
,p_message_text=>unistr('Comunicar dados de h\00E1 %0 minutos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902078116401292)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio da Grelha de Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800347259401218)
,p_name=>'APEXIR_DATE'
,p_message_language=>'pt'
,p_message_text=>'Data'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832421880401241)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909479613401297)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Tipo de Relat\00F3rio Por Omiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796750715401216)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'pt'
,p_message_text=>'Apagar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800664410401218)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'pt'
,p_message_text=>unistr('Pretende apagar as defini\00E7\00F5es deste relat\00F3rio?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895346134401287)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Apagar Relat\00F3rios Por Omiss\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826467377401237)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Apagar Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795421635401215)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'pt'
,p_message_text=>'Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802641773401220)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824682541401236)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o de Linha \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832911051401242)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Dire\00E7\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833860778401242)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'pt'
,p_message_text=>'Desativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796251279401215)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'pt'
,p_message_text=>'Apresentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799439410401218)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas Apresentadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832856286401242)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Apresentar no Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827622653401238)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'pt'
,p_message_text=>'Para Baixo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819249233401232)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'pt'
,p_message_text=>'Descarregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832743967401242)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Apresentar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898787277401289)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'pt'
,p_message_text=>unistr('J\00E1 existe um destaque com a mesma condi\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914367833401300)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('Coluna din\00E2mica duplicada. A lista de colunas din\00E2micas deve ser exclusiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914576009401301)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'pt'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828735686401239)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'pt'
,p_message_text=>unistr('Editar Defini\00E7\00F5es do Diagrama')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835331467401244)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'pt'
,p_message_text=>unistr('Editar Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835751638401244)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'pt'
,p_message_text=>'Editar Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890129901401283)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>'Editar Grupo por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835673811401244)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'pt'
,p_message_text=>'Editar Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860239334401262)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Editar Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909764987401297)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'pt'
,p_message_text=>unistr('Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788461040401210)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'pt'
,p_message_text=>unistr('Endere\00E7o de Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910051990401297)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'pt'
,p_message_text=>'Bcc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910296301401298)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'pt'
,p_message_text=>'Corpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909951364401297)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'pt'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910742428401298)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'pt'
,p_message_text=>unistr('Frequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792141529401212)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'pt'
,p_message_text=>unistr('O correio eletr\00F3nico n\00E3o foi configurado para esta aplica\00E7\00E3o. Contacte o administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883691747401278)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar o Endere\00E7o de Correio Eletr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910304161401298)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'pt'
,p_message_text=>'Consultar anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910169419401298)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'pt'
,p_message_text=>'Assunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884618832401279)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar o Assunto da Mensagem de Correio Eletr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909874373401297)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'pt'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793832432401214)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'pt'
,p_message_text=>'Ativado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835565055401244)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'pt'
,p_message_text=>'Ativar/Desativar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835042162401243)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834669332401243)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'pt'
,p_message_text=>'Exemplos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835496958401244)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'pt'
,p_message_text=>'Exemplos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799348390401218)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'pt'
,p_message_text=>'Excluir Valores Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836032353401244)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'pt'
,p_message_text=>'Expandir/Contrair'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833608967401242)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('Express\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818797335401231)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'pt'
,p_message_text=>'Filtrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829631725401239)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'pt'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839976438401247)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('Express\00E3o do Filtro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936402203401316)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'pt'
,p_message_text=>unistr('A express\00E3o do filtro \00E9 demasiado longa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839808576401247)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'pt'
,p_message_text=>'Tipo de Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836211995401244)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'pt'
,p_message_text=>'Selecionar colunas para pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819022728401232)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'pt'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833463303401242)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Uma consulta de flashback permite-lhe visualizar os dados tal como existiam num per\00EDodo anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884027105401279)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('Dura\00E7\00E3o do Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885410564401280)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'pt'
,p_message_text=>'Formatar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815182728401229)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1scara de Formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826392829401237)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Fun\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834104666401243)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('Fun\00E7\00F5es %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909300696401297)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'pt'
,p_message_text=>unistr('Fun\00E7\00F5es/Operadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826095515401237)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'pt'
,p_message_text=>unistr('Fun\00E7\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818524237401231)
,p_name=>'APEXIR_GO'
,p_message_language=>'pt'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794355710401214)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'pt'
,p_message_text=>'verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113777615750401202)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>'Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910468949401298)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Agrupar Por Coluna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865061699401265)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar Agrupar por coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876196844401273)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'pt'
,p_message_text=>unistr('O n\00FAmero m\00E1ximo de linhas para uma consulta de Agrupar Por limita o n\00FAmero de linhas na consulta base e n\00E3o o n\00FAmero de linhas apresentadas. A sua consulta base excede o n\00FAmero m\00E1ximo de linhas de %0. Aplique um filtro para reduzir o n\00FAmero de regist')
||'os na sua consulta base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856730045401259)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Ordena\00E7\00E3o de Agrupar Por')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914200689401300)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'pt'
,p_message_text=>unistr('Sequ\00EAncia de Ordena\00E7\00E3o de Agrupar Por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799746265401218)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'pt'
,p_message_text=>'Coluna Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831301140401241)
,p_name=>'APEXIR_HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823105096401235)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Os relat\00F3rios interativos permitem que os utilizadores finais customizem relat\00F3rios. Os utilizadores podem alterar a disposi\00E7\00E3o dos dados do relat\00F3rio ao selecionarem colunas, aplicarem filtros, destacarem e ordenarem. Os utilizadores tamb\00E9m podem de')
||unistr('finir quebras, agrega\00E7\00F5es, diagramas e agrupamentos e acrescentarem c\00E1lculos pr\00F3prios. Os utilizadores tamb\00E9m podem configurar uma subscri\00E7\00E3o para que uma vers\00E3o em HTML do relat\00F3rio lhes seja enviada por correio eletr\00F3nico em intervalos de tempo esp')
||unistr('ecificados. Os utilizadores podem criar diferentes varia\00E7\00F5es de um relat\00F3rio e grav\00E1-las como relat\00F3rios nomeados para visualiza\00E7\00E3o p\00FAblica ou privada. '),
'<p/>',
unistr('As sec\00E7\00F5es a seguir resumem as formas de customiza\00E7\00E3o de um relat\00F3rio interativo. Para saber mais, consulte "Utilizar Relat\00F3rios Interativos" no <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830234018401240)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'pt'
,p_message_text=>unistr('O menu A\00E7\00F5es aparece \00E0 direita do bot\00E3o Ir na barra de Pesquisa. Utilize este menu para customizar um relat\00F3rio interativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823950592401235)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('As agrega\00E7\00F5es s\00E3o c\00E1lculos matem\00E1ticos efetuados com base numa coluna. As agrega\00E7\00F5es s\00E3o apresentadas ap\00F3s cada controlo de interrup\00E7\00E3o e no fim do relat\00F3rio, na coluna onde est\00E3o definidas. As op\00E7\00F5es incluem:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agrega\00E7\00E3o</strong> permite-lhe selecionar uma agrega\00E7\00E3o'),
unistr('definida anteriormente para edi\00E7\00E3o.</li>'),
unistr('<li><strong>Fun\00E7\00E3o</strong> \00E9 a fun\00E7\00E3o a efetuar (por exemplo, SUM, MIN).</li>'),
unistr('<li><strong>Coluna</strong> \00E9 utilizada para selecionar a coluna \00E0 qual a fun\00E7\00E3o matem\00E1tica \00E9 aplicada. Apenas s\00E3o apresentadas'),
unistr('colunas num\00E9ricas.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824080519401235)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pode definir um diagrama por cada relat\00F3rio gravado. Conclu\00EDda'),
unistr('a defini\00E7\00E3o, pode alternar entre as visualiza\00E7\00F5es de diagrama e de relat\00F3rio com os \00EDcones de visualiza\00E7\00E3o na barra de Pesquisa.'),
unistr('As op\00E7\00F5es incluem:  '),
'<p>',
'</p><ul>',
'<li><strong>Tipo de Diagrama</strong> identifica o tipo de diagrama a incluir.',
'Selecione barra horizontal, barra vertical, sectograma ou linha.</li>',
'<li><strong>Etiqueta</strong> permite-lhe selecionar a coluna a utilizar como etiqueta.</li>',
unistr('<li><strong>T\00EDtulo do Eixo para Etiqueta</strong> \00E9 o t\00EDtulo apresentado no eixo associado \00E0 coluna selecionada para a'),
unistr('Etiqueta. N\00E3o est\00E1 dispon\00EDvel para sectogramas.</li>'),
unistr('<li><strong>Valor</strong> permite-lhe selecionar a coluna a utilizar como valor. Se a fun\00E7\00E3o'),
unistr('for COUNT, n\00E3o \00E9 necess\00E1rio selecionar um Valor.</li>'),
unistr('<li><strong>T\00EDtulo do Eixo para Valor</strong> \00E9 o t\00EDtulo apresentado no eixo associado \00E0 coluna selecionada para o'),
unistr('Valor. N\00E3o est\00E1 dispon\00EDvel para sectogramas.</li>'),
unistr('<li><strong>Fun\00E7\00E3o</strong> \00E9 uma fun\00E7\00E3o opcional a efetuar na coluna selecionada para o Valor.</li>'),
'<li><strong>Ordenar</strong> permite-lhe ordenar o conjunto de resultados.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823327378401235)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Clicar num t\00EDtulo de coluna exp\00F5e um menu de t\00EDtulo de coluna. As op\00E7\00F5es incluem:'),
'<p></p>',
'<ul>',
unistr('<li>O \00EDcone <strong>Ordem Crescente</strong> ordena o relat\00F3rio pela coluna na ordem crescente.</li>'),
unistr('<li>O \00EDcone <strong>Ordem Decrescente</strong> ordena o relat\00F3rio pela coluna na ordem decrescente.</li>'),
unistr('<li><strong>Ocultar Coluna</strong> oculta a coluna. Nem todas as colunas podem ser ocultadas. Se n\00E3o for poss\00EDvel ocultar uma coluna, o \00EDcone Ocultar Coluna n\00E3o \00E9 apresentado.</li>'),
unistr('<li><strong>Quebrar Coluna</strong> cria um grupo de quebras na coluna. Isto extrai a coluna do relat\00F3rio como um registo mestre.</li>'),
unistr('<li><strong>Informa\00E7\00F5es da Coluna</strong> apresenta texto de aux\00EDlio sobre a coluna, se dispon\00EDvel.</li>'),
unistr('<li>A <strong>\00C1rea de Texto</strong> \00E9 utilizada para introduzir crit\00E9rios de pesquisa n\00E3o sens\00EDveis a mai\00FAsculas/min\00FAsculas'),
unistr('(sem necessidade de caracteres de substitui\00E7\00E3o). A introdu\00E7\00E3o de um valor reduz a lista de'),
'valores na parte inferior do menu. Em seguida, pode selecionar um valor na',
unistr('parte inferior e o valor selecionado ser\00E1 criado como um filtro com ''='''),
unistr('(por exemplo, <code>coluna = ''ABC''</code>). Em alternativa, pode clicar no \00EDcone Lanterna e introduzir um valor para ser criado como um filtro com o modificador ''SEMELHANTE A'''),
'(por exemplo, <code>coluna SEMELHANTE A ''%ABC%''</code>).</li>',
unistr('<li>A <b>Lista de Valores Exclusivos</b> cont\00E9m os primeiros 500 valores'),
unistr('exclusivos correspondentes aos crit\00E9rios do filtro. Se a coluna for uma data, \00E9 apresentada'),
unistr('uma lista de intervalos de datas. Se selecionar um valor, ser\00E1 criado um filtro'),
'com ''='' (por exemplo, <code>coluna = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823838724401235)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite-lhe acrescentar colunas calculadas ao relat\00F3rio. Podem ser c\00E1lculos matem\00E1ticos (por exemplo, <code>NBR_HOURS/24</code>) ou fun\00E7\00F5es Oracle standard'),
unistr('aplicadas a colunas existentes. Alguns s\00E3o apresentados como exemplos e outros (como <code>TO_DATE)</code> tamb\00E9m podem ser utilizados). As op\00E7\00F5es incluem:'),
'<p></p>',
'<ul>',
unistr('<li><strong>C\00E1lculo</strong> permite-lhe selecionar um c\00E1lculo definido anteriormente para edi\00E7\00E3o.</li>'),
unistr('<li><strong>T\00EDtulo da Coluna</strong> \00E9 o t\00EDtulo da coluna para a nova coluna.</li>'),
unistr('<li><strong>M\00E1scara de Formato</strong> \00E9 uma m\00E1scara de formato Oracle a ser aplicada \00E0 coluna (por exemplo,S9999).</li>'),
unistr('<li><strong>C\00E1lculo</strong> \00E9 o c\00E1lculo a efetuar. No c\00E1lculo, as colunas s\00E3o referenciadas com os pseud\00F3nimos apresentados.</li>'),
'</ul>',
unistr('<p>Abaixo do c\00E1lculo, as colunas da consulta s\00E3o apresentadas com'),
unistr('o respetivo pseud\00F3nimo associado. Ao clicar no nome ou pseud\00F3nimo da coluna, inclui-a'),
unistr('no C\00E1lculo. Existe um teclado junto \00E0s Colunas. Este teclado funciona como'),
unistr('um atalho para teclas utilizadas frequentemente. Na extremidade direita, encontra as Fun\00E7\00F5es.</p>'),
unistr('<p>O c\00E1lculo de exemplo a seguir demonstra como apresentar a remunera\00E7\00E3o total:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(em que A \00E9 ORGANIZATION, B \00E9 SALARY e C \00E9 COMMISSION)</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830313492401240)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'pt'
,p_message_text=>unistr('Utilizado para criar um grupo de quebras numa ou mais colunas. Retira as colunas do relat\00F3rio interativo e apresenta-as como um registo mestre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824541284401236)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Para ver os detalhes de uma s\00F3 linha de cada vez, clique no \00EDcone de visualiza\00E7\00E3o de linha \00FAnica na linha que pretende visualizar. Se estiver dispon\00EDvel, a visualiza\00E7\00E3o de linha \00FAnica ser\00E1 sempre a primeira coluna. Consoante a customiza\00E7\00E3o do relat\00F3r')
||unistr('io interativo, a visualiza\00E7\00E3o de linha \00FAnica pode ser a visualiza\00E7\00E3o standard ou uma p\00E1gina customizada que pode permitir a atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824452941401236)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Permite que o conjunto de resultados atual seja descarregado. Os formatos de descarregamento',
unistr('variam consoante a instala\00E7\00E3o e a defini\00E7\00E3o do relat\00F3rio, mas'),
'podem incluir CSV, HTML, Email, XLS, PDF ou RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823586688401235)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Foca o relat\00F3rio ao acrescentar ou modificar a cl\00E1usula <code>WHERE</code> na consulta. Pode filtrar por coluna ou por linha.  '),
unistr('<p>Se filtrar por coluna, selecione uma coluna (n\00E3o precisa de ser'),
unistr('uma das colunas apresentadas), selecione um operador Oracle standard (=, !=, n\00E3o est\00E1 em, entre) e introduza uma express\00E3o para compara\00E7\00E3o. As express\00F5es s\00E3o sens\00EDveis a mai\00FAsculas/min\00FAsculas. Utilize % como car\00E1cter de substitui\00E7\00E3o (por exemplo, <co')
||'de>STATE_NAME',
'semelhante a A%)</code>.</p>',
unistr('<p>Se filtrar por linha, pode criar cl\00E1usulas <code>WHERE</code> complexas com'),
unistr('pseud\00F3nimos de colunas e quaisquer operadores ou fun\00E7\00F5es Oracle (por exemplo, <code>G = ''VA'' ou G = ''CT''</code>, em que'),
unistr('<code>G</code> \00E9 o pseud\00F3nimo de <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824171692401235)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uma consulta de flashback permite-lhe visualizar os dados tal como existiam num per\00EDodo'),
unistr('anterior. A quantidade de tempo por omiss\00E3o para o flashback \00E9 de 3 horas (ou 180'),
unistr('minutos), mas a quantidade real ser\00E1 diferente para cada base de dados.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885325091401280)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Formatar permite-lhe customizar a apresenta\00E7\00E3o do relat\00F3rio.'),
unistr('Formatar cont\00E9m o seguinte submenu:</p>'),
'<ul><li>Ordenar</li>',
unistr('<li>Controlo de Interrup\00E7\00E3o</li>'),
'<li>Destacar</li>',
'<li>Calcular</li>',
'<li>Agregar</li>',
'<li>Diagrama</li>',
'<li>Agrupar Por</li>',
unistr('<li>Din\00E2mica</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883568490401278)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pode definir uma visualiza\00E7\00E3o Agrupar Por para cada relat\00F3rio'),
unistr('gravado. Ap\00F3s a defini\00E7\00E3o, pode alternar entre as visualiza\00E7\00F5es'),
unistr('agrupar por e relat\00F3rio ao utilizar os \00EDcones de visualiza\00E7\00E3o na barra de Pesquisa. Para criar uma visualiza\00E7\00E3o Agrupar Por,'),
'selecione:',
'<p></p><ul>',
'<li>as colunas para agrupar</li>',
unistr('<li>as colunas a agregar com a fun\00E7\00E3o a efetuar (m\00E9dia, soma, contagem, etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823719670401235)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite-lhe definir um filtro. As linhas que cumprem os crit\00E9rios do filtro s\00E3o destacadas com as caracter\00EDsticas associadas ao filtro. As op\00E7\00F5es incluem:</p>'),
'<ul>',
unistr('<li>O <strong>Nome</strong> \00E9 utilizado apenas para apresenta\00E7\00E3o.</li>'),
unistr('<li>A <strong>Sequ\00EAncia</strong> identifica a sequ\00EAncia de avalia\00E7\00E3o das regras.</li>'),
unistr('<li>A op\00E7\00E3o <strong>Ativado</strong> identifica se uma regra est\00E1 ativada ou desativada.</li>'),
unistr('<li>O <strong>Tipo de Destaque</strong> identifica se a linha ou a c\00E9lula deve ser'),
unistr('destacada. Se selecionar C\00E9lula, a coluna referenciada na'),
unistr('Condi\00E7\00E3o de Destaque \00E9 destacada.</li>'),
unistr('<li>A <strong>Cor de Segundo Plano</strong> \00E9 a nova cor do segundo plano da \00E1rea destacada.</li>'),
unistr('<li>A <strong>Cor do Texto</strong> \00E9 a nova cor do texto na \00E1rea destacada.</li>'),
unistr('<li>A <strong>Condi\00E7\00E3o de Destaque</strong> define a condi\00E7\00E3o do filtro.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761353162401190)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pode definir uma visualiza\00E7\00E3o Din\00E2mica por relat\00F3rio gravado. Depois de definir a visualiza\00E7\00E3o, pode alternar entre as visualiza\00E7\00F5es de relat\00F3rio e din\00E2mica ao utilizar os \00EDcones de visualiza\00E7\00E3o dispon\00EDveis na barra de Pesquisa. Para criar uma visual')
||unistr('iza\00E7\00E3o Din\00E2mica, selecione: '),
'<p></p>',
'<ul>',
unistr('<li>as colunas din\00E2micas</li>'),
'<li>as colunas a apresentar como linhas</li>',
unistr('<li>as colunas a agregar com a fun\00E7\00E3o a efetuar (m\00E9dia, soma, contagem, etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834888850401243)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se customizar um relat\00F3rio interativo, as defini\00E7\00F5es do relat\00F3rio s\00E3o apresentadas'),
unistr('abaixo da barra de Pesquisa e acima do relat\00F3rio. Esta \00E1rea pode ser contra\00EDda ou expandida com o \00EDcone \00E0 esquerda.'),
'<p>',
unistr('Para cada defini\00E7\00E3o do relat\00F3rio, pode:'),
'</p><ul>',
unistr('<li>Editar uma defini\00E7\00E3o ao clicar no nome.</li>'),
unistr('<li>Desativar/Ativar uma defini\00E7\00E3o ao anular a sele\00E7\00E3o ou ao selecionar a caixa de sele\00E7\00E3o Ativar/Desativar. Utilize este controlo para desativar ou ativar temporariamente uma defini\00E7\00E3o.</li>'),
unistr('<li>Retirar uma defini\00E7\00E3o ao clicar no \00EDcone Retirar.</li>'),
'</ul>',
unistr('<p>Se tiver criado um diagrama, agrupar por ou din\00E2mica, pode alternar entre eles'),
unistr('e o relat\00F3rio base atrav\00E9s das liga\00E7\00F5es Visualiza\00E7\00E3o de Relat\00F3rio, Visualiza\00E7\00E3o de Diagrama, Visualiza\00E7\00E3o Agrupar Por e Visualiza\00E7\00E3o Din\00E2mica'),
unistr('mostradas \00E0 direita. Se est\00E1 a visualizar o diagrama, agrupar por ou din\00E2mica, tamb\00E9m'),
unistr('pode utilizar a liga\00E7\00E3o Editar para editar as defini\00E7\00F5es.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824364403401236)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'pt'
,p_message_text=>unistr('Redefine o relat\00F3rio para as defini\00E7\00F5es por omiss\00E3o ao retirar todas as customiza\00E7\00F5es que efetuou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885636538401280)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Define o n\00FAmero de registos a apresentar por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824244214401235)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Grava o relat\00F3rio customizado para utiliza\00E7\00E3o futura. Fornece um nome e uma descri\00E7\00E3o opcional e pode tornar o relat\00F3rio acess\00EDvel ao p\00FAblico (ou seja, a todos os utilizadores que podem aceder ao relat\00F3rio por omiss\00E3o principal). Pode gravar quatr')
||unistr('o tipos de relat\00F3rios interativos:</p>'),
'<ul>',
unistr('<li><strong>Por Omiss\00E3o Principal</strong> (Apenas para Programadores). O relat\00F3rio Por Omiss\00E3o Principal \00E9 o relat\00F3rio apresentado inicialmente. O relat\00F3rio Por Omiss\00E3o Principal n\00E3o pode ser renomeado nem apagado.</li>'),
unistr('<li><strong>Relat\00F3rio Alternativo</strong> (Apenas para Programadores). Permite que os programadores criem v\00E1rias disposi\00E7\00F5es de relat\00F3rios. Um relat\00F3rio Alternativo s\00F3 pode ser gravado, renomeado ou apagado por um programador.</li>'),
unistr('<li><strong>Relat\00F3rio P\00FAblico</strong> (Utilizador final). Pode ser gravado, renomeado ou apagado pelo utilizador final que o criou. Outros utilizadores podem visualizar e gravar a disposi\00E7\00E3o como outro relat\00F3rio.</li>'),
unistr('<li><strong>Relat\00F3rio Privado</strong> (Utilizador final). O relat\00F3rio s\00F3 pode ser visualizado, gravado, renomeado ou apagado pelo utilizador final que o criou.</li>'),
'</ul>',
unistr('<p>Se gravar relat\00F3rios customizados, um seletor de Relat\00F3rios \00E9 apresentado na barra de Pesquisa \00E0 esquerda do seletor de Linhas (se esta funcionalidade estiver ativada).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823209051401235)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'pt'
,p_message_text=>unistr('Encontra uma regi\00E3o de pesquisa no in\00EDcio de cada p\00E1gina do relat\00F3rio. Esta regi\00E3o (ou barra de Pesquisa) fornece as seguintes funcionalidades:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886212840401280)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'pt'
,p_message_text=>unistr('<li>O <strong>Menu A\00E7\00F5es</strong> permite-lhe customizar um relat\00F3rio. Consulte as sec\00E7\00F5es a seguir.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885711081401280)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'pt'
,p_message_text=>unistr('<li>O <strong>\00EDcone Selecionar colunas</strong> permite-lhe identificar as colunas a pesquisar (ou todas).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886009481401280)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'pt'
,p_message_text=>unistr('<li><strong>Relat\00F3rios</strong> apresenta os relat\00F3rios privados e p\00FAblicos gravados e por omiss\00E3o alternativos.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885943404401280)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'pt'
,p_message_text=>unistr('<li><strong>Linhas</strong> define o n\00FAmero de registos a apresentar por p\00E1gina.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885841998401280)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>A <strong>\00C1rea de texto</strong> permite-lhe introduzir crit\00E9rios de pesquisa n\00E3o sens\00EDveis a mai\00FAsculas/min\00FAsculas (incluindo caracteres de substitui\00E7\00E3o).</li>'),
unistr('<li>O <strong>bot\00E3o Ir</strong> executa a pesquisa. Premir a tecla enter tamb\00E9m executa a pesquisa quando o cursor est\00E1 na \00E1rea de texto da pesquisa.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886113699401280)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('<li>Os <strong>\00CDcones de Visualiza\00E7\00F5es</strong> alternam entre as visualiza\00E7\00F5es de \00EDcone, relat\00F3rio, detalhe, diagrama, agrupar por e din\00E2mica do relat\00F3rio caso estejam definidas.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902131662401292)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('<li><strong>Gerir</strong> permite-lhe gerir propriedades, colunas, linhas e o hist\00F3rico de visualiza\00E7\00E3o do relat\00F3rio ou da grelha de dados.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823474613401235)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>unistr('Utilizado para modificar as colunas apresentadas. S\00E3o apresentadas as colunas \00E0 direita. As colunas \00E0 esquerda s\00E3o ocultadas. Pode reordenar as colunas apresentadas com as setas na extremidade direita. As colunas calculadas t\00EAm o prefixo <strong>**</')
||'strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823643091401235)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilizado para alterar as colunas para ordena\00E7\00E3o e determina a utiliza\00E7\00E3o da'),
unistr('ordem crescente ou da ordem decrescente. Tamb\00E9m pode especificar como os'),
unistr('<code>NULLs</code> s\00E3o processados. A defini\00E7\00E3o por omiss\00E3o apresenta sempre os <code>NULLs</code> em \00FAltimo lugar ou sempre em primeiro lugar. A ordena\00E7\00E3o resultante \00E9 apresentada \00E0 direita dos'),
unistr('t\00EDtulos das colunas no relat\00F3rio.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883336196401278)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Quando acrescenta uma subscri\00E7\00E3o, fornece um endere\00E7o de correio eletr\00F3nico (ou v\00E1rios endere\00E7os de correio eletr\00F3nico separados por v\00EDrgulas), o assunto da mensagem de correio eletr\00F3nico, a frequ\00EAncia e as datas de in\00EDcio e fim. As mensagens de corr')
||unistr('eio eletr\00F3nico resultantes incluem uma vers\00E3o em HTML do relat\00F3rio interativo que cont\00E9m os dados atuais que utilizam as defini\00E7\00F5es do relat\00F3rio existentes quando a subscri\00E7\00E3o foi acrescentada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901989563401292)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Basicamente, as grelhas de dados s\00E3o relat\00F3rios edit\00E1veis altamente customiz\00E1veis. Os utilizadores podem alterar a disposi\00E7\00E3o dos dados do relat\00F3rio ao selecionarem colunas, aplicarem filtros e destaques e ordenarem. Os utilizadores tamb\00E9m podem defi')
||unistr('nir quebras, agrega\00E7\00F5es, diagramas e op\00E7\00F5es de agrupar por, al\00E9m de acrescentarem c\00E1lculos pr\00F3prios. Os utilizadores podem criar varia\00E7\00F5es de um relat\00F3rio e grav\00E1-las como relat\00F3rios nomeados para visualiza\00E7\00E3o privada. '),
'<p/>',
unistr('Uma Grelha de dados pode ser customizada com a barra de Pesquisa, o menu A\00E7\00F5es, o menu Gerir ou o menu T\00EDtulo da Coluna.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913706292401300)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'pt'
,p_message_text=>unistr('O menu A\00E7\00F5es aparece \00E0 direita do bot\00E3o Ir na barra de Pesquisa. Utilize este menu para customizar um relat\00F3rio de grelha de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902412728401292)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'pt'
,p_message_text=>unistr('P\00E1gina Acrescentar/Editar Linha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902567924401292)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para acrescentar uma linha \00E0 grelha de dados, clique em Acrescentar Linha. Para editar os detalhes de uma linha, clique no \00EDcone de edi\00E7\00E3o da linha (primeira coluna) na linha que pretende editar. A p\00E1gina Acrescentar/Editar Linha ser\00E1 apresentada ')
||'com as colunas da grelha de dados. </p>',
'',
'<p>Quando edita uma linha, pode:</p>',
'',
'<p><ul>',
'<li><strong>Apagar</strong> a linha.</li>',
unistr('<li><strong>Aplicar Altera\00E7\00F5es</strong> para gravar as altera\00E7\00F5es efetuadas na linha.</li>'),
unistr('<li>Nas <strong>A\00E7\00F5es</strong>, acrescente uma linha, acrescente ficheiros, notas, liga\00E7\00F5es ou identificadores e reveja o hist\00F3rico.</li>'),
'<li>Navegue para as linhas <strong>Seguintes e Anteriores</strong>.</li>',
unistr('<li>Em <strong>Gerir</strong>, defina as propriedades das colunas, os grupos de colunas, as valida\00E7\00F5es e as listas de valores.</li>'),
'</ul></p>',
'',
unistr('<p>A regi\00E3o Anota\00E7\00F5es na parte inferior da p\00E1gina ir\00E1 apresentar os ficheiros, as notas, as liga\00E7\00F5es ou os identificadores associados \00E0 linha atual.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913813907401300)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'pt'
,p_message_text=>'Utilizado para criar um grupo de quebras numa ou mais colunas. Retira as colunas da grelha de dados e apresenta-as como um registo mestre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902392058401292)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Permite o descarregamento do conjunto de resultados atual. Os formatos de descarregamento',
unistr('incluem CSV, HTML ou Correio Eletr\00F3nico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913998412401300)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se customizar um relat\00F3rio de grelha de dados, as defini\00E7\00F5es do relat\00F3rio s\00E3o apresentadas'),
unistr('abaixo da barra de Pesquisa e acima do relat\00F3rio. Esta \00E1rea pode ser contra\00EDda e expandida com o \00EDcone \00E0 esquerda.'),
'<p>',
unistr('Para cada defini\00E7\00E3o do relat\00F3rio, pode:'),
'</p><ul>',
unistr('<li>Editar a defini\00E7\00E3o ao clicar no nome.</li>'),
unistr('<li>Desativar/Ativar uma defini\00E7\00E3o ao anular a sele\00E7\00E3o ou selecionar a caixa de sele\00E7\00E3o Ativar/Desativar. Utilize este controlo para desativar e ativar temporariamente uma defini\00E7\00E3o.</li>'),
unistr('<li>Retirar uma defini\00E7\00E3o ao clicar no \00EDcone Retirar.</li>'),
'</ul>',
'<p>Se tiver criado um diagrama ou agrupar por, pode alterar entre eles',
unistr('e o relat\00F3rio base atrav\00E9s das liga\00E7\00F5es Visualiza\00E7\00E3o de Relat\00F3rio, Visualiza\00E7\00E3o de Diagrama e Visualiza\00E7\00E3o Agrupar Por'),
unistr('mostradas \00E0 direita. Se estiver a visualizar o gr\00E1fico ou agrupar por, tamb\00E9m'),
unistr('pode utilizar a liga\00E7\00E3o Editar para editar as defini\00E7\00F5es.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902264222401292)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Grava a disposi\00E7\00E3o do relat\00F3rio de grelha de dados customizado para utiliza\00E7\00E3o futura. Fornece um nome e uma descri\00E7\00E3o opcional. Pode gravar tr\00EAs tipos de disposi\00E7\00F5es de relat\00F3rio de grelha de dados:</p>'),
'<ul>',
unistr('<li><strong>Por Omiss\00E3o Principal</strong> (Apenas para Administradores). A disposi\00E7\00E3o Por Omiss\00E3o Principal \00E9 a disposi\00E7\00E3o apresentada inicialmente. O relat\00F3rio Por Omiss\00E3o Principal n\00E3o pode ser renomeado nem apagado.</li>'),
unistr('<li><strong>Relat\00F3rio Alternativo</strong> (Apenas para Administradores). Permite que os programadores criem v\00E1rias disposi\00E7\00F5es de relat\00F3rios. Um Relat\00F3rio Alternativo s\00F3 pode ser gravado, renomeado ou apagado por um administrador.</li>'),
unistr('<li><strong>Relat\00F3rio Alternativo</strong> (Apenas para Administradores). Permite que os administradores criem v\00E1rias disposi\00E7\00F5es de relat\00F3rios. Apenas os administradores podem gravar, renomear ou apagar um Relat\00F3rio Alternativo.</li>'),
unistr('<li><strong>Relat\00F3rio Privado</strong> (Todos os utilizadores). O utilizador que criou o relat\00F3rio pode visualizar, gravar, renomear ou apagar o relat\00F3rio.</li>'),
'</ul>',
unistr('<p>Se gravar relat\00F3rios customizados, um seletor de Relat\00F3rios \00E9 apresentado na barra de Pesquisa \00E0 esquerda do seletor de Linhas (se esta funcionalidade estiver ativada).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828385290401238)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Ocultar Coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818905401401232)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'pt'
,p_message_text=>'Destacar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829857643401240)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'pt'
,p_message_text=>'Destaques'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834966915401243)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'pt'
,p_message_text=>unistr('Condi\00E7\00E3o de Destaque')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883994265401279)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'pt'
,p_message_text=>'Estilo do Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793961570401214)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'pt'
,p_message_text=>'Tipo de Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903405147401293)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'pt'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933028006401314)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'pt'
,p_message_text=>unistr('1 defini\00E7\00E3o inativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933178013401314)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 defini\00E7\00F5es inativas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824932645401236)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio do Relat\00F3rio Interativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835915875401244)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('Inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829349743401239)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Express\00E3o de c\00E1lculo inv\00E1lida. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788741949401210)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'pt'
,p_message_text=>unistr('A data de fim deve ser posterior \00E0 data de in\00EDcio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843667443401249)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'pt'
,p_message_text=>unistr('Express\00E3o de filtro inv\00E1lida. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911408239401298)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'pt'
,p_message_text=>unistr('Consulta de filtro inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933237987401314)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'pt'
,p_message_text=>unistr('1 defini\00E7\00E3o inv\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933376135401314)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 defini\00E7\00F5es inv\00E1lidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884122056401279)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'pt'
,p_message_text=>'(em minutos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901190461401291)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 est\00E1 no \00FAltimo intervalo de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901384251401291)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 est\00E1 no pr\00F3ximo intervalo de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901279004401291)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no \00FAltimo intervalo de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901412981401291)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 n\00E3o est\00E1 no pr\00F3ximo intervalo de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834000928401243)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'pt'
,p_message_text=>'Teclado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800131998401218)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Etiqueta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827963502401238)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo do Eixo para Etiqueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820432847401233)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo Dia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820610800401233)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltima Hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820153972401232)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820262625401233)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltima Semana')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820364263401233)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimos %0 Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820599375401233)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimas %0 Horas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819901501401232)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimos %0 Anos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820097806401232)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00DAltimo Ano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800051715401218)
,p_name=>'APEXIR_LINE'
,p_message_language=>'pt'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796885705401216)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'pt'
,p_message_text=>unistr('Linha com \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911314877401298)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'pt'
,p_message_text=>unistr('Localiza\00E7\00E3o no Mapa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828807914401239)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'pt'
,p_message_text=>unistr('Estima-se que a consulta exceda o m\00E1ximo de recursos permitidos. Modifique as defini\00E7\00F5es do relat\00F3rio e tente novamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811078857401226)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'pt'
,p_message_text=>unistr('O n\00FAmero m\00E1ximo de linhas para este relat\00F3rio \00E9 %0 linhas. Aplique um filtro para reduzir o n\00FAmero de registos na sua consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911944614401299)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00E1ximo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912109462401299)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'pt'
,p_message_text=>'Mediano %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815032126401229)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 minutos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912051356401299)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EDnimo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911097955401298)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884553322401279)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'pt'
,p_message_text=>'Mensal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827115590401238)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'pt'
,p_message_text=>'Deslocar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827023797401237)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'pt'
,p_message_text=>'Deslocar Todos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938220129401318)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID Est\00E1tica da Regi\00E3o deve ser especificada dado que a p\00E1gina cont\00E9m v\00E1rios relat\00F3rios interativos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795541062401215)
,p_name=>'APEXIR_NAME'
,p_message_language=>'pt'
,p_message_text=>'Nome'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822942155401234)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Nova Agrega\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933997460401315)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'pt'
,p_message_text=>'Nova Categoria'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113823040632401235)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Novo C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817865032401231)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820930677401233)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'pt'
,p_message_text=>'Dia Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820703753401233)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3xima hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821267341401233)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximo M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821123412401233)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3xima Semana')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821051238401233)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximos %0 Dias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113820839801401233)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximas %0 Horas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821492999401233)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximos %0 Anos')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821312011401233)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00F3ximo Ano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795840659401215)
,p_name=>'APEXIR_NO'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836186683401244)
,p_name=>'APEXIR_NONE'
,p_message_language=>'pt'
,p_message_text=>'- Nenhum -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883737247401279)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 um endere\00E7o de correio eletr\00F3nico v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832622128401242)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'pt'
,p_message_text=>unistr('Nulos Sempre no In\00EDcio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832593572401242)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'pt'
,p_message_text=>'Nulos Sempre no Fim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833096693401242)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'pt'
,p_message_text=>unistr('Ordena\00E7\00E3o de Nulos %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829440046401239)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio que o tempo de flashback seja num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829071881401239)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio que a sequ\00EAncia seja num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833548182401242)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'pt'
,p_message_text=>'Operador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794479604401214)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'pt'
,p_message_text=>'laranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903378158401293)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Orienta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796370160401215)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'pt'
,p_message_text=>'Outro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779135367401203)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Orienta\00E7\00E3o da p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779804641401204)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'pt'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779924285401204)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'pt'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779043438401203)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'pt'
,p_message_text=>unistr('Tamanho da p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779633342401203)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'pt'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779511174401203)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'pt'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779740920401204)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'pt'
,p_message_text=>'Customizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779323770401203)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'pt'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779248574401203)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'pt'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113779480115401203)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'pt'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912437141401299)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'pt'
,p_message_text=>'Percentagem da Contagem Total %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911696683401299)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'pt'
,p_message_text=>'Percentagem da Soma Total %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910606807401298)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'pt'
,p_message_text=>'Percentagem da Contagem Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910502316401298)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'pt'
,p_message_text=>'Percentagem da Soma Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799994771401218)
,p_name=>'APEXIR_PIE'
,p_message_language=>'pt'
,p_message_text=>'Sectograma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859839347401261)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861329086401262)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a agrega\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861527945401263)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o pode efetuar a agrega\00E7\00E3o numa coluna selecionada como coluna da linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860746821401262)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>unistr('Colunas Din\00E2micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860510913401262)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'pt'
,p_message_text=>unistr('Coluna Din\00E2mica %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861173145401262)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a coluna din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761285451401190)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'pt'
,p_message_text=>unistr('O n\00FAmero m\00E1ximo de linhas para uma consulta Din\00E2mica limita o n\00FAmero de linhas na consulta base e n\00E3o o n\00FAmero de linhas apresentadas. A sua consulta base excede o n\00FAmero m\00E1ximo de linhas de %0. Aplique um filtro para reduzir o n\00FAmero de registos na ')
||'sua consulta base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861069398401262)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Ordena\00E7\00E3o Din\00E2mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830435248401240)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna din\00E2mica cont\00E9m demasiados valores distintos - n\00E3o \00E9 poss\00EDvel gerar o SQL din\00E2mico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883846071401279)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00E9-visualizar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817978097401231)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113909573018401297)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'pt'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884827533401279)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778909074401203)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'pt'
,p_message_text=>'Incluir Identificadores de Acessibilidade'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765862701401193)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'pt'
,p_message_text=>'Retirar RTF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842633976401249)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'pt'
,p_message_text=>'Privado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800515594401218)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'pt'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796136228401215)
,p_name=>'APEXIR_RED'
,p_message_language=>'pt'
,p_message_text=>'vermelho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938115919401318)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID Est\00E1tica da Regi\00E3o %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827258353401238)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'pt'
,p_message_text=>'Retirar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827325989401238)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'pt'
,p_message_text=>'Retirar Todos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933415041401314)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'pt'
,p_message_text=>'Retirar Diagrama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826888647401237)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'pt'
,p_message_text=>unistr('Retirar Controlo de Interrup\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826523813401237)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'pt'
,p_message_text=>'Retirar Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826693571401237)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'pt'
,p_message_text=>'Retirar Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933560981401314)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>'Retirar Agrupar Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826987234401237)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'pt'
,p_message_text=>'Retirar Destaque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933678481401314)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Retirar Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914632227401301)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Retirar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895260013401287)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Renomear Relat\00F3rio Por Omiss\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836412504401244)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Renomear Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818257835401231)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912514179401299)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792727335401213)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O relat\00F3rio interativo gravado com o pseud\00F3nimo %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842944505401249)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O relat\00F3rio n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792894309401213)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID do Relat\00F3rio Interativo Gravado %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113834728589401243)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'pt'
,p_message_text=>unistr('Defini\00E7\00F5es do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815501609401229)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualiza\00E7\00E3o do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819408571401232)
,p_name=>'APEXIR_RESET'
,p_message_language=>'pt'
,p_message_text=>'Redefinir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800796374401219)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'pt'
,p_message_text=>unistr('Repor defini\00E7\00F5es por omiss\00E3o do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795951700401215)
,p_name=>'APEXIR_ROW'
,p_message_language=>'pt'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908672044401296)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o pode utilizar ROWID como coluna de chave prim\00E1ria para uma Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825977894401237)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'pt'
,p_message_text=>'Linhas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885540761401280)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Linhas por P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860825131401262)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas da Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860635760401262)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'pt'
,p_message_text=>'Coluna da Linha %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861248672401262)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar a coluna da linha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861491227401262)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna da linha deve ser diferente da coluna din\00E2mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840095667401247)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'pt'
,p_message_text=>'Filtro de Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815614403401229)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'pt'
,p_message_text=>'Linha %0 de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819621636401232)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'pt'
,p_message_text=>unistr('O texto da linha cont\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795224331401215)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'pt'
,p_message_text=>'Gravar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830098890401240)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio Gravado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829900366401240)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio Gravado = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832192313401241)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'pt'
,p_message_text=>unistr('As defini\00E7\00F5es atuais do relat\00F3rio ser\00E3o utilizadas como valores por omiss\00E3o para todos os utilizadores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113895119543401287)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Gravar Relat\00F3rio Por Omiss\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113819353823401232)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Gravar Relat\00F3rio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933841702401315)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Gravar Relat\00F3rio *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886518097401281)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113824835418401236)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'pt'
,p_message_text=>'Barra Pesquisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113933759357401315)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892041224401284)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Pesquisar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876079420401273)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Colunas Selecionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796924482401216)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'- Selecionar Coluna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818606505401231)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>'Selecionar Colunas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800464740401218)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('- Selecionar Fun\00E7\00E3o -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825680584401236)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'- Selecionar Agrupar Por Coluna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860304378401262)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('- Selecionar Coluna Din\00E2mica -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911525680401299)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'pt'
,p_message_text=>'Selecionar Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860402500401262)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'- Selecionar Coluna da Linha -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769123017401196)
,p_name=>'APEXIR_SEND'
,p_message_language=>'pt'
,p_message_text=>'Enviar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775483115401200)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'pt'
,p_message_text=>unistr('Enviar como Mensagem de Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795693347401215)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'pt'
,p_message_text=>unistr('Sequ\00EAncia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818884066401232)
,p_name=>'APEXIR_SORT'
,p_message_language=>'pt'
,p_message_text=>'Ordenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828153112401238)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'pt'
,p_message_text=>'Ordem Crescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828242232401238)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'pt'
,p_message_text=>'Ordem Decrescente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914064541401300)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'pt'
,p_message_text=>unistr('Sequ\00EAncia de Ordena\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822611536401234)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'pt'
,p_message_text=>unistr('espa\00E7o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833722685401242)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'pt'
,p_message_text=>'Estado %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884252850401279)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Subscri\00E7\00E3o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910960395401298)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'pt'
,p_message_text=>'A terminar a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765318565401193)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'pt'
,p_message_text=>unistr('Ignorar se N\00E3o Foram Encontrados Dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113910863236401298)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'pt'
,p_message_text=>'A Partir De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911730181401299)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'pt'
,p_message_text=>'Soma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901738009401291)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'pt'
,p_message_text=>unistr('Regi\00E3o = %0, Relat\00F3rio = %1, Visualiza\00E7\00E3o = %2, In\00EDcio das Linhas Apresentadas = %3, Fim das Linhas Apresentadas = %4, Total de Linhas = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822349533401234)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'pt'
,p_message_text=>unistr('Regi\00E3o = %0, Relat\00F3rio = %1, Visualiza\00E7\00E3o = %2, In\00EDcio das Linhas Apresentadas = %3, Fim das Linhas Apresentadas = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794548962401214)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'pt'
,p_message_text=>'Cor do Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811644380401226)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'pt'
,p_message_text=>'dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811549936401226)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'pt'
,p_message_text=>'horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811456800401226)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'pt'
,p_message_text=>'minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811831191401227)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'pt'
,p_message_text=>'meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811701412401226)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'pt'
,p_message_text=>'semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113811934381401227)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'pt'
,p_message_text=>'anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113914481941401301)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'pt'
,p_message_text=>'Alternar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827495971401238)
,p_name=>'APEXIR_TOP'
,p_message_language=>'pt'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907622542401296)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('Coluna N\00E3o Agrupada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828943520401239)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio que o Nome do Destaque seja exclusivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799217952401217)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('tipo de dados n\00E3o suportado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827568660401238)
,p_name=>'APEXIR_UP'
,p_message_language=>'pt'
,p_message_text=>'Para Cima'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829191396401239)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'pt'
,p_message_text=>unistr('Introduza uma cor v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829242689401239)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'pt'
,p_message_text=>unistr('Introduza uma m\00E1scara de formato v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113796492459401215)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'pt'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113828061075401238)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo do Eixo para Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835878628401244)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Obrigat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799802339401218)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'pt'
,p_message_text=>'Coluna Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113903514155401293)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'pt'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835134875401243)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'pt'
,p_message_text=>'Visualizar Diagrama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890397726401283)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'pt'
,p_message_text=>'Visualizar Detalhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113935951510401316)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O relat\00F3rio n\00E3o tem a visualiza\00E7\00E3o %0 definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890497211401283)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'pt'
,p_message_text=>'Visualizar Grupo Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890228060401283)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualizar \00CDcones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860116610401261)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualizar Din\00E2mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113835273456401243)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Visualizar Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884402891401279)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'pt'
,p_message_text=>'Semanal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818187208401231)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio de Trabalho')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913188510401300)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'pt'
,p_message_text=>'%0 dias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913052395401300)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'pt'
,p_message_text=>'%0 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113912933688401300)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'pt'
,p_message_text=>'%0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913346324401300)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'pt'
,p_message_text=>'%0 meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913222059401300)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'pt'
,p_message_text=>'%0 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113913425844401300)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'pt'
,p_message_text=>'%0 anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113911112881401298)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'pt'
,p_message_text=>'Ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113794212141401214)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'pt'
,p_message_text=>'amarelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113795791488401215)
,p_name=>'APEXIR_YES'
,p_message_language=>'pt'
,p_message_text=>'Sim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113827813193401238)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 cont\00E9m < ou > que s\00E3o caracteres inv\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113850639504401255)
,p_name=>'APEX_REGION'
,p_message_language=>'pt'
,p_message_text=>unistr('Regi\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113778880205401203)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'pt'
,p_message_text=>unistr('Pr\00E9-condi\00E7\00E3o de API violada')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798313721401217)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel obter o valor para a Defini\00E7\00E3o de Aplica\00E7\00E3o %0 dado que a op\00E7\00E3o de cria\00E7\00E3o associada est\00E1 desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798236526401217)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel definir o valor para a Defini\00E7\00E3o de Aplica\00E7\00E3o %0 dado que a op\00E7\00E3o de cria\00E7\00E3o associada est\00E1 desativada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905937431401294)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'pt'
,p_message_text=>unistr('O valor da Defini\00E7\00E3o %0 da Aplica\00E7\00E3o \00E9 inv\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113905803867401294)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'pt'
,p_message_text=>unistr('A Defini\00E7\00E3o %0 da Aplica\00E7\00E3o Pedida n\00E3o est\00E1 definida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906077408401295)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('A Defini\00E7\00E3o %0 da Aplica\00E7\00E3o n\00E3o pode ser definida para um valor nulo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786902408401209)
,p_name=>'BACK'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773944364401199)
,p_name=>'BUILDER'
,p_message_language=>'pt'
,p_message_text=>'Criador'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838012340401245)
,p_name=>'BUTTON LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('Etiqueta de Bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773003647401199)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'pt'
,p_message_text=>unistr('Classes CSS do bot\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802275661401220)
,p_name=>'BUTTON_ID'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID de bot\00E3o gerada ser\00E1 a ID Est\00E1tica do bot\00E3o se for definida; caso contr\00E1rio, ser\00E1 uma ID gerada internamente no formato ''B'' || [ID de Bot\00E3o Interna]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765760497401193)
,p_name=>'CANDLESTICK'
,p_message_language=>'pt'
,p_message_text=>'Vela'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847251597401252)
,p_name=>'CENTER'
,p_message_language=>'pt'
,p_message_text=>'Centro'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797218078401216)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'pt'
,p_message_text=>'%0 Pedido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788627713401210)
,p_name=>'CHECK$'
,p_message_language=>'pt'
,p_message_text=>'seletor de linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113907777508401296)
,p_name=>'CHECKED'
,p_message_language=>'pt'
,p_message_text=>'selecionado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883202580401278)
,p_name=>'COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Coluna'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843781773401250)
,p_name=>'COMMENTS'
,p_message_language=>'pt'
,p_message_text=>unistr('Coment\00E1rios')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825297591401236)
,p_name=>'CONTINUE'
,p_message_language=>'pt'
,p_message_text=>'Continuar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787212907401209)
,p_name=>'COPYRIGHT'
,p_message_language=>'pt'
,p_message_text=>'Copyright &copy; %0, Todos os direitos reservados.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830930242401240)
,p_name=>'COUNT'
,p_message_language=>'pt'
,p_message_text=>'Contagem'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837645505401245)
,p_name=>'CREATE'
,p_message_language=>'pt'
,p_message_text=>'Criar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889940943401283)
,p_name=>'CREATED'
,p_message_language=>'pt'
,p_message_text=>'Criado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890005785401283)
,p_name=>'CREATED_BY'
,p_message_language=>'pt'
,p_message_text=>'Criado Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814800665401229)
,p_name=>'CREATED_ON'
,p_message_language=>'pt'
,p_message_text=>'Criado em'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825404980401236)
,p_name=>'CUSTOM'
,p_message_language=>'pt'
,p_message_text=>'Customizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836680494401244)
,p_name=>'CUSTOMIZE'
,p_message_language=>'pt'
,p_message_text=>'Customizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838263113401246)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'pt'
,p_message_text=>unistr('As prefer\00EAncias da p\00E1gina foram redefinidas para o utilizador %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838329538401246)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'pt'
,p_message_text=>unistr('As prefer\00EAncias foram alteradas para o utilizador %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838141030401246)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'pt'
,p_message_text=>unistr('As prefer\00EAncias da p\00E1gina foram redefinidas para o utilizador %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801996274401219)
,p_name=>'DAILY'
,p_message_language=>'pt'
,p_message_text=>unistr('Di\00E1rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113773580142401199)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'pt'
,p_message_text=>unistr('O ficheiro carregado \00E9 inv\00E1lido ou tem uma extens\00E3o incorreta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797466695401216)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi utilizado um seletor de XML ou JSON inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766797964401194)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'pt'
,p_message_text=>unistr('O perfil de dados e o ficheiro carregado n\00E3o cont\00EAm nenhuma coluna da tabela de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852475639401256)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontrados dados no ficheiro carregado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852547782401256)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontrados dados na folha de c\00E1lculo "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113772332370401198)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'pt'
,p_message_text=>unistr('O ficheiro especificado n\00E3o \00E9 um ficheiro XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113762737091401191)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'pt'
,p_message_text=>'O carregamento de dados terminou: %0 linhas processadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763905901401192)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'pt'
,p_message_text=>'O carregamento de dados terminou: %0 linhas processadas com 1 erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764238984401192)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'pt'
,p_message_text=>'O carregamento de dados terminou: %0 linhas processadas com %1 erros.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764052120401192)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'pt'
,p_message_text=>'O carregamento de dados terminou: 1 linha processada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767086169401194)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'pt'
,p_message_text=>'O carregamento de dados terminou: 1 linha processada com erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764132489401192)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'pt'
,p_message_text=>'O carregamento de dados terminou: 1 linha processada sem erro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857750148401260)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'pt'
,p_message_text=>'Coluna de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857865702401260)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'pt'
,p_message_text=>'Coluna de Origem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858698398401260)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'pt'
,p_message_text=>unistr('Formato de Data/N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922065093401306)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'pt'
,p_message_text=>'Falha ao obter o valor de lookup.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113890579802401283)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'pt'
,p_message_text=>unistr('Correspond\00EAncia de Dados/Tabela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858731051401260)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'pt'
,p_message_text=>'Linha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854255919401257)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'pt'
,p_message_text=>unistr('Falha na regra de transforma\00E7\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830528498401240)
,p_name=>'DATE'
,p_message_language=>'pt'
,p_message_text=>'Data'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804629028401221)
,p_name=>'DAY'
,p_message_language=>'pt'
,p_message_text=>'dia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804723073401221)
,p_name=>'DAYS'
,p_message_language=>'pt'
,p_message_text=>'dias'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843420153401249)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'pt'
,p_message_text=>unistr('A depura\00E7\00E3o n\00E3o est\00E1 ativada para esta aplica\00E7\00E3o.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113892213553401285)
,p_name=>'DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805450980401222)
,p_name=>'DELETE'
,p_message_language=>'pt'
,p_message_text=>'apagar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113765691897401193)
,p_name=>'DIAL_PCT'
,p_message_language=>'pt'
,p_message_text=>unistr('Man\00F3metro (Percentagem)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780161064401204)
,p_name=>'DOWNLOAD'
,p_message_language=>'pt'
,p_message_text=>'Descarregar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891307283401284)
,p_name=>'DUP_USER'
,p_message_language=>'pt'
,p_message_text=>'Nome de Utilizador duplicado na lista.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787757198401209)
,p_name=>'EDIT'
,p_message_language=>'pt'
,p_message_text=>'Editar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797156086401216)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('O endere\00E7o de correio eletr\00F3nico "%0" n\00E3o foi encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782234954401205)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta mensagem de correio eletr\00F3nico enviada por %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891564035401284)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'pt'
,p_message_text=>unistr('O Endere\00E7o de Correio Eletr\00F3nico \00E9 demasiado longo. Tem um limite de 240 caracteres.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825118244401236)
,p_name=>'ERROR'
,p_message_language=>'pt'
,p_message_text=>'Erro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854327686401257)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel definir o valor de origem do item da p\00E1gina para a regi\00E3o de renova\00E7\00E3o de p\00E1gina parcial')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816678433401230)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'pt'
,p_message_text=>'Criado Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782582563401206)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'pt'
,p_message_text=>'A Senha Expirou'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113776607118401201)
,p_name=>'FILE_EMPTY'
,p_message_language=>'pt'
,p_message_text=>unistr('O ficheiro est\00E1 vazio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856872736401259)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'pt'
,p_message_text=>'O tamanho do ficheiro carregado era maior que %0 MB. Carregue um ficheiro mais pequeno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784652862401207)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Falha na autentica\00E7\00E3o do utilizador e um ou mais ficheiros n\00E3o foram carregados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784722725401207)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta inst\00E2ncia n\00E3o permite que utilizadores n\00E3o autenticados carreguem ficheiros.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837778190401245)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Ocorreu 1 erro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836999823401245)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Ocorreram %0 erros'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787179543401209)
,p_name=>'FORM_OF'
,p_message_language=>'pt'
,p_message_text=>'%0 de %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821865700401234)
,p_name=>'GO'
,p_message_language=>'pt'
,p_message_text=>'Ir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921670170401306)
,p_name=>'HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('Aux\00EDlio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774039558401199)
,p_name=>'HOME'
,p_message_language=>'pt'
,p_message_text=>unistr('P\00E1gina Principal')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804451812401221)
,p_name=>'HOUR'
,p_message_language=>'pt'
,p_message_text=>'hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804589487401221)
,p_name=>'HOURS'
,p_message_language=>'pt'
,p_message_text=>'horas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788595837401210)
,p_name=>'ICON'
,p_message_language=>'pt'
,p_message_text=>unistr('\00CDcone %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838510875401246)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'pt'
,p_message_text=>unistr('Credencias de Entrada em Sess\00E3o Inv\00E1lidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113938003783401318)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor inv\00E1lido para o par\00E2metro: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833256551401242)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'pt'
,p_message_text=>unistr('Como Defini\00E7\00F5es Por Omiss\00E3o do Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833351642401242)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Como Relat\00F3rio Nomeado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815734636401229)
,p_name=>'IR_ERROR'
,p_message_language=>'pt'
,p_message_text=>'Erro de %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815491056401229)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel calcular a navega\00E7\00E3o na ficha. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793080630401213)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('O relat\00F3rio interativo n\00E3o foi encontrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792470134401213)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A regi\00E3o do relat\00F3rio interativo n\00E3o existe na aplica\00E7\00E3o %0, p\00E1gina %1 e regi\00E3o %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113833173398401242)
,p_name=>'IR_STAR'
,p_message_language=>'pt'
,p_message_text=>'Apenas apresentado para programadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821523357401233)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('A consulta de relat\00F3rio deve ser uma chave exclusiva para identificar cada linha. A chave fornecida n\00E3o pode ser utilizada para esta consulta. Defina uma coluna de chave exclusiva. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821687367401233)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'pt'
,p_message_text=>unistr('A consulta de relat\00F3rio deve ser uma chave exclusiva para identificar cada linha. A chave fornecida n\00E3o pode ser utilizada nesta consulta. Edite os atributos do relat\00F3rio para definir uma coluna de chave exclusiva. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858931151401261)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'pt'
,p_message_text=>'Escolher Ficheiro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858818639401261)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'pt'
,p_message_text=>'Arraste e largue o ficheiro aqui ou'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787446910401209)
,p_name=>'ITEMS'
,p_message_language=>'pt'
,p_message_text=>'Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816852973401230)
,p_name=>'ITEM_VALUE'
,p_message_language=>'pt'
,p_message_text=>'Valor do Item'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831274184401241)
,p_name=>'LABEL'
,p_message_language=>'pt'
,p_message_text=>'Etiqueta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843306140401249)
,p_name=>'LANGUAGE'
,p_message_language=>'pt'
,p_message_text=>unistr('L\00EDngua')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805147262401222)
,p_name=>'LAST'
,p_message_language=>'pt'
,p_message_text=>unistr('\00FAltimo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784521737401207)
,p_name=>'LENGTH'
,p_message_language=>'pt'
,p_message_text=>'Comprimento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837861265401245)
,p_name=>'LOGIN'
,p_message_language=>'pt'
,p_message_text=>unistr('Entrar em Sess\00E3o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876438847401273)
,p_name=>'MANAGE'
,p_message_language=>'pt'
,p_message_text=>'Gerir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113941051870401320)
,p_name=>'MAXIMIZE'
,p_message_language=>'pt'
,p_message_text=>'Maximizar'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804216747401221)
,p_name=>'MINUTE'
,p_message_language=>'pt'
,p_message_text=>'minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804399397401221)
,p_name=>'MINUTES'
,p_message_language=>'pt'
,p_message_text=>'minutos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891753537401284)
,p_name=>'MISSING_AT'
,p_message_language=>'pt'
,p_message_text=>unistr('Falta "@" no Endere\00E7o de Correio Eletr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891990861401284)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'pt'
,p_message_text=>unistr('Aviso: N\00E3o foi definido nenhum modelo de P\00E1gina de Caixa de Di\00E1logo para a p\00E1gina de Caixa de Di\00E1logo %0 na aplica\00E7\00E3o %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891646267401284)
,p_name=>'MISSING_DOT'
,p_message_language=>'pt'
,p_message_text=>unistr('Falta "." no dom\00EDnio do Endere\00E7o de Correio Eletr\00F3nico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840877180401247)
,p_name=>'MODULE'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00F3dulo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797926806401217)
,p_name=>'MONTH'
,p_message_language=>'pt'
,p_message_text=>unistr('M\00EAs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801721683401219)
,p_name=>'MONTHLY'
,p_message_language=>'pt'
,p_message_text=>'Mensal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798086259401217)
,p_name=>'MONTHS'
,p_message_language=>'pt'
,p_message_text=>'meses'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830895664401240)
,p_name=>'MOVE'
,p_message_language=>'pt'
,p_message_text=>'Deslocar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898390182401289)
,p_name=>'MOVE_FROM'
,p_message_language=>'pt'
,p_message_text=>'Deslocar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898436233401289)
,p_name=>'MOVE_TO'
,p_message_language=>'pt'
,p_message_text=>'Deslocar para'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113818063928401231)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro na opera\00E7\00E3o de apagamento de v\00E1rias linhas: linha= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817005084401230)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Deve Ser Utilizador P\00FAblico')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774293337401200)
,p_name=>'NAME'
,p_message_language=>'pt'
,p_message_text=>'Nome'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831093612401240)
,p_name=>'NEW'
,p_message_language=>'pt'
,p_message_text=>'Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797713468401216)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('Pode entrar em sess\00E3o em %0 ao ir para:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797898609401216)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Notifica\00E7\00E3o de Nova Conta de %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921866753401306)
,p_name=>'NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840772115401247)
,p_name=>'NO'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113936025365401316)
,p_name=>'NOBODY'
,p_message_language=>'pt'
,p_message_text=>unistr('ningu\00E9m')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805563181401222)
,p_name=>'NOT'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846386627401251)
,p_name=>'NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817170325401230)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836760797401245)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('n\00E3o foram encontrados dados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845818335401251)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi encontrado nenhum relat\00F3rio atualiz\00E1vel. As opera\00E7\00F5es de atualiza\00E7\00E3o e apagamento de v\00E1rias linhas s\00F3 podem ser efetuadas em fichas tabulares do tipo "Relat\00F3rio Atualiz\00E1vel".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846726444401252)
,p_name=>'OK'
,p_message_language=>'pt'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842407154401249)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'pt'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113939854442401319)
,p_name=>'ORA_06550'
,p_message_language=>'pt'
,p_message_text=>'ORA-06550: linha %0, coluna %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889364328401283)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'pt'
,p_message_text=>unistr('Est\00E1 a utilizar um browser desatualizado. Para obter uma lista de browsers suportados, consulte o Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790736642401211)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi pedido um conjunto de linhas inv\00E1lido. Os dados de origem do relat\00F3rio foram modificados.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810802793401226)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar um n\00FAmero de p\00E1gina v\00E1lido; por exemplo, p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814400387401228)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'pt'
,p_message_text=>'Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814553977401228)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'pt'
,p_message_text=>'Conjunto Seguinte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814646511401229)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113814766313401229)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'pt'
,p_message_text=>'Conjunto Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921792242401306)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'pt'
,p_message_text=>unistr('Selecionar Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852320625401256)
,p_name=>'PASSWORD'
,p_message_language=>'pt'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797010610401216)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'pt'
,p_message_text=>'A sua senha de %0 foi alterada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786882034401209)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha n\00E3o est\00E1 em conformidade com as regras de complexidade da senha do site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785994336401208)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'pt'
,p_message_text=>'A nova senha deve ser diferente da senha antiga em, pelo menos, %0 caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786511663401208)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha n\00E3o deve conter o nome de utilizador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786734302401209)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha cont\00E9m uma palavra simples proibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786605077401209)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha n\00E3o deve conter o nome do espa\00E7o de trabalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785878232401208)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'pt'
,p_message_text=>'A senha deve conter, pelo menos, %0 caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786041244401208)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha deve conter, pelo menos, um car\00E1cter alfab\00E9tico (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786491791401208)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha deve conter, pelo menos, um car\00E1cter alfab\00E9tico em min\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786106607401208)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha deve conter, pelo menos, um car\00E1cter num\00E9rico (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786213237401208)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha deve conter, pelo menos, um car\00E1cter de pontua\00E7\00E3o (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113786396900401208)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha deve conter, pelo menos, um car\00E1cter alfab\00E9tico em mai\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797575191401216)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Notifica\00E7\00E3o de Redefini\00E7\00E3o da Senha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784871856401207)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('A senha n\00E3o pode ser utilizada porque foi utilizada nos \00FAltimos %0 dias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865172314401265)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'pt'
,p_message_text=>'Itens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113865254189401265)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'pt'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842267045401249)
,p_name=>'PERCENT'
,p_message_language=>'pt'
,p_message_text=>'Percentagem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812527416401227)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'pt'
,p_message_text=>'Contacte o administrador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113921993676401306)
,p_name=>'PREVIOUS'
,p_message_language=>'pt'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857390152401259)
,p_name=>'PRINT'
,p_message_language=>'pt'
,p_message_text=>'Imprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841087326401248)
,p_name=>'PRIVILEGES'
,p_message_language=>'pt'
,p_message_text=>unistr('Privil\00E9gios')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810954625401226)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'pt'
,p_message_text=>unistr('Refer\00EAncias de Regi\00F5es')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831128744401241)
,p_name=>'REPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840937573401248)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'pt'
,p_message_text=>unistr('Per\00EDodo de Gera\00E7\00E3o de Relat\00F3rios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922133999401306)
,p_name=>'REPORT_LABEL'
,p_message_language=>'pt'
,p_message_text=>unistr('Relat\00F3rio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841666051401248)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'pt'
,p_message_text=>unistr('Total do Relat\00F3rio')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790868301401212)
,p_name=>'RESET'
,p_message_language=>'pt'
,p_message_text=>unistr('Redefinir Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816787587401230)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Redefinir Pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845779961401251)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'pt'
,p_message_text=>'Redefinir Senha'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822528856401234)
,p_name=>'RESTORE'
,p_message_language=>'pt'
,p_message_text=>'Repor'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113854430421401257)
,p_name=>'RESULTS'
,p_message_language=>'pt'
,p_message_text=>'Resultados'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846828909401252)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Regresse \00E0 aplica\00E7\00E3o.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113847121723401252)
,p_name=>'RIGHT'
,p_message_language=>'pt'
,p_message_text=>'Direita'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876774872401274)
,p_name=>'ROW'
,p_message_language=>'pt'
,p_message_text=>'Linha %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830758591401240)
,p_name=>'ROW_COUNT'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00FAmero de Linhas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113846262938401251)
,p_name=>'SAVE'
,p_message_language=>'pt'
,p_message_text=>'Gravar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842889318401249)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o Alternativo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843242424401249)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'pt'
,p_message_text=>unistr('Descri\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842793190401249)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o Principal')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843557499401249)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'pt'
,p_message_text=>unistr('Existem mais de %0 linhas dispon\00EDveis. Aumente o seletor de linhas para visualizar mais linhas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908904145401297)
,p_name=>'SEARCH'
,p_message_language=>'pt'
,p_message_text=>'Pesquisar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804136075401221)
,p_name=>'SECONDS'
,p_message_language=>'pt'
,p_message_text=>'segundos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842387418401249)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'pt'
,p_message_text=>'Consultar anexo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900096449401290)
,p_name=>'SELECT_ROW'
,p_message_language=>'pt'
,p_message_text=>'Selecionar Linha'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842070246401248)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'pt'
,p_message_text=>unistr('Desativar Modo de Leitor de Ecr\00E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842104054401248)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'pt'
,p_message_text=>unistr('Ativar Modo de Leitor de Ecr\00E3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838482922401246)
,p_name=>'SHOW'
,p_message_language=>'pt'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901866772401292)
,p_name=>'SHOW_ALL'
,p_message_language=>'pt'
,p_message_text=>'Mostrar Tudo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113927987983401310)
,p_name=>'SIGN_IN'
,p_message_language=>'pt'
,p_message_text=>unistr('Entrar em Sess\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113877580388401274)
,p_name=>'SIGN_OUT'
,p_message_language=>'pt'
,p_message_text=>unistr('Sair de sess\00E3o')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831793748401241)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 dias')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838946521401246)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 dias a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831694443401241)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838843035401246)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 horas a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831590055401241)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838763090401246)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 minutos a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831961183401241)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839196229401246)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 meses a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839395746401246)
,p_name=>'SINCE_NOW'
,p_message_language=>'pt'
,p_message_text=>'Agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831480794401241)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 segundos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113838666723401246)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 segundos a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113831884121401241)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839037113401246)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 semanas a partir de agora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113832001936401241)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'pt'
,p_message_text=>unistr('h\00E1 %0 anos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839257680401246)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'pt'
,p_message_text=>'%0 anos a partir de agora'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825523718401236)
,p_name=>'STANDARD'
,p_message_language=>'pt'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841969022401248)
,p_name=>'START_DATE'
,p_message_language=>'pt'
,p_message_text=>unistr('Data de In\00EDcio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782474632401206)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'pt'
,p_message_text=>unistr('Est\00E1 a receber esta mensagem de correio eletr\00F3nico a partir da subscri\00E7\00E3o de relat\00F3rio Interativo criada por %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937110459401317)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'pt'
,p_message_text=>unistr('Subscri\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885249454401280)
,p_name=>'TAB'
,p_message_language=>'pt'
,p_message_text=>'Separador'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804014698401221)
,p_name=>'TITLE'
,p_message_language=>'pt'
,p_message_text=>unistr('T\00EDtulo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787009188401209)
,p_name=>'TODAY'
,p_message_language=>'pt'
,p_message_text=>'Hoje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841580383401248)
,p_name=>'TOTAL'
,p_message_language=>'pt'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788026758401210)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 poss\00EDvel selecionar um m\00E1ximo de %0 colunas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766595356401194)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'pt'
,p_message_text=>'Contrair Todos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766849857401194)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'pt'
,p_message_text=>'Contrair Todos Abaixo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766409672401194)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'pt'
,p_message_text=>'Expandir Todos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766623165401194)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'pt'
,p_message_text=>'Expandir Todos Abaixo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766973642401194)
,p_name=>'TREE.REPARENT'
,p_message_language=>'pt'
,p_message_text=>'Novo pai'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859197762401261)
,p_name=>'TREES'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C1rvores')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113902658826401292)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('Obrigat\00F3rio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113826244982401237)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Autorizado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113873003636401271)
,p_name=>'UNAVAILABLE'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o Dispon\00EDvel')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839721543401247)
,p_name=>'UNKNOWN'
,p_message_language=>'pt'
,p_message_text=>'Desconhecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783369368401206)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Ocorreu um erro de autentica\00E7\00E3o n\00E3o reconhecido.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785366245401208)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'pt'
,p_message_text=>unistr('Se j\00E1 n\00E3o pretende receber mensagens de correio eletr\00F3nico, clique em <a href="%0">anular subscri\00E7\00E3o</a> para gerir a sua subscri\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113782323945401205)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Se j\00E1 n\00E3o pretende receber mensagens de correio eletr\00F3nico, aceda ao seguinte URL para gerir a sua subscri\00E7\00E3o:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113817278867401230)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('tipo de dados n\00E3o suportado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805399764401222)
,p_name=>'UPDATE'
,p_message_language=>'pt'
,p_message_text=>'atualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803925087401221)
,p_name=>'UPDATED'
,p_message_language=>'pt'
,p_message_text=>'Atualizado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810672203401226)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'pt'
,p_message_text=>'O URL pedido foi proibido. Contacte o administrador.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113830632163401240)
,p_name=>'USER'
,p_message_language=>'pt'
,p_message_text=>'Utilizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113852265621401256)
,p_name=>'USERNAME'
,p_message_language=>'pt'
,p_message_text=>'Nome de Utilizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891825491401284)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'pt'
,p_message_text=>unistr('O nome de utilizador \00E9 demasiado longo. Tem um limite de %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837439946401245)
,p_name=>'USERS'
,p_message_language=>'pt'
,p_message_text=>'utilizadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113891418221401284)
,p_name=>'USER_EXISTS'
,p_message_language=>'pt'
,p_message_text=>unistr('O nome de utilizador j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113906198368401295)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'pt'
,p_message_text=>'Imagem do perfil para o utilizador %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793712190401214)
,p_name=>'VALID'
,p_message_language=>'pt'
,p_message_text=>unistr('V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787360041401209)
,p_name=>'VALIDATIONS'
,p_message_language=>'pt'
,p_message_text=>unistr('Valida\00E7\00F5es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843040735401249)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar o valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886403572401280)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar o valor para %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812992780401227)
,p_name=>'VERTICAL'
,p_message_language=>'pt'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805206795401222)
,p_name=>'VIEW'
,p_message_language=>'pt'
,p_message_text=>'visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837503422401245)
,p_name=>'VIEWS'
,p_message_language=>'pt'
,p_message_text=>unistr('visualiza\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843889955401250)
,p_name=>'VIEW_ALL'
,p_message_language=>'pt'
,p_message_text=>'Visualizar Tudo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113825070851401236)
,p_name=>'WARNING'
,p_message_language=>'pt'
,p_message_text=>'Aviso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804819501401221)
,p_name=>'WEEK'
,p_message_language=>'pt'
,p_message_text=>'semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801875076401219)
,p_name=>'WEEKLY'
,p_message_language=>'pt'
,p_message_text=>'Semanal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113804941853401222)
,p_name=>'WEEKS'
,p_message_language=>'pt'
,p_message_text=>'semanas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113843186384401249)
,p_name=>'WELCOME_USER'
,p_message_language=>'pt'
,p_message_text=>'Damos-lhe as boas-vindas: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841327043401248)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi encontrado um valor inv\00E1lido. Verifique os dados introduzidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841477845401248)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi encontrado um valor inv\00E1lido. Verifique os dados introduzidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784485257401207)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi encontrado um valor de data inv\00E1lido. Verifique o formato da data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113841263177401248)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi encontrado um valor num\00E9rico inv\00E1lido. Verifique o formato do n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793354342401213)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi encontrado um valor de indica\00E7\00E3o de data/hora inv\00E1lido. Verifique o formato de indica\00E7\00E3o de data/hora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113815847593401229)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel associar "%0". Utilize aspas para itens com v\00E1rios bytes ou verifique se o item tem 30 bytes ou menos de comprimento. Utilize a sintaxe v() para referenciar itens com mais de 30 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806376677401223)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'pt'
,p_message_text=>unistr('Acesso negado pela verifica\00E7\00E3o de seguran\00E7a de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808844281401224)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Aplica\00E7\00E3o N\00E3o Dispon\00EDvel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807235577401223)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1014 Aplica\00E7\00E3o n\00E3o encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807387179401223)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('aplica\00E7\00E3o=%0  espa\00E7o de trabalho=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807782005401224)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'pt'
,p_message_text=>unistr('O acesso a esta aplica\00E7\00E3o est\00E1 restringido. Tente novamente mais tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807653974401223)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'pt'
,p_message_text=>unistr('O acesso a esta aplica\00E7\00E3o est\00E1 restringido a programadores de aplica\00E7\00F5es. Tente novamente mais tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806896696401223)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-7744 N\00E3o \00E9 poss\00EDvel processar a ramifica\00E7\00E3o para a fun\00E7\00E3o que devolve o URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806701224401223)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-7744 N\00E3o \00E9 poss\00EDvel processar a ramifica\00E7\00E3o para a fun\00E7\00E3o que devolve a p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807037125401223)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1430 A chamada para apresenta\00E7\00E3o a partir do processo da p\00E1gina n\00E3o \00E9 suportada: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808106771401224)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'pt'
,p_message_text=>'ERR-1018 Erro ao limpar cache de passos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806591856401223)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1005 Tipo de c\00E1lculo desconhecido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807467421401223)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1201 A ID da sess\00E3o n\00E3o est\00E1 definida na autentica\00E7\00E3o customizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807565705401223)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('p\00E1gina=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113807125257401223)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-7620 N\00E3o foi poss\00EDvel determinar o espa\00E7o de trabalho para a aplica\00E7\00E3o (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789581145401211)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'pt'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806225475401222)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1802 N\00E3o \00E9 poss\00EDvel encontrar a ID do item "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805904857401222)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1002 N\00E3o \00E9 poss\00EDvel encontrar a ID do item "%0" na aplica\00E7\00E3o "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806002430401222)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro inesperado, n\00E3o \00E9 poss\00EDvel encontrar o nome do item ao n\00EDvel da aplica\00E7\00E3o ou da p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806401651401223)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('J\00E1 est\00E1 na primeira p\00E1gina dos dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113821907288401234)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID do Item (%0) n\00E3o \00E9 um item definido na p\00E1gina atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784033093401207)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'pt'
,p_message_text=>unistr('O item pode ser definido atrav\00E9s da transmiss\00E3o de argumentos \00E0 aplica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784308221401207)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'pt'
,p_message_text=>unistr('(N\00E3o foi fornecida uma soma de verifica\00E7\00E3o)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783830343401207)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'pt'
,p_message_text=>unistr('O item pode ser definido quando acompanhado de uma soma de verifica\00E7\00E3o de "marcador de n\00EDvel de utilizador".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783766148401206)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'pt'
,p_message_text=>unistr('O item pode ser definido quando acompanhado de uma soma de verifica\00E7\00E3o de "marcador de n\00EDvel de aplica\00E7\00E3o".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783974680401207)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('O item pode ser definido quando acompanhado de um soma de verifica\00E7\00E3o de "sess\00E3o".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783604186401206)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'pt'
,p_message_text=>unistr('O item n\00E3o tem prote\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808290619401224)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o existe nenhuma p\00E1gina de aux\00EDlio dispon\00EDvel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113797308170401216)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'pt'
,p_message_text=>unistr('O espa\00E7o de trabalho %0 n\00E3o tem privil\00E9gios para analisar como schema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806637832401223)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1010 O limite de recurs\00E3o do processamento de aceita\00E7\00E3o da ramifica\00E7\00E3o para p\00E1gina foi excedido. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784225699401207)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta p\00E1gina n\00E3o pode ser invocada atrav\00E9s de um URL ou um comando GET ou POST para o procedimento show. Deve ser chamada com um tipo de ramo "Ramificar para P\00E1gina".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113860932095401262)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao tentar gravar valor n\00E3o num\00E9rico no item %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799028004401217)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'pt'
,p_message_text=>unistr('O schema de an\00E1lise "%0" da aplica\00E7\00E3o n\00E3o existe na base de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113799196394401217)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'pt'
,p_message_text=>unistr('As contas no espa\00E7o de trabalho INTERNAL s\00F3 podem ser utilizadas no acesso a &PRODUCT_NAME. <a href="%0">Servi\00E7os de Administra\00E7\00E3o</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805899780401222)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-1029 N\00E3o \00E9 poss\00EDvel armazenar informa\00E7\00F5es da sess\00E3o.  sess\00E3o=%0 item=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808912673401224)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel parar o diagn\00F3stico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113806198349401222)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'pt'
,p_message_text=>'Erro inesperado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816145730401230)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'pt'
,p_message_text=>'Erro em update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809084658401224)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio fornecer a aplica\00E7\00E3o e a p\00E1gina para visualizar o aux\00EDlio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113829522044401239)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('A automatiza\00E7\00E3o n\00E3o foi encontrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810141417401225)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 sess\00F5es eliminadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769433386401196)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel executar o c\00F3digo %0! N\00E3o \00E9 suportado pela base de dados ou n\00E3o \00E9 ativado pelo par\00E2metro de inst\00E2ncia MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113769294824401196)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'pt'
,p_message_text=>unistr('O Mecanismo Multilingue n\00E3o est\00E1 dispon\00EDvel nesta vers\00E3o da base de dados!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790020717401211)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('A matriz da cole\00E7\00E3o de aplica\00E7\00F5es n\00E3o deve ser nula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789834900401211)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'pt'
,p_message_text=>unistr('O n\00FAmero do atributo de membro %0 especificado \00E9 inv\00E1lido. O n\00FAmero do atributo deve ser entre 1 e %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790301518401211)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'pt'
,p_message_text=>unistr('Existe uma cole\00E7\00E3o de aplica\00E7\00F5es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790172571401211)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('O nome da cole\00E7\00E3o n\00E3o pode ser nula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790244957401211)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'pt'
,p_message_text=>unistr('O nome da cole\00E7\00E3o n\00E3o pode ter mais de 255 caracteres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789639594401211)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A cole\00E7\00E3o de aplica\00E7\00F5es %0 n\00E3o existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790404497401211)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'pt'
,p_message_text=>unistr('O cursor ainda n\00E3o est\00E1 aberto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789733339401211)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('A sequ\00EAncia de membros %0 n\00E3o existe na cole\00E7\00E3o de Aplica\00E7\00F5es %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113789922248401211)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('A sequ\00EAncia de membros %0 n\00E3o existe na cole\00E7\00E3o de Aplica\00E7\00F5es "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861749888401263)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('A fun\00E7\00E3o criptogr\00E1fica "%0" n\00E3o \00E9 suportada neste sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915205174401301)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'pt'
,p_message_text=>'Acessibilidade Testada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809674213401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'pt'
,p_message_text=>'Fechar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809743797401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'pt'
,p_message_text=>unistr('Op\00E7\00F5es de Customiza\00E7\00E3o da P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809830454401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor Por Omiss\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809973461401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'pt'
,p_message_text=>'Apresentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810026203401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'pt'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809425281401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'pt'
,p_message_text=>unistr('Selecione as regi\00F5es que pretende incluir nesta p\00E1gina. As regi\00F5es selecionadas podem n\00E3o ser apresentadas se n\00E3o estiver no contexto de aplica\00E7\00E3o adequado ou n\00E3o tiver os privil\00E9gios adequados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809592818401225)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta p\00E1gina n\00E3o \00E9 customiz\00E1vel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915545794401301)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'pt'
,p_message_text=>unistr('Pode personalizar o aspeto desta aplica\00E7\00E3o ao alterar o Estilo do Tema. Selecione um Estilo do Tema na lista abaixo e clique em Aplicar Altera\00E7\00F5es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113916367368401302)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'pt'
,p_message_text=>unistr('Apresenta\00E7\00E3o da Regi\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915413380401301)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'pt'
,p_message_text=>unistr('Utilizar Estilo Por Omiss\00E3o da Aplica\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113915374853401301)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'pt'
,p_message_text=>'Aspeto '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858303542401260)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O \00EDndice de colunas referenciado na agrega\00E7\00E3o %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113761684696401190)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'pt'
,p_message_text=>unistr('A sa\00EDda de dados de CLOB n\00E3o \00E9 suportada para o formato %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858055637401260)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'pt'
,p_message_text=>unistr('A quebra da coluna deve ficar no in\00EDcio da matriz de colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858129544401260)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O \00EDndice de grupo de colunas referenciado em %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113775636215401201)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'pt'
,p_message_text=>unistr('exporta\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113780888397401204)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'pt'
,p_message_text=>unistr('O formato de exporta\00E7\00E3o deve ser XML e utilizar ORDS como Servidor de Impress\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858429749401260)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O \00EDndice de colunas referenciado no destaque %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774141954401200)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'pt'
,p_message_text=>unistr('Formato de Exporta\00E7\00E3o Inv\00E1lido: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113858221347401260)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('O \00EDndice de grupos pai referenciado em %0 n\00E3o existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113883495544401278)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna %1 da tabela %0 \00E9 uma coluna de identidade "GENERATED ALWAYS". Certifique-se de que nenhuma coluna de origem tem correspond\00EAncia com a coluna %1 na caixa de di\00E1logo Configurar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800856026401219)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'pt'
,p_message_text=>unistr('O intervalo de confirma\00E7\00E3o especificado \00E9 demasiado pequeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113800978974401219)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram fornecidas colunas para o carregamento de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802127658401220)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi encontrada nenhuma coluna para o seletor de linhas "%0". Experimente a dete\00E7\00E3o autom\00E1tica ou reveja a estrutura do JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810461061401226)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foram encontradas folhas de c\00E1lculo no ficheiro XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810306749401225)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'pt'
,p_message_text=>unistr('A folha de c\00E1lculo especificada n\00E3o existe no ficheiro XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113790596251401211)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'pt'
,p_message_text=>unistr('A vers\00E3o atual dos dados na base de dados foi alterada desde que o utilizador iniciou o processo de atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792914165401213)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao atualizar as colunas do relat\00F3rio: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897634311401288)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel converter %0 em SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837147718401245)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna %0 com o tipo de dados %1 n\00E3o pode ser convertida em VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844197699401250)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna "%0" especificada para o atributo "%1" n\00E3o foi encontrada na origem de dados!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785492681401208)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'pt'
,p_message_text=>unistr('O tipo de filtro %0 n\00E3o \00E9 suportado para colunas de v\00E1rios valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113901051001401291)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'pt'
,p_message_text=>unistr('Filtro "entre" inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767599978401195)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi especificado um tipo de LDV inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767404077401195)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Tipo de consulta inv\00E1lido. O tipo de consulta deve ser Tabela, Consulta de SQL ou Fun\00E7\00E3o de PL/SQL que devolve uma Consulta de SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837257162401245)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Falha ao analisar a consulta de SQL!',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844208689401250)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('A posi\00E7\00E3o de coluna %0 especificada para o atributo "%1" n\00E3o foi encontrada na instru\00E7\00E3o de SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113766047275401194)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'pt'
,p_message_text=>unistr('Demasiados itens utilizados no filtro de V\00E1rios Valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844017189401250)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'pt'
,p_message_text=>'Nenhuma coluna especificada para o atributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767350542401195)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('O corpo da fun\00E7\00E3o de PL/SQL n\00E3o devolveu um valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113857248774401259)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'pt'
,p_message_text=>unistr('A Origem de Dados REST n\00E3o cont\00E9m uma Opera\00E7\00E3o para processar a a\00E7\00E3o DML pedida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113763286325401192)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'pt'
,p_message_text=>unistr('A convers\00E3o de GeoJSON em SDO_GEOMETRY (coluna %0) n\00E3o est\00E1 dispon\00EDvel nesta base de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764330597401192)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'pt'
,p_message_text=>unistr('A convers\00E3o de SDO_GEOMETRY (coluna %0) n\00E3o \00E9 suportada para origens de dados em XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113771629688401198)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'pt'
,p_message_text=>unistr('O car\00E1cter %0 n\00E3o \00E9 suportado como separador de v\00E1rios valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113898971242401289)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta fun\00E7\00E3o n\00E3o pode ser utilizada num Contexto de Consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113764479722401192)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o correspond\00EAncia do Tipo de Dados da Coluna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767242929401194)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'pt'
,p_message_text=>unistr('Os limites de Associa\00E7\00E3o de ORDS OUT internos foram excedidos. Reduza a quantidade de linhas de DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113845004545401251)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N\00E3o foi poss\00EDvel analisar a resposta de JSON a partir do servidor remoto: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113767154318401194)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'pt'
,p_message_text=>'Tipo de contexto desconhecido ou incorreto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113861696944401263)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('Este tipo de ficheiro n\00E3o \00E9 suportado pelo analisador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816243817401230)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Acesso n\00E3o autorizado (wwv_flow_api.set_credentials n\00E3o definido).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793232597401213)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'pt'
,p_message_text=>unistr('O espa\00E7o de trabalho n\00E3o foi criado porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113793163594401213)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'pt'
,p_message_text=>unistr('O grupo de utilizadores n\00E3o foi criado porque j\00E1 existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803433466401220)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'pt'
,p_message_text=>'Nome de utilizador duplicado encontrado para %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803559583401221)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'pt'
,p_message_text=>'Erro ao carregar utilizadores. Falha no utilizador %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813491122401228)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'pt'
,p_message_text=>'Teria carregado %0 utilizadores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813264628401228)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'pt'
,p_message_text=>'Senha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813306023401228)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'pt'
,p_message_text=>unistr('Privil\00E9gios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813060100401227)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'pt'
,p_message_text=>'Nome de Utilizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889537848401283)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro durante a apresenta\00E7\00E3o do item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809151550401225)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel apresentar o item da p\00E1gina porque a ficha em HTML ainda n\00E3o foi aberta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113774404412401200)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao calcular valor por omiss\00E3o para o item da p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808450298401224)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro no p\00F3s-c\00E1lculo do item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808375157401224)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao calcular valor de origem do item de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788158375401210)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'pt'
,p_message_text=>unistr('Acesso n\00E3o autorizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808683556401224)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'pt'
,p_message_text=>unistr('JavaScript n\00E3o suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808743641401224)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'pt'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113809324245401225)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel inicializar a consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816594148401230)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('A atualiza\00E7\00E3o de %0 n\00E3o \00E9 suportada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113810798792401226)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ID de item inv\00E1lido: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113837008328401245)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o existe aux\00EDlio para este item.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801525905401219)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'pt'
,p_message_text=>unistr('Falha na gera\00E7\00E3o da consulta do diagrama. Verifique a defini\00E7\00F5es Origem e Correspond\00EAncia de Colunas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896376741401288)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'pt'
,p_message_text=>unistr('O anexo com %0 MB excede o tamanho m\00E1ximo do anexo de %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802497598401220)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor inv\00E1lido para o par\00E2metro p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113919898872401305)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'pt'
,p_message_text=>unistr('Excedeu o n\00FAmero m\00E1ximo de mensagens de correio eletr\00F3nico por espa\00E7o de trabalho. Contacte o administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783459257401206)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'pt'
,p_message_text=>unistr('Este procedimento deve ser invocado numa sess\00E3o da aplica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802310291401220)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'pt'
,p_message_text=>unistr('Valor nulo fornecido para o par\00E2metro %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856389278401259)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('O modelo de correio eletr\00F3nico "%0" n\00E3o foi encontrado na aplica\00E7\00E3o %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113932879751401314)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('O par\00E2metro de inst\00E2ncia SMTP_HOST_ADDRESS deve ser definido para enviar correio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802034675401219)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('Deve fornece um destinat\00E1rio da mensagem para enviar correio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113922297482401306)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel estabelecer a liga\00E7\00E3o de SMTP com o servidor de correio eletr\00F3nico configurado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113896467120401288)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'pt'
,p_message_text=>unistr('Chamada de Ajax inv\00E1lida!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787827400401209)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi definida nenhuma fun\00E7\00E3o Ajax para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886848921401281)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi definida nenhuma fun\00E7\00E3o de execu\00E7\00E3o para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787935986401209)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o foi definida nenhuma fun\00E7\00E3o de apresenta\00E7\00E3o para o plug-in %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897333074401288)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o "Capacidades".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897229455401288)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897490050401288)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o de execu\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113897509159401288)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'pt'
,p_message_text=>unistr('O Plug-In da Origem de Dados REST "%0" n\00E3o cont\00E9m uma fun\00E7\00E3o de extra\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785643068401208)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro no c\00F3digo PLSQL gerado durante o processamento do plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792286928401213)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar o valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822894308401234)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'pt'
,p_message_text=>unistr('O tipo de dados %0 n\00E3o pode ser convertido em VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908462587401296)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('A coluna "%0" especificada para o atributo "%1" n\00E3o foi encontrada na instru\00E7\00E3o de SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884727222401279)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'pt'
,p_message_text=>unistr('\00C9 necess\00E1rio especificar um consulta de lista de valores (LDV) ou uma lista de valores Nomeada para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113886345564401280)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'pt'
,p_message_text=>unistr('Foi selecionado um n\00FAmero incorreto de colunas nas consulta de SQL da LDV para %0. Consulte os exemplos para obter instru\00E7\00F5es v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908276255401296)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'pt'
,p_message_text=>'Nenhuma coluna especificada para o atributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937934166401318)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('O valor %0 introduzido para o atributo "%1" n\00E3o \00E9 num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113889814455401283)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>unistr('%0 tem um tipo de dados incorreto na instru\00E7\00E3o de SQL. Column# %1 \00E9 %2, mas era esperado %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113908359667401296)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'pt'
,p_message_text=>'A coluna "%0" especificada para o atributo "%1" tem o tipo de dados %2, mas deveria ter %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113784948984401207)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel encontrar a disposi\00E7\00E3o do relat\00F3rio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844926108401250)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'pt'
,p_message_text=>unistr('A funcionalidade Calcular Soma n\00E3o pode ser utilizada para relat\00F3rios baseados numa Origem de Dados REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113808598796401224)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('ERR-2904 N\00E3o \00E9 poss\00EDvel definir valor do atalho.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113812831090401227)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'pt'
,p_message_text=>'Erro: Tipo de atalho desconhecido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113802830798401220)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel extrair authentication_scheme na aplica\00E7\00E3o %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113876350554401273)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'pt'
,p_message_text=>unistr('A ID do tenant j\00E1 existe para a sess\00E3o atual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113813168163401227)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'pt'
,p_message_text=>unistr('Correio Eletr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937382509401317)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'pt'
,p_message_text=>unistr('Falha na autentica\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113839602789401247)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'pt'
,p_message_text=>unistr('Um ou mais cookies definidos em apex_util.g_request_cookies cont\00EAm um valor inv\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113822109299401234)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'pt'
,p_message_text=>unistr('A resposta do registo de UDDI era inv\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113785760318401208)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'pt'
,p_message_text=>unistr('O URL fornecido n\00E3o devolveu uma documento em WSDL v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113788221731401210)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'pt'
,p_message_text=>unistr('O documento em WSDL cont\00E9m v\00E1rias associa\00E7\00F5es de SOAP. &PRODUCT_NAME. Apenas suporta WSDLs com uma associa\00E7\00E3o de SOAP. Clique em Criar Manualmente Refer\00EAncia de Servi\00E7o Web para continuar a criar uma refer\00EAncia para este servi\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113856674410401259)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'pt'
,p_message_text=>unistr('A resposta do servi\00E7o n\00E3o foi XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937288988401317)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'pt'
,p_message_text=>unistr('O token de acesso de OAuth n\00E3o est\00E1 dispon\00EDvel ou expirou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113900494344401291)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'pt'
,p_message_text=>unistr('Excedeu o n\00FAmero m\00E1ximo de pedidos de servi\00E7o Web por espa\00E7o de trabalho. Contacte o administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113937414743401317)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'pt'
,p_message_text=>unistr('O servidor respondeu com um tipo de token de OAuth n\00E3o suportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787684723401209)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'pt'
,p_message_text=>unistr('O documento em WSDL n\00E3o continha uma associa\00E7\00E3o para SOAP, o que \00E9 obrigat\00F3rio para acrescentar a refer\00EAncia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113783589578401206)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'pt'
,p_message_text=>unistr('Este WSDL requer credenciais de autentica\00E7\00E3o. Forne\00E7a o nome de utilizador e a senha abaixo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113792397495401213)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'pt'
,p_message_text=>unistr('O mecanismo de apresenta\00E7\00E3o n\00E3o conseguiu compreender o documento em WSDL. Clique em Criar Manualmente Refer\00EAncia do Servi\00E7o Web para criar uma refer\00EAncia para este servi\00E7o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113859238224401261)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00E3o \00E9 poss\00EDvel processar a atualiza\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113885083209401279)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'pt'
,p_message_text=>unistr('As colunas de devolu\00E7\00E3o e apresenta\00E7\00E3o da Lista de Valores s\00E3o iguais!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113884932595401279)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'pt'
,p_message_text=>unistr('A Lista de Valores n\00E3o tem uma coluna de devolu\00E7\00E3o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816487829401230)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'pt'
,p_message_text=>'Erro ao extrair valor da coluna: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840495044401247)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'pt'
,p_message_text=>unistr('Os dados da ficha tabular atual s\00E3o demasiado antigos; os dados de origem foram modificados.<br/> Clique <strong><a href="%0">aqui</a></strong> para excluir as altera\00E7\00F5es e carregar novamente os dados a partir da base de dados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798576256401217)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao determinar cadeia de caracteres de pagina\00E7\00E3o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798452956401217)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('n\00E3o \00E9 poss\00EDvel determinar os t\00EDtulos da consulta:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798633963401217)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'pt'
,p_message_text=>unistr('erro ao efetuar substitui\00E7\00F5es do rodap\00E9 do relat\00F3rio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798798715401217)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'falha ao analisar a consulta de SQL:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803771554401221)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'pt'
,p_message_text=>unistr('N\00FAmero m\00EDnimo de linhas pedido: %0, linhas encontradas, mas n\00E3o apresentadas: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801289543401219)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'pt'
,p_message_text=>unistr('a coluna de consulta #%0 (%1) \00E9 inv\00E1lida, as colunas que utilizam HTML necessitam de nomes de pseud\00F3nimos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113816316829401230)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'pt'
,p_message_text=>unistr('Erro ao obter t\00EDtulos da consulta: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798808324401217)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('erro de relat\00F3rio:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113836586296401244)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'pt'
,p_message_text=>'Ordenar por esta coluna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801320436401219)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'pt'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>N\00E3o \00E9 poss\00EDvel analisar a consulta. Verifique a sintaxe da consulta.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840591376401247)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'pt'
,p_message_text=>unistr('Esta ficha cont\00E9m altera\00E7\00F5es n\00E3o gravadas. Prima "OK" para continuar sem gravar as altera\00E7\00F5es. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113844814305401250)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'pt'
,p_message_text=>unistr('O esquema de pagina\00E7\00E3o do relat\00F3rio (%0) n\00E3o \00E9 suportado com a origem de dados escolhida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113801134104401219)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'pt'
,p_message_text=>unistr('a coluna de consulta #%0 (%1) \00E9 inv\00E1lida, utilize o pseud\00F3nimo da coluna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803865688401221)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'pt'
,p_message_text=>'linha(s) %0 - %1 de mais de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113842571826401249)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'pt'
,p_message_text=>'%0 - %1 de mais de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113803628346401221)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'pt'
,p_message_text=>'linha(s) %0 - %1 de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113787550168401209)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'pt'
,p_message_text=>'%0 - %1 de %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798921365401217)
,p_name=>'Y'
,p_message_language=>'pt'
,p_message_text=>'S'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113805069685401222)
,p_name=>'YEAR'
,p_message_language=>'pt'
,p_message_text=>'ano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113798100331401217)
,p_name=>'YEARS'
,p_message_language=>'pt'
,p_message_text=>'anos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(113840616118401247)
,p_name=>'YES'
,p_message_language=>'pt'
,p_message_text=>'Sim'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4495)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4495)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Ambiente de Trabalho'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4495
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4495)
,p_name=>'Mensagens'
,p_alias=>'MESSAGES'
,p_step_title=>'Mensagens'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
