prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4543
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4543 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4543
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103298885403778')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ro'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4543)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113352'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4543)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4543)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4543)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4543)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4543)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4543)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.ro'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4543)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4543)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4543)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4543)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4543)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4543)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.ro'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4543)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4543)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4543)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4543)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4543)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4543)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.ro'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4543)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4543)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.ro'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4543)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4543)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.ro'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4543)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4543)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.ro'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4543)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4543)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4543)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.ro'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4543
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4543)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4543)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4543)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4543
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4543)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4543
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4543)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4543
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4543)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4543
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4543)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4543
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4543)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4543
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4543
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4543)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4543)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4543)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4543)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4543)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4543)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4543)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4543)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4543)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4543)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4543)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4543)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4543)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4543)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4543)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4543)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4543)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4543)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4543)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4543)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4543)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4543)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4543
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4543)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4543)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4543)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4543)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4543)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4543
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4543)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4543
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4543)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4543
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4543)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4543
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4543)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4543
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4543)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4543
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4543)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4543)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4543)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4543)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4543)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4543)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4543)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4543)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4543)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4543
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4543)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4543)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4543)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4543)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4543)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4543)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4543)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4543
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4543)
,p_page_name=>'winlov'
,p_page_title=>unistr('Dialog c\0103utare')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('C\0103utare')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\00CEnchidere')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\00CEnainte &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \00EEnapoi')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">R\00E2ndurile #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4543
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4543)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4543
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4543)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4543)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4543)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4543)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4543)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4543)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4543)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4543)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4543)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4543)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4543)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4543)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4543)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4543)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4543)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4543)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4543)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4543)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4543)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4543)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4543)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4543)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4543)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4543)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4543)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4543)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4543)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4543)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4543)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4543)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4543)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4543)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4543)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4543)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4543)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4543)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4543)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4543)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4543)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4543)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4543)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4543)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4543)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4543)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4543)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4543)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4543)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4543)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4543)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4543)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4543)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4543)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4543)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4543)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4543)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4543)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4543)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4543)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4543)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4543)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4543)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4543)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4543)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4543)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4543)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4543)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4543)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4543)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4543)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4543)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4543)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4543)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4543)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4543)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4543)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4543)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4543)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4543)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4543)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4543)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4543)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4543)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4543)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4543)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4543)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4543)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4543)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4543)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4543)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4543)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4543)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4543)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4543)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4543)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4543)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4543)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4543)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4543)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4543)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4543)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4543)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4543)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4543)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4543)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4543)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4543)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4543)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4543)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4543)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4543)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4543)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4543)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4543)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4543)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4543)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4543)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4543)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4543)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4543)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4543)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4543)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4543)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4543)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4543)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4543)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4543)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4543)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4543)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4543)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4543)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4543)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4543)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4543)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4543)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4543)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4543)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4543)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4543)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4543)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4543)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4543)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4543)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4543)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4543)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4543)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4543)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4543)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4543)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4543)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4543)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4543)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4543)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4543)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4543)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4543)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4543)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4543)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4543)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4543)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4543)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4543)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4543)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4543)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4543)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4543)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4543)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4543)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4543)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4543)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4543)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4543)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4543)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153691207401488)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'ro'
,p_message_text=>'Coloana %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140793847401478)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'ro'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140606665401478)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'ro'
,p_message_text=>'Nume de utilizator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197919820401520)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'ro'
,p_message_text=>'Acces interzis'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157671022401491)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'ro'
,p_message_text=>'Contul dvs. %0 a fost creat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143296564401480)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'ro'
,p_message_text=>'Contul este blocat.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133148885401473)
,p_name=>'AM_PM'
,p_message_language=>'ro'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267519266401569)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'ro'
,p_message_text=>'Comutare %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275632726401575)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'ro'
,p_message_text=>'(Activ)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245106087401554)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Apelul Ajax a returnat eroarea de server %0 pentru %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175961210401504)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'ro'
,p_message_text=>unistr('Aliasul de aplica\0163ie "%0" nu poate fi convertit la un ID de aplica\0163ie unic.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176073764401504)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Aplica\0163ia cu aliasul "%0" nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165696912401497)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1816 Eroare nea\015Fteptat\0103 la convertirea aliasului de aplica\0163ie p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258570301401563)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Suma de control a aplica\0163iei furnizeaz\0103 un mod simplu de a stabili dac\0103 aceea\015Fi aplica\0163ie este implementat\0103 \00EEn spa\0163iile de lucru. Pute\0163i compara aceast\0103 sum\0103 de control pentru a stabili dac\0103 exist\0103 o potrivire. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151440360401486)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea func\0163iei de autentificare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136892403401476)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea func\0163iei de autentificare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300398317401593)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'ro'
,p_message_text=>unistr('Numele de tenant returnat de Oracle Cloud Identity Management nu este autorizat pentru domeniul!<br/><a href="&LOGOUT_URL.">Reconecta\0163i-v\0103</a> \015Fi specifica\0163i un nume de tenant autorizat sau modifica\0163i adresa de URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134532243401474)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'ro'
,p_message_text=>unistr('Contul dvs. "%0" nu are privilegiile de dezvoltare necesare (DB_DEVELOPER sau DB_ADMINISTRATOR)<br/>pentru spa\0163iul de lucru "%1"! <a href="&LOGOUT_URL.">Reconecta\0163i-v\0103</a> dup\0103 acordarea privilegiilor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133611337401473)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'ro'
,p_message_text=>unistr('Numele de tenant returnat de Oracle Cloud Identity Management nu este autorizat pentru spa\0163iul de lucru curent!<br/><a href="&LOGOUT_URL.">Reconecta\0163i-v\0103</a> \015Fi specifica\0163i un nume de tenant autorizat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134630726401474)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'ro'
,p_message_text=>unistr('Din motive de securitate, rularea aplica\0163iilor din acest spa\0163iu de lucru prin domeniul din URL nu este permis\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151139688401486)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Cere\0163i DBA s\0103 ruleze $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151019358401486)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'ro'
,p_message_text=>unistr('Pachetul SYS.DBMS_LDAP nu exist\0103 sau este nevalid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150986277401486)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea edit\0103rii func\0163iei utilizator LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151220317401486)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea autentific\0103rii LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152071203401487)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare \00EEn argumentul p_flow_page pentru procedura login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151686022401486)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'ro'
,p_message_text=>unistr('p_session nevalid \00EEn wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199535047401521)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Argument cu format gre\015Fit pentru wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151732399401486)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'ro'
,p_message_text=>unistr('Nume de utilizator nul trecut c\0103tre procedura de conectare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140557231401478)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'ro'
,p_message_text=>unistr('A\015Ftepta\0163i <span id="apex_login_throttle_sec">%0</span> secunde \00EEnainte de reconectare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141841301401479)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEncercarea de conectare a fost blocat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197332878401519)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Autentificarea "%0" nu a fost g\0103sit\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142138394401479)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'ro'
,p_message_text=>'ID-ul grupului de securitate este nul.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151502783401486)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la executarea procesului de post-autentificare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151379682401486)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la procesarea procesului de pre-autentificare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152509775401487)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Redeschide\0163i adresa URL \00EEn acela\015Fi browser \00EEn care a\0163i ini\0163iat cererea de resetare a parolei. Dac\0103 face\0163i clic pe URL-ul de resetare a parolei \015Fi sunte\0163i redirec\0163ionat c\0103tre pagina de conectare, ini\0163ia\0163i din nou resetarea parolei \015Fi l\0103sa\0163i'),
'browserul deschis.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297821336401591)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'ro'
,p_message_text=>unistr('URL resetare parol\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134852269401474)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'ro'
,p_message_text=>'Grupul de consumatori %0 pentru managerul de resurse nu a fost acordat pentru %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134937170401474)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'ro'
,p_message_text=>unistr('Utiliza\0163i DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP pentru acordarea privilegiului lips\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162900417401495)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea func\0163iei de santinel\0103 pentru sesiune.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163070095401495)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea func\0163iei de verificare pentru sesiune.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163298943401495)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Cere\0163i administratorului %0 s\0103 configureze motorul pentru conectarea unic\0103 SSO pentru Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172797400401502)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 ilegal \00EEn tokenul %1 returnat de SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151912329401487)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'ro'
,p_message_text=>unistr('Edita\0163i schema de autentificare \015Fi ad\0103uga\0163i numele aplica\0163iei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172471181401501)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'ro'
,p_message_text=>'Apelant ilegal pentru procedura %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172682557401502)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'ro'
,p_message_text=>unistr('Sesiune de aplica\0163ie nevalid\0103 \00EEn tokenul URLC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172256436401501)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare \00EEn portal_sso_redirect: lipsesc informa\0163iile de \00EEnregistrare pentru aplica\0163ie: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163151870401495)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'ro'
,p_message_text=>unistr('Pachetul WWSEC_SSO_ENABLER_PRIVATE nu exist\0103 sau este nevalid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114151811412401486)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut g\0103si numele aplica\0163iei partenere \00EEnregistrate din schema de autentificare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172369223401501)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnregistra\0163i aceast\0103 aplica\0163ie conform descrierii din ghidul de instalare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163302640401495)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea autentific\0103rii SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272766680401573)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'ro'
,p_message_text=>'URL neautorizat: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162712946401494)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea autentific\0103rii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134722989401474)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'ro'
,p_message_text=>unistr('Spa\0163iul de lucru "%0" este inactiv. Contacta\0163i administratorul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135114828401474)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'ro'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141554569401479)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Acces interzis de verificarea de securitate a aplica\0163iei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141639924401479)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'ro'
,p_message_text=>'Acces interzis de verificarea de securitate a paginii'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141754963401479)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea autoriza\0163iei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205157911401525)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'ro'
,p_message_text=>unistr('Generat cu %0 utiliz\00E2nd %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205252554401525)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'ro'
,p_message_text=>'Ador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263041886401566)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'ro'
,p_message_text=>'Descriere eveniment'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262812053401566)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'ro'
,p_message_text=>unistr('Data final\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263156998401566)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'ro'
,p_message_text=>'ID eveniment'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262722919401566)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'ro'
,p_message_text=>unistr('Data ini\0163ial\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262981291401566)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'ro'
,p_message_text=>'Titlu eveniment'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153508464401488)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare de con\0163inut pentru suma de control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153485299401488)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare de format pentru suma de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217479515401534)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'ro'
,p_message_text=>unistr('Copiat \00EEn clipboard.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217180657401534)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'ro'
,p_message_text=>unistr('Acest browser nu accept\0103 copierea folosind un buton sau meniu. \00CEncerca\0163i Ctrl+C sau Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205679524401525)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnchidere \00EEn\015Ftiin\0163are')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261666985401565)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'ro'
,p_message_text=>'Contrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256159911401561)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'ro'
,p_message_text=>'Curent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256069268401561)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'ro'
,p_message_text=>unistr('Ini\0163ial')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260258683401564)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie o culoare valid\0103. Exemplu: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255996284401561)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Alege\0163i o culoare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256211998401561)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'ro'
,p_message_text=>'Modificare format de culoare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295484932401590)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103 de valori')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295515932401590)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'ro'
,p_message_text=>unistr('Deschidere list\0103 pentru: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275700799401575)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'ro'
,p_message_text=>'(Finalizat)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168014363401498)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'ro'
,p_message_text=>unistr('Contacta\0163i administratorul aplica\0163iei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182490264401509)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Contacta\0163i administratorul aplica\0163iei.'),
'Detalii despre acest incident sunt disponibile prin ID-ul de remediere "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260561012401564)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'ro'
,p_message_text=>unistr('Corecta\0163i erorile \00EEnainte de salvare.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206599754401526)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Au fost g\0103site 0% coresponden\0163e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206490632401526)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a g\0103sit niciun rezultat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276206901401576)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'ro'
,p_message_text=>'Stadiu curent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260948783401565)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Fi\015Fierul specificat \00EEn articolul %0 nu exist\0103 \00EEn APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249469183401557)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'ro'
,p_message_text=>unistr('Versiunea curent\0103 a datelor din baza de date s-a schimbat de c\00E2nd utilizatorul a ini\0163iat procesul de actualizare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218581575401535)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu \00EEnc\0103rca\0163i')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265581083401568)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('Se preproceseaz\0103 eroarea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265311130401568)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'ro'
,p_message_text=>unistr('Inserare r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279407033401578)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Secven\0163\0103: ac\0163iune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265457096401568)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Actualizare r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206992810401526)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'ro'
,p_message_text=>'Calendar pop-up: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129592612401470)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129672977401470)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265767277401568)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 aib\0103 o valoare.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265628232401568)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie o dat\0103 valid\0103, de exemplu: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133226439401473)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie \00EEntre %0 \015Fi %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133364266401473)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie egal cu sau ulterior %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133454116401473)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie anterioar\0103 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210445806401529)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# este ulterioar\0103 datei maxime specificate %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210822266401529)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'ro'
,p_message_text=>'#LABEL# nu corespunde formatului %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210337799401529)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# este anterioar\0103 datei minime specificate %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210501574401529)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# nu este \00EEn intervalul valid de la %0 la %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210773791401529)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# nu este \00EEn intervalul de ani valid \00EEntre %0 \015Fi %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260835729401565)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'ro'
,p_message_text=>'Anulare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288076202401584)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnchidere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290079685401586)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260679571401565)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'ro'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260793123401565)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'ro'
,p_message_text=>'Salvare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166926948401497)
,p_name=>'APEX.ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134374720401474)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('A survenit urm\0103toarea eroare la executarea unui callback pentru tratarea erorilor: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143083752401480)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'A survenit o eroare la generarea paginii de eroare: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135064457401474)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare intern\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274899694401575)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Contacta\0163i administratorul.'),
'Detalii despre acest incident sunt disponibile prin ID-ul de remediere "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269121318401571)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'ro'
,p_message_text=>unistr('Baza de date este deschis\0103 pentru acces read-only.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299765724401593)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'ro'
,p_message_text=>unistr('ORA-28353: E\015Fec la deschiderea walletului. Datele aplica\0163iei nu sunt accesibile momentan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269265322401571)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Ne pare r\0103u, aceast\0103 pagin\0103 nu este disponibil\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136732549401475)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'ro'
,p_message_text=>unistr('Informa\0163ii tehnice (vizibile numai pentru dezvoltatori)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232866571401545)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'ro'
,p_message_text=>'Mesaj de eroare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246765775401555)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'ro'
,p_message_text=>unistr('Format a\015Fteptat: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213444326401531)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'ro'
,p_message_text=>unistr('Utilizatorul este deja \00EEn lista de control al accesului')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213329786401531)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'ro'
,p_message_text=>unistr('Confirma\0163i ad\0103ugarea urm\0103torilor utilizatori %0 la <strong>%1</strong> lista de control al accesului.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213810056401531)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'ro'
,p_message_text=>unistr('Exist\0103 un utilizator duplicat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213522435401531)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'ro'
,p_message_text=>unistr('Lipse\015Fte simbolul @ \00EEn adresa de e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213651995401531)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'ro'
,p_message_text=>unistr('Caracter punct (.) lips\0103 \00EEn adresa de e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213744947401531)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'ro'
,p_message_text=>'Numele de utilizator este prea lung'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214023984401531)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'ro'
,p_message_text=>unistr('Numai utilizatorii defini\0163i \00EEn lista de control al accesului pentru aplica\0163ie pot accesa aceast\0103 aplica\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214139839401531)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoare nea\015Fteptat\0103 pentru setarea controlului accesului: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213935160401531)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'ro'
,p_message_text=>unistr('To\0163i utilizatorii autentifica\0163i pot accesa aceast\0103 aplica\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256766836401562)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'ro'
,p_message_text=>'Dezactivat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256695612401562)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'ro'
,p_message_text=>'Activat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256999781401562)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'ro'
,p_message_text=>'%0: este dezactivat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256882181401562)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'ro'
,p_message_text=>'%0: este activat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256539784401562)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'ro'
,p_message_text=>'Neidentificat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249629390401557)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('Desc\0103rcare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206121243401526)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'ro'
,p_message_text=>'Filtru aplicat %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247212313401555)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'ro'
,p_message_text=>'Aplicare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132195424401472)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Diagram\0103 cu bare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259990182401564)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'ro'
,p_message_text=>'Altele'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132278872401472)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'ro'
,p_message_text=>unistr('Diagram\0103 disc')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258696403401563)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131980293401472)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247771262401555)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'ro'
,p_message_text=>'Golire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247870236401555)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'ro'
,p_message_text=>'Golire toate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247966474401556)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'ro'
,p_message_text=>'Golire %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265131602401568)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana %1, referin\0163\0103 pentru fa\0163eta %0, nu este disponibil\0103 sau este neautorizat\0103.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122345385401465)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i filtrele de afi\015Fat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204377257401524)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'ro'
,p_message_text=>'%0 rezultate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204428928401525)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'ro'
,p_message_text=>'%0 selectate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207037072401526)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'ro'
,p_message_text=>'Filtre curente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123853596401466)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103 de filtre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263667560401567)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoarea limit\0103 distinct\0103 (%0) a fost dep\0103\015Fit\0103 pentru fa\0163eta %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249281271401556)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Fa\0163eta %0 nu este acceptat\0103 pentru coloanele DATE sau TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247373787401555)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'ro'
,p_message_text=>'Filtru %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247444498401555)
,p_name=>'APEX.FS.GO'
,p_message_language=>'ro'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248867627401556)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'ro'
,p_message_text=>'egal cu %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132933655401473)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'ro'
,p_message_text=>unistr('Con\0163ine %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132641870401473)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'ro'
,p_message_text=>'Mai mare ca %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132769601401473)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'ro'
,p_message_text=>'Mai mare sau egal cu %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132448175401472)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'ro'
,p_message_text=>'Mai mic ca %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132564465401473)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'ro'
,p_message_text=>'Mai mic sau egal cu %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132883500401473)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEncepe cu %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135310994401475)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Tipul de date %0 (%1) nu este acceptat pentru fa\0163eta c\00E2mpului de intrare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125597289401468)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'ro'
,p_message_text=>unistr('Fa\0163etele cu valori multiple necesit\0103 baze de date cu versiunea 12.2 sau mai noi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249022653401556)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu au fost furnizate coloane de c\0103utare pentru fa\0163eta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122421458401465)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'ro'
,p_message_text=>'Mai multe filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204544003401525)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnceput de interval')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248505199401556)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'ro'
,p_message_text=>'%0 la %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248688966401556)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'ro'
,p_message_text=>'Peste %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248707248401556)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'ro'
,p_message_text=>'Sub %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204666036401525)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'ro'
,p_message_text=>'Final de interval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267485053401569)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Articolul LOV #%2 ("%1") pentru fa\0163eta de interval %0 este nevalid (separatorul "|" lipse\015Fte).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248982462401556)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'ro'
,p_message_text=>unistr('Intrarea manual\0103 nu este acceptat\0103 momentan pentru fa\0163eta %0, deoarece coloana este DATE sau TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248271493401556)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'ro'
,p_message_text=>'la'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132004557401472)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Eliminare diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201138110401522)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'ro'
,p_message_text=>'Resetare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247600094401555)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247525224401555)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248453041401556)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'ro'
,p_message_text=>'- Selectare -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131847399401472)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248084965401556)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare mai pu\0163ine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248182193401556)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare mai multe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114248328389401556)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 stele \015Fi mai multe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206036952401526)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'ro'
,p_message_text=>'Sugestii filtru'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249162259401556)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Fa\0163eta c\00E2mp de text %0 este acceptat\0103 \00EEn prezent numai pentru coloanele NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122251912401465)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r total de r\00E2nduri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265284015401568)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Tipul de date %0 (%1) nu este acceptat pentru c\0103utarea cu fa\0163ete.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257182900401562)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Accesa\0163i eroarea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214705194401532)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>'Agregare.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222333377401537)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'ro'
,p_message_text=>unistr('Restr\00E2ngere \00EEntrerupere control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214820825401532)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEntrerupere control.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222228538401537)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'ro'
,p_message_text=>unistr('Exindere \00EEntrerupere control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300944730401594)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222016414401537)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 r\00E2nduri \015Fterse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292410857401587)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'ro'
,p_message_text=>'Duplicare identitate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211725297401530)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'ro'
,p_message_text=>'Primul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215053448401532)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>'Antet grup.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214917124401532)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>'Antet.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211817976401530)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'ro'
,p_message_text=>'Ultimul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231842027401544)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcare mai multe r\00E2nduri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211503318401530)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215121229401532)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nduri pagin\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211932779401530)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'ro'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212014452401530)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'ro'
,p_message_text=>'%0 - %1 din %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268090595401570)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'ro'
,p_message_text=>'Selectarea paginii'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211626207401530)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292289963401587)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292391386401587)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'ro'
,p_message_text=>'Modificat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300729938401594)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nd %0, Coloan\0103 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300811442401594)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nd %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292133072401587)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Eters')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215330246401532)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'ro'
,p_message_text=>unistr('Antet r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210903463401529)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'ro'
,p_message_text=>'%0 celule selectate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212131036401530)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 r\00E2nduri selectate')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252438135401559)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'ro'
,p_message_text=>'Selectare tot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222131044401537)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'ro'
,p_message_text=>'Pagina %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215243963401532)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215433261401532)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'ro'
,p_message_text=>'Sortate ascendent %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215519080401532)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'ro'
,p_message_text=>'Sortate descendent %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211015829401529)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare ascendent\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211377123401529)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare ascendent\0103 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211166207401529)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare descendent\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211444772401530)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare descendent\0103 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114211207414401529)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'ro'
,p_message_text=>unistr('F\0103r\0103 sortare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221985185401537)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'ro'
,p_message_text=>'Total %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148308805401484)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('Cererea HTTP c\0103tre "%0" a e\015Fuat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289629181401586)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare list\0103 gril\0103 %0 coloane %1 r\00E2nduri. Utiliza\0163i tastele s\0103geat\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221897358401537)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i r\00E2ndurile din lista %0. Utiliza\0163i tastele s\0103ge\0163i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300526439401593)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Gril\0103 interactiv\0103 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208600671401528)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Ac\0163iuni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209636377401528)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209544162401528)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294051295401589)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'ro'
,p_message_text=>'Agregare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279515458401578)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'ro'
,p_message_text=>'Agregare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281263346401579)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'ro'
,p_message_text=>'Toate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237630575401548)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Toate coloanele de text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238835327401549)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'ro'
,p_message_text=>unistr('Alternativ\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239996309401550)
,p_name=>'APEX.IG.AND'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Fi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259341414401564)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rare distinct\0103 aproximativ\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295032720401589)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rare distinct\0103 aproximativ\0103 general\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278124524401577)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'ro'
,p_message_text=>unistr('Zon\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280088300401578)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'ro'
,p_message_text=>'Ascendent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238907509401549)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'ro'
,p_message_text=>'Autorizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294141117401589)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'ro'
,p_message_text=>'Automat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259742112401564)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'ro'
,p_message_text=>'Medie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294796552401589)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Medie general\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277673288401577)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Titlu ax\0103 etichet\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277852194401577)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r de zecimale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277785726401577)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Titlu ax\0103 valoare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283822079401581)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'ro'
,p_message_text=>'Culoare de fundal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278282837401577)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Bar\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234205636401546)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEntre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285077535401582)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'ro'
,p_message_text=>'Ambele'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278302106401577)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Bul\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209836275401528)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'ro'
,p_message_text=>'Anulare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239883682401550)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'ro'
,p_message_text=>unistr('Concordan\0163\0103 majuscule/minuscule')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295684923401590)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'ro'
,p_message_text=>unistr('(Concordan\0163\0103 majuscule/minuscule)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266583801401569)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'ro'
,p_message_text=>unistr('Modific\0103ri salvate')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210272463401529)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'ro'
,p_message_text=>'Modificare vizualizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240945406401551)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237456311401548)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Interogarea dvs. dep\0103\015Fe\015Fte num\0103rul maxim de %0 puncte de date per diagram\0103. Aplica\0163i un filtru pentru a reduce num\0103rul de \00EEnregistr\0103ri din interogarea dvs. de baz\0103.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208580050401527)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215863601401533)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'ro'
,p_message_text=>'Golire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277193319401576)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnchidere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284089817401581)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'ro'
,p_message_text=>'Culori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260119518401564)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'ro'
,p_message_text=>'Previzualizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239210137401549)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208771628401528)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Coloane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285858335401583)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Scop coloan\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239341813401549)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'ro'
,p_message_text=>'Complex'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208934463401528)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'ro'
,p_message_text=>'Compute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234825021401546)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'ro'
,p_message_text=>unistr('con\0163ine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241161357401551)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEntrerupere control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215658192401533)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'ro'
,p_message_text=>unistr('Copiere \00EEn clipboard')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215702342401533)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'ro'
,p_message_text=>unistr('Copiere \00EEn jos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259199256401563)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259228433401564)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rare distinct\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294932598401589)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rare distinct\0103 general\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294836326401589)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r general')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292545124401588)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'ro'
,p_message_text=>'Creare %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237806654401548)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'ro'
,p_message_text=>'Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285663762401583)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip de date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285298588401582)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Dat\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266343033401569)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoare nevalid\0103 pentru dat\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235545020401547)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'ro'
,p_message_text=>'zile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238556779401549)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Set\0103ri prestabilite')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238327142401549)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip prestabilit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209743189401528)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286822988401583)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'ro'
,p_message_text=>unistr('Sigur \015Fterge\0163i acest raport?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242922324401552)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241775585401551)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere r\00E2nduri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280142628401579)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'ro'
,p_message_text=>'Descendent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240684232401550)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'ro'
,p_message_text=>'Detaliu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208280098401527)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare detalii'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268891243401570)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Direc\0163ie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240310749401550)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'ro'
,p_message_text=>'Dezactivat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234916050401546)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'ro'
,p_message_text=>unistr('nu con\0163ine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235135757401546)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'ro'
,p_message_text=>unistr('nu \00EEncepe cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278424197401577)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'ro'
,p_message_text=>'Cercuri concentrice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241300054401551)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'ro'
,p_message_text=>unistr('Desc\0103rcare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140012030401478)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'ro'
,p_message_text=>'Numai date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287824316401584)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'ro'
,p_message_text=>'Selectare format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152623277401487)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'ro'
,p_message_text=>unistr('Formatul de desc\0103rcare %0 nu este activat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280801753401579)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'ro'
,p_message_text=>'Duplicare agregare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280954068401579)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'ro'
,p_message_text=>unistr('Duplicare \00EEntrerupere control')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242862079401552)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nd duplicat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241668000401551)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('Duplicare r\00E2nduri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209347901401528)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'ro'
,p_message_text=>'Editare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279949677401578)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Editare diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291419748401587)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Editare grup dup\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287443000401584)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'ro'
,p_message_text=>unistr('Copiere invizibil\0103 (BCC)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287643931401584)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'ro'
,p_message_text=>'Mesaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287301033401584)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'ro'
,p_message_text=>'Copiere (cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287035148401584)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'ro'
,p_message_text=>'E-mail trimis.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287537591401584)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'ro'
,p_message_text=>'Subiect'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287243654401584)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'ro'
,p_message_text=>'Destinatar (la)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240015165401550)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'ro'
,p_message_text=>'Activat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233230032401545)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'ro'
,p_message_text=>'egal cu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286485148401583)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'ro'
,p_message_text=>'Exemplu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240141496401550)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'ro'
,p_message_text=>'Expresie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286375849401583)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252375159401559)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'ro'
,p_message_text=>unistr('Fi\015Fier preg\0103tit. Se \00EEncepe desc\0103rcarea.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114215945085401533)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'ro'
,p_message_text=>'Umplere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217080558401534)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Umplere selec\0163ie cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216981528401533)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'ro'
,p_message_text=>'Selectare umplere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208867186401528)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'ro'
,p_message_text=>'Filtru'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239477810401550)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'ro'
,p_message_text=>'Filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294450968401589)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'ro'
,p_message_text=>'Filtrare...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280343698401579)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'ro'
,p_message_text=>'Primul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209008215401528)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'ro'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237970296401548)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'ro'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284945420401582)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'ro'
,p_message_text=>unistr('Masc\0103 de formatare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286738395401583)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'ro'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286658146401583)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'ro'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199440801401521)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'ro'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138762072401477)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'ro'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242548833401552)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnghe\0163are')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240241966401550)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'ro'
,p_message_text=>unistr('Func\0163ii \015Fi operatori')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278505214401577)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'ro'
,p_message_text=>unistr('P\00E2lnie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259029742401563)
,p_name=>'APEX.IG.GO'
,p_message_language=>'ro'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233889915401546)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'ro'
,p_message_text=>unistr('mai mare dec\00E2t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233937601401546)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'ro'
,p_message_text=>'mai mare sau egal cu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240546967401550)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'ro'
,p_message_text=>unistr('Gril\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208003355401527)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare gril\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281147937401579)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'ro'
,p_message_text=>'Grup'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240774879401550)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Grupare dup\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208339608401527)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare grupare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285542023401583)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Tip condi\0163ie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284404372401582)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'ro'
,p_message_text=>'Antet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284681380401582)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'ro'
,p_message_text=>'Aliniere antet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294366889401589)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289811091401586)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pute\0163i introduce, actualiza \015Fi \015Fterge date direct din aceast\0103 gril\0103 interactiv\0103.</p>'),
'',
unistr('<p>Introduce\0163i un r\00E2nd nou f\0103c\00E2nd clic pe butonul Ad\0103ugare r\00E2nd.</p>'),
'',
unistr('<p>Edita\0163i datele existente f\0103c\00E2nd dublu clic pe o anumit\0103 celul\0103. Pentru lucr\0103ri de editare mai mari, face\0163i clic pe Editare pentru a intra \00EEn modul de editare. \00CEn modul de editare pute\0163i face clic simplu sau folosi\0163i tastatura pentru a edita anumit')
||'e celule.</p>',
'',
unistr('<p>Utiliza\0163i meniul Modific\0103ri pentru a duplica \015Fi \015Fterge r\00E2nduri. Pentru a activa meniul Modific\0103ri, utiliza\0163i casetele de selectare pentru a selecta unul sau mai multe r\00E2nduri.</p>'),
'',
unistr('<p>Duplica\0163i un r\00E2nd selectat f\0103c\00E2nd clic pe meniul Modific\0103ri \015Fi select\00E2nd duplicare r\00E2nduri. \015Eterge\0163i un r\00E2nd selectat f\0103c\00E2nd clic pe meniul Modific\0103ri \015Fi select\00E2nd \015Etergere r\00E2nd.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291913687401587)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'ro'
,p_message_text=>unistr('Capacit\0103\0163i de editare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292007013401587)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>O gril\0103 interactiv\0103 prezint\0103 un set de date \00EEntr-un raport personalizat care permite c\0103utarea. Pute\0163i efectua numeroase opera\0163ii pentru a limita \00EEnregistr\0103rile returnate \015Fi a modifica modul \00EEn care datele sunt afi\015Fate.</p>'),
'',
unistr('<p>Utiliza\0163i c\00E2mpul de c\0103utare pentru filtrarea \00EEnregistr\0103rilor returnate. Face\0163i clic pe Ac\0163iuni pentru a accesa numeroasele op\0163iuni pentru modificarea machetei raportului, sau utiliza\0163i meniurile Antet coloan\0103 pe coloanele afi\015Fate.</p>'),
'',
unistr('<p>Utiliza\0163i set\0103ri raport pentru a salva personaliz\0103rile \00EEntr-un raport. Pute\0163i, de asemenea, s\0103 desc\0103rca\0163i datele din raport \00EEntr-un fi\015Fier extern sau s\0103 trimite\0163i datele prin e-mail c\0103tre dvs. \015Fi al\0163ii.</p>'),
'',
unistr('<p>Pentru a afla mai multe consulta\0163i "Utilizare grile interactive" \00EEn <em>Ghidul utilizatorului final Oracle Application Express</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291780217401587)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'ro'
,p_message_text=>unistr('Prezentare general\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289793456401586)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pute\0163i personaliza grila interactiv\0103 pentru a afi\015Fa datele \00EEn diferite moduri utiliz\00E2nd capacit\0103\0163ile \00EEnglobate.</p>'),
'',
unistr('<p>Utiliza\0163i meniurile Antet de coloan\0103 sau meniul Ac\0163iuni pentru a stabili ce coloane s\0103 afi\015Fa\0163i, \00EEn ce secven\0163\0103 \015Fi coloanele \00EEnghe\0163ate. Pute\0163i \015Fi s\0103 defini\0163i diferite filtre de date \015Fi s\0103 sorta\0163i datele returnate.</p>'),
'',
unistr('<p>Utiliza\0163i butonul Vizualizare (adiacent c\00E2mpului de c\0103utare) pentru a accesa alte vizualiz\0103ri de date ce au putut fi definite de dezvoltatorul aplica\0163iei. Pute\0163i \015Fi s\0103 crea\0163i o diagram\0103 sau s\0103 vizualiza\0163i o diagram\0103 existent\0103.</p>  '),
'',
unistr('<p><em>Not\0103: face\0163i clic pe <strong>Asisten\0163\0103</strong> din dialogurile grilei interactive pentru a ob\0163ine informa\0163ii detaliate pentru func\0163ia selectat\0103.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291811250401587)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'ro'
,p_message_text=>unistr('Capacit\0103\0163i de raportare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241574662401551)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 gril\0103 interactiv\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288621687401585)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru agregarea coloanelor. Valorile agregate sunt afi\015Fate \00EEn partea de jos a datelor sau, dac\0103 sunt definite controale de \00EEntrerupere, sub fiecare \00EEntrerupere.</p>'),
'',
unistr('<p><strong>List\0103 de agregare</strong><br>'),
unistr('Lista de agregare afi\015Feaz\0103 agreg\0103rile definite. Dezactiva\0163i o agregare existent\0103 prin deselectare.<br>'),
unistr('Face\0163i clic pe Ad\0103ugare ( &plus; ) pentru a crea o agregare nou\0103 sau pe \015Etergere ( &minus; ) pentru a elimina o agregare existent\0103.</p>'),
'',
unistr('<p><strong>Set\0103ri de agregare</strong><br>'),
unistr('Utiliza\0163i formularul din dreapta pentru a defini agregarea.<br>'),
unistr('Selecta\0163i numele coloanei \015Fi tipul de agregare.<br>'),
unistr('Op\0163ional, introduce\0163i o sugestie pentru agregare.<br>'),
unistr('Dac\0103 a\0163i definit un control de \00EEntrerupere, select\00E2nd <strong>Afi\015Fare valoare general\0103</strong> se afi\015Feaz\0103 media general\0103, totalul sau valoarea similar\0103 sub date.</p>'),
'',
unistr('<p><em>Not\0103: accesa\0163i dialogul de agregare din meniul Ac\0163iuni sau f\0103c\00E2nd clic pe antetul de coloan\0103 \015Fi sum\0103 ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290830880401586)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 agregare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289319692401585)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a defini o diagram\0103 ce se afi\015Feaz\0103 ca vizualizare de date separat\0103.<br>'),
unistr('Selecta\0163i un tip de diagram\0103 \015Fi atributele diagramei.</p>'),
unistr('<p><strong>Atribute diagram\0103</strong></br>'),
unistr('Atributele de diagram\0103 disponibile variaz\0103 \00EEn func\0163ie de tipul de diagram\0103.</p>'),
'<p>',
'<ul>',
unistr('  <li>Selecta\0163i coloana ce con\0163ine valoarea pentru atributul:'),
'    <ul>',
unistr('      <li>Etichet\0103 - Textul pentru fiecare punct de date.</li>'),
'      <li>Valoare - Datele de distribuit.</li>',
unistr('      <li>Serii - Pentru definirea interog\0103rii dinamice cu mai multe serii.</li>'),
unistr('      <li>Deschidere - Pre\0163ul de deschidere zilnic pentru ac\0163iuni (numai tipul Ac\0163iuni).</li>'),
unistr('      <li>\00CEnchidere - Pre\0163ul de \00EEnchidere zilnic pentru ac\0163iuni (numai tipul Ac\0163iuni).</li>'),
unistr('      <li>Superior - Valoarea superioar\0103 (numai tipurile Interval \015Fi Ac\0163iuni).</li>'),
unistr('      <li>Inferior - Valoarea inferioar\0103 (numai tipurile Interval \015Fi Ac\0163iuni).</li>'),
unistr('      <li>Volum - Volumul zilnic de ac\0163iuni (numai tipul Ac\0163iuni).</li>'),
unistr('      <li>\0162int\0103 - Valoarea \0163int\0103 (numai tipul P\00E2lnie).</li>'),
unistr('      <li>X - Valoare ax\0103 x (numai tipurile Sfer\0103 \015Fi Dispersie).</li>'),
unistr('      <li>Y - Valoare ax\0103 y (numai tipurile Sfer\0103 \015Fi Dispersie).</li>'),
unistr('      <li>Z - L\0103\0163ime bar\0103 sau raz\0103 sfer\0103 (numai tipurile Bar\0103, Sfer\0103 \015Fi Interval).</li>'),
'    </ul>',
'  </li>',
'  <li>Orientare - Vertical sau orizontal.</li>',
unistr('  <li>Agregare - Selecta\0163i modul de agregare pentru valorile asociate ale diagramei.</li>'),
unistr('  <li>Stiv\0103 - Specific\0103 dac\0103 elementele de date sunt stivuite.</li>'),
unistr('  <li>Sortare dup\0103 - Sortare dup\0103 etichet\0103 sau valori.'),
'    <ul>',
unistr('      <li>Direc\0163ie - Sortarea valorilor \00EEn ordine ascendent\0103 sau descendent\0103.</li>'),
unistr('      <li>Nule - Specific\0103 modul de sortare a \00EEnregistr\0103rilor cu valori nule comparativ cu cele cu valori non nule.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Num\0103r de zecimale</li>'),
unistr('  <li>Titlu ax\0103 etichet\0103</li>'),
unistr('  <li>Titlu ax\0103 valoare</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291294606401587)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288338637401585)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a selecta ce coloane vor fi afi\015Fate \015Fi \00EEn ce ordine.</p>'),
'',
unistr('<p>Ascunde\0163i o coloan\0103 prin deselectare.<br>'),
unistr('Reordona\0163i coloanele f\0103c\00E2nd clic pe Mutare \00EEn sus ( &uarr; ) sau Mutare \00EEn jos ( &darr; ).<br>'),
unistr('Utiliza\0163i selectorul derulant pentru a lista Toate coloanele, Coloanele afi\015Fate sau Coloanele neafi\015Fate.</p>'),
'',
unistr('<p>Op\0163ional, utiliza\0163i formularul pentru a specifica l\0103\0163imea minim\0103 a unei coloane \00EEn pixeli.</p>'),
'',
unistr('<p><em>Not\0103: de asemenea, pute\0163i reordona coloanele afi\015Fate f\0103c\00E2nd clic pe cursorul de glisare (de la \00EEnceputul antetului coloanei) \015Fi tr\0103g\00E2nd coloana spre st\00E2nga sau dreapta. Pute\0163i modifica l\0103\0163imea coloanei pentru coloanele afi\015Fate \015Fi prin selectar')
||unistr('ea separatorului coloanei, \00EEntre anteturi, \015Fi deplasarea acestuia spre st\00E2nga sau dreapta.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291153168401587)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 pt. coloane')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288766268401585)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a defini coloane suplimentare pe baza calculelor matematice \015Fi func\0163ionale efectuate pe coloanele existente.</p>'),
'',
unistr('<p><strong>List\0103 calcule</strong><br>'),
unistr('Lista de calcule afi\015Feaz\0103 calculele definite. Dezactiva\0163i un calcul existent prin deselectare.<br>'),
unistr('Face\0163i clic pe Ad\0103ugare ( &plus; ) pentru a ad\0103uga un calcul nou sau pe \015Etergere ( &minus; ) pentru a elimina un calcul existent.</p>'),
'',
unistr('<p><strong>Set\0103ri de calcul</strong><br>'),
unistr('Utiliza\0163i formularul pentru a defini calculul.<br>'),
unistr('Introduce\0163i detaliile coloanei cum ar fi antet, etichet\0103 \015Fi set\0103rile de selectare pentru aliniere.<br> '),
unistr('Utiliza\0163i expresia textarea pentru a introduce coloanele \015Fi func\0163iile asociate pentru calcul.<br>'),
unistr('Selecta\0163i tipul de date adecvat \015Fi, op\0163ional, o masc\0103 de formatare pentru noua coloan\0103.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290748719401586)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 Compute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289097397401585)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a defini un control de \00EEntrerupere pe una sau mai multe coloane.</p>'),
'',
unistr('<p><strong>List\0103 controale de \00EEntrerupere</strong><br>'),
unistr('Lista de controale de \00EEntrerupere afi\015Feaz\0103 controalele de \00EEntrerupere definite. Dezactiva\0163i o coloan\0103 dintr-un control de \00EEntrerupere prin deselectare.<br>'),
unistr('Face\0163i clic pe Ad\0103ugare ( &plus; ) pentru a ad\0103uga o nou\0103 coloan\0103 \00EEn controlul de \00EEntrerupere sau pe \015Etergere ( &minus; ) pentru a elimina o coloan\0103 existent\0103 din controlul de \00EEntrerupere.<br>'),
unistr('Pentru reordonarea coloanelor, face\0163i clic pe Mutare \00EEn sus ( &uarr; ) sau Mutare \00EEn jos ( &darr; ) pentru a muta coloana selectat\0103 \00EEn sus \015Fi jos fa\0163\0103 de alte coloane.</p>'),
'',
unistr('<p><strong>Set\0103ri pentru controale de \00EEntrerupere</strong><br>'),
unistr('Utiliza\0163i formularul pentru a defini o coloana \00EEn controlul de \00EEntrerupere.<br>'),
unistr('Selecta\0163i o coloan\0103 din controlul de \00EEntrerupere, direc\0163ia de sortare \015Fi modul de ordonare pentru coloane nule (coloane f\0103r\0103 valori).</p>'),
'',
unistr('<p><em>Not\0103: la vizualizarea unei grile interactive, pute\0163i defini un control de \00EEntrerupere f\0103c\00E2nd clic pe un Antet de coloan\0103 \015Fi select\00E2nd pictograma control de \00EEntrerupere.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290499724401586)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 \00EEntrerupere control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289218376401585)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a desc\0103rca toate r\00E2ndurile curente \00EEntr-un fi\015Fier extern. Fi\015Fierul va con\0163ine numai coloanele afi\015Fate \00EEn prezent, utiliz\00E2nd orice filtre \015Fi sort\0103ri aplicate datelor.</p>'),
'',
unistr('<p>Selecta\0163i formatul de fi\015Fier \015Fi face\0163i clic pe Desc\0103rcare.<br>'),
unistr('Not\0103: fi\015Fierul CSV nu va include formatarea de text cum ar fi agreg\0103rile \015Fi controalele de \00EEntrerupere.</p>'),
'',
unistr('<p>Pentru a trimite fi\015Fierul prin e-mail, selecta\0163i Trimitere e-mail \015Fi introduce\0163i detaliile pentru e-mail (destinatar, subiect \015Fi mesaj).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290206054401586)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 desc\0103rcare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288490301401585)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a configura filtrele de date ce limiteaz\0103 r\00E2ndurile returnate.</p>'),
'',
unistr('<p><strong>List\0103 filtre</strong><br>'),
unistr('Lista filtrelor afi\015Feaz\0103 filtrele definite. Dezactiva\0163i un filtru existent prin deselectare.<br>'),
unistr('Face\0163i clic pe Ad\0103ugare ( &plus; ) pentru a crea un filtru nou, sau pe \015Etergere ( &minus; ) pentru a elimina un filtru existent.</p>'),
'',
unistr('<p><strong>Set\0103ri filtru</strong><br>'),
unistr('Utiliza\0163i acest formular pentru a defini propriet\0103\0163ile filtrului.<br>'),
unistr('Selecta\0163i tipul de filtru adecvat:<br>'),
unistr('&nbsp;&nbsp;&nbsp;R\00E2nd - filtrare pentru un termen \00EEn orice coloan\0103 filtrabil\0103.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Coloan\0103 - filtrare pentru o anumit\0103 coloan\0103 cu un operator \015Fi o valoare specificate.</p>'),
'',
unistr('<p><em>Not\0103: la vizualizarea grilei interactive, pute\0163i defini filtrele de r\00E2nd tast\00E2nd direct \00EEn c\00E2mpul de c\0103utare. Face\0163i clic pe Selectare coloane de c\0103utat pentru a limita c\0103utarea la o anumit\0103 coloan\0103. Alternativ, deschide\0163i un meniu Antet de co')
||unistr('loan\0103 \015Fi selecta\0163i o valoare pentru a crea un filtru de coloan\0103.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291010032401586)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 filtrare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288839040401585)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a vizualiza datele a\015Fa cum au existat la un moment anterior.</p>'),
unistr('<p>Introduce\0163i num\0103rul de minute din trecut pentru executarea interog\0103rii flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290658014401586)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 flashback')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291313917401587)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 grupare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288911318401585)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a eviden\0163ia r\00E2ndurile sau coloanele de date pe baza condi\0163iilor introduse.</p>'),
'',
unistr('<p><strong>List\0103 eviden\0163ieri</strong><br>'),
unistr('Lista de eviden\0163ieri afi\015Feaz\0103 eviden\0163ierile definite. Dezactiva\0163i o eviden\0163iere existent\0103 prin deselectare.<br>'),
unistr('Face\0163i clic pe Ad\0103ugare ( &plus; ) pentru a ad\0103uga o eviden\0163iere nou\0103 sau pe \015Etergere ( &minus; ) pentru a elimina o eviden\0163iere existent\0103.</p>'),
'',
unistr('<p><strong>Set\0103ri de eviden\0163iere</strong><br>'),
unistr('Utiliza\0163i formularul pentru a defini set\0103rile de eviden\0163iere.<br>'),
unistr('Introduce\0163i numele, selecta\0163i r\00E2ndul sau coloan \015Fi selecta\0163i codurile de culoare HTML pentru fundal \015Fi text.<br>'),
unistr('Selecta\0163i <strong>Tipul de condi\0163ie</strong> adecvat pentru a eviden\0163ia anumite date:<br>'),
unistr('&nbsp;&nbsp;&nbsp;R\00E2nd - eviden\0163ierea termenului din orice coloan\0103.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Coloan\0103 - eviden\0163iere \00EEn cadrul unei anumite coloane pe baza operatorului \015Fi valorii specificate.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290508386401586)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 eviden\0163iere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289126994401585)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a salva modific\0103rile f\0103cute pentru macheta \015Fi configura\0163ia grilei curente.<br>'),
unistr('Dezvoltatorii de aplica\0163ii pot defini multiple machete de raportare alternative. Acolo unde este permis, dvs. \015Fi al\0163i utilizatori finali pute\0163i salva un raport ca Public, acest lucru f\0103c\00E2nd raportul disponibil pentru to\0163i ceilal\0163i utilizatori din gri')
||unistr('l\0103. De asemenea, pute\0163i salva un raport ca un raport Privat pe care doar dvs. \00EEl pute\0163i vizualiza.</p>'),
unistr('<p>Selecta\0163i din tipurile disponibile \015Fi introduce\0163i un nume pentru raportul salvat.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290314020401586)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Asisten\0163\0103 raport'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288528382401585)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utiliza\0163i acest dialog pentru a seta ordinea de afi\015Fare.</p>'),
'',
unistr('<p><strong>List\0103 de sortare</strong><br>'),
unistr('Dialogul de sortare afi\015Feaz\0103 o list\0103 a regulilor de sortare configurate.<br>'),
unistr('Face\0163i clic pe Ad\0103ugare ( &plus; ) pentru a crea o coloan\0103 de sortare sau pe \015Etergere ( &minus; ) pentru a elimina o coloan\0103 de sortare.<br>'),
unistr('Face\0163i clic pe Mutare \00EEn sus ( &uarr; ) \015Fi Mutare \00EEn jos ( &darr; ) pentru a muta coloana de sortare selectat\0103 \00EEn sus \015Fi jos fa\0163\0103 de celelalte coloane de sortare.</p>'),
'',
unistr('<p><strong>Set\0103ri de sortare</strong><br>'),
unistr('Selecta\0163i o coloan\0103 de sortare, direc\0163ia de sortare \015Fi modul de ordonare pentru coloane nule (coloane f\0103r\0103 valori).</p>'),
'',
unistr('<p><em>Not\0103: datele pot fi sortate dup\0103 coloanele ce nu sunt afi\015Fate, totu\015Fi, nu toate coloanele se pot sorta.</em><br>'),
unistr('<em>Coloanele afi\015Fate pot fi sortate prin ap\0103sarea s\0103ge\0163ilor sus (ascendent) sau jos (descendent) de la cap\0103tul anteturilor de coloan\0103. Pentru a ad\0103uga o coloan\0103 ulterioar\0103 la o sortare existent\0103, \0163ine\0163i ap\0103sat\0103 tasta Shift \015Fi face\0163i clic pe s\0103geata ')
||'sus sau jos.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290951308401586)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 sortare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114290120367401586)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 abonament')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242436824401552)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'ro'
,p_message_text=>'Ascundere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209218898401528)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'ro'
,p_message_text=>unistr('Eviden\0163iere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277250401401576)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Ridicat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278067901401577)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'ro'
,p_message_text=>'Orizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235426464401547)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'ro'
,p_message_text=>'ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240457414401550)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'ro'
,p_message_text=>unistr('Pictogram\0103')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208197147401527)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare pictogram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233622348401545)
,p_name=>'APEX.IG.IN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242015778401551)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'ro'
,p_message_text=>unistr('Setare inactiv\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242184009401551)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Set\0103ri inactive')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249730980401557)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('A survenit o eroare intern\0103 la procesarea cererii de gril\0103 interactiv\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145545364401482)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Filtrul de coloan\0103 de tipul "%0" nu este acceptat pentru coloana "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289943678401586)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'ro'
,p_message_text=>unistr('Format de dat\0103 nevalid')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264158815401567)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Grila interactiv\0103 nu accept\0103 definirea unui filtru pe coloana %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264085374401567)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este un tip de filtru valid pentru definirea unui filtru de gril\0103 interactiv\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150605436401486)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'ro'
,p_message_text=>unistr('Format de num\0103r nevalid')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292651596401588)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'ro'
,p_message_text=>unistr('Setare nevalid\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292720813401588)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Set\0103ri nevalide')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283779036401581)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Tipul de sortare a fost setat la %0, dar nu a fost selectat\0103 nicio coloan\0103 pentru %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281022633401579)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoare nevalid\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276149735401576)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu se afi\015Feaz\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234413236401546)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn ultimele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234617087401546)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn urm\0103torul')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233522799401545)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>'nu este gol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233414838401545)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'ro'
,p_message_text=>'este gol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284527882401582)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Etichet\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276526423401576)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Etichet\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280498856401579)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'ro'
,p_message_text=>'Ultimul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223747318401538)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'ro'
,p_message_text=>'Ultima zi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223964881401539)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultima or\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224429401401539)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'ro'
,p_message_text=>'Ultimul minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223479054401538)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultima lun\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223504036401538)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultima s\0103pt\0103m\00E2n\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223669803401538)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'ro'
,p_message_text=>'Ultimele %0 zile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223830798401538)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'ro'
,p_message_text=>'Ultimele %0 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224505707401539)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'ro'
,p_message_text=>'Ultimele %0 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224307514401539)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'ro'
,p_message_text=>'Ultimele %0 luni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224235630401539)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultimele %0 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223244309401538)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'ro'
,p_message_text=>'Ultimii %0 ani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223389999401538)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'ro'
,p_message_text=>'Ultimul an'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284722882401582)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'ro'
,p_message_text=>'Aliniere celule'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284880093401582)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'ro'
,p_message_text=>'Utilizare grup pentru'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234023432401546)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'ro'
,p_message_text=>unistr('mai mic dec\00E2t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234110819401546)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'ro'
,p_message_text=>'mai mic sau egal cu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278679792401577)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'ro'
,p_message_text=>'Linie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278794542401578)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'ro'
,p_message_text=>unistr('Linie cu zon\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285112978401582)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'ro'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277346539401577)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Redus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287729379401584)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'ro'
,p_message_text=>unistr('Separa\0163i adresele multiple prin virgule')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235261273401547)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'ro'
,p_message_text=>unistr('se potrive\015Fte cu expresia logic\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259641111401564)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'ro'
,p_message_text=>'Maxim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295237630401589)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'ro'
,p_message_text=>'Maxim general'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259861484401564)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'ro'
,p_message_text=>unistr('Median\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295349025401590)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Median\0103 general\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259590447401564)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'ro'
,p_message_text=>'Minim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235358016401547)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'ro'
,p_message_text=>'minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260333763401564)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'ro'
,p_message_text=>unistr('Minute \00EEn urm\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295189195401589)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'ro'
,p_message_text=>'Minim general'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235758970401547)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'ro'
,p_message_text=>'luni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242321913401552)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Datele con\0163in mai mult de %0 r\00E2nduri dep\0103\015Find maximul permis. Aplica\0163i filtre suplimentare pentru a vizualiza rezultatele.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269036889401571)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul static pentru regiune trebuie s\0103 fie specificat deoarece pagina con\0163ine mai multe grile interactive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238476249401549)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'ro'
,p_message_text=>'Nume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238666257401549)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport denumit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222635018401538)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Ziua urm\0103toare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222441905401537)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('Ora urm\0103toare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224603187401539)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('Minutul urm\0103tor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222996671401538)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Luna urm\0103toare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222870749401538)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('S\0103pt\0103m\00E2na urm\0103toare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222735661401538)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 zile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114222524143401537)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 ore')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224778643401539)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224029195401539)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 luni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224176610401539)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223122417401538)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103torii %0 ani')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114223091569401538)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Anul urm\0103tor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234372690401546)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn afara')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233355101401545)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'ro'
,p_message_text=>'nu este egal cu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299576993401593)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Regiunea cu ID-ul %0 nu este o regiune cu gril\0103 interactiv\0103 sau nu exist\0103 \00EEn aplica\0163ia %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233783445401546)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'ro'
,p_message_text=>unistr('nu este \00EEn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234509439401546)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('nu este \00EEn ultimele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114234790398401546)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('nu este \00EEn urm\0103torul')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242284947401552)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu au fost g\0103site date')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280262413401579)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'ro'
,p_message_text=>'Valori nule'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285385293401582)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoare numeric\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280592243401579)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'ro'
,p_message_text=>'Oprit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280672727401579)
,p_name=>'APEX.IG.ON'
,p_message_language=>'ro'
,p_message_text=>'Pornit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232561182401545)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum 1 minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288217837401584)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'ro'
,p_message_text=>'Deschidere selector de culori: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277011699401576)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Deschidere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239532735401550)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'ro'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276409236401576)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'ro'
,p_message_text=>'Orientare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278869275401578)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'ro'
,p_message_text=>'Disc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114240896601401551)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'ro'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114208451808401527)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114288140550401584)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'ro'
,p_message_text=>unistr('Separa\0163i valorile cu "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114278937683401578)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'ro'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284252170401582)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'ro'
,p_message_text=>'Centru'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284365510401582)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'ro'
,p_message_text=>unistr('Sf\00E2r\015Fit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114284125927401582)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'ro'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238782252401549)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'ro'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239036075401549)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255539185401561)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137752344401476)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'ro'
,p_message_text=>'Includere etichete de accesibilitate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136422059401475)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ro'
,p_message_text=>'Peisaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136513830401475)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ro'
,p_message_text=>'Portret'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136316996401475)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ro'
,p_message_text=>unistr('Orientare pagin\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136265947401475)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ro'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136108066401475)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ro'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137862005401476)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ro'
,p_message_text=>'Personalizat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135925977401475)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ro'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135823579401475)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ro'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136093941401475)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ro'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135706032401475)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ro'
,p_message_text=>unistr('Dimensiune pagin\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125958848401468)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'ro'
,p_message_text=>'Golire text formatat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279026716401578)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'ro'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279180305401578)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'ro'
,p_message_text=>'Interval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289437630401585)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'ro'
,p_message_text=>'Reactualizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243075668401552)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('Reactualizare r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241819974401551)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('Reactualizare r\00E2nduri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247032541401555)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Regiunea de gril\0103 interactiv\0103 nu exist\0103 \00EEn aplica\0163ia %0, pagina %1 \015Fi regiunea %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209927960401528)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'ro'
,p_message_text=>'Eliminare %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238175435401549)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298774139401592)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'ro'
,p_message_text=>unistr('Raport \015Fters')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298432631401592)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'ro'
,p_message_text=>unistr('Raport alternativ salvat pentru to\0163i utilizatorii')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298314765401592)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'ro'
,p_message_text=>unistr('Raport prestabilit salvat pentru to\0163i utilizatorii')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298659290401592)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'ro'
,p_message_text=>'Raport privat salvat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298541349401592)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'ro'
,p_message_text=>unistr('Raport public salvat pentru to\0163i utilizatorii')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114247154508401555)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Grila interactiv\0103 salvat\0103 cu numele %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232430364401545)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'ro'
,p_message_text=>'Raportare date de acum %0 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232312273401544)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'ro'
,p_message_text=>'Raportare date de acum 1 minut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172050291401501)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Raportul de gril\0103 interactiv nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291633254401587)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'ro'
,p_message_text=>'Raport - Editare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246977417401555)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Grila interactiv\0103 salvat\0103 cu ID-ul %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114291572850401587)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'ro'
,p_message_text=>'Raport - Salvare ca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210023466401529)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Set\0103ri raport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299669049401593)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Grila interactiv\0103 salvat\0103 cu ID-ul static %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294527638401589)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209123244401528)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'ro'
,p_message_text=>'Resetare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243101663401552)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'ro'
,p_message_text=>unistr('Anulare modific\0103ri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241943455401551)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('Restabilire r\00E2nduri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239183431401549)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238073425401549)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nduri pe pagin\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299298339401592)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Ac\0163iuni r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300495855401593)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'ro'
,p_message_text=>unistr('Ac\0163iuni pentru r\00E2ndul %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114209444014401528)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'ro'
,p_message_text=>'Salvare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252113095401559)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'ro'
,p_message_text=>'salvat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207661766401527)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'ro'
,p_message_text=>'Rapoarte salvate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207725615401527)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182247668401509)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Exist\0103 deja un raport salvat cu denumirea %0. Introduce\0163i un nume nou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207847819401527)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'ro'
,p_message_text=>'Privat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207941946401527)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'ro'
,p_message_text=>'Public'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294207632401589)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'ro'
,p_message_text=>'Salvare ca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241253648401551)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Salvare set\0103ri raport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279290657401578)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'ro'
,p_message_text=>'Dispersie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207588357401527)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286511560401583)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare: toate coloanele de text')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207484659401527)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285743121401583)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare: text integral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232269847401544)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare pentru ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275842410401575)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'ro'
,p_message_text=>'- Selectare -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216077027401533)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'ro'
,p_message_text=>'Selectare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268716339401570)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i 1 r\00E2nd \00EEn regiunea principal\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207305296401527)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i coloanele pentru c\0103utare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298996714401592)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Ac\0163iuni selectare')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216249534401533)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare celul\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216185963401533)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare r\00E2nduri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287164025401584)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'ro'
,p_message_text=>'Trimitere ca e-mail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279633587401578)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Serie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205388559401525)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257959272401563)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare valoare general\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242747005401552)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare pentru un singur r\00E2nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241044740401551)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'ro'
,p_message_text=>'Sortare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279771464401578)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare dup\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299356145401592)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Pute\0163i defini o singur\0103 sortare per coloan\0103.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299149468401592)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'ro'
,p_message_text=>'Modificare meniu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114280746413401579)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'ro'
,p_message_text=>unistr('Stiv\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235077258401546)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEncepe cu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279301032401578)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'ro'
,p_message_text=>'Stoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200397460401522)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Extindere l\0103\0163imi coloane')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114241439934401551)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'ro'
,p_message_text=>'Abonament'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114259461823401564)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'ro'
,p_message_text=>unistr('Sum\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300645057401593)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'ro'
,p_message_text=>unistr('Gril\0103 interactiv\0103. Raport: %0, Vizualizare: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114294625969401589)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Sum\0103 general\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277590098401577)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Destina\0163ie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283973895401581)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'ro'
,p_message_text=>'Culoare text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210135578401529)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'ro'
,p_message_text=>'Comutare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257884774401563)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'ro'
,p_message_text=>'Sugestie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114238201619401549)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114242636668401552)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'ro'
,p_message_text=>unistr('Dezghe\0163are')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239748444401550)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'ro'
,p_message_text=>'Unitate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286994680401584)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'ro'
,p_message_text=>unistr('Exist\0103 modific\0103ri nesalvate. Continua\0163i?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114239643244401550)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'ro'
,p_message_text=>'Valoare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276616664401576)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Valoare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281514194401580)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>'Este obligatorie o valoare.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266400123401569)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'ro'
,p_message_text=>'Valoare (fusul orar nu poate fi modificat)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285454270401582)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'ro'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277987258401577)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'ro'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237700564401548)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275901104401576)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114277484659401577)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Volum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235670591401547)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276080405401576)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'ro'
,p_message_text=>unistr('L\0103\0163ime minim\0103 coloan\0103 (pixeli)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226830295401541)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 este \00EEntre %1 \015Fi %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226551636401540)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 con\0163ine %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226682225401540)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu con\0163ine %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204728458401525)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEncepe cu %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225333756401540)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 egal cu %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225579175401540)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 mai mare ca %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225631789401540)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 mai mare sau egal cu %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226354896401540)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 este \00EEn %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227575757401541)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimele %1 zile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227397977401541)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimele %1 ore')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227141099401541)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimele %1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227960468401541)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimele %1 luni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227788121401541)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimele %1 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228180520401542)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimii %1 ani')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227438866401541)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultima zi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227267502401541)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultima or\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227094177401541)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimul minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227868029401541)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultima lun\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114227657559401541)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultima s\0103pt\0103m\00E2n\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228078882401541)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn ultimul an')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229926722401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarele %1 zile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229794919401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarele %1 ore')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229521787401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarele %1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230345740401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarele %1 luni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230189456401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarele %1 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230590820401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103tori %1 ani')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229803508401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarea zi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229638125401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarea or\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229461465401542)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103torul minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230268949401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarea lun\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230048652401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103toarea s\0103pt\0103m\00E2n\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230444936401543)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEn urm\0103torul an')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226013129401540)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>'%0 nu este gol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225944550401540)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'ro'
,p_message_text=>'%0 este gol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225771540401540)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 mai mic ca %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225878479401540)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 mai mic sau egal cu %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226192471401540)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 la fel ca %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226769942401541)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 se potrive\015Fte cu expresia logic\0103 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232677173401545)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226997845401541)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este \00EEntre %1 \015Fi %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225484873401540)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 nu este egal cu %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226447545401540)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este \00EEn %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228700117401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimele %1 zile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228540549401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimele %1 ore')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228315076401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimele %1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229155317401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimele %1 luni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228919161401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimele %1 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229362729401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimii %1 ani')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228625673401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultima zi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228414061401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultima or\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228263007401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimul minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229047085401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultima lun\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114228825748401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultima s\0103pt\0103m\00E2n\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114229220594401542)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn ultimul an')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231132331401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarele %1 zile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230929466401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarele %1 ore')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230731746401543)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarele %1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231508625401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarele %1 luni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231350030401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarele %1 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231705891401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103torii %1 ani')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231003361401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarea zi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230876397401543)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarea or\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114230600949401543)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103torul minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231479564401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarea lun\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231243868401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103toarea s\0103pt\0103m\00E2n\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231677201401544)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu \00EEn urm\0103torul an')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114226279398401540)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'ro'
,p_message_text=>'%0 diferit de %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233169222401545)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 \00EEncepe cu %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276798102401576)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235836198401547)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'ro'
,p_message_text=>'ani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276875155401576)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276968565401576)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'ro'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114285911578401583)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'ro'
,p_message_text=>'Luni, 12 ianuarie 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286002203401583)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'ro'
,p_message_text=>'Ianuarie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286148711401583)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'ro'
,p_message_text=>unistr('16 ore \00EEn urm\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114286255657401583)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn 16h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141237048401479)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'ro'
,p_message_text=>unistr('Tip de fi\015Fier nevalid. Tipuri de fi\015Fiere acceptate %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268196975401570)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'ro'
,p_message_text=>'Parcurgere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267818707401570)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare fi\015Fier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267976032401570)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'ro'
,p_message_text=>'Selectare filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141077966401479)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Glisare \015Fi plasare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141404635401479)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'ro'
,p_message_text=>unistr('Glisare \015Fi plasare fi\015Fiere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142634097401480)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i un fi\015Fier sau plasa\0163i unul aici.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142715945401480)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i fi\015Fiere sau plasa\0163i-le aici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142839107401480)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i un fi\015Fier sau plasa\0163i unul aici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142945149401480)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i fi\015Fiere sau plasa\0163i-le aici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141307944401479)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 fi\015Fiere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141124248401479)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'ro'
,p_message_text=>unistr('Fi\015Fierul este prea mare. Dimensiunea maxim\0103 a fi\015Fierului este de %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128943141401470)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>'Adresa este obligatorie.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127844286401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'ro'
,p_message_text=>'Localitate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128294362401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'ro'
,p_message_text=>unistr('Cod \0163ar\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127961311401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r cas\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128865354401470)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'ro'
,p_message_text=>'Latitudine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128791590401470)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'ro'
,p_message_text=>'Longitudine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128655096401470)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare pe hart\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128364330401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'ro'
,p_message_text=>'Punctaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128031277401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'ro'
,p_message_text=>unistr('Cod po\015Ftal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128125529401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'ro'
,p_message_text=>'Stare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127760395401469)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'ro'
,p_message_text=>unistr('Strad\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127671167401469)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'ro'
,p_message_text=>'Rezultate geocodificare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140202628401478)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'ro'
,p_message_text=>unistr('Cu codificare geografic\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140329046401478)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'ro'
,p_message_text=>unistr('F\0103r\0103 codificare geografic\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128555364401470)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Hart\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114128470164401470)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost g\0103sit\0103 nicio adres\0103.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129077996401470)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'ro'
,p_message_text=>'%0 este obligatoriu.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298880678401592)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('Text de asisten\0163\0103: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192288646401516)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'ro'
,p_message_text=>'Bifat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192328286401516)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'ro'
,p_message_text=>'Nebifat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138216182401477)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# nu este \00EEn intervalul valid de la %0 la %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138365441401477)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'ro'
,p_message_text=>'#LABEL# nu este un multiplu de %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137990738401476)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 corespund\0103 valorilor %0 \015Fi %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138108472401477)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Nu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216429345401533)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Oprit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216558285401533)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Pornit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138067931401476)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Da'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121465290401465)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare intrare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250670540401557)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250791108401558)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'ro'
,p_message_text=>'Eliminare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121550253401465)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'ro'
,p_message_text=>unistr('Intr\0103ri selectate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254496330401560)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'ro'
,p_message_text=>'Avansat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254736866401560)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'ro'
,p_message_text=>'Anulare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254591052401560)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'ro'
,p_message_text=>'Comun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254842575401560)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Op\0163iuni \015Fablon live')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255436218401561)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Op\0163iunile pentru \015Fablon nu sunt disponibile deoarece aceast\0103 component\0103 nu este randat\0103 pe pagin\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254321295401560)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost g\0103sit\0103 nicio op\0163iune de \015Fablon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254669262401560)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'ro'
,p_message_text=>'Salvare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129992873401471)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'ro'
,p_message_text=>'Eliminare cerc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131753168401472)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'ro'
,p_message_text=>unistr('Stilurile personalizate nu sunt \00EEn format JSON valid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130200258401471)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'ro'
,p_message_text=>unistr('Instrumentul Distan\0163\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130011496401471)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'ro'
,p_message_text=>'Desenare cerc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122628337401465)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utarea cu fa\0163ete necesit\0103 o surs\0103 de date la nivel regional.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125297168401467)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Loca\0163ie curent\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126302068401468)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Coordonatele pozi\0163iei ini\0163iale sunt nevalide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123716832401466)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Pozi\0163ia ini\0163ial\0103 trebuie s\0103 fie un punct geometric.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126168797401468)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'ro'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124747003401467)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'ro'
,p_message_text=>'Strat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258096998401563)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'ro'
,p_message_text=>'Strat: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129366592401470)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'ro'
,p_message_text=>unistr('Hart\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122511191401465)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'ro'
,p_message_text=>'Mesaje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126248990401468)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'ro'
,p_message_text=>'mile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257013340401562)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Datele con\0163in mai mult de %0 r\00E2nduri dep\0103\015Find maximul permis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124506020401467)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'ro'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Termeni</a> &nbsp;&nbsp; Date hart\0103 &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123429338401466)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Tipul de date SDO_GEOMETRY nu este disponibil \00EEn aceast\0103 baz\0103 de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124666192401467)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'ro'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; contributori OpenStreetMap </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124895077401467)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'ro'
,p_message_text=>'Puncte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258125002401563)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'ro'
,p_message_text=>'%0 puncte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130138060401471)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'ro'
,p_message_text=>'Zoom dreptunghi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129803665401471)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'ro'
,p_message_text=>'Eliminare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125126424401467)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Resetare orientare c\0103tre nord')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205443464401525)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'ro'
,p_message_text=>'Comutare mod 2D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205538370401525)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'ro'
,p_message_text=>'Comutare mod 3D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129752938401470)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'ro'
,p_message_text=>unistr('Comutare not\0103 de Copyright')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130370514401471)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'ro'
,p_message_text=>unistr('Distan\0163a total\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124930099401467)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'ro'
,p_message_text=>unistr('M\0103rire')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125055334401467)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'ro'
,p_message_text=>unistr('Mic\015Forare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252593966401559)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'ro'
,p_message_text=>'Aldin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253439410401559)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'ro'
,p_message_text=>'Imagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253007021401559)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'ro'
,p_message_text=>'Cod inline'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266654429401569)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'ro'
,p_message_text=>'Inserare imagine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266767823401569)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'ro'
,p_message_text=>unistr('Inserare leg\0103tur\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252635425401559)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'ro'
,p_message_text=>'Cursiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267324820401569)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'ro'
,p_message_text=>unistr('Leg\0103tur\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253329378401559)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253246404401559)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103 ordonat\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252707187401559)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'ro'
,p_message_text=>'Previzualizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252875224401559)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'ro'
,p_message_text=>'Nimic de previzualizat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252998040401559)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'ro'
,p_message_text=>unistr('Text t\0103iat cu o linie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253170669401559)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103 neordonat\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232065256401544)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'ro'
,p_message_text=>'curent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114289530662401585)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Mai mult...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114231961996401544)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'ro'
,p_message_text=>unistr('Se \00EEncarc\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263765712401567)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'ro'
,p_message_text=>'Mesaj de notificare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237098583401548)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie un num\0103r mai mic sau egal cu %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237102795401548)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie un num\0103r valid.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237279584401548)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# nu corespunde formatului de num\0103r %0 (exemplu: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236998721401548)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie un num\0103r mai mare sau egal cu %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236877211401548)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 fie un num\0103r cuprins \00EEntre %0 \015Fi %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232103421401544)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'ro'
,p_message_text=>unistr('se deschide \00EEn fereastr\0103 nou\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185371941401511)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 pagin\0103 a fost deja trimis\0103 \015Fi nu poate fi retrimis\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167970285401498)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Aplica\0163ia "%0", pagina "%1" nu a fost g\0103sit\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201728912401523)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('#LABEL# trebuie s\0103 aib\0103 o valoare.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145072399401482)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251068279401558)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnchidere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250907473401558)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251230151401558)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251196043401558)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137110774401476)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'ro'
,p_message_text=>unistr('Introduce\0163i un termen de c\0103utare de cel pu\0163in %0 caractere.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206628430401526)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103 de valori pop-up: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137246271401476)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'ro'
,p_message_text=>unistr('Introduce\0163i un termen de c\0103utare.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137028909401476)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost g\0103sit niciun rezultat.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136964548401476)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'ro'
,p_message_text=>'Eliminare %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224867833401539)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('Termen de c\0103utat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250854839401558)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261539057401565)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'ro'
,p_message_text=>unistr('Se proceseaz\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135501622401475)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare la ecranul Home')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131580857401472)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Dispozitivul sau browserul nu par s\0103 accepte instalarea Progressive Web Apps momentan.</p>'),
unistr('    <p class="a-pwaDialog-intro">Dac\0103 aceast\0103 aplica\0163ie este deja instalat\0103 pe dispozitivul dvs., deschide\0163i-o din ecranul Home.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131150498401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are func\0163ionalitate pentru aplica\0163ii. Ad\0103uga\0163i-l la ecranul Home pentru utilizare fullscreen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Atinge\0163i pictograma <strong>Meniu</strong> din partea inferioar\0103 a navig\0103rii</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Atinge\0163i <strong>Instalare</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Atinge\0163i <strong>Ad\0103ugare</strong> pentru confirmare</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131291464401472)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are o func\0163ionalitate pentru aplica\0163ii care func\0163ioneaz\0103 cel mai bine \00EEn Chrome sauEdge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Atinge\0163i pictograma <strong>Meniu</strong> de l\00E2ng\0103 bara de adrese</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Atinge\0163i <strong>Instalare</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130832882401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are o func\0163ionalitate pentru aplica\0163ii care func\0163ioneaz\0103 cel mai bine \00EEn Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Atinge\0163i pictograma <strong>Partajare</strong> din partea inferioar\0103 a navig\0103rii</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Atinge\0163i <strong>Deschidere \00EEn Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130576764401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are func\0163ionalitate pentru aplica\0163ii. Ad\0103uga\0163i-l la ecranul Home pentru cea mai bun\0103 experien\0163\0103.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Atinge\0163i pictograma <strong>Partajare</strong> de l\00E2ng\0103 bara de adrese</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Atinge\0163i <strong>Ad\0103ugare la ecranul Home</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Atinge\0163i <strong style="color:#007AE1;">Ad\0103ugare</strong> pentru confirmare</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130455165401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are func\0163ionalitate pentru aplica\0163ii. Ad\0103uga\0163i-l la ecranul Home pentru cea mai bun\0103 experien\0163\0103.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Atinge\0163i pictograma <strong>Partajare</strong> din partea inferioar\0103 a navig\0103rii</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Derula\0163i \00EEn jos \015Fi atinge\0163i <strong>Ad\0103ugare la ecranul Home</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Atinge\0163i <strong style="color:#007AE1;">Ad\0103ugare</strong> pentru confirmare</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125499399401467)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are func\0163ionalitate pentru aplica\0163ii. Ad\0103uga\0163i-l la ecranul Home pentru cea mai bun\0103 experien\0163\0103.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Atinge\0163i pictograma <strong>Mai mult</strong> de l\00E2ng\0103 bara de adrese</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Atinge\0163i <strong>Ad\0103ugare la ecranul Home</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Atinge\0163i <strong style="color:#007AE1;">Ad\0103ugare</strong> pentru confirmare</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130707254401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are func\0163ionalitate pentru aplica\0163ii. Ad\0103uga\0163i-l la ecranul Home pentru cea mai bun\0103 experien\0163\0103.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Atinge\0163i pictograma <strong>Partajare</strong> de l\00E2ng\0103 bara de adrese</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Atinge\0163i <strong>Deschidere \00EEn Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130663257401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are func\0163ionalitate pentru aplica\0163ii. Ad\0103uga\0163i-l la ecranul Home pentru cea mai bun\0103 experien\0163\0103.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Atinge\0163i pictograma <strong>Partajare</strong> de l\00E2ng\0103 bara de adrese</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Atinge\0163i <strong>Deschidere \00EEn Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131441847401472)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are o func\0163ionalitate pentru aplica\0163ii care func\0163ioneaz\0103 cel mai bine \00EEn Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox nu accept\0103 \00EEn prezent instalarea de aplica\0163ii web.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114130962160401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are o func\0163ionalitate pentru aplica\0163ii care func\0163ioneaz\0103 cel mai bine \00EEn Chrome sau Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox nu accept\0103 \00EEn prezent instalarea de aplica\0163ii web pe macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131087263401471)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are o func\0163ionalitate pentru aplica\0163ii care func\0163ioneaz\0103 cel mai bine \00EEn Chrome sau Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari nu accept\0103 \00EEn prezent instalarea de aplica\0163ii web pe macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131351235401472)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Acest site web are o func\0163ionalitate pentru aplica\0163ii care func\0163ioneaz\0103 cel mai bine \00EEn Chrome sau Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox nu accept\0103 \00EEn prezent instalarea de aplica\0163ii web pe Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133807026401473)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Conectare nereu\015Fit\0103</h1>'),
unistr('    <p>Ave\0163i nevoie de o conexiune la internet pentru utilizarea acestei aplica\0163ii.</p>'),
unistr('    <button type="button">Re\00EEncercare</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133760208401473)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Conectare nereu\015Fit\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273508111401574)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217955244401534)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'ro'
,p_message_text=>'De o zi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296872377401591)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'ro'
,p_message_text=>unistr('Trimitere invita\0163ie')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296645207401590)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Op\0163iuni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219780393401535)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare zilnic\0103 pentru toat\0103 ziua ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219530838401535)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare zilnic\0103 pentru datele cu ora ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264416508401567)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'ro'
,p_message_text=>'Zi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258878218401563)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'ro'
,p_message_text=>'Descriere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149417577401485)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'ro'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149254294401485)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'ro'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149116921401484)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'ro'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149388185401485)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'ro'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148825467401484)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Data final\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149074638401484)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'ro'
,p_message_text=>'Nume eveniment'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296728651401591)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Invita\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264568204401567)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264290581401567)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Lun\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267077164401569)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281341093401579)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'ro'
,p_message_text=>unistr('F\0103r\0103 evenimente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297057082401591)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'ro'
,p_message_text=>unistr('Edita\0163i un eveniment existent.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296930586401591)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'ro'
,p_message_text=>unistr('Trimite\0163i o invita\0163ie prin e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267199595401569)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275170287401575)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'ro'
,p_message_text=>'Trimitere e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274931215401575)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'ro'
,p_message_text=>'Trimitere e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297710953401591)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Completarea tuturor c\00E2mpurilor este obligatorie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297664093401591)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Trimitere invita\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296599246401590)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'ro'
,p_message_text=>'Subiect'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275019968401575)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'ro'
,p_message_text=>'Destinatar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148913201401484)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Data ini\0163ial\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272808025401573)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'ro'
,p_message_text=>'Formular pe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219359662401535)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'ro'
,p_message_text=>unistr('Or\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267244135401569)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Ast\0103zi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265049094401568)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264379325401567)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('S\0103pt\0103m\00E2n\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219688561401535)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare s\0103pt\0103m\00E2nal\0103 pentru toat\0103 ziua')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219407283401535)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare s\0103pt\0103m\00E2nal\0103 pentru datele cu ora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264998496401568)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'ro'
,p_message_text=>'An'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264628483401567)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Coloane...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264710223401567)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcare mai multe...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196885170401519)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143146776401480)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcare mai multe...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145237370401482)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114264830697401568)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcare mai multe...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266993812401569)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul de regiune %0 nu a fost g\0103sit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145104203401482)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu au fost g\0103site date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169259614401499)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut reseta pagina\0163ia regiunii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137493112401476)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la setarea pagina\0163iei regiunii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258243297401563)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Coloane...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266836461401569)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'ro'
,p_message_text=>'Tipul de regiune %0 nu este acceptat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137343566401476)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la randarea regiunii "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201887969401523)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('#COLUMN_HEADER# trebuie s\0103 aib\0103 o valoare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296150128401590)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'ro'
,p_message_text=>'%0, editor de text formatat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203947049401524)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'ro'
,p_message_text=>unistr('Cre\015Fterea de text formatat HTML dep\0103\015Fe\015Fte lungimea maxim\0103 a articolului (caractere efective %0, permise %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263839877401567)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255656461401561)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'ro'
,p_message_text=>'Duplicat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253936942401560)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloane afi\015Fate')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253877349401560)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'ro'
,p_message_text=>'Excludere valori nule'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263901557401567)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217532511401534)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'ro'
,p_message_text=>unistr('Mutare \00EEn jos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217640806401534)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'ro'
,p_message_text=>unistr('Mutare \00EEn sus')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253612622401560)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254261991401560)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Alte coloane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253744465401560)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254046357401560)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2ndul %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254135470401560)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2ndul %0 din %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255766680401561)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'ro'
,p_message_text=>'Reactualizare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255866628401561)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'ro'
,p_message_text=>unistr('Anulare modific\0103ri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114253515323401559)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'ro'
,p_message_text=>unistr('Meniul Set\0103ri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214510105401532)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'ro'
,p_message_text=>'De exemplu, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122021949401465)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'ro'
,p_message_text=>'Reconectare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121955528401465)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Sesiunea dvs. a fost \00EEncheiat\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122103262401465)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'ro'
,p_message_text=>'Extindere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121774555401465)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'ro'
,p_message_text=>unistr('Sesiunea dvs. se va \00EEncheia la %0. Dori\0163i s\0103 o extinde\0163i?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121805846401465)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'ro'
,p_message_text=>unistr('Sesiunea dvs. va \00EEnceta la %0 \015Fi nu poate fie extins\0103. Salva\0163i lucr\0103rile acum pentru a evita pierderea de date')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274770670401575)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la procesarea codului de cur\0103\0163are pentru sesiunea bazei de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167895081401498)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la procesarea codului de configurare pentru sesiunea bazei de date.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114141996610401479)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Sesiunea dvs. a fost \00EEncheiat\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273673130401574)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnchide\0163i acest dialog \015Fi ap\0103sa\0163i pe butonul de re\00EEnc\0103rcare al browserului pentru a ob\0163ine o nou\0103 sesiune.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292940817401588)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'ro'
,p_message_text=>unistr('Face\0163i clic <a href="%0">aici</a> pentru a crea o nou\0103 sesiune.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179579751401507)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Sesiune nevalid\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219098291401535)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-au putut activa roluri dinamice \00EEn sesiunea Real Application Security pentru utilizatorul "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165762956401497)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'ERR-99900 Nu s-a putut crea ID-ul de sesiune unic: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182024149401508)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103lcare a protec\0163iei pentru starea sesiunii: Acest lucru poate fi generat de modificarea manual\0103 a elementului de pagin\0103 protejat %0. Dac\0103 nu sunte\0163i sigur de sursa acestei erori, contacta\0163i administratorul aplica\0163iei pentru asisten\0163\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301102886401594)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103lcare a protec\0163iei pentru pagin\0103: acest lucru poate fi produs de trimiterea unei pagini ce nu terminase \00EEnc\0103rcarea sau prin modificarea manual\0103 a elementelor de pagin\0103 protejate. Pentru asisten\0163\0103 suplimentar\0103 contacta\0163i administratorul aplica\0163iei')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300194502401593)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 con\0163ine unul dintre urm\0103toarele caractere nevalide &<>"/;,*|=% sau --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300273740401593)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 con\0163ine unul dintre urm\0103toarele caractere nevalide &<>"/;,*|=% sau -- sau o linie nou\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299973798401593)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 con\0163ine caractere speciale. Numai caracterele a-Z, 0-9 \015Fi spa\0163iile sunt permise.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114300017440401593)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 con\0163ine <, > sau ". Acestea sunt caractere nevalide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144166293401481)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost furnizat\0103 nicio sum\0103 de control pentru a afi\015Fa procesarea pentru o pagin\0103 ce necesit\0103 o sum\0103 de control atunci c\00E2nd una sau mai multe valori de cerere, golire memorie cache sau argument sunt trecute ca parametri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176935580401505)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103lcare a protec\0163iei pentru starea sesiunii: Acest lucru poate fi generat de modificarea manual\0103 a unei adrese de URL ce con\0163ine o sum\0103 de control sau prin utilizarea unui link cu o sum\0103 de control incorect\0103 sau lips\0103. Dac\0103 nu sunte\0163i sigur de surs')
||unistr('a acestei erori, contacta\0163i administratorul aplica\0163iei pentru asisten\0163\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114254937567401560)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'ro'
,p_message_text=>unistr('Seta\0163i modul Contrast ridicat la oprit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255011905401561)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'ro'
,p_message_text=>unistr('Seta\0163i modul Contrast ridicat la pornit')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173680151401502)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'ro'
,p_message_text=>unistr('Partea inferioar\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173815313401502)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'ro'
,p_message_text=>'Jos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173932136401503)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'ro'
,p_message_text=>'Mutare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174035481401503)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Mutare global\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174173144401503)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'ro'
,p_message_text=>'Eliminare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174213696401503)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'ro'
,p_message_text=>'Eliminare tot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174347548401503)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'ro'
,p_message_text=>'Resetare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173523737401502)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'ro'
,p_message_text=>unistr('Partea superioar\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173766344401502)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'ro'
,p_message_text=>'Sus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282666435401580)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283398128401581)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282593038401580)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283466592401581)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282335845401580)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283531186401581)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282938674401581)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283198722401581)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0mo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282454832401580)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283276508401581)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282751855401581)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283630718401581)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282864019401581)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'ro'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114283063761401581)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn %0y')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122988327401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'ro'
,p_message_text=>'[Line]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123342135401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'ro'
,p_message_text=>'[Multiple Lines]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123150722401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'ro'
,p_message_text=>'[Multiple Points]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123582398401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'ro'
,p_message_text=>'[Multiple Polygons]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123630906401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'ro'
,p_message_text=>'[Geometry Object]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122889466401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'ro'
,p_message_text=>'[Point (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123014111401466)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'ro'
,p_message_text=>'[Polygon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200238045401521)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('Restr\00E2ngere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200183088401521)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'ro'
,p_message_text=>'Restabilire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246600006401555)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'ro'
,p_message_text=>'Eliminare evaluare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236577981401547)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este \00EEn intervalul de evaluare valid \00EEntre 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236643522401548)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este un num\0103r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232713670401545)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'ro'
,p_message_text=>'Mesaj de succes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295856075401590)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295729101401590)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281440486401580)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Bar\0103 de instrumente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296272137401590)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Extinde\0163i / restr\00E2nge\0163i navigarea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296300987401590)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Extinde\0163i / restr\00E2nge\0163i coloana lateral\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205985989401526)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Navigare principal\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212906308401531)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'ro'
,p_message_text=>'1 zi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212754041401530)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('1 or\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213036670401531)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'ro'
,p_message_text=>'%0 zile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212826300401531)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'ro'
,p_message_text=>'%0 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212603998401530)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'ro'
,p_message_text=>'%0 minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213277639401531)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 s\0103pt\0103m\00E2ni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114213136574401531)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('1 s\0103pt\0103m\00E2n\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299446611401593)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnceput pagin\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161437166401493)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'ro'
,p_message_text=>'Activat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135295319401474)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la procesarea cererii.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214690177401532)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>'Valoare obligatorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297510587401591)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'ro'
,p_message_text=>unistr('A\015Ftepta\0163i \00EEnc\0103rcarea complet\0103 a paginii \015Fi \00EEncerca\0163i din nou.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257763987401562)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 pagin\0103 con\0163ine modific\0103ri nesalvate.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138685883401477)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'ro'
,p_message_text=>unistr('Registrul de lucru nu are nicio foaie de calcul activ\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138598984401477)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'ro'
,p_message_text=>unistr('Registrul de lucru nu este ini\0163ializat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138454666401477)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('A survenit o eroare intern\0103 la crearea fi\015Fierului XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140916758401479)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'ro'
,p_message_text=>'Foaie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272695075401573)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Ac\0163iuni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190134236401514)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'ro'
,p_message_text=>unistr('Meniul Ac\0163iuni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185876984401511)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare func\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185771967401511)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare coloan\0103 de grupare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219998405401536)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare coloan\0103 pivot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220091531401536)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare coloan\0103 r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160206681401493)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'ro'
,p_message_text=>'Agregare'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196399040401519)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'ro'
,p_message_text=>'Agregare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177465341401505)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'ro'
,p_message_text=>'Medie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181737778401508)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177506020401505)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'ro'
,p_message_text=>'Maxim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177758169401505)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'ro'
,p_message_text=>unistr('Median\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177603419401505)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'ro'
,p_message_text=>'Minim'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177360029401505)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'ro'
,p_message_text=>unistr('Sum\0103 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178493038401506)
,p_name=>'APEXIR_ALL'
,p_message_language=>'ro'
,p_message_text=>'Toate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159513936401492)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Toate coloanele'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142097205401479)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('Toate r\00E2ndurile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269615936401571)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'ro'
,p_message_text=>unistr('Alternativ\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271232499401572)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit alternativ: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172136655401501)
,p_name=>'APEXIR_AND'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Fi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161639483401494)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'ro'
,p_message_text=>'Aplicare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155360726401489)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Cresc\0103tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174914064401503)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'ro'
,p_message_text=>'La data %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271845556401573)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'ro'
,p_message_text=>'Medie %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263280120401566)
,p_name=>'APEXIR_BAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Bar\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161094016401493)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEntre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154123459401488)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'ro'
,p_message_text=>'Culoare de fundal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156015116401490)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'ro'
,p_message_text=>'Albastru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187762866401512)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'ro'
,p_message_text=>unistr('Partea inferioar\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156643650401490)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'ro'
,p_message_text=>'Anulare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162573796401494)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'ro'
,p_message_text=>'Categorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154055562401488)
,p_name=>'APEXIR_CELL'
,p_message_language=>'ro'
,p_message_text=>unistr('Celul\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178354756401506)
,p_name=>'APEXIR_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Diagram\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188611742401513)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'ro'
,p_message_text=>unistr('Se ini\0163ializeaz\0103...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114224920606401539)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Eticheta diagramei trebuie s\0103 fie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237302486401548)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Interogarea dvs. dep\0103\015Fe\015Fte num\0103rul maxim de %0 puncte de date per diagram\0103. Aplica\0163i un filtru pentru a reduce num\0103rul de \00EEnregistr\0103ri din interogarea dvs. de baz\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236200500401547)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Num\0103rul maxim de r\00E2nduri pentru o diagram\0103 Pivot limiteaz\0103 num\0103rul de r\00E2nduri din interogarea de baz\0103, nu num\0103rul de r\00E2nduri afi\015Fate. '),
unistr('Interogarea dvs. de baz\0103 dep\0103\015Fe\015Fte num\0103rul maxim de r\00E2nduri de %0. Aplica\0163i un filtru pentru reducerea num\0103rului de \00EEnregistr\0103ri din interogarea de baz\0103.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159628556401492)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Tip diagram\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114232906143401545)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Toate op\0163iunile bifate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175318540401504)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'ro'
,p_message_text=>'Selectare format de raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182784980401509)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'ro'
,p_message_text=>'golire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156516740401490)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193968970401517)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Coloane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266270987401569)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'ro'
,p_message_text=>'Filtrare...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184724879401510)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'ro'
,p_message_text=>unistr('Meniu antet coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188440647401513)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'ro'
,p_message_text=>unistr('Informa\0163ii coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268522035401570)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Etichet\0103 coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186194943401511)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'ro'
,p_message_text=>'Coloana %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170214674401500)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'ro'
,p_message_text=>unistr('con\0163ine')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171181934401501)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'ro'
,p_message_text=>unistr('nu con\0163ine')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155014434401489)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'ro'
,p_message_text=>unistr('\00EEn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171370180401501)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('nu este \00EEn ultimele')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179822450401507)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('nu este \00EEn urm\0103torul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171215214401501)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('este \00EEn ultimele')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179737850401507)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('este \00EEn urm\0103torul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154931655401489)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>'nu este nul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154810900401489)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'ro'
,p_message_text=>'este nul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154615899401489)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'ro'
,p_message_text=>'la fel ca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155198263401489)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'ro'
,p_message_text=>unistr('nu este \00EEn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154747626401489)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'ro'
,p_message_text=>'nu este ca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170533531401500)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'ro'
,p_message_text=>unistr('Se potrive\015Fte cu expresia logic\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175286371401504)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'ro'
,p_message_text=>'Calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114235909475401547)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'ro'
,p_message_text=>'Expresie de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194277671401517)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Crea\0163i un calcul utiliz\00E2nd aliasurile de coloane.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194361766401517)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'ro'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194467942401517)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'ro'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194593845401517)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'ro'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140446419401478)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'ro'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179144340401506)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'ro'
,p_message_text=>'Compute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186744194401512)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEntrerupere control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189727587401514)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEntreruperi de control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274188476401574)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloane \00EEntrerupere control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137597402401476)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rare elemente distincte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272386878401573)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rare distinct\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272225112401573)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244386873401553)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'ro'
,p_message_text=>'Zilnic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299063425401592)
,p_name=>'APEXIR_DATA'
,p_message_language=>'ro'
,p_message_text=>'Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188528478401513)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'ro'
,p_message_text=>'Raportarea datelor de acum %0 minute.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262018547401566)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 gril\0103 pentru date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160315841401493)
,p_name=>'APEXIR_DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Dat\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192479551401516)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269481137401571)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip de raport prestabilit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156719301401490)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160674615401493)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'ro'
,p_message_text=>unistr('Dori\0163i s\0103 \015Fterge\0163i aceste set\0103ri de raport?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255339062401561)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere raport prestabilit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186441621401512)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Etergere raport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155447773401489)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Descresc\0103tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162662630401494)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'ro'
,p_message_text=>'Descriere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184619018401510)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare pentru un singur r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192915459401516)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Direc\0163ie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193891974401517)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'ro'
,p_message_text=>'Dezactivat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156244382401490)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159471772401492)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloane afi\015Fate')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192850396401516)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare \00EEn raport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187601525401512)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'ro'
,p_message_text=>'Jos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179261151401506)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'ro'
,p_message_text=>unistr('Desc\0103rcare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192747554401516)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu se afi\015Feaz\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258700454401563)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'ro'
,p_message_text=>unistr('O eviden\0163iere cu aceea\015Fi condi\0163ie exist\0103 deja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274392796401574)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 pivot dupliat\0103. Lista coloanei pivot trebuie s\0103 fie unic\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274587875401575)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'ro'
,p_message_text=>'Editare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188738128401513)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Editare set\0103ri diagram\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195355557401518)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'ro'
,p_message_text=>unistr('Editare diagram\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195729252401518)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'ro'
,p_message_text=>'Editare filtru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250177328401557)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Editare grup dup\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195692965401518)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'ro'
,p_message_text=>unistr('Editare eviden\0163iere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220207976401536)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'ro'
,p_message_text=>'Editare pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269720522401571)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'ro'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148432486401484)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'ro'
,p_message_text=>unistr('Adres\0103 de e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270060775401571)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'ro'
,p_message_text=>'BCC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270277671401571)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'ro'
,p_message_text=>'Corp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269983680401571)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'ro'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270755062401572)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'ro'
,p_message_text=>unistr('Frecven\0163\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152153669401487)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'ro'
,p_message_text=>unistr('E-mailul nu a fost configurat pentru aceast\0103 aplica\0163ie. Contacta\0163i administratorul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243617135401553)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Adresa de e-mail trebuie s\0103 fie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270350871401571)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'ro'
,p_message_text=>unistr('Consulta\0163i ata\015Famentul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270121845401571)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'ro'
,p_message_text=>'Subiect'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244618011401553)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Subiectul de e-mail trebuie s\0103 fie specificat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269868524401571)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'ro'
,p_message_text=>'Destinatar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153822265401488)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'ro'
,p_message_text=>'Activat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195505456401518)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'ro'
,p_message_text=>'Activare/dezactivare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195027179401518)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194623471401517)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'ro'
,p_message_text=>'Exemple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195453330401518)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'ro'
,p_message_text=>'Exemple:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159306154401492)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'ro'
,p_message_text=>'Excludere valori nule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196007000401518)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'ro'
,p_message_text=>unistr('Extindere/Restr\00E2ngere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193645749401517)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'ro'
,p_message_text=>'Expresie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178710872401506)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'ro'
,p_message_text=>'Filtru'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189610639401514)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'ro'
,p_message_text=>'Filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199978475401521)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'ro'
,p_message_text=>'Expresie pt. filtru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296445894401590)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'ro'
,p_message_text=>unistr('Expresia de filtrare este prea lung\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199864233401521)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip filtru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196267312401519)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'ro'
,p_message_text=>unistr('Selecta\0163i coloanele pentru c\0103utare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179064035401506)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'ro'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193438280401517)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'ro'
,p_message_text=>unistr('O interogare flashback v\0103 permite s\0103 vizualiza\0163i datele a\015Fa cum existau la un moment anterior \00EEn timp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244060742401553)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Durat\0103 flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245418136401554)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'ro'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175168842401503)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'ro'
,p_message_text=>unistr('Masc\0103 de formatare %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186399428401511)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Func\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194136392401517)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Func\0163ii %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269348949401571)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'ro'
,p_message_text=>unistr('Func\0163ii / operatori')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186082895401511)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'ro'
,p_message_text=>unistr('Func\0163ie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178562634401506)
,p_name=>'APEXIR_GO'
,p_message_language=>'ro'
,p_message_text=>'Start'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154367150401488)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'ro'
,p_message_text=>'Verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114137641244401476)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Grupare dup\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270437172401572)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Grupare dup\0103 coloana %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225007419401539)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana pentru grupare trebuie s\0103 fie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236162915401547)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rul maxim de r\00E2nduri pentru o interogare de grupare limiteaz\0103 num\0103rul de r\00E2nduri din interogarea de baz\0103, nu num\0103rul de r\00E2nduri afi\015Fate. Interogarea dvs. de baz\0103 dep\0103\015Fe\015Fte num\0103rul maxim de r\00E2nduri de %0. Aplica\0163i un filtru pentru reducerea num\0103ru')
||unistr('lui de \00EEnregistr\0103ri din interogarea de baz\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216749443401533)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'ro'
,p_message_text=>'Sortare grupare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274262136401574)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'ro'
,p_message_text=>'Ordine de sortare grupare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159731953401492)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 orizontal\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191393370401515)
,p_name=>'APEXIR_HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183101534401509)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Rapoartele interactive permit utilizatorilor finali s\0103 personalizeze rapoartele. Utilizatorii pot modifica macheta datelor raportate prin selectarea coloanelor, aplicarea filtrelor, eviden\0163iere \015Fi sortare. Utilizatorii pot \015Fi defini \00EEntreruperi, agre')
||unistr('g\0103ri, diagrame, grup\0103ri \015Fi \00EE\015Fi pot ad\0103uga propriile calcule. Utilizatorii pot \015Fi s\0103 configureze un abonament astfel \00EEnc\00E2t o versiune HTML a raportului le va fi trimis\0103 prin e-mail la intervalele stabilite. Utilizatorii pot crea multiple varia\0163ii ale ')
||unistr('unui raport \015Fi le pot salva ca rapoarte cu nume, pentru vizualizare public\0103 sau privat\0103. '),
'<p/>',
unistr('Sec\0163iunile urm\0103toare rezum\0103 modul \00EEn care pute\0163i personaliza un raport interactiv. Pentru a afla mai multe, consulta\0163i "Utilizare rapoarte interactive" din <i>Ghidul utilizatorului final Oracle Application Express</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190255922401514)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'ro'
,p_message_text=>unistr('Meniul de ac\0163iuni apare \00EEn partea dreapt\0103 a butonului de Start din bara de c\0103utare. Utiliza\0163i acest meniu pentru a personaliza un raport interactiv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183956616401510)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agreg\0103rile sunt calcule matematice efectuate pentru o coloan\0103. Agreg\0103rile se afi\015Feaz\0103 fiecare \00EEntrerupere de control \015Fi la finalul raportului din cadrul coloanei \00EEn care sunt definite. Op\0163iunile includ:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agregarea</strong> v\0103 permite s\0103 selecta\0163i o'),
unistr('agregare definit\0103 anterior pentru editare.</li>'),
unistr('<li><strong>Func\0163ia</strong> este func\0163ia de efectuat (de exemplu, SUM, MIN).</li>'),
unistr('<li><strong>Coloana</strong> se utilizeaz\0103 pentru a selecta coloana la care se aplic\0103 func\0163ia matematic\0103. Se afi\015Feaz\0103'),
'numai coloanele numerice.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184054969401510)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pute\0163i defini o diagram\0103 per raport salvat. Dup\0103'),
unistr('definire, pute\0163i comuta \00EEntre vizualiz\0103rile diagram\0103 \015Fi raport utiliz\00E2nd pictogramele de vizualizare din bara de c\0103utare.'),
unistr('Op\0163iunile includ:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Tipul de diagram\0103</strong> identific\0103 tipul de diagram\0103 de inclus.'),
unistr('Selecta\0163i \00EEntre bar\0103 orizontal\0103, bar\0103 vertical\0103, disc sau linie.</li>'),
unistr('<li><strong>Eticheta</strong> v\0103 permite s\0103 selecta\0163i coloana de utilizat ca etichet\0103.</li>'),
unistr('<li><strong>Titlul axei pentru etichet\0103</strong> este titlul afi\015Fat pe axa asociat\0103 coloanei selectate pentru '),
unistr('etichet\0103. Acest lucru nu este disponibil pentru diagrama disc.</li>'),
unistr('<li><strong>Valoarea</strong> v\0103 permite s\0103 selecta\0163i coloana de utilizat ca valoare. Dac\0103 func\0163ia'),
unistr('este de tip COUNT, nu trebuie s\0103 fie selectat\0103 o valoare.</li>'),
unistr('<li><strong>Titlul axei pentru valoare</strong> este titlul afi\015Fat pe axa asociat\0103 coloanei selectate pentru'),
'valoare. Acest lucru nu este disponibil pentru diagrama disc.</li>',
unistr('<li><strong>Func\0163ia</strong> este o func\0163ie op\0163ional\0103 de efectuat pe coloana selectat\0103 pentru valoare.</li>'),
unistr('<li><strong>Sortarea</strong> v\0103 permite s\0103 sorta\0163i setul de rezultate.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183328256401509)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Face\0163i clic pe orice antet de coloan\0103 pentru a expune un meniu al antetului coloanei. Op\0163iunile includ:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Sortare ascendent\0103</strong>, pictograma sorteaz\0103 raportul dup\0103 coloan\0103 \00EEn ordine ascendent\0103.</li>'),
unistr('<li><strong>Sortare descendent\0103</strong> pictograma sorteaz\0103 raportul dup\0103 coloan\0103 \00EEn ordine descendent\0103.</li>'),
unistr('<li><strong>Ascundere coloan\0103</strong> ascunde coloana. Nu toate coloanele pot fi ascunse. Dac\0103 o coloan\0103 nu poate fi ascuns\0103, nu va exista o pictogram\0103 de ascundere a coloanei.</li>'),
unistr('<li><strong>\00CEntrerupere coloan\0103</strong> creeaz\0103 un grup de \00EEntrerupere pe coloan\0103. Acest lucru scoate coloana din raport ca o \00EEnregistrare principal\0103.</li>'),
unistr('<li><strong>Informa\0163ii coloan\0103</strong> afi\015Feaz\0103 text de asisten\0163\0103 despre coloan\0103, dac\0103 este disponibil.</li>'),
unistr('<li><strong>Zon\0103 text</strong> este utilizat pentru a introduce criterii de c\0103utare ce nu \0163in seama de litere mari/mici'),
'(nu sunt necesare caractere speciale). Introducerea unei valori reduce lista de',
unistr('valori din partea inferioar\0103 a meniului. Apoi pute\0163i selecta o valoare din'),
unistr('partea inferioar\0103 iar valoarea selectat\0103 va fi creat\0103 ca un filtru utiliz\00E2nd ''='''),
unistr('(de exemplu, <code>coloan\0103 = ''ABC''</code>). Alternativ, pute\0163i face clic pe pictograma Lantern\0103 \015Fi introduce\0163i o valoare de creat ca filtru cu modificatorul ''LIKE'''),
unistr('(de exemplu, <code>coloan\0103 LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>Lista valorilor unice</b> con\0163ine primele 500 valori'),
unistr('unice care satisfac criteriile de filtrare. C\00E2nd coloana este o dat\0103 se afi\015Feaz\0103'),
unistr('\00EEn schimb o list\0103 de intervale de dat\0103. Dac\0103 selecta\0163i o valoare, se va crea'),
unistr('un filtru utiliz\00E2nd ''='' (de exemplu, <code>coloana = ''ABC''</code>).</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183810973401510)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('V\0103 permite s\0103 ad\0103uga\0163i coloane calculate \00EEn raport. Acestea pot fi calcule matematice (de exemplu, <code>NBR_HOURS/24</code>) sau func\0163ii Oracle'),
unistr('standard aplicate coloanelor existente. Unele sunt afi\015Fate ca exemple iar altele (cum ar fi <code>TO_DATE)</code> pot fi de asemenea utilizate). Op\0163iunile includ:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Calculul</strong> v\0103 permite s\0103 selecta\0163i un calcul definit anterior pentru editare.</li>'),
unistr('<li><strong>Antetul de coloan\0103</strong> este antetul de coloan\0103 pentru noua coloan\0103.</li>'),
unistr('<li><strong>Masca de formatare</strong> este o masc\0103 de formatare Oracle de aplicat pe coloan\0103 (de exemplu,S9999).</li>'),
unistr('<li><strong>Calculul</strong> este calculul de efectuat. \00CEn cadrul calculului, se face referire la coloane prin folosirea aliasurilor afi\015Fate.</li>'),
'</ul>',
unistr('<p>Sub calcul, coloanele din interogare sunt afi\015Fate cu'),
unistr('aliasurile lor asociate. F\0103c\00E2nd clic pe numele coloanei sau alias'),
unistr('le include \00EEn calcul. L\00E2ng\0103 coloane este o tastatur\0103 numeric\0103. Aceast\0103 tastatur\0103 numeric\0103 func\0163ioneaz\0103 ca'),
unistr('o scurt\0103tur\0103 pentru tastele cele mai utilizate. \00CEn partea dreapt\0103 extrem\0103 sunt Func\0163iile.</p>'),
unistr('<p>Exemplul urm\0103tor pentru calcul demonstreaz\0103 modul de afi\015Fare pentru compensarea total\0103:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(unde A este ORGANIZATION, B este SALARY \015Fi C este COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190397678401514)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'ro'
,p_message_text=>unistr('Utilizat pentru crearea unui grup de \00EEntrerupere pe una sau mai multe coloane. Acesta extrage coloanele din raportul interactiv \015Fi le afi\015Feaz\0103 ca o \00EEnregistrare principal\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184534221401510)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('Pentru vizualizarea detaliilor pe c\00E2te un singur r\00E2nd o dat\0103, face\0163i clic pe pictograma de vizualizare pentru un singur r\00E2nd pentru r\00E2ndul pe care dori\0163i s\0103 \00EEl vizualiza\0163i. Dac\0103 este disponibil\0103 vizualizarea pentru un singur r\00E2nd poate fi vizualizare')
||unistr('a standard sau o pagin\0103 personalizat\0103 ce poate permite actualizarea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184498025401510)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite desc\0103rcarea setului de rezultate curent. Desc\0103rcarea formatelor'),
unistr('difer\0103 \00EEn func\0163ie de instala\0163ie \015Fi defini\0163ia raportului dar poate'),
'include CSV, HTML, e-mail, XLS, PDF, sau RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183595418401509)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Concentreaz\0103 raportul prin ad\0103ugarea sau modificarea clauzei <code>WHERE</code> din interogare. Pute\0163i filtra dup\0103 o coloan\0103 sau dup\0103 un r\00E2nd. '),
unistr('<p>Dac\0103 filtra\0163i dup\0103 o coloan\0103, selecta\0163i o coloan\0103 (nu trebuie s\0103'),
unistr('fie una afi\015Fat\0103), selecta\0163i un operator Oracle standard (=, !=, nu este \00EEn, \00EEntre), \015Fi introduce\0163i o expresie cu care se va compara. Expresiile \0163in cont de literele mari \015Fi mici. Utiliza\0163i % ca un caracter special (de exemplu, <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>Dac\0103 filtra\0163i dup\0103 r\00E2nd, pute\0163i crea clauze <code>WHERE</code> complexe utiliz\00E2nd'),
unistr('aliasuri de coloane \015Fi orice func\0163ii sau operatori Oracle (de exemplu, <code>G = ''VA'' sau G = ''CT''</code>, unde'),
'<code>G</code> este aliasul pentru <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184133043401510)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('O interogare flashback v\0103 permite s\0103 vizualiza\0163i datele a\015Fa cum au existat la un punct anterior'),
unistr('\00EEn timp. Valoarea prestabilit\0103 de timp utilizat\0103 pentru este de 3 ore (sau 180'),
unistr('minute) dar valoarea efectiv\0103 va diferi pentru fiecare baz\0103 de date.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245390543401554)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Formatul v\0103 permite s\0103 personaliza\0163i afi\015Farea raportului.'),
unistr('Formatul con\0163ine urm\0103torul submeniu:</p>'),
'<ul><li>Sortare</li>',
unistr('<li>\00CEntrerupere control</li>'),
unistr('<li>Eviden\0163iere</li>'),
'<li>Compute</li>',
'<li>Agregare</li>',
unistr('<li>Diagram\0103</li>'),
'<li>Grupare</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243514664401552)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pute\0163i defini o vizualizare grupare pentru un raport'),
unistr('salvat. Dup\0103 definire, pute\0163i comuta \00EEntre vizualiz\0103rile grupare \015Fi raport'),
unistr('utiliz\00E2nd pictogramele de vizualizare de pe bara de c\0103utare. Pentru crearea unei vizualiz\0103ri Grupare,'),
unistr('selecta\0163i: '),
'<p></p><ul>',
'<li>coloanele pe care se va grupa</li>',
unistr('<li>coloanele de agregat \00EEmpreun\0103 cu func\0163ia de efectuat (medie, sum\0103, num\0103rare etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183786953401510)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V\0103 permite definirea unui filtru. R\00E2ndurile care satisfac criteriile de filtrare sunt afi\015Fate eviden\0163iate utiliz\00E2nd caracteristicile asociate cu filtrul. Op\0163iunile includ:</p>'),
'<ul>',
unistr('<li><strong>Numele</strong> este utilizat pentru afi\015Fare.</li>'),
unistr('<li><strong>Secven\0163a</strong> identific\0103 secven\0163a \00EEn care sunt evaluate regulile.</li>'),
unistr('<li><strong>Activat</strong> identific\0103 dac\0103 o regul\0103 este activat\0103 sau dezactivat\0103.</li>'),
unistr('<li><strong>Tipul de eviden\0163iere</strong> identific\0103 dac\0103 r\00E2ndul sau celula trebuie s\0103 fie'),
unistr('eviden\0163iat\0103. Dac\0103 se selecteaz\0103 Celul\0103, coloana la care se face referire \00EEn'),
unistr('condi\0163ia de eviden\0163iere este eviden\0163iat\0103.</li>'),
unistr('<li><strong>Culoarea de fundal</strong> este noua culoare pentru fundalul zonei eviden\0163iate.</li>'),
unistr('<li><strong>Culoarea de text</strong> este noua culoare pentru textul zonei eviden\0163iate.</li>'),
unistr('<li><strong>Condi\0163ia de eviden\0163iere</strong> define\015Fte condi\0163ia de filtrare.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121307893401464)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pute\0163i defini o vizualizare Pivot pentru un raport salvat. Dup\0103 definire, pute\0163i comuta \00EEntre vizualiz\0103rile pivot \015Fi raport utiliz\00E2nd pictogramele de vizualizare de pe bara de c\0103utare. Pentru crearea unei vizualiz\0103ri Pivot, selecta\0163i: '),
'<p></p>',
'<ul>',
'<li>coloanele pe care se va pivota</li>',
unistr('<li>coloanele de afi\015Fat ca r\00E2nduri</li>'),
unistr('<li>coloanele de agregat \00EEmpreun\0103 cu func\0163ia de efectuat (medie, sum\0103, num\0103rare etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194844671401518)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dac\0103 personaliza\0163i un raport interactiv, set\0103rile raportului sunt'),
unistr('afi\015Fate sub bara de c\0103utare \015Fi deasupra raportului. Aceast\0103 zon\0103 poate fi restr\00E2ns\0103 \015Fi extins\0103 utiliz\00E2nd pictograma din st\00E2nga.'),
'<p>',
'Pentru fiecare setare de raport:',
'</p><ul>',
unistr('<li>Edita\0163i o setare f\0103c\00E2nd clic pe nume.</li>'),
unistr('<li>Dezactiva\0163i/activa\0163i o setare prin debifarea sau bifarea casetei de validare Dezactivare/activare. Utiliza\0163i acest control pentru a porni sau opri temporar o setare.</li>'),
unistr('<li>Elimina\0163i o setare f\0103c\00E2nd clic pe pictograma Eliminare.</li>'),
'</ul>',
unistr('<p>Dac\0103 a\0163i creat o diagram\0103, grupare sau pivotare, pute\0163i comuta \00EEntre acestea'),
unistr('\015Fi raportul de baz\0103 utiliz\00E2nd vizualizarea raport, vizualizarea diagram\0103, vizualizarea grupare \015Fi vizualizarea pivotare'),
unistr('cu leg\0103turile prezentate \00EEn dreapta. Dac\0103 vizualiza\0163i diagrama, gruparea sau pivotarea'),
unistr('pute\0163i utiliza \015Fi leg\0103tura Editare pentru editarea set\0103rilor.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184354780401510)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'ro'
,p_message_text=>unistr('Reseteaz\0103 raportul \00EEnapoi la set\0103rile prestabilite, elimin\00E2nd orice personaliz\0103ri efectuate.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245678080401554)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Seteaz\0103 num\0103rul de \00EEnregistr\0103ri de afi\015Fat pe pagin\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184245383401510)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Salveaz\0103 raportul personalizat pentru utilizare viitoare. Furnza\0163i un nume \015Fi o descriere op\0163ional\0103 \015Fi pute\0163i face raportul accesibil pentru public (mai exact, to\0163i utilizatorii pot accesa raportul prestabilit primar). Pute\0163i salva patru tipuri de')
||' rapoarte interactive:</p>',
'<ul>',
unistr('<li><strong>Prestabilit principal</strong> (numai dezvoltatori). Raportul prestabilit principal este raportul care este afi\015Fat ini\0163ial. Rapoartele prestabilite principale nu pot fi redenumite sau \015Fterse.</li>'),
unistr('<li><strong>Raport alternativ</strong> (numai dezvoltatori). Permite dezvoltatorilor s\0103 creeze multiple machete de raport. Numai dezvoltatorii pot s\0103 salveze, redenumeasc\0103 sau \015Fterge un raport alternativ.</li>'),
unistr('<li><strong>Raport public</strong> (utilizator final). Poate fi salvat, redenumit sau \015Fters de utilizatorul final care l-a creat. Al\0163i utilizatori pot vizualiza \015Fi salva macheta ca un alt raport.</li>'),
unistr('<li><strong>Raport privat</strong> (utilizator final). Numai utilizatorul final care a creat raportul poate s\0103 vizualizaze, salveze, redenumeasc\0103 sau \015Fterge raportul.</li>'),
'</ul>',
unistr('<p>Dac\0103 salva\0163i rapoartele personalizate, un selector de rapoarte este afi\015Fat \00EEn bara de c\0103utare din st\00E2ngs selectorului de r\00E2nduri (dac\0103 este activat\0103 aceast\0103 caracteristic\0103).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183230666401509)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEn partea superioar\0103 a fiec\0103rei pagini de raport este o regiune de c\0103utare. Aceast\0103 regiune (sau bara de c\0103utare) asigur\0103 urm\0103toarele caracteristici:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246273268401554)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'ro'
,p_message_text=>unistr('<li><strong>Meniul de ac\0163iuni</strong> v\0103 permite s\0103 personaliza\0163i un raport. Consulta\0163i sec\0163iunile urm\0103toare.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245788433401554)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'ro'
,p_message_text=>unistr('<li><strong>Pictograma selectare coloane</strong> v\0103 permite s\0103 identifica\0163i ce coloane s\0103 c\0103uta\0163i (sau toate).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246068237401554)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'ro'
,p_message_text=>unistr('<li><strong>Rapoartele</strong> afi\015Feaz\0103 rapoartele prestabilit alternativ \015Fi privat sau public salvat.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245950061401554)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('<li><strong>R\00E2ndurile</strong> seteaz\0103 num\0103rul de \00EEnregistr\0103ri de afi\015Fat pe pagin\0103.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245840147401554)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Zona de text</strong> v\0103 permite s\0103 introduce\0163i criteriile de c\0103utare ce nu \0163in cont de majuscule/minuscule (caracterele speciale sunt implicite).</li>'),
unistr('<li><strong>Butonul Start</strong> execut\0103 c\0103utarea. Atingerea tastei centrale va executa c\0103utarea atunci c\00E2nd cursorul este \00EEn zona textului de c\0103utare.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246149516401554)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'ro'
,p_message_text=>unistr('<li><strong>Pictogramele de vizualizare</strong> comut\0103 \00EEntre vizualiz\0103rile pictogram\0103, raport, detaliu, diagram\0103, grupare \015Fi pivot pentru raport dac\0103 sunt definite.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262135774401566)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('<li><strong>Administrarea</strong> v\0103 permite s\0103 administra\0163i propriet\0103\0163ile, coloanele, r\00E2ndurile \015Fi istoricul de vizualizare pentru raport sau grila de date.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183485642401509)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Utilizat pentru modificarea coloanelor afi\015Fate. Coloanele din dreapta sunt afi\015Fate. Coloanele din st\00E2nga sunt ascunse. Pute\0163i reorganiza coloanele afi\015Fate utiliz\00E2nd s\0103ge\0163ile din partea dreapt\0103 extrem\0103. Coloanele calculate au prefixul <strong>**</stro')
||'ng>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183601499401510)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilizat pentru modificarea coloanelor pe care se sorteaz\0103 \015Fi determin\0103 dac\0103'),
unistr('se sorteaz\0103 \00EEn ordine ascendent\0103 sau descendent\0103. Pute\0163i specifica \015Fi modul de tratare pentru'),
unistr('<code>NULLs</code>. Setarea prestabilit\0103 afi\015Feaz\0103 \00EEntotdeauna valorile <code>NULLs</code> ultimele sau le afi\015Feaz\0103 \00EEntotdeauna primele. Sortarea rezultat\0103 se afi\015Feaz\0103 \00EEn dreapta'),
'anteturilor coloanelor din raport.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243323550401552)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'ro'
,p_message_text=>unistr('La ad\0103ugarea unui abonament, furniza\0163i o adres\0103 de e-mail (sau multiple adrese de e-mail, separate de virgule), subiectul e-mailului, frecven\0163a \015Fi datele de \00EEnceput \015Fi sf\00E2r\015Fit. E-mailurile rezultate includ o versiune HTML a raportului interactiv ce c')
||unistr('on\0163ine datele curente utiliz\00E2nd setarea raportului care era prezent\0103 la ad\0103ugarea abonamentului.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261913712401565)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Grilele de date sunt \00EEn esen\0163\0103 rapoarte editabile puternic personalizabile. Utilizatorii pot modifica macheta datelor raportate prin selectarea coloanelor, aplicarea filtrelor, eviden\0163iere \015Fi sortare. Utilizatorii pot \015Fi defini \00EEntreruperi, agreg\0103ri,')
||unistr(' diagrame, grup\0103ri \015Fi \00EE\015Fi pot ad\0103uga propriile calcule. Utilizatorii pot crea multiple varia\0163ii ale unui raport \015Fi le pot salva ca rapoarte denumite, pentru vizualizare privat\0103. '),
'<p/>',
unistr('O gril\0103 de date poate fi personalizat\0103 folosind bara de c\0103utare, meniul de ac\0163iuni, meniul de administrare sau meniul anteturi de coloane.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273709187401574)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'ro'
,p_message_text=>unistr('Meniul de ac\0163iuni apare \00EEn partea dreapt\0103 a butonului de Start din bara de c\0103utare. Utiliza\0163i acest meniu pentru a personaliza un raport de gril\0103 de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262455226401566)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'ro'
,p_message_text=>unistr('Ad\0103ugare / editare pagin\0103 r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262573525401566)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pentru a ad\0103uga un r\00E2nd la grila de date face\0163i clic pe Ad\0103ugare r\00E2nd. Pentru a edita detaliile unui r\00E2nd face\0163i clic pe pictograma editare r\00E2nd (prima coloan\0103) de pe r\00E2ndul pe care dori\0163i s\0103 \00EEl edita\0163i. Se va afi\015Fa pagina Ad\0103ugare/editare r\00E2nd, c')
||unistr('e arat\0103 coloanele grilei de date. </p>'),
'',
unistr('<p>La editarea unui r\00E2nd pute\0163i:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\015Eterge</strong> r\00E2ndul.</li>'),
unistr('<li><strong>Aplica modific\0103rile</strong> pentru salvarea modific\0103rilor efectuate \00EEn r\00E2nd.</li>'),
unistr('<li>\00CEn cadrul <strong>Ac\0163iunilor</strong>, ad\0103uga\0163i un r\00E2nd, ad\0103uga\0163i fi\015Fiere, note, leg\0103turi sau etichete \015Fi examina\0163i istoricul.</li>'),
unistr('<li>Naviga\0163i la r\00E2ndurile <strong>\00EEnainte \015Fi \00EEnapoi</strong>.</li>'),
unistr('<li>\00CEn cadrul <strong>Administr\0103rii</strong>, seta\0163i propriet\0103\0163ile coloanei, grupurile coloanei, valid\0103rile \015Fi listele de valori.</li>'),
'</ul></p>',
'',
unistr('<p>Regiunea de adnot\0103ri de la baza paginii va afi\015Fa orice fi\015Fiere, note, leg\0103turi sau etichete ce sunt asociate cu r\00E2ndul curent.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273885753401574)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'ro'
,p_message_text=>unistr('Utilizat pentru crearea unui grup de \00EEntrerupere pe una sau mai multe coloane. Acesta extrage coloanele din grija de date \015Fi le afi\015Feaz\0103 ca o \00EEnregistrare principal\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262349329401566)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite desc\0103rcarea setului de rezultate curent. Formatele de desc\0103rcare'),
'include CSV, HTML sau e-mail.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273983733401574)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dac\0103 personaliza\0163i un raport de gril\0103 de date, set\0103rile raportului sunt'),
unistr('afi\015Fate sub bara de c\0103utare \015Fi deasupra raportului. Aceast\0103 zon\0103 poate fi restr\00E2ns\0103 \015Fi extins\0103 utiliz\00E2nd pictograma din st\00E2nga.'),
'<p>',
'Pentru fiecare setare de raport:',
'</p><ul>',
unistr('<li>Edita\0163i o setare f\0103c\00E2nd clic pe nume.</li>'),
unistr('<li>Dezactiva\0163i/activa\0163i o setare prin debifarea sau bifarea casetei de validare Dezactivare/activare. Utiliza\0163i acest control pentru a porni sau opri temporar o setare.</li>'),
unistr('<li>Elimina\0163i o setare f\0103c\00E2nd clic pe pictograma Eliminare.</li>'),
'</ul>',
unistr('<p>Dac\0103 a\0163i creat o diagram\0103 sau grupare, pute\0163i comuta \00EEntre acestea'),
unistr('\015Fi raportul de baz\0103 utiliz\00E2nd vizualizarea raport, vizualizarea diagram\0103 \015Fi vizualizarea grupare'),
unistr('cu leg\0103turile prezentate \00EEn dreapta. Dac\0103 vizualiza\0163i diagrama sau gruparea'),
unistr('pute\0163i utiliza \015Fi leg\0103tura Editare pentru editarea set\0103rilor.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262215995401566)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Salveaz\0103 macheta raportului pentru grila de date personalizat\0103 pentru utilizare viitoare. Furniza\0163i un nume \015Fi o descriere op\0163ional\0103. Pute\0163i salva trei tipuri de machete de raport pentru grila de date:</p>'),
'<ul>',
unistr('<li><strong>Prestabilit principal</strong> (numai administrator). Tipul Prestabilit principal este macheta care este afi\015Fat\0103 ini\0163ial. Rapoartele prestabilite principale nu pot fi redenumite sau \015Fterse.</li>'),
unistr('<li><strong>Raport alternativ</strong> (numai administrator). Permite administratorilor s\0103 creeze multiple machete de raport. Numai administratorii pot s\0103 salveze, redenumeasc\0103 sau \015Fterge un raport alternativ.</li>'),
unistr('<li><strong>Raport privat</strong> (to\0163i utilizatorii). Utilizatorul care a creat raportul poate s\0103 vizualizaze, salveze, redenumeasc\0103 sau \015Fterge raportul.</li>'),
'</ul>',
unistr('<p>Dac\0103 salva\0163i rapoartele personalizate, un selector de rapoarte este afi\015Fat \00EEn bara de c\0103utare din st\00E2ngs selectorului de r\00E2nduri (dac\0103 este activat\0103 aceast\0103 caracteristic\0103).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188313984401513)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Ascundere coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178939118401506)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'ro'
,p_message_text=>unistr('Eviden\0163iere')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189813086401514)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Eviden\0163ieri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194999952401518)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'ro'
,p_message_text=>unistr('Condi\0163ie de eviden\0163iere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243977268401553)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Stil eviden\0163iere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153975550401488)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Eviden\0163iere tip')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263480598401567)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'ro'
,p_message_text=>'Orizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293041467401588)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'ro'
,p_message_text=>unistr('1 setare inactiv\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293156368401588)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 set\0103ri inactive')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184916166401510)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103 raport interactiv')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195960233401518)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'ro'
,p_message_text=>'Nevalid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189325556401514)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Expresie de calcul nevalid\0103. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148710961401484)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Data final\0103 trebuie s\0103 fie ulterioar\0103 datei ini\0163iale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203626156401524)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Expresie de filtrare nevalid\0103. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271442265401572)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'ro'
,p_message_text=>unistr('Interogare filtru nevalid\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293281251401588)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'ro'
,p_message_text=>unistr('1 setare nevalid\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293304359401588)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 set\0103ri nevalide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244177405401553)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'ro'
,p_message_text=>unistr('(\00EEn minute)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261163027401565)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 este \00EEn ultimul %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261340898401565)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 este \00EEn urm\0103torul %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261269100401565)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este \00EEn ultimul %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261459475401565)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 nu este \00EEn urm\0103torul %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194010514401517)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'ro'
,p_message_text=>unistr('Tastatur\0103 numeric\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160114132401493)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Etichet\0103 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187949759401513)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Titlul axei pentru etichet\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180478220401507)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'ro'
,p_message_text=>'Ultima zi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180610403401507)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultima or\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180121220401507)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultima lun\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180207379401507)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('Ultima s\0103pt\0103m\00E2n\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180300347401507)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'ro'
,p_message_text=>'Ultimele %0 zile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180522030401507)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'ro'
,p_message_text=>'Ultimele %0 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179967611401507)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'ro'
,p_message_text=>'Ultimii %0 ani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180009270401507)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'ro'
,p_message_text=>'Ultimul an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160047154401492)
,p_name=>'APEXIR_LINE'
,p_message_language=>'ro'
,p_message_text=>'Linie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156815018401490)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'ro'
,p_message_text=>unistr('Linie cu zon\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271312303401572)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'ro'
,p_message_text=>'Mapare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188851216401513)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'ro'
,p_message_text=>unistr('Interogarea este estimat\0103 c\0103 va dep\0103\015Fi resursele maxim permise. Modifica\0163i set\0103rile raportului \015Fi \00EEncerca\0163i din nou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171062818401500)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rul maxim de r\00E2nduri pentru acest raport este %0 r\00E2nduri. Aplica\0163i un filtru pentru a reduce num\0103rul de \00EEnregistr\0103ri din interogarea dvs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271992029401573)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'ro'
,p_message_text=>'Maxim %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272184445401573)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'ro'
,p_message_text=>unistr('Median\0103 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175014790401503)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272066505401573)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'ro'
,p_message_text=>'Minim %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271055197401572)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Lun\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244541296401553)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'ro'
,p_message_text=>'Lunar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187192058401512)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'ro'
,p_message_text=>'Mutare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187017533401512)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Mutare global\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298223874401592)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul static pentru regiune trebuie s\0103 fie specificat deoarece pagina con\0163ine multiple rapoarte inactive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155522826401489)
,p_name=>'APEXIR_NAME'
,p_message_language=>'ro'
,p_message_text=>'Nume'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182951686401509)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Agregare nou\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293952793401589)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Categorie nou\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114183050313401509)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'ro'
,p_message_text=>'Calcul nou'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177892463401505)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180938738401508)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Ziua urm\0103toare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180795022401507)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('Ora urm\0103toare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181255490401508)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Luna urm\0103toare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181108763401508)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('S\0103pt\0103m\00E2na urm\0103toare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181021762401508)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 zile')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114180866608401508)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103toarele %0 ore')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181474943401508)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'ro'
,p_message_text=>unistr('Urm\0103torii %0 ani')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181370171401508)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Anul urm\0103tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155859417401489)
,p_name=>'APEXIR_NO'
,p_message_language=>'ro'
,p_message_text=>'Nu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196133689401519)
,p_name=>'APEXIR_NONE'
,p_message_language=>'ro'
,p_message_text=>unistr('- F\0103r\0103 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243799116401553)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu este o adres\0103 de e-mail valid\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192620237401516)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'ro'
,p_message_text=>unistr('Valorile nule \00EEntotdeauna primele')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192592942401516)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'ro'
,p_message_text=>unistr('Valorile nule \00EEntotdeauna ultimele')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193040630401516)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'ro'
,p_message_text=>'Sortare valori nule %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189435802401514)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'ro'
,p_message_text=>unistr('Timpul de flashback trebuie s\0103 fie numeric.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189079466401513)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'ro'
,p_message_text=>unistr('Secven\0163a trebuie s\0103 fie numeric\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193543930401517)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'ro'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154489097401488)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'ro'
,p_message_text=>'Portocaliu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263345737401566)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'ro'
,p_message_text=>'Orientare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156372687401490)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'ro'
,p_message_text=>'Altele'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139136558401477)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Orientare pagin\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139804131401478)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'ro'
,p_message_text=>'Peisaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139935318401478)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'ro'
,p_message_text=>'Portret'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139095054401477)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'ro'
,p_message_text=>unistr('Dimensiune pagin\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139691079401478)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'ro'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139587131401478)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'ro'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139793203401478)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'ro'
,p_message_text=>'Personalizat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139312046401477)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'ro'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139224636401477)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Format pagin\0103 Letter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114139480569401477)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'ro'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272498456401573)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'ro'
,p_message_text=>unistr('Procent din num\0103rul total %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271679282401572)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'ro'
,p_message_text=>unistr('Procent din suma total\0103 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270620930401572)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Procent din num\0103rul total')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270512432401572)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'ro'
,p_message_text=>unistr('Procent din suma total\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159942469401492)
,p_name=>'APEXIR_PIE'
,p_message_language=>'ro'
,p_message_text=>'Disc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219831057401536)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'ro'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221382565401537)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Agregarea trebuie s\0103 fie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221501490401537)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu pute\0163i agrega pe o coloan\0103 selectat\0103 ca o coloan\0103 r\00E2nd.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220710893401536)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Coloane pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220540029401536)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 pivot %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221186366401536)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana pivot trebuie s\0103 fie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121243961401464)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rul maxim de r\00E2nduri pentru o interogare Pivot limiteaz\0103 num\0103rul de r\00E2nduri din interogarea de baz\0103, nu num\0103rul de r\00E2nduri afi\015Fate. Interogarea dvs. de baz\0103 dep\0103\015Fe\015Fte num\0103rul maxim de r\00E2nduri de %0. Aplica\0163i un filtru pentru reducerea num\0103rului d')
||unistr('e \00EEnregistr\0103ri din interogarea de baz\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221014351401536)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'ro'
,p_message_text=>'Sortare pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190488882401514)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana de pivotare con\0163ine prea multe valori distincte - pivotul SQL nu poate fi generat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243894618401553)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'ro'
,p_message_text=>'Previzualizare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177935994401505)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114269527066401571)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'ro'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244898733401553)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138928675401477)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'ro'
,p_message_text=>'Includere etichete de accesibilitate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125817506401468)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'ro'
,p_message_text=>'Golire text formatat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202654151401523)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'ro'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160598206401493)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'ro'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156114834401490)
,p_name=>'APEXIR_RED'
,p_message_language=>'ro'
,p_message_text=>unistr('Ro\015Fu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298194866401592)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul static %0 pentru regiune nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187282077401512)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'ro'
,p_message_text=>'Eliminare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187317459401512)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'ro'
,p_message_text=>'Eliminare tot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293401247401588)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Eliminare diagram\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186897982401512)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'ro'
,p_message_text=>unistr('Eliminare \00EEntrerupere control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186578958401512)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'ro'
,p_message_text=>'Eliminare filtru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186631388401512)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'ro'
,p_message_text=>'Eliminare flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293565657401588)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>'Eliminare grupare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186965503401512)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'ro'
,p_message_text=>unistr('Eliminare eviden\0163iere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293693142401588)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'ro'
,p_message_text=>'Eliminare pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274644285401575)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Eliminare raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255285502401561)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Redenumire raport prestabilit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196418781401519)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Redenumire raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178200509401506)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272566475401573)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'ro'
,p_message_text=>'Rapoarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152739427401487)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Raportul interactiv salvat cu aliasul %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202932572401523)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Raportul nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152835414401487)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Raportul interactiv salvat cu ID-ul %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114194741928401518)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'ro'
,p_message_text=>unistr('Set\0103ri raport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175504452401504)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179401083401507)
,p_name=>'APEXIR_RESET'
,p_message_language=>'ro'
,p_message_text=>'Resetare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160706444401493)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'ro'
,p_message_text=>unistr('Restabilire raport la set\0103rile prestabilite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155981169401489)
,p_name=>'APEXIR_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268600679401570)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu pute\0163i utiliza ROWID ca o coloan\0103 de cheie primar\0103 pentru o surs\0103 de date REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185905222401511)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nduri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245515395401554)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nduri pe pagin\0103')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220808931401536)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloane r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220634373401536)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 r\00E2nd %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221206509401537)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana r\00E2nd trebuie s\0103 fie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221491308401537)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana r\00E2nd trebuie s\0103 fie diferit\0103 de coloana pivot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200028231401521)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Filtru de r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175678339401504)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2ndul %0 din %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179660326401507)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'ro'
,p_message_text=>unistr('Textul r\00E2ndului con\0163ine')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155259214401489)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'ro'
,p_message_text=>'Salvare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190039689401514)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport salvat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189947810401514)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'ro'
,p_message_text=>'Raport salvat = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192175429401516)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'ro'
,p_message_text=>unistr('Set\0103rile raportului curent vor fi utilizate ca valori prestabilite pentru to\0163i utilizatorii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114255152729401561)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Salvare raport prestabilit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114179398246401506)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Salvare raport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293835781401588)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Salvare raport *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246508635401555)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114184841213401510)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Bar\0103 de c\0103utare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114293792133401588)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252071129401558)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'ro'
,p_message_text=>unistr('Raport de c\0103utare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236024549401547)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Coloane selectate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156954534401490)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('- Selectare coloan\0103 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178645683401506)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>'Selectare coloane'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160406728401493)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('- Selectare func\0163ie -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185666783401511)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('- Selectare coloan\0103 de grupare -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220367999401536)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('- Selectare coloan\0103 pivot -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271541932401572)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220449244401536)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('- Selectare coloan\0103 r\00E2nd -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129118746401470)
,p_name=>'APEXIR_SEND'
,p_message_language=>'ro'
,p_message_text=>'Trimitere'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135400362401475)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'ro'
,p_message_text=>'Trimitere ca e-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155659024401489)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'ro'
,p_message_text=>unistr('Secven\0163\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178837777401506)
,p_name=>'APEXIR_SORT'
,p_message_language=>'ro'
,p_message_text=>'Sortare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188191323401513)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare ascendent\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188273257401513)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Sortare descendent\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274033977401574)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'ro'
,p_message_text=>'Ordine de sortare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182632614401509)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'ro'
,p_message_text=>unistr('spa\0163iu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193788080401517)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'ro'
,p_message_text=>'Stare %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244284971401553)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'ro'
,p_message_text=>'Abonament'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270953010401572)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'ro'
,p_message_text=>unistr('Termin\00E2nd cu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125354230401467)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'ro'
,p_message_text=>unistr('Omitere dac\0103 nu se g\0103sesc date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114270817709401572)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEncep\00E2nd de la')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271749687401572)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'ro'
,p_message_text=>'Suma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261749927401565)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'ro'
,p_message_text=>unistr('Regiune = %0, Raport = %1, Vizualizare = %2, Start r\00E2nduri afi\015Fate = %3, Final r\00E2nduri afi\015Fate = %4, Total r\00E2nduri = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182398113401509)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'ro'
,p_message_text=>unistr('Regiune = %0, Raport = %1, Vizualizare = %2, Start r\00E2nduri afi\015Fate = %3, Final r\00E2nduri afi\015Fate = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154553292401488)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'ro'
,p_message_text=>'Culoare text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171624139401501)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'ro'
,p_message_text=>'zile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171571118401501)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'ro'
,p_message_text=>'ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171449567401501)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'ro'
,p_message_text=>'minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171836049401501)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'ro'
,p_message_text=>'luni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171703943401501)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('s\0103pt\0103m\00E2ni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114171994352401501)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'ro'
,p_message_text=>'ani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114274404927401574)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'ro'
,p_message_text=>'Comutare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187405629401512)
,p_name=>'APEXIR_TOP'
,p_message_language=>'ro'
,p_message_text=>unistr('Partea superioar\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267629571401570)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 f\0103r\0103 grupare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188987105401513)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'ro'
,p_message_text=>unistr('Numele eviden\0163iat trebuie s\0103 fie unic.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159271082401492)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip de date neacceptat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187537581401512)
,p_name=>'APEXIR_UP'
,p_message_language=>'ro'
,p_message_text=>'Sus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189194535401514)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'ro'
,p_message_text=>unistr('Introduce\0163i o culoare valid\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189276416401514)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'ro'
,p_message_text=>unistr('Introduce\0163i o masc\0103 de formatare valid\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114156420895401490)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'ro'
,p_message_text=>'Valoare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114188034770401513)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'ro'
,p_message_text=>'Titlul axei pentru valoare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195805561401518)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>'Valoare obligatorie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159887865401492)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 vertical\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114263584608401567)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'ro'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195159464401518)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare diagram\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250357743401557)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare detalii'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114295995198401590)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Raportul nu are vizualizarea %0 definit\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250415690401557)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare grupare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250270381401557)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare pictograme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220113654401536)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114195283167401518)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Vizualizare raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244499630401553)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'ro'
,p_message_text=>unistr('S\0103pt\0103m\00E2nal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178199923401506)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport de lucru'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273174149401574)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'ro'
,p_message_text=>'%0 zile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273011147401573)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'ro'
,p_message_text=>'%0 ore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114272959699401573)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'ro'
,p_message_text=>'%0 minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273313548401574)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'ro'
,p_message_text=>'%0 luni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273254104401574)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 s\0103pt\0103m\00E2ni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114273495319401574)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'ro'
,p_message_text=>'%0 ani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114271114817401572)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'ro'
,p_message_text=>'An'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114154203832401488)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'ro'
,p_message_text=>'Galben'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114155739438401489)
,p_name=>'APEXIR_YES'
,p_message_language=>'ro'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114187854180401513)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 con\0163ine < sau > acestea fiind caractere nevalide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114210696748401529)
,p_name=>'APEX_REGION'
,p_message_language=>'ro'
,p_message_text=>'Regiune'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114138834886401477)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'ro'
,p_message_text=>unistr('Precondi\0163ie API \00EEnc\0103lcat\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158302084401491)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu se poate prelua valoarea pentru setarea aplica\0163iei %0 deoarece op\0163iunea de generare asociat\0103 este dezactivat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158287042401491)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu se poate seta valoarea pentru setarea aplica\0163iei %0 deoarece op\0163iunea de generare asociat\0103 este dezactivat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265959383401568)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoarea %0 pentru setarea aplica\0163iei este nevalid\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114265829305401568)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'ro'
,p_message_text=>unistr('Setarea cerut\0103 a aplica\0163iei %0 nu este definit\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266055669401568)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Setarea aplica\0163iei %0 nu poate fi setat\0103 la o valoare nul\0103')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146907193401483)
,p_name=>'BACK'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133924076401474)
,p_name=>'BUILDER'
,p_message_language=>'ro'
,p_message_text=>'Generator'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198077070401520)
,p_name=>'BUTTON LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Etichet\0103 buton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133022127401473)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'ro'
,p_message_text=>'Clase CSS butoane'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162253602401494)
,p_name=>'BUTTON_ID'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul butonului generat va fi fie ID-ul static al butonului dac\0103 este definit, iar dac\0103 nu este definit, va fi un ID generat intern cu formatul ''B'' || [Internal Button ID]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125768821401468)
,p_name=>'CANDLESTICK'
,p_message_language=>'ro'
,p_message_text=>unistr('Lum\00E2nare')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207291496401527)
,p_name=>'CENTER'
,p_message_language=>'ro'
,p_message_text=>'Centru'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157281019401490)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'ro'
,p_message_text=>'Solicitare %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148689954401484)
,p_name=>'CHECK$'
,p_message_language=>'ro'
,p_message_text=>unistr('Selector r\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114267793242401570)
,p_name=>'CHECKED'
,p_message_language=>'ro'
,p_message_text=>'bifat'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243261350401552)
,p_name=>'COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203734433401524)
,p_name=>'COMMENTS'
,p_message_language=>'ro'
,p_message_text=>'Comentarii'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185221931401511)
,p_name=>'CONTINUE'
,p_message_language=>'ro'
,p_message_text=>'Continuare'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147211993401483)
,p_name=>'COPYRIGHT'
,p_message_language=>'ro'
,p_message_text=>'Copyright &copy; %0, Toate drepturile rezervate.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190958018401515)
,p_name=>'COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197677302401520)
,p_name=>'CREATE'
,p_message_language=>'ro'
,p_message_text=>'Creare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249945704401557)
,p_name=>'CREATED'
,p_message_language=>'ro'
,p_message_text=>'Creat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250040862401557)
,p_name=>'CREATED_BY'
,p_message_language=>'ro'
,p_message_text=>'Creat de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174803638401503)
,p_name=>'CREATED_ON'
,p_message_language=>'ro'
,p_message_text=>unistr('Data cre\0103rii')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185470780401511)
,p_name=>'CUSTOM'
,p_message_language=>'ro'
,p_message_text=>'Personalizat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196640776401519)
,p_name=>'CUSTOMIZE'
,p_message_language=>'ro'
,p_message_text=>'Personalizare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198226214401520)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'ro'
,p_message_text=>unistr('Resetare preferin\0163e pagin\0103 pentru utilizatorul %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198399105401520)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'ro'
,p_message_text=>unistr('Preferin\0163ele au fost modificate pentru utilizatorul %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198147847401520)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'ro'
,p_message_text=>unistr('Resetare preferin\0163e pagin\0103 pentru utilizatorul %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161926140401494)
,p_name=>'DAILY'
,p_message_language=>'ro'
,p_message_text=>'Zilnic'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114133505980401473)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Fi\015Fierul \00EEnc\0103rcat este nevalid sau are o extensie gre\015Fit\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157464063401491)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'ro'
,p_message_text=>'Selectorul XML sau JSON utilizat este nevalid.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126761273401468)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'ro'
,p_message_text=>unistr('Profilul de date \015Fi fi\015Fierul \00EEnc\0103rcat nu con\0163in nicio coloan\0103 de tabel de destina\0163ie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212402939401530)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu au fost g\0103site date \00EEn fi\015Fierul \00EEnc\0103rcat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212516826401530)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu au fost g\0103site date \00EEn foaia de calcul "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114132376137401472)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Fi\015Fierul specificat nu este un fi\015Fier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114122776800401465)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcarea datelor a fost finalizat\0103: %0 r\00E2nduri procesate.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123977153401466)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcarea datelor a fost finalizat\0103: %0 r\00E2nduri procesate cu 1 eroare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124251553401467)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcarea datelor a fost finalizat\0103: %0 r\00E2nduri procesate cu %1 erori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124004737401466)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcarea datelor a fost finalizat\0103: 1 r\00E2nd procesat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127057846401469)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcarea datelor a fost finalizat\0103: 1 r\00E2nd procesat cu erori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124117680401467)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnc\0103rcarea datelor a fost finalizat\0103: 1 r\00E2nd procesat f\0103r\0103 erori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217714638401534)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 de destina\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217873174401534)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloan\0103 surs\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218632502401535)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'ro'
,p_message_text=>unistr('Format dat\0103 / num\0103r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282061193401580)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('E\015Fec la preluarea valorii func\0163iei de c\0103utare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114250591163401557)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'ro'
,p_message_text=>'Mapare date / tabel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218769409401535)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2nd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214280980401532)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('Regula de transformare a e\015Fuat')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190512743401515)
,p_name=>'DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Dat\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164637743401496)
,p_name=>'DAY'
,p_message_language=>'ro'
,p_message_text=>'zi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164755265401496)
,p_name=>'DAYS'
,p_message_language=>'ro'
,p_message_text=>'zile'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203422069401524)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'ro'
,p_message_text=>unistr('Depanarea nu este activat\0103 pentru aceast\0103 aplica\0163ie.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114252212186401559)
,p_name=>'DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165439828401496)
,p_name=>'DELETE'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Ftergere')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114125622541401468)
,p_name=>'DIAL_PCT'
,p_message_language=>'ro'
,p_message_text=>'Cadran (procent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140156673401478)
,p_name=>'DOWNLOAD'
,p_message_language=>'ro'
,p_message_text=>unistr('Desc\0103rcare')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251342723401558)
,p_name=>'DUP_USER'
,p_message_language=>'ro'
,p_message_text=>unistr('Nume de utilizator duplicat \00EEn cadrul listei.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147776100401483)
,p_name=>'EDIT'
,p_message_language=>'ro'
,p_message_text=>'Editare'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157124095401490)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Adresa de e-mail "%0" nu a fost g\0103sit\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142263535401479)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'ro'
,p_message_text=>'Acest e-mail este trimis de %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251513981401558)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'ro'
,p_message_text=>unistr('Adresa de e-mail este prea lung\0103. Limita este de 240 de caractere.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185120723401511)
,p_name=>'ERROR'
,p_message_language=>'ro'
,p_message_text=>'Eroare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214361496401532)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut seta valoarea sursei articolului paginii pentru regiunea de reactualizare par\0163ial\0103 a paginii')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176646877401505)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'ro'
,p_message_text=>'Creat de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142505127401480)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Parol\0103 expirat\0103')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114136652332401475)
,p_name=>'FILE_EMPTY'
,p_message_language=>'ro'
,p_message_text=>unistr('Fi\015Fierul este gol.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216837829401533)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Dimensiunea fi\015Fierului \00EEnc\0103rcat a fost peste %0 MB. \00CEnc\0103rca\0163i un fi\015Fier mai mic.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144641593401481)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Autentificarea utilizatorului a e\015Fuat \015Fi unul sau mai multe fi\015Fiere nu au fost \00EEnc\0103rcate.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144723210401481)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 instan\0163\0103 nu permite utilizatorilor neautentifica\0163i s\0103 \00EEncarce fi\015Fiere.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197726306401520)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'ro'
,p_message_text=>'A survenit 1 eroare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196951233401519)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Au survenit %0 erori'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147192613401483)
,p_name=>'FORM_OF'
,p_message_language=>'ro'
,p_message_text=>'%0 din %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181846826401508)
,p_name=>'GO'
,p_message_language=>'ro'
,p_message_text=>'Start'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281667205401580)
,p_name=>'HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Asisten\0163\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134035383401474)
,p_name=>'HOME'
,p_message_language=>'ro'
,p_message_text=>'Home'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164477118401496)
,p_name=>'HOUR'
,p_message_language=>'ro'
,p_message_text=>unistr('or\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164579539401496)
,p_name=>'HOURS'
,p_message_language=>'ro'
,p_message_text=>'ore'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148579474401484)
,p_name=>'ICON'
,p_message_language=>'ro'
,p_message_text=>unistr('Pictogram\0103 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198547655401520)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'ro'
,p_message_text=>unistr('Acredit\0103ri de conectare nevalide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114298038232401591)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoare nevalid\0103 pentru parametrul: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193215856401516)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'ro'
,p_message_text=>unistr('Ca set\0103ri prestabilite pentru raport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193337811401516)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'ro'
,p_message_text=>'Ca raport denumit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175744732401504)
,p_name=>'IR_ERROR'
,p_message_language=>'ro'
,p_message_text=>'%0 eroare. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175460279401504)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Nu s-a putut calcula navigarea formularului. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153018815401487)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Raportul interactiv nu a fost g\0103sit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152478605401487)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Regiunea de raportare interactiv\0103 nu exist\0103 \00EEn aplica\0163ia %0, pagina %1 \015Fi regiunea %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114193169504401516)
,p_name=>'IR_STAR'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fat numai pentru dezvoltatori')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181522459401508)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Interogarea raportului necesit\0103 o cheie unic\0103 pentru identificarea fiec\0103rui r\00E2nd. Cheia furnizat\0103 nu poate fi utilizat\0103 pentru aceast\0103 interogare. Defini\0163i o coloan\0103 pentru cheia unic\0103. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181603694401508)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'ro'
,p_message_text=>unistr('Interogarea raportului necesit\0103 o cheie unic\0103 pentru identificarea fiec\0103rui r\00E2nd. Cheia furnizat\0103 nu poate fi utilizat\0103 pentru aceast\0103 interogare. Edita\0163i atributele raportului pentru a defini o coloan\0103 de cheie unic\0103. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218913699401535)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare fi\015Fier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218880260401535)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ro'
,p_message_text=>unistr('Glisa\0163i \015Fi plasa\0163i fi\015Fierul aici sau')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147485805401483)
,p_name=>'ITEMS'
,p_message_language=>'ro'
,p_message_text=>'Articole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176886867401505)
,p_name=>'ITEM_VALUE'
,p_message_language=>'ro'
,p_message_text=>'Valoare element'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191229291401515)
,p_name=>'LABEL'
,p_message_language=>'ro'
,p_message_text=>unistr('Etichet\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203398697401524)
,p_name=>'LANGUAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Limb\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165140494401496)
,p_name=>'LAST'
,p_message_language=>'ro'
,p_message_text=>'ultimul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144589567401481)
,p_name=>'LENGTH'
,p_message_language=>'ro'
,p_message_text=>'Lungime'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197872480401520)
,p_name=>'LOGIN'
,p_message_language=>'ro'
,p_message_text=>'Conectare'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236493317401547)
,p_name=>'MANAGE'
,p_message_language=>'ro'
,p_message_text=>'Administrare'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301064505401594)
,p_name=>'MAXIMIZE'
,p_message_language=>'ro'
,p_message_text=>'Maximizare'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164274094401495)
,p_name=>'MINUTE'
,p_message_language=>'ro'
,p_message_text=>'minut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164301055401496)
,p_name=>'MINUTES'
,p_message_language=>'ro'
,p_message_text=>'minute'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251706856401558)
,p_name=>'MISSING_AT'
,p_message_language=>'ro'
,p_message_text=>unistr('Lipse\015Fte "@" \00EEn adres de e-mail.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251948366401558)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'ro'
,p_message_text=>unistr('Avertisment: Nu a fost definit niciun \015Fablon de pagin\0103 de dialog pentru pagina de dialog %0 din aplica\0163ia %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251605172401558)
,p_name=>'MISSING_DOT'
,p_message_language=>'ro'
,p_message_text=>unistr('Lipse\015Fte "." \00EEn domeniul adresei de e-mail.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200847663401522)
,p_name=>'MODULE'
,p_message_language=>'ro'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157966580401491)
,p_name=>'MONTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Lun\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161791756401494)
,p_name=>'MONTHLY'
,p_message_language=>'ro'
,p_message_text=>'Lunar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158025053401491)
,p_name=>'MONTHS'
,p_message_language=>'ro'
,p_message_text=>'luni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190829100401515)
,p_name=>'MOVE'
,p_message_language=>'ro'
,p_message_text=>'Mutare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258397371401563)
,p_name=>'MOVE_FROM'
,p_message_language=>'ro'
,p_message_text=>'Mutare de la'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258491534401563)
,p_name=>'MOVE_TO'
,p_message_language=>'ro'
,p_message_text=>unistr('Mutare \00EEn')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114178048883401506)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare \00EEn opera\0163ia de \015Ftergere pentru mai multe r\00E2nduri: r\00E2nd= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177067290401505)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ro'
,p_message_text=>'Utilizatorul nu poate fi public'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134280678401474)
,p_name=>'NAME'
,p_message_language=>'ro'
,p_message_text=>'Nume'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191070764401515)
,p_name=>'NEW'
,p_message_language=>'ro'
,p_message_text=>'Nou'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157707275401491)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('V\0103 pute\0163i conecta la %0 acces\00E2nd:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157816334401491)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEn\015Ftiin\0163are pentru cont %0 nou')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281880672401580)
,p_name=>'NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200703685401522)
,p_name=>'NO'
,p_message_language=>'ro'
,p_message_text=>'Nu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114296013331401590)
,p_name=>'NOBODY'
,p_message_language=>'ro'
,p_message_text=>'nimeni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165552004401496)
,p_name=>'NOT'
,p_message_language=>'ro'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206301640401526)
,p_name=>'NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>'Nu este nul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177148502401505)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'ro'
,p_message_text=>'Diferit de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196737785401519)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('nu au fost g\0103site date')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205847539401526)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost g\0103sit niciun raport actualizabil. Opera\0163iunile de actualizare \015Fi \015Ftergere pe multiple r\00E2nduri pot fi efectuate numai pe formulare tabelare de tipul ''Raport actualizabil''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206711100401526)
,p_name=>'OK'
,p_message_language=>'ro'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202465455401523)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'ro'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114299803625401593)
,p_name=>'ORA_06550'
,p_message_language=>'ro'
,p_message_text=>'ORA-06550: linia %0, coloana %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249364561401557)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'ro'
,p_message_text=>unistr('Utiliza\0163i un browser web perimat. Pentru o list\0103 de browsere acceptate, consulta\0163i ghidul de instalare Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150797862401486)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost cerut un set de r\00E2nduri nevalid, datele surs\0103 ale raportului au fost modificate.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170853409401500)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Trebuie specificat un num\0103r de pagin\0103 valid, de exemplu p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174421494401503)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnainte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174595276401503)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'ro'
,p_message_text=>unistr('Set urm\0103tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174689309401503)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114174769685401503)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'ro'
,p_message_text=>'Set precedent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281795647401580)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'ro'
,p_message_text=>'Selectare paginare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212377615401530)
,p_name=>'PASSWORD'
,p_message_language=>'ro'
,p_message_text=>unistr('Parol\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157001488401490)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola dvs. pentru %0 a fost schimbat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146812395401483)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola nu se conformeaz\0103 regulilor privind complexitatea parolei de pe acest site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145912735401482)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Noua parol\0103 trebuie s\0103 difere de parola veche cu cel pu\0163in %0 caractere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146531675401483)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola nu trebuie s\0103 con\0163in\0103 numele de utilizator.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146742094401483)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola con\0163ine un cuv\00E2nt simplu interzis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146641794401483)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola nu trebuie s\0103 con\0163in\0103 numele spa\0163iului de lucru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145810551401482)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola trebuie s\0103 con\0163in\0103 cel pu\0163in %0 caractere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146006418401482)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola trebuie s\0103 con\0163in\0103 cel pu\0163in un caracter alfabetic (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146477399401483)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola trebuie s\0103 con\0163in\0103 cel pu\0163in un caracter alfabetic minuscul\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146109693401482)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola trebuie s\0103 con\0163in\0103 cel pu\0163in o cifr\0103 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146278989401482)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola trebuie s\0103 con\0163in\0103 cel pu\0163in un caracter de punctua\0163ie (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114146328242401482)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola trebuie s\0103 con\0163in\0103 cel pu\0163in un caracter alfabetic majuscul\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157588154401491)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEn\015Ftiin\0163are despre resetarea parolei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144892958401481)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Parola nu poate fi utilizat\0103 deoarece a fost utilizat\0103 \00EEn ultimele %0 zile.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225142666401539)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ro'
,p_message_text=>'Articole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114225223847401539)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ro'
,p_message_text=>'Articol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202241716401523)
,p_name=>'PERCENT'
,p_message_language=>'ro'
,p_message_text=>'Procent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172517667401502)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'ro'
,p_message_text=>unistr('Contacta\0163i administratorul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114281945279401580)
,p_name=>'PREVIOUS'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnapoi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217327087401534)
,p_name=>'PRINT'
,p_message_language=>'ro'
,p_message_text=>unistr('Tip\0103rire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201021352401522)
,p_name=>'PRIVILEGES'
,p_message_language=>'ro'
,p_message_text=>'Privilegii'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170945818401500)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'ro'
,p_message_text=>unistr('Referin\0163e regiune')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191131475401515)
,p_name=>'REPORT'
,p_message_language=>'ro'
,p_message_text=>'Raport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200927395401522)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'ro'
,p_message_text=>unistr('Perioad\0103 de raportare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282139303401580)
,p_name=>'REPORT_LABEL'
,p_message_language=>'ro'
,p_message_text=>'Raport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201652054401522)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'ro'
,p_message_text=>'Total raport'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150873670401486)
,p_name=>'RESET'
,p_message_language=>'ro'
,p_message_text=>'Resetare paginare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176719449401505)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'ro'
,p_message_text=>'Resetare paginare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205745966401525)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'ro'
,p_message_text=>unistr('Resetare parol\0103')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182533239401509)
,p_name=>'RESTORE'
,p_message_language=>'ro'
,p_message_text=>'Restabilire'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114214439738401532)
,p_name=>'RESULTS'
,p_message_language=>'ro'
,p_message_text=>'Rezultate'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206872953401526)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Revenire la aplica\0163ie.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114207165702401526)
,p_name=>'RIGHT'
,p_message_language=>'ro'
,p_message_text=>'Dreapta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236713682401548)
,p_name=>'ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2ndul %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190787660401515)
,p_name=>'ROW_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103r de r\00E2nduri')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114206289669401526)
,p_name=>'SAVE'
,p_message_language=>'ro'
,p_message_text=>'Salvare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202819841401523)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203277087401524)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'ro'
,p_message_text=>'Descriere'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202762108401523)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit principal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203549179401524)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'ro'
,p_message_text=>unistr('Mai mult de %0 r\00E2nduri disponibile. Cre\015Fte\0163i selectorul r\00E2ndurilor pentru a vedea mai multe r\00E2nduri.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268963124401570)
,p_name=>'SEARCH'
,p_message_language=>'ro'
,p_message_text=>unistr('C\0103utare')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164126999401495)
,p_name=>'SECONDS'
,p_message_language=>'ro'
,p_message_text=>'secunde'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202347599401523)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'ro'
,p_message_text=>unistr('Consulta\0163i ata\015Famentul')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260000281401564)
,p_name=>'SELECT_ROW'
,p_message_language=>'ro'
,p_message_text=>unistr('Selectare r\00E2nd')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202054043401523)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'ro'
,p_message_text=>unistr('Seta\0163i modul Cititor ecran ca dezactivat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202119430401523)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'ro'
,p_message_text=>unistr('Seta\0163i modul Cititor ecran ca activat')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198446624401520)
,p_name=>'SHOW'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261801786401565)
,p_name=>'SHOW_ALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare tot')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114287932482401584)
,p_name=>'SIGN_IN'
,p_message_language=>'ro'
,p_message_text=>'Conectare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114237570306401548)
,p_name=>'SIGN_OUT'
,p_message_language=>'ro'
,p_message_text=>'Deconectare'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191776220401515)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 zile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198929196401521)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>'Peste %0 zile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191634412401515)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198828035401520)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>'Peste %0 ore'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191593028401515)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198730570401520)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>'Peste %0 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191962046401516)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 luni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199165678401521)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>'Peste %0 luni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199315032401521)
,p_name=>'SINCE_NOW'
,p_message_language=>'ro'
,p_message_text=>'Acum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191415970401515)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 secunde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114198670099401520)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>'Peste %0 secunde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114191825641401515)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'ro'
,p_message_text=>unistr('Acum %0 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199007433401521)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>unistr('Peste %0 s\0103pt\0103m\00E2ni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114192059399401516)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'ro'
,p_message_text=>'Acum %0 ani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199287849401521)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'ro'
,p_message_text=>'Peste %0 ani'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185520742401511)
,p_name=>'STANDARD'
,p_message_language=>'ro'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201937119401523)
,p_name=>'START_DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('Data ini\0163ial\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142469400401480)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'ro'
,p_message_text=>unistr('Primi\0163i acest e-mail de la abonamentul de raportare interactiv\0103 creat de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297153629401591)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'ro'
,p_message_text=>'Abonamente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245295758401554)
,p_name=>'TAB'
,p_message_language=>'ro'
,p_message_text=>unistr('Fil\0103')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164029403401495)
,p_name=>'TITLE'
,p_message_language=>'ro'
,p_message_text=>'Titlu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147022891401483)
,p_name=>'TODAY'
,p_message_language=>'ro'
,p_message_text=>unistr('Ast\0103zi')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201502999401522)
,p_name=>'TOTAL'
,p_message_language=>'ro'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148026112401484)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'ro'
,p_message_text=>'Se pot selecta maxim %0 coloane.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126530044401468)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Restr\00E2ngere tot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126876567401468)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'ro'
,p_message_text=>unistr('Restr\00E2ngere toate de mai jos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126423342401468)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'ro'
,p_message_text=>'Extindere tot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126695192401468)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'ro'
,p_message_text=>'Expandare toate de mai jos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126932427401468)
,p_name=>'TREE.REPARENT'
,p_message_language=>'ro'
,p_message_text=>unistr('Restabilire p\0103rinte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219139428401535)
,p_name=>'TREES'
,p_message_language=>'ro'
,p_message_text=>'Arbori'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114262654111401566)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'ro'
,p_message_text=>'Obligatoriu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114186219563401511)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'ro'
,p_message_text=>'Neautorizat'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114233077828401545)
,p_name=>'UNAVAILABLE'
,p_message_language=>'ro'
,p_message_text=>'Indisponibil'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199720702401521)
,p_name=>'UNKNOWN'
,p_message_language=>'ro'
,p_message_text=>'Necunoscut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143327858401480)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('A survenit o eroare de autentificare nerecunoscut\0103.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145353641401482)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'ro'
,p_message_text=>unistr('Dac\0103 nu mai dori\0163i s\0103 primi\0163i e-mailuri, face\0163i clic pe <a href="%0">dezabonare</a> pentru administrarea abonamentului.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114142320374401480)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'ro'
,p_message_text=>unistr('Dac\0103 nu mai dori\0163i s\0103 primi\0163i aceste e-mailuri, accesa\0163i urm\0103toarea adres\0103 URL pentru administrarea abonamentului:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114177240815401505)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>'Tip de date neacceptat'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165374922401496)
,p_name=>'UPDATE'
,p_message_language=>'ro'
,p_message_text=>'actualizare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163958376401495)
,p_name=>'UPDATED'
,p_message_language=>'ro'
,p_message_text=>'Actualizat'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170681082401500)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'ro'
,p_message_text=>unistr('Adresa URL solicitat\0103 a fost interzis\0103. Contacta\0163i administratorul.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114190618301401515)
,p_name=>'USER'
,p_message_language=>'ro'
,p_message_text=>'Utilizator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114212200009401530)
,p_name=>'USERNAME'
,p_message_language=>'ro'
,p_message_text=>'Nume de utilizator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251898270401558)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'ro'
,p_message_text=>'Numele de utilizator este prea lung. Limita este de %0 de caractere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197434567401519)
,p_name=>'USERS'
,p_message_language=>'ro'
,p_message_text=>'utilizatori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114251495786401558)
,p_name=>'USER_EXISTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Numele de utilizator exist\0103 deja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114266134755401568)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'ro'
,p_message_text=>'Imagine de profil pentru utilizatorul %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153708268401488)
,p_name=>'VALID'
,p_message_language=>'ro'
,p_message_text=>'Valid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147360111401483)
,p_name=>'VALIDATIONS'
,p_message_language=>'ro'
,p_message_text=>unistr('Valid\0103ri')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203094475401524)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoarea trebuie specificat\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246499475401554)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'ro'
,p_message_text=>unistr('Trebuie s\0103 fie specificat\0103 valoarea pentru %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172950227401502)
,p_name=>'VERTICAL'
,p_message_language=>'ro'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165253176401496)
,p_name=>'VIEW'
,p_message_language=>'ro'
,p_message_text=>'vizualizare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197569078401520)
,p_name=>'VIEWS'
,p_message_language=>'ro'
,p_message_text=>unistr('vizualiz\0103ri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203840008401524)
,p_name=>'VIEW_ALL'
,p_message_language=>'ro'
,p_message_text=>unistr('Vizualizare global\0103')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114185003138401511)
,p_name=>'WARNING'
,p_message_language=>'ro'
,p_message_text=>'Avertisment'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164832697401496)
,p_name=>'WEEK'
,p_message_language=>'ro'
,p_message_text=>unistr('s\0103pt\0103m\00E2n\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161839253401494)
,p_name=>'WEEKLY'
,p_message_language=>'ro'
,p_message_text=>unistr('S\0103pt\0103m\00E2nal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114164989413401496)
,p_name=>'WEEKS'
,p_message_language=>'ro'
,p_message_text=>unistr('s\0103pt\0103m\00E2ni')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114203189191401524)
,p_name=>'WELCOME_USER'
,p_message_language=>'ro'
,p_message_text=>'Bun venit: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201356906401522)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost g\0103sit\0103 o valoare nevalid\0103, verifica\0163i datele introduse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201412067401522)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost g\0103sit\0103 o valoare nevalid\0103, verifica\0163i datele introduse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144462206401481)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost g\0103sit\0103 o valoare de dat\0103 nevalid\0103, verifica\0163i formatul datei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114201262036401522)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost g\0103sit\0103 o valoare numeric\0103 nevalid\0103, verifica\0163i formatul num\0103rului.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153390202401488)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'ro'
,p_message_text=>unistr('S-a g\0103sit o valoare nevalid\0103 pentru marcajul temporal, verifica\0163i formatul marcajului temporal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114175869876401504)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut lega "%0". Utiliza\0163i ghilimele duble pentru articolele multi byte sau verifica\0163i lungimea articolului pentru a fi de 30 de bytes sau mai mic\0103. Utiliza\0163i sintaxa v() pentru referin\0163\0103 la articolele cu lungime mai mare de 30 de bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166306094401497)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'ro'
,p_message_text=>'Acces interzis de verificarea de securitate %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168815621401499)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Aplica\0163ia nu este disponibil\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167213153401498)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1014 Aplica\0163ia nu a fost g\0103sit\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167323190401498)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('aplica\0163ie=%0 spa\0163iu de lucru=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167739489401498)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'ro'
,p_message_text=>unistr('Accesul la aceast\0103 aplica\0163ie este restric\0163ionat, re\00EEncerca\0163i mai t\00E2rziu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167642281401498)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'ro'
,p_message_text=>unistr('Accesul la aceast\0103 aplica\0163ie este restric\0163ionat la dezvoltatori, re\00EEncerca\0163i mai t\00E2rziu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166837278401497)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-7744 Nu s-a putut procesa adresa URL de retur pentru Ramur\0103 la func\0163ie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166755546401497)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-7744 Nu s-a putut procesa pagina de retur pentru Ramur\0103 la func\0163ie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167013719401498)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1430 Procesul Apel pentru afi\015Fare din pagin\0103 nu este acceptat: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168113650401498)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1018 Eroare la golirea memoriei cache pentru etap\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166501029401497)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'ro'
,p_message_text=>'ERR-1005 Tip de calcul necunoscut.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167431780401498)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1201 ID-ul sesiunii nu este setat pentru autentificarea personalizat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167544509401498)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'ro'
,p_message_text=>'pagina=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114167112907401498)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-7620 Nu s-a putut determina spa\0163iul de lucru pentru aplica\0163ie (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149567157401485)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'ro'
,p_message_text=>'Editare'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166225831401497)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1802 Nu s-a putut g\0103si ID-ul de articol "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165956732401497)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1002 Nu s-a putut g\0103si ID-ul de articol pentru articolul "%0" din aplica\0163ia "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166065314401497)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare nea\015Fteptat\0103, nu s-a putut g\0103si numele articolului la nivel de aplica\0163ie sau pagin\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166459590401497)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Sunte\0163i deja pe prima pagin\0103 a datelor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114181927753401508)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul articolului (%0) nu este un articol definit pe pagina curent\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144050839401481)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'ro'
,p_message_text=>unistr('Articolul nu poate fi setat prin trecerea argumentelor c\0103tre aplica\0163ie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144301929401481)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'ro'
,p_message_text=>unistr('(Nu a fost furnizat\0103 nicio sum\0103 de control)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143819829401481)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'ro'
,p_message_text=>unistr('Articolul poate fi setat c\00E2nd este \00EEnso\0163it de o sum\0103 de control "semn de carte la nivel de utilizator".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143728147401481)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'ro'
,p_message_text=>unistr('Articolul poate fi setat c\00E2nd este \00EEnso\0163it de o sum\0103 de control "semn de carte la nivel de aplica\0163ie".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143983160401481)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'ro'
,p_message_text=>unistr('Articolul poate fi setat c\00E2nd este \00EEnso\0163it de o sum\0103 de control "sesiune".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143619357401481)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'ro'
,p_message_text=>unistr('Articolul nu are nicio protec\0163ie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168276759401498)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu este disponibil\0103 nicio pagin\0103 de asisten\0163\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114157327322401491)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'ro'
,p_message_text=>unistr('Spa\0163iul de lucru %0 nu are privilegii pentru interpretare ca schema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166624169401497)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1010 Limita de acceptare a proces\0103rilor pentru recursie a fost dep\0103\015Fit\0103 pentru Ramur\0103 la pagin\0103. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144255652401481)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 pagin\0103 nu poate fi invocat\0103 utiliz\00E2nd o adres\0103 URL sau utiliz\00E2nd o func\0163ie GET sau POST pentru afi\015Farea procedurii, trebuie s\0103 fie apelat\0103 utiliz\00E2nd un tip de ramur\0103 "ramur\0103 la pagin\0103".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114220994404401536)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la \00EEncercarea salv\0103rii unei valori non-numerice \00EEn articolul %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159047502401492)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Schema de interpretare a aplica\0163iei "%0" nu exist\0103 \00EEn baza de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114159120230401492)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'ro'
,p_message_text=>unistr('Conturile din spa\0163iul de lucru INTERNAL pot fi utilizate numai pentru accesarea &PRODUCT_NAME. <a href="%0">Servicii de administrare</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165855442401497)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-1029 Nu s-au putut stoca informa\0163iile sesiunii. sesiune=%0 articol=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168983235401499)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut opri urm\0103rirea: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114166174102401497)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare nea\015Fteptat\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176136166401504)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare \00EEn update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169074088401499)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Aplica\0163ia \015Fi pagina trebuie s\0103 fie furnizate pentru vizualizarea asisten\0163ei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114189539017401514)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Automatizarea nu a fost g\0103sit\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170117101401500)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'ro'
,p_message_text=>'S-au eliminat %0 sesiuni.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129430674401470)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut executa codul %0! Nu este acceptat de baza de date sau nu este activat de parametrul de instan\0163\0103 MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114129295946401470)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'ro'
,p_message_text=>unistr('Motorul \00EEn mai multe limbi nu este disponibil \00EEn aceast\0103 versiune de baz\0103 de date!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150045050401485)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Matricea pentru colec\0163ia aplica\0163iei nu trebuie s\0103 fie nul\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149886330401485)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Num\0103rul de atribut %0 pentru membrul specificat este nevalid. Num\0103rul de atribut trebuie s\0103 fie \00EEntre 1 \015Fi %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150308546401485)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Colec\0163ia aplica\0163iei exist\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150188049401485)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('Numele colec\0163iei nu poate fi nul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150264545401485)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Numele colec\0163iei nu poate fi mai lung de 255 de caractere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149635809401485)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Colec\0163ia aplica\0163iei %0 nu exist\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150471550401485)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'ro'
,p_message_text=>unistr('Cursorul nu este \00EEnc\0103 deschis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149735918401485)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Secven\0163a membru %0 nu exist\0103 \00EEn colec\0163ia aplica\0163iei %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114149930043401485)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Secven\0163a membru %0 nu exist\0103 \00EEn colec\0163ia aplica\0163iei "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221777943401537)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Func\0163ia criptografic\0103 "%0" nu este acceptat\0103 \00EEn acest sistem.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275289227401575)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Accesibilitatea a fost testat\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169636371401499)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEnchidere')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169715286401499)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'ro'
,p_message_text=>unistr('Op\0163iuni de personalizare pentru pagin\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169853149401500)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'ro'
,p_message_text=>'Prestabilit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169977107401500)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170064876401500)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'ro'
,p_message_text=>'Ascuns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169445911401499)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'ro'
,p_message_text=>unistr('Bifa\0163i regiunile pe care dori\0163i s\0103 le include\0163i \00EEn aceast\0103 pagin\0103. Este posibil ca regiunile bifate s\0103 nu fie afi\015Fate dac\0103 nu sunte\0163i \00EEn contextul de aplica\0163ie corect sau dac\0103 nu ave\0163i privilegiile adecvate.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169535778401499)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 pagin\0103 nu poate fi personalizat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275581033401575)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'ro'
,p_message_text=>unistr('Pute\0163i personaliza aspectul acestei aplica\0163ii prin modificarea stilului temei. Selecta\0163i un stil de tem\0103 din lista de mai jos \015Fi face\0163i clic pe Aplicare modific\0103ri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114276392401401576)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'ro'
,p_message_text=>unistr('Afi\015Fare regiune')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275404027401575)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Utilizare stil prestabilit aplica\0163ie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114275382718401575)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'ro'
,p_message_text=>'Aspect '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218343803401534)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Indexul de coloane folosit ca referin\0163\0103 \00EEn agregarea %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114121644439401465)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'ro'
,p_message_text=>'Rezultatul CLOB nu este acceptat pentru formatul %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218096274401534)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'ro'
,p_message_text=>unistr('\00CEntreruperea coloanei trebuie s\0103 fie la \00EEnceputul matricei coloanei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218193842401534)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Indexul grupului de coloane folosit ca referin\0163\0103 \00EEn %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114135600886401475)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'ro'
,p_message_text=>'Export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114140849506401478)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'ro'
,p_message_text=>unistr('Formatul de exportare trebuie s\0103 fie XML utiliz\00E2nd ORDS ca server de tip\0103rire.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218499553401535)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Indexul de coloane folosit ca referin\0163\0103 \00EEn eviden\0163ierea %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134192488401474)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'ro'
,p_message_text=>'Format de exportare nevalid: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114218249893401534)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Indexul grupului p\0103rinte folosit ca referin\0163\0103 \00EEn %0 nu exist\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114243413200401552)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana %1 a tabelului %0 este o coloan\0103 de identitate "GENERATED ALWAYS". Verifica\0163i ca nicio coloan\0103 surs\0103 s\0103 nu fie mapat\0103 la coloana %1 din dialogul de configurare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160835225401493)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'ro'
,p_message_text=>'Intervalul de confirmare specificat este prea mic.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114160970711401493)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost furnizat\0103 nicio coloan\0103 pentru \00EEnc\0103rcarea datelor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162145432401494)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost g\0103sit\0103 nicio coloan\0103 pentru selectorul de r\00E2nduri "%0". \00CEncerca\0163i detectarea automat\0103 sau examina\0163i structura JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170480277401500)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost g\0103sit\0103 nicio foaie de calcul \00EEn fi\015Fierul XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170371364401500)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'ro'
,p_message_text=>unistr('Foaia de calcul specificat\0103 nu exist\0103 \00EEn fi\015Fierul XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114150561645401485)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'ro'
,p_message_text=>unistr('Versiunea curent\0103 a datelor din baza de date s-a schimbat de c\00E2nd utilizatorul a ini\0163iat procesul de actualizare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152987075401487)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'ro'
,p_message_text=>'Eroare la actualizarea coloanelor raportului: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257676062401562)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'ro'
,p_message_text=>'Nu se poate converti %0 la SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197180208401519)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana %0 care are tipul de date %1 nu poate fi convertit\0103 la VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204136511401524)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana "%0" specificat\0103 pentru atributul "%1" nu a fost g\0103sit\0103 \00EEn sursa de date!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145496781401482)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'ro'
,p_message_text=>'Filtrul de tipul %0 nu este acceptat pentru coloane multi-valoare.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114261097211401565)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Filtru "\00EEntre" nevalid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127595027401469)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Tipul de list\0103 de valori specificat este nevalid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127413809401469)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Tip de interogare nevalid. Tipul de interogare trebuie s\0103 fie Tabel, interogare SQL query sau func\0163ie PL/SQL ce returneaz\0103 interogarea SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197224764401519)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('E\015Fec la interpretarea interog\0103rii SQL!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204258584401524)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Pozi\0163ia specificat\0103 a coloanei %0 pentru atributul "%1" nu a fost g\0103sit\0103 \00EEn instruc\0163iunea SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114126098367401468)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'ro'
,p_message_text=>unistr('Prea multe articole utilizate \00EEn filtrul cu valori multiple.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204048896401524)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost specificat\0103 nicio coloan\0103 pentru atributul "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127306000401469)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Corpul func\0163iei PL/SQL nu a returnat o valoare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114217276637401534)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'ro'
,p_message_text=>unistr('Sursa de date REST nu con\0163ine o opera\0163ie pentru tratarea ac\0163iunii DML cerute.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114123275482401466)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'ro'
,p_message_text=>unistr('Conversia GeoJSON la SDO_GEOMETRY (coloana %0) nu este disponibil\0103 \00EEn aceast\0103 baz\0103 de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124378491401467)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'ro'
,p_message_text=>unistr('Conversia SDO_GEOMETRY (coloana %0) nu este acceptat\0103 pentru sursele de date XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114131606086401472)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'ro'
,p_message_text=>'Caracterul %0 nu este acceptat ca un separator de valori multiple.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114258922006401563)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 func\0163ie nu poate fi utilizat\0103 \00EEntr-un context de interogare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114124416908401467)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Nepotrivire tipuri de date pentru coloan\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127259686401469)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'ro'
,p_message_text=>unistr('Limitele interne de legare ORDS OUT au fost dep\0103\015Fite. Reduce\0163i num\0103rul de r\00E2nduri DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114205010906401525)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('R\0103spunsul JSON de la serverul la distan\0163\0103 nu poate fi interpretat: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114127151052401469)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Tip de context necunoscut sau gre\015Fit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114221635944401537)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Acest tip de fi\015Fier nu este acceptat de interpretor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176237379401504)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'ro'
,p_message_text=>'Acces neautorizat (wwv_flow_api.set_credentials not set).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153240467401487)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'ro'
,p_message_text=>unistr('Spa\0163iul de lucru nu a fost creat deoarece exist\0103 deja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114153160537401487)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'ro'
,p_message_text=>unistr('Grupul de utilizatori nu a fost creat deoarece exist\0103 deja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163466701401495)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'ro'
,p_message_text=>unistr('Nume de utilizator duplicat g\0103sit pentru %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163562515401495)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la \00EEnc\0103rcarea utilizatorilor. E\015Fec la utilizatorul %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173442052401502)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'ro'
,p_message_text=>unistr('Ar fi \00EEnc\0103rcat %0 utilizatori.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173287050401502)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'ro'
,p_message_text=>unistr('Parol\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173347078401502)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'ro'
,p_message_text=>'Privilegii'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173025551401502)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'ro'
,p_message_text=>'Nume de utilizator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249506444401557)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la randarea articolului de pagin\0103 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169150906401499)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu se poate afi\015Fa articolul paginii deoarece formularul HTML nu a fost \00EEnc\0103 deschis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114134453219401474)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la calcularea valorii prestabilite a articolului pentru articolul paginii #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168494017401499)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la post calcularea articolului pentru articolul paginii #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168321579401498)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la calcularea valorii surs\0103 a articolului pentru articolul paginii #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148173026401484)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'ro'
,p_message_text=>'Acces neautorizat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168669929401499)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'ro'
,p_message_text=>'Script-ul Java nu este acceptat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168782214401499)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'ro'
,p_message_text=>unistr('List\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114169366516401499)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut ini\0163ializa interogarea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176568585401504)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Actualizarea %0 nu este acceptat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114170715622401500)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'ro'
,p_message_text=>'ID articol nevalid: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114197086266401519)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu exist\0103 asisten\0163\0103 pentru acest articol.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161558730401494)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('Generarea interog\0103rii diagramei a e\015Fuat. Verifica\0163i set\0103rile de mapare pentru surs\0103 \015Fi coloan\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256397566401561)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'ro'
,p_message_text=>unistr('Ata\015Famentul cu dimensiunea %0 MB dep\0103\015Fe\015Fte dimensiunea maxim\0103 a ata\015Famentului de %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162451672401494)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoare nevalid\0103 pentru parametrul p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114279889660401578)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'ro'
,p_message_text=>unistr('A\0163i dep\0103\015Fit num\0103rul maxim de mesaje de e-mail per spa\0163iu de lucru. Contacta\0163i administratorul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143467832401480)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'ro'
,p_message_text=>unistr('Aceast\0103 procedur\0103 trebuie s\0103 fie invocat\0103 dintr-o sesiune de aplica\0163ie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162333824401494)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost furnizat\0103 o valoare nul\0103 pentru parametrul %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216376002401533)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('\015Eablonul de e-mail "%0" nu a fost g\0103sit \00EEn aplica\0163ia %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114292835082401588)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Parametrul instan\0163ei SMTP_HOST_ADDRESS trebuie setat pentru trimiterea e-mailurilor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162021593401494)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Trebuie s\0103 asigura\0163i un destinatar pentru mesaj pentru a trimite e-mailul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114282253754401580)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'ro'
,p_message_text=>'Nu s-a putut stabili conexiunea SMTP cu serverul de e-mail configurat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114256406654401562)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'ro'
,p_message_text=>'Apel Ajax nevalid!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147814433401484)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost definit\0103 nicio func\0163ie Ajax pentru plug-inul %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246899308401555)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost definit\0103 nicio func\0163ie de executare pentru plug-inul %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147952277401484)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost definit\0103 nicio func\0163ie de randare pentru plug-inul %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257368848401562)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Plug-inul "%0" pentru sursa de date REST nu con\0163ine o func\0163ie "Func\0163ionalit\0103\0163i".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257273272401562)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Plug-inul "%0" pentru sursa de date REST nu con\0163ine o func\0163ie DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257450717401562)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Plug-inul "%0" pentru sursa de date REST nu con\0163ine o func\0163ie de executare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114257586546401562)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'ro'
,p_message_text=>unistr('Plug-inul "%0" pentru sursa de date REST nu con\0163ine o func\0163ie de preluare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145646025401482)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare \00EEn codul PLSQL generat\0103 \00EEn timpul proces\0103rii pentru plug-in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152238805401487)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoarea trebuie specificat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182830258401509)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ro'
,p_message_text=>'Tipul de date %0 nu poate fi convertit la VARCHAR2!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268485861401570)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana "%0" specificat\0103 pentru atributul "%1" nu a fost g\0103sit\0103 \00EEn instruc\0163iunea SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244773454401553)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'ro'
,p_message_text=>unistr('O interogare list\0103 de valori (LOV) sau o list\0103 de valori denumit\0103 trebuie s\0103 fie specificat\0103 pentru %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114246363557401554)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ro'
,p_message_text=>unistr('A fost selectat un num\0103r gre\015Fit de coloane \00EEn interogarea SQL list\0103 de valori pentru %0. Consulta\0163i exemplele pentru instruc\0163iunile valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268213545401570)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu a fost specificat\0103 nicio coloan\0103 pentru atributul "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297958081401591)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Valoarea introdus\0103 %0 pentru atributul "%1" nu este numeric\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114249825974401557)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('%0 are tipul de date gre\015Fit \00EEn instruc\0163iunea SQL. Coloana# %1 este %2 dar se a\015Ftepta %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114268396521401570)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana "%0" specificat\0103 pentru atributul "%1" are tipul de date %2 dar trebuia s\0103 aib\0103 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114144929656401481)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut g\0103si macheta de rapoarte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204950154401525)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'ro'
,p_message_text=>unistr('Caracteristica de sum\0103 Compute nu poate fi utilizat\0103 pentru rapoartele bazate pe o surs\0103 de date REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114168564427401499)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('ERR-2904 Nu s-a putut seta valoarea scurt\0103turii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114172815795401502)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare: Tip de scurt\0103tur\0103 necunoscut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114162847170401495)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'ro'
,p_message_text=>unistr('Nu s-a putut prelua authentication_scheme \00EEn aplica\0163ia %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114236396406401547)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'ro'
,p_message_text=>unistr('ID-ul de tenant exist\0103 deja pentru sesiunea curent\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114173194706401502)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'ro'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297390767401591)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'ro'
,p_message_text=>unistr('Autentificare e\015Fuat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114199672902401521)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'ro'
,p_message_text=>unistr('Unul sau mai multe module cookie setate \00EEn apex_util.g_request_cookies con\0163in o valoare nevalid\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114182169724401508)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'ro'
,p_message_text=>unistr('R\0103spunsul de la registrul UDDI a fost nevalid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114145791135401482)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'ro'
,p_message_text=>unistr('Adresa URL furnizat\0103 nu a returnat un document WSDL valid.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114148241586401484)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'ro'
,p_message_text=>unistr('Documentul WSDL con\0163ine multiple leg\0103turi SOAP. &PRODUCT_NAME. accept\0103 doar WSDL-uri cu o singur\0103 leg\0103tur\0103 SOAP. Face\0163i clic pe Creare referin\0163\0103 serviciu web manual pentru a continua crearea unei referin\0163e pentru acest serviciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114216658350401533)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'ro'
,p_message_text=>unistr('R\0103spunsul de la serviciu nu a fost XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297282768401591)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'ro'
,p_message_text=>'Tokenul de acces OAuth nu este disponibil sau a expirat.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114260430188401564)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'ro'
,p_message_text=>unistr('A\0163i dep\0103\015Fit num\0103rul maxim de cereri serviciu web per spa\0163iu de lucru. Contacta\0163i administratorul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114297484685401591)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'ro'
,p_message_text=>unistr('Serverul a r\0103spuns cu un tip de token OAuth neacceptat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147617321401483)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'ro'
,p_message_text=>unistr('Documentul WSDL nu a con\0163inut o legare pentru SOAP, aceasta fiind obligatorie pentru ad\0103ugarea referin\0163ei.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114143523540401480)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'ro'
,p_message_text=>unistr('Acest WSDL necesit\0103 acredit\0103ri de autentificare. Furniza\0163i numele de utilizator \015Fi parola mai jos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114152368162401487)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'ro'
,p_message_text=>unistr('Documentul WSDL nu a putut fi \00EEn\0163eles de motorul de randare. Face\0163i clic pe Creare referin\0163\0103 serviciu web manual pentru a continua crearea unei referin\0163e pentru acest serviciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114219227581401535)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'ro'
,p_message_text=>'Nu s-a putut procesa actualizarea.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114245035031401554)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloanele de retur \015Fi afi\015Fare pentru lista de valori sunt identice!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114244976741401553)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Lista de valori nu are o coloan\0103 de retur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176405884401504)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la preluarea valorii coloanei: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200463115401522)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'ro'
,p_message_text=>unistr('Datele curente \00EEn format tabelar sunt prea vechi; datele surs\0103 au fost modificate.<br/> Face\0163i clic <strong><a href="%0">aici</a></strong> pentru a abandona modific\0103rile \015Fi a re\00EEnc\0103rca datele din baza de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158541455401491)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la determinarea \015Firului de paginare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158417114401491)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nu se pot determina anteturile interog\0103rii:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158604718401491)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'ro'
,p_message_text=>unistr('Eroare la efectuarea \00EEnlocuirilor pentru notele de subsol ale raportului')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158730377401492)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('E\015Fec la interpretarea interog\0103rii SQL:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163739769401495)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'ro'
,p_message_text=>unistr('R\00E2ndul minim solicitat: %0, r\00E2nduri g\0103site dar neafi\015Fate: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161215141401493)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana de interogare #%0 (%1) este nevalid\0103, coloanele care utilizeaz\0103 HTML necesit\0103 nume de alias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114176398136401504)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'ro'
,p_message_text=>'Eroare la preluarea anteturilor de interogare: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158860885401492)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Raport de eroare:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114196540492401519)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'ro'
,p_message_text=>unistr('Sorta\0163i dup\0103 aceast\0103 coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161351413401493)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'ro'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interogarea nu poate fi interpretat\0103, verifica\0163i sintaxa pentru interogare.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200564114401522)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'ro'
,p_message_text=>unistr('Acest formular con\0163ine modific\0103ri nesalvate. Ap\0103sa\0163i "OK" pentru a continua f\0103r\0103 salvarea modific\0103rilor. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114204832317401525)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'ro'
,p_message_text=>unistr('Schema de paginare a raportului (%0) nu este acceptat\0103 cu sursa de date selectat\0103.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114161162835401493)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'ro'
,p_message_text=>unistr('Coloana de interogare #%0 (%1) este nevalid\0103, utiliza\0163i aliasul de coloan\0103')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163824847401495)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'ro'
,p_message_text=>unistr('r\00E2ndurile %0 - %1 din mai mult de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114202536072401523)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'ro'
,p_message_text=>'%0 - %1 din mai mult de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114163606381401495)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'ro'
,p_message_text=>unistr('r\00E2ndurile %0 - %1 din %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114147551101401483)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'ro'
,p_message_text=>'%0 - %1 din %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158982612401492)
,p_name=>'Y'
,p_message_language=>'ro'
,p_message_text=>'D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114165080770401496)
,p_name=>'YEAR'
,p_message_language=>'ro'
,p_message_text=>'an'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114158103256401491)
,p_name=>'YEARS'
,p_message_language=>'ro'
,p_message_text=>'ani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114200642381401522)
,p_name=>'YES'
,p_message_language=>'ro'
,p_message_text=>'Da'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4543)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4543)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4543
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4543)
,p_name=>'Mesaje'
,p_alias=>'MESSAGES'
,p_step_title=>'Mesaje'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
