prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4544
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4544 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4544
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103361037403796')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'ru'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4544)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113353'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4544)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4544)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4544)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4544)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4544)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4544)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.ru'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4544)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4544)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4544)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4544)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4544)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4544)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.ru'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4544)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4544)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4544)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4544)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4544)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4544)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.ru'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4544)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4544)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.ru'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4544)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4544)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.ru'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4544)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4544)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.ru'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4544)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4544)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4544)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.ru'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4544
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4544)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4544)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4544)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4544
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4544)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4544
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4544)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4544
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4544)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4544
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4544)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4544
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4544)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4544
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4544
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4544)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4544)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4544)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4544)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4544)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4544)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4544)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4544)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4544)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4544)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4544)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4544)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4544)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4544)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4544)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4544)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4544)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4544)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4544)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4544)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4544)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4544)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4544
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4544)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4544)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4544)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4544)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4544)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4544
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4544)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4544
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4544)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4544
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4544)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4544
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4544)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4544
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4544)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4544
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4544)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4544)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4544)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4544)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4544)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4544)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4544)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4544)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4544)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4544
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4544)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4544)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4544)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4544)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4544)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4544)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4544)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4544
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4544)
,p_page_name=>'winlov'
,p_page_title=>unistr('\0414\0438\0430\043B\043E\0433 \043F\043E\0438\0441\043A\0430')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\041F\043E\0438\0441\043A')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\0417\0430\043A\0440\044B\0442\044C')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\0414\0430\043B\0435\0435 &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \041D\0430\0437\0430\0434')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\0421\0442\0440\043E\043A\0438 #FIRST_ROW#\2013#LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4544
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4544)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4544
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4544)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4544)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4544)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4544)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4544)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4544)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4544)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4544)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4544)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4544)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4544)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4544)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4544)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4544)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4544)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4544)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4544)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4544)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4544)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4544)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4544)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4544)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4544)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4544)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4544)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4544)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4544)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4544)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4544)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4544)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4544)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4544)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4544)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4544)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4544)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4544)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4544)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4544)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4544)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4544)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4544)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4544)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4544)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4544)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4544)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4544)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4544)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4544)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4544)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4544)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4544)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4544)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4544)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4544)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4544)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4544)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4544)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4544)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4544)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4544)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4544)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4544)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4544)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4544)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4544)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4544)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4544)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4544)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4544)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4544)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4544)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4544)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4544)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4544)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4544)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4544)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4544)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4544)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4544)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4544)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4544)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4544)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4544)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4544)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4544)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4544)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4544)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4544)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4544)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4544)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4544)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4544)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4544)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4544)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4544)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4544)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4544)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4544)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4544)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4544)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4544)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4544)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4544)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4544)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4544)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4544)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4544)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4544)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4544)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4544)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4544)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4544)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4544)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4544)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4544)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4544)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4544)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4544)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4544)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4544)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4544)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4544)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4544)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4544)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4544)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4544)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4544)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4544)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4544)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4544)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4544)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4544)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4544)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4544)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4544)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4544)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4544)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4544)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4544)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4544)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4544)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4544)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4544)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4544)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4544)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4544)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4544)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4544)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4544)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4544)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4544)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4544)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4544)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4544)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4544)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4544)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4544)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4544)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4544)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4544)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4544)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4544)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4544)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4544)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4544)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4544)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4544)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4544)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4544)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4544)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4544)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4544)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333688117401624)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320797441401615)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320603562401615)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377998635401657)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\0430\0437\0430\043D\043E \0432 \0434\043E\0441\0442\0443\043F\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337691364401627)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448\0430 \0443\0447\0435\0442\043D\0430\044F \0437\0430\043F\0438\0441\044C %0 \0441\043E\0437\0434\0430\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323241267401617)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0447\0435\0442\043D\0430\044F \0437\0430\043F\0438\0441\044C \0437\0430\0431\043B\043E\043A\0438\0440\043E\0432\0430\043D\0430.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313160036401610)
,p_name=>'AM_PM'
,p_message_language=>'ru'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447550947401707)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043A\043B\044E\0447\0438\0442\044C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455646191401713)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'ru'
,p_message_text=>unistr('(\0410\043A\0442\0438\0432\043D\043E)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425145512401691)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0437\043E\0432 Ajax \0432\0435\0440\043D\0443\043B \043E\0448\0438\0431\043A\0443 \0441\0435\0440\0432\0435\0440\0430 %0 \0434\043B\044F %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355945585401641)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \043F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\0442\044C \043F\0441\0435\0432\0434\043E\043D\0438\043C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F "%0" \0432 \0443\043D\0438\043A\0430\043B\044C\043D\044B\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356085458401641)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \0441 \043F\0441\0435\0432\0434\043E\043D\0438\043C\043E\043C "%0" \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345673511401633)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1816 \041D\0435\043E\0436\0438\0434\0430\043D\043D\0430\044F \043E\0448\0438\0431\043A\0430 \043F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\043D\0438\044F \043F\0441\0435\0432\0434\043E\043D\0438\043C\0430 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438515779401701)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\044C\043D\0430\044F \0441\0443\043C\043C\0430 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\044F\0435\0442 \043F\0440\043E\0441\0442\043E\0439 \0441\043F\043E\0441\043E\0431 \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C, \0440\0430\0437\0432\0435\0440\043D\0443\0442\043E \043B\0438 \043E\0434\043D\043E \0438 \0442\043E \0436\0435 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \0432 \0440\0430\0437\043D\044B\0445 \0440\0430\0431\043E\0447\0438\0445 \043F\0440\043E\0441\0442\0440\0430\043D\0441\0442\0432\0430\0445. \0412\044B \043C\043E\0436\0435\0442\0435 \0441\0440\0430\0432\043D\0438\0442\044C \044D\0442\0443 \043A\043E\043D\0442\0440\043E\043B\044C\043D\0443\044E \0441\0443\043C\043C\0443, \0447\0442\043E\0431\044B \043F\043E\0432\0435\0440\0438\0442\044C \043D\0430\043B\0438\0447\0438\0435 \0441\043E\0432\043F\0430\0434\0435\043D\0438\0439. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331442427401623)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0444\0443\043D\043A\0446\0438\0438 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316813533401612)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0444\0443\043D\043A\0446\0438\0438 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480316597401731)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \0430\0440\0435\043D\0434\0430\0442\043E\0440\0430 %0, \0432\043E\0437\0432\0440\0430\0449\0435\043D\043D\043E\0435 Oracle Cloud Identity Management, \043D\0435 \0430\0432\0442\043E\0440\0438\0437\043E\0432\0430\043D\043E \0434\043B\044F \0434\043E\043C\0435\043D\0430 %1!<br/>\0412\044B\043F\043E\043B\043D\0438\0442\0435 <a href="&LOGOUT_URL.">\043F\043E\0432\0442\043E\0440\043D\044B\0439 \0432\0445\043E\0434 \0432 \0441\0438\0441\0442\0435\043C\0443</a> \0438 \0443\043A\0430\0436\0438\0442\0435 \0430\0432\0442\043E\0440\0438\0437\043E\0432\0430\043D\043D\043E\0435 \0438\043C\044F \0430\0440\0435\043D\0434\0430\0442\043E\0440\0430 \0438\043B\0438 \0438\0437\043C\0435\043D\0438\0442\0435 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314567971401611)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448\0430 \0443\0447\0435\0442\043D\0430\044F \0437\0430\043F\0438\0441\044C "%0" \043D\0435 \0438\043C\0435\0435\0442 \043D\0435\043E\0431\0445\043E\0434\0438\043C\044B\0445 \043F\043E\043B\043D\043E\043C\043E\0447\0438\0439 \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\0430 (DB_DEVELOPER \0438\043B\0438 DB_ADMINISTRATOR)<br/>\0434\043B\044F \0440\0430\0431\043E\0447\0435\0433\043E \043F\0440\043E\0441\0442\0440\0430\043D\0441\0442\0432\0430 "%1"! \0412\044B\043F\043E\043B\043D\0438\0442\0435 <a href="&LOGOUT_URL.">\043F\043E\0432\0442\043E\0440\043D\044B\0439 \0432\0445\043E\0434 \0432 \0441\0438\0441\0442\0435\043C\0443</a> \043F\043E\0441\043B\0435 \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\0438\044F \043F\043E\043B\043D\043E\043C\043E\0447\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313635545401610)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \0430\0440\0435\043D\0434\0430\0442\043E\0440\0430, \0432\043E\0437\0432\0440\0430\0449\0435\043D\043D\043E\0435 Oracle Cloud Identity Management, \043D\0435 \0430\0432\0442\043E\0440\0438\0437\043E\0432\0430\043D\043E \0434\043B\044F \0442\0435\043A\0443\0449\0435\0433\043E \0440\0430\0431\043E\0447\0435\0433\043E \043F\0440\043E\0441\0442\0440\0430\043D\0441\0442\0432\0430!<br/>\0412\044B\043F\043E\043B\043D\0438\0442\0435 <a href="&LOGOUT_URL.">\043F\043E\0432\0442\043E\0440\043D\044B\0439 \0432\0445\043E\0434 \0432 \0441\0438\0441\0442\0435\043C\0443</a> \0438 \0443\043A\0430\0436\0438\0442\0435 \0430\0432\0442\043E\0440\0438\0437\043E\0432\0430\043D\043D\043E\0435 \0438\043C\044F \0430\0440\0435\043D\0434\0430\0442\043E\0440\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314644128401611)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0441\043E\043E\0431\0440\0430\0436\0435\043D\0438\044F\043C \0431\0435\0437\043E\043F\0430\0441\043D\043E\0441\0442\0438 \0437\0430\043F\0443\0441\043A \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \044D\0442\043E\0433\043E \0440\0430\0431\043E\0447\0435\0433\043E \043F\0440\043E\0441\0442\0440\0430\043D\0441\0442\0432\0430 \0447\0435\0440\0435\0437 \0434\043E\043C\0435\043D \0432 URL \043D\0435 \0434\043E\043F\0443\0441\043A\0430\0435\0442\0441\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331137300401623)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043F\0440\043E\0441\0438\0442\0435 \0432\0430\0448\0435\0433\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0430 \0431\0430\0437\044B \0434\0430\043D\043D\044B\0445 \0437\0430\043F\0443\0441\0442\0438\0442\044C $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331002108401623)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\043A\0435\0442 SYS.DBMS_LDAP \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0438\043B\0438 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330925935401622)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C\0441\043A\043E\0439 \0444\0443\043D\043A\0446\0438\0438 LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331292944401623)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438 LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332098011401623)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0432 \0430\0440\0433\0443\043C\0435\043D\0442\0435 p_flow_page \043F\0440\043E\0446\0435\0434\0443\0440\044B login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331659506401623)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 p_session \0432 wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379548069401658)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043F\0440\0430\0432\0438\043B\044C\043D\044B\0439 \0444\043E\0440\043C\0430\0442 \0430\0440\0433\0443\043C\0435\043D\0442\0430 \0434\043B\044F wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331715363401623)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F, \043F\0435\0440\0435\0434\0430\043D\043D\043E\0435 \0432 \043F\0440\043E\0446\0435\0434\0443\0440\0443 \0432\0445\043E\0434\0430 \0432 \0441\0438\0441\0442\0435\043C\0443, \0438\043C\0435\0435\0442 \0437\043D\0430\0447\0435\043D\0438\0435 null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320544805401615)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043E\0436\0434\0438\0442\0435 <span id="apex_login_throttle_sec">%0</span> \0441\0435\043A. \0438 \0432\043E\0439\0434\0438\0442\0435 \0432 \0441\0438\0441\0442\0435\043C\0443 \0441\043D\043E\0432\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321867460401616)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043F\044B\0442\043A\0430 \0432\0445\043E\0434\0430 \0432 \0441\0438\0441\0442\0435\043C\0443 \0431\044B\043B\0430 \0437\0430\0431\043B\043E\043A\0438\0440\043E\0432\0430\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377320315401656)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\044F "%0" \043D\0435 \043D\0430\0439\0434\0435\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322145487401616)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \0433\0440\0443\043F\043F\044B \0431\0435\0437\043E\043F\0430\0441\043D\043E\0441\0442\0438 \043D\0435 \0437\0430\0434\0430\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331560913401623)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \0432\044B\043F\043E\043B\043D\0435\043D\0438\0438 \043F\0440\043E\0446\0435\0441\0441\0430 \043F\043E\0441\043B\0435\0434\0443\044E\0449\0435\0439 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331384707401623)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \043F\0440\043E\0446\0435\0441\0441\0430 \043F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\043E\0439 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332552199401624)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\0442\043A\0440\043E\0439\0442\0435 URL-\0430\0434\0440\0435\0441 \0432 \0442\043E\043C \0436\0435 \0431\0440\0430\0443\0437\0435\0440\0435, \0432 \043A\043E\0442\043E\0440\043E\043C \0432\044B \0438\043D\0438\0446\0438\0438\0440\043E\0432\0430\043B\0438 \0437\0430\043F\0440\043E\0441 \043D\0430 \0441\0431\0440\043E\0441 \043F\0430\0440\043E\043B\044F. \0415\0441\043B\0438 \0432\044B \043D\0430\0436\0430\043B\0438 \043D\0430 URL-\0430\0434\0440\0435\0441 \0441\0431\0440\043E\0441\0430 \043F\0430\0440\043E\043B\044F'),
unistr('\0438 \0431\044B\043B\0438 \043F\0435\0440\0435\043D\0430\043F\0440\0430\0432\043B\0435\043D\044B \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443 \0432\0445\043E\0434\0430 \0432 \0441\0438\0441\0442\0435\043C\0443, \0438\043D\0438\0446\0438\0438\0440\0443\0439\0442\0435 \0437\0430\043F\0440\043E\0441'),
unistr('\043D\0430 \0441\0431\0440\043E\0441 \043F\0430\0440\043E\043B\044F \043F\043E\0432\0442\043E\0440\043D\043E \0438 \043E\0441\0442\0430\0432\044C\0442\0435 \0431\0440\0430\0443\0437\0435\0440 \043E\0442\043A\0440\044B\0442\044B\043C.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477817141401730)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C \043F\0430\0440\043E\043B\044C ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314833264401611)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\0435\0434\0436\0435\0440 \0440\0435\0441\0443\0440\0441\043E\0432 \043F\043E\0442\0440\0435\0431\0438\0442\0435\043B\044C\0441\043A\043E\0439 \0433\0440\0443\043F\043F\044B %0 \043D\0435 \0431\044B\043B \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314951267401611)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \0434\043B\044F \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\0438\044F \043D\0435\0434\043E\0441\0442\0430\044E\0449\0438\0445 \043F\043E\043B\043D\043E\043C\043E\0447\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342947708401631)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0444\0443\043D\043A\0446\0438\0438 \0441\0435\0430\043D\0441\0430 sentry.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343036130401631)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0444\0443\043D\043A\0446\0438\0438 \043F\0440\043E\0432\0435\0440\043A\0438 \0441\0435\0430\043D\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343212766401631)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 %0 \0434\043B\044F \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043F\0440\043E\0446\0435\0441\0441\043E\0440\0430 \0434\043B\044F \0440\0435\0433\0438\0441\0442\0440\0430\0446\0438\0438 \0441 \0443\043D\0438\043A\0430\043B\044C\043D\044B\043C \043F\0430\0440\043E\043B\0435\043C \0432 Oracle Application Server')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352776821401638)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 %0 \0432 \043C\0430\0440\043A\0435\0440\0435 %1, \0432\043E\0437\0432\0440\0430\0449\0435\043D\043D\043E\043C \0441\0435\0440\0432\0435\0440\043E\043C SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331985430401623)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0440\0435\0434\0430\043A\0442\0438\0440\0443\0439\0442\0435 \0441\0445\0435\043C\0443 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438 \0438 \0434\043E\0431\0430\0432\044C\0442\0435 \0438\043C\044F \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352414773401638)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0432\044B\0437\043E\0432 \043F\0440\043E\0446\0435\0434\0443\0440\044B %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352671535401638)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0441\0435\0430\043D\0441 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \0432 \043C\0430\0440\043A\0435\0440\0435 urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352229038401638)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0432 portal_sso_redirect: \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442 \0438\043D\0444\043E\0440\043C\0430\0446\0438\044F \043E \0440\0435\0433\0438\0441\0442\0440\0430\0446\0438\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343147859401631)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\043A\0435\0442 WWSEC_SSO_ENABLER_PRIVATE \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0438\043B\0438 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114331838136401623)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \043D\0430\0439\0442\0438 \0438\043C\044F \0437\0430\0440\0435\0433\0438\0441\0442\0440\0438\0440\043E\0432\0430\043D\043D\043E\0433\043E \043F\0430\0440\0442\043D\0435\0440\0441\043A\043E\0433\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \0432 \0441\0445\0435\043C\0435 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352398528401638)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0440\0435\0433\0438\0441\0442\0440\0438\0440\0443\0439\0442\0435 \044D\0442\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \0441\043E\0433\043B\0430\0441\043D\043E \043E\043F\0438\0441\0430\043D\0438\044E \0432 \0440\0443\043A\043E\0432\043E\0434\0441\0442\0432\0435 \043F\043E \0443\0441\0442\0430\043D\043E\0432\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343344511401632)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438 SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452742743401711)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0430\0432\0442\043E\0440\0438\0437\043E\0432\0430\043D\043D\044B\0439 URL-\0430\0434\0440\0435\0441: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342708768401631)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314782325401611)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0431\043E\0447\0435\0435 \043F\0440\043E\0441\0442\0440\0430\043D\0441\0442\0432\043E "%0" \043D\0435\0430\043A\0442\0438\0432\043D\043E. \041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0441\0432\043E\0435\043C\0443 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315192280401611)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'ru'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321563176401616)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0434\043E\0441\0442\0443\043F\0435 \043E\0442\043A\0430\0437\0430\043D\043E \0432 \0440\0435\0437\0443\043B\044C\0442\0430\0442\0435 \043F\0440\043E\0432\0435\0440\043A\0438 \0431\0435\0437\043E\043F\0430\0441\043D\043E\0441\0442\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321693657401616)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0434\043E\0441\0442\0443\043F\0435 \043E\0442\043A\0430\0437\0430\043D\043E \0432 \0440\0435\0437\0443\043B\044C\0442\0430\0442\0435 \043F\0440\043E\0432\0435\0440\043A\0438 \0431\0435\0437\043E\043F\0430\0441\043D\043E\0441\0442\0438 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321732234401616)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \0430\0432\0442\043E\0440\0438\0437\0430\0446\0438\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385152748401662)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0437\0434\0430\043D\043E \0441 %0 \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385292348401662)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043B\044E\0431\043E\0432\044C\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443077676401704)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\043F\0438\0441\0430\043D\0438\0435 \0441\043E\0431\044B\0442\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442867853401704)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 \0437\0430\0432\0435\0440\0448\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443104431401704)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \0441\043E\0431\044B\0442\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442700333401704)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 \043D\0430\0447\0430\043B\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442961821401704)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A \0441\043E\0431\044B\0442\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333544808401624)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0441\043E\0434\0435\0440\0436\0430\043D\0438\044F \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333450594401624)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0444\043E\0440\043C\0430\0442\0430 \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397442386401671)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043A\043E\043F\0438\0440\043E\0432\0430\043D\043E \0432 \0431\0443\0444\0435\0440 \043E\0431\043C\0435\043D\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397177368401671)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\043E\0442 \0431\0440\0430\0443\0437\0435\0440 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \043A\043E\043F\0438\0440\043E\0432\0430\043D\0438\0435 \0441 \043F\043E\043C\043E\0449\044C\044E \043A\043D\043E\043F\043A\0438 \0438\043B\0438 \0438\0437 \043C\0435\043D\044E. \041F\043E\043F\0440\043E\0431\0443\0439\0442\0435 \0441\043E\0447\0435\0442\0430\043D\0438\0435 \043A\043B\0430\0432\0438\0448 Ctrl+C \0438\043B\0438 Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385620253401662)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\044B\0442\044C \0443\0432\0435\0434\043E\043C\043B\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441698911401703)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\0430\0441\0442\043D\043E\0441\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436162086401699)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0443\0449\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436089280401699)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0430\043B\044C\043D\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440262581401702)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0442\043A\0430 #LABEL# \0434\043E\043B\0436\043D\0430 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\043E\0432\0430\0442\044C \0434\043E\043F\0443\0441\0442\0438\043C\043E\043C\0443 \0446\0432\0435\0442\0443. \041F\0440\0438\043C\0435\0440: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435962572401699)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0446\0432\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436258065401699)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C \0444\043E\0440\043C\0430\0442 \0446\0432\0435\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475445935401728)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A \0437\043D\0430\0447\0435\043D\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475512067401728)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\0440\044B\0442\044C \0441\043F\0438\0441\043E\043A \0434\043B\044F: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455769939401713)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'ru'
,p_message_text=>unistr('(\0412\044B\043F\043E\043B\043D\0435\043D\043E)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348081877401635)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362410387401645)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.'),
unistr('\041F\043E\0434\0440\043E\0431\043D\0430\044F \0438\043D\0444\043E\0440\043C\0430\0446\0438\044F \043F\043E \0434\0430\043D\043D\043E\0439 \043E\0448\0438\0431\043A\0435 \0434\043E\0441\0442\0443\043F\043D\0430 \043F\043E\0441\0440\0435\0434\0441\0442\0432\043E\043C \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\0430 \043E\0442\043B\0430\0434\043A\0438 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440500912401702)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0434 \0441\043E\0445\0440\0430\043D\0435\043D\0438\0435\043C \0438\0441\043F\0440\0430\0432\044C\0442\0435 \043E\0448\0438\0431\043A\0438.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386506824401663)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0439\0434\0435\043D\043E \0441\043E\0432\043F\0430\0434\0435\043D\0438\0439: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386496345401663)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0432\043F\0430\0434\0435\043D\0438\0439 \043D\0435 \043D\0430\0439\0434\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456217602401714)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0443\0449\0438\0439 \0445\043E\0434 \0432\044B\043F\043E\043B\043D\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440936800401703)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0439\043B, \0443\043A\0430\0437\0430\043D\043D\044B\0439 \0432 \044D\043B\0435\043C\0435\043D\0442\0435 %0, \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0432 APEX_APPLICATION_TEMP_FILES.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429443056401694)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421 \043C\043E\043C\0435\043D\0442\0430 \0438\043D\0438\0446\0438\0438\0440\043E\0432\0430\043D\0438\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\043C \043F\0440\043E\0446\0435\0441\0441\0430 \043E\0431\043D\043E\0432\043B\0435\043D\0438\044F \0438\0437\043C\0435\043D\0438\043B\0430\0441\044C \0442\0435\043A\0443\0449\0430\044F \0432\0435\0440\0441\0438\044F \0434\0430\043D\043D\044B\0445 \0432 \0431\0430\0437\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398533264401672)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0437\0430\0433\0440\0443\0436\0430\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445542422401706)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\043E\0439 \043E\0431\0440\0430\0431\043E\0442\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445363921401706)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0442\0430\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459432309401716)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C: \0434\0435\0439\0441\0442\0432\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445440178401706)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386937804401663)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\043F\043B\044B\0432\0430\044E\0449\0438\0439 \043A\0430\043B\0435\043D\0434\0430\0440\044C: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309571835401607)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309649018401607)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445783679401706)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423 \043F\043E\0434\043F\0438\0441\0438 #LABEL# \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \043D\0435\043A\043E\0442\043E\0440\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445644939401706)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C #LABEL# \0434\043E\043B\0436\043D\0430 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\043E\0432\0430\0442\044C \0434\043E\043F\0443\0441\0442\0438\043C\043E\0439 \0434\0430\0442\0435, \043D\0430\043F\0440\0438\043C\0435\0440 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313289971401610)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435 #LABEL# \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \0432 \0434\0438\0430\043F\0430\0437\043E\043D\0435 \043E\0442 %0 \0434\043E %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313394460401610)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 #LABEL# \043D\0435 \043C\043E\0436\0435\0442 \043F\0440\0435\0434\0448\0435\0441\0442\0432\043E\0432\0430\0442\044C \0434\0430\0442\0435 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313480155401610)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \043F\043E\0437\0434\043D\0435\0435 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390413467401666)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \0431\043E\043B\044C\0448\0435 \0443\043A\0430\0437\0430\043D\043D\043E\0439 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0439 \0434\0430\0442\044B %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390881526401666)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \0444\043E\0440\043C\0430\0442\0443 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390351324401666)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043C\0435\043D\044C\0448\0435 \0443\043A\0430\0437\0430\043D\043D\043E\0439 \043C\0438\043D\0438\043C\0430\043B\044C\043D\043E\0439 \0434\0430\0442\044B %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390509816401666)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \043D\0430\0445\043E\0434\0438\0442\0441\044F \0432 \0434\043E\043F\0443\0441\0442\0438\043C\043E\043C \0434\0438\0430\043F\0430\0437\043E\043D\0435 \043E\0442 %0 \0434\043E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390784109401666)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \043D\0430\0445\043E\0434\0438\0442\0441\044F \0432 \0434\043E\043F\0443\0441\0442\0438\043C\043E\043C \0434\0438\0430\043F\0430\0437\043E\043D\0435 \043B\0435\0442 \043E\0442 %0 \0434\043E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440808967401703)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468038239401722)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\044B\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470009798401724)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440698095401702)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\041A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440730593401702)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346990143401634)
,p_name=>'APEX.ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314398696401610)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438 \0432\044B\043F\043E\043B\043D\0435\043D\0438\0438 \043E\0431\0440\0430\0442\043D\043E\0433\043E \0432\044B\0437\043E\0432\0430 \043E\0431\0440\0430\0431\043E\0442\043A\0438 \043E\0448\0438\0431\043E\043A \043F\0440\043E\0438\0437\043E\0448\043B\0430 \0441\043B\0435\0434\0443\044E\0449\0430\044F \043E\0448\0438\0431\043A\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323018527401617)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0438\0437\043E\0448\043B\0430 \043E\0448\0438\0431\043A\0430 \043F\0440\0438 \0432\044B\0432\043E\0434\0435 \0441\0442\0440\0430\043D\0438\0446\044B \043E\0448\0438\0431\043A\0438: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315027738401611)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043D\0443\0442\0440\0435\043D\043D\044F\044F \043E\0448\0438\0431\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454818712401713)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.'),
unistr('\041F\043E\0434\0440\043E\0431\043D\0430\044F \0438\043D\0444\043E\0440\043C\0430\0446\0438\044F \043F\043E \0434\0430\043D\043D\043E\0439 \043E\0448\0438\0431\043A\0435 \0434\043E\0441\0442\0443\043F\043D\0430 \043F\043E\0441\0440\0435\0434\0441\0442\0432\043E\043C \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\0430 \043E\0442\043B\0430\0434\043A\0438 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449105932401709)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'ru'
,p_message_text=>unistr('\0411\0430\0437\0430 \0434\0430\043D\043D\044B\0445 \043E\0442\043A\0440\044B\0442\0430 \0442\043E\043B\044C\043A\043E \0434\043B\044F \0447\0442\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479729104401731)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'ru'
,p_message_text=>unistr('ORA-28353: \043D\0435 \0443\0434\0430\043B\043E\0441\044C \043E\0442\043A\0440\044B\0442\044C \043D\0430\043A\043E\043F\0438\0442\0435\043B\044C. \0414\0430\043D\043D\044B\0435 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043D\0435\0434\043E\0441\0442\0443\043F\043D\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449249596401709)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A \0441\043E\0436\0430\043B\0435\043D\0438\044E, \044D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\0430 \043D\0435\0434\043E\0441\0442\0443\043F\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316707739401612)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\0445\043D\0438\0447\0435\0441\043A\0430\044F \0438\043D\0444\043E\0440\043C\0430\0446\0438\044F (\0432\0438\0434\043D\0430 \0442\043E\043B\044C\043A\043E \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\0430\043C)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412869759401682)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\0435 \043E\0431 \043E\0448\0438\0431\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426728891401692)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0436\0438\0434\0430\0435\043C\044B\0439 \0444\043E\0440\043C\0430\0442: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393477231401668)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C \0443\0436\0435 \0432\043A\043B\044E\0447\0435\043D \0432 \0442\0430\0431\043B\0438\0446\0443 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F \0434\043E\0441\0442\0443\043F\043E\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393303779401668)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\0442\0432\0435\0440\0434\0438\0442\0435 \0434\043E\0431\0430\0432\043B\0435\043D\0438\0435 \0441\043B\0435\0434\0443\044E\0449\0438\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439 \0432 \043A\043E\043B\0438\0447\0435\0441\0442\0432\0435 %0 \0432 \0442\0430\0431\043B\0438\0446\0443 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F \0434\043E\0441\0442\0443\043F\043E\043C <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393810663401668)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0434\0443\0431\043B\0438\043A\0430\0442 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393563190401668)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0430\0434\0440\0435\0441\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442 \0437\043D\0430\043A @')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393625005401668)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0430\0434\0440\0435\0441\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442 \0442\043E\0447\043A\0430 (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393769967401668)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0438\0448\043A\043E\043C \0434\043B\0438\043D\043D\043E\0435 \0438\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394077691401668)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\043E\043B\044C\043A\043E \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438, \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0432 \0442\0430\0431\043B\0438\0446\0435 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F \0434\043E\0441\0442\0443\043F\043E\043C \043A \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E, \043C\043E\0433\0443\0442 \043F\043E\043B\0443\0447\0438\0442\044C \0434\043E\0441\0442\0443\043F \043A \044D\0442\043E\043C\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394124701401668)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0436\0438\0434\0430\043D\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F \0434\043E\0441\0442\0443\043F\043E\043C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393946583401668)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435 \0430\0443\0442\0435\043D\0442\0438\0444\0438\0446\0438\0440\043E\0432\0430\043D\043D\044B\0435 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043F\043E\043B\0443\0447\0430\044E\0442 \0434\043E\0441\0442\0443\043F \043A \044D\0442\043E\043C\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436726743401700)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\043B\044E\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436693966401700)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436964037401700)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('%0: \043E\0442\043A\043B\044E\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436860476401700)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('%0: \0432\043A\043B\044E\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436556289401699)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429649089401695)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0433\0440\0443\0437\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386197485401663)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\043D\0435\043D\043D\044B\0439 \0444\0438\043B\044C\0442\0440 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427284262401693)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\043D\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312152083401609)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0447\0430\0442\0430\044F \0434\0438\0430\0433\0440\0430\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439988167401702)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0447\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312233255401609)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0440\0443\0433\043E\0432\0430\044F \0434\0438\0430\0433\0440\0430\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438679545401701)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0438\0430\0433\0440\0430\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311941309401609)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427729184401693)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0441\0442\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427856257401693)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0441\0442\0438\0442\044C \0432\0441\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427943567401693)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0441\0442\0438\0442\044C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445134046401706)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 %1, \043D\0430 \043A\043E\0442\043E\0440\044B\0439 \0441\0441\044B\043B\0430\0435\0442\0441\044F \0444\0430\0441\0435\0442 %0, \043D\0435\0434\043E\0441\0442\0443\043F\0435\043D \0438\043B\0438 \043D\0435 \0438\043C\0435\0435\0442 \0434\043E\0441\0442\0430\0442\043E\0447\043D\044B\0445 \043F\0440\0430\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302373129401602)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0444\0438\043B\044C\0442\0440\044B \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384341815401661)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\044C\0442\0430\0442\043E\0432: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384419675401661)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\043D\043E: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387095167401663)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0443\0449\0438\0435 \0444\0438\043B\044C\0442\0440\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303830837401603)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A \0444\0438\043B\044C\0442\0440\043E\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443601762401705)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0432\044B\0448\0435\043D \043F\0440\0435\0434\0435\043B \0443\043D\0438\043A\0430\043B\044C\043D\044B\0445 \0437\043D\0430\0447\0435\043D\0438\0439 (%0) \0434\043B\044F \0444\0430\0441\0435\0442\0430 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429201811401694)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0441\0435\0442 %0 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0441\0442\043E\043B\0431\0446\043E\0432 \0442\0438\043F\0430 DATE \0438\043B\0438 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427310416401693)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427416383401693)
,p_name=>'APEX.FS.GO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0439\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428847996401694)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0440\0430\0432\043D\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312979730401609)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'ru'
,p_message_text=>unistr(' \0441\043E\0434\0435\0440\0436\0438\0442 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312618598401609)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0431\043E\043B\044C\0448\0435 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312723327401609)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0431\043E\043B\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312447631401609)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\043D\044C\0448\0435 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312541320401609)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\043D\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312858386401609)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0441 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315391512401611)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0434\0430\043D\043D\044B\0445 %0 (%1) \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0444\0430\0441\0435\0442\0430 "\041F\043E\043B\0435 \0432\0432\043E\0434\0430".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305565354401604)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0444\0430\0441\0435\0442\043E\0432 \0441 \043D\0435\0441\043A\043E\043B\044C\043A\0438\043C\0438 \0437\043D\0430\0447\0435\043D\0438\044F\043C\0438 \0442\0440\0435\0431\0443\044E\0442\0441\044F \0431\0430\0437\044B \0434\0430\043D\043D\044B\0445 \0432\0435\0440\0441\0438\0438 12.2 \0438\043B\0438 \0432\044B\0448\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429002059401694)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0444\0430\0441\0435\0442\0430 %0 \043D\0435 \0431\044B\043B\043E \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\043E \0441\0442\043E\043B\0431\0446\043E\0432 \043F\043E\0438\0441\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302461162401602)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0411\043E\043B\044C\0448\0435 \0444\0438\043B\044C\0442\0440\043E\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384539815401661)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0430\043B\043E \0434\0438\0430\043F\0430\0437\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428572124401694)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \2013 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428690254401694)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0448\0435 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428727026401694)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0438\0436\0435 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384620255401662)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043D\0435\0446 \0434\0438\0430\043F\0430\0437\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447400255401707)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043C\0435\043D\0442 \0441\043F\0438\0441\043A\0430 \0437\043D\0430\0447\0435\043D\0438\0439 #%2 ("%1") \0434\043B\044F \0444\0430\0441\0435\0442\0430 \0434\0438\0430\043F\0430\0437\043E\043D\0430 %0 \043D\0435\0434\0435\0439\0441\0442\0432\0438\0442\0435\043B\0435\043D (\043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442 \0440\0430\0437\0434\0435\043B\0438\0442\0435\043B\044C "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428973030401694)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0443\0447\043D\043E\0439 \0432\0432\043E\0434 \0434\043B\044F \0444\0430\0441\0435\0442\0430 \0434\0438\0430\043F\0430\0437\043E\043D\0430 %0 \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F, \043F\043E\0441\043A\043E\043B\044C\043A\0443 \0441\0442\043E\043B\0431\0435\0446 \0438\043C\0435\0435\0442 \0442\0438\043F DATE \0438\043B\0438 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428299376401693)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0434\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312042739401609)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0434\0438\0430\0433\0440\0430\043C\043C\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381125808401659)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427606659401693)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427529672401693)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428485848401694)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0435\0440\0438\0442\0435 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311844372401609)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C \0434\0438\0430\0433\0440\0430\043C\043C\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428006917401693)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C \043C\0435\043D\044C\0448\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428198190401693)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C \0431\043E\043B\044C\0448\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114428344306401693)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0432\0435\0437\0434 \0438 \0432\044B\0448\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386034302401663)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440\0430\0446\0438\044F \043F\0440\0435\0434\043B\043E\0436\0435\043D\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429162093401694)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0441\0435\0442 \0442\0435\043A\0441\0442\043E\0432\043E\0433\043E \043F\043E\043B\044F %0 \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0442\043E\043B\044C\043A\043E \0434\043B\044F \0441\0442\043E\043B\0431\0446\043E\0432 \0442\0438\043F\0430 NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302251150401602)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445285374401706)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0434\0430\043D\043D\044B\0445 %0 (%1) \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0444\0430\0441\0435\0442\043D\043E\0433\043E \043F\043E\0438\0441\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437141030401700)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0439\0442\0438 \043A \043E\0448\0438\0431\043A\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394766603401669)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402380642401674)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0440\043D\0443\0442\044C \0441\043C\0435\043D\0443 \043E\043F\0435\0440\0430\0446\0438\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394817350401669)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043C\0435\043D\0430 \043E\043F\0435\0440\0430\0446\0438\0438.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402259048401674)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0432\0435\0440\043D\0443\0442\044C \0441\043C\0435\043D\0443 \043E\043F\0435\0440\0430\0446\0438\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480984760401732)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402030923401674)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0435\043D\043E \0441\0442\0440\043E\043A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472456540401726)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0432\0442\043E\0440\044F\044E\0449\0430\044F\0441\044F \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391778348401667)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0432\044B\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395013594401669)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A \0433\0440\0443\043F\043F\044B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394916759401669)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0435\0440\0445\043D\0438\0439 \043A\043E\043B\043E\043D\0442\0438\0442\0443\043B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391849024401667)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411898411401681)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\0438\0442\044C \0431\043E\043B\044C\0448\0435 \0441\0442\0440\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391512822401667)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395154070401669)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0438 \0441\0442\0440\0430\043D\0438\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391945774401667)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'ru'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392055187401667)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 - %1 \0438\0437 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448007250401708)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\043E\0440 \0441\0442\0440\0430\043D\0438\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391694015401667)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472247607401725)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\043B\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472342237401726)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480724591401732)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430: %0, \0441\0442\043E\043B\0431\0435\0446: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480895960401732)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472146619401725)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395300204401669)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A \0441\0442\0440\043E\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390975782401666)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\043D\043E \044F\0447\0435\0435\043A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392163313401667)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\043D\043E \0441\0442\0440\043E\043A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432409997401696)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0432\0441\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402161044401674)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\0430\043D\0438\0446\0430 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395242013401669)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0441\0442\0440\043E\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395408244401669)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0441\043E\0440\0442\0438\0440\043E\0432\0430\043D\043D\044B\0435 \043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395501588401669)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\043D\043D\044B\0435 \043F\043E \0443\0431\044B\0432\0430\043D\0438\044E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391082278401666)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391374089401666)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391140071401666)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0443\0431\044B\0432\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391482028401666)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0443\0431\044B\0432\0430\043D\0438\044E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114391270264401666)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401920869401674)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0442\043E\0433\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328367901401621)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\043E\0439 \043F\0440\0438 \0432\044B\043F\043E\043B\043D\0435\043D\0438\0438 HTTP-\0437\0430\043F\0440\043E\0441\0430 \043A "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469670493401724)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A \0432\044B\0431\043E\0440\0430 \0441\0435\0442\043A\0438: \0441\0442\043E\043B\0431\0446\043E\0432: %0, \0441\0442\0440\043E\043A %1. \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043A\043B\0430\0432\0438\0448\0438 \0441\043E \0441\0442\0440\0435\043B\043A\0430\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401896230401674)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0438 (%0) \043F\0440\0438 \0432\044B\0431\043E\0440\0435 \0441\043F\0438\0441\043A\0430. \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043A\043B\0430\0432\0438\0448\0438 \0441\043E \0441\0442\0440\0435\043B\043A\0430\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480536706401732)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388639732401664)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0439\0441\0442\0432\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389657240401665)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389592406401665)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474048365401727)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459563734401716)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461206385401717)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417648597401686)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435 \0442\0435\043A\0441\0442\043E\0432\044B\0435 \0441\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418894332401687)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419974391401687)
,p_name=>'APEX.IG.AND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439345858401701)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\0431\043B. \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0440\0430\0437\043B\0438\0447\043D\044B\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475065667401728)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0435 \043F\0440\0438\0431\043B. \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0440\0430\0437\043D\044B\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458181499401715)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043B\0430\0441\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460002816401717)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418937887401687)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0432\0442\043E\0440\0438\0437\0430\0446\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474102936401727)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0432\0442\043E\043C\0430\0442\0438\0447\0435\0441\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439785742401702)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\0435\0434\043D\0435\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474728937401727)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0435 \0441\0440\0435\0434\043D\0435\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457625263401715)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A \043E\0441\0438 \043F\043E\0434\043F\0438\0441\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457886846401715)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0441\044F\0442\0438\0447\043D\044B\0435 \0440\0430\0437\0440\044F\0434\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457750670401715)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A \043E\0441\0438 \0437\043D\0430\0447\0435\043D\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463888100401719)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0432\0435\0442 \0444\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458218012401715)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0438\0441\0442\043E\0433\0440\0430\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414246475401683)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\0436\0434\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465009411401720)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458353517401715)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0443\0437\044B\0440\044C\043A\043E\0432\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389809785401665)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419803709401687)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421 \0443\0447\0435\0442\043E\043C \0440\0435\0433\0438\0441\0442\0440\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475657829401728)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'ru'
,p_message_text=>unistr('(\0423\0447\0438\0442\044B\0432\0430\0442\044C \0440\0435\0433\0438\0441\0442\0440)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446513042401707)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0435\043D\0438\044F \0441\043E\0445\0440\0430\043D\0435\043D\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390294843401666)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C \0432\0438\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420907634401688)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0438\0430\0433\0440\0430\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417405188401686)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \0437\0430\043F\0440\043E\0441 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043E\0433\0440\0430\043D\0438\0447\0435\043D\0438\0435 \043D\0430 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0442\043E\0447\0435\043A \0434\0430\043D\043D\044B\0445 \043D\0430 \0434\0438\0430\0433\0440\0430\043C\043C\0435: %0. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\044C\0442\0440, \0447\0442\043E\0431\044B \0443\043C\0435\043D\044C\0448\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441\0435\0439 \0432 \0441\0432\043E\0435\043C \0437\0430\043F\0440\043E\0441\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388571837401664)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440 \0434\0438\0430\0433\0440\0430\043C\043C\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395832780401670)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0441\0442\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457121249401714)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\044B\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464077544401720)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0432\0435\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440151975401702)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419294886401687)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388721849401664)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465814003401721)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\043D\0430\0447\0435\043D\0438\0435 \0441\0442\043E\043B\0431\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419322710401687)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\043E\0436\043D\044B\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388951162401665)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0447\0438\0441\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414807219401684)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\043E\0434\0435\0440\0436\0438\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421180315401688)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043C\0435\043D\0430 \043E\043F\0435\0440\0430\0446\0438\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395622641401670)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043F\0438\0440\043E\0432\0430\0442\044C \0432 \0431\0443\0444\0435\0440 \043E\0431\043C\0435\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395704478401670)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043F\0438\0440\043E\0432\0430\0442\044C \0432\043D\0438\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439163517401701)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439270159401701)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0440\0430\0437\043B\0438\0447\043D\044B\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474932503401727)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0440\0430\0437\043D\044B\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474803018401727)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472549899401726)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0437\0434\0430\0442\044C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417844305401686)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043D\043D\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465696380401721)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0434\0430\043D\043D\044B\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465226304401720)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446328987401707)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \0434\0430\0442\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415560349401684)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418523346401686)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0441\0442\0440\043E\0439\043A\0438 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418311674401686)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389763364401665)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466883086401722)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \044D\0442\043E\0442 \043E\0442\0447\0435\0442?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422931881401690)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0441\0442\0440\043E\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421721105401689)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0441\0442\0440\043E\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460141304401717)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\0431\044B\0432\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420612665401688)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0434\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388212280401664)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\0440\043E\0431\043D\043E\0435 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448841138401708)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\043F\0440\0430\0432\043B\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420300716401688)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\043B\044E\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414910322401684)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415165568401684)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \043D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458458957401715)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\044C\0446\0435\0432\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421327821401688)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0433\0440\0443\0437\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320078173401615)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\043E\043B\044C\043A\043E \0434\0430\043D\043D\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467880709401722)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\043E\0440 \0444\043E\0440\043C\0430\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332606230401624)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \0432\044B\0433\0440\0443\0437\043A\0438 %0 \043D\0435 \0432\043A\043B\044E\0447\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460820582401717)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0443\0431\043B\0438\0440\043E\0432\0430\043D\043D\043E\0435 \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460911423401717)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0443\0431\043B\0438\0440\043E\0432\0430\043D\043D\0430\044F \0441\043C\0435\043D\0430 \043E\043F\0435\0440\0430\0446\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422873143401689)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0443\0431\043B\0438\0440\043E\0432\0430\0442\044C \0441\0442\0440\043E\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421665876401689)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0432\0442\043E\0440\044F\044E\0449\0438\0435\0441\044F \0441\0442\0440\043E\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389361970401665)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459969039401717)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C \0434\0438\0430\0433\0440\0430\043C\043C\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471487818401725)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C "\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467497421401722)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043A\0440\044B\0442\0430\044F \043A\043E\043F\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467660174401722)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\0435')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467388044401722)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043F\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467073104401722)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0435 \043F\0438\0441\044C\043C\043E \043E\0442\043F\0440\0430\0432\043B\0435\043D\043E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467511395401722)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467271377401722)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\0443\0447\0430\0442\0435\043B\044C (\043A\043E\043C\0443)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420008025401687)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413208292401683)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0440\0430\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466402630401721)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420117680401688)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0436\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466325897401721)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432392628401696)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0439\043B \043F\043E\0434\0433\043E\0442\043E\0432\043B\0435\043D. \041D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0432\044B\0433\0440\0443\0437\043A\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114395986263401670)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\043E\043B\043D\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397044152401671)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\043E\0440 \0437\0430\043B\0438\0432\043A\0438 \0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396915915401670)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\043E\0440 \0437\0430\043B\0438\0432\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388861444401665)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419438046401687)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474454974401727)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460314369401717)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0432\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389070069401665)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'ru'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417941037401686)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464966082401720)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466798369401721)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'ru'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466615731401721)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'ru'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379425005401658)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'ru'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318792895401614)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'ru'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422518271401689)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\0435\043F\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420275484401688)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0438 \0438 \043E\043F\0435\0440\0430\0442\043E\0440\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458561178401715)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043D\0443\0441\043E\043E\0431\0440\0430\0437\043D\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439083704401701)
,p_name=>'APEX.IG.GO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0439\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413877111401683)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0431\043E\043B\044C\0448\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413927854401683)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0431\043E\043B\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420560602401688)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388020723401664)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0441\0435\0442\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461191314401717)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420797715401688)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388366915401664)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465529641401721)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0443\0441\043B\043E\0432\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464441979401720)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464626872401720)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0432\043D\0438\0432\0430\043D\0438\0435 \0437\0430\0433\043E\043B\043E\0432\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474378451401727)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469870384401724)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041C\043E\0436\043D\043E \0432\0441\0442\0430\0432\043B\044F\0442\044C, \043E\0431\043D\043E\0432\043B\044F\0442\044C \0438 \0443\0434\0430\043B\044F\0442\044C \0434\0430\043D\043D\044B\0435 \043D\0435\043F\043E\0441\0440\0435\0434\0441\0442\0432\0435\043D\043D\043E \0432 \044D\0442\043E\0439 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0435.</p>'),
'',
unistr('<p>\0412\0441\0442\0430\0432\043B\044F\0439\0442\0435 \043D\043E\0432\044B\0435 \0441\0442\0440\043E\043A\0438 \043D\0430\0436\0430\0442\0438\0435\043C \043A\043D\043E\043F\043A\0438 "\0414\043E\0431\0430\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443".</p>'),
'',
unistr('<p>\0420\0435\0434\0430\043A\0442\0438\0440\0443\0439\0442\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\0435 \0434\0430\043D\043D\044B\0435, \0434\0432\0430\0436\0434\044B \0449\0435\043B\043A\043D\0443\0432 \043F\043E \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\043E\0439 \044F\0447\0435\0439\043A\0435. \0414\043B\044F \0431\043E\043B\0435\0435 \043C\0430\0441\0448\0442\0430\0431\043D\043E\0439 \0440\0430\0431\043E\0442\044B \043F\043E \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044E \043D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\0420\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C", \0447\0442\043E\0431\044B \043F\0435\0440\0435\0439\0442\0438 \0432 \0440\0435\0436\0438\043C \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F. \0412 \0440\0435\0436\0438\043C\0435 \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F \0434\043B\044F \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0445 \044F\0447')
||unistr('\0435\0435\043A \043C\043E\0436\043D\043E \043D\0430\0436\0430\0442\044C \043E\0434\043D\0443 \043A\043D\043E\043F\043A\0443 \043C\044B\0448\0438 \0438\043B\0438 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \043A\043B\0430\0432\0438\0430\0442\0443\0440\0443.</p>'),
'',
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043C\0435\043D\044E "\0418\0437\043C\0435\043D\0438\0442\044C" \0434\043B\044F \0434\0443\0431\043B\0438\0440\043E\0432\0430\043D\0438\044F \0438 \0443\0434\0430\043B\0435\043D\0438\044F \0441\0442\0440\043E\043A. \0427\0442\043E\0431\044B \0432\043A\043B\044E\0447\0438\0442\044C \043C\0435\043D\044E "\0418\0437\043C\0435\043D\0438\0442\044C", \0441 \043F\043E\043C\043E\0449\044C\044E \0444\043B\0430\0436\043A\043E\0432 \0432\044B\0431\0435\0440\0438\0442\0435 \043E\0434\043D\0443 \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0441\0442\0440\043E\043A.</p>'),
'',
unistr('<p>\0414\0443\0431\043B\0438\0440\0443\0439\0442\0435 \0432\044B\0431\0440\0430\043D\043D\0443\044E \0441\0442\0440\043E\043A\0443, \043D\0430\0436\0430\0432 \043C\0435\043D\044E "\0418\0437\043C\0435\043D\0438\0442\044C" \0438 \0432\044B\0431\0440\0430\0432 "\0414\0443\0431\043B\0438\0440\043E\0432\0430\0442\044C \0441\0442\0440\043E\043A\0438". \0423\0434\0430\043B\0438\0442\0435 \0432\044B\0431\0440\0430\043D\043D\044B\0439 \0440\044F\0434, \043D\0430\0436\0430\0432 \043C\0435\043D\044E "\0418\0437\043C\0435\043D\0438\0442\044C" \0438 \0432\044B\0431\0440\0430\0432 "\0423\0434\0430\043B\0438\0442\044C \0441\0442\0440\043E\043A\0443".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471979838401725)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E\0437\043C\043E\0436\043D\043E\0441\0442\0438 \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472036954401725)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430 \043F\0440\0435\0434\0441\0442\0430\0432\043B\044F\0435\0442 \043D\0430\0431\043E\0440 \0434\0430\043D\043D\044B\0445 \0432 \0432\0438\0434\0435 \043E\0442\0447\0435\0442\0430 \0441 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\044C\044E \043F\043E\0438\0441\043A\0430 \0438 \043D\0430\0441\0442\0440\043E\0439\043A\0438. \0412\044B \043C\043E\0436\0435\0442\0435 \0432\044B\043F\043E\043B\043D\0438\0442\044C \043C\043D\043E\0436\0435\0441\0442\0432\043E \043E\043F\0435\0440\0430\0446\0438\0439, \0447\0442\043E\0431\044B \043E\0433\0440\0430\043D\0438\0447\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0432\043E\0437\0432\0440\0430\0449\0430\0435\043C\044B\0445 \0437\0430\043F\0438\0441\0435\0439 \0438 \0438\0437\043C\0435\043D\0438\0442\044C \0441\043F\043E\0441\043E\0431 \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F \0434\0430\043D\043D\044B\0445.</p>'),
'',
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043F\043E\043B\0435 \043F\043E\0438\0441\043A\0430 \0434\043B\044F \0444\0438\043B\044C\0442\0440\0430\0446\0438\0438 \0432\043E\0437\0432\0440\0430\0449\0430\0435\043C\044B\0445 \0437\0430\043F\0438\0441\0435\0439. \041D\0430\0436\043C\0438\0442\0435 "\0414\0435\0439\0441\0442\0432\0438\044F", \0447\0442\043E\0431\044B \043F\043E\043B\0443\0447\0438\0442\044C \0434\043E\0441\0442\0443\043F \043A \043C\043D\043E\0433\043E\0447\0438\0441\043B\0435\043D\043D\044B\043C \043E\043F\0446\0438\044F\043C \0434\043B\044F \0438\0437\043C\0435\043D\0435\043D\0438\044F \043C\0430\043A\0435\0442\0430 \043E\0442\0447\0435\0442\0430, \0438\043B\0438 \0438\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043C\0435\043D\044E \0437\0430\0433\043E\043B\043E\0432\043A\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432 \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432.</p>'),
'',
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 "\041D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430", \0447\0442\043E\0431\044B \0441\043E\0445\0440\0430\043D\0438\0442\044C \0441\0432\043E\0438 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0432 \043E\0442\0447\0435\0442\0435. \0412\044B \0442\0430\043A\0436\0435 \043C\043E\0436\0435\0442\0435 \0432\044B\0433\0440\0443\0437\0438\0442\044C \0434\0430\043D\043D\044B\0435 \0438\0437 \043E\0442\0447\0435\0442\0430 \0432\043E \0432\043D\0435\0448\043D\0438\0439 \0444\0430\0439\043B \0438\043B\0438 \043E\0442\043F\0440\0430\0432\0438\0442\044C \0438\0445 \043F\043E \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\0435 \0441\0435\0431\0435 \0438\043B\0438 \0434\0440\0443\0433\0438\043C \043B\044E\0434\044F\043C.</p> '),
'',
unistr('<p>\0414\043B\044F \043F\043E\043B\0443\0447\0435\043D\0438\044F \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E\0439 \0438\043D\0444\043E\0440\043C\0430\0446\0438\0438 \0441\043C. \0440\0430\0437\0434\0435\043B "\0418\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0445 \0441\0435\0442\043E\043A" \0432 <em>\0420\0443\043A\043E\0432\043E\0434\0441\0442\0432\0435 \043A\043E\043D\0435\0447\043D\043E\0433\043E \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F Oracle Application Express</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471797126401725)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0437\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469708692401724)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\044F \0432\0441\0442\0440\043E\0435\043D\043D\044B\0435 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\0438, \043C\043E\0436\043D\043E \043D\0430\0441\0442\0440\043E\0438\0442\044C \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0443\044E \0441\0435\0442\043A\0443 \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F \0434\0430\043D\043D\044B\0445 \0440\0430\0437\043B\0438\0447\043D\044B\043C\0438 \0441\043F\043E\0441\043E\0431\0430\043C\0438.</p>'),
'',
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 "\041C\0435\043D\044E \0437\0430\0433\043E\043B\043E\0432\043A\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432" \0438\043B\0438 \043C\0435\043D\044E "\0414\0435\0439\0441\0442\0432\0438\044F", \0447\0442\043E\0431\044B \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C, \043A\0430\043A\0438\0435 \0441\0442\043E\043B\0431\0446\044B \043E\0442\043E\0431\0440\0430\0436\0430\0442\044C, \0432 \043A\0430\043A\043E\0439 \043F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\0438, \0438 \0437\0430\043C\043E\0440\043E\0437\0438\0442\044C \0441\0442\043E\043B\0431\0446\044B. \0422\0430\043A\0436\0435 \043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C \0440\0430\0437\043B\0438\0447\043D\044B\0435 \0444\0438\043B\044C\0442\0440\044B \0434\0430\043D\043D\044B\0445 \0438 \043E\0442\0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E\043B\0443\0447\0435\043D\043D\044B\0435 \0434\0430\043D\043D\044B\0435.</p>'),
'',
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043A\043D\043E\043F\043A\0443 \0412\0438\0434 (\0440\044F\0434\043E\043C \0441 \043F\043E\043B\0435\043C \041F\043E\0438\0441\043A) \0434\043B\044F \0434\043E\0441\0442\0443\043F\0430 \043A \0434\0440\0443\0433\0438\043C \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C \0434\0430\043D\043D\044B\0445, \043A\043E\0442\043E\0440\044B\0435 \043C\043E\0433\043B\0438 \0431\044B\0442\044C \043E\043F\0440\0435\0434\0435\043B\0435\043D\044B \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\043E\043C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0422\0430\043A\0436\0435 \043C\043E\0436\043D\043E \0441\043E\0437\0434\0430\0442\044C \0434\0438\0430\0433\0440\0430\043C\043C\0443 \0438\043B\0438 \043F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0443\044E \0434\0438\0430\0433\0440\0430\043C\043C\0443.</p>  '),
'',
unistr('<p><em>\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435: \043D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 <strong>\041F\043E\043C\043E\0449\044C</strong> \0432 \0434\0438\0430\043B\043E\0433\043E\0432\044B\0445 \043E\043A\043D\0430\0445 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438, \0447\0442\043E\0431\044B \043F\043E\043B\0443\0447\0438\0442\044C \0431\043E\043B\0435\0435 \043F\043E\0434\0440\043E\0431\043D\0443\044E \0438\043D\0444\043E\0440\043C\0430\0446\0438\044E \043E \0432\044B\0431\0440\0430\043D\043D\043E\0439 \0444\0443\043D\043A\0446\0438\0438.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471818235401725)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E\0437\043C\043E\0436\043D\043E\0441\0442\0438 \043E\0442\0447\0435\0442\043D\043E\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421569959401689)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\043F\0440\0430\0432\043A\0430 \043F\043E \0441\0435\0442\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468612487401723)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \043E\0431\044A\0435\0434\0438\043D\0435\043D\0438\044F \0441\0442\043E\043B\0431\0446\043E\0432. \0421\0432\043E\0434\043D\044B\0435 \0437\043D\0430\0447\0435\043D\0438\044F \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \0432 \043D\0438\0436\043D\0435\0439 \0447\0430\0441\0442\0438 \0434\0430\043D\043D\044B\0445 \0438\043B\0438, \0435\0441\043B\0438 \043E\043F\0440\0435\0434\0435\043B\0435\043D\044B \0440\0430\0437\0440\044B\0432\044B \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F, \0432 \043D\0438\0436\043D\0435\0439 \0447\0430\0441\0442\0438 \043A\0430\0436\0434\043E\0433\043E \0440\0430\0437\0440\044B\0432\0430.</p>'),
'',
unistr('<p><strong>\0421\043F\0438\0441\043E\043A \043E\0431\044A\0435\0434\0438\043D\0435\043D\0438\044F</strong><br>'),
unistr('\0412 \0441\043F\0438\0441\043A\0435 \043E\0431\044A\0435\0434\0438\043D\0435\043D\0438\044F \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0430\0433\0440\0435\0433\0430\0446\0438\0438. \041E\0442\043A\043B\044E\0447\0438\0442\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0443\044E \0430\0433\0440\0435\0433\0430\0446\0438\044E, \043E\0442\043C\0435\043D\0438\0432 \0435\0435 \0432\044B\0434\0435\043B\0435\043D\0438\0435.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 "\0414\043E\0431\0430\0432\0438\0442\044C" ( &plus; ), \0447\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \043D\043E\0432\0443\044E \0430\0433\0440\0435\0433\0430\0446\0438\044E, \0438\043B\0438 "\0423\0434\0430\043B\0438\0442\044C" ( &minus; ), \0447\0442\043E\0431\044B \0443\0434\0430\043B\0438\0442\044C \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0443\044E \0430\0433\0440\0435\0433\0430\0446\0438\044E.</p> <p>'),
'',
unistr('<p><strong>\041D\0430\0441\0442\0440\043E\0439\043A\0438 \0430\0433\0440\0435\0433\0430\0446\0438\0438</strong><br>'),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0444\043E\0440\043C\0443 \0441\043F\0440\0430\0432\0430 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0430\0433\0440\0435\0433\0430\0446\0438\0438.<br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0438\043C\044F \0441\0442\043E\043B\0431\0446\0430 \0438 \0442\0438\043F \0430\0433\0440\0435\0433\0430\0446\0438\0438.<br>'),
unistr('\041F\043E \0436\0435\043B\0430\043D\0438\044E \0432\0432\0435\0434\0438\0442\0435 \0432\0441\043F\043B\044B\0432\0430\044E\0449\0443\044E \043F\043E\0434\0441\043A\0430\0437\043A\0443 \0434\043B\044F \0430\0433\0440\0435\0433\0430\0446\0438\0438.<br>'),
unistr('\0415\0441\043B\0438 \0432\044B \043E\043F\0440\0435\0434\0435\043B\0438\043B\0438 \0440\0430\0437\0440\044B\0432 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F, \043F\0440\0438 \0432\044B\0431\043E\0440\0435 \043F\0430\0440\0430\043C\0435\0442\0440\0430 <strong>\041F\043E\043A\0430\0437\0430\0442\044C \043E\0431\0449\0435\0435 \0437\043D\0430\0447\0435\043D\0438\0435</strong> \0432 \043D\0438\0436\043D\0435\0439 \0447\0430\0441\0442\0438 \0434\0430\043D\043D\044B\0445 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \043E\0431\0449\0435\0435 \0441\0440\0435\0434\043D\0435\0435, \043E\0431\0449\0435\0435 \0438\043B\0438 \0430\043D\0430\043B\043E\0433\0438\0447\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435.</p>'),
'',
unistr('<p><em>\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435: \043E\0442\043A\0440\043E\0439\0442\0435 \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E "\0421\0432\0435\0434\0435\043D\0438\0435" \0432 \043C\0435\043D\044E "\0414\0435\0439\0441\0442\0432\0438\044F" \0438\043B\0438 \043D\0430\0436\043C\0438\0442\0435 \0437\0430\0433\043E\043B\043E\0432\043E\043A \0441\0442\043E\043B\0431\0446\0430 \0438 \0432\044B\043F\043E\043B\043D\0438\0442\0435 \0441\0443\043C\043C\0438\0440\043E\0432\0430\043D\0438\0435 ( &sum; )</em></p>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470823589401725)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469378702401723)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0434\0438\0430\0433\0440\0430\043C\043C\044B, \043A\043E\0442\043E\0440\0430\044F \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \043A\0430\043A \043E\0442\0434\0435\043B\044C\043D\043E\0435 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0434\0430\043D\043D\044B\0445.<br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0442\0438\043F \0438 \0430\0442\0440\0438\0431\0443\0442\044B \0434\0438\0430\0433\0440\0430\043C\043C\044B.</p>'),
unistr('<p><strong>\0410\0442\0440\0438\0431\0443\0442\044B \0434\0438\0430\0433\0440\0430\043C\043C\044B</strong></br>'),
unistr('\0414\043E\0441\0442\0443\043F\043D\044B\0435 \0430\0442\0440\0438\0431\0443\0442\044B \0434\0438\0430\0433\0440\0430\043C\043C\044B \0440\0430\0437\043B\0438\0447\0430\044E\0442\0441\044F \0432 \0437\0430\0432\0438\0441\0438\043C\043E\0441\0442\0438 \043E\0442 \0442\0438\043F\0430 \0434\0438\0430\0433\0440\0430\043C\043C\044B.</p>'),
'<p>',
'<ul>',
unistr('  <li>\0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446, \0441\043E\0434\0435\0440\0436\0430\0449\0438\0439 \0437\043D\0430\0447\0435\043D\0438\0435 \0434\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430:'),
'    <ul>',
unistr('      <li>\041F\043E\0434\043F\0438\0441\044C \2014 \0442\0435\043A\0441\0442 \0434\043B\044F \043A\0430\0436\0434\043E\0439 \0442\043E\0447\043A\0438 \0434\0430\043D\043D\044B\0445.</li>'),
unistr('      <li>\0417\043D\0430\0447\0435\043D\0438\0435 \2014 \0434\0430\043D\043D\044B\0435 \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F.</li>'),
unistr('      <li>\0421\0435\0440\0438\044F \2014 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \043C\043D\043E\0433\043E\0441\0435\0440\0438\0439\043D\043E\0433\043E \0434\0438\043D\0430\043C\0438\0447\0435\0441\043A\043E\0433\043E \0437\0430\043F\0440\043E\0441\0430.</li>'),
unistr('      <li>\041E\0442\043A\0440\044B\0442\0438\0435 \2014 \0435\0436\0435\0434\043D\0435\0432\043D\0430\044F \043D\0430\0447\0430\043B\044C\043D\0430\044F \0446\0435\043D\0430 \0430\043A\0446\0438\0438 (\0442\043E\043B\044C\043A\043E \0430\043A\0446\0438\0438).</li>'),
unistr('      <li>\0417\0430\043A\0440\044B\0442\0438\0435 \2014 \0435\0436\0435\0434\043D\0435\0432\043D\0430\044F \043E\043A\043E\043D\0447\0430\0442\0435\043B\044C\043D\0430\044F \0446\0435\043D\0430 \0430\043A\0446\0438\0438 (\0442\043E\043B\044C\043A\043E \0430\043A\0446\0438\0438).</li>'),
unistr('      <li>\0412\044B\0441\043E\043A\043E\0435 \2014 \0432\044B\0441\043E\043A\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 (\0442\043E\043B\044C\043A\043E \0434\0438\0430\043F\0430\0437\043E\043D \0438 \0430\043A\0446\0438\0438).</li>'),
unistr('      <li>\041D\0438\0437\043A\043E\0435 \2014 \043D\0438\0437\043A\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 (\0442\043E\043B\044C\043A\043E \0434\0438\0430\043F\0430\0437\043E\043D \0438 \0430\043A\0446\0438\0438).</li>'),
unistr('      <li>\041E\0431\044A\0435\043C \2014 \0435\0436\0435\0434\043D\0435\0432\043D\044B\0439 \043E\0431\044A\0435\043C \0442\043E\0440\0433\043E\0432 (\0442\043E\043B\044C\043A\043E \0430\043A\0446\0438\0438).</li>'),
unistr('      <li>\0426\0435\043B\044C \2014 \0446\0435\043B\0435\0432\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 (\0442\043E\043B\044C\043A\043E \0432\043E\0440\043E\043D\043A\0430).</li>'),
unistr('      <li>X \2014 \0437\043D\0430\0447\0435\043D\0438\0435 \043F\043E \043E\0441\0438 X (\0442\043E\043B\044C\043A\043E \043F\0443\0437\044B\0440\044C\043A\0438 \0438 \0442\043E\0447\043A\0438).</li>'),
unistr('      <li>Y \2014 \0437\043D\0430\0447\0435\043D\0438\0435 \043F\043E \043E\0441\0438 Y (\0442\043E\043B\044C\043A\043E \043F\0443\0437\044B\0440\044C\043A\0438 \0438 \0442\043E\0447\043A\0438).</li>'),
unistr('      <li>Z \2014 \0448\0438\0440\0438\043D\0430 \0441\0442\043E\043B\0431\0446\0430 \0438\043B\0438 \0440\0430\0434\0438\0443\0441 \043F\0443\0437\044B\0440\044C\043A\0430 (\0442\043E\043B\044C\043A\043E \0441\0442\043E\043B\0431\0446\044B, \043F\0443\0437\044B\0440\044C\043A\0438 \0438 \0434\0438\0430\043F\0430\0437\043E\043D).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\041E\0440\0438\0435\043D\0442\0430\0446\0438\044F \2014 \0432\0435\0440\0442\0438\043A\0430\043B\044C\043D\0430\044F \0438\043B\0438 \0433\043E\0440\0438\0437\043E\043D\0442\0430\043B\044C\043D\0430\044F.</li>'),
unistr('  <li>\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435 \2014 \0432\044B\0431\0435\0440\0438\0442\0435 \0432\0430\0440\0438\0430\043D\0442 \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\044F \0437\043D\0430\0447\0435\043D\0438\0439 \0434\0438\0430\0433\0440\0430\043C\043C\044B.</li>'),
unistr('  <li>\0413\0440\0443\043F\043F\0430 \2014 \0443\043A\0430\0436\0438\0442\0435, \0433\0440\0443\043F\043F\0438\0440\0443\044E\0442\0441\044F \043B\0438 \044D\043B\0435\043C\0435\043D\0442\044B \0434\0430\043D\043D\044B\0445.</li>'),
unistr('  <li>\0421\043E\0440\0442\0438\0440\043E\0432\043A\0430 \2014 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0430 \043F\043E \043F\043E\0434\043F\0438\0441\0438 \0438\043B\0438 \0437\043D\0430\0447\0435\043D\0438\044F\043C.'),
'    <ul>',
unistr('      <li>\041D\0430\043F\0440\0430\0432\043B\0435\043D\0438\0435 \2014 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0430 \0437\043D\0430\0447\0435\043D\0438\0439 \043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E \0438\043B\0438 \0443\0431\044B\0432\0430\043D\0438\044E.</li>'),
unistr('      <li>\041F\0443\0441\0442\044B\0435 \2014 \0443\043A\0430\0436\0438\0442\0435, \043A\0430\043A \0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \0437\0430\043F\0438\0441\0438 \0441 \043F\0443\0441\0442\044B\043C\0438 \0437\043D\0430\0447\0435\043D\0438\044F\043C\0438 \043F\043E \043E\0442\043D\043E\0448\0435\043D\0438\044E \043A \0437\0430\043F\0438\0441\044F\043C \0441 \043D\0435\043F\0443\0441\0442\044B\043C\0438 \0437\043D\0430\0447\0435\043D\0438\044F\043C\0438.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0414\0435\0441\044F\0442\0438\0447\043D\044B\0435 \0437\043D\0430\043A\0438</li>'),
unistr('  <li>\0417\0430\0433\043E\043B\043E\0432\043E\043A \043E\0441\0438 \043F\043E\0434\043F\0438\0441\0435\0439</li>'),
unistr('  <li>\0417\0430\0433\043E\043B\043E\0432\043E\043A \043E\0441\0438 \0437\043D\0430\0447\0435\043D\0438\0439</li>'),
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471227127401725)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0434\0438\0430\0433\0440\0430\043C\043C\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468388063401723)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E, \0447\0442\043E\0431\044B \0432\044B\0431\0440\0430\0442\044C, \043A\0430\043A\0438\0435 \0441\0442\043E\043B\0431\0446\044B \0434\043E\043B\0436\043D\044B \043E\0442\043E\0431\0440\0430\0436\0430\0442\044C\0441\044F \0438 \0432 \043A\0430\043A\043E\043C \043F\043E\0440\044F\0434\043A\0435.</p>'),
'',
unistr('<p>\0421\043A\0440\043E\0439\0442\0435 \0441\0442\043E\043B\0431\0435\0446, \043E\0442\043C\0435\043D\0438\0432 \0435\0433\043E \0432\044B\0434\0435\043B\0435\043D\0438\0435.<br>'),
unistr('\0418\0437\043C\0435\043D\0438\0442\0435 \043F\043E\0440\044F\0434\043E\043A \043A\043E\043B\043E\043D\043E\043A, \043D\0430\0436\0430\0432 \043A\043D\043E\043F\043A\0443 \041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\0432\0435\0440\0445 ( &uarr; ) \0438\043B\0438 \041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\043D\0438\0437 ( &darr; ).<br>'),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0441\0435\043B\0435\043A\0442\043E\0440 \0440\0430\0441\043A\0440\044B\0432\0430\044E\0449\0435\0433\043E\0441\044F \0441\043F\0438\0441\043A\0430, \0447\0442\043E\0431\044B \0432\044B\0431\0440\0430\0442\044C \0432\0441\0435 \0441\0442\043E\043B\0431\0446\044B, \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B \0438\043B\0438 \043D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B.<br>'),
'',
unistr('<p>\041F\0440\0438 \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E\0441\0442\0438 \0438\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0444\043E\0440\043C\0443, \0447\0442\043E\0431\044B \0443\043A\0430\0437\0430\0442\044C \043C\0438\043D\0438\043C\0430\043B\044C\043D\0443\044E \0448\0438\0440\0438\043D\0443 \0441\0442\043E\043B\0431\0446\0430 \0432 \043F\0438\043A\0441\0435\043B\044F\0445.</p>'),
'',
unistr('<p><em>\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435: \0412\044B \0442\0430\043A\0436\0435 \043C\043E\0436\0435\0442\0435 \0438\0437\043C\0435\043D\0438\0442\044C \043F\043E\0440\044F\0434\043E\043A \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432, \043D\0430\0436\0430\0432 \043D\0430 \043C\0430\0440\043A\0435\0440 \043F\0435\0440\0435\0442\0430\0441\043A\0438\0432\0430\043D\0438\044F (\0432 \043D\0430\0447\0430\043B\0435 \0437\0430\0433\043E\043B\043E\0432\043A\0430 \0441\0442\043E\043B\0431\0446\0430) \0438 \043F\0435\0440\0435\0442\0430\0449\0438\0432 \0441\0442\043E\043B\0431\0435\0446 \0432\043B\0435\0432\043E \0438\043B\0438 \0432\043F\0440\0430\0432\043E. \0422\0430\043A\0436\0435 \043C\043E\0436\043D\043E \0438\0437\043C\0435\043D\0438\0442\044C \0448\0438\0440\0438\043D\0443 \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432, \0432\044B\0431\0440\0430\0432 \0440\0430\0437\0434\0435\043B\0438\0442\0435\043B\044C \0441\0442\043E\043B\0431\0446\043E')
||unistr('\0432 \043C\0435\0436\0434\0443 \0437\0430\0433\043E\043B\043E\0432\043A\0430\043C\0438 \0438 \043F\0435\0440\0435\043C\0435\0441\0442\0438\0432 \0435\0433\043E \0432\043B\0435\0432\043E \0438\043B\0438 \0432\043F\0440\0430\0432\043E.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471112835401725)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \0441\0442\043E\043B\0431\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468745306401723)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E\0442 \0434\0438\0430\043B\043E\0433 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432 \043D\0430 \043E\0441\043D\043E\0432\0435 \043C\0430\0442\0435\043C\0430\0442\0438\0447\0435\0441\043A\0438\0445 \0438 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\044B\0445 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0439, \0432\044B\043F\043E\043B\043D\0435\043D\043D\044B\0445 \0434\043B\044F \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\0445 \0441\0442\043E\043B\0431\0446\043E\0432.</p>'),
'',
unistr('<p><strong>\0421\043F\0438\0441\043E\043A \0432\044B\0447\0438\0441\043B\0435\043D\0438\0439</strong><br>'),
unistr('\0421\043F\0438\0441\043E\043A \0432\044B\0447\0438\0441\043B\0435\043D\0438\0439 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442 \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F. \041E\0442\043A\043B\044E\0447\0438\0442\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0435\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435, \0441\043D\044F\0432 \0432\044B\0434\0435\043B\0435\043D\0438\0435.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 "\0414\043E\0431\0430\0432\0438\0442\044C" ( &plus; ), \0447\0442\043E\0431\044B \0434\043E\0431\0430\0432\0438\0442\044C \043D\043E\0432\043E\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435, \0438\043B\0438 "\0423\0434\0430\043B\0438\0442\044C" ( &minus; ), \0447\0442\043E\0431\044B \0443\0434\0430\043B\0438\0442\044C \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0435\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435.</p> <p>'),
'',
unistr('<p><strong>\041D\0430\0441\0442\0440\043E\0439\043A\0438 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0439</strong><br>'),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0444\043E\0440\043C\0443 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F.<br>'),
unistr('\0412\0432\0435\0434\0438\0442\0435 \0441\0432\0435\0434\0435\043D\0438\044F \043E \0441\0442\043E\043B\0431\0446\0435, \0442\0430\043A\0438\0435 \043A\0430\043A \0437\0430\0433\043E\043B\043E\0432\043E\043A, \043C\0435\0442\043A\0430 \0438 \043F\0430\0440\0430\043C\0435\0442\0440\044B \0432\044B\0440\0430\0432\043D\0438\0432\0430\043D\0438\044F \043F\0440\0438 \0432\044B\0431\043E\0440\0435.<br> '),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0442\0435\043A\0441\0442\043E\0432\0443\044E \043E\0431\043B\0430\0441\0442\044C "\0412\044B\0440\0430\0436\0435\043D\0438\0435" \0434\043B\044F \0432\0432\043E\0434\0430 \0441\0442\043E\043B\0431\0446\043E\0432 \0438 \0441\0432\044F\0437\0430\043D\043D\044B\0445 \0444\0443\043D\043A\0446\0438\0439 \0434\043B\044F \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F.<br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0439 \0442\0438\043F \0434\0430\043D\043D\044B\0445 \0438, \043F\043E \0436\0435\043B\0430\043D\0438\044E, \043C\0430\0441\043A\0443 \0444\043E\0440\043C\0430\0442\0430 \0434\043B\044F \043D\043E\0432\043E\0433\043E \0441\0442\043E\043B\0431\0446\0430.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470732458401724)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469067281401723)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438 \0432 \043E\0434\043D\043E\043C \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\0438\0445 \0441\0442\043E\043B\0431\0446\0430\0445.</p>'),
'',
unistr('<p><strong>\0421\043F\0438\0441\043E\043A \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438</strong><br>'),
unistr('\0412 \0421\043F\0438\0441\043A\0435 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0439. \041E\0442\043A\043B\044E\0447\0438\0442\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\0439 \0441\0442\043E\043B\0431\0435\0446 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438, \043E\0442\043C\0435\043D\0438\0432 \0435\0433\043E \0432\044B\0434\0435\043B\0435\043D\0438\0435.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 "\0414\043E\0431\0430\0432\0438\0442\044C" ( &plus; ), \0447\0442\043E\0431\044B \0432\043A\043B\044E\0447\0438\0442\044C \043D\043E\0432\044B\0439 \0441\0442\043E\043B\0431\0435\0446 \0432 \0441\043C\0435\043D\0443 \043E\043F\0435\0440\0430\0446\0438\0438, \0438\043B\0438 "\0423\0434\0430\043B\0438\0442\044C" ( &minus; ), \0447\0442\043E\0431\044B \0443\0434\0430\043B\0438\0442\044C \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\0439 \0441\0442\043E\043B\0431\0435\0446 \0438\0437 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438.<br>'),
unistr('\0427\0442\043E\0431\044B \0438\0437\043C\0435\043D\0438\0442\044C \043F\043E\0440\044F\0434\043E\043A \0441\0442\043E\043B\0431\0446\043E\0432, \043D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\0432\0435\0440\0445" ( &uarr; ) \0438\043B\0438 "\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\043D\0438\0437" ( &darr; ), \0447\0442\043E\0431\044B \043F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\044B\0431\0440\0430\043D\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446 \0432\0432\0435\0440\0445 \0438\043B\0438 \0432\043D\0438\0437 \043E\0442\043D\043E\0441\0438\0442\0435\043B\044C\043D\043E \0434\0440\0443\0433\0438\0445 \0441\0442\043E\043B\0431\0446\043E\0432.</p>'),
'',
unistr('<p><strong>\041D\0430\0441\0442\0440\043E\0439\043A\0438 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438</strong><br>'),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0444\043E\0440\043C\0443 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0441\0442\043E\043B\0431\0446\0430 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438.<br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438, \043D\0430\043F\0440\0430\0432\043B\0435\043D\0438\0435 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438 \0438 \0441\043F\043E\0441\043E\0431 \0443\043F\043E\0440\044F\0434\043E\0447\0438\0432\0430\043D\0438\044F \043F\0443\0441\0442\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432 (\0441\0442\043E\043B\0431\0446\043E\0432 \0431\0435\0437 \0437\043D\0430\0447\0435\043D\0438\044F).</p>'),
'',
unistr('<p><em>\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435. \041F\0440\0438 \043F\0440\043E\0441\043C\043E\0442\0440\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438 \0432\044B \043C\043E\0436\0435\0442\0435 \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0441\043C\0435\043D\0443 \043E\043F\0435\0440\0430\0446\0438\0439, \043D\0430\0436\0430\0432 \043D\0430 \0437\0430\0433\043E\043B\043E\0432\043E\043A \0441\0442\043E\043B\0431\0446\0430 \0438 \0432\044B\0431\0440\0430\0432 \0437\043D\0430\0447\043E\043A \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470459519401724)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0441\043C\0435\043D\0435 \043E\043F\0435\0440\0430\0446\0438\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469276780401723)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \0432\044B\0433\0440\0443\0437\043A\0438 \0432\0441\0435\0445 \0442\0435\043A\0443\0449\0438\0445 \0441\0442\0440\043E\043A \0432\043E \0432\043D\0435\0448\043D\0438\0439 \0444\0430\0439\043B. \0424\0430\0439\043B \0431\0443\0434\0435\0442 \0441\043E\0434\0435\0440\0436\0430\0442\044C \0442\043E\043B\044C\043A\043E \0442\0435\043A\0443\0449\0438\0435 \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B, \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \043B\044E\0431\044B\0445 \0444\0438\043B\044C\0442\0440\043E\0432 \0438 \0441\043E\0440\0442\0438\0440\043E\0432\043E\043A, \043F\0440\0438\043C\0435\043D\0435\043D\043D\044B\0445 \043A \0434\0430\043D\043D\044B\043C.</p>'),
'',
unistr('<p>\0412\044B\0431\0435\0440\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \0444\0430\0439\043B\0430 \0438 \043D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\0412\044B\0433\0440\0443\0437\0438\0442\044C".<br>'),
unistr('\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435: CSV \043D\0435 \0432\043A\043B\044E\0447\0430\0435\0442 \0444\043E\0440\043C\0430\0442\0438\0440\043E\0432\0430\043D\0438\0435 \0442\0435\043A\0441\0442\0430, \0442\0430\043A\043E\0435 \043A\0430\043A \0430\0433\0440\0435\0433\0430\0442\044B \0438 \0440\0430\0437\0440\044B\0432\044B \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F.</p>'),
'',
unistr('<p>\0427\0442\043E\0431\044B \043E\0442\043F\0440\0430\0432\0438\0442\044C \0444\0430\0439\043B \043F\043E \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\0435, \0432\044B\0431\0435\0440\0438\0442\0435 "\041F\0435\0440\0435\0434\0430\0442\044C \043F\043E \044D\043B. \043F\043E\0447\0442\0435" \0438 \0432\0432\0435\0434\0438\0442\0435 \0434\0430\043D\043D\044B\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B ("\041F\043E\043B\0443\0447\0430\0442\0435\043B\044C", "\0422\0435\043C\0430" \0438 "\0421\043E\043E\0431\0449\0435\043D\0438\0435").</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470244370401724)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0432\044B\0433\0440\0443\0437\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468438849401723)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0444\0438\043B\044C\0442\0440\043E\0432 \0434\0430\043D\043D\044B\0445, \043A\043E\0442\043E\0440\044B\0435 \043E\0433\0440\0430\043D\0438\0447\0438\0432\0430\044E\0442 \0432\043E\0437\0432\0440\0430\0449\0430\0435\043C\044B\0435 \0441\0442\0440\043E\043A\0438.</p>'),
'',
unistr('<p><strong>\0421\043F\0438\0441\043E\043A \0444\0438\043B\044C\0442\0440\043E\0432</strong><br>'),
unistr('\0412 \0441\043F\0438\0441\043A\0435 \0424\0438\043B\044C\0442\0440 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0444\0438\043B\044C\0442\0440\044B. \041E\0442\043A\043B\044E\0447\0438\0442\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\0439 \0444\0438\043B\044C\0442\0440, \0441\043D\044F\0432 \0441 \043D\0435\0433\043E \0432\044B\0434\0435\043B\0435\043D\0438\0435.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\0414\043E\0431\0430\0432\0438\0442\044C" ( &plus; ), \0447\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \043D\043E\0432\044B\0439 \0444\0438\043B\044C\0442\0440, \0438\043B\0438 "\0423\0434\0430\043B\0438\0442\044C" ( &minus; ), \0447\0442\043E\0431\044B \0443\0434\0430\043B\0438\0442\044C \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\0439 \0444\0438\043B\044C\0442\0440.</p> <p><strong>\0421\043F\0438\0441\043E\043A \0444\0438\043B\044C\0442\0440\043E\0432</strong><br>.'),
'',
unistr('<p><strong>\041D\0430\0441\0442\0440\043E\0439\043A\0438 \0444\0438\043B\044C\0442\0440\0430</strong><br>'),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0444\043E\0440\043C\0443 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0441\0432\043E\0439\0441\0442\0432 \0444\0438\043B\044C\0442\0440\0430.<br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0439 \0442\0438\043F \0444\0438\043B\044C\0442\0440\0430:<br>'),
unistr('&nbsp;&nbsp;&nbsp;&nbsp;\0421\0442\0440\043E\043A\0430\00A0\2014 \0444\0438\043B\044C\0442\0440 \0434\043B\044F \0442\0435\0440\043C\0438\043D\0430 \0432 \043B\044E\0431\043E\043C \0441\0442\043E\043B\0431\0446\0435, \043A \043A\043E\0442\043E\0440\043E\043C\0443 \043F\0440\0438\043C\0435\043D\044F\0435\0442\0441\044F \0444\0438\043B\044C\0442\0440.<br>'),
unistr('&nbsp;&nbsp;&nbsp;&nbsp;\0421\0442\043E\043B\0431\0435\0446\00A0\2014 \0444\0438\043B\044C\0442\0440 \043A\043E\043D\043A\0440\0435\0442\043D\043E\0433\043E \0441\0442\043E\043B\0431\0446\0430 \0441 \0437\0430\0434\0430\043D\043D\044B\043C \043E\043F\0435\0440\0430\0442\043E\0440\043E\043C \0438 \0437\043D\0430\0447\0435\043D\0438\0435\043C.</p>'),
'',
unistr('<p><em>\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435: \043F\0440\0438 \043F\0440\043E\0441\043C\043E\0442\0440\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438 \0432\044B \043C\043E\0436\0435\0442\0435 \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0444\0438\043B\044C\0442\0440\044B \0441\0442\0440\043E\043A, \0432\0432\0435\0434\044F \0442\0435\043A\0441\0442 \043D\0435\043F\043E\0441\0440\0435\0434\0441\0442\0432\0435\043D\043D\043E \0432 \043F\043E\043B\0435 \043F\043E\0438\0441\043A\0430. \041D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \043F\043E\0438\0441\043A\0430", \0447\0442\043E\0431\044B \043E\0433\0440\0430\043D\0438\0447\0438\0442\044C \043F\043E\0438\0441\043A \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\043C \0441\0442\043E\043B\0431\0446\043E\043C. \0422\0430\043A\0436\0435 \043E\0442\043A\0440\043E\0439\0442\0435 \043C\0435\043D\044E \0437\0430\0433\043E\043B\043E')
||unistr('\0432\043A\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432 \0438 \0432\044B\0431\0435\0440\0438\0442\0435 \0437\043D\0430\0447\0435\043D\0438\0435, \0447\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \0444\0438\043B\044C\0442\0440 \0441\0442\043E\043B\0431\0446\0430.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471028590401725)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0444\0438\043B\044C\0442\0440\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468836252401723)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \043F\0440\043E\0441\043C\043E\0442\0440\0430 \0434\0430\043D\043D\044B\0445 \0432 \0442\043E\043C \0432\0438\0434\0435, \0432 \043A\043E\0442\043E\0440\043E\043C \043E\043D\0438 \0441\0443\0449\0435\0441\0442\0432\043E\0432\0430\043B\0438 \0432 \043F\0440\0435\0434\044B\0434\0443\0449\0438\0439 \043C\043E\043C\0435\043D\0442 \0432\0440\0435\043C\0435\043D\0438.</p>'),
unistr('<p>\0423\043A\0430\0436\0438\0442\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \043C\0438\043D\0443\0442 \0432 \043F\0440\043E\0448\043B\043E\043C, \0447\0442\043E\0431\044B \0432\044B\043F\043E\043B\043D\0438\0442\044C \0437\0430\043F\0440\043E\0441 flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470699448401724)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E Flashback')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471324250401725)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468967639401723)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \0432\044B\0434\0435\043B\0435\043D\0438\044F \0441\0442\0440\043E\043A \0438\043B\0438 \0441\0442\043E\043B\0431\0446\043E\0432 \0434\0430\043D\043D\044B\0445 \043D\0430 \043E\0441\043D\043E\0432\0435 \0432\0432\0435\0434\0435\043D\043D\043E\0433\043E \0443\0441\043B\043E\0432\0438\044F.</p>'),
'',
unistr('<p><strong>\0421\043F\0438\0441\043E\043A \0432\044B\0434\0435\043B\0435\043D\0438\0439</strong><br>'),
unistr('\0412 "\0421\043F\0438\0441\043A\0435 \0432\044B\0434\0435\043B\0435\043D\0438\0439" \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0432\044B\0434\0435\043B\0435\043D\0438\044F. \041E\0442\043A\043B\044E\0447\0438\0442\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0435\0435 \0432\044B\0434\0435\043B\0435\043D\0438\0435, \0441\043D\044F\0432 \0432\044B\0431\043E\0440 \0432\044B\0434\0435\043B\0435\043D\0438\044F.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\0414\043E\0431\0430\0432\0438\0442\044C" ( &plus; ), \0447\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \043D\043E\0432\043E\0435 \0432\044B\0434\0435\043B\0435\043D\0438\0435, \0438\043B\0438 "\0423\0434\0430\043B\0438\0442\044C" ( &minus; ), \0447\0442\043E\0431\044B \0443\0434\0430\043B\0438\0442\044C \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0435\0435 \0432\044B\0434\0435\043B\0435\043D\0438\0435.</p> <p>'),
'',
unistr('<p><strong>\041D\0430\0441\0442\0440\043E\0439\043A\0438 \0432\044B\0434\0435\043B\0435\043D\0438\044F</strong><br>'),
unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0444\043E\0440\043C\0443 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0441\0432\043E\0439\0441\0442\0432 \0432\044B\0434\0435\043B\0435\043D\0438\044F.<br>'),
unistr('\0412\0432\0435\0434\0438\0442\0435 \0438\043C\044F, \0432\044B\0431\0435\0440\0438\0442\0435 \0437\043D\0430\0447\0435\043D\0438\044F "\0421\0442\0440\043E\043A\0430" \0438\043B\0438 "\0421\0442\043E\043B\0431\0435\0446" \0438 \0432\044B\0431\0435\0440\0438\0442\0435 \0446\0432\0435\0442\043E\0432\044B\0435 \043A\043E\0434\044B HTML \0434\043B\044F \0444\043E\043D\0430 \0438 \0442\0435\043A\0441\0442\0430.<br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0439 <strong>\0422\0438\043F \0443\0441\043B\043E\0432\0438\044F</strong> \0434\043B\044F \0432\044B\0434\0435\043B\0435\043D\0438\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0445 \0434\0430\043D\043D\044B\0445:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0421\0442\0440\043E\043A\0430\00A0\2014 \0432\044B\0434\0435\043B\0435\043D\0438\0435 \0442\0435\0440\043C\0438\043D\0430 \0432 \043B\044E\0431\043E\043C \0441\0442\043E\043B\0431\0446\0435.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0421\0442\043E\043B\0431\0435\0446\00A0\2014 \0432\044B\0434\0435\043B\0435\043D\0438\0435 \0432 \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\043E\043C \0441\0442\043E\043B\0431\0446\0435 \043D\0430 \043E\0441\043D\043E\0432\0435 \0443\043A\0430\0437\0430\043D\043D\043E\0433\043E \043E\043F\0435\0440\0430\0442\043E\0440\0430 \0438 \0437\043D\0430\0447\0435\043D\0438\044F.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470537698401724)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0432\044B\0434\0435\043B\0435\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469133282401723)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \0441\043E\0445\0440\0430\043D\0435\043D\0438\044F \0438\0437\043C\0435\043D\0435\043D\0438\0439, \0432\043D\0435\0441\0435\043D\043D\044B\0445 \0432 \0442\0435\043A\0443\0449\0438\0439 \043C\0430\043A\0435\0442 \0438 \043A\043E\043D\0444\0438\0433\0443\0440\0430\0446\0438\044E \0441\0435\0442\043A\0438.<br>'),
unistr('\0420\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \043C\043E\0433\0443\0442 \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \043D\0435\0441\043A\043E\043B\044C\043A\043E \0430\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0445 \043C\0430\043A\0435\0442\043E\0432 \043E\0442\0447\0435\0442\043E\0432. \0422\0430\043C, \0433\0434\0435 \044D\0442\043E \0434\043E\043F\0443\0441\0442\0438\043C\043E, \0432\044B \0438 \0434\0440\0443\0433\0438\0435 \043A\043E\043D\0435\0447\043D\044B\0435 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043C\043E\0436\0435\0442\0435 \0441\043E\0445\0440\0430\043D\0438\0442\044C \043E\0442\0447\0435\0442 \043A\0430\043A "\041E\0431\0449\0435\0434\043E\0441\0442\0443\043F\043D\044B\0439", \0447\0442\043E \0434\0435\043B\0430\0435\0442 \0435\0433\043E \0434\043E\0441\0442\0443\043F\043D\044B\043C \0434\043B\044F \0432\0441\0435\0445 \0434\0440\0443\0433\0438\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439 \0441\0435\0442\043A\0438. \0412\044B ')
||unistr('\0442\0430\043A\0436\0435 \043C\043E\0436\0435\0442\0435 \0441\043E\0445\0440\0430\043D\0438\0442\044C \043E\0442\0447\0435\0442 \043A\0430\043A "\0417\0430\043A\0440\044B\0442\044B\0439", \043A\043E\0442\043E\0440\044B\0439 \0441\043C\043E\0436\0435\0442\0435 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C \0442\043E\043B\044C\043A\043E \0432\044B.</p>'),
unistr('<p>\0412\044B\0431\0435\0440\0438\0442\0435 \043E\0434\0438\043D \0438\0437 \0434\043E\0441\0442\0443\043F\043D\044B\0445 \0442\0438\043F\043E\0432 \0438 \0432\0432\0435\0434\0438\0442\0435 \0438\043C\044F \0441\043E\0445\0440\0430\043D\0435\043D\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470322669401724)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \043E\0442\0447\0435\0442\0443'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468558370401723)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0434\043B\044F \0443\0441\0442\0430\043D\043E\0432\043A\0438 \043F\043E\0440\044F\0434\043A\0430 \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F.</p>'),
'',
unistr('<p><strong>\0421\043F\0438\0441\043E\043A \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438</strong><br>'),
unistr('\0412 \0434\0438\0430\043B\043E\0433\043E\0432\043E\043C \043E\043A\043D\0435 "\0421\043E\0440\0442\0438\0440\043E\0432\043A\0430" \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\043F\0438\0441\043E\043A \043D\0430\0441\0442\0440\043E\0435\043D\043D\044B\0445 \043F\0440\0430\0432\0438\043B \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 "\0414\043E\0431\0430\0432\0438\0442\044C" ( &plus; ), \0447\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438, \0438\043B\0438 "\0423\0434\0430\043B\0438\0442\044C" ( &minus; ), \0447\0442\043E\0431\044B \0443\0434\0430\043B\0438\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438.<br>'),
unistr('\041D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 "\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\0432\0435\0440\0445" ( &uarr; ) \0438 "\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\043D\0438\0437" ( &darr; ), \0447\0442\043E\0431\044B \043F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\044B\0431\0440\0430\043D\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438 \0432\0432\0435\0440\0445 \0438 \0432\043D\0438\0437 \043E\0442\043D\043E\0441\0438\0442\0435\043B\044C\043D\043E \0434\0440\0443\0433\0438\0445 \0441\0442\043E\043B\0431\0446\043E\0432 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438.</p>'),
'',
unistr('<p><strong>\041D\0430\0441\0442\0440\043E\0439\043A\0438 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438</strong><br>'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438, \043D\0430\043F\0440\0430\0432\043B\0435\043D\0438\0435 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438 \0438 \0441\043F\043E\0441\043E\0431 \0443\043F\043E\0440\044F\0434\043E\0447\0438\0432\0430\043D\0438\044F \043F\0443\0441\0442\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432 (\0441\0442\043E\043B\0431\0446\043E\0432 \0431\0435\0437 \0437\043D\0430\0447\0435\043D\0438\044F).</p> '),
'',
unistr('<p><em>\041F\0440\0438\043C\0435\0447\0430\043D\0438\0435: \0434\0430\043D\043D\044B\0435 \043C\043E\0436\043D\043E \0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0441\0442\043E\043B\0431\0446\0430\043C, \043A\043E\0442\043E\0440\044B\0435 \043D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F; \043E\0434\043D\0430\043A\043E \043D\0435 \0432\0441\0435 \0441\0442\043E\043B\0431\0446\044B \043C\043E\0436\043D\043E \0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C.</em><br>'),
unistr('<em>\041E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B \043C\043E\0436\043D\043E \0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C, \043D\0430\0436\0438\043C\0430\044F \0441\0442\0440\0435\043B\043A\0438 \0432\0432\0435\0440\0445 (\043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E) \0438\043B\0438 \0432\043D\0438\0437 (\043F\043E \0443\0431\044B\0432\0430\043D\0438\044E) \0432 \043A\043E\043D\0446\0435 \0437\0430\0433\043E\043B\043E\0432\043A\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432. \0427\0442\043E\0431\044B \0434\043E\0431\0430\0432\0438\0442\044C \043F\043E\0441\043B\0435\0434\0443\044E\0449\0438\0439 \0441\0442\043E\043B\0431\0435\0446 \043A \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0435\0439 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0435, \0443\0434\0435\0440\0436\0438\0432\0430\0439\0442\0435 \043A\043B\0430\0432\0438\0448\0443 "Shift" \0438 \043D\0430\0436\043C\0438\0442\0435 \0441\0442\0440\0435\043B\043A\0443 \0432\0432\0435\0440\0445 \0438')
||unistr('\043B\0438 \0432\043D\0438\0437.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470935980401725)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0441\043E\0440\0442\0438\0440\043E\0432\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114470126973401724)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \043F\043E\0434\043F\0438\0441\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422434068401689)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043A\0440\044B\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389277334401665)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0434\0435\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457276418401715)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0441\043E\043A\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458044360401715)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0433\043E\0440\0438\0437\043E\043D\0442\0430\043B\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415471639401684)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420404101401688)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388158810401664)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0432 \0432\0438\0434\0435 \0437\043D\0430\0447\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413616574401683)
,p_name=>'APEX.IG.IN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422010219401689)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0430\043A\0442\0438\0432\043D\0430\044F \043D\0430\0441\0442\0440\043E\0439\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422120795401689)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0430\043A\0442\0438\0432\043D\044B\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429734960401695)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \0437\0430\043F\0440\043E\0441\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438 \043F\0440\043E\0438\0437\043E\0448\043B\0430 \0432\043D\0443\0442\0440\0435\043D\043D\044F\044F \043E\0448\0438\0431\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325526647401618)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0444\0438\043B\044C\0442\0440\0430 \0441\0442\043E\043B\0431\0446\0430 "%0" \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0441\0442\043E\043B\0431\0446\043E\0432 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469938154401724)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0444\043E\0440\043C\0430\0442 \0434\0430\0442\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444172405401705)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\0435 \0444\0438\043B\044C\0442\0440\0430 \043F\043E \0441\0442\043E\043B\0431\0446\0443 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444062390401705)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \044F\0432\043B\044F\0435\0442\0441\044F \0434\043E\043F\0443\0441\0442\0438\043C\044B\043C \0442\0438\043F\043E\043C \0444\0438\043B\044C\0442\0440\0430 \0434\043B\044F \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \0444\0438\043B\044C\0442\0440\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330626571401622)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0444\043E\0440\043C\0430\0442 \0447\0438\0441\0435\043B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472675417401726)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\0430\044F \043D\0430\0441\0442\0440\043E\0439\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472738069401726)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463751064401719)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0441\0442\0440\043E\0435\043D\0430 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0430 %0, \043D\043E \043D\0435 \0432\044B\0431\0440\0430\043D\044B \0441\0442\043E\043B\0431\0446\044B \0434\043B\044F %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461000454401717)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456119178401714)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414428815401683)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 \043F\043E\0441\043B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414673838401684)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 \0441\043B\0435\0434\0443\044E\0449.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413527678401683)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \043F\0443\0441\0442\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413496065401683)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\0443\0441\0442\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464574934401720)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456597121401714)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460400910401717)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403707216401675)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0439 \0434\0435\043D\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403996058401676)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0439 \0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404438758401676)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\044F\044F \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403487937401675)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\044B\0439 \043C\0435\0441\044F\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403568647401675)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0430\044F \043D\0435\0434\0435\043B\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403645945401675)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403867436401676)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404511880401676)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404342351401676)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404230264401676)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403221928401675)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435%0 \0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403398184401675)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\044B\0439 \0433\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464767405401720)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0432\043D\0438\0432\0430\043D\0438\0435 \044F\0447\0435\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464898749401720)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0433\0440\0443\043F\043F\0443 \0434\043B\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414052706401683)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\043D\044C\0448\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414198375401683)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\043D\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458652062401716)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041B\0438\043D\0435\0439\043D\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458708727401716)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'ru'
,p_message_text=>unistr('\041B\0438\043D\0438\044F \0441 \043E\0431\043B\0430\0441\0442\044C\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465121671401720)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'ru'
,p_message_text=>'ListAgg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457301338401715)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0438\0437\043A\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467765143401722)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0434\0435\043B\044F\0442\044C \0430\0434\0440\0435\0441\0430 \0437\0430\043F\044F\0442\044B\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415253505401684)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \0440\0435\0433\0443\043B\044F\0440\043D\043E\043C\0443 \0432\044B\0440\0430\0436\0435\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439651559401702)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475279483401728)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0438\0439 \043C\0430\043A\0441\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439899042401702)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0434\0438\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475375256401728)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0430\044F \043C\0435\0434\0438\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439544753401702)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415305994401684)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440338250401702)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0438\043D. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475170296401728)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0438\0439 \043C\0438\043D\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415721613401684)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422327526401689)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A \0432 \0434\0430\043D\043D\044B\0445: \0431\043E\043B\0435\0435 %0. \042D\0442\043E \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E \0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435. \0414\043B\044F \043F\0440\043E\0441\043C\043E\0442\0440\0430 \0440\0435\0437\0443\043B\044C\0442\0430\0442\043E\0432 \043F\0440\0438\043C\0435\043D\0438\0442\0435 \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0435 \0444\0438\043B\044C\0442\0440\044B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449097452401708)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0441\0442\0430\0442\0438\0447\0435\0441\043A\0438\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043E\0431\043B\0430\0441\0442\0438, \0442\0430\043A \043A\0430\043A \0441\0442\0440\0430\043D\0438\0446\0430 \0441\043E\0434\0435\0440\0436\0438\0442 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0445 \0441\0435\0442\043E\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418493168401686)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418699132401686)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\0435\043D\043E\0432\0430\043D\043D\044B\0439 \043E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402643816401675)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \0434\0435\043D\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402400663401675)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404651920401676)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0430\044F \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402933661401675)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \043C\0435\0441\044F\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402889052401675)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0430\044F \043D\0435\0434\0435\043B\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402776901401675)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114402538387401675)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404727029401676)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404013737401676)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404120200401676)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403146142401675)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114403064648401675)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \0433\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414371278401683)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \043C\0435\0436\0434\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413396390401683)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0440\0430\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479507137401731)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043B\0430\0441\0442\044C \0441 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C %0 \043D\0435 \044F\0432\043B\044F\0435\0442\0441\044F \043E\0431\043B\0430\0441\0442\044C\044E \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438 \0438\043B\0438 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0432 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413708584401683)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414553256401683)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0432 \043F\043E\0441\043B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114414741591401684)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0432 \0441\043B\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422298071401689)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043D\043D\044B\0435 \043D\0435 \043D\0430\0439\0434\0435\043D\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460243124401717)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\044F null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465334383401720)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0438\0441\043B\043E\0432\043E\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460502572401717)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\043A\043B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460635453401717)
,p_name=>'APEX.IG.ON'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412529854401682)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('1 \043C\0438\043D\0443\0442\0430 \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468220249401723)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\0440\044B\0442\044C \043E\043A\043D\043E \0432\044B\0431\043E\0440\0430 \0446\0432\0435\0442\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457023985401714)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\0440\044B\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419588340401687)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\043F\0435\0440\0430\0442\043E\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456436305401714)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0440\0438\0435\043D\0442\0430\0446\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458838023401716)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0440\0443\0433\043E\0432\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114420833998401688)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\0435\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114388404386401664)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0441\0440\0435\0437\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114468140013401722)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0440\0430\0437\0434\0435\043B\0435\043D\0438\044F \0437\043D\0430\0447\0435\043D\0438\0439 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114458903903401716)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\044F\0440\043D\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464290450401720)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0435\043D\0442\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464363736401720)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043D\0435\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114464195556401720)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0430\043B\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418798173401686)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\043E\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419091963401687)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\043E\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435557364401699)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\043E\0439 \043E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317722244401613)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0438\0442\044C \0442\0435\0433\0438 \0441\043F\0435\0446\0438\0430\043B\044C\043D\044B\0445 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\0435\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316441912401612)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0431\043E\043C\043D\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316518522401612)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043D\0438\0436\043D\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316310964401612)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0440\0438\0435\043D\0442\0430\0446\0438\044F \0441\0442\0440\0430\043D\0438\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316236634401612)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'ru'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316157292401612)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'ru'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317835233401613)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0432\044B\0431\043E\0440\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315904566401612)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'ru'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315826617401611)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'ru'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316023835401612)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'ru'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315724282401611)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \0441\0442\0440\0430\043D\0438\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305960446401604)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0444\043E\0440\043C\0430\0442\0438\0440\043E\0432\0430\043D\0438\0435 \0442\0435\043A\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459069074401716)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041B\0435\043F\0435\0441\0442\043A\043E\0432\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459199207401716)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0438\0430\043F\0430\0437\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469405768401723)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423044732401690)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421896850401689)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\0438\0442\044C \0441\0442\0440\043E\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427047987401693)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043B\0430\0441\0442\044C \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0438 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0432 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0438 %0, \0441\0442\0440\0430\043D\0438\0446\0435 %1 \0438 \043E\0431\043B\0430\0441\0442\0438 %2.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389923748401665)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418148541401686)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478799930401730)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442 \0443\0434\0430\043B\0435\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478453908401730)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442, \0441\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \0434\043B\044F \0432\0441\0435\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478315864401730)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E, \0441\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \0434\043B\044F \0432\0441\0435\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478642143401730)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0430\0441\0442\043D\044B\0439 \043E\0442\0447\0435\0442 \0441\043E\0445\0440\0430\043D\0435\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478502820401730)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0434\043E\0441\0442\0443\043F\043D\044B\0439 \043E\0442\0447\0435\0442, \0441\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \0434\043B\044F \0432\0441\0435\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114427140932401693)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\0430\044F \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430 \0441 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412451429401682)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0438\0442\044C \0434\0430\043D\043D\044B\0435 \043F\043E \0441\043E\0441\0442\043E\044F\043D\0438\044E %0 \043C\0438\043D. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412315027401682)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0438\0442\044C \0434\0430\043D\043D\044B\0435 \043F\043E \0441\043E\0441\0442\043E\044F\043D\0438\044E 1 \043C\0438\043D\0443\0442\0430 \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352040049401638)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442 \043F\043E \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0439 \0441\0435\0442\043A\0435 \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471679234401725)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442 - \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426956693401692)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\0430\044F \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430 \0441 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114471512121401725)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442 \2014 \0421\043E\0445\0440\0430\043D\0438\0442\044C \043A\0430\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390079677401665)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479687576401731)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\0430\044F \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430 \0441\043E \0441\0442\0430\0442\0438\0447\0435\0441\043A\0438\043C \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474539973401727)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0438\0434 \043E\0442\0447\0435\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389111895401665)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423108325401690)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0438\0442\044C \0438\0437\043C\0435\043D\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421939366401689)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0435\0440\043D\0443\0442\044C \0441\0442\0440\043E\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419143296401687)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418053899401686)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479291132401731)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0439\0441\0442\0432\0438\044F \0441\043E \0441\0442\0440\043E\043A\0430\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480439326401731)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0439\0441\0442\0432\0438\044F \0434\043B\044F \0441\0442\0440\043E\043A\0438 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114389401506401665)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432123059401696)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\043E\0445\0440\0430\043D\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387677176401664)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\044B\0435 \043E\0442\0447\0435\0442\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387781547401664)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362260840401645)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \043E\0442\0447\0435\0442 \0441 \0438\043C\0435\043D\0435\043C %0 \0443\0436\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442. \0412\0432\0435\0434\0438\0442\0435 \043D\043E\0432\043E\0435 \0438\043C\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387801907401664)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0430\0441\0442\043D\044B\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387924420401664)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0434\043E\0441\0442\0443\043F\043D\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474203752401727)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C \043A\0430\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421210789401688)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459213152401716)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\0440\0440\0435\043B\044F\0446\0438\043E\043D\043D\044B\0439 \0433\0440\0430\0444\0438\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387599946401664)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466549404401721)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A: \0432\0441\0435 \0442\0435\043A\0441\0442\043E\0432\044B\0435 \0441\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387409186401664)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465751582401721)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A: \043F\043E\043B\043D\043E\0442\0435\043A\0441\0442\043E\0432\044B\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412267344401682)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455834610401713)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0435\0440\0438\0442\0435 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396082854401670)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\043D\043D\044B\0435 \044D\043B\0435\043C\0435\043D\0442\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448776960401708)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 1 \0441\0442\0440\043E\043A\0443 \0432 \043E\0441\043D\043E\0432\043D\043E\0439 \043E\0431\043B\0430\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387382643401663)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \043F\043E\0438\0441\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478949336401730)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0439\0441\0442\0432\0438\044F \0441 \0432\044B\0431\0440\0430\043D\043D\044B\043C\0438 \044D\043B\0435\043C\0435\043D\0442\0430\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396242085401670)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\043E\0440 \044F\0447\0435\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396177150401670)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\043E\0440 \0441\0442\0440\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467126124401722)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0434\0430\0442\044C \043F\043E \044D\043B. \043F\043E\0447\0442\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459688965401716)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\0440\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385339993401662)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437930704401700)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C \043E\0431\0449\0435\0435 \0437\043D\0430\0447\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422733851401689)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \043E\0434\043D\043E\0439 \0441\0442\0440\043E\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421040411401688)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459787818401716)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479358280401731)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\043E\0436\043D\043E \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0442\043E\043B\044C\043A\043E \043E\0434\043D\0443 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0443 \043D\0430 \0441\0442\043E\043B\0431\0435\0446.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479111490401731)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\044E "\0418\0437\043C\0435\043D\0438\0442\044C"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114460709334401717)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415063813401684)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459376479401716)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0411\0438\0440\0436\0435\0432\0430\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380387106401658)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0428\0438\0440\0438\043D\044B \0440\0430\0441\0442\044F\043D\0443\0442\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114421429436401688)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114439433823401702)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0443\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480691115401732)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\0435\0442\043A\0430. \041E\0442\0447\0435\0442: %0, \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114474647409401727)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0430\044F \0441\0443\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457574531401715)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\043D\0430\0447\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463987314401719)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0432\0435\0442 \0442\0435\043A\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390150661401666)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043A\043B\044E\0447\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437891819401700)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\043F\043B\044B\0432\0430\044E\0449\0430\044F \043F\043E\0434\0441\043A\0430\0437\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114418238249401686)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114422654070401689)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0438\0442\044C \0444\0438\043A\0441\0430\0446\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419727645401687)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0434\0438\043D\0438\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466974203401722)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0435\043D\0438\044F \043D\0435 \0441\043E\0445\0440\0430\043D\0435\043D\044B. \041F\0440\043E\0434\043E\043B\0436\0438\0442\044C?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114419627554401687)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456612917401714)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461507220401718)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0440\0435\0431\0443\0435\0442\0441\044F \0437\0430\0434\0430\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446459277401707)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435 (\0447\0430\0441\043E\0432\043E\0439 \043F\043E\044F\0441 \043D\0435\043B\044C\0437\044F \0438\0437\043C\0435\043D\0438\0442\044C)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465411277401721)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457960352401715)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0432\0435\0440\0442\0438\043A\0430\043B\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417738927401686)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455975496401714)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114457405665401715)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\044A\0435\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415601856401684)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456035527401714)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0430\043B\044C\043D\0430\044F \0448\0438\0440\0438\043D\0430 \0441\0442\043E\043B\0431\0446\0430 (\043F\0438\043A\0441\0435\043B\0438)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406815443401678)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0435\0436\0434\0443 %1 \0438 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406508298401678)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\0434\0435\0440\0436\0438\0442 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406678451401678)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384733407401662)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \043D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0441 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405354982401677)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0440\0430\0432\043D\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405556178401677)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0431\043E\043B\044C\0448\0435 \0447\0435\043C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405687759401677)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0431\043E\043B\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406392890401677)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0432 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407500473401678)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407380523401678)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407170507401678)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407992890401679)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407705853401678)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0432 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408142049401679)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407435266401678)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0439 \0434\0435\043D\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407222250401678)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0439 \0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407093516401678)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0432 \043F\043E\0441\043B\0435\0434\043D\044E\044E \043C\0438\043D\0443\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407868419401678)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0439 \043C\0435\0441\044F\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114407691591401678)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\044E\044E \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408043495401679)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \043F\0440\043E\0448\043B\044B\0439 \0433\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409983806401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409714079401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409567485401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410336209401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410102075401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410588184401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409894584401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \0434\0435\043D\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409618486401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409466414401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0443\044E \043C\0438\043D\0443\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410216448401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \043C\0435\0441\044F\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410048990401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0443\044E \043D\0435\0434\0435\043B\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410499437401680)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \0433\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406006696401677)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \043F\0443\0441\0442\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405968445401677)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043F\0443\0441\0442\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405737847401677)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0435\043D\044C\0448\0435 \0447\0435\043C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405862231401677)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0435\043D\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E %1')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406198067401677)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043F\043E\0434\043E\0431\043D\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406790022401678)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \0440\0435\0433\0443\043B\044F\0440\043D\043E\043C\0443 \0432\044B\0440\0430\0436\0435\043D\0438\044E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412670015401682)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0438\043D. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406980040401678)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \043C\0435\0436\0434\0443 %1 \0438 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405465811401677)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0440\0430\0432\043D\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406483330401677)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0432 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408757872401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408523052401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408372128401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409135100401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408908616401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409363859401680)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0435 %1 \0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408694609401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0439 \0434\0435\043D\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408442831401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0439 \0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408208322401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\044E\044E \043C\0438\043D\0443\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409094439401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\0438\0439 \043C\0435\0441\044F\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114408890816401679)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\043E\0441\043B\0435\0434\043D\044E\044E \043D\0435\0434\0435\043B\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114409270776401680)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \043F\0440\043E\0448\043B\044B\0439 \0433\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411117257401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \0434\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410980099401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410759482401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411542220401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \043C\0435\0441. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411391569401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411790078401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0435 %1 \0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411024453401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \0434\0435\043D\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410812240401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114410619770401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0443\044E \043C\0438\043D\0443\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411430230401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \043C\0435\0441\044F\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411274347401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0443\044E \043D\0435\0434\0435\043B\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411677367401681)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0437\0430 \0441\043B\0435\0434\0443\044E\0449\0438\0439 \0433\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114406279098401677)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \043F\043E\0434\043E\0431\043D\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413161928401682)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0441 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456766103401714)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'ru'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415851910401684)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0433\043E\0434\0430 (\043B\0435\0442)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456880529401714)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'ru'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456949169401714)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'ru'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114465900782401721)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043D\0435\0434\0435\043B\044C\043D\0438\043A, 12 \044F\043D\0432\0430\0440\044F 2016 \0433.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466007568401721)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'ru'
,p_message_text=>unistr('\042F\043D\0432\0430\0440\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466165615401721)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'ru'
,p_message_text=>unistr('16 \0447\0430\0441\043E\0432 \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114466261154401721)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'ru'
,p_message_text=>unistr('\0447\0435\0440\0435\0437 16 \0447\0430\0441\043E\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321268315401615)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0442\0438\043F \0444\0430\0439\043B\0430. \041F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\043C\044B\0435 \0442\0438\043F\044B \0444\0430\0439\043B\043E\0432: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448150270401708)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0437\043E\0440..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447826505401708)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0444\0430\0439\043B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447976453401708)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0444\0430\0439\043B\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321097911401615)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0442\0430\0441\043A\0438\0432\0430\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321415271401616)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0442\0430\0449\0438\0442\0435 \0444\0430\0439\043B\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322662356401616)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0438\043B\0438 \043F\0435\0440\0435\0442\0430\0449\0438\0442\0435 \0444\0430\0439\043B \0441\044E\0434\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322767024401616)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0438\043B\0438 \043F\0435\0440\0435\0442\0430\0449\0438\0442\0435 \0444\0430\0439\043B\044B \0441\044E\0434\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322839998401617)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0438\043B\0438 \043F\0435\0440\0435\0442\0430\0449\0438\0442\0435 \0444\0430\0439\043B \0441\044E\0434\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322985934401617)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0438\043B\0438 \043F\0435\0440\0435\0442\0430\0449\0438\0442\0435 \0444\0430\0439\043B\044B \0441\044E\0434\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321375740401615)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0439\043B\043E\0432: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321194658401615)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0439\043B \0441\043B\0438\0448\043A\043E\043C \0431\043E\043B\044C\0448\043E\0439. \041C\0430\043A\0441\0438\043C\0430\043B\044C\043D\044B\0439 \0440\0430\0437\043C\0435\0440 \0444\0430\0439\043B\0430: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308967464401607)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0440\0435\0431\0443\0435\0442\0441\044F \0430\0434\0440\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307878644401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\043E\0440\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308275532401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\0434 \0441\0442\0440\0430\043D\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307900776401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\043E\043C\0435\0440 \0434\043E\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308892399401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0428\0438\0440\043E\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308755695401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043B\0433\043E\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308643687401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C \043D\0430 \043A\0430\0440\0442\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308386660401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0446\0435\043D\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308044079401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0447\0442\043E\0432\044B\0439 \0438\043D\0434\0435\043A\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308129192401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0441\0442\043E\044F\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307789176401606)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043B\0438\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307615654401606)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\044C\0442\0430\0442\044B \0433\0435\043E\043A\043E\0434\0438\0440\043E\0432\0430\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320236005401615)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421 \0433\0435\043E\043A\043E\0434\0438\0440\043E\0432\0430\043D\0438\0435\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320366776401615)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0411\0435\0437 \0433\0435\043E\043A\043E\0434\0438\0440\043E\0432\0430\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308550231401606)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0430\0440\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114308439797401606)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0434\0440\0435\0441\0430 \043D\0435 \043D\0430\0439\0434\0435\043D\044B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309029855401607)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0442\0440\0435\0431\0443\0435\0442\0441\044F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478829870401730)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0441\0442 \0441\043F\0440\0430\0432\043A\0438: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372285248401653)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372332721401653)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \043E\0442\043C\0435\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318281966401613)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \043D\0430\0445\043E\0434\0438\0442\0441\044F \0432 \0434\043E\043F\0443\0441\0442\0438\043C\043E\043C \0434\0438\0430\043F\0430\0437\043E\043D\0435 \043E\0442 %0 \0434\043E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318389142401613)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \044F\0432\043B\044F\0435\0442\0441\044F \043A\0440\0430\0442\043D\043E\0439 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317989035401613)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \0434\043E\043B\0436\043D\0430 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\043E\0432\0430\0442\044C \0437\043D\0430\0447\0435\043D\0438\044F\043C %0 \0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318137644401613)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396445437401670)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\043A\043B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396575108401670)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318082045401613)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301425822401601)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \0437\0430\043F\0438\0441\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430665100401695)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430720915401695)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301549546401601)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\043D\043D\044B\0435 \0437\0430\043F\0438\0441\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434404086401698)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0441\0448\0438\0440\0435\043D\043D\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434728522401698)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434565949401698)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434838107401698)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B \0430\043A\0442\0438\0432\043D\043E\0433\043E \0448\0430\0431\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435487738401699)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B \0448\0430\0431\043B\043E\043D\0430 \043D\0435\0434\043E\0441\0442\0443\043F\043D\044B, \043F\043E\0441\043A\043E\043B\044C\043A\0443 \044D\0442\043E\0442 \043A\043E\043C\043F\043E\043D\0435\043D\0442 \043D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434326101401698)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B \0448\0430\0431\043B\043E\043D\0430  \043D\0435 \043D\0430\0439\0434\0435\043D\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434677024401698)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309929579401607)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0441\0442\0438\0442\044C \043A\0440\0443\0433')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311757080401609)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C\0441\043A\0438\0435 \0441\0442\0438\043B\0438 \043D\0435 \044F\0432\043B\044F\044E\0442\0441\044F \0434\043E\043F\0443\0441\0442\0438\043C\044B\043C \043E\0431\044A\0435\043A\0442\043E\043C JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310247821401607)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\0435\0434\0441\0442\0432\043E \0437\0430\0434\0430\043D\0438\044F \0440\0430\0441\0441\0442\043E\044F\043D\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310089568401607)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0440\0438\0441\043E\0432\0430\0442\044C \043E\043A\0440\0443\0436\043D\043E\0441\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302697411401602)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0441\0435\0442\043D\044B\0439 \043F\043E\0438\0441\043A \0442\0440\0435\0431\0443\0435\0442 \043D\0430\043B\0438\0447\0438\044F \0438\0441\0442\043E\0447\043D\0438\043A\0430 \0434\0430\043D\043D\044B\0445 \043D\0430 \0443\0440\043E\0432\043D\0435 \0440\0435\0433\0438\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305218947401604)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0443\0449\0435\0435 \043C\0435\0441\0442\043E\043F\043E\043B\043E\0436\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306397026401605)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0430\043B\044C\043D\044B\0435 \043A\043E\043E\0440\0434\0438\043D\0430\0442\044B \043F\043E\043B\043E\0436\0435\043D\0438\044F \043D\0435\0434\0435\0439\0441\0442\0432\0438\0442\0435\043B\044C\043D\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303745916401603)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0430\043B\044C\043D\0430\044F \043F\043E\0437\0438\0446\0438\044F \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \0433\0435\043E\043C\0435\0442\0440\0438\0435\0439 \0442\043E\0447\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306112416401605)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'ru'
,p_message_text=>unistr('\043A\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304799762401604)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\043E\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438070058401700)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\043E\0439: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309350176401607)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043F\043E\0441\0442\0430\0432\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302521501401602)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306217766401605)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0438\043B\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437090519401700)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A \0432 \0434\0430\043D\043D\044B\0445: \0431\043E\043B\0435\0435 %0. \042D\0442\043E \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E \0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304599933401603)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\0423\0441\043B\043E\0432\0438\044F</a> &nbsp;&nbsp; \0414\0430\043D\043D\044B\0435 \043A\0430\0440\0442 &copy; 2017 \0417\0414\0415\0421\042C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303489750401603)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0434\0430\043D\043D\044B\0445 SDO_GEOMETRY \043D\0435\0434\043E\0441\0442\0443\043F\0435\043D \0432 \044D\0442\043E\0439 \0431\0430\0437\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304611482401603)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; \041F\043B\0438\0442\043A\0438 OpenMap </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; \0421\043E\0430\0432\0442\043E\0440\044B OpenStreetMap </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304868902401604)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\043E\0447\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438122542401701)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0443\043D\043A\0442\043E\0432: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310149176401607)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\0441\0448\0442\0430\0431\0438\0440\043E\0432\0430\043D\0438\0435 \043F\0440\044F\043C\043E\0443\0433\043E\043B\044C\043D\0438\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309877456401607)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305171049401604)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C \043E\0440\0438\0435\043D\0442\0430\0446\0438\044E \043D\0430 \0441\0435\0432\0435\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385456205401662)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043A\043B\044E\0447\0435\043D\0438\0435 \043D\0430 \0440\0435\0436\0438\043C 2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385592023401662)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043A\043B\044E\0447\0435\043D\0438\0435 \043D\0430 \0440\0435\0436\0438\043C 3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309771400401607)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043A\043B\044E\0447\0438\0442\044C \0443\0432\0435\0434\043E\043C\043B\0435\043D\0438\0435 \043E\0431 \0430\0432\0442\043E\0440\0441\043A\0438\0445 \043F\0440\0430\0432\0430\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310335143401608)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0435 \0440\0430\0441\0441\0442\043E\044F\043D\0438\0435')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304900591401604)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0432\0435\043B\0438\0447\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305026852401604)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043C\0435\043D\044C\0448\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432529531401697)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\0443\0436\0438\0440\043D\044B\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433472053401697)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043E\0431\0440\0430\0436\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433078896401697)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0442\0440\043E\0435\043D\043D\044B\0439 \043A\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446637522401707)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0442\0430\0432\0438\0442\044C \0438\0437\043E\0431\0440\0430\0436\0435\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446753690401707)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0442\0430\0432\0438\0442\044C \0441\0441\044B\043B\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432691473401697)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0443\0440\0441\0438\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447339971401707)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\044F\0437\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433337915401697)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433211597401697)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043F\043E\0440\044F\0434\043E\0447\0435\043D\043D\044B\0439 \0441\043F\0438\0441\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432766206401697)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432898352401697)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0441\0443\0442\0441\0442\0432\0443\044E\0442 \043E\0431\044A\0435\043A\0442\044B \0434\043B\044F \043F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\043E\0433\043E \043F\0440\043E\0441\043C\043E\0442\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432944896401697)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0447\0435\0440\043A\0438\0432\0430\043D\0438\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433140844401697)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0443\043F\043E\0440\044F\0434\043E\0447\0435\043D\043D\044B\0439 \0441\043F\0438\0441\043E\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412041093401682)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\0442\0435\043A\0443\0449\0438\0439')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114469539616401724)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114411943813401682)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443762897401705)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\0435 \0443\0432\0435\0434\043E\043C\043B\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417087229401685)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C #LABEL# \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \0447\0438\0441\043B\043E\043C, \043A\043E\0442\043E\0440\043E\0435 \043C\0435\043D\044C\0448\0435 \0438\043B\0438 \0440\0430\0432\043D\043E %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417155342401685)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C #LABEL# \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \0434\043E\043F\0443\0441\0442\0438\043C\044B\043C \0447\0438\0441\043B\043E\043C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417231815401685)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'ru'
,p_message_text=>unistr('#LABEL# \043D\0435 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \0447\0438\0441\043B\043E\0432\043E\043C\0443 \0444\043E\0440\043C\0430\0442\0443 %0 (\043F\0440\0438\043C\0435\0440 %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416961993401685)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C #LABEL# \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \0447\0438\0441\043B\043E\043C \043D\0435 \043C\0435\043D\044C\0448\0435 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416805489401685)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C #LABEL# \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \0447\0438\0441\043B\043E\043C \043C\0435\0436\0434\0443 %0 \0438 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412188504401682)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'ru'
,p_message_text=>unistr('\043E\0442\043A\0440\044B\0432\0430\0435\0442\0441\044F \0432 \043D\043E\0432\043E\043C \043E\043A\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365370713401648)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\0430 \0443\0436\0435 \0431\044B\043B\0430 \043E\0442\043F\0440\0430\0432\043B\0435\043D\0430 \0438 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \043E\0442\043F\0440\0430\0432\043B\0435\043D\0430 \043F\043E\0432\0442\043E\0440\043D\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347941934401635)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043B\043E\0436\0435\043D\0438\0435 "%0" \0441\0442\0440\0430\043D\0438\0446\0430 "%1" \043D\0435 \043D\0430\0439\0434\0435\043D\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381748709401659)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423 #LABEL# \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \043D\0435\043A\043E\0442\043E\0440\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325088888401618)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431097297401695)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\044B\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430908995401695)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431285355401696)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431154520401696)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317195532401612)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0432\0435\0434\0438\0442\0435 \0443\0441\043B\043E\0432\0438\0435 \043F\043E\0438\0441\043A\0430 \0434\043B\0438\043D\043E\0439 \043D\0435 \043C\0435\043D\0435\0435 %0 \0441\0438\043C\0432.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386627114401663)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\043F\043B\044B\0432\0430\044E\0449\0438\0439 \0441\043F\0438\0441\043E\043A \0437\043D\0430\0447\0435\043D\0438\0439: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317273132401612)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0432\0435\0434\0438\0442\0435 \0443\0441\043B\043E\0432\0438\0435 \043F\043E\0438\0441\043A\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317061489401612)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\044C\0442\0430\0442\044B \043D\0435 \043D\0430\0439\0434\0435\043D\044B.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316938960401612)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404803052401676)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0441\043B\043E\0432\0438\0435 \043F\043E\0438\0441\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430824677401695)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441541802401703)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\043F\043E\043B\043D\044F\0435\0442\0441\044F \043E\0431\0440\0430\0431\043E\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315566472401611)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \043D\0430 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311591299401608)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041F\043E\0445\043E\0436\0435, \0447\0442\043E \043F\0440\044F\043C\043E \0441\0435\0439\0447\0430\0441 \0432\0430\0448\0435 \0443\0441\0442\0440\043E\0439\0441\0442\0432\043E \0438\043B\0438 \0431\0440\0430\0443\0437\0435\0440 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\044E\0442 \0443\0441\0442\0430\043D\043E\0432\043A\0443 \043F\0435\0440\0435\0434\043E\0432\044B\0445 \0432\0435\0431-\043F\0440\0438\043B\043E\0436\0435\043D\0438\0439.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0415\0441\043B\0438 \044D\0442\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \0443\0436\0435 \0443\0441\0442\0430\043D\043E\0432\043B\0435\043D\043E \043D\0430 \0432\0430\0448\0435\043C \0443\0441\0442\0440\043E\0439\0441\0442\0432\0435, \043E\0442\043A\0440\043E\0439\0442\0435 \0435\0433\043E \0441 \0434\043E\043C\0430\0448\043D\0435\0433\043E \044D\043A\0440\0430\043D\0430.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311133071401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0414\043E\0431\0430\0432\044C\0442\0435 \0435\0433\043E \043D\0430 \0441\0432\043E\0439 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D, \0447\0442\043E\0431\044B \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \043D\0430 \043F\043E\043B\043D\043E\043C \044D\043A\0440\0430\043D\0435.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\041C\0435\043D\044E</strong> \0432 \043D\0438\0436\043D\0435\0439 \043E\0431\043B\0430\0441\0442\0438 \043D\0430\0432\0438\0433\0430\0446\0438\0438</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041D\0430\0436\043C\0438\0442\0435  <strong>\0423\0441\0442\0430\043D\043E\0432\0438\0442\044C</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \041D\0430\0436\043C\0438\0442\0435 <strong>\0414\043E\0431\0430\0432\0438\0442\044C</strong>, \0447\0442\043E\0431\044B \043F\043E\0434\0442\0432\0435\0440\0434\0438\0442\044C</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311285863401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F, \043A\043E\0442\043E\0440\0430\044F \043B\0443\0447\0448\0435 \0432\0441\0435\0433\043E \0440\0430\0431\043E\0442\0430\0435\0442 \0432 Chrome \0438\043B\0438 Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\041C\0435\043D\044E</strong> \0440\044F\0434\043E\043C \0441 \0430\0434\0440\0435\0441\043D\043E\0439 \0441\0442\0440\043E\043A\043E\0439</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041D\0430\0436\043C\0438\0442\0435 <strong>\0423\0441\0442\0430\043D\043E\0432\0438\0442\044C</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310885556401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F, \043A\043E\0442\043E\0440\0430\044F \0443\043B\0443\0447\0448\0430\0435\0442 \0443\0441\043B\043E\0432\0438\044F \0440\0430\0431\043E\0442\044B \0432 Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\041F\043E\0434\0435\043B\0438\0442\044C\0441\044F</strong> \0432 \043D\0438\0436\043D\0435\0439 \043E\0431\043B\0430\0441\0442\0438 \043D\0430\0432\0438\0433\0430\0446\0438\0438</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041D\0430\0436\043C\0438\0442\0435 <strong>\041E\0442\043A\0440\044B\0442\044C \0432 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310581612401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \043E\0431\043B\0430\0434\0430\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C\044E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0414\043E\0431\0430\0432\044C\0442\0435 \0435\0433\043E \043D\0430 \0441\0432\043E\0439 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D, \0447\0442\043E\0431\044B \0443\043B\0443\0447\0448\0438\0442\044C \0443\0441\043B\043E\0432\0438\044F \0440\0430\0431\043E\0442\044B.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E</strong> \0440\044F\0434\043E\043C \0441 \0430\0434\0440\0435\0441\043D\043E\0439 \0441\0442\0440\043E\043A\043E\0439</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041D\0430\0436\043C\0438\0442\0435 <strong>\0414\043E\0431\0430\0432\0438\0442\044C \043D\0430 \0433\043B\0430\0432\043D\044B\0439 \044D\043A\0440\0430\043D</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \041D\0430\0436\043C\0438\0442\0435 <strong style="color:#007AE1;">\0414\043E\0431\0430\0432\0438\0442\044C</strong>, \0447\0442\043E\0431\044B \043F\043E\0434\0442\0432\0435\0440\0434\0438\0442\044C</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310406416401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0414\043E\0431\0430\0432\044C\0442\0435 \0435\0433\043E \043D\0430 \0441\0432\043E\0439 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D, \0447\0442\043E\0431\044B \0443\043B\0443\0447\0448\0438\0442\044C \0443\0441\043B\043E\0432\0438\044F \0440\0430\0431\043E\0442\044B.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\041F\043E\0434\0435\043B\0438\0442\044C\0441\044F</strong> \0432 \043D\0438\0436\043D\0435\0439 \043E\0431\043B\0430\0441\0442\0438 \043D\0430\0432\0438\0433\0430\0446\0438\0438</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041F\0440\043E\043A\0440\0443\0442\0438\0442\0435 \0441\043E\0434\0435\0440\0436\0438\043C\043E\0435 \0432\043D\0438\0437 \0438 \043D\0430\0436\043C\0438\0442\0435 <strong>\0414\043E\0431\0430\0432\0438\0442\044C \043D\0430 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \041D\0430\0436\043C\0438\0442\0435 <strong style="color:#007AE1;">\0414\043E\0431\0430\0432\0438\0442\044C</strong>, \0447\0442\043E\0431\044B \043F\0440\043E\0434\043E\043B\0436\0438\0442\044C</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305402950401604)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \043E\0431\043B\0430\0434\0430\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C\044E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0414\043E\0431\0430\0432\044C\0442\0435 \0435\0433\043E \043D\0430 \0441\0432\043E\0439 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D, \0447\0442\043E\0431\044B \0443\043B\0443\0447\0448\0438\0442\044C \0443\0441\043B\043E\0432\0438\044F \0440\0430\0431\043E\0442\044B.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E</strong> \0440\044F\0434\043E\043C \0441 \0430\0434\0440\0435\0441\043D\043E\0439 \0441\0442\0440\043E\043A\043E\0439</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041D\0430\0436\043C\0438\0442\0435 <strong>\0414\043E\0431\0430\0432\0438\0442\044C \043D\0430 \0433\043B\0430\0432\043D\044B\0439 \044D\043A\0440\0430\043D</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \041D\0430\0436\043C\0438\0442\0435 <strong style="color:#007AE1;">\0414\043E\0431\0430\0432\0438\0442\044C</strong>, \0447\0442\043E\0431\044B \043F\043E\0434\0442\0432\0435\0440\0434\0438\0442\044C</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310765805401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0414\043E\0431\0430\0432\044C\0442\0435 \0435\0433\043E \043D\0430 \0441\0432\043E\0439 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D, \0447\0442\043E\0431\044B \0443\043B\0443\0447\0448\0438\0442\044C \0443\0441\043B\043E\0432\0438\044F \0440\0430\0431\043E\0442\044B.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\041F\043E\0434\0435\043B\0438\0442\044C\0441\044F</strong> \0432 \0430\0434\0440\0435\0441\043D\043E\0439 \0441\0442\0440\043E\043A\0435</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\041D\0430\0436\043C\0438\0442\0435 <strong>\041E\0442\043A\0440\044B\0442\044C \0432 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310645757401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \0414\043E\0431\0430\0432\044C\0442\0435 \0435\0433\043E \043D\0430 \0441\0432\043E\0439 \0434\043E\043C\0430\0448\043D\0438\0439 \044D\043A\0440\0430\043D, \0447\0442\043E\0431\044B \0443\043B\0443\0447\0448\0438\0442\044C \0443\0441\043B\043E\0432\0438\044F \0440\0430\0431\043E\0442\044B.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\041D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A <strong>\041F\043E\0434\0435\043B\0438\0442\044C\0441\044F</strong> \0432 \043D\0438\0436\043D\0435\0439 \043E\0431\043B\0430\0441\0442\0438 \043D\0430\0432\0438\0433\0430\0446\0438\0438</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\041D\0430\0436\043C\0438\0442\0435 <strong>\041E\0442\043A\0440\044B\0442\044C \0432 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311472925401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \043E\0431\043B\0430\0434\0430\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C\044E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F, \043A\043E\0442\043E\0440\0430\044F \043B\0443\0447\0448\0435 \0432\0441\0435\0433\043E \0440\0430\0431\043E\0442\0430\0435\0442 \0432 Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \0443\0441\0442\0430\043D\043E\0432\043A\0443 \0432\0435\0431-\043F\0440\0438\043B\043E\0436\0435\043D\0438\0439.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114310946923401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \043E\0431\043B\0430\0434\0430\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C\044E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F, \043A\043E\0442\043E\0440\0430\044F \043B\0443\0447\0448\0435 \0432\0441\0435\0433\043E \0440\0430\0431\043E\0442\0430\0435\0442 \0432 Chrome \0438\043B\0438 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \0443\0441\0442\0430\043D\043E\0432\043A\0443 \0432\0435\0431-\043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \0432 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311052050401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \043E\0431\043B\0430\0434\0430\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C\044E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F, \043A\043E\0442\043E\0440\0430\044F \043B\0443\0447\0448\0435 \0432\0441\0435\0433\043E \0440\0430\0431\043E\0442\0430\0435\0442 \0432 Chrome \0438\043B\0438 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \0443\0441\0442\0430\043D\043E\0432\043A\0443 \0432\0435\0431-\043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \0432 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311328909401608)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\042D\0442\043E\0442 \0432\0435\0431-\0441\0430\0439\0442 \0438\043C\0435\0435\0442 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\044C\043D\043E\0441\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F, \043A\043E\0442\043E\0440\0430\044F \043B\0443\0447\0448\0435 \0432\0441\0435\0433\043E \0440\0430\0431\043E\0442\0430\0435\0442 \0432 Chrome \0438\043B\0438 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \0432 \043D\0430\0441\0442\043E\044F\0449\0435\0435 \0432\0440\0435\043C\044F \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \0443\0441\0442\0430\043D\043E\0432\043A\0443 \0432\0435\0431-\043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \0432 Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313823772401610)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\041D\0435 \0443\0434\0430\0435\0442\0441\044F \043F\043E\0434\043A\043B\044E\0447\0438\0442\044C\0441\044F</h1>'),
unistr('    <p>\0414\043B\044F \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\044F \044D\0442\043E\0433\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \0442\0440\0435\0431\0443\0435\0442\0441\044F \043F\043E\0434\043A\043B\044E\0447\0435\043D\0438\0435 \043A \0418\043D\0442\0435\0440\043D\0435\0442\0443.</p>'),
unistr('    <button type="button">\041F\043E\0432\0442\043E\0440\0438\0442\044C</button>'),
'</main>',
'',
'<script>',
unistr('    document.querySelector("button").addEventListener("\043D\0430\0436\0430\0442\044C", () => {'),
'        window.location.reload();',
'    });',
'</script>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313758387401610)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \043F\043E\0434\043A\043B\044E\0447\0438\0442\044C\0441\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453566275401712)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397903792401671)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430 \0446\0435\043B\044B\0439 \0434\0435\043D\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476819487401729)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043F\0440\0430\0432\043A\0430 \043F\0440\0438\0433\043B\0430\0448\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476610368401729)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399791298401673)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\0434\043D\0435\0432\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440 \0437\0430 \0432\0435\0441\044C \0434\0435\043D\044C ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399525349401672)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\0434\043D\0435\0432\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440 \0434\0430\043D\043D\044B\0445 \0441 \0443\0447\0435\0442\043E\043C \0432\0440\0435\043C\0435\043D\0438 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444461172401705)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\043D\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438861534401701)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\043F\0438\0441\0430\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329492668401621)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'ru'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329290854401621)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'ru'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329183558401621)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'ru'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329320818401621)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'ru'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328829508401621)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 \0437\0430\0432\0435\0440\0448\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329094432401621)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \0441\043E\0431\044B\0442\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476758848401729)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\0433\043B\0430\0448\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444562329401705)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444239325401705)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0441\044F\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447033526401707)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461303042401718)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0431\044B\0442\0438\044F \043E\0442\0441\0443\0442\0441\0442\0432\0443\044E\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477001875401729)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\0435 \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0435\0433\043E \0441\043E\0431\044B\0442\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476931388401729)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043F\0440\0430\0432\043A\0430 \043F\0440\0438\0433\043B\0430\0448\0435\043D\0438\044F \043F\043E \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447134977401707)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455199740401713)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0434\0430\0442\044C \0441\043E\043E\0431\0449\0435\043D\0438\0435 \044D\043B. \043F\043E\0447\0442\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454934871401713)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0434\0430\0442\044C \0441\043E\043E\0431\0449\0435\043D\0438\0435 \044D\043B. \043F\043E\0447\0442\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477781687401730)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435 \043F\043E\043B\044F \043E\0431\044F\0437\0430\0442\0435\043B\044C\043D\044B \0434\043B\044F \0437\0430\043F\043E\043B\043D\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477671068401729)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043F\0440\0430\0432\0438\0442\044C \043F\0440\0438\0433\043B\0430\0448\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476598855401729)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455020404401713)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043C\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328945931401621)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 \043D\0430\0447\0430\043B\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452885270401711)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430 \0432 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399311154401672)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0440\0435\043C\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447254466401707)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\0433\043E\0434\043D\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445095551401706)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444343503401705)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399671066401672)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\043D\0435\0434\0435\043B\044C\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440 \0437\0430 \0432\0435\0441\044C \0434\0435\043D\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399488737401672)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\043D\0435\0434\0435\043B\044C\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440 \0434\0430\043D\043D\044B\0445 \0441 \0443\0447\0435\0442\043E\043C \0432\0440\0435\043C\0435\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444954504401706)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444649695401705)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444716777401705)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\0438\0442\044C \0435\0449\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376862245401656)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323194301401617)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\0438\0442\044C \0435\0449\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325214461401618)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114444816312401706)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\0438\0442\044C \0435\0449\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446997911401707)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043E\0431\043B\0430\0441\0442\0438 %0 \043D\0435 \043D\0430\0439\0434\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325147676401618)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043D\043D\044B\0435 \043D\0435 \043D\0430\0439\0434\0435\043D\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349285925401636)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \0441\0431\0440\043E\0441\0438\0442\044C \0440\0430\0437\0431\0438\0432\043A\0443 \043E\0431\043B\0430\0441\0442\0438 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317484325401613)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0440\0430\0437\0431\0438\0432\043A\0438 \043E\0431\043B\0430\0441\0442\0438 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438223325401701)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446814192401707)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \043E\0431\043B\0430\0441\0442\0438 %0 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317319980401613)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \0440\0435\043D\0434\0435\0440\0438\043D\0433\0435 \043E\0431\043B\0430\0441\0442\0438 "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381804110401660)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423 \043F\043E\0434\043F\0438\0441\0438 #COLUMN_HEADER# \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \043D\0435\043A\043E\0442\043E\0440\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476184742401728)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('%0, \0440\0435\0434\0430\043A\0442\043E\0440 \0444\043E\0440\043C\0430\0442\0438\0440\043E\0432\0430\043D\043D\043E\0433\043E \0442\0435\043A\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383918897401661)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'ru'
,p_message_text=>unistr('HTML-\0440\0430\0437\043C\0435\0442\043A\0430 \0444\043E\0440\043C\0430\0442\0438\0440\043E\0432\0430\043D\043D\043E\0433\043E \0442\0435\043A\0441\0442\0430 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E \0434\043E\043F\0443\0441\0442\0438\043C\0443\044E \0434\043B\0438\043D\0443 \044D\043B\0435\043C\0435\043D\0442\0430 (\0444\0430\043A\0442\0438\0447\0435\0441\043A\0430\044F\00A0\2014 %0, \0434\043E\043F\0443\0441\0442\0438\043C\0430\044F\00A0\2014 %1 \0441\0438\043C\0432.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443816231401705)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435655487401699)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0443\0431\043B\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433942033401698)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433807580401697)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043A\043B\044E\0447\0438\0442\044C \043D\0435\043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0437\043D\0430\0447\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443941128401705)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397505384401671)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\043D\0438\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397613561401671)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\0432\0435\0440\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433675589401697)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434284686401698)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0440\0443\0433\0438\0435 \0441\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433736429401697)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434039799401698)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434192593401698)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430 %0 \0438\0437 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435766566401699)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435820915401699)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0438\0442\044C \0438\0437\043C\0435\043D\0435\043D\0438\044F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114433591822401697)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\044E \043D\0430\0441\0442\0440\043E\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394549871401669)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\043F\0440\0438\043C\0435\0440, %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302046417401602)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0432\0442\043E\0440\043D\044B\0439 \0432\0445\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301961143401601)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \0441\0435\0430\043D\0441 \0437\0430\0432\0435\0440\0448\0435\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302113570401602)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0434\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301749279401601)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \0441\0435\0430\043D\0441 \0437\0430\0432\0435\0440\0448\0430\0435\0442\0441\044F \0432 %0. \041F\0440\043E\0434\043B\0438\0442\044C \0435\0433\043E?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301873793401601)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \0441\0435\0430\043D\0441 \0437\0430\0432\0435\0440\0448\0430\0435\0442\0441\044F \0432 %0 \0438 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \043F\0440\043E\0434\043B\0435\043D. \0421\043E\0445\0440\0430\043D\0438\0442\0435 \0440\0435\0437\0443\043B\044C\0442\0430\0442\044B \0440\0430\0431\043E\0442\044B, \0447\0442\043E\0431\044B \0438\0437\0431\0435\0436\0430\0442\044C \043F\043E\0442\0435\0440\0438 \0434\0430\043D\043D\044B\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454772013401713)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \043A\043E\0434\0430 \043E\0447\0438\0441\0442\043A\0438 \0441\0435\0430\043D\0441\0430 \0431\0430\0437\044B \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347882274401635)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0435 \043A\043E\0434\0430 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0441\0435\0430\043D\0441\0430 \0431\0430\0437\044B \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114321920775401616)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \0441\0435\0430\043D\0441 \0437\0430\0432\0435\0440\0448\0435\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453675130401712)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\043E\0439\0442\0435 \044D\0442\043E \0434\0438\0430\043B\043E\0433\043E\0432\043E\0435 \043E\043A\043D\043E \0438 \043D\0430\0436\043C\0438\0442\0435 \043A\043D\043E\043F\043A\0443 \043F\0435\0440\0435\0437\0430\0433\0440\0443\0437\043A\0438 \0431\0440\0430\0443\0437\0435\0440\0430 \0434\043B\044F \043F\043E\043B\0443\0447\0435\043D\0438\044F \043D\043E\0432\043E\0433\043E \0441\0435\0430\043D\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472925385401726)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 <a href="%0">\044D\0442\0443 \0441\0441\044B\043B\043A\0443</a>, \0447\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \043D\043E\0432\044B\0439 \0441\0435\0430\043D\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359596465401643)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\0435\0439\0441\0442\0432\0438\0442\0435\043B\044C\043D\044B\0439 \0441\0435\0430\043D\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399045239401672)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0441\0435\0430\043D\0441\0435 Real Application Security \043D\0435 \0443\0434\0430\043B\043E\0441\044C \0432\043A\043B\044E\0447\0438\0442\044C \0434\0438\043D\0430\043C\0438\0447\0435\0441\043A\0438\0435 \0440\043E\043B\0438 \0434\043B\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345785120401633)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-99900 \041D\0435 \0443\0434\0430\043B\043E\0441\044C \0441\043E\0437\0434\0430\0442\044C \0443\043D\0438\043A\0430\043B\044C\043D\044B\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \0441\0435\0430\043D\0441\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362002118401645)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0440\0443\0448\0435\043D\0438\0435 \0437\0430\0449\0438\0442\044B \0441\043E\0441\0442\043E\044F\043D\0438\044F \0441\0435\0430\043D\0441\0430: \044D\0442\043E \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0432\044B\0437\0432\0430\043D\043E \0440\0443\0447\043D\044B\043C \0438\0437\043C\0435\043D\0435\043D\0438\0435\043C \0437\0430\0449\0438\0449\0435\043D\043D\043E\0433\043E \044D\043B\0435\043C\0435\043D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\044B %0. \0415\0441\043B\0438 \0432\044B \043D\0435 \0437\043D\0430\0435\0442\0435, \0447\0442\043E \0432\044B\0437\0432\0430\043B\043E \044D\0442\0443 \043E\0448\0438\0431\043A\0443, \043E\0431\0440\0430\0442\0438\0442\0435\0441\044C \0437\0430 \043F\043E\043C\043E\0449\044C\044E \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481146369401732)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0440\0443\0448\0435\043D\0438\0435 \0437\0430\0449\0438\0442\044B \0441\0442\0440\0430\043D\0438\0446\044B: \044D\0442\043E \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0432\044B\0437\0432\0430\043D\043E \043E\0442\043F\0440\0430\0432\043A\043E\0439 \0441\0442\0440\0430\043D\0438\0446\044B \0434\043E \043E\043A\043E\043D\0447\0430\043D\0438\044F \0435\0435 \043F\043E\043B\043D\043E\0439 \0437\0430\0433\0440\0443\0437\043A\0438, \0438\043B\0438 \0440\0443\0447\043D\044B\043C \0438\0437\043C\0435\043D\0435\043D\0438\0435\043C \0437\0430\0449\0438\0449\0435\043D\043D\044B\0445 \044D\043B\0435\043C\0435\043D\0442\043E\0432 \0441\0442\0440\0430\043D\0438\0446\044B. \0414\043B\044F \043F\043E\043B\0443\0447\0435\043D\0438\044F \0434\0430\043B\044C\043D\0435\0439\0448\0435\0439 \043F\043E\043C\043E\0449\0438 \043E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480160655401731)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\0434\0435\0440\0436\0438\0442 \043E\0434\0438\043D \0438\0437 \0441\043B\0435\0434\0443\044E\0449\0438\0445 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0445 \0441\0438\043C\0432\043E\043B\043E\0432 &<>"/;,*|=% \0438\043B\0438 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480274129401731)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\0434\0435\0440\0436\0438\0442 \043E\0434\0438\043D \0438\0437 \0441\043B\0435\0434\0443\044E\0449\0438\0445 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0445 \0441\0438\043C\0432\043E\043B\043E\0432 &<>"/;,*|=% \0438\043B\0438 -- \0438\043B\0438 \043D\043E\0432\0443\044E \0441\0442\0440\043E\043A\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479961229401731)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\0434\0435\0440\0436\0438\0442 \0441\043F\0435\0446\0438\0430\043B\044C\043D\044B\0435 \0441\0438\043C\0432\043E\043B\044B. \0414\043E\043F\0443\0441\043A\0430\044E\0442\0441\044F \0442\043E\043B\044C\043A\043E \0441\0438\043C\0432\043E\043B\044B a-Z, 0-9 \0438 \043F\0440\043E\0431\0435\043B\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114480036996401731)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\0434\0435\0440\0436\0438\0442 \0441\0438\043C\0432\043E\043B\044B <, > \0438\043B\0438 ", \043A\043E\0442\043E\0440\044B\0435 \0441\0447\0438\0442\0430\044E\0442\0441\044F \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\043C\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324191201401617)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0442\043E\0431\044B \043F\043E\043A\0430\0437\0430\0442\044C \043E\0431\0440\0430\0431\043E\0442\043A\0443 \0434\043B\044F \0441\0442\0440\0430\043D\0438\0446\044B, \0442\0440\0435\0431\0443\044E\0449\0435\0439 \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\044B, \043A\043E\0433\0434\0430 \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \043F\0430\0440\0430\043C\0435\0442\0440\043E\0432 \043F\0435\0440\0435\0434\0430\0435\0442\0441\044F \043E\0434\043D\043E \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0437\043D\0430\0447\0435\043D\0438\0439 \0437\0430\043F\0440\043E\0441\0430, \043E\0447\0438\0441\0442\043A\0438 \043A\044D\0448\0430 \0438\043B\0438 \0430\0440\0433\0443\043C\0435\043D\0442\043E\0432 \043D\0435 \0431\044B\043B\0430 \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\0430 \043A\043E\043D\0442\0440\043E\043B\044C\043D\0430\044F \0441\0443\043C\043C\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356977393401641)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0440\0443\0448\0435\043D\0438\0435 \0437\0430\0449\0438\0442\044B \0441\043E\0441\0442\043E\044F\043D\0438\044F \0441\0435\0430\043D\0441\0430: \044D\0442\043E \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0432\044B\0437\0432\0430\043D\043E \0440\0443\0447\043D\044B\043C \0438\0437\043C\0435\043D\0435\043D\0438\0435\043C URL-\0430\0434\0440\0435\0441\0430, \0441\043E\0434\0435\0440\0436\0430\0449\0435\0433\043E \043A\043E\043D\0442\0440\043E\043B\044C\043D\0443\044E \0441\0443\043C\043C\0443, \0438\043B\0438 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \0441\0441\044B\043B\043A\0438 \0441 \043D\0435\043A\043E\0440\0440\0435\043A\0442\043D\043E\0439 \0438\043B\0438 \043E\0442\0441\0443\0442\0441\0442\0432\0443\044E\0449\0435\0439 \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\043E\0439. \0415\0441\043B\0438 \0432\044B \043D\0435 \0437\043D\0430\0435\0442\0435, \0447\0442\043E \0432\044B\0437\0432\0430\043B\043E \044D\0442\0443 \043E\0448\0438\0431\043A\0443, \043E\0431\0440\0430\0442\0438\0442\0435\0441')
||unistr('\044C \0437\0430 \043F\043E\043C\043E\0449\044C\044E \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114434953262401698)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\043B\044E\0447\0438\0442\044C \0440\0435\0436\0438\043C \0432\044B\0441\043E\043A\043E\0439 \043A\043E\043D\0442\0440\0430\0441\0442\043D\043E\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435002480401698)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0438\0442\044C \0440\0435\0436\0438\043C \0432\044B\0441\043E\043A\043E\0439 \043A\043E\043D\0442\0440\0430\0441\0442\043D\043E\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353640029401639)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043D\0438\0437\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353887476401639)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043D\0438\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353925063401639)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354043095401639)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354188957401639)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354260679401639)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0432\0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354366187401639)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353531789401639)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0440\0445\0443')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353788433401639)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0432\0435\0440\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462606780401718)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463347003401719)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462522148401718)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463479031401719)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0h')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462374130401718)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463587668401719)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462928736401719)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463131695401719)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0mo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462408268401718)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463284233401719)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462717877401719)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463640072401719)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0w')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462831053401719)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'ru'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114463093910401719)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 %0y')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302910947401602)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'ru'
,p_message_text=>unistr('[\0421\0442\0440\043E\043A\0430]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303344193401602)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'ru'
,p_message_text=>unistr('[\041D\0435\0441\043A\043E\043B\044C\043A\043E \0441\0442\0440\043E\043A]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303102132401602)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'ru'
,p_message_text=>unistr('[\041D\0435\0441\043A\043E\043B\044C\043A\043E \0442\043E\0447\0435\043A]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303505746401603)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'ru'
,p_message_text=>unistr('[\041D\0435\0441\043A\043E\043B\044C\043A\043E \043C\043D\043E\0433\043E\0443\0433\043E\043B\044C\043D\0438\043A\043E\0432]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303675321401603)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'ru'
,p_message_text=>unistr('[\0413\0435\043E\043C\0435\0442\0440\0438\0447\0435\0441\043A\0438\0439 \043E\0431\044A\0435\043A\0442]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302870012401602)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'ru'
,p_message_text=>unistr('[\0422\043E\0447\043A\0430 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303037696401602)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'ru'
,p_message_text=>unistr('[\041C\043D\043E\0433\043E\0443\0433\043E\043B\044C\043D\0438\043A]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380284261401658)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0440\043D\0443\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380184548401658)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E\0441\0441\0442\0430\043D\043E\0432\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426632367401692)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0441\0442\043A\0430 \043E\0446\0435\043D\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416570784401685)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \043D\0430\0445\043E\0434\0438\0442\0441\044F \0432 \0434\043E\043F\0443\0441\0442\0438\043C\043E\043C \0434\0438\0430\043F\0430\0437\043E\043D\0435 \043E\0446\0435\043D\043A\0438 1\2013%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416655778401685)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \044F\0432\043B\044F\0435\0442\0441\044F \0447\0438\0441\043B\043E\0432\044B\043C \0437\043D\0430\0447\0435\043D\0438\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412735264401682)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\0435 \043E\0431 \0443\0441\043F\0435\0448\043D\043E\043C \0432\044B\043F\043E\043B\043D\0435\043D\0438\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475836065401728)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475711062401728)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461406582401718)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\043D\0435\043B\044C \0438\043D\0441\0442\0440\0443\043C\0435\043D\0442\043E\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476208631401728)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0432\0435\0440\043D\0443\0442\044C / \0441\0432\0435\0440\043D\0443\0442\044C \043D\0430\0432\0438\0433\0430\0446\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476380769401728)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0432\0435\0440\043D\0443\0442\044C / \0441\0432\0435\0440\043D\0443\0442\044C \0431\043E\043A\043E\0432\043E\0439 \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385961195401662)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\0430\044F \043F\0430\043D\0435\043B\044C \043D\0430\0432\0438\0433\0430\0446\0438\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392976525401667)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('1 \0434\0435\043D\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392738316401667)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('1 \0447\0430\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393017683401668)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392852456401667)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392608422401667)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393218581401668)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114393128657401668)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('1 \043D\0435\0434\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479457039401731)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0430\043B\043E \0441\0442\0440\0430\043D\0438\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341414301401630)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315245829401611)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0437\0430\043F\0440\043E\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394608783401669)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0440\0435\0431\0443\0435\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477501268401729)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0436\0434\0438\0442\0435\0441\044C \043F\043E\043B\043D\043E\0439 \0437\0430\0433\0440\0443\0437\043A\0438 \0441\0442\0440\0430\043D\0438\0446\044B \0438 \043F\043E\0432\0442\043E\0440\0438\0442\0435 \043F\043E\043F\044B\0442\043A\0443.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437718190401700)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430 \044D\0442\043E\0439 \0441\0442\0440\0430\043D\0438\0446\0435 \0435\0441\0442\044C \043D\0435\0441\043E\0445\0440\0430\043D\0435\043D\043D\044B\0435 \0438\0437\043C\0435\043D\0435\043D\0438\044F.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318693567401614)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0440\0430\0431\043E\0447\0435\0439 \043A\043D\0438\0433\0435 \043D\0435\0442 \0430\043A\0442\0438\0432\043D\043E\0433\043E \0440\0430\0431\043E\0447\0435\0433\043E \043B\0438\0441\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318588399401613)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0431\043E\0447\0430\044F \043A\043D\0438\0433\0430 \043D\0435 \0438\043D\0438\0446\0438\0430\043B\0438\0437\0438\0440\043E\0432\0430\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318485678401613)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438 \0441\043E\0437\0434\0430\043D\0438\0438 \0444\0430\0439\043B\0430 XLSX \043F\0440\043E\0438\0437\043E\0448\043B\0430 \0432\043D\0443\0442\0440\0435\043D\043D\044F\044F \043E\0448\0438\0431\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320919675401615)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041B\0438\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452627221401711)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0439\0441\0442\0432\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370139447401651)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\044E \0434\0435\0439\0441\0442\0432\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365825553401648)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \0444\0443\043D\043A\0446\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365740197401648)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \0433\0440\0443\043F\043F\0443 \043F\043E \0441\0442\043E\043B\0431\0446\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399996254401673)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0441\0440\0435\0437\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400088449401673)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0430\0432\0438\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0441\0442\0440\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340299502401629)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376391689401656)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357479743401642)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\0435\0434\043D\0435\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361731242401645)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357586110401642)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0443\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357746362401642)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0434\0438\0430\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357669655401642)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0443\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357329305401642)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0443\043C\043C\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358420246401642)
,p_name=>'APEXIR_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339557767401629)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435 \0441\0442\043E\043B\0431\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322094844401616)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0441\0435 \0441\0442\0440\043E\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449672413401709)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451292272401710)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\0430 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352157012401638)
,p_name=>'APEXIR_AND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341698662401630)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\043D\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335339426401626)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354969168401640)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451825618401711)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\0435\0434\043D\0435\0435 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443298492401704)
,p_name=>'APEXIR_BAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0438\0441\0442\043E\0433\0440\0430\043C\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341061510401630)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\0436\0434\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334149960401625)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0432\0435\0442 \0444\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336067246401626)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0438\043D\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367757821401649)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043D\0438\0437\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336648200401627)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342583527401631)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0430\0442\0435\0433\043E\0440\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334048413401625)
,p_name=>'APEXIR_CELL'
,p_message_language=>'ru'
,p_message_text=>unistr('\042F\0447\0435\0439\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358313753401642)
,p_name=>'APEXIR_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0438\0430\0433\0440\0430\043C\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368655114401650)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0438\0446\0438\0430\043B\0438\0437\0430\0446\0438\044F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114404938306401676)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \043C\0435\0442\043A\0443 \0434\0438\0430\0433\0440\0430\043C\043C\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417331420401685)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \0437\0430\043F\0440\043E\0441 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043E\0433\0440\0430\043D\0438\0447\0435\043D\0438\0435 \043D\0430 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0442\043E\0447\0435\043A \0434\0430\043D\043D\044B\0445 \043D\0430 \0434\0438\0430\0433\0440\0430\043C\043C\0435: %0. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\044C\0442\0440, \0447\0442\043E\0431\044B \0443\043C\0435\043D\044C\0448\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441\0435\0439 \0432 \0441\0432\043E\0435\043C \0437\0430\043F\0440\043E\0441\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416228105401685)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0434\043B\044F \0437\0430\043F\0440\043E\0441\0430 \0434\0438\0430\0433\0440\0430\043C\043C\044B \043E\0433\0440\0430\043D\0438\0447\0438\0432\0430\0435\0442 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0432 \0431\0430\0437\043E\0432\043E\043C \0437\0430\043F\0440\043E\0441\0435, \0430 \043D\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A. \0412\0430\0448 \0431\0430\0437\043E\0432\044B\0439 \0437\0430\043F\0440\043E\0441 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A %0. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\044C\0442\0440, \0447\0442\043E\0431\044B \0443\043C\0435\043D\044C\0448\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441')
||unistr('\0435\0439 \0432 \0441\0432\043E\0435\043C \0431\0430\0437\043E\0432\043E\043C \0437\0430\043F\0440\043E\0441\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339640838401629)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0434\0438\0430\0433\0440\0430\043C\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114412967133401682)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043C\0435\0442\0438\0442\044C \0432\0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355308599401640)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0444\043E\0440\043C\0430\0442 \043E\0442\0447\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362758860401646)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\043E\0447\0438\0441\0442\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336590421401627)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373971497401654)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446270628401707)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364788358401647)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\044E \0437\0430\0433\043E\043B\043E\0432\043A\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368410335401650)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0444\043E\0440\043C\0430\0446\0438\044F \043E \0441\0442\043E\043B\0431\0446\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448539342401708)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0442\043A\0430 \0441\0442\043E\043B\0431\0446\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366147383401648)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350204064401636)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\043E\0434\0435\0440\0436\0438\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351165355401637)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335040699401625)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351333447401637)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0432 \043F\043E\0441\043B\0435\0434\043D\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359877805401643)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0432 \0441\043B\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351264555401637)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 \043F\043E\0441\043B\0435\0434\043D\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359754460401643)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0432 \0441\043B\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334981675401625)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0440\0430\0432\043D\043E null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334887632401625)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0438\043C\0435\0435\0442 \0437\043D\0430\0447\0435\043D\0438\0435 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334626472401625)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\043E\0434\043E\0431\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335172887401626)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \0432')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334766495401625)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435 \043F\043E\0434\043E\0431\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350571852401637)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \0440\0435\0433\0443\043B\044F\0440\043D\043E\043C\0443 \0432\044B\0440\0430\0436\0435\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355266097401640)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0447\0438\0441\043B\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114415955048401684)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0436\0435\043D\0438\0435 \0434\043B\044F \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374240212401654)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0437\0434\0430\0439\0442\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435 \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \043F\0441\0435\0432\0434\043E\043D\0438\043C\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374301299401654)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'ru'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374425623401654)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'ru'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374538912401654)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'ru'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320440886401615)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'ru'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359118185401643)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0447\0438\0441\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366766320401649)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043C\0435\043D\0430 \043E\043F\0435\0440\0430\0446\0438\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369742505401651)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454149489401712)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317529681401613)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0440\0430\0437\043D\044B\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452326306401711)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0440\0430\0437\043D\044B\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452222306401711)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424301405401691)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\0434\043D\0435\0432\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479047519401730)
,p_name=>'APEXIR_DATA'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043D\043D\044B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368568375401650)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043E\0431\0449\0438\0442\044C \0434\0430\043D\043D\044B\0435 \043F\043E \0441\043E\0441\0442\043E\044F\043D\0438\044E %0 \043C\0438\043D. \043D\0430\0437\0430\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442024966401703)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \0442\0430\0431\043B\0438\0446\044B \0434\0430\043D\043D\044B\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340390942401629)
,p_name=>'APEXIR_DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372471938401653)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449499812401709)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \043E\0442\0447\0435\0442\0430 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336716245401627)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340654223401630)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \044D\0442\0438 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435369297401699)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \043E\0442\0447\0435\0442 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366431579401648)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \043E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335483223401626)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\0431\044B\0432\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342634378401631)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\043F\0438\0441\0430\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364682865401647)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \043E\0434\043D\043E\0439 \0441\0442\0440\043E\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372932252401653)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\043F\0440\0430\0432\043B\0435\043D\0438\0435 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373867075401654)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\043B\044E\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336200073401626)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339410988401629)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372878790401653)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\044B\0432\0430\0442\044C \0432 \043E\0442\0447\0435\0442\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367687687401649)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043D\0438\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359273467401643)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0433\0440\0443\0437\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372746716401653)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438726276401701)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0434\0435\043B\0435\043D\0438\0435 \0441 \0442\0430\043A\0438\043C \0436\0435 \0443\0441\043B\043E\0432\0438\0435\043C \0443\0436\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454313507401712)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0443\0431\043B\0438\0440\043E\0432\0430\043D\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446 \0441\0440\0435\0437\0430. \0421\043F\0438\0441\043E\043A \0441\0442\043E\043B\0431\0446\043E\0432 \0441\0440\0435\0437\0430 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C \0443\043D\0438\043A\0430\043B\044C\043D\044B\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454532238401712)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0430\0432\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368738846401650)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0434\0438\0430\0433\0440\0430\043C\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375364898401655)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C \0434\0438\0430\0433\0440\0430\043C\043C\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375741120401655)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C \0444\0438\043B\044C\0442\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430129904401695)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C "\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375649623401655)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0438\0442\044C \0432\044B\0434\0435\043B\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400278545401673)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C \0441\0440\0435\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449719976401709)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043A\0442\0440\043E\043D\043D\0430\044F \043F\043E\0447\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328441924401621)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0434\0440\0435\0441 \044D\043B. \043F\043E\0447\0442\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450085101401709)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043A\0440\044B\0442\0430\044F \043A\043E\043F\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450207877401709)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449981253401709)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043F\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450724785401710)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0430\0441\0442\043E\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332117044401623)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \044D\0442\043E\0433\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \043D\0435 \043D\0430\0441\0442\0440\043E\0435\043D\0430 \044D\043B\0435\043A\0442\0440\043E\043D\043D\0430\044F \043F\043E\0447\0442\0430.  \041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0441\0432\043E\0435\043C\0443 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423636878401690)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0430\0434\0440\0435\0441 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450320821401709)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043C. \0432\043B\043E\0436\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450185830401709)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424610087401691)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0442\0435\043C\0443 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0433\043E \043F\0438\0441\044C\043C\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449888246401709)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043C\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333813763401625)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375553561401655)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0438\0442\044C/\043E\0442\043A\043B\044E\0447\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375051375401655)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374652625401654)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\0440\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375449679401655)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\0440\044B:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339375523401629)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043A\043B\044E\0447\0438\0442\044C \043D\0435\043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0435 \0437\043D\0430\0447\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376090353401655)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0432\0435\0440\043D\0443\0442\044C/\0441\0432\0435\0440\043D\0443\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373645791401654)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0436\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358739698401643)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369699849401651)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379902071401658)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0436\0435\043D\0438\0435 \0444\0438\043B\044C\0442\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476404378401729)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0440\0430\0436\0435\043D\0438\0435 \0444\0438\043B\044C\0442\0440\0430 \0441\043B\0438\0448\043A\043E\043C \0434\043B\0438\043D\043D\043E\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379818634401658)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0444\0438\043B\044C\0442\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376297908401655)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \043F\043E\0438\0441\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359068534401643)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'ru'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373487741401653)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0441 flashback \043F\043E\0437\0432\043E\043B\044F\0435\0442 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C \0434\0430\043D\043D\044B\0435 \0432 \0442\043E\043C \0432\0438\0434\0435, \0432 \043A\0430\043A\043E\043C \043E\043D\0438 \0441\0443\0449\0435\0441\0442\0432\043E\0432\0430\043B\0438 \0432 \043F\0440\0435\0434\044B\0434\0443\0449\0438\0439 \043C\043E\043C\0435\043D\0442 \0432\0440\0435\043C\0435\043D\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424080414401690)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\0438\0442\0435\043B\044C\043D\043E\0441\0442\044C Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425413633401691)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355181913401640)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366326368401648)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374157949401654)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0438 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449340155401709)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0438/\043E\043F\0435\0440\0430\0442\043E\0440\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366011538401648)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\044F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358571176401642)
,p_name=>'APEXIR_GO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0439\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334381868401625)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0437\0435\043B\0435\043D\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114317610021401613)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450470892401710)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E \0441\0442\043E\043B\0431\0446\0443 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405066772401676)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0433\0440\0443\043F\043F\0438\0440\043E\0432\043A\0443 \043F\043E \0441\0442\043E\043B\0431\0446\0430\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416181946401685)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0434\043B\044F \0437\0430\043F\0440\043E\0441\0430 \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\044F \043E\0433\0440\0430\043D\0438\0447\0438\0432\0430\0435\0442 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0432 \0431\0430\0437\043E\0432\043E\043C \0437\0430\043F\0440\043E\0441\0435, \0430 \043D\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A. \0412\0430\0448 \0431\0430\0437\043E\0432\044B\0439 \0437\0430\043F\0440\043E\0441 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A %0. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\044C\0442\0440, \0447\0442\043E\0431\044B \0443\043C\0435\043D\044C\0448\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437')
||unistr('\0430\043F\0438\0441\0435\0439 \0432 \0441\0432\043E\0435\043C \0431\0430\0437\043E\0432\043E\043C \0437\0430\043F\0440\043E\0441\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396760671401670)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E \0441\043E\0440\0442\0438\0440\043E\0432\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454215029401712)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C \043F\043E \043F\043E\0440\044F\0434\043A\0443 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339764993401629)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\043E\0440\0438\0437\043E\043D\0442\0430\043B\044C\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371389755401652)
,p_name=>'APEXIR_HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363187062401646)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0435 \043E\0442\0447\0435\0442\044B \043F\043E\0437\0432\043E\043B\044F\044E\0442 \043A\043E\043D\0435\0447\043D\044B\043C \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F\043C \043D\0430\0441\0442\0440\0430\0438\0432\0430\0442\044C \043E\0442\0447\0435\0442\044B. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043C\043E\0433\0443\0442 \0438\0437\043C\0435\043D\044F\0442\044C \043A\043E\043C\043F\043E\043D\043E\0432\043A\0443 \0434\0430\043D\043D\044B\0445 \043E\0442\0447\0435\0442\0430, \0432\044B\0431\0438\0440\0430\044F \0441\0442\043E\043B\0431\0446\044B, \043F\0440\0438\043C\0435\043D\044F\044F \0444\0438\043B\044C\0442\0440\044B, \0432\044B\0434\0435\043B\044F\044F \0438 \0441\043E\0440\0442\0438\0440\0443\044F. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \0442\0430\043A\0436\0435 \043C\043E\0433\0443\0442 \043E\043F\0440\0435\0434\0435\043B\044F\0442\044C \0440\0430\0437\0440\044B\0432\044B, \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435, \0434\0438\0430\0433\0440\0430\043C')
||unistr('\043C\044B, \0433\0440\0443\043F\043F\044B \0438 \0434\043E\0431\0430\0432\043B\044F\0442\044C \0441\043E\0431\0441\0442\0432\0435\043D\043D\044B\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \0442\0430\043A\0436\0435 \043C\043E\0433\0443\0442 \043D\0430\0441\0442\0440\043E\0438\0442\044C \043F\043E\0434\043F\0438\0441\043A\0443 \0442\0430\043A, \0447\0442\043E\0431\044B HTML-\0432\0435\0440\0441\0438\044F \043E\0442\0447\0435\0442\0430 \043E\0442\043F\0440\0430\0432\043B\044F\043B\0430\0441\044C \0438\043C \043F\043E \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\0435 \0447\0435\0440\0435\0437 \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\0439 \043F\0440\043E\043C\0435\0436\0443\0442\043E\043A \0432\0440\0435\043C\0435\043D\0438. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043C\043E\0433\0443\0442 \0441\043E\0437\0434\0430\0432\0430\0442\044C \043D\0435\0441\043A\043E\043B\044C\043A\043E \0432\0430\0440\0438\0430\043D\0442\043E\0432 \043E\0442\0447\0435')
||unistr('\0442\0430 \0438 \0441\043E\0445\0440\0430\043D\044F\0442\044C \0438\0445 \0432 \0432\0438\0434\0435 \0438\043C\0435\043D\043E\0432\0430\043D\043D\044B\0445 \043E\0442\0447\0435\0442\043E\0432 \0434\043B\044F \043F\0443\0431\043B\0438\0447\043D\043E\0433\043E \0438\043B\0438 \0447\0430\0441\0442\043D\043E\0433\043E \043F\0440\043E\0441\043C\043E\0442\0440\0430. '),
'<p/>',
unistr('\0412 \0441\043B\0435\0434\0443\044E\0449\0438\0445 \0440\0430\0437\0434\0435\043B\0430\0445 \043A\0440\0430\0442\043A\043E \043E\043F\0438\0441\044B\0432\0430\044E\0442\0441\044F \0441\043F\043E\0441\043E\0431\044B \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0445 \043E\0442\0447\0435\0442\043E\0432. \0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0435 \0441\0432\0435\0434\0435\043D\0438\044F \0441\043C. \0432 \0440\0430\0437\0434\0435\043B\0435 "\0418\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0445 \043E\0442\0447\0435\0442\043E\0432" \0432 <i>\0420\0443\043A\043E\0432\043E\0434\0441\0442\0432\0435 \043A\043E\043D\0435\0447\043D\043E\0433\043E \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F Oracle Application Express</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370218135401651)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\044E "\0414\0435\0439\0441\0442\0432\0438\044F" \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\043F\0440\0430\0432\0430 \043E\0442 \043A\043D\043E\043F\043A\0438 "\041F\0435\0440\0435\0439\0442\0438" \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430. \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \043C\0435\043D\044E \0434\043B\044F \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363945994401647)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0410\0433\0440\0435\0433\0430\0442\044B\2014 \044D\0442\043E \043C\0430\0442\0435\043C\0430\0442\0438\0447\0435\0441\043A\0438\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F, \0432\044B\043F\043E\043B\043D\044F\0435\043C\044B\0435 \043D\0430 \043E\0441\043D\043E\0432\0435 \0441\0442\043E\043B\0431\0446\0430. \0410\0433\0440\0435\0433\0430\0442\044B \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043F\043E\0441\043B\0435 \043A\0430\0436\0434\043E\0439 \0441\043C\0435\043D\044B \043E\043F\0435\0440\0430\0446\0438\0438 \0438 \0432 \043A\043E\043D\0446\0435 \043E\0442\0447\0435\0442\0430 \0432 \0441\0442\043E\043B\0431\0446\0435, \0432 \043A\043E\0442\043E\0440\043E\043C \043E\043D\0438 \043E\043F\0440\0435\0434\0435\043B\0435\043D\044B. \0421\0440\0435\0434\0438 \0434\043E\0441\0442\0443\043F\043D\044B\0445 \0432\0430\0440\0438\0430\043D\0442\043E\0432:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\044B\0431\0440\0430\0442\044C \0440\0430\043D\0435\0435'),
unistr('\043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\043E\0435 \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435 \0434\043B\044F \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F.</li>'),
unistr('<li><strong>\0424\0443\043D\043A\0446\0438\044F</strong> \2014 \044D\0442\043E \0444\0443\043D\043A\0446\0438\044F, \043A\043E\0442\043E\0440\0443\044E \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0432\044B\043F\043E\043B\043D\0438\0442\044C (\043D\0430\043F\0440\0438\043C\0435\0440, SUM, MIN).</li>'),
unistr('<li><strong>\0421\0442\043E\043B\0431\0435\0446</strong> \0438\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0434\043B\044F \0432\044B\0431\043E\0440\0430 \0441\0442\043E\043B\0431\0446\0430, \043A \043A\043E\0442\043E\0440\043E\043C\0443 \0431\0443\0434\0435\0442 \043F\0440\0438\043C\0435\043D\0435\043D\0430 \043C\0430\0442\0435\043C\0430\0442\0438\0447\0435\0441\043A\0430\044F \0444\0443\043D\043A\0446\0438\044F. \041E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \0442\043E\043B\044C\043A\043E \0447\0438\0441\043B\043E\0432\044B\0435'),
unistr('\0441\0442\043E\043B\0431\0446\044B.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364092992401647)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041C\043E\0436\043D\043E \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \043E\0434\043D\0443 \0434\0438\0430\0433\0440\0430\043C\043C\0443 \0434\043B\044F \043A\0430\0436\0434\043E\0433\043E \0441\043E\0445\0440\0430\043D\0435\043D\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430. \041F\043E\0441\043B\0435'),
unistr('\043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \043C\043E\0436\043D\043E \043F\0435\0440\0435\043A\043B\044E\0447\0430\0442\044C\0441\044F \043C\0435\0436\0434\0443 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C\0438 \0434\0438\0430\0433\0440\0430\043C\043C\044B \0438 \043E\0442\0447\0435\0442\0430 \0441 \043F\043E\043C\043E\0449\044C\044E \0437\043D\0430\0447\043A\043E\0432 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430.'),
unistr('\0421\0440\0435\0434\0438 \0434\043E\0441\0442\0443\043F\043D\044B\0445 \0432\0430\0440\0438\0430\043D\0442\043E\0432:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\0422\0438\043F \0434\0438\0430\0433\0440\0430\043C\043C\044B</strong> \043E\043F\0440\0435\0434\0435\043B\044F\0435\0442 \0442\0438\043F \0434\0438\0430\0433\0440\0430\043C\043C\044B \0434\043B\044F \0432\043A\043B\044E\0447\0435\043D\0438\044F.'),
unistr('\0412\044B\0431\0435\0440\0438\0442\0435 \0433\043E\0440\0438\0437\043E\043D\0442\0430\043B\044C\043D\0443\044E \043F\043E\043B\043E\0441\0443, \0432\0435\0440\0442\0438\043A\0430\043B\044C\043D\0443\044E \043F\043E\043B\043E\0441\0443, \043A\0440\0443\0433 \0438\043B\0438 \043B\0438\043D\0438\044E.</li>'),
unistr('<li><strong>\041C\0435\0442\043A\0430</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\044B\0431\0440\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446, \043A\043E\0442\043E\0440\044B\0439 \0431\0443\0434\0435\0442 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C\0441\044F \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \043C\0435\0442\043A\0438.</li>'),
unistr('<li><strong>\0417\0430\0433\043E\043B\043E\0432\043E\043A \043E\0441\0438 \0434\043B\044F \043C\0435\0442\043A\0438</strong>\00A0\2014 \044D\0442\043E \0437\0430\0433\043E\043B\043E\0432\043E\043A, \043A\043E\0442\043E\0440\044B\0439 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \043D\0430 \043E\0441\0438, \0441\0432\044F\0437\0430\043D\043D\043E\0439 \0441 \0432\044B\0431\0440\0430\043D\043D\044B\043C \0434\043B\044F \043C\0435\0442\043A\0438 \0441\0442\043E\043B\0431\0446\043E\043C, '),
unistr('\042D\0442\043E \043D\0435\0434\043E\0441\0442\0443\043F\043D\043E \0434\043B\044F \043A\0440\0443\0433\043E\0432\043E\0439 \0434\0438\0430\0433\0440\0430\043C\043C\044B.</li>'),
unistr('<li><strong>\0417\043D\0430\0447\0435\043D\0438\0435</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\044B\0431\0440\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446, \043A\043E\0442\043E\0440\044B\0439 \0431\0443\0434\0435\0442 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C\0441\044F \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0437\043D\0430\0447\0435\043D\0438\044F. \0415\0441\043B\0438 \0432\0430\0448\0430 \0444\0443\043D\043A\0446\0438\044F'),
unistr('\044F\0432\043B\044F\0435\0442\0441\044F \0441\0447\0435\0442\0447\0438\043A\043E\043C, \0437\043D\0430\0447\0435\043D\0438\0435 \0432\044B\0431\0438\0440\0430\0442\044C \043D\0435 \043D\0443\0436\043D\043E.</li>'),
unistr('<li><strong>\0417\0430\0433\043E\043B\043E\0432\043E\043A \043E\0441\0438 \0434\043B\044F \0437\043D\0430\0447\0435\043D\0438\044F</strong>\00A0\2014 \044D\0442\043E \0437\0430\0433\043E\043B\043E\0432\043E\043A, \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0439 \043D\0430 \043E\0441\0438, \043A\043E\0442\043E\0440\0430\044F \0441\0432\044F\0437\0430\043D\0430 \0441\043E \0441\0442\043E\043B\0431\0446\043E\043C, \0432\044B\0431\0440\0430\043D\043D\044B\043C \0434\043B\044F'),
unistr('\0437\043D\0430\0447\0435\043D\0438\044F. \042D\0442\043E \043D\0435\0434\043E\0441\0442\0443\043F\043D\043E \0434\043B\044F \043A\0440\0443\0433\043E\0432\043E\0439 \0434\0438\0430\0433\0440\0430\043C\043C\044B.</li>'),
unistr('<li><strong>\0424\0443\043D\043A\0446\0438\044F</strong>\00A0\2014 \044D\0442\043E \043D\0435\043E\0431\044F\0437\0430\0442\0435\043B\044C\043D\0430\044F \0444\0443\043D\043A\0446\0438\044F, \043A\043E\0442\043E\0440\0430\044F \043F\0440\0438\043C\0435\043D\044F\0435\0442\0441\044F \043A \0441\0442\043E\043B\0431\0446\0443, \0432\044B\0431\0440\0430\043D\043D\043E\043C\0443 \0434\043B\044F \0437\043D\0430\0447\0435\043D\0438\044F.</li>'),
unistr('<li><strong>\0421\043E\0440\0442\0438\0440\043E\0432\043A\0430</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \0440\0435\0437\0443\043B\044C\0442\0438\0440\0443\044E\0449\0438\0439 \043D\0430\0431\043E\0440.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363376926401646)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0415\0441\043B\0438 \043D\0430\0436\0430\0442\044C \043D\0430 \043B\044E\0431\043E\0439 \0437\0430\0433\043E\043B\043E\0432\043E\043A \0441\0442\043E\043B\0431\0446\0430, \043E\0442\043A\0440\044B\0432\0430\0435\0442\0441\044F \043C\0435\043D\044E \0437\0430\0433\043E\043B\043E\0432\043A\0430 \0441\0442\043E\043B\0431\0446\0430. \0421\0440\0435\0434\0438 \0434\043E\0441\0442\0443\043F\043D\044B\0445 \0432\0430\0440\0438\0430\043D\0442\043E\0432:'),
'<p></p>',
'<ul>',
unistr('<li>\0417\043D\0430\0447\043E\043A <strong>\0421\043E\0440\0442\0438\0440\043E\0432\043A\0430 \043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E</strong> \0441\043E\0440\0442\0438\0440\0443\0435\0442 \043E\0442\0447\0435\0442 \043F\043E \0432\044B\0431\0440\0430\043D\043D\043E\043C\0443 \0441\0442\043E\043B\0431\0446\0443 \0432 \043F\043E\0440\044F\0434\043A\0435 \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044F.</li>'),
unistr('<li>\0417\043D\0430\0447\043E\043A <strong>\0421\043E\0440\0442\0438\0440\043E\0432\043A\0430 \043F\043E \0443\0431\044B\0432\0430\043D\0438\044E</strong> \0441\043E\0440\0442\0438\0440\0443\0435\0442 \043E\0442\0447\0435\0442 \043F\043E \0441\0442\043E\043B\0431\0446\0443 \0432 \043F\043E\0440\044F\0434\043A\0435 \0443\0431\044B\0432\0430\043D\0438\044F.</li>'),
unistr('<li>\041A\043E\043C\0430\043D\0434\0430 <strong>\0421\043A\0440\044B\0442\044C \0441\0442\043E\043B\0431\0435\0446</strong> \0441\043A\0440\044B\0432\0430\0435\0442 \0441\0442\043E\043B\0431\0435\0446. \041D\0435 \0432\0441\0435 \0441\0442\043E\043B\0431\0446\044B \043C\043E\0436\043D\043E \0441\043A\0440\044B\0442\044C. \0415\0441\043B\0438 \0441\0442\043E\043B\0431\0435\0446 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0441\043A\0440\044B\0442, \0437\043D\0430\0447\043E\043A "\0421\043A\0440\044B\0442\044C \0441\0442\043E\043B\0431\0435\0446" \043D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F.</li>'),
unistr('<li>\041A\043E\043C\0430\043D\0434\0430 <strong>\0421\0442\043E\043B\0431\0435\0446 \0440\0430\0437\0431\0438\0432\043A\0438</strong> \0441\043E\0437\0434\0430\0435\0442 \0433\0440\0443\043F\043F\0443 \0440\0430\0437\0431\0438\0432\043A\0438 \0432 \0441\0442\043E\043B\0431\0446\0435.  \042D\0442\043E \043F\0440\0438\0432\0435\0434\0435\0442 \043A \0443\0434\0430\043B\0435\043D\0438\044E \0441\0442\043E\043B\0431\0446\0430 \0438\0437 \043E\0442\0447\0435\0442\0430 \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0433\043B\0430\0432\043D\043E\0439 \0437\0430\043F\0438\0441\0438.</li>'),
unistr('<li>\041F\0443\043D\043A\0442 <strong>\0418\043D\0444\043E\0440\043C\0430\0446\0438\044F \043E \0441\0442\043E\043B\0431\0446\0435</strong> \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442 \0442\0435\043A\0441\0442 \0441\043F\0440\0430\0432\043A\0438 \043E \0441\0442\043E\043B\0431\0446\0435, \0435\0441\043B\0438 \043E\043D \0434\043E\0441\0442\0443\043F\0435\043D.</li>'),
unistr('<li>\041F\0443\043D\043A\0442 <strong>\0422\0435\043A\0441\0442\043E\0432\0430\044F \043E\0431\043B\0430\0441\0442\044C</strong> \0438\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0434\043B\044F \0432\0432\043E\0434\0430 \043A\0440\0438\0442\0435\0440\0438\0435\0432 \043F\043E\0438\0441\043A\0430 \0431\0435\0437 \0443\0447\0435\0442\0430 \0440\0435\0433\0438\0441\0442\0440\0430'),
unistr('(\043D\0435\0442 \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E\0441\0442\0438 \0432 \043F\043E\0434\0441\0442\0430\043D\043E\0432\043E\0447\043D\044B\0445 \0437\043D\0430\043A\0430\0445). \0421 \0432\0432\043E\0434\043E\043C \0437\043D\0430\0447\0435\043D\0438\044F \0443\043C\0435\043D\044C\0448\0430\0435\0442\0441\044F \0441\043F\0438\0441\043E\043A'),
unistr('\0437\043D\0430\0447\0435\043D\0438\0439 \0432 \043D\0438\0436\043D\0435\0439 \0447\0430\0441\0442\0438 \043C\0435\043D\044E. \0417\0430\0442\0435\043C \0432\044B \043C\043E\0436\0435\0442\0435 \0432\044B\0431\0440\0430\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435'),
unistr('\0441\043D\0438\0437\0443, \0438 \0432\044B\0431\0440\0430\043D\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \0431\0443\0434\0435\0442 \0441\043E\0437\0434\0430\043D\043E \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0444\0438\043B\044C\0442\0440\0430 \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \0437\043D\0430\043A\0430 "="'),
unistr('(\043D\0430\043F\0440\0438\043C\0435\0440, <code>column =  ''ABC''</code>). \0412 \043A\0430\0447\0435\0441\0442\0432\0435 \0430\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\044B \043C\043E\0436\043D\043E \0449\0435\043B\043A\043D\0443\0442\044C \0437\043D\0430\0447\043E\043A \0444\043E\043D\0430\0440\0438\043A\0430 \0438 \0432\0432\0435\0441\0442\0438 \0437\043D\0430\0447\0435\043D\0438\0435, \043A\043E\0442\043E\0440\043E\0435 \0431\0443\0434\0435\0442 \0441\043E\0437\0434\0430\043D\043E \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0444\0438\043B\044C\0442\0440\0430 \0441 \043C\043E\0434\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C "LIKE"'),
unistr('(\043D\0430\043F\0440\0438\043C\0435\0440, <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>\0421\043F\0438\0441\043E\043A \0443\043D\0438\043A\0430\043B\044C\043D\044B\0445 \0437\043D\0430\0447\0435\043D\0438\0439</b> \0441\043E\0434\0435\0440\0436\0438\0442 \043F\0435\0440\0432\044B\0435 500 \0443\043D\0438\043A\0430\043B\044C\043D\044B\0445'),
unistr('\0437\043D\0430\0447\0435\043D\0438\0439, \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0445 \0432\0430\0448\0438\043C \043A\0440\0438\0442\0435\0440\0438\044F\043C \0444\0438\043B\044C\0442\0440\0430\0446\0438\0438. \0415\0441\043B\0438 \0441\0442\043E\043B\0431\0435\0446 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \0434\0430\0442\0435,'),
unistr('\0432\043C\0435\0441\0442\043E \044D\0442\043E\0433\043E \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\043F\0438\0441\043E\043A \0434\0438\0430\043F\0430\0437\043E\043D\043E\0432 \0434\0430\0442. \0415\0441\043B\0438 \0432\044B\0431\0440\0430\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435, \0444\0438\043B\044C\0442\0440 \0431\0443\0434\0435\0442'),
unistr('\0441\043E\0437\0434\0430\043D \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \0437\043D\0430\043A\0430 "=" (\043D\0430\043F\0440\0438\043C\0435\0440, <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363895569401646)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\043E\0437\0432\043E\043B\044F\0435\0442 \0434\043E\0431\0430\0432\043B\044F\0442\044C \0432\044B\0447\0438\0441\043B\044F\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B \0432 \043E\0442\0447\0435\0442. \042D\0442\043E \043C\043E\0433\0443\0442 \0431\044B\0442\044C \043C\0430\0442\0435\043C\0430\0442\0438\0447\0435\0441\043A\0438\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F (\043D\0430\043F\0440\0438\043C\0435\0440, <code>NBR_HOURS/24</code>) \0438\043B\0438 \0441\0442\0430\043D\0434\0430\0440\0442\043D\044B\0435'),
unistr('\0444\0443\043D\043A\0446\0438\0438 Oracle, \043F\0440\0438\043C\0435\043D\044F\0435\043C\044B\0435 \043A \0441\0443\0449\0435\0441\0442\0432\0443\044E\0449\0438\043C \0441\0442\043E\043B\0431\0446\0430\043C. \041D\0435\043A\043E\0442\043E\0440\044B\0435 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \043F\0440\0438\043C\0435\0440\043E\0432, \0430 \0434\0440\0443\0433\0438\0435 (\0442\0430\043A\0438\0435 \043A\0430\043A <code>TO_DATE)</code> \0442\0430\043A\0436\0435 \043C\043E\0436\043D\043E \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C. \0421\0440\0435\0434\0438 \0434\043E\0441\0442\0443\043F\043D\044B\0445 \0432\0430\0440\0438\0430\043D\0442\043E\0432:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\0412\044B\0447\0438\0441\043B\0435\043D\0438\0435</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\044B\0431\0440\0430\0442\044C \0440\0430\043D\0435\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\043E\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435 \0434\043B\044F \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F.</li>'),
unistr('<li><strong>\0417\0430\0433\043E\043B\043E\0432\043E\043A \0441\0442\043E\043B\0431\0446\0430</strong> \2014 \044D\0442\043E \0437\0430\0433\043E\043B\043E\0432\043E\043A \043D\043E\0432\043E\0433\043E \0441\0442\043E\043B\0431\0446\0430.</li>'),
unistr('<li><strong>\041C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430</strong> \2014 \044D\0442\043E \043C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430 Oracle,\043A\043E\0442\043E\0440\0430\044F \043F\0440\0438\043C\0435\043D\044F\0435\0442\0441\044F \043A \0441\0442\043E\043B\0431\0446\0443 (\043D\0430\043F\0440\0438\043C\0435\0440, S9999).</li>'),
unistr('<li><strong>\0412\044B\0447\0438\0441\043B\0435\043D\0438\0435</strong> \2014 \044D\0442\043E \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435, \043A\043E\0442\043E\0440\043E\0435 \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \0432\044B\043F\043E\043B\043D\0435\043D\043E. \0412 \0440\0430\043C\043A\0430\0445 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \0441\0442\043E\043B\0431\0446\044B, \0434\043B\044F \0441\0441\044B\043B\043A\0438 \043D\0430 \043A\043E\0442\043E\0440\044B\0435 \0438\0441\043F\043E\043B\044C\0437\0443\044E\0442\0441\044F \043F\0441\0435\0432\0434\043E\043D\0438\043C\044B.</li>'),
'</ul>',
unistr('<p>\041F\043E\0434 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435\043C \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \0441\0442\043E\043B\0431\0446\044B \0438\0437 \0432\0430\0448\0435\0433\043E \0437\0430\043F\0440\043E\0441\0430 \0441'),
unistr('\0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\043C \043F\0441\0435\0432\0434\043E\043D\0438\043C\043E\043C. \0415\0441\043B\0438 \043D\0430\0436\0430\0442\044C \0438\043C\044F \0441\0442\043E\043B\0431\0446\0430 \0438\043B\0438 \043F\0441\0435\0432\0434\043E\043D\0438\043C, \043E\043D\0438 \0432\043A\043B\044E\0447\0430\044E\0442\0441\044F'),
unistr('\0432 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435. \0420\044F\0434\043E\043C \0441\043E \0441\0442\043E\043B\0431\0446\0430\043C\0438 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \043A\043B\0430\0432\0438\0430\0442\0443\0440\0430. \042D\0442\0430 \043A\043B\0430\0432\0438\0430\0442\0443\0440\0430 \0444\0443\043D\043A\0446\0438\043E\043D\0438\0440\0443\0435\0442 \043A\0430\043A'),
unistr('\044F\0440\043B\044B\043A \0434\043B\044F \0447\0430\0441\0442\043E \0438\0441\043F\043E\043B\044C\0437\0443\0435\043C\044B\0445 \043A\043B\0430\0432\0438\0448. \0412 \043A\0440\0430\0439\043D\0435\043C \043F\0440\0430\0432\043E\043C \0443\0433\043B\0443 \043F\0440\0438\0432\0435\0434\0435\043D\044B \0444\0443\043D\043A\0446\0438\0438.</p>'),
unistr('<p>\0412 \0441\043B\0435\0434\0443\044E\0449\0435\043C \043F\0440\0438\043C\0435\0440\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0439 \043F\043E\043A\0430\0437\0430\043D\043E, \043A\0430\043A \043E\0442\043E\0431\0440\0430\0437\0438\0442\044C \0441\043E\0432\043E\043A\0443\043F\043D\0443\044E \043A\043E\043C\043F\0435\043D\0441\0430\0446\0438\044E:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\0433\0434\0435 A \2014 ORGANIZATION (\043E\0440\0433\0430\043D\0438\0437\0430\0446\0438\044F), B \2014 SALARY (\0437\0430\0440\043F\043B\0430\0442\0430), \0430 C \2014 COMMISSION (\043A\043E\043C\0438\0441\0441\0438\044F))</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370322706401651)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0434\043B\044F \0441\043E\0437\0434\0430\043D\0438\044F \0433\0440\0443\043F\043F\044B \0440\0430\0437\0440\044B\0432\043E\0432 \0432 \043E\0434\043D\043E\043C \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\0438\0445 \0441\0442\043E\043B\0431\0446\0430\0445. \042D\0442\043E \0434\0435\0439\0441\0442\0432\0438\0435 \0438\0437\0432\043B\0435\043A\0430\0435\0442 \0441\0442\043E\043B\0431\0446\044B \0438\0437 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430 \0438 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442 \0438\0445 \0432 \0432\0438\0434\0435 \0433\043B\0430\0432\043D\043E\0439 \0437\0430\043F\0438\0441\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364512416401647)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0442\043E\0431\044B \043F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0441\0432\0435\0434\0435\043D\0438\044F \043E\0431 \043E\0434\043D\043E\0439 \0441\0442\0440\043E\043A\0435 \0437\0430 \0440\0430\0437, \043D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F \043E\0434\043D\043E\0439 \0441\0442\0440\043E\043A\0438 \0432 \0441\0442\0440\043E\043A\0435, \043A\043E\0442\043E\0440\0443\044E \0442\0440\0435\0431\0443\0435\0442\0441\044F \043F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C. \0415\0441\043B\0438 \044D\0442\043E \0432\043E\0437\043C\043E\0436\043D\043E, \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \043E\0434\043D\043E\0439 \0441\0442\0440\043E\043A\0438 \0432\0441\0435\0433\0434\0430 \0431\0443\0434\0435\0442 \043F\0435\0440\0432\044B\043C \0441\0442\043E\043B\0431\0446\043E\043C. \0412 \0437\0430\0432\0438\0441\0438\043C\043E\0441\0442\0438 \043E\0442 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433')
||unistr('\043E \043E\0442\0447\0435\0442\0430 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \043E\0434\043D\043E\0439 \0441\0442\0440\043E\043A\0438 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0441\0442\0430\043D\0434\0430\0440\0442\043D\044B\043C \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435\043C \0438\043B\0438 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C\0441\043A\043E\0439 \0441\0442\0440\0430\043D\0438\0446\0435\0439, \043A\043E\0442\043E\0440\0430\044F \043C\043E\0436\0435\0442 \0434\043E\043F\0443\0441\043A\0430\0442\044C \043E\0431\043D\043E\0432\043B\0435\043D\0438\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364480131401647)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\044B\0433\0440\0443\0437\0438\0442\044C \0442\0435\043A\0443\0449\0438\0439 \043D\0430\0431\043E\0440 \0440\0435\0437\0443\043B\044C\0442\0430\0442\043E\0432. \0424\043E\0440\043C\0430\0442\044B \0432\044B\0433\0440\0443\0437\043A\0438 \0437\0430\0432\0438\0441\044F\0442 \043E\0442 \0432\0430\0448\0435\0439 \0443\0441\0442\0430\043D\043E\0432\043A\0438 \0438 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \043E\0442\0447\0435\0442\0430, \043D\043E \043C\043E\0433\0443\0442 \0432\043A\043B\044E\0447\0430\0442\044C CSV, HTML, \044D\043B\0435\043A\0442\0440\043E\043D\043D\0443\044E \043F\043E\0447\0442\0443, XLS, PDF \0438\043B\0438 RTF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363516924401646)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\0435\0440\0435\043D\043E\0441\0438\0442 \0444\043E\043A\0443\0441 \043D\0430 \043E\0442\0447\0435\0442, \0434\043E\0431\0430\0432\043B\044F\044F \0438\043B\0438 \0438\0437\043C\0435\043D\044F\044F \0432 \0437\0430\043F\0440\043E\0441\0435 \043F\0440\0435\0434\043B\043E\0436\0435\043D\0438\0435 <code>WHERE</code>. \041C\043E\0436\043D\043E \0444\0438\043B\044C\0442\0440\043E\0432\0430\0442\044C \043F\043E \0441\0442\043E\043B\0431\0446\0443 \0438\043B\0438 \043F\043E \0441\0442\0440\043E\043A\0435. '),
unistr('<p>\0424\0438\043B\044C\0442\0440\0443\044F \043F\043E \0441\0442\043E\043B\0431\0446\0443, \0432\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446 (\043E\043D \043D\0435 \043E\0431\044F\0437\0430\0442\0435\043B\044C\043D\043E \0434\043E\043B\0436\0435\043D'),
unistr('\043E\0442\043E\0431\0440\0430\0436\0430\0442\044C\0441\044F), \0432\044B\0431\0435\0440\0438\0442\0435 \0441\0442\0430\043D\0434\0430\0440\0442\043D\044B\0439 \043E\043F\0435\0440\0430\0442\043E\0440 Oracle (=, !=, not in, between) \0438 \0432\0432\0435\0434\0438\0442\0435 \0432\044B\0440\0430\0436\0435\043D\0438\0435 \0434\043B\044F \0441\0440\0430\0432\043D\0435\043D\0438\044F. \0412 \0432\044B\0440\0430\0436\0435\043D\0438\044F\0445 \0440\0430\0437\043B\0438\0447\0430\0435\0442\0441\044F \0440\0435\0433\0438\0441\0442\0440 \0431\0443\043A\0432. \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 % \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \043F\043E\0434\0441\0442\0430\043D\043E\0432\043E\0447\043D\043E\0433\043E \0437\043D\0430\043A\0430 (\043D\0430\043F\0440\0438\043C\0435\0440, <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>\0424\0438\043B\044C\0442\0440\0443\044F \043F\043E \0441\0442\0440\043E\043A\0430\043C, \043C\043E\0436\043D\043E \0441\043E\0437\0434\0430\0432\0430\0442\044C \0441\043B\043E\0436\043D\044B\0435 \043F\0440\0435\0434\043B\043E\0436\0435\043D\0438\044F <code>WHERE</code>, \0438\0441\043F\043E\043B\044C\0437\0443\044F'),
unistr('\043F\0441\0435\0432\0434\043E\043D\0438\043C\044B \0441\0442\043E\043B\0431\0446\043E\0432 \0438 \043B\044E\0431\044B\0435 \0444\0443\043D\043A\0446\0438\0438 \0438\043B\0438 \043E\043F\0435\0440\0430\0442\043E\0440\044B Oracle (\043D\0430\043F\0440\0438\043C\0435\0440, <code>G = ''VA'' or G = ''CT''</code>, \0433\0434\0435'),
unistr('<code>G</code> \2014 \043F\0441\0435\0432\0434\043E\043D\0438\043C \0434\043B\044F <code>CUSTOMER_STATE</code>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364189604401647)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0441 flashback \043F\043E\0437\0432\043E\043B\044F\0435\0442 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C \0434\0430\043D\043D\044B\0435 \0432 \0442\043E\043C \0432\0438\0434\0435, \0432 \043A\0430\043A\043E\043C \043E\043D\0438 \0441\0443\0449\0435\0441\0442\0432\043E\0432\0430\043B\0438 \0432 \043F\0440\0435\0434\044B\0434\0443\0449\0438\0439 \043C\043E\043C\0435\043D\0442 \0432\0440\0435\043C\0435\043D\0438. \041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E \0437\0430\043F\0440\043E\0441 flashback \043C\043E\0436\043D\043E \0432\044B\043F\043E\043B\043D\044F\0442\044C \0432 \0442\0435\0447\0435\043D\0438\0435 3 \0447\0430\0441\043E\0432 (\0438\043B\0438 180 \043C\0438\043D\0443\0442), \043D\043E \0444\0430\043A\0442\0438\0447\0435\0441\043A\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0432\0440\0435\043C\0435\043D\0438 \0437\0430\0432\0438\0441\0438\0442 \043E\0442 \043A\0430\0436\0434\043E\0439 \0431\0430\0437')
||unistr('\044B \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425374146401691)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0424\043E\0440\043C\0430\0442 \043F\043E\0437\0432\043E\043B\044F\0435\0442 \043D\0430\0441\0442\0440\043E\0438\0442\044C \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\0435 \043E\0442\0447\0435\0442\0430.'),
unistr('\0424\043E\0440\043C\0430\0442 \0441\043E\0434\0435\0440\0436\0438\0442 \0441\043B\0435\0434\0443\044E\0449\0435\0435 \043F\043E\0434\043C\0435\043D\044E:</p>'),
unistr('<ul><li>\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C</li>'),
unistr('<li>\0421\043C\0435\043D\0430 \043E\043F\0435\0440\0430\0446\0438\0438</li>'),
unistr('<li>\0412\044B\0434\0435\043B\0438\0442\044C</li>'),
unistr('<li>\0412\044B\0447\0438\0441\043B\0438\0442\044C</li>'),
unistr('<li>\0410\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435</li>'),
unistr('<li>\0414\0438\0430\0433\0440\0430\043C\043C\0430</li>'),
unistr('<li>\0413\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C</li>'),
unistr('<li>\0421\0440\0435\0437</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423500584401690)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041C\043E\0436\043D\043E \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \043E\0434\043D\0443 \0433\0440\0443\043F\043F\0443 \043F\043E \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C \0434\043B\044F \043A\0430\0436\0434\043E\0433\043E \0441\043E\0445\0440\0430\043D\0435\043D\043D\043E\0433\043E'),
unistr('\043E\0442\0447\0435\0442\0430. \041F\043E\0441\043B\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \043C\043E\0436\043D\043E \043F\0435\0440\0435\043A\043B\044E\0447\0430\0442\044C\0441\044F \043C\0435\0436\0434\0443 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C\0438 \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\044F \0438 \043E\0442\0447\0435\0442\043E\0432'),
unistr('\0441 \043F\043E\043C\043E\0449\044C\044E \0437\043D\0430\0447\043A\043E\0432 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0439 \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430. \0427\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\044F,'),
unistr('\0432\044B\0431\0435\0440\0438\0442\0435:'),
'<p></p><ul>',
unistr('<li>\0441\0442\043E\043B\0431\0446\044B, \043F\043E \043A\043E\0442\043E\0440\044B\043C \043D\0443\0436\043D\043E \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\0442\044C;</li>'),
unistr('<li>\0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\044F \0432\043C\0435\0441\0442\0435 \0441 \0432\044B\043F\043E\043B\043D\044F\0435\043C\043E\0439 \0444\0443\043D\043A\0446\0438\0435\0439 (\0441\0440\0435\0434\043D\0435\0435 \0437\043D\0430\0447\0435\043D\0438\0435, \0441\0443\043C\043C\0430, \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0438 \0442.\00A0\0434.)</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363716065401646)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041F\043E\0437\0432\043E\043B\044F\0435\0442 \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0444\0438\043B\044C\0442\0440. \0421\0442\0440\043E\043A\0438, \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0435 \043A\0440\0438\0442\0435\0440\0438\044F\043C \0444\0438\043B\044C\0442\0440\0430, \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \0432\044B\0434\0435\043B\0435\043D\043D\044B\043C\0438 \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \0441\0432\044F\0437\0430\043D\043D\044B\0445 \0441 \0444\0438\043B\044C\0442\0440\043E\043C \0445\0430\0440\0430\043A\0442\0435\0440\0438\0441\0442\0438\043A. \0421\0440\0435\0434\0438 \0434\043E\0441\0442\0443\043F\043D\044B\0445 \0432\0430\0440\0438\0430\043D\0442\043E\0432:</p>'),
'<ul>',
unistr('<li><strong>\0418\043C\044F</strong> \0438\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0442\043E\043B\044C\043A\043E \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F.</li>'),
unistr('<li><strong>\041F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C</strong> \043E\043F\0440\0435\0434\0435\043B\044F\0435\0442 \043F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C, \0432 \043A\043E\0442\043E\0440\043E\0439 \043E\0446\0435\043D\0438\0432\0430\044E\0442\0441\044F \043F\0440\0430\0432\0438\043B\0430.</li>'),
unistr('<li><strong>\0412\043A\043B\044E\0447\0435\043D\043E</strong> \043E\043F\0440\0435\0434\0435\043B\044F\0435\0442, \0432\043A\043B\044E\0447\0435\043D\043E \0438\043B\0438 \043E\0442\043A\043B\044E\0447\0435\043D\043E \043F\0440\0430\0432\0438\043B\043E.</li>'),
unistr('<li><strong>\0422\0438\043F \0432\044B\0434\0435\043B\0435\043D\0438\044F</strong> \043E\043F\0440\0435\0434\0435\043B\044F\0435\0442, \0441\043B\0435\0434\0443\0435\0442 \043B\0438 \0432\044B\0434\0435\043B\044F\0442\044C \0441\0442\0440\043E\043A\0443 \0438\043B\0438 \044F\0447\0435\0439\043A\0443. '),
unistr('\0415\0441\043B\0438 \0432\044B\0431\0440\0430\043D\0430 \044F\0447\0435\0439\043A\0430, \0441\0442\043E\043B\0431\0435\0446, \043D\0430 \043A\043E\0442\043E\0440\044B\0439 \0441\0441\044B\043B\0430\0435\0442\0441\044F'),
unistr('\0443\0441\043B\043E\0432\0438\0435 \0432\044B\0434\0435\043B\0435\043D\0438\044F, \0432\044B\0434\0435\043B\0435\043D.</li>'),
unistr('<li><strong>\0426\0432\0435\0442 \0444\043E\043D\0430</strong> \2014 \044D\0442\043E \043D\043E\0432\044B\0439 \0446\0432\0435\0442 \0444\043E\043D\0430 \0432\044B\0434\0435\043B\0435\043D\043D\043E\0439 \043E\0431\043B\0430\0441\0442\0438.</li>'),
unistr('<li><strong>\0426\0432\0435\0442 \0442\0435\043A\0441\0442\0430</strong> \2014 \044D\0442\043E \043D\043E\0432\044B\0439 \0446\0432\0435\0442 \0442\0435\043A\0441\0442\0430 \0432 \0432\044B\0434\0435\043B\0435\043D\043D\043E\0439 \043E\0431\043B\0430\0441\0442\0438.</li>'),
unistr('<li><strong>\0423\0441\043B\043E\0432\0438\0435 \0432\044B\0434\0435\043B\0435\043D\0438\044F</strong> \043E\043F\0440\0435\0434\0435\043B\044F\0435\0442 \0443\0441\043B\043E\0432\0438\0435 \0444\0438\043B\044C\0442\0440\0430.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301334903401601)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0414\043B\044F \043A\0430\0436\0434\043E\0433\043E \0441\043E\0445\0440\0430\043D\0435\043D\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430 \043C\043E\0436\043D\043E \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \043E\0434\043D\043E \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0441\0440\0435\0437\0430. \041F\043E\0441\043B\0435 \0441\043E\0437\0434\0430\043D\0438\044F \0442\0430\043A\043E\0433\043E \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\044F \043C\0435\0436\0434\0443 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C\0438 \0441\0440\0435\0437\0430 \0438 \043E\0442\0447\0435\0442\0430 \043C\043E\0436\043D\043E \043F\0435\0440\0435\043A\043B\044E\0447\0430\0442\044C\0441\044F \0441 \043F\043E\043C\043E\0449\044C\044E \0437\043D\0430\0447\043A\043E\0432 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430. \0427\0442\043E\0431\044B \0441\043E\0437\0434\0430\0442\044C \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0441\0440\0435\0437\0430, ')
||unistr('\043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0432\044B\0431\0440\0430\0442\044C: '),
'<p></p>',
'<ul>',
unistr('<li>\0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \0432\043A\043B\044E\0447\0435\043D\0438\044F \0432 \0441\0440\0435\0437,</li>'),
unistr('<li>\0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F \0432 \0432\0438\0434\0435 \0441\0442\0440\043E\043A,</li>'),
unistr('<li>\0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\044F \0432\043C\0435\0441\0442\0435 \0441 \0432\044B\043F\043E\043B\043D\044F\0435\043C\043E\0439 \0444\0443\043D\043A\0446\0438\0435\0439 (\0441\0440\0435\0434\043D\0435\0435 \0437\043D\0430\0447\0435\043D\0438\0435, \0441\0443\043C\043C\0430, \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0438 \0442.\00A0\0434.).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374877611401654)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\0440\0438 \043D\0430\0441\0442\0440\043E\0439\043A\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430 \043F\0430\0440\0430\043C\0435\0442\0440\044B \043E\0442\0447\0435\0442\0430 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F'),
unistr('\043F\043E\0434 \0441\0442\0440\043E\043A\043E\0439 \043F\043E\0438\0441\043A\0430 \0438 \043D\0430\0434 \043E\0442\0447\0435\0442\043E\043C. \042D\0442\0443 \043E\0431\043B\0430\0441\0442\044C \043C\043E\0436\043D\043E \0441\0432\0435\0440\043D\0443\0442\044C \0438 \0440\0430\0437\0432\0435\0440\043D\0443\0442\044C \0441 \043F\043E\043C\043E\0449\044C\044E \0437\043D\0430\0447\043A\0430 \0441\043B\0435\0432\0430.'),
'<p>',
unistr('\0414\043B\044F \043A\0430\0436\0434\043E\0439 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430 \043C\043E\0436\043D\043E:'),
'</p><ul>',
unistr('<li>\0438\0437\043C\0435\043D\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0443, \043D\0430\0436\0430\0432 \043D\0430 \0438\043C\044F;</li>'),
unistr('<li>\043E\0442\043A\043B\044E\0447\0438\0442\044C/\0432\043A\043B\044E\0447\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0443, \0441\043D\044F\0432 \0438\043B\0438 \0443\0441\0442\0430\043D\043E\0432\0438\0432 \0444\043B\0430\0436\043E\043A "\0412\043A\043B\044E\0447\0438\0442\044C/\041E\0442\043A\043B\044E\0447\0438\0442\044C". \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E\0442 \044D\043B\0435\043C\0435\043D\0442 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F \0434\043B\044F \0432\0440\0435\043C\0435\043D\043D\043E\0433\043E \0432\044B\043A\043B\044E\0447\0435\043D\0438\044F \0438 \0432\043A\043B\044E\0447\0435\043D\0438\044F \043D\0430\0441\0442\0440\043E\0435\043A;</li>'),
unistr('<li>\0443\0434\0430\043B\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0443, \043D\0430\0436\0430\0432 \0437\043D\0430\0447\043E\043A "\0423\0434\0430\043B\0438\0442\044C".</li>'),
'</ul>',
unistr('<p>\0415\0441\043B\0438 \0432\044B \0441\043E\0437\0434\0430\043B\0438 \0434\0438\0430\0433\0440\0430\043C\043C\0443, \0433\0440\0443\043F\043F\044B \0438\043B\0438 \0441\0440\0435\0437, \0432\044B \043C\043E\0436\0435\0442\0435 \043F\0435\0440\0435\043A\043B\044E\0447\0430\0442\044C\0441\044F \043C\0435\0436\0434\0443 \043D\0438\043C\0438'),
unistr('\0438 \0431\0430\0437\043E\0432\044B\043C \043E\0442\0447\0435\0442\043E\043C, \0438\0441\043F\043E\043B\044C\0437\0443\044F \0441\0441\044B\043B\043A\0438 "\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \043E\0442\0447\0435\0442\0430", "\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0434\0438\0430\0433\0440\0430\043C\043C\044B", "\0413\0440\0443\043F\043F\044B \043F\043E \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C" \0438 "\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0441\0440\0435\0437\0430",'),
unistr('\043F\043E\043A\0430\0437\0430\043D\043D\044B\0435 \0441\043F\0440\0430\0432\0430. \0415\0441\043B\0438 \0432\044B \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0435\0442\0435 \0434\0438\0430\0433\0440\0430\043C\043C\0443, \0433\0440\0443\043F\043F\044B \0438\043B\0438 \0441\0440\0435\0437, \0434\043B\044F \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F \043D\0430\0441\0442\0440\043E\0435\043A'),
unistr('\0442\0430\043A\0436\0435 \043C\043E\0436\0435\0442\0435 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0441\0441\044B\043B\043A\0443 "\0418\0437\043C\0435\043D\0438\0442\044C".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364352021401647)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E\0437\0432\0440\0430\0449\0430\0435\0442 \043E\0442\0447\0435\0442 \043A \043D\0430\0441\0442\0440\043E\0439\043A\0430\043C \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E, \0443\0434\0430\043B\044F\044F \0432\0441\0435 \0432\043D\0435\0441\0435\043D\043D\044B\0435 \0432\0430\043C\0438 \0438\0437\043C\0435\043D\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425650343401692)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0434\0430\0435\0442 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441\0435\0439 \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364260645401647)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0421\043E\0445\0440\0430\043D\044F\0435\0442 \043D\0430\0441\0442\0440\043E\0435\043D\043D\044B\0439 \043E\0442\0447\0435\0442 \0434\043B\044F \0434\0430\043B\044C\043D\0435\0439\0448\0435\0433\043E \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\044F. \0412\044B \0443\043A\0430\0437\044B\0432\0430\0435\0442\0435 \0438\043C\044F \0438 \043E\043F\0438\0441\0430\043D\0438\0435 (\0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E) \0438 \043C\043E\0436\0435\0442\0435 \0441\0434\0435\043B\0430\0442\044C \043E\0442\0447\0435\0442 \043F\0443\0431\043B\0438\0447\043D\044B\043C (\0442\043E \0435\0441\0442\044C \0432\0438\0434\0438\043C\044B\043C \0434\043B\044F \0432\0441\0435\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439, \043A\043E\0442\043E\0440\044B\0435 \043C\043E\0433\0443\0442 \043F\043E\043B\0443\0447\0438\0442\044C \0434\043E\0441\0442\0443\043F \043A \043E\0441\043D\043E\0432\043D\043E\043C\0443 \043E\0442\0447\0435\0442\0443 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E). \0412\044B \043C\043E')
||unistr('\0436\0435\0442\0435 \0441\043E\0445\0440\0430\043D\044F\0442\044C \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0435 \043E\0442\0447\0435\0442\044B \0447\0435\0442\044B\0440\0435\0445 \0442\0438\043F\043E\0432:</p>'),
'<ul>',
unistr('<li><strong>\041E\0441\043D\043E\0432\043D\043E\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E</strong> (\0442\043E\043B\044C\043A\043E \0434\043B\044F \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\043E\0432). \041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E \043E\0441\043D\043E\0432\043D\043E\0439 \043E\0442\0447\0435\0442\00A0\2014 \044D\0442\043E \0442\043E\0442, \043A\043E\0442\043E\0440\044B\0439 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0438\0437\043D\0430\0447\0430\043B\044C\043D\043E. \041E\0441\043D\043E\0432\043D\044B\0435 \043E\0442\0447\0435\0442\044B \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E \043D\0435 \043C\043E\0433\0443\0442 \0431\044B\0442\044C \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\0430\043D\044B \0438\043B\0438 \0443\0434\0430\043B\0435\043D\044B.</li>'),
unistr('<li><strong>\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442</strong> (\0442\043E\043B\044C\043A\043E \0434\043B\044F \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\043E\0432) \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\0430\043C \0441\043E\0437\0434\0430\0432\0430\0442\044C \043D\0435\0441\043A\043E\043B\044C\043A\043E \0440\0430\0437\043C\0435\0442\043E\043A \043E\0442\0447\0435\0442\043E\0432. \0422\043E\043B\044C\043A\043E \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\0438 \043C\043E\0433\0443\0442 \0441\043E\0445\0440\0430\043D\044F\0442\044C, \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\044B\0432\0430\0442\044C \0438\043B\0438 \0443\0434\0430\043B\044F\0442\044C \0430\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442.</li>'),
unistr('<li><strong>\041F\0443\0431\043B\0438\0447\043D\044B\0439 \043E\0442\0447\0435\0442</strong> (\041A\043E\043D\0435\0447\043D\044B\0439 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C). \041C\043E\0436\0435\0442 \0431\044B\0442\044C \0441\043E\0445\0440\0430\043D\0435\043D, \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\0430\043D \0438\043B\0438 \0443\0434\0430\043B\0435\043D \043A\043E\043D\0435\0447\043D\044B\043C \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\043C, \043A\043E\0442\043E\0440\044B\0439 \0435\0433\043E \0441\043E\0437\0434\0430\043B. \0414\0440\0443\0433\0438\0435 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043C\043E\0433\0443\0442 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C \0438 \0441\043E\0445\0440\0430\043D\044F\0442\044C \0440\0430\0437\043C\0435\0442\043A\0443 \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0434\0440\0443\0433\043E\0433\043E \043E\0442\0447\0435\0442\0430.</li>'),
unistr('<li><strong>\0427\0430\0441\0442\043D\044B\0439 \043E\0442\0447\0435\0442</strong> (\041A\043E\043D\0435\0447\043D\044B\0439 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C). \0422\043E\043B\044C\043A\043E \043A\043E\043D\0435\0447\043D\044B\0439 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C, \0441\043E\0437\0434\0430\0432\0448\0438\0439 \043E\0442\0447\0435\0442, \043C\043E\0436\0435\0442 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C, \0441\043E\0445\0440\0430\043D\044F\0442\044C, \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\044B\0432\0430\0442\044C \0438\043B\0438 \0443\0434\0430\043B\044F\0442\044C \043E\0442\0447\0435\0442.</li>'),
'</ul>',
unistr('<p>\0415\0441\043B\0438 \0432\044B \0441\043E\0445\0440\0430\043D\044F\0435\0442\0435 \043D\0430\0441\0442\0440\043E\0435\043D\043D\044B\0435 \043E\0442\0447\0435\0442\044B, \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430 \0441\043B\0435\0432\0430 \043E\0442 \0441\0435\043B\0435\043A\0442\043E\0440\0430 \0441\0442\0440\043E\043A \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\0435\043B\0435\043A\0442\043E\0440 \043E\0442\0447\0435\0442\043E\0432 (\0435\0441\043B\0438 \044D\0442\0430 \0444\0443\043D\043A\0446\0438\044F \0432\043A\043B\044E\0447\0435\043D\0430).</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363212216401646)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0432\0435\0440\0445\043D\0435\0439 \0447\0430\0441\0442\0438 \043A\0430\0436\0434\043E\0439 \0441\0442\0440\0430\043D\0438\0446\044B \043E\0442\0447\0435\0442\0430 \043D\0430\0445\043E\0434\0438\0442\0441\044F \043E\0431\043B\0430\0441\0442\044C \043F\043E\0438\0441\043A\0430. \042D\0442\0430 \043E\0431\043B\0430\0441\0442\044C (\0438\043B\0438 \0441\0442\0440\043E\043A\0430 \043F\043E\0438\0441\043A\0430) \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\044F\0435\0442 \0441\043B\0435\0434\0443\044E\0449\0438\0435 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\0438:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426263370401692)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('<li>\041C\0435\043D\044E <strong>\0414\0435\0439\0441\0442\0432\0438\044F</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \043D\0430\0441\0442\0440\043E\0438\0442\044C \043E\0442\0447\0435\0442. \0421\043C. \043F\043E\0441\043B\0435\0434\0443\044E\0449\0438\0435 \0440\0430\0437\0434\0435\043B\044B.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425749425401692)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'ru'
,p_message_text=>unistr('<li><strong>\0417\043D\0430\0447\043E\043A \0432\044B\0431\043E\0440\0430 \0441\0442\043E\043B\0431\0446\043E\0432</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0443\043A\0430\0437\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446, \0432 \043A\043E\0442\043E\0440\043E\043C \0432\044B\043F\043E\043B\043D\044F\0435\0442\0441\044F \043F\043E\0438\0441\043A (\0438\043B\0438 \0432\043E \0432\0441\0435\0445).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426024599401692)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'ru'
,p_message_text=>unistr('<li><strong>\041E\0442\0447\0435\0442\044B</strong> \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442 \0430\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0435 \043E\0442\0447\0435\0442\044B \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E, \0430 \0442\0430\043A\0436\0435 \0441\043E\0445\0440\0430\043D\0435\043D\043D\044B\0435 \0447\0430\0441\0442\043D\044B\0435 \0438\043B\0438 \043E\0431\0449\0435\0434\043E\0441\0442\0443\043F\043D\044B\0435 \043E\0442\0447\0435\0442\044B.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425971653401692)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('<li><strong>\0421\0442\0440\043E\043A\0438</strong> \0437\0430\0434\0430\0435\0442 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441\0435\0439 \0434\043B\044F \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0435.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425866986401692)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\0422\0435\043A\0441\0442\043E\0432\0430\044F \043E\0431\043B\0430\0441\0442\044C</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\0432\043E\0434\0438\0442\044C \043A\0440\0438\0442\0435\0440\0438\0438 \043F\043E\0438\0441\043A\0430 \0431\0435\0437 \0443\0447\0435\0442\0430 \0440\0435\0433\0438\0441\0442\0440\0430 (\043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\044E\0442\0441\044F \043F\043E\0434\0441\0442\0430\043D\043E\0432\043E\0447\043D\044B\0435 \0437\043D\0430\043A\0438).</li>'),
unistr('<li>\041A\043D\043E\043F\043A\0430 <strong>\041F\0435\0440\0435\0439\0442\0438</strong> \0437\0430\043F\0443\0441\043A\0430\0435\0442 \0432\044B\043F\043E\043B\043D\0435\043D\0438\0435 \043F\043E\0438\0441\043A\0430. \041A\043E\0433\0434\0430 \043A\0443\0440\0441\043E\0440 \043D\0430\0445\043E\0434\0438\0442\0441\044F \0432 \0442\0435\043A\0441\0442\043E\0432\043E\0439 \043E\0431\043B\0430\0441\0442\0438 \043F\043E\0438\0441\043A\0430, \043F\0440\0438 \043D\0430\0436\0430\0442\0438\0438 \043A\043B\0430\0432\0438\0448\0438 Enter \0442\0430\043A\0436\0435 \0432\044B\043F\043E\043B\043D\044F\0435\0442\0441\044F \043F\043E\0438\0441\043A.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426196699401692)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('<li><strong>\0417\043D\0430\0447\043A\0438 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0439</strong> \0438\0441\043F\043E\043B\044C\0437\0443\044E\0442\0441\044F \0434\043B\044F \043F\0435\0440\0435\043A\043B\044E\0447\0435\043D\0438\044F \043C\0435\0436\0434\0443 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C\0438 (\043E\0442\0447\0435\0442\0430) \0432 \0432\0438\0434\0435 \0437\043D\0430\0447\043A\0430, \043E\0442\0447\0435\0442\0430, \0441\0432\0435\0434\0435\043D\0438\0439, \0434\0438\0430\0433\0440\0430\043C\043C\044B, \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\044F \0438 \0441\0440\0435\0437\0430, \0435\0441\043B\0438 \043E\043D\0438 \043E\043F\0440\0435\0434\0435\043B\0435\043D\044B.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442101778401703)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('<li><strong>\0423\043F\0440\0430\0432\043B\0435\043D\0438\0435</strong> \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0443\043F\0440\0430\0432\043B\044F\0442\044C \0441\0432\043E\0439\0441\0442\0432\0430\043C\0438, \0441\0442\043E\043B\0431\0446\0430\043C\0438, \0441\0442\0440\043E\043A\0430\043C\0438 \0438 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C \0438\0441\0442\043E\0440\0438\044E \043E\0442\0447\0435\0442\0430 \0438\043B\0438 \0442\0430\0431\043B\0438\0446\044B \0434\0430\043D\043D\044B\0445.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363426336401646)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0434\043B\044F \0438\0437\043C\0435\043D\0435\043D\0438\044F \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432. \0421\0442\043E\043B\0431\0446\044B \0441\043F\0440\0430\0432\0430 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F. \0421\0442\043E\043B\0431\0446\044B \0441\043B\0435\0432\0430 \0441\043A\0440\044B\0442\044B. \041F\043E\0440\044F\0434\043E\043A \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432 \043C\043E\0436\043D\043E \0438\0437\043C\0435\043D\0438\0442\044C \0441 \043F\043E\043C\043E\0449\044C\044E \0441\0442\0440\0435\043B\043E\043A \0432 \043A\0440\0430\0439\043D\0435\043C \043F\0440\0430\0432\043E\043C \0443\0433\043B\0443. \0412\044B\0447\0438\0441\043B\044F\0435\043C\044B\0435 \0441\0442\043E\043B\0431\0446\044B \0438\043C\0435\044E\0442 \043F\0440\0435\0444\0438\043A\0441 <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363612935401646)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0434\043B\044F \0438\0437\043C\0435\043D\0435\043D\0438\044F \0441\0442\043E\043B\0431\0446\043E\0432 \0432 \0446\0435\043B\044F\0445 \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438 \0438 \043E\043F\0440\0435\0434\0435\043B\044F\0435\0442, \0441\043B\0435\0434\0443\0435\0442 \043B\0438'),
unistr('\0441\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \0432 \043F\043E\0440\044F\0434\043A\0435 \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044F \0438\043B\0438 \0443\0431\044B\0432\0430\043D\0438\044F. \0422\0430\043A\0436\0435 \043C\043E\0436\043D\043E \0443\043A\0430\0437\0430\0442\044C \0441\043F\043E\0441\043E\0431 \043E\0431\0440\0430\0431\043E\0442\043A\0438'),
unistr('\0437\043D\0430\0447\0435\043D\0438\044F <code>NULL</code>. \041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E \0437\043D\0430\0447\0435\043D\0438\044F <code>NULL</code> \0432\0441\0435\0433\0434\0430 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043F\043E\0441\043B\0435\0434\043D\0438\043C\0438 \0438\043B\0438 \043F\0435\0440\0432\044B\043C\0438. \041F\043E\043B\0443\0447\0435\043D\043D\0430\044F \0441\043E\0440\0442\0438\0440\043E\0432\043A\0430 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\043F\0440\0430\0432\0430 \043E\0442'),
unistr('\0437\0430\0433\043E\043B\043E\0432\043A\043E\0432 \0441\0442\043E\043B\0431\0446\043E\0432 \0432 \043E\0442\0447\0435\0442\0435.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423367975401690)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438 \0434\043E\0431\0430\0432\043B\0435\043D\0438\0438 \043F\043E\0434\043F\0438\0441\043A\0438 \0432\044B \0443\043A\0430\0437\044B\0432\0430\0435\0442\0435 \0430\0434\0440\0435\0441 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B (\0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0430\0434\0440\0435\0441\043E\0432 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B, \0440\0430\0437\0434\0435\043B\0435\043D\043D\044B\0445 \0437\0430\043F\044F\0442\044B\043C\0438), \0442\0435\043C\0443, \0447\0430\0441\0442\043E\0442\0443, \0434\0430\0442\044B \043D\0430\0447\0430\043B\0430 \0438 \043E\043A\043E\043D\0447\0430\043D\0438\044F. \041F\043E\043B\0443\0447\0435\043D\043D\044B\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\044B\0435 \043F\0438\0441\044C\043C\0430 \0432\043A\043B\044E\0447\0430\044E\0442 HTML-\0432\0435\0440\0441\0438\044E \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430 \0441 \0442\0435\043A\0443\0449\0438\043C\0438')
||unistr(' \0434\0430\043D\043D\044B\043C\0438 \043D\0430 \043E\0441\043D\043E\0432\0435 \043D\0430\0441\0442\0440\043E\0435\043A \043E\0442\0447\0435\0442\0430, \043A\043E\0442\043E\0440\044B\0435 \0434\0435\0439\0441\0442\0432\043E\0432\0430\043B\0438 \043F\0440\0438 \0434\043E\0431\0430\0432\043B\0435\043D\0438\0438 \043F\043E\0434\043F\0438\0441\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441971149401703)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0422\0430\0431\043B\0438\0446\044B \0434\0430\043D\043D\044B\0445 \2014 \044D\0442\043E, \0432 \043E\0441\043D\043E\0432\043D\043E\043C, \0440\0435\0434\0430\043A\0442\0438\0440\0443\0435\043C\044B\0435 \043E\0442\0447\0435\0442\044B \0441 \0448\0438\0440\043E\043A\0438\043C\0438 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\044F\043C\0438 \043D\0430\0441\0442\0440\043E\0439\043A\0438. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043C\043E\0433\0443\0442 \0438\0437\043C\0435\043D\044F\0442\044C \043A\043E\043C\043F\043E\043D\043E\0432\043A\0443 \0434\0430\043D\043D\044B\0445 \043E\0442\0447\0435\0442\0430, \0432\044B\0431\0438\0440\0430\044F \0441\0442\043E\043B\0431\0446\044B, \043F\0440\0438\043C\0435\043D\044F\044F \0444\0438\043B\044C\0442\0440\044B, \0432\044B\0434\0435\043B\044F\044F \0438 \0441\043E\0440\0442\0438\0440\0443\044F. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \0442\0430\043A\0436\0435 \043C\043E\0433\0443\0442 \043E\043F\0440\0435\0434\0435\043B\044F\0442\044C \0440\0430\0437\0440\044B\0432\044B, \0430\0433\0440\0435\0433')
||unistr('\0438\0440\043E\0432\0430\043D\0438\0435, \0434\0438\0430\0433\0440\0430\043C\043C\044B, \0433\0440\0443\043F\043F\044B \0438 \0434\043E\0431\0430\0432\043B\044F\0442\044C \0441\043E\0431\0441\0442\0432\0435\043D\043D\044B\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F. \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438 \043C\043E\0433\0443\0442 \0441\043E\0437\0434\0430\0432\0430\0442\044C \043D\0435\0441\043A\043E\043B\044C\043A\043E \0432\0430\0440\0438\0430\043D\0442\043E\0432 \043E\0442\0447\0435\0442\0430 \0438 \0441\043E\0445\0440\0430\043D\044F\0442\044C \0438\0445 \0432 \0432\0438\0434\0435 \0438\043C\0435\043D\043E\0432\0430\043D\043D\044B\0445 \043E\0442\0447\0435\0442\043E\0432 \0434\043B\044F \0447\0430\0441\0442\043D\043E\0433\043E \043F\0440\043E\0441\043C\043E\0442\0440\0430. '),
'<p/>',
unistr('\0422\0430\0431\043B\0438\0446\0443 \0434\0430\043D\043D\044B\0445 \043C\043E\0436\043D\043E \043D\0430\0441\0442\0440\043E\0438\0442\044C \0441 \043F\043E\043C\043E\0449\044C\044E \0441\0442\0440\043E\043A\0438 \043F\043E\0438\0441\043A\0430, \043C\0435\043D\044E "\0414\0435\0439\0441\0442\0432\0438\044F", \043C\0435\043D\044E "\0423\043F\0440\0430\0432\043B\0435\043D\0438\0435" \0438\043B\0438 \043C\0435\043D\044E "\0417\0430\0433\043E\043B\043E\0432\043E\043A \0441\0442\043E\043B\0431\0446\0430".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453794468401712)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\043D\044E "\0414\0435\0439\0441\0442\0432\0438\044F" \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\043F\0440\0430\0432\0430 \043E\0442 \043A\043D\043E\043F\043A\0438 "\041F\0435\0440\0435\0439\0442\0438" \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430. \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E \043C\0435\043D\044E \0434\043B\044F \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430 \0441 \0441\0435\0442\043A\043E\0439 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442457425401704)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\0430\043D\0438\0446\0430 "\0414\043E\0431\0430\0432\043B\0435\043D\0438\0435/\0438\0437\043C\0435\043D\0435\043D\0438\0435 \0441\0442\0440\043E\043A\0438"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442596061401704)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0427\0442\043E\0431\044B \0434\043E\0431\0430\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443 \0432 \0442\0430\0431\043B\0438\0446\0443 \0434\0430\043D\043D\044B\0445, \043D\0430\0436\043C\0438\0442\0435 "\0414\043E\0431\0430\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443". \0427\0442\043E\0431\044B \0438\0437\043C\0435\043D\0438\0442\044C \0441\0432\0435\0434\0435\043D\0438\044F \043E \0441\0442\0440\043E\043A\0435, \043D\0430\0436\043C\0438\0442\0435 \0437\043D\0430\0447\043E\043A \0441\0442\0440\043E\043A\0443 \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F (\043F\0435\0440\0432\044B\0439 \0441\0442\043E\043B\0431\0435\0446) \0432 \0441\0442\0440\043E\043A\0435, \043A\043E\0442\043E\0440\0443\044E \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \043E\0442\0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\0442\044C. \041E\0442\043A\0440\044B\0432\0430\0435\0442\0441\044F \0441\0442\0440\0430\043D\0438\0446\0430 "\0414\043E\0431\0430\0432\043B\0435\043D\0438\0435/\0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438')
||unistr('\0435 \0441\0442\0440\043E\043A\0438" \0441 \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\0435\043C \0441\0442\043E\043B\0431\0446\043E\0432 \0442\0430\0431\043B\0438\0446\044B \0434\0430\043D\043D\044B\0445. </p>'),
'',
unistr('<p>\041F\0440\0438 \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\0438 \0441\0442\0440\043E\043A\0438 \043C\043E\0436\043D\043E \0441\0434\0435\043B\0430\0442\044C \0441\043B\0435\0434\0443\044E\0449\0435\0435:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\0423\0434\0430\043B\0438\0442\044C</strong> \0441\0442\0440\043E\043A\0443.</li>'),
unistr('<li><strong>\041F\0440\0438\043C\0435\043D\0438\0442\044C \0438\0437\043C\0435\043D\0435\043D\0438\044F</strong>, \0447\0442\043E\0431\044B \0441\043E\0445\0440\0430\043D\0438\0442\044C \0438\0437\043C\0435\043D\0435\043D\0438\044F, \0432\043D\0435\0441\0435\043D\043D\044B\0435 \0432 \0441\0442\0440\043E\043A\0443.</li>'),
unistr('<li>\0412 \0440\0430\0437\0434\0435\043B\0435 <strong>\0414\0435\0439\0441\0442\0432\0438\044F</strong> \043C\043E\0436\043D\043E \0434\043E\0431\0430\0432\0438\0442\044C \0441\0442\0440\043E\043A\0443, \0444\0430\0439\043B\044B, \0437\0430\043C\0435\0442\043A\0438, \0441\0441\044B\043B\043A\0438 \0438\043B\0438 \0442\0435\0433\0438 \0438 \043F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0438\0441\0442\043E\0440\0438\044E.</li>'),
unistr('<li>\041F\0435\0440\0435\0439\0442\0438 \043A \0441\0442\0440\043E\043A\0430\043C <strong>\0421\043B\0435\0434\0443\044E\0449\0438\0435 \0438 \043F\0440\0435\0434\044B\0434\0443\0449\0438\0435</strong>.</li>'),
unistr('<li>\0412 \0440\0430\0437\0434\0435\043B\0435 <strong>\0423\043F\0440\0430\0432\043B\0435\043D\0438\0435</strong> \043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C \0441\0432\043E\0439\0441\0442\0432\0430 \0441\0442\043E\043B\0431\0446\043E\0432, \0433\0440\0443\043F\043F\044B \0441\0442\043E\043B\0431\0446\043E\0432, \043F\0440\043E\0432\0435\0440\043A\0438 \0438 \0441\043F\0438\0441\043E\043A \0437\043D\0430\0447\0435\043D\0438\0439.</li>'),
'</ul></p>',
'',
unistr('<p>\0412 \043E\0431\043B\0430\0441\0442\0438 "\0410\043D\043D\043E\0442\0430\0446\0438\0438" \0432\043D\0438\0437\0443 \0441\0442\0440\0430\043D\0438\0446\044B \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F \043B\044E\0431\044B\0435 \0444\0430\0439\043B\044B, \0437\0430\043C\0435\0442\043A\0438, \0441\0441\044B\043B\043A\0438 \0438\043B\0438 \0442\0435\0433\0438, \0441\0432\044F\0437\0430\043D\043D\044B\0435 \0441 \0442\0435\043A\0443\0449\0435\0439 \0441\0442\0440\043E\043A\043E\0439.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453874661401712)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0434\043B\044F \0441\043E\0437\0434\0430\043D\0438\044F \0433\0440\0443\043F\043F\044B \0440\0430\0437\0440\044B\0432\043E\0432 \0432 \043E\0434\043D\043E\043C \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\0438\0445 \0441\0442\043E\043B\0431\0446\0430\0445. \042D\0442\043E \0434\0435\0439\0441\0442\0432\0438\0435 \0438\0437\0432\043B\0435\043A\0430\0435\0442 \0441\0442\043E\043B\0431\0446\044B \0438\0437 \0441\0435\0442\043A\0438 \0434\0430\043D\043D\044B\0445 \0438 \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442 \0438\0445 \0432 \0432\0438\0434\0435 \0433\043B\0430\0432\043D\043E\0439 \0437\0430\043F\0438\0441\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442339436401704)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\043E\0437\0432\043E\043B\044F\0435\0442 \0432\044B\0433\0440\0443\0437\0438\0442\044C \0442\0435\043A\0443\0449\0438\0439 \043D\0430\0431\043E\0440 \0440\0435\0437\0443\043B\044C\0442\0430\0442\043E\0432. \0424\043E\0440\043C\0430\0442\044B \0432\044B\0433\0440\0443\0437\043A\0438'),
unistr('\0432\043A\043B\044E\0447\0430\044E\0442 CSV, HTML \0438\043B\0438 \044D\043B\0435\043A\0442\0440\043E\043D\043D\0443\044E \043F\043E\0447\0442\0443.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453951530401712)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\0440\0438 \043D\0430\0441\0442\0440\043E\0439\043A\0435 \043E\0442\0447\0435\0442\0430 \0441 \0441\0435\0442\043A\043E\0439 \0434\0430\043D\043D\044B\0445 \043F\0430\0440\0430\043C\0435\0442\0440\044B \043E\0442\0447\0435\0442\0430 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F'),
unistr('\043F\043E\0434 \0441\0442\0440\043E\043A\043E\0439 \043F\043E\0438\0441\043A\0430 \0438 \043D\0430\0434 \043E\0442\0447\0435\0442\043E\043C. \042D\0442\0443 \043E\0431\043B\0430\0441\0442\044C \043C\043E\0436\043D\043E \0441\0432\0435\0440\043D\0443\0442\044C \0438 \0440\0430\0437\0432\0435\0440\043D\0443\0442\044C \0441 \043F\043E\043C\043E\0449\044C\044E \0437\043D\0430\0447\043A\0430 \0441\043B\0435\0432\0430.'),
'<p>',
unistr('\0414\043B\044F \043A\0430\0436\0434\043E\0439 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430 \043C\043E\0436\043D\043E:'),
'</p><ul>',
unistr('<li>\0438\0437\043C\0435\043D\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0443, \043D\0430\0436\0430\0432 \043D\0430 \0438\043C\044F;</li>'),
unistr('<li>\043E\0442\043A\043B\044E\0447\0438\0442\044C/\0432\043A\043B\044E\0447\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0443, \0441\043D\044F\0432 \0438\043B\0438 \0443\0441\0442\0430\043D\043E\0432\0438\0432 \0444\043B\0430\0436\043E\043A "\0412\043A\043B\044E\0447\0438\0442\044C/\041E\0442\043A\043B\044E\0447\0438\0442\044C". \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \044D\0442\043E\0442 \044D\043B\0435\043C\0435\043D\0442 \0443\043F\0440\0430\0432\043B\0435\043D\0438\044F \0434\043B\044F \0432\0440\0435\043C\0435\043D\043D\043E\0433\043E \0432\044B\043A\043B\044E\0447\0435\043D\0438\044F \0438 \0432\043A\043B\044E\0447\0435\043D\0438\044F \043D\0430\0441\0442\0440\043E\0435\043A;</li>'),
unistr('<li>\0443\0434\0430\043B\0438\0442\044C \043D\0430\0441\0442\0440\043E\0439\043A\0443, \043D\0430\0436\0430\0432 \0437\043D\0430\0447\043E\043A "\0423\0434\0430\043B\0438\0442\044C".</li>'),
'</ul>',
unistr('<p>\0415\0441\043B\0438 \0432\044B \0441\043E\0437\0434\0430\043B\0438 \0434\0438\0430\0433\0440\0430\043C\043C\0443 \0438\043B\0438  \0433\0440\0443\043F\043F\044B, \0432\044B \043C\043E\0436\0435\0442\0435 \043F\0435\0440\0435\043A\043B\044E\0447\0430\0442\044C\0441\044F \043C\0435\0436\0434\0443 \043D\0438\043C\0438'),
unistr('\0438 \0431\0430\0437\043E\0432\044B\043C \043E\0442\0447\0435\0442\043E\043C, \0438\0441\043F\043E\043B\044C\0437\0443\044F \0441\0441\044B\043B\043A\0438 "\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \043E\0442\0447\0435\0442\0430", "\041F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0434\0438\0430\0433\0440\0430\043C\043C\044B" \0438 "\0413\0440\0443\043F\043F\044B \043F\043E \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F\043C",'),
unistr('\043F\043E\043A\0430\0437\0430\043D\043D\044B\0435 \0441\043F\0440\0430\0432\0430. \0415\0441\043B\0438 \0432\044B \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0435\0442\0435 \0434\0438\0430\0433\0440\0430\043C\043C\0443 \0438\043B\0438 \0433\0440\0443\043F\043F\044B, \0434\043B\044F \0440\0435\0434\0430\043A\0442\0438\0440\043E\0432\0430\043D\0438\044F \043D\0430\0441\0442\0440\043E\0435\043A'),
unistr('\0442\0430\043A\0436\0435 \043C\043E\0436\0435\0442\0435 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0441\0441\044B\043B\043A\0443 "\0418\0437\043C\0435\043D\0438\0442\044C".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442223974401704)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0421\043E\0445\0440\0430\043D\044F\0435\0442 \043D\0430\0441\0442\0440\043E\0435\043D\043D\044B\0439 \043C\0430\043A\0435\0442 \043E\0442\0447\0435\0442\0430 \0441 \0441\0435\0442\043A\043E\0439 \0434\0430\043D\043D\044B\0445 \0434\043B\044F \0434\0430\043B\044C\043D\0435\0439\0448\0435\0433\043E \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\044F. \0412\044B \0443\043A\0430\0437\044B\0432\0430\0435\0442\0435 \0438\043C\044F \0438 \043E\043F\0438\0441\0430\043D\0438\0435 (\0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E). \041C\043E\0436\043D\043E \0441\043E\0445\0440\0430\043D\044F\0442\044C \043C\0430\043A\0435\0442\044B \043E\0442\0447\0435\0442\043E\0432 \0441 \0441\0435\0442\043A\043E\0439 \0434\0430\043D\043D\044B\0445 \0442\0440\0435\0445 \0442\0438\043F\043E\0432:</p>'),
'<ul>',
unistr('<li><strong>\041E\0441\043D\043E\0432\043D\043E\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E</strong> (\0442\043E\043B\044C\043A\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\044B). \041C\0430\043A\0435\0442 "\041E\0441\043D\043E\0432\043D\043E\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E" \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0438\0437\043D\0430\0447\0430\043B\044C\043D\043E. \041E\0442\0447\0435\0442\044B \0442\0438\043F\0430 "\041E\0441\043D\043E\0432\043D\043E\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E" \043D\0435\043B\044C\0437\044F \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\0430\0442\044C \0438\043B\0438 \0443\0434\0430\043B\0438\0442\044C.</li>'),
unistr('<li><strong>\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442</strong> (\0422\043E\043B\044C\043A\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\044B). \041F\043E\0437\0432\043E\043B\044F\0435\0442 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0430\043C \0441\043E\0437\0434\0430\0442\044C \043D\0435\0441\043A\043E\043B\044C\043A\043E \043C\0430\043A\0435\0442\043E\0432 \043E\0442\0447\0435\0442\043E\0432. \0422\043E\043B\044C\043A\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\044B \043C\043E\0433\0443\0442 \0441\043E\0445\0440\0430\043D\044F\0442\044C, \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\044B\0432\0430\0442\044C \0438\043B\0438 \0443\0434\0430\043B\044F\0442\044C \043E\0442\0447\0435\0442\044B \0442\0438\043F\0430 "\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442".</li>'),
unistr('<li><strong>\0427\0430\0441\0442\043D\044B\0439 \043E\0442\0447\0435\0442</strong> (\0432\0441\0435 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438). \041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C, \0441\043E\0437\0434\0430\0432\0448\0438\0439 \043C\0430\043A\0435\0442 \043E\0442\0447\0435\0442\0430, \043C\043E\0436\0435\0442 \043F\0440\043E\0441\043C\0430\0442\0440\0438\0432\0430\0442\044C, \0441\043E\0445\0440\0430\043D\044F\0442\044C, \043F\0435\0440\0435\0438\043C\0435\043D\043E\0432\044B\0432\0430\0442\044C \0438\043B\0438 \0443\0434\0430\043B\044F\0442\044C \043E\0442\0447\0435\0442 \0441 \0442\0430\043A\0438\043C \043C\0430\043A\0435\0442\043E\043C.</li>'),
'</ul>',
unistr('<p>\0415\0441\043B\0438 \0432\044B \0441\043E\0445\0440\0430\043D\044F\0435\0442\0435 \043D\0430\0441\0442\0440\043E\0435\043D\043D\044B\0435 \043E\0442\0447\0435\0442\044B, \0432 \0441\0442\0440\043E\043A\0435 \043F\043E\0438\0441\043A\0430 \0441\043B\0435\0432\0430 \043E\0442 \0441\0435\043B\0435\043A\0442\043E\0440\0430 \0441\0442\0440\043E\043A \043E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0441\0435\043B\0435\043A\0442\043E\0440 \043E\0442\0447\0435\0442\043E\0432 (\0435\0441\043B\0438 \044D\0442\0430 \0444\0443\043D\043A\0446\0438\044F \0432\043A\043B\044E\0447\0435\043D\0430).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368394996401650)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043A\0440\044B\0442\044C \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358903431401643)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0434\0435\043B\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369823387401651)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0434\0435\043B\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374940340401655)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0441\043B\043E\0432\0438\0435 \0432\044B\0434\0435\043B\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423990886401690)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0438\043B\044C \0432\044B\0434\0435\043B\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333943152401625)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0432\044B\0434\0435\043B\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443427625401704)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0433\043E\0440\0438\0437\043E\043D\0442\0430\043B\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473015849401726)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'ru'
,p_message_text=>unistr('1 \043D\0435\0430\043A\0442\0438\0432\043D\0430\044F \043D\0430\0441\0442\0440\043E\0439\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473198595401726)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0430\043A\0442\0438\0432\043D\044B\0445 \043D\0430\0441\0442\0440\043E\0435\043A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364961544401647)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430\044F \0441\043F\0440\0430\0432\043A\0430 \043F\043E \043E\0442\0447\0435\0442\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375907863401655)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369361338401650)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0432\044B\0440\0430\0436\0435\043D\0438\0435 \0434\043B\044F \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328777461401621)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043D\0435\0447\043D\0430\044F \0434\0430\0442\0430 \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \043F\043E\0437\0436\0435 \043D\0430\0447\0430\043B\044C\043D\043E\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383672034401661)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0432\044B\0440\0430\0436\0435\043D\0438\0435 \0444\0438\043B\044C\0442\0440\0430. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451453100401710)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\0435\0440\043D\044B\0439 \0437\0430\043F\0440\043E\0441 \0444\0438\043B\044C\0442\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473264013401726)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'ru'
,p_message_text=>unistr('1 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\0430\044F \043D\0430\0441\0442\0440\043E\0439\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473309532401726)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0445 \043D\0430\0441\0442\0440\043E\0435\043A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424167584401690)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('(\0432 \043C\0438\043D\0443\0442\0430\0445)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441187995401703)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0432 \043F\043E\0441\043B. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441376022401703)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0432 \0441\043B\0435\0434. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441210567401703)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0432 \043F\043E\0441\043B. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441494674401703)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435 \0432 \0441\043B\0435\0434. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374042774401654)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043B\0430\0432\0438\0430\0442\0443\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340168431401629)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0442\043A\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367930567401649)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C \043E\0441\0438 \0434\043B\044F \043C\0435\0442\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360494915401644)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0439 \0434\0435\043D\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360699162401644)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0439 \0447\0430\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360184998401644)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\044B\0439 \043C\0435\0441\044F\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360249469401644)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0430\044F \043D\0435\0434\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360366889401644)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360529220401644)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359973042401643)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043D\0438\0435%0 \043B\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360050714401644)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\044B\0439 \0433\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340053321401629)
,p_name=>'APEXIR_LINE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041B\0438\043D\0435\0439\043D\0430\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336853756401627)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'ru'
,p_message_text=>unistr('\041B\0438\043D\0438\044F \0441 \043E\0431\043B\0430\0441\0442\044C\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451308414401710)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0437\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368882464401650)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \043E\0446\0435\043D\043A\0435, \0434\043B\044F \0432\044B\043F\043E\043B\043D\0435\043D\0438\044F \0437\0430\043F\0440\043E\0441\0430 \0442\0440\0435\0431\0443\0435\0442\0441\044F \043F\0440\0435\0432\044B\0448\0435\043D\0438\0435 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E \0434\043E\043F\0443\0441\0442\0438\043C\044B\0445 \0440\0435\0441\0443\0440\0441\043E\0432. \0418\0437\043C\0435\043D\0438\0442\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0441\0432\043E\0435\0433\043E \043E\0442\0447\0435\0442\0430 \0438 \043F\043E\0432\0442\043E\0440\0438\0442\0435 \043F\043E\043F\044B\0442\043A\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351054203401637)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0434\043B\044F \044D\0442\043E\0433\043E \043E\0442\0447\0435\0442\0430: %0. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\044C\0442\0440, \0447\0442\043E\0431\044B \0443\043C\0435\043D\044C\0448\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441\0435\0439 \0432 \0441\0432\043E\0435\043C \0437\0430\043F\0440\043E\0441\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451988825401711)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0443\043C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452127480401711)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0434\0438\0430\043D\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355052346401640)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0438\043D. \043D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452068708401711)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0443\043C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451005637401710)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0441\044F\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424598982401691)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\043C\0435\0441\044F\0447\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367164552401649)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367033619401649)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432\0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478289037401730)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0441\0442\0430\0442\0438\0447\0435\0441\043A\0438\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043E\0431\043B\0430\0441\0442\0438, \0442\0430\043A \043A\0430\043A \0441\0442\0440\0430\043D\0438\0446\0430 \0441\043E\0434\0435\0440\0436\0438\0442 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0445 \043E\0442\0447\0435\0442\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335517895401626)
,p_name=>'APEXIR_NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362962134401646)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\043E\0432\043E\0435 \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473979525401727)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0437\0434\0430\0442\044C \043A\0430\0442\0435\0433\043E\0440\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114363048268401646)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\043E\0432\043E\0435 \0432\044B\0447\0438\0441\043B\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357846975401642)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360902330401644)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \0434\0435\043D\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360789582401644)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \0447\0430\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361297509401644)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \043C\0435\0441\044F\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361161502401644)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0430\044F \043D\0435\0434\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361007594401644)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114360839855401644)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361491726401645)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0435 %0 \043B\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361335498401644)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \0433\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335823019401626)
,p_name=>'APEXIR_NO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376180695401655)
,p_name=>'APEXIR_NONE'
,p_message_language=>'ru'
,p_message_text=>unistr('- \041D\0435\0442 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423742983401690)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0430\0434\0440\0435\0441 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372620312401653)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\044F Null \0432\0441\0435\0433\0434\0430 \0432 \043D\0430\0447\0430\043B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372549344401653)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\044F Null \0432\0441\0435\0433\0434\0430 \0432 \043A\043E\043D\0446\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373073848401653)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0443\043B\0435\0432\0430\044F \0441\043E\0440\0442\0438\0440\043E\0432\043A\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369470953401651)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0440\0435\043C\044F Flashback \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \0447\0438\0441\043B\043E\0432\044B\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369019561401650)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C \0434\043E\043B\0436\043D\0430 \0431\044B\0442\044C \0447\0438\0441\043B\043E\0432\043E\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373595466401653)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\043F\0435\0440\0430\0442\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334462268401625)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043E\0440\0430\043D\0436\0435\0432\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443327675401704)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0440\0438\0435\043D\0442\0430\0446\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336346465401626)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0440\0443\0433\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319126355401614)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0440\0438\0435\043D\0442\0430\0446\0438\044F \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319818795401614)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0431\043E\043C\043D\0430\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319952061401614)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043D\0438\0436\043D\0430\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319016420401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319648304401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'ru'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319536117401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'ru'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319757998401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0432\044B\0431\043E\0440\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319343589401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'ru'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319231152401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'ru'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114319479389401614)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'ru'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452468875401711)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0442 \043E\0442 \043E\0431\0449\0435\0433\043E \043A\043E\043B\0438\0447\0435\0441\0442\0432\0430 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451655442401710)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0442 \043E\0442 \043E\0431\0449\0435\0439 \0441\0443\043C\043C\044B %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450638097401710)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0442 \043E\0442 \043E\0431\0449\0435\0433\043E \043A\043E\043B\0438\0447\0435\0441\0442\0432\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450556387401710)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0442 \043E\0442 \043E\0431\0449\0435\0439 \0441\0443\043C\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339936366401629)
,p_name=>'APEXIR_PIE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0440\0443\0433\043E\0432\0430\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399801394401673)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\0435\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401344020401674)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0430\0433\0440\0435\0433\0430\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401551395401674)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B \043D\0435 \043C\043E\0436\0435\0442\0435 \0430\0433\0440\0435\0433\0438\0440\043E\0432\0430\0442\044C \0434\0430\043D\043D\044B\0435 \0432 \0441\0442\043E\043B\0431\0446\0435, \0432\044B\0431\0440\0430\043D\043D\043E\043C \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0441\0442\043E\043B\0431\0446\0430 \0441\0442\0440\043E\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400720051401673)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B \0441\0440\0435\0437\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400536789401673)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 \0441\0440\0435\0437\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401103108401674)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0441\0440\0435\0437\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301275100401601)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0434\043B\044F \0437\0430\043F\0440\043E\0441\0430 \0441\0440\0435\0437\0430 \043E\0433\0440\0430\043D\0438\0447\0438\0432\0430\0435\0442 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A \0432 \0431\0430\0437\043E\0432\043E\043C \0437\0430\043F\0440\043E\0441\0435, \0430 \043D\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A. \0412\0430\0448 \0431\0430\0437\043E\0432\044B\0439 \0437\0430\043F\0440\043E\0441 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A (%0). \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\044C\0442\0440, \0447\0442\043E\0431\044B \0443\043C\0435\043D\044C\0448\0438\0442\044C \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0438\0441\0435\0439')
||unistr(' \0432 \0441\0432\043E\0435\043C \0431\0430\0437\043E\0432\043E\043C \0437\0430\043F\0440\043E\0441\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401015119401674)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\043A\0430 \0441\0440\0435\0437\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370458553401651)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 \0441\0440\0435\0437\0430 \0441\043E\0434\0435\0440\0436\0438\0442 \0441\043B\0438\0448\043A\043E\043C \043C\043D\043E\0433\043E \0440\0430\0437\043B\0438\0447\043D\044B\0445 \0437\043D\0430\0447\0435\043D\0438\0439, \043D\0435 \0443\0434\0430\0435\0442\0441\044F \0441\043E\0437\0434\0430\0442\044C SQL-\0437\0430\043F\0440\043E\0441 \0441\0440\0435\0437\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423820961401690)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\044B\0439 \043F\0440\043E\0441\043C\043E\0442\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357904076401642)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114449556430401709)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\043E\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424893512401691)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\043E\0439 \043E\0442\0447\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318908371401614)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0438\0442\044C \0442\0435\0433\0438 \0441\043F\0435\0446\0438\0430\043B\044C\043D\044B\0445 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\0435\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305869112401604)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0444\043E\0440\043C\0430\0442\0438\0440\043E\0432\0430\043D\0438\0435 \0442\0435\043A\0441\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382650947401660)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0430\0441\0442\043D\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340553718401629)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0449\0435\0434\043E\0441\0442\0443\043F\043D\044B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336171065401626)
,p_name=>'APEXIR_RED'
,p_message_language=>'ru'
,p_message_text=>unistr('\043A\0440\0430\0441\043D\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478101536401730)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0430\0442\0438\0447\0435\0441\043A\0438\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043E\0431\043B\0430\0441\0442\0438 %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367283572401649)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367326386401649)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0432\0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473453132401726)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0434\0438\0430\0433\0440\0430\043C\043C\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366850153401649)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0441\043C\0435\043D\0443 \043E\043F\0435\0440\0430\0446\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366513932401648)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0444\0438\043B\044C\0442\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366639372401648)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473563414401726)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366996676401649)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0432\044B\0434\0435\043B\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473634369401727)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \0441\0440\0435\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454614299401713)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0434\0430\043B\0438\0442\044C \043E\0442\0447\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435290959401698)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0438\043C\0435\043D\043E\0432\0430\0442\044C \043E\0442\0447\0435\0442 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376456438401656)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0438\043C\0435\043D\043E\0432\0430\0442\044C \043E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358244295401642)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452591993401711)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332756272401624)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442 \0441 \043F\0441\0435\0432\0434\043E\043D\0438\043C\043E\043C %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382913954401660)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332825345401624)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \0441\043E\0445\0440\0430\043D\0435\043D\043D\043E\0433\043E \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430 %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114374745823401654)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355588829401640)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0438\0434 \043E\0442\0447\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359495073401643)
,p_name=>'APEXIR_RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340721746401630)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E\0441\0441\0442\0430\043D\043E\0432\0438\0442\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335932234401626)
,p_name=>'APEXIR_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448688557401708)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'ru'
,p_message_text=>unistr('ROWID \043D\0435\043B\044C\0437\044F \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0441\0442\043E\043B\0431\0446\0430 \043F\0435\0440\0432\0438\0447\043D\043E\0433\043E \043A\043B\044E\0447\0430 \0434\043B\044F \0438\0441\0442\043E\0447\043D\0438\043A\0430 \0434\0430\043D\043D\044B\0445 REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365901449401648)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425526207401691)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400843634401673)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\044B \0441\0442\0440\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400692114401673)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 \0441\0442\0440\043E\043A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401239508401674)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0441\0442\0440\043E\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401411771401674)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 \0441\0442\0440\043E\043A \0434\043E\043B\0436\0435\043D \043E\0442\043B\0438\0447\0430\0442\044C\0441\044F \043E\0442 \0441\0442\043E\043B\0431\0446\0430 \0441\0440\0435\0437\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380045498401658)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0438\043B\044C\0442\0440 \0441\0442\0440\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355634202401640)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430 %0 \0438\0437 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359652315401643)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0441\0442 \0441\0442\0440\043E\043A\0438 \0441\043E\0434\0435\0440\0436\0438\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335220128401626)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370013664401651)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \043E\0442\0447\0435\0442')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369912855401651)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0435\043D\043D\044B\0439 \043E\0442\0447\0435\0442 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372112450401652)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0443\0449\0438\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430 \0431\0443\0434\0443\0442 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C\0441\044F \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E \0434\043B\044F \0432\0441\0435\0445 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114435129059401698)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C \043E\0442\0447\0435\0442 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114359393930401643)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C \043E\0442\0447\0435\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473833025401727)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C \043E\0442\0447\0435\0442*')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426567645401692)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114364829460401647)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\043D\0435\043B\044C \043F\043E\0438\0441\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114473754323401727)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432064297401696)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A \043E\0442\0447\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416023756401685)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\043D\043D\044B\0435 \0441\0442\043E\043B\0431\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336927815401627)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0440\0430\0442\044C \0441\0442\043E\043B\0431\0435\0446 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358683767401643)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0441\0442\043E\043B\0431\0446\044B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340424157401629)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0440\0430\0442\044C \0444\0443\043D\043A\0446\0438\044E -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365607631401648)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0435\0440\0438\0442\0435 \0433\0440\0443\043F\043F\0443 \043F\043E \0441\0442\043E\043B\0431\0446\0443 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400368834401673)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446 \0441\0440\0435\0437\0430 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451595145401710)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0441\0442\0440\043E\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400481064401673)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('- \0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446 \0441\0442\0440\043E\043A -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309123535401607)
,p_name=>'APEXIR_SEND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043F\0440\0430\0432\0438\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315473883401611)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0434\0430\0442\044C \043F\043E \044D\043B. \043F\043E\0447\0442\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335616265401626)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358863401401643)
,p_name=>'APEXIR_SORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368122394401650)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0432\043E\0437\0440\0430\0441\0442\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368292073401650)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \0443\0431\044B\0432\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454030605401712)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0440\044F\0434\043E\043A \0441\043E\0440\0442\0438\0440\043E\0432\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362605953401646)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\0440\043E\0431\0435\043B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373731599401654)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0430\0442\0443\0441 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424200717401690)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450929847401710)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0430\043D\0447\0438\0432\0430\0435\0442\0441\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305397888401604)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\043F\0443\0441\0442\0438\0442\044C, \0435\0441\043B\0438 \0434\0430\043D\043D\044B\0435 \043D\0435 \043D\0430\0439\0434\0435\043D\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114450847263401710)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0447\0438\043D\0430\0435\0442\0441\044F \0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451722351401710)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0443\043C\043C\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441744376401703)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043B\0430\0441\0442\044C = %0, \043E\0442\0447\0435\0442 = %1, \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 = %2, \043D\0430\0447\0430\043B\043E \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A = %3, \043A\043E\043D\0435\0446 \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A = %4, \0432\0441\0435\0433\043E \0441\0442\0440\043E\043A = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362346044401645)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0433\0438\043E\043D = %0, \043E\0442\0447\0435\0442 = %1, \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 = %2, \043D\0430\0447\0430\043B\043E \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A = %3, \043A\043E\043D\0435\0446 \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0445 \0441\0442\0440\043E\043A = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334519793401625)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0432\0435\0442 \0442\0435\043A\0441\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351650118401637)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351504589401637)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351405893401637)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351802977401638)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351730580401638)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114351919472401638)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043B\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114454452120401712)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043A\043B\044E\0447\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367475744401649)
,p_name=>'APEXIR_TOP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0440\0445\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447643989401707)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0441\0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368947106401650)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \0432\044B\0434\0435\043B\0435\043D\0438\044F \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \0443\043D\0438\043A\0430\043B\044C\043D\044B\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339274417401628)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435\043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\043C\044B\0439 \0442\0438\043F \0434\0430\043D\043D\044B\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367568320401649)
,p_name=>'APEXIR_UP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0432\0435\0440\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369142603401650)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0436\0438\0442\0435 \0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0446\0432\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369279743401650)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0432\0435\0434\0438\0442\0435 \0434\043E\043F\0443\0441\0442\0438\043C\0443\044E \043C\0430\0441\043A\0443 \0444\043E\0440\043C\0430\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114336455985401626)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114368080656401649)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C \043E\0441\0438 \0434\043B\044F \0437\043D\0430\0447\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375881891401655)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0440\0435\0431\0443\0435\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339846618401629)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0435\0440\0442\0438\043A\0430\043B\044C\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114443518371401705)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0432\0435\0440\0442\0438\043A\0430\043B\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375188826401655)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440 \0434\0438\0430\0433\0440\0430\043C\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430381141401695)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0441\0432\0435\0434\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114475986258401728)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \043E\0442\0447\0435\0442\0435 \043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\043E \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430416316401695)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440 \0433\0440\0443\043F\043F\0438\0440\043E\0432\0430\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430281098401695)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\043A\0438 \043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400104726401673)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0441\0440\0435\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114375242476401655)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440 \043E\0442\0447\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424485270401691)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\043D\0435\0434\0435\043B\044C\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358132997401642)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0431\043E\0447\0438\0439 \043E\0442\0447\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453171692401711)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453011748401711)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114452972136401711)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453358688401712)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0435\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453210374401712)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114453403758401712)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0433\043E\0434\0430 (\043B\0435\0442)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114451169486401710)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114334233550401625)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0436\0435\043B\0442\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114335724574401626)
,p_name=>'APEXIR_YES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114367892207401649)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441\043E\0434\0435\0440\0436\0438\0442 < \0438\043B\0438 >, \0430 \044D\0442\043E \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0435 \0441\0438\043C\0432\043E\043B\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114390644473401666)
,p_name=>'APEX_REGION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043B\0430\0441\0442\044C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114318883011401614)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0440\0443\0448\0435\043D\043E \043F\0440\0435\0434\0432\0430\0440\0438\0442\0435\043B\044C\043D\043E\0435 \0443\0441\043B\043E\0432\0438\0435 API')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338364563401628)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \043F\043E\043B\0443\0447\0438\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435 \043F\0430\0440\0430\043C\0435\0442\0440\0430 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F %0, \0442\0430\043A \043A\0430\043A \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0439 \043F\0430\0440\0430\043C\0435\0442\0440 \0441\0431\043E\0440\043A\0438 \043E\0442\043A\043B\044E\0447\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338214331401628)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \0437\0430\0434\0430\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435 \043F\0430\0440\0430\043C\0435\0442\0440\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F %0, \0442\0430\043A \043A\0430\043A \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0438\0439 \043F\0430\0440\0430\043C\0435\0442\0440 \0441\0431\043E\0440\043A\0438 \043E\0442\043A\043B\044E\0447\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445914467401706)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F %0 \043D\0435 \0434\043E\043F\0443\0441\0442\0438\043C\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114445830949401706)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0448\0435\043D\043D\0430\044F \043D\0430\0441\0442\0440\043E\0439\043A\0430 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F %0 \043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446037699401706)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0441\0442\0440\043E\0439\043A\0435 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F %0 \043D\0435\043B\044C\0437\044F \0437\0430\0434\0430\0442\044C \043D\0435\043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 (null).')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326951254401619)
,p_name=>'BACK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313945915401610)
,p_name=>'BUILDER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043C\043F\043E\043D\043E\0432\0449\0438\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378071762401657)
,p_name=>'BUTTON LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\044C \043A\043D\043E\043F\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313048526401609)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043B\0430\0441\0441\044B CSS \043A\043D\043E\043F\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342243045401631)
,p_name=>'BUTTON_ID'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0441\043B\0438 \0441\043E\0437\0434\0430\043D\043D\044B\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043A\043D\043E\043F\043A\0438 \043E\043F\0440\0435\0434\0435\043B\0435\043D, \043E\043D \0431\0443\0434\0435\0442 \0441\0442\0430\0442\0438\0447\0435\0441\043A\0438\043C \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C \043A\043D\043E\043F\043A\0438, \0430 \0435\0441\043B\0438 \043D\0435\0442, \043E\043D \0431\0443\0434\0435\0442 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C \0432\043D\0443\0442\0440\0435\043D\043D\0435\0433\043E \043F\0440\043E\0438\0441\0445\043E\0436\0434\0435\043D\0438\044F \0432 \0444\043E\0440\043C\0430\0442\0435 "B" || [\0412\043D\0443\0442\0440\0435\043D\043D\0438\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043A\043D\043E\043F\043A\0438]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305797810401604)
,p_name=>'CANDLESTICK'
,p_message_language=>'ru'
,p_message_text=>unistr('\042F\043F\043E\043D\0441\043A\0438\0435 \0441\0432\0435\0447\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387274802401663)
,p_name=>'CENTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0446\0435\043D\0442\0440\0443')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337276448401627)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0441 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328678628401621)
,p_name=>'CHECK$'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0435\043B\0435\043A\0442\043E\0440 \0441\0442\0440\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114447794334401708)
,p_name=>'CHECKED'
,p_message_language=>'ru'
,p_message_text=>unistr('\043E\0442\043C\0435\0447\0435\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423203913401690)
,p_name=>'COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383716252401661)
,p_name=>'COMMENTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043C\043C\0435\043D\0442\0430\0440\0438\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365295371401647)
,p_name=>'CONTINUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0434\043E\043B\0436\0438\0442\044C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327294268401620)
,p_name=>'COPYRIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('&copy; %0. \0412\0441\0435 \043F\0440\0430\0432\0430 \0437\0430\0449\0438\0449\0435\043D\044B.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370932193401652)
,p_name=>'COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\0438\0447\0435\0441\0442\0432\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377686696401656)
,p_name=>'CREATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0437\0434\0430\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429953153401695)
,p_name=>'CREATED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0437\0434\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430037619401695)
,p_name=>'CREATED_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0435\043C \0441\043E\0437\0434\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354852031401640)
,p_name=>'CREATED_ON'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 \0441\043E\0437\0434\0430\043D\0438\044F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365460711401648)
,p_name=>'CUSTOM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C\0441\043A\0438\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376641257401656)
,p_name=>'CUSTOMIZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0441\0442\0440\043E\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378256387401657)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B \0441\0442\0440\0430\043D\0438\0446\044B \0441\0431\0440\043E\0448\0435\043D\044B \0434\043B\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378308488401657)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043C\0435\043D\0435\043D\044B \043F\0430\0440\0430\043C\0435\0442\0440\044B \0434\043B\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378177930401657)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B \0441\0442\0440\0430\043D\0438\0446\044B \0441\0431\0440\043E\0448\0435\043D\044B \0434\043B\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341972373401630)
,p_name=>'DAILY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\0434\043D\0435\0432\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114313523151401610)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0436\0435\043D \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0444\0430\0439\043B \0438\043B\0438 \0444\0430\0439\043B \0441 \043D\0435\043F\0440\0430\0432\0438\043B\044C\043D\044B\043C \0440\0430\0441\0448\0438\0440\0435\043D\0438\0435 \0438\043C\0435\043D\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337474616401627)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0441\0435\043B\0435\043A\0442\043E\0440 XML \0438\043B\0438 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306789930401605)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \043F\0440\043E\0444\0438\043B\0435 \0434\0430\043D\043D\044B\0445 \0438 \0437\0430\0433\0440\0443\0436\0435\043D\043D\043E\043C \0444\0430\0439\043B\0435 \043D\0435\0442 \043D\0438 \043E\0434\043D\043E\0433\043E \0441\0442\043E\043B\0431\0446\0430 \0446\0435\043B\0435\0432\043E\0439 \0442\0430\0431\043B\0438\0446\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392438415401667)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0437\0430\0433\0440\0443\0436\0435\043D\043D\043E\043C \0444\0430\0439\043B\0435 \043D\0435\0442 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392565227401667)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \043D\0430\0439\0434\0435\043D\044B \0434\0430\043D\043D\044B\0435 \0432 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \0442\0430\0431\043B\0438\0446\0435 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114312367599401609)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0437\0430\043D \043D\0435 XLSX-\0444\0430\0439\043B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114302742602401602)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430 \0434\0430\043D\043D\044B\0445 \0437\0430\0432\0435\0440\0448\0435\043D\0430. \041E\0431\0440\0430\0431\043E\0442\0430\043D\043E \0441\0442\0440\043E\043A: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303924034401603)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430 \0434\0430\043D\043D\044B\0445 \0437\0430\0432\0435\0440\0448\0435\043D\0430. \041E\0431\0440\0430\0431\043E\0442\0430\043D\043E \0441\0442\0440\043E\043A \0441 1 \043E\0448\0438\0431\043A\043E\0439: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304217037401603)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430 \0434\0430\043D\043D\044B\0445 \0437\0430\0432\0435\0440\0448\0435\043D\0430. \041E\0431\0440\0430\0431\043E\0442\0430\043D\043E \0441\0442\0440\043E\043A: %0, \043E\0448\0438\0431\043E\043A: %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304056395401603)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430 \0434\0430\043D\043D\044B\0445 \0437\0430\0432\0435\0440\0448\0435\043D\0430: \043E\0431\0440\0430\0431\043E\0442\0430\043D\0430 1 \0441\0442\0440\043E\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307055112401605)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430 \0434\0430\043D\043D\044B\0445 \0437\0430\0432\0435\0440\0448\0435\043D\0430: \043E\0431\0440\0430\0431\043E\0442\0430\043D\0430 1 \0441\0442\0440\043E\043A\0430 \0441 \043E\0448\0438\0431\043A\043E\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304134017401603)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\0440\0443\0437\043A\0430 \0434\0430\043D\043D\044B\0445 \0437\0430\0432\0435\0440\0448\0435\043D\0430: \043E\0431\0440\0430\0431\043E\0442\0430\043D\0430 1 \0441\0442\0440\043E\043A\0430 \0431\0435\0437 \043E\0448\0438\0431\043E\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397756918401671)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0426\0435\043B\0435\0432\043E\0439 \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397808393401671)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\0445\043E\0434\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398656515401672)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \0434\0430\0442\044B/\0447\0438\0441\0435\043B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462060176401718)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \043F\043E\043B\0443\0447\0438\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435 \043F\043E\0434\0441\0442\0430\043D\043E\0432\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114430576671401695)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\043F\043E\0441\0442\0430\0432\043B\0435\043D\0438\0435 \0434\0430\043D\043D\044B\0445/\0442\0430\0431\043B\0438\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398725758401672)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394267976401668)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\043E\0439 \043F\0440\0430\0432\0438\043B\0430 \043F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\043D\0438\044F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370565453401651)
,p_name=>'DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344618945401632)
,p_name=>'DAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344777122401633)
,p_name=>'DAYS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0434\043D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383485331401661)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043B\0430\0434\043A\0430 \0434\043B\044F \044D\0442\043E\0433\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \043D\0435 \0432\043A\043B\044E\0447\0435\043D\0430.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114432218064401696)
,p_name=>'DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345440230401633)
,p_name=>'DELETE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0443\0434\0430\043B\0438\0442\044C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114305629805401604)
,p_name=>'DIAL_PCT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\043A\0442\043E\0440\043D\0430\044F (\0432 \043F\0440\043E\0446\0435\043D\0442\0430\0445)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320150412401615)
,p_name=>'DOWNLOAD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0433\0440\0443\0437\0438\0442\044C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431391249401696)
,p_name=>'DUP_USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0443\0431\043B\0438\043A\0430\0442 \0438\043C\0435\043D\0438 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F \0432 \0441\043F\0438\0441\043A\0435.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327728590401620)
,p_name=>'EDIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0430\0432\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337105418401627)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0434\0440\0435\0441 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B "%0" \043D\0435 \043D\0430\0439\0434\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322227007401616)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043F\0440\0430\0432\0438\0442\0435\043B\044C \044D\0442\043E\0433\043E \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0433\043E \043F\0438\0441\044C\043C\0430: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431589802401696)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0434\0440\0435\0441 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B \0441\043B\0438\0448\043A\043E\043C \0434\043B\0438\043D\043D\044B\0439. \041E\0433\0440\0430\043D\0438\0447\0435\043D\0438\0435: 240 \0441\0438\043C\0432\043E\043B\043E\0432.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365149789401647)
,p_name=>'ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394386386401669)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \0443\0441\0442\0430\043D\043E\0432\0438\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435 \0438\0441\0442\043E\0447\043D\0438\043A\0430 \044D\043B\0435\043C\0435\043D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\044B \0434\043B\044F \043E\0431\043B\0430\0441\0442\0438 \0447\0430\0441\0442\0438\0447\043D\043E\0433\043E \043E\0431\043D\043E\0432\043B\0435\043D\0438\044F \0441\0442\0440\0430\043D\0438\0446\044B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356613774401641)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0435\043C \0441\043E\0437\0434\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322541831401616)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0440\043E\043A \0434\0435\0439\0441\0442\0432\0438\044F \043F\0430\0440\043E\043B\044F \0438\0441\0442\0435\043A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114316643791401612)
,p_name=>'FILE_EMPTY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0430\0439\043B \043F\0443\0441\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396823770401670)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\043C\0435\0440 \0437\0430\0433\0440\0443\0436\0435\043D\043D\043E\0433\043E \0444\0430\0439\043B\0430 \043F\0440\0435\0432\044B\0441\0438\043B %0\00A0\041C\0411. \0417\0430\0433\0440\0443\0437\0438\0442\0435 \0444\0430\0439\043B \043C\0435\043D\044C\0448\0435\0433\043E \0440\0430\0437\043C\0435\0440\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324624465401618)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \0432\044B\043F\043E\043B\043D\0438\0442\044C \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\044E \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F. \041E\0434\0438\043D \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0444\0430\0439\043B\043E\0432 \043D\0435 \0437\0430\0433\0440\0443\0436\0435\043D\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324747193401618)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\043E\0442 \044D\043A\0437\0435\043C\043F\043B\044F\0440 \043D\0435 \043F\043E\0437\0432\043E\043B\044F\0435\0442 \0430\0443\0442\0435\043D\0442\0438\0444\0438\0446\0438\0440\043E\0432\0430\043D\043D\044B\043C \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F\043C \0437\0430\0433\0440\0443\0436\0430\0442\044C \0444\0430\0439\043B\044B.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377710670401657)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0438\0437\043E\0448\043B\0430 1 \043E\0448\0438\0431\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376911765401656)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0438\0437\043E\0448\043B\043E \043E\0448\0438\0431\043E\043A: %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327130175401620)
,p_name=>'FORM_OF'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0438\0437 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361879947401645)
,p_name=>'GO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0439\0442\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461680390401718)
,p_name=>'HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314033929401610)
,p_name=>'HOME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043C\0430\0448\043D\044F\044F \0441\0442\0440\0430\043D\0438\0446\0430')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344411407401632)
,p_name=>'HOUR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344532534401632)
,p_name=>'HOURS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0447.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328545101401621)
,p_name=>'ICON'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\043E\043A %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378558076401657)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\0435\0440\043D\044B\0435 \0443\0447\0435\0442\043D\044B\0435 \0434\0430\043D\043D\044B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114478091532401730)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \043F\0430\0440\0430\043C\0435\0442\0440\0430: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373269558401653)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0430\043A \043D\0430\0441\0442\0440\043E\0439\043A\0438 \043E\0442\0447\0435\0442\0430 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373359272401653)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0430\043A \0438\043C\0435\043D\043E\0432\0430\043D\043D\044B\0439 \043E\0442\0447\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355773163401640)
,p_name=>'IR_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 %0 . %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355426497401640)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \0440\0430\0441\0441\0447\0438\0442\0430\0442\044C \043D\0430\0432\0438\0433\0430\0446\0438\044E \043F\043E \0444\043E\0440\043C\0435. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333098001401624)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0439 \043E\0442\0447\0435\0442 \043D\0435 \043D\0430\0439\0434\0435\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332411624401624)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043B\043E\0436\0435\043D\0438\0435 %0, \0441\0442\0440\0430\043D\0438\0446\0430 %1 \0438 \043E\0431\043B\0430\0441\0442\044C %2: \043E\0431\043B\0430\0441\0442\044C \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433\043E \043E\0442\0447\0435\0442\0430 \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114373193703401653)
,p_name=>'IR_STAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0430\0435\0442\0441\044F \0442\043E\043B\044C\043A\043E \0434\043B\044F \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\043E\0432')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361517752401645)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0437\0430\043F\0440\043E\0441\0430 \043E\0442\0447\0435\0442\0430 \0442\0440\0435\0431\0443\0435\0442\0441\044F \0443\043D\0438\043A\0430\043B\044C\043D\044B\0439 \043A\043B\044E\0447, \0447\0442\043E\0431\044B \0438\0434\0435\043D\0442\0438\0444\0438\0446\0438\0440\043E\0432\0430\0442\044C \043A\0430\0436\0434\0443\044E \0441\0442\0440\043E\043A\0443. \041F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\043D\044B\0439 \043A\043B\044E\0447 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D \0434\043B\044F \044D\0442\043E\0433\043E \0437\0430\043F\0440\043E\0441\0430. \041E\043F\0440\0435\0434\0435\043B\0438\0442\0435 \0441\0442\043E\043B\0431\0435\0446 \0443\043D\0438\043A\0430\043B\044C\043D\043E\0433\043E \043A\043B\044E\0447\0430. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361629360401645)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0437\0430\043F\0440\043E\0441\0430 \043E\0442\0447\0435\0442\0430 \0442\0440\0435\0431\0443\0435\0442\0441\044F \0443\043D\0438\043A\0430\043B\044C\043D\044B\0439 \043A\043B\044E\0447, \0447\0442\043E\0431\044B \0438\0434\0435\043D\0442\0438\0444\0438\0446\0438\0440\043E\0432\0430\0442\044C \043A\0430\0436\0434\0443\044E \0441\0442\0440\043E\043A\0443. \041F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\043D\044B\0439 \043A\043B\044E\0447 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D \0434\043B\044F \044D\0442\043E\0433\043E \0437\0430\043F\0440\043E\0441\0430. \0418\0437\043C\0435\043D\0438\0442\0435 \0430\0442\0440\0438\0431\0443\0442\044B \043E\0442\0447\0435\0442\0430, \0447\0442\043E\0431\044B \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0441\0442\043E\043B\0431\0435\0446 \0443\043D\0438\043A\0430\043B\044C\043D\043E\0433\043E \043A\043B\044E\0447\0430. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398954832401672)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0444\0430\0439\043B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398891643401672)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\0442\0430\0449\0438\0442\0435 \0444\0430\0439\043B \0441\044E\0434\0430 \0438\043B\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327482004401620)
,p_name=>'ITEMS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0437\0438\0446\0438\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356848504401641)
,p_name=>'ITEM_VALUE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\043D\0430\0447\0435\043D\0438\0435 \044D\043B\0435\043C\0435\043D\0442\0430')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371262602401652)
,p_name=>'LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0442\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383319346401661)
,p_name=>'LANGUAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\042F\0437\044B\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345169524401633)
,p_name=>'LAST'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\043E\0441\043B.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324501452401618)
,p_name=>'LENGTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\0438\043D\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377804727401657)
,p_name=>'LOGIN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0445\043E\0434')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416405973401685)
,p_name=>'MANAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043F\0440\0430\0432\043B\0435\043D\0438\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481015646401732)
,p_name=>'MAXIMIZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0432\0435\0440\043D\0443\0442\044C')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344241552401632)
,p_name=>'MINUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344324322401632)
,p_name=>'MINUTES'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0438\043D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431747759401696)
,p_name=>'MISSING_AT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0430\0434\0440\0435\0441\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442 "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431975502401696)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0443\043F\0440\0435\0436\0434\0435\043D\0438\0435! \0414\043B\044F \0441\0442\0440\0430\043D\0438\0446\044B \0434\0438\0430\043B\043E\0433\043E\0432\043E\0433\043E \043E\043A\043D\0430 %0 \0432 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0438 %1 \043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D \0448\0430\0431\043B\043E\043D \0441\0442\0440\0430\043D\0438\0446 \0434\0438\0430\043B\043E\0433\043E\0432\043E\0433\043E \043E\043A\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431692793401696)
,p_name=>'MISSING_DOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0434\043E\043C\0435\043D\0435 \0430\0434\0440\0435\0441\0430 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B \043E\0442\0441\0443\0442\0441\0442\0432\0443\0435\0442 ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380844384401659)
,p_name=>'MODULE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\043E\0434\0443\043B\044C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337992316401628)
,p_name=>'MONTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0441\044F\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341787522401630)
,p_name=>'MONTHLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\043C\0435\0441\044F\0447\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338032480401628)
,p_name=>'MONTHS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043C\0435\0441.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370889888401652)
,p_name=>'MOVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438320441401701)
,p_name=>'MOVE_FROM'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0438\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438446770401701)
,p_name=>'MOVE_TO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0440\0435\043C\0435\0441\0442\0438\0442\044C \0432')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114358047203401642)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0432 \043E\043F\0435\0440\0430\0446\0438\0438 \0443\0434\0430\043B\0435\043D\0438\044F \043D\0435\0441\043A\043E\043B\044C\043A\0438\0445 \0441\0442\0440\043E\043A: \0441\0442\0440\043E\043A\0430= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357036842401641)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C \043F\0443\0431\043B\0438\0447\043D\044B\043C \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\043C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314239283401610)
,p_name=>'NAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371049595401652)
,p_name=>'NEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\043E\0432\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337744660401627)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B \043C\043E\0436\0435\0442\0435 \0432\043E\0439\0442\0438 \0432 %0, \043F\0435\0440\0435\0439\0434\044F \043F\043E \0441\043B\0435\0434\0443\044E\0449\0435\043C\0443 \0430\0434\0440\0435\0441\0443:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337876264401627)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0432\0435\0434\043E\043C\043B\0435\043D\0438\0435 \043E \043D\043E\0432\043E\0439 \0443\0447\0435\0442\043D\043E\0439 \0437\0430\043F\0438\0441\0438 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461817770401718)
,p_name=>'NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380791017401659)
,p_name=>'NO'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114476035486401728)
,p_name=>'NOBODY'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0438\043A\0442\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345531243401633)
,p_name=>'NOT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386311502401663)
,p_name=>'NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \043F\0443\0441\0442\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357163690401641)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376729485401656)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0434\0430\043D\043D\044B\0435 \043D\0435 \043D\0430\0439\0434\0435\043D\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385829290401662)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\043B\044F\0435\043C\044B\0439 \043E\0442\0447\0435\0442 \043D\0435 \043D\0430\0439\0434\0435\043D. \041E\043F\0435\0440\0430\0446\0438\0438 \043E\0431\043D\043E\0432\043B\0435\043D\0438\044F \0438 \0443\0434\0430\043B\0435\043D\0438\044F \043D\0435\0441\043A\043E\043B\044C\043A\0438\0445 \0441\0442\0440\043E\043A \043C\043E\0433\0443\0442 \0432\044B\043F\043E\043B\043D\044F\0442\044C\0441\044F \0442\043E\043B\044C\043A\043E \0432 \0442\0430\0431\043B\0438\0447\043D\044B\0445 \0444\043E\0440\043C\0430\0445 \0442\0438\043F\0430 "\041E\0431\043D\043E\0432\043B\044F\0435\043C\044B\0439 \043E\0442\0447\0435\0442".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386755281401663)
,p_name=>'OK'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\041A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382499815401660)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'ru'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114479891058401731)
,p_name=>'ORA_06550'
,p_message_language=>'ru'
,p_message_text=>unistr('ORA-06550: \0441\0442\0440\043E\043A\0430 %0, \0441\0442\043E\043B\0431\0435\0446 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429396044401694)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0443\0441\0442\0430\0440\0435\0432\0448\0438\0439 \0432\0435\0431-\0431\0440\0430\0443\0437\0435\0440. \0421\043F\0438\0441\043E\043A \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\043C\044B\0445 \0431\0440\0430\0443\0437\0435\0440\043E\0432 \0441\043C. \0432 \0420\0443\043A\043E\0432\043E\0434\0441\0442\0432\0435 \043F\043E \0443\0441\0442\0430\043D\043E\0432\043A\0435 Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330792528401622)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0448\0435\043D \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \043D\0430\0431\043E\0440 \0441\0442\0440\043E\043A, \0438\0441\0445\043E\0434\043D\044B\0435 \0434\0430\043D\043D\044B\0435 \043E\0442\0447\0435\0442\0430 \0438\0437\043C\0435\043D\0435\043D\044B.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350840413401637)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \043D\043E\043C\0435\0440 \0441\0442\0440\0430\043D\0438\0446\044B, \043D\0430\043F\0440\0438\043C\0435\0440 p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354472856401640)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043B\0435\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354566454401640)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043B\0435\0434\0443\044E\0449\0438\0439 \043D\0430\0431\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354652844401640)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114354781284401640)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\044B\0434\0443\0449\0438\0439 \043D\0430\0431\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461734201401718)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0440\0430\0437\0431\0438\0432\043A\0443 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392378999401667)
,p_name=>'PASSWORD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337078315401627)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0430\0448 \043F\0430\0440\043E\043B\044C \0434\043B\044F %0 \0438\0437\043C\0435\043D\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326839077401619)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \043D\0435 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\0435\0442 \043F\0440\0430\0432\0438\043B\0430\043C \0441\043B\043E\0436\043D\043E\0441\0442\0438 \043F\0430\0440\043E\043B\0435\0439 \044D\0442\043E\0433\043E \0441\0430\0439\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325935026401619)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\043E\0432\044B\0439 \043F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \043E\0442\043B\0438\0447\0430\0442\044C\0441\044F \043E\0442 \0441\0442\0430\0440\043E\0433\043E \043F\0430\0440\043E\043B\044F \043A\0430\043A \043C\0438\043D\0438\043C\0443\043C \043D\0430 %0 \0441\0438\043C\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326560167401619)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \043D\0435 \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0438\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326730438401619)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0441\043E\0434\0435\0440\0436\0438\0442 \0437\0430\043F\0440\0435\0449\0435\043D\043D\043E\0435 \043F\0440\043E\0441\0442\043E\0435 \0441\043B\043E\0432\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326678838401619)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \043D\0435 \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0438\043C\044F \0440\0430\0431\043E\0447\0435\0439 \043E\0431\043B\0430\0441\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325810785401619)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \043D\0435 \043C\0435\043D\0435\0435 %0 \0441\0438\043C\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326040138401619)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0445\043E\0442\044F \0431\044B \043E\0434\0438\043D \0431\0443\043A\0432\0435\043D\043D\044B\0439 \0441\0438\043C\0432\043E\043B (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326432159401619)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0445\043E\0442\044F \0431\044B \043E\0434\043D\0443 \0441\0442\0440\043E\0447\043D\0443\044E \0431\0443\043A\0432\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326109783401619)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0445\043E\0442\044F \0431\044B \043E\0434\043D\0443 \0446\0438\0444\0440\0443 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326219906401619)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0445\043E\0442\044F \0431\044B \043E\0434\0438\043D \0437\043D\0430\043A \043F\0440\0435\043F\0438\043D\0430\043D\0438\044F (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114326364215401619)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C \0434\043E\043B\0436\0435\043D \0441\043E\0434\0435\0440\0436\0430\0442\044C \0445\043E\0442\044F \0431\044B \043E\0434\043D\0443 \043F\0440\043E\043F\0438\0441\043D\0443\044E \0431\0443\043A\0432\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337533216401627)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0432\0435\0434\043E\043C\043B\0435\043D\0438\0435 \043E \0441\0431\0440\043E\0441\0435 \043F\0430\0440\043E\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324894794401618)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \043F\0430\0440\043E\043B\044C, \0442\0430\043A \043A\0430\043A \043E\043D \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043B\0441\044F \043F\043E\0441\043B\0435\0434\043D\0438\0435 %0 \0434\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405108681401677)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0437\0438\0446\0438\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114405262371401677)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043C\0435\043D\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382286415401660)
,p_name=>'PERCENT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352563770401638)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114461990740401718)
,p_name=>'PREVIOUS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397330652401671)
,p_name=>'PRINT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0435\0447\0430\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381063014401659)
,p_name=>'PRIVILEGES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\043D\043E\043C\043E\0447\0438\044F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350961477401637)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0441\044B\043B\043A\0438 \043D\0430 \043E\0431\043B\0430\0441\0442\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371158019401652)
,p_name=>'REPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380923244401659)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442\043D\044B\0439 \043F\0435\0440\0438\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462103368401718)
,p_name=>'REPORT_LABEL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0447\0435\0442: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381627731401659)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0442\043E\0433\043E \043F\043E \043E\0442\0447\0435\0442\0443')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330833568401622)
,p_name=>'RESET'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C \0440\0430\0437\0431\0438\0432\043A\0443 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356781986401641)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C \0440\0430\0437\0431\0438\0432\043A\0443 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385772829401662)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0431\0440\043E\0441\0438\0442\044C \043F\0430\0440\043E\043B\044C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362516620401645)
,p_name=>'RESTORE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E\0441\0441\0442\0430\043D\043E\0432\0438\0442\044C')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114394462263401669)
,p_name=>'RESULTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\044C\0442\0430\0442\044B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386821780401663)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0435\0440\043D\0438\0442\0435\0441\044C \043A \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114387163128401663)
,p_name=>'RIGHT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416758726401685)
,p_name=>'ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0440\043E\043A\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370705139401651)
,p_name=>'ROW_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0438\0441\043B\043E \0441\0442\0440\043E\043A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114386280821401663)
,p_name=>'SAVE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0445\0440\0430\043D\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382837692401660)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\043B\044C\0442\0435\0440\043D\0430\0442\0438\0432\043D\044B\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383200345401661)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\043F\0438\0441\0430\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382754996401660)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0441\043D\043E\0432\043D\043E\0439 \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383574309401661)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0441\0442\0443\043F\043D\043E \0441\0442\0440\043E\043A: \0431\043E\043B\0435\0435 %0. \0423\0432\0435\043B\0438\0447\044C\0442\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441 \043F\043E\043C\043E\0449\044C\044E \0441\0435\043B\0435\043A\0442\043E\0440\0430 \0441\0442\0440\043E\043A, \0447\0442\043E\0431\044B \043F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0431\043E\043B\044C\0448\0435 \0441\0442\0440\043E\043A.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448989185401708)
,p_name=>'SEARCH'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0438\0441\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344166926401632)
,p_name=>'SECONDS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0435\043A.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382360706401660)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043C. \0432\043B\043E\0436\0435\043D\0438\044F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440010891401702)
,p_name=>'SELECT_ROW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0431\0440\0430\0442\044C \0441\0442\0440\043E\043A\0443')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382022411401660)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043A\043B\044E\0447\0438\0442\044C \0440\0435\0436\0438\043C \0447\0442\0435\043D\0438\044F \0441 \044D\043A\0440\0430\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382116092401660)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\044E\0447\0438\0442\044C \0440\0435\0436\0438\043C \0447\0442\0435\043D\0438\044F \0441 \044D\043A\0440\0430\043D\0430')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378458780401657)
,p_name=>'SHOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441882915401703)
,p_name=>'SHOW_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043A\0430\0437\0430\0442\044C \0432\0441\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114467966609401722)
,p_name=>'SIGN_IN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0445\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114417590551401686)
,p_name=>'SIGN_OUT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0439\0442\0438')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371790983401652)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0434\043D. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378930251401657)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0434\043D. \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371685275401652)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0447. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378867384401657)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0447. \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371582560401652)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0438\043D. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378788810401657)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0438\043D. \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371932259401652)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0435\0441. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379182471401658)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043C\0435\0441. \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379381755401658)
,p_name=>'SINCE_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\0439\0447\0430\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371462557401652)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441 \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114378666123401657)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0441 \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114371866294401652)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435\0434. \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379044118401658)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \043D\0435\0434. \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114372035653401652)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0433\043E\0434\0430 (\043B\0435\0442) \043D\0430\0437\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379270733401658)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 \0433\043E\0434\0430 (\043B\0435\0442) \043E\0442 \0442\0435\043A\0443\0449\0435\0433\043E \043C\043E\043C\0435\043D\0442\0430')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365584715401648)
,p_name=>'STANDARD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\0430\043D\0434\0430\0440\0442')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381928741401660)
,p_name=>'START_DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\0442\0430 \043D\0430\0447\0430\043B\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322402894401616)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\043E \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0435 \043F\0438\0441\044C\043C\043E \0432\044B \043F\043E\043B\0443\0447\0430\0435\0442\0435 \043F\043E \043F\043E\0434\043F\0438\0441\043A\0435 \043D\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\044B\0435 \043E\0442\0447\0435\0442\044B, \0441\043E\0437\0434\0430\043D\043D\043E\0439 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\043C %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477113108401729)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0434\043F\0438\0441\043A\0438')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425236564401691)
,p_name=>'TAB'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043A\043B\0430\0434\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344001482401632)
,p_name=>'TITLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\0433\043E\043B\043E\0432\043E\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327053805401620)
,p_name=>'TODAY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\0433\043E\0434\043D\044F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381578530401659)
,p_name=>'TOTAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0442\043E\0433\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328081034401620)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0446\043E\0432 \0434\043B\044F \0432\044B\0431\043E\0440\0430 \2014 \043D\0435 \0431\043E\043B\0435\0435 %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306510852401605)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0440\043D\0443\0442\044C \0432\0441\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306840432401605)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0432\0435\0440\043D\0443\0442\044C \0432\0441\0435 \043D\0438\0436\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306489375401605)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0432\0435\0440\043D\0443\0442\044C \0432\0441\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306630820401605)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0441\043A\0440\044B\0442\044C \0432\0441\0435 \043D\0438\0436\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306935756401605)
,p_name=>'TREE.REPARENT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421 \0438\0437\043C\0435\043D\0435\043D\043D\044B\043C \0440\043E\0434\0438\0442\0435\043B\0435\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399197715401672)
,p_name=>'TREES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0435\0440\0435\0432\044C\044F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114442696304401704)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\044F\0437\0430\0442\0435\043B\044C\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114366229382401648)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0411\0435\0437 \0440\0430\0437\0440\0435\0448\0435\043D\0438\044F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114413056811401682)
,p_name=>'UNAVAILABLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\0441\0442\0443\043F\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379770979401658)
,p_name=>'UNKNOWN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0438\0437\0432\0435\0441\0442\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323303221401617)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0440\0430\0441\043F\043E\0437\043D\0430\043D\043D\0430\044F \043E\0448\0438\0431\043A\0430 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325307417401618)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0442\043E\0431\044B \0431\043E\043B\044C\0448\0435 \043D\0435 \043F\043E\043B\0443\0447\0430\0442\044C \044D\043B\0435\043A\0442\0440\043E\043D\043D\044B\0435 \043F\0438\0441\044C\043C\0430, \043D\0430\0436\043C\0438\0442\0435 <a href="%0">\043E\0442\043A\0430\0437\0430\0442\044C\0441\044F \043E\0442 \043F\043E\0434\043F\0438\0441\043A\0438</a>, \0447\0442\043E\0431\044B \043F\0435\0440\0435\0439\0442\0438 \043A \0443\043F\0440\0430\0432\043B\0435\043D\0438\044E \0441\0432\043E\0435\0439 \043F\043E\0434\043F\0438\0441\043A\043E\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114322315480401616)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0427\0442\043E\0431\044B \0431\043E\043B\044C\0448\0435 \043D\0435 \043F\043E\043B\0443\0447\0430\0442\044C \0442\0430\043A\0438\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\044B\0435 \043F\0438\0441\044C\043C\0430, \043F\0435\0440\0435\0439\0434\0438\0442\0435 \043A \0443\043F\0440\0430\0432\043B\0435\043D\0438\044E \0441\0432\043E\0435\0439 \043F\043E\0434\043F\0438\0441\043A\043E\0439 \043F\043E \0441\043B\0435\0434\0443\044E\0449\0435\043C\0443 \0430\0434\0440\0435\0441\0443:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114357217660401642)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435\043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\043C\044B\0439 \0442\0438\043F \0434\0430\043D\043D\044B\0445')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345398286401633)
,p_name=>'UPDATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\043E\0431\043D\043E\0432\0438\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343969215401632)
,p_name=>'UPDATED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\043B\0435\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350662465401637)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0448\0435\043D\043D\044B\0439 URL-\0430\0434\0440\0435\0441 \0437\0430\043F\0440\0435\0449\0435\043D. \041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0441\0432\043E\0435\043C\0443 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114370675491401651)
,p_name=>'USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114392257119401667)
,p_name=>'USERNAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431843491401696)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F \0441\043B\0438\0448\043A\043E\043C \0434\043B\0438\043D\043D\043E\0435. \041E\0433\0440\0430\043D\0438\0447\0435\043D\0438\0435: %0 \0441\0438\043C\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377448385401656)
,p_name=>'USERS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114431409969401696)
,p_name=>'USER_EXISTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F \0443\0436\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114446137584401706)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0437\043E\0431\0440\0430\0436\0435\043D\0438\0435 \043F\0440\043E\0444\0438\043B\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333747650401625)
,p_name=>'VALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043F\0443\0441\0442\0438\043C\044B\0439')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327366844401620)
,p_name=>'VALIDATIONS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0432\0435\0440\043A\0438')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383068575401660)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043B\0436\043D\043E \0431\044B\0442\044C \0443\043A\0430\0437\0430\043D\043E \0437\043D\0430\0447\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426417899401692)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F %0 \0434\043E\043B\0436\043D\043E \0431\044B\0442\044C \0443\043A\0430\0437\0430\043D\043E \0437\043D\0430\0447\0435\043D\0438\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352972469401638)
,p_name=>'VERTICAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\043E \0432\0435\0440\0442\0438\043A\0430\043B\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345249161401633)
,p_name=>'VIEW'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377515528401656)
,p_name=>'VIEWS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\0440\0435\0434\0441\0442\0430\0432\043B\0435\043D\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383800419401661)
,p_name=>'VIEW_ALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0441\043C\043E\0442\0440 \0432\0441\0435\0445')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114365000839401647)
,p_name=>'WARNING'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0434\0443\043F\0440\0435\0436\0434\0435\043D\0438\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344898941401633)
,p_name=>'WEEK'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341853943401630)
,p_name=>'WEEKLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0415\0436\0435\043D\0435\0434\0435\043B\044C\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114344913794401633)
,p_name=>'WEEKS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043D\0435\0434.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114383114294401660)
,p_name=>'WELCOME_USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0431\0440\043E \043F\043E\0436\0430\043B\043E\0432\0430\0442\044C: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381316957401659)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0439\0434\0435\043D\043E \043D\0435\0432\0435\0440\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435, \043F\0440\043E\0432\0435\0440\044C\0442\0435 \0432\0432\0435\0434\0435\043D\043D\044B\0435 \0434\0430\043D\043D\044B\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381434056401659)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0439\0434\0435\043D\043E \043D\0435\0432\0435\0440\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435, \043F\0440\043E\0432\0435\0440\044C\0442\0435 \0432\0432\0435\0434\0435\043D\043D\044B\0435 \0434\0430\043D\043D\044B\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324408743401618)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0439\0434\0435\043D\043E \043D\0435\0432\0435\0440\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \0434\0430\0442\044B, \043F\0440\043E\0432\0435\0440\044C\0442\0435 \0444\043E\0440\043C\0430\0442 \0434\0430\0442\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114381256854401659)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0439\0434\0435\043D\043E \043D\0435\0432\0435\0440\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \043D\043E\043C\0435\0440\0430, \043F\0440\043E\0432\0435\0440\044C\0442\0435 \0444\043E\0440\043C\0430\0442 \043D\043E\043C\0435\0440\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333379963401624)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0430\0439\0434\0435\043D\043E \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \043C\0435\0442\043A\0438 \0432\0440\0435\043C\0435\043D\0438. \041F\0440\043E\0432\0435\0440\044C\0442\0435 \0444\043E\0440\043C\0430\0442 \043C\0435\0442\043A\0438 \0432\0440\0435\043C\0435\043D\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114355849816401641)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \0441\0432\044F\0437\0430\0442\044C "%0". \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0434\0432\043E\0439\043D\044B\0435 \043A\0430\0432\044B\0447\043A\0438 \0434\043B\044F \043C\043D\043E\0433\043E\0431\0430\0439\0442\043E\0432\044B\0445 \044D\043B\0435\043C\0435\043D\0442\043E\0432 \0438\043B\0438 \0443\0431\0435\0434\0438\0442\0435\0441\044C, \0447\0442\043E \0434\043B\0438\043D\0430 \044D\043B\0435\043C\0435\043D\0442\0430 \043D\0435 \043F\0440\0435\0432\044B\0448\0430\0435\0442 30 \0431\0430\0439\0442. \0418\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \0441\0438\043D\0442\0430\043A\0441\0438\0441 v(), \0447\0442\043E\0431\044B \0441\0441\044B\043B\0430\0442\044C\0441\044F \043D\0430 \044D\043B\0435\043C\0435\043D\0442\044B \0434\043B\0438\043D\043E\0439 \0431\043E\043B\0435\0435 30 \0431\0430\0439\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346329769401634)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0440\0435\0437\0443\043B\044C\0442\0430\0442\0435 \043F\0440\043E\0432\0435\0440\043A\0438 \0431\0435\0437\043E\043F\0430\0441\043D\043E\0441\0442\0438 %0 \043E\0442\043A\0430\0437\0430\043D\043E \0432 \0434\043E\0441\0442\0443\043F\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348857667401636)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \043D\0435 \0434\043E\0441\0442\0443\043F\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347228136401634)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1014 \041F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \043D\0435 \043D\0430\0439\0434\0435\043D\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347352355401634)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\043F\0440\0438\043B\043E\0436\0435\043D\0438\0435=%0 \0440\0430\0431\043E\0447\0430\044F \043E\0431\043B\0430\0441\0442\044C=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347706189401635)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0441\0442\0443\043F \043A \044D\0442\043E\043C\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E \043E\0433\0440\0430\043D\0438\0447\0435\043D. \041F\043E\0432\0442\043E\0440\0438\0442\0435 \043F\043E\043F\044B\0442\043A\0443 \043F\043E\0437\0436\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347622818401635)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\0441\0442\0443\043F \043A \044D\0442\043E\043C\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E \043E\0433\0440\0430\043D\0438\0447\0435\043D \0438 \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\044F\0435\0442\0441\044F \0442\043E\043B\044C\043A\043E \0440\0430\0437\0440\0430\0431\043E\0442\0447\0438\043A\0430\043C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F. \041F\043E\0432\0442\043E\0440\0438\0442\0435 \043F\043E\043F\044B\0442\043A\0443 \043F\043E\0437\0436\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346859196401634)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-7744 \041D\0435 \0443\0434\0430\043B\043E\0441\044C \043E\0431\0440\0430\0431\043E\0442\0430\0442\044C \0432\0435\0442\0432\044C \0434\043B\044F \0444\0443\043D\043A\0446\0438\043E\043D\0438\0440\043E\0432\0430\043D\0438\044F URL-\0430\0434\0440\0435\0441\0430 \0432\043E\0437\0432\0440\0430\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346707210401634)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-7744 \041D\0435 \0443\0434\0430\043B\043E\0441\044C \043E\0431\0440\0430\0431\043E\0442\0430\0442\044C \0432\0435\0442\0432\044C \0434\043B\044F \0444\0443\043D\043A\0446\0438\043E\043D\0438\0440\043E\0432\0430\043D\0438\044F \0441\0442\0440\0430\043D\0438\0446\044B \0432\043E\0437\0432\0440\0430\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347007204401634)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1430 \0412\044B\0437\043E\0432 \043E\0442\043E\0431\0440\0430\0436\0435\043D\0438\044F \0438\0437 \043F\0440\043E\0446\0435\0441\0441\0430 \0441\0442\0440\0430\043D\0438\0446\044B \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348147185401635)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1018 \041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0447\0438\0441\0442\043A\0435 \043A\044D\0448\0430 \0448\0430\0433\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346546804401634)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1005 \041D\0435\0438\0437\0432\0435\0441\0442\043D\044B\0439 \0442\0438\043F \0432\044B\0447\0438\0441\043B\0435\043D\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347454907401635)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1201 \041F\0440\0438 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044C\0441\043A\043E\0439 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438 \043D\0435 \0437\0430\0434\0430\043D \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \0441\0435\0430\043D\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347567409401635)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0442\0440\0430\043D\0438\0446\0430=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114347102384401634)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-7620 \041D\0435 \0443\0434\0430\043B\043E\0441\044C \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0440\0430\0431\043E\0447\0443\044E \043E\0431\043B\0430\0441\0442\044C \0434\043B\044F \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329568404401621)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0430\0432\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346246556401634)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1802 \041D\0435 \0443\0434\0430\043B\043E\0441\044C \043D\0430\0439\0442\0438 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043F\043E\0437\0438\0446\0438\0438 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345903124401633)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1002 \041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \043D\0430\0439\0442\0438 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \043F\043E\0437\0438\0446\0438\0438 "%0" \0432 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0438 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346061919401633)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043F\0440\0435\0434\0432\0438\0434\0435\043D\043D\0430\044F \043E\0448\0438\0431\043A\0430. \041D\0435 \0443\0434\0430\043B\043E\0441\044C \043D\0430\0439\0442\0438 \0438\043C\044F \043F\043E\0437\0438\0446\0438\0438 \043D\0430 \0443\0440\043E\0432\043D\0435 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \0438\043B\0438 \0441\0442\0440\0430\043D\0438\0446\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346460787401634)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B \0443\0436\0435 \043D\0430\0445\043E\0434\0438\0442\0435\0441\044C \043D\0430 \043F\0435\0440\0432\043E\0439 \0441\0442\0440\0430\043D\0438\0446\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114361998600401645)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \044D\043B\0435\043C\0435\043D\0442\0430 (%0) \043D\0435 \044F\0432\043B\044F\0435\0442\0441\044F \044D\043B\0435\043C\0435\043D\0442\043E\043C, \043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\043C \043D\0430 \0442\0435\043A\0443\0449\0435\0439 \0441\0442\0440\0430\043D\0438\0446\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324009603401617)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C \044D\043B\0435\043C\0435\043D\0442, \043F\0435\0440\0435\0434\0430\0432 \0430\0440\0433\0443\043C\0435\043D\0442\044B \0434\0430\043D\043D\043E\043C\0443 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324305725401618)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'ru'
,p_message_text=>unistr('(\041A\043E\043D\0442\0440\043E\043B\044C\043D\0430\044F \0441\0443\043C\043C\0430 \043D\0435 \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323853630401617)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043C\0435\043D\0442 \043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C, \0435\0441\043B\0438 \043E\043D \0441\043E\043F\0440\043E\0432\043E\0436\0434\0430\0435\0442\0441\044F \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\043E\0439 "\0437\0430\043A\043B\0430\0434\043A\0430 \043D\0430 \0443\0440\043E\0432\043D\0435 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323786562401617)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043C\0435\043D\0442 \043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C, \0435\0441\043B\0438 \043E\043D \0441\043E\043F\0440\043E\0432\043E\0436\0434\0430\0435\0442\0441\044F \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\043E\0439 "\0437\0430\043A\043B\0430\0434\043A\0430 \043D\0430 \0443\0440\043E\0432\043D\0435 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323925306401617)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043C\0435\043D\0442 \043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C, \0435\0441\043B\0438 \043E\043D \0441\043E\043F\0440\043E\0432\043E\0436\0434\0430\0435\0442\0441\044F \043A\043E\043D\0442\0440\043E\043B\044C\043D\043E\0439 \0441\0443\043C\043C\043E\0439 "\0441\0435\0430\043D\0441".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323669839401617)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043C\0435\043D\0442 \043D\0435 \0437\0430\0449\0438\0449\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348279629401635)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0440\0430\0432\043A\0430 \043F\043E \0441\0442\0440\0430\043D\0438\0446\0435 \043D\0435\0434\043E\0441\0442\0443\043F\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114337355804401627)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0440\0430\0431\043E\0447\0435\0439 \043E\0431\043B\0430\0441\0442\0438 %0 \043D\0435\0442 \043F\0440\0430\0432 \0434\043B\044F \0430\043D\0430\043B\0438\0437\0430 \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0441\0445\0435\043C\044B %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346679036401634)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1010 \0412\0435\0442\0432\044C \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443 \043F\0440\0438\043D\0438\043C\0430\0435\0442 \043F\0440\0435\0432\044B\0448\0435\043D\0438\0435 \043F\0440\0435\0434\0435\043B\0430 \0440\0435\043A\0443\0440\0441\0438\0438 \043E\0431\0440\0430\0431\043E\0442\043A\0438. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324279924401618)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\0443 \0441\0442\0440\0430\043D\0438\0446\0443 \043D\0435\043B\044C\0437\044F \0432\044B\0437\0432\0430\0442\044C \0432 \0434\0435\043C\043E\043D\0441\0442\0440\0430\0446\0438\043E\043D\043D\043E\0439 \043F\0440\043E\0446\0435\0434\0443\0440\0435 \0441 \043F\043E\043C\043E\0449\044C\044E URL-\0430\0434\0440\0435\0441\0430 \0438\043B\0438 \043A\043E\043C\0430\043D\0434\044B GET/POST, \043E\043D\0430 \0434\043E\043B\0436\043D\0430 \0432\044B\0437\044B\0432\0430\0442\044C\0441\044F \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C \0442\0438\043F\0430 \0432\0435\0442\0432\043B\0435\043D\0438\044F "\0412\0435\0442\0432\044C \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114400960446401673)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043F\043E\043F\044B\0442\043A\0435 \0441\043E\0445\0440\0430\043D\0438\0442\044C \043D\0435\0447\0438\0441\043B\043E\0432\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \0432 \044D\043B\0435\043C\0435\043D\0442\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339004643401628)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0445\0435\043C\044B \0430\043D\0430\043B\0438\0437\0430 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F "%0" \043D\0435\0442 \0432 \0431\0430\0437\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114339129796401628)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\0447\0435\0442\043D\044B\0435 \0437\0430\043F\0438\0441\0438 \0432\043E \0412\041D\0423\0422\0420\0415\041D\041D\0415\0419 \0440\0430\0431\043E\0447\0435\0439 \043E\0431\043B\0430\0441\0442\0438 \043C\043E\0436\043D\043E \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0442\043E\043B\044C\043A\043E \0434\043B\044F \0434\043E\0441\0442\0443\043F\0430 \043A &PRODUCT_NAME. <a href="%0">\0421\043B\0443\0436\0431\044B \0430\0434\043C\0438\043D\0438\0441\0442\0440\0438\0440\043E\0432\0430\043D\0438\044F</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345814990401633)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-1029 \041D\0435 \0443\0434\0430\0435\0442\0441\044F \0441\043E\0445\0440\0430\043D\0438\0442\044C \0438\043D\0444\043E\0440\043C\0430\0446\0438\044E \043E \0441\0435\0430\043D\0441\0435. \0421\0435\0430\043D\0441=%0, \043F\043E\0437\0438\0446\0438\044F=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348986144401636)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \043E\0441\0442\0430\043D\043E\0432\0438\0442\044C \0442\0440\0430\0441\0441\0438\0440\043E\0432\043A\0443: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114346113591401634)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\043F\0440\0435\0434\0432\0438\0434\0435\043D\043D\0430\044F \043E\0448\0438\0431\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356153569401641)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0432 update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349065242401636)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \043F\0440\043E\0441\043C\043E\0442\0440\0430 \0441\043F\0440\0430\0432\043A\0438 \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \043F\0440\0435\0434\043E\0441\0442\0430\0432\0438\0442\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\0435 \0438 \0441\0442\0440\0430\043D\0438\0446\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114369581980401651)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0410\0432\0442\043E\043C\0430\0442\0438\0437\0430\0446\0438\044F \043D\0435 \043D\0430\0439\0434\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350192495401636)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0447\0438\0449\0435\043D\043E \0441\0435\0430\043D\0441\043E\0432: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309407022401607)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \0432\044B\043F\043E\043B\043D\0438\0442\044C \043A\043E\0434 %0! \041E\043D \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0431\0430\0437\043E\0439 \0434\0430\043D\043D\044B\0445 \0438\043B\0438 \043D\0435 \0432\043A\043B\044E\0447\0435\043D \043F\0430\0440\0430\043C\0435\0442\0440\043E\043C \044D\043A\0437\0435\043C\043F\043B\044F\0440\0430 MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114309251810401607)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\043D\043E\0433\043E\044F\0437\044B\0447\043D\043E\0435 \044F\0434\0440\043E \043D\0435 \0434\043E\0441\0442\0443\043F\043D\043E \0432 \044D\0442\043E\0439 \0432\0435\0440\0441\0438\0438 \0431\0430\0437\044B \0434\0430\043D\043D\044B\0445!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330038539401622)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\0441\0441\0438\0432 \043A\043E\043B\043B\0435\043A\0446\0438\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \043D\0435 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C \043D\0435\043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\043C (null)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329823286401622)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0437\0430\043D\043D\044B\0439 \043D\043E\043C\0435\0440 \0430\0442\0440\0438\0431\0443\0442\0430 \044D\043B\0435\043C\0435\043D\0442\0430 %0 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C. \041D\043E\043C\0435\0440 \0430\0442\0440\0438\0431\0443\0442\0430 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C \0432 \0434\0438\0430\043F\0430\0437\043E\043D\0435 \043E\0442 1 \0434\043E %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330376187401622)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\043B\0435\043A\0446\0438\044F \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330112765401622)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043A\043E\043B\043B\0435\043A\0446\0438\0438 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \043D\0435\043E\043F\0440\0435\0434\0435\043B\0435\043D\043D\044B\043C (null)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330280904401622)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043A\043E\043B\043B\0435\043A\0446\0438\0438 \043C\043E\0436\0435\0442 \0441\043E\0434\0435\0440\0436\0430\0442\044C \043D\0435 \0431\043E\043B\0435\0435 255 \0441\0438\043C\0432\043E\043B\043E\0432')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329677245401622)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\043E\043B\043B\0435\043A\0446\0438\044F \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330441427401622)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0443\0440\0441\043E\0440 \0435\0449\0435 \043D\0435 \043E\0442\043A\0440\044B\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329769435401622)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C \044D\043B\0435\043C\0435\043D\0442\043E\0432 %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0432 \043A\043E\043B\043B\0435\043A\0446\0438\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114329973019401622)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\043E\0432\0430\0442\0435\043B\044C\043D\043E\0441\0442\044C \044D\043B\0435\043C\0435\043D\0442\043E\0432 %0 \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0432 \043A\043E\043B\043B\0435\043A\0446\0438\0438 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0439 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401787601401674)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041A\0440\0438\043F\0442\043E\0433\0440\0430\0444\0438\0447\0435\0441\043A\0430\044F \0444\0443\043D\043A\0446\0438\044F "%0" \0432 \044D\0442\043E\0439 \0441\0438\0441\0442\0435\043C\0435 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455298679401713)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0435\0446\0438\0430\043B\044C\043D\044B\0435 \0432\043E\0437\043C\043E\0436\043D\043E\0441\0442\0438 \043F\0440\043E\0432\0435\0440\0435\043D\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349655976401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043A\0440\044B\0442\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349742012401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\044B \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349830479401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349962752401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350005034401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043A\0440\044B\0442\044B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349446491401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\043E\0432\0435\0440\044C\0442\0435 \043E\0431\043B\0430\0441\0442\0438, \043A\043E\0442\043E\0440\044B\0435 \0432\044B \0445\043E\0442\0438\0442\0435 \0432\043A\043B\044E\0447\0438\0442\044C \0432 \044D\0442\0443 \0441\0442\0440\0430\043D\0438\0446\0443. \041E\0442\043C\0435\0447\0435\043D\043D\044B\0435 \043E\0431\043B\0430\0441\0442\0438 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F, \0442\043E\043B\044C\043A\043E \043A\043E\0433\0434\0430 \0432\044B \043D\0430\0445\043E\0434\0438\0442\0435\0441\044C \0432 \0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0443\044E\0449\0435\043C \043A\043E\043D\0442\0435\043A\0441\0442\0435 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \0438 \043E\0431\043B\0430\0434\0430\0435\0442\0435 \043D\0430\0434\043B\0435\0436\0430\0449\0438\043C\0438 \043F\0440\0430\0432\0430\043C\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349591021401636)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\0443 \0441\0442\0440\0430\043D\0438\0446\0443 \043D\0435\043B\044C\0437\044F \043D\0430\0441\0442\0440\043E\0438\0442\044C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455538009401713)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043D\0435\0448\043D\0438\0439 \0432\0438\0434 \044D\0442\043E\0433\043E \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \043C\043E\0436\043D\043E \043F\0435\0440\0441\043E\043D\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C, \0438\0437\043C\0435\043D\0438\0432 \0441\0442\0438\043B\044C \0442\0435\043C\044B. \0412\044B\0431\0435\0440\0438\0442\0435 \0441\0442\0438\043B\044C \0442\0435\043C\044B \0438\0437 \0441\043F\0438\0441\043A\0430 \043D\0438\0436\0435 \0438 \043D\0430\0436\043C\0438\0442\0435 "\041F\0440\0438\043C\0435\043D\0438\0442\044C \0438\0437\043C\0435\043D\0435\043D\0438\044F".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114456306907401714)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\043E\0431\0440\0430\0436\0435\043D\0438\0435 \043E\0431\043B\0430\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455410404401713)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0441\0442\0438\043B\044C \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114455315965401713)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043D\0435\0448\043D\0438\0439 \0432\0438\0434 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398314063401672)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \0441\0442\043E\043B\0431\0446\0430, \043D\0430 \043A\043E\0442\043E\0440\044B\0439 \0443\043A\0430\0437\044B\0432\0430\0435\0442 \0430\0433\0440\0435\0433\0430\0442 %0, \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114301653033401601)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\044B\0432\043E\0434 CLOB \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0444\043E\0440\043C\0430\0442\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398040204401671)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0437\0440\044B\0432 \0441\0442\043E\043B\0431\0446\0430 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C \0432 \043D\0430\0447\0430\043B\0435 \043C\0430\0441\0441\0438\0432\0430 \0441\0442\043E\043B\0431\0446\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398136169401671)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \0433\0440\0443\043F\043F\044B \0441\0442\043E\043B\0431\0446\043E\0432, \0443\043A\0430\0437\0430\043D\043D\044B\0439 \0432 %0, \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114315684131401611)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'ru'
,p_message_text=>unistr('\044D\043A\0441\043F\043E\0440\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114320817228401615)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442\043E\043C \044D\043A\0441\043F\043E\0440\0442\0430 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C XML \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C ORDS \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0441\0435\0440\0432\0435\0440\0430 \043F\0435\0447\0430\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398402455401672)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \0441\0442\043E\043B\0431\0446\0430, \043D\0430 \043A\043E\0442\043E\0440\044B\0439 \0443\043A\0430\0437\044B\0432\0430\0435\0442 \0432\044B\0434\0435\043B\0435\043D\0438\0435 %0, \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314120706401610)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0444\043E\0440\043C\0430\0442 \044D\043A\0441\043F\043E\0440\0442\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114398291434401671)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \0433\0440\0443\043F\043F\044B-\0440\043E\0434\0438\0442\0435\043B\044F, \0443\043A\0430\0437\0430\043D\043D\044B\0439 \0432 %0, \043D\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114423488767401690)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 %1 \0442\0430\0431\043B\0438\0446\044B %0 \2014 \044D\0442\043E \0441\0442\043E\043B\0431\0435\0446 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440\0430 "GENERATED ALWAYS". \0423\0431\0435\0434\0438\0442\0435\0441\044C, \0447\0442\043E \043D\0438 \043E\0434\0438\043D \0438\0441\0445\043E\0434\043D\044B\0439 \0441\0442\043E\043B\0431\0435\0446 \043D\0435 \0441\043E\043F\043E\0441\0442\0430\0432\043B\0435\043D \0441\0442\043E\043B\0431\0446\0443 %1 \0432 \0434\0438\0430\043B\043E\0433\043E\0432\043E\043C \043E\043A\043D\0435 "\041D\0430\0441\0442\0440\043E\0439\043A\0430".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340870344401630)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0437\0430\043D\043D\044B\0439 \0438\043D\0442\0435\0440\0432\0430\043B \0444\0438\043A\0441\0430\0446\0438\0438 \0441\043B\0438\0448\043A\043E\043C \043C\0430\043B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114340999677401630)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0437\0430\0433\0440\0443\0437\043A\0438 \0434\0430\043D\043D\044B\0445 \043D\0435 \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\044B \0441\0442\043E\043B\0431\0446\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342102513401631)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \043D\0430\0439\0434\0435\043D\044B \0441\0442\043E\043B\0431\0446\044B \0434\043B\044F \0441\0435\043B\0435\043A\0442\043E\0440\0430 \0441\0442\0440\043E\043A "%0". \041F\043E\043F\0440\043E\0431\0443\0439\0442\0435 \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0430\0432\0442\043E\043C\0430\0442\0438\0447\0435\0441\043A\0438 \0438\043B\0438 \043F\0440\043E\0441\043C\043E\0442\0440\0435\0442\044C \0441\0442\0440\0443\043A\0442\0443\0440\0443 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350447267401637)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 XLSX-\0444\0430\0439\043B\0435 \044D\043B\0435\043A\0442\0440\043E\043D\043D\044B\0435 \0442\0430\0431\043B\0438\0446\044B \043D\0435 \043D\0430\0439\0434\0435\043D\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350304830401637)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0437\0430\043D\043D\043E\0433\043E \0440\0430\0431\043E\0447\0435\0433\043E \043B\0438\0441\0442\0430 \043D\0435\0442 \0432 XLSX-\0444\0430\0439\043B\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114330558013401622)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421 \043C\043E\043C\0435\043D\0442\0430 \0438\043D\0438\0446\0438\0438\0440\043E\0432\0430\043D\0438\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\043C \043F\0440\043E\0446\0435\0441\0441\0430 \043E\0431\043D\043E\0432\043B\0435\043D\0438\044F \0438\0437\043C\0435\043D\0438\043B\0430\0441\044C \0442\0435\043A\0443\0449\0430\044F \0432\0435\0440\0441\0438\044F \0434\0430\043D\043D\044B\0445 \0432 \0431\0430\0437\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332977824401624)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\0431\043D\043E\0432\043B\0435\043D\0438\0438 \0441\0442\043E\043B\0431\0446\043E\0432 \043E\0442\0447\0435\0442\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437636391401700)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \043F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\0442\044C %0 \0432 SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377150622401656)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 %0 \0441 \0434\0430\043D\043D\044B\043C\0438 \0442\0438\043F\0430 %1 \043D\0435 \043C\043E\0436\0435\0442 \0431\044B\0442\044C \043F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\043D \0432 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384105497401661)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 "%0", \0443\043A\0430\0437\0430\043D\043D\044B\0439 \0434\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%1", \043D\0435 \043D\0430\0439\0434\0435\043D \0432 \0438\0441\0442\043E\0447\043D\0438\043A\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325433374401618)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0444\0438\043B\044C\0442\0440\0430 %0 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0441\0442\043E\043B\0431\0446\043E\0432 \0441 \043D\0435\0441\043A\043E\043B\044C\043A\0438\043C\0438 \0437\043D\0430\0447\0435\043D\0438\044F\043C\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114441086156401703)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0444\0438\043B\044C\0442\0440 "between" (\043C\0435\0436\0434\0443).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307506115401606)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0437\0430\043D \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0442\0438\043F \0441\043F\0438\0441\043A\0430 \0437\043D\0430\0447\0435\043D\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307451379401605)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0442\0438\043F \0437\0430\043F\0440\043E\0441\0430. \0422\0438\043F \0437\0430\043F\0440\043E\0441\0430 \0434\043E\043B\0436\0435\043D \0431\044B\0442\044C \0442\0430\0431\043B\0438\0446\0435\0439, SQL-\0437\0430\043F\0440\043E\0441\043E\043C \0438\043B\0438 \0444\0443\043D\043A\0446\0438\0435\0439 PL/SQL, \0432\043E\0437\0432\0440\0430\0449\0430\044E\0449\0435\0439 SQL-\0437\0430\043F\0440\043E\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377299165401656)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \043F\0440\043E\0430\043D\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C SQL-\0437\0430\043F\0440\043E\0441!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384242317401661)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423\043A\0430\0437\0430\043D\043D\0430\044F \043F\043E\0437\0438\0446\0438\044F \0441\0442\043E\043B\0431\0446\0430 %0 \0434\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%1" \043D\0435 \043D\0430\0439\0434\0435\043D\0430 \0432 \0438\043D\0441\0442\0440\0443\043A\0446\0438\0438 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114306008218401604)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 \0444\0438\043B\044C\0442\0440\0435 \0441 \043D\0435\0441\043A\043E\043B\044C\043A\0438\043C\0438 \0437\043D\0430\0447\0435\043D\0438\044F\043C\0438 \0438\0441\043F\043E\043B\044C\0437\0443\0435\0442\0441\044F \0441\043B\0438\0448\043A\043E\043C \043C\043D\043E\0433\043E \044D\043B\0435\043C\0435\043D\0442\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384062777401661)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%0"\043D\0435 \0443\043A\0430\0437\0430\043D \0441\0442\043E\043B\0431\0435\0446.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307361968401605)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043B\043E \0444\0443\043D\043A\0446\0438\0438 PL/SQL \043D\0435 \0432\0435\0440\043D\0443\043B\043E \0437\043D\0430\0447\0435\043D\0438\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114397259475401671)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0441\0442\043E\0447\043D\0438\043A \0434\0430\043D\043D\044B\0445 REST \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 \043E\043F\0435\0440\0430\0446\0438\044E \0434\043B\044F \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0437\0430\043F\0440\043E\0448\0435\043D\043D\043E\0433\043E \0434\0435\0439\0441\0442\0432\0438\044F DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114303228531401602)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\043D\0438\0435 GeoJSON \0432 SDO_GEOMETRY (\0441\0442\043E\043B\0431\0435\0446 %0) \043D\0435\0434\043E\0441\0442\0443\043F\043D\043E \0432 \044D\0442\043E\0439 \0431\0430\0437\0435 \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304311330401603)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\043D\0438\0435 SDO_GEOMETRY (\0441\0442\043E\043B\0431\0435\0446 %0) \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0434\043B\044F \0438\0441\0442\043E\0447\043D\0438\043A\043E\0432 \0434\0430\043D\043D\044B\0445 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114311608381401608)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0438\043C\0432\043E\043B %0 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0432 \043A\0430\0447\0435\0441\0442\0432\0435 \0440\0430\0437\0434\0435\043B\0438\0442\0435\043B\044F \043D\0435\0441\043A\043E\043B\044C\043A\0438\0445 \0437\043D\0430\0447\0435\043D\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114438920976401701)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\0443 \0444\0443\043D\043A\0446\0438\044E \043D\0435\043B\044C\0437\044F \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C \0432 \043A\043E\043D\0442\0435\043A\0441\0442\0435 \0437\0430\043F\0440\043E\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114304476177401603)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0441\043E\043E\0442\0432\0435\0442\0441\0442\0432\0438\0435 \0442\0438\043F\043E\0432 \0434\0430\043D\043D\044B\0445 \0441\0442\043E\043B\0431\0446\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307241106401605)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0432\044B\0448\0435\043D\044B \043F\0440\0435\0434\0435\043B\044B \043D\0430 \0432\043D\0443\0442\0440\0435\043D\043D\0438\0435 \043F\0440\0438\0432\044F\0437\043A\0438 ORDS OUT. \0423\043C\0435\043D\044C\0448\0438\0442\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\0440\043E\043A DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114385014631401662)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \043F\0440\043E\0430\043D\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C \043E\0442\0432\0435\0442 JSON \0441 \0443\0434\0430\043B\0435\043D\043D\043E\0433\043E \0441\0435\0440\0432\0435\0440\0430: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114307151945401605)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0438\0437\0432\0435\0441\0442\043D\044B\0439 \0438\043B\0438 \043D\0435\043F\0440\0430\0432\0438\043B\044C\043D\044B\0439 \0442\0438\043F \043A\043E\043D\0442\0435\043A\0441\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114401622666401674)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\043E\0442 \0442\0438\043F \0444\0430\0439\043B\043E\0432 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \043F\0430\0440\0441\0435\0440\043E\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356213511401641)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0441\0430\043D\043A\0446\0438\043E\043D\0438\0440\043E\0432\0430\043D\043D\044B\0439 \0434\043E\0441\0442\0443\043F (\043F\0430\0440\0430\043C\0435\0442\0440 wwv_flow_api.set_credentials \043D\0435 \0437\0430\0434\0430\043D).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333261166401624)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'ru'
,p_message_text=>unistr('\0420\0430\0431\043E\0447\0430\044F \043E\0431\043B\0430\0441\0442\044C \043D\0435 \0441\043E\0437\0434\0430\043D\0430, \043F\043E\0442\043E\043C\0443 \0447\0442\043E \043E\043D\0430 \0443\0436\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114333196601401624)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0413\0440\0443\043F\043F\0430 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439 \043D\0435 \0441\043E\0437\0434\0430\043D\0430, \043F\043E\0442\043E\043C\0443 \0447\0442\043E \043E\043D\0430 \0443\0436\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343449712401632)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F %0 \043D\0430\0439\0434\0435\043D\043E \043F\043E\0432\0442\043E\0440\044F\044E\0449\0435\0435\0441\044F \0438\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343519871401632)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \0437\0430\0433\0440\0443\0437\043A\0435 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439. \0421\0431\043E\0439 \043F\0440\043E\0438\0437\043E\0448\0435\043B \043D\0430 \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353406537401639)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0411\044B\043B\043E \0431\044B \0437\0430\0433\0440\0443\0436\0435\043D\043E \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\0435\0439: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353205438401639)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\043E\043B\044C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353307613401639)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E\043B\043D\043E\043C\043E\0447\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353001689401639)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429587122401694)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \0440\0435\043D\0434\0435\0440\0438\043D\0433\0435 \044D\043B\0435\043C\0435\043D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\044B #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349127689401636)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \043E\0442\043E\0431\0440\0430\0437\0438\0442\044C \044D\043B\0435\043C\0435\043D\0442 \0441\0442\0440\0430\043D\0438\0446\044B, \0442\0430\043A \043A\0430\043A HTML-\0444\043E\0440\043C\0430 \0435\0449\0435 \043D\0435 \0431\044B\043B\0430 \043E\0442\043A\0440\044B\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114314464507401610)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F \0437\043D\0430\0447\0435\043D\0438\044F \043F\043E \0443\043C\043E\043B\0447\0430\043D\0438\044E \0434\043B\044F \044D\043B\0435\043C\0435\043D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\044B #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348490386401635)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0432 \043F\043E\0441\043B\0435\0434\0443\044E\0449\0435\043C \0440\0430\0441\0447\0435\0442\0435 \044D\043B\0435\043C\0435\043D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\044B #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348385569401635)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F \0438\0441\0445\043E\0434\043D\043E\0433\043E \0437\043D\0430\0447\0435\043D\0438\044F \044D\043B\0435\043C\0435\043D\0442\0430 \0441\0442\0440\0430\043D\0438\0446\044B #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328197182401620)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0441\0430\043D\043A\0446\0438\043E\043D\0438\0440\043E\0432\0430\043D\043D\044B\0439 \0434\043E\0441\0442\0443\043F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348600687401635)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'ru'
,p_message_text=>unistr('JavaScript \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348726785401635)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114349358728401636)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \0438\043D\0438\0446\0438\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C \0437\0430\043F\0440\043E\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356505424401641)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0431\043D\043E\0432\043B\0435\043D\0438\0435 %0 \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114350747601401637)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \044D\043B\0435\043C\0435\043D\0442\0430: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114377076592401656)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \044D\0442\043E\0433\043E \044D\043B\0435\043C\0435\043D\0442\0430 \043D\0435\0442 \0441\043F\0440\0430\0432\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341545346401630)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \0441\043E\0437\0434\0430\0442\044C \0437\0430\043F\0440\043E\0441 \0434\0438\0430\0433\0440\0430\043C\043C\044B. \041F\0440\043E\0432\0435\0440\044C\0442\0435 \043D\0430\0441\0442\0440\043E\0439\043A\0438 \0441\043E\043F\043E\0441\0442\0430\0432\043B\0435\043D\0438\044F \0438\0441\0442\043E\0447\043D\0438\043A\043E\0432 \0438 \0441\0442\043E\043B\0431\0446\043E\0432.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436324029401699)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043B\043E\0436\0435\043D\0438\0435 \0440\0430\0437\043C\0435\0440\043E\043C %0 \041C\0411 \043F\0440\0435\0432\044B\0448\0430\0435\0442 \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\044B\0439 \0440\0430\0437\043C\0435\0440 \0432\043B\043E\0436\0435\043D\0438\044F %1 \041C\0411.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342488387401631)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 \043F\0430\0440\0430\043C\0435\0442\0440\0430 p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114459813191401716)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0432\044B\0448\0435\043D\043E \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\043E\043E\0431\0449\0435\043D\0438\0439 \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B \043D\0430 \0440\0430\0431\043E\0447\0443\044E \043E\0431\043B\0430\0441\0442\044C. \041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0441\0432\043E\0435\043C\0443 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323414675401617)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\0443 \043F\0440\043E\0446\0435\0434\0443\0440\0430 \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0432\044B\0437\044B\0432\0430\0442\044C \0438\0437 \0441\0435\0430\043D\0441\0430 \043F\0440\0438\043B\043E\0436\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342398360401631)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0440\0443 %0 \043F\0440\0435\0434\043E\0441\0442\0430\0432\043B\0435\043D\043E \0437\043D\0430\0447\0435\043D\0438\0435 Null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396331549401670)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0428\0430\0431\043B\043E\043D \044D\043B\0435\043A\0442\0440\043E\043D\043D\043E\0439 \043F\043E\0447\0442\044B "%0" \043D\0435 \043D\0430\0439\0434\0435\043D \0432 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114472896912401726)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \043E\0442\043F\0440\0430\0432\043A\0438 \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0437\0430\0434\0430\0442\044C \043F\0430\0440\0430\043C\0435\0442\0440 \044D\043A\0437\0435\043C\043F\043B\044F\0440\0430 SMTP_HOST_ADDRESS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342035746401631)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \043E\0442\043F\0440\0430\0432\043A\0438 \043F\043E\0447\0442\044B \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \043F\043E\043B\0443\0447\0430\0442\0435\043B\044F \0441\043E\043E\0431\0449\0435\043D\0438\044F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114462210529401718)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\0435\0442\0441\044F \0443\0441\0442\0430\043D\043E\0432\0438\0442\044C SMTP-\0441\043E\0435\0434\0438\043D\0435\043D\0438\0435 \0441 \043D\0430\0441\0442\0440\043E\0435\043D\043D\044B\043C \043F\043E\0447\0442\043E\0432\044B\043C \0441\0435\0440\0432\0435\0440\043E\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114436453918401699)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 \0432\044B\0437\043E\0432 Ajax!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327810099401620)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E\0433\043E \043C\043E\0434\0443\043B\044F %0 \043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0430 \0444\0443\043D\043A\0446\0438\044F Ajax')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426828729401692)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E\0433\043E \043C\043E\0434\0443\043B\044F %0 \043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0430 \0438\0441\043F\043E\043B\043D\044F\0435\043C\0430\044F \0444\0443\043D\043A\0446\0438\044F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327941383401620)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E\0433\043E \043C\043E\0434\0443\043B\044F %0 \043D\0435 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0430 \0444\0443\043D\043A\0446\0438\044F \0440\0435\043D\0434\0435\0440\0438\043D\0433\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437302142401700)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0439 \043C\043E\0434\0443\043B\044C \0438\0441\0442\043E\0447\043D\0438\043A\0430 \0434\0430\043D\043D\044B\0445 REST "%0" \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 \0444\0443\043D\043A\0446\0438\044E "\0412\043E\0437\043C\043E\0436\043D\043E\0441\0442\0438".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437245151401700)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0439 \043C\043E\0434\0443\043B\044C \0438\0441\0442\043E\0447\043D\0438\043A\0430 \0434\0430\043D\043D\044B\0445 REST "%0" \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 \0444\0443\043D\043A\0446\0438\044E DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437474389401700)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0439 \043C\043E\0434\0443\043B\044C \0438\0441\0442\043E\0447\043D\0438\043A\0430 \0434\0430\043D\043D\044B\0445 REST "%0" \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 \0432\044B\043F\043E\043B\043D\044F\0435\043C\0443\044E \0444\0443\043D\043A\0446\0438\044E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114437567387401700)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\044B\0439 \043C\043E\0434\0443\043B\044C \0438\0441\0442\043E\0447\043D\0438\043A\0430 \0434\0430\043D\043D\044B\0445 REST "%0" \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 \0444\0443\043D\043A\0446\0438\044E DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325695825401619)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\043E \0432\0440\0435\043C\044F \043E\0431\0440\0430\0431\043E\0442\043A\0438 \0434\043E\043F\043E\043B\043D\0438\0442\0435\043B\044C\043D\043E\0433\043E \043C\043E\0434\0443\043B\044F \0432\043E\0437\043D\0438\043A\043B\0430 \043E\0448\0438\0431\043A\0430 \0432 PLSQL-\043A\043E\0434\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332266215401623)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043B\0436\043D\043E \0431\044B\0442\044C \0443\043A\0430\0437\0430\043D\043E \0437\043D\0430\0447\0435\043D\0438\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362839241401646)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0438\043F \0434\0430\043D\043D\044B\0445 %0 \043D\0435\0432\043E\0437\043C\043E\0436\043D\043E \043F\0440\0435\043E\0431\0440\0430\0437\043E\0432\0430\043D \0432 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448434515401708)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 "%0", \0443\043A\0430\0437\0430\043D\043D\044B\0439 \0434\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%1", \043D\0435 \043D\0430\0439\0434\0435\043D \0432 \0438\043D\0441\0442\0440\0443\043A\0446\0438\0438 SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424785696401691)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F %0 \043D\0435\043E\0431\0445\043E\0434\0438\043C\043E \0443\043A\0430\0437\0430\0442\044C \0437\0430\043F\0440\043E\0441 \0441\043F\0438\0441\043A\0430 \0437\043D\0430\0447\0435\043D\0438\0439 \0438\043B\0438 \0438\043C\0435\043D\043E\0432\0430\043D\043D\044B\0439 \0441\043F\0438\0441\043E\043A \0437\043D\0430\0447\0435\043D\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114426395252401692)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412 SQL-\0437\0430\043F\0440\043E\0441\0435 \0441\043F\0438\0441\043A\0430 \0437\043D\0430\0447\0435\043D\0438\0439 \0434\043B\044F %0 \0432\044B\0431\0440\0430\043D\043E \043D\0435\0432\0435\0440\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0441\0442\043E\043B\0431\0446\043E\0432. \0421\043C. \043F\0440\0438\043C\0435\0440\044B \0434\043E\043F\0443\0441\0442\0438\043C\044B\0445 \0438\043D\0441\0442\0440\0443\043A\0446\0438\0439.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448247083401708)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%0"\043D\0435 \0443\043A\0430\0437\0430\043D \0441\0442\043E\043B\0431\0435\0446.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477957311401730)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\0412\0432\0435\0434\0435\043D\043D\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435 %0 \0434\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%1" \043D\0435 \0447\0438\0441\043B\043E\0432\043E\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114429888321401695)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0423 %0 \043D\0435\043F\0440\0430\0432\0438\043B\044C\043D\044B\0439 \0442\0438\043F \0434\0430\043D\043D\044B\0445 \0432 \0438\043D\0441\0442\0440\0443\043A\0446\0438\0438 SQL. \0421\0442\043E\043B\0431\0435\0446 \2116\00A0%1 \0440\0430\0432\0435\043D %2, \043D\043E \043E\0436\0438\0434\0430\0435\0442\0441\044F %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114448385552401708)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446 "%0", \0443\043A\0430\0437\0430\043D\043D\044B\0439 \0434\043B\044F \0430\0442\0440\0438\0431\0443\0442\0430 "%1", \0438\043C\0435\0435\0442 \0442\0438\043F \0434\0430\043D\043D\044B\0445 %2, \043D\043E \0434\043E\043B\0436\0435\043D \0438\043C\0435\0442\044C %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114324983779401618)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \043D\0430\0439\0442\0438 \0440\0430\0437\043C\0435\0442\043A\0443 \043E\0442\0447\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384982440401662)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\044F \0432\044B\0447\0438\0441\043B\0435\043D\0438\044F \0441\0443\043C\043C\044B \043D\0435 \043C\043E\0436\0435\0442 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\0442\044C\0441\044F \0434\043B\044F \043E\0442\0447\0435\0442\043E\0432, \043E\0441\043D\043E\0432\0430\043D\043D\044B\0445 \043D\0430 \0438\0441\0442\043E\0447\043D\0438\043A\0435 \0434\0430\043D\043D\044B\0445 REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114348569813401635)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('ERR-2904 \041D\0435\0432\043E\0437\043C\043E\0436\043D\043E \0437\0430\0434\0430\0442\044C \0437\043D\0430\0447\0435\043D\0438\0435 \044F\0440\043B\044B\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114352841987401638)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430. \041D\0435\0438\0437\0432\0435\0441\0442\043D\044B\0439 \0442\0438\043F \044F\0440\043B\044B\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114342875095401631)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \043F\043E\043B\0443\0447\0438\0442\044C \0441\0445\0435\043C\0443 \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438 \0432 \043F\0440\0438\043B\043E\0436\0435\043D\0438\0438 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114416365876401685)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0418\0434\0435\043D\0442\0438\0444\0438\043A\0430\0442\043E\0440 \0430\0440\0435\043D\0434\0430\0442\043E\0440\0430 \0443\0436\0435 \0441\0443\0449\0435\0441\0442\0432\0443\0435\0442 \0434\043B\044F \0442\0435\043A\0443\0449\0435\0433\043E \0441\0435\0430\043D\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114353117449401639)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\043B\0435\043A\0442\0440\043E\043D\043D\0430\044F \043F\043E\0447\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477378411401729)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \0432\044B\043F\043E\043B\043D\0438\0442\044C \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\044E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114379616037401658)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0434\0438\043D \0438\043B\0438 \043D\0435\0441\043A\043E\043B\044C\043A\043E \0444\0430\0439\043B\043E\0432 cookie, \0437\0430\0434\0430\043D\043D\044B\0445 \0432 apex_util.g_request_cookies, \0441\043E\0434\0435\0440\0436\0430\0442 \043D\0435\0434\043E\043F\0443\0441\0442\0438\043C\043E\0435 \0437\043D\0430\0447\0435\043D\0438\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114362187715401645)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0432\0435\0442 \0438\0437 \0440\0435\0435\0441\0442\0440\0430 UDDI \0431\044B\043B \043D\0435\0434\0435\0439\0441\0442\0432\0438\0442\0435\043B\044C\043D\044B\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114325790748401619)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\043E \0443\043A\0430\0437\0430\043D\043D\043E\043C\0443 URL-\0430\0434\0440\0435\0441\0443 \043D\0435 \0431\044B\043B \0432\043E\0437\0432\0440\0430\0449\0435\043D \0434\043E\043F\0443\0441\0442\0438\043C\044B\0439 WSDL-\0434\043E\043A\0443\043C\0435\043D\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114328215141401621)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430\043D\043D\044B\0439 WSDL-\0434\043E\043A\0443\043C\0435\043D\0442 \0441\043E\0434\0435\0440\0436\0438\0442 \043D\0435\0441\043A\043E\043B\044C\043A\043E \043F\0440\0438\0432\044F\0437\043E\043A SOAP. &PRODUCT_NAME. \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442 \0442\043E\043B\044C\043A\043E WSDL \0441 \043E\0434\043D\043E\0439 \043F\0440\0438\0432\044F\0437\043A\043E\0439 SOAP. \041D\0430\0436\043C\0438\0442\0435 "\0421\043E\0437\0434\0430\0442\044C \0441\0441\044B\043B\043A\0443 \043D\0430 \0432\0435\0431-\0441\043B\0443\0436\0431\0443 \0432\0440\0443\0447\043D\0443\044E", \0447\0442\043E\0431\044B \043F\0440\043E\0434\043E\043B\0436\0438\0442\044C \0441\043E\0437\0434\0430\043D\0438\0435 \0441\0441\044B\043B\043A\0438 \0434\043B\044F \044D\0442\043E\0439 \0441\043B\0443\0436\0431\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114396690888401670)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0442\0432\0435\0442 \043E\0442 \0441\043B\0443\0436\0431\044B \043D\0435 \0438\043C\0435\043B \0444\043E\0440\043C\0430\0442 XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477230778401729)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0430\0440\043A\0435\0440 \0434\043E\0441\0442\0443\043F\0430 OAuth \043D\0435\0434\043E\0441\0442\0443\043F\0435\043D \0438\043B\0438 \0441\0440\043E\043A \0435\0433\043E \0434\0435\0439\0441\0442\0432\0438\044F \0438\0441\0442\0435\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114440406742401702)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041F\0440\0435\0432\044B\0448\0435\043D\043E \043C\0430\043A\0441\0438\043C\0430\043B\044C\043D\043E\0435 \043A\043E\043B\0438\0447\0435\0441\0442\0432\043E \0437\0430\043F\0440\043E\0441\043E\0432 \0432\0435\0431-\0441\043B\0443\0436\0431 \043D\0430 \0440\0430\0431\043E\0447\0443\044E \043E\0431\043B\0430\0441\0442\044C. \041E\0431\0440\0430\0442\0438\0442\0435\0441\044C \043A \0441\0432\043E\0435\043C\0443 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114477459059401729)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0435\0440\0432\0435\0440 \043E\0442\0432\0435\0442\0438\043B \043C\0430\0440\043A\0435\0440\043E\043C OAuth \043D\0435\043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\043C\043E\0433\043E \0442\0438\043F\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327624342401620)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\043E\043A\0443\043C\0435\043D\0442 WSDL \043D\0435 \0441\043E\0434\0435\0440\0436\0430\043B \043F\0440\0438\0432\044F\0437\043A\0438 SOAP, \043A\043E\0442\043E\0440\0430\044F \0442\0440\0435\0431\0443\0435\0442\0441\044F \0434\043B\044F \0434\043E\0431\0430\0432\043B\0435\043D\0438\044F \0441\0441\044B\043B\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114323561661401617)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\043E\043C\0443 \044D\043A\0437\0435\043C\043F\043B\044F\0440\0443 WSDL \0442\0440\0435\0431\0443\044E\0442\0441\044F \0443\0447\0435\0442\043D\044B\0435 \0434\0430\043D\043D\044B\0435 \0434\043B\044F \0430\0443\0442\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0438. \0423\043A\0430\0436\0438\0442\0435 \0438\043C\044F \043F\043E\043B\044C\0437\043E\0432\0430\0442\0435\043B\044F \0438 \043F\0430\0440\043E\043B\044C \043D\0438\0436\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114332364705401624)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'ru'
,p_message_text=>unistr('\041C\0435\0445\0430\043D\0438\0437\043C\0443 \0440\0435\043D\0434\0435\0440\0438\043D\0433\0430 \043D\0435 \0443\0434\0430\043B\043E\0441\044C \043F\0440\043E\0430\043D\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C WSDL-\0434\043E\043A\0443\043C\0435\043D\0442. \041D\0430\0436\043C\0438\0442\0435 "\0421\043E\0437\0434\0430\0442\044C \0441\0441\044B\043B\043A\0443 \043D\0430 \0432\0435\0431-\0441\043B\0443\0436\0431\0443 \0432\0440\0443\0447\043D\0443\044E", \0447\0442\043E\0431\044B \043F\0440\043E\0434\043E\043B\0436\0438\0442\044C \0441\043E\0437\0434\0430\043D\0438\0435 \0441\0441\044B\043B\043A\0438 \0434\043B\044F \044D\0442\043E\0439 \0441\043B\0443\0436\0431\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114399250523401672)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041D\0435 \0443\0434\0430\043B\043E\0441\044C \043E\0431\0440\0430\0431\043E\0442\0430\0442\044C \043E\0431\043D\043E\0432\043B\0435\043D\0438\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114425092824401691)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0442\043E\043B\0431\0435\0446, \0432\043E\0437\0432\0440\0430\0449\0430\044E\0449\0438\0439 \0441\043F\0438\0441\043E\043A \0437\043D\0430\0447\0435\043D\0438\0439, \0438 \043E\0442\043E\0431\0440\0430\0436\0430\0435\043C\044B\0439 \0441\0442\043E\043B\0431\0435\0446 \043E\0434\0438\043D\0430\043A\043E\0432\044B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114424904892401691)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043F\0438\0441\043E\043A \0437\043D\0430\0447\0435\043D\0438\0439 \043D\0435 \0441\043E\0434\0435\0440\0436\0438\0442 \0432\043E\0437\0432\0440\0430\0449\0430\0435\043C\043E\0433\043E \0441\0442\043E\043B\0431\0446\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356440847401641)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \0434\043B\044F \043F\043E\043B\0443\0447\0435\043D\0438\044F \0437\043D\0430\0447\0435\043D\0438\044F \0441\0442\043E\043B\0431\0446\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380427300401659)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'ru'
,p_message_text=>unistr('\0422\0435\043A\0443\0449\0438\0435 \0434\0430\043D\043D\044B\0435 \0442\0430\0431\043B\0438\0447\043D\043E\0439 \0444\043E\0440\043C\044B \0441\043B\0438\0448\043A\043E\043C \0443\0441\0442\0430\0440\0435\043B\0438; \0438\0441\0445\043E\0434\043D\044B\0435 \0434\0430\043D\043D\044B\0435 \0438\0437\043C\0435\043D\0435\043D\044B.<br/> \041D\0430\0436\043C\0438\0442\0435 <strong><a href="%0">\0437\0434\0435\0441\044C</a></strong>, \0447\0442\043E\0431\044B \043E\0442\043C\0435\043D\0438\0442\044C \0432\043D\0435\0441\0435\043D\043D\044B\0435 \0438\0437\043C\0435\043D\0435\043D\0438\044F \0438 \043F\0435\0440\0435\0437\0430\0433\0440\0443\0437\0438\0442\044C \0434\0430\043D\043D\044B\0435 \0438\0437 \0431\0430\0437\044B \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338586294401628)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043E\043F\0440\0435\0434\0435\043B\0435\043D\0438\0438 \0441\0442\0440\043E\043A\0438 \0440\0430\0437\0431\0438\0435\043D\0438\044F \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338400850401628)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\043D\0435\0432\043E\0437\043C\043E\0436\043D\043E \043E\043F\0440\0435\0434\0435\043B\0438\0442\044C \0437\0430\0433\043E\043B\043E\0432\043A\0438 \0437\0430\043F\0440\043E\0441\043E\0432:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338652121401628)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'ru'
,p_message_text=>unistr('\043E\0448\0438\0431\043A\0430 \043F\0440\0438 \0437\0430\043C\0435\043D\0435 \043D\0438\0436\043D\0435\0433\043E \043A\043E\043B\043E\043D\0442\0438\0442\0443\043B\0430 \043E\0442\0447\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338712546401628)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\043D\0435 \0443\0434\0430\043B\043E\0441\044C \043F\0440\043E\0430\043D\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C SQL-\0437\0430\043F\0440\043E\0441:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343791964401632)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'ru'
,p_message_text=>unistr('\0417\0430\043F\0440\043E\0448\0435\043D\0430 \043C\0438\043D\0438\043C\0430\043B\044C\043D\0430\044F \0441\0442\0440\043E\043A\0430: %0, \0441\0442\0440\043E\043A, \043A\043E\0442\043E\0440\044B\0435 \043D\0430\0439\0434\0435\043D\044B, \043D\043E \043D\0435 \043E\0442\043E\0431\0440\0430\0436\0430\044E\0442\0441\044F: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341239483401630)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0442\043E\043B\0431\0435\0446 \0437\0430\043F\0440\043E\0441\0430 #%0 (%1) \043D\0435 \0434\043E\043F\0443\0441\0442\0438\043C, \0441\0442\043E\043B\0431\0446\0430\043C \0441 \0438\0441\043F\043E\043B\044C\0437\043E\0432\0430\043D\0438\0435\043C HTML \043D\0443\0436\043D\044B \043F\0441\0435\0432\0434\043E\043D\0438\043C\044B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114356376970401641)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'ru'
,p_message_text=>unistr('\041E\0448\0438\0431\043A\0430 \043F\0440\0438 \043F\043E\043B\0443\0447\0435\043D\0438\0438 \0437\0430\0433\043E\043B\043E\0432\043A\043E\0432 \0437\0430\043F\0440\043E\0441\043E\0432: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338832398401628)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\043E\0448\0438\0431\043A\0430 \0432 \043E\0442\0447\0435\0442\0435:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114376565122401656)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\043E\0432\0430\0442\044C \043F\043E \044D\0442\043E\043C\0443 \0441\0442\043E\043B\0431\0446\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341312894401630)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'ru'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041D\0435 \0443\0434\0430\0435\0442\0441\044F \043F\0440\043E\0430\043D\0430\043B\0438\0437\0438\0440\043E\0432\0430\0442\044C \0437\0430\043F\0440\043E\0441. \041F\0440\043E\0432\0435\0440\044C\0442\0435 \0441\0438\043D\0442\0430\043A\0441\0438\0441 \0441\0432\043E\0435\0433\043E \0437\0430\043F\0440\043E\0441\0430.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380556153401659)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'ru'
,p_message_text=>unistr('\042D\0442\0430 \0444\043E\0440\043C\0430 \0441\043E\0434\0435\0440\0436\0438\0442 \043D\0435\0441\043E\0445\0440\0430\043D\0435\043D\043D\044B\0435 \0438\0437\043C\0435\043D\0435\043D\0438\044F. \041D\0430\0436\043C\0438\0442\0435 \041E\041A, \0447\0442\043E\0431\044B \043F\0440\043E\0434\043E\043B\0436\0438\0442\044C \0431\0435\0437 \0441\043E\0445\0440\0430\043D\0435\043D\0438\044F \0438\0437\043C\0435\043D\0435\043D\0438\0439.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114384829630401662)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'ru'
,p_message_text=>unistr('\0421\0445\0435\043C\0430 \0440\0430\0437\0431\0438\0432\043A\0438 \043E\0442\0447\0435\0442\043E\0432 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\044B (%0) \043D\0435 \043F\043E\0434\0434\0435\0440\0436\0438\0432\0430\0435\0442\0441\044F \0432\044B\0431\0440\0430\043D\043D\044B\043C \0438\0441\0442\043E\0447\043D\0438\043A\043E\043C \0434\0430\043D\043D\044B\0445.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114341188592401630)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0442\043E\043B\0431\0435\0446 \0437\0430\043F\0440\043E\0441\0430 #%0 (%1) \043D\0435 \0434\043E\043F\0443\0441\0442\0438\043C, \0438\0441\043F\043E\043B\044C\0437\0443\0439\0442\0435 \043F\0441\0435\0432\0434\043E\043D\0438\043C \0441\0442\043E\043B\0431\0446\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343803122401632)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0442\0440\043E\043A\0438 %0 - %1 \0438\0437 \0431\043E\043B\0435\0435 \0447\0435\043C %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114382577543401660)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'ru'
,p_message_text=>unistr('%0 - %1 \0438\0437 \0431\043E\043B\0435\0435 \0447\0435\043C %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114343678987401632)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'ru'
,p_message_text=>unistr('\0441\0442\0440\043E\043A\0438 %0 - %1 \0438\0437 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114327508509401620)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'ru'
,p_message_text=>unistr('%0\2013%1 \0438\0437 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338989008401628)
,p_name=>'Y'
,p_message_language=>'ru'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114345050053401633)
,p_name=>'YEAR'
,p_message_language=>'ru'
,p_message_text=>unistr('\0433\043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114338187998401628)
,p_name=>'YEARS'
,p_message_language=>'ru'
,p_message_text=>unistr('\043B\0435\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114380664719401659)
,p_name=>'YES'
,p_message_language=>'ru'
,p_message_text=>unistr('\0414\0430')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4544)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4544)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4544
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4544)
,p_name=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\044F')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\0421\043E\043E\0431\0449\0435\043D\0438\044F')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
