prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4485
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4485 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4485
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103440443403814')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'sk'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4485)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113353'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4485)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4485)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4485)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4485)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4485)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4485)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.sk'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4485)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4485)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4485)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4485)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4485)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4485)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.sk'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4485)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4485)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4485)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4485)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4485)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4485)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.sk'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4485)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4485)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.sk'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4485)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4485)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.sk'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4485)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4485)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.sk'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4485)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4485)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4485)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.sk'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4485
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4485)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4485)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4485)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4485
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4485)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4485
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4485)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4485
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4485)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4485
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4485)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4485
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4485)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4485
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4485
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4485)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4485)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4485)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4485)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4485)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4485)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4485)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4485)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4485)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4485)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4485)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4485)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4485)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4485)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4485)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4485)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4485)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4485)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4485)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4485)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4485)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4485
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4485)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4485)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4485)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4485
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4485)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4485
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4485)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4485
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4485)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4485
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4485)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4485
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4485)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4485
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4485)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4485)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4485)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4485)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4485)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4485)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4485)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4485)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4485)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4485
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4485)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4485)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4485)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4485)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4485)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4485)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4485)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4485
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4485)
,p_page_name=>'winlov'
,p_page_title=>unistr('Dial\00F3gov\00E9 okno vyh\013Ead\00E1vania')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('Vyh\013Eada\0165')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('Zavrie\0165')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\010Ealej &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; Sp\00E4\0165')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Riadky #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4485
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4485)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4485
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4485)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4485)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4485)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4485)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4485)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4485)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4485)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4485)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4485)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4485)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4485)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4485)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4485)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4485)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4485)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4485)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4485)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4485)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4485)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4485)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4485)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4485)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4485)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4485)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4485)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4485)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4485)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4485)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4485)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4485)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4485)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4485)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4485)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4485)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4485)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4485)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4485)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4485)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4485)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4485)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4485)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4485)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4485)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4485)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4485)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4485)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4485)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4485)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4485)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4485)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4485)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4485)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4485)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4485)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4485)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4485)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4485)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4485)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4485)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4485)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4485)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4485)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4485)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4485)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4485)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4485)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4485)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4485)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4485)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4485)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4485)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4485)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4485)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4485)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4485)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4485)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4485)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4485)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4485)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4485)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4485)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4485)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4485)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4485)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4485)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4485)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4485)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4485)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4485)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4485)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4485)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4485)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4485)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4485)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4485)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4485)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4485)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4485)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4485)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4485)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4485)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4485)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4485)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4485)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4485)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4485)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4485)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4485)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4485)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4485)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4485)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4485)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4485)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4485)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4485)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4485)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4485)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4485)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4485)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4485)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4485)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4485)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4485)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4485)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4485)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4485)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4485)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4485)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4485)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4485)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4485)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4485)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4485)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4485)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4485)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4485)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4485)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4485)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4485)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4485)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4485)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4485)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4485)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4485)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4485)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4485)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4485)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4485)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4485)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4485)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4485)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4485)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4485)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4485)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4485)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4485)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4485)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4485)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4485)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4485)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4485)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4485)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4485)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4485)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4485)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4485)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4485)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4485)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4485)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4485)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4485)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4485)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513621415401764)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500789147401753)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'sk'
,p_message_text=>unistr('Administr\00E1tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500659370401753)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'sk'
,p_message_text=>unistr('Meno pou\017E\00EDvate\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557935598401797)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstup odmietnut\00FD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517615206401767)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161e konto %0 bolo vytvoren\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503225054401755)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'sk'
,p_message_text=>unistr('Konto je zamknut\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493127207401747)
,p_name=>'AM_PM'
,p_message_language=>'sk'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627573652401847)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prepn\00FA\0165 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635618850401853)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'sk'
,p_message_text=>unistr('(Akt\00EDvne)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605129038401831)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Volanie Ajax vr\00E1tilo chybu servera %0 pre %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535992013401780)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Alias aplik\00E1cie "%0" nie je mo\017En\00E9 skonvertova\0165 na jednozna\010Dn\00E9 ID aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536028837401780)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Aplik\00E1cia s aliasom "%0" neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525616723401773)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1816 Neo\010Dak\00E1van\00E1 chyba pri konverzii aliasu aplik\00E1cie p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618554554401840)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomocou kontroln\00E9ho s\00FA\010Dtu aplik\00E1cie sa m\00F4\017Ee jednoducho ur\010Di\0165, \010Di je rovnak\00E1 aplik\00E1cia nasaden\00E1 v r\00E1mci pracovn\00FDch priestorov. Tento kontroln\00FD s\00FA\010Det m\00F4\017Eete porovna\0165 a ur\010Di\0165, \010Di existuje zhoda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511440221401762)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri spracov\00E1van\00ED funkcie autentifik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496874211401750)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri spracov\00E1van\00ED funkcie autentifik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660304444401871)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov n\00E1jomcu %0 vr\00E1ten\00FD slu\017Ebou Oracle Cloud Identity Management nem\00E1 opr\00E1vnenie pre dom\00E9nu %1!<br/><a href="&LOGOUT_URL.">Znovu sa prihl\00E1ste</a> a zadajte n\00E1zov opr\00E1vnen\00E9ho n\00E1jomcu alebo zme\0148te adresu URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494576682401748)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161e konto "%0" nem\00E1 potrebn\00E9 privil\00E9gi\00E1 na v\00FDvoj (DB_DEVELOPER alebo DB_ADMINISTRATOR)<br/>pre pracovn\00FD priestor "%1"! <a href="&LOGOUT_URL.">Znovu sa prihl\00E1ste</a> po poskytnut\00ED privil\00E9gi\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493614152401748)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov n\00E1jomcu vr\00E1ten\00FD slu\017Ebou Oracle Cloud Identity Management nem\00E1 opr\00E1vnenie pre aktu\00E1lny pracovn\00FD priestor!<br/><a href="&LOGOUT_URL.">Znovu sa prihl\00E1ste</a> a zadajte n\00E1zov opr\00E1vnen\00E9ho n\00E1jomcu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494646679401748)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Z bezpe\010Dnostn\00FDch d\00F4vodov nie je povolen\00E9 spustenie aplik\00E1ci\00ED tohto pracovn\00E9ho priestoru prostredn\00EDctvom dom\00E9ny v adrese URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511176741401762)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eiadajte administr\00E1tora datab\00E1zy o spustenie $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511013922401762)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'sk'
,p_message_text=>unistr('Bal\00EDk SYS.DBMS_LDAP neexistuje alebo je neplatn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510920329401762)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania funkcie \00FApravy pou\017E\00EDvate\013Ea LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511283616401762)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania autentifik\00E1cie LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512027188401763)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba v argumente p_flow_page pre proced\00FAru login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511693242401763)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 rel\00E1cia p_session v wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559584229401798)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Chybne vytvoren\00FD argument pre wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511764442401763)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'sk'
,p_message_text=>unistr('Do prihlasovacej proced\00FAry bolo odovzdan\00E9 meno pou\017E\00EDvate\013Ea null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500506171401753)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Ak sa chcete znova prihl\00E1si\0165, po\010Dkajte <span id="apex_login_throttle_sec">%0</span> s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501843861401754)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pokus o prihl\00E1senie bol blokovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557349043401796)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Autentifik\00E1cia "%" sa nena\0161la')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502145799401754)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'sk'
,p_message_text=>unistr('ID skupiny zabezpe\010Denia je null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511565507401763)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das vykon\00E1vania procesu dodato\010Dnej autentifik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511310036401762)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania procesu predbe\017Enej autentifik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512531118401763)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'sk'
,p_message_text=>unistr('Otvorte adresu URL v rovnakom preh\013Ead\00E1va\010Di, v ktorom ste iniciovali po\017Eiadavku na znovunastavenie hesla. Ak kliknete na adresu URL na znovunastavenie hesla a budete presmerovan\00ED na prihlasovaciu str\00E1nku, znovu spustite po\017Eiadavku na znovunastavenie h')
||unistr('esla a preh\013Ead\00E1va\010D ponechajte otvoren\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657840464401869)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'sk'
,p_message_text=>'Adresa URL na znovunastavenie hesla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494850904401749)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Skupina spotrebite\013Eov spr\00E1vcu prostriedkov %0 nebola pridelen\00E1 pou\017E\00EDvate\013Eovi %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494937763401749)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Eite skupinu DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP na pridelenie ch\00FDbaj\00FAceho privil\00E9gia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522900276401771)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania funkcie sentry rel\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523077372401771)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania funkcie overenia rel\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523229975401771)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eiadajte administr\00E1tora %0 o konfigur\00E1ciu mechanizmu pre prihl\00E1senie jedn\00FDm vstupom do syst\00E9mu Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532777064401778)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'sk'
,p_message_text=>unistr('Prihl\00E1senie SSO vr\00E1tilo neplatn\00FA hodnotu %0 v tokene %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511974534401763)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravte sch\00E9mu autentifik\00E1cie a pridajte n\00E1zov aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532495505401778)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD volaj\00FAci proced\00FAry %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532623062401778)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 rel\00E1cia aplik\00E1cie v tokene urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532295686401778)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba v pr\00EDkaze portal_sso_redirect: ch\00FDbaj\00FA inform\00E1cie o registr\00E1cii aplik\00E1cie: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523122302401771)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'sk'
,p_message_text=>unistr('Bal\00EDk WWSEC_SSO_ENABLER_PRIVATE neexistuje alebo je neplatn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114511852435401763)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov registrovanej partnerskej aplik\00E1cie sa v sch\00E9me autentifik\00E1cie nena\0161iel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532316457401778)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FAto aplik\00E1ciu zaregistrujte pod\013Ea popisu v in\0161tala\010Dnej pr\00EDru\010Dke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523305652401771)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das autentifik\00E1cie prihl\00E1senia jedn\00FDm vstupom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632721602401851)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'sk'
,p_message_text=>unistr('Neautorizovan\00E1 adresa URL: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522706750401771)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania autentifik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494790877401749)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pracovn\00FD priestor "%0" je neakt\00EDvny. Kontaktujte administr\00E1tora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495110691401749)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'sk'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501548655401754)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstup zamietnut\00FD na z\00E1klade kontroly zabezpe\010Denia aplik\00E1cie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501627458401754)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstup zamietnut\00FD na z\00E1klade kontroly zabezpe\010Denia str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501702015401754)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania autoriz\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565153166401802)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'sk'
,p_message_text=>unistr('Vytvoren\00E9 %0 s pou\017Eit\00EDm platformy %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565238390401802)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('s l\00E1skou')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623097960401844)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'sk'
,p_message_text=>'Popis udalosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622882980401843)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'sk'
,p_message_text=>unistr('Koncov\00FD d\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623173477401844)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'sk'
,p_message_text=>'ID udalosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622782062401843)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Diato\010Dn\00FD d\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622921587401844)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Nadpis udalosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513507782401764)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba obsahu kontroln\00E9ho s\00FA\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513402634401764)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba form\00E1tu kontroln\00E9ho s\00FA\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577428149401811)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'sk'
,p_message_text=>unistr('Skop\00EDrovan\00E9 do schr\00E1nky.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577116225401810)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'sk'
,p_message_text=>unistr('Tento preh\013Ead\00E1va\010D nepodporuje kop\00EDrovanie z tla\010Didla alebo ponuky. Sk\00FAste stla\010Di\0165 Ctrl+C alebo Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565615257401802)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavrie\0165 upozornenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621649569401843)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'sk'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616193437401839)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616081876401839)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Diato\010Dn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620263572401842)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 platn\00E1 farba. Pr\00EDklad: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615962040401839)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 farbu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616244438401839)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zmeni\0165 form\00E1t farby')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655495793401867)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'sk'
,p_message_text=>unistr('Zoznam hodn\00F4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655571039401868)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'sk'
,p_message_text=>unistr('Otvori\0165 zoznam pre: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635788304401853)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'sk'
,p_message_text=>unistr('(Dokon\010Den\00E9)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528076090401775)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'sk'
,p_message_text=>unistr('Kontaktujte administr\00E1tora aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542477935401785)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kontaktujte administr\00E1tora aplik\00E1cie.'),
unistr('Detaily tohto incidentu z\00EDskate pomocou ID ladenia "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620582389401842)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'sk'
,p_message_text=>unistr('Pred ulo\017Een\00EDm opravte chyby.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566514305401803)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1jden\00E9 zhody: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566498578401803)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161li sa \017Eiadne zhody')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636220670401853)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lny priebeh')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620971700401842)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00E9 pole v polo\017Eke %0 neexistuje v s\00FAboroch APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609441737401834)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lna verzia d\00E1t v datab\00E1ze bola zmenen\00E1, preto\017Ee pou\017E\00EDvate\013E spustil proces aktualiz\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578567913401811)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezavies\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625541943401845)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba predbe\017En\00E9ho spracovania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625358525401845)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlo\017Ei\0165 riadok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639479842401856)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'sk'
,p_message_text=>'Poradie: Akcia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625470010401845)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktualizova\0165 riadok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566953482401803)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozba\013Eovac\00ED kalend\00E1r: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489521501401745)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489646349401745)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625747765401846)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED obsahova\0165 hodnotu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625628108401845)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 platn\00FD d\00E1tum, napr\00EDklad %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493283812401747)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 v rozsahu od %0 do %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493322585401748)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 rovnak\00E9 alebo neskor\0161ie ako %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493439894401748)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 rovnak\00E9 alebo skor\0161ie ako %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570438672401806)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# je nesk\00F4r ako zadan\00FD maxim\00E1lny d\00E1tum %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570809592401806)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# nezodpoved\00E1 form\00E1tu %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570382368401806)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# je sk\00F4r ako zadan\00FD minim\00E1lny d\00E1tum %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570582856401806)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sk'
,p_message_text=>'#LABEL# nie je v platnom rozsahu od %0 do %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570782649401806)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'sk'
,p_message_text=>'#LABEL# nie je v platnom rozsahu rokov od %0 do %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620860507401842)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zru\0161i\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648098028401862)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavrie\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650098749401863)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'sk'
,p_message_text=>'Pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620605432401842)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'sk'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620786673401842)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526968683401774)
,p_name=>'APEX.ERROR'
,p_message_language=>'sk'
,p_message_text=>'Chyba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494342200401748)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Das vykon\00E1vania sp\00E4tn\00E9ho volania rie\0161enia ch\00FDb sa vyskytla nasleduj\00FAca chyba: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503033384401755)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Das ma\013Eovania chybovej str\00E1nky sa vyskytla chyba: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495057625401749)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Intern\00E1 chyba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634887726401852)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kontaktujte administr\00E1tora.'),
unistr('Detaily tohto incidentu z\00EDskate pomocou ID ladenia "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629191934401848)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'sk'
,p_message_text=>unistr('Datab\00E1za je otvoren\00E1 pre pr\00EDstup len na \010D\00EDtanie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659753849401871)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'sk'
,p_message_text=>unistr('ORA-28353: S\00FAbor wallet sa nepodarilo otvori\0165. Pr\00EDstup k d\00E1tam aplik\00E1cie moment\00E1lne nie je mo\017En\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629269782401848)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00E1to str\00E1nka nie je dostupn\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496770190401750)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'sk'
,p_message_text=>unistr('Technick\00E9 inform\00E1cie (vidite\013En\00E9 len pre v\00FDvoj\00E1rov)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592849155401822)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'sk'
,p_message_text=>unistr('Chybov\00E9 hl\00E1senie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606753636401832)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('O\010Dak\00E1van\00FD form\00E1t: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573445033401808)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017E\00EDvate\013E u\017E je v zozname riadenia pr\00EDstupu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573348715401808)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'sk'
,p_message_text=>unistr('Potvr\010Fte pridanie nasleduj\00FAcich %0 pou\017E\00EDvate\013Eov do zoznamu riadenia pr\00EDstupu <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573856346401808)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'sk'
,p_message_text=>unistr('Existuje duplicitn\00FD pou\017E\00EDvate\013E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573515249401808)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'sk'
,p_message_text=>unistr('V e-mailovej adrese ch\00FDba znak zavin\00E1\010Da (@)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573619552401808)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'sk'
,p_message_text=>unistr('V e-mailovej adrese ch\00FDba bodka (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573746070401808)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'sk'
,p_message_text=>unistr('Meno pou\017E\00EDvate\013Ea je pr\00EDli\0161 dlh\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574040743401808)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'sk'
,p_message_text=>unistr('K tejto aplik\00E1cii maj\00FA pr\00EDstup len pou\017E\00EDvatelia definovan\00ED v zozname riadenia pr\00EDstupu do aplik\00E1cie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574164255401808)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Neo\010Dak\00E1van\00E1 hodnota nastavenia riadenia pr\00EDstupu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573972343401808)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'sk'
,p_message_text=>unistr('K tejto aplik\00E1cii maj\00FA pr\00EDstup v\0161etci autentifikovan\00ED pou\017E\00EDvatelia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616723247401839)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Deaktivovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616670043401839)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktivovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616973371401839)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('%0: Je deaktivovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616859857401839)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('%0: Je aktivovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616505961401839)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'sk'
,p_message_text=>unistr('neidentifikovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609626001401834)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Stiahnu\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566197161401802)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Eit\00FD filter %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607255151401832)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Ei\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492113057401747)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pruhov\00FD graf')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619927427401841)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'sk'
,p_message_text=>unistr('In\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492227690401747)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'sk'
,p_message_text=>unistr('Kol\00E1\010Dov\00FD graf')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618630175401840)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Graf'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491966353401747)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607701947401833)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Vymaza\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607817033401833)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Vymaza\0165 v\0161etko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607945014401833)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vymaza\0165 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625119298401845)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec %1, na ktor\00FD odkazuje facet %0, nie je k dispoz\00EDcii alebo nie je autorizovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482303372401740)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyberte filtre, ktor\00E9 sa maj\00FA zobrazi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564355687401801)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det v\00FDsledkov: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564408067401801)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybran\00E9: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567096179401803)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lne filtre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483891999401741)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'sk'
,p_message_text=>'Zoznam filtrov'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623637026401844)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Limit jednozna\010Dnej hodnoty (%0) bol prekro\010Den\00FD pre facet %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609212889401834)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Facet %0 nie je podporovan\00FD pre st\013Apce DATE ani TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607347231401832)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Filtrova\0165 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607459152401832)
,p_name=>'APEX.FS.GO'
,p_message_language=>'sk'
,p_message_text=>unistr('Prejs\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608871626401833)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('rovn\00E1 sa %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492968069401747)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'sk'
,p_message_text=>'obsahuje %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492673990401747)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'sk'
,p_message_text=>unistr('v\00E4\010D\0161ie ako %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492737850401747)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'sk'
,p_message_text=>unistr('v\00E4\010D\0161ie ako alebo rovn\00E9 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492493399401747)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'sk'
,p_message_text=>unistr('men\0161ie ako %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492591787401747)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'sk'
,p_message_text=>unistr('men\0161ie ako alebo rovn\00E9 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492833405401747)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'sk'
,p_message_text=>unistr('za\010D\00EDna sa na %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495393131401749)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tov\00FD typ %0 (%1) pre facet Vstupn\00E9 pole nie je podporovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485517510401742)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'sk'
,p_message_text=>unistr('Facety s viacer\00FDmi hodnotami vy\017Eaduj\00FA datab\00E1zy minim\00E1lne verzie 12.2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609085042401834)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre facet %0 neboli zadan\00E9 \017Eiadne st\013Apce vyh\013Ead\00E1vania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482437365401740)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Eal\0161ie filtre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564512690401801)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diatok rozsahu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608580698401833)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 a\017E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608617851401833)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'sk'
,p_message_text=>'Nad %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608714625401833)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'sk'
,p_message_text=>'Pod %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564694160401801)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'sk'
,p_message_text=>'Koniec rozsahu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627407652401847)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eka ZH #%2 ("%1") pre facet rozsahu %0 je neplatn\00E1 (ch\00FDba odde\013Eova\010D "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608902561401834)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Manu\00E1lny vstup pre facet Rozsah %0 moment\00E1lne nie je podporovan\00FD, preto\017Ee st\013Apec m\00E1 hodnotu DATE alebo TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608274416401833)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'sk'
,p_message_text=>'do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492000777401747)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 graf')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561143299401799)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607662215401833)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607547364401832)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'sk'
,p_message_text=>unistr('H\013Eada\0165...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608420765401833)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491899799401746)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 graf')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608032471401833)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 menej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608172964401833)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 viac')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114608378880401833)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 a viac hviezdi\010Diek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566042768401802)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1vrhy filtra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609158712401834)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Facet Textov\00E9 pole %0 je moment\00E1lne podporovan\00FD len pre st\013Apce NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482226990401740)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD po\010Det riadkov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625217074401845)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tov\00FD typ %0 (%1) nie je podporovan\00FD pre vyh\013Ead\00E1vanie na z\00E1klade facetov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617133732401839)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Prejs\0165 na chybu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574781147401809)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Agregova\0165.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582315381401814)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zbali\0165 funkciu Control Break')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574824822401809)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>'Control Break.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582282294401814)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozbali\0165 funkciu Control Break')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660972181401871)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582079218401814)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det odstr\00E1nen\00FDch riadkov: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652494612401865)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplicitn\00E1 identita')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571731386401807)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575068713401809)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Hlavi\010Dka skupiny.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574951836401809)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Hlavi\010Dka.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571853930401807)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591869601401821)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavies\0165 \010Fal\0161ie riadky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571585744401806)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575101439401809)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Riadky str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571908332401807)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'sk'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572063098401807)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'sk'
,p_message_text=>'%0 - %1 z %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628019757401847)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDber str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571687253401806)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652231219401865)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pridan\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652397226401865)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zmenen\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660750019401871)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Riadok %0, st\013Apec %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660800783401871)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>'Riadok %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652195200401865)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1nen\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575356481401809)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'sk'
,p_message_text=>unistr('Hlavi\010Dka str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570940906401806)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det vybran\00FDch buniek: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572171713401807)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det vybran\00FDch riadkov: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612498388401836)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 v\0161etko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582109778401814)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'sk'
,p_message_text=>unistr('Str\00E1nka %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575275451401809)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 riadok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575428106401809)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Trieden\00E9 vzostupne %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575592039401809)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Trieden\00E9 zostupne %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571056369401806)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 vzostupne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571319564401806)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 vzostupne %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571180287401806)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 zostupne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571460576401806)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 zostupne %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114571294616401806)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'sk'
,p_message_text=>unistr('Netriedi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581905605401814)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'sk'
,p_message_text=>'Celkom %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508385808401760)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eiadavka HTTP "%0" zlyhala.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649698834401863)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDberov\00FD zoznam mrie\017Eky %0 st\013Apcov, %1 riadkov. Pou\017Eite kl\00E1vesy so \0161\00EDpkami.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581858676401814)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDberov\00FD zoznam %0 riadkov. Pou\017Eite kl\00E1vesy so \0161\00EDpkami.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660598265401871)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Interakt\00EDvna mrie\017Eka %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568601377401804)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'sk'
,p_message_text=>'Akcie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569662639401805)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569571395401805)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 riadok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654089376401866)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Agregova\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639562784401856)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Agreg\00E1cia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641287962401857)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161etko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597655280401825)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161etky textov\00E9 st\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598815080401826)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Alternat\00EDvne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599944014401827)
,p_name=>'APEX.IG.AND'
,p_message_language=>'sk'
,p_message_text=>'a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619354597401841)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'sk'
,p_message_text=>unistr('Pribli\017En\00FD po\010Det odli\0161n\00FDch hodn\00F4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655010766401867)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD pribli\017En\00FD po\010Det odli\0161n\00FDch hodn\00F4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638175116401855)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'sk'
,p_message_text=>unistr('Plo\0161n\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640016051401856)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'sk'
,p_message_text=>'Vzostupne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598951704401826)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Autoriz\00E1cia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654145204401866)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'sk'
,p_message_text=>'Automaticky'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619754857401841)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'sk'
,p_message_text=>'Priemer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654791771401867)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD priemer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637696642401854)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nadpis osi ozna\010Denia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637890189401855)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det desatinn\00FDch miest')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637795643401854)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Nadpis osi hodnoty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643883608401859)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'sk'
,p_message_text=>'Farba pozadia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638229845401855)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pruhov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594294015401823)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'sk'
,p_message_text=>'medzi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645033250401860)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'sk'
,p_message_text=>'Oboje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638380688401855)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Bublinov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569860162401805)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zru\0161i\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599802399401827)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozl\00ED\0161i\0165 mal\00E9/VE\013DK\00C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655669500401868)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'sk'
,p_message_text=>unistr('(rozli\0161uje mal\00E9 a ve\013Ek\00E9 p\00EDsmen\00E1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626554168401846)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zmeny ulo\017Een\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570208284401805)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zmeni\0165 zobrazenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600901909401828)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'sk'
,p_message_text=>'Graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597484100401825)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt prekra\010Duje maxim\00E1lny po\010Det %0 d\00E1tov\00FDch bodov na graf. Pou\017Eite filter na zn\00ED\017Eenie po\010Dtu z\00E1znamov v z\00E1kladnom dopyte.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568520195401804)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazenie sch\00E9my')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575891028401810)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Vymaza\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637132039401854)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Koniec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644017906401859)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'sk'
,p_message_text=>'Farby'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620135848401841)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Uk\00E1\017Eka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599248985401826)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568708822401804)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645897623401860)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('\00DA\010Del st\013Apca')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599330659401826)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'sk'
,p_message_text=>unistr('Komplexn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568982398401804)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vypo\010D\00EDta\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594888108401823)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'sk'
,p_message_text=>'obsahuje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601165818401828)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'sk'
,p_message_text=>'Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575622824401809)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'sk'
,p_message_text=>unistr('Skop\00EDrova\0165 do schr\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575768925401809)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'sk'
,p_message_text=>unistr('Kop\00EDrova\0165 nadol')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619173618401841)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619213780401841)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det odli\0161n\00FDch hodn\00F4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654974658401867)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD po\010Det odli\0161n\00FDch hodn\00F4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654884688401867)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD po\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652530180401865)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'sk'
,p_message_text=>unistr('Vytvori\0165 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597866981401825)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645638378401860)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tov\00FD typ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645215667401860)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626378124401846)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 hodnota d\00E1tumu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595514844401823)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'sk'
,p_message_text=>'d.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598541751401826)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00E9 nastavenia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598397263401826)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00FD typ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569707037401805)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646867835401861)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'sk'
,p_message_text=>unistr('Naozaj chcete odstr\00E1ni\0165 t\00FAto zostavu?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602964478401829)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 riadok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601780195401828)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 riadky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640199625401856)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'sk'
,p_message_text=>'Zostupne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600622844401827)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'sk'
,p_message_text=>'Detaily'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568231102401804)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Detailn\00E9 zobrazenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628806795401848)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'sk'
,p_message_text=>'Smer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600368856401827)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Deaktivovan\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594904742401823)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'sk'
,p_message_text=>'neobsahuje'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595136826401823)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'sk'
,p_message_text=>unistr('neza\010D\00EDna znakom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638446774401855)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prstencov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601362970401828)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'sk'
,p_message_text=>unistr('Stiahnu\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500061456401752)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'sk'
,p_message_text=>unistr('Len d\00E1ta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647838887401862)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 form\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512637386401763)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Form\00E1t na stiahnutie %0 nie je aktivovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640855736401857)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplikova\0165 agreg\00E1ciu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640974638401857)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplikova\0165 funkciu Control Break')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602897076401829)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplikova\0165 riadok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601688930401828)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplikova\0165 riadky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569317081401805)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639919281401856)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 graf')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651471505401864)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 skupinu pod\013Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647434678401862)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'sk'
,p_message_text=>unistr('Skryt\00E1 k\00F3pia (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647629788401862)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'sk'
,p_message_text=>unistr('Spr\00E1va')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647307988401861)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'sk'
,p_message_text=>unistr('K\00F3pia (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647053905401861)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'sk'
,p_message_text=>unistr('E-mail bol odoslan\00FD.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647540439401862)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'sk'
,p_message_text=>'Predmet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647206326401861)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDjemca (komu)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600016827401827)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktivovan\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593210281401822)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'sk'
,p_message_text=>unistr('rovn\00E1 sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646432350401861)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDklad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600185807401827)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646370821401861)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'sk'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612345120401836)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAbor je pripraven\00FD. Sp\00FA\0161\0165a sa s\0165ahovanie.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114575910189401810)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDpl\0148')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577054501401810)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDber v\00FDplne s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576926714401810)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDber v\00FDplne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568874580401804)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Filtrova\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599491321401826)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'sk'
,p_message_text=>'Filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654479663401867)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Filtrova\0165...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640380710401856)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'sk'
,p_message_text=>unistr('Prv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569023774401805)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'sk'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597993041401825)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Form\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644931978401860)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'sk'
,p_message_text=>unistr('Maska form\00E1tu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646743646401861)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'sk'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646618052401861)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'sk'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559444816401798)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'sk'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498780298401752)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'sk'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602593151401829)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zmrazi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600239544401827)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'sk'
,p_message_text=>unistr('Funkcie a oper\00E1tory')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638512245401855)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Lievikov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619046282401841)
,p_name=>'APEX.IG.GO'
,p_message_language=>'sk'
,p_message_text=>unistr('Prejs\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593824794401822)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'sk'
,p_message_text=>unistr('je v\00E4\010D\0161ie ako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593974769401822)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'sk'
,p_message_text=>unistr('je v\00E4\010D\0161ie alebo rovnak\00E9 ako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600565428401827)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'sk'
,p_message_text=>unistr('Mrie\017Eka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568073105401804)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazenie mrie\017Eky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641121867401857)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'sk'
,p_message_text=>'Skupina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600755106401827)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Zoskupi\0165 pod\013Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568385455401804)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazenie Zoskupi\0165 pod\013Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645598969401860)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'sk'
,p_message_text=>'Typ podmienky'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644464084401859)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'sk'
,p_message_text=>unistr('Z\00E1hlavie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644658009401860)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'sk'
,p_message_text=>unistr('Zarovnanie z\00E1hlavia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654385658401867)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'sk'
,p_message_text=>'Pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649865915401863)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>V r\00E1mci tejto interakt\00EDvnej mrie\017Eky m\00F4\017Eete priamo vklada\0165, aktualizova\0165 a odstra\0148ova\0165 d\00E1ta.</p>'),
'',
unistr('<p>Kliknut\00EDm na tla\010Didlo Prida\0165 riadok vlo\017Ete nov\00FD riadok.</p>'),
'',
unistr('<p>Dvojit\00FDm kliknut\00EDm na konkr\00E9tnu bunku upravte existuj\00FAce d\00E1ta. Pri v\00E4\010D\0161\00EDch \00FAprav\00E1ch prejdite kliknut\00EDm na polo\017Eku Upravi\0165 do re\017Eimu \00FAprav. V re\017Eime \00FAprav m\00F4\017Eete kliknut\00EDm alebo pou\017Eit\00EDm kl\00E1vesnice upravi\0165 konkr\00E9tne bunky.</p>'),
'',
unistr('<p>Pomocou ponuky Zmeni\0165 m\00F4\017Eete duplikova\0165 a odstr\00E1ni\0165 riadky. Ponuku Zmeni\0165 aktivujete v\00FDberom jedn\00E9ho alebo viacer\00FDch riadkov pomocou za\010Diarkavac\00EDch pol\00ED.</p>'),
'',
unistr('<p>Duplikujte vybran\00FD riadok kliknut\00EDm na ponuku Zmeni\0165 a v\00FDberom polo\017Eky Duplikova\0165 riadky. Kliknut\00EDm na ponuku Zmeni\0165 a v\00FDberom polo\017Eky Odstr\00E1ni\0165 riadok odstr\00E1\0148te vybran\00FD riadok.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651969626401865)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'sk'
,p_message_text=>unistr('Funkcie \00FApravy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652064235401865)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interakt\00EDvna mrie\017Eka predstavuje mno\017Einu d\00E1t v preh\013Ead\00E1vate\013Enej a prisp\00F4sobite\013Enej zostave. M\00F4\017Eete vykona\0165 mnoho oper\00E1ci\00ED a obmedzi\0165 po\010Det vr\00E1ten\00FDch z\00E1znamov alebo zmeni\0165 zobrazenie d\00E1t.</p>'),
'',
unistr('<p>Pomocou po\013Ea H\013Eada\0165 m\00F4\017Eete filtrova\0165 vr\00E1ten\00E9 z\00E1znamy. Kliknut\00EDm na polo\017Eku Akcie z\00EDskate viacer\00E9 vo\013Eby na zmenu rozlo\017Eenia zostavy alebo pou\017Eite ponuky Z\00E1hlavie st\013Apca pre zobrazen\00E9 st\013Apce.</p>'),
'',
unistr('<p>Pomocou polo\017Eky Nastavenia zostavy m\00F4\017Eete ulo\017Ei\0165 prisp\00F4sobenia zostavy. D\00E1ta tie\017E m\00F4\017Eete stiahnu\0165 zo zostavy do extern\00E9ho s\00FAboru alebo posla\0165 e-mailom sebe alebo in\00FDm pou\017E\00EDvate\013Eom.</p>'),
'',
unistr('<p>\010Eal\0161ie inform\00E1cie n\00E1jdete v \010Dasti "Using Interactive Reports" (Pou\017E\00EDvanie interakt\00EDvnych zost\00E1v) v pr\00EDru\010Dke <em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651767986401865)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'sk'
,p_message_text=>unistr('Preh\013Ead')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649790774401863)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou zabudovan\00FDch funkci\00ED m\00F4\017Eete prisp\00F4sobi\0165 interakt\00EDvnu mrie\017Eku tak, aby zobrazovala d\00E1ta r\00F4znymi sp\00F4sobmi.</p>'),
'',
unistr('<p>Pomocou pon\00FAk Z\00E1hlavie st\013Apca alebo Akcie m\00F4\017Eete ur\010Di\0165, ktor\00E9 st\013Apce chcete zobrazi\0165 a v akom porad\00ED, a m\00F4\017Eete tie\017E zmrazi\0165 st\013Apce. M\00F4\017Eete definova\0165 aj r\00F4zne filtre d\00E1t a triedi\0165 vr\00E1ten\00E9 d\00E1ta.</p>'),
'',
unistr('<p>Pomocou tla\010Didla Zobrazi\0165 (ved\013Ea tla\010Didla H\013Eada\0165) z\00EDskate pr\00EDstup k \010Fal\0161\00EDm zobrazen\00EDm d\00E1t, ktor\00E9 definoval v\00FDvoj\00E1r aplik\00E1cie. \010Ealej m\00F4\017Eete vytvori\0165 graf alebo zobrazi\0165 existuj\00FAci graf.</p>  '),
'',
unistr('<p><em>Pozn\00E1mka: Kliknut\00EDm na polo\017Eku <strong>Pomoc</strong> v dial\00F3gu interakt\00EDvnej mrie\017Eky z\00EDskate podrobnej\0161ie inform\00E1cie o vybranej funkcii.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651881590401865)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'sk'
,p_message_text=>'Funkcie vykazovania'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601595073401828)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre interakt\00EDvnu mrie\017Eku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648651271401862)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete agregova\0165 st\013Apce. Agregovan\00E9 hodnoty sa zobrazuj\00FA v dolnej \010Dasti d\00E1t alebo v dolnej \010Dasti ka\017Ed\00E9ho zlomu, pokia\013E s\00FA aktivovan\00E9 znaky Control Break.</p>'),
'',
unistr('<p><strong>Zoznam agreg\00E1ci\00ED</strong><br>'),
unistr('Zoznam agreg\00E1ci\00ED zobrazuje definovan\00E9 agreg\00E1cie. Existuj\00FAcu agreg\00E1ciu deaktivujete tak, \017Ee zru\0161\00EDte jej v\00FDber.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Prida\0165 (&plus;) vytvor\00EDte nov\00FA agreg\00E1ciu a kliknut\00EDm na polo\017Eku Odstr\00E1ni\0165 (&minus;) odoberiete existuj\00FAcu agreg\00E1ciu.</p>'),
'',
unistr('<p><strong>Nastavenia agreg\00E1cie</strong><br>'),
unistr('Pomocou formul\00E1ra vpravo definujete agreg\00E1ciu.<br>'),
unistr('Vyberte n\00E1zov st\013Apca a typ agreg\00E1cie.<br>'),
unistr('M\00F4\017Eete zada\0165 popis agreg\00E1cie.<br>'),
unistr('Ak ste definovali znak Control Break, v\00FDberom polo\017Eky <strong>Zobrazi\0165 celkov\00FA hodnotu</strong> sa v dolnej \010Dasti d\00E1t zobraz\00ED celkov\00E1 priemern\00E1 hodnota, celkov\00E1 hodnota alebo podobn\00E1 hodnota.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Pr\00EDstup do dial\00F3gov\00E9ho okna Agreg\00E1cia je mo\017En\00FD cez ponuku Akcie alebo kliknut\00EDm na z\00E1hlavie st\013Apca a s\00FA\010Det (&sum;).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650833755401864)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre agreg\00E1ciu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649300264401863)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete definova\0165 graf, ktor\00FD sa zobraz\00ED ako samostatn\00E9 zobrazenie d\00E1t.<br>'),
unistr('Vyberte typ grafu a atrib\00FAty grafu.</p>'),
unistr('<p><strong>Atrib\00FAty grafu</strong></br>'),
unistr('Dostupn\00E9 atrib\00FAty grafu sa l\00ED\0161ia v z\00E1vislosti od typu grafu.</p>'),
'<p>',
'<ul>',
unistr('  <li>Vyberte st\013Apec, ktor\00FD obsahuje hodnotu pre atrib\00FAt:'),
'    <ul>',
unistr('      <li>Ozna\010Denie - text pre jednotliv\00E9 d\00E1tov\00E9 body.</li>'),
unistr('      <li>Hodnota - d\00E1ta, ktor\00E9 sa maj\00FA zakresli\0165.</li>'),
unistr('      <li>S\00E9ria - na definovanie dynamick\00E9ho dopytu s viacer\00FDmi s\00E9riami.</li>'),
unistr('      <li>Za\010Diatok - denn\00E1 po\010Diato\010Dn\00E1 cena akci\00ED (len burzov\00E9 grafy).</li>'),
unistr('      <li>Koniec - denn\00E1 z\00E1vere\010Dn\00E1 cena akci\00ED (len burzov\00E9 grafy).</li>'),
unistr('      <li>Maximum - maxim\00E1lna hodnota (len grafy rozsahu a burzov\00E9 grafy).</li>'),
unistr('      <li>Minimum - minim\00E1lna hodnota (len grafy rozsahu a burzov\00E9 grafy).</li>'),
unistr('      <li>Objem - denn\00FD objem akci\00ED (len burzov\00E9 grafy).</li>'),
unistr('      <li>Cie\013E - cie\013Eov\00E1 hodnota (len lievikov\00FD graf).</li>'),
unistr('      <li>X - hodnota osi X (len bublinov\00E9 a rozptylov\00E9 grafy).</li>'),
unistr('      <li>Y - hodnota osi Y (len bublinov\00E9 a rozptylov\00E9 grafy).</li>'),
unistr('      <li>Z - \0161\00EDrka pruhu alebo polomer bubliny (len pruhov\00E9 a bublinov\00E9 grafy a grafy rozsahu).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Orient\00E1cia - zvisle alebo vodorovne.</li>'),
unistr('  <li>Agreg\00E1cia - vyberte sp\00F4sob agreg\00E1cie hodn\00F4t grafu.</li>'),
unistr('  <li>Kumulovan\00FD - zadajte, \010Di sa maj\00FA d\00E1tov\00E9 polo\017Eky kumulova\0165.</li>'),
unistr('  <li>Triedi\0165 pod\013Ea - triedi\0165 pod\013Ea ozna\010Denia alebo hodn\00F4t.'),
'    <ul>',
unistr('      <li>Smer - vzostupn\00E9 alebo zostupn\00E9 triedenie hodn\00F4t.</li>'),
unistr('      <li>Hodnoty null - zadajte, ako sa maj\00FA triedi\0165 z\00E1znamy s hodnotami null vo vz\0165ahu k z\00E1znamom s hodnotami in\00FDmi ako null.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Desatinn\00E9 miesta</li>'),
unistr('  <li>Nadpis osi ozna\010Denia</li>'),
'  <li>Nadpis osi hodnoty</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651228663401864)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648318203401862)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete vybra\0165, ktor\00E9 st\013Apce a v akom porad\00ED sa zobrazia.</p>'),
'',
unistr('<p>St\013Apec skryjete tak, \017Ee zru\0161\00EDte jeho v\00FDber.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Presun\00FA\0165 nahor (&uarr;) alebo Presun\00FA\0165 nadol (&darr;) m\00F4\017Eete zmeni\0165 poradie st\013Apcov.<br>'),
unistr('Pomocou selektora rozba\013Eovacieho zoznamu zobraz\00EDte v\0161etky st\013Apce, zobrazen\00E9 st\013Apce alebo nezobrazen\00E9 st\013Apce.</p>'),
'',
unistr('<p>Pomocou formul\00E1ra m\00F4\017Eete zada\0165 minim\00E1lnu \0161\00EDrku st\013Apca v pixeloch.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Poradie zobrazen\00FDch st\013Apcov m\00F4\017Eete zmeni\0165 aj kliknut\00EDm na rukov\00E4\0165 pos\00FAvania (na za\010Diatku z\00E1hlavia st\013Apca) a potiahnut\00EDm st\013Apca do\013Eava alebo doprava. Zmeni\0165 m\00F4\017Eete aj \0161\00EDrku zobrazen\00FDch st\013Apcov, a to v\00FDberom odde\013Eova\010Da st\013Apca medzi z\00E1h')
||unistr('laviami a jeho posunut\00EDm do\013Eava alebo doprava.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651134108401864)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre st\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648745689401862)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete definova\0165 \010Fal\0161ie st\013Apce na z\00E1klade matematick\00FDch a funk\010Dn\00FDch v\00FDpo\010Dtov vykonan\00FDch pre existuj\00FAce st\013Apce.</p>'),
'',
unistr('<p><strong>Zoznam v\00FDpo\010Dtov</strong><br>'),
unistr('Zoznam v\00FDpo\010Dtov zobrazuje definovan\00E9 v\00FDpo\010Dty. Existuj\00FAci v\00FDpo\010Det deaktivujete tak, \017Ee zru\0161\00EDte jeho v\00FDber.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Prida\0165 (&plus;) prid\00E1te nov\00FD v\00FDpo\010Det a kliknut\00EDm na polo\017Eku Odstr\00E1ni\0165 (&minus;) odoberiete existuj\00FAci v\00FDpo\010Det.</p>'),
'',
unistr('<p><strong>Nastavenia v\00FDpo\010Dtu</strong><br>'),
unistr('Pomocou tohto formul\00E1ra definujete v\00FDpo\010Det.<br>'),
unistr('Zadajte detaily st\013Apca, napr\00EDklad ozna\010Denie z\00E1hlavia, a vyberte nastavenia zarovnania.<br> '),
unistr('Pomocou textovej oblasti V\00FDraz zad\00E1te st\013Apce a priraden\00E9 funkcie pre v\00FDpo\010Det.<br>'),
unistr('Pre nov\00FD st\013Apec vyberte pr\00EDslu\0161n\00FD d\00E1tov\00FD typ aj masku form\00E1tu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650730259401864)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre v\00FDpo\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649099876401863)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete definova\0165 znak Control Break pre jeden alebo viacero st\013Apcov.</p>'),
'',
'<p><strong>Zoznam Control Break</strong><br>',
unistr('Zoznam Control Break zobrazuje definovan\00E9 znaky Control Break. Existuj\00FAci st\013Apec Control Break deaktivujete tak, \017Ee zru\0161\00EDte jeho v\00FDber.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Prida\0165 (&plus;) prid\00E1te do Control Break nov\00FD st\013Apec alebo kliknut\00EDm na polo\017Eku Odstr\00E1ni\0165 (&minus;) odoberiete z Control Break existuj\00FAci st\013Apec.<br>'),
unistr('Ak chcete zmeni\0165 poradie st\013Apcov, kliknite na polo\017Eku Presun\00FA\0165 nahor (&uarr;) alebo Presun\00FA\0165 nadol (&darr; ) a presu\0148te vybran\00FD st\013Apec nad alebo pod ostatn\00E9 st\013Apce.</p>'),
'',
'<p><strong>Nastavenia Control Break</strong><br>',
unistr('Pomocou tohto formul\00E1ra definujete st\013Apec Control Break.<br>'),
unistr('Vybran\00FD st\013Apec Control Break , smer triedenia a sp\00F4sob zoradenia st\013Apcov null (st\013Apcov bez hodnoty).</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Pri zobrazen\00ED interakt\00EDvnej mrie\017Eky m\00F4\017Eete definova\0165 Control Break kliknut\00EDm na z\00E1hlavie st\013Apca a v\00FDberom ikony Control Break.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650455599401864)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649266289401863)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete stiahnu\0165 v\0161etky aktu\00E1lne riadky do extern\00E9ho s\00FAboru. S\00FAbor obsahuje len aktu\00E1lne zobrazen\00E9 st\013Apce a pou\017E\00EDva filtre a triedenia pou\017Eit\00E9 pri d\00E1tach.</p>'),
'',
unistr('<p>Vyberte form\00E1t s\00FAboru a kliknite na polo\017Eku Stiahnu\0165.<br>'),
unistr('Pozn\00E1mka: S\00FAbor CSV nebude obsahova\0165 form\00E1tovanie textu, ako s\00FA agreg\00E1cie a znaky Control Break.</p>'),
'',
unistr('<p>Ak chcete e-mailom odosla\0165 s\00FAbor, vyberte polo\017Eku Odosla\0165 ako e-mail a zadajte detaily e-mailu (pr\00EDjemcu, predmet a spr\00E1vu).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650266802401864)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre s\0165ahovanie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648465929401862)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete konfigurova\0165 filtre d\00E1t, ktor\00E9 obmedzuj\00FA po\010Det vr\00E1ten\00FDch riadkov.</p>'),
'',
'<p><strong>Zoznam filtrov</strong><br>',
unistr('Zoznam filtrov zobrazuje definovan\00E9 filtre. Existuj\00FAci filter deaktivujete tak, \017Ee zru\0161\00EDte jeho v\00FDber.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Prida\0165 (&plus;) vytvor\00EDte nov\00FD filter alebo kliknut\00EDm na polo\017Eku Odstr\00E1ni\0165 (&minus;) odoberiete existuj\00FAci filter.</p>'),
'',
'<p><strong>Nastavenia filtra</strong><br>',
unistr('Pomocou tohto formul\00E1ra definujete vlastnosti filtra.<br>'),
unistr('Vyberte pr\00EDslu\0161n\00FD typ filtra:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Riadok - filtrovanie v\00FDrazu v ka\017Edom filtrovate\013Eom st\013Apci.<br>'),
unistr('&nbsp;&nbsp;&nbsp;St\013Apec - filtrovanie konkr\00E9tneho st\013Apca so zadan\00FDm oper\00E1torom a hodnotou.</p>'),
'',
unistr('<p><em>Pozn\00E1mka: Po\010Das zobrazenia interakt\00EDvnej mrie\017Eky m\00F4\017Eete zadan\00EDm priamo do po\013Ea H\013Eada\0165 definova\0165 filtre riadkov. Kliknut\00EDm na polo\017Eku Vybra\0165 st\013Apce na vyh\013Ead\00E1vanie obmedz\00EDte vyh\013Ead\00E1vanie na konkr\00E9tny st\013Apec. Alternat\00EDvne m\00F4\017Eete vytvori\0165 filter ')
||unistr('st\013Apca tak, \017Ee otvor\00EDte ponuku Z\00E1hlavie st\013Apca a vyberiete hodnotu.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651066407401864)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre filtrovanie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648839245401863)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete zobrazi\0165 d\00E1ta, ako existovali v predch\00E1dzaj\00FAcom \010Dasovom bode.</p>'),
unistr('<p>Na vykonanie dopytu na flashback zadajte po\010Det min\00FAt v minulosti.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650618748401864)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651383051401864)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre zoskupenie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648930649401863)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete zv\00FDrazni\0165 riadky alebo st\013Apce d\00E1t na z\00E1klade zadanej podmienky.</p>'),
'',
unistr('<p><strong>Zoznam zv\00FDraznen\00ED</strong><br>'),
unistr('Zoznam zv\00FDraznen\00ED zobraz\00ED definovan\00E9 zv\00FDraznenia. Existuj\00FAce zv\00FDraznenie deaktivujete tak, \017Ee zru\0161\00EDte jeho v\00FDber.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Prida\0165 (&plus;) vytvor\00EDte nov\00E9 zv\00FDraznenie a kliknut\00EDm na polo\017Eku Odstr\00E1ni\0165 (&minus;) odoberiete existuj\00FAce zv\00FDraznenie.</p>'),
'',
unistr('<p><strong>Nastavenia zv\00FDraznenia</strong><br>'),
unistr('Pomocou tohto formul\00E1ra definujete vlastnosti zv\00FDraznenia.<br>'),
unistr('Zadajte n\00E1zov, vyberte polo\017Eku Riadok alebo St\013Apec a vyberte farebn\00E9 ozna\010Denie HTML pre pozadie a text.<br>'),
unistr('Vyberte pr\00EDslu\0161n\00FD <strong>Typ podmienky</strong> na zv\00FDraznenie konkr\00E9tnych d\00E1t:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Riadok - zv\00FDraznenie term\00EDnu v ka\017Edom st\013Apci.<br>'),
unistr('&nbsp;&nbsp;&nbsp;St\013Apec - zv\00FDraznenie v r\00E1mci konkr\00E9tneho st\013Apca na z\00E1klade zadan\00E9ho oper\00E1tora a hodnoty.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650513468401864)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre zv\00FDraznenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649127242401863)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete ulo\017Ei\0165 vykonan\00E9 zmeny aktu\00E1lneho rozlo\017Eenia a konfigur\00E1cie mrie\017Eky.<br>'),
unistr('V\00FDvoj\00E1ri aplik\00E1ci\00ED m\00F4\017Eu definova\0165 viacer\00E9 alternat\00EDvne rozlo\017Eenia zost\00E1v. Tam kde je to povolen\00E9, m\00F4\017Eete vy a \010Fal\0161\00ED koncov\00ED pou\017E\00EDvatelia ulo\017Ei\0165 zostavu ako verejn\00FA, v\010Faka \010Domu bude dostupn\00E1 v\0161etk\00FDm pou\017E\00EDvate\013Eom mrie\017Eky. Zostavu m\00F4\017Eete ulo\017Ei\0165 aj ako s')
||unistr('\00FAkromn\00FA a budete ju m\00F4c\0165 zobrazi\0165 len vy.</p>'),
unistr('<p>Vyberte z dostupn\00FDch typov a zadajte n\00E1zov ulo\017Eenej zostavy.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650399092401864)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Pomoc pre zostavu',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648589187401862)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pomocou tohto dial\00F3gov\00E9ho okna m\00F4\017Eete nastavi\0165 poradie zobrazenia.</p>'),
'',
'<p><strong>Zoznam triedenia</strong><br>',
unistr('Dial\00F3gov\00E9 okno Triedi\0165 zobrazuje zoznam konfigurovan\00FDch pravidiel triedenia.<br>'),
unistr('Kliknut\00EDm na polo\017Eku Prida\0165 (&plus;) vytvor\00EDte st\013Apec triedenia a kliknut\00EDm na polo\017Eku Odstr\00E1ni\0165 (&minus;) st\013Apec triedenia odoberiete.<br>'),
unistr('Kliknut\00EDm na polo\017Eky Presun\00FA\0165 nahor (&uarr;) a Presun\00FA\0165 nadol (&darr;) presuniete vybran\00FD st\013Apec triedenia nad alebo pod ostatn\00E9 st\013Apce triedenia.</p>'),
'',
'<p><strong>Nastavenia triedenia</strong><br>',
unistr('Vyberte st\013Apec triedenia, smer triedenia a sp\00F4sob zoradenia st\013Apcov null (st\013Apcov bez hodnoty).</p>'),
'',
unistr('<p><em>Pozn\00E1mka: D\00E1ta sa m\00F4\017Eu triedi\0165 pod\013Ea st\013Apcov, ktor\00E9 nie s\00FA zobrazen\00E9, ale triedenie nemus\00ED by\0165 mo\017En\00E9 pre v\0161etky st\013Apce.</em><br>'),
unistr('<em>Zobrazen\00E9 st\013Apce sa m\00F4\017Eu triedi\0165 stla\010Den\00EDm \0161\00EDpok nahor (vzostupne) alebo nadol (zostupne) na konci z\00E1hlavia st\013Apcov. Ak chcete do existuj\00FAceho triedenia prida\0165 n\00E1sledn\00FD st\013Apec, podr\017Ete kl\00E1ves Shift a kliknite na \0161\00EDpku nahor alebo nadol.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650993095401864)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre triedenie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114650158003401863)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Pomoc pre odber'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602454224401829)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'sk'
,p_message_text=>unistr('Skry\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569236810401805)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zv\00FDrazni\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637264962401854)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638093490401855)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'sk'
,p_message_text=>'Vodorovne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595483160401823)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'sk'
,p_message_text=>'hod.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600405625401827)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'sk'
,p_message_text=>'Ikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568144681401804)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'sk'
,p_message_text=>'Zobrazenie ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593688723401822)
,p_name=>'APEX.IG.IN'
,p_message_language=>'sk'
,p_message_text=>'je v'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602097741401828)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'sk'
,p_message_text=>unistr('Neakt\00EDvne nastavenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602180227401829)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Neakt\00EDvne nastavenia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609781295401834)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Das spracovania po\017Eiadavky na interakt\00EDvnu mrie\017Eku sa vyskytla intern\00E1 chyba.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505599917401757)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Typ filtra st\013Apca "%0" pre st\013Apec "%1" nie je podporovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649909376401863)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD form\00E1t d\00E1tumu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624136493401844)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Interakt\00EDvna mrie\017Eka nepodporuje definovanie filtra pre st\013Apec %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624071428401844)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je platn\00FD typ filtra na definovanie filtra interakt\00EDvnej mrie\017Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510650677401762)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD form\00E1t \010D\00EDsla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652667883401865)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E9 nastavenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652772211401865)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E9 nastavenia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643736952401859)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnota Triedi\0165 pod\013Ea bola nastaven\00E1 na %0, ale pre %0 nebol vybran\00FD \017Eiadny st\013Apec.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641093430401857)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 hodnota')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636148445401853)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezobrazen\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594478512401823)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'sk'
,p_message_text=>'je v posl.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594670714401823)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'sk'
,p_message_text=>'je v nasl.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593589118401822)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('nie je pr\00E1zdne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593401811401822)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('je pr\00E1zdne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644544935401859)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636506382401854)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640494905401857)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583718492401815)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00FD de\0148')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583907755401815)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00E1 hodina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584476473401816)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00E1 min\00FAta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583421373401815)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'sk'
,p_message_text=>unistr('Minul\00FD mesiac')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583523348401815)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('Minul\00FD t\00FD\017Ede\0148')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583654217401815)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 d.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583800874401815)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 hod.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584506671401816)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 min.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584355269401816)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 mes.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584254994401815)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('Posl. %0 t\00FD\017E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583280863401815)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 r.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583316487401815)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Minul\00FD rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644722045401860)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'sk'
,p_message_text=>'Zarovnanie bunky'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644835746401860)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Ei\0165 skupinu pre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594085875401822)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'sk'
,p_message_text=>unistr('je men\0161ie ako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594166325401822)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'sk'
,p_message_text=>unistr('je men\0161ie alebo rovnak\00E9 ako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638670736401855)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ciarov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638722218401855)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ciarov\00FD s plochou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645181699401860)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'sk'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637389241401854)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647764448401862)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'sk'
,p_message_text=>unistr('Viacer\00E9 adresy odde\013Ete \010Diarkami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595239094401823)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('zodpoved\00E1 regul\00E1rnemu v\00FDrazu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619674766401841)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'sk'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655225124401867)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00E9 maximum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619870322401841)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'sk'
,p_message_text=>unistr('Medi\00E1n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655364552401867)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD medi\00E1n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619561914401841)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'sk'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595338647401823)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'sk'
,p_message_text=>'min.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620383131401842)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'sk'
,p_message_text=>'min. dozadu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655113446401867)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00E9 minimum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595767710401824)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'sk'
,p_message_text=>'mes.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602378897401829)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta obsahuj\00FA viac ako %0 riadkov, \010Do prekra\010Duje maxim\00E1lny povolen\00FD po\010Det. Ak chcete zobrazi\0165 v\00FDsledky, pou\017Eite \010Fal\0161ie filtre.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629099792401848)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Je potrebn\00E9 zada\0165 statick\00E9 ID oblasti, preto\017Ee str\00E1nka obsahuje viacero interakt\00EDvnych mrie\017Eok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598439549401826)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598656435401826)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomenovan\00E1 zostava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582687233401814)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci de\0148')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582446167401814)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAca hodina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584628250401816)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAca min\00FAta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582977487401815)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci mesiac')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582838133401815)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci t\00FD\017Ede\0148')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582730234401814)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 d.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114582574164401814)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 hod.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584738238401816)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 min.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584070586401815)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 mes.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584140026401815)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasl. %0 t\00FD\017E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583150827401815)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 r.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114583039941401815)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci rok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594377392401823)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'sk'
,p_message_text=>'nie medzi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593371241401822)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'sk'
,p_message_text=>unistr('nerovn\00E1 sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659505902401870)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Oblas\0165 s ID %0 nie je oblas\0165 interakt\00EDvnej mrie\017Eky alebo neexistuje v aplik\00E1cii %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593740646401822)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'sk'
,p_message_text=>'nie je v'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594572243401823)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'sk'
,p_message_text=>'nie je v posl.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114594765706401823)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'sk'
,p_message_text=>'nie je v nasl.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602280967401829)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161li sa \017Eiadne d\00E1ta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640298763401856)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'sk'
,p_message_text=>'Hodnoty Null'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645312450401860)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'sk'
,p_message_text=>unistr('Numerick\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640574628401857)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'sk'
,p_message_text=>'Vyp.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640668667401857)
,p_name=>'APEX.IG.ON'
,p_message_language=>'sk'
,p_message_text=>'Zap.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592536091401821)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('pred 1 min\00FAtou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648251119401862)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'sk'
,p_message_text=>unistr('Otvori\0165 v\00FDber farby: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637020163401854)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diatok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599548763401827)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Oper\00E1tor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636443804401853)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Orient\00E1cia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638888617401855)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'sk'
,p_message_text=>unistr('Kol\00E1\010Dov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114600873504401828)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'sk'
,p_message_text=>unistr('Kontingen\010Dn\00E1 zostava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114568461837401804)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Kontingen\010Dn\00E9 zobrazenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114648137078401862)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnoty odde\013Ete pomocou "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114638908055401855)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pol\00E1rny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644247836401859)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'sk'
,p_message_text=>'Stred'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644327858401859)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'sk'
,p_message_text=>'Koniec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114644181499401859)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diatok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598775271401826)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'sk'
,p_message_text=>unistr('Prim\00E1rne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599050962401826)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prim\00E1rne predvolen\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615556774401838)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prim\00E1rna zostava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497773810401751)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zahrn\00FA\0165 zna\010Dky pr\00EDstupnosti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496453433401750)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'sk'
,p_message_text=>unistr('Na \0161\00EDrku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496518719401750)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'sk'
,p_message_text=>unistr('Na v\00FD\0161ku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496325318401750)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'sk'
,p_message_text=>unistr('Orient\00E1cia str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496204687401750)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'sk'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496166414401750)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'sk'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497850762401751)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlastn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495929783401749)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'sk'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495848152401749)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'sk'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496031130401750)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'sk'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495779545401749)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ve\013Ekos\0165 str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485930061401742)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 form\00E1tovanie RTF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639007100401855)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Radarov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639145064401856)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozsahov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649444693401863)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603083288401829)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovi\0165 riadok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601808997401828)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovi\0165 riadky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607094925401832)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Oblas\0165 interakt\00EDvnej mrie\017Eky neexistuje v aplik\00E1cii %0, na str\00E1nke %1 a v oblasti %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569947896401805)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598121024401825)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'sk'
,p_message_text=>'Zostava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658709754401870)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zostava odstr\00E1nen\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658424385401870)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Alternat\00EDvna zostava ulo\017Een\00E1 pre v\0161etk\00FDch pou\017E\00EDvate\013Eov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658339052401870)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00E1 zostava ulo\017Een\00E1 pre v\0161etk\00FDch pou\017E\00EDvate\013Eov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658603807401870)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAkromn\00E1 zostava ulo\017Een\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658509120401870)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'sk'
,p_message_text=>unistr('Verejn\00E1 zostava ulo\017Een\00E1 pre v\0161etk\00FDch pou\017E\00EDvate\013Eov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114607143287401832)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E1 interakt\00EDvna mrie\017Eka s n\00E1zvom %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592440346401821)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta zostavy spred %0 min\00FAt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592304022401821)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta zostavy spred 1 min\00FAty')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532009517401777)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Zostava interakt\00EDvnej mrie\017Eky neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651671003401865)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zostava - upravi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606929558401832)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E1 interakt\00EDvna mrie\017Eka s ID %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114651536561401864)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'sk'
,p_message_text=>unistr('Zostava - ulo\017Ei\0165 ako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570080216401805)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>'Nastavenia zostavy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659613546401871)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E1 interakt\00EDvna mrie\017Eka so statick\00FDm ID %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654532661401867)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'sk'
,p_message_text=>'Zobrazenie zostavy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569140734401805)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603173906401829)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'sk'
,p_message_text=>unistr('Vr\00E1ti\0165 zmeny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601966773401828)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('Vr\00E1ti\0165 riadky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599104314401826)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'sk'
,p_message_text=>'Riadok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598099969401825)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det riadkov na str\00E1nku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659206957401870)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'sk'
,p_message_text=>'Akcie pre riadok'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660449240401871)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'sk'
,p_message_text=>'Akcie pre riadok %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114569447746401805)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612110408401836)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'sk'
,p_message_text=>unistr('ulo\017Een\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567696905401804)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E9 zostavy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567703664401804)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542295248401785)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov ulo\017Eenej zostavy %0 u\017E existuje. Zadajte nov\00FD n\00E1zov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567831762401804)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAkromn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567915852401804)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'sk'
,p_message_text=>unistr('Verejn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654225932401867)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165 ako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601211151401828)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165 nastavenia zostavy')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639262274401856)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozptylov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567524926401803)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646573443401861)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Ead\00E1vanie: V\0161etky textov\00E9 st\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567478020401803)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645756046401860)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Ead\00E1vanie: Cel\00FD text')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592220838401821)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'sk'
,p_message_text=>unistr('H\013Eada\0165 "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635801245401853)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576071922401810)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDber')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628739477401848)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'sk'
,p_message_text=>'Vyberte jeden riadok v hlavnej oblasti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567347252401803)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 st\013Apce na vyh\013Ead\00E1vanie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658956300401870)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'sk'
,p_message_text=>unistr('Akcie v\00FDberu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576274988401810)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDber bunky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576157540401810)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDber riadka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647131096401861)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165 ako elektronick\00FA po\0161tu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639651807401856)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00E9ria')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565386895401802)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617979536401840)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 celkov\00FA hodnotu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602793169401829)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazenie jedn\00E9ho riadka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601017863401828)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639722352401856)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 pod\013Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659331931401870)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('M\00F4\017Eete definova\0165 len jedno triedenie na st\013Apec.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659180087401870)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('Ponuka Zmeni\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114640777512401857)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'sk'
,p_message_text=>unistr('Z\00E1sobn\00EDk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595069379401823)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'sk'
,p_message_text=>unistr('za\010D\00EDna sa na')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639345324401856)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'sk'
,p_message_text=>unistr('Burzov\00FD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560317702401798)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Roztiahnu\0165 \0161\00EDrky st\013Apcov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114601448598401828)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'sk'
,p_message_text=>'Odber'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114619411270401841)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FA\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660688050401871)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'sk'
,p_message_text=>unistr('Interakt\00EDvna mrie\017Eka: zostava: %0, zobrazenie: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114654693695401867)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00FD s\00FA\010Det')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637503291401854)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Cie\013E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643991170401859)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'sk'
,p_message_text=>'Farba textu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570190278401805)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prepn\00FA\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617872422401840)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'sk'
,p_message_text=>'Popis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114598296142401826)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'sk'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114602697307401829)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zru\0161i\0165 zmrazenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599700246401827)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'sk'
,p_message_text=>'Jednotka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646949537401861)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'sk'
,p_message_text=>unistr('Existuj\00FA neulo\017Een\00E9 zmeny. Chcete pokra\010Dova\0165?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114599691791401827)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'sk'
,p_message_text=>'Hodnota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636674254401854)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Hodnota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641577952401857)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eaduje sa hodnota.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626464278401846)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnota (\010Dasov\00E9 p\00E1smo nemo\017Eno zmeni\0165)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645421325401860)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'sk'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637994737401855)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'sk'
,p_message_text=>'Zvisle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597716507401825)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635970943401853)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazen\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114637479683401854)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Objem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595644202401824)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('t\00FD\017E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636096935401853)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'sk'
,p_message_text=>unistr('Minim\00E1lna \0161\00EDrka st\013Apca (v pixeloch)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586842171401817)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'sk'
,p_message_text=>'%0 je medzi %1 a %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586565621401817)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'sk'
,p_message_text=>'%0 obsahuje %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586684899401817)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'sk'
,p_message_text=>'%0 neobsahuje %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564735498401801)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 sa neza\010D\00EDna na %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585339526401816)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 sa rovn\00E1 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585516768401816)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v\00E4\010D\0161ie ako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585674419401816)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v\00E4\010D\0161ie alebo rovnak\00E9 ako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586366389401817)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'sk'
,p_message_text=>'%0 je v %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587558261401818)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v posledn\00FDch %1 d\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587379938401818)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v posledn\00FDch %1 hodin\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587173748401818)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v posledn\00FDch %1 min\00FAtach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587909935401818)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v posledn\00FDch %1 mesiacoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587714711401818)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v posledn\00FDch %1 t\00FD\017Ed\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588128053401818)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v posledn\00FDch %1 rokoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587426824401818)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'sk'
,p_message_text=>'%0 je v poslednom dni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587280520401818)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'sk'
,p_message_text=>'%0 je v poslednej hodine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587054273401817)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v poslednej min\00FAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587810882401818)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'sk'
,p_message_text=>'%0 je v poslednom mesiaci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114587691188401818)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v poslednom t\00FD\017Edni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588096593401818)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'sk'
,p_message_text=>'%0 je v poslednom roku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589938546401819)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcich %1 d\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589746917401819)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcich %1 hodin\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589546949401819)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcich %1 min\00FAtach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590302237401820)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcich %1 mesiacoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590192149401820)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcich %1 t\00FD\017Ed\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590514911401820)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcich %1 rokoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589899717401819)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcom dni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589610668401819)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcej hodine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589488343401819)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcej min\00FAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590268350401820)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcom mesiaci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590054992401820)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcom t\00FD\017Edni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590406136401820)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je v nasleduj\00FAcom roku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586009963401817)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnota %0 nie je pr\00E1zdna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585926430401817)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnota %0 je pr\00E1zdna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585737562401817)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je men\0161ie ako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585849339401817)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 je men\0161ie alebo rovnak\00E9 ako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586167878401817)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'sk'
,p_message_text=>'%0 je ako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586748688401817)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 zodpoved\00E1 regul\00E1rnemu v\00FDrazu %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592603465401821)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('pred %0 min\00FAtami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586915502401817)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je medzi %1 a %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585496269401816)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 sa nerovn\00E1 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586443219401817)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588723541401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v posledn\00FDch %1 d\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588577832401818)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v posledn\00FDch %1 hodin\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588326944401818)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v posledn\00FDch %1 min\00FAtach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589109312401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v posledn\00FDch %1 mesiacoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588921329401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v posledn\00FDch %1 t\00FD\017Ed\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589310649401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v posledn\00FDch %1 rokoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588667012401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v poslednom dni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588435577401818)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v poslednej hodine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588260934401818)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v poslednej min\00FAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589058214401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v poslednom mesiaci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114588833395401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v poslednom t\00FD\017Edni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114589253035401819)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v poslednom roku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591125229401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcich %1 d\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590978623401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcich %1 hodin\00E1ch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590764485401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcich %1 min\00FAtach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591572089401821)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcich %1 mesiacoch ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591335442401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcich %1 t\00FD\017Ed\0148och')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591768203401821)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcich %1 rokoch')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591082255401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcom dni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590892288401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcej hodine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114590638922401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcej min\00FAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591417455401821)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcom mesiaci')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591226338401820)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcom t\00FD\017Edni')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591603412401821)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je v nasleduj\00FAcom roku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114586243843401817)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je ako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593118240401822)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 sa za\010D\00EDna na %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636747997401854)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595867054401824)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'sk'
,p_message_text=>'r.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636871225401854)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636909529401854)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'sk'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114645923506401860)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'sk'
,p_message_text=>unistr('Pondelok, 12. janu\00E1r 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646029644401861)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'sk'
,p_message_text=>unistr('Janu\00E1r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646111037401861)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'sk'
,p_message_text=>'16 hod. uplynuli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114646257136401861)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'sk'
,p_message_text=>'o 16 hod.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501262380401753)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD typ s\00FAboru. Podporovan\00E9 typy s\00FAborov %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628183130401847)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'sk'
,p_message_text=>unistr('Preh\013Ead\00E1va\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627827722401847)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 s\00FAbor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627977657401847)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 s\00FAbory')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501084893401753)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Presunutie my\0161ou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501495653401754)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 s\00FAbory my\0161ou')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502643204401755)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyberte s\00FAbor alebo sem presu\0148te nejak\00FD s\00FAbor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502721329401755)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyberte s\00FAbory alebo sem presu\0148te nejak\00E9 s\00FAbory.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502810962401755)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyberte s\00FAbor alebo sem presu\0148te nejak\00FD s\00FAbor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502966908401755)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyberte s\00FAbory alebo sem presu\0148te nejak\00E9 s\00FAbory.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501336275401754)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det s\00FAborov: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501168003401753)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAbor je pr\00EDli\0161 ve\013Ek\00FD. Maxim\00E1lna ve\013Ekos\0165 s\00FAboru je %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488950607401744)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Vy\017Eaduje sa adresa.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487847574401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'sk'
,p_message_text=>'Mesto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488271246401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'sk'
,p_message_text=>unistr('K\00F3d krajiny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487987681401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'sk'
,p_message_text=>unistr('\010C\00EDslo domu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488869821401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zemepisn\00E1 \0161\00EDrka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488764450401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zemepisn\00E1 d\013A\017Eka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488610705401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 na mape')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488304167401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Sk\00F3re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488056623401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'sk'
,p_message_text=>unistr('PS\010C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488193260401744)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'sk'
,p_message_text=>unistr('\0160t\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487758434401743)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'sk'
,p_message_text=>'Ulica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487668458401743)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDsledky geok\00F3dovania')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500244678401753)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'sk'
,p_message_text=>unistr('S geok\00F3dom')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500393884401753)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'sk'
,p_message_text=>unistr('Bez geok\00F3du')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488548943401744)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114488456113401744)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161li sa \017Eiadne adresy.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489062277401744)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Vy\017Eaduje sa %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658859526401870)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'sk'
,p_message_text=>'Text pomoci: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552295624401792)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diarknut\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552370082401792)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'sk'
,p_message_text=>unistr('Neza\010Diarknut\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498293238401751)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sk'
,p_message_text=>'#LABEL# nie je v platnom rozsahu od %0 do %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498308321401751)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# nie je n\00E1sobkom hodnoty %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497960986401751)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED zodpoveda\0165 hodnot\00E1m %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498110452401751)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'sk'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576440378401810)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'sk'
,p_message_text=>'Vyp.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576526856401810)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'sk'
,p_message_text=>'Zap.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498036257401751)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('\00C1no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481415609401739)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 polo\017Eku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610600966401835)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610700248401835)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481572383401739)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybran\00E9 polo\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614402078401837)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'sk'
,p_message_text=>unistr('Roz\0161\00EDren\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614761592401838)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zru\0161i\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614509980401838)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161eobecn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614839603401838)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'sk'
,p_message_text=>unistr('Vo\013Eby akt\00EDvnej \0161abl\00F3ny')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615409159401838)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vo\013Eby \0161abl\00F3ny nie s\00FA k dispoz\00EDcii, preto\017Ee tento komponent nie je na str\00E1nke vykreslen\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614377061401837)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161li sa \017Eiadne vo\013Eby \0161abl\00F3ny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614631947401838)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489915705401745)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vymaza\0165 kruh')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491763330401746)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlastn\00E9 \0161t\00FDly nie s\00FA platn\00FD objekt JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490299045401745)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1stroj Vzdialenos\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490081530401745)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nakresli\0165 kruh')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482647885401740)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Ead\00E1vanie na z\00E1klade facetov vy\017Eaduje d\00E1tov\00FD zdroj na \00FArovni oblasti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485222203401742)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lne miesto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486390105401742)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAradnice po\010Diato\010Dnej poz\00EDcie s\00FA neplatn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483708749401741)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Diato\010Dn\00E1 poz\00EDcia mus\00ED by\0165 geometria bodu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486132052401742)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'sk'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484771625401741)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'sk'
,p_message_text=>'Vrstva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618014654401840)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'sk'
,p_message_text=>'Vrstva: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489303241401745)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'sk'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482517512401740)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'sk'
,p_message_text=>unistr('Spr\00E1vy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486288117401742)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'sk'
,p_message_text=>'mi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617004476401839)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta obsahuj\00FA viac ako %0 riadkov, \010Do prekra\010Duje maxim\00E1lny povolen\00FD po\010Det.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484536273401741)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'sk'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Podmienky</a> &nbsp;&nbsp; Map data &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483415431401740)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tov\00FD typ SDO_GEOMETRY v tejto datab\00E1ze nie je dostupn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484613569401741)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'sk'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Prispievatelia OpenStreetMap </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484874216401741)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'sk'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618198835401840)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det bodov: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490181281401745)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'sk'
,p_message_text=>unistr('Pribl\00ED\017Eenie obd\013A\017Enika')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489889825401745)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485167138401742)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165 orient\00E1ciu na sever')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565480379401802)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prepn\00FA\0165 na 2D re\017Eim')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565506759401802)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prepn\00FA\0165 na 3D re\017Eim')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489753540401745)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prepn\00FA\0165 upozornenie o autorsk\00FDch pr\00E1vach')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490301391401745)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'sk'
,p_message_text=>unistr('Celkov\00E1 vzdialenos\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484963781401741)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'sk'
,p_message_text=>unistr('Pribl\00ED\017Ei\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485070246401742)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'sk'
,p_message_text=>unistr('Oddiali\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612517300401836)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'sk'
,p_message_text=>unistr('Tu\010Dn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613440664401837)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Obr\00E1zok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613022276401836)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlo\017Een\00FD k\00F3d')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626655715401846)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlo\017Ei\0165 obr\00E1zok')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626786271401846)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlo\017Ei\0165 prepojenie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612699369401836)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'sk'
,p_message_text=>unistr('Kurz\00EDva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627365675401847)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'sk'
,p_message_text=>'Prepojenie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613341049401837)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'sk'
,p_message_text=>'Zoznam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613258868401837)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Zoraden\00FD zoznam')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612768487401836)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Uk\00E1\017Eka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612861524401836)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'sk'
,p_message_text=>unistr('Ni\010D na zobrazenie uk\00E1\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612947237401836)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre\010Diarknut\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613176728401837)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezoraden\00FD zoznam')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592087302401821)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('aktu\00E1lne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114649593542401863)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Eal\0161ie...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114591931989401821)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'sk'
,p_message_text=>unistr('Zav\00E1dza sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623778428401844)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'sk'
,p_message_text=>unistr('Spr\00E1va s upozornen\00EDm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597037979401825)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 \010D\00EDslo men\0161ie alebo rovnak\00E9 ako %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597131264401825)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 platn\00E9 \010D\00EDslo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597273958401825)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# nezodpoved\00E1 \010D\00EDseln\00E9mu form\00E1tu %0 (pr\00EDklad: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596977356401825)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 \010D\00EDslo v\00E4\010D\0161ie alebo rovnak\00E9 ako %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596825648401824)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED by\0165 \010D\00EDslo medzi %0 a %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592146958401821)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'sk'
,p_message_text=>unistr('otvor\00ED sa v novom okne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545355026401787)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00E1to str\00E1nka u\017E bola odoslan\00E1 a nem\00F4\017Ee sa znovu odosla\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527939663401774)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Str\00E1nka "%1" aplik\00E1cie "%0" sa nena\0161la.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561717798401799)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('#LABEL# mus\00ED obsahova\0165 hodnotu.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505047683401757)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611067274401835)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavrie\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610964859401835)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1js\0165 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611246965401835)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611154705401835)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497185976401750)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadajte h\013Eadan\00FD v\00FDraz s minim\00E1lnym po\010Dtom znakov %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566612716401803)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozba\013Eovac\00ED zoznam hodn\00F4t: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497242896401750)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadajte h\013Eadan\00FD v\00FDraz.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497059102401750)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161li sa \017Eiadne v\00FDsledky.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496967082401750)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584834992401816)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Podmienka vyh\013Ead\00E1vania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610872876401835)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621504634401843)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'sk'
,p_message_text=>unistr('Spracov\00E1va sa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495537436401749)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 na domovsk\00FA str\00E1nku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491599877401746)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Zd\00E1 sa, \017Ee va\0161e zariadenie alebo preh\013Ead\00E1va\010D moment\00E1lne nepodporuj\00FA in\0161tal\00E1ciu progres\00EDvnych webov\00FDch aplik\00E1ci\00ED.</p>'),
unistr('    <p class="a-pwaDialog-intro">Ak u\017E m\00E1te t\00FAto aplik\00E1ciu v zariaden\00ED nain\0161talovan\00FA, otvorte ju z domovskej obrazovky.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491127695401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie. Pridajte ju na svoju domovsk\00FA obrazovku, aby ste ju mohli pou\017E\00EDva\0165 na celej obrazovke.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0164uknite na ikonu <strong>Ponuka</strong> v navig\00E1cii naspodku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0164uknite na tla\010Didlo <strong>In\0161talova\0165</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Potvr\010Fte \0165uknut\00EDm na tla\010Didlo <strong>Prida\0165</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491204474401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie, ktor\00E1 najlep\0161ie funguje v preh\013Ead\00E1va\010Di Chrome alebo Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0164uknite na ikonu <strong>Ponuka</strong> ved\013Ea panela s adresou</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0164uknite na tla\010Didlo <strong>In\0161talova\0165</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490812744401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie, ktor\00E1 najlep\0161ie funguje v preh\013Ead\00E1va\010Di Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0164uknite na ikonu <strong>Zdie\013Ea\0165</strong> v navig\00E1cii naspodku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0164uknite na polo\017Eku <strong>Otvori\0165 v Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490587265401745)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie. Na \010Do najlep\0161ie fungovanie ju pridajte na svoju domovsk\00FA obrazovku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0164uknite na ikonu <strong>Zdie\013Ea\0165</strong> ved\013Ea panela s adresou</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0164uknite na polo\017Eku <strong>Prida\0165 na domovsk\00FA obrazovku</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Potvr\010Fte \0165uknut\00EDm na tla\010Didlo <strong style="color:#007AE1;">Prida\0165</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490437286401745)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie. Na \010Do najlep\0161ie fungovanie ju pridajte na svoju domovsk\00FA obrazovku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0164uknite na ikonu <strong>Zdie\013Ea\0165</strong> v navig\00E1cii naspodku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Posu\0148te sa nadol a \0165uknite na polo\017Eku <strong>Prida\0165 na domovsk\00FA obrazovku</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Potvr\010Fte \0165uknut\00EDm na tla\010Didlo <strong style="color:#007AE1;">Prida\0165</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485452940401742)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie. Na \010Do najlep\0161ie fungovanie ju pridajte na svoju domovsk\00FA obrazovku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0164uknite na ikonu <strong>\010Eal\0161ie</strong> ved\013Ea po\013Ea s adresou</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0164uknite na polo\017Eku <strong>Prida\0165 na domovsk\00FA obrazovku</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Potvr\010Fte \0165uknut\00EDm na tla\010Didlo <strong style="color:#007AE1;">Prida\0165</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490791122401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie. Na \010Do najlep\0161ie fungovanie ju pridajte na svoju domovsk\00FA obrazovku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0164uknite na ikonu <strong>Zdie\013Ea\0165</strong> ved\013Ea panela s adresou</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0164uknite na polo\017Eku <strong>Otvori\0165 v Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490616410401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie. Na \010Do najlep\0161ie fungovanie ju pridajte na svoju domovsk\00FA obrazovku.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0164uknite na ikonu <strong>Zdie\013Ea\0165</strong> v navig\00E1cii naspodku</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0164uknite na polo\017Eku <strong>Otvori\0165 v Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491480544401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie, ktor\00E1 najlep\0161ie funguje v preh\013Ead\00E1va\010Di Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Preh\013Ead\00E1va\010D Firefox moment\00E1lne nepodporuje in\0161tal\00E1ciu webov\00FDch aplik\00E1ci\00ED.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114490927028401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie, ktor\00E1 najlep\0161ie funguje v preh\013Ead\00E1va\010Di Chrome alebo Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Preh\013Ead\00E1va\010D Firefox moment\00E1lne nepodporuje in\0161tal\00E1ciu webov\00FDch aplik\00E1ci\00ED v syst\00E9me macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491023466401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie, ktor\00E1 najlep\0161ie funguje v preh\013Ead\00E1va\010Di Chrome alebo Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Preh\013Ead\00E1va\010D Safari moment\00E1lne nepodporuje in\0161tal\00E1ciu webov\00FDch aplik\00E1ci\00ED v syst\00E9me macOS.</p>'),
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491373461401746)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E1to webov\00E1 lokalita m\00E1 funkcionalitu aplik\00E1cie, ktor\00E1 najlep\0161ie funguje v preh\013Ead\00E1va\010Di Chrome alebo Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Preh\013Ead\00E1va\010D Firefox moment\00E1lne nepodporuje in\0161tal\00E1ciu webov\00FDch aplik\00E1ci\00ED v syst\00E9me Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493808969401748)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Pripojenie nie je mo\017En\00E9</h1>'),
unistr('    <p>Na pou\017E\00EDvanie tejto aplik\00E1cie je potrebn\00E9 internetov\00E9 pripojenie.</p>'),
unistr('    <button type="button">Sk\00FAsi\0165 znova</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493704925401748)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pripojenie nie je mo\017En\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633539838401851)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577954666401811)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Cel\00FD de\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656821928401868)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165 pozvanie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656650709401868)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Vo\013Eby')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579798746401812)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Denn\00E9 zobrazenie pre cel\00FD de\0148 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579570301401812)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'sk'
,p_message_text=>unistr('Denn\00E9 zobrazenie pre d\00E1ta s \010Dasom ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624405652401845)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('De\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618850437401841)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'sk'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509413064401761)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'sk'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509291291401761)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'sk'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509141521401760)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'sk'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509341487401761)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'sk'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508882865401760)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Koncov\00FD d\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509034241401760)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov udalosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656722459401868)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'sk'
,p_message_text=>'Pozvanie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624514485401845)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'sk'
,p_message_text=>'Zoznam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624245259401844)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'sk'
,p_message_text=>'Mesiac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627016296401847)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641399987401857)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'sk'
,p_message_text=>unistr('\017Diadne udalosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657051340401869)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravte existuj\00FAcu udalos\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656909448401869)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'sk'
,p_message_text=>'Odosiela sa pozvanie e-mailom.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627106281401847)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635187980401853)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165 e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634948098401852)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165 e-mail')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657724397401869)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161etky polia s\00FA povinn\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657624797401869)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165 pozvanie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656520808401868)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'sk'
,p_message_text=>'Predmet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635055582401852)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'sk'
,p_message_text=>'Komu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508932838401760)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Diato\010Dn\00FD d\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632876972401851)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'sk'
,p_message_text=>unistr('Formul\00E1r pre %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579340737401812)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Cas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627243160401847)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'sk'
,p_message_text=>'Dnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625065567401845)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624315548401845)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FD\017Ede\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579621969401812)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FD\017Edenn\00E9 zobrazenie pre cel\00FD de\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579454047401812)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FD\017Edenn\00E9 zobrazenie pre d\00E1ta s \010Dasom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624968454401845)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'sk'
,p_message_text=>'Rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624649193401845)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624749456401845)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavies\0165 \010Fal\0161ie...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556800531401796)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503137536401755)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavies\0165 \010Fal\0161ie...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505244430401757)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('H\013Eada\0165...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114624800150401845)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavies\0165 \010Fal\0161ie...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626934152401846)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('ID oblasti %0 sa nena\0161lo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505185633401757)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161li sa \017Eiadne d\00E1ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529238657401775)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nie je mo\017En\00E9 znovunastavi\0165 str\00E1nkovanie oblasti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497464808401751)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri nastaven\00ED str\00E1nkovania oblasti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618267126401840)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626847808401846)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Typ oblasti %0 nie je podporovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497318992401750)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das vykres\013Eovania oblasti "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561868532401799)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('#COLUMN_HEADER# mus\00ED obsahova\0165 hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656149937401868)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('%0, editor form\00E1tovan\00E9ho textu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563938606401801)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'sk'
,p_message_text=>unistr('HTML markup form\00E1tovania RTF prekra\010Duje maxim\00E1lnu d\013A\017Eku polo\017Eky (skuto\010Dn\00E1 d\013A\017Eka %0, povolen\00FD po\010Det znakov: %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623817334401844)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615656884401838)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplikova\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613935501401837)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazen\00E9 st\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613801920401837)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyl\00FA\010Di\0165 hodnoty null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623952005401844)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577576661401811)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 nadol')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577603217401811)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 nahor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613621546401837)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614274929401837)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ostatn\00E9 st\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613732835401837)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614013997401837)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'sk'
,p_message_text=>'Riadok %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614137667401837)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'sk'
,p_message_text=>'Riadok %0 z %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615719890401838)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615849260401838)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vr\00E1ti\0165 zmeny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114613534317401837)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'sk'
,p_message_text=>'Ponuka Nastavenia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574548465401809)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Napr\00EDklad %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482058999401739)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovu sa prihl\00E1si\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481938766401739)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161a rel\00E1cia bola ukon\010Den\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482170143401740)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'sk'
,p_message_text=>unistr('Pred\013A\017Ei\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481744187401739)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161a rel\00E1cia bude ukon\010Den\00E1 o %0. Chcete ju pred\013A\017Ei\0165?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481841737401739)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161a rel\00E1cia bude ukon\010Den\00E1 o %0 a nem\00F4\017Ee sa pred\013A\017Ei\0165. Teraz ulo\017Ete svoju pr\00E1cu, aby ste sa vyhli strate d\00E1t.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634727563401852)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania k\00F3du v\00FDmazu datab\00E1zovej rel\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527883608401774)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das spracovania k\00F3du nastavenia datab\00E1zovej rel\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114501917720401754)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161a rel\00E1cia bola ukon\010Den\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633638390401851)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'sk'
,p_message_text=>unistr('Zatvorte toto dial\00F3gov\00E9 okno a stla\010Dte tla\010Didlo obnovenia preh\013Ead\00E1va\010Da, aby ste z\00EDskali nov\00FA rel\00E1ciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652976174401866)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('Kliknite <a href="%0">sem</a>, ak chcete vytvori\0165 nov\00FA rel\00E1ciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539530051401783)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Rel\00E1cia nie je platn\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579025801401812)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'sk'
,p_message_text=>unistr('V rel\00E1cii Real Application Security nebolo pre pou\017E\00EDvate\013Ea "%0" mo\017En\00E9 aktivova\0165 dynamick\00E9 roly.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525790373401773)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-99900 Nepodarilo sa vytvori\0165 jednozna\010Dn\00E9 ID rel\00E1cie: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542007583401785)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Poru\0161enie ochrany stavu rel\00E1cie: Pr\00ED\010Dinou m\00F4\017Ee by\0165 manu\00E1lna zmena chr\00E1nenej polo\017Eky str\00E1nky %0. Ak neviete, \010Do t\00FAto chybu sp\00F4sobilo, po\017Eiadajte o pomoc administr\00E1tora aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661175126401872)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Poru\0161enie ochrany str\00E1nky: Pr\00ED\010Dinou m\00F4\017Ee by\0165 odoslanie str\00E1nky, ktor\00E1 sa e\0161te nena\010D\00EDtala, alebo manu\00E1lna zmena chr\00E1nen\00FDch polo\017Eiek str\00E1nky. \010Eal\0161iu pomoc v\00E1m poskytne administr\00E1tor aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660142619401871)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 obsahuje jeden z nasleduj\00FAcich neplatn\00FDch znakov &<>"/;,*|=% alebo --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660233085401871)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 obsahuje jeden z nasleduj\00FAcich neplatn\00FDch znakov &<>"/;,*|=% alebo --, pr\00EDpadne nov\00FD riadok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659934037401871)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 obsahuje \0161peci\00E1lne znaky. Povolen\00E9 s\00FA len znaky a-Z, 0-9 a medzery.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114660018418401871)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 obsahuje <, > alebo ", \010Do s\00FA neplatn\00E9 znaky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504107343401756)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'sk'
,p_message_text=>unistr('Nebol zadan\00FD \017Eiadny kontroln\00FD s\00FA\010Det na zobrazenie spracovania pre str\00E1nku, ktor\00E1 vy\017Eaduje kontroln\00FD s\00FA\010Det, ke\010F je minim\00E1lne jedna hodnota po\017Eiadavky, v\00FDmazu cache alebo argumentu odovzdan\00E1 ako parameter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536916678401781)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Poru\0161enie ochrany stavu rel\00E1cie: Pr\00ED\010Dinou m\00F4\017Ee by\0165 manu\00E1lna zmena adresy URL obsahuj\00FAcej kontroln\00FD s\00FA\010Det alebo pou\017Eitie prepojenia s nespr\00E1vnym alebo ch\00FDbaj\00FAcim kontroln\00FDm \00FA\010Dtom. Ak neviete, \010Do t\00FAto chybu sp\00F4sobilo, po\017Eiadajte o pomoc administr\00E1tora ')
||unistr('aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114614997241401838)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'sk'
,p_message_text=>unistr('Nastavi\0165 vypnutie re\017Eimu s vysok\00FDm kontrastom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615023814401838)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'sk'
,p_message_text=>unistr('Nastavi\0165 zapnutie re\017Eimu s vysok\00FDm kontrastom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533616129401778)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'sk'
,p_message_text=>'Na koniec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533847248401779)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'sk'
,p_message_text=>'Nadol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533943432401779)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534089234401779)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 v\0161etko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534135234401779)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534210870401779)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165 v\0161etko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534328067401779)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533584285401778)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'sk'
,p_message_text=>unistr('Na za\010Diatok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533731313401779)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'sk'
,p_message_text=>'Nahor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642684966401858)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643351011401859)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'o %0 d.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642598539401858)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643453057401859)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'o %0 hod.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642331449401858)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643536166401859)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'o %0 min.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642989297401858)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0 mes.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643183202401858)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'o %0 mes.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642434583401858)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643209815401859)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'o %0 s.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642798931401858)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643600246401859)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>unistr('o %0 t\00FD\017E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642881208401858)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'sk'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114643085036401858)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'o %0 r.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482950119401740)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'sk'
,p_message_text=>unistr('[\010Ciara]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483386333401740)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'sk'
,p_message_text=>unistr('[Viacero \010Diar]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483173227401740)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'sk'
,p_message_text=>'[Viacero bodov]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483504812401740)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'sk'
,p_message_text=>unistr('[Viacer\00E9 mnohouholn\00EDky]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483608181401741)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'sk'
,p_message_text=>unistr('[Geometrick\00FD objekt]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482872277401740)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'sk'
,p_message_text=>'[Bod (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483070620401740)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'sk'
,p_message_text=>unistr('[Mnohouholn\00EDk]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560268685401798)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zbali\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560141876401798)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606606261401832)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'sk'
,p_message_text=>unistr('Vymaza\0165 hodnotenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596538114401824)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v platnom rozsahu hodnotenia 1 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596623343401824)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nie je numerick\00E1 hodnota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592771566401821)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'sk'
,p_message_text=>unistr('Hl\00E1senie o \00FAspechu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655865735401868)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655768117401868)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641408193401857)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Panel s n\00E1strojmi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656240446401868)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozbali\0165 / zbali\0165 navig\00E1ciu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656371259401868)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozbali\0165 / zbali\0165 st\013Apec strany')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565963154401802)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Hlavn\00E1 navig\00E1cia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572976732401807)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('1 de\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572704104401807)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'sk'
,p_message_text=>'1 hodina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573005046401807)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'sk'
,p_message_text=>'%0 d.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572862916401807)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'sk'
,p_message_text=>'%0 hod.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572672943401807)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'sk'
,p_message_text=>'%0 min.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573217445401808)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 t\00FD\017E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114573104755401808)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('1 t\00FD\017Ede\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659497885401870)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diatok str\00E1nky')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521479552401770)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktivovan\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495258135401749)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri spracovan\00ED po\017Eiadavky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574627328401809)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Povinn\00E1 hodnota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657516413401869)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Dkajte, k\00FDm sa str\00E1nka \00FAplne nena\010D\00EDta, a sk\00FAste to znova.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617722475401840)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00E1to str\00E1nka m\00E1 neulo\017Een\00E9 zmeny.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498652319401751)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'sk'
,p_message_text=>unistr('Zo\0161it nem\00E1 \017Eiadny akt\00EDvny zo\0161it.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498547295401751)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zo\0161it nie je inicializovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498464404401751)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pri vytv\00E1ran\00ED s\00FAboru XLSX sa vyskytla intern\00E1 chyba.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500934106401753)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'sk'
,p_message_text=>unistr('H\00E1rok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632619555401851)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'sk'
,p_message_text=>'Akcie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550125203401791)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('Ponuka akci\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545857223401788)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 funkciu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545791965401788)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 st\013Apec Zoskupi\0165 pod\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579964937401812)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 st\013Apec kontingen\010Dnej zostavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580051845401812)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Prida\0165 st\013Apec riadka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520238754401769)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Agregova\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556355494401795)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Agreg\00E1cia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537428621401781)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'sk'
,p_message_text=>'Priemer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541701967401785)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537544830401781)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'sk'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537793670401782)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'sk'
,p_message_text=>unistr('Medi\00E1n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537656772401781)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'sk'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537352426401781)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FA\010Det %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538400853401782)
,p_name=>'APEXIR_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161etko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519532647401768)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161etky st\013Apce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502060492401754)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('V\0161etky riadky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629637188401848)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Alternat\00EDvne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631219018401850)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'sk'
,p_message_text=>unistr('Alternat\00EDvne predvolen\00E9: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532120960401777)
,p_name=>'APEXIR_AND'
,p_message_language=>'sk'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521645663401770)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Ei\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515356348401765)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'sk'
,p_message_text=>'Vzostupne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534935461401779)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Das: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631882451401850)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'sk'
,p_message_text=>'Priemer %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623268891401844)
,p_name=>'APEXIR_BAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pruhov\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521008146401769)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'sk'
,p_message_text=>'medzi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514158373401764)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'sk'
,p_message_text=>'Farba pozadia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516042290401766)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'sk'
,p_message_text=>unistr('modr\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547754236401789)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'sk'
,p_message_text=>'Na koniec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516674998401766)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zru\0161i\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522547170401771)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'sk'
,p_message_text=>unistr('Kateg\00F3ria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514013737401764)
,p_name=>'APEXIR_CELL'
,p_message_language=>'sk'
,p_message_text=>'Bunka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538383747401782)
,p_name=>'APEXIR_CHART'
,p_message_language=>'sk'
,p_message_text=>'Graf'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548646636401790)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'sk'
,p_message_text=>'Inicializuje sa...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114584918924401816)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie grafu mus\00ED by\0165 zadan\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597315796401825)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt prekra\010Duje maxim\00E1lny po\010Det %0 d\00E1tov\00FDch bodov na graf. Pou\017Eite filter na zn\00ED\017Eenie po\010Dtu z\00E1znamov v z\00E1kladnom dopyte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596253125401824)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Maxim\00E1lny po\010Det riadkov pre dopyt Graf obmedzuje po\010Det riadkov v z\00E1kladnom dopyte, nie po\010Det zobrazen\00FDch riadkov.'),
unistr('Z\00E1kladn\00FD dopyt prekra\010Duje maxim\00E1lny po\010Det riadkov %0. Pomocou filtra zn\00ED\017Ete po\010Det z\00E1znamov v z\00E1kladnom dopyte.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519670677401768)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'sk'
,p_message_text=>'Typ grafu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114592929264401822)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diarknu\0165 v\0161etko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535358292401780)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyberte form\00E1t zostavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542718949401785)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('vymaza\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516506863401766)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553948853401794)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626247111401846)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Filtrova\0165...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544718726401787)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('Ponuka z\00E1hlavia st\013Apca')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548442482401790)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'sk'
,p_message_text=>unistr('Inform\00E1cie o st\013Apcoch')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628581117401848)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie st\013Apca')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546162542401788)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530256696401776)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'sk'
,p_message_text=>'obsahuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531177366401777)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'sk'
,p_message_text=>'neobsahuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515022169401765)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'sk'
,p_message_text=>'je v'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531343930401777)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'sk'
,p_message_text=>'nie je v posl.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539810146401783)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'sk'
,p_message_text=>'nie je v nasl.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531285875401777)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'sk'
,p_message_text=>'je v posl.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539728756401783)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'sk'
,p_message_text=>'je v nasl.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514932100401765)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>'nie je null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514846018401765)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'sk'
,p_message_text=>'je null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514687217401765)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'sk'
,p_message_text=>unistr('podobn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515173863401765)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'sk'
,p_message_text=>'nie je v'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514760522401765)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'sk'
,p_message_text=>unistr('nie podobn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530574024401776)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'sk'
,p_message_text=>unistr('zodpoved\00E1 regul\00E1rnemu v\00FDrazu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535223620401780)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDpo\010Det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114595943567401824)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDraz v\00FDpo\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554280258401794)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Vytvorte v\00FDpo\010Det s pou\017Eit\00EDm aliasov st\013Apcov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554301680401794)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'sk'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554407318401794)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'sk'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554554448401794)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'sk'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500452721401753)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'sk'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539154460401783)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vypo\010D\00EDta\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546778216401788)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'sk'
,p_message_text=>'Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549762326401791)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'sk'
,p_message_text=>'Znaky Control Break'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634111353401852)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Control Break pre st\013Apce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497505267401751)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det odli\0161n\00FDch hodn\00F4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632373989401850)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det odli\0161n\00FDch hodn\00F4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632290229401850)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604321956401830)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'sk'
,p_message_text=>'Denne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659090771401870)
,p_name=>'APEXIR_DATA'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548516763401790)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1ta zostavy spred %0 min\00FAt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622077307401843)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre d\00E1tov\00FA mrie\017Eku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520359020401769)
,p_name=>'APEXIR_DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552417554401793)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629422982401848)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00FD typ zostavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516787139401766)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520676374401769)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'sk'
,p_message_text=>unistr('Chcete odstr\00E1ni\0165 tieto nastavenia zostavy?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615307244401838)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 predvolen\00FA zostavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546442780401788)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 zostavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515406009401765)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'sk'
,p_message_text=>'Zostupne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522615435401771)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'sk'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544637429401787)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazenie jedn\00E9ho riadka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552982275401793)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'sk'
,p_message_text=>'Smer %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553830734401794)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Deaktivovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516282814401766)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazen\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519418057401768)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazen\00E9 st\013Apce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552896606401793)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 v zostave')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547683140401789)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'sk'
,p_message_text=>'Nadol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539227662401783)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'sk'
,p_message_text=>unistr('Stiahnu\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552751124401793)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezobrazova\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618787798401841)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'sk'
,p_message_text=>unistr('Zv\00FDraznenie s rovnakou podmienkou u\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634345242401852)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplicitn\00FD st\013Apec kontingen\010Dnej zostavy. Zoznam st\013Apcov kontingen\010Dnej zostavy mus\00ED by\0165 jednozna\010Dn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634565459401852)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548732939401790)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 nastavenia grafu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555323090401795)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 graf')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555765331401795)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 filter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610175609401834)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 skupinu pod\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555682784401795)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 zv\00FDraznenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580280065401813)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165 kontingen\010Dn\00FA zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629773061401849)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'sk'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508491807401760)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'sk'
,p_message_text=>unistr('E-mailov\00E1 adresa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630074895401849)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'sk'
,p_message_text=>unistr('Skryt\00E1 k\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630228334401849)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'sk'
,p_message_text=>'Telo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629983760401849)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'sk'
,p_message_text=>unistr('K\00F3pia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630753902401849)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'sk'
,p_message_text=>'Frekvencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512120608401763)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre t\00FAto aplik\00E1ciu nebol konfigurovan\00FD e-mail. Kontaktujte administr\00E1tora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603613514401830)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Mus\00ED by\0165 zadan\00E1 e-mailov\00E1 adresa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630343161401849)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pozrite pr\00EDlohu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630123215401849)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'sk'
,p_message_text=>'Predmet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604674149401830)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Mus\00ED by\0165 zadan\00FD predmet e-mailu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629817274401849)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'sk'
,p_message_text=>'Komu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513821388401764)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktivovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555537619401795)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktivova\0165/deaktivova\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555051761401794)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'sk'
,p_message_text=>'Chyba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554633696401794)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDklady')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555417382401795)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDklady:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519351095401768)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyl\00FA\010Di\0165 hodnoty null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556021358401795)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozbali\0165/Zbali\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553685438401793)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDraz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538750691401782)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Filtrova\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549606909401790)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'sk'
,p_message_text=>'Filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559959001401798)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDraz filtra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656455592401868)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDraz filtra je pr\00EDli\0161 dlh\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559830729401798)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'sk'
,p_message_text=>'Typ filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556254592401795)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 st\013Apce na vyh\013Ead\00E1vanie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539032566401783)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'sk'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553417467401793)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt na flashback v\00E1m umo\017E\0148uje zobrazi\0165 d\00E1ta, ako existovali v predch\00E1dzaj\00FAcom \010Dasovom bode.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604039930401830)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'sk'
,p_message_text=>'Trvanie flashbacku'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605430770401831)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Form\00E1t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535102360401780)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'sk'
,p_message_text=>unistr('Maska form\00E1tu %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546327134401788)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>'Funkcia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554148937401794)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'sk'
,p_message_text=>'Funkcie %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629326287401848)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'sk'
,p_message_text=>unistr('Funkcie / oper\00E1tory')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546015524401788)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'sk'
,p_message_text=>'Funkcia %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538591334401782)
,p_name=>'APEXIR_GO'
,p_message_language=>'sk'
,p_message_text=>unistr('Prejs\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514307502401765)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'sk'
,p_message_text=>unistr('zelen\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114497659137401751)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Zoskupi\0165 pod\013Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630403172401849)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Zoskupi\0165 pod\013Ea st\013Apca %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585085038401816)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec Zoskupi\0165 pod\013Ea mus\00ED by\0165 zadan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596131930401824)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Maxim\00E1lny po\010Det riadkov pre dopyt Zoskupi\0165 pod\013Ea obmedzuje po\010Det riadkov v z\00E1kladnom dopyte, nie po\010Det zobrazen\00FDch riadkov. Z\00E1kladn\00FD dopyt prekra\010Duje maxim\00E1lny po\010Det riadkov %0. Pomocou filtra zn\00ED\017Ete po\010Det z\00E1znamov v z\00E1kladnom dopyte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576748311401810)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedenie Zoskupi\0165 pod\013Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634279393401852)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'sk'
,p_message_text=>unistr('Poradie triedenia Zoskupi\0165 pod\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519712859401768)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Vodorovn\00FD st\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551372549401792)
,p_name=>'APEXIR_HELP'
,p_message_language=>'sk'
,p_message_text=>'Pomoc'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543151795401786)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interakt\00EDvne zostavy umo\017E\0148uj\00FA koncov\00FDm pou\017E\00EDvate\013Eom prisp\00F4sobova\0165 zostavy. Pou\017E\00EDvatelia m\00F4\017Eu v\00FDberom st\013Apcov, pou\017Eit\00EDm filtrov, zv\00FDraznen\00EDm a trieden\00EDm zmeni\0165 rozlo\017Eenie d\00E1t zostavy. M\00F4\017Eu definova\0165 aj zlomy, agreg\00E1cie, grafy alebo zoskupenia a prida\0165')
||unistr(' vlastn\00E9 v\00FDpo\010Dty. Pou\017E\00EDvatelia si m\00F4\017Eu nastavi\0165 odber, aby im mohla by\0165 v ur\010Denom intervale e-mailom odoslan\00E1 verzia HTML zostavy. \010Ealej m\00F4\017Eu vytv\00E1ra\0165 viacer\00E9 varianty zostavy a uklada\0165 ich ako pomenovan\00E9 zostavy na verejn\00E9 alebo s\00FAkromn\00E9 zobrazovani')
||'e. ',
'<p/>',
unistr('V nasleduj\00FAcich sekci\00E1ch s\00FA zhrnut\00E9 sp\00F4soby prisp\00F4sobenia interakt\00EDvnej zostavy. \010Eal\0161ie inform\00E1cie n\00E1jdete v \010Dasti "Using Interactive Reports" (Pou\017E\00EDvanie interakt\00EDvnych zost\00E1v) pr\00EDru\010Dke <i>Oracle Application Express End User''s Guide</i></a>.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550207151401791)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('Ponuka Akcie sa zobrazuje napravo od tla\010Didla Prejs\0165 na paneli vyh\013Ead\00E1vania. Pomocou tejto ponuky m\00F4\017Eete prisp\00F4sobi\0165 interakt\00EDvnu zostavu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543969557401786)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agreg\00E1ty s\00FA matematick\00E9 v\00FDpo\010Dty vykon\00E1van\00E9 v st\013Apci. Zobrazuj\00FA sa za ka\017Ed\00FDm znakom Control Break a na konci zostavy v r\00E1mci st\013Apca, pre ktor\00FD s\00FA definovan\00E9. Medzi vo\013Eby patria:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agreg\00E1cia</strong> v\00E1m umo\017E\0148uje vybra\0165 predt\00FDm definovan\00FA agreg\00E1ciu na \00FApravu.</li>'),
unistr('<li><strong>Funkcia</strong> predstavuje funkciu na vykonanie (napr\00EDklad SUM, MIN).</li>'),
unistr('<li><strong>St\013Apec</strong> sa pou\017E\00EDva na v\00FDber st\013Apca, pre ktor\00FD sa pou\017Eije matematick\00E1 funkcia. Zobrazuj\00FA sa len numerick\00E9 st\013Apce.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544077684401786)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('M\00F4\017Eete definova\0165 jeden graf na jednu ulo\017Een\00FA zostavu. Po definovan\00ED m\00F4\017Eete pomocou ikon zobrazenia na paneli vyh\013Ead\00E1vania prep\00EDna\0165 medzi zobrazen\00EDm grafu a zobrazen\00EDm zostavy. Medzi vo\013Eby patria:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Typ grafu</strong> identifikuje typ grafu, ktor\00FD sa m\00E1 pou\017Ei\0165.'),
unistr('Vybra\0165 m\00F4\017Eete vodorovn\00FD pruhov\00FD, zvisl\00FD pruhov\00FD, kol\00E1\010Dov\00FD alebo \010Diarov\00FD graf.</li>'),
unistr('<li><strong>Ozna\010Denie</strong> v\00E1m umo\017E\0148uje vybra\0165 st\013Apec, ktor\00FD sa m\00E1 pou\017Ei\0165 ako ozna\010Denie.</li>'),
unistr('<li><strong>Nadpis osi pre ozna\010Denie</strong> je nadpis, ktor\00FD sa zobraz\00ED na osi spojenej s vybran\00FDm st\013Apcom pre ozna\010Denie.'),
unistr('T\00E1to vo\013Eba nie je k dispoz\00EDcii pre kol\00E1\010Dov\00FD graf.</li>'),
unistr('<li><strong>Hodnota</strong> v\00E1m umo\017E\0148uje vybra\0165 st\013Apec, ktor\00FD sa m\00E1 pou\017Ei\0165 ako hodnota.'),
unistr('Ak pou\017Eijete funkciu COUNT, hodnotu nie je potrebn\00E9 vybra\0165.</li>'),
unistr('<li><strong>Nadpis osi pre hodnotu</strong> je nadpis, ktor\00FD sa zobraz\00ED na osi spojenej s vybran\00FDm st\013Apcom pre hodnotu.'),
unistr('T\00E1to vo\013Eba nie je k dispoz\00EDcii pre kol\00E1\010Dov\00FD graf.</li>'),
unistr('<li><strong>Funkcia</strong> je volite\013En\00E1 funkcia, ktor\00E1 sa m\00E1 vykona\0165 vo vybranom st\013Apci pre hodnotu.</li>'),
unistr('<li><strong>Triedi\0165</strong> v\00E1m umo\017E\0148uje triedi\0165 mno\017Einu v\00FDsledkov.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543353252401786)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kliknut\00EDm na \013Eubovo\013En\00E9 z\00E1hlavie st\013Apca sa zobraz\00ED ponuka z\00E1hlavia st\013Apca. Medzi vo\013Eby patr\00ED:'),
'<p></p>',
'<ul>',
unistr('<li>Ikona <strong>Triedi\0165 vzostupne</strong> triedi zostavu pod\013Ea st\013Apca vo vzostupnom porad\00ED.</li>'),
unistr('<li>Ikona <strong>Triedi\0165 zostupne</strong> triedi zostavu pod\013Ea st\013Apca v zostupnom porad\00ED.</li>'),
unistr('<li><strong>Skry\0165 st\013Apec</strong> skryje st\013Apec. Nie je mo\017En\00E9 skry\0165 v\0161etky st\013Apce. Ak st\013Apec nie je mo\017En\00E9 skry\0165, ikona Skry\0165 st\013Apec sa nezobraz\00ED.</li>'),
unistr('<li><strong>Zalamovac\00ED st\013Apec</strong> vytvor\00ED zalamovaciu skupinu pre st\013Apec. T\00FDmto sa vytiahne st\013Apec zo zostavy ako hlavn\00FD z\00E1znam.</li>'),
unistr('<li><strong>Inform\00E1cie o st\013Apci</strong> zobrazia text pomoci k st\013Apcu (ak je k dispoz\00EDcii),</li>'),
unistr('<li><strong>Textov\00E1 oblas\0165</strong> sa pou\017E\00EDva na zadanie krit\00E9ri\00ED vyh\013Ead\00E1vania bez rozli\0161ovania ve\013Ek\00FDch a mal\00FDch p\00EDsmen'),
unistr('(bez potreby z\00E1stupn\00FDch znakov). Zadan\00EDm hodnoty sa zmen\0161\00ED zoznam'),
unistr('hodn\00F4t v dolnej \010Dasti ponuky. Potom m\00F4\017Eete vybra\0165 hodnotu'),
unistr('zdola a vybran\00E1 hodnota sa pou\017Eije ako filter s pou\017Eit\00EDm "="'),
unistr('(napr\00EDklad <code>column = ''ABC''</code>). Alternat\00EDvne m\00F4\017Eete klikn\00FA\0165 na ikonu baterky a zada\0165 hodnotu, ktor\00E1 sa vytvor\00ED ako filter s modifik\00E1torom ''LIKE'''),
unistr('(napr\00EDklad <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>Zoznam jednozna\010Dn\00FDch hodn\00F4t</b> obsahuje prv\00FDch 500 jednozna\010Dn\00FDch'),
unistr('hodn\00F4t, ktor\00E9 zodpovedaj\00FA krit\00E9ri\00E1m filtra. Ak st\013Apec predstavuje d\00E1tum, namiesto toho sa zobraz\00ED zoznam rozsahov d\00E1tumu. Ak vyberiete hodnotu, vytvor\00ED sa '),
unistr('filter s pou\017Eit\00EDm "=" (napr\00EDklad <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543863287401786)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017E\0148uje v\00E1m prida\0165 vypo\010D\00EDtan\00E9 st\013Apce do zostavy. M\00F4\017Ee \00EDs\0165 o matematick\00E9 v\00FDpo\010Dty (napr\00EDklad <code>NBR_HOURS/24</code>) alebo \0161tandardn\00E9 funkcie Oracle'),
unistr('pou\017Eit\00E9 v existuj\00FAcich st\013Apcoch. Niektor\00E9 sa zobrazuj\00FA ako pr\00EDklady a m\00F4\017Eu sa pou\017Ei\0165 aj in\00E9 (napr\00EDklad <code>TO_DATE)</code>. Medzi vo\013Eby patria:'),
'<p></p>',
'<ul>',
unistr('<li><strong>V\00FDpo\010Det</strong> v\00E1m umo\017E\0148uje vybra\0165 predt\00FDm definovan\00FD v\00FDpo\010Det na \00FApravu.</li>'),
unistr('<li><strong>Z\00E1hlavie st\013Apca</strong> je z\00E1hlavie nov\00E9ho st\013Apca.</li>'),
unistr('<li><strong>Maska form\00E1tu</strong> je maska form\00E1tu Oracle, ktor\00E1 sa pou\017Eije pre st\013Apec (napr\00EDklad S9999).</li>'),
unistr('<li><strong>V\00FDpo\010Det</strong> je v\00FDpo\010Det, ktor\00FD sa m\00E1 vykona\0165. V r\00E1mci v\00FDpo\010Dtu sa odkazuje na st\013Apce pomocou zobrazen\00FDch aliasov.</li>'),
'</ul>',
unistr('<p>Pod v\00FDpo\010Dtom sa st\013Apce v dopyte zobrazuj\00FA'),
unistr('s pr\00EDslu\0161n\00FDm aliasom. Ak kliknete na n\00E1zov alebo alias st\013Apca, zahrnie'),
unistr('sa do v\00FDpo\010Dtu. Ved\013Ea st\013Apcov je kl\00E1vesnica, ktor\00E1 funguje ako '),
unistr('odkaz na be\017Ene pou\017E\00EDvan\00E9 kl\00E1vesy. \010Ealej vpravo s\00FA funkcie.</p>'),
unistr('<p>Nasleduj\00FAci vzorov\00FD v\00FDpo\010Det zn\00E1zor\0148uje, ako zobrazi\0165 celkov\00E9 odme\0148ovanie:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(kde A je ORGANIZ\00C1CIA, B je PLAT a C je PROV\00CDZIA)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550303794401791)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017E\00EDva sa na vytvorenie zalamovacej skupiny pre jeden alebo viacero st\013Apcov. T\00FDmto sa vytiahnu st\013Apce z interakt\00EDvnej zostavy, ktor\00E9 sa zobrazia ako hlavn\00FD z\00E1znam.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544523738401787)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Ak chcete zobrazi\0165 detaily jedn\00E9ho riadka v ur\010Ditom \010Dase, kliknite na ikonu zobrazenia jedn\00E9ho riadka pre riadok, ktor\00FD chcete zobrazi\0165. Ak je zobrazenie jedn\00E9ho riadka k dispoz\00EDcii, v\017Edy sa zobraz\00ED ako prv\00FD st\013Apec. V z\00E1vislosti od prisp\00F4sobenia inte')
||unistr('rakt\00EDvnej zostavy m\00F4\017Ee v pr\00EDpade zobrazenia jedn\00E9ho riadka \00EDs\0165 o \0161tandardn\00E9 zobrazenie alebo vlastn\00FA str\00E1nku, ktor\00E1 m\00F4\017Ee umo\017E\0148ova\0165 aktualiz\00E1ciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544414750401787)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017E\0148uje stiahnutie aktu\00E1lnej mno\017Einy v\00FDsledkov. Form\00E1ty s\0165ahovania'),
unistr('sa l\00ED\0161ia v z\00E1vislosti od va\0161ej in\0161tal\00E1cie a defin\00EDcie zostavy, ale'),
unistr('m\00F4\017Eu zah\0155\0148a\0165 CSV, HTML, e-mail, XLS, PDF alebo RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543563351401786)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zameria zostavu pridan\00EDm alebo modifikovan\00EDm klauzuly <code>WHERE</code> v dopyte. M\00F4\017Eete filtrova\0165 na z\00E1klade st\013Apca alebo riadka. '),
unistr('<p>Ak filtrujete pod\013Ea st\013Apca, vyberte st\013Apec'),
unistr('(nemus\00ED \00EDs\0165 o zobrazen\00FD st\013Apec), vyberte \0161tandardn\00FD oper\00E1tor Oracle (=, !=, not in, between) a zadajte v\00FDraz na porovnanie. Vo v\00FDrazoch sa rozli\0161uj\00FA ve\013Ek\00E9 a mal\00E9 p\00EDsmen\00E1. Ako z\00E1stupn\00FD znak pou\017Eite % (napr\00EDklad <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>Ak filtrujete pod\013Ea riadka, m\00F4\017Eete vytvori\0165 komplexn\00E9 klauzuly <code>WHERE</code> s pou\017Eit\00EDm'),
unistr('aliasov st\013Apcov a funkci\00ED alebo oper\00E1torov Oracle (napr\00EDklad <code>G = ''VA'' alebo G = ''CT''</code>, kde'),
'<code>G</code> je alias pre <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544114126401787)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt na flashback v\00E1m umo\017E\0148uje zobrazi\0165 d\00E1ta tak, ako existovali v predch\00E1dzaj\00FAcom \010Dasovom bode. Predvolen\00FD \010Dasov\00FD interval flashbacku s\00FA 3 hodiny (alebo 180 min\00FAt), ale skuto\010Dn\00E1 hodnota sa bude pre jednotliv\00E9 datab\00E1zy l\00ED\0161i\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605322451401831)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Form\00E1t v\00E1m umo\017E\0148uje prisp\00F4sobi\0165 zobrazenie zostavy.'),
unistr('Form\00E1t obsahuje nasleduj\00FAcu podponuku:</p>'),
unistr('<ul><li>Triedi\0165</li>'),
'<li>Control Break</li>',
unistr('<li>Zv\00FDrazni\0165</li>'),
unistr('<li>Vypo\010D\00EDta\0165</li>'),
unistr('<li>Agregova\0165</li>'),
'<li>Graf</li>',
unistr('<li>Zoskupi\0165 pod\013Ea</li>'),
unistr('<li>Kontingen\010Dn\00E1 zostava</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603584739401830)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('M\00F4\017Eete definova\0165 jedno zobrazenie Zoskupi\0165 pod\013Ea na ulo\017Een\00FA zostavu.'),
unistr('Po definovan\00ED m\00F4\017Eete pomocou ikon zobrazenia na paneli vyh\013Ead\00E1vania'),
unistr('prep\00EDna\0165 medzi zobrazen\00EDm Zoskupi\0165 pod\013Ea a Zostava. Ak chcete vytvori\0165 zobrazenie Zoskupi\0165 pod\013Ea,'),
'vyberte:',
'<p></p><ul>',
unistr('<li>st\013Apce, ktor\00E9 sa maj\00FA zoskupi\0165</li>'),
unistr('<li>st\013Apce na agregovanie spolu s funkciou, ktor\00E1 sa m\00E1 vykona\0165 (priemer, s\00FA\010Det, po\010Det at\010F.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543758735401786)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Umo\017E\0148uje v\00E1m definova\0165 filter. Riadky, ktor\00E9 sp\013A\0148aj\00FA krit\00E9ri\00E1 filtra, sa zobrazuj\00FA zv\00FDraznen\00E9 s pou\017Eit\00EDm charakterist\00EDk priraden\00FDch k filtru. Medzi vo\013Eby patria:</p>'),
'<ul>',
unistr('<li><strong>N\00E1zov</strong> sa pou\017E\00EDva iba na zobrazenie.</li>'),
unistr('<li><strong>Poradie</strong> identifikuje poradie, v ktorom sa vyhodnocuj\00FA pravidl\00E1.</li>'),
unistr('<li><strong>Aktivovan\00E9</strong> identifikuje, \010Di je pravidlo aktivovan\00E9 alebo deaktivovan\00E9.</li>'),
unistr('<li><strong>Typ zv\00FDraznenia</strong> identifikuje, \010Di by mal by\0165 riadok alebo'),
unistr('st\013Apec zv\00FDraznen\00FD. Ak je vybran\00E1 bunka, zv\00FDrazn\00ED sa st\013Apec,'),
unistr('na ktor\00FD odkazuje podmienka zv\00FDraznenia.</li>'),
unistr('<li><strong>Farba pozadia</strong> predstavuje nov\00FA farbu pozadia zv\00FDraznenej oblasti.</li>'),
unistr('<li><strong>Farba textu</strong> predstavuje nov\00FA farbu textu vo zv\00FDraznenej oblasti.</li>'),
unistr('<li><strong>Podmienka zv\00FDraznenia</strong> definuje podmienku filtra.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481360373401739)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('M\00F4\017Eete definova\0165 jedno kontingen\010Dn\00E9 zobrazenie na ulo\017Een\00FA zostavu. Po definovan\00ED m\00F4\017Eete pomocou ikon zobrazenia na paneli vyh\013Ead\00E1vania prep\00EDna\0165 medzi kontingen\010Dn\00FDm zobrazen\00EDm a zobrazen\00EDm zostavy. Ak chcete vytvori\0165 kontingen\010Dn\00E9 zobrazenie, vyberte: '),
'<p></p>',
'<ul>',
unistr('<li>st\013Apce, pre ktor\00E9 sa m\00E1 vytvori\0165 kontingen\010Dn\00E9 zobrazenie,</li>'),
unistr('<li>st\013Apce, ktor\00E9 sa zobrazia ako riadky,</li>'),
unistr('<li>st\013Apce na agregovanie spolu s funkciou, ktor\00E1 sa m\00E1 vykona\0165 (priemer, s\00FA\010Det, po\010Det at\010F.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554889836401794)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ak prisp\00F4sob\00EDte interakt\00EDvnu zostavu, nastavenia zostavy sa zobrazia'),
unistr('pod panelom vyh\013Ead\00E1vania a nad zostavou. T\00FAto oblas\0165 je mo\017En\00E9 zbali\0165 a rozbali\0165 pomocou ikony v\013Eavo.'),
'<p>',
unistr('Pre ka\017Ed\00E9 nastavenie zostavy m\00F4\017Eete:'),
'</p><ul>',
unistr('<li>Upravi\0165 nastavenie kliknut\00EDm na n\00E1zov.</li>'),
unistr('<li>Deaktivova\0165/aktivova\0165 nastavenie zru\0161en\00EDm za\010Diarknutia alebo za\010Diarknut\00EDm pol\00ED\010Dka Aktivova\0165/deaktivova\0165. Pomocou tohto ovl\00E1dacieho prvku m\00F4\017Eete nastavenie do\010Dasne vypn\00FA\0165 a zapn\00FA\0165.</li>'),
unistr('<li>Odstr\00E1ni\0165 nastavenie kliknut\00EDm na ikonu Odobra\0165.</li>'),
'</ul>',
unistr('<p>Ak ste vytvorili graf, zoskupenie alebo kontingen\010Dn\00E9 zobrazenie, m\00F4\017Eete prep\00EDna\0165 medzi nimi a z\00E1kladnou zostavou pomocou prepojen\00ED Zobrazenie zostavy, Zobrazenie grafu, Zobrazenie Zoskupi\0165 pod\013Ea a Kontingen\010Dn\00E9 zobrazenie, ktor\00E9 s\00FA vpravo. V pr\00EDpad')
||unistr('e grafu, zoskupenia alebo kontingen\010Dn\00E9ho zobrazenia m\00F4\017Eete na \00FApravu nastaven\00ED pou\017Ei\0165 aj prepojenie Upravi\0165.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544316628401787)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnov\00ED predvolen\00E9 nastavenia zostavy, pri\010Dom odstr\00E1ni vykonan\00E9 prisp\00F4sobenia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605604601401831)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nastav\00ED po\010Det z\00E1znamov, ktor\00E9 sa maj\00FA zobrazi\0165 na str\00E1nke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544246631401787)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ulo\017E\00ED prisp\00F4soben\00FA zostavu na bud\00FAce pou\017Eitie. Zad\00E1vate n\00E1zov a volite\013En\00FD popis a m\00F4\017Eete nastavi\0165 verejn\00FD pr\00EDstup k zostave (pre v\0161etk\00FDch pou\017E\00EDvate\013Eov, ktor\00ED maj\00FA pr\00EDstup k prim\00E1rnej predvolenej zostave). M\00F4\017Eete ulo\017Ei\0165 \0161tyri typy interakt\00EDvnych zo')
||unistr('st\00E1v:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E1rne predvolen\00E9</strong> (len pre v\00FDvoj\00E1ra). Prim\00E1rna predvolen\00E1 zostava sa zobrazuje ako prv\00E1. Prim\00E1rne predvolen\00E9 zostavy nemo\017Eno premenova\0165 ani odstr\00E1ni\0165.</li>'),
unistr('<li><strong>Alternat\00EDvna zostava</strong> (len pre v\00FDvoj\00E1ra). V\00FDvoj\00E1rom umo\017E\0148uje vytvori\0165 viacer\00E9 rozlo\017Eenia zost\00E1v. Alternat\00EDvnu zostavu m\00F4\017Eu ulo\017Ei\0165, premenova\0165 alebo odstr\00E1ni\0165 len v\00FDvoj\00E1ri.</li>'),
unistr('<li><strong>Verejn\00E1 zostava</strong> (pre koncov\00E9ho pou\017E\00EDvate\013Ea). Ulo\017Ei\0165, premenova\0165 alebo odstr\00E1ni\0165 ju m\00F4\017Ee koncov\00FD pou\017E\00EDvate\013E, ktor\00FD ju vytvoril. Ostatn\00ED pou\017E\00EDvatelia m\00F4\017Eu zobrazi\0165 a ulo\017Ei\0165 rozlo\017Eenie ako in\00FA zostavu.</li>'),
unistr('<li><strong>S\00FAkromn\00E1 zostava</strong> (pre koncov\00E9ho pou\017E\00EDvate\013Ea). Zostavu m\00F4\017Ee zobrazi\0165, ulo\017Ei\0165, premenova\0165 alebo odstr\00E1ni\0165 len koncov\00FD pou\017E\00EDvate\013E, ktor\00FD ju vytvoril.</li>'),
'</ul>',
unistr('<p>Ak ulo\017E\00EDte prisp\00F4soben\00E9 zostavy, selektor Zostavy sa zobraz\00ED na paneli vyh\013Ead\00E1vania na\013Eavo od selektora Riadky (ak je t\00E1to funkcia aktivovan\00E1).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543276865401786)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'sk'
,p_message_text=>unistr('V hornej \010Dasti ka\017Edej str\00E1nky zostavy je oblas\0165 vyh\013Ead\00E1vania. T\00E1to oblas\0165 (alebo panel vyh\013Ead\00E1vania) poskytuje nasleduj\00FAce funkcie:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606288725401832)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('<li><strong>Ponuka Akcie</strong> v\00E1m umo\017E\0148uje prisp\00F4sobi\0165 zostavu. Pozrite si nasleduj\00FAce sekcie.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605723309401831)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'sk'
,p_message_text=>unistr('<li><strong>Ikona Vybra\0165 st\013Apce</strong> v\00E1m umo\017E\0148uje identifikova\0165 st\013Apec (alebo v\0161etky st\013Apce) na vyh\013Ead\00E1vanie.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606088764401831)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'sk'
,p_message_text=>unistr('<li><strong>Zostavy</strong> zobrazuj\00FA alternat\00EDvne predvolen\00E9 a ulo\017Een\00E9 s\00FAkromn\00E9 alebo verejn\00E9 zostavy.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605976537401831)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('<li>Vo\013Eba <strong>Riadky</strong> nastav\00ED po\010Det z\00E1znamov, ktor\00E9 sa maj\00FA zobrazi\0165 na jednej str\00E1nke.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605851575401831)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Textov\00E1 oblas\0165</strong> v\00E1m umo\017E\0148uje zada\0165 krit\00E9ri\00E1 vyh\013Ead\00E1vania, v ktor\00FDch sa nerozli\0161uj\00FA mal\00E9 a ve\013Ek\00E9 p\00EDsmen\00E1 (z\00E1stupn\00E9 znaky s\00FA implicitn\00E9).</li>'),
unistr('<li><strong>Tla\010Didlo Prejs\0165</strong> spust\00ED vyh\013Ead\00E1vanie. Ke\010F je kurzor v textovej oblasti vyh\013Ead\00E1vania, vyh\013Ead\00E1vanie sa spust\00ED aj stla\010Den\00EDm kl\00E1vesu Enter.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606123986401831)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Tla\010Didlo <li><strong>Zobrazi\0165 ikony</strong> prep\00EDna medzi zobrazen\00EDm ikony, zostavy, detailov, grafu, zoskupenia a kontingen\010Dn\00FDm zobrazen\00EDm zostavy, ak s\00FA definovan\00E9.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622146193401843)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('<li>Ponuka <strong>Spravova\0165</strong> v\00E1m umo\017E\0148uje spravova\0165 vlastnosti, st\013Apce, riadky a hist\00F3riu zobrazenia pre zostavu alebo d\00E1tov\00FA mrie\017Eku.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543470585401786)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017E\00EDva sa na modifik\00E1ciu zobrazen\00FDch st\013Apcov. Zobrazuj\00FA sa st\013Apce vpravo. St\013Apce v\013Eavo s\00FA skryt\00E9. Poradie zobrazen\00FDch st\013Apcov m\00F4\017Eete zmeni\0165 pomocou \0161\00EDpok \00FAplne vpravo. Vypo\010D\00EDtan\00E9 st\013Apce maj\00FA predponu <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543651884401786)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pou\017E\00EDva sa na zmenu st\013Apcov na triedenie a ur\010D\00ED, \010Di'),
unistr('triedi\0165 v zostupnom alebo vzostupnom porad\00ED. M\00F4\017Eete tie\017E zada\0165, ako postupova\0165 pri hodnot\00E1ch'),
unistr('<code>NULL</code>. Pri predvolenom nastaven\00ED sa hodnoty <code>NULL</code> v\017Edy zobrazuj\00FA na konci alebo na za\010Diatku. V\00FDsledn\00E9 triedenie sa zobrazuje napravo od'),
unistr('z\00E1hlav\00ED st\013Apcov v zostave.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603380783401829)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Ke\010F prid\00E1te odber, zadajte e-mailov\00FA adresu (alebo viacer\00E9 e-mailov\00E9 adresy oddelen\00E9 \010Diarkami), predmet e-mailu, frekvenciu a po\010Diato\010Dn\00FD a koncov\00FD d\00E1tum. V\00FDsledn\00E9 e-maily zah\0155\0148aj\00FA verziu HTML interakt\00EDvnej zostavy, ktor\00E1 obsahuje aktu\00E1lne d\00E1ta a pou\017E')
||unistr('\00EDva nastavenia zostavy, ktor\00E9 existovali po\010Das prid\00E1vania odberu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621940820401843)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E1tov\00E9 mrie\017Eky s\00FA upravite\013En\00E9 zostavy s ve\013Ekou mierou prisp\00F4sobenia. Pou\017E\00EDvatelia m\00F4\017Eu zmeni\0165 rozlo\017Eenie d\00E1t zostavy v\00FDberom st\013Apcov, pou\017Eit\00EDm filtrov, zv\00FDraznen\00EDm a trieden\00EDm. M\00F4\017Eu definova\0165 aj zlomy, agreg\00E1cie, grafy alebo zoskupenia a prida\0165 vlast')
||unistr('n\00E9 v\00FDpo\010Dty. \010Ealej m\00F4\017Eu vytv\00E1ra\0165 viacer\00E9 varianty zost\00E1v a uklada\0165 ich ako pomenovan\00E9 zostavy na s\00FAkromn\00E9 zobrazenie. '),
'<p/>',
unistr('D\00E1tov\00FA mrie\017Eku je mo\017En\00E9 prisp\00F4sobi\0165 pomocou panela vyh\013Ead\00E1vania, ponuky Akcie, ponuky Spravova\0165 alebo ponuky Z\00E1hlavie st\013Apca.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633706440401851)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'sk'
,p_message_text=>unistr('Ponuka Akcie sa zobrazuje napravo od tla\010Didla Prejs\0165 na paneli vyh\013Ead\00E1vania. Pomocou tejto ponuky m\00F4\017Eete prisp\00F4sobi\0165 zostavu d\00E1tovej mrie\017Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622495634401843)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'sk'
,p_message_text=>unistr('Str\00E1nka Prida\0165 / upravi\0165 riadok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622573409401843)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ak chcete prida\0165 riadok do d\00E1tovej mrie\017Eky, kliknite na polo\017Eku Prida\0165 riadok. Ak chcete upravi\0165 detaily riadka, kliknite na ikonu \00FAprav riadka (prv\00FD st\013Apec) pre riadok, ktor\00FD chcete upravi\0165. Zobraz\00ED sa str\00E1nka Prida\0165/upravi\0165 riadok, na ktorej sa ')
||unistr('zobrazia st\013Apce d\00E1tovej mrie\017Eky. </p>'),
'',
unistr('<p>Pri \00FAprave riadka m\00F4\017Eete:</p>'),
'',
'<p><ul>',
unistr('<li><strong>Odstr\00E1ni\0165</strong> riadok.</li>'),
unistr('<li><strong>Pou\017Ei\0165 zmeny</strong> na ulo\017Eenie vykonan\00FDch zmien riadka.</li>'),
unistr('<li>V sekcii <strong>Akcie</strong> m\00F4\017Eete prida\0165 riadok, prida\0165 s\00FAbory, pozn\00E1mky, prepojenia alebo zna\010Dky a skontrolova\0165 hist\00F3riu.</li>'),
unistr('<li>Prejs\0165 na <strong>nasleduj\00FAce a predch\00E1dzaj\00FAce</strong> riadky.</li>'),
unistr('<li>V ponuke <strong>Spravova\0165</strong> m\00F4\017Eete nastavi\0165 vlastnosti st\013Apca, skupiny st\013Apcov, overenia a zoznamy hodn\00F4t.</li>'),
'</ul></p>',
'',
unistr('<p>V oblasti Anot\00E1cie v dolnej \010Dasti str\00E1nky sa zobrazia s\00FAbory, pozn\00E1mky, prepojenia alebo zna\010Dky, ktor\00E9 s\00FA priraden\00E9 k aktu\00E1lnemu riadku.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633896664401852)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017E\00EDva sa na vytvorenie zalamovacej skupiny pre jeden alebo viacero st\013Apcov. T\00FDmto sa vytiahnu st\013Apce z d\00E1tovej mrie\017Eky, ktor\00E9 sa zobrazia ako hlavn\00FD z\00E1znam.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622331079401843)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Umo\017E\0148uje stiahnutie aktu\00E1lnej mno\017Einy v\00FDsledkov. Medzi form\00E1ty na stiahnutie'),
unistr('patr\00ED CSV, HTML alebo E-mail.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633912243401852)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ak prisp\00F4sob\00EDte zostavu d\00E1tovej mrie\017Eky, nastavenia zostavy sa zobrazia pod panelom vyh\013Ead\00E1vania a nad zostavou. T\00FAto oblas\0165 je mo\017En\00E9 zbali\0165 a rozbali\0165 pomocou ikony v\013Eavo.'),
'<p>',
unistr('Pre ka\017Ed\00E9 nastavenie zostavy m\00F4\017Eete:'),
'</p><ul>',
unistr('<li>Upravi\0165 nastavenie kliknut\00EDm na n\00E1zov.</li>'),
unistr('<li>Deaktivova\0165/aktivova\0165 nastavenie zru\0161en\00EDm za\010Diarknutia alebo za\010Diarknut\00EDm pol\00ED\010Dka Aktivova\0165/deaktivova\0165. Pomocou tohto ovl\00E1dacieho prvku m\00F4\017Eete nastavenie do\010Dasne vypn\00FA\0165 a zapn\00FA\0165.</li>'),
unistr('<li>Odstr\00E1ni\0165 nastavenie kliknut\00EDm na ikonu Odobra\0165.</li>'),
'</ul>',
unistr('<p>Ak ste vytvorili graf alebo zoskupenie, m\00F4\017Eete prep\00EDna\0165 medzi nimi a z\00E1kladnou zostavou pomocou prepojen\00ED Zobrazenie zostavy, Zobrazenie grafu a Zobrazenie Zoskupi\0165 pod\013Ea, ktor\00E9 s\00FA vpravo. V pr\00EDpade zobrazenia grafu alebo zoskupenia m\00F4\017Eete na \00FApra')
||unistr('vu nastaven\00ED pou\017Ei\0165 aj prepojenie Upravi\0165.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622277720401843)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ulo\017E\00ED prisp\00F4soben\00E9 rozlo\017Eenie zostavy d\00E1tovej mrie\017Eky na bud\00FAce pou\017Eitie. Zad\00E1vate n\00E1zov a volite\013En\00FD popis. M\00F4\017Eete ulo\017Ei\0165 tri typy rozlo\017Eenia zostavy d\00E1tovej mrie\017Eky:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E1rne predvolen\00E9</strong> (len pre administr\00E1tora). Prim\00E1rne predvolen\00E9 rozlo\017Eenie sa zobrazuje ako po\010Diato\010Dn\00E9. Prim\00E1rne predvolen\00E9 zostavy nie je mo\017En\00E9 premenova\0165 ani odstr\00E1ni\0165.</li>'),
unistr('<li><strong>Alternat\00EDvna zostava</strong> (len pre administr\00E1tora). Administr\00E1torom umo\017E\0148uje vytvori\0165 viacer\00E9 rozlo\017Eenia zost\00E1v. Alternat\00EDvnu zostavu m\00F4\017Eu ulo\017Ei\0165, premenova\0165 alebo odstr\00E1ni\0165 len administr\00E1tori.</li>'),
unistr('<li><strong>S\00FAkromn\00E1 zostava</strong> (pre v\0161etk\00FDch pou\017E\00EDvate\013Eov). Zostavu m\00F4\017Ee zobrazi\0165, ulo\017Ei\0165, premenova\0165 alebo odstr\00E1ni\0165 pou\017E\00EDvate\013E, ktor\00FD vytvoril rozlo\017Eenie zostavy.</li>'),
'</ul>',
unistr('<p>Ak ulo\017E\00EDte prisp\00F4soben\00E9 zostavy, na paneli vyh\013Ead\00E1vania na\013Eavo od selektora Riadky sa zobraz\00ED selektor Zostavy (ak je t\00E1to funkcia aktivovan\00E1).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548350679401790)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Skry\0165 st\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538946861401783)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zv\00FDrazni\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549813008401791)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Zv\00FDraznenia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554970553401794)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'sk'
,p_message_text=>unistr('Podmienka zv\00FDraznenia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603936571401830)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'sk'
,p_message_text=>unistr('\0160t\00FDl zv\00FDraznenia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513906067401764)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Typ zv\00FDraznenia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623416546401844)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'sk'
,p_message_text=>'Vodorovne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653054706401866)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'sk'
,p_message_text=>unistr('1 neakt\00EDvne nastavenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653105075401866)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det neakt\00EDvnych nastaven\00ED: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544959008401787)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre interakt\00EDvnu zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555928212401795)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549371799401790)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD v\00FDraz v\00FDpo\010Dtu. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508776077401760)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Koncov\00FD d\00E1tum mus\00ED by\0165 neskor\0161\00ED ako po\010Diato\010Dn\00FD d\00E1tum.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563673796401801)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD v\00FDraz filtra. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631426051401850)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD dopyt filtra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653287546401866)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'sk'
,p_message_text=>unistr('1 neplatn\00E9 nastavenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653320403401866)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det neplatn\00FDch nastaven\00ED: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604152758401830)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'sk'
,p_message_text=>unistr('(v min\00FAtach)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621153557401842)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'sk'
,p_message_text=>'%0 je v posl. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621336912401842)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'sk'
,p_message_text=>'%0 je v nasl. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621290268401842)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v posl. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621497178401842)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'sk'
,p_message_text=>'%0 nie je v nasl. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554094242401794)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'sk'
,p_message_text=>unistr('Kl\00E1vesnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520117727401769)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547952116401789)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nadpis osi pre ozna\010Denie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540455474401784)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00FD de\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540664292401784)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'sk'
,p_message_text=>unistr('Posledn\00E1 hodina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540183002401783)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'sk'
,p_message_text=>unistr('Minul\00FD mesiac')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540237497401784)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('Minul\00FD t\00FD\017Ede\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540334053401784)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 d.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540547209401784)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 hod.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539974691401783)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'sk'
,p_message_text=>'Posl. %0 r.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540048847401783)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Minul\00FD rok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520083878401769)
,p_name=>'APEXIR_LINE'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ciarov\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516890989401766)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ciarov\00FD s plochou')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631308077401850)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'sk'
,p_message_text=>unistr('Mapova\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548870063401790)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'sk'
,p_message_text=>unistr('Odhaduje sa, \017Ee dopyt prekra\010Duje maxim\00E1lny povolen\00FD po\010Det prostriedkov. Zme\0148te nastavenia zostavy a sk\00FAste to znova.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531059710401777)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Maxim\00E1lny po\010Det riadkov pre t\00FAto zostavu je %0. Pou\017Eite filter na zn\00ED\017Eenie po\010Dtu z\00E1znamov v dopyte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631932286401850)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'sk'
,p_message_text=>'Maximum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632119986401850)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'sk'
,p_message_text=>unistr('Medi\00E1n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535062955401780)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('pred %0 min\00FAtami')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632038141401850)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'sk'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631014569401850)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'sk'
,p_message_text=>'Mesiac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604586295401830)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'sk'
,p_message_text=>unistr('Mesa\010Dne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547182609401789)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547059646401789)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 v\0161etko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658271583401869)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Je potrebn\00E9 zada\0165 statick\00E9 ID oblasti, preto\017Ee str\00E1nka obsahuje viacero interakt\00EDvnych zost\00E1v.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515514478401765)
,p_name=>'APEXIR_NAME'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542958278401786)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Nov\00E1 agreg\00E1cia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653907302401866)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Nov\00E1 kateg\00F3ria')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114543039053401786)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Nov\00FD v\00FDpo\010Det')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537893022401782)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540945223401784)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci de\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540723329401784)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAca hodina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541260096401784)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci mesiac')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541130498401784)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci t\00FD\017Ede\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541029476401784)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 d.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114540801752401784)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 hod.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541492039401784)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'sk'
,p_message_text=>'Nasl. %0 r.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541312140401784)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nasleduj\00FAci rok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515863082401766)
,p_name=>'APEXIR_NO'
,p_message_language=>'sk'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556122281401795)
,p_name=>'APEXIR_NONE'
,p_message_language=>'sk'
,p_message_text=>unistr('- \017Diadne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603726240401830)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 e-mailov\00E1 adresa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552628128401793)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnoty null v\017Edy na za\010Diatku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552598102401793)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnoty null v\017Edy na konci')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553038547401793)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'sk'
,p_message_text=>'Triedenie null %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549487239401790)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Cas flashbacku mus\00ED by\0165 numerick\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549083759401790)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'sk'
,p_message_text=>unistr('Poradie mus\00ED by\0165 numerick\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553521711401793)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Oper\00E1tor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514433560401765)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'sk'
,p_message_text=>unistr('oran\017Eov\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623355354401844)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Orient\00E1cia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516322671401766)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'sk'
,p_message_text=>unistr('In\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499163074401752)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Orient\00E1cia str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499893301401752)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Na \0161\00EDrku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499957832401752)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Na v\00FD\0161ku')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499098251401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ve\013Ekos\0165 str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499684279401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'sk'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499501427401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'sk'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499731422401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlastn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499350383401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'sk'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499281771401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'sk'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114499488105401752)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'sk'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632437307401850)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'sk'
,p_message_text=>unistr('Percento celkov\00E9ho po\010Dtu %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631634749401850)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'sk'
,p_message_text=>unistr('Percento celkov\00E9ho s\00FA\010Dtu %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630640454401849)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Percento celkov\00E9ho po\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630540621401849)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'sk'
,p_message_text=>unistr('Percento celkov\00E9ho s\00FA\010Dtu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519900662401769)
,p_name=>'APEXIR_PIE'
,p_message_language=>'sk'
,p_message_text=>unistr('Kol\00E1\010Dov\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579886123401812)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'sk'
,p_message_text=>unistr('Kontingen\010Dn\00E1 zostava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581322883401813)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Agreg\00E1t mus\00ED by\0165 zadan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581565543401814)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybran\00FD st\013Apec nemo\017Eno agregova\0165 ako st\013Apec riadka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580789400401813)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce kontingen\010Dnej zostavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580511810401813)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec kontingen\010Dnej zostavy %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581174710401813)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec kontingen\010Dnej zostavy mus\00ED by\0165 zadan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481231134401739)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Maxim\00E1lny po\010Det riadkov pre dopyt na kontingen\010Dn\00FA zostavu obmedzuje po\010Det riadkov v z\00E1kladnom dopyte, nie po\010Det zobrazen\00FDch riadkov. Z\00E1kladn\00FD dopyt prekra\010Duje maxim\00E1lny po\010Det riadkov %0. Pomocou filtra zn\00ED\017Ete po\010Det z\00E1znamov v z\00E1kladnom dopyte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581001872401813)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedenie kontingen\010Dnej zostavy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550476520401791)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec kontingen\010Dnej zostavy obsahuje pr\00EDli\0161 ve\013Ea odli\0161n\00FDch hodn\00F4t - pr\00EDkaz SQL kontingen\010Dnej zostavy nemo\017Eno vygenerova\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603863992401830)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Uk\00E1\017Eka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537986351401782)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114629538402401848)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'sk'
,p_message_text=>unistr('Prim\00E1rne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604872542401831)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prim\00E1rna zostava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498925322401752)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zahrn\00FA\0165 zna\010Dky pr\00EDstupnosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485820598401742)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 form\00E1tovanie RTF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562646208401800)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAkromn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520586167401769)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'sk'
,p_message_text=>unistr('Verejn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516188106401766)
,p_name=>'APEXIR_RED'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Derven\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658112640401869)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Statick\00E9 ID oblasti %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547270694401789)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547339277401789)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odobra\0165 v\0161etko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653494940401866)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 graf')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546887634401788)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 Control Break')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546583342401788)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 filter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546630745401788)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653598689401866)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 nastavenie Zoskupi\0165 pod\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546990305401789)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 zv\00FDraznenie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653600265401866)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 kontingen\010Dn\00FA zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634671049401852)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odstr\00E1ni\0165 zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615286401401838)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Premenova\0165 predvolen\00FA zostavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556448682401795)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Premenova\0165 zostavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538244324401782)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'sk'
,p_message_text=>'Zostava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632519176401851)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'sk'
,p_message_text=>'Zostavy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512763745401763)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E1 interakt\00EDvna zostava s aliasom %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562900653401800)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>'Zostava neexistuje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512876397401763)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('ID ulo\017Eenej interakt\00EDvnej zostavy %0 neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114554729794401794)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'sk'
,p_message_text=>'Nastavenia zostavy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535580747401780)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'sk'
,p_message_text=>'Zobrazenie zostavy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539429447401783)
,p_name=>'APEXIR_RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520748109401769)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovte predvolen\00E9 nastavenia zostavy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515984576401766)
,p_name=>'APEXIR_ROW'
,p_message_language=>'sk'
,p_message_text=>'Riadok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628632675401848)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnotu ROWID nem\00F4\017Eete pou\017Ei\0165 ako st\013Apec prim\00E1rneho k\013E\00FA\010Da pre d\00E1tov\00FD zdroj REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545980327401788)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'sk'
,p_message_text=>'Riadky'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605585226401831)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det riadkov na str\00E1nku')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580827575401813)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce riadka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580636532401813)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec riadka %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581256970401813)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec riadka mus\00ED by\0165 zadan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581436787401814)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec riadka sa mus\00ED l\00ED\0161i\0165 od st\013Apca kontingen\010Dnej zostavy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560087323401798)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'sk'
,p_message_text=>'Filter riadkov'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535625174401780)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'sk'
,p_message_text=>'Riadok %0 z %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539670910401783)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'sk'
,p_message_text=>'Text riadka obsahuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515273214401765)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550037476401791)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E1 zostava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549916357401791)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Een\00E1 zostava = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552123419401792)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lne nastavenia zostavy sa pou\017Eij\00FA ako predvolen\00E9 nastavenia pre v\0161etk\00FDch pou\017E\00EDvate\013Eov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114615146256401838)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165 predvolen\00FA zostavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114539371680401783)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165 zostavu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653849868401866)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165 zostavu *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606522090401832)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114544836042401787)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Panel h\013Eadania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114653783935401866)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612015345401836)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165 zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596059098401824)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybran\00E9 st\013Apce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516901316401766)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 st\013Apec -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538640551401782)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 st\013Apce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520405580401769)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 funkciu -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545659779401788)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 st\013Apec Zoskupi\0165 pod\013Ea -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580315924401813)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 st\013Apec kontingen\010Dnej zostavy -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631568289401850)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 riadok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580465064401813)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('- Vybra\0165 st\013Apec riadka -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489118505401744)
,p_name=>'APEXIR_SEND'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495404208401749)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'sk'
,p_message_text=>unistr('Odosla\0165 ako elektronick\00FA po\0161tu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515674851401766)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'sk'
,p_message_text=>'Poradie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538803673401783)
,p_name=>'APEXIR_SORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548169024401789)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 vzostupne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548218679401789)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 zostupne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634038830401852)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'sk'
,p_message_text=>'Poradie triedenia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542681873401785)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'sk'
,p_message_text=>'medzera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553757549401794)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'sk'
,p_message_text=>'Stav %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604289142401830)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'sk'
,p_message_text=>'Odber'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630971797401849)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'sk'
,p_message_text=>unistr('Kon\010D\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485394078401742)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'sk'
,p_message_text=>unistr('Vynecha\0165, ak sa nena\0161li \017Eiadne d\00E1ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114630856731401849)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010D\00EDna sa od')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631724663401850)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FA\010Det %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621710303401843)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'sk'
,p_message_text=>unistr('Oblas\0165 = %0, zostava = %1, zobrazenie = %2, za\010Diatok zobrazen\00FDch riadkov = %3, koniec zobrazen\00FDch riadkov = %4, celkov\00FD po\010Det riadkov = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542355913401785)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Oblas\0165 = %0, zostava = %1, zobrazenie = %2, za\010Diatok zobrazen\00FDch riadkov = %3, koniec zobrazen\00FDch riadkov = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514580177401765)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'sk'
,p_message_text=>'Farba textu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531641202401777)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'sk'
,p_message_text=>'d.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531599237401777)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'sk'
,p_message_text=>'hod.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531419825401777)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'sk'
,p_message_text=>'min.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531896961401777)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'sk'
,p_message_text=>'mes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531749978401777)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('t\00FD\017E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114531900408401777)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'sk'
,p_message_text=>'r.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114634488088401852)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prepn\00FA\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547449312401789)
,p_name=>'APEXIR_TOP'
,p_message_language=>'sk'
,p_message_text=>unistr('Na za\010Diatok')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627680856401847)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezoskupen\00FD st\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548908529401790)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov zv\00FDraznenia mus\00ED by\0165 jednozna\010Dn\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519253435401768)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('nepodporovan\00FD d\00E1tov\00FD typ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547568688401789)
,p_name=>'APEXIR_UP'
,p_message_language=>'sk'
,p_message_text=>'Nahor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549104759401790)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadajte platn\00FA farbu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549220773401790)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadajte platn\00FA masku form\00E1tu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114516498066401766)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'sk'
,p_message_text=>'Hodnota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114548057994401789)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'sk'
,p_message_text=>'Nadpis osi pre hodnotu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555858097401795)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Povinn\00E1 hodnota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519891742401768)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Zvisl\00FD st\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114623552433401844)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'sk'
,p_message_text=>'Zvisle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555154561401795)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 graf')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610318054401834)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 detaily')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114655933783401868)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Zostava nem\00E1 definovan\00E9 zobrazenie %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610458068401835)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 zoskupenie pod\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610252773401834)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'sk'
,p_message_text=>'Ikony zobrazenia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580152680401813)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 kontingen\010Dn\00FA zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114555271973401795)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 zostavu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604445051401830)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FD\017Edenne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538161746401782)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Pracovn\00E1 zostava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633134478401851)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'sk'
,p_message_text=>'%0 d.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633016962401851)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'sk'
,p_message_text=>'%0 hod.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114632942199401851)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'sk'
,p_message_text=>'%0 min.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633325015401851)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'sk'
,p_message_text=>'%0 mes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633287892401851)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 t\00FD\017E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114633409760401851)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'sk'
,p_message_text=>'%0 r.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114631153801401850)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'sk'
,p_message_text=>'Rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114514208041401764)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'sk'
,p_message_text=>unistr('\017Elt\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114515704792401766)
,p_name=>'APEXIR_YES'
,p_message_language=>'sk'
,p_message_text=>unistr('\00C1no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114547842690401789)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 obsahuje < or >, \010Do s\00FA neplatn\00E9 znaky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114570619846401806)
,p_name=>'APEX_REGION'
,p_message_language=>'sk'
,p_message_text=>unistr('Oblas\0165')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114498886194401752)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'sk'
,p_message_text=>unistr('Predbe\017En\00E1 podmienka API bola poru\0161en\00E1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518337243401767)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnotu nastavenia aplik\00E1cie %0 nie je mo\017En\00E9 z\00EDska\0165, preto\017Ee je deaktivovan\00E1 s\00FAvisiaca vo\013Eba kompil\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518200334401767)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnotu nastavenia aplik\00E1cie %0 nie je mo\017En\00E9 nastavi\0165, preto\017Ee je deaktivovan\00E1 s\00FAvisiaca vo\013Eba kompil\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625952782401846)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnota nastavenia aplik\00E1cie %0 je neplatn\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114625857435401846)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eadovan\00E9 nastavenie aplik\00E1cie %0 nie je definovan\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626051861401846)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Nastavenie aplik\00E1cie %0 nesmie obsahova\0165 hodnotu null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506995997401759)
,p_name=>'BACK'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493984820401748)
,p_name=>'BUILDER'
,p_message_language=>'sk'
,p_message_text=>unistr('Gener\00E1tor')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558017330401797)
,p_name=>'BUTTON LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie tla\010Didla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493040930401747)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedy CSS tla\010Didla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522289150401770)
,p_name=>'BUTTON_ID'
,p_message_language=>'sk'
,p_message_text=>unistr('Generovan\00E9 ID tla\010Didla bude statick\00E9 ID tla\010Didla (ak je definovan\00E9) alebo (ak nie je definovan\00E9) interne generovan\00E9 ID vo form\00E1te "B" || [Intern\00E9 ID tla\010Didla]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485783545401742)
,p_name=>'CANDLESTICK'
,p_message_language=>'sk'
,p_message_text=>unistr('Svie\010Dkov\00FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567229765401803)
,p_name=>'CENTER'
,p_message_language=>'sk'
,p_message_text=>'V strede'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517205817401767)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eiadavka %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508668120401760)
,p_name=>'CHECK$'
,p_message_language=>'sk'
,p_message_text=>'selektor riadkov'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114627750354401847)
,p_name=>'CHECKED'
,p_message_language=>'sk'
,p_message_text=>unistr('za\010Diarknut\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603283244401829)
,p_name=>'COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563711077401801)
,p_name=>'COMMENTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Koment\00E1re')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545246164401787)
,p_name=>'CONTINUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pokra\010Dova\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507256497401759)
,p_name=>'COPYRIGHT'
,p_message_language=>'sk'
,p_message_text=>'Copyright &copy; %0.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550953261401791)
,p_name=>'COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557638041401796)
,p_name=>'CREATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vytvori\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609936818401834)
,p_name=>'CREATED'
,p_message_language=>'sk'
,p_message_text=>unistr('Vytvoren\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610090193401834)
,p_name=>'CREATED_BY'
,p_message_language=>'sk'
,p_message_text=>'Vytvoril'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534839136401779)
,p_name=>'CREATED_ON'
,p_message_language=>'sk'
,p_message_text=>unistr('Vytvoren\00E9 d\0148a')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545405886401787)
,p_name=>'CUSTOM'
,p_message_language=>'sk'
,p_message_text=>unistr('Vlastn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556667110401796)
,p_name=>'CUSTOMIZE'
,p_message_language=>'sk'
,p_message_text=>unistr('Prisp\00F4sobi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558241916401797)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Preferencie str\00E1nky boli znovunastaven\00E9 pre pou\017E\00EDvate\013Ea %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558346885401797)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'sk'
,p_message_text=>unistr('Preferencie boli zmenen\00E9 pre pou\017E\00EDvate\013Ea %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558137016401797)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Preferencie str\00E1nky boli znovunastaven\00E9 pre pou\017E\00EDvate\013Ea %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521994058401770)
,p_name=>'DAILY'
,p_message_language=>'sk'
,p_message_text=>'Denne'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114493511529401748)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nahran\00FD s\00FAbor je neplatn\00FD alebo m\00E1 nespr\00E1vnu pr\00EDponu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517481773401767)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Eit\00FD neplatn\00FD selektor XML alebo JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486790927401743)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'sk'
,p_message_text=>unistr('Profil d\00E1t a nahran\00FD s\00FAbor neobsahuj\00FA \017Eiadny st\013Apec cie\013Eovej tabu\013Eky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572477393401807)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'sk'
,p_message_text=>unistr('V nahranom s\00FAbore sa nena\0161li \017Eiadne d\00E1ta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572576366401807)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'sk'
,p_message_text=>unistr('V pracovnom h\00E1rku "%0" sa nena\0161li \017Eiadne d\00E1ta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114492318271401747)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00FD s\00FAbor nie je s\00FAborom XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114482702503401740)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavedenie d\00E1t bolo dokon\010Den\00E9: po\010Det spracovan\00FDch riadkov: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483964632401741)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavedenie d\00E1t bolo dokon\010Den\00E9: po\010Det spracovan\00FDch riadkov s jednou chybou: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484250413401741)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavedenie d\00E1t bolo dokon\010Den\00E9: po\010Det spracovan\00FDch riadkov s %1 chybami: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484085648401741)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavedenie d\00E1t bolo dokon\010Den\00E9: spracovan\00FD 1 riadok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487053675401743)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavedenie d\00E1t bolo dokon\010Den\00E9: spracovan\00FD bol jeden riadok s chybou.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484179739401741)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavedenie d\00E1t bolo dokon\010Den\00E9: spracovan\00FD bol jeden riadok bez chyby.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577742365401811)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'sk'
,p_message_text=>unistr('Cie\013Eov\00FD st\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577801367401811)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'sk'
,p_message_text=>unistr('Zdrojov\00FD st\013Apec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578611241401811)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Form\00E1t d\00E1tumu / \010D\00EDsla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642068039401858)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Nepodarilo sa vyvola\0165 hodnotu vyh\013Ead\00E1vacieho k\00F3du.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114610565998401835)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'sk'
,p_message_text=>unistr('Mapovanie d\00E1t / tabuliek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578799916401812)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'sk'
,p_message_text=>'Riadok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574260545401808)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pravidlo transform\00E1cie zlyhalo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550585402401791)
,p_name=>'DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tum')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524644686401772)
,p_name=>'DAY'
,p_message_language=>'sk'
,p_message_text=>unistr('de\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524742167401772)
,p_name=>'DAYS'
,p_message_language=>'sk'
,p_message_text=>'d.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563490368401800)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'sk'
,p_message_text=>unistr('Ladenie pre t\00FAto aplik\00E1ciu nie je aktivovan\00E9.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114612269115401836)
,p_name=>'DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525471115401773)
,p_name=>'DELETE'
,p_message_language=>'sk'
,p_message_text=>unistr('odstr\00E1ni\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114485687519401742)
,p_name=>'DIAL_PCT'
,p_message_language=>'sk'
,p_message_text=>unistr('Mera\010D (percento)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500198902401753)
,p_name=>'DOWNLOAD'
,p_message_language=>'sk'
,p_message_text=>unistr('Stiahnu\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611394303401835)
,p_name=>'DUP_USER'
,p_message_language=>'sk'
,p_message_text=>unistr('Duplicitn\00E9 meno pou\017E\00EDvate\013Ea v r\00E1mci zoznamu.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507717120401759)
,p_name=>'EDIT'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517153162401767)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('E-mailov\00E1 adresa "%0" sa nena\0161la.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502223517401754)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Tento e-mail je od odosielate\013Ea %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611513505401835)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'sk'
,p_message_text=>unistr('E-mailov\00E1 adresa je pr\00EDli\0161 dlh\00E1. Limit je 240 znakov.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545142739401787)
,p_name=>'ERROR'
,p_message_language=>'sk'
,p_message_text=>'Chyba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574350613401808)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'sk'
,p_message_text=>unistr('Nie je mo\017En\00E9 nastavi\0165 zdrojov\00FA hodnotu polo\017Eky str\00E1nky pre oblas\0165 \010Diasto\010Dn\00E9ho obnovenia str\00E1nky')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536652101401781)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'sk'
,p_message_text=>'Vytvoril'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502526655401754)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Platnos\0165 hesla uplynula')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114496603013401750)
,p_name=>'FILE_EMPTY'
,p_message_language=>'sk'
,p_message_text=>unistr('S\00FAbor je pr\00E1zdny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576873206401810)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ve\013Ekos\0165 nahran\00E9ho s\00FAboru bola viac ako %0 MB. Nahrajte men\0161\00ED s\00FAbor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504680940401756)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Autentifik\00E1cia pou\017E\00EDvate\013Ea zlyhala a jeden alebo viacero s\00FAborov sa nepodarilo nahra\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504700984401757)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00E1to in\0161tancia nepovo\013Euje neautentifikovan\00FDm pou\017E\00EDvate\013Eom nahr\00E1va\0165 s\00FAbory.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557783917401796)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'sk'
,p_message_text=>'Vyskytla sa jedna chyba'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556983821401796)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'sk'
,p_message_text=>'Vyskytli sa chyby (%0)'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507133686401759)
,p_name=>'FORM_OF'
,p_message_language=>'sk'
,p_message_text=>'%0 z %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541889161401785)
,p_name=>'GO'
,p_message_language=>'sk'
,p_message_text=>unistr('Prejs\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641609343401857)
,p_name=>'HELP'
,p_message_language=>'sk'
,p_message_text=>'Pomoc'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494051530401748)
,p_name=>'HOME'
,p_message_language=>'sk'
,p_message_text=>'Domov'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524409943401772)
,p_name=>'HOUR'
,p_message_language=>'sk'
,p_message_text=>'hodina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524507841401772)
,p_name=>'HOURS'
,p_message_language=>'sk'
,p_message_text=>'hod.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508582690401760)
,p_name=>'ICON'
,p_message_language=>'sk'
,p_message_text=>'Ikona %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558536010401797)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E9 prihlasovacie doklady')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114658054586401869)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 hodnota pre parameter: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553285622401793)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'sk'
,p_message_text=>unistr('Ako predvolen\00E9 nastavenia zostavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553307100401793)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ako pomenovan\00E1 zostava')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535746459401780)
,p_name=>'IR_ERROR'
,p_message_language=>'sk'
,p_message_text=>'Chyba %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535442596401780)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nie je mo\017En\00E9 vypo\010D\00EDta\0165 navig\00E1ciu vo formul\00E1ri. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513056786401764)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Interakt\00EDvna zostava sa nena\0161la.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512467239401763)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Oblas\0165 interakt\00EDvnej zostavy neexistuje v aplik\00E1cii %0, na str\00E1nke %1 a v oblasti %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114553171831401793)
,p_name=>'IR_STAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazen\00E9 len pre v\00FDvoj\00E1rov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541580847401784)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt na zostavu po\017Eaduje na identifik\00E1ciu ka\017Ed\00E9ho riadka jednozna\010Dn\00FD k\013E\00FA\010D. Zadan\00FD k\013E\00FA\010D sa pre tento dopyt ned\00E1 pou\017Ei\0165. Definujte st\013Apec jednozna\010Dn\00E9ho k\013E\00FA\010Da. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541685887401785)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt na zostavu po\017Eaduje na identifik\00E1ciu ka\017Ed\00E9ho riadka jednozna\010Dn\00FD k\013E\00FA\010D. Zadan\00FD k\013E\00FA\010D sa pre tento dopyt ned\00E1 pou\017Ei\0165. Upravte atrib\00FAty zostavy na definovanie st\013Apca jednozna\010Dn\00E9ho k\013E\00FA\010Da. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578952827401812)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 s\00FAbor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578841449401812)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'sk'
,p_message_text=>unistr('Sem presu\0148te s\00FAbor alebo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507487980401759)
,p_name=>'ITEMS'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536865837401781)
,p_name=>'ITEM_VALUE'
,p_message_language=>'sk'
,p_message_text=>unistr('Hodnota polo\017Eky')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551237691401792)
,p_name=>'LABEL'
,p_message_language=>'sk'
,p_message_text=>unistr('Ozna\010Denie')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563321314401800)
,p_name=>'LANGUAGE'
,p_message_language=>'sk'
,p_message_text=>'Jazyk'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525187329401772)
,p_name=>'LAST'
,p_message_language=>'sk'
,p_message_text=>'posl.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504524821401756)
,p_name=>'LENGTH'
,p_message_language=>'sk'
,p_message_text=>unistr('D\013A\017Eka')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557859358401796)
,p_name=>'LOGIN'
,p_message_language=>'sk'
,p_message_text=>unistr('Prihl\00E1senie')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596444596401824)
,p_name=>'MANAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Spravova\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661035069401872)
,p_name=>'MAXIMIZE'
,p_message_language=>'sk'
,p_message_text=>unistr('Maximalizova\0165')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524296034401772)
,p_name=>'MINUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('min\00FAta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524331981401772)
,p_name=>'MINUTES'
,p_message_language=>'sk'
,p_message_text=>'min.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611720539401836)
,p_name=>'MISSING_AT'
,p_message_language=>'sk'
,p_message_text=>unistr('V e-mailovej adrese ch\00FDba "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611988804401836)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'sk'
,p_message_text=>unistr('Upozornenie: Pre str\00E1nku dial\00F3gov\00E9ho okna %0 v aplik\00E1cii %1 nebola definovan\00E1 \017Eiadna \0161abl\00F3na str\00E1nky dial\00F3gov\00E9ho okna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611695442401835)
,p_name=>'MISSING_DOT'
,p_message_language=>'sk'
,p_message_text=>unistr('V dom\00E9ne e-mailovej adresy ch\00FDba ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560864008401799)
,p_name=>'MODULE'
,p_message_language=>'sk'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517957192401767)
,p_name=>'MONTH'
,p_message_language=>'sk'
,p_message_text=>'Mesiac'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521780573401770)
,p_name=>'MONTHLY'
,p_message_language=>'sk'
,p_message_text=>unistr('Mesa\010Dne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518003107401767)
,p_name=>'MONTHS'
,p_message_language=>'sk'
,p_message_text=>'mes.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550803328401791)
,p_name=>'MOVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618375566401840)
,p_name=>'MOVE_FROM'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 z')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618482614401840)
,p_name=>'MOVE_TO'
,p_message_language=>'sk'
,p_message_text=>unistr('Presun\00FA\0165 do')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114538054840401782)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri oper\00E1cii odstr\00E1nenia viacer\00FDch riadkov: riadok = %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537033095401781)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'sk'
,p_message_text=>unistr('Nesmie \00EDs\0165 o verejn\00E9ho pou\017E\00EDvate\013Ea')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494200037401748)
,p_name=>'NAME'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551008074401791)
,p_name=>'NEW'
,p_message_language=>'sk'
,p_message_text=>unistr('Nov\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517744350401767)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'sk'
,p_message_text=>unistr('Tu sa m\00F4\017Eete prihl\00E1si\0165 do %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517834720401767)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Upozornenie na nov\00E9 konto %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641816475401858)
,p_name=>'NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560733429401799)
,p_name=>'NO'
,p_message_language=>'sk'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114656004386401868)
,p_name=>'NOBODY'
,p_message_language=>'sk'
,p_message_text=>'nikto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525566407401773)
,p_name=>'NOT'
,p_message_language=>'sk'
,p_message_text=>'Nie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566397056401803)
,p_name=>'NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>'Nie je null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537119331401781)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'sk'
,p_message_text=>'Nie je %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556777338401796)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('nena\0161li sa \017Eiadne d\00E1ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565873873401802)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Nena\0161la sa zostava, ktor\00FA mo\017Eno aktualizova\0165. Oper\00E1cie aktualiz\00E1cie a odstr\00E1nenia viacer\00FDch riadkov je mo\017En\00E9 vykon\00E1va\0165 len pre tabu\013Ekov\00E9 formul\00E1re typu Aktualizovate\013En\00E1 zostava.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566732254401803)
,p_name=>'OK'
,p_message_language=>'sk'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562495507401800)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'sk'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114659822736401871)
,p_name=>'ORA_06550'
,p_message_language=>'sk'
,p_message_text=>unistr('ORA-06550: Riadok %0, st\013Apec %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609398030401834)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017E\00EDvate zastaran\00FD webov\00FD preh\013Ead\00E1va\010D. Zoznam podporovan\00FDch preh\013Ead\00E1va\010Dov n\00E1jdete v pr\00EDru\010Dke Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510751422401762)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eadovan\00E1 neplatn\00E1 mno\017Eina riadkov, zdrojov\00E9 d\00E1ta zostavy boli modifikovan\00E9.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530875170401776)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Je potrebn\00E9 zada\0165 platn\00E9 \010D\00EDslo str\00E1nky, napr\00EDklad p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534494691401779)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Ealej')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534598454401779)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'sk'
,p_message_text=>unistr('\010Eal\0161ia mno\017Eina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534646719401779)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114534714339401779)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'sk'
,p_message_text=>unistr('Predch\00E1dzaj\00FAca mno\017Eina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641785703401857)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 str\00E1nkovanie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572315528401807)
,p_name=>'PASSWORD'
,p_message_language=>'sk'
,p_message_text=>'Heslo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517065580401767)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'sk'
,p_message_text=>unistr('Va\0161e heslo pre %0 bolo zmenen\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506843683401758)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo nezodpoved\00E1 pravidl\00E1m zlo\017Eitosti hesla tejto lokality.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505915124401758)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nov\00E9 heslo sa mus\00ED l\00ED\0161i\0165 od star\00E9ho hesla aspo\0148 v %0 znakoch.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506558041401758)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo nesmie obsahova\0165 meno pou\017E\00EDvate\013Ea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506719157401758)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo obsahuje zak\00E1zan\00E9 jednoduch\00E9 slovo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506693363401758)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo nesmie obsahova\0165 n\00E1zov pracovn\00E9ho priestoru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505894590401758)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo mus\00ED obsahova\0165 aspo\0148 %0 znakov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506039980401758)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo mus\00ED obsahova\0165 aspo\0148 jeden abecedn\00FD znak (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506425627401758)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo mus\00ED obsahova\0165 aspo\0148 jedno mal\00E9 p\00EDsmeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506178787401758)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo mus\00ED obsahova\0165 aspo\0148 jeden numerick\00FD znak (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506244767401758)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo mus\00ED obsahova\0165 aspo\0148 jedno interpunk\010Dn\00E9 znamienko (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114506395698401758)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo mus\00ED obsahova\0165 aspo\0148 jedno ve\013Ek\00E9 p\00EDsmeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517575398401767)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'sk'
,p_message_text=>'Upozornenie na znovunastavenie hesla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504895936401757)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Heslo nie je mo\017En\00E9 pou\017Ei\0165, preto\017Ee bolo pou\017Eit\00E9 v posledn\00FDch %0 d\0148och.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585128231401816)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114585229002401816)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562289596401800)
,p_name=>'PERCENT'
,p_message_language=>'sk'
,p_message_text=>'Percento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532584888401778)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Kontaktujte administr\00E1tora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114641968982401858)
,p_name=>'PREVIOUS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sp\00E4\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577392451401811)
,p_name=>'PRINT'
,p_message_language=>'sk'
,p_message_text=>unistr('Tla\010Di\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561071423401799)
,p_name=>'PRIVILEGES'
,p_message_language=>'sk'
,p_message_text=>unistr('Privil\00E9gi\00E1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530934735401777)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'sk'
,p_message_text=>'Referencie oblasti'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551122419401792)
,p_name=>'REPORT'
,p_message_language=>'sk'
,p_message_text=>'Zostava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560962610401799)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'sk'
,p_message_text=>unistr('Vykazovan\00E9 obdobie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642187634401858)
,p_name=>'REPORT_LABEL'
,p_message_language=>'sk'
,p_message_text=>'Zostava: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561692095401799)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'sk'
,p_message_text=>'Zostava celkom'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510854325401762)
,p_name=>'RESET'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165 str\00E1nkovanie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536702583401781)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165 str\00E1nkovanie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565788510401802)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'sk'
,p_message_text=>unistr('Znovunastavi\0165 heslo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542537467401785)
,p_name=>'RESTORE'
,p_message_language=>'sk'
,p_message_text=>unistr('Obnovi\0165')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114574492797401809)
,p_name=>'RESULTS'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDsledky')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566854558401803)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1vrat do aplik\00E1cie.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114567180390401803)
,p_name=>'RIGHT'
,p_message_language=>'sk'
,p_message_text=>'Vpravo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596732812401824)
,p_name=>'ROW'
,p_message_language=>'sk'
,p_message_text=>'Riadok %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550751186401791)
,p_name=>'ROW_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det riadkov')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114566280551401802)
,p_name=>'SAVE'
,p_message_language=>'sk'
,p_message_text=>unistr('Ulo\017Ei\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562818492401800)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Alternat\00EDvne predvolen\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563260728401800)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'sk'
,p_message_text=>'Popis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562746717401800)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Prim\00E1rne predvolen\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563582092401801)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'sk'
,p_message_text=>unistr('K dispoz\00EDcii je viac riadkov ako %0. Zv\00FD\0161te hodnotu selektora riadkov na zobrazenie \010Fal\0161\00EDch riadkov.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628969764401848)
,p_name=>'SEARCH'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyh\013Eada\0165')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524192435401772)
,p_name=>'SECONDS'
,p_message_language=>'sk'
,p_message_text=>'s.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562309432401800)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pozrite pr\00EDlohu')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620015040401841)
,p_name=>'SELECT_ROW'
,p_message_language=>'sk'
,p_message_text=>unistr('Vybra\0165 riadok')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562095005401799)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'sk'
,p_message_text=>unistr('Nastavi\0165 vypnutie re\017Eimu pom\00F4cky na \010D\00EDtanie obrazovky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562177545401800)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'sk'
,p_message_text=>unistr('Nastavi\0165 zapnutie re\017Eimu pom\00F4cky na \010D\00EDtanie obrazovky')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558498903401797)
,p_name=>'SHOW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621834335401843)
,p_name=>'SHOW_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 v\0161etko')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114647901979401862)
,p_name=>'SIGN_IN'
,p_message_language=>'sk'
,p_message_text=>unistr('Prihl\00E1si\0165 sa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114597576802401825)
,p_name=>'SIGN_OUT'
,p_message_language=>'sk'
,p_message_text=>unistr('Odhl\00E1si\0165 sa')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551727882401792)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('pred %0 d\0148ami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558985335401797)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 dn\00ED odteraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551647426401792)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'sk'
,p_message_text=>'pred %0 hodinami'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558806840401797)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 hod\00EDn odteraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551531242401792)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('pred %0 min\00FAtami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558751851401797)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 min\00FAt odteraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551977615401792)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'sk'
,p_message_text=>'pred %0 mesiacmi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559115258401797)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'%0 mesiacov odteraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559382839401798)
,p_name=>'SINCE_NOW'
,p_message_language=>'sk'
,p_message_text=>'Teraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551414286401792)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'sk'
,p_message_text=>'Pred %0 sekundami'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114558619742401797)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 sek\00FAnd odteraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114551895244401792)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'sk'
,p_message_text=>unistr('pred %0 t\00FD\017Ed\0148ami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559039637401797)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 t\00FD\017Ed\0148ov odteraz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114552052513401792)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'sk'
,p_message_text=>'pred %0 rokmi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559237380401797)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'sk'
,p_message_text=>'%0 rokov odteraz'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545566900401788)
,p_name=>'STANDARD'
,p_message_language=>'sk'
,p_message_text=>unistr('\0160tandardn\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561968571401799)
,p_name=>'START_DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Diato\010Dn\00FD d\00E1tum')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502473861401754)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'sk'
,p_message_text=>unistr('Tento e-mail ste dostali na z\00E1klade odberu interakt\00EDvnej zostavy, ktor\00FD vytvoril pou\017E\00EDvate\013E %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657122747401869)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'sk'
,p_message_text=>'Odbery'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605251146401831)
,p_name=>'TAB'
,p_message_language=>'sk'
,p_message_text=>'Karta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524065096401772)
,p_name=>'TITLE'
,p_message_language=>'sk'
,p_message_text=>'Nadpis'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507051433401759)
,p_name=>'TODAY'
,p_message_language=>'sk'
,p_message_text=>'Dnes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561509233401799)
,p_name=>'TOTAL'
,p_message_language=>'sk'
,p_message_text=>'Celkom'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508027893401760)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Je mo\017En\00E9 vybra\0165 maxim\00E1lne %0 st\013Apcov.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486555107401743)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zbali\0165 v\0161etko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486896009401743)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zbali\0165 v\0161etko pod')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486472843401743)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozbali\0165 v\0161etko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486689615401743)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'sk'
,p_message_text=>unistr('Rozbali\0165 v\0161etko pod')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486973431401743)
,p_name=>'TREE.REPARENT'
,p_message_language=>'sk'
,p_message_text=>unistr('Nov\00E1 nadraden\00E1 polo\017Eka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579124894401812)
,p_name=>'TREES'
,p_message_language=>'sk'
,p_message_text=>'Stromy'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114622608471401843)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Povinn\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114546240834401788)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'sk'
,p_message_text=>unistr('Neautorizovan\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114593048709401822)
,p_name=>'UNAVAILABLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nedostupn\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559790323401798)
,p_name=>'UNKNOWN'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezn\00E1me')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503326549401755)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Vyskytla sa nerozpoznan\00E1 chyba autentifik\00E1cie.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505332990401757)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'sk'
,p_message_text=>unistr('Ak u\017E \010Falej nechcete by\0165 pr\00EDjemcom t\00FDchto e-mailov, kliknite na polo\017Eku <a href="%0">Zru\0161i\0165 odber</a> a vykonajte spr\00E1vu svojho odberu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114502373613401754)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'sk'
,p_message_text=>unistr('Ak u\017E \010Falej nechcete by\0165 pr\00EDjemcom t\00FDchto e-mailov, na nasleduj\00FAcej adrese URL m\00F4\017Eete spravova\0165 svoj odber:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114537278559401781)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('nepodporovan\00FD d\00E1tov\00FD typ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525329074401773)
,p_name=>'UPDATE'
,p_message_language=>'sk'
,p_message_text=>unistr('aktualizova\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523971977401772)
,p_name=>'UPDATED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktualizovan\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530668240401776)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eadovan\00E1 adresa URL bola zak\00E1zan\00E1. Kontaktujte administr\00E1tora.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114550680781401791)
,p_name=>'USER'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017E\00EDvate\013E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114572291534401807)
,p_name=>'USERNAME'
,p_message_language=>'sk'
,p_message_text=>unistr('Meno pou\017E\00EDvate\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611874747401836)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'sk'
,p_message_text=>unistr('Meno pou\017E\00EDvate\013Ea je pr\00EDli\0161 dlh\00E9. Limit je %0 znakov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557401856401796)
,p_name=>'USERS'
,p_message_language=>'sk'
,p_message_text=>unistr('pou\017E\00EDvatelia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114611472827401835)
,p_name=>'USER_EXISTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Meno pou\017E\00EDvate\013Ea u\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114626113674401846)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Obr\00E1zok profilu pre pou\017E\00EDvate\013Ea %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513753623401764)
,p_name=>'VALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Platn\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507321529401759)
,p_name=>'VALIDATIONS'
,p_message_language=>'sk'
,p_message_text=>'Overenia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563086664401800)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'sk'
,p_message_text=>unistr('Je potrebn\00E9 zada\0165 hodnotu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606435491401832)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre %0 mus\00ED by\0165 zadan\00E1 hodnota')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532964250401778)
,p_name=>'VERTICAL'
,p_message_language=>'sk'
,p_message_text=>unistr('zvisl\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525219923401772)
,p_name=>'VIEW'
,p_message_language=>'sk'
,p_message_text=>unistr('zobrazi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557530611401796)
,p_name=>'VIEWS'
,p_message_language=>'sk'
,p_message_text=>'zobrazenia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563835385401801)
,p_name=>'VIEW_ALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazi\0165 v\0161etko')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114545020240401787)
,p_name=>'WARNING'
,p_message_language=>'sk'
,p_message_text=>'Upozornenie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524826620401772)
,p_name=>'WEEK'
,p_message_language=>'sk'
,p_message_text=>unistr('t\00FD\017Ede\0148')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521851386401770)
,p_name=>'WEEKLY'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FD\017Edenne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114524925362401772)
,p_name=>'WEEKS'
,p_message_language=>'sk'
,p_message_text=>unistr('t\00FD\017E.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114563172729401800)
,p_name=>'WELCOME_USER'
,p_message_language=>'sk'
,p_message_text=>'Vitajte: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561372154401799)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'sk'
,p_message_text=>unistr('Na\0161la sa neplatn\00E1 hodnota, overte zadan\00E9 d\00E1ta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561421933401799)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Na\0161la sa neplatn\00E1 hodnota, overte zadan\00E9 d\00E1ta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504453198401756)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'sk'
,p_message_text=>unistr('Na\0161la sa neplatn\00E1 hodnota d\00E1tumu, overte form\00E1t d\00E1tumu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114561284369401799)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'sk'
,p_message_text=>unistr('Na\0161la sa neplatn\00E1 \010D\00EDseln\00E1 hodnota, overte form\00E1t \010D\00EDsla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513308785401764)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'sk'
,p_message_text=>unistr('Na\0161la sa neplatn\00E1 hodnota \010Dasovej zna\010Dky. Overte form\00E1t \010Dasovej zna\010Dky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114535839026401780)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Viazanie "%0" nie je mo\017En\00E9. Pou\017Eite dvojit\00E9 \00FAvodzovky pre viacbajtov\00E9 polo\017Eky alebo overte, \017Ee d\013A\017Eka polo\017Eky neprekra\010Duje 30 bajtov. Ak chcete odkazova\0165 na polo\017Eky dlh\0161ie ako 30 bajtov, pou\017Eite syntax v().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526395073401773)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstup odmietnut\00FD na z\00E1klade kontroly zabezpe\010Denia %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528805643401775)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Aplik\00E1cia nie je k dispoz\00EDcii')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527200490401774)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1014 Aplik\00E1cia sa nena\0161la.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527391808401774)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('aplik\00E1cia=%0  pracovn\00FD priestor=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527757107401774)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstup k tejto aplik\00E1cii je obmedzen\00FD. Sk\00FAste to znova nesk\00F4r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527690463401774)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstup k tejto aplik\00E1cii je obmedzen\00FD na v\00FDvoj\00E1rov aplik\00E1ci\00ED. Sk\00FAste to znova nesk\00F4r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526819004401774)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-7744 Nie je mo\017En\00E9 spracova\0165 vetvenie na funkciu, ktor\00E1 vr\00E1ti adresu URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526783453401774)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-7744 Nie je mo\017En\00E9 spracova\0165 vetvenie na funkciu, ktor\00E1 vr\00E1ti str\00E1nku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527000793401774)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1430 Nepodporovan\00E9 volanie na zobrazenie z procesu str\00E1nky: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528164647401775)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1018 Chyba pri vymaz\00E1van\00ED cache kroku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526531487401773)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1005 Nezn\00E1my typ v\00FDpo\010Dtu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527489230401774)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1201 ID rel\00E1cie nie je nastaven\00E9 na vlastn\00FA autentifik\00E1ciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527567431401774)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('str\00E1nka=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114527157906401774)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-7620 Nepodarilo sa ur\010Di\0165 pracovn\00FD priestor pre aplik\00E1ciu (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509596598401761)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'sk'
,p_message_text=>unistr('Upravi\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526248422401773)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1802 Nena\0161lo sa ID polo\017Eky "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525988537401773)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1002 Nena\0161lo sa ID polo\017Eky "%0" v aplik\00E1cii "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526034098401773)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'sk'
,p_message_text=>unistr('Neo\010Dak\00E1van\00E1 chyba, nena\0161iel sa n\00E1zov polo\017Eky na \00FArovni aplik\00E1cie alebo str\00E1nky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526481756401773)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('U\017E sa nach\00E1dzate na prvej str\00E1nke d\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114541924589401785)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'sk'
,p_message_text=>unistr('V pr\00EDpade ID polo\017Eky (%0) nejde o polo\017Eku definovan\00FA na aktu\00E1lnej str\00E1nke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504062552401756)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eku nie je mo\017En\00E9 nastavi\0165 odovzdan\00EDm argumentov do aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504356749401756)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'sk'
,p_message_text=>unistr('(Nebol zadan\00FD \017Eiadny kontroln\00FD s\00FA\010Det)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503840747401756)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eku je mo\017En\00E9 nastavi\0165, ke\010F m\00E1 pridelen\00FD kontroln\00FD s\00FA\010Det "z\00E1lo\017Eka na \00FArovni pou\017E\00EDvate\013Ea".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503700417401756)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eku je mo\017En\00E9 nastavi\0165, ke\010F m\00E1 pridelen\00FD kontroln\00FD s\00FA\010Det "z\00E1lo\017Eka na \00FArovni aplik\00E1cie".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503975220401756)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eku je mo\017En\00E9 nastavi\0165, ke\010F m\00E1 pridelen\00FD kontroln\00FD s\00FA\010Det "rel\00E1cia".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503603263401756)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eka nem\00E1 \017Eiadnu ochranu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528273936401775)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'sk'
,p_message_text=>unistr('Pomoc pre str\00E1nku nie je k dispoz\00EDcii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114517301835401767)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'sk'
,p_message_text=>unistr('Pracovn\00FD priestor %0 nem\00E1 \017Eiadne privil\00E9gi\00E1, aby sa syntakticky analyzoval ako sch\00E9ma %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526627338401773)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1010 Bol prekro\010Den\00FD limit rekurzie spracovania prijatia vetvenia na str\00E1nku. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504227042401756)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FAto str\00E1nku nemo\017Eno vyvola\0165 pomocou adresy URL ani pomocou pr\00EDkazov GET alebo POST na zobrazenie proced\00FAry. Je potrebn\00E9 ju vyvola\0165 pomocou typu vetvenia "Vetvi\0165 na str\00E1nku".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114580948305401813)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri pokuse o ulo\017Eenie nenumerickej hodnoty v polo\017Eke %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519014864401768)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Sch\00E9ma syntaktickej anal\00FDzy aplik\00E1cie "%0" v datab\00E1ze neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114519131660401768)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'sk'
,p_message_text=>unistr('Kont\00E1 v INTERNOM pracovnom priestore sa m\00F4\017Eu pou\017Ei\0165 len na pr\00EDstup do produktu &PRODUCT_NAME. <a href="%0">Slu\017Eby administr\00E1cie</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525834938401773)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-1029 Nie je mo\017En\00E9 ulo\017Ei\0165 inform\00E1cie o rel\00E1cii.  Rel\00E1cia=%0 polo\017Eka=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528961551401775)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Trasovanie nie je mo\017En\00E9 zastavi\0165: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114526127913401773)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Neo\010Dak\00E1van\00E1 chyba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536127442401780)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'sk'
,p_message_text=>'Chyba v update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529053723401775)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Na zobrazenie pomoci je potrebn\00E9 zada\0165 aplik\00E1ciu a str\00E1nku.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114549539141401790)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Automatiz\00E1cia sa nena\0161la.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530150863401776)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det \00FAplne vymazan\00FDch rel\00E1ci\00ED: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489408439401745)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'sk'
,p_message_text=>unistr('K\00F3d %0 nie je mo\017En\00E9 spusti\0165! Nie je podporovan\00FD v datab\00E1ze alebo nie je aktivovan\00FD parametrom in\0161tancie MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114489201140401745)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'sk'
,p_message_text=>unistr('Multilingual Engine nie je v tejto verzii datab\00E1zy k dispoz\00EDcii!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510084917401761)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Pole kolekcie aplik\00E1cie nesmie by\0165 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509894267401761)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00FD po\010Det atrib\00FAtov \010Dlena %0 je neplatn\00FD. Po\010Det atrib\00FAtov mus\00ED by\0165 v rozsahu od 1 do %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510332844401762)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Kolekcia aplik\00E1cie existuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510119507401761)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov kolekcie nem\00F4\017Ee by\0165 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510216327401761)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'sk'
,p_message_text=>unistr('N\00E1zov kolekcie nem\00F4\017Ee ma\0165 viac ako 255 znakov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509618227401761)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Kolekcia aplik\00E1cie %0 neexistuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510413958401762)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'sk'
,p_message_text=>unistr('Kurzor zatia\013E nie je otvoren\00FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509702381401761)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Poradie \010Dlenov %0 v kolekcii aplik\00E1cie %1 neexistuje'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114509962515401761)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Poradie \010Dlenov %0 v kolekcii aplik\00E1cie "%1" neexistuje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581754448401814)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Kryptografick\00E1 funkcia "%0" nie je v tomto syst\00E9me podporovan\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635242571401853)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstupnos\0165 testovan\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529671831401776)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'sk'
,p_message_text=>unistr('Zavrie\0165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529708154401776)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'sk'
,p_message_text=>unistr('Vo\013Eby prisp\00F4sobenia str\00E1nky')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529889477401776)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'sk'
,p_message_text=>unistr('Predvolen\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529901557401776)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'sk'
,p_message_text=>unistr('Zobrazen\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530025437401776)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'sk'
,p_message_text=>unistr('Skryt\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529407500401775)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'sk'
,p_message_text=>unistr('Za\010Diarknite oblasti, ktor\00E9 chcete zahrn\00FA\0165 na str\00E1nku. Za\010Diarknut\00E9 oblasti sa nemusia zobrazi\0165, pokia\013E nie ste v spr\00E1vnom kontexte aplik\00E1cie alebo nem\00E1te spr\00E1vne privil\00E9gi\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529556374401776)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FAto str\00E1nku nie je mo\017En\00E9 prisp\00F4sobi\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635565019401853)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'sk'
,p_message_text=>unistr('Vzh\013Ead tejto aplik\00E1cie m\00F4\017Eete personalizova\0165 zmenou \0161t\00FDlu mot\00EDvu. Vyberte \0161t\00FDl mot\00EDvu v zozname ni\017E\0161ie a kliknite na polo\017Eku Pou\017Ei\0165 zmeny.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114636337593401853)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'sk'
,p_message_text=>'Zobrazenie oblasti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635449259401853)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pou\017Ei\0165 predvolen\00FD \0161t\00FDl aplik\00E1cie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114635306618401853)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Vzh\013Ead ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578312906401811)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Index st\013Apca, na ktor\00FD sa odkazuje v agreg\00E1cii %0, neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114481632583401739)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'sk'
,p_message_text=>unistr('V\00FDstup CLOB pre form\00E1t %0 nie je podporovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578058692401811)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'sk'
,p_message_text=>unistr('Zlom st\013Apca mus\00ED by\0165 na za\010Diatku po\013Ea st\013Apcov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578174559401811)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Index skupiny st\013Apcov, na ktor\00FD sa odkazuje v %0, neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114495673842401749)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'sk'
,p_message_text=>'export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114500826496401753)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'sk'
,p_message_text=>unistr('Form\00E1t exportu mus\00ED by\0165 XML s pou\017Eit\00EDm tla\010Dov\00E9ho servera ORDS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578408507401811)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Index st\013Apca, na ktor\00FD sa odkazuje vo zv\00FDraznen\00ED %0, neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494103600401748)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD form\00E1t exportu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114578267714401811)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Index nadradenej skupiny, na ktor\00FD sa odkazuje v %0, neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114603436242401830)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec %1 tabu\013Eky %0 je st\013Apec identity, ktor\00FD je definovan\00FD ako "GENERATED ALWAYS". Zabezpe\010Dte, aby k st\013Apcu %1 v dial\00F3govom okne Konfigurova\0165 nebol mapovan\00FD \017Eiadny zdrojov\00FD st\013Apec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520896802401769)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00FD interval potvrdenia je pr\00EDli\0161 mal\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114520970074401769)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Neboli zadan\00E9 \017Eiadne st\013Apce na zavedenie d\00E1t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522126653401770)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre selektor riadkov "%0" sa nena\0161li \017Eiadne st\013Apce. Sk\00FAste automatick\00FA detekciu alebo skontrolujte \0161trukt\00FAru JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530466037401776)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('V s\00FAbore XLSX sa nena\0161li \017Eiadne pracovn\00E9 h\00E1rky.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530388922401776)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00FD pracovn\00FD h\00E1rok v s\00FAbore XLSX neexistuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114510516620401762)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lna verzia d\00E1t v datab\00E1ze bola zmenen\00E1, preto\017Ee pou\017E\00EDvate\013E spustil proces aktualiz\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512947401401764)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri aktualiz\00E1cii st\013Apcov zostavy: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617643745401840)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 nemo\017Eno skonvertova\0165 na SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557191387401796)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec %0, ktor\00FD je d\00E1tov\00E9ho typu %1, nemo\017Eno konvertova\0165 na VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564117057401801)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec "%0" zadan\00FD pre atrib\00FAt "%1" sa v d\00E1tovom zdroji nena\0161iel!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505482722401757)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'sk'
,p_message_text=>unistr('Typ filtra %0 nie je podporovan\00FD pre st\013Apce s viacer\00FDmi hodnotami.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114621070055401842)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD filter "medzi".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487520310401743)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Bol zadan\00FD neplatn\00FD typ ZH.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487488859401743)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00FD typ dopytu. Typom dopytu mus\00ED by\0165 tabu\013Eka, dopyt SQL alebo funkcia PL/SQL, ktor\00E1 vracia dopyt SQP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557263035401796)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Nepodarilo sa syntakticky analyzova\0165 dopyt SQL!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564210215401801)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00E1 poz\00EDcia st\013Apca %0 pre atrib\00FAt "%1" sa v pr\00EDkaze SQL nena\0161la!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114486030008401742)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'sk'
,p_message_text=>unistr('Vo filtri viacer\00FDch hodn\00F4t je pou\017Eit\00FDch pr\00EDli\0161 ve\013Ea polo\017Eiek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564040634401801)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre atrib\00FAt "%0" nie je zadan\00FD \017Eiadny st\013Apec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487393515401743)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Telo funkcie PL/SQL nevr\00E1tilo hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114577268939401811)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tov\00FD zdroj REST neobsahuje oper\00E1ciu na spracovanie po\017Eadovanej akcie DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114483218342401740)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'sk'
,p_message_text=>unistr('Konverzia GeoJSON na SDO_GEOMETRY (st\013Apec %0) nie je v tejto datab\00E1ze k dispoz\00EDcii.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484366881401741)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'sk'
,p_message_text=>unistr('Konverzia SDO_GEOMETRY (st\013Apec %0) nie je podporovan\00E1 pre d\00E1tov\00E9 zdroje XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114491680478401746)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'sk'
,p_message_text=>unistr('Znak %0 nie je podporovan\00FD ako odde\013Eova\010D viacer\00FDch hodn\00F4t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114618943510401841)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00E1to funkcia sa nem\00F4\017Ee pou\017Ei\0165 pre kontext dopytu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114484487427401741)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezhoda d\00E1tov\00E9ho typu st\013Apca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487277549401743)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Intern\00E9 limity v\00E4zby ORDS OUT boli prekro\010Den\00E9. Zn\00ED\017Ete po\010Det riadkov DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114565060419401802)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Odpove\010F JSON zo vzdialen\00E9ho servera nebolo mo\017En\00E9 syntakticky analyzova\0165: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114487155859401743)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nezn\00E1my alebo nespr\00E1vny typ kontextu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114581674590401814)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('Syntaktick\00FD analyz\00E1tor nepodporuje tento typ s\00FAboru.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536283505401780)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Neautorizovan\00FD pr\00EDstup (nie je nastaven\00E9 wwv_flow_api.set_credentials).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513289208401764)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'sk'
,p_message_text=>unistr('Pracovn\00FD priestor nebol vytvoren\00FD, preto\017Ee u\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114513116404401764)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'sk'
,p_message_text=>unistr('Skupina pou\017E\00EDvate\013Eov nebola vytvoren\00E1, preto\017Ee u\017E existuje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523423560401771)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'sk'
,p_message_text=>unistr('Na\0161lo sa duplicitn\00E9 meno pou\017E\00EDvate\013Ea pre %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523559108401771)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri zaveden\00ED pou\017E\00EDvate\013Eov. Zlyhanie pri pou\017E\00EDvate\013Eovi %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533436133401778)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Det na\010D\00EDtan\00FDch pou\017E\00EDvate\013Eov by bol %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533206892401778)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'sk'
,p_message_text=>'Heslo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533394680401778)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'sk'
,p_message_text=>unistr('Privil\00E9gi\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533098001401778)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'sk'
,p_message_text=>unistr('Meno pou\017E\00EDvate\013Ea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609531408401834)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Das vykres\013Eovania polo\017Eky str\00E1nky #COMPONENT_NAME# sa vyskytla chyba.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529129316401775)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Polo\017Eku str\00E1nky nie je mo\017En\00E9 zobrazi\0165, preto\017Ee formul\00E1r HTML zatia\013E nebol otvoren\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114494404537401748)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri v\00FDpo\010Dte predvolenej hodnoty polo\017Eky str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528438592401775)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba v n\00E1slednom v\00FDpo\010Dte polo\017Eky pre polo\017Eku str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528335507401775)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri v\00FDpo\010Dte zdrojovej hodnoty polo\017Eky pre polo\017Eku str\00E1nky #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508165510401760)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'sk'
,p_message_text=>unistr('Neautorizovan\00FD pr\00EDstup.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528690678401775)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'sk'
,p_message_text=>unistr('JavaScript nie je podporovan\00FD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528715678401775)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'sk'
,p_message_text=>'Zoznam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114529373666401775)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'sk'
,p_message_text=>unistr('Dopyt nie je mo\017En\00E9 inicializova\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536512600401781)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktualiz\00E1cia %0 nie je podporovan\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114530755805401776)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E9 ID polo\017Eky: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114557085135401796)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre t\00FAto polo\017Eku neexistuje \017Eiadna pomoc.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521591499401770)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Generovanie dopytu na graf zlyhalo. Skontrolujte nastavenia mapovania zdroja a st\013Apca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616323795401839)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDloha ve\013Ekosti %0 MB prekra\010Duje maxim\00E1lnu ve\013Ekos\0165 pr\00EDlohy %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522403186401770)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E1 hodnota parametra p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114639822373401856)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Prekro\010Dili ste maxim\00E1lny po\010Det e-mailov\00FDch spr\00E1v na jeden pracovn\00FD priestor. Kontaktujte administr\00E1tora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503453368401755)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'sk'
,p_message_text=>unistr('T\00FAto proced\00FAru je potrebn\00E9 vyvola\0165 z rel\00E1cie aplik\00E1cie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522347547401770)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00E1 bola hodnota null pre parameter %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576395103401810)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('\0160abl\00F3na e-mailu "%0" sa v aplik\00E1cii %1 nena\0161la.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114652802922401865)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Parameter in\0161tancie SMTP_HOST_ADDRESS mus\00ED by\0165 nastaven\00FD, aby bolo mo\017En\00E9 odosiela\0165 e-maily.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522048137401770)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Na odoslanie e-mailu je potrebn\00E9 zada\0165 pr\00EDjemcu spr\00E1vy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114642246633401858)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Nemo\017Eno vytvori\0165 pripojenie SMTP na konfigurovan\00FD e-mailov\00FD server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114616415009401839)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'sk'
,p_message_text=>unistr('Neplatn\00E9 volanie Ajax!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507847361401759)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre plugin %0 nebola definovan\00E1 \017Eiadna funkcia Ajax')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606889559401832)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre plugin %0 nebola definovan\00E1 \017Eiadna funkcia vykonania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507912460401759)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre plugin %0 nebola definovan\00E1 \017Eiadna funkcia vykreslenia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617381313401840)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Plugin d\00E1tov\00E9ho zdroja REST "%0" neobsahuje funkciu "Mo\017Enosti".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617291822401839)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Plugin d\00E1tov\00E9ho zdroja REST "%0" neobsahuje funkciu DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617458640401840)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Plugin d\00E1tov\00E9ho zdroja REST "%0" neobsahuje funkciu vykonania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114617556140401840)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'sk'
,p_message_text=>unistr('Plugin d\00E1tov\00E9ho zdroja REST "%0" neobsahuje funkciu vyvolania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505617317401757)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\010Das spracovania pluginu sa zistila chyba v k\00F3de PLSQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512293987401763)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Je potrebn\00E9 zada\0165 hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542885031401786)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sk'
,p_message_text=>unistr('D\00E1tov\00FD typ %0 nie je mo\017En\00E9 konvertova\0165 na VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628426973401848)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec "%0" zadan\00FD pre atrib\00FAt "%1" sa v pr\00EDkaze SQL nena\0161iel!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604798564401830)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre %0 mus\00ED by\0165 zadan\00FD dopyt na zoznam hodn\00F4t (ZH) alebo pomenovan\00FD zoznam hodn\00F4t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114606357191401832)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'sk'
,p_message_text=>unistr('V dopyte SQL na ZH pre %0 bol vybran\00FD nespr\00E1vny po\010Det st\013Apcov. Pozrite si pr\00EDklady platn\00FDch pr\00EDkazov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628285059401847)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre atrib\00FAt "%0" nie je zadan\00FD \017Eiadny st\013Apec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657970003401869)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00E1 hodnota %0 pre atrib\00FAt "%1" nie je numerick\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114609858015401834)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('%0 m\00E1 nespr\00E1vny d\00E1tov\00FD typ v pr\00EDkaze SQL. \010C\00EDslo st\013Apca %1 je %2, ale o\010Dak\00E1vala sa hodnota %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114628355494401848)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apec "%0" zadan\00FD pre atrib\00FAt "%1" m\00E1 d\00E1tov\00FD typ %2, ale mal by ma\0165 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114504941429401757)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'sk'
,p_message_text=>unistr('Nemo\017Eno n\00E1js\0165 rozlo\017Eenie zostavy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564944504401802)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'sk'
,p_message_text=>unistr('Pre zostavy na z\00E1klade d\00E1tov\00E9ho zdroja REST nie je mo\017En\00E9 pou\017Ei\0165 funkciu Vypo\010D\00EDta\0165 s\00FA\010Det.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114528557336401775)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('ERR-2904 Nie je mo\017En\00E9 nastavi\0165 hodnotu odkazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114532829792401778)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba: Nezn\00E1my typ odkazu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114522821563401771)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Nie je mo\017En\00E9 vyvola\0165 authentication_scheme v aplik\00E1cii %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114596339461401824)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'sk'
,p_message_text=>unistr('ID n\00E1jomcu u\017E existuje pre aktu\00E1lnu rel\00E1ciu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114533170312401778)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'sk'
,p_message_text=>'E-mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657365244401869)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'sk'
,p_message_text=>unistr('Autentifik\00E1cia zlyhala.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114559608377401798)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'sk'
,p_message_text=>unistr('Jeden alebo viacero s\00FAborov cookie nastaven\00FDch v parametri apex_util.g_request_cookies obsahuje neplatn\00FA hodnotu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114542150361401785)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'sk'
,p_message_text=>unistr('Odpove\010F z registra UDDI bola neplatn\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114505794343401757)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'sk'
,p_message_text=>unistr('Zadan\00E1 adresa URL nevr\00E1tila platn\00FD dokument WSDL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114508250641401760)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'sk'
,p_message_text=>unistr('Dokument WSDL obsahuje viacer\00E9 viazania SOAP. &PRODUCT_NAME. podporuje len WSDL s jedn\00FDm viazan\00EDm SOAP. Ak chcete pokra\010Dova\0165 vo vytv\00E1ran\00ED referencie pre t\00FAto slu\017Ebu, kliknite na polo\017Eku Manu\00E1lne vytvori\0165 referenciu na webov\00FA slu\017Ebu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114576664926401810)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'sk'
,p_message_text=>unistr('Odpove\010F zo slu\017Eby nebola vo form\00E1te XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657234243401869)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'sk'
,p_message_text=>unistr('Pr\00EDstupov\00FD token OAuth nie je dostupn\00FD alebo jeho platnos\0165 uplynula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114620429454401842)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'sk'
,p_message_text=>unistr('Prekro\010Dili ste maxim\00E1lny po\010Det po\017Eiadaviek na webov\00FA slu\017Ebu na jeden pracovn\00FD priestor. Kontaktujte administr\00E1tora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114657466078401869)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'sk'
,p_message_text=>unistr('Server odpovedal nepodporovan\00FDm typom tokenu OAuth.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507668625401759)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'sk'
,p_message_text=>unistr('Dokument WSDL neobsahoval viazanie pre SOAP, ktor\00E9 je potrebn\00E9 na pridanie referencie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114503595216401755)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'sk'
,p_message_text=>unistr('WSDL vy\017Eaduje doklady autentifik\00E1cie. Ni\017E\0161ie zadajte meno pou\017E\00EDvate\013Ea a heslo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114512300728401763)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'sk'
,p_message_text=>unistr('Vykres\013Eovac\00ED mechanizmus nerozpoznal dokument WSDL. Ak chcete pokra\010Dova\0165 vo vytv\00E1ran\00ED referencie na t\00FAto slu\017Ebu, kliknite na polo\017Eku Manu\00E1lne vytvori\0165 referenciu na webov\00FA slu\017Ebu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114579275044401812)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktualiz\00E1ciu nemo\017Eno spracova\0165.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114605050946401831)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'sk'
,p_message_text=>unistr('St\013Apce vr\00E1tenia a zobrazenia zoznamu hodn\00F4t s\00FA rovnak\00E9!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114604937386401831)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Zoznam hodn\00F4t nem\00E1 st\013Apec vr\00E1tenia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536413297401781)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri vyvol\00E1van\00ED hodnoty st\013Apca: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560407796401798)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'sk'
,p_message_text=>unistr('Aktu\00E1lne d\00E1ta tabu\013Ekov\00E9ho formul\00E1ra s\00FA pr\00EDli\0161 star\00E9. Zdrojov\00E9 d\00E1ta boli modifikovan\00E9.<br/> Kliknite <strong><a href="%0">sem</a></strong>, ak chcete zru\0161i\0165 zmeny a znovu zavies\0165 d\00E1ta z datab\00E1zy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518589468401768)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba po\010Das ur\010Dovania re\0165azca str\00E1nkovania')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518457359401768)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('nie je mo\017En\00E9 ur\010Di\0165 z\00E1hlavia dopytu:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518658546401768)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'sk'
,p_message_text=>unistr('chyba po\010Das vykon\00E1vania nahraden\00ED p\00E4ty zostavy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518766407401768)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('nepodarilo sa syntakticky analyzova\0165 dopyt SQL:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523783039401771)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'sk'
,p_message_text=>unistr('Po\017Eadovan\00FD minim\00E1lny po\010Det riadkov: %0, n\00E1jden\00E9, ale nezobrazen\00E9 riadky: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521285367401770)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'sk'
,p_message_text=>unistr('st\013Apec dopytu #%0 (%1) je neplatn\00FD, st\013Apce pou\017E\00EDvaj\00FAce HTML vy\017Eaduj\00FA n\00E1zvy aliasu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114536335003401781)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'sk'
,p_message_text=>unistr('Chyba pri z\00EDskavan\00ED z\00E1hlav\00ED dopytu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518800003401768)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'chyba zostavy:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114556546646401796)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'sk'
,p_message_text=>unistr('Triedi\0165 pod\013Ea tohto st\013Apca')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521380147401770)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'sk'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Dopyt nie je mo\017En\00E9 syntakticky analyzova\0165, skontrolujte syntax dopytu.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560521841401798)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'sk'
,p_message_text=>unistr('Tento formul\00E1r obsahuje neulo\017Een\00E9 zmeny. Stla\010Dte tla\010Didlo OK, ak chcete pokra\010Dova\0165 bez ulo\017Eenia zmien. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114564805897401801)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'sk'
,p_message_text=>unistr('Sch\00E9ma str\00E1nkovania zostavy (%0) pre vybran\00FD d\00E1tov\00FD zdroj nie je podporovan\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114521121947401769)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'sk'
,p_message_text=>unistr('st\013Apec dopytu #%0 (%1) je neplatn\00FD, pou\017Eite alias st\013Apca')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523893680401771)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'sk'
,p_message_text=>'riadky %0 - %1 z viac ako %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114562542240401800)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'sk'
,p_message_text=>'%0 - %1 z viac ako %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114523630222401771)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'sk'
,p_message_text=>'riadky %0 - %1 z %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114507593303401759)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'sk'
,p_message_text=>'%0 - %1 z %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518971777401768)
,p_name=>'Y'
,p_message_language=>'sk'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114525087568401772)
,p_name=>'YEAR'
,p_message_language=>'sk'
,p_message_text=>'rok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114518169383401767)
,p_name=>'YEARS'
,p_message_language=>'sk'
,p_message_text=>'r.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114560699231401798)
,p_name=>'YES'
,p_message_language=>'sk'
,p_message_text=>unistr('\00C1no')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4485)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4485)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('Pracovn\00E1 plocha')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4485
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4485)
,p_name=>unistr('Spr\00E1vy')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('Spr\00E1vy')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
