prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4486
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4486 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4486
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103558898403834')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'sl'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4486)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113353'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4486)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4486)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4486)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4486)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4486)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4486)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.sl'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4486)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4486)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4486)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4486)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4486)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4486)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.sl'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4486)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4486)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4486)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4486)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4486)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4486)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.sl'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4486)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4486)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.sl'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4486)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4486)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.sl'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4486)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4486)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.sl'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4486)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4486)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4486)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.sl'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4486
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4486)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4486)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4486)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4486
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4486)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4486
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4486)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4486
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4486)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4486
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4486)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4486
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4486)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4486
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4486
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4486)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4486)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4486)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4486)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4486)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4486)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4486)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4486)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4486)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4486)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4486)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4486)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4486)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4486)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4486)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4486)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4486)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4486)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4486)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4486)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4486)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4486)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4486
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4486)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4486)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4486)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4486)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4486)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4486
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4486)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4486
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4486)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4486
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4486)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4486
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4486)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4486
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4486)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4486
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4486)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4486)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4486)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4486)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4486)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4486)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4486)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4486)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4486)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4486
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4486)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4486)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4486)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4486)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4486)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4486)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4486)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4486
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4486)
,p_page_name=>'winlov'
,p_page_title=>'Pogovorno okno za iskanje'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Iskanje'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Zapri'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Naprej &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Nazaj'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Vrstice #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4486
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4486)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4486
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4486)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4486)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4486)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4486)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4486)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4486)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4486)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4486)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4486)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4486)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4486)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4486)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4486)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4486)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4486)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4486)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4486)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4486)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4486)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4486)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4486)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4486)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4486)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4486)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4486)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4486)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4486)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4486)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4486)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4486)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4486)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4486)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4486)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4486)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4486)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4486)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4486)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4486)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4486)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4486)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4486)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4486)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4486)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4486)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4486)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4486)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4486)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4486)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4486)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4486)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4486)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4486)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4486)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4486)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4486)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4486)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4486)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4486)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4486)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4486)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4486)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4486)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4486)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4486)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4486)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4486)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4486)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4486)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4486)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4486)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4486)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4486)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4486)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4486)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4486)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4486)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4486)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4486)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4486)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4486)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4486)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4486)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4486)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4486)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4486)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4486)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4486)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4486)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4486)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4486)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4486)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4486)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4486)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4486)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4486)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4486)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4486)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4486)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4486)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4486)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4486)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4486)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4486)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4486)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4486)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4486)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4486)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4486)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4486)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4486)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4486)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4486)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4486)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4486)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4486)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4486)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4486)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4486)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4486)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4486)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4486)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4486)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4486)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4486)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4486)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4486)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4486)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4486)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4486)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4486)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4486)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4486)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4486)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4486)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4486)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4486)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4486)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4486)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4486)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4486)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4486)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4486)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4486)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4486)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4486)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4486)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4486)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4486)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4486)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4486)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4486)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4486)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4486)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4486)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4486)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4486)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4486)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4486)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4486)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4486)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4486)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4486)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4486)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4486)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4486)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4486)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4486)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4486)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4486)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4486)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4486)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4486)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693675073401902)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'sl'
,p_message_text=>'Stolpec %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680752826401893)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'sl'
,p_message_text=>'Skrbnik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680613721401893)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737955267401936)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'sl'
,p_message_text=>'Dostop zavrnjen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697660781401905)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161 ra\010Dun %0 je bil ustvarjen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683227280401895)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'sl'
,p_message_text=>unistr('Ra\010Dun je zaklenjen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673117719401887)
,p_name=>'AM_PM'
,p_message_language=>'sl'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807593114401990)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'sl'
,p_message_text=>'Preklop %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815695589401996)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'sl'
,p_message_text=>'(Aktivno)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785130948401972)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Klic Ajax je vrnil napako stre\017Enika %0 za %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715976517401919)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'sl'
,p_message_text=>unistr('Drugega imena aplikacije "%0" ni mogo\010De pretvoriti v enoli\010Den ID aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716094744401919)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>'Aplikacija z drugim imenom "%0" ne obstaja.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705640653401911)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1816 Nepri\010Dakovana napaka pri pretvarjanju drugega imena aplikacije p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798576004401983)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Kontrolna vsota aplikacije omogo\010Da enostaven na\010Din dolo\010Danja tega, ali je ista aplikacija postavljena po delovnih prostorih. To kontrolno vsoto lahko primerjate, da dolo\010Dite, ali obstaja ujemanje. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691416767401901)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi funkcije preverjanja pristnosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676847824401890)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi funkcije preverjanja pristnosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840379695402014)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'sl'
,p_message_text=>unistr('Ime najemnika, ki ga vrne Oracle Cloud Identity Management, ni odobreno za domeno %1!<br/><a href="&LOGOUT_URL.">Prijavite se znova</a> in dolo\010Dite odobreno ime najemnika ali spremenite svoj URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674545015401888)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161 ra\010Dun "%0" nima potrebnih privilegijev za razvoj (DB_DEVELOPER ali DB_ADMINISTRATOR)<br/>za delovni prostor "%1"! <a href="&LOGOUT_URL.">Ponovno se prijavite</a>, ko vam bodo zagotovljeni privilegiji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673662436401887)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'sl'
,p_message_text=>'Ime najemnika, ki ga vrne Oracle Cloud Identity Management, ni odobreno za trenutni delovni prostor!<br/><a href="&LOGOUT_URL.">Ponovno se prijavite</a> in navedite odobreno ime najemnika.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674619178401888)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'sl'
,p_message_text=>'Iz varnostnih razlogov izvajanje aplikacij tega delovnega prostora prek domene v URL-ju ni dovoljeno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691179895401900)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Svojega skrbnika baze podatkov prosite, da za\017Eene $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691011326401900)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'sl'
,p_message_text=>'Paket SYS.DBMS_LDAP ne obstaja ali je neveljaven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690901998401900)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi funkcije urejanja uporabnika LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691242458401900)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi preverjanja pristnosti LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692006259401901)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'sl'
,p_message_text=>'Napaka v argumentu p_flow_page do postopka login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691659447401901)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna seja p_session v wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739572817401937)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161kodovan argument za wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691709487401901)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime NULL podano v postopek prijave.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680570265401893)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'sl'
,p_message_text=>unistr('Pred ponovnim vpisom po\010Dakajte toliko sekund: <span id="apex_login_throttle_sec">%0</span>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681842559401894)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'sl'
,p_message_text=>'Poskus prijave je bil blokiran.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737373851401936)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>'Preverjanje pristnosti "%0" ni najdeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682133238401894)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'sl'
,p_message_text=>'ID varnostne skupine je NULL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691575331401901)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri izvajanju procesa naknadnega preverjanja pristnosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691342329401900)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri obdelavi procesa vnaprej\0161njega preverjanja pristnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692530963401901)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Naslov URL odprite v istem brskalniku, v katerem ste inicializirali zahtevo za ponastavitev gesla. \010Ce kliknete URL za ponastavitev gesla in ste preusmerjeni na'),
'stran za prijavo, znova inicializirajte Ponastavitev gesla in pustite',
'brskalnik odprt.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837875242402013)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'sl'
,p_message_text=>'URL za ponastavitev gesla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674838725401888)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'sl'
,p_message_text=>'Skupina porabnikov upravitelja virov %0 ni bila dodeljena %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674985281401888)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'sl'
,p_message_text=>unistr('Za podelitev manjkajo\010Dega privilegija uporabite DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702973135401909)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri obdelavi funkcije stra\017Ee v seji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703002567401909)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi funkcije preverjanja seje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703272410401909)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Svojega skrbnika %0 prosite, da konfigurira mehanizem za enotno prijavo v stre\017Enik Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712783151401917)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'sl'
,p_message_text=>unistr('Neveljaven %0 v \017Eetonu %1 vrnjen s strani SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691990785401901)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'sl'
,p_message_text=>'Uredite shemo preverjanja pristnosti in dodajte ime aplikacije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712435996401916)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven program za klicanje postopka %0:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712602267401916)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'sl'
,p_message_text=>unistr('Neveljavna seja aplikacije v \017Eetonu urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712263672401916)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka v portal_sso_redirect: manjkajo\010De informacije o registraciji aplikacije: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703180021401909)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'sl'
,p_message_text=>'Paket WWSEC_SSO_ENABLER_PRIVATE ne obstaja ali je neveljaven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114691897694401901)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De najti imena aplikacije registriranega partnerja v shemi preverjanja pristnosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712328908401916)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'sl'
,p_message_text=>unistr('Registrirajte to aplikacijo, kot je opisano v priro\010Dniku za namestitev.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703367659401909)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi preverjanja pristnosti SSO.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812732183401994)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'sl'
,p_message_text=>'Neodobreni URL: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702783429401909)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi preverjanja pristnosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674756541401888)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'sl'
,p_message_text=>'Delovni prostor "%0" je neaktiven. Obrnite se na svojega skrbnika.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675134737401889)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'sl'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681540540401893)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'sl'
,p_message_text=>'Dostop je zavrnilo varnostno preverjanje aplikacije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681614851401893)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'sl'
,p_message_text=>'Dostop je zavrnilo varnostno preverjanje strani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681776758401893)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi odobritve.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745172427401942)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'sl'
,p_message_text=>'Izdelano s/z %0 z uporabo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745232096401942)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'sl'
,p_message_text=>'ljubezen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803059438401986)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'sl'
,p_message_text=>'Opis dogodka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802880107401986)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'sl'
,p_message_text=>'Datum konca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803172057401986)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'sl'
,p_message_text=>'ID dogodka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802729083401986)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'sl'
,p_message_text=>unistr('Datum za\010Detka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802971901401986)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Naziv dogodka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693513804401902)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka vsebine kontrolne vsote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693413435401902)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka formata kontrolne vsote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757450740401951)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'sl'
,p_message_text=>unistr('Kopirano v odlo\017Ei\0161\010De.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757176477401951)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'sl'
,p_message_text=>'Ta brskalnik ne podpira kopiranja iz gumba ali menija. Poskusite z ukazom Ctrl + C ali Command + C.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745687136401942)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'sl'
,p_message_text=>'Zapri obvestilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801637870401985)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'sl'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796162113401981)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'sl'
,p_message_text=>'Trenutno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796068865401981)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Za\010Detno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800295588401984)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora biti veljavna barva. Primer: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795992228401981)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'sl'
,p_message_text=>'Izbira barve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796264393401981)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Spreminjanje formata barve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835445135402011)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'sl'
,p_message_text=>'Seznam vrednosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835504959402011)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'sl'
,p_message_text=>'Odpri seznam za: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815736096401996)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'sl'
,p_message_text=>unistr('(Dokon\010Dano)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708062533401913)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'sl'
,p_message_text=>'Obrnite se na skrbnika aplikacije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722411543401924)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Obrnite se na skrbnika aplikacije.',
'Podrobnosti o tem incidentu so na voljo prek ID-ja za iskanje napak "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800530383401984)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'sl'
,p_message_text=>'Pred shranjevanjem popravite napake.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746583022401943)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'sl'
,p_message_text=>'Najdenih je toliko zadetkov: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746448448401943)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'sl'
,p_message_text=>'Ni ustreznih zadetkov'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816266127401996)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'sl'
,p_message_text=>'Trenutni napredek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800982018401985)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Datoteka, dolo\010Dena v elementu %0, ne obstaja v APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789451185401976)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'sl'
,p_message_text=>'Trenutna verzija podatkov v bazi podatkov se je spremenila, odkar je uporabnik inicializiral postopek posodobitve.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758580840401952)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'sl'
,p_message_text=>'Ne nalagaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805517679401988)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'sl'
,p_message_text=>'Predobdelava napake'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805362273401988)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'sl'
,p_message_text=>'Vstavi vrstico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819466134401999)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'sl'
,p_message_text=>'Zaporedje: Dejanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805464266401988)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'sl'
,p_message_text=>'Posodobi vrstico'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746901268401943)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'sl'
,p_message_text=>'Pojavni koledar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669596655401884)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669687894401885)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805788202401988)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora imeti neko vrednost.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805614052401988)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora biti veljaven datum, na primer %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673287704401887)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora biti med %0 in %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673361570401887)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora biti na ali po %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673490372401887)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora biti na ali pred %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750415566401946)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# zna\0161a ve\010D od navedenega maksimalnega datuma %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750854677401946)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# se ne ujema s formatom %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750339891401946)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# zna\0161a manj od navedenega minimalnega datuma %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750502260401946)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# ni v veljavnem razponu med %0 in %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750713105401946)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# ni v veljavnem razponu let med %0 in %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800889088401985)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Prekli\010Di')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828023901402005)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'sl'
,p_message_text=>'Zapri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830011318402007)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800684917401985)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'sl'
,p_message_text=>'V redu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800722339401985)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'sl'
,p_message_text=>'Shrani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706916079401912)
,p_name=>'APEX.ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674387990401888)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'sl'
,p_message_text=>unistr('Med izvajanjem povratnega klica obravnavanja napak je pri\0161lo do naslednje napake: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683087528401894)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Med slikanjem strani z napako je pri\0161lo do napake: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675056863401888)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'sl'
,p_message_text=>'Notranja napaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814884720401995)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Obrnite se na skrbnika.',
'Podrobnosti o tem incidentu so na voljo prek ID-ja za iskanje napak "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809192021401991)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'sl'
,p_message_text=>'Baza podatkov je odprta za dostop samo za branje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839709883402014)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'sl'
,p_message_text=>'ORA-28353: Odpiranje denarnice ni uspelo. Podatki o aplikaciji trenutno niso na voljo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809260721401991)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Ta stran \017Eal ni razpolo\017Eljiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676780042401890)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'sl'
,p_message_text=>unistr('Tehni\010Dne informacije (vidne samo razvijalcem)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772845804401963)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'sl'
,p_message_text=>unistr('Sporo\010Dilo o napaki')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786792133401974)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'sl'
,p_message_text=>unistr('Pri\010Dakovani format: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753464375401948)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabnik je \017Ee na seznamu kontrole dostopa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753351712401948)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'sl'
,p_message_text=>unistr('Potrdite dodajanje naslednjega \0161tevila uporabnikov na seznam kontrole dostopa <strong>%1</strong>: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753854904401948)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'sl'
,p_message_text=>'Obstaja dvojnik uporabnika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753577495401948)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'sl'
,p_message_text=>unistr('V e-po\0161tnem naslovu manjka znak afne (@)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753692441401948)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'sl'
,p_message_text=>unistr('V e-po\0161tnem naslovu manjka pika (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753751976401948)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime je predolgo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754042949401949)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'sl'
,p_message_text=>'Do te aplikacije lahko dostopajo samo uporabniki, navedeni na seznamu kontrole dostopa aplikacije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754166869401949)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('Nepri\010Dakovana vrednost nastavitve kontrole dostopa: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753989172401948)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'sl'
,p_message_text=>'Do te aplikacije lahko dostopajo vsi uporabniki s preverjeno pristnostjo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796768008401981)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Onemogo\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796687391401981)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Omogo\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796970116401982)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('%0: Je onemogo\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796884429401982)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('%0: Je omogo\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796519514401981)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'sl'
,p_message_text=>'ni identificirano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789633988401976)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'sl'
,p_message_text=>'Prenos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746198926401942)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'sl'
,p_message_text=>'Dodeljen filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787259057401974)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'sl'
,p_message_text=>'Dodeli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672154328401886)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'sl'
,p_message_text=>unistr('Pali\010Dni grafikon')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799960117401984)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'sl'
,p_message_text=>'Drugo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672294722401886)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'sl'
,p_message_text=>'Tortni grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798617647401983)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671983770401886)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787734383401974)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Disti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787857507401975)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Disti vse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787980947401975)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Disti %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805121930401988)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'sl'
,p_message_text=>'Stolpec %1, na katerega se sklicuje faseta %0, ni na voljo ali ni odobren.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662337035401879)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Izbira filtrov za prikaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744315113401941)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160t. rezultatov: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744476436401941)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160t. izbranih: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747084674401943)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'sl'
,p_message_text=>'Trenutni filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663846656401880)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'sl'
,p_message_text=>'Seznam filtrov'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803604985401987)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'sl'
,p_message_text=>unistr('Razli\010Dna meja vrednosti (%0) je prese\017Eena za faseto %1.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789258792401976)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Faseta %0 ni podprta za stolpce DATE ali TIMESTAMP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787307133401974)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'sl'
,p_message_text=>'Filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787489271401974)
,p_name=>'APEX.FS.GO'
,p_message_language=>'sl'
,p_message_text=>'Pojdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788865083401975)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Enako %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672995623401887)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'sl'
,p_message_text=>'vsebuje %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672686442401887)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'sl'
,p_message_text=>unistr('ve\010D kot %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672722428401887)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'sl'
,p_message_text=>unistr('ve\010D kot ali enako %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672416429401887)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'sl'
,p_message_text=>'manj kot %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672576179401887)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'sl'
,p_message_text=>'manj kot ali enako %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672836761401887)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'sl'
,p_message_text=>unistr('se za\010Dne s/z %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675325703401889)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Podatkovni tip %0 (%1) ni podprt za faseto Vnosno polje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665555292401882)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'sl'
,p_message_text=>unistr('Fasete z ve\010D vrednostmi zahtevajo baze podatkov 12.2 ali novej\0161e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789050444401975)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'sl'
,p_message_text=>'Za faseto %0 niso bili zagotovljeni nobeni stolpci za iskanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662442068401879)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'sl'
,p_message_text=>unistr('Ve\010D filtrov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744549122401941)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'sl'
,p_message_text=>unistr('Za\010Detek razpona')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788547155401975)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'sl'
,p_message_text=>'%0 do %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788615473401975)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'sl'
,p_message_text=>'Nad %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788762808401975)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'sl'
,p_message_text=>'Pod %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744666407401941)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'sl'
,p_message_text=>'Konec razpona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807463025401990)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('Element seznama vrednosti #%2 ("%1") za faseto razpona %0 je neveljaven (manjka lo\010Dilo "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788930402401975)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'sl'
,p_message_text=>unistr('Ro\010Dni vnos za faseto Razpon %0 trenutno ni podprt, ker je stolpec DATE ali TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788280976401975)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'sl'
,p_message_text=>'do'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672018927401886)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'sl'
,p_message_text=>'Odstrani grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741188136401939)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'sl'
,p_message_text=>'Ponastavi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787642503401974)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Iskanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787594597401974)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'sl'
,p_message_text=>unistr('I\0161\010Di ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788478422401975)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'sl'
,p_message_text=>'- Izbira -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671876884401886)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'sl'
,p_message_text=>'Prikaz grafikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788034717401975)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'sl'
,p_message_text=>unistr('Prika\017Ei manj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788150396401975)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'sl'
,p_message_text=>unistr('Prika\017Ei ve\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114788314466401975)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Toliko zvezdic in ve\010D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746009670401942)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'sl'
,p_message_text=>'Filtriraj predloge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789173502401975)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Faseta Besedilno polje %0 je trenutno podprta le za stolpce NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662274230401879)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupno \0161tevilo vrstic')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805254495401988)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Podatkovni tip %0 (%1) ni podprt za fasetno iskanje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797100679401982)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Pojdi na napako'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754738278401949)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>unistr('Zdru\017Eevanje.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762300333401955)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'sl'
,p_message_text=>'Strni kontrolni prelom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754844688401949)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Kontrolni prelom.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762292300401955)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iri kontrolni prelom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840983448402015)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Stolpec %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762018433401955)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160t. izbrisanih vrstic: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832467693402008)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'sl'
,p_message_text=>'Podvojena identiteta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751714562401947)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'sl'
,p_message_text=>'Prvi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755020295401949)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Glava skupine.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754954723401949)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Glava.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751899322401947)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'sl'
,p_message_text=>'Zadnji'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771883833401962)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje ve\010D vrstic')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751519599401947)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755133689401949)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'sl'
,p_message_text=>'Vrstice strani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751914406401947)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'sl'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752079779401947)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'sl'
,p_message_text=>'%0 - %1 od %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808066838401990)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'sl'
,p_message_text=>'Izbira strani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751621858401947)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832222631402008)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'sl'
,p_message_text=>'Dodano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832399438402008)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'sl'
,p_message_text=>'Spremenjeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840744612402015)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Vrstica %0, Stolpec %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840801884402015)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Vrstica %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832133725402008)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'sl'
,p_message_text=>'Izbrisano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755314782401950)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'sl'
,p_message_text=>'Glava strani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750918670401946)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160t. izbranih celic: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752180500401947)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160t. izbranih vrstic: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792428136401978)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'sl'
,p_message_text=>'Izberi vse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762170537401955)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'sl'
,p_message_text=>'Stran %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755284033401950)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'sl'
,p_message_text=>'Izbira vrstice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755493876401950)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvr\0161\010Deno nara\0161\010Dajo\010De %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755538739401950)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvr\0161\010Deno padajo\010De %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751064628401946)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvrsti nara\0161\010Dajo\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751383051401947)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvrsti nara\0161\010Dajo\010De %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751179513401946)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvrsti padajo\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751495562401947)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvrsti padajo\010De %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114751210921401946)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'sl'
,p_message_text=>unistr('Ne razvr\0161\010Daj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761906691401955)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'sl'
,p_message_text=>'Skupno %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688396469401898)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'sl'
,p_message_text=>'Zahteva HTTP za "%0" ni uspela.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829610871402006)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'sl'
,p_message_text=>unistr('Seznam za izbiro mre\017Ee, \0161t. stolpcev: %0, \0161t. vrstic: %1. Uporabite pu\0161\010Di\010Dne tipke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761825969401955)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'sl'
,p_message_text=>unistr('Seznam za izbiro, \0161t. vrstic: %0. Uporabite pu\0161\010Di\010Dne tipke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840544365402015)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Interaktivna mre\017Ea %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748694975401944)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'sl'
,p_message_text=>'Dejanja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749602140401945)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'sl'
,p_message_text=>'Dodaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749593335401945)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'sl'
,p_message_text=>'Dodaj vrstico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834097792402010)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'sl'
,p_message_text=>unistr('Zdru\017Eevanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819575811401999)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Zdru\017Eevanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821237938402000)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'sl'
,p_message_text=>'Vse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777602422401967)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Vsi besedilni stolpci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778898254401968)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'sl'
,p_message_text=>'Nadomestno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779995758401968)
,p_name=>'APEX.IG.AND'
,p_message_language=>'sl'
,p_message_text=>'in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799361113401983)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'sl'
,p_message_text=>unistr('Pribl. \0161tevilo razli\010Dnih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835060048402010)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupno pribl. \0161tevilo razli\010Dnih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818162823401998)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'sl'
,p_message_text=>unistr('Obmo\010Dje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820096169401999)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Nara\0161\010Dajo\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778917790401968)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'sl'
,p_message_text=>'Odobritev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834108987402010)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'sl'
,p_message_text=>'Samodejno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799706104401984)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'sl'
,p_message_text=>unistr('Povpre\010Dje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834743884402010)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupno povpre\010Dje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817638594401997)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Naslov osi oznake'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817879265401997)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'sl'
,p_message_text=>'Decimalna mesta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817735481401997)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Naslov osi vrednosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823883544402002)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'sl'
,p_message_text=>'Barva ozadja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818280768401998)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774297180401964)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'sl'
,p_message_text=>'med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825071822402003)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'sl'
,p_message_text=>'Oboje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818329786401998)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Mehur\010Dek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749871244401945)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Prekli\010Di')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779863891401968)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'sl'
,p_message_text=>unistr('Upo\0161tevaj velike/male \010Drke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835609281402011)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'sl'
,p_message_text=>unistr('(Upo\0161tevaj velike/male \010Drke)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806500852401989)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'sl'
,p_message_text=>'Spremembe shranjene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750270897401946)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Sprememba pogleda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780981052401969)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'sl'
,p_message_text=>'Grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777494886401967)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161a poizvedba presega maksimalno \0161tevilo podatkovnih to\010Dk %0 na grafikon. Uporabite filter, da zmanj\0161ate \0161tevilo zapisov v osnovni poizvedbi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748521205401944)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled grafikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755827253401950)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Disti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817130831401997)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Zapri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824043165402002)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'sl'
,p_message_text=>'Barve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800124392401984)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'sl'
,p_message_text=>'Predogled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779222197401968)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Stolpec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748724884401944)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Stolpci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825809107402003)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Namen stolpca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779332399401968)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'sl'
,p_message_text=>'Zapleteno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748930122401945)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'sl'
,p_message_text=>unistr('Izra\010Dun')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774830577401965)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'sl'
,p_message_text=>'vsebuje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781182144401969)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'sl'
,p_message_text=>'Kontrolni prelom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755653528401950)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'sl'
,p_message_text=>unistr('Kopiraj v odlo\017Ei\0161\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755797257401950)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'sl'
,p_message_text=>'Kopiranje navzdol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799100514401983)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799249591401983)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo razli\010Dnih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834949029402010)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupno \0161tevilo razli\010Dnih')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834853736402010)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupno \0161tevilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832599924402009)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'sl'
,p_message_text=>'Ustvari %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777896762401967)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'sl'
,p_message_text=>'Podatki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825608875402003)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Podatkovni tip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825258203402003)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'sl'
,p_message_text=>'Datum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806372221401989)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna vrednost datuma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775572892401965)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'sl'
,p_message_text=>'dnevi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778567756401967)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>'Privzete nastavitve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778337917401967)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Privzeti tip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749792559401945)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbri\0161i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826875837402004)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'sl'
,p_message_text=>unistr('Ali ste prepri\010Dani, da \017Eelite izbrisati to poro\010Dilo?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782963348401971)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbri\0161i vrstico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781782547401970)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbri\0161i vrstice')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820107757401999)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Padajo\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780656636401969)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'sl'
,p_message_text=>'Podrobnost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748221742401944)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Podroben pogled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808859216401991)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'sl'
,p_message_text=>'Smer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780308360401969)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Onemogo\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774931470401965)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'sl'
,p_message_text=>'ne vsebuje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775119922401965)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'sl'
,p_message_text=>unistr('se ne za\010Dne s/z')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818432611401998)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'sl'
,p_message_text=>'Kolobar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781305087401969)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'sl'
,p_message_text=>'Prenos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680094146401892)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'sl'
,p_message_text=>'Samo podatki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827862591402005)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'sl'
,p_message_text=>'Izbira formata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692650848401901)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Format prenosa %0 ni omogo\010Den.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820809130402000)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Podvojeno zdru\017Eevanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820955301402000)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'sl'
,p_message_text=>'Podvojen kontrolni prelom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782862063401971)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'sl'
,p_message_text=>'Podvoji vrstico'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781663393401970)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'sl'
,p_message_text=>'Podvojene vrstice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749345626401945)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'sl'
,p_message_text=>'Uredi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819940528401999)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'sl'
,p_message_text=>'Uredi grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831461748402008)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>'Uredi grupiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827426567402005)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'sl'
,p_message_text=>'Slepa kopija (Skp)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827686136402005)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'sl'
,p_message_text=>unistr('Sporo\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827360212402005)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'sl'
,p_message_text=>'Kopija (Kp)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827072414402004)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161tno sporo\010Dilo je poslano.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827572039402005)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'sl'
,p_message_text=>'Zadeva'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827236648402004)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'sl'
,p_message_text=>'Prejemnik (Za)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780063345401968)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Omogo\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773244667401963)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'sl'
,p_message_text=>'je enako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826494819402004)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'sl'
,p_message_text=>'Primer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780157977401969)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'sl'
,p_message_text=>'Izraz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826366186402004)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Tip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792392931401978)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'sl'
,p_message_text=>unistr('Datoteka je pripravljena. Za\010Detek prenosa.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114755904139401950)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'sl'
,p_message_text=>'Zapolnitev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757045745401951)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Zapolnitev izbire s/z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756903193401951)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Zapolnitev izbire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748843438401944)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'sl'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779450194401968)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'sl'
,p_message_text=>'Filtri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834495936402010)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'sl'
,p_message_text=>'Filtriranje ...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820308205401999)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'sl'
,p_message_text=>'Prvi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749002797401945)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'sl'
,p_message_text=>'Pogled nazaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777955376401967)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'sl'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824974314402003)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'sl'
,p_message_text=>'Maska formata'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826718195402004)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'sl'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826630803402004)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'sl'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739435224401937)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'sl'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678787930401891)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'sl'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782529384401970)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'sl'
,p_message_text=>'Zamrzni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780291061401969)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'sl'
,p_message_text=>'Funkcije in operatorji'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818567454401998)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'sl'
,p_message_text=>'Lijak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799097189401983)
,p_name=>'APEX.IG.GO'
,p_message_language=>'sl'
,p_message_text=>'Pojdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773833736401964)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'sl'
,p_message_text=>unistr('ve\010Dje kot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773998919401964)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'sl'
,p_message_text=>unistr('ve\010Dje kot ali enako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780582998401969)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'sl'
,p_message_text=>unistr('Mre\017Ea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748035437401944)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'sl'
,p_message_text=>unistr('Pogled mre\017Ee')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821112539402000)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'sl'
,p_message_text=>'Skupina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780732460401969)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>'Grupiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748368612401944)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled grupiranja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825599997402003)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Tip pogoja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824473369402002)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'sl'
,p_message_text=>'Naslov'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824606824402003)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'sl'
,p_message_text=>'Poravnava naslova'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834388895402010)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829858042402006)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Podatke lahko vstavljate, posodabljate in bri\0161ete neposredno v tej interaktivni mre\017Ei.</p>'),
'',
'<p>Novo vrstico vstavite tako, da kliknete gumb Dodaj vrstico.</p>',
'',
unistr('<p>Obstoje\010De podatke uredite tako, da dvokliknete dolo\010Deno celico. Pri obse\017Enej\0161em urejanju kliknite Uredi, da vstopite v na\010Din za urejanje. V na\010Dinu za urejanje lahko dolo\010Dene celice urejate tako, da jih enkrat kliknete ali uporabite tipkovnico.</p>'),
'',
unistr('<p>Z menijem Spremeni podvojite in bri\0161ite vrstice. \010Ce \017Eelite omogo\010Diti meni Spremeni, uporabite potrditvena polja, da izberete eno ali ve\010D vrstic.</p>'),
'',
unistr('<p>Izbrano vrstico podvojite tako, da kliknete meni Spremeni in izberete Podvoji vrstice. Izbrano vrstico izbri\0161ite tako, da kliknete meni Spremeni in izberete Izbri\0161i vrstico.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831935034402008)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'sl'
,p_message_text=>unistr('Zmo\017Enosti urejanja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832031268402008)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interaktivna mre\017Ea predstavlja nabor podatkov v poro\010Dilu, po katerem je mogo\010De iskati in ga prilagajati. Izvajate lahko \0161tevilne operacije za omejitev vrnjenih zapisov in spremenite na\010Din prikaza podatkov.</p>'),
'',
unistr('<p>S poljem Iskanje filtrirajte vrnjene rezultate. Kliknite Dejanja za dostop do \0161tevilnih mo\017Enosti za spreminjanje postavitve poro\010Dila ali pa uporabite menije Glava stolpca na prikazanih stolpcih.</p>'),
'',
unistr('<p>Uporabite Nastavitve poro\010Dila, da shranite svoje prilagoditve v poro\010Dilo. Podatke iz poro\010Dila lahko tudi prenesete v zunanjo datoteko ali jih po\0161ljete po e-po\0161ti sebi ali drugim.</p>'),
'',
unistr('<p>Za ve\010D informacij si oglejte "Uporaba interaktivnih mre\017E" v <em>priro\010Dniku za kon\010Dnega uporabnika Oracle Application Express</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831753403402008)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'sl'
,p_message_text=>'Pregled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829724687402006)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interaktivno mre\017Eo lahko prilagodite tako, da prikazuje podatke na razli\010Dne na\010Dine z vgrajenimi zmo\017Enostmi.</p>'),
'',
unistr('<p>Z meniji Glava stolpca ali menijem Dejanja dolo\010Dite, kateri stolpci bodo prikazani , v katerem zaporedju, stolpce pa lahko tudi zamrznete. Dolo\010Dite lahko tudi razli\010Dne filtre podatkov in razvrstite vrnjene podatke.</p>'),
'',
unistr('<p>Z gumbom Pogled (poleg polja Iskanje) dostopajte do drugih pogledov podatkov, ki jih je morda dolo\010Dil razvijalec aplikacije. Lahko tudi ustvarite grafikon ali si ogledate obstoje\010Di grafikon.</p>  '),
'',
unistr('<p><em>Opomba: Kliknite <strong>Pomo\010D</strong> v pogovornih oknih interaktivne mre\017Ee, da pridobite podrobnej\0161e informacije o izbrani funkciji.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831821864402008)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'sl'
,p_message_text=>unistr('Zmo\017Enosti poro\010Danja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781597327401970)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Interaktivna mre\017Ea - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828698617402006)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom zdru\017Eite stolpce. Zdru\017Eene vrednosti se prika\017Eejo na dnu podatkov, \010De pa so dolo\010Deni kontrolni prelomi, se prika\017Eejo na dnu vsakega preloma.</p>'),
'',
unistr('<p><strong>Seznam zdru\017Eevanja</strong><br>'),
unistr('Na seznamu zdru\017Eevanja so prikazana dolo\010Dena zdru\017Eevanja. Obstoje\010De zdru\017Eevanje onemogo\010Dite tako, da prekli\010Dete njegovo izbiro.<br>'),
unistr('Kliknite Dodaj ( &plus; ), da ustvarite novo zdru\017Eevanje, ali Izbri\0161i ( &minus; ), da odstranite obstoje\010De zdru\017Eevanje.</p>'),
'',
unistr('<p><strong>Nastavitve zdru\017Eevanja</strong><br>'),
unistr('Z obrazcem na desni strani dolo\010Dite zdru\017Eevanje.<br>'),
unistr('Izberite ime stolpca in tip zdru\017Eevanja.<br>'),
unistr('Druga mo\017Enost je, da za zdru\017Eevanje vnesete zaslonski namig.<br>'),
unistr('\010Ce ste dolo\010Dili kontrolni prelom, z izbiro mo\017Enosti <strong>Prika\017Ei skupno vrednost</strong> na dnu podatkov prika\017Eete celotno povpre\010Dje, skupno vrednost ali podobno vrednost.</p>'),
'',
unistr('<p><em>Opomba: Do pogovornega okna Zdru\017Eevanje dostopajte v meniju Dejanja ali tako, da kliknete naslov stolpca in vsoto ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830824385402007)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Zdru\017Eevanje - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829316121402006)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom dolo\010Dite grafikon, ki se prika\017Ee kot lo\010Den prikaz podatkov.<br>'),
'Izberite tip grafikona in atribute grafikona.</p>',
'<p><strong>Atributi grafikona</strong></br>',
unistr('Razpolo\017Eljivi atributi grafikona se razlikujejo glede na tip grafikona.</p>'),
'<p>',
'<ul>',
'  <li>Izberite stolpec, ki vsebuje vrednost za atribut:',
'    <ul>',
unistr('      <li>Oznaka - Besedilo za vsako podatkovno to\010Dko.</li>'),
'      <li>Vrednost - Podatki, ki bodo izrisani.</li>',
unistr('      <li>Serija - Za definiranje dinami\010Dne poizvedbe z ve\010D serijami.</li>'),
unistr('      <li>Odpiranje - Dnevna za\010Detna cena delnic (Samo Delnica).</li>'),
unistr('      <li>Zaklju\010Dek - Dnevna zaklju\010Dna cena delnic (Samo Delnica).</li>'),
'      <li>Visoko - Visoka vrednost (Samo Razpon in Delnica).</li>',
'      <li>Nizko - Nizka vrednost (Samo Razpon in Delnica).</li>',
'      <li>Obseg - Dnevni obseg delnic (Samo Delnica).</li>',
'      <li>Cilj - Ciljna vrednost (Samo Lijak).</li>',
unistr('      <li>X - Vrednost osi x (Samo Mehur\010Dek in Raztreseni).</li>'),
unistr('      <li>Y - Vrednost osi y (Samo Mehur\010Dek in Raztreseni).</li>'),
unistr('      <li>Z - \0160irina stolpca ali polmer mehur\010Dka (Samo Stolp\010Dni, Mehur\010Dek in Razpon).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Usmerjenost - Navpi\010Dno ali vodoravno.</li>'),
unistr('  <li>Zdru\017Eevanje - Izberite, kako zdru\017Eiti povezane vrednosti grafikona.</li>'),
unistr('  <li>Sklad - Dolo\010Dite, ali so elementi podatkov nalo\017Eeni v sklad.</li>'),
unistr('  <li>Razvrsti po - Razvr\0161\010Danje po oznaki ali vrednostih.'),
'    <ul>',
unistr('      <li>Smer - Razvr\0161\010Danje po nara\0161\010Dajo\010Dih ali padajo\010Dih vrednostih.</li>'),
unistr('      <li>Ni\010Dle - Dolo\010Dite, kako razvrstiti zapise z ni\010Delnimi vrednostmi glede na zapise z neni\010Delnimi vrednostmi.</li>'),
'    </ul>',
'  </li>',
'  <li>Decimalna mesta</li>',
'  <li>Naslov osi oznake</li>',
'  <li>Naslov osi vrednosti</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831255458402008)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Grafikon - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828302030402005)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>To pogovorno okno uporabite za izbiranje tega, kateri stolpci se prika\017Eejo in v katerem vrstnem redu.</p>'),
'',
unistr('<p>Stolpec skrijete tako, da prekli\010Dete njegovo izbiro.<br>'),
'Stolpce prerazporedite tako, da kliknete Premakni navzgor ( &uarr; ) ali Premakni navzdol ( &darr; ).<br>',
unistr('S spustnim izbirnikom na seznamu navedite mo\017Enosti Vsi stolpci, Prikazani stolpci ali Neprikazani stolpci.</p>'),
'',
unistr('<p>Obrazec lahko uporabite za dolo\010Danje minimalne \0161irine stolpca v pikslih.</p>'),
'',
unistr('<p><em>Opomba: Prikazane stolpce lahko prerazporedite tudi tako, da kliknete oprimek za vle\010Denje (na za\010Detku glave stolpca) in povle\010Dete stolpec v levo ali desno. \0160irino prikazanih stolpcev lahko spremenite tudi tako, da izberete lo\010Devalnik stolpca, ')
||'med glavami, in ga premaknete v levo ali desno.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831134787402007)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpci - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828728085402006)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom dolo\010Dite dodatne stolpce na podlagi matemati\010Dnih in funkcijskih izra\010Dunov, izvedenih na podlagi obstoje\010Dih stolpcev.</p>'),
'',
unistr('<p><strong>Seznam izra\010Dunov</strong><br>'),
unistr('Na seznamu izra\010Dunov so prikazani dolo\010Deni izra\010Duni. Obstoje\010Di izra\010Dun onemogo\010Dite tako, da prekli\010Dete njegovo izbiro.<br>'),
unistr('Kliknite Dodaj ( &plus; ), da dodate nov izra\010Dun, ali Izbri\0161i ( &minus; ), da odstranite obstoje\010Di izra\010Dun.</p>'),
'',
unistr('<p><strong>Nastavitve izra\010Dunov</strong><br>'),
unistr('Z obrazcem dolo\010Dite izra\010Dun.<br>'),
'Vnesite podrobnosti stolpca, kot sta naslov in oznaka, ter izberite nastavitve poravnave.<br> ',
unistr('Z besedilnim obmo\010Djem Izraz vnesite stolpce in povezane funkcije za izra\010Dun.<br>'),
unistr('Izberite ustrezen podatkovni tip in po \017Eelji masko formata za nov stolpec.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830769591402007)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Izra\010Dun - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829063903402006)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom dolo\010Dite kontrolni prelom na enem ali ve\010D stolpcih.</p>'),
'',
'<p><strong>Seznam kontrolnih prelomov</strong><br>',
unistr('Na seznamu kontrolnih prelomov so prikazani dolo\010Deni kontrolni prelomi. Onemogo\010Dite obstoje\010Di kontrolni prelom tako, da prekli\010Dete njegovo izbiro.<br>'),
unistr('Kliknite Dodaj ( &plus; ), da vklju\010Dite nov stolpec v kontrolni prelom, ali Izbri\0161i ( &minus; ), da odstranite obstoje\010Di stolpec iz kontrolnega preloma.<br>'),
'Stolpce prerazporedite tako, da kliknite Premakni navzgor ( &uarr; ) ali Premakni navzdol ( &darr; ), da premaknete izbrani stolpec navzgor in navzdol glede na druge stolpce.</p>',
'',
'<p><strong>Nastavitve kontrolnega preloma</strong><br>',
unistr('Z obrazcem dolo\010Dite stolpec s kontrolnim prelomom.<br>'),
unistr('Izberite stolpec s kontrolnim prelomom, smer razvr\0161\010Danja in na\010Din razporeditve ni\010Delnih stolpcev (stolpci brez vrednosti).</p>'),
'',
unistr('<p><em>Opomba: Kadar si ogledujete interaktivno mre\017Eo, lahko kontrolni prelom dolo\010Dite tako, da kliknete glavo stolpca in izberete ikono kontrolnega preloma.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830452127402007)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Kontrolni prelom - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829226932402006)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom prenesite vse trenutne vrstice v zunanjo datoteko. Datoteka bo vsebovala le trenutno prikazane stolpce, pri \010Demer bodo uporabljeni katerikoli filtri in razvr\0161\010Danja, uporabljeni pri podatkih.</p>'),
'',
'<p>Izberite format datoteke in kliknite Prenesi.<br>',
'Opomba: Datoteka CSV ne bo vsebovala formatiranja besedila, na primer skupnih vrednosti in kontrolnih prelomov.</p>',
'',
unistr('<p>\010Ce \017Eelite datoteko poslati po elektronski po\0161ti, izberite Po\0161lji kot e-po\0161to in vnesite podrobnosti e-po\0161te (prejemnik, zadeva in sporo\010Dilo).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830289061402007)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Prenos - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828492560402005)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom konfigurirajte podatkovne filtre, ki omejujejo \0161tevilo vrnjenih vrstic.</p>'),
'',
'<p><strong>Seznam filtrov</strong><br>',
unistr('Na seznamu filtrov so prikazani dolo\010Deni filtri. Obstoje\010Di filter onemogo\010Dite tako, da prekli\010Dete njegovo izbiro.<br>'),
unistr('Kliknite Dodaj ( &plus; ), da ustvarite nov filter, ali Izbri\0161i ( &minus; ), da odstranite obstoje\010Di filter.</p>'),
'',
'<p><strong>Nastavitve filtra</strong><br>',
unistr('Uporabite obrazec, da dolo\010Dite lastnosti filtra.<br>'),
'Izberite ustrezen tip filtra:<br>',
unistr('&nbsp;&nbsp;&nbsp;Vrstica - filter za izraz v kateremkoli stolpcu, ki ga je mogo\010De filtrirati.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Stolpec - filtriranje dolo\010Denega stolpca z dolo\010Denim operatorjem in vrednostjo.</p>'),
'',
unistr('<p><em>Opomba: Med ogledom interaktivne mre\017Ee lahko dolo\010Dite filtre vrstic tako, da tipkate neposredno v polje Iskanje. Kliknite Izbira stolpcev za iskanje, da omejite iskanje na dolo\010Deni stolpec. Druga mo\017Enost je, da odprete meni naslova stolpca in ')
||'izberete vrednost za ustvarjanje filtra stolpca.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831007946402007)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Filtriranje - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828865542402006)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom si oglejte podatke, kot so obstajali na neki pretekli to\010Dki v \010Dasu.</p>'),
unistr('<p>Vnesite \0161tevilo minut v preteklosti, da izvedete poizvedbo pogleda nazaj.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830642232402007)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Pogled nazaj - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831305512402008)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Grupiranje - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828948313402006)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom ozna\010Dite vrstice ali stolpce podatkov na podlagi vnesenih pogojev.</p>'),
'',
unistr('<p><strong>Seznam ozna\010Db</strong><br>'),
unistr('Na seznamu ozna\010Db so prikazane dolo\010Dene ozna\010Dbe. Obstoje\010Do ozna\010Dbo onemogo\010Dite tako, da prekli\010Dete njeno izbiro.<br>'),
unistr('Kliknite Dodaj ( &plus; ), da ustvarite novo ozna\010Dbo, ali Izbri\0161i ( &minus; ), da odstranite obstoje\010Do ozna\010Dbo.</p>'),
'',
unistr('<p><strong>Nastavitve ozna\010Db</strong><br>'),
unistr('Z obrazcem dolo\010Dite lastnosti ozna\010Dbe.<br>'),
'Vnesite ime, izberite vrstico ali stolpec in izberite barvne kode HTML za ozadje in besedilo.<br>',
unistr('Izberite ustrezno mo\017Enost <strong>Tip pogoja</strong>, da ozna\010Dite posebne podatke:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Vrstica - ozna\010Dite izraz v kateremkoli stolpcu.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Stolpec - ozna\010Dite znotraj posebnega stolpca na podlagi navedenega operatorja in vrednosti.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830531547402007)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Dba - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829165460402006)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S tem pogovornim oknom shranite spremembe, ki ste jih opravili pri trenutni postavitvi mre\017Ee in konfiguraciji.<br>'),
unistr('Razvijalci aplikacij lahko dolo\010Dijo ve\010D razli\010Dnih postavitev poro\010Dila. \010Ce je dovoljeno, lahko vi in drugi kon\010Dni uporabniki shranijo poro\010Dilo kot Javno, kar omogo\010Da, da je poro\010Dilo razpolo\017Eljivo vsem drugim uporabnikom mre\017Ee. Poro\010Dilo lahko shranite ')
||'tudi kot Zasebno, ki si ga lahko ogledate le vi.</p>',
unistr('<p>Izberite med razpolo\017Eljivimi tipi in vnesite ime za shranjeno poro\010Dilo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830317285402007)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Poro\010Dilo - Pomo\010D'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828523715402005)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>S tem pogovornim oknom nastavite vrstni red prikaza.</p>',
'',
unistr('<p><strong>Seznam razvr\0161\010Danja</strong><br>'),
unistr('V pogovornem oknu Razvr\0161\010Danje je prikazan seznam konfiguriranih pravil razvr\0161\010Danja.<br>'),
unistr('Kliknite Dodaj ( &plus; ), da ustvarite stolpec za razvr\0161\010Danje, ali Izbri\0161i ( &minus; ), da odstranite stolpec za razvr\0161\010Danje.<br>'),
unistr('Kliknite Premakni navzgor ( &uarr; ) in Premakni navzdol ( &darr; ), da premaknete izbrani stolpec za razvr\0161\010Danje navzgor in navzdol relativno glede na ostale stolpce za razvr\0161\010Danje.</p>'),
'',
unistr('<p><strong>Nastavitve razvr\0161\010Danja</strong><br>'),
unistr('Izberite stolpec za razvr\0161\010Danje, smer razvr\0161\010Danja in na\010Din razvrstitve ni\010Delnih stolpcev (stolpci brez vrednosti).</p>'),
'',
unistr('<p><em>Opomba: Podatke lahko razvrstite glede na stolpce, ki niso prikazani; vendar pa se lahko zgodi, da ne bo mogo\010De razvrstiti vseh stolpcev.</em><br>'),
unistr('<em>Prikazane stolpce lahko razvrstite tako, da pritisnete pu\0161\010Dico navzgor (nara\0161\010Dajo\010De) ali navzdol (padajo\010De) na koncu glav stolpca. \010Ce \017Eelite obstoje\010Demu razvr\0161\010Danju dodati naslednji stolpec, pridr\017Eite tipko Shift in kliknite pu\0161\010Dico navzgor ali n')
||'avzdol.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830947457402007)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvr\0161\010Danje - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114830156777402007)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Naro\010Dnina - Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782448023401970)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'sl'
,p_message_text=>'Skrij'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749261544401945)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Dba')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817202482401997)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Visoko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818085761401998)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'sl'
,p_message_text=>'Vodoravno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775416324401965)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'sl'
,p_message_text=>'ure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780474454401969)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'sl'
,p_message_text=>'Ikona'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748115409401944)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773654392401964)
,p_name=>'APEX.IG.IN'
,p_message_language=>'sl'
,p_message_text=>'v'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782010773401970)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'sl'
,p_message_text=>'Neaktivna nastavitev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782163385401970)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>'Neaktivne nastavitve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789710192401976)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Med obdelavo zahteve Interaktivna mre\017Ea je pri\0161lo do notranje napake.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685569897401896)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Tip filtra stolpca "%0" ni podprt za stolpec "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829929520402007)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna oblika datuma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804135774401987)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Interaktivna mre\017Ea ne podpira dolo\010Danja filtra na stolpcu %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804001307401987)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 ni veljaven tip filtra za dolo\010Danje filtra Interaktivna mre\017Ea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690680460401900)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'sl'
,p_message_text=>unistr('Neveljaven format \0161tevilke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832644472402009)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna nastavitev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832725799402009)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>'Neveljavne nastavitve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823768082402002)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enost Razvrsti po je bila nastavljena na %0, vendar za %0 ni bil izbran noben stolpec.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821027707402000)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna vrednost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816135311401996)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'sl'
,p_message_text=>'Ni prikazano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774478844401964)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'sl'
,p_message_text=>'v zadnjih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774687680401964)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'sl'
,p_message_text=>'v naslednjih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773575547401964)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>'ni prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773446577401964)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'sl'
,p_message_text=>'je prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824577109402002)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'sl'
,p_message_text=>'Oznaka'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816522216401996)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Oznaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820476213401999)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'sl'
,p_message_text=>'Zadnji'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763741958401956)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'sl'
,p_message_text=>'Zadnji dan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763923785401956)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'sl'
,p_message_text=>'Zadnja ura'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764470261401957)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'sl'
,p_message_text=>'Zadnja minuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763471194401956)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'sl'
,p_message_text=>'Zadnji mesec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763547124401956)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'sl'
,p_message_text=>'Zadnji teden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763648352401956)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko dni: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763891149401956)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko ur: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764501746401957)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko minut: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764386760401956)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko mesecev: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764234820401956)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko tednov: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763205516401956)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko let: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763386032401956)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'sl'
,p_message_text=>'Zadnje leto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824768131402003)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'sl'
,p_message_text=>'Poravnava celic'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824839333402003)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'sl'
,p_message_text=>'Uporabi skupino za'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774000851401964)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'sl'
,p_message_text=>unistr('manj\0161e kot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774177763401964)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'sl'
,p_message_text=>unistr('manj\0161e kot ali enako')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818695725401998)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818719337401998)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrstica z obmo\010Djem')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825191806402003)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'sl'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817314392401997)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Nizko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827776743402005)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'sl'
,p_message_text=>unistr('Ve\010D naslovov lo\010Dite z vejicami')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775289929401965)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'sl'
,p_message_text=>'se ujema z regularnim izrazom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799632305401984)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'sl'
,p_message_text=>'Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835257782402011)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'sl'
,p_message_text=>'Skupno maksimalno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799852549401984)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'sl'
,p_message_text=>'Mediana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835323721402011)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'sl'
,p_message_text=>'Skupna mediana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799543859401984)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'sl'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775303564401965)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'sl'
,p_message_text=>'minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800322854401984)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'sl'
,p_message_text=>'min. v preteklosti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835193005402011)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'sl'
,p_message_text=>'Skupno minimalno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775760124401965)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'sl'
,p_message_text=>'meseci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782324689401970)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatki vsebujejo ve\010D kot toliko vrstic: %0, kar presega maksimalno dovoljeno \0161tevilo. Za ogled rezultatov dodelite dodatne filtre.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809003865401991)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Naveden mora biti stati\010Dni ID podro\010Dja, saj stran vsebuje ve\010D interaktivnih mre\017E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778443220401967)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'sl'
,p_message_text=>'Ime'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778689516401967)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Imenovano poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762621233401955)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'sl'
,p_message_text=>'Naslednji dan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762437948401955)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'sl'
,p_message_text=>'Naslednja ura'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764641048401957)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'sl'
,p_message_text=>'Naslednja minuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762916497401955)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'sl'
,p_message_text=>'Naslednji mesec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762834128401955)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'sl'
,p_message_text=>'Naslednji teden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762767283401955)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko dni: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114762587270401955)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko ur: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764790675401957)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko minut: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764004816401956)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko mesecev: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764124495401956)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko tednov: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763106155401956)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko let: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114763010893401955)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'sl'
,p_message_text=>'Naslednje leto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774341594401964)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'sl'
,p_message_text=>'ni med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773391076401963)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'sl'
,p_message_text=>'ni enako'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839539815402014)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje z ID-jem %0 ni podro\010Dje interaktivne mre\017Ee ali pa ne obstaja v aplikaciji %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773736098401964)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'sl'
,p_message_text=>'ni v'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774577036401964)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'sl'
,p_message_text=>'ni v zadnjih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114774788228401965)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'sl'
,p_message_text=>'ni v naslednjih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782215387401970)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatkov ni bilo mogo\010De najti')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820209455401999)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'sl'
,p_message_text=>'Vrednosti NULL'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825379703402003)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilska vrednost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820535089401999)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'sl'
,p_message_text=>'Izklopljeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820677679402000)
,p_name=>'APEX.IG.ON'
,p_message_language=>'sl'
,p_message_text=>'Vklopljeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772512399401963)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred 1 minuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828265154402005)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'sl'
,p_message_text=>'Odpri izbirnik barve: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817075737401997)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Odpri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779501930401968)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'sl'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816478210401996)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'sl'
,p_message_text=>'Usmerjenost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818874909401998)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'sl'
,p_message_text=>'Tortni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114780846681401969)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'sl'
,p_message_text=>'Vrtenje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114748409354401944)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Vrtilni pogled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114828126974402005)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednosti lo\010Dite s/z "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114818998925401998)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'sl'
,p_message_text=>'Polarni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824222882402002)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'sl'
,p_message_text=>'Sredina'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824367951402002)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'sl'
,p_message_text=>'Konec'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114824107011402002)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'sl'
,p_message_text=>unistr('Za\010Detek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778780541401968)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'sl'
,p_message_text=>'Primarno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779011754401968)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Primarno privzeto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795503624401981)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Primarno poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677743539401890)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'sl'
,p_message_text=>unistr('Vklju\010Ditev oznak za dostopnost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676484048401890)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'sl'
,p_message_text=>unistr('Le\017Ee\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676574788401890)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'sl'
,p_message_text=>unistr('Pokon\010Dno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676340609401889)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'sl'
,p_message_text=>'Usmerjenost strani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676284471401889)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'sl'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676107423401889)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'sl'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677897488401891)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'sl'
,p_message_text=>'Prilagojeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675904261401889)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'sl'
,p_message_text=>'Pravno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675838386401889)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Crka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676063786401889)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'sl'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675751266401889)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'sl'
,p_message_text=>'Velikost strani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665939615401882)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Ci\0161\010Denje obogatenega besedila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819013904401998)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'sl'
,p_message_text=>'Radarski'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819187941401998)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'sl'
,p_message_text=>'Razpon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829453786402006)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'sl'
,p_message_text=>unistr('Osve\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783082709401971)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'sl'
,p_message_text=>unistr('Osve\017Ei vrstico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781818310401970)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'sl'
,p_message_text=>unistr('Osve\017Ei vrstice')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787068231401974)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje interaktivne mre\017Ee ne obstaja v aplikaciji %0 na strani %1 in na podro\010Dju %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749978273401945)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'sl'
,p_message_text=>'Odstrani %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778121425401967)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838761903402013)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo je bilo izbrisano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838440781402013)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nadomestno poro\010Dilo je bilo shranjeno za vse uporabnike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838353829402013)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'sl'
,p_message_text=>unistr('Privzeto poro\010Dilo je bilo shranjeno za vse uporabnike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838629970402013)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'sl'
,p_message_text=>unistr('Zasebno poro\010Dilo je bilo shranjeno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838575537402013)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'sl'
,p_message_text=>unistr('Javno poro\010Dilo je bilo shranjeno za vse uporabnike')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114787189578401974)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjena interaktivna mre\017Ea z imenom %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772435947401963)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatki poro\010Dila pred toliko minutami: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772399621401963)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatki poro\010Dila pred 1 minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712094842401916)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo o interaktivni mre\017Ei ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831698367402008)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo - Urejanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786952360401974)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjena interaktivna mre\017Ea z ID-jem %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114831509330402008)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo - Shrani kot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750003415401946)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>unistr('Nastavitve poro\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839623205402014)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjena interaktivna mre\017Ea s stati\010Dnim ID-jem %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834542589402010)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'sl'
,p_message_text=>unistr('Pogled poro\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749122573401945)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'sl'
,p_message_text=>'Ponastavi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783134970401971)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'sl'
,p_message_text=>'Povrni spremembe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781945175401970)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'sl'
,p_message_text=>'Povrni vrstice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779131602401968)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778075648401967)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo vrstic na stran')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839218212402014)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'sl'
,p_message_text=>'Dejanja za vrstice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840497644402015)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'sl'
,p_message_text=>'Dejanja za vrstico %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114749418057401945)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'sl'
,p_message_text=>'Shrani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792155610401978)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'sl'
,p_message_text=>'shranjeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747686663401944)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjena poro\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747757822401944)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Privzeto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722231877401924)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjeno poro\010Dilo z imenom %0 \017Ee obstaja. Vnesite novo ime.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747843833401944)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'sl'
,p_message_text=>'Zasebno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747970273401944)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'sl'
,p_message_text=>'Javno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834243135402010)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'sl'
,p_message_text=>'Shrani kot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781238809401969)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>unistr('Shrani nastavitve poro\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819250274401998)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'sl'
,p_message_text=>'Raztreseni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747536756401944)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'sl'
,p_message_text=>'Iskanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826593934402004)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Iskanje: Vsi besedilni stolpci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747440215401943)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Iskanje: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825751863402003)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'sl'
,p_message_text=>'Iskanje: Polno besedilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772286014401963)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'sl'
,p_message_text=>'Iskanje "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815868287401996)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'sl'
,p_message_text=>'- Izbira -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756026600401950)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'sl'
,p_message_text=>'Izbira'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808745547401991)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'sl'
,p_message_text=>unistr('Izberite 1 vrstico znotraj glavnega podro\010Dja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747384876401943)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'sl'
,p_message_text=>'Izbira stolpcev za iskanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838954735402013)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'sl'
,p_message_text=>'Dejanja izbire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756214252401950)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'sl'
,p_message_text=>'Izbira celice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756167858401950)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'sl'
,p_message_text=>'Izbira vrstice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827193664402004)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji kot e-po\0161to')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819659554401999)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Serija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745352336401942)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'sl'
,p_message_text=>'Prikaz'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797985076401982)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'sl'
,p_message_text=>unistr('Prika\017Ei skupno vrednost')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782731724401971)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled ene vrstice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781003308401969)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'sl'
,p_message_text=>'Razvrsti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819773033401999)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'sl'
,p_message_text=>'Razvrsti po'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839333772402014)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Dolo\010Dite lahko samo eno razvrstitev na stolpec.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839104865402014)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'sl'
,p_message_text=>'Meni za spremembe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114820715544402000)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'sl'
,p_message_text=>'Sklad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775059551401965)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'sl'
,p_message_text=>unistr('se za\010Dne s/z')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819374851401999)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'sl'
,p_message_text=>'Zaloga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740361724401938)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>unistr('Raztegni \0161irino stolpcev')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114781409593401970)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Naro\010Dnina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114799433918401984)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'sl'
,p_message_text=>'Vsota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840694067402015)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'sl'
,p_message_text=>unistr('Interaktivna mre\017Ea. Poro\010Dilo: %0, Pogled: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114834621521402010)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'sl'
,p_message_text=>'Skupna vsota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817533572401997)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Cilj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823903271402002)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'sl'
,p_message_text=>'Barva besedila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750170499401946)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'sl'
,p_message_text=>'Preklop'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797888240401982)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'sl'
,p_message_text=>'Zaslonski namig'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114778282769401967)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'sl'
,p_message_text=>'Tip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114782636160401970)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'sl'
,p_message_text=>'Odmrzni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779722785401968)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'sl'
,p_message_text=>'Enota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826950740402004)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'sl'
,p_message_text=>unistr('Obstajajo neshranjene spremembe. Ali \017Eelite nadaljevati?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114779624235401968)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'sl'
,p_message_text=>'Vrednost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816606422401997)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Vrednost'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821541606402000)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Zahtevana je vrednost.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806400044401989)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednost (\010Dasovnega pasu ni mogo\010De spremeniti)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825486643402003)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'sl'
,p_message_text=>'Besedilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817971629401998)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Navpi\010Dno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777787819401967)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815957723401996)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'sl'
,p_message_text=>'Prikazano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114817490725401997)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775663062401965)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'sl'
,p_message_text=>'tedni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816093387401996)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'sl'
,p_message_text=>unistr('Minimalna \0161irina stolpca (slikovne pike)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766816919401958)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'sl'
,p_message_text=>'%0 med %1 in %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766508343401958)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 vsebuje %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766668176401958)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 ne vsebuje %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744734190401941)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 se ne za\010Dne s/z %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765331775401957)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 je enako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765534407401957)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 ve\010Dje kot %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765671585401958)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 ve\010Dje kot ali enako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766379307401958)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 v %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767526541401959)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjih %1 dneh'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767350677401959)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjih %1 urah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767147447401959)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjih %1 minutah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767903451401959)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjih %1 mesecih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767717591401959)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjih %1 tednih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768127683401959)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjih toliko letih: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767429687401959)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjem dnevu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767234915401959)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnji uri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767015531401959)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnji minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767878358401959)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjem mesecu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114767665170401959)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjem tednu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768069226401959)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'sl'
,p_message_text=>'%0 v zadnjem letu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769954306401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjih %1 dneh'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769715973401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjih %1 urah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769538682401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjih %1 minutah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770398445401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjih %1 mesecih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770190460401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjih %1 tednih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770569550401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjih %1 letih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769895118401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjem dnevu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769682712401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednji uri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769470815401960)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednji minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770229743401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjem mesecu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770000904401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjem tednu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770465579401961)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'sl'
,p_message_text=>'%0 v naslednjem letu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766037703401958)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>'%0 ni prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765979986401958)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'sl'
,p_message_text=>'%0 je prazno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765798869401958)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 manj\0161e kot %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765817875401958)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 manj\0161e kot ali enako %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766108358401958)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 kot %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766742330401958)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 se ujema z regularnim izrazom %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772659160401963)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko minutami: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766993827401959)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'sl'
,p_message_text=>'%0 ni med %1 in %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765406246401957)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 ni enako %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766484942401958)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768717369401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih toliko dneh: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768528862401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih toliko urah: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768365926401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih toliko minutah: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769186128401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih toliko mesecih: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768940629401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih toliko tednih: %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769399008401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih %1 letih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768690851401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjem dnevu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768468550401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnji uri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768206924401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnji minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769007982401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjem mesecu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114768815228401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjem tednu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114769266896401960)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjem letu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771139860401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1 dneh'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770976328401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1 urah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770736262401961)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1 minutah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771546871401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1 mesecih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771339544401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1 tednih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771723419401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1 letih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771071177401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjem dnevu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770853259401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednji uri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114770642630401961)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednji minuti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771427237401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjem mesecu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771290692401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjem tednu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771690869401962)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjem letu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114766263933401958)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'sl'
,p_message_text=>'%0 ni kot %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773175815401963)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 se za\010Dne s/z %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816773273401997)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775847513401965)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'sl'
,p_message_text=>'leta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816827699401997)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816978390401997)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114825905473402003)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'sl'
,p_message_text=>'Ponedeljek, 12. januar 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826015212402004)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'sl'
,p_message_text=>'Januar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826119529402004)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'sl'
,p_message_text=>'Pred 16 urami'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114826242644402004)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'sl'
,p_message_text=>'v roku 16 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681237263401893)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven tip datoteke. Podprti tipi datotek %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808145953401990)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'sl'
,p_message_text=>'Prebrskaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807889322401990)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'sl'
,p_message_text=>'Izbira datoteke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807910966401990)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'sl'
,p_message_text=>'Izbira datotek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681041483401893)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'sl'
,p_message_text=>'Povlecite in spustite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681427000401893)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'sl'
,p_message_text=>'Povlecite in spustite datoteke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682665839401894)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'sl'
,p_message_text=>'Izberite datoteko ali jo spustite sem.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682742069401894)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'sl'
,p_message_text=>'Izberite ali spustite datoteke sem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682823188401894)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'sl'
,p_message_text=>'Izberite datoteko ali jo spustite sem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682948684401894)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'sl'
,p_message_text=>'Izberite ali spustite datoteke sem.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681321195401893)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'sl'
,p_message_text=>'Datoteke: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681138992401893)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'sl'
,p_message_text=>'Datoteka je prevelika. Maksimalna velikost datoteke je %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668912738401884)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Naslov je zahtevan.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667860559401883)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'sl'
,p_message_text=>'Kraj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668229936401884)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'sl'
,p_message_text=>unistr('Koda dr\017Eave')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667934409401883)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'sl'
,p_message_text=>unistr('Hi\0161na \0161tevilka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668802242401884)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160irina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668775888401884)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'sl'
,p_message_text=>unistr('Dol\017Eina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668694021401884)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'sl'
,p_message_text=>unistr('Poka\017Ei na zemljevidu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668327944401884)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'sl'
,p_message_text=>'Rezultat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668032877401883)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161tna \0161tevilka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668177033401883)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'sl'
,p_message_text=>'Stanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667740256401883)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'sl'
,p_message_text=>'Ulica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667665359401883)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Rezultati geokodiranja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680294653401892)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'sl'
,p_message_text=>'Geokodirano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680313964401892)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'sl'
,p_message_text=>'Ni geokodirano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668560627401884)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Zemljevid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114668406928401884)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Nobenega naslova ni bilo mogo\010De najti.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669054724401884)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'%0 je zahtevano.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838891306402013)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'sl'
,p_message_text=>unistr('Besedilo pomo\010Di: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732224124401931)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'sl'
,p_message_text=>'Potrjeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732341402401931)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'sl'
,p_message_text=>'Nepotrjeno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678208036401891)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# ni v veljavnem razponu med %0 in %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678336368401891)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# ni ve\010Dkratnik %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677954238401891)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# se mora ujemati z vrednostma %0 in %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678143643401891)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756482348401950)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Izklopljeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756542660401950)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Vklopljeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678048915401891)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661403136401879)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'sl'
,p_message_text=>'Dodaj vnos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790639275401977)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'sl'
,p_message_text=>'Dodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790730081401977)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'sl'
,p_message_text=>'Odstrani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661509852401879)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'sl'
,p_message_text=>'Izbrani vnosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794429619401980)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'sl'
,p_message_text=>'Napredno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794749668401980)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Prekli\010Di')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794596087401980)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'sl'
,p_message_text=>unistr('Splo\0161no')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794844976401980)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enosti predloge v \017Eivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795476877401980)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enosti predloge niso na voljo, ker ta komponenta ni upodobljena na strani.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794321767401980)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enosti predloge ni bilo mogo\010De najti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794699934401980)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'sl'
,p_message_text=>'Shrani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669994861401885)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Disti krog')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671701963401886)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enost Prilagojeni slogi ni veljaven JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670263397401885)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'sl'
,p_message_text=>'Orodje razdalje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670008835401885)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nari\0161i krog')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662677147401879)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'sl'
,p_message_text=>unistr('Za fasetno iskanje potrebujete vir podatkov na ravni podro\010Dja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665255744401881)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'sl'
,p_message_text=>'Trenutna lokacija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666351849401882)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('Koordinate za\010Detnega polo\017Eaja so neveljavne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663795235401880)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Za\010Detni polo\017Eaj mora biti to\010Dkovna geometrija.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666146266401882)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'sl'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664750374401881)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'sl'
,p_message_text=>'Plast'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798078796401982)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'sl'
,p_message_text=>'Nivo: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669349478401884)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'sl'
,p_message_text=>'Zemljevid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662568934401879)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'sl'
,p_message_text=>unistr('Sporo\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666293874401882)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'sl'
,p_message_text=>'milje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797014014401982)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatki vsebujejo ve\010D kot %0 vrstic, kar presega maksimalno dovoljeno \0161tevilo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664517298401881)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'sl'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Pogoji</a> &nbsp;&nbsp; Podatki zemljevida &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663403562401880)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatkovni tip SDO_GEOMETRY ni razpolo\017Eljiv v tej bazi podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664664647401881)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'sl'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Sodelavci pri OpenStreetMap </a>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664840502401881)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'sl'
,p_message_text=>unistr('To\010Dke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798158250401983)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 To\010Dke')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670171914401885)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'sl'
,p_message_text=>unistr('Pove\010Dava pravokotnika')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669858262401885)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'sl'
,p_message_text=>'Odstrani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665133738401881)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'sl'
,p_message_text=>'Ponastavitev usmerjenosti na sever'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745407057401942)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'sl'
,p_message_text=>unistr('Preklopi na 2D-na\010Din')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745579815401942)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'sl'
,p_message_text=>unistr('Preklopi na 3D-na\010Din')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669711726401885)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'sl'
,p_message_text=>'Preklop obvestila o avtorskih pravicah'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670314686401885)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'sl'
,p_message_text=>'Skupna razdalja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664918633401881)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'sl'
,p_message_text=>unistr('Pove\010Dava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665098410401881)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'sl'
,p_message_text=>unistr('Pomanj\0161ava')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792589643401978)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'sl'
,p_message_text=>'Krepko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793462381401979)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'sl'
,p_message_text=>'Slika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793033907401979)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'sl'
,p_message_text=>'Koda v vrstici'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806633409401989)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'sl'
,p_message_text=>'Vstavi sliko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806796816401989)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'sl'
,p_message_text=>'Vstavi povezavo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792653083401978)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'sl'
,p_message_text=>unistr('Le\017Ee\010De')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807325530401990)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'sl'
,p_message_text=>'Povezava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793372192401979)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'sl'
,p_message_text=>'Seznam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793260007401979)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvr\0161\010Den seznam')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792743390401978)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'sl'
,p_message_text=>'Predogled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792847382401978)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni ni\010Desar za predogled')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792979674401979)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'sl'
,p_message_text=>unistr('Pre\010Drtano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793178969401979)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Nerazvr\0161\010Den seznam')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772052163401962)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'sl'
,p_message_text=>'trenutno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114829547920402006)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Ve\010D ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114771945839401962)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'sl'
,p_message_text=>'Nalaganje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803703077401987)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'sl'
,p_message_text=>unistr('Obvestilno sporo\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777091907401966)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# mora biti \0161tevilo, manj\0161e kot ali enako %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777161649401966)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# mora biti veljavno \0161tevilo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777227212401966)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# se ne ujema s formatom \0161tevilke %0 (Primer: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776922984401966)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# mora biti \0161tevilo, ve\010Dje kot ali enako %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776853910401966)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sl'
,p_message_text=>unistr('#LABEL# mora biti \0161tevilo med %0 in %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772121926401963)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'sl'
,p_message_text=>'odpre se v novem oknu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725391914401926)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'sl'
,p_message_text=>unistr('Ta stran je \017Ee bila predlo\017Eena in je ni mogo\010De ponovno predlo\017Eiti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707969078401913)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>'Aplikacija "%0", stran "%1" ni bila najdena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741795315401939)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'#LABEL# mora imeti neko vrednost.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685041300401896)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'sl'
,p_message_text=>'Iskanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791058815401977)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'sl'
,p_message_text=>'Zapri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790988143401977)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'sl'
,p_message_text=>unistr('Poi\0161\010Di%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791291884401977)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791148870401977)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677188233401890)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'sl'
,p_message_text=>'Vnesite iskani izraz, ki vsebuje vsaj toliko znakov: %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746631010401943)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'sl'
,p_message_text=>'Pojavni seznam vrednosti: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677291471401890)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'sl'
,p_message_text=>'Vnesite iskani izraz.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677061781401890)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'sl'
,p_message_text=>'Ni najdenih rezultatov.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676911444401890)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'sl'
,p_message_text=>'Odstrani %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764800866401957)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'sl'
,p_message_text=>'Iskani izraz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790812815401977)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'sl'
,p_message_text=>'Iskanje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801588370401985)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'sl'
,p_message_text=>'Obdelava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675526378401889)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Dodaj na za\010Detni zaslon')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671591376401886)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ni videti, da bi va\0161a naprava ali brskalnik trenutno podpirala namestitev progresivnih spletnih aplikacij.</p>'),
unistr('    <p class="a-pwaDialog-intro">\010Ce je ta aplikacija \017Ee name\0161\010Dena v va\0161i napravi, jo odprite na svojem za\010Detnem zaslonu.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671180583401886)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije. Dodajte ga na svoj za\010Detni zaslon za uporabo v celozaslonskem na\010Dinu.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tapnite ikono <strong>Meni</strong> v spodnjem obmo\010Dju za krmarjenje</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tapnite <strong>Namesti</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tapnite <strong>Dodaj</strong> za potrditev</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671269599401886)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije, ki jo je najbolje izkusiti v brskalniku Chrome ali Edge.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tapnite ikono <strong>Meni</strong> poleg naslovne vrstice</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tapnite <strong>Namesti</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670856964401885)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije, ki jo je najbolje izkusiti v brskalniku Safari.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tapnite ikono <strong>Deli</strong> v spodnjem obmo\010Dju za krmarjenje</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tapnite <strong>Odpri v brskalniku Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670586220401885)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije. Za najbolj\0161o izku\0161njo ga dodajte na svoj za\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tapnite ikono <strong>Deli</strong> poleg naslovne vrstice</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tapnite <strong>Dodaj na za\010Detni zaslon</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tapnite <strong style="color:#007AE1;">Dodaj</strong> za potrditev</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670495183401885)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije. Za najbolj\0161o izku\0161njo ga dodajte na svoj za\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tapnite ikono <strong>Deli</strong> v spodnjem obmo\010Dju za krmarjenje</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Pomaknite se navzdol in tapnite <strong>Dodaj na za\010Detni zaslon</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tapnite <strong style="color:#007AE1;">Dodaj</strong> za potrditev</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665423536401881)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije. Za najbolj\0161o izku\0161njo ga dodajte na svoj za\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tapnite ikono <strong>Ve\010D</strong> poleg naslovne vrstice</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tapnite <strong>Dodaj na za\010Detni zaslon</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tapnite <strong style="color:#007AE1;">Dodaj</strong> za potrditev</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670746211401885)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije. Za najbolj\0161o izku\0161njo ga dodajte na svoj za\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tapnite ikono <strong>Deli</strong> poleg naslovne vrstice</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tapnite <strong>Odpri v brskalniku Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670623057401885)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije. Za najbolj\0161o izku\0161njo ga dodajte na svoj za\010Detni zaslon.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tapnite ikono <strong>Deli</strong> v spodnjem obmo\010Dju za krmarjenje</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tapnite <strong>Odpri v brskalniku Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671419683401886)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije, ki jo je najbolje izkusiti v brskalniku Chrome.</p>',
'    <p class="a-pwaDialog-intro">Brskalnik Firefox trenutno ne podpira namestitve spletnih aplikacij.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114670979535401885)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije, ki jo je najbolje izkusiti v brskalniku Chrome ali Edge.</p>',
'    <p class="a-pwaDialog-intro">Brskalnik Firefox trenutno ne podpira namestitve spletnih aplikacij v operacijskem sistemu macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671072190401886)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije, ki jo je najbolje izkusiti v brskalniku Chrome ali Edge.</p>',
'    <p class="a-pwaDialog-intro">Brskalnik Safari trenutno ne podpira namestitve spletnih aplikacij v operacijskem sistemu macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671361975401886)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">To spletno mesto ima funkcionalnost aplikacije, ki jo je najbolje izkusiti v brskalniku Chrome ali Edge.</p>',
'    <p class="a-pwaDialog-intro">Brskalnik Firefox trenutno ne podpira namestitve spletnih aplikacij v operacijskem sistemu Windows.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673860555401888)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Ni mogo\010De povezati</h1>'),
'    <p>Za uporabo te aplikacije potrebujete internetno povezavo.</p>',
'    <button type="button">Poskusi znova</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673729365401888)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De povezati')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813588336401994)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'sl'
,p_message_text=>'Dodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757951243401952)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'sl'
,p_message_text=>'Ves dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836818342402012)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji vabilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836697649402012)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enosti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759726497401953)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'sl'
,p_message_text=>'Dnevni pogled za ves dan '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759530688401953)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'sl'
,p_message_text=>unistr('Dnevni pogled za podatke s \010Dasom ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804488275401987)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'sl'
,p_message_text=>'Dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798867177401983)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'sl'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689456190401899)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'sl'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689273058401899)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'sl'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689150592401899)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'sl'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689386372401899)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'sl'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688854412401899)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'sl'
,p_message_text=>'Datum konca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689087237401899)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'sl'
,p_message_text=>'Ime dogodka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836742705402012)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'sl'
,p_message_text=>'Vabilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804585955401988)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'sl'
,p_message_text=>'Seznam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804219265401987)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'sl'
,p_message_text=>'Mesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807031007401989)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821355222402000)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'sl'
,p_message_text=>'Ni dogodkov'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837074858402012)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'sl'
,p_message_text=>unistr('Uredite obstoje\010Di dogodek.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836936018402012)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161ljite vabilo prek e-po\0161te.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807103004401989)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815100927401995)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji e-po\0161to')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814903349401995)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji e-po\0161to')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837743152402012)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Zahtevana so vsa polja.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837625234402012)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji vabilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836512242402012)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'sl'
,p_message_text=>'Zadeva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815070730401995)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'sl'
,p_message_text=>'Za'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688908332401899)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'sl'
,p_message_text=>unistr('Datum za\010Detka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812827717401994)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'sl'
,p_message_text=>'Obrazec na %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759369518401953)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Cas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807220152401990)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'sl'
,p_message_text=>'Danes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805003114401988)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804346655401987)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'sl'
,p_message_text=>'Teden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759609559401953)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'sl'
,p_message_text=>'Tedenski pogled za ves dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759444217401953)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'sl'
,p_message_text=>unistr('Tedenski pogled za podatke s \010Dasom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804951498401988)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'sl'
,p_message_text=>'Leto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804625620401988)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Stolpci ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804791709401988)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalo\017Ei ve\010D ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736813840401935)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683107107401894)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalo\017Ei ve\010D ...')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685280265401896)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'sl'
,p_message_text=>unistr('I\0161\010Di ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114804817240401988)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalo\017Ei ve\010D ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806907162401989)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('ID podro\010Dja %0 ni najden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685153080401896)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'sl'
,p_message_text=>'Najdeni niso bili nobeni podatki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709275413401914)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De ponastaviti \0161tevil\010Denja strani podro\010Dja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677492348401890)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri nastavljanju \0161tevil\010Denja strani podro\010Dja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798218261401983)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Stolpci ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806843568401989)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'sl'
,p_message_text=>unistr('Tip podro\010Dja %0 ni podprt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677357428401890)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka med upodabljanjem podro\010Dja "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741800290401939)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'#COLUMN_HEADER# mora imeti neko vrednost.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836148980402011)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'sl'
,p_message_text=>'%0, urejevalnik obogatenega besedila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743977030401941)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Devanje HTML obogatenega besedila presega maksimalno dol\017Eino elementa (dejansko \0161tevilo znakov je %0, dovoljenih je toliko znakov: %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803800496401987)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbri\0161i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795673481401981)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'sl'
,p_message_text=>'Podvoji'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793956771401979)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'sl'
,p_message_text=>'Prikazani stolpci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793836094401979)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Izklju\010Di vrednosti NULL')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803902062401987)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'sl'
,p_message_text=>'Dodaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757558069401951)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'sl'
,p_message_text=>'Premik navzdol'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757678473401951)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'sl'
,p_message_text=>'Premik navzgor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793666787401979)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794261283401980)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Drugi stolpci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793769433401979)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794057773401979)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'sl'
,p_message_text=>'Vrstica %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794172796401979)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'sl'
,p_message_text=>'Vrstica %0 od %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795757556401981)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'sl'
,p_message_text=>unistr('Osve\017Ei')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795851421401981)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'sl'
,p_message_text=>'Povrni spremembe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114793520918401979)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'sl'
,p_message_text=>'Meni z nastavitvami'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754599342401949)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'sl'
,p_message_text=>'Na primer %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662075474401879)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'sl'
,p_message_text=>'Ponovni vpis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661943733401879)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161a seja se je kon\010Dala')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662181122401879)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iritev')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661769005401879)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161a seja bo kon\010Dana ob %0. Ali jo \017Eelite podalj\0161ati?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661857636401879)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161a seja se bo kon\010Dala ob %0 in je ni mogo\010De podalj\0161ati. Shranite vse delo zdaj, da ne izgubite podatkov')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814727955401995)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri obdelavi kode za \010Di\0161\010Denje seje baze podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707823569401913)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi kode za nastavitev seje baze podatkov.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114681944909401894)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161a seja se je kon\010Dala')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813656557401994)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'sl'
,p_message_text=>'Zaprite to pogovorno okno in pritisnite gumb za ponovno nalaganje v brskalniku, da pridobite novo sejo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832909160402009)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'sl'
,p_message_text=>'Kliknite <a href="%0">tukaj</a> za ustvarjanje nove seje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719544324401922)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'sl'
,p_message_text=>'Seja ni veljavna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759028135401952)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'sl'
,p_message_text=>unistr('V seji Real Application Security ni bilo mogo\010De omogo\010Diti nobene dinami\010Dne vloge za uporabnika "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705737685401911)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-99900 Ni bilo mogo\010De ustvariti enoli\010Dnega ID-ja seje: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722082868401924)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Kr\0161itev za\0161\010Dite stanja seje: Vzrok za to je lahko ro\010Dno spreminjanje za\0161\010Ditenega elementa strani %0. \010Ce niste prepri\010Dani, kaj je povzro\010Dilo to napako, se za pomo\010D obrnite na skrbnika aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841105701402015)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Kr\0161itev za\0161\010Dite strani: Vzrok za to je lahko po\0161iljanje strani, ki se \0161e ni nalo\017Eila do konca, ali ro\010Dno spreminjanje za\0161\010Ditenih elementov strani. Za nadaljnjo pomo\010D se obrnite na skrbnika aplikacije.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840175962402014)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'sl'
,p_message_text=>'%0 vsebuje enega izmed naslednjih neveljavnih znakov &<>"/;,*|=% ali --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840234867402014)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'sl'
,p_message_text=>'%0 vsebuje enega izmed naslednjih neveljavnih znakov &<>"/;,*|=% ali -- ali novo vrstico.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839940560402014)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'sl'
,p_message_text=>'%0 vsebuje posebne znake. Dovoljeni so le znaki a-Z, 0-9 in presledki.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114840017869402014)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sl'
,p_message_text=>'%0 vsebuje <, > ali ", kar so neveljavni znaki.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684110527401895)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'sl'
,p_message_text=>unistr('Nobena kontrolna vsota ni bila navedena za prikaz obdelave za stran, ki zahteva kontrolno vsoto, kadar so kot parametri podani ena ali ve\010D zahtev, \010Di\0161\010Denje predpomnilnika ali vrednosti argumentov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716982091401920)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Kr\0161itev za\0161\010Dite stanja seje: Vzrok za to je lahko ro\010Dno spreminjanje URL-ja, ki vsebuje kontrolno vsoto, ali uporaba povezave z nepravilno ali manjkajo\010Do kontrolno vsoto. \010Ce niste prepri\010Dani, kaj je povzro\010Dilo to napako, se za pomo\010D obrnite na skrbni')
||'ka aplikacije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114794914124401980)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'sl'
,p_message_text=>unistr('Izklop na\010Dina visokega kontrasta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795051936401980)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'sl'
,p_message_text=>unistr('Vklop na\010Dina visokega kontrasta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713647541401917)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'sl'
,p_message_text=>'Spodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713861055401917)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'sl'
,p_message_text=>'Dol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713918698401917)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'sl'
,p_message_text=>'Premik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714086864401918)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'sl'
,p_message_text=>'Premakni vse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714117149401918)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'sl'
,p_message_text=>'Odstrani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714210446401918)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'sl'
,p_message_text=>'Odstrani vse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714350503401918)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'sl'
,p_message_text=>'Ponastavi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713504458401917)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'sl'
,p_message_text=>'Zgoraj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713748494401917)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'sl'
,p_message_text=>'Gor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822624551402001)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823354434402002)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko dneh: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822584886402001)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823469708402002)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko urah: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822396836402001)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823535212402002)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko minutah: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822989808402001)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823198626402001)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko mesecih: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822472625402001)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823285668402001)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko sekundah: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822752914402001)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823678422402002)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko tednih: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822871294402001)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'sl'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114823046925402001)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'v toliko letih: %'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662953763401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'sl'
,p_message_text=>unistr('[\010Crta]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663308820401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'sl'
,p_message_text=>unistr('[Ve\010D \010Drt]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663198291401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'sl'
,p_message_text=>unistr('[Ve\010D to\010Dk]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663542567401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'sl'
,p_message_text=>unistr('[Ve\010D poligonov]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663674794401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'sl'
,p_message_text=>'[Geometrijski objekt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662818759401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'sl'
,p_message_text=>unistr('[To\010Dka (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663066846401880)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'sl'
,p_message_text=>'[Poligon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740298260401938)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'sl'
,p_message_text=>'Strni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740169052401938)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'sl'
,p_message_text=>'Obnovi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786612139401974)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Disti oceno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776562069401966)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v veljavnem razponu ocenjevanja 1 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776616316401966)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 ni \0161tevilska vrednost')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772753481401963)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'sl'
,p_message_text=>unistr('Sporo\010Dilo o uspehu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835817250402011)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835719387402011)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821437033402000)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'sl'
,p_message_text=>'Orodna vrstica'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836212210402011)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iri/strni krmarjenje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836394775402011)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iri/strni stranski stolpec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745996600401942)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Glavno krmarjenje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752946557401948)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'sl'
,p_message_text=>'1 dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752721489401948)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'sl'
,p_message_text=>'1 ura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753027396401948)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'sl'
,p_message_text=>'%0 (dnevi)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752828077401948)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'sl'
,p_message_text=>'%0 (ure)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752631398401948)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'sl'
,p_message_text=>'%0 (minute)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753252521401948)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'sl'
,p_message_text=>'%0 (tedni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114753161726401948)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'sl'
,p_message_text=>'1 teden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839459359402014)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'sl'
,p_message_text=>unistr('Za\010Detek strani')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701484546401908)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Omogo\010Deno')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675298331401889)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri obdelavi zahteve.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754681012401949)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Zahtevana je vrednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837543238402012)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\010Dakajte, da se stran v celoti nalo\017Ei, in poskusite znova.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797727518401982)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'sl'
,p_message_text=>'Ta stran ima neshranjene spremembe.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678634344401891)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'sl'
,p_message_text=>'Delovni zvezek nima nobenega aktivnega delovnega lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678586229401891)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'sl'
,p_message_text=>'Delovni zvezek ni inicializiran.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678497345401891)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Pri ustvarjanju datoteke XLSX je pri\0161lo do notranje napake.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680946699401893)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'sl'
,p_message_text=>'List'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812613747401994)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'sl'
,p_message_text=>'Dejanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730193953401930)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'sl'
,p_message_text=>'Meni Dejanja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725805363401926)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>'Doda funkcijo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725701636401926)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Dodaj stolpec Grupiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759951067401953)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Dodaj vrtilni stolpec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760060432401953)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Dodaj stolpec vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700205081401907)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'sl'
,p_message_text=>unistr('Zdru\017Eevanje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736389266401935)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Zdru\017Eevanje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717490406401920)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'sl'
,p_message_text=>unistr('Povpre\010Dje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721770669401923)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717517205401920)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'sl'
,p_message_text=>'Maksimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717798208401920)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'sl'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717635520401920)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'sl'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717372628401920)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'sl'
,p_message_text=>'Vsota %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718477699401921)
,p_name=>'APEXIR_ALL'
,p_message_language=>'sl'
,p_message_text=>'Vse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699563463401907)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Vsi stolpci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682017848401894)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'sl'
,p_message_text=>'Vse vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809649538401991)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'sl'
,p_message_text=>'Nadomestno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811240992401993)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'sl'
,p_message_text=>'Nadomestno privzeto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712182967401916)
,p_name=>'APEXIR_AND'
,p_message_language=>'sl'
,p_message_text=>'in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701609878401908)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'sl'
,p_message_text=>'Dodeli'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695318083401903)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Nara\0161\010Dajo\010De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714900141401918)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'sl'
,p_message_text=>'Z dne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811827102401993)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'sl'
,p_message_text=>unistr('Povpre\010Dje %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803236301401987)
,p_name=>'APEXIR_BAR'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701035659401908)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'sl'
,p_message_text=>'med'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694149260401903)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'sl'
,p_message_text=>'Barva ozadja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696046984401904)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'sl'
,p_message_text=>'modra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727746657401928)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'sl'
,p_message_text=>'Spodaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696678618401904)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Prekli\010Di')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702580856401909)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'sl'
,p_message_text=>'Kategorija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694085525401903)
,p_name=>'APEXIR_CELL'
,p_message_language=>'sl'
,p_message_text=>'Celica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718346509401921)
,p_name=>'APEXIR_CHART'
,p_message_language=>'sl'
,p_message_text=>'Grafikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728620913401929)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'sl'
,p_message_text=>'Inicializiranje ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114764962373401957)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Dolo\010Diti je treba oznako grafikona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777394679401966)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161a poizvedba presega maksimalno \0161tevilo podatkovnih to\010Dk %0 na grafikon. Uporabite filter, da zmanj\0161ate \0161tevilo zapisov v osnovni poizvedbi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776201387401966)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Maksimalno \0161tevilo vrstic za poizvedbo grafikonov omeji \0161tevilo vrstic v osnovni poizvedbi in ne \0161tevila prikazanih vrstic. '),
unistr('Va\0161a osnovna poizvedba presega maksimalno \0161tevilo vrstic, ki je %0. Uporabite filter, da zmanj\0161ate \0161tevilo zapisov v osnovni poizvedbi.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699603843401907)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Tip grafikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114772912837401963)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Di vse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715321268401918)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbira formata poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722787486401924)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'sl'
,p_message_text=>unistr('po\010Disti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696550931401904)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Stolpec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733925429401933)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Stolpci'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806219400401989)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Filtriranje ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724787194401926)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'sl'
,p_message_text=>'Meni naslova stolpca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728485834401928)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'sl'
,p_message_text=>'Informacije o stolpcu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808565700401991)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Oznaka stolpca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726176153401927)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'sl'
,p_message_text=>'Stolpec %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710275002401915)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'sl'
,p_message_text=>'vsebuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711120274401915)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'sl'
,p_message_text=>'ne vsebuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695098290401903)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'sl'
,p_message_text=>'v'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711328131401916)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'sl'
,p_message_text=>'ni v zadnjih'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719896628401922)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'sl'
,p_message_text=>'ni v naslednjem'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711258019401915)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'sl'
,p_message_text=>'je v zadnjih'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719722525401922)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'sl'
,p_message_text=>'je v naslednjem'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694974519401903)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>'ni NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694836441401903)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'sl'
,p_message_text=>'je NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694680352401903)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'sl'
,p_message_text=>'kot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695164584401903)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'sl'
,p_message_text=>'ni v'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694772210401903)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'sl'
,p_message_text=>'ni kot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710564999401915)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'sl'
,p_message_text=>'se ujema z regularnim izrazom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715234390401918)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Izra\010Dun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114775996156401965)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'sl'
,p_message_text=>unistr('Izraz izra\010Duna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734258222401933)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'sl'
,p_message_text=>unistr('Ustvarjanje izra\010Duna z drugimi imeni stolpcev.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734335974401933)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'sl'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734495629401933)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'sl'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734568458401933)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'sl'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680484515401892)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'sl'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719180002401921)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'sl'
,p_message_text=>unistr('Izra\010Dun')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726721117401927)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'sl'
,p_message_text=>'Kontrolni prelom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729737949401929)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'sl'
,p_message_text=>'Kontrolni prelomi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814188326401995)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Kontrolni prelomni stolpci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677585109401890)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo razli\010Dnih')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812355234401993)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo razli\010Dnih')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812261740401993)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784305288401972)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'sl'
,p_message_text=>'Dnevno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839008068402013)
,p_name=>'APEXIR_DATA'
,p_message_language=>'sl'
,p_message_text=>'Podatki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728530914401929)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatki poro\010Dila pred toliko minutami: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802048927401986)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatkovna mre\017Ea - Pomo\010D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700330997401907)
,p_name=>'APEXIR_DATE'
,p_message_language=>'sl'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732421983401932)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Privzeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809453661401991)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'sl'
,p_message_text=>unistr('Privzeti tip poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696731257401905)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbri\0161i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700658076401907)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'sl'
,p_message_text=>unistr('\017Delite izbrisati te nastavitve poro\010Dila?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795327253401980)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbri\0161i privzeto poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726470454401927)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Brisanje poro\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695494767401904)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Padajo\010De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702619053401909)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'sl'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724695241401926)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'sl'
,p_message_text=>'Pogled ene vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732922509401932)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'sl'
,p_message_text=>'Smer %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733830642401933)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Onemogo\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696208230401904)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'sl'
,p_message_text=>'Prikazano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699439342401907)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Prikazani stolpci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732858164401932)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Prika\017Ei v poro\010Dilu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727622339401928)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'sl'
,p_message_text=>'Dol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719265569401921)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'sl'
,p_message_text=>'Prenos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732738419401932)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'sl'
,p_message_text=>unistr('Ne prika\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798797564401983)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Dba z istim pogojem \017Ee obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814360780401995)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Podvojen vrtilni stolpec. Seznam vrtilnih stolpcev mora biti enoli\010Den.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814525691401995)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'sl'
,p_message_text=>'Uredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728704069401929)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'sl'
,p_message_text=>'Uredi nastavitve grafikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735397347401934)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'sl'
,p_message_text=>'Uredi grafikon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735727951401934)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Uredi filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790182991401976)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>'Uredi grupiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735623960401934)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'sl'
,p_message_text=>unistr('Uredi ozna\010Dbo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760287053401953)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'sl'
,p_message_text=>'Uredi vrtenje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809720516401991)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688474732401898)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161tni naslov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810031804401992)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'sl'
,p_message_text=>'Skp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810276620401992)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'sl'
,p_message_text=>'Telo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809986119401992)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'sl'
,p_message_text=>'Kp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810711044401992)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'sl'
,p_message_text=>'Pogostost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692180298401901)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161ta ni bila konfigurirana za to aplikacijo. Obrnite se na svojega skrbnika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783695812401971)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161tni naslov mora biti naveden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810371451401992)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'sl'
,p_message_text=>'Glejte prilogo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810196680401992)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'sl'
,p_message_text=>'Zadeva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784610408401972)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Zadeva e-po\0161tnega sporo\010Dila mora biti navedena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809847845401991)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'sl'
,p_message_text=>'Za'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693878246401902)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Omogo\010Deno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735551391401934)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'sl'
,p_message_text=>unistr('Omogo\010Di/onemogo\010Di')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735023817401934)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734669370401933)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'sl'
,p_message_text=>'Primeri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735452044401934)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'sl'
,p_message_text=>'Primeri:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699327229401906)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Izklju\010Di vrednosti NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736051883401935)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iri/strni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733690513401932)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'sl'
,p_message_text=>'Izraz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718783340401921)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729600054401929)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'sl'
,p_message_text=>'Filtri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739923738401938)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'sl'
,p_message_text=>'Izraz filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836455800402011)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'sl'
,p_message_text=>'Izraz filtra je predolg.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739894121401938)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Tip filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736295972401935)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'sl'
,p_message_text=>'Izbira stolpcev za iskanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719041711401921)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'sl'
,p_message_text=>'Pogled nazaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733404136401932)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Poizvedba pogleda nazaj vam omogo\010Da ogled podatkov, kot so obstajali na predhodni to\010Dki v \010Dasu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784014111401972)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Trajanje pogleda nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785490178401973)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'sl'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715121678401918)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'sl'
,p_message_text=>'Maska formata %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726386070401927)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>'Funkcija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734132606401933)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'sl'
,p_message_text=>'Funkcije %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809330489401991)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'sl'
,p_message_text=>'Funkcije/operatorji'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726099175401927)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'sl'
,p_message_text=>'Funkcija %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718500981401921)
,p_name=>'APEXIR_GO'
,p_message_language=>'sl'
,p_message_text=>'Pojdi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694306295401903)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'sl'
,p_message_text=>'zelena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114677667457401890)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>'Grupiranje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810429390401992)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Stolpec Grupiranje %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765047959401957)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Dolo\010Diti je treba stolpec Grupiranje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776142085401966)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'sl'
,p_message_text=>unistr('Maksimalno \0161tevilo vrstic za poizvedbo Grupiranje omeji \0161tevilo vrstic v osnovni poizvedbi in ne \0161tevila prikazanih vrstic. Va\0161a osnovna poizvedba presega maksimalno \0161tevilo vrstic %0. Uporabite filter, da zmanj\0161ate \0161tevilo zapisov v osnovni poizvedb')
||'i.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756733995401951)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvr\0161\010Danje grupiranja')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814290681401995)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrstni red razvr\0161\010Danja grupiranja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699733884401907)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'sl'
,p_message_text=>'Vodoravni stolpec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731333906401931)
,p_name=>'APEXIR_HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Pomo\010D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723113587401924)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interaktivna poro\010Dila kon\010Dnim uporabnikom omogo\010Dajo prilagajanje poro\010Dil. Uporabniki lahko spremenijo postavitev podatkov poro\010Dila z izbiranjem stolpcev, uporabo filtrov, ozna\010Devanjem in razvr\0161\010Danjem. Uporabniki lahko tudi dolo\010Dijo prelome, zdru\017Eevan')
||unistr('ja, grafikone, grupiranja in dodajajo lastne izra\010Dune. Uporabniki lahko tudi nastavijo naro\010Dnino tako, da jim bo verzija HTML poro\010Dila poslana po e-po\0161ti v skladu z dolo\010Denim intervalom. Uporabniki lahko ustvarijo ve\010D variacij poro\010Dila in jih shranij')
||unistr('o kot imenovana poro\010Dila, bodisi za javni bodisi zasebni ogled. '),
'<p/>',
unistr('Naslednji razdelki povzemajo na\010Dine, kako lahko prilagodite interaktivno poro\010Dilo. Za ve\010D informacij si oglejte "Uporaba interaktivnih poro\010Dil" v <i>Uporabni\0161kem priro\010Dniku za kon\010Dne uporabnike Oracle Application Express</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730221072401930)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'sl'
,p_message_text=>unistr('Meni Dejanja se prika\017Ee na desni strani gumba Pojdi v vrstici za iskanje. V tem meniju lahko prilagodite interaktivno poro\010Dilo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723909895401925)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zdru\017Eevanja so matemati\010Dni izra\010Duni, ki se izvedejo za stolpec. Zdru\017Eevanja so prikazana po vsakem kontrolnem prelomu in ob koncu poro\010Dila v stolpcu, v katerem so dolo\010Dena. Mo\017Enosti vklju\010Dujejo:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Zdru\017Eevanje</strong> vam omogo\010Da, da izberete predhodno'),
unistr('dolo\010Deno zdru\017Eevanje za urejanje.</li>'),
'<li><strong>Funkcija</strong> je funkcija, ki se izvede (na primer SUM, MIN).</li>',
unistr('<li><strong>Stolpec</strong> se uporablja za izbiro stolpca, za katerega se uporabi matemati\010Dna funkcija. Prikazani so'),
unistr('samo \0161tevilski stolpci.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724027649401925)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dolo\010Dite lahko en grafikon na shranjeno poro\010Dilo. Ko'),
unistr('je dolo\010Den, lahko preklapljate med pogledom grafikona in poro\010Dila z uporabo ikon v vrstici za iskanje.'),
unistr('Mo\017Enosti vklju\010Dujejo:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Tip grafikona</strong> identificira tip grafikona, ki bo vklju\010Den.'),
unistr('Izberite horizontalni pali\010Dni, vertikalni pali\010Dni, tortni ali \010Drtni.</li>'),
unistr('<li><strong>Oznaka</strong> vam omogo\010Da, da izberete stolpec, ki bo uporabljen kot oznaka.</li>'),
'<li><strong>Naslov osi za oznako</strong> je naslov, ki je prikazan na osi, povezani s stolpcem, izbranim za',
'oznako. To ni na voljo za tortni grafikon.</li>',
unistr('<li><strong>Vrednost</strong> vam omogo\010Da, da izberete stolpec, ki bo uporabljen kot vrednost.  \010Ce je va\0161a funkcija'),
'COUNT, vrednosti ni treba izbrati.</li>',
'<li><strong>Naslov osi za vrednost</strong> je naslov, ki je prikazan na osi, povezani s stolpcem, izbranim za',
'vrednost. To ni na voljo za tortni grafikon.</li>',
'<li><strong>Funkcija</strong> je izbirna funkcija, ki jo je treba izvesti za stolpec, izbran za vrednost.</li>',
unistr('<li><strong>Razvr\0161\010Danje</strong> vam omogo\010Da, da razvrstite svoj nabor rezultatov.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723335311401925)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\010Ce kliknete katerikoli naslov stolpca, se prika\017Ee meni naslova stolpca. Mo\017Enosti vklju\010Dujejo:'),
'<p></p>',
'<ul>',
unistr('<li>Ikona <strong>Razvrsti nara\0161\010Dajo\010De</strong> razvrsti poro\010Dilo po stolpcu v nara\0161\010Dajo\010Dem vrstnem redu.</li>'),
unistr('<li>Ikona <strong>Razvrsti padajo\010De</strong> razvrsti poro\010Dilo po stolpcu v padajo\010Dem vrstnem redu.</li>'),
unistr('<li><strong>Skrij stolpec</strong> skrije stolpec. Vseh stolpcev ni mogo\010De skriti. \010Ce stolpca ni mogo\010De skriti, ikona Skrij stolpec ne bo prikazana.</li>'),
unistr('<li><strong>Prelomi stolpec</strong> ustvari skupino za prelom v stolpcu. To stolpec povle\010De iz poro\010Dila kot glavni zapis.</li>'),
unistr('<li><strong>Informacije o stolpcu</strong> prikazuje besedilo pomo\010Di o stolpcu, \010De je na voljo.</li>'),
unistr('<li><strong>Obmo\010Dje besedila</strong> se uporablja za vnos iskalnih kriterijev brez razlikovanja velikih in malih \010Drk'),
unistr('(brez potrebe po nadomestnih znakih). Z vnosom vrednosti se zmanj\0161a seznam'),
'vrednosti na dnu menija. Nato lahko izberete vrednost z',
'dna in izbrana vrednost bo ustvarjena kot filter, ki uporablja "="',
'(na primer <code>column = ''ABC''</code>). Lahko pa tudi kliknete ikono svetilke in vnesete vrednost, ki bo ustvarjena kot filter z modifikatorjem "LIKE"',
'(na primer <code>column LIKE ''%ABC%''</code>).</li>',
unistr('<li><b>Seznam enoli\010Dnih vrednosti</b> vsebuje prvih 500 enoli\010Dnih'),
unistr('vrednosti, ki izpolnjujejo va\0161e kriterije filtriranja. \010Ce je stolpec datum, je namesto tega prikazan'),
unistr('seznam datumskih razponov. \010Ce izberete vrednost, bo filter ustvarjen'),
'z "=" (na primer <code>column = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723893402401925)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Omogo\010Da vam dodajanje izra\010Dunanih stolpcev v poro\010Dilo. Lahko so matemati\010Dni izra\010Duni (na primer <code>NBR_HOURS/24</code>) ali standardne Oraclove'),
unistr('funkcije, uporabljene na obstoje\010Dih stolpcih. Nekateri so prikazani kot primeri, mogo\010De pa je uporabiti tudi druge (kot je <code>TO_DATE)</code>). Mo\017Enosti vklju\010Dujejo:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Izra\010Dun</strong> vam omogo\010Da izbiro predhodno dolo\010Denega izra\010Duna za urejanje.</li>'),
'<li><strong>Naslov stolpca</strong> je naslov stolpca za novi stolpec.</li>',
'<li><strong>Maska formata</strong> je Oraclova maska formata, ki se uporabi za stolpec (na primer S9999).</li>',
unistr('<li><strong>Izra\010Dun</strong> je izra\010Dun, ki se izvede. V izra\010Dune se vklju\010Dijo sklici na stolpce s prikazanimi drugimi imeni.</li>'),
'</ul>',
unistr('<p>Pod izra\010Dunom se stolpci v va\0161i poizvedbi prika\017Eejo s'),
unistr('svojimi povezanimi drugimi imeni. \010Ce kliknete ime ali drugo ime stolpca, bo ta vklju\010Den'),
unistr('v izra\010Dun. Ob stolpcu je \0161tevilska tipkovnica. Ta tipkovnica deluje kot'),
unistr('bli\017Enjica do pogosto uporabljanih klju\010Dev. Na skrajni desni so funkcije.</p>'),
unistr('<p>Naslednji primer izra\010Duna prikazuje, kako prikazati skupno nadomestilo:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(A je ORGANIZATION, B je SALARY in C je COMMISSION)</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730365986401930)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporablja se za ustvarjanje prelomne skupine v enem ali ve\010D stolpcih. Na ta na\010Din se stolpci izvle\010Dejo iz interaktivnega poro\010Dila in prika\017Eejo kot glavni zapis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724516927401925)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'sl'
,p_message_text=>unistr('Za ogled podrobnosti ene vrstice naenkrat kliknite ikono za ogled ene vrstice za vrstico, ki si jo \017Eelite ogledati. \010Ce je na voljo, bo pogled ene vrstice vedno prvi stolpec. Odvisno od prilagoditve interaktivnega poro\010Dila je lahko pogled ene vrstice ')
||unistr('standardni pogled ali prilagojena stran, ki lahko omogo\010Da posodobitev.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724479155401925)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Omogo\010Da prenos trenutnega nabora rezultatov. Formati za prenos'),
unistr('se razlikujejo glede na va\0161o namestitev in definicijo poro\010Dila, vendar'),
unistr('lahko vklju\010Dujejo CSV, HTML, e-po\0161tno sporo\010Dilo, XLS, PDF ali RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723547511401925)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Osredoto\010Di poro\010Dilo tako, da doda ali spremeni stavek <code>WHERE</code> v poizvedbi. Filtrirate lahko v stolpcu ali po vrstici.  '),
unistr('<p>\010Ce filtrirate po stolpcu, izberite stolpec (ni treba, da je eden od prikazanih), izberite standardni Oraclov operator (=, !=, not in, between) in vnesite izraz za primerjavo. Izrazi razlikujejo med velikimi in malimi \010Drkami. Uporabite % kot nadome')
||'stni znak (na primer <code>STATE_NAME',
'like A%)</code>.</p>',
unistr('<p>\010Ce filtrirate po vrsticah, lahko ustvarite zapletene stavke <code>WHERE</code> z'),
unistr('drugimi imeni stolpcev in vsemi Oraclovimi funkcijami ali operatorji (na primer <code>G = ''VA'' or G = ''CT''</code>, pri \010Demer'),
'je <code>G</code> drugo ime za <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724162250401925)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Poizvedba pogleda nazaj vam omogo\010Da, da si ogledate podatke, kot so obstajali na predhodni to\010Dki'),
unistr('v \010Dasu. Privzeta koli\010Dina \010Dasa za pogled nazaj je 3 ure (ali 180'),
unistr('minut), vendar dejanska koli\010Dina se razlikuje za vsako bazo podatkov.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785345210401973)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Format vam omogo\010Da prilagoditev prikaza poro\010Dila.'),
'Format vsebuje naslednji podmeni:</p>',
unistr('<ul><li>Razvr\0161\010Danje</li>'),
'<li>Kontrolni prelom</li>',
unistr('<li>Ozna\010Dba</li>'),
unistr('<li>Izra\010Dun</li>'),
unistr('<li>Zdru\017Eevanje</li>'),
'<li>Grafikon</li>',
'<li>Grupiranje</li>',
'<li>Vrtenje</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783550540401971)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dolo\010Dite lahko en pogled grupiranja na shranjeno poro\010Dilo. Ko je dolo\010Den, lahko preklapljate med pogledom grupiranja in pogledom poro\010Dila z ikonami pogleda v vrstici za iskanje. \010Ce \017Eelite ustvariti pogled grupiranja, izberite: '),
'<p></p><ul>',
'<li>stolpce za grupiranje</li>',
unistr('<li>stolpce za zdru\017Eevanje s funkcijo, ki bo izvedena (povpre\010Dje, vsota, \0161tevilo, itd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723701718401925)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Omogo\010Da vam dolo\010Ditev filtra. Vrstice, ki se ujemajo s kriteriji filtriranja, se prika\017Eejo kot ozna\010Dene z zna\010Dilnostmi, povezanimi s filtrom. Mo\017Enosti vklju\010Dujejo:</p>'),
'<ul>',
'<li><strong>Ime</strong> se uporablja samo za prikaz.</li>',
'<li><strong>Zaporedje</strong> identificira zaporedje, po katerem se ocenjujejo pravila.</li>',
unistr('<li><strong>Omogo\010Deno</strong> identificira, ali je pravilo omogo\010Deno ali onemogo\010Deno.</li>'),
unistr('<li><strong>Tip ozna\010Dbe</strong> identificira, ali je treba vrstico ali celico'),
unistr('ozna\010Diti. \010Ce izberete celico, se ozna\010Di stolpec, naveden'),
unistr('v pogoju ozna\010Dbe.</li>'),
unistr('<li><strong>Barva ozadja</strong> je nova barva za ozadje ozna\010Denega obmo\010Dja.</li>'),
unistr('<li><strong>Barva besedila</strong> je nova barva za besedilo v ozna\010Denem obmo\010Dju.</li>'),
unistr('<li><strong>Pogoj ozna\010Dbe</strong> dolo\010Da va\0161 pogoj filtriranja.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661342262401878)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Dolo\010Dite lahko en vrtilni pogled na shranjeno poro\010Dilo. Ko je dolo\010Den, lahko preklapljate med vrtilnim pogledom in pogledom poro\010Dila z ikonami pogleda v vrstici za iskanje. \010Ce \017Eelite ustvariti vrtilni pogled, izberite: '),
'<p></p>',
'<ul>',
'<li>stolpce za vrtenje</li>',
'<li>stolpce za prikaz v obliki vrstic</li>',
unistr('<li>stolpce za zdru\017Eevanje in funkcijo, ki bo izvedena (povpre\010Dje, vsota, \0161tevilo, itd.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734848914401933)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pri prilagajanju interaktivnega poro\010Dila so nastavitve poro\010Dila prikazane'),
unistr('pod vrstico za iskanje in nad poro\010Dilom. To obmo\010Dje lahko strnete in raz\0161irite z ikono na levi.'),
'<p>',
unistr('Za vsako nastavitev poro\010Dila lahko uporabite naslednje mo\017Enosti:'),
'</p><ul>',
'<li>Uredite nastavitev tako, da kliknete ime.</li>',
unistr('<li>Onemogo\010Dite/omogo\010Dite nastavitev tako, da ozna\010Dite/po\010Distite potrditveno polje Omogo\010Di/Onemogo\010Di. S tem kontrolnim elementom lahko za\010Dasno izklopite in vklopite nastavitev.</li>'),
'<li>Odstranite nastavitev tako, da kliknete ikono Odstrani.</li>',
'</ul>',
unistr('<p>\010Ce ste ustvarili grafikon, grupiranje ali vrtenje, lahko preklapljate med njimi '),
unistr('in osnovnim poro\010Dilom z uporabo povezav Pogled poro\010Dila, Pogled grafikona, Pogled grupiranja in Vrtilni pogled,'),
'prikazanimi na desni. Pri ogledu grafikona, grupiranja ali vrtenja lahko',
'uporabite tudi povezavo Uredi in uredite nastavitve.</p>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724380640401925)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'sl'
,p_message_text=>unistr('Ponastavi poro\010Dilo nazaj na privzete nastavitve, pri \010Demer se odstranijo vse izvedene prilagoditve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785628632401973)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nastavi \0161tevilo zapisov za prikaz na stran.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724225222401925)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Shrani prilagojeno poro\010Dilo za prihodnjo uporabo. Navedete ime in izbirni opis ter zagotovite, da je poro\010Dilo dostopno javnosti (tj. vsem uporabnikom, ki lahko dostopajo do primarnega privzetega poro\010Dila). Shranite lahko \0161tiri tipe interaktivnih p')
||unistr('oro\010Dil:</p>'),
'<ul>',
unistr('<li><strong>Primarno privzeto</strong> (samo za razvijalce). Primarno privzeto je poro\010Dilo, ki se prika\017Ee na za\010Detku. Primarnih privzetih poro\010Dil ni mogo\010De preimenovati ali izbrisati.</li>'),
unistr('<li><strong>Nadomestno poro\010Dilo</strong> (samo za razvijalce). Razvijalcem omogo\010Da ustvarjanje ve\010D postavitev poro\010Dil. Samo razvijalci lahko shranijo, preimenujejo ali izbri\0161ejo nadomestno poro\010Dilo.</li>'),
unistr('<li><strong>Javno poro\010Dilo</strong> (kon\010Dni uporabnik). Shrani, preimenuje ali izbri\0161e ga lahko kon\010Dni uporabnik, ki ga je ustvaril. Drugi uporabniki si lahko ogledajo in shranijo postavitev kot drugo poro\010Dilo.</li>'),
unistr('<li><strong>Zasebno poro\010Dilo</strong> (kon\010Dni uporabnik). Samo kon\010Dni uporabnik, ki je ustvaril poro\010Dilo, si lahko ogleda, shrani, preimenuje ali izbri\0161e poro\010Dilo.</li>'),
'</ul>',
unistr('<p>\010Ce shranite prilagojena poro\010Dila, se prika\017Ee izbirnik poro\010Dil v vrstici za iskanje na levi strani izbirnika vrstic (\010De je ta funkcija omogo\010Dena).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723263515401924)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'sl'
,p_message_text=>unistr('Na vrhu vsake strani poro\010Dila je podro\010Dje za iskanje. To podro\010Dje (ali vrstica za iskanje) zagotavlja naslednje funkcije:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786225783401973)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'sl'
,p_message_text=>unistr('<li><strong>Meni Dejanja</strong> omogo\010Da prilagoditev poro\010Dila. Oglejte si odseke, ki sledijo.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785746411401973)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'sl'
,p_message_text=>unistr('<li><strong>Ikona za izbiro stolpcev</strong> vam omogo\010Da identifikacijo stolpca za iskanje (ali vseh).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786013346401973)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'sl'
,p_message_text=>unistr('<li><strong>Poro\010Dila</strong> prika\017Ee nadomestna privzeta in shranjena zasebna ali javna poro\010Dila.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785901392401973)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'sl'
,p_message_text=>unistr('<li><strong>Vrstice</strong> nastavi \0161tevilo zapisov za prikaz na stran.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785886992401973)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Besedilno obmo\010Dje</strong> vam omogo\010Da vnos kriterijev iskanja brez razlikovanja med velikimi in malimi \010Drkami (nadomestni znaki so nakazani).</li>'),
unistr('<li><strong>Gumb Pojdi</strong> izvede iskanje. Ko je kazalec v besedilnem obmo\010Dju za iskanje, lahko iskanje izvedete tudi s pritiskom tipke Enter.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786133288401973)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'sl'
,p_message_text=>unistr('<li><strong>Ogled ikon</strong> omogo\010Da preklop med pogledi ikon, poro\010Dil, podrobnosti, grafikonov, grupiranj in vrtenji poro\010Dila, \010De so dolo\010Deni.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802165593401986)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'sl'
,p_message_text=>unistr('<li><strong>Upravljanje</strong> omogo\010Da upravljanje lastnosti, stolpcev in vrstic ter ogled zgodovine za poro\010Dilo ali podatkovno mre\017Eo.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723448800401925)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporablja se za spreminjanje prikazanih stolpcev. Stolpci na desni so prikazani. Stolpci na levi so skriti. Prikazane stolpce lahko ponovno razvrstite s pu\0161\010Dicami na skrajni desni. Izra\010Dunani stolpci imajo predpono <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723684218401925)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Uporablja se za spreminjanje stolpcev, v katerih poteka razvr\0161\010Danje, in dolo\010Da, ali'),
unistr('razvr\0161\010Dati v nara\0161\010Dajo\010Dem ali padajo\010Dem vrstnem redu. Lahko tudi dolo\010Dite, kako ravnati z vrednostmi'),
unistr('<code>NULL</code>. Privzeta nastavitev vedno prika\017Ee vrednosti <code>NULL</code> nazadnje ali pa jih vedno prika\017Ee najprej. Tako nastala razporeditev se prika\017Ee desno od'),
unistr('naslovov stolpcev v poro\010Dilu.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783354472401971)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Pri dodajanju naro\010Dnine navedete e-po\0161tni naslov (ali ve\010D e-po\0161tnih naslovov, lo\010Denih z vejicami), zadevo e-po\0161tnega sporo\010Dila, pogostost ter datuma za\010Detka in konca. E-po\0161tna sporo\010Dila posledi\010Dno vklju\010Dujejo verzijo HTML interaktivnega poro\010Dila s tr')
||unistr('enutnimi podatki z uporabo nastavitev poro\010Dila, ki so se uporabljale v \010Dasu dodajanja naro\010Dnine.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801981363401985)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Podatkovne mre\017Ee so v osnovi poro\010Dila, ki jih je mogo\010De urejati in ki so zelo prilagodljiva. Uporabniki lahko spremenijo postavitev podatkov poro\010Dila z izbiranjem stolpcev, uporabo filtrov, ozna\010Devanjem in razvr\0161\010Danjem. Uporabniki lahko tudi dolo\010Dijo')
||unistr(' prelome, zdru\017Eevanja, grafikone, grupiranja in dodajajo lastne izra\010Dune. Uporabniki lahko ustvarijo ve\010D variacij poro\010Dila in jih shranijo kot imenovana poro\010Dila za zasebni ogled. '),
'<p/>',
unistr('Podatkovno mre\017Eo je mogo\010De prilagoditi z vrstico za iskanje, menijem Dejanja, menijem Upravljanje ali menijem Naslov stolpca.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813732029401994)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'sl'
,p_message_text=>unistr('Meni Dejanja se prika\017Ee na desni strani vrstice za iskanje. V tem meniju lahko prilagodite poro\010Dilo podatkovne mre\017Ee.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802452768401986)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'sl'
,p_message_text=>'Stran Dodajanje/urejanje vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802593060401986)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Za dodajanje vrstice v podatkovno mre\017Eo kliknite Dodaj vrstico. Za urejanje podrobnosti vrstice kliknite ikono za urejanje vrstice (prvi stolpec) v vrstici, ki jo \017Eelite urediti. Prikazala se bo stran Dodajanje/urejanje vrstice s stolpci podatkovn')
||unistr('e mre\017Ee. </p>'),
'',
unistr('<p>Pri urejanju vrstice lahko uporabite naslednje mo\017Enosti:</p>'),
'',
'<p><ul>',
unistr('<li><strong>Izbri\0161i</strong> za brisanje vrstice.</li>'),
'<li><strong>Dodeli spremembe</strong> za shranjevanje sprememb vrstice.</li>',
'<li>V meniju <strong>Dejanja</strong> lahko dodate vrstico, datoteke, opombe, povezave ali oznake in pregledate zgodovino.</li>',
unistr('<li>Krmarite lahko po vrsticah z mo\017Enostma <strong>Naprej in Nazaj</strong>.</li>'),
'<li>V meniju <strong>Upravljanje</strong> lahko nastavite lastnosti stolpcev, skupine stolpcev, potrditve in sezname vrednosti.</li>',
'</ul></p>',
'',
unistr('<p>Znotraj podro\010Dja Pripisi na dnu strani bodo prikazane vse datoteke, opombe, povezave ali oznake, povezane s trenutno vrstico.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813860932401995)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporablja se za ustvarjanje prelomne skupine v enem ali ve\010D stolpcih. Na ta na\010Din se stolpci izvle\010Dejo iz podatkovne mre\017Ee in prika\017Eejo kot glavni zapis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802354799401986)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'sl'
,p_message_text=>unistr('Omogo\010Da prenos trenutnega nabora rezultatov. Formati za prenos vklju\010Dujejo CSV, HTML ali e-po\0161tno sporo\010Dilo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813909760401995)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pri prilagajanju poro\010Dila podatkovne mre\017Ee so nastavitve poro\010Dila prikazane pod vrstico za iskanje in nad poro\010Dilom. To obmo\010Dje lahko strnete in raz\0161irite z uporabo ikone na levi.'),
'<p>',
unistr('Za vsako nastavitev poro\010Dila lahko uporabite naslednje mo\017Enosti:'),
'</p><ul>',
'<li>Uredite nastavitev tako, da kliknete ime.</li>',
unistr('<li>Onemogo\010Dite/omogo\010Dite nastavitev tako, da ozna\010Dite/po\010Distite potrditveno polje Omogo\010Di/Onemogo\010Di. S tem kontrolnim elementom lahko za\010Dasno izklopite in vklopite nastavitev.</li>'),
'<li>Odstranite nastavitev tako, da kliknete ikono Odstrani.</li>',
'</ul>',
unistr('<p>\010Ce ste ustvarili grafikon ali grupiranje, lahko med njima in osnovnim poro\010Dilom preklapljate z uporabo povezav Pogled poro\010Dila, Pogled grafikona in Pogled grupiranja, prikazanih na desni. Pri ogledu grafikona ali grupiranja lahko uporabite tudi po')
||'vezavo Uredi in uredite nastavitve.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802278268401986)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Shrani prilagojeno postavitev poro\010Dila podatkovne mre\017Ee za prihodnjo uporabo. Navedete ime in izbirni opis. Shranite lahko tri tipe postavitev poro\010Dila podatkovne mre\017Ee:</p>'),
'<ul>',
unistr('<li><strong>Primarno privzeto</strong> (samo za skrbnike). Primarno privzeto je prvotno prikazana postavitev. Poro\010Dil Primarno privzeto ni mogo\010De preimenovati ali izbrisati.</li>'),
unistr('<li><strong>Nadomestno poro\010Dilo</strong> (samo za skrbnike). Skrbnikom omogo\010Da ustvarjanje ve\010D postavitev poro\010Dila. Nadomestno poro\010Dilo lahko shranijo, preimenujejo ali izbri\0161ejo le skrbniki.</li>'),
unistr('<li><strong>Zasebno poro\010Dilo</strong> (vsi uporabniki). Uporabnik, ki je ustvaril postavitev poro\010Dila, si lahko ogleda, shrani, preimenuje ali izbri\0161e poro\010Dilo.</li>'),
'</ul>',
unistr('<p>Pri shranjevanju prilagojenih poro\010Dil se v vrstici za iskanje na levi strani izbirnika vrstic prika\017Ee izbirnik poro\010Dil (\010De je ta funkcija omogo\010Dena).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728379160401928)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Skrij stolpec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718920219401921)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Dba')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729878343401930)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Ozna\010Dbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734912525401933)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'sl'
,p_message_text=>unistr('Pogoj ozna\010Dbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783979899401971)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Slog ozna\010Dbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693957064401902)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'sl'
,p_message_text=>unistr('Tip ozna\010Dbe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803429840401987)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'sl'
,p_message_text=>'Vodoravno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833061382402009)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'sl'
,p_message_text=>'1 neaktivna nastavitev'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833148020402009)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>'Neaktivne nastavitve: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724989739401926)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Interaktivno poro\010Dilo - Pomo\010D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735940309401935)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'sl'
,p_message_text=>'Neveljavno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729373413401929)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Neveljaven izraz izra\010Duna. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688730493401899)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'sl'
,p_message_text=>unistr('Datum konca mora biti poznej\0161i od datuma za\010Detka.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743659619401941)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven izraz filtra. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811466497401993)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna poizvedba filtra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833230237402009)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'sl'
,p_message_text=>'1 neveljavna nastavitev'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833348642402009)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>'Neveljavne nastavitve: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784162652401972)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'sl'
,p_message_text=>'(v minutah)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801197439401985)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'sl'
,p_message_text=>'%0 je v zadnjih %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801381947401985)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'sl'
,p_message_text=>'%0 je v naslednjih %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801232340401985)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v zadnjih %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801466186401985)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'sl'
,p_message_text=>'%0 ni v naslednjih %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734076783401933)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilska tipkovnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700122925401907)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Oznaka %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727903875401928)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Naslov osi za oznako'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720445014401922)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'sl'
,p_message_text=>'Zadnji dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720628699401923)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'sl'
,p_message_text=>'Zadnja ura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720142685401922)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'sl'
,p_message_text=>'Zadnji mesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720293394401922)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'sl'
,p_message_text=>'Zadnji teden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720328009401922)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko dni: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720558894401922)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko ur: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719914832401922)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'sl'
,p_message_text=>'Zadnjih toliko let: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720022779401922)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'sl'
,p_message_text=>'Zadnje leto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700007798401907)
,p_name=>'APEXIR_LINE'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696835440401905)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrstica z obmo\010Djem')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811387290401993)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'sl'
,p_message_text=>unistr('Pove\017Ei')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728832442401929)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'sl'
,p_message_text=>unistr('Poizvedba predvidoma presega maksimalno \0161tevilo dovoljenih virov. Spremenite svoje nastavitve poro\010Dila in poskusite znova.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711009154401915)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'sl'
,p_message_text=>unistr('Maksimalno \0161tevilo vrstic za to poro\010Dilo je %0. Uporabite filter za zmanj\0161anje \0161tevila zapisov v svoji poizvedbi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811900901401993)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'sl'
,p_message_text=>'Maksimalno %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812120353401993)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'sl'
,p_message_text=>'Mediana %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715007696401918)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko minutami: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812010921401993)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'sl'
,p_message_text=>'Minimalno %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811029233401992)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'sl'
,p_message_text=>'Mesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784557308401972)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'sl'
,p_message_text=>unistr('Mese\010Dno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727141251401927)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'sl'
,p_message_text=>'Premik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727098955401927)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'sl'
,p_message_text=>'Premakni vse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838298314402013)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Naveden mora biti stati\010Dni ID podro\010Dja, saj stran vsebuje ve\010D interaktivnih poro\010Dil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695560745401904)
,p_name=>'APEXIR_NAME'
,p_message_language=>'sl'
,p_message_text=>'Ime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722926322401924)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Novo zdru\017Eevanje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833920356402010)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'sl'
,p_message_text=>'Nova kategorija'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114723077147401924)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Nov izra\010Dun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717813785401920)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720972838401923)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'sl'
,p_message_text=>'Naslednji dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720742619401923)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'sl'
,p_message_text=>'Naslednja ura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721208616401923)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'sl'
,p_message_text=>'Naslednji mesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721162780401923)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'sl'
,p_message_text=>'Naslednji teden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721032284401923)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko dni: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114720826124401923)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko ur: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721470359401923)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'sl'
,p_message_text=>'Naslednjih toliko let: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721336667401923)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'sl'
,p_message_text=>'Naslednje leto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695802825401904)
,p_name=>'APEXIR_NO'
,p_message_language=>'sl'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736157756401935)
,p_name=>'APEXIR_NONE'
,p_message_language=>'sl'
,p_message_text=>'- Brez -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783743097401971)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni veljaven e-po\0161tni naslov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732633854401932)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'sl'
,p_message_text=>'Vrednosti NULL vedno prve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732508171401932)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'sl'
,p_message_text=>'Vrednosti NULL vedno zadnje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733009132401932)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'sl'
,p_message_text=>'Razvrsti NULL %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729413181401929)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Cas pogleda nazaj mora biti \0161tevilski.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729097190401929)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'sl'
,p_message_text=>unistr('Zaporedje mora biti \0161tevilsko.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733587840401932)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'sl'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694458329401903)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'sl'
,p_message_text=>unistr('oran\017Ena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803354519401987)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'sl'
,p_message_text=>'Usmerjenost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696355885401904)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'sl'
,p_message_text=>'Drugo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679143191401891)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'sl'
,p_message_text=>'Usmerjenost strani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679866473401892)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Le\017Ee\010De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679961145401892)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Pokon\010Dno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679075683401891)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'sl'
,p_message_text=>'Velikost strani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679634154401892)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'sl'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679513655401892)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'sl'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679726565401892)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'sl'
,p_message_text=>'Prilagojeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679380255401892)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'sl'
,p_message_text=>'Pravno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679227423401892)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Crka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114679422296401892)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'sl'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812453396401993)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'sl'
,p_message_text=>unistr('Odstotek skupnega \0161tevila %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811602649401993)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'sl'
,p_message_text=>'Odstotek skupne vsote %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810631581401992)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('Odstotek skupnega \0161tevila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810559407401992)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'sl'
,p_message_text=>'Odstotek skupne vsote'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699947887401907)
,p_name=>'APEXIR_PIE'
,p_message_language=>'sl'
,p_message_text=>'Tortni grafikon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759818903401953)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'sl'
,p_message_text=>'Vrtenje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761374770401954)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Dolo\010Diti je treba zdru\017Eevanje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761574666401954)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'sl'
,p_message_text=>unistr('V stolpcu, ki je izbran kot stolpec vrstice, ne morete zdru\017Eevati.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760747340401954)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Vrtilni stolpci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760525444401954)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'sl'
,p_message_text=>'Vrtilni stolpec %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761139381401954)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Dolo\010Diti je treba vrtilni stolpec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661248696401878)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'sl'
,p_message_text=>unistr('Maksimalno \0161tevilo vrstic za poizvedbo PIVOT omeji \0161tevilo vrstic v osnovni poizvedbi in ne \0161tevila prikazanih vrstic. Va\0161a osnovna poizvedba presega maksimalno \0161tevilo vrstic, ki je %0. Uporabite filter, da zmanj\0161ate \0161tevilo zapisov v osnovni poizve')
||'dbi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761084949401954)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrtilno razvr\0161\010Danje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730486381401930)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrtilni stolpec vsebuje preve\010D razli\010Dnih vrednosti - poizvedbe SQL PIVOT ni mogo\010De ustvariti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783803174401971)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'sl'
,p_message_text=>'Predogled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717975938401920)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114809588029401991)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'sl'
,p_message_text=>'Primarno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784871460401972)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Primarno poro\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678948577401891)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'sl'
,p_message_text=>unistr('Vklju\010Ditev oznak za dostopnost')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665886775401882)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Ci\0161\010Denje obogatenega besedila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742639888401940)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'sl'
,p_message_text=>'Zasebno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700516260401907)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'sl'
,p_message_text=>'Javno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696149829401904)
,p_name=>'APEXIR_RED'
,p_message_language=>'sl'
,p_message_text=>unistr('rde\010Da')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838173105402013)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Stati\010Dni ID podro\010Dja %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727201810401928)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'sl'
,p_message_text=>'Odstrani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727330652401928)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'sl'
,p_message_text=>'Odstrani vse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833460341402009)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'sl'
,p_message_text=>'Odstrani grafikon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726845393401927)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'sl'
,p_message_text=>'Odstrani kontrolni prelom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726514592401927)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Odstrani filter'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726682220401927)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'sl'
,p_message_text=>'Odstrani pogled nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833588251402009)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>'Odstrani grupiranje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726905512401927)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'sl'
,p_message_text=>unistr('Odstrani ozna\010Dbo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833687698402009)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'sl'
,p_message_text=>'Odstrani vrtenje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814652857401995)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Odstrani poro\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795248256401980)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Preimenuj privzeto poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736424439401935)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Preimenovanje poro\010Dila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718272655401921)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812582573401994)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692796628401902)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjeno interaktivno poro\010Dilo z drugim imenom %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742923191401940)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692840638401902)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('ID shranjenega interaktivnega poro\010Dila %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114734743431401933)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'sl'
,p_message_text=>unistr('Nastavitve poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715514049401919)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'sl'
,p_message_text=>unistr('Pogled poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719494337401922)
,p_name=>'APEXIR_RESET'
,p_message_language=>'sl'
,p_message_text=>'Ponastavi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700714575401908)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'sl'
,p_message_text=>unistr('Obnovite poro\010Dilo na privzete nastavitve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695987542401904)
,p_name=>'APEXIR_ROW'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808650434401991)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'sl'
,p_message_text=>unistr('ROWID ni mogo\010De uporabiti kot stolpec primarnega klju\010Da za vir podatkov REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725976445401927)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'sl'
,p_message_text=>'Vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785556972401973)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo vrstic na stran')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760851319401954)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Stolpci vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760679782401954)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'sl'
,p_message_text=>'Stolpec vrstice %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761235165401954)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Dolo\010Diti je treba stolpec vrstice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761482548401954)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'sl'
,p_message_text=>'Stolpec vrstice se mora razlikovati od vrtilnega stolpca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740058021401938)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Filter vrstic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715666233401919)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'sl'
,p_message_text=>'Vrstica %0 od %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719632931401922)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'sl'
,p_message_text=>'Besedilo vrstice vsebuje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695255187401903)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'sl'
,p_message_text=>'Shrani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730069314401930)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjeno poro\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729915697401930)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'sl'
,p_message_text=>unistr('Shranjeno poro\010Dilo = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732150150401931)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'sl'
,p_message_text=>unistr('Trenutne nastavitve poro\010Dila bodo uporabljene kot privzete za vse uporabnike.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114795168743401980)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Shrani privzeto poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114719384291401922)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Shrani poro\010Dilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833803601402010)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'sl'
,p_message_text=>unistr('Shrani poro\010Dilo *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786578093401974)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'sl'
,p_message_text=>'Iskanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114724809981401926)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'sl'
,p_message_text=>'Vrstica za iskanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114833795525402009)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Iskanje: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792072989401978)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo o iskanju')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776089152401965)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Izbrani stolpci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696987984401905)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'- Izbira stolpca -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718605504401921)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>'Izbira stolpcev'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700405426401907)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>'- Izbira funkcije -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725601397401926)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'- Izbira stolpca Grupiranje -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760353111401953)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'- Izbira vrtilnega stolpca -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811552721401993)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'sl'
,p_message_text=>'Izbira vrstice'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760434954401953)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'- Izbira stolpca vrstice -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669173004401884)
,p_name=>'APEXIR_SEND'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675436417401889)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('Po\0161lji kot e-po\0161to')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695633849401904)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'sl'
,p_message_text=>'Zaporedje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718894411401921)
,p_name=>'APEXIR_SORT'
,p_message_language=>'sl'
,p_message_text=>'Razvrsti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728101399401928)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvrsti nara\0161\010Dajo\010De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728277687401928)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'sl'
,p_message_text=>unistr('Razvrsti padajo\010De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814010709401995)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrstni red razvr\0161\010Danja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722662374401924)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'sl'
,p_message_text=>'presledek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733762612401932)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'sl'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784264554401972)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Naro\010Dnina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810994682401992)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'sl'
,p_message_text=>'Konec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665363999401881)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'sl'
,p_message_text=>unistr('Presko\010Di, \010De ni najdenih podatkov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114810849224401992)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'sl'
,p_message_text=>unistr('Za\010Detek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811762262401993)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'sl'
,p_message_text=>'Vsota %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801773579401985)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje = %0, Poro\010Dilo = %1, Pogled = %2, Za\010Detek prikazanih vrstic = %3, Konec prikazanih vrstic = %4, Skupaj vrstic = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722358086401924)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje = %0, Poro\010Dilo = %1, Pogled = %2, Za\010Detek prikazanih vrstic = %3, Konec prikazanih vrstic = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694580709401903)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'sl'
,p_message_text=>'Barva besedila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711600630401916)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'sl'
,p_message_text=>'dnevi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711584464401916)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'sl'
,p_message_text=>'ure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711475817401916)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'sl'
,p_message_text=>'minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711876920401916)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'sl'
,p_message_text=>'meseci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711723246401916)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'sl'
,p_message_text=>'tedni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114711915981401916)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'sl'
,p_message_text=>'leta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114814490332401995)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'sl'
,p_message_text=>'Preklop'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727475698401928)
,p_name=>'APEXIR_TOP'
,p_message_language=>'sl'
,p_message_text=>'Zgoraj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807657324401990)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Razdru\017Een stolpec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728937062401929)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'sl'
,p_message_text=>unistr('Ime ozna\010Dbe mora biti enoli\010Dno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699287819401906)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>'nepodprt podatkovni tip'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727540605401928)
,p_name=>'APEXIR_UP'
,p_message_language=>'sl'
,p_message_text=>'Gor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729171330401929)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'sl'
,p_message_text=>'Vnesite veljavno barvo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729246242401929)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'sl'
,p_message_text=>'Vnesite veljavno masko formata.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114696400165401904)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'sl'
,p_message_text=>'Vrednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114728047417401928)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'sl'
,p_message_text=>'Naslov osi za vrednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735805268401935)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Zahtevana je vrednost'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699866191401907)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Navpi\010Dni stolpec')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114803528622401987)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Navpi\010Dno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735148655401934)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'sl'
,p_message_text=>'Ogled grafikona'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790346931401976)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'sl'
,p_message_text=>'Ogled podrobnosti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114835911035402011)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo nima dolo\010Denega pogleda %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790418521401977)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'sl'
,p_message_text=>'Ogled grupiranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790280335401976)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'sl'
,p_message_text=>'Ogled ikon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760120600401953)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'sl'
,p_message_text=>'Pogled vrtenja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114735204692401934)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Ogled poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784405875401972)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'sl'
,p_message_text=>'Tedensko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718123612401921)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Delovno poro\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813199750401994)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'sl'
,p_message_text=>'%0 (dnevi)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813034144401994)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'sl'
,p_message_text=>'%0 (ure)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114812980431401994)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'sl'
,p_message_text=>'%0 (minute)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813360393401994)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'sl'
,p_message_text=>'%0 (meseci)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813250267401994)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'sl'
,p_message_text=>'%0 (tedni)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114813458972401994)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'sl'
,p_message_text=>'%0 (leta)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114811104277401993)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'sl'
,p_message_text=>'Leto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114694285945401903)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'sl'
,p_message_text=>'rumena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114695729252401904)
,p_name=>'APEXIR_YES'
,p_message_language=>'sl'
,p_message_text=>'Da'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114727831814401928)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sl'
,p_message_text=>'%0 vsebuje < ali >, ki sta neveljavna znaka.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114750694625401946)
,p_name=>'APEX_REGION'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114678882340401891)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'sl'
,p_message_text=>unistr('Prekr\0161en predpogoj API-ja')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698300304401906)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednosti za nastavitev aplikacije %0 ni mogo\010De pridobiti, ker je povezana mo\017Enost gradnje onemogo\010Dena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698240698401906)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednosti za nastavitev aplikacije %0 ni mogo\010De nastaviti, ker je povezana mo\017Enost gradnje onemogo\010Dena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805951946401989)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'sl'
,p_message_text=>'Vrednost nastavitve aplikacije %0 je neveljavna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114805884286401988)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'sl'
,p_message_text=>unistr('Zahtevana nastavitev aplikacije %0 ni dolo\010Dena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806045436401989)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'sl'
,p_message_text=>unistr('Nastavitve aplikacije %0 ni mogo\010De nastaviti na vrednost NULL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686942254401897)
,p_name=>'BACK'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673942881401888)
,p_name=>'BUILDER'
,p_message_language=>'sl'
,p_message_text=>'Graditelj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738018636401936)
,p_name=>'BUTTON LABEL'
,p_message_language=>'sl'
,p_message_text=>'Oznaka gumba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673070112401887)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'sl'
,p_message_text=>'Razredi CSS gumba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702240174401909)
,p_name=>'BUTTON_ID'
,p_message_language=>'sl'
,p_message_text=>unistr('Ustvarjeni ID gumba bo stati\010Dni ID gumba, \010De je dolo\010Den. \010Ce ni dolo\010Den, bo notranje ustvarjeni ID v formatu "B" || [Notranji ID gumba]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665722646401882)
,p_name=>'CANDLESTICK'
,p_message_language=>'sl'
,p_message_text=>unistr('Sve\010Dnik')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747252342401943)
,p_name=>'CENTER'
,p_message_language=>'sl'
,p_message_text=>'Sredina'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697216377401905)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'sl'
,p_message_text=>'Zahteva %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688646959401898)
,p_name=>'CHECK$'
,p_message_language=>'sl'
,p_message_text=>'izbirnik vrstic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114807730150401990)
,p_name=>'CHECKED'
,p_message_language=>'sl'
,p_message_text=>'potrjeno'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783204924401971)
,p_name=>'COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Stolpec'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743749494401941)
,p_name=>'COMMENTS'
,p_message_language=>'sl'
,p_message_text=>'Komentarji'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725211797401926)
,p_name=>'CONTINUE'
,p_message_language=>'sl'
,p_message_text=>'Nadaljuj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687241564401897)
,p_name=>'COPYRIGHT'
,p_message_language=>'sl'
,p_message_text=>unistr('Copyright &copy; %0. Vse pravice pridr\017Eane.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730914223401930)
,p_name=>'COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737684263401936)
,p_name=>'CREATE'
,p_message_language=>'sl'
,p_message_text=>'Ustvarjanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789927106401976)
,p_name=>'CREATED'
,p_message_language=>'sl'
,p_message_text=>'Ustvarjeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790061473401976)
,p_name=>'CREATED_BY'
,p_message_language=>'sl'
,p_message_text=>'Ustvaril(-a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714863735401918)
,p_name=>'CREATED_ON'
,p_message_language=>'sl'
,p_message_text=>'Ustvarjeno dne'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725421518401926)
,p_name=>'CUSTOM'
,p_message_language=>'sl'
,p_message_text=>'Prilagojeno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736669104401935)
,p_name=>'CUSTOMIZE'
,p_message_language=>'sl'
,p_message_text=>'Prilagajanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738267208401937)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'sl'
,p_message_text=>'Preference strani so bile ponastavljene za uporabnika %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738385486401937)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'sl'
,p_message_text=>'Preference spremenjene za uporabnika %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738163840401936)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'sl'
,p_message_text=>'Preference strani so bile ponastavljene za uporabnika %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701927018401908)
,p_name=>'DAILY'
,p_message_language=>'sl'
,p_message_text=>'Dnevno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114673545238401887)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalo\017Eena datoteka je neveljavna ali ima napa\010Dno pripono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697463602401905)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'sl'
,p_message_text=>'Uporabljen je bil neveljaven izbirnik XML ali JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666749143401882)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatkovni profil in nalo\017Eena datoteka ne vsebujeta nobenega ciljnega stolpca tabele.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752449965401947)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'sl'
,p_message_text=>unistr('V nalo\017Eeni datoteki ni bilo mogo\010De najti podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752580877401947)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'sl'
,p_message_text=>unistr('V delovnem listu "%0" ni bilo mogo\010De najti podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114672302373401887)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'sl'
,p_message_text=>'Navedena datoteka ni datoteka XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114662718902401879)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje podatkov je kon\010Dano. Obdelanih je bilo toliko vrstic: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663911067401880)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje podatkov je kon\010Dano. Obdelanih je bilo toliko vrstic: %0 z 1 napako.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664227038401881)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje podatkov je kon\010Dano. Obdelanih je bilo toliko vrstic: %0 s toliko napakami: %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664083703401880)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje podatkov je kon\010Dano. Obdelana je bila 1 vrstica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667033000401883)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje podatkov je kon\010Dano. Obdelana je bila 1 vrstica z napako.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664190682401881)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalaganje podatkov je kon\010Dano. Obdelana je bila 1 vrstica brez napake.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757784719401951)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'sl'
,p_message_text=>'Ciljni stolpec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757801264401951)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'sl'
,p_message_text=>'Izvorni stolpec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758607345401952)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'sl'
,p_message_text=>unistr('Format datuma/\0161tevilke')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822019482402001)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednosti \0161ifranta ni bilo mogo\010De pridobiti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114790565376401977)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'sl'
,p_message_text=>'Preslikava podatkov/tabele'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758735326401952)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'sl'
,p_message_text=>'Vrstica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754219005401949)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'sl'
,p_message_text=>'Pravilo transformacije ni uspelo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730580104401930)
,p_name=>'DATE'
,p_message_language=>'sl'
,p_message_text=>'Datum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704688686401910)
,p_name=>'DAY'
,p_message_language=>'sl'
,p_message_text=>'dan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704744489401911)
,p_name=>'DAYS'
,p_message_language=>'sl'
,p_message_text=>'dnevi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743413142401940)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'sl'
,p_message_text=>unistr('Iskanje napak ni omogo\010Deno za to aplikacijo.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114792204474401978)
,p_name=>'DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Privzeto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705409779401911)
,p_name=>'DELETE'
,p_message_language=>'sl'
,p_message_text=>unistr('izbri\0161i')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114665649939401882)
,p_name=>'DIAL_PCT'
,p_message_language=>'sl'
,p_message_text=>'Merilnik (odstotek)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680117575401892)
,p_name=>'DOWNLOAD'
,p_message_language=>'sl'
,p_message_text=>'Prenos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791336541401977)
,p_name=>'DUP_USER'
,p_message_language=>'sl'
,p_message_text=>unistr('Podvojeno uporabni\0161ko ime na seznamu.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687708955401898)
,p_name=>'EDIT'
,p_message_language=>'sl'
,p_message_text=>'Uredi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697142114401905)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161tnega naslova "%0" ni bilo mogo\010De najti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682238914401894)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'sl'
,p_message_text=>unistr('To e-po\0161to je poslal(-a) %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791588871401977)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'sl'
,p_message_text=>'Elektronski naslov je predolg. Omejitev je 240 znakov.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725122829401926)
,p_name=>'ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754337092401949)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De nastaviti izvorne vrednosti elementa strani za podro\010Dje delne osve\017Eitve strani')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716662795401919)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'sl'
,p_message_text=>'Ustvaril(-a)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682559296401894)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'sl'
,p_message_text=>'Geslo je poteklo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114676696083401890)
,p_name=>'FILE_EMPTY'
,p_message_language=>'sl'
,p_message_text=>'Datoteka je prazna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756872465401951)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'sl'
,p_message_text=>unistr('Velikost nalo\017Eene datoteke je bila ve\010D kot %0 MB. Nalo\017Eite manj\0161o datoteko.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684620692401896)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Preverjanje pristnosti uporabnika ni uspelo in vsaj ena datoteka ni bila nalo\017Eena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684763488401896)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ta instanca uporabnikom brez preverjene pristnosti ne omogo\010Da nalaganja datotek.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737700030401936)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Pri\0161lo je do 1 napake')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736968569401936)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Pri\0161lo je do toliko napak: %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687133476401897)
,p_name=>'FORM_OF'
,p_message_language=>'sl'
,p_message_text=>'%0 od %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721802207401923)
,p_name=>'GO'
,p_message_language=>'sl'
,p_message_text=>'Pojdi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821657837402000)
,p_name=>'HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Pomo\010D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674083504401888)
,p_name=>'HOME'
,p_message_language=>'sl'
,p_message_text=>'Domov'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704456960401910)
,p_name=>'HOUR'
,p_message_language=>'sl'
,p_message_text=>'ura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704500202401910)
,p_name=>'HOURS'
,p_message_language=>'sl'
,p_message_text=>'ure'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688537585401898)
,p_name=>'ICON'
,p_message_language=>'sl'
,p_message_text=>'Ikona %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738516569401937)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'sl'
,p_message_text=>'Neveljavne poverilnice za prijavo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114838074025402013)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna vrednost za parameter: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733255188401932)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'sl'
,p_message_text=>unistr('Kot privzete nastavitve poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733311901401932)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Kot imenovano poro\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715714487401919)
,p_name=>'IR_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715409795401919)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De izra\010Dunati krmarjenja obrazca. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693031411401902)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Interaktivno poro\010Dilo ni bilo najdeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692467271401901)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Podro\010Dje interaktivnega poro\010Dila ne obstaja v aplikaciji %0, stran %1 in podro\010Dje %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114733159115401932)
,p_name=>'IR_STAR'
,p_message_language=>'sl'
,p_message_text=>'Prikazano samo za razvijalce'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721565885401923)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Poizvedba poro\010Dila zahteva enoli\010Den klju\010D za identifikacijo posamezne vrstice. Posredovanega klju\010Da ni mogo\010De uporabiti za to poizvedbo. Dolo\010Dite stolpec enoli\010Dnega klju\010Da. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721650289401923)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'sl'
,p_message_text=>unistr('Poizvedba poro\010Dila zahteva enoli\010Den klju\010D za identifikacijo posamezne vrstice. Posredovanega klju\010Da ni mogo\010De uporabiti za to poizvedbo. Za dolo\010Danje stolpca enoli\010Dnega klju\010Da uredite atribute poro\010Dila. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758932480401952)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'sl'
,p_message_text=>'Izbira datoteke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758841304401952)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'sl'
,p_message_text=>'Povlecite in spustite datoteko sem ali'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687428318401898)
,p_name=>'ITEMS'
,p_message_language=>'sl'
,p_message_text=>'Elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716827663401920)
,p_name=>'ITEM_VALUE'
,p_message_language=>'sl'
,p_message_text=>'Vrednost elementa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731256827401931)
,p_name=>'LABEL'
,p_message_language=>'sl'
,p_message_text=>'Oznaka'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743398195401940)
,p_name=>'LANGUAGE'
,p_message_language=>'sl'
,p_message_text=>'Jezik'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705119305401911)
,p_name=>'LAST'
,p_message_language=>'sl'
,p_message_text=>'zadnji'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684552889401895)
,p_name=>'LENGTH'
,p_message_language=>'sl'
,p_message_text=>unistr('Dol\017Eina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737896380401936)
,p_name=>'LOGIN'
,p_message_language=>'sl'
,p_message_text=>'Prijava'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776498013401966)
,p_name=>'MANAGE'
,p_message_language=>'sl'
,p_message_text=>'Upravljanje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841065839402015)
,p_name=>'MAXIMIZE'
,p_message_language=>'sl'
,p_message_text=>'Maksimiraj'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704221689401910)
,p_name=>'MINUTE'
,p_message_language=>'sl'
,p_message_text=>'minuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704301245401910)
,p_name=>'MINUTES'
,p_message_language=>'sl'
,p_message_text=>'minute'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791776661401978)
,p_name=>'MISSING_AT'
,p_message_language=>'sl'
,p_message_text=>unistr('V e-po\0161tnem naslovu manjka "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791939632401978)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'sl'
,p_message_text=>unistr('Opozorilo: Za pogovorno stran %0 v aplikaciji %1 ni bila dolo\010Dena nobena predloga pogovorne strani.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791684725401978)
,p_name=>'MISSING_DOT'
,p_message_language=>'sl'
,p_message_text=>unistr('V domeni e-po\0161tnega naslova manjka ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740845259401938)
,p_name=>'MODULE'
,p_message_language=>'sl'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697939386401905)
,p_name=>'MONTH'
,p_message_language=>'sl'
,p_message_text=>'Mesec'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701761083401908)
,p_name=>'MONTHLY'
,p_message_language=>'sl'
,p_message_text=>unistr('Mese\010Dno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698097730401905)
,p_name=>'MONTHS'
,p_message_language=>'sl'
,p_message_text=>'meseci'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730850123401930)
,p_name=>'MOVE'
,p_message_language=>'sl'
,p_message_text=>'Premik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798365631401983)
,p_name=>'MOVE_FROM'
,p_message_language=>'sl'
,p_message_text=>'Premakni iz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798450356401983)
,p_name=>'MOVE_TO'
,p_message_language=>'sl'
,p_message_text=>'Premakni v'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114718022225401921)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka v operaciji brisanja ve\010D vrstic: vrstica= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717034792401920)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'sl'
,p_message_text=>'Ne sme biti javni uporabnik'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674261638401888)
,p_name=>'NAME'
,p_message_language=>'sl'
,p_message_text=>'Ime'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731078081401930)
,p_name=>'NEW'
,p_message_language=>'sl'
,p_message_text=>'Novo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697722113401905)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'sl'
,p_message_text=>unistr('V %0 se lahko prijavite tako, da obi\0161\010Dete:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697846606401905)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160t. novih obvestil o ra\010Dunu: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821850989402000)
,p_name=>'NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740727684401938)
,p_name=>'NO'
,p_message_language=>'sl'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114836021173402011)
,p_name=>'NOBODY'
,p_message_language=>'sl'
,p_message_text=>unistr('nih\010De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705552374401911)
,p_name=>'NOT'
,p_message_language=>'sl'
,p_message_text=>'Ne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746389697401943)
,p_name=>'NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>'Ni NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717133913401920)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'sl'
,p_message_text=>'Ni %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736766893401935)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('podatkov ni bilo mogo\010De najti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745852162401942)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni bilo mogo\010De najti poro\010Dila, ki bi ga bilo mogo\010De posodobiti. Ve\010D vrstic je bilo posodobljenih in operacije brisanja je mogo\010De izvajati samo na tabelarnih obrazcih tipa "Poro\010Dilo, ki ga je mogo\010De posodobiti".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746715027401943)
,p_name=>'OK'
,p_message_language=>'sl'
,p_message_text=>'V redu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742421413401940)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'sl'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114839817658402014)
,p_name=>'ORA_06550'
,p_message_language=>'sl'
,p_message_text=>'ORA-06550: vrstica %0, stolpec %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789329881401976)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabljate zastarel spletni brskalnik. Za seznam podprtih brskalnikov glejte priro\010Dnik za namestitev Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690777159401900)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'sl'
,p_message_text=>unistr('Zahtevan je bil neveljaven nabor vrstic, izvorni podatki poro\010Dila so bili spremenjeni.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710867037401915)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Treba je navesti veljavno \0161tevilko strani, na primer p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714438655401918)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'sl'
,p_message_text=>'Naprej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714558470401918)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'sl'
,p_message_text=>'Naslednji nabor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714611592401918)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114714781705401918)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'sl'
,p_message_text=>unistr('Prej\0161nji nabor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821770269402000)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbira \0161tevil\010Denja strani')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752363325401947)
,p_name=>'PASSWORD'
,p_message_language=>'sl'
,p_message_text=>'Geslo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697083685401905)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'sl'
,p_message_text=>unistr('Va\0161e geslo za %0 je bilo spremenjeno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686810302401897)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Geslo ne ustreza pravilom o zapletenosti gesla za to mesto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685956769401896)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'sl'
,p_message_text=>'Novo geslo se mora razlikovati od starega gesla za vsaj toliko znakov: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686539716401897)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Geslo ne sme vsebovati uporabni\0161kega imena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686752035401897)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Geslo vsebuje prepovedano vzor\010Dno besedo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686668807401897)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'sl'
,p_message_text=>'Geslo ne sme vsebovati imena delovnega prostora.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685861787401896)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'sl'
,p_message_text=>'Geslo mora vsebovati vsaj toliko znakov: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686067771401897)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'sl'
,p_message_text=>'Geslo mora vsebovati vsaj en abecedni znak (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686470868401897)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Geslo mora vsebovati vsaj eno malo \010Drko.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686162607401897)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Geslo mora vsebovati vsaj en \0161tevilski znak (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686250315401897)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Geslo mora vsebovati vsaj eno lo\010Dilo (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114686353433401897)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Geslo mora vsebovati vsaj eno veliko \010Drko.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697568872401905)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'sl'
,p_message_text=>'Obvestilo o ponastavitvi gesla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684879410401896)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Gesla ni dovoljeno uporabiti, ker je \017Ee bilo uporabljeno v zadnjih %0 dneh.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765195383401957)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'sl'
,p_message_text=>'Elementi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114765286053401957)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'sl'
,p_message_text=>'Element'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742245428401940)
,p_name=>'PERCENT'
,p_message_language=>'sl'
,p_message_text=>'Odstotek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712519698401916)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'sl'
,p_message_text=>'Obrnite se na skrbnika.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114821925177402001)
,p_name=>'PREVIOUS'
,p_message_language=>'sl'
,p_message_text=>'Nazaj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757336744401951)
,p_name=>'PRINT'
,p_message_language=>'sl'
,p_message_text=>'Tiskanje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741026335401939)
,p_name=>'PRIVILEGES'
,p_message_language=>'sl'
,p_message_text=>'Privilegiji'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710961380401915)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'sl'
,p_message_text=>unistr('Reference podro\010Dja')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731115047401931)
,p_name=>'REPORT'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740931574401939)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'sl'
,p_message_text=>unistr('Obdobje poro\010Danja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822168551402001)
,p_name=>'REPORT_LABEL'
,p_message_language=>'sl'
,p_message_text=>unistr('Poro\010Dilo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741604237401939)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupna vsota poro\010Dila')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690884765401900)
,p_name=>'RESET'
,p_message_language=>'sl'
,p_message_text=>unistr('Ponastavitev \0161tevil\010Denja strani')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716756781401920)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Ponastavitev \0161tevil\010Denja strani')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745718789401942)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'sl'
,p_message_text=>'Ponastavitev gesla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722583258401924)
,p_name=>'RESTORE'
,p_message_language=>'sl'
,p_message_text=>'Obnovi'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114754440017401949)
,p_name=>'RESULTS'
,p_message_language=>'sl'
,p_message_text=>'Rezultati'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746892027401943)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'sl'
,p_message_text=>'Nazaj na aplikacijo.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114747176141401943)
,p_name=>'RIGHT'
,p_message_language=>'sl'
,p_message_text=>'Desno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776793095401966)
,p_name=>'ROW'
,p_message_language=>'sl'
,p_message_text=>'Vrstica %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730798105401930)
,p_name=>'ROW_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo vrstic')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114746237298401943)
,p_name=>'SAVE'
,p_message_language=>'sl'
,p_message_text=>'Shrani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742884977401940)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Nadomestno privzeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743227116401940)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'sl'
,p_message_text=>'Opis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742704827401940)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Primarno privzeto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743585690401940)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'sl'
,p_message_text=>unistr('Na voljo je ve\010D kot toliko vrstic: %0. Pove\010Dajte izbirnik vrstic za ogled ve\010D vrstic.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808981760401991)
,p_name=>'SEARCH'
,p_message_language=>'sl'
,p_message_text=>'Iskanje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704111692401910)
,p_name=>'SECONDS'
,p_message_language=>'sl'
,p_message_text=>'sekunde'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742368981401940)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'sl'
,p_message_text=>'Glejte prilogo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800092847401984)
,p_name=>'SELECT_ROW'
,p_message_language=>'sl'
,p_message_text=>'Izbira vrstice'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742054845401939)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'sl'
,p_message_text=>unistr('Izklop na\010Dina bralnika zaslona')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742143802401939)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'sl'
,p_message_text=>unistr('Vklop na\010Dina bralnika zaslona')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738469448401937)
,p_name=>'SHOW'
,p_message_language=>'sl'
,p_message_text=>'Prikaz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801844574401985)
,p_name=>'SHOW_ALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Prika\017Ei vse')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114827902448402005)
,p_name=>'SIGN_IN'
,p_message_language=>'sl'
,p_message_text=>'Vpis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114777575483401967)
,p_name=>'SIGN_OUT'
,p_message_language=>'sl'
,p_message_text=>'Odjava'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731787702401931)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko dnevi: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738938795401937)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko dni od tega trenutka: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731676057401931)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko urami: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738899533401937)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko ur od tega trenutka: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731521504401931)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko minutami: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738790675401937)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko minut od tega trenutka: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731974015401931)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko meseci: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739121469401937)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko mesecev od tega trenutka: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739393449401937)
,p_name=>'SINCE_NOW'
,p_message_language=>'sl'
,p_message_text=>'Zdaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731470462401931)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko sekundami: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114738655751401937)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko sekund od tega trenutka: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114731880450401931)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko tedni: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739072287401937)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko tednov od tega trenutka: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114732034210401931)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'sl'
,p_message_text=>'Pred toliko leti: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739276776401937)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'sl'
,p_message_text=>'Toliko let od tega trenutka: %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725596461401926)
,p_name=>'STANDARD'
,p_message_language=>'sl'
,p_message_text=>'Standardno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741929361401939)
,p_name=>'START_DATE'
,p_message_language=>'sl'
,p_message_text=>unistr('Datum za\010Detka')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682494022401894)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'sl'
,p_message_text=>unistr('To e-po\0161tno sporo\010Dilo ste prejeli iz naro\010Dnine na interaktivno poro\010Dilo, ki jo je ustvaril(-a) %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837197294402012)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'sl'
,p_message_text=>unistr('Naro\010Dnine')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785252600401972)
,p_name=>'TAB'
,p_message_language=>'sl'
,p_message_text=>'Zavihek'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704030890401910)
,p_name=>'TITLE'
,p_message_language=>'sl'
,p_message_text=>'Naslov'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687055912401897)
,p_name=>'TODAY'
,p_message_language=>'sl'
,p_message_text=>'Danes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741519863401939)
,p_name=>'TOTAL'
,p_message_language=>'sl'
,p_message_text=>'Skupaj'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688095787401898)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'sl'
,p_message_text=>unistr('Izbrati je mogo\010De maksimalno toliko stolpcev: %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666527513401882)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'sl'
,p_message_text=>'Strni vse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666870000401882)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'sl'
,p_message_text=>'Strni vse spodnje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666466698401882)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iri vse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666675394401882)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'sl'
,p_message_text=>unistr('Raz\0161iri vse spodnje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666904449401883)
,p_name=>'TREE.REPARENT'
,p_message_language=>'sl'
,p_message_text=>unistr('Ponovna dolo\010Ditev nadrejenega')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759196144401952)
,p_name=>'TREES'
,p_message_language=>'sl'
,p_message_text=>'Drevesa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114802603781401986)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Zahtevano'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114726277842401927)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'sl'
,p_message_text=>'Neodobreno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114773040826401963)
,p_name=>'UNAVAILABLE'
,p_message_language=>'sl'
,p_message_text=>'Ni na voljo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739793561401938)
,p_name=>'UNKNOWN'
,p_message_language=>'sl'
,p_message_text=>'Neznano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683312264401895)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Pri\0161lo je do neprepoznane napake preverjanja pristnosti.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685359442401896)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Ce ne \017Eelite ve\010D prejemati e-po\0161tnih sporo\010Dil, za upravljanje svoje naro\010Dnine kliknite <a href="%0">Odjavi</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114682378736401894)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'sl'
,p_message_text=>unistr('\010Ce ne \017Eelite ve\010D prejemati e-po\0161tnih sporo\010Dil, za upravljanje svoje naro\010Dnine obi\0161\010Dite naslednji URL:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114717288192401920)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>'nepodprt podatkovni tip'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705331268401911)
,p_name=>'UPDATE'
,p_message_language=>'sl'
,p_message_text=>'posodobitev'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703900092401910)
,p_name=>'UPDATED'
,p_message_language=>'sl'
,p_message_text=>'Posodobljeno'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710648183401915)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'sl'
,p_message_text=>'Zahtevani URL je bil prepovedan. Obrnite se na svojega skrbnika.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114730696627401930)
,p_name=>'USER'
,p_message_language=>'sl'
,p_message_text=>'Uporabnik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114752276588401947)
,p_name=>'USERNAME'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791883229401978)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime je predolgo. Omejitev je %0 znakov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737491630401936)
,p_name=>'USERS'
,p_message_language=>'sl'
,p_message_text=>'uporabniki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114791473355401977)
,p_name=>'USER_EXISTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime \017Ee obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114806190820401989)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'sl'
,p_message_text=>'Slika profila za uporabnika %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693704113401902)
,p_name=>'VALID'
,p_message_language=>'sl'
,p_message_text=>'Veljavno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687370647401897)
,p_name=>'VALIDATIONS'
,p_message_language=>'sl'
,p_message_text=>'Preverjanja'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743048993401940)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednost mora biti dolo\010Dena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786498512401973)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednost mora biti dolo\010Dena za %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712933449401917)
,p_name=>'VERTICAL'
,p_message_language=>'sl'
,p_message_text=>unistr('navpi\010Dno')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705244132401911)
,p_name=>'VIEW'
,p_message_language=>'sl'
,p_message_text=>'ogled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737566659401936)
,p_name=>'VIEWS'
,p_message_language=>'sl'
,p_message_text=>'pogledi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743877800401941)
,p_name=>'VIEW_ALL'
,p_message_language=>'sl'
,p_message_text=>'Ogled vsega'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114725020766401926)
,p_name=>'WARNING'
,p_message_language=>'sl'
,p_message_text=>'Opozorilo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704820401401911)
,p_name=>'WEEK'
,p_message_language=>'sl'
,p_message_text=>'teden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701800774401908)
,p_name=>'WEEKLY'
,p_message_language=>'sl'
,p_message_text=>'Tedensko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114704915067401911)
,p_name=>'WEEKS'
,p_message_language=>'sl'
,p_message_text=>'tedni'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114743124908401940)
,p_name=>'WELCOME_USER'
,p_message_language=>'sl'
,p_message_text=>unistr('Dobrodo\0161li: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741392738401939)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'sl'
,p_message_text=>'Najdena je bila neveljavna vrednost, preverite vnesene podatke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741433251401939)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'sl'
,p_message_text=>'Najdena je bila neveljavna vrednost, preverite vnesene podatke.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684434037401895)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'sl'
,p_message_text=>'Najdena je bila neveljavna vrednost datuma, preverite format datuma.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114741266857401939)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'sl'
,p_message_text=>unistr('Najdena je bila neveljavna vrednost \0161tevilke, preverite format \0161tevilke.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693361509401902)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'sl'
,p_message_text=>unistr('Najdena je bila neveljavna vrednost \010Dasovnega \017Eiga, preverite format \010Dasovnega \017Eiga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114715803680401919)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De vezati "%0". Uporabite dvojne narekovaje za elemente iz ve\010D bajtov ali preverite, ali je dol\017Eina elementa 30 bajtov ali manj. Za sklicevanje na elemente, dalj\0161e od 30 bajtov, uporabite sintakso v().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706398780401912)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'sl'
,p_message_text=>'Dostop zavrnilo varnostno preverjanje %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708854460401914)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'sl'
,p_message_text=>'Aplikacija ni na voljo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707216791401912)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1014 Aplikacije ni bilo mogo\010De najti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707310585401913)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'sl'
,p_message_text=>'aplikacija=%0  delovni prostor=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707776712401913)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'sl'
,p_message_text=>'Dostop do te aplikacije je omejen, poskusite znova pozneje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707672879401913)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'sl'
,p_message_text=>'Dostop do te aplikacije je omejen na razvijalce aplikacij, poskusite znova pozneje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706806968401912)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-7744 Ni mogo\010De obdelati veje do funkcije, ki vrne URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706766115401912)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-7744 Ni mogo\010De obdelati veje do funkcije, ki vrne stran.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707044734401912)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'sl'
,p_message_text=>'ERR-1430 Klic za prikaz iz obdelave strani ni podprt: G_FLOW_STEP_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708190827401913)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1018 Napaka pri \010Di\0161\010Denju predpomnilnika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706508791401912)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1005 Neznan tip izra\010Duna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707430732401913)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'sl'
,p_message_text=>'ERR-1201 ID seje ni nastavljen za prilagojeno preverjanje pristnosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707586484401913)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'sl'
,p_message_text=>'stran=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114707128669401912)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-7620 Ni bilo mogo\010De dolo\010Diti delovnega prostora za aplikacijo (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689563377401899)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'sl'
,p_message_text=>'Uredi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706234835401912)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1802 Ni mogo\010De najti ID-ja elementa "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705908579401911)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1002 Ni mogo\010De poiskati ID-ja elementa za element "%0" v aplikaciji "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706088719401911)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'sl'
,p_message_text=>unistr('Nepri\010Dakovana napaka, ni mogo\010De poiskati imena elementa na ravni aplikacije ali strani.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706409971401912)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ste \017Ee na prvi strani podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114721920104401924)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'sl'
,p_message_text=>unistr('ID elementa (%0) ni element, dolo\010Den na trenutni strani.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684040954401895)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'sl'
,p_message_text=>unistr('Elementa ni mogo\010De nastaviti s podajanjem argumentov aplikaciji.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684357627401895)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'sl'
,p_message_text=>'(Navedena ni bila nobena vrednost kontrolne vsote)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683837928401895)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'sl'
,p_message_text=>unistr('Element je mogo\010De nastaviti, ko ga spremlja vrednost kontrolne vsote "user-level bookmark".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683702705401895)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'sl'
,p_message_text=>unistr('Element je mogo\010De nastaviti, ko ga spremlja vrednost kontrolne vsote "application-level bookmark".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683902089401895)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'sl'
,p_message_text=>unistr('Element je mogo\010De nastaviti, ko ga spremlja vrednost kontrolne vsote "session".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683636310401895)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'sl'
,p_message_text=>unistr('Element nima za\0161\010Dite.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708265652401913)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'sl'
,p_message_text=>unistr('Pomo\010D za stran ni na voljo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114697347671401905)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'sl'
,p_message_text=>unistr('Delovni prostor %0 nima pravic za raz\010Dlenjevanje kot shema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706639778401912)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1010 Prese\017Eena je bila omejitev rekurzije obdelave veje do sprejetja strani. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684216144401895)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'sl'
,p_message_text=>unistr('Te strani ni mogo\010De priklicati z URL-jem ali z uporabo GET ali POST za postopek prikaza, priklicati jo morate s tipom veje "Branch to Page".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114760944913401954)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri poskusu shranjevanja ne\0161tevilske vrednosti v elementu %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699081362401906)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Shema raz\010Dlenjevanja aplikacije "%0" ne obstaja v bazi podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114699110926401906)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'sl'
,p_message_text=>unistr('Ra\010Dune v delovnem prostoru INTERNAL je mogo\010De uporabiti samo za dostop do elementa &PRODUCT_NAME. <a href="%0">Skrbni\0161ke storitve</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705863674401911)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-1029 Ni mogo\010De shraniti informacij seje.  seja=%0 element=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708995165401914)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Sledenja ni bilo mogo\010De zaustaviti: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114706155901401912)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Nepri\010Dakovana napaka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716159896401919)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'sl'
,p_message_text=>'Napaka v update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709067983401914)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Za ogled pomo\010Di je treba navesti aplikacijo in stran.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114729556667401929)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Avtomatizacije ni bilo mogo\010De najti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710136979401915)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo po\010Di\0161\010Denih sej: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669457967401884)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De izvr\0161iti kode %0! Baza podatkov je ne podpira ali pa je ne omogo\010Da parameter instance MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114669259585401884)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'sl'
,p_message_text=>'Multilingual Engine ni na voljo v tej verziji baze podatkov!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690044947401899)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>'Polje zbirke aplikacij ne sme biti NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689861470401899)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'sl'
,p_message_text=>unistr('Navedena \0161tevilka atributa \010Dlana %0 je neveljavna.  \0160tevilka atributa mora biti med 1 in %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690319074401900)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'sl'
,p_message_text=>'Zbirka aplikacij obstaja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690165556401900)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'sl'
,p_message_text=>'Ime zbirke ne sme biti NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690299111401900)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'sl'
,p_message_text=>unistr('Ime zbirke ne sme biti dalj\0161e od 255 znakov')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689689951401899)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>'Zbirka aplikacij %0 ne obstaja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690471084401900)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'sl'
,p_message_text=>unistr('Kazalec \0161e ni odprt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689782057401899)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Zaporedje \010Dlanov %0 ne obstaja v zbirki aplikacij %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114689989885401899)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('Zaporedje \010Dlanov %0 ne obstaja v zbirki aplikacij "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761767763401954)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>'Kriptografska funkcija "%0" ni podprta v tem sistemu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815267777401996)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'sl'
,p_message_text=>'Dostopnost testirana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709690417401914)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'sl'
,p_message_text=>'Zapri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709704412401914)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'sl'
,p_message_text=>unistr('Mo\017Enosti prilagajanja strani')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709849982401914)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'sl'
,p_message_text=>'Privzeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709906690401914)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'sl'
,p_message_text=>'Prikazano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710074909401915)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'sl'
,p_message_text=>'Skrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709489606401914)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'sl'
,p_message_text=>unistr('Preverite podro\010Dja, ki jih \017Eelite vklju\010Diti na to stran.  Preverjena podro\010Dja se morda ne bodo prikazala, \010De niste v ustreznem kontekstu aplikacije ali nimate ustreznih privilegijev.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709518327401914)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'sl'
,p_message_text=>unistr('Te strani ni mogo\010De prilagoditi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815579584401996)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'sl'
,p_message_text=>'Videz te aplikacije lahko prilagodite tako, da spremenite slog teme. Izberite slog teme s spodnjega seznama in kliknite Dodeli spremembe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114816335504401996)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'sl'
,p_message_text=>unistr('Prikaz podro\010Dja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815400047401996)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'sl'
,p_message_text=>'Uporabi privzeti slog aplikacije'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114815329836401996)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'sl'
,p_message_text=>'Videz '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758380611401952)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Indeks stolpcev s sklicem v zdru\017Eevanju %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114661683604401879)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'sl'
,p_message_text=>'Izhod CLOB ni podprt za format %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758035982401952)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'sl'
,p_message_text=>unistr('Prelom stolpca mora biti na za\010Detku polja stolpcev.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758168058401952)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>'Indeks skupine stolpcev s sklicem v %0 ne obstaja.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114675671699401889)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'sl'
,p_message_text=>'izvoz'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114680897471401893)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'sl'
,p_message_text=>unistr('Format izvoza mora biti XML, ki uporablja ORDS kot tiskalni stre\017Enik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758431656401952)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>unistr('Indeks stolpcev s sklicem v ozna\010Dbi %0 ne obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674156510401888)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven format izvoza: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114758217677401952)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>'Indeks nadrejene skupine s sklicem v %0 ne obstaja.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114783419644401971)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpec %1 tabele %0 je stolpec identitet "GENERATED ALWAYS". Prepri\010Dajte se, da noben izvorni stolpec ni preslikan v stolpec %1 v pogovornem oknu Konfiguracija.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700892971401908)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'sl'
,p_message_text=>'Navedeni interval potrditev je prenizek.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114700903321401908)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'sl'
,p_message_text=>'Za nalaganje podatkov ni bilo zagotovljenih nobenih stolpcev.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702126872401909)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Za izbirnika vrstic "%0" ni bilo mogo\010De najti nobenega stolpca. Poskusite samodejno zaznati ali pregledati strukturo JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710496446401915)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('V datoteki XLSX ni bilo mogo\010De najti delovnih listov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710336569401915)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'sl'
,p_message_text=>'Navedeni delovni list ne obstaja v datoteki XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114690574562401900)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'sl'
,p_message_text=>'Trenutna verzija podatkov v bazi podatkov se je spremenila, odkar je uporabnik inicializiral postopek posodobitve.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692989865401902)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri posodabljanju stolpcev poro\010Dila: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797662825401982)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 ni mogo\010De pretvoriti v SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737141806401936)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpca %0, ki je podatkovnega tipa %1, ni mogo\010De pretvoriti v VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744157643401941)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpca "%0", dolo\010Denega za atribut "%1", ni bilo mogo\010De najti v viru podatkov!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685485878401896)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'sl'
,p_message_text=>unistr('Tip filtra %0 ni podprt za stolpce z ve\010D vrednostmi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114801002931401985)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven filter "med".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667551829401883)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'sl'
,p_message_text=>'Naveden neveljaven tip LOV.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667417728401883)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven tip poizvedbe. Tip poizvedbe mora biti tabela, poizvedba SQL ali funkcija PL/SQL, ki vrne poizvedbo SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737230055401936)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Raz\010Dlenjevanje poizvedbe SQL ni uspelo!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744250751401941)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Navedenega polo\017Eaja stolpca %0 za atribut "%1" ni bilo mogo\010De najti v izpisku SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114666036547401882)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'sl'
,p_message_text=>unistr('V filtru z ve\010D vrednostmi je bilo uporabljenih preve\010D elementov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744099748401941)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sl'
,p_message_text=>unistr('Za atribut "%0" ni dolo\010Den noben stolpec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667323731401883)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>'Telo funkcije PL/SQL ni vrnilo vrednosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114757215806401951)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'sl'
,p_message_text=>'Vir podatkov REST ne vsebuje operacije za obravnavo zahtevanega dejanja DML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114663241523401880)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'sl'
,p_message_text=>'Pretvorba GeoJSON v SDO_GEOMETRY (stolpec %0) ni na voljo v tej bazi podatkov.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664365573401881)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'sl'
,p_message_text=>'Pretvorba SDO_GEOMETRY (stolpec %0) ni podprta za vire podatkov XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114671667983401886)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'sl'
,p_message_text=>unistr('Znak %0 ni podprt kot lo\010Dilo za ve\010D vrednosti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114798982777401983)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'sl'
,p_message_text=>unistr('Te funkcije ni mogo\010De uporabiti za kontekst poizvedbe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114664461428401881)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>'Podatkovni tip stolpca se ne ujema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667230142401883)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'sl'
,p_message_text=>unistr('Prekora\010Dene notranje omejitve vezave ORDS OUT. Zmanj\0161ajte \0161tevilo vrstic DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114745037095401942)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Odgovora JSON oddaljenega stre\017Enika ni bilo mogo\010De raz\010Dleniti: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114667161796401883)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Neznan ali napa\010Den tip konteksta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114761639648401954)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'sl'
,p_message_text=>unistr('Tega tipa datoteke raz\010Dlenjevalnik ne podpira.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716289080401919)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Nepoobla\0161\010Den dostop (wwv_flow_api.set_credentials ni nastavljeno).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693244108401902)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'sl'
,p_message_text=>unistr('Delovni prostor ni bil ustvarjen, ker \017Ee obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114693151280401902)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'sl'
,p_message_text=>unistr('Skupina uporabnikov ni bila ustvarjena, ker \017Ee obstaja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703479867401910)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'sl'
,p_message_text=>unistr('Podvojeno uporabni\0161ko ime najdeno za %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703574049401910)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri nalaganju uporabnikov. Ni uspelo za uporabnika %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713453103401917)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'sl'
,p_message_text=>unistr('Nalo\017Eilo bi se toliko uporabnikov: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713273791401917)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'sl'
,p_message_text=>'Geslo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713346048401917)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'sl'
,p_message_text=>'Privilegiji'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713090925401917)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'sl'
,p_message_text=>unistr('Uporabni\0161ko ime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789551209401976)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'sl'
,p_message_text=>'Napaka med upodabljanjem elementa strani #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709198570401914)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Elementa strani ni mogo\010De prikazati, ker obrazec HTML \0161e ni bil odprt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114674459218401888)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri izra\010Dunavanju privzete vrednosti elementa za element strani #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708466302401913)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri izra\010Dunavanju objave elementa za element strani #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708378142401913)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri izra\010Dunavanju izvorne vrednosti elementa za element strani #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688157465401898)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'sl'
,p_message_text=>unistr('Nepoobla\0161\010Den dostop.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708686979401914)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'sl'
,p_message_text=>'JavaScript ni podprt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708759452401914)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'sl'
,p_message_text=>'Seznam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114709336494401914)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni bilo mogo\010De inicializirati poizvedbe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716584608401919)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'sl'
,p_message_text=>'Posodobitev %0 ni podprta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114710711428401915)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven ID elementa: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114737014427401936)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'sl'
,p_message_text=>unistr('Za ta element ne obstaja nobena pomo\010D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701590028401908)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'sl'
,p_message_text=>'Ustvarjanje poizvedbe grafikona ni uspelo. Preverite nastavitve preslikave izvora in stolpcev.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796355019401981)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'sl'
,p_message_text=>'Velikost priloge %0 MB presega maksimalno velikost priloge %1 MB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702448162401909)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'sl'
,p_message_text=>'Neveljavna vrednost za parameter p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114819865105401999)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'sl'
,p_message_text=>unistr('Presegli ste maksimalno \0161tevilo e-po\0161tnih sporo\010Dil na delovni prostor. Obrnite se na svojega skrbnika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683478954401895)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'sl'
,p_message_text=>'Ta postopek je treba priklicati iz seje aplikacije.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702318530401909)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'sl'
,p_message_text=>'Vrednost NULL navedena za parameter %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756396942401950)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161tne predloge "%0" ni bilo mogo\010De najti v aplikaciji %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114832882966402009)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Parameter instance SMTP_HOST_ADDRESS mora biti nastavljen za po\0161iljanje po\0161te.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702045530401908)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Za po\0161iljanje po\0161te je treba navesti prejemnika sporo\010Dila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114822243750402001)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Povezave SMTP s konfiguriranim e-po\0161tnim stre\017Enikom ni bilo mogo\010De vzpostaviti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114796411411401981)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'sl'
,p_message_text=>'Neveljaven klic Ajax!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687800918401898)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Za vti\010Dnik %0 ni bila dolo\010Dena nobena funkcija Ajax')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786837451401974)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Nobena funkcija izvajanja ni bila dolo\010Dena za vti\010Dnik %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687923691401898)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Za vti\010Dnik %0 ni bila dolo\010Dena nobena funkcija upodobitve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797309085401982)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Vti\010Dnik vira podatkov REST "%0" ne vsebuje funkcije "Zmo\017Enosti".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797262449401982)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Vti\010Dnik vira podatkov REST "%0" ne vsebuje funkcije DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797430465401982)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Vti\010Dnik vira podatkov REST "%0" ne vsebuje funkcije izvajanja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114797560752401982)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'sl'
,p_message_text=>unistr('Vti\010Dnik vira podatkov REST "%0" ne vsebuje funkcije pridobivanja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685644190401896)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka v kodi PLSQL, do katere je pri\0161lo med obdelovanjem vti\010Dnika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692242260401901)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>unistr('Vrednost mora biti dolo\010Dena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722846931401924)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sl'
,p_message_text=>unistr('Podatkovnega tipa %0 ni mogo\010De pretvoriti v VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808463690401990)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpca "%0", dolo\010Denega za atribut "%1", ni bilo mogo\010De najti v izpisku SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784792379401972)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'sl'
,p_message_text=>'Za %0 mora biti navedena poizvedba o seznamu vrednosti (LOV) ali poimenovan seznam vrednosti.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114786364506401973)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'sl'
,p_message_text=>unistr('\0160tevilo stolpcev v poizvedbi LOV SQL za %0 je napa\010Dno. Oglejte si primere veljavnih izpiskov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808224442401990)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sl'
,p_message_text=>unistr('Za atribut "%0" ni dolo\010Den noben stolpec.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837935845402013)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('Vnesena vrednost %0 za atribut "%1" ni \0161tevilska.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114789801027401976)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 vsebuje napa\010Den tip podatkov v izpisku SQL. Stolpec \0161t. %1 je %2, vendar pri\010Dakovano je bilo %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114808351241401990)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpec "%0", dolo\010Den za atribut "%1", ima tip podatkov %2, a bi moral imeti %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114684920275401896)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni mogo\010De najti postavitve poro\010Dila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744900535401942)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'sl'
,p_message_text=>unistr('Funkcije Vsota izra\010Duna ni mogo\010De uporabiti za poro\010Dila na osnovi vira podatkov REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114708585714401913)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('ERR-2904 Ni mogo\010De nastaviti vrednosti bli\017Enjice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114712876088401917)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka: Neznan tip bli\017Enjice.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114702818554401909)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni bilo mogo\010De pridobiti authentication_scheme v aplikaciji %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114776383873401966)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'sl'
,p_message_text=>unistr('ID najemnika \017Ee obstaja za trenutno sejo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114713112925401917)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'sl'
,p_message_text=>unistr('E-po\0161ta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837322194402012)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'sl'
,p_message_text=>'Preverjanje pristnosti ni uspelo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114739692029401938)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'sl'
,p_message_text=>unistr('Eden ali ve\010D pi\0161kotkov, nastavljenih v apex_util.g_request_cookies, vsebuje neveljavno vrednost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114722115577401924)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'sl'
,p_message_text=>'Odgovor registra UDDI je bil neveljaven.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114685722926401896)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'sl'
,p_message_text=>'Navedeni URL ni vrnil veljavnega dokumenta WSDL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114688253549401898)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'sl'
,p_message_text=>unistr('Dokument WSDL vsebuje ve\010D vezav SOAP. &PRODUCT_NAME. podpira samo WSDL-je z eno vezavo SOAP. Za nadaljevanje postopka ustvarjanja reference za to storitev kliknite Ro\010Dno ustvari referenco spletne storitve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114756669365401951)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'sl'
,p_message_text=>'Odgovor storitve ni bil XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837274509402012)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'sl'
,p_message_text=>unistr('\017Deton za dostop OAuth ni na voljo ali pa je potekel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114800465744401984)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'sl'
,p_message_text=>unistr('Presegli ste maksimalno \0161tevilo zahtev spletne storitve na delovni prostor. Obrnite se na svojega skrbnika.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114837494674402012)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'sl'
,p_message_text=>unistr('Stre\017Enik se je odzval z nepodprtim tipom \017Eetona OAuth.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687646854401898)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'sl'
,p_message_text=>'Dokument WSDL ni vseboval vezave za SOAP, ki je zahtevana za namene dodajanja reference.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114683513580401895)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'sl'
,p_message_text=>unistr('Ta WSDL zahteva poverilnice za preverjanje pristnosti. Spodaj navedite uporabni\0161ko ime in geslo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114692352913401901)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'sl'
,p_message_text=>unistr('Dokumenta WSDL mehanizem upodabljanja ni mogel razumeti. Za nadaljevanje postopka ustvarjanja reference za to storitev kliknite Ro\010Dno ustvari referenco spletne storitve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114759235097401953)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'sl'
,p_message_text=>unistr('Ni bilo mogo\010De obdelati posodobitve.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114785007315401972)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'sl'
,p_message_text=>unistr('Stolpec za vra\010Dilo in stolpec za prikaz na seznamu vrednosti sta enaka!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114784928134401972)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'sl'
,p_message_text=>unistr('Seznam vrednosti nima stolpca za vra\010Dilo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716436031401919)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri pridobivanju vrednosti stolpca: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740477618401938)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'sl'
,p_message_text=>unistr('Trenutni podatki tabelarnega obrazca so prestari; izvorni podatki so bili spremenjeni.<br/> Kliknite <strong><a href="%0">tukaj</a></strong>, da zavr\017Eete spremembe in znova nalo\017Eite podatke iz baze podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698588404401906)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'sl'
,p_message_text=>unistr('Napaka pri dolo\010Danju niza \0161tevil\010Denja strani')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698485976401906)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ni mogo\010De dolo\010Diti naslovov poizvedbe:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698621771401906)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'sl'
,p_message_text=>unistr('napaka pri izvajanju zamenjav noge poro\010Dila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698768610401906)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('raz\010Dlenjevanje poizvedbe SQL ni uspelo:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703742850401910)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'sl'
,p_message_text=>unistr('Minimalno \0161tevilo zahtevanih vrstic: %0, \0161tevilo najdenih vrstic, ki pa niso prikazane: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701201243401908)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'sl'
,p_message_text=>'stolpec poizvedbe #%0 (%1) je neveljaven, stolpci, ki uporabljajo HTML, potrebujejo druga imena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114716320966401919)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'sl'
,p_message_text=>'Napaka pri pridobivanju naslovov poizvedb: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698855962401906)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('napaka poro\010Dila:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114736546606401935)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'sl'
,p_message_text=>'Razvrsti po tem stolpcu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701344460401908)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'sl'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Poizvedbe ni mogo\010De raz\010Dleniti, preverite sintakso svoje poizvedbe.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740569783401938)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'sl'
,p_message_text=>'Ta obrazec vsebuje neshranjene spremembe. Pritisnite "V redu", da nadaljujete, ne da bi shranili spremembe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114744809992401941)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'sl'
,p_message_text=>unistr('Shema \0161tevil\010Denja strani poro\010Dila (%0) ni podprta z izbranim virom podatkov.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114701117047401908)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'sl'
,p_message_text=>'stolpec poizvedbe #%0 (%1) je neveljaven, uporabite drugo ime stolpca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703858608401910)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'sl'
,p_message_text=>unistr('vrstice %0 - %1 od ve\010D kot %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114742517823401940)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'sl'
,p_message_text=>unistr('%0 - %1 od ve\010D kot %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114703629745401910)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'sl'
,p_message_text=>'vrstice %0 - %1 od %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114687544772401898)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'sl'
,p_message_text=>'%0 - %1 od %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698939629401906)
,p_name=>'Y'
,p_message_language=>'sl'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114705019397401911)
,p_name=>'YEAR'
,p_message_language=>'sl'
,p_message_text=>'leto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114698144132401906)
,p_name=>'YEARS'
,p_message_language=>'sl'
,p_message_text=>'leta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114740648659401938)
,p_name=>'YES'
,p_message_language=>'sl'
,p_message_text=>'Da'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4486)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4486)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Namizje'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4486
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4486)
,p_name=>unistr('Sporo\010Dila')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('Sporo\010Dila')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
