prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4489
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4489 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4489
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103734924403872')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'sr-latn'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4489)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113353'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4489)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4489)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4489)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4489)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4489)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4489)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.sr-latn'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4489)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4489)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4489)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4489)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4489)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4489)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.sr-latn'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4489)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4489)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4489)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4489)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4489)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4489)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.sr-latn'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4489)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4489)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.sr-latn'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4489)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4489)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.sr-latn'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4489)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4489)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.sr-latn'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4489)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4489)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4489)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.sr-latn'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4489
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4489)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4489)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4489)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4489
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4489)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4489
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4489)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4489
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4489)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4489
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4489)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4489
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4489)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4489
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4489
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4489)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4489)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4489)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4489)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4489)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4489)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4489)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4489)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4489)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4489)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4489)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4489)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4489)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4489)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4489)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4489)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4489)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4489)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4489)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4489)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4489)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4489)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4489
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4489)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4489)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4489)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4489)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4489)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4489
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4489)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4489
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4489)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4489
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4489)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4489
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4489)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4489
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4489)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4489
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4489)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4489)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4489)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4489)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4489)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4489)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4489)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4489)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4489)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4489
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4489)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4489)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4489)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4489)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4489)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4489)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4489)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4489
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4489)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4489
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4489)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4489
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4489)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4489)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4489)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4489)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4489)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4489)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4489)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4489)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4489)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4489)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4489)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4489)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4489)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4489)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4489)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4489)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4489)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4489)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4489)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4489)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4489)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4489)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4489)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4489)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4489)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4489)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4489)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4489)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4489)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4489)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4489)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4489)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4489)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4489)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4489)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4489)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4489)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4489)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4489)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4489)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4489)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4489)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4489)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4489)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4489)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4489)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4489)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4489)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4489)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4489)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4489)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4489)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4489)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4489)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4489)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4489)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4489)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4489)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4489)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4489)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4489)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4489)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4489)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4489)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4489)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4489)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4489)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4489)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4489)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4489)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4489)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4489)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4489)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4489)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4489)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4489)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4489)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4489)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4489)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4489)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4489)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4489)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4489)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4489)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4489)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4489)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4489)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4489)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4489)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4489)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4489)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4489)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4489)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4489)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4489)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4489)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4489)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4489)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4489)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4489)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4489)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4489)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4489)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4489)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4489)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4489)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4489)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4489)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4489)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4489)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4489)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4489)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4489)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4489)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4489)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4489)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4489)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4489)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4489)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4489)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4489)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4489)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4489)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4489)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4489)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4489)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4489)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4489)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4489)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4489)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4489)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4489)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4489)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4489)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4489)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4489)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4489)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4489)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4489)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4489)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4489)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4489)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4489)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4489)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4489)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4489)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4489)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4489)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4489)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4489)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4489)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4489)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4489)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4489)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4489)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4489)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4489)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4489)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4489)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4489)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4489)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4489)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4489)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4489)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4489)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4489)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4489)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4489)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4489)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4489)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4489)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4489)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113030415403880)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'sr-latn'
,p_message_text=>'Column %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113155804403880)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'sr-latn'
,p_message_text=>'Administrator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113295181403880)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Username'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113377083403880)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Access Denied'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113411196403880)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'sr-latn'
,p_message_text=>'Your %0 account has been created.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113577996403880)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'sr-latn'
,p_message_text=>'The account is locked.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113662811403880)
,p_name=>'AM_PM'
,p_message_language=>'sr-latn'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221766985403898)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Toggle %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221850318403898)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'sr-latn'
,p_message_text=>'(Active)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113755596403880)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Ajax call returned server error %0 for %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113882306403880)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'sr-latn'
,p_message_text=>'The application alias "%0" can not be converted to a unique application ID.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116113977109403880)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Application with the alias "%0" does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114012361403880)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1816 Unexpected error converting application alias p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114116780403880)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'The application checksum provides an easy way to determine whether the same application is deployed across workspaces. You can compare this checksum to determine whether there is a match. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114278764403880)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing authentication function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114380196403880)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing authentication function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114478107403880)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Tenant Name %0 returned by Oracle Cloud Identity Management isn''t authorized for the domain %1!<br/>Please <a href="&LOGOUT_URL.">re-login</a> and specify an authorized tenant name or change your URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114553462403880)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'sr-latn'
,p_message_text=>'Your account "%0" does not have the necessary development privileges (DB_DEVELOPER or DB_ADMINISTRATOR)<br/>for workspace "%1"! Please <a href="&LOGOUT_URL.">re-login</a> after privileges have been provided.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114689184403880)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Tenant Name returned by Oracle Cloud Identity Management isn''t authorized for current workspace!<br/>Please <a href="&LOGOUT_URL.">re-login</a> and specify an authorized tenant name.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114727177403880)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'sr-latn'
,p_message_text=>'For security reasons, running applications of this workspace via the domain in the URL is not allowed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114874885403880)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Please ask your DBA to run $OH/rdbms/admin/catldap.sql.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116114916264403880)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'sr-latn'
,p_message_text=>'SYS.DBMS_LDAP package does not exist or is invalid.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115019676403880)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing edit LDAP user function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115113723403880)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing LDAP authentication.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115204325403880)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'sr-latn'
,p_message_text=>'Error in p_flow_page argument to login_page procedure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115366773403880)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid p_session in wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116103846041403878)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Malformed argument to wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116103961939403878)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'sr-latn'
,p_message_text=>'Null username passed to login procedure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104061586403878)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Please wait <span id="apex_login_throttle_sec">%0</span> seconds to sign in again.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104121820403879)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'The login attempt has been blocked.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104284184403879)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Authentication "%0" not found'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104376110403879)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'sr-latn'
,p_message_text=>'Security group ID is null.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104418785403879)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error executing post-authentication process.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104564334403879)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing pre-authentication process.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104624074403879)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Please open the URL in the same browser where you initiated the Reset Password request.  If you click the Reset Password URL and are redirected to',
'the login page, please initiate the Reset Password again and leave the',
'browser open.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104725548403879)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset Password URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104813051403879)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Resource Manager consumer group %0 has not been granted to %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116104929138403879)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'sr-latn'
,p_message_text=>'Please use DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP to grant the missing privilege.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105041913403879)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing session sentry function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105157404403879)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing session verification function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105287887403879)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Please ask your %0 administrator to configure the engine for Oracle Application Server Single Sign-On.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105325693403879)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'sr-latn'
,p_message_text=>'Illegal %0 in %1 token returned by sso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105474200403879)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'sr-latn'
,p_message_text=>'Please edit the authentication scheme and add the application name.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105502733403879)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'sr-latn'
,p_message_text=>'Illegal caller of %0 procedure:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105642168403879)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid app session in urlc token: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105742683403879)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Error in portal_sso_redirect: missing application registration information: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105872989403879)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'sr-latn'
,p_message_text=>'WWSEC_SSO_ENABLER_PRIVATE package does not exist or is invalid.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116105921967403879)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to find registered partner application name in authentication scheme.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106006532403879)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'sr-latn'
,p_message_text=>'Please register this application as described in the installation guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106179573403879)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing SSO authentication.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106259070403879)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'sr-latn'
,p_message_text=>'Unauthorized URL:  %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106313433403879)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing authentication.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106450727403879)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'sr-latn'
,p_message_text=>'Workspace "%0" is inactive. Contact your administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106586092403879)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'sr-latn'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106664016403879)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Access denied by Application security check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106701141403879)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Access denied by Page security check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106872064403879)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing authorization.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116106937608403879)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'sr-latn'
,p_message_text=>'Built with %0 using %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107083975403879)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214914070403897)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Event Description'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215062134403897)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'sr-latn'
,p_message_text=>'End Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215159637403897)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'sr-latn'
,p_message_text=>'Event ID'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215213578403897)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'sr-latn'
,p_message_text=>'Start Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215383910403897)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Event Title'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107141352403879)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Checksum content error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107299721403879)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Checksum format error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215489045403897)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'sr-latn'
,p_message_text=>'Copied to clipboard.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107340642403879)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'sr-latn'
,p_message_text=>'This browser does not support copy from a button or menu. Try Ctrl+C or Command+C.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215515380403897)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Close Notification'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215659171403897)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'sr-latn'
,p_message_text=>'Contrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215786446403897)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'sr-latn'
,p_message_text=>'Current'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215859383403897)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Initial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116215925062403897)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be a valid color. Example: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216049309403897)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose a color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216190041403897)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Change color format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216207710403897)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'sr-latn'
,p_message_text=>'List of Values'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216332614403897)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'sr-latn'
,p_message_text=>'Open list for: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216408748403897)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'sr-latn'
,p_message_text=>'(Completed)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107493672403879)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'sr-latn'
,p_message_text=>'Contact your application administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107556573403879)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contact your application administrator.',
'Details about this incident are available via debug id "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216553853403897)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'sr-latn'
,p_message_text=>'Correct errors before saving.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216655113403897)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 matches found'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216706145403897)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'sr-latn'
,p_message_text=>'No matches found'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107618580403879)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'sr-latn'
,p_message_text=>'Current Progress'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107709018403879)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'File specified in %0 item does not exist in APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107868607403879)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'sr-latn'
,p_message_text=>'Current version of data in database has changed since user initiated update process.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116107964719403879)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'sr-latn'
,p_message_text=>'Do Not Load'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108013929403879)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'Preprocessing error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108119298403879)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'sr-latn'
,p_message_text=>'Insert row'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108280094403879)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Sequence : Action'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108312004403879)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Update row'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216822933403897)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Popup Calendar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108461814403879)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108515942403879)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116216900008403897)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must have some value.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217056173403897)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be a valid date, for example %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217131991403897)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be between %0 and %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217233260403897)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be on or after %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217304857403897)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be on or before %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108603481403879)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# is greater than specified maximum date %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217424624403897)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# does not match format %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108761622403879)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# is less than specified minimum date %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108850156403879)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# is not in valid range of %0 to %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116108938398403879)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# is not within valid year range of %0 and %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217541932403897)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Cancel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217600971403897)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'sr-latn'
,p_message_text=>'Close'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217716938403897)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217819068403897)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'sr-latn'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116217910722403897)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Save'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109014000403879)
,p_name=>'APEX.ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109136089403879)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'The following error has occurred while executing the error handling callback: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109276759403879)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error occurred while painting error page: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109325092403879)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Internal Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109408866403879)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Contact your administrator.',
'Details about this incident are available via debug id "%0".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109547535403879)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'sr-latn'
,p_message_text=>'The database is open for read-only access.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109604855403879)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'sr-latn'
,p_message_text=>'ORA-28353: Failed to open wallet. Application data currently not accessible.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109768271403879)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Sorry, this page isn''t available'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218018977403897)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'sr-latn'
,p_message_text=>'Technical Info (only visible for developers)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218158712403897)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Error Message'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109834110403879)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Expected format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116109965146403879)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'sr-latn'
,p_message_text=>'User is already in Access Control List'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110070282403879)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'sr-latn'
,p_message_text=>'Please confirm adding the following %0 user(s) to <strong>%1</strong> access control list.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110105710403879)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate user exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110217086403880)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'sr-latn'
,p_message_text=>'Missing at-sign (@) in Email address'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110314116403880)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Missing period (.) in Email address'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110456174403880)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'sr-latn'
,p_message_text=>'Username is too long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110567714403880)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Only users defined in the application access control list may access this application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110630163403880)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Unexpected Access Control Setting Value: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110749789403880)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'sr-latn'
,p_message_text=>'All authenticated users can access this application'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110878342403880)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Disabled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116110929741403880)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Enabled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111021944403880)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'%0: Is Disabled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111117519403880)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'%0: Is Enabled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111231973403880)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'sr-latn'
,p_message_text=>'not identified'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111361249403880)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Download'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218249379403897)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'sr-latn'
,p_message_text=>'Applied Filter %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218363218403897)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Apply'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218449399403897)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Bar Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218596345403897)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'sr-latn'
,p_message_text=>'Others'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218627949403897)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'sr-latn'
,p_message_text=>'Pie Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218784635403897)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218895632403897)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Count'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116218973217403897)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Clear'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219055474403897)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Clear All'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219100063403897)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Clear %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111405893403880)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'sr-latn'
,p_message_text=>'Column %1, referenced by facet %0, is not available or unauthorized.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219286412403897)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose Filters to show'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219377242403898)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 results'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219455428403898)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 selected'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219545410403898)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'sr-latn'
,p_message_text=>'Current filters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219669148403898)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Filters list'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111590062403880)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'sr-latn'
,p_message_text=>'Distinct value limit (%0) exceeded for facet %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111651116403880)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Facet %0 is not supported for DATE or TIMESTAMP columns.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219794101403898)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219814001403898)
,p_name=>'APEX.FS.GO'
,p_message_language=>'sr-latn'
,p_message_text=>'Go'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116219935317403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'equals %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220020358403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'sr-latn'
,p_message_text=>'contains %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220198295403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'sr-latn'
,p_message_text=>'greater than %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220296569403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'sr-latn'
,p_message_text=>'greater than or equals %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220374879403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'sr-latn'
,p_message_text=>'less than %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220419810403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'sr-latn'
,p_message_text=>'less than or equals %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220551812403898)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'sr-latn'
,p_message_text=>'starts With %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111758417403880)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'The %0 data type (%1) is not supported for the Input Field facet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111819328403880)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'sr-latn'
,p_message_text=>'Multi-Value facets require 12.2 or higher databases.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116111976361403880)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'sr-latn'
,p_message_text=>'No search columns have been provided for facet %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220656332403898)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'sr-latn'
,p_message_text=>'More Filters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220799251403898)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'sr-latn'
,p_message_text=>'Range Begin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220886822403898)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 to %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116220962957403898)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'sr-latn'
,p_message_text=>'Above %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221077070403898)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'sr-latn'
,p_message_text=>'Below %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221102150403898)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'sr-latn'
,p_message_text=>'Range End'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112024259403880)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'LOV item #%2 ("%1") for range facet %0 is invalid ("|" separator missing).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112148638403880)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Manual Input for Range facet %0 is currently not supported, since the column is DATE or TIMESTAMP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112235343403880)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'to'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221205123403898)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112399355403880)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112450382403880)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Search'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112535855403880)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'sr-latn'
,p_message_text=>'Search...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112680216403880)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221347004403898)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Show Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221407999403898)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'sr-latn'
,p_message_text=>'Show Less'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221526353403898)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Show More'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112778977403880)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 stars and up'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221676243403898)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter suggestions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112872995403880)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Text Field facet %0 is currently only supported for NUMBER columns.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116112948550403880)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Total Row Count'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211194084403896)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'The %0 data type (%1) is not supported for faceted search.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211295016403896)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Go to error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249501121403902)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregate.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249641988403902)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'sr-latn'
,p_message_text=>'Collapse control break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249702479403903)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Control break.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249849751403903)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'sr-latn'
,p_message_text=>'Expand control break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249920795403903)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Column %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250078761403903)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 rows deleted'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250198343403903)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate identity'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250233604403903)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'First'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250384731403903)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Group header.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250445200403903)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Header.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250581597403903)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Last'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250611685403903)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Load More Rows'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250714040403903)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250888352403903)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Page rows'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116250916902403903)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251089924403903)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 - %1 of %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251168070403903)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Page Selection'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251233595403903)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251396042403903)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'sr-latn'
,p_message_text=>'Added'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251483580403903)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'sr-latn'
,p_message_text=>'Changed'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251560480403903)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Row %0, Column %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251623457403903)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Row %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251731494403903)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'sr-latn'
,p_message_text=>'Deleted'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251806316403903)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'sr-latn'
,p_message_text=>'Row header'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116251945082403903)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 cells selected'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252095922403903)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 rows selected'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252153977403903)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Select All'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252272070403903)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'sr-latn'
,p_message_text=>'Page %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252393897403903)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Select Row'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252483277403903)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Sorted Ascending %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252561044403903)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Sorted Descending %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252674337403903)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Ascending'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252771359403903)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Ascending %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252897066403903)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Descending'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116252902438403903)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Descending %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253047889403903)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'sr-latn'
,p_message_text=>'Don''t Sort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253199434403903)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'sr-latn'
,p_message_text=>'Total %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211372411403896)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'The HTTP request to "%0" failed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253231629403903)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'sr-latn'
,p_message_text=>'Grid Select List %0 columns %1 rows. Use arrow keys'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253319024403903)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'sr-latn'
,p_message_text=>'Select List %0 rows. Use arrow keys'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211412905403896)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Grid %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253468820403903)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253519139403903)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'sr-latn'
,p_message_text=>'Add'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253627038403903)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Add Row'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253725464403903)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253835847403903)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116253951298403903)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'All'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254089313403903)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'All Text Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254105072403903)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Alternative'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254250016403903)
,p_name=>'APEX.IG.AND'
,p_message_language=>'sr-latn'
,p_message_text=>'and'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254375745403903)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'sr-latn'
,p_message_text=>'Approx. Count Distinct'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254453173403903)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overal Approx. Count Distinct'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254547878403903)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'sr-latn'
,p_message_text=>'Area'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254667752403903)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Ascending'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254755242403903)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Authorization'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254899603403903)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'sr-latn'
,p_message_text=>'Auto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116254946919403903)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'sr-latn'
,p_message_text=>'Average'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255056090403903)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Average'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255156907403903)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Label Axis Title'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255217151403903)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Decimal Places'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255341308403903)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Value Axis Title'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255451180403903)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Background Color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255582063403903)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Bar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255637103403903)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'sr-latn'
,p_message_text=>'between'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255712258403903)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Both'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255836824403903)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Bubble'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116255928177403904)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Cancel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256078943403904)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Case Sensitive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256146289403904)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'sr-latn'
,p_message_text=>'(Case Sensitive)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256267666403904)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'sr-latn'
,p_message_text=>'Changes saved'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256399884403904)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Change View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256467139403904)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256540683403904)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Your query exceeds the maximum of %0 data points per chart. Please apply a filter to reduce the number of records in your base query.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256690262403904)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256761120403904)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Clear'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256870449403904)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Close'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116256917793403904)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'sr-latn'
,p_message_text=>'Colors'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257071474403904)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Preview'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257135550403904)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Column'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257280688403904)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257356306403904)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Column Purpose'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257440606403904)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'sr-latn'
,p_message_text=>'Complex'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257540336403904)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'Compute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257674436403904)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'sr-latn'
,p_message_text=>'contains'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257743099403904)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'sr-latn'
,p_message_text=>'Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257868950403904)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'sr-latn'
,p_message_text=>'Copy to Clipboard'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116257989550403904)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'sr-latn'
,p_message_text=>'Copy Down'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258000447403904)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Count'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258139299403904)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'sr-latn'
,p_message_text=>'Count Distinct'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258270905403904)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Count Distinct'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258304276403904)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Count'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258485348403904)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Create %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258594951403904)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'sr-latn'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258679979403904)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Data Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258740232403904)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258873694403904)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Date Value'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116258901808403904)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259027326403904)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Default Settings'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259147375403904)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Default Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259228999403904)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259343070403904)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'sr-latn'
,p_message_text=>'Are you sure you would like to delete this report?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259485746403904)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete Row'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259540586403904)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete Rows'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259638160403904)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Descending'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259747700403904)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Detail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259850035403904)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Detail View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116259950610403904)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Direction'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260019455403904)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Disabled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260160748403904)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'sr-latn'
,p_message_text=>'does not contain'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260247363403904)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'sr-latn'
,p_message_text=>'does not start with'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260318376403904)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'sr-latn'
,p_message_text=>'Donut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260407509403904)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'sr-latn'
,p_message_text=>'Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260580465403904)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Data Only'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278774370403907)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214118105403897)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Download Format %0 is not enabled.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278829034403907)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate Aggregation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278910102403907)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279031258403907)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate Row'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279136725403907)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate Rows'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279273890403907)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279367753403907)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279458640403907)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Group By'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279542261403907)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'sr-latn'
,p_message_text=>'Blind Copy (bcc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279666589403907)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'sr-latn'
,p_message_text=>'Message'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279713561403907)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'sr-latn'
,p_message_text=>'Copy (cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279833198403907)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'sr-latn'
,p_message_text=>'Email sent.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116279908363403907)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'sr-latn'
,p_message_text=>'Subject'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280068528403907)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'sr-latn'
,p_message_text=>'Recipient (to)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280176243403907)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Enabled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280280425403907)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'sr-latn'
,p_message_text=>'equals'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280364347403907)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Example'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280471974403907)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Expression'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280514971403907)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280650520403907)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'sr-latn'
,p_message_text=>'File prepared. Starting download.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280790566403908)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'sr-latn'
,p_message_text=>'Fill'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280896319403908)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Fill selection with'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116280948111403908)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Fill Selection'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281038194403908)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281192432403908)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'sr-latn'
,p_message_text=>'Filters'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281238019403908)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281349874403908)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'sr-latn'
,p_message_text=>'First'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281423442403908)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'sr-latn'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281578122403908)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281652560403908)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'sr-latn'
,p_message_text=>'Format Mask'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281770735403908)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'sr-latn'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281832097403908)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'sr-latn'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116281969732403908)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'sr-latn'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282039265403908)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'sr-latn'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282117008403908)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'sr-latn'
,p_message_text=>'Freeze'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282283925403908)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'sr-latn'
,p_message_text=>'Functions and Operators'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282341590403908)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Funnel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282471167403908)
,p_name=>'APEX.IG.GO'
,p_message_language=>'sr-latn'
,p_message_text=>'Go'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282520415403908)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'sr-latn'
,p_message_text=>'greater than'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282694460403908)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'sr-latn'
,p_message_text=>'greater than or equals'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282723237403908)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'sr-latn'
,p_message_text=>'Grid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282889461403908)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Grid View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116282954581403908)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'sr-latn'
,p_message_text=>'Group'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283019457403908)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283186857403908)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283257493403908)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Condition Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283396122403908)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Heading'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283481297403908)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'sr-latn'
,p_message_text=>'Heading Alignment'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283555333403908)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214285468403897)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can insert, update, and delete data directly within this interactive grid.</p>',
'',
'<p>Insert a new row by clicking the Add Row button.</p>',
'',
'<p>Edit existing data by double-clicking a specific cell. For larger editing work, click Edit to enter editing mode. In editing mode, you can single-click or use the keyboard to edit specific cells.</p>',
'',
'<p>Use the Change menu to duplicate and delete rows. To enable the Change menu, use the check boxes to select one or more rows.</p>',
'',
'<p>Duplicate a selected row by clicking the Change menu and selecting Duplicate Rows. Delete a selected row by clicking the Change menu and selecting Delete Row.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214346545403897)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Editing Capabilities'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214485472403897)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An interactive grid presents a set of data in a searchable, customizable report. You can perform numerous operations to limit the records returned, and change the way the data is displayed.</p>',
'',
'<p>Use the Search field to filter the records returned. Click Actions to access numerous options for modifying the report layout, or use the Column Heading menus on displayed columns.</p>',
'',
'<p>Use Report Settings to save your customizations to a report. You can also download the data from the report to an external file or email the data to yourself or others.</p>',
'',
'<p>To learn more, see "Using Interactive Grids" in <em>Oracle Application Express End User''s Guide</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214595926403897)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Overview'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214611557403897)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can customize the interactive grid to display data in various different ways using the built-in capabilities.</p>',
'',
'<p>Use the Column Heading menus or the Actions menu to determine which columns to display, in what sequence, and freeze columns. You can also define various data filters and sort the data returned.</p>',
'',
'<p>Use the View button (adjacent to the Search field) to access other data views that may have been defined by the application developer. You can also create a chart or view an existing chart.</p>  ',
'',
'<p><em>Note: Click <strong>Help</strong> in the interactive grid dialogs to obtain more detailed information on the selected function.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214740301403897)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Reporting Capabilities'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283627965403908)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Grid Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214886779403897)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to aggregate columns. Aggregated values display at the bottom of the data, or if Control Breaks are defined, at the bottom of each break.</p>',
'',
'<p><strong>Aggregation List</strong><br>',
'The Aggregation list displays defined aggregations. Disable an existing aggregation by deselecting it.<br>',
'Click Add ( &plus; ) to create a new aggregation, or Delete ( &minus; ) to remove an existing aggregation.</p>',
'',
'<p><strong>Aggregation Settings</strong><br>',
'Use the form on the right to define the aggregation.<br>',
'Select the Column name and Aggregation type.<br>',
'Optionally, enter a tooltip for the aggregation.<br>',
'If you have defined a Control Break, selecting <strong>Show Overall Value</strong> displays the overall average, total, or similar value at the bottom of the data.</p>',
'',
'<p><em>Note: Access the Aggregation dialog in the Actions menu or by clicking the column heading and sum ( &sum; ).</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116283716726403908)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregation Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115498271403880)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to define a chart which displays as a separate data view.<br>',
'Select a chart Type, and chart attributes.</p>',
'<p><strong>Chart Attributes</strong></br>',
'The available chart attributes vary depending on the chart type.</p>',
'<p>',
'<ul>',
'  <li>Select the column containing the value for the attribute:',
'    <ul>',
'      <li>Label - The text for each data point.</li>',
'      <li>Value - The data to be plotted.</li>',
'      <li>Series - For defining your multi-series dynamic query.</li>',
'      <li>Open - The daily stock opening price (Stock only).</li>',
'      <li>Close - The daily stock close price (Stock only).</li>',
'      <li>High - The high value (Range and Stock only).</li>',
'      <li>Low - The low value (Range and Stock only).</li>',
'      <li>Volume - The daily stock volume (Stock only).</li>',
'      <li>Target - The target value (Funnel only).</li>',
'      <li>X - The x-axis value (Bubble and Scatter only).</li>',
'      <li>Y - The y-axis value (Bubble and Scatter only).</li>',
'      <li>Z - The bar width or bubble radius (Bar, Bubble, and Range only).</li>',
'    </ul>',
'  </li>',
'  <li>Orientation - Vertical or horizontal.</li>',
'  <li>Aggregation - Select how to aggregate the chart values.</li>',
'  <li>Stack - Specify whether the data items are stacked.</li>',
'  <li>Sort By - Sort by the label or value(s).',
'    <ul>',
'      <li>Direction - Sort in ascending or descending values.</li>',
'      <li>Nulls - Specify how to sort records with null values in relation to records with non null values.</li>',
'    </ul>',
'  </li>',
'  <li>Decimal Places</li>',
'  <li>Label Axis Title</li>',
'  <li>Value Axis Title</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116221939744403898)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115594739403880)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to choose which columns display and in what order.</p>',
'',
'<p>Hide a column by deselecting it.<br>',
'Reorder columns by clicking Move Up ( &uarr; ) or Move Down ( &darr; ).<br>',
'Use the drop down selector to list All columns, Displayed columns, or Not Displayed columns.</p>',
'',
'<p>Optionally, use the form to specify the minimum width of a column in pixels.</p>',
'',
'<p><em>Note: You can also reorder displayed columns by clicking the drag handle (at the start of the column heading) and dragging the column left or right. You can also change the column width of displayed columns by selecting the column separator, b'
||'etween headings, and moving it left or right.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222074593403898)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Columns Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115634660403880)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to define additional columns based on mathematical and functional computations performed against existing columns.</p>',
'',
'<p><strong>Computation List</strong><br>',
'The Computation list displays defined computations. Disable an existing computation by deselecting it.<br>',
'Click Add ( &plus; ) to add a new computation, or Delete ( &minus; ) to remove an existing computation.</p>',
'',
'<p><strong>Computation Settings</strong><br>',
'Use the form to define the computation.<br>',
'Enter the column details such as heading, label, and select alignment settings.<br> ',
'Use the Expression textarea to enter the column(s) and associated functions for the computation.<br>',
'Select the appropriate data type, and optionally a format mask, for the new column.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222183713403898)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Compute Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115786834403880)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to define a control break on one or more columns.</p>',
'',
'<p><strong>Control Break List</strong><br>',
'The Control Break list displays defined control breaks. Disable an existing control break column by deselecting it.<br>',
'Click Add ( &plus; ) to include a new column in the control break, or Delete ( &minus; ) to remove an existing column from the control break.<br>',
'To reorder columns, click Move Up ( &uarr; ) or Move Down ( &darr; ) to move the selected column up and down relative to other columns.</p>',
'',
'<p><strong>Control Break Settings</strong><br>',
'Use the form to define the control break column.<br>',
'Selected a control break column, the sort direction, and how to order null columns (columns with no value).</p>',
'',
'<p><em>Note: When viewing the interactive grid, you can define a control break by clicking a Column Heading and selecting the control break icon.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222260087403898)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Control Break Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115822203403880)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to download all the current rows to an external file. The file will contain only the currently displayed columns, using any filters and sorts applied to the data.</p>',
'',
'<p>Select the file format and click Download.<br>',
'Note: CSV will not include text formatting such as aggregates and control breaks.</p>',
'',
'<p>To email the file, select Send as Email and enter the email details (Recipient, Subject and Message).</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222325236403898)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Download Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116115941396403880)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to configure data filters which limit the rows returned.</p>',
'',
'<p><strong>Filter List</strong><br>',
'The Filter list displays defined filters. Disable an existing filter by deselecting it.<br>',
'Click Add ( &plus; ) to create a new filter, or Delete ( &minus; ) to remove an existing filter.</p>',
'',
'<p><strong>Filter Settings</strong><br>',
'Use the form to define the filter properties.<br>',
'Select the appropriate filter type:<br>',
'&nbsp;&nbsp;&nbsp;Row - filter for a term in any filterable column.<br>',
'&nbsp;&nbsp;&nbsp;Column - filter a specific column with a specified operator and value.</p>',
'',
'<p><em>Note: When viewing the interactive grid, you can define row filters by typing directly into the Search field. Click Select Columns to Search to limit the search to a specific column. Alternately, open a Column Heading menu and select a value t'
||'o create a column filter.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222465879403898)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116027633403880)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to view the data as it existed at a previous point in time.</p>',
'<p>Enter the number of minutes in the past to execute the flashback query.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222554172403898)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Flashback Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222667799403898)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116104025403881)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to highlight rows or columns of data based on the condition entered.</p>',
'',
'<p><strong>Highlight List</strong><br>',
'The Highlight list displays defined highlights. Disable an existing highlight by deselecting it.<br>',
'Click Add ( &plus; ) to create a new highlight, or Delete ( &minus; ) to remove an existing highlight.</p>',
'',
'<p><strong>Highlight Settings</strong><br>',
'Use the form to define the highlight properties.<br>',
'Enter the name, select Row or Column, and select the HTML color codes for the background and text.<br>',
'Select the appropriate <strong>Condition Type</strong> to highlight specific data:<br>',
'&nbsp;&nbsp;&nbsp;Row - highlight the term in any column.<br>',
'&nbsp;&nbsp;&nbsp;Column - highlight within a specific column based on the specified operator and value.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260690624403904)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211567658403896)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to save changes you have made to the current grid layout and configuration.<br>',
'Application developers can define multiple alternate report layouts. Where permissible, you and other end users can save a report as Public, which makes the report available to all other users of the grid. You can also save a report as a Private repo'
||'rt that only you can view.</p>',
'<p>Select from the available types and enter a name for the saved report.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260743293403904)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Report Help',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211634197403896)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this dialog to set the display order.</p>',
'',
'<p><strong>Sort List</strong><br>',
'The Sort dialog displays a list of configured sorting rules.<br>',
'Click Add ( &plus; ) to create a sort column, or Delete ( &minus; ) to remove a sort column.<br>',
'Click Move Up ( &uarr; ) and Move Down ( &darr; ) to move the selected sort column up and down relative to the other sort columns.</p>',
'',
'<p><strong>Sort Settings</strong><br>',
'Select a sort column, the sort direction, and how to order null columns (columns with no value).</p>',
'',
'<p><em>Note: Data can be sorted by columns which are not displayed; however, not all columns may be sortable.</em><br>',
'<em>Displayed columns can be sorted by pressing the up (ascending) or down (descending) arrows at the end of the column headings. To add a subsequent column to an existing sort, hold the Shift key and click the up or down arrow.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260884351403904)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116260904754403904)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Subscription Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261072215403904)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'sr-latn'
,p_message_text=>'Hide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261181715403904)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261259884403904)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'High'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261397060403904)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261462978403904)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261556039403904)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'sr-latn'
,p_message_text=>'Icon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261616469403904)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Icon View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261757040403904)
,p_name=>'APEX.IG.IN'
,p_message_language=>'sr-latn'
,p_message_text=>'in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261878449403904)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'sr-latn'
,p_message_text=>'Inactive Setting'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116261934938403904)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Inactive Settings'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211789445403896)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'An internal error has occurred while processing the Interactive Grid request.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211829005403896)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Column Filter Type "%0" is not supported for column "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262029725403904)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Date Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211976145403896)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Grid does not support defining a filter on the column %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212045709403896)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is not a valid filter type for defining an Interactive Grid filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262189903403904)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Number Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262254939403904)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Setting'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262388280403905)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Settings'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262405206403905)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort By has been set to %0, but no column as been selected for %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262544850403905)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Value'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262657994403905)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Not Displayed'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262768906403905)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'in the last'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262804884403905)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'in the next'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116262902118403905)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'is not empty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263099431403905)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'is empty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263169531403905)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263282052403905)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Label'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263357366403905)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'Last'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263419500403905)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Day'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263507004403905)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Hour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263619056403905)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263737808403905)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Month'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263883726403905)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116263978433403905)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264009790403905)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264114940403905)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264244465403905)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Months'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264384719403905)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264485823403905)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264578371403905)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Year'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264682655403905)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'sr-latn'
,p_message_text=>'Cell Alignment'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264788842403905)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Use Group For'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264880922403905)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'sr-latn'
,p_message_text=>'less than'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116264907336403905)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'sr-latn'
,p_message_text=>'less than or equals'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265009348403905)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'sr-latn'
,p_message_text=>'Line'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265135069403905)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'sr-latn'
,p_message_text=>'Line with Area'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265214900403905)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'sr-latn'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265398557403905)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Low'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265405340403905)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'sr-latn'
,p_message_text=>'Separate multiple addresses with commas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265518969403905)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'matches regular expression'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265651541403905)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'sr-latn'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265723127403905)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265888496403905)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'sr-latn'
,p_message_text=>'Median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116265983548403905)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266019562403905)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'sr-latn'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266162950403905)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266257154403905)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'Minutes ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266352376403905)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266446892403905)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'months'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266564131403905)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'The data contains more than %0 rows which exceeds the maximum allowed. Please apply additional filters in order to view the results.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212197180403896)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Region Static ID must be specified as the page contains multiple Interactive Grids.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266620385403905)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Name'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266713990403905)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Named Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266811887403905)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Day'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116266991761403905)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Hour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267091329403905)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267165675403905)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Month'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267228075403905)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267389646403905)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267465538403905)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267540426403905)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267616905403905)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Months'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267793905403905)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267822032403905)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116267947240403905)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Year'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268080546403905)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'sr-latn'
,p_message_text=>'not between'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268182487403905)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'sr-latn'
,p_message_text=>'not equals'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212210619403896)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Region with ID %0 is not an Interactive Grid region or does not exist in application %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268290400403905)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'sr-latn'
,p_message_text=>'not in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268325385403905)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'not in the last'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268474892403905)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'not in the next'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222760547403898)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'No data found'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222817509403898)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'sr-latn'
,p_message_text=>'Nulls'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116222966185403898)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'sr-latn'
,p_message_text=>'Numeric'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223026245403898)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'sr-latn'
,p_message_text=>'Off'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223185833403898)
,p_name=>'APEX.IG.ON'
,p_message_language=>'sr-latn'
,p_message_text=>'On'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223257007403898)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'1 minute ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223306747403898)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'sr-latn'
,p_message_text=>'Open Color Picker: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223410987403898)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Open'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223544934403898)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223648014403898)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Orientation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223798127403898)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'sr-latn'
,p_message_text=>'Pie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223877731403898)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116223912808403898)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224059154403898)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'sr-latn'
,p_message_text=>'Separate values with "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224154325403898)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224218096403898)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Center'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224381965403898)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'sr-latn'
,p_message_text=>'End'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224473497403898)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'sr-latn'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224587169403898)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'sr-latn'
,p_message_text=>'Primary'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224628260403898)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Primary Default'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224795991403898)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Primary Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224822136403898)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'sr-latn'
,p_message_text=>'Include Accessibility Tags'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116224964341403898)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'sr-latn'
,p_message_text=>'Landscape'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225044495403898)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'sr-latn'
,p_message_text=>'Portrait'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225159872403898)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'sr-latn'
,p_message_text=>'Page orientation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225297923403898)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'sr-latn'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225304092403898)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'sr-latn'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225426927403898)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'sr-latn'
,p_message_text=>'Custom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225519848403899)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'sr-latn'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225631313403899)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'sr-latn'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225756556403899)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'sr-latn'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225863980403899)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'sr-latn'
,p_message_text=>'Page size'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116225972458403899)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'sr-latn'
,p_message_text=>'Strip Rich Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226010683403899)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226176510403899)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Range'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226267469403899)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'sr-latn'
,p_message_text=>'Refresh'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226317684403899)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Refresh Row'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226489243403899)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Refresh Rows'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116284577403881)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Grid region does not exist in application %0, page %1 and region %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226569209403899)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226677132403899)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226781153403899)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'sr-latn'
,p_message_text=>'Report deleted'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226850846403899)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Alternative report saved for all users'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116226904268403899)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Default report saved for all users'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227059917403899)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Private report saved'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227193597403899)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'sr-latn'
,p_message_text=>'Public report saved for all users'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116372933403881)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Interactive Grid with name %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227272876403899)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'Report data as of %0 minutes ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227303067403899)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'Report data as of 1 minute ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116432055403881)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Grid Report does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227496966403899)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Report - Edit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116539852403881)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Interactive Grid with ID %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227543063403899)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'sr-latn'
,p_message_text=>'Report - Save As'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227642371403899)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Report Settings'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116699623403881)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Interactive Grid with static ID %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227796232403899)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Report View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227829758403899)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116227961831403899)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'sr-latn'
,p_message_text=>'Revert Changes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228084712403899)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Revert Rows'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228144275403899)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Row'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228240079403899)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Rows Per Page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228369283403899)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Row Actions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228476203403899)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Actions for row %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228599461403899)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Save'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228695138403899)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'sr-latn'
,p_message_text=>'saved'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228786147403899)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Reports'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228822486403899)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Default'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116768013403881)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'sr-latn'
,p_message_text=>'A saved report named %0 already exists. Enter a new name.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116228982076403899)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Private'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229029796403899)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'sr-latn'
,p_message_text=>'Public'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229179090403899)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'sr-latn'
,p_message_text=>'Save As'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229211432403899)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Save Report Settings'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229338271403899)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Scatter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229415851403899)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Search'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229571066403899)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Search: All Text Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229630687403899)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Search: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229725031403899)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Search: Full Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229801615403899)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'sr-latn'
,p_message_text=>'Search for ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116229978037403899)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230049281403899)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Selection'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230175492403899)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Select 1 row in the master region'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230285488403899)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Select columns to search'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230354029403899)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Selection Actions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230403267403899)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'sr-latn'
,p_message_text=>'Cell Selection'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230537429403899)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Row Selection'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230610688403899)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Send as Email'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230764074403899)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Series'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230818375403899)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'sr-latn'
,p_message_text=>'Show'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116230972471403899)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Show Overall Value'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231008549403899)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Single Row View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231116598403899)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231223110403899)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort By'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231306663403899)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'You can define only one sort per column.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231445986403899)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'Change Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231574713403899)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'sr-latn'
,p_message_text=>'Stack'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231695863403899)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'sr-latn'
,p_message_text=>'starts with'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231742107403899)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'sr-latn'
,p_message_text=>'Stock'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231859664403900)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Stretch Column Widths'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116231999378403900)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Subscription'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232066275403900)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'sr-latn'
,p_message_text=>'Sum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232170131403900)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Grid. Report: %0, View: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232215058403900)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Overall Sum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232365429403900)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Target'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232438782403900)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Text Color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232511492403900)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Toggle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232643943403900)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'sr-latn'
,p_message_text=>'Tooltip'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232789853403900)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232842099403900)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'sr-latn'
,p_message_text=>'Unfreeze'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116232952763403900)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Unit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268543405403905)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'sr-latn'
,p_message_text=>'There are unsaved changes. Do you want to continue?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268669753403905)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Value'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268710509403905)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Value'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268812340403905)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'A value is required.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116268988612403906)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'sr-latn'
,p_message_text=>'Value (time zone cannot be changed)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269005125403906)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'sr-latn'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269180138403906)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269267052403906)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'View'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269333795403906)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Displayed'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269402782403906)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269516409403906)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269685412403906)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Minimum Column Width (Pixel)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269704334403906)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 between %1 and %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269816675403906)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 contains %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116269937788403906)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 does not contain %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270084118403906)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 does not start with %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270112167403906)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 equals %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270208738403906)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 greater than %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270321070403906)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 greater than or equal to %1'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270460374403906)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270598431403906)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last %1 days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270685217403906)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last %1 hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270719041403906)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last %1 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270825318403906)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last %1 months'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116270995242403906)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last %1 weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271064664403906)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last %1 years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271146653403906)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last day'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271263131403906)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last hour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271324074403906)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271471914403906)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last month'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271569696403906)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271681302403906)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the last year'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271785502403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next %1 days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271880175403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next %1 hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116271954878403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next %1 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272049400403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next %1 months'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272198187403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next %1 weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272224247403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next %1 years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272398890403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next day'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272431674403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next hour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272551606403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272695983403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next month'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272785251403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272844322403906)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 in the next year'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116272977607403906)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is not empty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273007505403906)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is empty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273177554403906)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 less than %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273290623403906)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 less than or equal to %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273365452403906)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 like %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273499086403906)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 matches regular expression %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273505196403906)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 minutes ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273696272403906)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not between %1 and %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273790815403906)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not equals %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273827835403906)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116273981290403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last %1 days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274065896403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last %1 hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274134879403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last %1 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274215522403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last %1 months'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274389585403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last %1 weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274438956403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last %1 years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274514540403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last day'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274669877403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last hour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274768508403906)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274869039403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last month'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116274968624403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275060847403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the last year'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275155672403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next %1 days'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275237010403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next %1 hours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275302352403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next %1 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275400471403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next %1 months '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275528006403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next %1 weeks'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275675025403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next %1 years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275765044403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next day'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275874236403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next hour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116275983140403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276031912403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next month'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276123380403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next week'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276246773403907)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not in the next year'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276319014403907)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 not like %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276433892403907)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 starts with %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276513710403907)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276642045403907)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'years'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276758769403907)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276853147403907)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116276988014403907)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'sr-latn'
,p_message_text=>'Monday, 12 January, 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277000241403907)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'sr-latn'
,p_message_text=>'January'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277196427403907)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'sr-latn'
,p_message_text=>'16 hours ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277252301403907)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'sr-latn'
,p_message_text=>'in 16h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277380854403907)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid file type. Supported file types %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212321023403896)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'sr-latn'
,p_message_text=>'Browse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277493620403907)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose File'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277577407403907)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose Files'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277650801403907)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'Drag and Drop'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212494906403896)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'sr-latn'
,p_message_text=>'Drag and Drop Files'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277712629403907)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'Select a file or drop one here.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116852836403881)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'sr-latn'
,p_message_text=>'Select or drop files here.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116116936820403881)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'Select a file or drop one here.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117049560403881)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'sr-latn'
,p_message_text=>'Select or drop files here.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233071527403900)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 files'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233174326403900)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'sr-latn'
,p_message_text=>'File is too large. Maximum file size is %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233200777403900)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Address required.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233322087403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'sr-latn'
,p_message_text=>'City'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233482439403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'sr-latn'
,p_message_text=>'Country Code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233524501403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'sr-latn'
,p_message_text=>'House Number'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233607392403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'sr-latn'
,p_message_text=>'Latitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233713346403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'sr-latn'
,p_message_text=>'Longitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233817271403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'sr-latn'
,p_message_text=>'Show on Map'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116233953677403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Score'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234072718403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'sr-latn'
,p_message_text=>'Postal Code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234121610403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'sr-latn'
,p_message_text=>'State'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234202403403900)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'sr-latn'
,p_message_text=>'Street'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234348719403900)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Geocoding Results'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234451481403900)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'sr-latn'
,p_message_text=>'Geocoded'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234525042403900)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'sr-latn'
,p_message_text=>'Not Geocoded'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234644649403900)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Map'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234724987403900)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'No addresses found.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234850195403900)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is required.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116234913494403900)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Help Text: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235086529403900)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'sr-latn'
,p_message_text=>'Checked'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235166871403900)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'sr-latn'
,p_message_text=>'Unchecked'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117185854403881)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# is not in valid range of %0 to %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117215160403881)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# is not a multiple of %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117391517403881)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must match the values %0 and %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117424718403881)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117585476403881)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Off'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117698181403881)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117748611403881)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Yes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117859148403881)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'sr-latn'
,p_message_text=>'Add Entry'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116117970133403881)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'sr-latn'
,p_message_text=>'Add'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118082344403881)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118123913403881)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'sr-latn'
,p_message_text=>'Selected entries'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118229915403881)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'sr-latn'
,p_message_text=>'Advanced'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118321445403881)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Cancel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118478522403881)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'sr-latn'
,p_message_text=>'Common'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118511935403881)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Live Template Options'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118650582403881)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Template Options are not available because this component is not rendered on the page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118731328403881)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'No Template Options found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118815902403881)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Save'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235283687403900)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Clear Circle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116118970078403881)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'sr-latn'
,p_message_text=>'Custom Styles is not valid JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235347249403900)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'sr-latn'
,p_message_text=>'Distance Tool'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235429795403900)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Draw Circle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119033367403881)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'sr-latn'
,p_message_text=>'Faceted Search requires a Data Source at the region level.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235584565403900)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Current Location'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119171155403881)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Initial position coordinates are invalid.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119218403403881)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Initial position must be a point geometry.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235691313403900)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'sr-latn'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119352751403881)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'sr-latn'
,p_message_text=>'Layer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235760194403900)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Layer: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235858895403900)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'sr-latn'
,p_message_text=>'Map'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116235972637403900)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'sr-latn'
,p_message_text=>'Messages'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236022414403900)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'sr-latn'
,p_message_text=>'miles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119403254403881)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'The data contains more than %0 rows which exceeds the maximum allowed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119512196403881)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Terms</a> &nbsp;&nbsp; Map data &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119626175403881)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'sr-latn'
,p_message_text=>'SDO_GEOMETRY data type is not available in this database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119795151403881)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap contributors </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119888281403881)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236133049403900)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 Points'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236243631403900)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'sr-latn'
,p_message_text=>'Rectangle Zoom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236371989403900)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236463882403900)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset Bearing to North'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236549937403900)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'sr-latn'
,p_message_text=>'Toggle to 2D mode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236659168403900)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'sr-latn'
,p_message_text=>'Toggle to 3D mode'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236769209403900)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Toggle Copyright Notice'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236880495403900)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'sr-latn'
,p_message_text=>'Total Distance'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116236969419403900)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'sr-latn'
,p_message_text=>'Zoom in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237092282403900)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'sr-latn'
,p_message_text=>'Zoom out'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237173788403900)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'sr-latn'
,p_message_text=>'Bold'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237270645403900)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Image'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237388979403901)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'sr-latn'
,p_message_text=>'Inline Code'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237414244403901)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Insert Image'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237523883403901)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'sr-latn'
,p_message_text=>'Insert Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237683284403901)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'sr-latn'
,p_message_text=>'Italic'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237744200403901)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'sr-latn'
,p_message_text=>'Link'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237815415403901)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'sr-latn'
,p_message_text=>'List'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116237977051403901)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Ordered List'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238099968403901)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Preview'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116119955705403881)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'sr-latn'
,p_message_text=>'Nothing To Preview'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238180271403901)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'sr-latn'
,p_message_text=>'Strikethrough'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238214277403901)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Unordered List'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238317307403901)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'current'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238405015403901)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'More...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238535575403901)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'sr-latn'
,p_message_text=>'Loading'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120080252403881)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Notification Message'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238641713403901)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be a number less than or equal to %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238784353403901)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be a valid number.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120198228403881)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# does not match number format %0 (Example: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238804431403901)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be a number greater than or equal to %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277898523403907)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must be a number between %0 and %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212580558403896)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'sr-latn'
,p_message_text=>'opens in new window'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212619176403896)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'sr-latn'
,p_message_text=>'This page was already submitted and can not be re-submitted.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212795661403896)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Application "%0" Page "%1" not found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116277950754403907)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'#LABEL# must have some value.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278075979403907)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Search'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212874939403896)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'sr-latn'
,p_message_text=>'Close'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116212964625403896)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'sr-latn'
,p_message_text=>'Find%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213067507403896)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213169405403896)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278156127403907)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'sr-latn'
,p_message_text=>'Enter a search term of at least %0 characters.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213237183403896)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Popup List of Values: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278240977403907)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'sr-latn'
,p_message_text=>'Enter a search term.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278388525403907)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'sr-latn'
,p_message_text=>'No results found.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278474072403907)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213317227403896)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Search Term'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278545758403907)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Search'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116278606710403907)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'sr-latn'
,p_message_text=>'Processing'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213497749403896)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Add to Home Screen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213562056403897)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Your device or browser does not appear to support the installation of Progressive Web Apps right now.</p>',
'    <p class="a-pwaDialog-intro">If this application is already installed on your device, open it from your home screen.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213678531403897)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality. Add it to your home screen to use it in fullscreen.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tap the <strong>Menu</strong> icon in the bottom navigation</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tap <strong>Install</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tap <strong>Add</strong> to confirm</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213785907403897)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality that is best experienced in Chrome or Edge.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tap the <strong>Menu</strong> icon next to the address bar</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tap <strong>Install</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213825015403897)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality that is best experienced in Safari.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tap the <strong>Share</strong> icon in the bottom navigation</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tap <strong>Open in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116213909400403897)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality. Add it to your home screen for the best experience.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tap the <strong>Share</strong> icon next to the address bar</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tap <strong>Add to Home Screen</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tap <strong style="color:#007AE1;">Add</strong> to confirm</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116214002387403897)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality. Add it to your home screen for the best experience.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tap the <strong>Share</strong> icon in the bottom navigation</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Scroll down and tap <strong>Add to Home Screen</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tap <strong style="color:#007AE1;">Add</strong> to confirm</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120214233403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality. Add it to your home screen for the best experience.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
'        <p class="a-pwaDialog-stepText">1. Tap the <strong>More</strong> icon next to the address bar</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Tap <strong>Add to Home Screen</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Tap <strong style="color:#007AE1;">Add</strong> to confirm</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120354277403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality. Add it to your home screen for the best experience.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tap the <strong>Share</strong> icon next to the address bar</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tap <strong>Open in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120495792403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality. Add it to your home screen for the best experience.</p>',
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Tap the <strong>Share</strong> icon in the bottom navigation</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Tap <strong>Open in Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120541950403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality that is best experienced in Chrome.</p>',
'    <p class="a-pwaDialog-intro">Firefox does not currently support web apps installation.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120639549403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality that is best experienced in Chrome or Edge.</p>',
'    <p class="a-pwaDialog-intro">Firefox does not currently support web apps installation on macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120739562403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality that is best experienced in Chrome or Edge.</p>',
'    <p class="a-pwaDialog-intro">Safari does not currently support web apps installation on macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120836739403881)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">This website has app functionality that is best experienced in Chrome or Edge.</p>',
'    <p class="a-pwaDialog-intro">Firefox does not currently support web apps installation on Windows.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116120959218403881)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Can''t connect</h1>',
'    <p>You need an internet connection to use this app.</p>',
'    <button type="button">Retry</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121038574403881)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Can''t connect'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121147341403881)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'sr-latn'
,p_message_text=>'Add'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121224750403881)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'All Day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121356765403881)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Send Invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121477146403881)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Options'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121508931403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Daily view for all day '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121697373403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'sr-latn'
,p_message_text=>'Daily view for data with time '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121793303403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121887122403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116121947007403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'sr-latn'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122060898403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'sr-latn'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122130504403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'sr-latn'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122241151403881)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'sr-latn'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122337789403882)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'sr-latn'
,p_message_text=>'End Date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122476276403882)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Event Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122539967403882)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122619308403882)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'sr-latn'
,p_message_text=>'List'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122771700403882)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Month'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122814811403882)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116122971169403882)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'sr-latn'
,p_message_text=>'No Events'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123029496403882)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit an Existing Event.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123173824403882)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'sr-latn'
,p_message_text=>'Sending an Invitation through Email.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123267033403882)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123355849403882)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Send Email'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123440993403882)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'sr-latn'
,p_message_text=>'Send Email'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123584496403882)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'All fields are required.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123686548403882)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Send Invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123707796403882)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'sr-latn'
,p_message_text=>'Subject'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123887960403882)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'sr-latn'
,p_message_text=>'To'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116123930313403882)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Start Date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124059645403882)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'sr-latn'
,p_message_text=>'Form on %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124173785403882)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'sr-latn'
,p_message_text=>'Time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124246070403882)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Today'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124397963403882)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124419939403882)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'Week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124566746403882)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Weekly view for all day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124641512403882)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'sr-latn'
,p_message_text=>'Weekly view for data with time'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124714504403882)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Year'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124864994403882)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Columns...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116124970026403882)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Load more...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125039430403882)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'sr-latn'
,p_message_text=>'Back'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125123950403882)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Load more...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125229293403882)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Search...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125355209403882)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Load more...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125473523403882)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Region ID %0 not found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125505436403882)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'No Data Found'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125606192403882)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to reset region pagination.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125753471403882)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error setting region pagination.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125881041403882)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Columns...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116125973875403882)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Region Type %0 is not supported.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126098019403882)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error during rendering of region "#COMPONENT_NAME#".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126140120403882)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'#COLUMN_HEADER# must have some value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116238931548403901)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'%0, rich text editor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126273606403882)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'sr-latn'
,p_message_text=>'The Rich Text HTML markup exceeds the item''s maximum length (actual %0, allowed %1 characters)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239083003403901)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239161918403901)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239249752403901)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'sr-latn'
,p_message_text=>'Displayed Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239313290403901)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Exclude Null Values'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239486545403901)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'sr-latn'
,p_message_text=>'Add'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239528680403901)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'sr-latn'
,p_message_text=>'Move Down'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239684121403901)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'sr-latn'
,p_message_text=>'Move Up'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239768056403901)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239833746403901)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Other Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116239972797403901)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240056249403901)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Row %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240185314403901)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'sr-latn'
,p_message_text=>'Row %0 of %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240299588403901)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'sr-latn'
,p_message_text=>'Refresh'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240310939403901)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'sr-latn'
,p_message_text=>'Revert Changes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240423827403901)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'Settings Menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126322253403882)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'For example, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240562852403901)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Sign In Again'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240668813403901)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Your session has ended'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240767237403901)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'sr-latn'
,p_message_text=>'Extend'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240826105403901)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'sr-latn'
,p_message_text=>'Your session will end at %0. Would you like to extend it?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116240910735403901)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'sr-latn'
,p_message_text=>'Your session will end at %0 and cannot be extended. Please save any work now to avoid losing any data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126490782403882)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing database session cleanup code.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126594493403882)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing database session setup code.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126622729403882)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Your session has ended'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126775244403882)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'sr-latn'
,p_message_text=>'Please close this dialog and press your browser''s reload button to obtain a new session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126828962403882)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Click <a href="%0">here</a> to create a new session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116126941275403882)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Session Not Valid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127037304403882)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'sr-latn'
,p_message_text=>'No Dynamic Roles could be enabled in the Real Application Security session for user "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127160254403882)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-99900 Could not create unique session ID: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127263719403882)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Session state protection violation: This may be caused by manual alteration of protected page item %0. If you are unsure what caused this error, please contact the application administrator for assistance.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127363202403882)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Page protection violation: This may be caused by submitting a page that had not yet finished loading or by manual alteration of protected page items. For further assistance, please contact the application administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127491572403882)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 contains one of the following invalid characters &<>"/;,*|=% or --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127565692403882)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 contains one of the following invalid characters &<>"/;,*|=% or -- or new line.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127683719403882)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 contains special characters. Only the characters a-Z, 0-9 and spaces are allowed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127778226403882)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 contains <, > or " which are invalid characters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127864525403882)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'sr-latn'
,p_message_text=>'No checksum was provided to show processing for a page that requires a checksum when one or more request, clear cache, or argument values are passed as parameters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116127920468403882)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Session state protection violation: This may be caused by manual alteration of a URL containing a checksum or by using a link with an incorrect or missing checksum. If you are unsure what caused this error, please contact the application administrato'
||'r for assistance.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128056060403882)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'sr-latn'
,p_message_text=>'Set High Contrast Mode Off'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128104361403882)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'sr-latn'
,p_message_text=>'Set High Contrast Mode On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128239562403882)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'sr-latn'
,p_message_text=>'Bottom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128352693403882)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'sr-latn'
,p_message_text=>'Down'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128419015403882)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Move'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128575859403882)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Move All'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128663220403883)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128731070403883)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove All'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128887646403883)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116128914574403883)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'sr-latn'
,p_message_text=>'Top'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129002350403883)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'sr-latn'
,p_message_text=>'Up'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241000250403901)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241126501403901)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241239314403901)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241315355403901)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241480895403901)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241516577403901)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241647096403901)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241704752403901)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241806330403901)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116241971292403901)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242031721403901)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242142848403901)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242295550403901)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242331618403901)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'in %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129100112403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'sr-latn'
,p_message_text=>'[Line]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129275007403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'sr-latn'
,p_message_text=>'[Multiple Lines]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129375228403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'sr-latn'
,p_message_text=>'[Multiple Points]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129444174403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'sr-latn'
,p_message_text=>'[Multiple Polygons]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129579258403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'sr-latn'
,p_message_text=>'[Geometry Object]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129625047403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'sr-latn'
,p_message_text=>'[Point (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129720139403883)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'sr-latn'
,p_message_text=>'[Polygon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129839378403883)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Collapse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116129972502403883)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Restore'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130028327403883)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'sr-latn'
,p_message_text=>'Clear Rating'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130156875403883)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is not in the valid rating range of 1 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130254848403883)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is not numeric'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242406769403901)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'sr-latn'
,p_message_text=>'Success Message'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242522161403901)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242630993403901)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242701244403901)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Toolbar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130380418403883)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Expand / Collapse Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130426450403883)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Expand / Collapse Side Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130525980403883)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Main Navigation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130645194403883)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'1 day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130746577403883)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'1 hour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130852054403883)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 days'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116130965546403883)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 hours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131080013403883)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131100865403883)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 weeks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131281456403883)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'1 week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242808382403901)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'sr-latn'
,p_message_text=>'Start of page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116242955335403901)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Enabled'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131304763403883)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error processing request.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131434295403883)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Value Required'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243043423403901)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'sr-latn'
,p_message_text=>'Please wait until the page is fully loaded and try again.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243109400403901)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'sr-latn'
,p_message_text=>'This page has unsaved changes.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131543583403883)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'sr-latn'
,p_message_text=>'The workbook has no active worksheet.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131613862403883)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'sr-latn'
,p_message_text=>'The workbook is not initialized.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131703264403883)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'An internal error has occurred while creating the XLSX file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131828295403883)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'sr-latn'
,p_message_text=>'Sheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116131953041403883)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132069403403883)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'Actions Menu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132194140403883)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Add Function'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132246599403883)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Add Group By Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132353629403883)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Add Pivot Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132447366403883)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Add Row Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243210286403901)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregate'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132587070403883)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132615807403883)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'sr-latn'
,p_message_text=>'Average'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132789536403883)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Count'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132841438403883)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'sr-latn'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116132974298403883)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'sr-latn'
,p_message_text=>'Median'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133053549403883)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'sr-latn'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133144430403883)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'sr-latn'
,p_message_text=>'Sum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243326163403901)
,p_name=>'APEXIR_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'All'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133208408403883)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'All Columns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133380504403883)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'All Rows'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133484317403883)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Alternative'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133589831403883)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Alternative Default:  %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133622274403883)
,p_name=>'APEXIR_AND'
,p_message_language=>'sr-latn'
,p_message_text=>'and'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243428973403902)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Apply'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133727588403883)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Ascending'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133828562403883)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'sr-latn'
,p_message_text=>'As of %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116133914358403883)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Average %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134035728403883)
,p_name=>'APEXIR_BAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Bar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134139636403883)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'sr-latn'
,p_message_text=>'between'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134241188403883)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Background Color'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134331896403883)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'sr-latn'
,p_message_text=>'blue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134469251403883)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'sr-latn'
,p_message_text=>'Bottom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243524889403902)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Cancel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134516956403883)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'sr-latn'
,p_message_text=>'Category'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134675256403883)
,p_name=>'APEXIR_CELL'
,p_message_language=>'sr-latn'
,p_message_text=>'Cell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243691865403902)
,p_name=>'APEXIR_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134764738403883)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'sr-latn'
,p_message_text=>'Initializing...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134816142403883)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart label must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116134986575403884)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Your query exceeds the maximum of %0 data points per chart. Please apply a filter to reduce the number of records in your base query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135044596403884)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The maximum row count for a Chart query limits the number of rows in the base query, not the number of rows displayed.  ',
'Your base query exceeds the maximum row count of %0.  Please apply a filter to reduce the number of records in your base query.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135190365403884)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135201584403884)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Check All'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135395199403884)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose report format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135459453403884)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'clear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135530759403884)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243720756403902)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135687781403884)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135741051403884)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'Column Heading Menu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135841869403884)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'sr-latn'
,p_message_text=>'Column Information'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116135966329403884)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Column Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136079225403884)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'sr-latn'
,p_message_text=>'Column %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136135626403884)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'sr-latn'
,p_message_text=>'contains'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136226339403884)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'sr-latn'
,p_message_text=>'does not contain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136323044403884)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'sr-latn'
,p_message_text=>'in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136406193403884)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'is not in the last'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136534700403884)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'is not in the next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136630348403884)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'is in the last'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136730520403884)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'is in the next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136845196403884)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'is not null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116136914250403884)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'is null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137046860403884)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'sr-latn'
,p_message_text=>'like'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137138578403884)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'sr-latn'
,p_message_text=>'not in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137233260403884)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'sr-latn'
,p_message_text=>'not like'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137321453403884)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'sr-latn'
,p_message_text=>'matches regular expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137446984403884)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Computation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137548307403884)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Computation Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137684807403884)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Create a computation using column aliases.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137797149403884)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'sr-latn'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137805686403884)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'sr-latn'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116137971324403884)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'sr-latn'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138073251403884)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'sr-latn'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243884137403902)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'Compute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116243988632403902)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'sr-latn'
,p_message_text=>'Control Break'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138134341403884)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'sr-latn'
,p_message_text=>'Control Breaks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138242246403884)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Control Break Columns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138325740403884)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'sr-latn'
,p_message_text=>'Count Distinct'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138404556403884)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Count Distinct'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138562455403884)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Count %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138645004403884)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'sr-latn'
,p_message_text=>'Daily'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244080955403902)
,p_name=>'APEXIR_DATA'
,p_message_language=>'sr-latn'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138772869403884)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'sr-latn'
,p_message_text=>'Report data as of %0 minutes ago.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138812728403884)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'Data Grid Help'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116138944438403884)
,p_name=>'APEXIR_DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139055454403884)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Default'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139114691403884)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Default Report Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244110318403902)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139215010403884)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'sr-latn'
,p_message_text=>'Would you like to delete these report settings?'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244220194403902)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete Default Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244311433403902)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Delete Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139334048403884)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Descending'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139481003403884)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139566360403884)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Single Row View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139621195403884)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Direction %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139785489403884)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Disabled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139882844403884)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'sr-latn'
,p_message_text=>'Displayed'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116139967969403884)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Displayed Columns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140035691403884)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Display in Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140119555403884)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'sr-latn'
,p_message_text=>'Down'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244481462403902)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'sr-latn'
,p_message_text=>'Download'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140264608403884)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Do Not Display'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140381070403884)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight with the same condition exists already.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140472684403884)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate pivot column.  Pivot column list must be unique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140539056403884)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140629070403884)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Chart Settings'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140798327403884)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Chart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140899003403884)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116140998138403885)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Group By'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141022445403885)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Highlight'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141153306403885)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141205275403885)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Email'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141306431403885)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'sr-latn'
,p_message_text=>'Email Address'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141481242403885)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'sr-latn'
,p_message_text=>'Bcc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141511319403885)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'sr-latn'
,p_message_text=>'Body'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141615741403885)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'sr-latn'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141754110403885)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'sr-latn'
,p_message_text=>'Frequency'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141850737403885)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'sr-latn'
,p_message_text=>'Email has not been configured for this application.  Please contact your administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116141916903403885)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Email Address must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142035183403885)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'sr-latn'
,p_message_text=>'See attached'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142126177403885)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'sr-latn'
,p_message_text=>'Subject'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142288958403885)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Email Subject must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142376736403885)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'sr-latn'
,p_message_text=>'To'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142462911403885)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'sr-latn'
,p_message_text=>'Enabled'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142512063403885)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'sr-latn'
,p_message_text=>'Enable/Disable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142688567403885)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142729086403885)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'sr-latn'
,p_message_text=>'Examples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142818668403885)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'sr-latn'
,p_message_text=>'Examples:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116142911660403885)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Exclude Null Values'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143044333403885)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'sr-latn'
,p_message_text=>'Expand/Collapse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143197299403885)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244544540403902)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143242638403885)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'sr-latn'
,p_message_text=>'Filters'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143340818403885)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143440262403885)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'sr-latn'
,p_message_text=>'The filter expression is too long.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143511258403885)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143685498403885)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'sr-latn'
,p_message_text=>'Select columns to search'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244628471403902)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'sr-latn'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143743343403885)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'A flashback query allows you to view the data as it existed at a previous point in time.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143813511403885)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Flashback Duration'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244763474403902)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116143972263403885)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'sr-latn'
,p_message_text=>'Format Mask %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144019572403885)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Function'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144179822403885)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Functions %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144260545403885)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'sr-latn'
,p_message_text=>'Functions / Operators'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144393533403885)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'sr-latn'
,p_message_text=>'Function %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144403219403885)
,p_name=>'APEXIR_GO'
,p_message_language=>'sr-latn'
,p_message_text=>'Go'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144524280403885)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'sr-latn'
,p_message_text=>'green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244816312403902)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144647115403885)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By Column %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144713598403885)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Group by column must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144856920403885)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'sr-latn'
,p_message_text=>'The maximum row count for a Group By query limits the number of rows in the base query, not the number of rows displayed.  Your base query exceeds the maximum row count of %0.  Please apply a filter to reduce the number of records in your base query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116244941509403902)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By Sort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116144928400403885)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'sr-latn'
,p_message_text=>'Group By Sort Order'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145023661403885)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Horizontal Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245003389403902)
,p_name=>'APEXIR_HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'Help'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145182942403885)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Interactive reports enable end users to customize reports. Users can alter the layout of report data by selecting columns, applying filters, highlighting, and sorting. Users can also define breaks, aggregations, charts, group bys, and add their own c'
||'omputations. Users can also set up a subscription so that an HTML version of the report will be emailed to them at a designated interval. Users can create multiple variations of a report and save them as named reports, for either public or private vi'
||'ewing. ',
'<p/>',
'The sections that follow summarize ways you can customize an interactive report. To learn more, see "Using Interactive Reports" in <i>Oracle Application Express End User''s Guide</i></a>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145243384403885)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'The Actions menu appears to the right of the Go button on the Search bar. Use this menu to customize an interactive report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145310836403885)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Aggregates are mathematical computations performed against a column. Aggregates display after each control break and at the end of the report within the column they are defined. Options include:',
'<p>',
'</p><ul>',
'<li><strong>Aggregation</strong> enables you to select a previously',
'defined aggregation to edit.</li>',
'<li><strong>Function</strong> is the function to be performed (for example, SUM, MIN).</li>',
'<li><strong>Column</strong> is used to select the column to apply the mathematical function to. Only numeric',
'columns display.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145435476403885)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can define one chart per saved report. Once',
'defined, you can switch between the chart and report views using view icons in the Search bar.',
'Options include:  ',
'<p>',
'</p><ul>',
'<li><strong>Chart Type</strong> identifies the chart type to include.',
'Select from horizontal bar, vertical bar, pie, or line.</li>',
'<li><strong>Label</strong> enables you to select the column to be used as the label.</li>',
'<li><strong>Axis Title for Label</strong> is the title that displays on the axis associated with the column selected for',
'Label. This is not available for pie chart.</li>',
'<li><strong>Value</strong> enables you to select the column to be used as the value.  If your function',
'is a COUNT, a Value does not need to be selected.</li>',
'<li><strong>Axis Title for Value</strong> is the title that displays on the axis associated with the column selected for',
'Value. This is not available for pie chart.</li>',
'<li><strong>Function</strong> is an optional function to be performed on the column selected for Value.</li>',
'<li><strong>Sort</strong> allows you to sort your result set.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145526514403885)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Clicking on any column heading exposes a column heading menu.Options include:',
'<p></p>',
'<ul>',
'<li><strong>Sort Ascending</strong> icon sorts the report by the column in ascending order.</li>',
'<li><strong>Sort Descending</strong> icon sorts the report by the column in descending order.</li>',
'<li><strong>Hide Column</strong> hides the column.  Not all columns can be hidden.  If a column cannot be hidden, there will be no Hide Column icon.</li>',
'<li><strong>Break Column</strong> creates a break group on the column.  This pulls the column out of the report as a master record.</li>',
'<li><strong>Column Information</strong> displays help text about the column, if available.</li>',
'<li><strong>Text Area</strong> is used to enter case insensitive search criteria',
'(no need for wild cards). Entering a value  reduces the list of',
'values at the bottom of the menu. You can then select a value from the',
'bottom and the selected value will be created as a filter using ''=''',
'(for example, <code>column = ''ABC''</code>). Alternatively, you can click the Flashlight icon and enter a value to be created as a filter with the ''LIKE''',
'modifier (for example, <code>column LIKE ''%ABC%''</code>).</li>',
'<li><b>List of Unique Values</b> contains the first 500 unique',
'values that meets your filter criteria. If the column is a date, a list of date',
'ranges is displayed instead. If you select a value, a filter will be',
'created using ''='' (for example, <code>column = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145683846403885)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enables you to add computed columns to your report. These can be mathematical computations (for example, <code>NBR_HOURS/24</code>) or standard Oracle',
'functions applied to existing columns. Some display as examples and others (such as <code>TO_DATE)</code> can also be used). Options include:',
'<p></p>',
'<ul>',
'<li><strong>Computation</strong> enables you to select a previously defined computation to edit.</li>',
'<li><strong>Column Heading</strong> is the column heading for the new column.</li>',
'<li><strong>Format Mask</strong> is an Oracle format mask to be applied against the column (for example,S9999).</li>',
'<li><strong>Computation</strong> is the computation to be performed. Within the computation, columns are referenced using the aliases displayed.</li>',
'</ul>',
'<p>Below computation, the columns in your query display with',
'their associated alias. Clicking on the column name or alias includes',
'them in the Computation. Next to Columns is a keypad. This keypad functions as',
'a shortcut to commonly used keys. On the far right are Functions.</p>',
'<p>The following  example computation demonstrates how to display total compensation:</p>',
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(where A is ORGANIZATION, B is SALARY and C is COMMISSION)</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145798627403885)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'sr-latn'
,p_message_text=>'Used to create a break group on one or several columns. This pulls the columns out of the interactive report and displays them as a master record.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145801117403885)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'To view the details of a single row at a time, click the single row view icon on the row you wish to view. If available, the single row view will always be the first column. Depending on the customization of the interactive report, the single row vie'
||'w may be the standard view or a custom page that may allow update.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116145922210403885)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enables the current result set to be downloaded. The download formats',
'differ depending upon your installation and report definition but',
'may include CSV, HTML, Email, XLS, PDF, or RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146089091403885)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Focuses the report by adding or modifying the <code>WHERE</code> clause on the query. You can filter on a column or by row.  ',
'<p>If you filter by column, select a column (it does not need to',
'be one that displays), select a standard Oracle operator  (=, !=, not in, between), and enter an expression to compare against. Expressions are case sensitive. Use % as a wild card (for example, <code>STATE_NAME',
'like A%)</code>.</p>',
'<p>If you filter by row, you can create complex <code>WHERE</code> clauses using',
'column aliases and any Oracle functions or operators (for example, <code>G = ''VA'' or G = ''CT''</code>, where',
'<code>G</code> is the alias for <code>CUSTOMER_STATE</code>).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146171584403885)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A flashback query enables you to view the data as it existed at a previous point',
'in time. The default amount of time that you can flashback is 3 hours (or 180',
'minutes) but the actual amount will differ for each database.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146283280403885)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Format enable you to customize the display of the report.',
'Format contains the following submenu:</p>',
'<ul><li>Sort</li>',
'<li>Control Break</li>',
'<li>Highlight</li>',
'<li>Compute</li>',
'<li>Aggregate</li>',
'<li>Chart</li>',
'<li>Group By</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146305633403885)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can define one Group By view per saved',
'report. Once defined, you can switch between the group by and report',
'views using view icons on the Search bar. To create a Group By view,',
'you select:',
'<p></p><ul>',
'<li>the columns on which to group</li>',
'<li>the columns to aggregate along with the function to be performed (average, sum, count, etc.)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146447965403885)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enables you to define a filter. The rows that meet the filter criteria display as highlighted using the characteristics associated with the filter. Options include:</p>',
'<ul>',
'<li><strong>Name</strong> is used only for display.</li>',
'<li><strong>Sequence</strong> identifies the sequence in which the rules are evaluated.</li>',
'<li><strong>Enabled</strong> identifies if a rule is enabled or disabled.</li>',
'<li><strong>Highlight Type</strong> identifies whether the row or cell should be',
'highlighted. If Cell is selected, the column referenced in the',
'Highlight Condition is highlighted.</li>',
'<li><strong>Background Color</strong> is the new color for the background of the highlighted area.</li>',
'<li><strong>Text Color</strong> is the new color for the text in the highlighted area.</li>',
'<li><strong>Highlight Condition</strong>  defines your filter condition.</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146527666403885)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can define one Pivot view per saved report. Once defined, you can switch between the pivot and report views using view icons on the Search bar. To create a Pivot view, you select: ',
'<p></p>',
'<ul>',
'<li>the columns on which to pivot</li>',
'<li>the columns to display as rows</li>',
'<li>the columns to aggregate along with the function to be performed (average, sum, count, etc.)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146665236403885)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If you customize an interactive report, the report settings display',
'below the Search bar and above the report. This area can be collapsed and expanded using the icon on the left.',
'<p>',
'For each report setting, you can:',
'</p><ul>',
'<li>Edit a setting by clicking the name.</li>',
'<li>Disable/Enable a setting by unchecking or checking the Enable/Disable check box. Use this control to temporarily turn a setting off and on.</li>',
'<li>Remove a setting by clicking the Remove icon.</li>',
'</ul>',
'<p>If you have created a chart, group by or pivot, you can toggle between them',
'and the base report using the Report View, Chart View, Group By View, and Pivot View',
'links shown on the right. If you are viewing the chart, group by or pivot, you',
'can also use the Edit link to edit the settings.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146756868403885)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Resets the report back to the default settings, removing any customizations that you have made.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146865751403885)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Sets the number of records to display per page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116146902287403886)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Saves the customized report for future use. You provide a name and optional description and can make the report accessible to the public (that is, all users who can access the primary default report). You can save four types of interactive reports'
||':</p>',
'<ul>',
'<li><strong>Primary Default</strong> (Developer Only). The Primary Default is the report that initially displays. Primary Default reports cannot be renamed or deleted.</li>',
'<li><strong>Alternative Report</strong> (Developer Only). Enables developers to create multiple report layouts. Only developers can save, rename, or delete an Alternative Report.</li>',
'<li><strong>Public Report</strong> (End user). Can be saved, renamed, or deleted by the end user who created it. Other users can view and save the layout as another report.</li>',
'<li><strong>Private Report</strong> (End user). Only the end user that created the report can view, save, rename or delete the report.</li>',
'</ul>',
'<p>If you save customized reports, a Reports selector displays in the Search bar to the left of the Rows selector (if this feature is enabled).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147087008403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'sr-latn'
,p_message_text=>'At the top of each report page is a search region. This region (or Search bar) provides the following features:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147197423403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'<li><strong>Actions Menu</strong> enables you to customize a report. See the sections that follow.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147251993403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'sr-latn'
,p_message_text=>'<li><strong>Select columns icon</strong> enables you to identify which column to search (or all).</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147373246403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'sr-latn'
,p_message_text=>'<li><strong>Reports</strong> displays alternate default and saved private or public reports.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147455328403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'<li><strong>Rows</strong> sets the number of records to display per page.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147555101403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li><strong>Text area</strong> enables you to enter case insensitive search criteria (wild card characters are implied).</li>',
'<li><strong>Go button</strong> executes the search. Hitting the enter key will also execute the search when the cursor is in the search text area.</li>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147636648403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'<li><strong>View Icons</strong> switches between the icon, report, detail, chart, group by, and pivot views of the report if they are defined.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147766557403886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'<li><strong>Manage</strong> enables you to manage the properties, columns, rows, and view history for the report or data grid.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147866453403886)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Used to modify the columns displayed. The columns on the right display. The columns on the left are hidden. You can reorder the displayed columns using the arrows on the far right. Computed columns are prefixed with <strong>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116147931997403886)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Used to change the columns to sort on and determines whether',
'to sort in ascending or descending order. You can also specify how to handle',
'<code>NULLs</code>. The default setting always displays <code>NULLs</code> last or always display them first. The resulting sorting displays to the right of',
'column headings in the report.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148010590403886)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'When you add a subscription, you provide an email address (or multiple email addresses, separated by commas), email subject, frequency, and start and end dates. The resulting emails include an HTML version of the interactive report containing the cur'
||'rent data using the report setting that were present when the subscription was added.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148199609403886)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Data grids are basically editable reports that are highly customizable.  Users can alter the layout of report data by selecting columns, applying filters, highlighting, and sorting. Users can also define breaks, aggregations, charts, group bys, and a'
||'dd their own computations. Users can create multiple variations of a report and save them as named reports, for private viewing. ',
'<p/>',
'A Data grid can be customized using the Search bar, Actions menu, Manage menu or Column Heading menu.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148237523403886)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'sr-latn'
,p_message_text=>'The Actions menu appears to the right of the Go button on the Search bar. Use this menu to customize a data grid report.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148390279403886)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Add / Edit Row Page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148449517403886)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To add a row to the data grid click Add Row. To edit the details of a row click the edit row icon (first column) on the row you wish to edit. The Add/Edit Row page will be displayed showing the columns of the data grid. </p>',
'',
'<p>When editing a row you can:</p>',
'',
'<p><ul>',
'<li><strong>Delete</strong> the row.</li>',
'<li><strong>Apply Changes</strong> to save the changes made to the row.</li>',
'<li>Within <strong>Actions</strong>, add a row, add files, notes, links, or tags, and review the history.</li>',
'<li>Navigate to the <strong>Next and Previous</strong> rows.</li>',
'<li>Within <strong>Manage</strong>, set column properties, column groups, validations and lists of values.</li>',
'</ul></p>',
'',
'<p>The Annotations region at the bottom of the page will display any files, notes, links, or tags that are associated with the current row.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148583571403886)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'sr-latn'
,p_message_text=>'Used to create a break group on one or several columns. This pulls the columns out of the data grid and displays them as a master record.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148621838403886)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enables the current result set to be downloaded. The download formats',
'include CSV, HTML, or Email.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148751180403886)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If you customize a data grid report, the report settings display',
'below the Search bar and above the report. This area can be collapsed and expanded using the icon on the left.',
'<p>',
'For each report setting, you can:',
'</p><ul>',
'<li>Edit a setting by clicking the name.</li>',
'<li>Disable/Enable a setting by unchecking or checking the Enable/Disable check box. Use this control to temporarily turn a setting off and on.</li>',
'<li>Remove a setting by clicking the Remove icon.</li>',
'</ul>',
'<p>If you have created a chart or group by, you can toggle between them',
'and the base report using the Report View, Chart View, and Group By View',
'links shown on the right. If you are viewing the chart or group by, you',
'can also use the Edit link to edit the settings.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148864847403886)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Saves the customized data grid report layout for future use. You provide a name and optional description. You can save three types of data grid report layouts:</p>',
'<ul>',
'<li><strong>Primary Default</strong> (Administrator Only). The Primary Default is the layout that initially displays. Primary Default reports cannot be renamed or deleted.</li>',
'<li><strong>Alternative Report</strong> (Administrator Only). Enables administrators to create multiple report layouts. Only administrators can save, rename, or delete an Alternative Report.</li>',
'<li><strong>Private Report</strong> (All users). The user that created the report layout can view, save, rename or delete the report.</li>',
'</ul>',
'<p>If you save customized reports, a Reports selector displays in the Search bar to the left of the Rows selector (if this feature is enabled).</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116148999720403886)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Hide Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245193006403902)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149037504403886)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlights'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149160809403886)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight Condition'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149245636403886)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149344267403886)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight Type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149450106403886)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149511347403886)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'sr-latn'
,p_message_text=>'1 inactive setting'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149678908403886)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 inactive settings'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149761191403886)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive Report Help'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149835828403886)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116149924084403886)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid computation expression. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150066108403886)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'The end date must be greater than the start date.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150146941403886)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid filter expression. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150277229403886)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid filter query'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150344832403886)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'sr-latn'
,p_message_text=>'1 invalid setting'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150410446403886)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 invalid settings'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150561480403886)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'(in minutes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150686340403886)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is in the last %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150796817403886)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is in the next %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150811334403886)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is not in the last %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116150981770403886)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 is not in the next %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151069302403886)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'sr-latn'
,p_message_text=>'Keypad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151121226403886)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Label %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151209346403886)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Axis Title for Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151362435403886)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151477968403886)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Hour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151583438403886)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Month'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151675979403886)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151713300403886)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Days'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151809592403886)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Hours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116151944822403886)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'Last %0 Years'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152058080403886)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Last Year'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152111651403886)
,p_name=>'APEXIR_LINE'
,p_message_language=>'sr-latn'
,p_message_text=>'Line'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152226337403886)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'sr-latn'
,p_message_text=>'Line with Area'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152308931403886)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'sr-latn'
,p_message_text=>'Map it'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152421150403886)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'sr-latn'
,p_message_text=>'The query is estimated to exceed the maximum allowed resources.  Please modify your report settings and try again.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152515493403886)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'sr-latn'
,p_message_text=>'The maximum row count for this report is %0 rows.  Please apply a filter to reduce the number of records in your query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152632665403886)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Maximum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152761401403886)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Median %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152890241403886)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 minutes ago'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116152956232403887)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153080092403887)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Month'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153125500403887)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Monthly'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153241538403887)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Move'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153390563403887)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Move All'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153430904403887)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Region Static ID must be specified as the page contains multiple interactive reports.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153547366403887)
,p_name=>'APEXIR_NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153605376403887)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'sr-latn'
,p_message_text=>'New Aggregation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245280893403902)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'New Category'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153760662403887)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'sr-latn'
,p_message_text=>'New Computation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153844425403887)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116153934258403887)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154001842403887)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Hour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154183544403887)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Month'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154273539403887)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154321662403887)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Days'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154487642403887)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Hours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154525970403887)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'Next %0 Years'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154686105403887)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Year'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154751307403887)
,p_name=>'APEXIR_NO'
,p_message_language=>'sr-latn'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154809865403887)
,p_name=>'APEXIR_NONE'
,p_message_language=>'sr-latn'
,p_message_text=>'- None -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116154938705403887)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Not a valid email address.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155072428403887)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'sr-latn'
,p_message_text=>'Nulls Always First'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155117936403887)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'Nulls Always Last'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155231296403887)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'sr-latn'
,p_message_text=>'Null Sorting %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155338153403887)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'sr-latn'
,p_message_text=>'Flashback time must be numeric.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155419785403887)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'sr-latn'
,p_message_text=>'Sequence must be numeric.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155510317403887)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155670974403887)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155777471403887)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155829430403887)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'sr-latn'
,p_message_text=>'Other'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116155986485403887)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Page orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156081809403887)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Landscape'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156175369403887)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Portrait'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156257637403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'sr-latn'
,p_message_text=>'Page size'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156335492403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'sr-latn'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156412080403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'sr-latn'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156546887403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'sr-latn'
,p_message_text=>'Custom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156681787403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156742638403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156894699403887)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'sr-latn'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116156955761403887)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Percent of Total Count %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157046061403887)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Percent of Total Sum %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157158581403887)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Percent of Total Count'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157233777403887)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'sr-latn'
,p_message_text=>'Percent of Total Sum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157339779403887)
,p_name=>'APEXIR_PIE'
,p_message_language=>'sr-latn'
,p_message_text=>'Pie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245314282403902)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157439210403887)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Aggregate must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157510420403887)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'sr-latn'
,p_message_text=>'You cannot aggregate on a column selected to as row column.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157602477403887)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot Columns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157748382403887)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot Column %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157810168403887)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot column must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116157904980403887)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'sr-latn'
,p_message_text=>'The maximum row count for a Pivot query limits the number of rows in the base query, not the number of rows displayed. Your base query exceeds the maximum row count of %0. Please apply a filter to reduce the number of records in your base query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245452133403902)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Pivot Sort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158062941403887)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'sr-latn'
,p_message_text=>'The pivot column contains too many distinct values - pivot SQL cannot be generated.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158131146403887)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Preview'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158227056403887)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158380539403887)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'sr-latn'
,p_message_text=>'Primary'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158456026403887)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Primary Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158583844403887)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Include Accessibility Tags'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158608658403887)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Strip Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158746285403887)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Private'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158821298403887)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'sr-latn'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116158956371403887)
,p_name=>'APEXIR_RED'
,p_message_language=>'sr-latn'
,p_message_text=>'red'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159065568403887)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Region Static ID %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159110949403887)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159297846403888)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove All'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159305819403888)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Chart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159488818403888)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Control Break'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159550016403888)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159669959403888)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159751054403888)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Group By'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159888429403888)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Highlight'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116159955278403888)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160072738403888)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Remove Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245531988403902)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Rename Default Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245639816403902)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Rename Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245732188403902)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160133640403888)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Reports'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160288691403888)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Interactive report with alias %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160303539403888)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Report does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160496511403888)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Interactive Report ID %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160592446403888)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'sr-latn'
,p_message_text=>'Report Settings'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160609601403888)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'Report View'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245880846403902)
,p_name=>'APEXIR_RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160726023403888)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'sr-latn'
,p_message_text=>'Restore report to the default settings.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160868624403888)
,p_name=>'APEXIR_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Row'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116160977372403888)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'sr-latn'
,p_message_text=>'You cannot use ROWID as the primary key column for a REST Data Source.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161075391403888)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Rows'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116245928969403902)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Rows Per Page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161186084403888)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Row Columns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161294395403888)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'sr-latn'
,p_message_text=>'Row Column %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161306511403888)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Row column must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161487227403888)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'sr-latn'
,p_message_text=>'Row column must be different from the pivot column.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161568186403888)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Row Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161619172403888)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'sr-latn'
,p_message_text=>'Row %0 of %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161783267403888)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'sr-latn'
,p_message_text=>'Row text contains'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161871194403888)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Save'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116161901723403888)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162047290403888)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'sr-latn'
,p_message_text=>'Saved Report = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162123992403888)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'sr-latn'
,p_message_text=>'The current report settings will be used as the default for all users.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246073296403902)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Save Default Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246185138403902)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Save Report'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246299959403902)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Save Report *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162205592403888)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Search'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162306307403888)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Search Bar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246357148403902)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Search: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162437112403888)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Search Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162555845403888)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Selected Columns'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162606947403888)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select Column -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246495115403902)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Select Columns'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162750515403888)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select Function -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162810249403888)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select Group By Column -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116162984987403888)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select Pivot Column -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163002505403888)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Select Row'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163167341403888)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'- Select Row Column -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246527139403902)
,p_name=>'APEXIR_SEND'
,p_message_language=>'sr-latn'
,p_message_text=>'Send'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163229417403888)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'Send as Email'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163356729403888)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'sr-latn'
,p_message_text=>'Sequence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246612152403902)
,p_name=>'APEXIR_SORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163451367403888)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Ascending'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163587476403888)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Descending'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163627433403888)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort Order'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163762268403888)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'sr-latn'
,p_message_text=>'space'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163856733403888)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246721854403902)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Subscription'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116163978382403888)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'sr-latn'
,p_message_text=>'Ending'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164095812403888)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'sr-latn'
,p_message_text=>'Skip if No Data Found'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164121544403888)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'sr-latn'
,p_message_text=>'Starting From'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164272275403888)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'sr-latn'
,p_message_text=>'Sum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164338226403888)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'sr-latn'
,p_message_text=>'Region = %0, Report = %1, View = %2, Displayed Rows Start = %3, Displayed Rows End = %4, Total Rows = %5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164479226403888)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Region = %0, Report = %1, View = %2, Displayed Rows Start = %3, Displayed Rows End = %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164538624403888)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Text Color'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164648011403888)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'days'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164790733403888)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'hours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164871657403888)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'sr-latn'
,p_message_text=>'minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116164987062403888)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'months'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165027091403888)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'weeks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165196962403888)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'years'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165268999403888)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Toggle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165383663403889)
,p_name=>'APEXIR_TOP'
,p_message_language=>'sr-latn'
,p_message_text=>'Top'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165458668403889)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Ungrouped Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165518082403889)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Highlight Name must be unique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165675278403889)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'unsupported data type'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165712124403889)
,p_name=>'APEXIR_UP'
,p_message_language=>'sr-latn'
,p_message_text=>'Up'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165880543403889)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Please enter a valid color.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116165913223403889)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'sr-latn'
,p_message_text=>'Please enter a valid format mask.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166046521403889)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Value'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166166575403889)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Axis Title for Value'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166231288403889)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Value Required'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166357988403889)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Vertical Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166473344403889)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166572656403889)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'sr-latn'
,p_message_text=>'View Chart'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166698975403889)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'View Detail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166789775403889)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'The report does not have %0 view defined.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166890005403889)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'View Group By'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116166944600403889)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'sr-latn'
,p_message_text=>'View Icons'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167096988403889)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'sr-latn'
,p_message_text=>'View Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167135519403889)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'View Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167280635403889)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Weekly'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167384301403889)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Working Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167439240403889)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 days'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167593568403889)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 hours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167629433403889)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167764401403889)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 months'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167877973403889)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 weeks'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116167961158403889)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 years'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168059405403889)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Year'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168172397403889)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'sr-latn'
,p_message_text=>'yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168252880403889)
,p_name=>'APEXIR_YES'
,p_message_language=>'sr-latn'
,p_message_text=>'Yes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168317430403889)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 contains < or > which are invalid characters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168486995403889)
,p_name=>'APEX_REGION'
,p_message_language=>'sr-latn'
,p_message_text=>'Region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168512647403889)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'sr-latn'
,p_message_text=>'API precondition violated'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168651164403889)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'sr-latn'
,p_message_text=>'Cannot get value for Application Setting %0 as associated build option is disabled.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168710481403889)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'sr-latn'
,p_message_text=>'Cannot set value for Application Setting %0 as associated build option is disabled.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168862668403889)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Application Setting %0 value is invalid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116168945698403889)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'sr-latn'
,p_message_text=>'Requested Application Setting %0 is not defined'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169092364403889)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Application Setting %0 may not be set to a null value'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169103148403889)
,p_name=>'BACK'
,p_message_language=>'sr-latn'
,p_message_text=>'Back'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169270343403889)
,p_name=>'BUILDER'
,p_message_language=>'sr-latn'
,p_message_text=>'Builder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169317149403889)
,p_name=>'BUTTON LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Button Label'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169461561403889)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'sr-latn'
,p_message_text=>'Button CSS Classes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169553159403889)
,p_name=>'BUTTON_ID'
,p_message_language=>'sr-latn'
,p_message_text=>'Generated button ID will be either the button''s Static ID if defined, or if not will be an internally generated ID in the format ''B'' || [Internal Button ID]'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169667708403889)
,p_name=>'CANDLESTICK'
,p_message_language=>'sr-latn'
,p_message_text=>'Candlestick'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169757273403889)
,p_name=>'CENTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Center'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169824754403889)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 Request'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116169969681403889)
,p_name=>'CHECK$'
,p_message_language=>'sr-latn'
,p_message_text=>'row selector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170082272403889)
,p_name=>'CHECKED'
,p_message_language=>'sr-latn'
,p_message_text=>'checked'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170133101403889)
,p_name=>'COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Column'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170298026403889)
,p_name=>'COMMENTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Comments'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170310536403889)
,p_name=>'CONTINUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Continue'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170433554403889)
,p_name=>'COPYRIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Copyright &copy; %0, All rights reserved.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170538865403889)
,p_name=>'COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Count'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170663530403889)
,p_name=>'CREATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Create'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170786205403889)
,p_name=>'CREATED'
,p_message_language=>'sr-latn'
,p_message_text=>'Created'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170888815403889)
,p_name=>'CREATED_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Created By'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116170909776403889)
,p_name=>'CREATED_ON'
,p_message_language=>'sr-latn'
,p_message_text=>'Created On'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171007630403889)
,p_name=>'CUSTOM'
,p_message_language=>'sr-latn'
,p_message_text=>'Custom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171185539403889)
,p_name=>'CUSTOMIZE'
,p_message_language=>'sr-latn'
,p_message_text=>'Customize'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171269082403890)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Page preferences reset for user %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171337865403890)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'sr-latn'
,p_message_text=>'Preferences changed for user %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171421872403890)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Page preferences reset for user %0.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171547631403890)
,p_name=>'DAILY'
,p_message_language=>'sr-latn'
,p_message_text=>'Daily'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171631119403890)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'Uploaded file is invalid or has wrong extension.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171735936403890)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid XML or JSON selector used.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171865988403890)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'sr-latn'
,p_message_text=>'Data profile and uploaded file do not contain any target table column.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116171945175403890)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'sr-latn'
,p_message_text=>'No data found in uploaded file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172061206403890)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'sr-latn'
,p_message_text=>'No data found in worksheet "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172123972403890)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'The specified file is not an XLSX file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172277723403890)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'sr-latn'
,p_message_text=>'Data loading finished: %0 rows processed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172337504403890)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Data loading finished: %0 rows processed with 1 error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172454297403890)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Data loading finished: %0 rows processed with %1 errors.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172509687403890)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'sr-latn'
,p_message_text=>'Data loading finished: 1 row processed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172694796403890)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Data loading finished: 1 row processed with error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172745987403890)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'Data loading finished: 1 row processed without error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172841191403890)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'sr-latn'
,p_message_text=>'Target Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116172973265403890)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'sr-latn'
,p_message_text=>'Source Column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173035300403890)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Date / Number Format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173188235403890)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'Failed to retrieve the lookup value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173262608403890)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'sr-latn'
,p_message_text=>'Data / Table Mapping'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173335470403890)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Row'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173443853403890)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'The transformation rule failed'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173570024403890)
,p_name=>'DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Date'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173665480403890)
,p_name=>'DAY'
,p_message_language=>'sr-latn'
,p_message_text=>'day'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173790516403890)
,p_name=>'DAYS'
,p_message_language=>'sr-latn'
,p_message_text=>'days'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173874298403890)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'sr-latn'
,p_message_text=>'Debugging is not enabled for this application.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116173950044403890)
,p_name=>'DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Default'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174072382403890)
,p_name=>'DELETE'
,p_message_language=>'sr-latn'
,p_message_text=>'delete'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174102133403890)
,p_name=>'DIAL_PCT'
,p_message_language=>'sr-latn'
,p_message_text=>'Dial (Percent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174272569403890)
,p_name=>'DOWNLOAD'
,p_message_language=>'sr-latn'
,p_message_text=>'Download'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174326585403890)
,p_name=>'DUP_USER'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate Username within list.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174495705403890)
,p_name=>'EDIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174566456403890)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Email address "%0" was not found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174668984403890)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'This email sent by %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174748954403890)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'sr-latn'
,p_message_text=>'Email Address is too long.  The limit is 240 characters.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174894330403890)
,p_name=>'ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116174985470403890)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to set page item source value for partial page refresh region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175067025403890)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'Created By'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175189969403890)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Password Expired'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175221328403890)
,p_name=>'FILE_EMPTY'
,p_message_language=>'sr-latn'
,p_message_text=>'The file is empty.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175320943403890)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'sr-latn'
,p_message_text=>'The size of the uploaded file was over %0 MB. Please upload a smaller file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175461663403890)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'User authentication failed and one or more files were not uploaded.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175577008403890)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'This instance does not allow unauthenticated users to upload files.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246827136403902)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'1 error has occurred'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116246972516403902)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 errors have occurred'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175630678403890)
,p_name=>'FORM_OF'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 of %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175705089403890)
,p_name=>'GO'
,p_message_language=>'sr-latn'
,p_message_text=>'Go'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175864433403890)
,p_name=>'HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'Help'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247044060403902)
,p_name=>'HOME'
,p_message_language=>'sr-latn'
,p_message_text=>'Home'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116175904159403890)
,p_name=>'HOUR'
,p_message_language=>'sr-latn'
,p_message_text=>'hour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176028464403890)
,p_name=>'HOURS'
,p_message_language=>'sr-latn'
,p_message_text=>'hours'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176121920403890)
,p_name=>'ICON'
,p_message_language=>'sr-latn'
,p_message_text=>'Icon %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176209050403890)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Login Credentials'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176361955403890)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid value for parameter: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176472350403890)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'sr-latn'
,p_message_text=>'As Default Report Settings'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176553095403890)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'As Named Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176686201403890)
,p_name=>'IR_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 error. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176783208403890)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to calculate form navigation. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176821013403890)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive report not found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116176991733403890)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Interactive report region does not exist in application %0, page %1 and region %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177039670403890)
,p_name=>'IR_STAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Only displayed for developers'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177101114403890)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'The report query needs a unique key to identify each row.  The supplied key cannot be used for this query.  Please define a unique key column. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177299992403891)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'sr-latn'
,p_message_text=>'The report query needs a unique key to identify each row.  The supplied key cannot be used for this query.  Please edit the report attributes to define a unique key column. %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247158671403902)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'sr-latn'
,p_message_text=>'Choose File'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247284065403902)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'sr-latn'
,p_message_text=>'Drag and drop file here or'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177351293403891)
,p_name=>'ITEMS'
,p_message_language=>'sr-latn'
,p_message_text=>'Items'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177413894403891)
,p_name=>'ITEM_VALUE'
,p_message_language=>'sr-latn'
,p_message_text=>'Item Value'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177504335403891)
,p_name=>'LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Label'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177637556403891)
,p_name=>'LANGUAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Language'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177776802403891)
,p_name=>'LAST'
,p_message_language=>'sr-latn'
,p_message_text=>'last'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177843419403891)
,p_name=>'LENGTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Length'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116177966844403891)
,p_name=>'LOGIN'
,p_message_language=>'sr-latn'
,p_message_text=>'Login'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178078950403891)
,p_name=>'MANAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Manage'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247345585403902)
,p_name=>'MAXIMIZE'
,p_message_language=>'sr-latn'
,p_message_text=>'Maximize'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178138816403891)
,p_name=>'MINUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178274161403891)
,p_name=>'MINUTES'
,p_message_language=>'sr-latn'
,p_message_text=>'minutes'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178379093403891)
,p_name=>'MISSING_AT'
,p_message_language=>'sr-latn'
,p_message_text=>'Missing "@" in Email Address.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178452330403891)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'sr-latn'
,p_message_text=>'Warning: No Dialog Page template has been defined for Dialog page %0 in application %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178566827403891)
,p_name=>'MISSING_DOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Missing "." in Email Address domain.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178628338403891)
,p_name=>'MODULE'
,p_message_language=>'sr-latn'
,p_message_text=>'Module'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178747846403891)
,p_name=>'MONTH'
,p_message_language=>'sr-latn'
,p_message_text=>'Month'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178882184403891)
,p_name=>'MONTHLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Monthly'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116178909940403891)
,p_name=>'MONTHS'
,p_message_language=>'sr-latn'
,p_message_text=>'months'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179067205403891)
,p_name=>'MOVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Move'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179184156403891)
,p_name=>'MOVE_FROM'
,p_message_language=>'sr-latn'
,p_message_text=>'Move from'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179285651403891)
,p_name=>'MOVE_TO'
,p_message_language=>'sr-latn'
,p_message_text=>'Move to'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179395243403891)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'sr-latn'
,p_message_text=>'Error in multi row delete operation: row= %0, %1, %2'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179476973403891)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'sr-latn'
,p_message_text=>'Must Not Be Public User'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179593585403891)
,p_name=>'NAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Name'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179601736403891)
,p_name=>'NEW'
,p_message_language=>'sr-latn'
,p_message_text=>'New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179734097403891)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'You can log in to %0 by going to:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179894075403891)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'sr-latn'
,p_message_text=>'New %0 Account Notification'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116179909283403891)
,p_name=>'NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180012873403891)
,p_name=>'NO'
,p_message_language=>'sr-latn'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180126039403891)
,p_name=>'NOBODY'
,p_message_language=>'sr-latn'
,p_message_text=>'nobody'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180245699403891)
,p_name=>'NOT'
,p_message_language=>'sr-latn'
,p_message_text=>'Not'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180307518403891)
,p_name=>'NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Not Null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180453871403891)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'sr-latn'
,p_message_text=>'Not %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180573184403891)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'no data found'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180699604403891)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'No updateable report found. Multi row updated and delete operations can only be performed on tabular forms of type ''Updateable Report''.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180779561403891)
,p_name=>'OK'
,p_message_language=>'sr-latn'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180859910403891)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'sr-latn'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116180917696403891)
,p_name=>'ORA_06550'
,p_message_language=>'sr-latn'
,p_message_text=>'ORA-06550: line %0, column %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181063847403891)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'sr-latn'
,p_message_text=>'You are using an outdated web browser. For a list of supported browsers, please reference the Oracle Application Express Installation Guide.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181175448403891)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid set of rows requested, the source data of the report has been modified.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181279261403891)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'A valid page number must be specified, for example p?n=1234.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181326083403891)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'Next'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181462004403891)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'sr-latn'
,p_message_text=>'Next Set'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181570838403891)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181647404403891)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous Set'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181791478403891)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'sr-latn'
,p_message_text=>'Select Pagination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181810045403891)
,p_name=>'PASSWORD'
,p_message_language=>'sr-latn'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116181991308403891)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'sr-latn'
,p_message_text=>'Your password for %0 has been changed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182044467403891)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password does not conform to this site''s password complexity rules.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182117381403891)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'New password must differ from old password by at least %0 characters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182276460403891)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must not contain username.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182310226403891)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password contains a prohibited simple word.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182481140403891)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must not contain workspace name.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182502835403891)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must contain at least %0 characters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182668994403891)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must contain at least one alphabetic character (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182713830403891)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must contain at least one lower-case alphabetic character.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182895008403891)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must contain at least one numeric character (0123456789).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116182980749403891)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must contain at least one punctuation character (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183095136403891)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Password must contain at least one upper-case alphabetic character.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183115598403891)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Password Reset Notification'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183291755403891)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'The password may not be used because it has been used within the past %0 days.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183329593403892)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Items'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183481635403892)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'sr-latn'
,p_message_text=>'Item'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183583632403892)
,p_name=>'PERCENT'
,p_message_language=>'sr-latn'
,p_message_text=>'Percent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183682749403892)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Please contact the administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183734323403892)
,p_name=>'PREVIOUS'
,p_message_language=>'sr-latn'
,p_message_text=>'Previous'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183872566403892)
,p_name=>'PRINT'
,p_message_language=>'sr-latn'
,p_message_text=>'Print'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116183942756403892)
,p_name=>'PRIVILEGES'
,p_message_language=>'sr-latn'
,p_message_text=>'Privileges'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184042560403892)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'sr-latn'
,p_message_text=>'Region References'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184111048403892)
,p_name=>'REPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'Report'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184246295403892)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'sr-latn'
,p_message_text=>'Reporting Period'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184362586403892)
,p_name=>'REPORT_LABEL'
,p_message_language=>'sr-latn'
,p_message_text=>'Report: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184476342403892)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Report Total'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184569781403892)
,p_name=>'RESET'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset Pagination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184684603403892)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset Pagination'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184713689403892)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'sr-latn'
,p_message_text=>'Reset Password'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247400693403902)
,p_name=>'RESTORE'
,p_message_language=>'sr-latn'
,p_message_text=>'Restore'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184815388403892)
,p_name=>'RESULTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Results'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116184986888403892)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Return to application.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185034690403892)
,p_name=>'RIGHT'
,p_message_language=>'sr-latn'
,p_message_text=>'Right'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185144113403892)
,p_name=>'ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Row %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185205659403892)
,p_name=>'ROW_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Row Count'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185312403403892)
,p_name=>'SAVE'
,p_message_language=>'sr-latn'
,p_message_text=>'Save'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185438237403892)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Alternative Default'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185500073403892)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185680485403892)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Primary Default'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185764990403892)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'sr-latn'
,p_message_text=>'More than %0 rows available. Increase rows selector to view more rows.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185840710403892)
,p_name=>'SEARCH'
,p_message_language=>'sr-latn'
,p_message_text=>'Search'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116185981625403892)
,p_name=>'SECONDS'
,p_message_language=>'sr-latn'
,p_message_text=>'seconds'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186068333403892)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'sr-latn'
,p_message_text=>'See attached'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186110813403892)
,p_name=>'SELECT_ROW'
,p_message_language=>'sr-latn'
,p_message_text=>'Select Row'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186261643403892)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'sr-latn'
,p_message_text=>'Set Screen Reader Mode Off'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186347801403892)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'sr-latn'
,p_message_text=>'Set Screen Reader Mode On'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186490502403892)
,p_name=>'SHOW'
,p_message_language=>'sr-latn'
,p_message_text=>'Show'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186508507403892)
,p_name=>'SHOW_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Show All'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186683358403892)
,p_name=>'SIGN_IN'
,p_message_language=>'sr-latn'
,p_message_text=>'Sign In'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186725576403892)
,p_name=>'SIGN_OUT'
,p_message_language=>'sr-latn'
,p_message_text=>'Sign out'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247539513403902)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 days ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247607559403902)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 days from now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247722275403902)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 hours ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247811917403902)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 hours from now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116247953560403902)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 minutes ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248024207403902)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 minutes from now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248129090403902)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 months ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248201168403902)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 months from now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248315524403902)
,p_name=>'SINCE_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'Now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248499556403902)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 seconds ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248568298403902)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 seconds from now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248627615403902)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 weeks ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248766146403902)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 weeks from now'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248847110403902)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 years ago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116248916103403902)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 years from now'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186804396403892)
,p_name=>'STANDARD'
,p_message_language=>'sr-latn'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116186909682403892)
,p_name=>'START_DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Start Date'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187057620403892)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'sr-latn'
,p_message_text=>'You are receiving this email from Interactive report subscription created by %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187160344403892)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'sr-latn'
,p_message_text=>'Subscriptions'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187254020403892)
,p_name=>'TAB'
,p_message_language=>'sr-latn'
,p_message_text=>'Tab'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187351585403892)
,p_name=>'TITLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Title'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187497121403892)
,p_name=>'TODAY'
,p_message_language=>'sr-latn'
,p_message_text=>'Today'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187545780403892)
,p_name=>'TOTAL'
,p_message_language=>'sr-latn'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187629725403892)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'sr-latn'
,p_message_text=>'A maximum of %0 columns can be selected.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249069671403902)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Collapse All'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249110169403902)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'sr-latn'
,p_message_text=>'Collapse All Below'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249207278403902)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Expand All'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249303822403902)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'sr-latn'
,p_message_text=>'Expand All Below'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116249482328403902)
,p_name=>'TREE.REPARENT'
,p_message_language=>'sr-latn'
,p_message_text=>'Reparent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187729727403892)
,p_name=>'TREES'
,p_message_language=>'sr-latn'
,p_message_text=>'Trees'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187843702403892)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Required'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116187911101403892)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'sr-latn'
,p_message_text=>'Unauthorized'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188042437403892)
,p_name=>'UNAVAILABLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Unavailable'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188196517403892)
,p_name=>'UNKNOWN'
,p_message_language=>'sr-latn'
,p_message_text=>'Unknown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188279345403892)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'An unrecognized authentication error has occurred.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188384219403892)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'sr-latn'
,p_message_text=>'If you no longer wish to receive emails, please click <a href="%0">unsubscribe</a> to manage your subscription.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188496855403892)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'sr-latn'
,p_message_text=>'If you no longer wish to receive emails, please go to the following URL to manage your subscription:'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188518309403892)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'unsupported data type'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188658025403892)
,p_name=>'UPDATE'
,p_message_language=>'sr-latn'
,p_message_text=>'update'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188788452403892)
,p_name=>'UPDATED'
,p_message_language=>'sr-latn'
,p_message_text=>'Updated'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188861672403892)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'sr-latn'
,p_message_text=>'The requested URL has been prohibited. Contact your administrator.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116188968059403892)
,p_name=>'USER'
,p_message_language=>'sr-latn'
,p_message_text=>'User'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189029311403892)
,p_name=>'USERNAME'
,p_message_language=>'sr-latn'
,p_message_text=>'User Name'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189139514403892)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'sr-latn'
,p_message_text=>'Username is too long. The limit is %0 characters.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189223531403892)
,p_name=>'USERS'
,p_message_language=>'sr-latn'
,p_message_text=>'users'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189353133403892)
,p_name=>'USER_EXISTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Username already exists.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189450835403892)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Profile image for user %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189544345403893)
,p_name=>'VALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Valid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189657530403893)
,p_name=>'VALIDATIONS'
,p_message_language=>'sr-latn'
,p_message_text=>'Validations'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189720336403893)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'sr-latn'
,p_message_text=>'Value must be specified'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189824785403893)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Value must be specified for %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116189978278403893)
,p_name=>'VERTICAL'
,p_message_language=>'sr-latn'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190054193403893)
,p_name=>'VIEW'
,p_message_language=>'sr-latn'
,p_message_text=>'view'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190110771403893)
,p_name=>'VIEWS'
,p_message_language=>'sr-latn'
,p_message_text=>'views'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190210949403893)
,p_name=>'VIEW_ALL'
,p_message_language=>'sr-latn'
,p_message_text=>'View All'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190366160403893)
,p_name=>'WARNING'
,p_message_language=>'sr-latn'
,p_message_text=>'Warning'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190444644403893)
,p_name=>'WEEK'
,p_message_language=>'sr-latn'
,p_message_text=>'week'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190583945403893)
,p_name=>'WEEKLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Weekly'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190682408403893)
,p_name=>'WEEKS'
,p_message_language=>'sr-latn'
,p_message_text=>'weeks'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190775778403893)
,p_name=>'WELCOME_USER'
,p_message_language=>'sr-latn'
,p_message_text=>'Welcome: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190890339403893)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'sr-latn'
,p_message_text=>'Found invalid value, please verify data entered.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116190961283403893)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Found invalid value, please verify data entered.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191002623403893)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'sr-latn'
,p_message_text=>'Found invalid date value, please verify date format.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191169591403893)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'sr-latn'
,p_message_text=>'Found invalid number value, please verify number format.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191213426403893)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'sr-latn'
,p_message_text=>'Found invalid timestamp value, please verify timestamp format.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191303783403893)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to bind "%0". Use double quotes for multi byte items or verify length of item is 30 bytes or less. Use v() syntax to reference items longer than 30 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191438624403893)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'sr-latn'
,p_message_text=>'Access denied by %0 security check'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191579169403893)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Application Not Available'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191611079403893)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1014 Application not found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191780926403893)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'application=%0  workspace=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191826668403893)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Access to this application is restricted, please try again later.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116191958076403893)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'sr-latn'
,p_message_text=>'Access to this application is restricted to application developers, please try again later.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192039894403893)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-7744 Unable to process branch to function returning URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192148001403893)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-7744 Unable to process branch to function returning page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192255678403893)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1430 Call to show from page process unsupported: G_FLOW_STEP_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192389137403893)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1018 Error clearing step cache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192431230403893)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1005 Unknown computation type.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192522580403893)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1201 session ID not set on custom authentication.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192654638403893)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'page=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192707442403893)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-7620 Could not determine workspace for application (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192825674403893)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'sr-latn'
,p_message_text=>'Edit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116192910871403893)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1802 Unable to find item id "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193032478403893)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1002 Unable to find item ID for item "%0" in application "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193191138403893)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'sr-latn'
,p_message_text=>'Unexpected error, unable to find item name at application or page level.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193222038403893)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'You are already at the first page of data.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193302106403893)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Item ID (%0) is not an item defined on the current page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193430578403893)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'sr-latn'
,p_message_text=>'Item may be not be set by passing arguments to the application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193529621403893)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'sr-latn'
,p_message_text=>'(No checksum was provided)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193660705403893)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'sr-latn'
,p_message_text=>'Item may be set when accompanied by a "user-level bookmark" checksum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193765247403893)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'sr-latn'
,p_message_text=>'Item may be set when accompanied by an "application-level bookmark" checksum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193866615403893)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Item may be set when accompanied by a "session" checksum.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116193955442403893)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Item has no protection.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194093334403893)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'sr-latn'
,p_message_text=>'No page help available.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194120555403893)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'sr-latn'
,p_message_text=>'Workspace %0 has no privileges to parse as schema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194278554403893)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1010 Branch to page accept processing recursion limit exceeded. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194351374403893)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'sr-latn'
,p_message_text=>'This page cannot be invoked using a URL or using a GET or POST to the show procedure, it must be called using a "Branch to Page" branch type.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194479089403893)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error attempting to save non-numeric value in item %0. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194570214403893)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'sr-latn'
,p_message_text=>'The application''s parsing schema "%0" does not exist in the database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194695585403893)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'sr-latn'
,p_message_text=>'Accounts in the INTERNAL workspace can be used only to access &PRODUCT_NAME. <a href="%0">Administration Services</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194719980403893)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-1029 Unable to store session info.  session=%0 item=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194847198403893)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to stop trace: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116194924723403893)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unexpected error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195056580403893)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error in update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195197579403893)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Application and page must be provided to view help.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195220347403893)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Automation not found.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195328601403893)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'sr-latn'
,p_message_text=>'Purged %0 sessions.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195415746403893)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Can''t execute %0 code! It''s not supported by database or not enabled by instance parameter MLE_LANGUAGES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195536087403893)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'sr-latn'
,p_message_text=>'Multi Lingual Engine is not available on this database version!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195696856403894)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Application collection array must not be null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195722838403894)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Specified member attribute number %0 is invalid.  Attribute number must be between 1 and %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195806879403894)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'sr-latn'
,p_message_text=>'Application collection exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116195992213403894)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Collection name cannot be null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196068366403894)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Collection name cannot be larger than 255 characters'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196159887403894)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Application collection %0 does not exist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196231463403894)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'sr-latn'
,p_message_text=>'Cursor is not yet open'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196343150403894)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Member sequence %0 does not exist in Application collection %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196443280403894)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Member sequence %0 does not exist in application collection "%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196543649403894)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'The cryptographic function "%0" is not supported on this system.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196634204403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Accessibility Tested'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196746584403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'sr-latn'
,p_message_text=>'Close'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196886930403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'sr-latn'
,p_message_text=>'Page Customization Options'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116196997405403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'sr-latn'
,p_message_text=>'Default'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197014313403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'sr-latn'
,p_message_text=>'Displayed'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197186772403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'sr-latn'
,p_message_text=>'Hidden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197252949403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'sr-latn'
,p_message_text=>'Check the regions you wish to have included on this page.  Checked regions may not display if you are not in the proper application context or do not have proper privileges.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197317319403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'sr-latn'
,p_message_text=>'This page is not customizable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197439907403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'sr-latn'
,p_message_text=>'You can personalize the appearance of this application by changing the Theme Style. Please select a Theme Style from the list below and click on Apply Changes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197518190403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'sr-latn'
,p_message_text=>'Region Display'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197686286403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Use Application Default Style'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197785992403894)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'sr-latn'
,p_message_text=>'Appearance '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197870559403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'The column index referenced in the aggregate %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116197947009403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'sr-latn'
,p_message_text=>'CLOB output is not supported for %0 format.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198005549403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'sr-latn'
,p_message_text=>'The column break needs to be in the beggining of the columns array.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198127013403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'The column group index referenced in %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198221234403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'sr-latn'
,p_message_text=>'export'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198399743403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'sr-latn'
,p_message_text=>'The export format must be XML using ORDS as Print Server.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198477256403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'The column index referenced in the highlight %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198571331403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Export Format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198625180403894)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'The parent group index referenced in %0 does not exist.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198725055403894)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'The %1 column of the %0 table is a "GENERATED ALWAYS" identity column. Please make sure that no source column is mapped to the %1 column in the Configure dialog.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198893951403894)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'sr-latn'
,p_message_text=>'Specified commit interval is too low.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116198960154403894)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'sr-latn'
,p_message_text=>'No columns have been provided for data loading.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199032636403894)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'No columns found for row selector "%0". Try to auto-detect or review the JSON structure.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199184833403894)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'No worksheets found in XLSX file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199244981403894)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'sr-latn'
,p_message_text=>'Specified worksheet does not exist in XLSX file.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199389362403894)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'sr-latn'
,p_message_text=>'Current version of data in database has changed since user initiated update process.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199470513403894)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'sr-latn'
,p_message_text=>'Error updating report columns: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199594999403894)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'sr-latn'
,p_message_text=>'Cannot convert %0 to SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199623722403894)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sr-latn'
,p_message_text=>'Column %0 which is of data type %1 can not be converted to VARCHAR2!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199757355403894)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Column "%0" specified for attribute "%1" has not been found in data source!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199850411403894)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'sr-latn'
,p_message_text=>'Filter type %0 is not supported for multi-value columns.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116199958021403894)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid "between" filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200091032403894)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid LOV type specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200139442403894)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid query type. Query type must be Table, SQL query or PL/SQL Function returning SQL Query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200276902403894)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Failed to parse SQL query!',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200394268403894)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Specified column position %0 for attribute "%1" has not been found in SQL statement!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200494147403894)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'sr-latn'
,p_message_text=>'Too many items used in Multi-Value filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200590570403894)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'No column specified for attribute "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200646987403894)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'PL/SQL function body did not return a value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200726524403894)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'sr-latn'
,p_message_text=>'The REST Data Source does not contain an Operation to handle the requested DML action.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200834205403894)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'sr-latn'
,p_message_text=>'GeoJSON to SDO_GEOMETRY conversion (column %0) is not available in this database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116200939391403894)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'sr-latn'
,p_message_text=>'SDO_GEOMETRY conversion (column %0) is not supported for XML data sources.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201058462403894)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'sr-latn'
,p_message_text=>'Character %0 is not supported as a multi-value separator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201171275403894)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'This function cannot be used on a Query Context.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201256363403895)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Column Data Type mismatch.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201382459403895)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'sr-latn'
,p_message_text=>'Internal ORDS OUT Bind limits exceeded. Please reduce the amount of DML rows.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201451487403895)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The JSON response from the remote server could not be parsed: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201534873403895)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unknown or wrong context type.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201658987403895)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'This file type is not supported by the parser.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201768380403895)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unauthorized access (wwv_flow_api.set_credentials not set).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201801385403895)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'sr-latn'
,p_message_text=>'Workspace did not create because it already exists.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116201985480403895)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'sr-latn'
,p_message_text=>'User group did not create because it already exists.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202059944403895)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'sr-latn'
,p_message_text=>'Duplicate username found for %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202115261403895)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error loading users. Failed on user %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202206175403895)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Would have loaded %0 users.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202343578403895)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'sr-latn'
,p_message_text=>'Password'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202484755403895)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'sr-latn'
,p_message_text=>'Privileges'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202587277403895)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'sr-latn'
,p_message_text=>'Username'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202625525403895)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error during rendering of page item #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202756355403895)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Can''t display page item because the HTML form was not yet opened.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202885565403895)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error computing item default value for page item #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116202996784403895)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error in item post calculation for page item #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203021654403895)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error computing item source value for page item #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203199695403895)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'sr-latn'
,p_message_text=>'Unauthorized access.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203222703403895)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'sr-latn'
,p_message_text=>'JavaScript not supported.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203366848403895)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'sr-latn'
,p_message_text=>'List'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203426196403895)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to initialize query.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203536684403895)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Update of %0 is not supported.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203694706403895)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid item ID: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203747824403895)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'sr-latn'
,p_message_text=>'No help exists for this item.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203804769403895)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'Chart query generation failed. Check Source and Column Mapping settings.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116203927847403895)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'sr-latn'
,p_message_text=>'The attachment of size %0 MB exceeds the maximum attachment size of %1 MB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204072332403895)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid value for parameter p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204115178403895)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'sr-latn'
,p_message_text=>'You have exceeded the maximum number of email messages per workspace.  Please contact your administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204201937403895)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'sr-latn'
,p_message_text=>'This procedure must be invoked from within an application session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204378118403895)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'sr-latn'
,p_message_text=>'Null value supplied for parameter %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204421957403895)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Email template "%0" not found in application %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204594463403895)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'The SMTP_HOST_ADDRESS instance parameter must be set to send mails.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204631591403895)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'You must supply a message recipient to send mail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204760128403895)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to establish SMTP connection with the configured email server.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204876481403895)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'sr-latn'
,p_message_text=>'Invalid Ajax call!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116204931804403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'No Ajax function has been defined for plug-in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205032031403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'No execution function has been defined for plug-in %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205113769403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'No render function has been defined for plug-in %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205267304403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'The REST Data Source Plug-In "%0" does not contain a "Capabilities" function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205386998403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'The REST Data Source Plug-In "%0" does not contain a DML function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205412316403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'The REST Data Source Plug-In "%0" dies not contain an execute function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205553353403895)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'sr-latn'
,p_message_text=>'The REST Data Source Plug-In "%0" dies not contain a fetch function.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205668118403895)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error in PLSQL code raised during plug-in processing.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205776221403895)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'Value must be specified.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205814768403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sr-latn'
,p_message_text=>'Data type %0 can not be converted to VARCHAR2!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116205969815403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Column "%0" specified for attribute "%1" has not been found in SQL statement!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206015383403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'sr-latn'
,p_message_text=>'A list of values (LOV) query or Named list of values must be specified for %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206178270403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'sr-latn'
,p_message_text=>'Wrong number of columns selected in the LOV SQL query for %0. See examples for valid statements.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206237128403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sr-latn'
,p_message_text=>'No column specified for attribute "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206301494403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'Entered value %0 for attribute "%1" is not numeric.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206458961403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 has a wrong data type in SQL statement. Column# %1 is %2 but %3 expected.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206590478403895)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'sr-latn'
,p_message_text=>'Column "%0" specified for attribute "%1" has data type %2 but should have %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206694935403895)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to find the report layout.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206711394403895)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'sr-latn'
,p_message_text=>'Compute Sum feature cannot be used for reports based on a REST Data Source.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206840502403895)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'ERR-2904 Unable to set shortcut value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116206995261403895)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error: Unknown shortcut type.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207067863403895)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to fetch authentication_scheme in application %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207186590403895)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'sr-latn'
,p_message_text=>'The tenant id already exists for the current session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207213637403896)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'sr-latn'
,p_message_text=>'E-Mail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207335456403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'sr-latn'
,p_message_text=>'Authentication failed.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207467394403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'sr-latn'
,p_message_text=>'One or more cookies set in apex_util.g_request_cookies contain an invalid value.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207550266403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'sr-latn'
,p_message_text=>'The response from the UDDI registry was invalid.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207605087403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'sr-latn'
,p_message_text=>'The URL provided did not return a valid WSDL document.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207708103403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'sr-latn'
,p_message_text=>'The WSDL document contains multiple SOAP bindings. &PRODUCT_NAME. only supports WSDL''s with one SOAP binding. Click Create Web Service Reference Manually to continue creating a reference for this service.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207838856403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'sr-latn'
,p_message_text=>'The response from the service was not XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116207949277403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'sr-latn'
,p_message_text=>'OAuth access token not available or expired.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208083291403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'sr-latn'
,p_message_text=>'You have exceeded the maximum number of web service requests per workspace. Please contact your administrator.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208137426403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'sr-latn'
,p_message_text=>'Server responded with unsupported OAuth token type.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208235649403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'sr-latn'
,p_message_text=>'The WSDL document did not contain a binding for SOAP which is required in order to add the reference.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208390655403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'sr-latn'
,p_message_text=>'This WSDL requires authentication credentials. Please supply the username and password below.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208484646403896)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'sr-latn'
,p_message_text=>'The WSDL document could not be understood by the rendering engine. Click Create Web Service Reference Manually to continue creating a reference for this service.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208552496403896)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>'Unable to process update.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208615407403896)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'sr-latn'
,p_message_text=>'List of Values return and display column are the same!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208731486403896)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'List of Values doesn''t have a return column.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208846785403896)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error fetching column value: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116208997231403896)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'sr-latn'
,p_message_text=>'Current tabular form data is too old; the source data has been modified.<br/> Click <strong><a href="%0">here</a></strong> to discard your changes and reload the data from the database.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209060554403896)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'sr-latn'
,p_message_text=>'Error determining pagination string'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209110237403896)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'unable to determine query headings:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209255305403896)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'sr-latn'
,p_message_text=>'error performing report footer replacements'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209372985403896)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'failed to parse SQL query:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209402141403896)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'sr-latn'
,p_message_text=>'Minimum row requested: %0, rows found but not displayed: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209567856403896)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'sr-latn'
,p_message_text=>'query column #%0 (%1) is invalid, columns that use HTML need alias names'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209665279403896)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'sr-latn'
,p_message_text=>'Error getting query headings: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209705232403896)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'report error:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209884899403896)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'sr-latn'
,p_message_text=>'Sort by this column'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116209945495403896)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'sr-latn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Query cannot be parsed, please check the syntax of your query.',
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210095123403896)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'sr-latn'
,p_message_text=>'This form contains unsaved changes. Press "Ok" to proceed without saving your changes. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210106329403896)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'sr-latn'
,p_message_text=>'Report pagination scheme (%0) is not supported with the chosen data source.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210225186403896)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'sr-latn'
,p_message_text=>'query column #%0 (%1) is invalid, use column alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210304597403896)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'sr-latn'
,p_message_text=>'row(s) %0 - %1 of more than %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210471359403896)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 - %1 of more than %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210562231403896)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'sr-latn'
,p_message_text=>'row(s) %0 - %1 of %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210641410403896)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'sr-latn'
,p_message_text=>'%0 - %1 of %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210707861403896)
,p_name=>'Y'
,p_message_language=>'sr-latn'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210884014403896)
,p_name=>'YEAR'
,p_message_language=>'sr-latn'
,p_message_text=>'year'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116210975410403896)
,p_name=>'YEARS'
,p_message_language=>'sr-latn'
,p_message_text=>'years'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(116211072371403896)
,p_name=>'YES'
,p_message_language=>'sr-latn'
,p_message_text=>'Yes'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4489)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4489)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4489
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4489)
,p_name=>'Messages'
,p_alias=>'MESSAGES'
,p_step_title=>'Messages'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
