prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4492
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4492 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4492
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116103625430403853')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'sr'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4492)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113353'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4492)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4492)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4492)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4492)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4492)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4492)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.sr'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4492)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4492)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4492)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4492)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4492)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4492)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.sr'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4492)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4492)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4492)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4492)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4492)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4492)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.sr'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4492)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4492)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.sr'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4492)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4492)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.sr'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4492)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4492)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.sr'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4492)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4492)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4492)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.sr'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4492
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4492)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4492)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4492)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4492
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4492)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4492
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4492)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4492
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4492)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4492
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4492)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4492
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4492)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4492
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4492
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4492)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4492)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4492)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4492)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4492)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4492)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4492)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4492)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4492)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4492)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4492)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4492)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4492)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4492)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4492)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4492)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4492)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4492)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4492)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4492)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4492)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4492)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4492
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4492)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4492)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4492)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4492)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4492)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4492
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4492)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4492
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4492)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4492
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4492)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4492
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4492)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4492
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4492)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4492
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4492)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4492)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4492)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4492)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4492)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4492)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4492)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4492)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4492)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4492
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4492)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4492)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4492)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4492)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4492)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4492)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4492)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4492
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4492)
,p_page_name=>'winlov'
,p_page_title=>unistr('\0414\0438\0458\0430\043B\043E\0433 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\0417\0430\0442\0432\043E\0440\0438')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\0421\043B\0435\0434\0435\045B\0435 &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \041F\0440\0435\0442\0445\043E\0434\043D\043E')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\0420\0435\0434\043E\0432\0438 #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4492
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4492)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4492
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4492)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4492)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4492)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4492)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4492)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4492)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4492)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4492)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4492)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4492)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4492)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4492)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4492)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4492)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4492)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4492)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4492)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4492)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4492)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4492)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4492)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4492)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4492)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4492)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4492)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4492)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4492)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4492)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4492)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4492)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4492)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4492)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4492)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4492)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4492)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4492)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4492)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4492)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4492)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4492)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4492)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4492)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4492)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4492)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4492)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4492)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4492)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4492)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4492)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4492)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4492)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4492)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4492)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4492)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4492)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4492)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4492)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4492)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4492)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4492)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4492)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4492)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4492)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4492)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4492)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4492)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4492)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4492)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4492)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4492)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4492)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4492)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4492)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4492)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4492)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4492)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4492)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4492)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4492)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4492)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4492)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4492)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4492)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4492)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4492)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4492)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4492)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4492)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4492)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4492)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4492)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4492)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4492)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4492)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4492)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4492)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4492)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4492)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4492)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4492)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4492)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4492)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4492)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4492)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4492)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4492)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4492)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4492)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4492)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4492)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4492)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4492)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4492)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4492)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4492)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4492)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4492)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4492)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4492)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4492)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4492)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4492)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4492)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4492)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4492)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4492)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4492)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4492)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4492)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4492)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4492)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4492)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4492)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4492)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4492)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4492)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4492)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4492)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4492)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4492)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4492)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4492)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4492)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4492)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4492)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4492)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4492)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4492)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4492)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4492)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4492)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4492)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4492)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4492)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4492)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4492)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4492)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4492)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4492)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4492)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4492)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4492)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4492)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4492)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4492)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4492)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4492)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4492)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4492)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4492)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4492)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4492)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873635517402048)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860745690402038)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860665490402038)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917985436402083)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0441\0442\0443\043F \0458\0435 \0437\0430\0431\0440\0430\045A\0435\043D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877674620402051)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0430\043B\043E\0433 \0458\0435 \043A\0440\0435\0438\0440\0430\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863235903402040)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\043B\043E\0433 \0458\0435 \0437\0430\043A\0459\0443\0447\0430\043D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853151431402032)
,p_name=>'AM_PM'
,p_message_language=>'sr'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987525739402137)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0438/\0438\0441\043A\0459\0443\0447\0438 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995614166402143)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'sr'
,p_message_text=>unistr('(\0410\043A\0442\0438\0432\043D\043E)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965184218402119)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('Ajax \043F\043E\0437\0438\0432 \0458\0435 \0432\0440\0430\0442\0438\043E \0433\0440\0435\0448\043A\0443 \0441\0435\0440\0432\0435\0440\0430 %0 \0437\0430 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895920979402066)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0438\0458\0430\0441 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 "%0" \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\043D\0432\0435\0440\0442\0443\0458\0435 \0443 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\0438 ID \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896049746402066)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043F\043B\0438\043A\0430\0446\0438\0458\0430 \0441\0430 \0430\043B\0438\0458\0430\0441\043E\043C "%0" \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885608350402058)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1816 \041D\0435\043E\0447\0435\043A\0438\0432\0430\043D\0430 \0433\0440\0435\0448\043A\0430 \043F\0440\0438 \043A\043E\043D\0432\0435\0440\0442\043E\0432\0430\045A\0443 \0430\043B\0438\0458\0430\0441\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978522217402130)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \043F\0440\0443\0436\0430 \043B\0430\043A \043D\0430\0447\0438\043D \0437\0430 \0443\0442\0432\0440\0452\0438\0432\0430\045A\0435 \0434\0430 \043B\0438 \0458\0435 \0438\0441\0442\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043F\043E\043A\0440\0435\043D\0443\0442\0430 \0443 \0432\0438\0448\0435 \0440\0430\0434\043D\0438\0445 \043F\0440\043E\0441\0442\043E\0440\0430. \041E\0432\0430\0458 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440 \043C\043E\0436\0435\0442\0435 \0434\0430 \0443\043F\043E\0440\0435\0434\0438\0442\0435 \043A\0430\043A\043E \0431\0438\0441\0442\0435 \0443\0442\0432\0440\0434\0438\043B\0438 \0434\0430 \043B\0438 \043F\043E\0441\0442\043E\0458\0438 \043F\043E\0434\0443\0434\0430\0440\0430\045A\0435. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871456886402046)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \0444\0443\043D\043A\0446\0438\0458\0435 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856878007402035)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \0444\0443\043D\043A\0446\0438\0458\0435 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020395118402162)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435 \0437\0430\043A\0443\043F\0446\0430 %0 \043A\043E\0458\0435 \0458\0435 \0432\0440\0430\0442\0438\043B\0430 \0443\0441\043B\0443\0433\0430 Oracle Cloud Identity Management \043D\0438\0458\0435 \043E\0432\043B\0430\0448\045B\0435\043D\043E \0437\0430 \0434\043E\043C\0435\043D %1!<br/><a href="&LOGOUT_URL.">\041F\0440\0438\0458\0430\0432\0438\0442\0435 \0441\0435 \043F\043E\043D\043E\0432\043E</a> \0438 \043D\0430\0432\0435\0434\0438\0442\0435 \0438\043C\0435 \043E\0432\043B\0430\0448\045B\0435\043D\043E\0433 \0437\0430\043A\0443\043F\0446\0430 \0438\043B\0438 \043F\0440\043E\043C\0435\043D\0438\0442\0435 URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854596688402033)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\043B\043E\0433 "%0" \043D\0435\043C\0430 \043D\0435\043E\043F\0445\043E\0434\043D\0435 \043F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0435 \0437\0430 \0440\0430\0437\0432\043E\0458 (DB_DEVELOPER \0438\043B\0438 DB_ADMINISTRATOR)<br/>\0437\0430 \0440\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440 "%1". <a href="&LOGOUT_URL.">\041F\043E\043D\043E\0432\043E \0441\0435 \043F\0440\0438\0458\0430\0432\0438\0442\0435</a> \043A\0430\0434\0430 \0434\043E\0431\0438\0458\0435\0442\0435 \043F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853695987402033)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435 \0437\0430\043A\0443\043F\0446\0430 \043A\043E\0458\0435 \0458\0435 \043F\0440\0438\043A\0430\0437\0430\043B\0430 \0443\0441\043B\0443\0433\0430 Oracle Cloud Identity Management \043D\0438\0458\0435 \043E\0432\043B\0430\0448\045B\0435\043D\043E \0437\0430 \0430\043A\0442\0443\0435\043B\043D\0438 \0440\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440.<br/><a href="&LOGOUT_URL.">\041F\043E\043D\043E\0432\043E \0441\0435 \043F\0440\0438\0458\0430\0432\0438\0442\0435</a> \0438 \043D\0430\0432\0435\0434\0438\0442\0435 \043E\0432\043B\0430\0448\045B\0435\043D\043E \0438\043C\0435 \0437\0430\043A\0443\043F\0446\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854664631402033)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437 \0431\0435\0437\0431\0435\0434\043D\043E\0441\043D\0438\0445 \0440\0430\0437\043B\043E\0433\0430 \043D\0438\0458\0435 \0434\043E\0437\0432\043E\0459\0435\043D\043E \0434\0430 \0441\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0438\0437 \043E\0432\043E\0433 \0440\0430\0434\043D\043E\0433 \043F\0440\043E\0441\0442\043E\0440\0430 \0438\0437\0432\0440\0448\0430\0432\0430\0458\0443 \043F\0443\0442\0435\043C \0434\043E\043C\0435\043D\0430 \0438\0437 URL \0430\0434\0440\0435\0441\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871197482402046)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\043C\043E\043B\0438\0442\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0430 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0434\0430 \043F\043E\043A\0440\0435\043D\0435 $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871046388402046)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'sr'
,p_message_text=>unistr('SYS.DBMS_LDAP \043F\0430\043A\0435\0442 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0438\043B\0438 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870935214402046)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \0443\0440\0435\0452\0438\0432\0430\045A\0430 \0444\0443\043D\043A\0446\0438\0458\0435 LDAP \043A\043E\0440\0438\0441\043D\0438\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871222809402046)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 LDAP \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872003325402047)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \0443 \0430\0440\0433\0443\043C\0435\043D\0442\0443 p_flow_page \0437\0430 \043F\0440\043E\0446\0435\0434\0443\0440\0443 login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871668961402047)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \0432\0430\0436\0435\045B\0435: p_session in wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919563557402084)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0448\0435 \0444\043E\0440\043C\0438\0440\0430\043D \0430\0440\0433\0443\043C\0435\043D\0442 \0437\0430 wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871731182402047)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\0434\0443\0440\0438 \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0430 \0458\0435 \043F\0440\043E\0441\043B\0435\0452\0435\043D\043E null \043A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860582472402038)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0435\043A\0430\0458\0442\0435 <span id="apex_login_throttle_sec">%0</span> \0441\0435\043A. \0434\0430 \0431\0438\0441\0442\0435 \0441\0435 \043E\043F\0435\0442 \043F\0440\0438\0458\0430\0432\0438\043B\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861835569402039)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043A\0443\0448\0430\0458 \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0430 \0458\0435 \0431\043B\043E\043A\0438\0440\0430\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917338441402082)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0432\0440\0434\0430 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430 "%0" \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862144442402039)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'sr'
,p_message_text=>unistr('ID \0431\0435\0437\0431\0435\0434\043D\043E\0441\043D\0435 \0433\0440\0443\043F\0435 \0458\0435 null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871590540402047)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \043F\0440\043E\0446\0435\0441\0430 \043D\0430\043A\043E\043D \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871342283402046)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \043F\0440\043E\0446\0435\0441\0430 \043F\0440\0435 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872572187402047)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\0432\043E\0440\0438\0442\0435 URL \0443 \0438\0441\0442\043E\043C \043F\0440\0435\0433\043B\0435\0434\0430\0447\0443 \0443 \043A\043E\0458\0435\043C \0441\0442\0435 \043F\043E\043A\0440\0435\043D\0443\043B\0438 \0437\0430\0445\0442\0435\0432 \0437\0430 \0440\0435\0441\0435\0442\043E\0432\0430\045A\0435 \043B\043E\0437\0438\043D\043A\0435. \0410\043A\043E \043A\043B\0438\043A\043D\0435\0442\0435 \043D\0430 URL \0437\0430 \0440\0435\0441\0435\0442\043E\0432\0430\045A\0435 \043B\043E\0437\0438\043D\043A\0435 \0438 \0431\0443\0434\0435\0442\0435 \043F\0440\0435\0443\0441\043C\0435\0440\0435\043D\0438 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443 \0437\0430 \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0435, \043F\043E\043D\043E\0432\043E \043F\043E\043A\0440\0435\043D\0438\0442\0435 \0440\0435\0441\0435\0442\043E\0432\0430\045A\0435 \043B\043E\0437\0438\043D\043A\0435 \0438 \043E\0441\0442\0430\0432\0438\0442\0435 \043F\0440\0435\0433\043B\0435\0434\0430\0447 \043E\0442\0432\043E\0440\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017845266402160)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'sr'
,p_message_text=>unistr('URL \0437\0430 \0440\0435\0441\0435\0442\043E\0432\0430\045A\0435 \043B\043E\0437\0438\043D\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854835435402033)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0438 \043F\043E\0442\0440\043E\0448\0430\0447\0430 %0 \0443 \0443\043F\0440\0430\0432\0459\0430\0447\0443 \0440\0435\0441\0443\0440\0441\0438\043C\0430 \043D\0438\0458\0435 \0434\043E\0434\0435\0459\0435\043D\0430 \043F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0430 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854911709402034)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\043E\0442\0440\0435\0431\0438\0442\0435 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \0434\0430 \0431\0438\0441\0442\0435 \0434\043E\0434\0435\043B\0438\043B\0438 \043F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0443 \043A\043E\0458\0430 \043D\0435\0434\043E\0441\0442\0430\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882943456402056)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043E\0431\0440\0430\0434\0435 \0444\0443\043D\043A\0446\0438\0458\0435 \0441\0442\0440\0430\0436\0430\0440\0430 \0441\0435\0441\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883037410402056)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043E\0431\0440\0430\0434\0435 \0444\0443\043D\043A\0446\0438\0458\0435 \0432\0435\0440\0438\0444\0438\043A\0430\0446\0438\0458\0435 \0441\0435\0441\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883296382402056)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\043C\043E\043B\0438\0442\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0430 \0437\0430 %0 \0434\0430 \043A\043E\043D\0444\0438\0433\0443\0440\0438\0448\0435 \043C\0430\0448\0438\043D\0443 \0437\0430 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0435 \043F\0443\0442\0435\043C \0441\0435\0440\0432\0435\0440\0430 \0437\0430 Oracle \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892716517402063)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0435 \0458\0435 \043F\0440\0438\0458\0430\0432\0438\043B\043E \043D\0435\0434\043E\0437\0432\043E\0459\0435\043D\0438 %0 \0443 \0442\043E\043A\0435\043D\0443 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871908312402047)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438\0442\0435 \0448\0435\043C\0443 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430 \0438 \0434\043E\0434\0430\0458\0442\0435 \0438\043C\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892477624402063)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0434\043E\0437\0432\043E\0459\0435\043D\0438 \043F\043E\0437\0438\0432\0430\043B\0430\0446 \0437\0430 \043F\0440\043E\0446\0435\0434\0443\0440\0443 %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892680423402063)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0430 \0441\0435\0441\0438\0458\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0443 urlc \0442\043E\043A\0435\043D\0443: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892245281402063)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \0443 \043F\0430\0440\0430\043C\0435\0442\0440\0443 portal_sso_redirect: \043D\0435\0434\043E\0441\0442\0430\0458\0443 \0438\043D\0444\043E\0440\043C\0430\0446\0438\0458\0435 \043E \0440\0435\0433\0438\0441\0442\0440\0430\0446\0438\0458\0438 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883161643402056)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0430\043A\0435\0442 WWSEC_SSO_ENABLER_PRIVATE \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0438\043B\0438 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114871808252402047)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0448\0435\043C\0438 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430 \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\043E \0438\043C\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0440\0435\0433\0438\0441\0442\0440\043E\0432\0430\043D\043E\0433 \043F\0430\0440\0442\043D\0435\0440\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892352965402063)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0433\0438\0441\0442\0440\0443\0458\0442\0435 \043E\0432\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443 \043E\043D\0430\043A\043E \043A\0430\043A\043E \0458\0435 \043E\043F\0438\0441\0430\043D\043E \0443 \0432\043E\0434\0438\0447\0443 \0437\0430 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883363107402056)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430 \0437\0430 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992780275402141)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0432\043B\0430\0448\045B\0435\043D\0438 URL:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882767728402055)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854766679402033)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440 "%0" \043D\0438\0458\0435 \0430\043A\0442\0438\0432\0430\043D. \041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855126742402034)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'sr'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861521836402039)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0435\0437\0431\0435\0434\043D\043E\0441\043D\0430 \043F\0440\043E\0432\0435\0440\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0458\0435 \0437\0430\0431\0440\0430\043D\0438\043B\0430 \043F\0440\0438\0441\0442\0443\043F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861690461402039)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0435\0437\0431\0435\0434\043D\043E\0441\043D\0430 \043F\0440\043E\0432\0435\0440\0430 \0441\0442\0440\0430\043D\0438\0446\0435 \0458\0435 \0437\0430\0431\0440\0430\043D\0438\043B\0430 \043F\0440\0438\0441\0442\0443\043F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861777866402039)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043E\0431\0440\0430\0434\0438 \043E\0432\043B\0430\0448\045B\0435\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925101138402088)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\043F\0440\0430\0432\0459\0435\043D\043E \0443\0437 %0 \043A\043E\0440\0438\0441\0442\0435\045B\0438 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925207949402088)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0459\0443\0431\0430\0432')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983020997402133)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0438\0441 \0434\043E\0433\0430\0452\0430\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982807585402133)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C \0437\0430\0432\0440\0448\0435\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983124074402133)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'sr'
,p_message_text=>unistr('ID \0434\043E\0433\0430\0452\0430\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982758540402133)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C \043F\043E\0447\0435\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982954640402133)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432 \0434\043E\0433\0430\0452\0430\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873505705402048)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \0441\0430\0434\0440\0436\0430\0458\0430 \0437\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873417442402048)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \0444\043E\0440\043C\0430\0442\0430 \0437\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937468594402098)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043F\0438\0440\0430\043D\043E \0458\0435 \0443 \043E\0441\0442\0430\0432\0443.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937181651402098)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430\0458 \043F\0440\0435\0433\043B\0435\0434\0430\0447 \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \043A\043E\043F\0438\0440\0430\045A\0435 \0438\0437 \0434\0443\0433\043C\0435\0442\0430 \0438\043B\0438 \043C\0435\043D\0438\0458\0430. \041F\043E\043A\0443\0448\0430\0458\0442\0435 \0441\0430 Ctrl+C \0438\043B\0438 Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925690632402089)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0442\0432\043E\0440\0438 \043E\0431\0430\0432\0435\0448\0442\0435\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981646029402132)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\0430\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976108493402128)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043A\0442\0443\0435\043B\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976071573402128)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0442\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980266206402131)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0432\0430\0436\0435\045B\0430 \0431\043E\0458\0430. \041F\0440\0438\043C\0435\0440: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975902275402128)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0430\0431\0435\0440\0438\0442\0435 \0431\043E\0458\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976285746402128)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043C\0435\043D\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \0431\043E\0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015489823402158)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015570185402158)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\0432\043E\0440\0438 \043B\0438\0441\0442\0443 \0437\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995702518402143)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'sr'
,p_message_text=>unistr('(\0414\043E\0432\0440\0448\0435\043D\043E)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888024513402060)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902499387402071)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435.'),
unistr('\0414\0435\0442\0430\0459\0438 \043E \043E\0432\043E\043C \0438\043D\0446\0438\0434\0435\043D\0442\0443 \0441\0443 \0434\043E\0441\0442\0443\043F\043D\0438 \043F\0443\0442\0435\043C ID-\0430 \0437\0430 \043E\0442\043A\043B\0430\045A\0430\045A\0435 \0433\0440\0435\0448\0430\043A\0430 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980512318402131)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\043F\0440\0430\0432\0438\0442\0435 \0433\0440\0435\0448\043A\0435 \043F\0440\0435 \043D\0435\0433\043E \0448\0442\043E \0441\0430\0447\0443\0432\0430\0442\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926534784402089)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D\0438\0445 \043F\043E\0434\0443\0434\0430\0440\0430\045A\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926410511402089)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D \043D\0438\0458\0435\0434\0430\043D \043F\043E\0433\043E\0434\0430\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996202941402143)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0435\043D\0443\0442\043D\0438 \043D\0430\043F\0440\0435\0434\0430\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980917197402132)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\043E\0442\0435\043A\0430 \043D\0430\0432\0435\0434\0435\043D\0430 \0443 \0441\0442\0430\0432\0446\0438 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969438839402123)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0435\043D\0443\0442\043D\0430 \0432\0435\0440\0437\0438\0458\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0443 \0431\0430\0437\0438 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \043F\0440\043E\043C\0435\045A\0435\043D\0430 \043E\0434 \043A\0430\0434\0430 \0458\0435 \043A\043E\0440\0438\0441\043D\0438\043A \043F\043E\043A\0440\0435\043D\0443\043E \043F\0440\043E\0446\0435\0441 \0430\0436\0443\0440\0438\0440\0430\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938551118402099)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \0443\0447\0438\0442\0430\0432\0430\0458')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985558012402135)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \0443 \043F\0440\0438\043F\0440\0435\043C\043D\043E\0458 \043E\0431\0440\0430\0434\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985385130402135)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043C\0435\0442\043D\0438 \0440\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999418119402146)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434\043E\0441\043B\0435\0434 : \0440\0430\0434\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985438346402135)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0436\0443\0440\0438\0440\0430\0458 \0440\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926978371402090)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\043A\0430\0447\0443\045B\0438 \043A\0430\043B\0435\043D\0434\0430\0440: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849548435402029)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849682079402029)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985746866402135)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0438\043C\0430 \043D\0435\043A\0443 \0432\0440\0435\0434\043D\043E\0441\0442.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985612684402135)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0432\0430\0436\0435\045B\0438 \0434\0430\0442\0443\043C, \043D\0430 \043F\0440\0438\043C\0435\0440 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853240220402032)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0438\0437\043C\0435\0452\0443 %0 \0438 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853302095402032)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 %0 \0438\043B\0438 \043D\0430\043A\043E\043D \0442\043E\0433\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853447626402032)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 %0 \0438\043B\0438 \043F\0440\0435 \0442\043E\0433\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930466559402092)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 #LABEL# \0458\0435 \0432\0435\045B\0430 \043E\0434 \043D\0430\0432\0435\0434\0435\043D\043E\0433 \043C\0430\043A\0441\0438\043C\0430\043B\043D\043E\0433 \0434\0430\0442\0443\043C\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930842916402093)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \0441\0435 \043D\0435 \043F\043E\0434\0443\0434\0430\0440\0430 \0441\0430 \0444\043E\0440\043C\0430\0442\043E\043C %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930340328402092)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 #LABEL# \0458\0435 \043C\0430\045A\0430 \043E\0434 \043D\0430\0432\0435\0434\0435\043D\043E\0433 \043C\0438\043D\0438\043C\0430\043B\043D\043E\0433 \0434\0430\0442\0443\043C\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930518644402092)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043D\0438\0458\0435 \0443 \0432\0430\0436\0435\045B\0435\043C \043E\043F\0441\0435\0433\0443 \043E\0434 %0 \0434\043E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930736226402093)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043D\0438\0458\0435 \0443 \0432\0430\0436\0435\045B\0435\043C \043E\043F\0441\0435\0433\0443 \0433\043E\0434\0438\043D\0430 \043E\0434 %0 \0434\043E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980839138402132)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\043A\0430\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008031526402153)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0442\0432\043E\0440\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010038503402154)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980609162402131)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0440\0435\0434\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980785833402131)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886906657402059)
,p_name=>'APEX.ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854386489402033)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0441\043B\0435\0434\0435\045B\0435 \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \0438\0437\0432\0440\0448\0430\0432\0430\045A\0430 \043F\043E\0432\0440\0430\0442\043D\043E\0433 \043F\043E\0437\0438\0432\0430 \0437\0430 \043E\0431\0440\0430\0434\0443 \0433\0440\0435\0448\043A\0435: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863011258402040)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \0431\043E\0458\0435\045A\0443 \0441\0442\0440\0430\043D\0438\0446\0435 \0433\0440\0435\0448\043A\0435: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855031139402034)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043D\0443\0442\0440\0430\0448\045A\0430 \0433\0440\0435\0448\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994838712402142)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.'),
unistr('\0414\0435\0442\0430\0459\0438 \043E \043E\0432\043E\043C \0438\043D\0446\0438\0434\0435\043D\0442\0443 \0441\0443 \0434\043E\0441\0442\0443\043F\043D\0438 \043F\0440\0435\043A\043E ID-\0430 \0437\0430 \043E\0442\043A\043B\0430\045A\0430\045A\0435 \0433\0440\0435\0448\0430\043A\0430 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989142164402138)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0430\0437\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \043E\0442\0432\043E\0440\0435\043D\0430 \0437\0430 \043F\0440\0438\0441\0442\0443\043F \0441\0430\043C\043E \0437\0430 \0447\0438\0442\0430\045A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019786550402162)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'sr'
,p_message_text=>unistr('ORA-28353: \041D\0438\0458\0435 \0443\0441\043F\0435\043B\043E \043E\0442\0432\0430\0440\0430\045A\0435 \043D\043E\0432\0447\0430\043D\0438\043A\0430. \041F\043E\0434\0430\0446\0438 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0442\0440\0435\043D\0443\0442\043D\043E \043D\0438\0441\0443 \0434\043E\0441\0442\0443\043F\043D\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989293796402138)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430 \0441\0442\0440\0430\043D\0438\0446\0430 \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856751330402035)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\0445\043D\0438\0447\043A\0435 \0438\043D\0444\043E\0440\043C\0430\0446\0438\0458\0435 (\0432\0438\0434\0435 \0438\0445 \0441\0430\043C\043E \043F\0440\043E\0433\0440\0430\043C\0435\0440\0438)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952893918402110)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0443\043A\0430 \043E \0433\0440\0435\0448\0446\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966709648402121)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0447\0435\043A\0438\0432\0430\043D\0438 \0444\043E\0440\043C\0430\0442: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933453544402095)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\043A \0458\0435 \0432\0435\045B \043D\0430 \043B\0438\0441\0442\0438 \0437\0430 \043A\043E\043D\0442\0440\043E\043B\0443 \043F\0440\0438\0441\0442\0443\043F\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933375052402095)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0432\0440\0434\0438\0442\0435 \0434\043E\0434\0430\0432\0430\045A\0435 \0441\043B\0435\0434\0435\045B\0438\0445 \043A\043E\0440\0438\0441\043D\0438\043A\0430 (%0) \043D\0430 \043B\0438\0441\0442\0443 \0437\0430 \043A\043E\043D\0442\0440\043E\043B\0443 \043F\0440\0438\0441\0442\0443\043F\0430 <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933868341402095)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\0442\043E\0458\0438 \0434\0443\043F\043B\0438\043A\0430\0442 \043A\043E\0440\0438\0441\043D\0438\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933596230402095)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0435-\0430\0434\0440\0435\0441\0438 \043D\0435\0434\043E\0441\0442\0430\0458\0435 \0437\043D\0430\043A \0435\0442 (@)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933663007402095)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0435-\0430\0434\0440\0435\0441\0438 \043D\0435\0434\043E\0441\0442\0430\0458\0435 \0442\0430\0447\043A\0430 (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933791701402095)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435 \0458\0435 \043F\0440\0435\0434\0443\0433\0430\0447\043A\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934060466402095)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\043C\043E \043A\043E\0440\0438\0441\043D\0438\0446\0438 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0438 \043D\0430 \043B\0438\0441\0442\0438 \0437\0430 \043A\043E\043D\0442\0440\043E\043B\0443 \043F\0440\0438\0441\0442\0443\043F\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \043C\043E\0433\0443 \0434\0430 \043F\0440\0438\0441\0442\0443\043F\0435 \043E\0432\043E\0458 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934118872402095)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0447\0435\043A\0438\0432\0430\043D\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043A\043E\043D\0442\0440\043E\043B\0435 \043F\0440\0438\0441\0442\0443\043F\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933953479402095)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0438 \043E\0432\043B\0430\0448\045B\0435\043D\0438 \043A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \043F\0440\0438\0441\0442\0443\043F\0435 \043E\0432\043E\0458 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976751223402128)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043D\0435\043C\043E\0433\0443\045B\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976621511402128)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976980638402129)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('%0: \043E\043D\0435\043C\043E\0433\0443\045B\0435\043D\043E \0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976876907402128)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('%0: \043E\043C\043E\0433\0443\045B\0435\043D\043E \0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976514031402128)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0438\0434\0435\043D\0442\0438\0444\0438\043A\043E\0432\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969605498402123)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0443\0437\043C\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926167221402089)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\045A\0435\043D\0438 \0444\0438\043B\0442\0435\0440 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967288630402121)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852175126402031)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0430\043A\0430\0441\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979969606402131)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0440\0443\0433\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852254269402031)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0443\0436\043D\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978608783402130)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851925222402031)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967768056402121)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0438\0448\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967841446402121)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0438\0448\0438 \0441\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967922657402122)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0438\0448\0438 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985114640402135)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 %1, \0441\0430 \0440\0435\0444\0435\0440\0435\043D\0446\043E\043C \0443 \0430\0441\043F\0435\043A\0442\0443 %0, \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\0430 \0438\043B\0438 \043D\0435\043C\0430 \043E\0432\043B\0430\0448\045B\0435\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842389862402024)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0430\0431\0435\0440\0438\0442\0435 \0444\0438\043B\0442\0435\0440\0435 \0437\0430 \043F\0440\0438\043A\0430\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924395671402088)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0435\0437\0443\043B\0442\0430\0442\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924405522402088)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0440\0430\043D\043E: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927010575402090)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0435\043D\0443\0442\043D\0438 \0444\0438\043B\0442\0435\0440\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843840949402025)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430 \0444\0438\043B\0442\0435\0440\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983636907402134)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E \043E\0433\0440\0430\043D\0438\0447\0435\045A\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 (%0) \0458\0435 \043F\0440\0435\043C\0430\0448\0435\043D\043E \0437\0430 \0430\0441\043F\0435\043A\0442 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969222940402123)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043F\0435\043A\0442 %0 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \0437\0430 \043A\043E\043B\043E\043D\0435 DATE \0438\043B\0438 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967354667402121)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0440\0438\0440\0430\0458 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967412744402121)
,p_name=>'APEX.FS.GO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0434\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968876327402122)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0458\0435\0434\043D\0430\043A\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852974510402032)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0441\0430\0434\0440\0436\0438 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852657458402032)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0432\0438\0448\0435 \043E\0434 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852782739402032)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0432\0438\0448\0435 \043E\0434 \0438\043B\0438 \0458\0435\0434\043D\0430\043A\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852461243402032)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0430\045A\0435 \043E\0434 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852544714402032)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0430\045A\0435 \043E\0434 \0438\043B\0438 \0458\0435\0434\043D\0430\043A\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852882786402032)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\0447\0438\045A\0435 \0441\0430 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855315040402034)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 %0 (%1) \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \0437\0430 \0430\0441\043F\0435\043A\0442 \043F\043E\0459\0430 \0437\0430 \0443\043D\043E\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845558887402026)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0441\043F\0435\043A\0442\0438 \0441\0430 \0432\0438\0448\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0437\0430\0445\0442\0435\0432\0430\0458\0443 \0432\0435\0440\0437\0438\0458\0443 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430 12.2 \0438\043B\0438 \043D\043E\0432\0438\0458\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969065147402122)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043D\0430\0432\0435\0434\0435\043D\0430 \043D\0438\0458\0435\0434\043D\0430 \043A\043E\043B\043E\043D\0430 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443 \0437\0430 \0430\0441\043F\0435\043A\0442 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842443854402024)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\043E\0448 \0444\0438\043B\0442\0435\0440\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924524092402088)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0442\0430\043A \043E\043F\0441\0435\0433\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968551891402122)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\043E\0434 %0 \0434\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968688597402122)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043A\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968777646402122)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\043F\043E\0434 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924601161402088)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0430\0458 \043E\043F\0441\0435\0433\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987473965402137)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430 \043B\0438\0441\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 #%2 ("%1") \0437\0430 \0430\0441\043F\0435\043A\0442 \043E\043F\0441\0435\0433\0430 %0 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0430 ("|" \043D\0435\0434\043E\0441\0442\0430\0458\0435 \0440\0430\0437\0434\0435\043B\043D\0438\043A).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968925518402122)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0443\0447\043D\0438 \0443\043D\043E\0441 \0437\0430 \0430\0441\043F\0435\043A\0442 \043E\043F\0441\0435\0433\0430 %0 \0442\0440\0435\043D\0443\0442\043D\043E \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D, \0458\0435\0440 \0458\0435 \043A\043E\043B\043E\043D\0430 DATE \0438\043B\0438 TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968205327402122)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0434\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852060970402031)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921130642402085)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967604951402121)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967532917402121)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0436\0438\0432\0430\045A\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968484463402122)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851863636402031)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968001698402122)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \043C\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968169778402122)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0432\0438\0448\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114968331619402122)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0437\0432\0435\0437\0434\0438\0446\0430 \0438 \0432\0438\0448\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926007110402089)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0440\0438\0440\0430\0458 \043F\0440\0435\0434\043B\043E\0433\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969156851402122)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0441\043F\0435\043A\0442 \0442\0435\043A\0441\0442\0443\0430\043B\043D\043E\0433 \043F\043E\0459\0430 %0 \0458\0435 \0442\0440\0435\043D\0443\0442\043D\043E \043F\043E\0434\0440\0436\0430\043D \0441\0430\043C\043E \0437\0430 \043A\043E\043B\043E\043D\0435 NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842289542402023)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\0430\043D \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985220176402135)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 %0 (%1) \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \0441\0430 \043F\0440\0435\0442\0440\0430\0433\0443 \043F\043E\043C\043E\045B\0443 \0430\0441\043F\0435\043A\0430\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977194416402129)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0434\0438 \043D\0430 \0433\0440\0435\0448\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934735864402096)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0430\0446\0438\0458\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942376347402102)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043A\0443\043F\0438 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934860260402096)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942229829402102)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\0438\0440\0438 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020966289402163)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942010750402101)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0441\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012451464402156)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\043A\0430\0442 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931737772402093)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0432\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935042585402096)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0433\043B\0430\0432\0459\0435 \0433\0440\0443\043F\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934970280402096)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0433\043B\0430\0432\0459\0435.')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931808482402093)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951848738402109)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0458 \0458\043E\0448 \0440\0435\0434\043E\0432\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931592435402093)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935182943402096)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434\043E\0432\0438 \0441\0442\0440\0430\043D\0438\0446\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931944183402094)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'sr'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932059163402094)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 - %1 \043E\0434 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988093665402137)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440 \0441\0442\0440\0430\043D\0438\0446\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931600036402093)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012245305402156)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0442\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012361756402156)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043C\0435\045A\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020723561402162)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434 %0, \043A\043E\043B\043E\043D\0430 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020870809402162)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012132288402156)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0441\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935335343402096)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0433\043B\0430\0432\0459\0435 \0440\0435\0434\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930968001402093)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0440\0430\043D\0438\0445 \045B\0435\043B\0438\0458\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932107151402094)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0440\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972492013402125)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438 \0441\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942127709402102)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0440\0430\043D\0438\0446\0430 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935248504402096)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0440\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935464328402096)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\043D\043E \043F\043E \0440\0430\0441\0442\0443\045B\0435\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935510847402096)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\043D\043E \043F\043E \043E\043F\0430\0434\0430\0458\0443\045B\0435\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931086679402093)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \0440\0430\0441\0442\0443\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931367874402093)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \043F\043E \0440\0430\0441\0442\0443\045B\0435\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931119296402093)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \043E\043F\0430\0434\0430\0458\0443\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931484919402093)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \043F\043E \043E\043F\0430\0434\0430\0458\0443\045B\0435\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114931286305402093)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043C\043E\0458 \0434\0430 \0441\043E\0440\0442\0438\0440\0430\0448')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941991355402101)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\043E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868378005402044)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('HTTP \0437\0430\0445\0442\0435\0432 \0437\0430 "%0" \043D\0438\0458\0435 \0443\0441\043F\0435\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009652093402154)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440 \043B\0438\0441\0442\0435 \0437\0430 \043C\0440\0435\0436\0443; \043A\043E\043B\043E\043D\0430: %0, \0440\0435\0434\043E\0432\0430: %1. \0423\043F\043E\0442\0440\0435\0431\0438\0442\0435 \0442\0430\0441\0442\0435\0440\0435 \0441\0430 \0441\0442\0440\0435\043B\0438\0446\0430\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941843745402101)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440 \043B\0438\0441\0442\0435, %0 \0440\0435\0434\043E\0432\0430. \0423\043F\043E\0442\0440\0435\0431\0438\0442\0435 \0442\0430\0441\0442\0435\0440\0435 \0441\0430 \0441\0442\0440\0435\043B\0438\0446\0430\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020526396402162)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430 \043C\0440\0435\0436\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928617538402091)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929649431402092)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929503041402092)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \0440\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014057610402157)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999588613402146)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0430\0446\0438\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001215282402147)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957690476402114)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0435 \0442\0435\043A\0441\0442\0443\0430\043B\043D\0435 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958886430402115)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959981799402115)
,p_name=>'APEX.IG.AND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979360015402130)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0431\043B. \0431\0440\043E\0458 \0440\0430\0437\043B\0438\0447\0438\0442\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015072454402158)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \043F\0440\0438\0431\043B. \0431\0440\043E\0458 \0440\0430\0437\043B\0438\0447\0438\0442\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998135864402145)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0441\0442\043E\0440\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000024545402146)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0441\0442\0443\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958951650402115)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\043B\0430\0448\045B\0435\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014185594402157)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0443\0442\043E\043C\0430\0442\0441\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979737265402131)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0441\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014757818402158)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \043F\0440\043E\0441\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997654333402144)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0437\0430 \043E\0437\043D\0430\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997801025402145)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0435\0446\0438\043C\0430\043B\043D\0430 \043C\0435\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997704923402144)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003800397402149)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\043E\0458\0430 \043F\043E\0437\0430\0434\0438\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998218498402145)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0430\043A\0430\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954237277402111)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0438\0437\043C\0435\0452\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005047052402150)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\043E\0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998310853402145)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0430\043B\043E\043D\0447\0438\045B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929882572402092)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\043A\0430\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959841253402115)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0437\043B\0438\043A\0443\0458\0435 \043C\0430\043B\0430 \0438 \0432\0435\043B\0438\043A\0430 \0441\043B\043E\0432\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015660106402158)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'sr'
,p_message_text=>unistr('(\0420\0430\0437\043B\0438\043A\0443\0458\0435 \043C\0430\043B\0430 \0438 \0432\0435\043B\0438\043A\0430 \0441\043B\043E\0432\0430)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986585934402136)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043C\0435\043D\0435 \0441\0443 \0441\0430\0447\0443\0432\0430\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930203923402092)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043C\0435\043D\0438 \043F\0440\0438\043A\0430\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960991125402116)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957423488402113)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\0438\0442 \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\0430\043D \0431\0440\043E\0458 \0442\0430\0447\0430\043A\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043F\043E \0433\0440\0430\0444\0438\043A\043E\043D\0443 (%0). \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\0442\0435\0440 \0434\0430 \0431\0438\0441\0442\0435 \0441\043C\0430\045A\0438\043B\0438 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928570713402091)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0433\0440\0430\0444\0438\043A\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935814684402097)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0438\0448\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997154318402144)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0442\0432\043E\0440\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004091364402149)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\043E\0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980126455402131)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0433\043B\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959208255402115)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928747149402091)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005848683402151)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0440\0445\0430 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959309469402115)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043C\043F\043B\0435\043A\0441\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928912610402091)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0447\0443\043D\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954809952402111)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0441\0430\0434\0440\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961124104402116)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935696361402096)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043F\0438\0440\0430\0458 \0443 \043E\0441\0442\0430\0432\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935791292402096)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043F\0438\0440\0430\0458 \0434\043E\043B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979158810402130)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979258637402130)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0430\0437\043B\0438\0447\0438\0442\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014976021402158)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \0431\0440\043E\0458 \0440\0430\0437\043B\0438\0447\0438\0442\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014832225402158)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \0431\0440\043E\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012543205402156)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0435\0438\0440\0430\0458 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957801404402114)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0430\0446\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005638212402151)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005261578402150)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986386263402136)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \0434\0430\0442\0443\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955550260402112)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0434\0430\043D(\0430)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958581658402114)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958390290402114)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0442\0438\043F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929786880402092)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006821067402152)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0416\0435\043B\0438\0442\0435 \043B\0438 \0437\0430\0438\0441\0442\0430 \0434\0430 \0438\0437\0431\0440\0438\0448\0435\0442\0435 \043E\0432\0430\0458 \0438\0437\0432\0435\0448\0442\0430\0458?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962962144402118)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438 \0440\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961756474402117)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438 \0440\0435\0434\043E\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000197958402146)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0430\0434\0430\0458\0443\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960663516402116)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0435\0442\0430\0459\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928291079402091)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0434\0435\0442\0430\0459\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988831140402138)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043C\0435\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960353043402116)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043D\0435\043C\043E\0433\0443\045B\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954949267402111)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435 \0441\0430\0434\0440\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955102573402112)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435 \043F\043E\0447\0438\045A\0435 \0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998421308402145)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0441\0442\0435\043D\0430\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961328392402117)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0443\0437\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860027603402038)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\043C\043E \043F\043E\0434\0430\0446\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007805977402152)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0430\0431\0435\0440\0438\0442\0435 \0444\043E\0440\043C\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872677437402047)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0430 %0 \043D\0438\0458\0435 \043E\043C\043E\0433\0443\045B\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000896405402147)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\0440\0430\0458 \0430\0433\0440\0435\0433\0430\0446\0438\0458\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000909449402147)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\0440\0430\0458 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962823052402118)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\0440\0430\0458 \0440\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961688613402117)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\0440\0430\043D\0438 \0440\0435\0434\043E\0432\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929305757402092)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999903962402146)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011412740402155)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007414177402152)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043A\0440\0438\0432\0435\043D\0438 \0434\043E\0434\0430\0442\043D\0438 \043F\0440\0438\043C\0430\043B\0430\0446 (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007697152402152)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0443\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007320313402152)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0442\043D\0438 \043F\0440\0438\043C\0430\043B\0430\0446 (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007045926402152)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\043F\043E\0440\0443\043A\0430 \0458\0435 \043F\043E\0441\043B\0430\0442\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007548174402152)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007222279402152)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\043B\0430\0446 (\0437\0430)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960063690402116)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953204272402110)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0458\0435\0434\043D\0430\043A\043E \0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006460627402151)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960188640402116)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0437')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006307425402151)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972385524402125)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\043E\0442\0435\043A\0430 \0458\0435 \043F\0440\0438\043F\0440\0435\043C\0459\0435\043D\0430. \041F\0440\0435\0443\0437\0438\043C\0430\045A\0435 \0441\0435 \043F\043E\043A\0440\0435\045B\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114935914066402097)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043F\0443\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937090533402098)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043F\0443\043D\0438 \0438\0437\0431\043E\0440 \0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936911217402098)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440 \043F\043E\043F\0443\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928859366402091)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959480686402115)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014474537402158)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000341248402146)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0432\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929005984402091)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\045B\0430\045A\0435 \0443 \043F\0440\043E\0448\043B\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957999221402114)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004947591402150)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006701458402152)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'sr'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006680604402151)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'sr'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919427859402084)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'sr'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858734328402037)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'sr'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962589011402117)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\043C\0440\0437\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960258502402116)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0435 \0438 \043E\043F\0435\0440\0430\0442\043E\0440\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998522090402145)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0435\0432\0430\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979006530402130)
,p_name=>'APEX.IG.GO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0434\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953819370402111)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0432\0435\045B\0435 \043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953995289402111)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0432\0435\045B\0435 \043E\0434 \0438\043B\0438 \0458\0435\0434\043D\0430\043A\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960588391402116)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0440\0435\0436\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928055958402091)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \043A\043E\043E\0440\0434\0438\043D\0430\0442\043D\0435 \043C\0440\0435\0436\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001161017402147)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960726093402116)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0438\0448\0438 \043F\0440\0435\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928388048402091)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0438\0448\0438 \043F\043E \043F\0440\0438\043A\0430\0437\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005524258402151)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0443\0441\043B\043E\0432\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004495358402150)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004643059402150)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0430\0432\043D\0430\045A\0435 \043D\0430\0441\043B\043E\0432\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014330592402157)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009874775402154)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041C\043E\0436\0435\0442\0435 \0434\0430 \0443\043C\0435\0442\043D\0435\0442\0435, \0430\0436\0443\0440\0438\0440\0430\0442\0435 \0438 \0438\0437\0431\0440\0438\0448\0435\0442\0435 \043F\043E\0434\0430\0442\043A\0435 \0434\0438\0440\0435\043A\0442\043D\043E \0443 \043E\043A\0432\0438\0440\0443 \043E\0432\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435.</p>'),
'',
unistr('<p>\0423\043C\0435\0442\043D\0438\0442\0435 \043D\043E\0432\0438 \0440\0435\0434 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \0434\0443\0433\043C\0435 \0414\043E\0434\0430\0458 \0440\0435\0434.</p>'),
'',
unistr('<p>\0423\0440\0435\0434\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \043F\043E\0434\0430\0442\043A\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \0434\0432\0430 \043F\0443\0442\0430 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \043E\0434\0440\0435\0452\0435\043D\043E \043F\043E\0459\0435. \0414\0430 \0431\0438\0441\0442\0435 \0438\0437\0432\0440\0448\0438\043B\0438 \043E\0431\0438\043C\043D\0438\0458\0435 \0443\0440\0435\0452\0438\0432\0430\045A\0435, \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0423\0440\0435\0434\0438 \0434\0430 \0431\0438\0441\0442\0435 \043F\0440\0435\0448\043B\0438 \0443 \0440\0435\0436\0438\043C \0443\0440\0435\0452\0438\0432\0430\045A\0430. \0423 \0440\0435\0436\0438\043C\0443 \0443\0440\0435\0452\0438\0432\0430\045A\0430, \043C\043E\0436\0435\0442\0435 \0434\0430 \043A\043B\0438\043A\043D\0435\0442\0435 \043D\0430 \043F\043E\0458\0435\0434\0438\043D\0430\0447\043D\043E \043F\043E\0459\0435 \0438\043B\0438 \0434\0430 \043A\043E\0440\0438\0441\0442\0438\0442\0435 \0442\0430\0441\0442')
||unistr('\0430\0442\0443\0440\0443 \0437\0430 \0443\0440\0435\0452\0438\0432\0430\045A\0435 \043E\0434\0440\0435\0452\0435\043D\0438\0445 \043F\043E\0459\0430.</p>'),
'',
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043C\0435\043D\0438 \041F\0440\043E\043C\0435\043D\0438 \0434\0430 \0431\0438\0441\0442\0435 \0434\0443\043F\043B\0438\0440\0430\043B\0438 \0438\043B\0438 \0438\0437\0431\0440\0438\0441\0430\043B\0438 \0440\0435\0434\043E\0432\0435. \0414\0430 \0431\0438\0441\0442\0435 \043E\043C\043E\0433\0443\045B\0438\043B\0438 \043C\0435\043D\0438 \043F\0440\043E\043C\0435\043D\0430, \043A\043E\0440\0438\0441\0442\0438\0442\0435 \043F\043E\0459\0430 \0437\0430 \043F\043E\0442\0432\0440\0434\0443 \0434\0430 \0431\0438\0441\0442\0435 \0438\0437\0430\0431\0440\0430\043B\0438 \0458\0435\0434\0430\043D \0440\0435\0434 \0438\043B\0438 \0432\0438\0448\0435 \045A\0438\0445.</p>'),
'',
unistr('<p>\0414\0443\043F\043B\0438\0440\0430\0458\0442\0435 \0438\0437\0430\0431\0440\0430\043D\0438 \0440\0435\0434 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \043C\0435\043D\0438 \041F\0440\043E\043C\0435\043D\0438 \0438 \0438\0437\0430\0431\0440\0430\0442\0438 \0414\0443\043F\043B\0438\0440\0430\0458 \0440\0435\0434\043E\0432\0435. \0418\0437\0431\0440\0438\0448\0438\0442\0435 \0438\0437\0430\0431\0440\0430\043D\0438 \0440\0435\0434 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \043C\0435\043D\0438 \041F\0440\043E\043C\0435\043D\0438 \0438 \0438\0437\0430\0431\0440\0430\0442\0438 \0418\0437\0431\0440\0438\0448\0438 \0440\0435\0434.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011957128402156)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0435 \0443\0440\0435\0452\0438\0432\0430\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012007460402156)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430 \043C\0440\0435\0436\0430 \043F\0440\0435\0434\0441\0442\0430\0432\0459\0430 \0441\043A\0443\043F \043F\043E\0434\0430\0442\0430\043A\0430 \0443 \0438\0437\0432\0435\0448\0442\0430\0458\0443 \043A\043E\0458\0438 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\0440\0435\0442\0440\0430\0436\0443\0458\0435 \0438 \043F\0440\0438\043B\0430\0433\043E\0434\0438. \041C\043E\0436\0435\0442\0435 \0434\0430 \0438\0437\0432\0440\0448\0438\0442\0435 \0431\0440\043E\0458\043D\0435 \043E\043F\0435\0440\0430\0446\0438\0458\0435 \0437\0430 \043E\0433\0440\0430\043D\0438\0447\0430\0432\0430\045A\0435 \0432\0440\0430\045B\0435\043D\0438\0445 \0437\0430\043F\0438\0441\0430 \0438 \043F\0440\043E\043C\0435\043D\0438\0442\0435 \043D\0430\0447\0438\043D \043D\0430 \043A\043E\0458\0438 \0441\0435 \043F\043E\0434\0430\0446\0438 \043F\0440\0438\043A\0430\0437\0443\0458\0443.</p>'),
'',
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043F\043E\0459\0435 \041F\0440\0435\0442\0440\0430\0433\0430 \0434\0430 \0431\0438\0441\0442\0435 \0444\0438\043B\0442\0440\0438\0440\0430\043B\0438 \0432\0440\0430\045B\0435\043D\0435 \0437\0430\043F\0438\0441\0435. \041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0420\0430\0434\045A\0435 \0434\0430 \0431\0438\0441\0442\0435 \043F\0440\0438\0441\0442\0443\043F\0438\043B\0438 \0431\0440\043E\0458\043D\0438\043C \043E\043F\0446\0438\0458\0430\043C\0430 \0437\0430 \0438\0437\043C\0435\043D\0443 \0440\0430\0441\043F\043E\0440\0435\0434\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438\043B\0438 \043A\043E\0440\0438\0441\0442\0438\0442\0435 \043C\0435\043D\0438\0458\0435 \0417\0430\0433\043B\0430\0432\0459\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \043F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435.</p>'),
'',
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0434\0430 \0431\0438\0441\0442\0435 \0441\0430\0447\0443\0432\0430\043B\0438 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \041C\043E\0436\0435\0442\0435 \0438 \0434\0430 \043F\0440\0435\0443\0437\043C\0435\0442\0435 \043F\043E\0434\0430\0442\043A\0435 \0438\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0443 \0441\043F\043E\0459\043D\0443 \0434\0430\0442\043E\0442\0435\043A\0443 \0438\043B\0438 \0434\0430 \043F\043E\0448\0430\0459\0435\0442\0435 \043F\043E\0434\0430\0442\043A\0435 \0435-\043F\043E\0448\0442\043E\043C \0441\0435\0431\0438 \0438\043B\0438 \0434\0440\0443\0433\0438\043C\0430.</p>'),
'',
unistr('<p>\0414\0430 \0431\0438\0441\0442\0435 \0441\0430\0437\043D\0430\043B\0438 \0432\0438\0448\0435, \043F\043E\0433\043B\0435\0434\0430\0458\0442\0435 "\041A\043E\0440\0438\0448\045B\0435\045A\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438\0445 \043C\0440\0435\0436\0430" \0443 <em>\0412\043E\0434\0438\0447 \0437\0430 \043A\0440\0430\0458\045A\0435 \043A\043E\0440\0438\0441\043D\0438\043A\0435 \0437\0430 \0443\0441\043B\0443\0433\0443 Oracle Application Express</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011717363402155)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0433\043B\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009798924402154)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0443 \043C\0440\0435\0436\0443 \0442\0430\043A\043E \0434\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043F\043E\0434\0430\0442\043A\0435 \043D\0430 \0440\0430\0437\043B\0438\0447\0438\0442\0435 \043D\0430\0447\0438\043D\0435 \043F\043E\043C\043E\045B\0443 \0443\0433\0440\0430\0452\0435\043D\0438\0445 \0444\0443\043D\043A\0446\0438\0458\0430.</p>'),
'',
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043C\0435\043D\0438\0458\0435 \0437\0430 \0437\0430\0433\043B\0430\0432\0459\0435 \043A\043E\043B\043E\043D\0435 \0438\043B\0438 \043C\0435\043D\0438 \0441\0430 \0440\0430\0434\045A\0430\043C\0430 \0434\0430 \0431\0438\0441\0442\0435 \043E\0434\0440\0435\0434\0438\043B\0438 \043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0438\0432\0430\0442\0438, \043F\0440\0435\043C\0430 \043A\043E\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443 \0438 \043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \0441\0435 \0437\0430\043C\0440\0437\0430\0432\0430\0458\0443. \041C\043E\0436\0435\0442\0435 \0438 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0440\0430\0437\043B\0438\0447\0438\0442\0435 \0444\0438\043B\0442\0435\0440\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0438 \0441\043E\0440\0442\0438\0440\0430\0442\0435 \0432\0440\0430\045B\0435\043D\0435 \043F\043E\0434\0430\0442\043A\0435.</p>'),
'',
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \0434\0443\0433\043C\0435 \041F\0440\0438\043A\0430\0437 (\043F\043E\0440\0435\0434 \043F\043E\0459\0430 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443) \0434\0430 \0431\0438\0441\0442\0435 \043F\0440\0438\0441\0442\0443\043F\0438\043B\0438 \0434\0440\0443\0433\0438\043C \043F\0440\0438\043A\0430\0437\0438\043C\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043A\043E\0458\0435 \0458\0435 \043C\043E\0436\0434\0430 \0434\0435\0444\0438\043D\0438\0441\0430\043E \043F\0440\043E\0433\0440\0430\043C\0435\0440 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \041C\043E\0436\0435\0442\0435 \0438 \0434\0430 \043A\0440\0435\0438\0440\0430\0442\0435 \0433\0440\0430\0444\0438\043A\043E\043D \0438\043B\0438 \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \0433\0440\0430\0444\0438\043A\043E\043D.</p>  '),
'',
unistr('<p><em>\041D\0430\043F\043E\043C\0435\043D\0430: \041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 <strong>\041F\043E\043C\043E\045B</strong> \0443 \0434\0438\0458\0430\043B\043E\0437\0438\043C\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435 \0434\0430 \0431\0438\0441\0442\0435 \0434\043E\0431\0438\043B\0438 \0434\0435\0442\0430\0459\043D\0438\0458\0435 \0438\043D\0444\043E\0440\043C\0430\0446\0438\0458\0435 \043E \0438\0437\0430\0431\0440\0430\043D\043E\0458 \0444\0443\043D\043A\0446\0438\0458\0438.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011879219402156)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0435 \0438\0437\0432\0435\0448\0442\0430\0432\0430\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961552038402117)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0443 \043C\0440\0435\0436\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008635205402153)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0437\0430 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435 \043A\043E\043B\043E\043D\0430. \041E\0431\0458\0435\0434\0438\045A\0435\043D\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \043D\0430 \0434\043D\0443 \043F\043E\0434\0430\0442\0430\043A\0430 \0438\043B\0438 \0430\043A\043E \0441\0443 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0438 \043F\0440\0435\043B\043E\043C\0438 \043A\043E\043D\0442\0440\043E\043B\0435, \043D\0430 \043A\0440\0430\0458\0443 \0441\0432\0430\043A\043E\0433 \043F\0440\0435\043B\043E\043C\0430.</p>'),
'',
unistr('<p><strong>\041B\0438\0441\0442\0430 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430</strong><br>'),
unistr('\041B\0438\0441\0442\0430 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430. \041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\043E\043D\0438\0448\0442\0438\0442\0438 \045A\0435\0433\043E\0432 \0438\0437\0431\043E\0440.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 ( &plus; ) \0434\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \043D\043E\0432\043E \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435 \0438\043B\0438 \043D\0430 \0418\0437\0431\0440\0438\0448\0438 ( &minus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\043A\043B\043E\043D\0438\043B\0438 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435.</p>'),
'',
unistr('<p><strong>\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430</strong><br>'),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\0440\0430\0437\0430\0446 \0441\0430 \0434\0435\0441\043D\0435 \0441\0442\0440\0430\043D\0435 \0434\0430 \0431\0438\0441\0442\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043B\0438 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435.<br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0438\043C\0435 \043A\043E\043B\043E\043D\0435 \0438 \0442\0438\043F \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430.<br>'),
unistr('\041E\043F\0446\0438\043E\043D\0430\043B\043D\043E, \043C\043E\0436\0435\0442\0435 \0434\0430 \0443\043D\0435\0441\0435\0442\0435 \043E\043F\0438\0441 \0437\0430 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435.<br>'),
unistr('\0410\043A\043E \0441\0442\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043B\0438 \043F\0440\0435\043B\043E\043C \043A\043E\043D\0442\0440\043E\043B\0435, \0430\043A\043E \0438\0437\0430\0431\0435\0440\0435\0442\0435 <strong>\041F\0440\0438\043A\0430\0436\0438 \0443\043A\0443\043F\043D\0443 \0432\0440\0435\0434\043D\043E\0441\0442</strong> \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0441\0435 \0443\043A\0443\043F\043D\0430 \043F\0440\043E\0441\0435\0447\043D\0430, \0443\043A\0443\043F\043D\0430 \0438\043B\0438 \0441\043B\0438\0447\043D\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \043D\0430 \0434\043D\0443 \043F\043E\0434\0430\0442\0430\043A\0430.</p>'),
'',
unistr('<p><em>\041D\0430\043F\043E\043C\0435\043D\0430: \041F\0440\0438\0441\0442\0443\043F\0438\0442\0435 \0434\0438\0458\0430\043B\043E\0433\0443 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430 \0443 \043C\0435\043D\0438\0458\0443 \0441\0430 \0440\0430\0434\045A\0430\043C\0430 \0438\043B\0438 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \0437\0430\0433\043B\0430\0432\0459\0435 \043A\043E\043B\043E\043D\0435 \0438 \0437\0431\0438\0440 ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010864394402155)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0430\0433\0440\0435\0433\0430\0446\0438\0458\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009398317402154)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0434\0430 \0431\0438\0441\0442\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043B\0438 \0433\0440\0430\0444\0438\043A\043E\043D \043A\043E\0458\0438 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043A\0430\043E \0437\0430\0441\0435\0431\0430\043D \043F\0440\0438\043A\0430\0437 \043F\043E\0434\0430\0442\0430\043A\0430.<br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0422\0438\043F \0433\0440\0430\0444\0438\043A\043E\043D\0430 \0438 \0430\0442\0440\0438\0431\0443\0442\0435 \0433\0440\0430\0444\0438\043A\043E\043D\0430.</p>'),
unistr('<p><strong>\0410\0442\0440\0438\0431\0443\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D\0430</strong></br>'),
unistr('\0414\043E\0441\0442\0443\043F\043D\0438 \0430\0442\0440\0438\0431\0443\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D\0430 \0441\0435 \0440\0430\0437\043B\0438\043A\0443\0458\0443 \0443 \0437\0430\0432\0438\0441\043D\043E\0441\0442\0438 \043E\0434 \0442\0438\043F\0430 \0433\0440\0430\0444\0438\043A\043E\043D\0430.</p>'),
'<p>',
'<ul>',
unistr('  <li>\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0443 \043A\043E\0458\0430 \0441\0430\0434\0440\0436\0438 \0432\0440\0435\0434\043D\043E\0441\0442 \0437\0430 \0430\0442\0440\0438\0431\0443\0442:'),
'    <ul>',
unistr('      <li>\041E\0437\043D\0430\043A\0430 - \0442\0435\043A\0441\0442 \0437\0430 \0441\0432\0430\043A\0443 \0442\0430\0447\043A\0443 \043F\043E\0434\0430\0442\0430\043A\0430.</li>'),
unistr('      <li>\0412\0440\0435\0434\043D\043E\0441\0442 - \043F\043E\0434\0430\0446\0438 \043A\043E\0458\0438 \0442\0440\0435\0431\0430 \0434\0430 \0441\0435 \043F\0440\0438\043A\0430\0436\0443.</li>'),
unistr('      <li>\0421\0435\0440\0438\0458\0435 - \0437\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \0434\0438\043D\0430\043C\0438\0447\043A\043E\0433 \0443\043F\0438\0442\0430 \0441\0430 \0432\0438\0448\0435 \0441\0435\0440\0438\0458\0430.</li>'),
unistr('      <li>\041F\043E\0447\0435\0442\043D\0430 - \043F\043E\0447\0435\0442\043D\0430 \0434\043D\0435\0432\043D\0430 \0446\0435\043D\0430 \0430\043A\0446\0438\0458\0430 (\0441\0430\043C\043E \0437\0430 \0430\043A\0446\0438\0458\0435).</li>'),
unistr('      <li>\0417\0430\0432\0440\0448\043D\0430 - \0437\0430\0432\0440\0448\043D\0430 \0434\043D\0435\0432\043D\0430 \0446\0435\043D\0430 \0430\043A\0446\0438\0458\0430 (\0441\0430\043C\043E \0437\0430 \0430\043A\0446\0438\0458\0435).</li>'),
unistr('      <li>\0412\0438\0441\043E\043A\0430 - \0432\0438\0441\043E\043A\0430 \0432\0440\0435\0434\043D\043E\0441\0442 (\0441\0430\043C\043E \0437\0430 \043E\043F\0441\0435\0433 \0438 \0430\043A\0446\0438\0458\0435).</li>'),
unistr('      <li>\041D\0438\0441\043A\0430 - \043D\0438\0441\043A\0430 \0432\0440\0435\0434\043D\043E\0441\0442 (\0441\0430\043C\043E \0437\0430 \043E\043F\0441\0435\0433 \0438 \0430\043A\0446\0438\0458\0435).</li>'),
unistr('      <li>\041E\0431\0438\043C - \0434\043D\0435\0432\043D\0438 \043E\0431\0438\043C \0430\043A\0446\0438\0458\0430 (\0441\0430\043C\043E \0437\0430 \0430\043A\0446\0438\0458\0435).</li>'),
unistr('      <li>\0426\0438\0459 - \0446\0438\0459\043D\0430 \0432\0440\0435\0434\043D\043E\0441\0442 (\0441\0430\043C\043E \043B\0435\0432\043A\0430\0441\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D\0438).</li>'),
unistr('      <li>X - \0432\0440\0435\0434\043D\043E\0441\0442 x \043E\0441\0435 (\0441\0430\043C\043E \0433\0440\0430\0444\0438\043A\043E\043D \0441\0430 \043C\0435\0445\0443\0440\0438\045B\0438\043C\0430 \0438 \0442\0430\0447\043A\0430\0441\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D).</li>'),
unistr('      <li>Y - \0432\0440\0435\0434\043D\043E\0441\0442 y \043E\0441\0435 (\0441\0430\043C\043E \0433\0440\0430\0444\0438\043A\043E\043D \0441\0430 \043C\0435\0445\0443\0440\0438\045B\0438\043C\0430 \0438 \0442\0430\0447\043A\0430\0441\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D).</li>'),
unistr('      <li>Z - \0448\0438\0440\0438\043D\0430 \0442\0440\0430\043A\0435 \0438\043B\0438 \043F\0440\0435\0447\043D\0438\043A \043C\0435\0445\0443\0440\0438\045B\0430 (\0441\0430\043C\043E \0442\0440\0430\043A\0430\0441\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D, \0433\0440\0430\0444\0438\043A\043E\043D \0441\0430 \043C\0435\0445\0443\0440\0438\045B\0438\043C\0430 \0438 \0433\0440\0430\0444\0438\043A\043E\043D \043E\043F\0441\0435\0433\0430).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\041E\0440\0438\0458\0435\043D\0442\0430\0446\0438\0458\0430 - \0443\0441\043F\0440\0430\0432\043D\0430 \0438\043B\0438 \0432\043E\0434\043E\0440\0430\0432\043D\0430.</li>'),
unistr('  <li>\041E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435 - \0438\0437\0430\0431\0435\0440\0438\0442\0435 \043D\0430\0447\0438\043D \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0433\0440\0430\0444\0438\043A\043E\043D\0430.</li>'),
unistr('  <li>\041D\0430\0441\043B\0430\0433\0430\043D\043E - \043D\0430\0432\0435\0434\0438\0442\0435 \0434\0430 \043B\0438 \0441\0435 \0441\0442\0430\0432\043A\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0441\043B\0430\0436\0443.</li>'),
unistr('  <li>\0421\043E\0440\0442\0438\0440\0430\0458 \043F\043E - \0441\043E\0440\0442\0438\0440\0430\0458\0442\0435 \043F\043E \043E\0437\043D\0430\0446\0438 \0438\043B\0438 \0432\0440\0435\0434\043D\043E\0441\0442\0438\043C\0430.'),
'    <ul>',
unistr('      <li>\0421\043C\0435\0440 - \0441\043E\0440\0442\0438\0440\0430\045A\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \043F\043E \0440\0430\0441\0442\0443\045B\0435\043C \0438\043B\0438 \043E\043F\0430\0434\0430\0458\0443\045B\0435\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443.</li>'),
unistr('      <li>\0412\0440\0435\0434\043D\043E\0441\0442\0438 Null - \043E\0434\0440\0435\0434\0438\0442\0435 \043A\0430\043A\043E \0441\0435 \0441\043E\0440\0442\0438\0440\0430\0458\0443 \0437\0430\043F\0438\0441\0438 \0441\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438\043C\0430 null \0443 \043E\0434\043D\043E\0441\0443 \043D\0430 \0437\0430\043F\0438\0441\0435 \0447\0438\0458\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \043D\0438\0458\0435 null.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0414\0435\0446\0438\043C\0430\043B\043D\0430 \043C\0435\0441\0442\0430</li>'),
unistr('  <li>\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \043E\0437\043D\0430\043A\0435</li>'),
unistr('  <li>\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011237252402155)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0433\0440\0430\0444\0438\043A\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008354624402153)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0434\0430 \043E\0434\0430\0431\0435\0440\0435\0442\0435 \043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0438\0432\0430\0442\0438 \0438 \043F\0440\0435\043C\0430 \043A\043E\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443.</p>'),
'',
unistr('<p>\0421\0430\043A\0440\0438\0458\0442\0435 \043A\043E\043B\043E\043D\0443 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\043E\043D\0438\0448\0442\0438\0442\0438 \045A\0435\043D \0438\0437\0431\043E\0440.<br>'),
unistr('\041F\0440\0435\0443\0440\0435\0434\0438\0442\0435 \043A\043E\043B\043E\043D\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0433\043E\0440\0435 ( &uarr; ) \0438\043B\0438 \041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0434\043E\043B\0435 ( &darr; ).<br>'),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \0431\0438\0440\0430\0447 \0441\0430 \043F\0430\0434\0430\0458\0443\045B\043E\043C \043B\0438\0441\0442\043E\043C \0434\0430 \0431\0438\0441\0442\0435 \043D\0430\0432\0435\043B\0438 \0421\0432\0435 \043A\043E\043B\043E\043D\0435, \041F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435 \0438\043B\0438 \041A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \043D\0438\0441\0443 \043F\0440\0438\043A\0430\0437\0430\043D\0435.</p>'),
'',
unistr('<p>\041E\043F\0446\0438\043E\043D\0430\043B\043D\043E, \043A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\0440\0430\0437\0430\0446 \0434\0430 \0431\0438\0441\0442\0435 \043D\0430\0432\0435\043B\0438 \043C\0438\043D\0438\043C\0430\043B\043D\0443 \0448\0438\0440\0438\043D\0443 \043A\043E\043B\043E\043D\0435 \0443 \043F\0438\043A\0441\0435\043B\0438\043C\0430.</p>'),
'',
unistr('<p><em>\041D\0430\043F\043E\043C\0435\043D\0430: \041F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\0435\0443\0440\0435\0434\0438\0442\0435 \0438 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \0440\0443\0447\043A\0443 \0437\0430 \043F\0440\0435\0432\043B\0430\0447\0435\045A\0435 (\043D\0430 \043F\043E\0447\0435\0442\043A\0443 \0437\0430\0433\043B\0430\0432\0459\0430 \043A\043E\043B\043E\043D\0435) \0438 \043F\0440\0435\0432\0443\045B\0438 \043A\043E\043B\043E\043D\0443 \043D\0430\043B\0435\0432\043E \0438\043B\0438 \043D\0430\0434\0435\0441\043D\043E. \041C\043E\0436\0435\0442\0435 \0438 \0434\0430 \043F\0440\043E\043C\0435\043D\0438\0442\0435 \0448\0438\0440\0438\043D\0443 \043A\043E\043B\043E\043D\0435 \0437\0430 \043F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \0438\0437\0430\0431\0440\0430\0442\0438 \0440\0430')
||unistr('\0437\0434\0435\043B\043D\0438\043A \043A\043E\043B\043E\043D\0435, \0438\0437\043C\0435\0452\0443 \0437\0430\0433\043B\0430\0432\0459\0430, \0438 \043F\043E\043C\0435\0440\0438\0442\0438 \0433\0430 \043D\0430\043B\0435\0432\043E \0438\043B\0438 \043D\0430\0434\0435\0441\043D\043E.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011142968402155)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008772049402153)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0434\0430 \0431\0438\0441\0442\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043B\0438 \0434\043E\0434\0430\0442\043D\0435 \043A\043E\043B\043E\043D\0435 \043D\0430 \043E\0441\043D\043E\0432\0443 \043C\0430\0442\0435\043C\0430\0442\0438\0447\043A\0438\0445 \0438 \0444\0443\043D\043A\0446\0438\043E\043D\0430\043B\043D\0438\0445 \043F\0440\043E\0440\0430\0447\0443\043D\0430 \043A\043E\0458\0438 \0441\0435 \0432\0440\0448\0435 \0437\0430 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \043A\043E\043B\043E\043D\0435.</p>'),
'',
unistr('<p><strong>\041B\0438\0441\0442\0430 \043F\0440\043E\0440\0430\0447\0443\043D\0430</strong><br>'),
unistr('\041B\0438\0441\0442\0430 \043F\0440\043E\0440\0430\0447\0443\043D\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0435 \043F\0440\043E\0440\0430\0447\0443\043D\0435. \041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \043F\0440\043E\0440\0430\0447\0443\043D \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\043E\043D\0438\0448\0442\0438\0442\0438 \045A\0435\0433\043E\0432 \0438\0437\0431\043E\0440.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 ( &plus; ) \0434\0430 \0431\0438\0441\0442\0435 \0434\043E\0434\0430\043B\0438 \043D\043E\0432\0438 \043F\0440\043E\0440\0430\0447\0443\043D \0438\043B\0438 \0418\0437\0431\0440\0438\0448\0438 ( &minus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\043A\043B\043E\043D\0438\043B\0438 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \043F\0440\043E\0440\0430\0447\0443\043D.</p>'),
'',
unistr('<p><strong>\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043F\0440\043E\0440\0430\0447\0443\043D\0430</strong><br>'),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\0440\0430\0437\0430\0446 \0437\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \043F\0440\043E\0440\0430\0447\0443\043D\0430.<br>'),
unistr('\0423\043D\0435\0441\0438\0442\0435 \0434\0435\0442\0430\0459\0435 \043A\043E\043B\043E\043D\0435, \043A\0430\043E \0448\0442\043E \0441\0443 \0437\0430\0433\043B\0430\0432\0459\0435, \043E\0437\043D\0430\043A\0430 \0438 \0438\0437\0430\0431\0435\0440\0438\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0443\0441\043A\043B\0430\0452\0438\0432\0430\045A\0430.<br> '),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\043B\0430\0441\0442 \0437\0430 \0442\0435\043A\0441\0442 \0438\0437\0440\0430\0437\0430 \0434\0430 \0431\0438\0441\0442\0435 \0443\043D\0435\043B\0438 \043A\043E\043B\043E\043D\0435 \0438 \043F\043E\0432\0435\0437\0430\043D\0435 \0444\0443\043D\043A\0446\0438\0458\0435 \0437\0430 \043F\0440\043E\0440\0430\0447\0443\043D.<br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043E\0434\0433\043E\0432\0430\0440\0430\0458\0443\045B\0438 \0442\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 \0438 \043E\043F\0446\0438\043E\043D\0430\043B\043D\043E \043C\0430\0441\043A\0443 \0444\043E\0440\043C\0430\0442\0430 \0437\0430 \043D\043E\0432\0443 \043A\043E\043B\043E\043D\0443.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010766288402155)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009004608402153)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0434\0430 \0431\0438\0441\0442\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043B\0438 \043F\0440\0435\043B\043E\043C \043A\043E\043D\0442\0440\043E\043B\0435 \043D\0430 \0458\0435\0434\043D\043E\0458 \043A\043E\043B\043E\043D\0438 \0438\043B\0438 \0432\0438\0448\0435 \045A\0438\0445.</p>'),
'',
unistr('<p><strong>\041B\0438\0441\0442\0430 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435</strong><br>'),
unistr('\041B\0438\0441\0442\0430 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0435 \043F\0440\0435\043B\043E\043C\0435 \043A\043E\043D\0442\0440\043E\043B\0435. \041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \043F\0440\0435\043B\043E\043C \043A\043E\043B\043E\043D\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\043E\043D\0438\0448\0442\0438\0442\0438 \045A\0435\0433\043E\0432 \0438\0437\0431\043E\0440.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 ( &plus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\0432\0440\0441\0442\0438\043B\0438 \043D\043E\0432\0443 \043A\043E\043B\043E\043D\0443 \0443 \043F\0440\0435\043B\043E\043C \043A\043E\043D\0442\0440\043E\043B\0435 \0438\043B\0438 \0418\0437\0431\0440\0438\0448\0438 ( &minus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\043A\043B\043E\043D\0438\043B\0438 \043F\043E\0441\0442\043E\0458\0435\045B\0443 \043A\043E\043B\043E\043D\0443 \0438\0437 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435.<br>'),
unistr('\0414\0430 \0431\0438\0441\0442\0435 \043F\0440\0435\0443\0440\0435\0434\0438\043B\0438 \043A\043E\043B\043E\043D\0435, \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0433\043E\0440\0435 ( &uarr; ) \0438\043B\0438 \041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0434\043E\043B\0435 ( &darr; ) \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\043C\0435\0440\0438\043B\0438 \0438\0437\0430\0431\0440\0430\043D\0443 \043A\043E\043B\043E\043D\0443 \043D\0430\0433\043E\0440\0435 \0438\043B\0438 \043D\0430\0434\043E\043B\0435 \0443 \043E\0434\043D\043E\0441\0443 \043D\0430 \0434\0440\0443\0433\0435 \043A\043E\043B\043E\043D\0435.</p>'),
'',
unistr('<p><strong>\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435</strong><br>'),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\0440\0430\0437\0430\0446 \0437\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \043A\043E\043B\043E\043D\0435 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435.<br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0443 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435, \0441\043C\0435\0440 \0441\043E\0440\0442\0438\0440\0430\045A\0430 \0438 \043D\0430\0447\0438\043D \0440\0430\0441\043F\043E\0440\0435\0452\0438\0432\0430\045A\0430 \043A\043E\043B\043E\043D\0430 \0441\0430 \0432\0440\0435\0434\043D\043E\0448\045B\0443 null (\043A\043E\043B\043E\043D\0430 \0431\0435\0437 \0432\0440\0435\0434\043D\043E\0441\0442\0438).</p>'),
'',
unistr('<p><em>\041D\0430\043F\043E\043C\0435\043D\0430: \041A\0430\0434\0430 \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0443 \043C\0440\0435\0436\0443, \043C\043E\0436\0435\0442\0435 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \043F\0440\0435\043B\043E\043C \043A\043E\043D\0442\0440\043E\043B\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043A\043B\0438\043A\043D\0443\0442\0438 \043D\0430 \0437\0430\0433\043B\0430\0432\0459\0435 \043A\043E\043B\043E\043D\0435 \0438 \0438\0437\0430\0431\0440\0430\0442\0438 \0438\043A\043E\043D\0443 \043F\0440\0435\043B\043E\043C\0430 \043A\043E\043D\0442\0440\043E\043B\0435.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010487537402154)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009278383402154)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0437\0430 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0435 \0441\0432\0438\0445 \0442\0440\0435\043D\0443\0442\043D\0438\0445 \0440\0435\0434\043E\0432\0430 \0443 \0441\043F\043E\0459\043D\0443 \0434\0430\0442\043E\0442\0435\043A\0443. \0414\0430\0442\043E\0442\0435\043A\0430 \045B\0435 \0441\0430\0434\0440\0436\0430\0442\0438 \0441\0430\043C\043E \0442\0440\0435\043D\0443\0442\043D\043E \043F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435, \043A\043E\0440\0438\0441\0442\0435\045B\0438 \0444\0438\043B\0442\0435\0440\0435 \0438 \0441\043E\0440\0442\0438\0440\0430\045A\0430 \043A\043E\0458\0430 \0441\0443 \043F\0440\0438\043C\0435\045A\0435\043D\0430 \043D\0430 \043F\043E\0434\0430\0442\043A\0435.</p>'),
'',
unistr('<p>\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \0434\0430\0442\043E\0442\0435\043A\0435 \0438 \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \041F\0440\0435\0443\0437\043C\0438.<br>'),
unistr('\041D\0430\043F\043E\043C\0435\043D\0430: CSV \0434\0430\0442\043E\0442\0435\043A\0430 \043D\0435 \043E\0431\0443\0445\0432\0430\0442\0430 \0444\043E\0440\043C\0430\0442\0438\0440\0430\045A\0435 \0442\0435\043A\0441\0442\0430, \043A\0430\043E \0448\0442\043E \0441\0443 \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430 \0438 \043F\0440\0435\043B\043E\043C\0438 \043A\043E\043D\0442\0440\043E\043B\0435.</p>'),
'',
unistr('<p>\0414\0430 \0431\0438\0441\0442\0435 \043F\043E\0441\043B\0430\043B\0438 \0434\0430\0442\043E\0442\0435\043A\0443 \0435-\043F\043E\0448\0442\043E\043C, \0438\0437\0430\0431\0435\0440\0438\0442\0435 \041F\043E\0448\0430\0459\0438 \043A\0430\043E \0435-\043F\043E\0440\0443\043A\0443 \0438 \0443\043D\0435\0441\0438\0442\0435 \0434\0435\0442\0430\0459\0435 \0435-\043F\043E\0440\0443\043A\0435 (\043F\0440\0438\043C\0430\043B\0430\0446, \0442\0435\043C\0430 \0438 \043F\043E\0440\0443\043A\0430).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010241848402154)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008464568402153)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0437\0430 \043A\043E\043D\0444\0438\0433\0443\0440\0438\0441\0430\045A\0435 \0444\0438\043B\0442\0435\0440\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043A\043E\0458\0438 \043E\0433\0440\0430\043D\0438\0447\0430\0432\0430\0458\0443 \0432\0440\0430\045B\0435\043D\0435 \0440\0435\0434\043E\0432\0435.</p>'),
'',
unistr('<p><strong>\041B\0438\0441\0442\0430 \0444\0438\043B\0442\0435\0440\0430</strong><br>'),
unistr('\041B\0438\0441\0442\0430 \0444\0438\043B\0442\0435\0440\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0435 \0444\0438\043B\0442\0435\0440\0435. \041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \0444\0438\043B\0442\0435\0440 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\043E\043D\0438\0448\0442\0438\0442\0438 \045A\0435\0433\043E\0432 \0438\0437\0431\043E\0440.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 ( &plus; ) \0434\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \043D\043E\0432\0438 \0444\0438\043B\0442\0435\0440 \0438\043B\0438 \043D\0430 \0418\0437\0431\0440\0438\0448\0438 ( &minus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\043A\043B\043E\043D\0438\043B\0438 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \0444\0438\043B\0442\0435\0440.</p>'),
'',
unistr('<p><strong>\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0444\0438\043B\0442\0435\0440\0430</strong><br>'),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\0440\0430\0437\0430\0446 \0437\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \0441\0432\043E\0458\0441\0442\0430\0432\0430 \0444\0438\043B\0442\0435\0440\0430.<br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043E\0434\0433\043E\0432\0430\0440\0430\0458\0443\045B\0438 \0442\0438\043F \0444\0438\043B\0442\0435\0440\0430:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0420\0435\0434 - \0444\0438\043B\0442\0435\0440 \0437\0430 \043F\043E\0458\0430\043C \0443 \0431\0438\043B\043E \043A\043E\0458\043E\0458 \043A\043E\043B\043E\043D\0438 \043A\043E\0458\0430 \043C\043E\0436\0435 \0434\0430 \0441\0435 \0444\0438\043B\0442\0440\0438\0440\0430.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\041A\043E\043B\043E\043D\0430 - \0444\0438\043B\0442\0440\0438\0440\0430\0458\0442\0435 \043E\0434\0440\0435\0452\0435\043D\0443 \043A\043E\043B\043E\043D\0443 \0441\0430 \043D\0430\0432\0435\0434\0435\043D\0438\043C \043E\043F\0435\0440\0430\0442\043E\0440\043E\043C \0438 \0432\0440\0435\0434\043D\043E\0448\045B\0443.</p>'),
'',
unistr('<p><em>\041D\0430\043F\043E\043C\0435\043D\0430: \041A\0430\0434\0430 \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0443 \043C\0440\0435\0436\0443, \043C\043E\0436\0435\0442\0435 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0444\0438\043B\0442\0435\0440\0435 \0440\0435\0434\0430 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \0443\043D\043E\0441\0438\0442\0438 \0442\0435\043A\0441\0442 \0434\0438\0440\0435\043A\0442\043D\043E \0443 \043F\043E\0459\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443. \041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443 \0434\0430 \0431\0438\0441\0442\0435 \043E\0433\0440\0430\043D\0438\0447\0438\043B\0438 \043F\0440\0435\0442\0440\0430\0433\0443 \043D\0430 \043E\0434\0440\0435\0452\0435\043D\0443 \043A\043E\043B\043E\043D\0443. \041F\043E\0440\0435\0434 \0442\043E\0433\0430, \043C\043E\0436\0435')
||unistr('\0442\0435 \0434\0430 \043E\0442\0432\043E\0440\0438\0442\0435 \043C\0435\043D\0438 \0437\0430\0433\043B\0430\0432\0459\0430 \043A\043E\043B\043E\043D\0435 \0438 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442 \0434\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \0444\0438\043B\0442\0435\0440 \043A\043E\043B\043E\043D\0435.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011073316402155)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0444\0438\043B\0442\0435\0440\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008821831402153)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0437\0430 \043F\0440\0435\0433\043B\0435\0434 \043F\043E\0434\0430\0442\0430\043A\0430 \0443 \043E\0431\043B\0438\043A\0443 \0443 \043A\043E\043C \0441\0443 \043F\043E\0441\0442\043E\0458\0430\043B\0438 \0443 \043D\0435\043A\043E\043C \0440\0430\043D\0438\0458\0435\043C \0432\0440\0435\043C\0435\043D\0441\043A\043E\043C \0442\0440\0435\043D\0443\0442\043A\0443.</p>'),
unistr('<p>\0423\043D\0435\0441\0438\0442\0435 \0431\0440\043E\0458 \043C\0438\043D\0443\0442\0430 \0443 \043F\0440\043E\0448\043B\043E\0441\0442\0438 \0434\0430 \0431\0438\0441\0442\0435 \0438\0437\0432\0440\0448\0438\043B\0438 \0443\043F\0438\0442 \0432\0440\0430\045B\0430\045A\0430 \0443 \043F\0440\043E\0448\043B\043E\0441\0442.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010669874402155)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0432\0440\0430\045B\0430\045A\0435 \0443 \043F\0440\043E\0448\043B\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011341705402155)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008969062402153)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0437\0430 \0438\0441\0442\0438\0446\0430\045A\0435 \0440\0435\0434\043E\0432\0430 \0438\043B\0438 \043A\043E\043B\043E\043D\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043D\0430 \043E\0441\043D\043E\0432\0443 \0443\043D\0435\0442\043E\0433 \0443\0441\043B\043E\0432\0430.</p>'),
'',
unistr('<p><strong>\041B\0438\0441\0442\0430 \0438\0441\0442\0438\0446\0430\045A\0430</strong><br>'),
unistr('\041B\0438\0441\0442\0430 \0438\0441\0442\0438\0446\0430\045A\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430 \0438\0441\0442\0438\0446\0430\045A\0430. \041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \0438\0441\0442\0438\0446\0430\045A\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\043E\043D\0438\0448\0442\0438\0442\0438 \045A\0435\0433\043E\0432 \0438\0437\0431\043E\0440.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 ( &plus; ) \0434\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \043D\043E\0432\043E \0438\0441\0442\0438\0446\0430\045A\0435 \0438\043B\0438 \0418\0437\0431\0440\0438\0448\0438 ( &minus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\043A\043B\043E\043D\0438\043B\0438 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \0438\0441\0442\0438\0446\0430\045A\0435.</p>'),
'',
unistr('<p><strong>\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0441\0442\0438\0446\0430\045A\0430</strong><br>'),
unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0431\0440\0430\0437\0430\0446 \0437\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \0441\0432\043E\0458\0441\0442\0430\0432\0430 \0438\0441\0442\0438\0446\0430\045A\0430.<br>'),
unistr('\0423\043D\0435\0441\0438\0442\0435 \0438\043C\0435, \0438\0437\0430\0431\0435\0440\0438\0442\0435 \0420\0435\0434 \0438\043B\0438 \041A\043E\043B\043E\043D\0430 \0438 \0438\0437\0430\0431\0435\0440\0438\0442\0435 HTML \0448\0438\0444\0440\0435 \0431\043E\0458\0430 \0437\0430 \043F\043E\0437\0430\0434\0438\043D\0443 \0438 \0442\0435\043A\0441\0442.<br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043E\0434\0433\043E\0432\0430\0440\0430\0458\0443\045B\0438 <strong>\0422\0438\043F \0443\0441\043B\043E\0432\0430</strong> \0437\0430 \0438\0441\0442\0438\0446\0430\045A\0435 \043E\0434\0440\0435\0452\0435\043D\0438\0445 \043F\043E\0434\0430\0442\0430\043A\0430:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0420\0435\0434 - \0438\0441\0442\0430\043A\043D\0438\0442\0435 \043F\043E\0458\0430\043C \0443 \0431\0438\043B\043E \043A\043E\0458\043E\0458 \043A\043E\043B\043E\043D\0438.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\041A\043E\043B\043E\043D\0430 - \0438\0441\0442\0438\0446\0430\045A\0435 \0443 \043E\043A\0432\0438\0440\0443 \043E\0434\0440\0435\0452\0435\043D\0435 \043A\043E\043B\043E\043D\0435 \043D\0430 \043E\0441\043D\043E\0432\0443 \043E\0434\0440\0435\0452\0435\043D\043E\0433 \043E\043F\0435\0440\0430\0442\043E\0440\0430 \0438 \0432\0440\0435\0434\043D\043E\0441\0442\0438.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010567545402155)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0438\0441\0442\0430\043A\043D\0443\0442\0435 \0441\0442\0430\0432\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009105151402153)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0434\0430 \0431\0438\0441\0442\0435 \0441\0430\0447\0443\0432\0430\043B\0438 \043F\0440\043E\043C\0435\043D\0435 \043A\043E\0458\0435 \0441\0442\0435 \043D\0430\043F\0440\0430\0432\0438\043B\0438 \043D\0430 \0442\0440\0435\043D\0443\0442\043D\043E\043C \0440\0430\0441\043F\043E\0440\0435\0434\0443 \0438 \043A\043E\043D\0444\0438\0433\0443\0440\0430\0446\0438\0458\0438 \043C\0440\0435\0436\0435.<br>'),
unistr('\041F\0440\043E\0433\0440\0430\043C\0435\0440\0438 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \043C\043E\0433\0443 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0443 \0432\0438\0448\0435 \0430\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0438\0445 \0440\0430\0441\043F\043E\0440\0435\0434\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \0422\0430\043C\043E \0433\0434\0435 \0458\0435 \0434\043E\0437\0432\043E\0459\0435\043D\043E, \0432\0438 \0438 \0434\0440\0443\0433\0438 \043A\0440\0430\0458\045A\0438 \043A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0436\0435\0442\0435 \0434\0430 \0441\0430\0447\0443\0432\0430\0442\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043A\0430\043E \0408\0430\0432\0430\043D, \0447\0438\043C\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043F\043E\0441\0442\0430\0458\0435 \0434\043E\0441\0442\0443\043F\0430\043D \0441\0432\0438\043C \0434\0440\0443\0433\0438\043C \043A\043E\0440\0438\0441\043D\0438\0446\0438\043C\0430 \043C\0440\0435\0436\0435. \041C\043E\0436\0435\0442\0435 \0438 \0434\0430 \0441\0430\0447\0443\0432\0430\0442')
||unistr('\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043A\0430\043E \041F\0440\0438\0432\0430\0442\0430\043D \0442\0430\043A\043E \0434\0430 \0441\0430\043C\043E \0432\0438 \043C\043E\0436\0435\0442\0435 \0434\0430 \0433\0430 \0432\0438\0434\0438\0442\0435.</p>'),
unistr('<p>\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0458\0435\0434\0430\043D \043E\0434 \0434\043E\0441\0442\0443\043F\043D\0438\0445 \0442\0438\043F\043E\0432\0430 \0438 \0443\043D\0435\0441\0438\0442\0435 \0438\043C\0435 \0437\0430 \0441\0430\0447\0443\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010339906402154)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041F\043E\043C\043E\045B \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0435'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008589082402153)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\0434\0435\0441\0438\043B\0438 \0440\0430\0441\043F\043E\0440\0435\0434 \043F\0440\0438\043A\0430\0437\0438\0432\0430\045A\0430.</p>'),
'',
unistr('<p><strong>\041B\0438\0441\0442\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0430</strong><br>'),
unistr('\0414\0438\0458\0430\043B\043E\0433 \0421\043E\0440\0442\0438\0440\0430\045A\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043B\0438\0441\0442\0443 \043A\043E\043D\0444\0438\0433\0443\0440\0438\0441\0430\043D\0438\0445 \043F\0440\0430\0432\0438\043B\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0430.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 ( &plus; ) \0434\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \043A\043E\043B\043E\043D\0443 \0437\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0435 \0438\043B\0438 \0418\0437\0431\0440\0438\0448\0438 ( &minus; ) \0434\0430 \0431\0438\0441\0442\0435 \0443\043A\043B\043E\043D\0438\043B\0438 \043A\043E\043B\043E\043D\0443 \0437\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0435.<br>'),
unistr('\041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0433\043E\0440\0435 ( &uarr; ) \0438 \041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0434\043E\043B\0435 ( &darr; ) \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\043C\0435\0440\0438\043B\0438 \0438\0437\0430\0431\0440\0430\043D\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0435 \043D\0430\0433\043E\0440\0435 \0438 \043D\0430\0434\043E\043B\0435 \0443 \043E\0434\043D\043E\0441\0443 \043D\0430 \0434\0440\0443\0433\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0435.</p>'),
'',
unistr('<p><strong>\041F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0441\043E\0440\0442\0438\0440\0430\045A\0430</strong><br>'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0443 \0437\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0435, \0441\043C\0435\0440 \0441\043E\0440\0442\0438\0440\0430\045A\0430 \0438 \043D\0430\0447\0438\043D \043D\0430 \043A\043E\0458\0438 \0441\0435 \0440\0430\0441\043F\043E\0440\0435\0452\0443\0458\0443 \043A\043E\043B\043E\043D\0435 \0441\0430 \0432\0440\0435\0434\043D\043E\0448\045B\0443 null (\043A\043E\043B\043E\043D\0435 \0431\0435\0437 \0432\0440\0435\0434\043D\043E\0441\0442\0438).</p>'),
'',
unistr('<p><em>\041D\0430\043F\043E\043C\0435\043D\0430: \041F\043E\0434\0430\0446\0438 \043C\043E\0433\0443 \0434\0430 \0441\0435 \0441\043E\0440\0442\0438\0440\0430\0458\0443 \043F\0440\0435\043C\0430 \043A\043E\043B\043E\043D\0430\043C\0430 \043A\043E\0458\0435 \0441\0435 \043D\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443. \041C\0435\0452\0443\0442\0438\043C, \043C\043E\0436\0434\0430 \043D\0435 \043C\043E\0433\0443 \0441\0432\0435 \043A\043E\043B\043E\043D\0435 \0434\0430 \0441\0435 \0441\043E\0440\0442\0438\0440\0430\0458\0443.</em><br>'),
unistr('<em>\041F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435 \043C\043E\0433\0443 \0434\0430 \0441\0435 \0441\043E\0440\0442\0438\0440\0430\0458\0443 \043F\0440\0438\0442\0438\0441\043A\043E\043C \043D\0430 \0441\0442\0440\0435\043B\0438\0446\0443 \043D\0430\0433\043E\0440\0435 (\0440\0430\0441\0442\0443\045B\0435) \0438\043B\0438 \043D\0430\0434\043E\043B\0435 (\043E\043F\0430\0434\0430\0458\0443\045B\0435) \043D\0430 \043A\0440\0430\0458\0443 \0437\0430\0433\043B\0430\0432\0459\0430 \043A\043E\043B\043E\043D\0435. \0414\0430 \0431\0438\0441\0442\0435 \0434\043E\0434\0430\043B\0438 \0434\043E\0434\0430\0442\043D\0443 \043A\043E\043B\043E\043D\0443 \043F\043E\0441\0442\043E\0458\0435\045B\0435\043C \0441\043E\0440\0442\0438\0440\0430\045A\0443, \043F\0440\0438\0442\0438\0441\043D\0438\0442\0435 \0438 \0437\0430\0434\0440\0436\0438\0442\0435 \0442\0430\0441\0442\0435\0440 Shift \0438 \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0441\0442\0440\0435\043B\0438\0446\0443 \043D\0430\0433\043E\0440\0435 \0438\043B')
||unistr('\0438 \043D\0430\0434\043E\043B\0435.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010914363402155)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0441\043E\0440\0442\0438\0440\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115010104278402154)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \043F\0440\0435\0442\043F\043B\0430\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962419997402117)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\043A\0440\0438\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929208995402091)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\0442\0430\043A\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997207366402144)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0438\0441\043E\043A\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998001558402145)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0425\043E\0440\0438\0437\043E\043D\0442\0430\043B\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955424324402112)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960475569402116)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043A\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928109886402091)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0438\043A\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953619288402110)
,p_name=>'APEX.IG.IN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962098723402117)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0430\043A\0442\0438\0432\043D\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962162742402117)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0430\043A\0442\0438\0432\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969739336402123)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0438\043D\0442\0435\0440\043D\0435 \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043E\0431\0440\0430\0434\0435 \0437\0430\0445\0442\0435\0432\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865571305402042)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0444\0438\043B\0442\0435\0440\0430 \043A\043E\043B\043E\043D\0435 "%0" \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \0437\0430 \043A\043E\043B\043E\043D\0443 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009948550402154)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0444\043E\0440\043C\0430\0442 \0434\0430\0442\0443\043C\0430')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984100448402134)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430 \043C\0440\0435\0436\0430 \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \0444\0438\043B\0442\0435\0440\0430 \0437\0430 \043A\043E\043B\043E\043D\0443 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984044434402134)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0438 \0442\0438\043F \0444\0438\043B\0442\0435\0440\0430 \0437\0430 \0434\0435\0444\0438\043D\0438\0441\0430\045A\0435 \0444\0438\043B\0442\0435\0440\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870600560402046)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0444\043E\0440\043C\0430\0442 \0431\0440\043E\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012664852402156)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012708537402156)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003756340402149)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0446\0438\0458\0430 \0421\043E\0440\0442\0438\0440\0430\0458 \043F\043E \0458\0435 \043F\043E\0434\0435\0448\0435\043D\0430 \043D\0430 %0, \0430\043B\0438 \0437\0430 %0 \043D\0438\0458\0435 \0438\0437\0430\0431\0440\0430\043D\0430 \043D\0438\0458\0435\0434\043D\0430 \043A\043E\043B\043E\043D\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001099743402147)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996172451402143)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043F\0440\0438\043A\0430\0437\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954449439402111)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0442\043E\043A\043E\043C \043F\0440\043E\0442\0435\043A\043B\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954613512402111)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0443 \0441\043B\0435\0434\0435\045B\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953599361402110)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \043F\0440\0430\0437\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953451357402110)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\0440\0430\0437\043D\043E \0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004588445402150)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996524228402143)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000418710402147)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943763155402103)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\0438 \0434\0430\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943925665402103)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438 \0441\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944458608402103)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438 \043C\0438\043D\0443\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943434105402103)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0438 \043C\0435\0441\0435\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943546337402103)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0430 \043D\0435\0434\0435\0459\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943664817402103)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943877324402103)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0441\0430\0442\0438 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944519734402103)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0438\043D\0443\0442\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944398994402103)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0435\0441\0435\0446\0438 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944214308402103)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043D\0435\0434\0435\0459\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943219578402102)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943386760402102)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0430 \0433\043E\0434\0438\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004777584402150)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0430\0432\043D\0430\045A\0435 \045B\0435\043B\0438\0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004824073402150)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\0442\0438 \0433\0440\0443\043F\0443 \0437\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954011400402111)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0430\045A\0435 \043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954193753402111)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0430\045A\0435 \043E\0434 \0438\043B\0438 \0458\0435\0434\043D\0430\043A\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998637312402145)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\043D\0438\0458\0441\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998738819402145)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\043D\0438\0458\0441\043A\0438 \0441\0430 \043F\043E\0432\0440\0448\0438\043D\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005129799402150)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'sr'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997340143402144)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0441\043A\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007791586402152)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\045B\0438 \0431\0440\043E\0458 \0430\0434\0440\0435\0441\0430 \0440\0430\0437\0434\0432\043E\0458\0438\0442\0435 \0437\0430\0440\0435\0437\0438\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955217329402112)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\0434\0443\0434\0430\0440\0430 \0441\0435 \0441\0430 \0443\043E\0431\0438\0447\0430\0458\0435\043D\0438\043C \0438\0437\0440\0430\0437\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979683788402131)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015222199402158)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \043C\0430\043A\0441\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979864444402131)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0440\0435\0434\045A\0430 \0432\0440\0435\0434\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015307539402158)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0430 \0441\0440\0435\0434\045A\0430 \0432\0440\0435\0434\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979504592402131)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955334395402112)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980370589402131)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 \0432\0438\0448\0435 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015158073402158)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \043C\0438\043D\0438\043C\0443\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955750373402112)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962303492402117)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0435\0434\043E\0432\0430 (%0) \043A\043E\0458\0435 \0441\0430\0434\0440\0436\0435 \043E\0432\0438 \043F\043E\0434\0430\0446\0438 \043F\0440\0435\043C\0430\0448\0443\0458\0435 \0434\043E\0437\0432\043E\0459\0435\043D\0438 \043C\0430\043A\0441\0438\043C\0443\043C. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0434\043E\0434\0430\0442\043D\0435 \0444\0438\043B\0442\0435\0440\0435 \0434\0430 \0431\0438\0441\0442\0435 \0432\0438\0434\0435\043B\0438 \0440\0435\0437\0443\043B\0442\0430\0442\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989050263402138)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0442\0438\0447\043A\0438 ID \0440\0435\0433\0438\043E\043D\0430 \043C\043E\0440\0430 \0434\0430 \0441\0435 \043D\0430\0432\0435\0434\0435 \0458\0435\0440 \0441\0442\0440\0430\043D\0438\0446\0430 \0441\0430\0434\0440\0436\0438 \0432\0438\0448\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438\0445 \043C\0440\0435\0436\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958451706402114)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958609413402114)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435\043D\043E\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942652304402102)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \0434\0430\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942476817402102)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \0441\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944607392402103)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \043C\0438\043D\0443\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942910893402102)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \043C\0435\0441\0435\0446')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942838090402102)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0430 \043D\0435\0434\0435\0459\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942790122402102)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114942588834402102)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0441\0430\0442\0438 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944790000402104)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0438\043D\0443\0442\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944054184402103)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0435\0441\0435\0446\0438 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944138101402103)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043D\0435\0434\0435\0459\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943169125402102)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114943076448402102)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0430 \0433\043E\0434\0438\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954325132402111)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0438\0437\043C\0435\0452\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953340759402110)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0458\0435\0434\043D\0430\043A\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019541350402161)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0433\0438\043E\043D \0441\0430 ID-\043E\043C %0 \043D\0438\0458\0435 \0443 \0440\0435\0433\0438\043E\043D\0443 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435 \0438\043B\0438 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953796404402110)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954505286402111)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0442\043E\043A\043E\043C \043F\0440\043E\0442\0435\043A\043B\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114954771375402111)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0443 \0441\043B\0435\0434\0435\045B\0438\0445')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962248801402117)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0430\0446\0438 \043D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000281004402146)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'sr'
,p_message_text=>unistr('Null \0432\0440\0435\0434\043D\043E\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005375208402150)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0443\043C\0435\0440\0438\0447\043A\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000514457402147)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\043A\0459\0443\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000626565402147)
,p_name=>'APEX.IG.ON'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952571461402110)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 1 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008212909402153)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\0432\043E\0440\0438 \0431\0438\0440\0430\0447 \0431\043E\0458\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997012652402144)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\0432\043E\0440\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959508891402115)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0435\0440\0430\0442\043E\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996480706402143)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0440\0438\0458\0435\043D\0442\0430\0446\0438\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998874328402145)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0443\0436\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114960886239402116)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0438\0432\043E\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114928437991402091)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \043F\0438\0432\043E\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115008109832402153)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0437\0434\0432\043E\0458\0438\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0437\043D\0430\043A\043E\043C "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114998905815402145)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043B\0430\0440\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004242931402150)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0440\0435\0434\0438\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004353265402150)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115004113907402150)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0442\0430\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958744299402114)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\0440\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959034910402115)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\0440\043D\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975519469402127)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\0440\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857715075402036)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0443\0445\0432\0430\0442\0438 \043E\0437\043D\0430\043A\0435 \043F\0440\0438\0441\0442\0443\043F\0430\0447\043D\043E\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856494331402035)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043B\043E\0436\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856598340402035)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0441\043F\0440\0430\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856343943402035)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0440\0438\0458\0435\043D\0442\0430\0446\0438\0458\0430 \0441\0442\0440\0430\043D\0438\0446\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856293832402035)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'sr'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856106614402034)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'sr'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857888245402036)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043B\0430\0433\043E\0452\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855941759402034)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'sr'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855868328402034)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'sr'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856001092402034)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'sr'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855736703402034)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\043B\0438\0447\0438\043D\0430 \0441\0442\0440\0430\043D\0438\0446\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845939435402027)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \043E\0431\043E\0433\0430\045B\0435\043D\0438 \0442\0435\043A\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999026491402145)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\0430\0440\0441\043A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999176701402146)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0441\0435\0433')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009464691402154)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0441\0432\0435\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963067789402118)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0441\0432\0435\0436\0438 \0440\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961866619402117)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0441\0432\0435\0436\0438 \0440\0435\0434\043E\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967087564402121)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0433\0438\043E\043D \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 %0, \0441\0442\0440\0430\043D\0438\0446\0438 %1 \0438 \0440\0435\0433\0438\043E\043D\0443 %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929924862402092)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958135681402114)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018795175402161)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 \0458\0435 \0438\0437\0431\0440\0438\0441\0430\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018432310402161)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0458\0435 \0441\0430\0447\0443\0432\0430\043D \0437\0430 \0441\0432\0435 \043A\043E\0440\0438\0441\043D\0438\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018329289402161)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0458\0435 \0441\0430\0447\0443\0432\0430\043D \0437\0430 \0441\0432\0435 \043A\043E\0440\0438\0441\043D\0438\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018642321402161)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0432\0430\0442\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0458\0435 \0441\0430\0447\0443\0432\0430\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018567589402161)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0430\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0458\0435 \0441\0430\0447\0443\0432\0430\043D \0437\0430 \0441\0432\0435 \043A\043E\0440\0438\0441\043D\0438\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114967122161402121)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430 \043C\0440\0435\0436\0430 \043F\043E\0434 \0438\043C\0435\043D\043E\043C %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952450961402109)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0441\0442\0438 \043E \043F\043E\0434\0430\0446\0438\043C\0430 \043E\0434 \043F\0440\0435 %0 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952375891402109)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0441\0442\0438 \043E \043F\043E\0434\0430\0446\0438\043C\0430 \043E\0434 \043F\0440\0435 1 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892098427402063)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0435 \043C\0440\0435\0436\0435 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011615120402155)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 - \0443\0440\0435\0434\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966936687402121)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430 \043C\0440\0435\0436\0430 \0441\0430 ID-\043E\043C %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115011581885402155)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 - \0441\0430\0447\0443\0432\0430\0458 \043A\0430\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930005961402092)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019605726402162)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0430 \043C\0440\0435\0436\0430 \0441\0430 \0441\0442\0430\0442\0438\0447\043A\0438\043C ID-\043E\043C %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014522841402158)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929122623402091)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963121619402118)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\0442\0438 \043F\0440\043E\043C\0435\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961965816402117)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\0442\0438 \0440\0435\0434\043E\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959112509402115)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958000846402114)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \043F\043E \0441\0442\0440\0430\043D\0438\0446\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019216862402161)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\045A\0435 \043D\0430 \0440\0435\0434\043E\0432\0438\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020474985402162)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\045A\0435 \0437\0430 \0440\0435\0434 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114929488442402092)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972190452402125)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0441\0430\0447\0443\0432\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927674105402090)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927711801402090)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902207630402071)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \043F\043E\0434 \0438\043C\0435\043D\043E\043C %0 \0432\0435\045B \043F\043E\0441\0442\043E\0458\0438. \0423\043D\0435\0441\0438\0442\0435 \043D\043E\0432\043E \0438\043C\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927872063402090)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0432\0430\0442\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927972912402090)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0430\0432\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014227995402157)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458 \043A\0430\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961212080402116)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999265660402146)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0441\0443\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927585358402090)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006565572402151)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430: \0441\0432\0435 \0442\0435\043A\0441\0442\0443\0430\043B\043D\0435 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927447739402090)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005767698402151)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430: \0446\0435\043E \0442\0435\043A\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952282255402109)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0438 ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995874657402143)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936032012402097)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988733403402138)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 1 \0440\0435\0434 \0443 \0433\043B\0430\0432\043D\043E\043C \0440\0435\0433\0438\043E\043D\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927347888402090)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018919542402161)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\045A\0435 \0438\0437\0431\043E\0440\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936227251402097)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440 \045B\0435\043B\0438\0458\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936123986402097)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\043E\0440 \0440\0435\0434\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007190295402152)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438 \0435-\043F\043E\0448\0442\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999644620402146)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0435\0440\0438\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925381836402088)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977957361402129)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0443\043A\0443\043F\043D\0443 \0432\0440\0435\0434\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962714044402118)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0458\0435\0434\043D\043E\0433 \0440\0435\0434\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961073018402116)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999774257402146)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \043F\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019360954402161)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0441\0432\0430\043A\043E\0458 \043A\043E\043B\043E\043D\0438 \043C\043E\0436\0435\0442\0435 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0441\0430\043C\043E \0458\0435\0434\043D\043E \0441\043E\0440\0442\0438\0440\0430\045A\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019111918402161)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\043D\0438 \0437\0430 \043F\0440\043E\043C\0435\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115000750020402147)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0435\043A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955000263402111)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\0447\0438\045A\0435 \0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999312224402146)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\043B\0438\0445\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920304098402085)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0437\0432\0443\0446\0438 \0448\0438\0440\0438\043D\0435 \043A\043E\043B\043E\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114961479960402117)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\043F\043B\0430\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114979410334402130)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0431\0438\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020617763402162)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \043E \043C\0440\0435\0436\0438: %0, \043F\0440\0438\043A\0430\0437: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115014679328402158)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0438 \0437\0431\0438\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997579959402144)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0426\0438\0459')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003912125402149)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\043E\0458\0430 \0442\0435\043A\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930177368402092)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0438/\0438\0441\043A\0459\0443\0447\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977851396402129)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0438\0441 \0430\043B\0430\0442\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114958233445402114)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114962668606402117)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\043C\0440\0437\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959732056402115)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0435\0434\0438\043D\0438\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006991488402152)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\0442\043E\0458\0435 \043D\0435\0441\0430\0447\0443\0432\0430\043D\0435 \043F\0440\043E\043C\0435\043D\0435. \0416\0435\043B\0438\0442\0435 \043B\0438 \0434\0430 \043D\0430\0441\0442\0430\0432\0438\0442\0435?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114959655499402115)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996643771402144)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001517344402147)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \0458\0435 \043E\0431\0430\0432\0435\0437\043D\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986498019402136)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 (\0432\0440\0435\043C\0435\043D\0441\043A\0430 \0437\043E\043D\0430 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\0440\043E\043C\0435\043D\0438)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005415846402151)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043A\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997942154402145)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\0440\0442\0438\043A\0430\043B\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957736621402114)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995936271402143)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114997485366402144)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0438\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955693155402112)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996074131402143)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0430\043B\043D\0430 \0448\0438\0440\0438\043D\0430 \043A\043E\043B\043E\043D\0435 (\043F\0438\043A\0441\0435\043B\0438)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946803085402105)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \0438\0437\043C\0435\0452\0443 %1 \0438 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946517892402105)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0430\0434\0440\0436\0438 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946684183402105)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0441\0430\0434\0440\0436\0438 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924794765402088)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \043F\043E\0447\0438\045A\0435 \0441\0430 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945364237402104)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \0458\0435\0434\043D\0430\043A\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945533601402104)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \0432\0435\045B\0435 \043E\0434 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945679539402104)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \0432\0435\045B\0435 \0438\043B\0438 \0458\0435\0434\043D\0430\043A\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946305694402105)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947587092402106)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947385808402106)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0447\0430\0441\043E\0432\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947170559402105)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0438\043D\0443\0442\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947912856402106)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0435\0441\0435\0446\0438 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947748275402106)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043D\0435\0434\0435\0459\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948142816402106)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947493394402106)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \0434\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947226210402106)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \0447\0430\0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947037341402105)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947823939402106)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \043C\0435\0441\0435\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114947612159402106)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435 \043D\0435\0434\0435\0459\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948043655402106)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435 \0433\043E\0434\0438\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949930591402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949751533402107)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0447\0430\0441\043E\0432\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949579892402107)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445  \043D\0435\043A\043E\043B\0438\043A\043E \043C\0438\043D\0443\0442\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950397178402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0435\0441\0435\0446\0438 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950162197402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043D\0435\0434\0435\0459\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950511441402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949872737402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \0434\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949625341402107)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \0447\0430\0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949420175402107)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950252091402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \043C\0435\0441\0435\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950073257402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435 \043D\0435\0434\0435\0459\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950448568402108)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435 \0433\043E\0434\0438\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946021181402105)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \043F\0440\0430\0437\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945977558402104)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \043F\0440\0430\0437\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945783567402104)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \043C\0430\045A\0435 \043E\0434 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945878965402104)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0430\045A\0435 \0438\043B\0438 \0458\0435\0434\043D\0430\043A\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946147482402105)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \043A\0430\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946752476402105)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0435 \043F\043E\0434\0443\0434\0430\0440\0430 \0441\0430 \0443\043E\0431\0438\0447\0430\0458\0435\043D\0438\043C \0438\0437\0440\0430\0437\043E\043C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952656031402110)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946957442402105)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0438\0437\043C\0435\0452\0443 %1 \0438 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945417939402104)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0458\0435\0434\043D\0430\043A\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946448744402105)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0443 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948710049402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948522262402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0447\0430\0441\043E\0432\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948308674402106)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0438\043D\0443\0442\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949197362402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0435\0441\0435\0446\0438 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948990003402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043D\0435\0434\0435\0459\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949381360402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%1)')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948673946402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \0434\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948447700402106)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \0447\0430\0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948279072402106)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949025480402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435\0433 \043C\0435\0441\0435\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114948852037402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435 \043D\0435\0434\0435\0459\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114949241236402107)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \043F\043E\0441\043B\0435\0434\045A\0435 \0433\043E\0434\0438\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951105773402108)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950918954402108)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0447\0430\0441\043E\0432\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950781569402108)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0438\043D\0443\0442\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951507159402109)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043C\0435\0441\0435\0446\0438 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951348874402109)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \043D\0435\0434\0435\0459\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951730924402109)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951067910402108)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \0434\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950804406402108)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \0447\0430\0441\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114950604149402108)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \043C\0438\043D\0443\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951406118402109)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435\0433 \043C\0435\0441\0435\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951290494402109)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435 \043D\0435\0434\0435\0459\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951675638402109)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \0443 \0442\043E\043A\0443 \0441\043B\0435\0434\0435\045B\0435 \0433\043E\0434\0438\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114946266172402105)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \043A\0430\043E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953102113402110)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043F\043E\0447\0438\045A\0435 \0441\0430 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996716152402144)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'sr'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955880614402112)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0433\043E\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996869042402144)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'sr'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996935915402144)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'sr'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115005900712402151)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\043D\0435\0434\0435\0459\0430\043A, 12. \0458\0430\043D\0443\0430\0440 2016.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006014238402151)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'sr'
,p_message_text=>unistr('\0458\0430\043D\0443\0430\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006139577402151)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 16 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115006296749402151)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 16 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861238134402038)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0442\0438\043F \0434\0430\0442\043E\0442\0435\043A\0435. \041F\043E\0434\0440\0436\0430\043D\0438 \0442\0438\043F\043E\0432\0438 \0434\0430\0442\043E\0442\0435\043A\0435: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988166963402137)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987800650402137)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0430\0431\0435\0440\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987927336402137)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0430\0431\0435\0440\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861066123402038)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0432\0443\0446\0438\0442\0435 \0438 \043E\0442\043F\0443\0441\0442\0438\0442\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861443006402039)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0432\0443\0446\0438\0442\0435 \0438 \043E\0442\043F\0443\0441\0442\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862693432402040)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0443 \0438\043B\0438 \0458\0435 \043E\0442\043F\0443\0441\0442\0438\0442\0435 \043E\0432\0434\0435.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862773715402040)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0438\043B\0438 \043F\0440\0435\0432\0443\0446\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0435 \043E\0432\0434\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862864291402040)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0443 \0438\043B\0438 \0458\0435 \043E\0442\043F\0443\0441\0442\0438\0442\0435 \043E\0432\0434\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862903531402040)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0438\043B\0438 \043F\0440\0435\0432\0443\0446\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0435 \043E\0432\0434\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861359848402039)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0434\0430\0442\043E\0442\0435\043A\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861170817402038)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\043E\0442\0435\043A\0430 \0458\0435 \043F\0440\0435\0432\0435\043B\0438\043A\0430. \041C\0430\043A\0441\0438\043C\0430\043B\043D\0430 \0432\0435\043B\0438\0447\0438\043D\0430 \0434\0430\0442\043E\0442\0435\043A\0435 \0458\0435 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848912478402029)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0434\0440\0435\0441\0430 \0458\0435 \043E\0431\0430\0432\0435\0437\043D\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847814941402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0430\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848274177402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0437\0438\0432\043D\0438 \0431\0440\043E\0458 \0437\0430 \0437\0435\043C\0459\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847904217402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0443\045B\043D\0438 \0431\0440\043E\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848890205402029)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0435\043E\0433\0440\0430\0444\0441\043A\0430 \0448\0438\0440\0438\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848730386402029)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0435\043E\0433\0440\0430\0444\0441\043A\0430 \0434\0443\0436\0438\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848686433402029)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \043D\0430 \043C\0430\043F\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848322017402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0446\0435\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848058063402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0442\0430\043D\0441\043A\0438 \0431\0440\043E\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848159641402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0442\0443\0441')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847798905402028)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043B\0438\0446\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847639356402028)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\0442\0430\0442\0438 \0433\0435\043E\0433\0440\0430\0444\0441\043A\043E\0433 \0448\0438\0444\0440\043E\0432\0430\045A\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860298660402038)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430 \0433\0435\043E\0433\0440\0430\0444\0441\043A\043E\043C \0448\0438\0444\0440\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860329467402038)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0435\0437 \0433\0435\043E\0433\0440\0430\0444\0441\043A\0435 \0448\0438\0444\0440\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848578521402029)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043F\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114848478865402028)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430 \0430\0434\0440\0435\0441\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849020292402029)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \043E\0431\0430\0432\0435\0437\043D\043E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018810646402161)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043A\0441\0442 \043F\043E\043C\043E\045B\0438: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912236193402078)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912396694402078)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0437\043D\0430\0447\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858222908402036)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043D\0438\0458\0435 \0443 \0432\0430\0436\0435\045B\0435\043C \043E\043F\0441\0435\0433\0443 \043E\0434 %0 \0434\043E %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858391689402036)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 #LABEL# \043D\0438\0458\0435 \0434\0435\0459\0438\0432\0430 \0441\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857970767402036)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0441\0435 \043F\043E\0434\0443\0434\0430\0440\0430 \0441\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438\043C\0430 %0 \0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858169096402036)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936434319402097)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\043A\0459\0443\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936515650402097)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858041754402036)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841479219402023)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \0443\043D\043E\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970660072402124)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970727445402124)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841536557402023)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0440\0430\043D\0438 \0443\043D\043E\0441\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974468517402127)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\043F\0440\0435\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974747271402127)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\043A\0430\0436\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974588136402127)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0448\0442\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974813000402127)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043A\0442\0438\0432\043D\0435 \043E\043F\0446\0438\0458\0435 \0448\0430\0431\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975471000402127)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0446\0438\0458\0435 \0448\0430\0431\043B\043E\043D\0430 \043D\0438\0441\0443 \0434\043E\0441\0442\0443\043F\043D\0435 \0458\0435\0440 \0441\0435 \043E\0432\0430 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0430 \043D\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974383755402127)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430 \043D\0438\0458\0435\0434\043D\0430 \043E\043F\0446\0438\0458\0430 \0448\0430\0431\043B\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974677427402127)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849996635402030)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0438\0448\0438 \043A\0440\0443\0433')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851709329402031)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0438 \0441\0442\0438\043B\043E\0432\0438 \043D\0438\0441\0443 \0432\0430\0436\0435\045B\0438 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850228861402030)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0430\0442\043A\0430 \0437\0430 \0440\0430\0441\0442\043E\0458\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850036163402030)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0446\0440\0442\0430\0458 \043A\0440\0443\0433')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842693267402024)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043F\0435\0446\0438\0458\0430\043B\0438\0437\043E\0432\0430\043D\0430 \043F\0440\0435\0442\0440\0430\0433\0430 \0437\0430\0445\0442\0435\0432\0430 \0438\0437\0432\043E\0440 \043F\043E\0434\0430\0442\0430\043A\0430 \043D\0430 \043D\0438\0432\043E\0443 \0440\0435\0433\0438\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845247976402026)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043A\0442\0443\0435\043B\043D\0430 \043B\043E\043A\0430\0446\0438\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846386828402027)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043E\0440\0434\0438\043D\0430\0442\0435 \043F\043E\0447\0435\0442\043D\043E\0433 \043F\043E\043B\043E\0436\0430\0458\0430 \043D\0438\0441\0443 \0432\0430\0436\0435\045B\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843766054402025)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0442\043D\0438 \043F\043E\043B\043E\0436\0430\0458 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0433\0435\043E\043C\0435\0442\0440\0438\0458\0430 \0442\0430\0447\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846123637402027)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'sr'
,p_message_text=>unistr('\043A\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844710326402026)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\043E\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978010846402129)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\043E\0458: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849398072402029)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043F\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842551096402024)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0443\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846225981402027)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'sr'
,p_message_text=>unistr(' \043C\0438\0459.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977025318402129)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \043A\043E\0458\0438 \043F\043E\0434\0430\0446\0438 \0441\0430\0434\0440\0436\0435 \0458\0435 %0, \0448\0442\043E \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0434\043E\0437\0432\043E\0459\0435\043D\0438 \0431\0440\043E\0458.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844598169402025)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\0423\0441\043B\043E\0432\0438</a> &nbsp;&nbsp; \041F\043E\0434\0430\0446\0438 \043C\0430\043F\0435 &copy; 2017. \041E\0412\0414\0415')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843481473402025)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 SDO_GEOMETRY \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\0430\043D \0443 \043E\0432\043E\0458 \0431\0430\0437\0438 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844669232402026)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap - \0441\0430\0440\0430\0434\043D\0438\0446\0438 </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844857414402026)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0430\0447\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978127022402129)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0430\0447\0430\043A\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850141087402030)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0430\0432\043E\0443\0433\0430\043E\043D\043E \0443\0432\0435\045B\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849864286402030)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845154393402026)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\043E\0432\0430\045A\0435 \0441\043C\0435\0440\0430 \043D\0430 \0441\0435\0432\0435\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925443009402089)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0438 2D \0440\0435\0436\0438\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925525993402089)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0438 3D \0440\0435\0436\0438\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849764356402029)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0438/\0438\0441\043A\0459\0443\0447\0438 \043E\0431\0430\0432\0435\0448\0442\0435\045A\0435 \043E \0430\0443\0442\043E\0440\0441\043A\043E\043C \043F\0440\0430\0432\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850374367402030)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\0430 \0443\0434\0430\0459\0435\043D\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844912670402026)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0432\0435\045B\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845012506402026)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043C\0430\045A\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972539205402125)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0431\0459\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973451361402126)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0438\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973099335402125)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043C\0435\0442\043D\0443\0442 \043A\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986694554402136)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043C\0435\0442\043D\0438 \0441\043B\0438\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986718199402136)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043C\0435\0442\043D\0438 \0432\0435\0437\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972608323402125)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0443\0440\0437\0438\0432')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987338459402136)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\0437\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973380019402126)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973264646402126)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430 \0441\0430 \0440\0435\0434\043D\0438\043C \0431\0440\043E\0458\0435\0432\0438\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972744619402125)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0433\043B\0435\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972861416402125)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043C\0430 \043D\0438\0447\0435\0433\0430 \0437\0430 \043F\0440\0435\0433\043B\0435\0434')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972975721402125)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0446\0440\0442\0430\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973101163402126)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0443\0440\0435\0452\0435\043D\0430 \043B\0438\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952037534402109)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\0442\0440\0435\043D\0443\0442\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115009539905402154)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0438\0448\0435...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114951954963402109)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0432\0430\045A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983786211402134)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0443\043A\0430 \043E\0431\0430\0432\0435\0448\0442\0435\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957013257402113)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0431\0440\043E\0458 \043A\043E\0458\0438 \0458\0435 \043C\0430\045A\0438 \043E\0434 \0438\043B\0438 \0458\0435\0434\043D\0430\043A %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957105282402113)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0432\0430\0436\0435\045B\0438 \0431\0440\043E\0458.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957266430402113)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \0441\0435 \043D\0435 \043F\043E\0434\0443\0434\0430\0440\0430 \0441\0430 \0444\043E\0440\043C\0430\0442\043E\043C \0431\0440\043E\0458\0430 %0 (\043F\0440\0438\043C\0435\0440: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956971429402113)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0431\0440\043E\0458 \043A\043E\0458\0438 \0458\0435 \0432\0435\045B\0438 \043E\0434 \0438\043B\0438 \0458\0435\0434\043D\0430\043A %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956895057402113)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0431\0440\043E\0458 \0438\0437\043C\0435\0452\0443 %0 \0438 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952127860402109)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'sr'
,p_message_text=>unistr('\043E\0442\0432\0430\0440\0430 \0441\0435 \0443 \043D\043E\0432\043E\043C \043F\0440\043E\0437\043E\0440\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905335092402073)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430 \0441\0442\0440\0430\043D\0438\0446\0430 \0458\0435 \0432\0435\045B \043F\0440\043E\0441\043B\0435\0452\0435\043D\0430 \0438 \043D\0435 \043C\043E\0436\0435 \043F\043E\043D\043E\0432\043E \0434\0430 \0441\0435 \043F\0440\043E\0441\043B\0435\0434\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887918156402059)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043F\043B\0438\043A\0430\0446\0438\0458\0430 "%0", \0441\0442\0440\0430\043D\0438\0446\0430 "%1" \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921751486402086)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('#LABEL# \043C\043E\0440\0430 \0434\0430 \0438\043C\0430 \043D\0435\043A\0443 \0432\0440\0435\0434\043D\043E\0441\0442.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865088482402041)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971009271402124)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0442\0432\043E\0440\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970923819402124)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0438%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971233584402124)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971104944402124)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857169629402035)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043D\0435\0441\0438\0442\0435 \0442\0435\0440\043C\0438\043D \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443 \0443\0437 \043C\0438\043D\0438\043C\0430\043B\0430\043D \0431\0440\043E\0458 \0437\043D\0430\043A\043E\0432\0430 (%0).')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926649765402089)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\043A\0430\0447\0443\045B\0430 \043B\0438\0441\0442\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857240077402035)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043D\0435\0441\0438\0442\0435 \0442\0435\0440\043C\0438\043D \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857011707402035)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\0442\0430\0442\0438 \043D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856961706402035)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944819307402104)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0441\043B\043E\0432 \043F\0440\0435\0442\0440\0430\0436\0438\0432\0430\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970877008402124)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981507201402132)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0430\0434\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855536788402034)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851549704402031)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0418\0437\0433\043B\0435\0434\0430 \0434\0430 \0443\0440\0435\0452\0430\0458 \0438\043B\0438 \043F\0440\0435\0433\043B\0435\0434\0430\0447 \0442\0440\0435\043D\0443\0442\043D\043E \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430\0458\0443 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435 \043F\0440\043E\0433\0440\0435\0441\0438\0432\043D\0438\0445 \0432\0435\0431-\0430\043F\043B\0438\043A\0430\0446\0438\0458\0430.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0410\043A\043E \0458\0435 \043E\0432\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \0432\0435\045B \0438\043D\0441\0442\0430\043B\0438\0440\0430\043D\0430 \043D\0430 \0443\0440\0435\0452\0430\0458\0443, \043E\0442\0432\043E\0440\0438\0442\0435 \0458\0435 \0441\0430 \043F\043E\0447\0435\0442\043D\043E\0433 \0435\043A\0440\0430\043D\0430.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851113616402031)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \0414\043E\0434\0430\0458\0442\0435 \0458\0435 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D \0434\0430 \0431\0438\0441\0442\0435 \0458\0435 \043A\043E\0440\0438\0441\0442\0438\043B\0438 \043F\0440\0435\043A\043E \0446\0435\043B\043E\0433 \0435\043A\0440\0430\043D\0430.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\041C\0435\043D\0438</strong> \0443 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0438 \043D\0430 \0434\043D\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0414\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\0418\043D\0441\0442\0430\043B\0438\0440\0430\0458</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0414\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\0414\043E\0434\0430\0458</strong> \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\0442\0432\0440\0434\0438\043B\0438</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851201083402031)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0435 \043A\043E\0458\0435 \0441\0435 \043D\0430\0458\0431\043E\0459\0435 \0434\043E\0436\0438\0432\0459\0430\0432\0430\0458\0443 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0438\043C\0430 Chrome \0438\043B\0438 Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\041C\0435\043D\0438</strong> \043F\043E\0440\0435\0434 \0442\0440\0430\043A\0435 \0437\0430 \0430\0434\0440\0435\0441\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0414\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\0418\043D\0441\0442\0430\043B\0438\0440\0430\0458</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850854965402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0435 \043A\043E\0458\0435 \0441\0435 \043D\0430\0458\0431\043E\0459\0435 \0434\043E\0436\0438\0432\0459\0430\0432\0430\0458\0443 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0443 Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\0414\0435\043B\0438</strong> \0443 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0438 \0443 \0434\043D\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0414\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\041E\0442\0432\043E\0440\0438 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0443 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850573093402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \0414\043E\0434\0430\0458\0442\0435 \0458\0435 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D \0434\0430 \0431\0438\0441\0442\0435 \043E\0441\0442\0432\0430\0440\0438\043B\0438 \043D\0430\0458\0431\043E\0459\0438 \0434\043E\0436\0438\0432\0459\0430\0458.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\0414\0435\043B\0438</strong> \043F\043E\0440\0435\0434 \0442\0440\0430\043A\0435 \0437\0430 \0430\0434\0440\0435\0441\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0441\0442\0430\0432\043A\0443 <strong>\0414\043E\0434\0430\0458 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0441\0442\0430\0432\043A\0443 <strong style="color:#007AE1;">\0414\043E\0434\0430\0458</strong> \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\0442\0432\0440\0434\0438\043B\0438</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850402900402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \0414\043E\0434\0430\0458\0442\0435 \0458\0435 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D \0434\0430 \0431\0438\0441\0442\0435 \043E\0441\0442\0432\0430\0440\0438\043B\0438 \043D\0430\0458\0431\043E\0459\0438 \0434\043E\0436\0438\0432\0459\0430\0458.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\0414\0435\043B\0438</strong> \0443 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0438 \043D\0430 \0434\043D\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \041A\0440\0435\045B\0438\0442\0435 \0441\0435 \043D\0430\0434\043E\043B\0435 \0438 \0434\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\0414\043E\0434\0430\0458 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0441\0442\0430\0432\043A\0443 <strong style="color:#007AE1;">\0414\043E\0434\0430\0458</strong> \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\0442\0432\0440\0434\0438\043B\0438</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845430375402026)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \0414\043E\0434\0430\0458\0442\0435 \0458\0435 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D \0434\0430 \0431\0438\0441\0442\0435 \043E\0441\0442\0432\0430\0440\0438\043B\0438 \043D\0430\0458\0431\043E\0459\0438 \0434\043E\0436\0438\0432\0459\0430\0458.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\0412\0438\0448\0435</strong> \043F\043E\0440\0435\0434 \0442\0440\0430\043A\0435 \0437\0430 \0430\0434\0440\0435\0441\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0441\0442\0430\0432\043A\0443 <strong>\0414\043E\0434\0430\0458 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0414\043E\0434\0438\0440\043D\0438\0442\0435 \0441\0442\0430\0432\043A\0443 <strong style="color:#007AE1;">\0414\043E\0434\0430\0458</strong> \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\0442\0432\0440\0434\0438\043B\0438</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850740810402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \0414\043E\0434\0430\0458\0442\0435 \0458\0435 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D \0434\0430 \0431\0438\0441\0442\0435 \043E\0441\0442\0432\0430\0440\0438\043B\0438 \043D\0430\0458\0431\043E\0459\0438 \0434\043E\0436\0438\0432\0459\0430\0458.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\0414\0435\043B\0438</strong> \043F\043E\0440\0435\0434 \0442\0440\0430\043A\0435 \0437\0430 \0430\0434\0440\0435\0441\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0414\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\041E\0442\0432\043E\0440\0438 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0443 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850681897402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435. \0414\043E\0434\0430\0458\0442\0435 \0458\0435 \043D\0430 \043F\043E\0447\0435\0442\043D\0438 \0435\043A\0440\0430\043D \0434\0430 \0431\0438\0441\0442\0435 \043E\0441\0442\0432\0430\0440\0438\043B\0438 \043D\0430\0458\0431\043E\0459\0438 \0434\043E\0436\0438\0432\0459\0430\0458.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0414\043E\0434\0438\0440\043D\0438\0442\0435 \0438\043A\043E\043D\0443 <strong>\0414\0435\043B\0438</strong> \0443 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0438 \0443 \0434\043D\0443</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0414\043E\0434\0438\0440\043D\0438\0442\0435 <strong>\041E\0442\0432\043E\0440\0438 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0443 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851437172402031)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0435 \043A\043E\0458\0435 \0441\0435 \043D\0430\0458\0431\043E\0459\0435 \0434\043E\0436\0438\0432\0459\0430\0432\0430\0458\0443 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0443 Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \0442\0440\0435\043D\0443\0442\043D\043E \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435 \0432\0435\0431 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114850993134402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0435 \043A\043E\0458\0435 \0441\0435 \043D\0430\0458\0431\043E\0459\0435 \0434\043E\0436\0438\0432\0459\0430\0432\0430\0458\0443 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0438\043C\0430 Chrome \0438\043B\0438 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \0442\0440\0435\043D\0443\0442\043D\043E \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435 \0432\0435\0431 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043D\0430 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851035136402030)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0435 \043A\043E\0458\0435 \0441\0435 \043D\0430\0458\0431\043E\0459\0435 \0434\043E\0436\0438\0432\0459\0430\0432\0430\0458\0443 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0438\043C\0430 Chrome \0438\043B\0438 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari \0442\0440\0435\043D\0443\0442\043D\043E \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435 \0432\0435\0431 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043D\0430 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851369381402031)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\041E\0432\0430 \0432\0435\0431 \043B\043E\043A\0430\0446\0438\0458\0430 \0438\043C\0430 \0444\0443\043D\043A\0446\0438\0458\0435 \043A\043E\0458\0435 \0441\0435 \043D\0430\0458\0431\043E\0459\0435 \0434\043E\0436\0438\0432\0459\0430\0432\0430\0458\0443 \0443 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0438\043C\0430 Chrome \0438\043B\0438 Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \0442\0440\0435\043D\0443\0442\043D\043E \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435 \0432\0435\0431 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043D\0430 Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853812735402033)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\041F\043E\0432\0435\0437\0438\0432\0430\045A\0435 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435</h1>'),
unistr('    <p>\041F\043E\0442\0440\0435\0431\043D\0430 \0458\0435 \0432\0435\0437\0430 \0441\0430 \0438\043D\0442\0435\0440\043D\0435\0442\043E\043C \0434\0430 \0431\0438\0441\0442\0435 \043C\043E\0433\043B\0438 \0434\0430 \043A\043E\0440\0438\0441\0442\0438\0442\0435 \043E\0432\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443.</p>'),
unistr('    <button type="button">\041F\043E\043A\0443\0448\0430\0458\0442\0435 \043F\043E\043D\043E\0432\043E</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853754318402033)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0432\0435\0437\0438\0432\0430\045A\0435 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993565307402141)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937913044402098)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0426\0435\043E \0434\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016833429402159)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438 \043F\043E\0437\0438\0432\043D\0438\0446\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016674835402159)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0446\0438\0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939702317402100)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043D\0435\0432\043D\0438 \043F\0440\0435\0433\043B\0435\0434 \0437\0430 \0446\0435\043E \0434\0430\043D ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939548223402100)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043D\0435\0432\043D\0438 \043F\0440\0435\0433\043B\0435\0434 \0437\0430 \043F\043E\0434\0430\0442\043A\0435 \0441\0430 \0432\0440\0435\043C\0435\043D\043E\043C ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984403457402134)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\043D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978856947402130)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0438\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869469104402045)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'sr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869241017402045)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'sr'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869181346402045)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'sr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869375847402045)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'sr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868856747402044)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C \0437\0430\0432\0440\0448\0435\0442\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869035625402045)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435 \0434\043E\0433\0430\0452\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016740590402159)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0437\0438\0432\043D\0438\0446\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984599361402134)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984240228402134)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\0441\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987094038402136)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001363481402147)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043C\0430 \0434\043E\0433\0430\0452\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017037467402160)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438\0442\0435 \043F\043E\0441\0442\043E\0458\0435\045B\0438 \0434\043E\0433\0430\0452\0430\0458.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016940044402159)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0430\045A\0435 \043F\043E\0437\0438\0432\043D\0438\0446\0435 \043F\0443\0442\0435\043C \0435-\043F\043E\0448\0442\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987191449402136)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995155640402142)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438 \0435-\043F\043E\0440\0443\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994955387402142)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438 \0435-\043F\043E\0440\0443\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017752521402160)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0430 \043F\043E\0459\0430 \0441\0443 \043E\0431\0430\0432\0435\0437\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017695738402160)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438 \043F\043E\0437\0438\0432\043D\0438\0446\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016577060402159)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995051167402142)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868952249402044)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C \043F\043E\0447\0435\0442\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992880835402141)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0430\0437\0430\0446 \043D\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939319430402099)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\043C\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987292705402136)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\043D\0430\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985042904402135)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984340172402134)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0434\0435\0459\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939669179402100)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0434\0435\0459\043D\0438 \043F\0440\0435\0433\043B\0435\0434 \0437\0430 \0446\0435\043E \0434\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939463420402099)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0434\0435\0459\043D\0438 \043F\0440\0435\0433\043B\0435\0434 \0437\0430 \043F\043E\0434\0430\0442\043A\0435 \0441\0430 \0432\0440\0435\043C\0435\043D\043E\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984953412402135)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\043E\0434\0438\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984665671402134)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984782568402135)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0458 \0458\043E\0448...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916825409402082)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863135416402040)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0458 \0458\043E\0448...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865253493402042)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114984876755402135)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0458 \0458\043E\0448...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986905735402136)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('ID \0440\0435\0433\0438\043E\043D\0430 %0 \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865144176402041)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0430\0446\0438 \043D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889213089402060)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\043E\0432\0430\045A\0435 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0435 \0440\0435\0433\0438\043E\043D\0430 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857407287402035)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0443 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0435 \0440\0435\0433\0438\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978234875402130)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986820406402136)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0440\0435\0433\0438\043E\043D\0430 %0 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857311108402035)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \0443 \043F\0440\0438\043A\0430\0437\0438\0432\0430\045A\0443 \0440\0435\0433\0438\043E\043D\0430 "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921835744402086)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('#COLUMN_HEADER# \043C\043E\0440\0430 \0434\0430 \0438\043C\0430 \043D\0435\043A\0443 \0432\0440\0435\0434\043D\043E\0441\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016160971402159)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('%0, \0443\0440\0435\0452\0438\0432\0430\0447 \043E\0431\043E\0433\0430\045B\0435\043D\043E\0433 \0442\0435\043A\0441\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923941967402087)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'sr'
,p_message_text=>unistr('HTML \043E\0437\043D\0430\0447\0430\0432\0430\045A\0435 \0441\0430 \043E\0431\043E\0433\0430\045B\0435\043D\0438\043C \0442\0435\043A\0441\0442\043E\043C \043F\0440\0435\043A\043E\0440\0430\0447\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0443 \0434\043E\0437\0432\043E\0459\0435\043D\0443 \0434\0443\0436\0438\043D\0443 (\0441\0442\0432\0430\0440\043D\043E: %0, \0434\043E\0437\0432\043E\0459\0435\043D\0438\0445 \0437\043D\0430\043A\043E\0432\0430: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983845297402134)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975692795402128)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\043A\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973962942402126)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973897473402126)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0443\0437\043C\0438 null \0432\0440\0435\0434\043D\043E\0441\0442\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983991924402134)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937528260402098)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0434\043E\043B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937601158402098)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438 \043D\0430\0433\043E\0440\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973630825402126)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974270992402126)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0440\0443\0433\0435 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973721399402126)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974099172402126)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974144306402126)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434 %0 \043E\0434 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975726310402128)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0441\0432\0435\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975824640402128)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\0442\0438 \043F\0440\043E\043C\0435\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114973541759402126)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\043D\0438 \0441\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0438\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934548539402095)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430 \043F\0440\0438\043C\0435\0440, %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842025850402023)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0458\0430\0432\0438\0442\0435 \0441\0435 \043F\043E\043D\043E\0432\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841953590402023)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0430\0448\0430 \0441\0435\0441\0438\0458\0430 \0458\0435 \0437\0430\0432\0440\0448\0435\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842114301402023)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0434\0443\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841770438402023)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0430\0448\0430 \0441\0435\0441\0438\0458\0430 \045B\0435 \0441\0435 \0437\0430\0432\0440\0448\0438\0442\0438 \0443 %0. \0416\0435\043B\0438\0442\0435 \043B\0438 \0434\0430 \0458\0435 \043F\0440\043E\0434\0443\0436\0438\0442\0435?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841847551402023)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0435\0441\0438\0458\0430 \045B\0435 \0441\0435 \0437\0430\0432\0440\0448\0438\0442\0438 \0443 %0 \0438 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\0440\043E\0434\0443\0436\0438\0442\0438 \0458\0435. \0421\0430\0447\0443\0432\0430\0458\0442\0435 \0448\0442\0430 \0441\0442\0435 \0440\0430\0434\0438\043B\0438 \0434\0430 \043D\0435 \0431\0438\0441\0442\0435 \0438\0437\0433\0443\0431\0438\043B\0438 \043F\043E\0434\0430\0442\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994751514402142)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438\043B\0438\043A\043E\043C \043E\0431\0440\0430\0434\0435 \0448\0438\0444\0440\0435 \0447\0438\0448\045B\0435\045A\0430 \0441\0435\0441\0438\0458\0435 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887824519402059)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043E\0431\0440\0430\0434\0435 \0448\0438\0444\0440\0435 \0437\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0441\0435\0441\0438\0458\0435 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114861969031402039)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0430\0448\0430 \0441\0435\0441\0438\0458\0430 \0458\0435 \0437\0430\0432\0440\0448\0435\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993615271402141)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0442\0432\043E\0440\0438\0442\0435 \043E\0432\0430\0458 \0434\0438\0458\0430\043B\043E\0433 \0438 \043F\0440\0438\0442\0438\0441\043D\0438\0442\0435 \0434\0443\0433\043C\0435 \0437\0430 \043E\0441\0432\0435\0436\0430\0432\0430\045A\0435 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0430 \0434\0430 \0431\0438\0441\0442\0435 \0437\0430\043F\043E\0447\0435\043B\0438 \043D\043E\0432\0443 \0441\0435\0441\0438\0458\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012968981402156)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043B\0438\043A\043D\0438\0442\0435 <a href="%0">\043E\0432\0434\0435</a> \0434\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \043D\043E\0432\0443 \0441\0435\0441\0438\0458\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899517219402069)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0435\0441\0438\0458\0430 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939025548402099)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0430\0432\0430\045A\0435 \0434\0438\043D\0430\043C\0438\0447\043A\0438\0445 \0443\043B\043E\0433\0430 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E \0443 \0441\0435\0441\0438\0458\0438 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 Real Application Security \0437\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430"%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885707418402058)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-99900 \041A\0440\0435\0438\0440\0430\045A\0435 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E\0433 ID-\0430 \0441\0435\0441\0438\0458\0435 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902091774402070)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0448\0435\045A\0435 \0437\0430\0448\0442\0438\0442\0435 \0441\0442\0430\045A\0430 \0441\0435\0441\0438\0458\0435: \041E\0432\043E \0458\0435 \043C\043E\0436\0434\0430 \0438\0437\0430\0437\0432\0430\043D\043E \0440\0443\0447\043D\043E\043C \0438\0437\043C\0435\043D\043E\043C \0437\0430\0448\0442\0438\045B\0435\043D\0435 \0441\0442\0430\0432\043A\0435 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0438 %0. \0410\043A\043E \043D\0438\0441\0442\0435 \0441\0438\0433\0443\0440\043D\0438 \0448\0442\0430 \0458\0435 \0438\0437\0430\0437\0432\0430\043B\043E \043E\0432\0443 \0433\0440\0435\0448\043A\0443, \043E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0437\0430 \043F\043E\043C\043E\045B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115021186816402163)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0440\0443\0448\0430\0432\0430\045A\0435 \0437\0430\0448\0442\0438\0442\0435 \0441\0442\0440\0430\043D\0438\0446\0435: \041E\0432\043E \043C\043E\0436\0435 \0434\0430 \0431\0443\0434\0435 \0443\0437\0440\043E\043A\043E\0432\0430\043D\043E \043F\0440\043E\0441\043B\0435\0452\0438\0432\0430\045A\0435\043C \0441\0442\0440\0430\043D\0438\0446\0435 \043A\043E\0458\0430 \0441\0435 \0458\043E\0448 \043D\0438\0458\0435 \0443\0447\0438\0442\0430\043B\0430 \0438\043B\0438 \0440\0443\0447\043D\0438\043C \043C\0435\045A\0430\045A\0435\043C \0441\0442\0430\0432\043A\0438 \0437\0430\0448\0442\0438\045B\0435\043D\0435 \0441\0442\0440\0430\043D\0438\0446\0435. \041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0437\0430 \0434\043E\0434\0430\0442\043D\0443 \043F\043E\043C\043E\045B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020190970402162)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0430\0434\0440\0436\0438 \0458\0435\0434\0430\043D \043E\0434 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\0432\0430\0436\0435\045B\0438\0445 \0437\043D\0430\043A\043E\0432\0430 &<>"/;,*|=% \0438\043B\0438 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020223503402162)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0430\0434\0440\0436\0438 \0458\0435\0434\0430\043D \043E\0434 \0441\043B\0435\0434\0435\045B\0438\0445 \043D\0435\0432\0430\0436\0435\045B\0438\0445 \0437\043D\0430\043A\043E\0432\0430 &<>"/;,*|=% \0438\043B\0438 -- \0438\043B\0438 \043D\043E\0432\0438 \0440\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019989273402162)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0430\0434\0440\0436\0438 \043F\043E\0441\0435\0431\043D\0435 \0437\043D\0430\043A\043E\0432\0435. \0414\043E\0437\0432\043E\0459\0435\043D\0438 \0441\0443 \0441\0430\043C\043E \0437\043D\0430\043A\043E\0432\0438 a-Z, 0-9 \0438 \0440\0430\0437\043C\0430\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115020054290402162)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0430\0434\0440\0436\0438 <, > \0438\043B\0438 " \043A\043E\0458\0438 \043D\0438\0441\0443 \0432\0430\0436\0435\045B\0438 \0437\043D\0430\043A\043E\0432\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864184203402041)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440 \043D\0438\0458\0435 \043D\0430\0432\0435\0434\0435\043D \043A\0430\043A\043E \0431\0438 \0441\0435 \043F\0440\0438\043A\0430\0437\0430\043B\0430 \043E\0431\0440\0430\0434\0430 \0437\0430 \0441\0442\0440\0430\043D\0438\0446\0443 \043A\043E\0458\0430 \0437\0430\0445\0442\0435\0432\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440 \043A\0430\0434\0430 \0441\0435 \043A\0430\043E \043F\0430\0440\0430\043C\0435\0442\0440\0438 \043F\0440\043E\0441\043B\0435\0452\0443\0458\0443 \0458\0435\0434\0430\043D \0438\043B\0438 \0432\0438\0448\0435 \0437\0430\0445\0442\0435\0432\0430, \0431\0440\0438\0441\0430\045A\0435 \043A\0435\0448\0430 \0438\043B\0438 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0430\0440\0433\0443\043C\0435\043D\0430\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896924840402066)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0448\0435\045A\0435 \0437\0430\0448\0442\0438\0442\0435 \0441\0442\0430\045A\0430 \0441\0435\0441\0438\0458\0435: \041E\0432\043E \0458\0435 \043C\043E\0436\0434\0430 \0438\0437\0430\0437\0432\0430\043D\043E \0440\0443\0447\043D\043E\043C \0438\0437\043C\0435\043D\043E\043C URL \0430\0434\0440\0435\0441\0435 \043A\043E\0458\0430 \0441\0430\0434\0440\0436\0438 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440 \0438\043B\0438 \0443\043F\043E\0442\0440\0435\0431\043E\043C \0432\0435\0437\0435 \0441\0430 \043D\0435\0442\0430\0447\043D\0438\043C \0438\043B\0438 \043D\0435\043F\043E\0441\0442\043E\0458\0435\045B\0438\043C \043A\043E\043D\0442\0440\043E\043B\043D\0438\043C \0437\0431\0438\0440\043E\043C. \0410\043A\043E \043D\0438\0441\0442\0435 \0441\0438\0433\0443\0440\043D\0438 \0448\0442\0430 \0458\0435 \0438\0437\0430\0437\0432\0430\043B\043E \043E\0432\0443 \0433\0440\0435\0448\043A\0443, \043E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443 \0430\043F\043B\0438\043A\0430')
||unistr('\0446\0438\0458\0435 \0437\0430 \043F\043E\043C\043E\045B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114974910794402127)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0441\0438 \0440\0435\0436\0438\043C \0432\0438\0441\043E\043A\043E\0433 \043A\043E\043D\0442\0440\0430\0441\0442\0430 \043D\0430 \0438\0441\043A\0459\0443\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975050343402127)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0441\0438 \0440\0435\0436\0438\043C \0432\0438\0441\043E\043A\043E\0433 \043A\043E\043D\0442\0440\0430\0441\0442\0430 \043D\0430 \0443\043A\0459\0443\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893668668402064)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893883912402064)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\043B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893946454402064)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894092861402064)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438 \0441\0432\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894113263402064)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894236311402064)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0441\0432\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894329191402064)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893511246402064)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893789183402064)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\043E\0440\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002614340402148)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'sr'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003372344402149)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002587700402148)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'sr'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003416529402149)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002368695402148)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'sr'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003518247402149)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002913935402148)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003118618402149)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002404855402148)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'sr'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003228152402149)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \0441\0435\043A.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002764946402148)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'sr'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003669293402149)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002842124402148)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'sr'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115003063125402149)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0430 %0 \0433\043E\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842991032402024)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'sr'
,p_message_text=>unistr('[\041B\0438\043D\0438\0458\0430]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843367322402025)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'sr'
,p_message_text=>unistr('[\0412\0438\0448\0435 \043B\0438\043D\0438\0458\0430]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843171505402024)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'sr'
,p_message_text=>unistr('[\0412\0438\0448\0435 \0442\0430\0447\0430\043A\0430]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843547267402025)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'sr'
,p_message_text=>unistr('[\0412\0438\0448\0435 \043C\043D\043E\0433\043E\0443\0433\043B\043E\0432\0430]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843682104402025)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'sr'
,p_message_text=>unistr('[\0413\0435\043E\043C\0435\0442\0440\0438\0458\0441\043A\0438 \043E\0431\0458\0435\043A\0430\0442]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842870154402024)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'sr'
,p_message_text=>unistr('[\0422\0430\0447\043A\0430 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843047798402024)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'sr'
,p_message_text=>unistr('[\041C\043D\043E\0433\043E\0443\0433\0430\043E]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920271052402084)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043A\0443\043F\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920169576402084)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966616363402121)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0438\0448\0438 \0440\0430\043D\0433\0438\0440\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956577695402113)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0438 \043E\043F\0441\0435\0433 \0440\0430\043D\0433\0438\0440\0430\045A\0430 \043E\0434 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956684438402113)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \043D\0443\043C\0435\0440\0438\0447\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952716387402110)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0440\0443\043A\0430 \043E \0443\0441\043F\0435\0445\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015831087402159)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015792450402159)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001407116402147)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0430\043A\0430 \0441\0430 \0430\043B\0430\0442\043A\0430\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016289830402159)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\0438\0440\0438/\0441\043A\0443\043F\0438 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016322885402159)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\0438\0440\0438/\0441\043A\0443\043F\0438 \0431\043E\0447\043D\0443 \043A\043E\043B\043E\043D\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925989607402089)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\043B\0430\0432\043D\0430 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932920107402094)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('1 \0434\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932701049402094)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('1 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933010837402094)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0434\0430\043D(\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932836380402094)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932658360402094)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933289447402095)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114933151033402094)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('1 \043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019420667402161)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0442\0430\043A \0441\0442\0440\0430\043D\0438\0446\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881416135402054)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855237594402034)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \0443 \043E\0431\0440\0430\0434\0438 \0437\0430\0445\0442\0435\0432\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934631389402096)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \0458\0435 \043E\0431\0430\0432\0435\0437\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017531297402160)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0435\043A\0430\0458\0442\0435 \0434\0430 \0441\0435 \0441\0442\0440\0430\043D\0438\0446\0430 \043F\043E\0442\043F\0443\043D\043E \0443\0447\0438\0442\0430, \043F\0430 \043F\0440\043E\0431\0430\0458\0442\0435 \043F\043E\043D\043E\0432\043E.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977728161402129)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430 \043E\0432\043E\0458 \0441\0442\0440\0430\043D\0438\0446\0438 \0438\043C\0430 \043D\0435\0441\0430\0447\0443\0432\0430\043D\0438\0445 \043F\0440\043E\043C\0435\043D\0430.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858676413402036)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\043D\0430 \0441\0432\0435\0441\043A\0430 \043C\0435\043D\0430 \0430\043A\0442\0438\0432\043D\0438\0445 \0440\0430\0434\043D\0438\0445 \043B\0438\0441\0442\043E\0432\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858583364402036)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\043D\0430 \0441\0432\0435\0441\043A\0430 \043D\0438\0458\0435 \043F\043E\043A\0440\0435\043D\0443\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858436645402036)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0438\043D\0442\0435\0440\043D\0435 \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043A\0440\0435\0438\0440\0430\045A\0430 XLSX \0434\0430\0442\043E\0442\0435\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860907290402038)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992677253402140)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910100373402077)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\043D\0438 \0441\0430 \0440\0430\0434\045A\0430\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905825020402073)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \0444\0443\043D\043A\0446\0438\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905787297402073)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \043A\043E\043B\043E\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939950958402100)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \043F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940091655402100)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0458 \043A\043E\043B\043E\043D\0443 \0440\0435\0434\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880238091402053)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0438\0440\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916331448402081)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0433\0440\0435\0433\0430\0446\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897415751402067)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0441\0435\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901784933402070)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897504203402067)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0443\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897764354402067)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0440\0435\0434\045A\0430 \0432\0440\0435\0434\043D\043E\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897600682402067)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0443\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897380370402067)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0431\0438\0440 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898442364402068)
,p_name=>'APEXIR_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879541659402053)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0435 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862006005402039)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0438 \0440\0435\0434\043E\0432\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989642471402138)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991277195402139)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892162642402063)
,p_name=>'APEXIR_AND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881657864402054)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875355991402049)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0441\0442\0443\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894981837402065)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0432 \043E\0434%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991855585402140)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0441\0435\043A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983285033402133)
,p_name=>'APEXIR_BAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0430\043A\0430\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881004887402054)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0438\0437\043C\0435\0452\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874167975402049)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\043E\0458\0430 \043F\043E\0437\0430\0434\0438\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876010178402050)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043B\0430\0432\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907749504402075)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876619120402050)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\043A\0430\0436\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882555186402055)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0430\0442\0435\0433\043E\0440\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874058706402048)
,p_name=>'APEXIR_CELL'
,p_message_language=>'sr'
,p_message_text=>unistr('\040B\0435\043B\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898361663402068)
,p_name=>'APEXIR_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0430\0444\0438\043A\043E\043D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908605023402076)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043A\0440\0435\0442\0430\045A\0435...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114944921307402104)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430 \0433\0440\0430\0444\0438\043A\043E\043D\0430 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043D\0430\0432\0435\0434\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957356660402113)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\0438\0442 \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\0430\043D \0431\0440\043E\0458 \0442\0430\0447\0430\043A\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043F\043E \0433\0440\0430\0444\0438\043A\043E\043D\0443 (%0). \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\0442\0435\0440 \0434\0430 \0431\0438\0441\0442\0435 \0441\043C\0430\045A\0438\043B\0438 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956291414402112)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0437\0430 \0443\043F\0438\0442 \0433\0440\0430\0444\0438\043A\043E\043D\0430 \043E\0433\0440\0430\043D\0438\0447\0430\0432\0430 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443, \043D\0435 \0438 \0431\0440\043E\0458 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430. \0412\0430\0448 \043E\0441\043D\043E\0432\043D\0438 \0443\043F\0438\0442 \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 (%0). \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\0442\0435\0440 \0434\0430 \0431\0438\0441\0442\0435 \0441\043C\0430\045A\0438\043B\0438 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879603914402053)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0433\0440\0430\0444\0438\043A\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114952939450402110)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\0447\0438 \0441\0432\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895372619402065)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902783820402071)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\043E\0431\0440\0438\0448\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876576543402050)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913914602402080)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986245359402136)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904764937402073)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\043D\0438 \0437\0430\0433\043B\0430\0432\0459\0430 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908412764402075)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0444\043E\0440\043C\0430\0446\0438\0458\0435 \043E \043A\043E\043B\043E\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988560304402137)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906129579402074)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890230820402061)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0441\0430\0434\0440\0436\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891191243402062)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435 \0441\0430\0434\0440\0436\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875075199402049)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891341711402062)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0443 \043F\043E\0441\043B\0435\0434\045A\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899886893402069)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0443 \0441\043B\0435\0434\0435\045B\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891280254402062)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0458\0435 \0443 \043F\043E\0441\043B\0435\0434\045A\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899765113402069)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0458\0435 \0443 \0441\043B\0435\0434\0435\045B\0435\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874909597402049)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874825782402049)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0458\0435\0441\0442\0435 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874626606402049)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\043F\0443\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875193885402049)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874748486402049)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\0458\0435 \043F\043E\043F\0443\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890542876402061)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\0434\0443\0434\0430\0440\0430 \0441\0435 \0441\0430 \0443\043E\0431\0438\0447\0430\0458\0435\043D\0438\043C \0438\0437\0440\0430\0437\043E\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895234246402065)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114955953980402112)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0437 \0437\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914206993402080)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0435\0438\0440\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435 \043F\043E\043C\043E\045B\0443 \0430\043B\0438\0458\0430\0441\0430 \043A\043E\043B\043E\043D\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914317982402080)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'sr'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914469823402080)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'sr'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914583309402080)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'sr'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860444754402038)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'sr'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899129560402068)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0447\0443\043D\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906721694402074)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909749883402076)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994190568402142)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0435 \0441\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438\043C \043F\0440\0435\043B\043E\043C\0438\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857557481402036)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0430\0437\043B\0438\0447\0438\0442\0438\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992332450402140)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0430\0437\043B\0438\0447\0438\0442\0438\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992220569402140)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964368950402119)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043D\0435\0432\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019068879402161)
,p_name=>'APEXIR_DATA'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0430\0446\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908528584402075)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0441\0442\0438 \043E \043F\043E\0434\0430\0446\0438\043C\0430 \043E\0434 \043F\0440\0435 %0 \043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982027752402132)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \043C\0440\0435\0436\0443 \043F\043E\0434\0430\0442\0430\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880395767402053)
,p_name=>'APEXIR_DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912446029402078)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989433125402138)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0442\0438\043F \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876707912402051)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880601672402054)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0416\0435\043B\0438\0442\0435 \043B\0438 \0434\0430 \0438\0437\0431\0440\0438\0448\0435\0442\0435 \043E\0432\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975356967402127)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906462465402074)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0431\0440\0438\0448\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875499620402050)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0430\0434\0430\0458\0443\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882678920402055)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0438\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904628093402073)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0458\0435\0434\043D\043E\0433 \0440\0435\0434\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912977881402079)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043C\0435\0440 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913845597402080)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043D\0435\043C\043E\0433\0443\045B\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876213315402050)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879430117402053)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437\0430\043D\0435 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912852309402079)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0443 \0438\0437\0432\0435\0448\0442\0430\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907600315402075)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\043B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899235124402068)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0443\0437\043C\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912706453402079)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \043F\0440\0438\043A\0430\0437\0443\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978798149402130)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\0442\0430\043A\043D\0443\0442\0430 \0441\0442\0430\0432\043A\0430 \0441\0430 \0438\0441\0442\0438\043C \0443\0441\043B\043E\0432\043E\043C \0432\0435\045B \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994362848402142)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\043A\0430\0442 \043F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0435. \041B\0438\0441\0442\0430 \043F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0430 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\0430.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994541231402142)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908748898402076)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0452\0438\0432\0430\045A\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0433\0440\0430\0444\0438\043A\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915333588402081)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915704957402081)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \0444\0438\043B\0442\0435\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970124513402123)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915654390402081)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \0438\0441\0442\0430\043A\043D\0443\0442\0443 \0441\0442\0430\0432\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940271458402100)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438 \043F\0438\0432\043E\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989786852402138)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\0430\0434\0440\0435\0441\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868487033402044)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\0430\0434\0440\0435\0441\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990011985402139)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'sr'
,p_message_text=>'Bcc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990283208402139)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043A\0441\0442 \043F\043E\0440\0443\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989924454402138)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'sr'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990752509402139)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0435\0441\0442\0430\043B\043E\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872105740402047)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\043F\043E\0448\0442\0430 \043D\0438\0458\0435 \043A\043E\043D\0444\0438\0433\0443\0440\0438\0441\0430\043D\0430 \0437\0430 \043E\0432\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443. \041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963675240402118)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\0430\0434\0440\0435\0441\0430 \043C\043E\0440\0430 \0434\0430 \0441\0435 \043D\0430\0432\0435\0434\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990318308402139)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0433\043B\0435\0434\0430\0458\0442\0435 \043F\0440\0438\043B\043E\0433\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990150618402139)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964612567402119)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043C\0430 \0435-\043F\043E\0440\0443\043A\0435 \043C\043E\0440\0430 \0434\0430 \0441\0435 \043D\0430\0432\0435\0434\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989812108402138)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873879603402048)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915573624402081)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0438/\043E\043D\0435\043C\043E\0433\0443\045B\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915030248402080)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914610606402080)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\0440\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915454065402081)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0435\0440\0438:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879394837402053)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0443\0437\043C\0438 null \0432\0440\0435\0434\043D\043E\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916006706402081)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\0438\0440\0438/\0441\043A\0443\043F\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913670252402079)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898794306402068)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909660305402076)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919956406402084)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0437 \0444\0438\043B\0442\0435\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016462844402159)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0440\0430\0437 \0444\0438\043B\0442\0435\0440\0430 \0458\0435 \043F\0440\0435\0434\0443\0433\0430\0447\0430\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919835248402084)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0444\0438\043B\0442\0435\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916226474402081)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899068017402068)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\045B\0430\045A\0435 \0443 \043F\0440\043E\0448\043B\043E\0441\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913480672402079)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\0438\0442 \0432\0440\0430\045B\0430\045A\0430 \0443 \043F\0440\043E\0448\043B\043E\0441\0442 \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0432\0438\0434\0438\0442\0435 \043F\043E\0434\0430\0442\043A\0435 \043A\0430\043A\0432\0438 \0441\0443 \0431\0438\043B\0438 \0443 \0440\0430\043D\0438\0458\0435\043C \0442\0440\0435\043D\0443\0442\043A\0443 \0443 \043F\0440\043E\0448\043B\043E\0441\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964031634402119)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0430\0458\0430\045A\0435 \0432\0440\0430\045B\0430\045A\0430 \0443 \043F\0440\043E\0448\043B\043E\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965414525402120)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895101772402065)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906319925402074)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914136041402080)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0435 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989380590402138)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0435/\043E\043F\0435\0440\0430\0442\043E\0440\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906003110402074)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898596516402068)
,p_name=>'APEXIR_GO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0434\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874372291402049)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0437\0435\043B\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114857610709402036)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0438\0448\0438 \043F\0440\0435\043C\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990432388402139)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \043A\043E\043B\043E\043D\0438 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945075129402104)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \043A\043E\043B\043E\043D\0438 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043D\0430\0432\0435\0434\0435\043D\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956118230402112)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0437\0430 \0443\043F\0438\0442 \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \043E\0433\0440\0430\043D\0438\0447\0430\0432\0430 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443, \043D\0435 \0438 \0431\0440\043E\0458 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430. \0412\0430\0448 \043E\0441\043D\043E\0432\043D\0438 \0443\043F\0438\0442 \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 (%0). \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\0442\0435\0440 \0434\0430 \0431\0438\0441\0442\0435 \0441\043C\0430\045A\0438\043B\0438 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936734737402097)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\045A\0435 \0433\0440\0443\043F\0438\0441\0430\045A\0435\043C \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994232894402142)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434\043E\0441\043B\0435\0434 \0441\043E\0440\0442\0438\0440\0430\045A\0430 \0433\0440\0443\043F\0438\0441\0430\045A\0435\043C \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879733219402053)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0425\043E\0440\0438\0437\043E\043D\0442\0430\043B\043D\0430 \043A\043E\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911311665402078)
,p_name=>'APEXIR_HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903139855402071)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0418\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458\0438 \043E\043C\043E\0433\0443\045B\0430\0432\0430\0458\0443 \043A\0440\0430\0458\045A\0438\043C \043A\043E\0440\0438\0441\043D\0438\0446\0438\043C\0430 \0434\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \0438\0437\043C\0435\043D\0435 \0440\0430\0441\043F\043E\0440\0435\0434 \043F\043E\0434\0430\0442\0430\043A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438\0437\0431\043E\0440\043E\043C \043A\043E\043B\043E\043D\0430, \043F\0440\0438\043C\0435\043D\043E\043C \0444\0438\043B\0442\0435\0440\0430, \0438\0441\0442\0438\0446\0430\045A\0435\043C \0438 \0441\043E\0440\0442\0438\0440\0430\045A\0435\043C. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0443 \0438 \043F\0440\0435\043B\043E\043C\0435, \0430\0433\0440\0435\0433\0430\0446\0438\0458\0435, \0433\0440\0430\0444\0438\043A\043E\043D\0435,')
||unistr(' \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0438\043C\0430 \0438 \043C\043E\0433\0443 \0434\0430 \0434\043E\0434\0430\0458\0443 \0441\0432\043E\0458\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \043F\043E\0434\0435\0441\0435 \0438 \043F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0435 \043A\0430\043A\043E \0431\0438 \0438\043C \0441\0435 HTML \0432\0435\0440\0437\0438\0458\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043F\043E\0441\043B\0430\043B\0430 \0443 \043D\0430\0432\0435\0434\0435\043D\043E\043C \0438\043D\0442\0435\0440\0432\0430\043B\0443. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \043A\0440\0435\0438\0440\0430\0458\0443 \0432\0438\0448\0435 \0432\0430\0440\0438\0458\0430\0446\0438\0458\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \0434\0430 \0438\0445 \0441\0430\0447\0443\0432\0430\0458\0443 \043A\0430\043E \0438\043C\0435\043D\043E\0432')
||unistr('\0430\043D\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435, \0437\0430 \0458\0430\0432\043D\043E \0438\043B\0438 \043F\0440\0438\0432\0430\0442\043D\043E \043F\0440\0438\043A\0430\0437\0438\0432\0430\045A\0435. '),
'<p/>',
unistr('\0423 \0441\043B\0435\0434\0435\045B\0438\043C \043E\0434\0435\0459\0446\0438\043C\0430 \0441\0443 \0440\0435\0437\0438\043C\0438\0440\0430\043D\0438 \043D\0430\0447\0438\043D\0438 \043D\0430 \043A\043E\0458\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458. \0414\0430 \0431\0438\0441\0442\0435 \0441\0430\0437\043D\0430\043B\0438 \0432\0438\0448\0435, \043F\0440\043E\0447\0438\0442\0430\0458\0442\0435 "\041A\043E\0440\0438\0448\045B\0435\045A\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438\0445 \0438\0437\0432\0435\0448\0442\0430\0458\0430" \0443 <i>\0412\043E\0434\0438\0447\0443 \0437\0430 \043A\0440\0430\0458\045A\0435\0433 \043A\043E\0440\0438\0441\043D\0438\043A\0430 \0437\0430 Oracle Application Express</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910282420402077)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\043D\0438 \0441\0430 \0440\0430\0434\045A\0430\043C\0430 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0441\043D\043E \043E\0434 \0434\0443\0433\043C\0435\0442\0430 \0418\0434\0438 \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443. \041F\043E\043C\043E\045B\0443 \043E\0432\043E\0433 \043C\0435\043D\0438\0458\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903954924402072)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430 \0441\0443 \043C\0430\0442\0435\043C\0430\0442\0438\0447\043A\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 \043A\043E\0458\0430 \0441\0435 \043E\0431\0430\0432\0459\0430\0458\0443 \043D\0430 \043A\043E\043B\043E\043D\0438. \041E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0430 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \043D\0430\043A\043E\043D \0441\0432\0430\043A\043E\0433 \043A\043E\043D\0442\0440\043E\043B\043D\043E\0433 \043F\0440\0435\043B\043E\043C\0430 \0438 \043D\0430 \043A\0440\0430\0458\0443 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0443 \043E\043A\0432\0438\0440\0443 \043A\043E\043B\043E\043D\0435 \0443 \043A\043E\0458\043E\0458 \0441\0443 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430. \041E\043F\0446\0438\0458\0435 \0441\0443 \0441\043B\0435\0434\0435\045B\0435:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\041E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \043F\0440\0435\0442\0445\043E\0434\043D\043E \0434\0435\0444\0438\043D\0438\0441\0430\043D\043E \043E\0431\0458\0435\0434\0438\045A\0430\0432\0430\045A\0435 \0437\0430 \0443\0440\0435\0452\0438\0432\0430\045A\0435.</li>'),
unistr('<li><strong>\0424\0443\043D\043A\0446\0438\0458\0430</strong> \043F\0440\0435\0434\0441\0442\0430\0432\0459\0430 \0444\0443\043D\043A\0446\0438\0458\0443 \043A\043E\0458\0430 \045B\0435 \0441\0435 \043E\0431\0430\0432\0438\0442\0438 (\043D\0430 \043F\0440\0438\043C\0435\0440, SUM, MIN).</li>'),
unistr('<li><strong>\041A\043E\043B\043E\043D\0430</strong> \0441\0435 \043A\043E\0440\0438\0441\0442\0438 \0437\0430 \0438\0437\0431\043E\0440 \043A\043E\043B\043E\043D\0435 \043D\0430 \043A\043E\0458\0443 \045B\0435 \0441\0435 \043F\0440\0438\043C\0435\043D\0438\0442\0438 \043C\0430\0442\0435\043C\0430\0442\0438\0447\043A\0430 \0444\0443\043D\043A\0446\0438\0458\0430. \041F\0440\0438\043A\0430\0437\0443\0458\0443 \0441\0435 \0441\0430\043C\043E'),
unistr('\043D\0443\043C\0435\0440\0438\0447\043A\0435 \043A\043E\043B\043E\043D\0435.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904067170402072)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041C\043E\0436\0435\0442\0435 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0458\0435\0434\0430\043D \0433\0440\0430\0444\0438\043A\043E\043D \043F\043E \0441\0430\0447\0443\0432\0430\043D\043E\043C \0438\0437\0432\0435\0448\0442\0430\0458\0443. \041A\0430\0434\0430'),
unistr('\0441\0435 \0434\0435\0444\0438\043D\0438\0448\0435, \043C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\0435\043B\0430\0437\0438\0442\0435 \0441\0430 \043F\0440\0438\043A\0430\0437\0430 \0433\0440\0430\0444\0438\043A\043E\043D\0430 \043D\0430 \043F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \043E\0431\0440\0430\0442\043D\043E \043F\043E\043C\043E\045B\0443 \0438\043A\043E\043D\0430 \0437\0430 \043F\0440\0438\043A\0430\0437 \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443.'),
unistr('\041E\043F\0446\0438\0458\0435 \0441\0443 \0441\043B\0435\0434\0435\045B\0435:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>\0422\0438\043F \0433\0440\0430\0444\0438\043A\043E\043D\0430</strong> \0438\0434\0435\043D\0442\0438\0444\0438\043A\0443\0458\0435 \0442\0438\043F \0433\0440\0430\0444\0438\043A\043E\043D\0430 \043A\043E\0458\0438 \045B\0435 \0441\0435 \0434\043E\0434\0430\0442\0438.'),
unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0445\043E\0440\0438\0437\043E\043D\0442\0430\043B\043D\0443 \0442\0440\0430\043A\0443, \0432\0435\0440\0442\0438\043A\0430\043B\043D\0443 \0442\0440\0430\043A\0443, \043A\0440\0443\0436\043D\0438 \0433\0440\0430\0444\0438\043A\043E\043D \0438\043B\0438 \043B\0438\043D\0438\0458\0441\043A\0438.</li>'),
unistr('<li><strong>\041E\0437\043D\0430\043A\0430</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \043A\043E\043B\043E\043D\0443 \043A\043E\0458\0430 \045B\0435 \0441\0435 \043A\043E\0440\0438\0441\0442\0438\0442\0438 \043A\0430\043E \043E\0437\043D\0430\043A\0430.</li>'),
unistr('<li><strong>\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0437\0430 \043E\0437\043D\0430\043A\0443</strong> \0458\0435 \043D\0430\0441\043B\043E\0432 \043A\043E\0458\0438 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043D\0430 \043E\0441\0438 \043F\043E\0432\0435\0437\0430\043D\043E\0458 \0441\0430 \043A\043E\043B\043E\043D\043E\043C \043A\043E\0458\0430 \0458\0435 \0438\0437\0430\0431\0440\0430\043D\0430 \0437\0430'),
unistr('\043E\0437\043D\0430\043A\0443. \041E\0432\043E \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\043E \043A\043E\0434 \043A\0440\0443\0436\043D\043E\0433 \0433\0440\0430\0444\0438\043A\043E\043D\0430.</li>'),
unistr('<li><strong>\0412\0440\0435\0434\043D\043E\0441\0442</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \043A\043E\043B\043E\043D\0443 \043A\043E\0458\0430 \045B\0435 \0441\0435 \043A\043E\0440\0438\0441\0442\0438\0442\0438 \043A\0430\043E \0432\0440\0435\0434\043D\043E\0441\0442. \0410\043A\043E \0458\0435 \0444\0443\043D\043A\0446\0438\0458\0430 COUNT, \043D\0438\0458\0435 \043F\043E\0442\0440\0435\0431\043D\043E \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442.</li>'),
unistr('<li><strong>\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0437\0430 \0432\0440\0435\0434\043D\043E\0441\0442</strong> \0458\0435 \043D\0430\0441\043B\043E\0432 \043A\043E\0458\0438 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043D\0430 \043E\0441\0438 \043F\043E\0432\0435\0437\0430\043D\043E\0458 \0441\0430 \043A\043E\043B\043E\043D\043E\043C \0438\0437\0430\0431\0440\0430\043D\043E\043C \0437\0430'),
unistr('\0432\0440\0435\0434\043D\043E\0441\0442. \0422\043E \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\043E \043A\043E\0434 \043A\0440\0443\0436\043D\0438\0445 \0433\0440\0430\0444\0438\043A\043E\043D\0430.</li>'),
unistr('<li><strong>\0424\0443\043D\043A\0446\0438\0458\0430</strong> \0458\0435 \043E\043F\0446\0438\043E\043D\0430\043B\043D\0430 \0444\0443\043D\043A\0446\0438\0458\0430 \043A\043E\0458\0430 \0441\0435 \043E\0431\0430\0432\0459\0430 \043D\0430 \043A\043E\043B\043E\043D\0438 \0438\0437\0430\0431\0440\0430\043D\043E\0458 \0437\0430 \0432\0440\0435\0434\043D\043E\0441\0442.</li>'),
unistr('<li><strong>\0421\043E\0440\0442\0438\0440\0430\045A\0435</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0441\043E\0440\0442\0438\0440\0430\0442\0435 \0441\043A\0443\043F \0440\0435\0437\0443\043B\0442\0430\0442\0430.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903376266402071)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041A\043B\0438\043A\043E\043C \043D\0430 \0437\0430\0433\043B\0430\0432\0459\0435 \0431\0438\043B\043E \043A\043E\0458\0435 \043A\043E\043B\043E\043D\0435 \043E\0442\0432\0430\0440\0430 \0441\0435 \043C\0435\043D\0438 \0437\0430\0433\043B\0430\0432\0459\0430 \043A\043E\043B\043E\043D\0435. \041E\043F\0446\0438\0458\0435 \0441\0443 \0441\043B\0435\0434\0435\045B\0435:'),
'<p></p>',
'<ul>',
unistr('<li>\0418\043A\043E\043D\0430 <strong>\0421\043E\0440\0442\0438\0440\0430\0458 \0440\0430\0441\0442\0443\045B\0438\043C \0440\0435\0434\043E\0441\043B\0435\0434\043E\043C</strong> \0441\043E\0440\0442\0438\0440\0430 \0438\0437\0432\0435\0448\0442\0430\0458 \043F\043E \043A\043E\043B\043E\043D\0438 \0440\0430\0441\0442\0443\045B\0438\043C \0440\0435\0434\043E\0441\043B\0435\0434\043E\043C.</li>'),
unistr('<li>\0418\043A\043E\043D\0430 <strong>\0421\043E\0440\0442\0438\0440\0430\0458 \043E\043F\0430\0434\0430\0458\0443\045B\0438\043C \0440\0435\0434\043E\0441\043B\0435\0434\043E\043C</strong> \0441\043E\0440\0442\0438\0440\0430 \0438\0437\0432\0435\0448\0442\0430\0458 \043E\043F\0430\0434\0430\0458\0443\045B\0438\043C \0440\0435\0434\043E\0441\043B\0435\0434\043E\043C.</li>'),
unistr('<li><strong>\0421\0430\043A\0440\0438\0458 \043A\043E\043B\043E\043D\0443</strong> \0441\043A\0440\0438\0432\0430 \043A\043E\043B\043E\043D\0443. \041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0441\0430\043A\0440\0438\0442\0438 \0441\0432\0435 \043A\043E\043B\043E\043D\0435. \0410\043A\043E \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0441\0430\043A\0440\0438\0442\0438 \043A\043E\043B\043E\043D\0443, \0438\043A\043E\043D\0430 \0421\0430\043A\0440\0438\0458 \043A\043E\043B\043E\043D\0443 \0441\0435 \043D\0435\045B\0435 \043F\0440\0438\043A\0430\0437\0430\0442\0438.</li>'),
unistr('<li><strong>\041F\0440\0435\043B\043E\043C \043A\043E\043B\043E\043D\0435</strong> \043A\0440\0435\0438\0440\0430 \0433\0440\0443\043F\0443 \043F\0440\0435\043B\043E\043C\0430 \0443 \043A\043E\043B\043E\043D\0438. \0422\0438\043C\0435 \0441\0435 \043A\043E\043B\043E\043D\0430 \0438\0437\0432\043B\0430\0447\0438 \0438\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043A\0430\043E \0433\043B\0430\0432\043D\0438 \0437\0430\043F\0438\0441.</li>'),
unistr('<li>\0421\0442\0430\0432\043A\0430 <strong>\0418\043D\0444\043E\0440\043C\0430\0446\0438\0458\0435 \043E \043A\043E\043B\043E\043D\0438</strong> \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0442\0435\043A\0441\0442 \043F\043E\043C\043E\045B\0438 \0443 \0432\0435\0437\0438 \0441\0430 \043A\043E\043B\043E\043D\043E\043C, \0430\043A\043E \0458\0435 \0434\043E\0441\0442\0443\043F\0430\043D.</li>'),
unistr('<li><strong>\041E\0431\043B\0430\0441\0442 \0442\0435\043A\0441\0442\0430</strong> \043A\043E\0440\0438\0441\0442\0438 \0441\0435 \0437\0430 \0443\043D\043E\0441 \043A\0440\0438\0442\0435\0440\0438\0458\0443\043C\0430 \043F\0440\0435\0442\0440\0430\0433\0435 \043A\043E\0458\0438 \043D\0435 \0440\0430\0437\043B\0438\043A\0443\0458\0443 \0432\0435\043B\0438\043A\0430 \0438 \043C\0430\043B\0430 \0441\043B\043E\0432\0430'),
unistr('(\043D\0435\043C\0430 \043F\043E\0442\0440\0435\0431\0435 \0437\0430 \045F\043E\043A\0435\0440\0438\043C\0430). \0423\043D\043E\0441\043E\043C \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0441\043A\0440\0430\045B\0443\0458\0435 \0441\0435 \043B\0438\0441\0442\0430'),
unistr('\0432\0440\0435\0434\043D\043E\0441\0442\0438 \0443 \0434\043D\0443 \043C\0435\043D\0438\0458\0430. \0417\0430\0442\0438\043C \043C\043E\0436\0435\0442\0435 \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442 \0443'),
unistr('\0434\043D\0443 \0438 \0438\0437\0430\0431\0440\0430\043D\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \045B\0435 \0441\0435 \043A\0440\0435\0438\0440\0430\0442\0438 \043A\0430\043E \0444\0438\043B\0442\0435\0440 \0441\0430 ''='''),
unistr('(\043D\0430 \043F\0440\0438\043C\0435\0440, <code>column = ''ABC''</code>). \0414\0440\0443\0433\0430 \043C\043E\0433\0443\045B\043D\043E\0441\0442 \0458\0435 \0434\0430 \043A\043B\0438\043A\043D\0435\0442\0435 \043D\0430 \0438\043A\043E\043D\0443 \043B\0430\043C\043F\0435 \0438 \0443\043D\0435\0441\0435\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442 \043A\0430\043E \0444\0438\043B\0442\0435\0440 \0441\0430 \043C\043E\0434\0438\0444\0438\043A\0430\0442\043E\0440\043E\043C ''LIKE'''),
unistr('(\043D\0430 \043F\0440\0438\043C\0435\0440, <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>\041B\0438\0441\0442\0430 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\0438\0445 \0432\0440\0435\0434\043D\043E\0441\0442\0438</b> \0441\0430\0434\0440\0436\0438 \043F\0440\0432\0438\0445 500 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\0438\0445'),
unistr('\0432\0440\0435\0434\043D\043E\0441\0442\0438 \043A\043E\0458\0435 \0438\0441\043F\0443\045A\0430\0432\0430\0458\0443 \0432\0430\0448\0435 \043A\0440\0438\0442\0435\0440\0438\0458\0443\043C\0435 \0444\0438\043B\0442\0435\0440\0430. \0410\043A\043E \0458\0435 \043A\043E\043B\043E\043D\0430 \0434\0430\0442\0443\043C, \0443\043C\0435\0441\0442\043E \0442\043E\0433\0430 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0430\0442\0438'),
unistr('\043E\043F\0441\0435\0437\0438 \0434\0430\0442\0443\043C\0430. \0410\043A\043E \0438\0437\0430\0431\0435\0440\0435\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442, \043A\0440\0435\0438\0440\0430\045B\0435 \0441\0435'),
unistr('\0444\0438\043B\0442\0435\0440 \0441\0430 ''='' (\043D\0430 \043F\0440\0438\043C\0435\0440, <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903828321402072)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041E\043C\043E\0433\0443\045B\0430\0432\0430 \0432\0430\043C \0434\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0443 \0434\043E\0434\0430\0442\0435 \0438\0437\0440\0430\0447\0443\043D\0430\0442\0435 \043A\043E\043B\043E\043D\0435. \0422\043E \043C\043E\0433\0443 \0434\0430 \0431\0443\0434\0443 \043C\0430\0442\0435\043C\0430\0442\0438\0447\043A\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 (\043D\0430 \043F\0440\0438\043C\0435\0440, <code>NBR_HOURS/24</code>) \0438\043B\0438 \0441\0442\0430\043D\0434\0430\0440\0434\043D\0435 Oracle'),
unistr('\0444\0443\043D\043A\0446\0438\0458\0435 \043F\0440\0438\043C\0435\045A\0435\043D\0435 \043D\0430 \043F\043E\0441\0442\043E\0458\0435\045B\0435 \043A\043E\043B\043E\043D\0435. \041D\0435\043A\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \043A\0430\043E \043F\0440\0438\043C\0435\0440\0438, \0430 \043C\043E\0433\0443 \0434\0430 \0441\0435 \043A\043E\0440\0438\0441\0442\0435 \0438 \0434\0440\0443\0433\0435 (\043C\043E\0436\0435 \0441\0435 \043A\043E\0440\0438\0441\0442\0438\0442\0438 \0438 <code>TO_DATE)</code>. \041E\043F\0446\0438\0458\0435 \0441\0443 \0441\043B\0435\0434\0435\045B\0435:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\0418\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \043F\0440\0435\0442\0445\043E\0434\043D\043E \0434\0435\0444\0438\043D\0438\0441\0430\043D\043E \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435 \0437\0430 \0443\0440\0435\0452\0438\0432\0430\045A\0435.</li>'),
unistr('<li><strong>\0417\0430\0433\043B\0430\0432\0459\0435 \043A\043E\043B\043E\043D\0435</strong> \0458\0435 \0437\0430\0433\043B\0430\0432\0459\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \043D\043E\0432\0443 \043A\043E\043B\043E\043D\0443.</li>'),
unistr('<li><strong>\041C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430</strong> \0458\0435 Oracle \043C\0430\0441\043A\0430 \0444\043E\0440\043C\0430\0442\0430 \043A\043E\0458\0430 \0441\0435 \043F\0440\0438\043C\0435\045A\0443\0458\0435 \043D\0430 \043A\043E\043B\043E\043D\0443 (\043D\0430 \043F\0440\0438\043C\0435\0440, S9999).</li>'),
unistr('<li><strong>\0418\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435</strong> \0458\0435 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435 \043A\043E\0458\0435 \0441\0435 \043E\0431\0430\0432\0459\0430. \0423 \043E\043A\0432\0438\0440\0443 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430, \043A\043E\043B\043E\043D\0435 \0441\0435 \0440\0435\0444\0435\0440\0435\043D\0446\0438\0440\0430\0458\0443 \043F\043E\043C\043E\045B\0443 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0430\043B\0438\0458\0430\0441\0430.</li>'),
'</ul>',
unistr('<p>\0418\0441\043F\043E\0434 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430, \043A\043E\043B\043E\043D\0435 \0443\043F\0438\0442\0430 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443'),
unistr('\0441\0430 \043F\043E\0432\0435\0437\0430\043D\0438\043C \0430\043B\0438\0458\0430\0441\0438\043C\0430. \041A\043B\0438\043A\043E\043C \043D\0430 \043D\0430\0437\0438\0432 \043A\043E\043B\043E\043D\0435 \0438\043B\0438 \0430\043B\0438\0458\0430\0441 \0443\043A\0459\0443\0447\0443\0458\0435\0442\0435'),
unistr('\0438\0445 \0443 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435. \041F\043E\0440\0435\0434 \043A\043E\043B\043E\043D\0430 \0441\0435 \043D\0430\043B\0430\0437\0438 \0442\0430\0441\0442\0430\0442\0443\0440\0430. \041E\0432\0430 \0442\0430\0441\0442\0430\0442\0443\0440\0430 \0444\0443\043D\043A\0446\0438\043E\043D\0438\0448\0435 \043A\0430\043E'),
unistr('\043F\0440\0435\0447\0438\0446\0430 \0437\0430 \0442\0430\0441\0442\0435\0440\0435 \043A\043E\0458\0438 \0441\0435 \0447\0435\0441\0442\043E \043A\043E\0440\0438\0441\0442\0435. \041D\0430 \043A\0440\0430\0458\045A\043E\0458 \0434\0435\0441\043D\043E\0458 \0441\0442\0440\0430\043D\0438 \043D\0430\043B\0430\0437\0435 \0441\0435 \0444\0443\043D\043A\0446\0438\0458\0435.</p>'),
unistr('<p>\0421\043B\0435\0434\0435\045B\0438 \043F\0440\0438\043C\0435\0440 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 \043F\043E\043A\0430\0437\0443\0458\0435 \043A\0430\043A\043E \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0443\043A\0443\043F\043D\0430 \043A\043E\043C\043F\0435\043D\0437\0430\0446\0438\0458\0430:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\0433\0434\0435 \0458\0435 A ORGANIZATION, B \0458\0435 SALARY, \0430 C \0458\0435 COMMISSION)</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910378840402077)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\0442\0438 \0441\0435 \0437\0430 \043A\0440\0435\0438\0440\0430\045A\0435 \0433\0440\0443\043F\0435 \043F\0440\0435\043B\043E\043C\0430 \043D\0430 \0458\0435\0434\043D\043E\0458 \0438\043B\0438 \0432\0438\0448\0435 \043A\043E\043B\043E\043D\0430. \041D\0430 \0442\0430\0458 \043D\0430\0447\0438\043D \0441\0435 \043A\043E\043B\043E\043D\0435 \0438\0437\0432\043B\0430\0447\0435 \0438\0437 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \0441\0435 \043A\0430\043E \0433\043B\0430\0432\043D\0438 \0437\0430\043F\0438\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904560007402072)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430 \0431\0438\0441\0442\0435 \0432\0438\0434\0435\043B\0438 \0434\0435\0442\0430\0459\0435 \0458\0435\0434\043D\043E\0433 \043F\043E \0458\0435\0434\043D\043E\0433 \0440\0435\0434\0430, \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0438\043A\043E\043D\0443 \0437\0430 \043F\0440\0438\043A\0430\0437 \0458\0435\0434\043D\043E\0433 \0440\0435\0434\0430 \0443 \0440\0435\0434\0443 \043A\043E\0458\0438 \0436\0435\043B\0438\0442\0435 \0434\0430 \043F\0440\0438\043A\0430\0436\0435\0442\0435. \0410\043A\043E \0458\0435 \0434\043E\0441\0442\0443\043F\043D\043E, \043F\0440\0438\043A\0430\0437 \0458\0435\0434\043D\043E\0433 \0440\0435\0434\0430 \045B\0435 \0443\0432\0435\043A \0431\0438\0442\0438 \043F\0440\0432\0430 \043A\043E\043B\043E\043D\0430. \0423 \0437\0430\0432\0438\0441\043D\043E\0441\0442\0438 \043E\0434 \043F\0440\0438\043B\0430\0433\043E\0452\0430\0432\0430\045A\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433 \0438\0437\0432\0435\0448\0442\0430\0458\0430, \043F\0440\0438\043A\0430\0437 \0458\0435\0434\043D\043E\0433 ')
||unistr('\0440\0435\0434\0430 \043C\043E\0436\0435 \0434\0430 \0431\0443\0434\0435 \0441\0442\0430\043D\0434\0430\0440\0434\043D\0438 \043F\0440\0438\043A\0430\0437 \0438\043B\0438 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0430 \0441\0442\0440\0430\043D\0438\0446\0430 \043A\043E\0458\0443 \0458\0435 \043C\043E\0433\0443\045B\0435 \0430\0436\0443\0440\0438\0440\0430\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904412189402072)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0430\0432\0430 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0435 \0442\0440\0435\043D\0443\0442\043D\043E\0433 \0441\043A\0443\043F\0430 \0440\0435\0437\0443\043B\0442\0430\0442\0430. \0424\043E\0440\043C\0430\0442\0438 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0430 \0441\0435 \0440\0430\0437\043B\0438\043A\0443\0458\0443 \0443 \0437\0430\0432\0438\0441\043D\043E\0441\0442\0438 \043E\0434 \0438\043D\0441\0442\0430\043B\0430\0446\0438\0458\0435 \0438 \0434\0435\0444\0438\043D\0438\0446\0438\0458\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0430, \0430\043B\0438 \043C\043E\0433\0443 \0434\0430 \043E\0431\0443\0445\0432\0430\0442\0430\0458\0443 CSV, HTML, \0415-\043F\043E\0448\0442\0443, XLS, PDF \0438\043B\0438 RTF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903599130402072)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0424\043E\043A\0443\0441\0438\0440\0430 \0438\0437\0432\0435\0448\0442\0430\0458 \0434\043E\0434\0430\0432\0430\045A\0435\043C \0438\043B\0438 \043C\043E\0434\0438\0444\0438\043A\043E\0432\0430\045A\0435\043C \043E\0434\0440\0435\0434\0431\0435 <code>WHERE</code> \043D\0430 \0443\043F\0438\0442\0443. \0424\0438\043B\0442\0440\0438\0440\0430\045A\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \043E\0431\0430\0432\0438\0442\0435 \043D\0430 \043A\043E\043B\043E\043D\0438 \0438\043B\0438 \043F\043E \0440\0435\0434\0443. '),
unistr('<p>\0410\043A\043E \0444\0438\043B\0442\0440\0438\0440\0430\0442\0435 \043F\043E \043A\043E\043B\043E\043D\0438, \0438\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0443 (\043D\0435 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043E\043D\0430 \043A\043E\0458\0430 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435), \0438\0437\0430\0431\0435\0440\0438\0442\0435 \0441\0442\0430\043D\0434\0430\0440\0434\043D\0438 Oracle \043E\043F\0435\0440\0430\0442\043E\0440 (=, !=, \043D\0438\0458\0435 \0443, \0438\0437\043C\0435\0452\0443) \0438 \0443\043D\0435\0441\0438\0442\0435 \0438\0437\0440\0430\0437 \043F\0440\0435\043C\0430 \043A\043E\043C \0441\0435 \043E\0431\0430\0432\0459\0430 \043F\043E\0440\0435\0452\0435\045A\0435. \0418\0437\0440\0430\0437\0438 \0440\0430\0437\043B\0438\043A\0443\0458\0443 \0432\0435\043B\0438\043A\0430 \0438 \043C\0430\043B\0430 \0441\043B\043E\0432\0430. \041A\043E\0440\0438\0441\0442\0438\0442\0435 % \043A\0430\043E \045F\043E')
||unistr('\043A\0435\0440 (\043D\0430 \043F\0440\0438\043C\0435\0440, <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>\0410\043A\043E \0444\0438\043B\0442\0440\0438\0440\0430\0442\0435 \043F\043E \0440\0435\0434\0443, \043C\043E\0436\0435\0442\0435 \0434\0430 \043A\0440\0435\0438\0440\0430\0442\0435 \0441\043B\043E\0436\0435\043D\0435 \043E\0434\0440\0435\0434\0431\0435 <code>WHERE</code> \043A\043E\0440\0438\0441\0442\0435\045B\0438'),
unistr('\0430\043B\0438\0458\0430\0441\0435 \043A\043E\043B\043E\043D\0435 \0438 \0431\0438\043B\043E \043A\043E\0458\0435 Oracle \0444\0443\043D\043A\0446\0438\0458\0435 \0438\043B\0438 \043E\043F\0435\0440\0430\0442\043E\0440\0435 (\043D\0430 \043F\0440\0438\043C\0435\0440, <code>G = ''VA'' \0438\043B\0438 G = ''CT''</code>, \0433\0434\0435 \0458\0435'),
unistr('<code>G</code> \0430\043B\0438\0458\0430\0441 \0437\0430 <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904135081402072)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0423\043F\0438\0442 \0437\0430 \0432\0440\0430\045B\0430\045A\0435 \0443 \043F\0440\043E\0448\043B\043E\0441\0442 \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0432\0438\0434\0438\0442\0435 \043F\043E\0434\0430\0442\043A\0435 \043A\0430\043A\0432\0438 \0441\0443 \0431\0438\043B\0438 \0443 \0440\0430\043D\0438\0458\0435\043C \0432\0440\0435\043C\0435\043D\0441\043A\043E\043C'),
unistr('\0442\0440\0435\043D\0443\0442\043A\0443. \041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E \0432\0440\0435\043C\0435 \0443 \043A\043E\043C \043C\043E\0436\0435\0442\0435 \0434\0430 \0441\0435 \0432\0440\0430\0442\0438\0442\0435 \0443 \043F\0440\043E\0448\043B\043E\0441\0442 \0458\0435 3 \0441\0430\0442\0430 (\0438\043B\0438 180'),
unistr('\043C\0438\043D\0443\0442\0430), \0430\043B\0438 \045B\0435 \0441\0442\0432\0430\0440\043D\0430 \0434\0443\0436\0438\043D\0430 \0432\0440\0435\043C\0435\043D\0430 \0431\0438\0442\0438 \0440\0430\0437\043B\0438\0447\0438\0442\0430 \0437\0430\0432\0438\0441\043D\043E\0441\0442\0438 \043E\0434 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965312494402120)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0424\043E\0440\043C\0430\0442 \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \043F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \0424\043E\0440\043C\0430\0442 \0441\0430\0434\0440\0436\0438 \0441\043B\0435\0434\0435\045B\0438 \043F\043E\0434\043C\0435\043D\0438:</p>'),
unistr('<ul><li>\0421\043E\0440\0442\0438\0440\0430\0458</li>'),
unistr('<li>\041A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C</li>'),
unistr('<li>\0418\0441\0442\0430\043A\043D\0438</li>'),
unistr('<li>\0418\0437\0440\0430\0447\0443\043D\0430\0458</li>'),
unistr('<li>\0410\0433\0440\0435\0433\0438\0440\0430\0458</li>'),
unistr('<li>\0413\0440\0430\0444\0438\043A\043E\043D</li>'),
unistr('<li>\0413\0440\0443\043F\0438\0448\0438 \043F\043E</li>'),
unistr('<li>\041F\0438\0432\043E\0442</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963505495402118)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041C\043E\0436\0435\0442\0435 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0458\0435\0434\0430\043D \043F\0440\0438\043A\0430\0437 \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \043F\043E \0441\0430\0447\0443\0432\0430\043D\043E\043C \0438\0437\0432\0435\0448\0442\0430\0458\0443. \041A\0430\0434\0430 \0433\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435, \043C\043E\0436\0435\0442\0435 \0434\0430 \0441\0435 \043F\0440\0435\0431\0430\0446\0443\0458\0435\0442\0435 \0441\0430 \043F\0440\0438\043A\0430\0437\0430 \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \043D\0430 \043F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \043E\0431\0440\043D\0443\0442\043E \043F\043E\043C\043E\045B\0443 \0438\043A\043E\043D\0430 \0437\0430 \043F\0440\0438\043A\0430\0437 \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443. \0414\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438')
||unistr(' \043F\0440\0438\043A\0430\0437 \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443, \0438\0437\0430\0431\0435\0440\0438\0442\0435: '),
'<p></p><ul>',
unistr('<li>\043A\043E\043B\043E\043D\0435 \043D\0430 \043A\043E\0458\0438\043C\0430 \0441\0435 \043E\0431\0430\0432\0459\0430 \0433\0440\0443\043F\0438\0441\0430\045A\0435</li>'),
unistr('<li>\043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \045B\0435 \0441\0435 \0430\0433\0440\0435\0433\0438\0440\0430\0442\0438 \0437\0430\0458\0435\0434\043D\043E \0441\0430 \0444\0443\043D\043A\0446\0438\0458\0430\043C\0430 \043A\043E\0458\0435 \045B\0435 \0441\0435 \043E\0431\0430\0432\0438\0442\0438 (\043F\0440\043E\0441\0435\043A, \0437\0431\0438\0440, \0431\0440\043E\0458 \0438\0442\0434.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903726605402072)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041E\043C\043E\0433\0443\045B\0430\0432\0430 \0432\0430\043C \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0444\0438\043B\0442\0435\0440. \0420\0435\0434\043E\0432\0438 \043A\043E\0458\0438 \0438\0441\043F\0443\045A\0430\0432\0430\0458\0443 \043A\0440\0438\0442\0435\0440\0438\0458\0443\043C \0444\0438\043B\0442\0435\0440\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \0441\0435 \043A\0430\043E \0438\0441\0442\0430\043A\043D\0443\0442\0438 \043F\0443\0442\0435\043C \043A\0430\0440\0430\043A\0442\0435\0440\0438\0441\0442\0438\043A\0430 \043F\043E\0432\0435\0437\0430\043D\0438\0445 \0441\0430 \0444\0438\043B\0442\0435\0440\043E\043C. \041E\043F\0446\0438\0458\0435 \043E\0431\0443\0445\0432\0430\0442\0430\0458\0443:</p>'),
'<ul>',
unistr('<li><strong>\0418\043C\0435</strong> \0441\0435 \043A\043E\0440\0438\0441\0442\0438 \0441\0430\043C\043E \0437\0430 \043F\0440\0438\043A\0430\0437.</li>'),
unistr('<li><strong>\041D\0438\0437</strong> \0438\0434\0435\043D\0442\0438\0444\0438\043A\0443\0458\0435 \043D\0438\0437 \043A\043E\0458\0438\043C \0441\0435 \043F\0440\0430\0432\0438\043B\0430 \043F\0440\043E\0446\0435\045A\0443\0458\0443.</li>'),
unistr('<li><strong>\041E\043C\043E\0433\0443\045B\0435\043D\043E</strong> \043E\0437\043D\0430\0447\0430\0432\0430 \0434\0430 \043B\0438 \0458\0435 \043F\0440\0430\0432\0438\043B\043E \043E\043C\043E\0433\0443\045B\0435\043D\043E \0438\043B\0438 \043D\0438\0458\0435 \043E\043C\043E\0433\0443\045B\0435\043D\043E.</li>'),
unistr('<li><strong>\0422\0438\043F \0438\0441\0442\0438\0446\0430\045A\0430</strong> \043E\0437\043D\0430\0447\0430\0432\0430 \0434\0430 \043B\0438 \0458\0435 \043F\043E\0442\0440\0435\0431\043D\043E \0438\0441\0442\0430\043A\043D\0443\0442\0438 \0440\0435\0434'),
unistr('\0438\043B\0438 \045B\0435\043B\0438\0458\0443. \0410\043A\043E \0438\0437\0430\0431\0435\0440\0435\0442\0435 \045B\0435\043B\0438\0458\0443, \0438\0441\0442\0438\0447\0435 \0441\0435 \043A\043E\043B\043E\043D\0430 \043A\043E\0458\0430 \0458\0435 \043D\0430\0437\043D\0430\0447\0435\043D\0430 \0443 \0443\0441\043B\043E\0432\0443 \0438\0441\0442\0438\0446\0430\045A\0430.</li>'),
unistr('<li><strong>\0411\043E\0458\0430 \043F\043E\0437\0430\0434\0438\043D\0435</strong> \0458\0435 \043D\043E\0432\0430 \0431\043E\0458\0430 \043F\043E\0437\0430\0434\0438\043D\0435 \0443 \0438\0441\0442\0430\043A\043D\0443\0442\043E\0458 \043E\0431\043B\0430\0441\0442\0438.</li>'),
unistr('<li><strong>\0411\043E\0458\0430 \0442\0435\043A\0441\0442\0430</strong> \0458\0435 \043D\043E\0432\0430 \0431\043E\0458\0430 \0442\0435\043A\0441\0442\0430 \0443 \0438\0441\0442\0430\043A\043D\0443\0442\043E\0458 \043E\0431\043B\0430\0441\0442\0438.</li>'),
unistr('<li><strong>\0423\0441\043B\043E\0432 \0438\0441\0442\0438\0446\0430\045A\0430</strong>  \0434\0435\0444\0438\043D\0438\0448\0435 \0443\0441\043B\043E\0432 \0444\0438\043B\0442\0435\0440\0430.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841395086402023)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041C\043E\0436\0435\0442\0435 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435 \0458\0435\0434\0430\043D \043F\0440\0438\043A\0430\0437 \043F\0438\0432\043E\0442\0430 \043F\043E \0441\0430\0447\0443\0432\0430\043D\043E\043C \0438\0437\0432\0435\0448\0442\0430\0458\0443. \041A\0430\0434\0430 \0433\0430 \0434\0435\0444\0438\043D\0438\0448\0435\0442\0435, \043C\043E\0436\0435\0442\0435 \0434\0430 \0441\0435 \043F\0440\0435\0431\0430\0446\0443\0458\0435\0442\0435 \0441\0430 \043F\0440\0438\043A\0430\0437\0430 \043F\0438\0432\043E\0442\0430 \043D\0430 \043F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \043E\0431\0440\043D\0443\0442\043E \043F\043E\043C\043E\045B\0443 \0438\043A\043E\043D\0430 \0437\0430 \043F\0440\0438\043A\0430\0437 \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443.  \0414\0430 \0431\0438\0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \043F\0440\0438\043A\0430\0437 \043F\0438\0432\043E\0442\0430, \0438\0437\0430\0431\0435\0440\0438\0442\0435: '),
'<p></p>',
'<ul>',
unistr('<li>\043A\043E\043B\043E\043D\0435 \043D\0430 \043A\043E\0458\0438\043C\0430 \0441\0435 \043E\0431\0430\0432\0459\0430 \043F\0438\0432\043E\0442 \0444\0443\043D\043A\0446\0438\0458\0430</li>'),
unistr('<li>\043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0430\0442\0438 \043A\0430\043E \0440\0435\0434\043E\0432\0438</li>'),
unistr('<li>\043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \045B\0435 \0441\0435 \0430\0433\0440\0435\0433\0438\0440\0430\0442\0438 \0437\0430\0458\0435\0434\043D\043E \0441\0430 \0444\0443\043D\043A\0446\0438\0458\0430\043C\0430 \043A\043E\0458\0435 \045B\0435 \0441\0435 \043E\0431\0430\0432\0438\0442\0438 (\043F\0440\043E\0441\0435\043A, \0437\0431\0438\0440, \0431\0440\043E\0458 \0438\0442\0434.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914892788402080)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0410\043A\043E \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458, \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0430\0442\0438'),
unistr('\0438\0441\043F\043E\0434 \0442\0440\0430\043A\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443 \0438 \0438\0437\043D\0430\0434 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \041E\0432\0430 \043E\0431\043B\0430\0441\0442 \043C\043E\0436\0435 \0434\0430 \0441\0435 \0441\043A\0443\043F\0438 \0438 \043F\0440\043E\0448\0438\0440\0438 \043F\043E\043C\043E\045B\0443 \0438\043A\043E\043D\0435 \0441\0430 \043B\0435\0432\0435 \0441\0442\0440\0430\043D\0435.'),
'<p>',
unistr('\0417\0430 \0441\0432\0430\043A\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043C\043E\0436\0435\0442\0435 \0434\0430 \0443\0447\0438\043D\0438\0442\0435 \0441\043B\0435\0434\0435\045B\0435:'),
'</p><ul>',
unistr('<li>\0423\0440\0435\0452\0443\0458\0435\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \043A\043B\0438\043A\043E\043C \043D\0430 \0438\043C\0435.</li>'),
unistr('<li>\041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435/\043E\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0443\043A\043B\0430\045A\0430\045A\0435\043C \043E\0437\043D\0430\043A\0435 \0438\0437 \043F\043E\0459\0430 \041E\043C\043E\0433\0443\045B\0438/\043E\043D\0435\043C\043E\0433\0443\045B\0438 \0438\043B\0438 \045A\0435\0433\043E\0432\0438\043C \043E\0437\043D\0430\0447\0430\0432\0430\045A\0435\043C. \041F\043E\043C\043E\045B\0443 \043E\0432\0435 \043A\043E\043D\0442\0440\043E\043B\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\0438\0432\0440\0435\043C\0435\043D\043E \0438\0441\043A\0459\0443\0447\0438\0442\0435 \0438 \0443\043A\0459\0443\0447\0438\0442\0435 \043D\0435\043A\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435.</li>'),
unistr('<li>\0423\043A\043B\0430\045A\0430\045A\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043A\043B\0438\043A\043E\043C \043D\0430 \0438\043A\043E\043D\0443 \0423\043A\043B\043E\043D\0438.</li>'),
'</ul>',
unistr('<p>\0410\043A\043E \0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \0433\0440\0430\0444\0438\043A\043E\043D, \0433\0440\0443\043F\0443 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \0438\043B\0438 \043F\0438\0432\043E\0442, \043C\043E\0436\0435\0442\0435 \0434\0430 \0441\0435 \043F\0440\0435\0431\0430\0446\0443\0458\0435\0442\0435 \0441\0430 \045A\0438\0445'),
unistr('\043D\0430 \043E\0441\043D\043E\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \043F\043E\043C\043E\045B\0443 \0432\0435\0437\0430 \041F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430, \041F\0440\0438\043A\0430\0437 \0433\0440\0430\0444\0438\043A\043E\043D\0430, \041F\0440\0438\043A\0430\0437 \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \0438 \041F\0440\0438\043A\0430\0437 \043F\0438\0432\043E\0442\0430'),
unistr('\043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0441\0430 \0434\0435\0441\043D\0435 \0441\0442\0440\0430\043D\0435. \0410\043A\043E \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \0433\0440\0430\0444\0438\043A\043E\043D, \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \0438\043B\0438 \043F\0438\0432\043E\0442 \043C\043E\0436\0435\0442\0435'),
unistr('\0434\0430 \043A\043E\0440\0438\0441\0442\0438\0442\0435 \0438 \0432\0435\0437\0443 \0423\0440\0435\0434\0438 \0434\0430 \0431\0438\0441\0442\0435 \0443\0440\0435\0434\0438\043B\0438 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904342504402072)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043D\0430 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438 \0443\043A\043B\0430\045A\0430 \0441\0432\0435 \0438\0437\043C\0435\043D\0435 \043A\043E\0458\0435 \0441\0442\0435 \043D\0430\043F\0440\0430\0432\0438\043B\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965667884402120)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0448\0430\0432\0430 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \043A\043E\0458\0438 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0438\0432\0430\0442\0438 \043F\043E \0441\0442\0440\0430\043D\0438\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904213908402072)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0427\0443\0432\0430 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0437\0430 \0431\0443\0434\0443\045B\0443 \0443\043F\043E\0442\0440\0435\0431\0443. \0412\0438 \043D\0430\0432\043E\0434\0438\0442\0435 \0438\043C\0435 \0438 \043E\043F\0446\0438\043E\043D\0430\043B\043D\0438 \043E\043F\0438\0441 \0438 \043E\0434\0440\0435\0452\0443\0458\0435\0442\0435 \0434\0430 \043B\0438 \045B\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \0431\0438\0442\0438 \0458\0430\0432\0430\043D (\043E\0434\043D\043E\0441\043D\043E, \0434\043E\0441\0442\0443\043F\0430\043D \0441\0432\0438\043C \043A\043E\0440\0438\0441\043D\0438\0446\0438\043C\0430 \043A\043E\0458\0438 \043C\043E\0433\0443 \0434\0430 \043F\0440\0438\0441\0442\0443\043F\0435 \043F\0440\0438\043C\0430\0440\043D\043E\043C \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E\043C \0438\0437\0432\0435\0448\0442\0430\0458\0443). \041C\043E\0436\0435\0442\0435 \0434\0430 \0441\0430\0447\0443\0432\0430\0442\0435 \0447\0435\0442\0438\0440\0438 \0442\0438\043F\0430')
||unistr(' \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438\0445 \0438\0437\0432\0435\0448\0442\0430\0458\0430:</p>'),
'<ul>',
unistr('<li><strong>\041F\0440\0438\043C\0430\0440\043D\0438 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438</strong> (\0441\0430\043C\043E \0437\0430 \043F\0440\043E\0433\0440\0430\043C\0435\0440\0435). \041F\0440\0438\043C\0430\0440\043D\0438 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0458\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043A\043E\0458\0438 \0441\0435 \043F\0440\0432\0438 \043F\0440\0438\043A\0430\0437\0443\0458\0435. \041F\0440\0438\043C\0430\0440\043D\0435 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\0440\0435\0438\043C\0435\043D\043E\0432\0430\0442\0438 \043D\0438\0442\0438 \0438\0437\0431\0440\0438\0441\0430\0442\0438.</li>'),
unistr('<li><strong>\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458</strong> (\0441\0430\043C\043E \0437\0430 \043F\0440\043E\0433\0440\0430\043C\0435\0440\0435). \041E\043C\043E\0433\0443\045B\0430\0432\0430 \043F\0440\043E\0433\0440\0430\043C\0435\0440\0438\043C\0430 \0434\0430 \043A\0440\0435\0438\0440\0430\0458\0443 \0432\0438\0448\0435 \0440\0430\0441\043F\043E\0440\0435\0434\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \0418\0441\043A\0459\0443\0447\0438\0432\043E \043F\0440\043E\0433\0440\0430\043C\0435\0440\0438 \043C\043E\0433\0443 \0434\0430 \0441\0430\0447\0443\0432\0430\0458\0443, \043F\0440\0435\0438\043C\0435\043D\0443\0458\0443 \0438\043B\0438 \0438\0437\0431\0440\0438\0448\0443 \0430\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458.</li>'),
unistr('<li><strong>\0408\0430\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458</strong> (\043A\0440\0430\0458\045A\0438 \043A\043E\0440\0438\0441\043D\0438\043A). \041C\043E\0436\0435 \0434\0430 \0433\0430 \0441\0430\0447\0443\0432\0430, \043F\0440\0435\0438\043C\0435\043D\0443\0458\0435 \0438\043B\0438 \0438\0437\0431\0440\0438\0448\0435 \043A\0440\0430\0458\045A\0438 \043A\043E\0440\0438\0441\043D\0438\043A \043A\043E\0458\0438 \0433\0430 \0458\0435 \043A\0440\0435\0438\0440\0430\043E. \0414\0440\0443\0433\0438 \043A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \043F\0440\0435\0433\043B\0435\0434\0430\0458\0443 \0438 \0441\0430\0447\0443\0432\0430\0458\0443 \0440\0430\0441\043F\043E\0440\0435\0434 \043A\0430\043E \0434\0440\0443\0433\0438 \0438\0437\0432\0435\0448\0442\0430\0458.</li>'),
unistr('<li><strong>\041B\0438\0447\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458</strong> (\043A\0440\0430\0458\045A\0438 \043A\043E\0440\0438\0441\043D\0438\043A). \0421\0430\043C\043E \043A\0440\0430\0458\045A\0438 \043A\043E\0440\0438\0441\043D\0438\043A \043A\043E\0458\0438 \0458\0435 \043A\0440\0435\0438\0440\0430\043E \0438\0437\0432\0435\0448\0442\0430\0458 \043C\043E\0436\0435 \0434\0430 \043F\0440\0438\043A\0430\0436\0435, \0441\0430\0447\0443\0432\0430, \043F\0440\0435\0438\043C\0435\043D\0443\0458\0435 \0438\043B\0438 \0438\0437\0431\0440\0438\0448\0435 \0438\0437\0432\0435\0448\0442\0430\0458.</li>'),
'</ul>',
unistr('<p>\0410\043A\043E \0447\0443\0432\0430\0442\0435 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435, \0431\0438\0440\0430\0447 \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443, \043B\0435\0432\043E \043E\0434 \0431\0438\0440\0430\0447\0430 \0440\0435\0434\043E\0432\0430 (\0430\043A\043E \0458\0435 \0442\0430 \0444\0443\043D\043A\0446\0438\0458\0430 \043E\043C\043E\0433\0443\045B\0435\043D\0430).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903260451402071)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0432\0440\0445\0443 \0441\0432\0430\043A\0435 \0441\0442\0440\0430\043D\0438\0446\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043D\0430\043B\0430\0437\0438 \0441\0435 \0440\0435\0433\0438\043E\043D \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443. \041E\0432\0430\0458 \0440\0435\0433\0438\043E\043D (\0438\043B\0438 \0442\0440\0430\043A\0430 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443) \0441\0430\0434\0440\0436\0438 \0441\043B\0435\0434\0435\045B\0435 \0444\0443\043D\043A\0446\0438\0458\0435:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966266358402120)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('<li><strong>\041C\0435\043D\0438 \0441\0430 \0440\0430\0434\045A\0430\043C\0430</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\0437\0432\0435\0448\0442\0430\0458. \041F\043E\0433\043B\0435\0434\0430\0458\0442\0435 \043E\0434\0435\0459\043A\0435 \0443 \043D\0430\0441\0442\0430\0432\043A\0443.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965711301402120)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'sr'
,p_message_text=>unistr('<li><strong>\0418\043A\043E\043D\0430 \0437\0430 \0438\0437\0431\043E\0440 \043A\043E\043B\043E\043D\0435</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0438\0437\0430\0431\0435\0440\0435\0442\0435 \043A\043E\0458\0443 \043A\043E\043B\043E\043D\0443 \045B\0435\0442\0435 \043F\0440\0435\0442\0440\0430\0436\0438\0432\0430\0442\0438 (\0438\043B\0438 \0441\0432\0435).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966009813402120)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'sr'
,p_message_text=>unistr('<li><strong>\0418\0437\0432\0435\0448\0442\0430\0458\0438</strong> \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0430\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0435 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0435 \0438 \0441\0430\0447\0443\0432\0430\043D\0435 \043F\0440\0438\0432\0430\0442\043D\0435 \0438\043B\0438 \0458\0430\0432\043D\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965907064402120)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('<li><strong>\0420\0435\0434\043E\0432\0438</strong> \043F\043E\0434\0435\0448\0430\0432\0430 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \043A\043E\0458\0438 \045B\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0438\0432\0430\0442\0438 \043F\043E \0441\0442\0440\0430\043D\0438\0446\0438.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965870282402120)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\041E\0431\043B\0430\0441\0442 \0437\0430 \0442\0435\043A\0441\0442</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0443\043D\0435\0441\0435\0442\0435 \043A\0440\0438\0442\0435\0440\0438\0458\0443\043C\0435 \043F\0440\0435\0442\0440\0430\0433\0435 \043A\043E\0458\0438 \043D\0435 \0440\0430\0437\043B\0438\043A\0443\0458\0443 \043C\0430\043B\0430 \0438 \0432\0435\043B\0438\043A\0430 \0441\043B\043E\0432\0430 (\045F\043E\043A\0435\0440 \0437\043D\0430\043A\043E\0432\0438 \0441\0435 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\0458\0443).</li>'),
unistr('<li><strong>\0414\0443\0433\043C\0435 \0418\0434\0438</strong> \0438\0437\0432\0440\0448\0430\0432\0430 \043F\0440\0435\0442\0440\0430\0433\0443. \041F\0440\0435\0442\0440\0430\0433\0430 \0441\0435 \0438\0437\0432\0440\0448\0430\0432\0430 \0438 \0430\043A\043E \043F\0440\0438\0442\0438\0441\043D\0435\0442\0435 \0442\0430\0441\0442\0435\0440 Enter \0434\043E\043A \0441\0435 \043A\0443\0440\0441\043E\0440 \043D\0430\043B\0430\0437\0438 \0443 \043E\0431\043B\0430\0441\0442\0438 \0442\0435\043A\0441\0442\0430 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966169056402120)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('<li><strong>\0418\043A\043E\043D\0435 \043F\0440\0438\043A\0430\0437\0430</strong> \043C\043E\0433\0443 \0434\0430 \043F\0440\0435\0434\0441\0442\0430\0432\0459\0430\0458\0443 \043F\0440\0438\043A\0430\0437\0435 \0438\043A\043E\043D\0430, \0438\0437\0432\0435\0448\0442\0430\0458\0430, \0434\0435\0442\0430\0459\0430, \0433\0440\0430\0444\0438\043A\043E\043D\0430, \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443 \0438 \043F\0438\0432\043E\0442\0430 \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458 \0430\043A\043E \0441\0443 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0435.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982166426402133)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('<li><strong>\0423\043F\0440\0430\0432\0459\0430\045A\0435</strong> \0432\0430\043C \043E\043C\043E\0433\0443\045B\0430\0432\0430 \0434\0430 \0443\043F\0440\0430\0432\0459\0430\0442\0435 \0441\0432\043E\0458\0441\0442\0432\0438\043C\0430, \043A\043E\043B\043E\043D\0430\043C\0430 \0438 \0440\0435\0434\043E\0432\0438\043C\0430 \043A\0430\043E \0438 \0434\0430 \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \0438\0441\0442\043E\0440\0438\0458\0443 \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458 \0438\043B\0438 \043C\0440\0435\0436\0443 \043F\043E\0434\0430\0442\0430\043A\0430.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903422621402072)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\0442\0438 \0441\0435 \0437\0430 \043C\043E\0434\0438\0444\0438\043A\043E\0432\0430\045A\0435 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \043A\043E\043B\043E\043D\0430. \041A\043E\043B\043E\043D\0435 \0441\0430 \0434\0435\0441\043D\0435 \0441\0442\0440\0430\043D\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443. \041A\043E\043B\043E\043D\0435 \0441\0430 \043B\0435\0432\0435 \0441\0442\0440\0430\043D\0435 \0441\0443 \0441\043A\0440\0438\0432\0435\043D\0435. \041C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\043E\043C\0435\043D\0438\0442\0435 \0440\0435\0434\043E\0441\043B\0435\0434 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \043A\043E\043B\043E\043D\0430 \043A\043E\0440\0438\0441\0442\0435\045B\0438 \0441\0442\0440\0435\043B\0438\0446\0435 \043D\0430 \043A\0440\0430\0458\045A\043E\0458 \0434\0435\0441\043D\043E\0458 \0441\0442\0440\0430\043D\0438. \0418\0437\0440\0430\0447\0443\043D\0430\0442\0435 \043A\043E\043B\043E\043D\0435 \0438\043C\0430\0458\0443 \043F\0440\0435\0444\0438\043A\0441 <strong>')
||'**</strong>.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903650268402072)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\041A\043E\0440\0438\0441\0442\0438 \0441\0435 \0437\0430 \043F\0440\043E\043C\0435\043D\0443 \043A\043E\043B\043E\043D\0430 \043A\043E\0458\0435 \0441\0435 \0441\043E\0440\0442\0438\0440\0430\0458\0443 \0438 \043E\0434\0440\0435\0452\0443\0458\0435 \0434\0430 \043B\0438 \045B\0435 \0441\0435'),
unistr('\0441\043E\0440\0442\0438\0440\0430\0442\0438 \043F\043E \0440\0430\0441\0442\0443\045B\0435\043C \0438\043B\0438 \043E\043F\0430\0434\0430\0458\0443\045B\0438\043C \0440\0435\0434\043E\0441\043B\0435\0434\0443. \041C\043E\0436\0435\0442\0435 \0434\0430 \043D\0430\0432\0435\0434\0435\0442\0435 \0438 \043A\0430\043A\043E \0441\0435 \0440\0435\0448\0430\0432\0430\0458\0443'),
unistr('\0432\0440\0435\0434\043D\043E\0441\0442\0438 <code>NULL</code>. \041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0443\0432\0435\043A \043F\043E\043A\0430\0437\0443\0458\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 <code>NULL</code> \043F\043E\0441\043B\0435\0434\045A\0435 \0438\043B\0438 \0438\0445 \0443\0432\0435\043A \043F\0440\0438\043A\0430\0437\0443\0458\0435 \043A\0430\043E \043F\0440\0432\0435. \0420\0435\0437\0443\043B\0442\0443\0458\0443\045B\0435 \0441\043E\0440\0442\0438\0440\0430\045A\0435 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0434\0435\0441\043D\043E \043E\0434'),
unistr('\0437\0430\0433\043B\0430\0432\0459\0430 \043A\043E\043B\043E\043D\0435 \0443 \0438\0437\0432\0435\0448\0442\0430\0458\0443.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963321644402118)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0430\0434\0430 \0434\043E\0434\0430\0442\0435 \043F\0440\0435\0442\043F\043B\0430\0442\0443, \043D\0430\0432\043E\0434\0438\0442\0435 \0435-\0430\0434\0440\0435\0441\0443 (\0438\043B\0438 \0432\0438\0448\0435 \0435-\0430\0434\0440\0435\0441\0430 \0440\0430\0437\0434\0432\043E\0458\0435\043D\0438\0445 \0437\0430\0440\0435\0437\0438\043C\0430), \0442\0435\043C\0443 \0435-\043F\043E\0440\0443\043A\0435, \0443\0447\0435\0441\0442\0430\043B\043E\0441\0442 \0438 \0434\0430\0442\0443\043C\0435 \043F\043E\0447\0435\0442\043A\0430 \0438 \0437\0430\0432\0440\0448\0435\0442\043A\0430. \0422\0430\043A\043E \043D\0430\043F\0440\0430\0432\0459\0435\043D\0435 \0435-\043F\043E\0440\0443\043A\0435 \043E\0431\0443\0445\0432\0430\0442\0430\0458\0443 HTML \0432\0435\0440\0437\0438\0458\0443 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043A\043E\0458\0438 \0441\0430\0434\0440\0436\0438 \0430\043A\0442\0443\0435\043B\043D\0435 \043F\043E\0434\0430\0442\043A\0435 \0443\0437 \0443\043F\043E\0442\0440\0435')
||unistr('\0431\0443 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043A\043E\0458\0430 \0441\0443 \0431\0438\043B\0430 \043F\0440\0438\0441\0443\0442\043D\0430 \0443 \0442\0440\0435\043D\0443\0442\043A\0443 \0434\043E\0434\0430\0432\0430\045A\0430 \043F\0440\0435\0442\043F\043B\0430\0442\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981962712402132)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041C\0440\0435\0436\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0441\0443, \0443 \043E\0441\043D\043E\0432\0438, \0438\0437\0432\0435\0448\0442\0430\0458\0438 \043A\043E\0458\0438 \043C\043E\0433\0443 \0434\0430 \0441\0435 \0443\0440\0435\0452\0443\0458\0443 \0438 \043F\0440\0438\043B\0430\0433\043E\0452\0430\0432\0430\0458\0443. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \0438\0437\043C\0435\043D\0435 \0440\0430\0441\043F\043E\0440\0435\0434 \043F\043E\0434\0430\0442\0430\043A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438\0437\0431\043E\0440\043E\043C \043A\043E\043B\043E\043D\0430, \043F\0440\0438\043C\0435\043D\043E\043C \0444\0438\043B\0442\0435\0440\0430, \0438\0441\0442\0438\0446\0430\045A\0435\043C \0438 \0441\043E\0440\0442\0438\0440\0430\045A\0435\043C. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \0434\0435\0444\0438\043D\0438\0448\0443 \0438 \043F\0440\0435\043B\043E\043C\0435, \0430\0433\0440\0435\0433\0430\0446\0438\0458\0435, \0433\0440\0430\0444\0438\043A\043E\043D\0435')
||unistr(', \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0438\043C\0430 \0438 \043C\043E\0433\0443 \0434\0430 \0434\043E\0434\0430\0458\0443 \0441\0432\043E\0458\0430 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430. \041A\043E\0440\0438\0441\043D\0438\0446\0438 \043C\043E\0433\0443 \0434\0430 \043A\0440\0435\0438\0440\0430\0458\0443 \0432\0438\0448\0435 \0432\0430\0440\0438\0458\0430\0446\0438\0458\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \0434\0430 \0438\0445 \0441\0430\0447\0443\0432\0430\0458\0443 \043A\0430\043E \0438\043C\0435\043D\043E\0432\0430\043D\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435, \0437\0430 \0458\0430\0432\043D\0438 \0438\043B\0438 \043B\0438\0447\043D\0438 \043F\0440\0438\043A\0430\0437. '),
'<p/>',
unistr('\041C\0440\0435\0436\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\0440\0438\043B\0430\0433\043E\0434\0438 \043F\043E\043C\043E\045B\0443 \0442\0440\0430\043A\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443, \043C\0435\043D\0438\0458\0430 \0441\0430 \0440\0430\0434\045A\0430\043C\0430, \043C\0435\043D\0438\0458\0430 \0437\0430 \0443\043F\0440\0430\0432\0459\0430\045A\0435 \0438\043B\0438 \043C\0435\043D\0438\0458\0430 \0437\0430 \043D\0430\0441\043B\043E\0432\0435 \043A\043E\043B\043E\043D\0430.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993769949402141)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\043D\0438 \0441\0430 \0440\0430\0434\045A\0430\043C\0430 \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0441\0435 \0434\0435\0441\043D\043E \043E\0434 \0434\0443\0433\043C\0435\0442\0430 \0418\0434\0438 \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443. \041F\043E\043C\043E\045B\0443 \043E\0432\043E\0433 \043C\0435\043D\0438\0458\0430 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043C\0440\0435\0436\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982409237402133)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0440\0430\043D\0438\0446\0430 \0437\0430 \0434\043E\0434\0430\0432\0430\045A\0435/\0443\0440\0435\0452\0438\0432\0430\045A\0435 \0440\0435\0434\043E\0432\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982575544402133)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0414\0430 \0431\0438\0441\0442\0435 \0434\043E\0434\0430\043B\0438 \0440\0435\0434 \0443 \043C\0440\0435\0436\0443 \043F\043E\0434\0430\0442\0430\043A\0430, \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0414\043E\0434\0430\0458 \0440\0435\0434. \0414\0430 \0431\0438\0441\0442\0435 \0443\0440\0435\0434\0438\043B\0438 \0434\0435\0442\0430\0459\0435 \0440\0435\0434\0430, \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0438\043A\043E\043D\0443 \0437\0430 \0443\0440\0435\0452\0438\0432\0430\045A\0435 \0440\0435\0434\0430 (\043F\0440\0432\0430 \043A\043E\043B\043E\043D\0430) \0443 \0440\0435\0434\0443 \043A\043E\0458\0438 \0436\0435\043B\0438\0442\0435 \0434\0430 \0443\0440\0435\0434\0438\0442\0435. </p>'),
'',
unistr('<p>\041A\0430\0434\0430 \0443\0440\0435\0452\0443\0458\0435\0442\0435 \0440\0435\0434, \043C\043E\0436\0435\0442\0435 \0434\0430:</p>'),
'',
'<p><ul>',
unistr('<li>\0438\0437\0430\0431\0435\0440\0435\0442\0435 <strong>\0418\0437\0431\0440\0438\0448\0438</strong> \0434\0430 \0431\0438\0441\0442\0435 \0438\0437\0431\0440\0438\0441\0430\043B\0438 \0442\0430\0458 \0440\0435\0434.</li>'),
unistr('<li>\0438\0437\0430\0431\0435\0440\0435\0442\0435 <strong>\041F\0440\0438\043C\0435\043D\0438 \043F\0440\043E\043C\0435\043D\0435</strong> \043A\0430\043A\043E \0431\0438\0441\0442\0435 \0441\0430\0447\0443\0432\0430\043B\0438 \043F\0440\043E\043C\0435\043D\0435 \043A\043E\0458\0435 \0441\0442\0435 \0443\043D\0435\043B\0438 \0443 \0440\0435\0434.</li>'),
unistr('<li>\0443 \043E\043A\0432\0438\0440\0443 \043C\0435\043D\0438\0458\0430 <strong>\0420\0430\0434\045A\0435</strong>, \0434\043E\0434\0430\0458\0435\0442\0435 \0440\0435\0434, \0434\043E\0434\0430\0458\0435\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0435, \0431\0435\043B\0435\0448\043A\0435, \0432\0435\0437\0435 \0438\043B\0438 \043E\0437\043D\0430\043A\0435 \0438 \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \0438\0441\0442\043E\0440\0438\0458\0443.</li>'),
unistr('<li>\043F\0440\0435\0452\0435\0442\0435 \043D\0430 <strong>\0441\043B\0435\0434\0435\045B\0438 \0438\043B\0438 \043F\0440\0435\0442\0445\043E\0434\043D\0438</strong> \0440\0435\0434.</li>'),
unistr('<li>\0443 \043C\0435\043D\0438\0458\0443 <strong>\0423\043F\0440\0430\0432\0459\0430\045A\0435</strong>, \043F\043E\0434\0435\0441\0438\0442\0435 \0441\0432\043E\0458\0441\0442\0432\0430 \043A\043E\043B\043E\043D\0430, \0433\0440\0443\043F\0435 \043A\043E\043B\043E\043D\0430, \043F\0440\043E\0432\0435\0440\0435 \0438\0441\043F\0440\0430\0432\043D\043E\0441\0442\0438 \0438 \043B\0438\0441\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438.</li>'),
'</ul></p>',
'',
unistr('<p>\0423 \0440\0435\0433\0438\043E\043D\0443 \0437\0430 \043D\0430\043F\043E\043C\0435\043D\0435 \043D\0430 \0434\043D\0443 \0441\0442\0440\0430\043D\0438\0446\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \0441\0435 \0441\0432\0435 \0434\0430\0442\043E\0442\0435\043A\0435, \0431\0435\043B\0435\0448\043A\0435, \0432\0435\0437\0435 \0438\043B\0438 \043E\0437\043D\0430\043A\0435 \043A\043E\0458\0435 \0441\0443 \043F\043E\0432\0435\0437\0430\043D\0435 \0441\0430 \0430\043A\0442\0443\0435\043B\043D\0438\043C \0440\0435\0434\043E\043C.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993838667402141)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\0442\0438 \0441\0435 \0437\0430 \043A\0440\0435\0438\0440\0430\045A\0435 \0433\0440\0443\043F\0435 \043F\0440\0435\043B\043E\043C\0430 \043D\0430 \0458\0435\0434\043D\043E\0458 \043A\043E\043B\043E\043D\0438 \0438\043B\0438 \0432\0438\0448\0435 \045A\0438\0445. \041D\0430 \0442\0430\0458 \043D\0430\0447\0438\043D \0441\0435 \043A\043E\043B\043E\043D\0435 \0438\0437\0432\043B\0430\0447\0435 \0438\0437 \043C\0440\0435\0436\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0438 \043F\0440\0438\043A\0430\0437\0443\0458\0443 \0441\0435 \043A\0430\043E \0433\043B\0430\0432\043D\0438 \0437\0430\043F\0438\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982318525402133)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043C\043E\0433\0443\045B\0430\0432\0430 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0435 \0430\043A\0442\0443\0435\043B\043D\043E\0433 \0441\043A\0443\043F\0430 \0440\0435\0437\0443\043B\0442\0430\0442\0430. \0424\043E\0440\043C\0430\0442\0438 \0437\0430 \043F\0440\0435\0443\0437\0438\043C\0430\045A\0435 \043E\0431\0443\0445\0432\0430\0442\0430\0458\0443 CSV, HTML, \0438\043B\0438 \0435-\043F\043E\0440\0443\043A\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993936270402141)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0410\043A\043E \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043E \043C\0440\0435\0436\0438 \043F\043E\0434\0430\0442\0430\043A\0430, \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0441\0435 \043F\0440\0438\043A\0430\0437\0443\0458\0443'),
unistr('\0438\0441\043F\043E\0434 \0442\0440\0430\043A\0435 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443 \0438 \0438\0437\043D\0430\0434 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \041E\0432\0430 \043E\0431\043B\0430\0441\0442 \043C\043E\0436\0435 \0434\0430 \0441\0435 \0441\043A\0443\043F\0438 \0438 \043F\0440\043E\0448\0438\0440\0438 \043F\043E\043C\043E\045B\0443 \0438\043A\043E\043D\0435 \0441\0430 \043B\0435\0432\0435 \0441\0442\0440\0430\043D\0435.'),
'<p>',
unistr('\0417\0430 \0441\0432\0430\043A\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043C\043E\0436\0435\0442\0435 \0434\0430 \0443\0447\0438\043D\0438\0442\0435 \0441\043B\0435\0434\0435\045B\0435:'),
'</p><ul>',
unistr('<li>\0423\0440\0435\0452\0443\0458\0435\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \043A\043B\0438\043A\043E\043C \043D\0430 \0438\043C\0435.</li>'),
unistr('<li>\041E\043D\0435\043C\043E\0433\0443\045B\0438\0442\0435/\043E\043C\043E\0433\0443\045B\0438\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0443\043A\043B\0430\045A\0430\045A\0435\043C \043E\0437\043D\0430\043A\0435 \0438\0437 \043F\043E\0459\0430 \041E\043C\043E\0433\0443\045B\0438/\043E\043D\0435\043C\043E\0433\0443\045B\0438 \0438\043B\0438 \045A\0435\0433\043E\0432\0438\043C \043E\0437\043D\0430\0447\0430\0432\0430\045A\0435\043C. \041F\043E\043C\043E\045B\0443 \043E\0432\0435 \043A\043E\043D\0442\0440\043E\043B\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \043F\0440\0438\0432\0440\0435\043C\0435\043D\043E \0438\0441\043A\0459\0443\0447\0438\0442\0435 \0438 \0443\043A\0459\0443\0447\0438\0442\0435 \043D\0435\043A\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435.</li>'),
unistr('<li>\0423\043A\043B\0430\045A\0430\045A\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043A\043B\0438\043A\043E\043C \043D\0430 \0438\043A\043E\043D\0443 \0423\043A\043B\043E\043D\0438.</li>'),
'</ul>',
unistr('<p>\0410\043A\043E \0441\0442\0435 \043A\0440\0435\0438\0440\0430\043B\0438 \0433\0440\0430\0444\0438\043A\043E\043D \0438\043B\0438 \0433\0440\0443\043F\0443 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443, \043C\043E\0436\0435\0442\0435 \0434\0430 \0441\0435 \043F\0440\0435\0431\0430\0446\0443\0458\0435\0442\0435 \0441\0430 \045A\0438\0445'),
unistr('\043D\0430 \043E\0441\043D\043E\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \043F\043E\043C\043E\045B\0443 \0432\0435\0437\0430 \041F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430, \041F\0440\0438\043A\0430\0437 \0433\0440\0430\0444\0438\043A\043E\043D\0430, \041F\0440\0438\043A\0430\0437 \0433\0440\0443\043F\0438\0441\0430\045A\0430 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443'),
unistr('\043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0441\0430 \0434\0435\0441\043D\0435 \0441\0442\0440\0430\043D\0435. \0410\043A\043E \043F\0440\0435\0433\043B\0435\0434\0430\0442\0435 \0433\0440\0430\0444\0438\043A\043E\043D \0438\043B\0438 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443, \043C\043E\0436\0435\0442\0435'),
unistr('\0434\0430 \043A\043E\0440\0438\0441\0442\0438\0442\0435 \0438 \0432\0435\0437\0443 \0423\0440\0435\0434\0438 \0434\0430 \0431\0438\0441\0442\0435 \0443\0440\0435\0434\0438\043B\0438 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982269458402133)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0427\0443\0432\0430 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0438 \0440\0430\0441\043F\043E\0440\0435\0434 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043E \043C\0440\0435\0436\0438 \043F\043E\0434\0430\0442\0430\043A\0430 \0437\0430 \0431\0443\0434\0443\045B\0443 \0443\043F\043E\0442\0440\0435\0431\0443. \0412\0438 \043D\0430\0432\043E\0434\0438\0442\0435 \0438\043C\0435 \0438 \043E\043F\0446\0438\043E\043D\0430\043B\043D\0438 \043E\043F\0438\0441. \041C\043E\0436\0435\0442\0435 \0434\0430 \0441\0430\0447\0443\0432\0430\0442\0435 \0442\0440\0438 \0442\0438\043F\0430 \0440\0430\0441\043F\043E\0440\0435\0434\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043E \043C\0440\0435\0436\0438 \043F\043E\0434\0430\0442\0430\043A\0430:</p>'),
'<ul>',
unistr('<li><strong>\041F\0440\0438\043C\0430\0440\043D\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E</strong> (\0441\0430\043C\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440). \041F\0440\0438\043C\0430\0440\043D\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E \0458\0435 \0440\0430\0441\043F\043E\0440\0435\0434 \043A\043E\0458\0438 \0441\0435 \043F\0440\0432\043E\0431\0438\0442\043D\043E \043F\0440\0438\043A\0430\0437\0443\0458\0435. \041F\0440\0438\043C\0430\0440\043D\0438 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458\0438 \043D\0435 \043C\043E\0433\0443 \0434\0430 \0441\0435 \043F\0440\0435\0438\043C\0435\043D\0443\0458\0443 \0438\043B\0438 \0438\0437\0431\0440\0438\0448\0443.</li>'),
unistr('<li><strong>\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458</strong> (\0441\0430\043C\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440). \041E\043C\043E\0433\0443\045B\0430\0432\0430 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0438\043C\0430 \0434\0430 \043A\0440\0435\0438\0440\0430\0458\0443 \0432\0438\0448\0435 \0440\0430\0441\043F\043E\0440\0435\0434\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430. \0421\0430\043C\043E \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0438 \043C\043E\0433\0443 \0434\0430 \0441\0430\0447\0443\0432\0430\0458\0443, , \043F\0440\0435\0438\043C\0435\043D\0443\0458\0443 \0438\043B\0438 \0438\0437\0431\0440\0438\0448\0443 \0430\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458.</li>'),
unistr('<li><strong>\041F\0440\0438\0432\0430\0442\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458</strong> (\0441\0432\0438 \043A\043E\0440\0438\0441\043D\0438\0446\0438). \041A\043E\0440\0438\0441\043D\0438\043A \043A\043E\0458\0438 \0458\0435 \043A\0440\0435\0438\0440\0430\043E \0440\0430\0441\043F\043E\0440\0435\0434 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043C\043E\0436\0435 \0434\0430 \043F\0440\0435\0433\043B\0435\0434\0430, \0441\0430\0447\0443\0432\0430, \043F\0440\0435\0438\043C\0435\043D\0443\0458\0435 \0438\043B\0438 \0438\0437\0431\0440\0438\0448\0435 \0442\0430\0458 \0438\0437\0432\0435\0448\0442\0430\0458.</li>'),
'</ul>',
unistr('<p>\0410\043A\043E \0441\0430\0447\0443\0432\0430\0442\0435 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0435, \043D\0430 \0442\0440\0430\0446\0438 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443, \0441\0430 \043B\0435\0432\0435 \0441\0442\0440\0430\043D\0435 \0431\0438\0440\0430\0447\0430 \0440\0435\0434\043E\0432\0430, \043F\0440\0438\043A\0430\0437\0443\0458\0435 \0441\0435 \0431\0438\0440\0430\0447 \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0435 (\0430\043A\043E \0458\0435 \043E\0432\0430 \0444\0443\043D\043A\0446\0438\0458\0430 \043E\043C\043E\0433\0443\045B\0435\043D\0430).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908393047402075)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\043A\0440\0438\0458 \043A\043E\043B\043E\043D\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898960540402068)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\0442\0430\043A\043D\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909893676402076)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\0442\0430\043A\043D\0443\0442\0435 \0441\0442\0430\0432\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914976723402080)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0441\0442\0438\0446\0430\045A\0435 \0443\0441\043B\043E\0432\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963945630402118)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0438\043B \0438\0441\0442\0438\0446\0430\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873959906402048)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0438\0441\0442\0430\043A\043D\0443\0442\0435 \0441\0442\0430\0432\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983453950402134)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0425\043E\0440\0438\0437\043E\043D\0442\0430\043B\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013093052402156)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'sr'
,p_message_text=>unistr('1 \043D\0435\0430\043A\0442\0438\0432\043D\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013199783402157)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0430\043A\0442\0438\0432\043D\0438\0445 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904952938402073)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B \0437\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915999805402081)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909326466402076)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0438\0437\0440\0430\0437 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868704551402044)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0430\0458\045A\0438 \0434\0430\0442\0443\043C \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0432\0435\045B\0438 \043E\0434 \043F\043E\0447\0435\0442\043D\043E\0433 \0434\0430\0442\0443\043C\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923640650402087)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0438\0437\0440\0430\0437 \0444\0438\043B\0442\0435\0440\0430. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991457624402140)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0443\043F\0438\0442 \0437\0430 \0444\0438\043B\0442\0435\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013214859402157)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'sr'
,p_message_text=>unistr('1 \043D\0435\0432\0430\0436\0435\045B\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013351338402157)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438\0445 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964127101402119)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('(\0443 \043C\0438\043D\0443\0442\0438\043C\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981191428402132)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981318395402132)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0458\0435 \0443 \0441\043B\0435\0434\0435\045B\0438\0445 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981277225402132)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0443 \043F\043E\0441\043B\0435\0434\045A\0438\0445 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981455648402132)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0438\0458\0435 \0443 \0441\043B\0435\0434\0435\045B\0438\0445 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914067252402080)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0430\0441\0442\0430\0442\0443\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880197868402053)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907965757402075)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0437\0430 \043E\0437\043D\0430\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900485859402069)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\0438 \0434\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900605615402069)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438 \0441\0430\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900186954402069)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0438 \043C\0435\0441\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900264564402069)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0430 \043D\0435\0434\0435\0459\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900307371402069)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900571922402069)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0441\0430\0442\0438 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899908798402069)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0441\043B\0435\0434\045A\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900075474402069)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\043B\0430 \0433\043E\0434\0438\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880045531402053)
,p_name=>'APEXIR_LINE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\043D\0438\0458\0441\043A\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876859082402051)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\043D\0438\0458\0441\043A\0438 \0441\0430 \043F\043E\0432\0440\0448\0438\043D\043E\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991353405402139)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043F\0438\0440\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908829424402076)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\045A\0443\0458\0435 \0441\0435 \0434\0430 \045B\0435 \0443\043F\0438\0442 \043F\0440\0435\043C\0430\0448\0438\0442\0438 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0435 \0434\043E\0437\0432\043E\0459\0435\043D\0435 \0440\0435\0441\0443\0440\0441\0435. \0418\0437\043C\0435\043D\0438\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0438 \043F\043E\043A\0443\0448\0430\0458\0442\0435 \043F\043E\043D\043E\0432\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891051951402062)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0437\0430 \043E\0432\0430\0458 \0438\0437\0432\0435\0448\0442\0430\0458 \0458\0435 %0. \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\0442\0435\0440 \0434\0430 \0431\0438\0441\0442\0435 \0441\043C\0430\045A\0438\043B\0438 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \0443 \0443\043F\0438\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991972213402140)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0443\043C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992104504402140)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0440\0435\0434\045A\0430 \0432\0440\0435\0434\043D\043E\0441\0442 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895041831402065)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992035382402140)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0443\043C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991056141402139)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\0441\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964501339402119)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\0441\0435\0447\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907184091402074)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907018397402074)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438 \0441\0432\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018255579402161)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0442\0438\0447\043A\0438 ID \0440\0435\0433\0438\043E\043D\0430 \043C\043E\0440\0430 \0434\0430 \0441\0435 \043D\0430\0432\0435\0434\0435 \0458\0435\0440 \0441\0442\0440\0430\043D\0438\0446\0430 \0441\0430\0434\0440\0436\0438 \0432\0438\0448\0435 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438\0445 \0438\0437\0432\0435\0448\0442\0430\0458\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875566468402050)
,p_name=>'APEXIR_NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902908174402071)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\043E\0432\0430 \0430\0433\0440\0435\0433\0430\0446\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013960061402157)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\043E\0432\0430 \043A\0430\0442\0435\0433\043E\0440\0438\0458\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114903048403402071)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\043E\0432\043E \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897828389402067)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900985665402070)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \0434\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900717966402069)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \0441\0430\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901263032402070)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \043C\0435\0441\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901111936402070)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0430 \043D\0435\0434\0435\0459\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901071731402070)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0434\0430\043D\0430 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114900895088402070)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0441\0430\0442\0438 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901497331402070)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438\0445 \043D\0435\043A\043E\043B\0438\043A\043E \0433\043E\0434\0438\043D\0430 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901379990402070)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0430 \0433\043E\0434\0438\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875800100402050)
,p_name=>'APEXIR_NO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916141395402081)
,p_name=>'APEXIR_NONE'
,p_message_language=>'sr'
,p_message_text=>unistr('-\041D\0438\0458\0435\0434\043D\043E-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963762892402118)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \0432\0430\0436\0435\045B\0430 \0435-\0430\0434\0440\0435\0441\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912614944402079)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442\0438 null \0443\0432\0435\043A \043D\0430 \043F\043E\0447\0435\0442\043A\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912520590402079)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442\0438 null \0443\0432\0435\043A \043D\0430 \043A\0440\0430\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913088978402079)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\045A\0435 \0437\0430 null %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909415822402076)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\043C\0435 \0432\0440\0430\045B\0430\045A\0430 \0443 \043F\0440\043E\0448\043B\043E\0441\0442 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0438\0437\0440\0430\0436\0435\043D\043E \0431\0440\043E\0458\0435\0432\0438\043C\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909036306402076)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0437 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043D\0443\043C\0435\0440\0438\0447\043A\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913526294402079)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0435\0440\0430\0442\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874416755402049)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0430\0440\0430\043D\045F\0430\0441\0442\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983366183402133)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0440\0438\0458\0435\043D\0442\0430\0446\0438\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876346977402050)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0441\0442\0430\043B\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859163466402037)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0440\0438\0458\0435\043D\0442\0430\0446\0438\0458\0430 \0441\0442\0440\0430\043D\0438\0446\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859881612402037)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043B\043E\0436\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859985498402037)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0441\043F\0440\0430\0432\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859012379402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\043B\0438\0447\0438\043D\0430 \0441\0442\0440\0430\043D\0438\0446\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859696026402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'sr'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859526182402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'sr'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859783634402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043B\0430\0433\043E\0452\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859343563402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'sr'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859286425402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'sr'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114859495069402037)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'sr'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992431167402140)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0430\0442 \0443\043A\0443\043F\043D\043E\0433 \0431\0440\043E\0458\0430 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991630742402140)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0430\0442 \0443\043A\0443\043F\043D\043E\0433 \0437\0431\0438\0440\0430 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990645400402139)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0430\0442 \0443\043A\0443\043F\043D\043E\0433 \0431\0440\043E\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990589068402139)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0430\0442 \0443\043A\0443\043F\043D\043E\0433 \0437\0431\0438\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879995982402053)
,p_name=>'APEXIR_PIE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0443\0436\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939876411402100)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0438\0432\043E\0442')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941385535402101)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0440\0435\0431\043D\043E \0458\0435 \043D\0430\0432\0435\0441\0442\0438 \0430\0433\0440\0435\0433\0430\0446\0438\0458\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941567757402101)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \0430\0433\0440\0435\0433\0438\0440\0430\0442\0435 \043D\0430 \0438\0437\0430\0431\0440\0430\043D\043E\0458 \043A\043E\043B\043E\043D\0438 \043A\0430\043E \043D\0430 \043A\043E\043B\043E\043D\0438 \0440\0435\0434\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940792942402100)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940595374402100)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941186034402101)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0440\0435\0431\043D\043E \0458\0435 \043D\0430\0432\0435\0441\0442\0438 \043F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841206338402023)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0437\0430 \043F\0438\0432\043E\0442 \0443\043F\0438\0442 \043E\0433\0440\0430\043D\0438\0447\0430\0432\0430 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443, \043D\0435 \0438 \0431\0440\043E\0458 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430. \0412\0430\0448 \043E\0441\043D\043E\0432\043D\0438 \0443\043F\0438\0442 \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 (%0). \041F\0440\0438\043C\0435\043D\0438\0442\0435 \0444\0438\043B\0442\0435\0440 \0434\0430 \0431\0438\0441\0442\0435 \0441\043C\0430\045A\0438\043B\0438 \0431\0440\043E\0458 \0437\0430\043F\0438\0441\0430 \0443 \043E\0441\043D\043E\0432\043D\043E\043C \0443\043F\0438\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941056587402101)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\045A\0435 \043F\0438\0432\043E\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910448533402077)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0430 \0441\0430\0434\0440\0436\0438 \043F\0440\0435\0432\0438\0448\0435 \0441\043F\0435\0446\0438\0458\0430\043B\043D\0438\0445 \0432\0440\0435\0434\043D\043E\0441\0442\0438 - \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0433\0435\043D\0435\0440\0438\0441\0430\0442\0438 SQL \0437\0430 \043F\0438\0432\043E\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963838699402118)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0433\043B\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897976233402067)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114989542926402138)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\0440\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964836562402119)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\0440\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858961901402037)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0443\0445\0432\0430\0442\0438 \043E\0437\043D\0430\043A\0435 \043F\0440\0438\0441\0442\0443\043F\0430\0447\043D\043E\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845877478402026)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \043E\0431\043E\0433\0430\045B\0435\043D\0438 \0442\0435\043A\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922642168402086)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0432\0430\0442\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880524035402054)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0430\0432\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876114967402050)
,p_name=>'APEXIR_RED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0446\0440\0432\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018124371402160)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0442\0438\0447\043A\0438 ID \0440\0435\0433\0438\043E\043D\0430 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907249480402075)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907335393402075)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0441\0432\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013404766402157)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0433\0440\0430\0444\0438\043A\043E\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906860012402074)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \043A\043E\043D\0442\0440\043E\043B\043D\0438 \043F\0440\0435\043B\043E\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906562194402074)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0444\0438\043B\0442\0435\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906648844402074)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0432\0440\0430\045B\0430\045A\0435 \0443 \043F\0440\043E\0448\043B\043E\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013500844402157)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\043E \0435\043B\0435\043C\0435\043D\0442\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906941191402074)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0438\0441\0442\0438\0446\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013600340402157)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \043F\0438\0432\043E\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994606437402142)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\043B\043E\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975247761402127)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0438\043C\0435\043D\0443\0458 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916450444402082)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0438\043C\0435\043D\0443\0458 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898245162402067)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992520900402140)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872764221402047)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \043F\043E\0441\0442\043E\0458\0438 \0441\0430\0447\0443\0432\0430\043D\0438 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0441\0430 \0430\043B\0438\0458\0430\0441\043E\043C %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922969454402087)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872851419402048)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \043F\043E\0441\0442\043E\0458\0438 \0441\0430\0447\0443\0432\0430\043D\0438 ID \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433 \0438\0437\0432\0435\0448\0442\0430\0458\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114914766404402080)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895573598402065)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899428298402068)
,p_name=>'APEXIR_RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880716987402054)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\0442\0438\0442\0435 \0438\0437\0432\0435\0448\0442\0430\0458 \043D\0430 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875987175402050)
,p_name=>'APEXIR_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988642584402137)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \043C\043E\0436\0435\0442\0435 \0434\0430 \043A\043E\0440\0438\0441\0442\0438\0442\0435 ROWID \043A\0430\043E \043F\0440\0438\043C\0430\0440\043D\0443 \043A\043E\043B\043E\043D\0443 \043A\0459\0443\0447\0430 \0437\0430 REST \0438\0437\0432\043E\0440 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905939322402074)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434\043E\0432\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965531791402120)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0435\0434\043E\0432\0430 \043F\043E \0441\0442\0440\0430\043D\0438\0446\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940858484402101)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0435 \0440\0435\0434\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940619476402100)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 \0440\0435\0434\0430 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941213646402101)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0440\0435\0431\043D\043E \0458\0435 \043D\0430\0432\0435\0441\0442\0438 \043A\043E\043B\043E\043D\0443 \0440\0435\0434\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941426707402101)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 \0440\0435\0434\0430 \043C\043E\0440\0430 \0434\0430 \0441\0435 \0440\0430\0437\043B\0438\043A\0443\0458\0435 \043E\0434 \043F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920087840402084)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0438\043B\0442\0435\0440 \0440\0435\0434\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895631416402065)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434 %0 \043E\0434 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899626750402069)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043A\0441\0442 \0440\0435\0434\0430 \0441\0430\0434\0440\0436\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875220074402049)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910006316402077)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909906392402077)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912123185402078)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0435\043D\0443\0442\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \045B\0435 \0441\0435 \043A\043E\0440\0438\0441\0442\0438\0442\0438 \043A\0430\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0430 \0437\0430 \0441\0432\0435 \043A\043E\0440\0438\0441\043D\0438\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114975187210402127)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114899398227402068)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458 \0438\0437\0432\0435\0448\0442\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013858139402157)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458 \0438\0437\0432\0435\0448\0442\0430\0458 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966544034402120)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114904831871402073)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0430\043A\0430 \0437\0430 \043F\0440\0435\0442\0440\0430\0433\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115013778816402157)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972079738402125)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 \043E \043F\0440\0435\0442\0440\0430\0437\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956083828402112)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0440\0430\043D\0435 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876948003402051)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0443 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898651329402068)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043A\043E\043B\043E\043D\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880494553402053)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 \0444\0443\043D\043A\0446\0438\0458\0443 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905666014402073)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 \0433\0440\0443\043F\0438\0441\0430\045A\0435 \043F\0440\0435\043C\0430 \043A\043E\043B\043E\043D\0438 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940311745402100)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 \043F\0438\0432\043E\0442 \043A\043E\043B\043E\043D\0443 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991542530402140)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0440\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940475520402100)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('- \0418\0437\0430\0431\0435\0440\0438\0442\0435 \0440\0435\0434 \043A\043E\043B\043E\043D\0435 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849151495402029)
,p_name=>'APEXIR_SEND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855412416402034)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0430\0459\0438 \0435-\043F\043E\0448\0442\043E\043C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875613593402050)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434\043E\0441\043B\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898824712402068)
,p_name=>'APEXIR_SORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908125216402075)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \0440\0430\0441\0442\0443\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908276831402075)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \043E\043F\0430\0434\0430\0458\0443\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994034426402142)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434\043E\0441\043B\0435\0434 \0441\043E\0440\0442\0438\0440\0430\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902647938402071)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0440\0430\0437\043C\0430\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913759559402079)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0442\0443\0441 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964216414402119)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\043F\043B\0430\0442\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990904697402139)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0432\0440\0448\0430\0432\0430 \0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845384439402026)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0441\043A\043E\0447\0438 \0430\043A\043E \043D\0435\043C\0430 \043F\0440\043E\043D\0430\0452\0435\043D\0438\0445 \043F\043E\0434\0430\0442\0430\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114990806234402139)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0432\0448\0438 \043E\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991700668402140)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0431\0438\0440 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981707001402132)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0433\0438\043E\043D = %0, \0418\0437\0432\0435\0448\0442\0430\0458 = %1, \041F\0440\0438\043A\0430\0437 = %2, \041F\043E\0447\0435\0442\0430\043A \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430 = %3, \041A\0440\0430\0458 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430 = %4, \0423\043A\0443\043F\0430\043D \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430 = %5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902300198402071)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0433\0438\043E\043D = %0, \0418\0437\0432\0435\0448\0442\0430\0458 = %1, \041F\0440\0438\043A\0430\0437 = %2, \041F\043E\0447\0435\0442\0430\043A \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430 = %3, \041A\0440\0430\0458 \043F\0440\0438\043A\0430\0437\0430\043D\0438\0445 \0440\0435\0434\043E\0432\0430 = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874599320402049)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\043E\0458\0430 \0442\0435\043A\0441\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891651418402062)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0434\0430\043D(\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891582402402062)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891454925402062)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891804609402062)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0435\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891797289402062)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114891982078402063)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0433\043E\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114994425998402142)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0459\0443\0447\0438/\0438\0441\043A\0459\0443\0447\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907472451402075)
,p_name=>'APEXIR_TOP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0445')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987650215402137)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0437\0433\0440\0443\043F\0438\0441\0430\043D\0430 \043A\043E\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908984682402076)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0437\0438\0432 \0438\0441\0442\0430\043A\043D\0443\0442\0435 \0441\0442\0430\0432\043A\0435 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879263251402053)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435\043F\043E\0434\0440\0436\0430\043D\0438 \0442\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907557174402075)
,p_name=>'APEXIR_UP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\043E\0440\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909140923402076)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043D\0435\0441\0438\0442\0435 \0432\0430\0436\0435\045B\0443 \0431\043E\0458\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909240444402076)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043D\0435\0441\0438\0442\0435 \0432\0430\0436\0435\045B\0443 \043C\0430\0441\043A\0443 \0444\043E\0440\043C\0430\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114876446376402050)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114908032781402075)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432 \043E\0441\0435 \0437\0430 \0432\0440\0435\0434\043D\043E\0441\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915808157402081)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \0458\0435 \043E\0431\0430\0432\0435\0437\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879891866402053)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\0440\0442\0438\043A\0430\043B\043D\0430 \043A\043E\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114983571610402134)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\0440\0442\0438\043A\0430\043B\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915144260402081)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0433\0440\0430\0444\0438\043A\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970306816402123)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0434\0435\0442\0430\0459')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115015965740402159)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 %0 \043D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970437302402124)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0433\0440\0443\043F\0443 \043F\0440\0435\043C\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970234312402123)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0438\043A\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940119334402100)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \043F\0438\0432\043E\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114915243776402081)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964487723402119)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0434\0435\0459\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898109945402067)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993125541402141)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0434\0430\043D(\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993068039402141)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114992992490402141)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993312720402141)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0435\0441.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993201602402141)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114993436388402141)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0433\043E\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114991159003402139)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\043E\0434\0438\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114874295520402049)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0436\0443\0442\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114875738514402050)
,p_name=>'APEXIR_YES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114907842541402075)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0430\0434\0440\0436\0438 < \0438\043B\0438 >, \0448\0442\043E \0441\0443 \043D\0435\0432\0430\0436\0435\045B\0438 \0437\043D\0430\043A\043E\0432\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114930698003402093)
,p_name=>'APEX_REGION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0433\0438\043E\043D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114858845000402037)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'sr'
,p_message_text=>unistr('API \043F\0440\0435\0434\0443\0441\043B\043E\0432 \0458\0435 \043F\0440\0435\043A\0440\0448\0435\043D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878338189402052)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\0440\0435\0443\0437\0435\0442\0438 \0432\0440\0435\0434\043D\043E\0441\0442 \0437\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 %0 \0458\0435\0440 \0441\0443 \043F\043E\0432\0435\0437\0430\043D\0435 \043E\043F\0446\0438\0458\0435 \0432\0435\0440\0437\0438\0458\0435 \043E\043D\0435\043C\043E\0433\0443\045B\0435\043D\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878206200402052)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\043E\0434\0435\0441\0438\0442\0438 \0432\0440\0435\0434\043D\043E\0441\0442 \0437\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 %0 \0458\0435\0440 \0441\0443 \043F\043E\0432\0435\0437\0430\043D\0435 \043E\043F\0446\0438\0458\0435 \0432\0435\0440\0437\0438\0458\0435 \043E\043D\0435\043C\043E\0433\0443\045B\0435\043D\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985984055402135)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \0437\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 %0 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114985841757402135)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0445\0442\0435\0432\0430\043D\043E \043F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 %0 \043D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986040939402136)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0448\0430\0432\0430\045A\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 %0 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\043E\0434\0435\0441\0438 \043D\0430 \0432\0440\0435\0434\043D\043E\0441\0442 null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866993395402043)
,p_name=>'BACK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0437\0430\0434')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853935696402033)
,p_name=>'BUILDER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0433\0440\0430\043C \0437\0430 \0438\0437\0440\0430\0434\0443')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918068078402083)
,p_name=>'BUTTON LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430 \0434\0443\0433\043C\0435\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853038226402032)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\0433\043C\0435 CSS \043A\043B\0430\0441\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882220154402055)
,p_name=>'BUTTON_ID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0435\043D\0435\0440\0438\0441\0430\043D\0438 ID \0434\0443\0433\043C\0435\0442\0430 \045B\0435 \0431\0438\0442\0438 \0438\043B\0438 \0441\0442\0430\0442\0438\0447\043A\0438 ID \0434\0443\0433\043C\0435\0442\0430, \0430\043A\043E \0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D, \0438\043B\0438, \0430\043A\043E \043D\0438\0458\0435, \0431\0438\045B\0435 \0438\043D\0442\0435\0440\043D\043E \0433\0435\043D\0435\0440\0438\0441\0430\043D ID \0443 \0444\043E\0440\043C\0430\0442\0443 ''B'' || [\0418\043D\0442\0435\0440\043D\0438 ID \0434\0443\0433\043C\0435\0442\0430]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845713666402026)
,p_name=>'CANDLESTICK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0432\0435\045B\045A\0430\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927219584402090)
,p_name=>'CENTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0440\0435\0434\0438\043D\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877291180402051)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0437\0430\0445\0442\0435\0432')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868697199402044)
,p_name=>'CHECK$'
,p_message_language=>'sr'
,p_message_text=>unistr('\0431\0438\0440\0430\0447 \0440\0435\0434\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114987780289402137)
,p_name=>'CHECKED'
,p_message_language=>'sr'
,p_message_text=>unistr('\043E\0437\043D\0430\0447\0435\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963293338402118)
,p_name=>'COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923731245402087)
,p_name=>'COMMENTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\043F\043E\043C\0435\043D\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905207856402073)
,p_name=>'CONTINUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\0442\0430\0432\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867291139402043)
,p_name=>'COPYRIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('Copyright &copy; %0. \0421\0432\0430 \043F\0440\0430\0432\0430 \0437\0430\0434\0440\0436\0430\043D\0430.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910943624402077)
,p_name=>'COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917657996402082)
,p_name=>'CREATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0435\0438\0440\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969924988402123)
,p_name=>'CREATED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0440\0435\0438\0440\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970065029402123)
,p_name=>'CREATED_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0443\0442\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894825483402065)
,p_name=>'CREATED_ON'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C \043A\0440\0435\0438\0440\0430\045A\0430')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905479930402073)
,p_name=>'CUSTOM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043B\0430\0433\043E\0452\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916658613402082)
,p_name=>'CUSTOMIZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043B\0430\0433\043E\0434\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918222653402083)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\043E\0432\0430\045A\0435 \0436\0435\0459\0435\043D\0438\0445 \043E\043F\0446\0438\0458\0430 \0441\0442\0440\0430\043D\0438\0446\0435 \0437\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918348113402083)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\043C\0435\045A\0435\043D\0435 \0441\0443 \0436\0435\0459\0435\043D\0435 \043E\043F\0446\0438\0458\0435 \0437\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918154348402083)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\043E\0432\0430\045A\0435 \0436\0435\0459\0435\043D\0438\0445 \043E\043F\0446\0438\0458\0430 \0441\0442\0440\0430\043D\0438\0446\0435 \0437\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430 %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881918944402055)
,p_name=>'DAILY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043D\0435\0432\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114853526931402032)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\043F\0440\0435\043C\0459\0435\043D\0430 \0434\0430\0442\043E\0442\0435\043A\0430 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0430 \0438\043B\0438 \0438\043C\0430 \043F\043E\0433\0440\0435\0448\043D\0443 \043E\0437\043D\0430\043A\0443 \0442\0438\043F\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877471353402051)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\043E\0442\0440\0435\0431\0459\0435\043D \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0438 \0431\0438\0440\0430\0447 \0437\0430 XML \0438\043B\0438 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846740017402027)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0444\0438\043B \043F\043E\0434\0430\0442\0430\043A\0430 \0438 \043E\0442\043F\0440\0435\043C\0459\0435\043D\0430 \0434\0430\0442\043E\0442\0435\043A\0430 \043D\0435 \0441\0430\0434\0440\0436\0435 \043A\043E\043B\043E\043D\0435 \0446\0438\0459\043D\0435 \0434\0430\0442\043E\0442\0435\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932492435402094)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438 \043F\043E\0434\0430\0446\0438 \0443 \043E\0442\043F\0440\0435\043C\0459\0435\043D\043E\0458 \0434\0430\0442\043E\0442\0435\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932573672402094)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438 \043F\043E\0434\0430\0446\0438 \0443 \0440\0430\0434\043D\043E\043C \043B\0438\0441\0442\0443 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114852339573402032)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D\0430 \0434\0430\0442\043E\0442\0435\043A\0430 \043D\0438\0458\0435 XLSX \0434\0430\0442\043E\0442\0435\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114842737590402024)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0432\0440\0448\0435\043D\043E \0458\0435 \0443\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430: \0431\0440\043E\0458 \043E\0431\0440\0430\0452\0435\043D\0438\0445 \0440\0435\0434\043E\0432\0430 \0458\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843973621402025)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \0434\043E\0432\0440\0448\0435\043D\043E: \0440\0435\0434\043E\0432\0438 (%0) \0441\0443 \043E\0431\0440\0430\0452\0435\043D\0438 \0441\0430 1 \0433\0440\0435\0448\043A\043E\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844272189402025)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \0434\043E\0432\0440\0448\0435\043D\043E: \0440\0435\0434\043E\0432\0438 (%0) \0441\0443 \043E\0431\0440\0430\0452\0435\043D\0438 \0441\0430 \0432\0438\0448\0435 \0433\0440\0435\0448\0430\043A\0430 (%1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844036684402025)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0432\0440\0448\0435\043D\043E \0458\0435 \0443\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430: \043E\0431\0440\0430\0452\0435\043D \0458\0435 1 \0440\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847051210402027)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \0437\0430\0432\0440\0448\0435\043D\043E: 1 \0440\0435\0434 \0458\0435 \043E\0431\0440\0430\0452\0435\043D \0441\0430 \0433\0440\0435\0448\043A\043E\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844103789402025)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \0437\0430\0432\0440\0448\0435\043D\043E: 1 \0440\0435\0434 \0458\0435 \043E\0431\0440\0430\0452\0435\043D \0431\0435\0437 \0433\0440\0435\0448\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937725773402098)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0426\0438\0459\043D\0430 \043A\043E\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937865634402098)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\043E\0440\043D\0430 \043A\043E\043B\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938668187402099)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \0434\0430\0442\0443\043C\0430/\0432\0440\0435\043C\0435\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002031124402148)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0443\0437\0438\043C\0430\045A\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0437\0430 \0442\0440\0430\0436\0435\045A\0435 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114970574318402124)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0430\0446\0438 / \043C\0430\043F\0438\0440\0430\045A\0435 \0442\0430\0431\0435\043B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938785992402099)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934259211402095)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0430\0432\0438\043B\043E \0442\0440\0430\043D\0441\0444\043E\0440\043C\0430\0446\0438\0458\0435 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910571850402077)
,p_name=>'DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884628929402057)
,p_name=>'DAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0434\0430\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884715480402057)
,p_name=>'DAYS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0434\0430\043D(\0430)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923464023402087)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0442\043A\043B\0430\045A\0430\045A\0435 \0433\0440\0435\0448\0430\043A\0430 \043D\0438\0458\0435 \043E\043C\043E\0433\0443\045B\0435\043D\043E \0437\0430 \043E\0432\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114972271261402125)
,p_name=>'DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885452647402057)
,p_name=>'DELETE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0438\0437\0431\0440\0438\0448\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114845626909402026)
,p_name=>'DIAL_PCT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0438\0440\0430\045A\0435 (\043F\0440\043E\0446\0435\043D\0430\0442)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860177110402038)
,p_name=>'DOWNLOAD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0443\0437\043C\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971350494402124)
,p_name=>'DUP_USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\043F\043B\0438\043A\0430\0442 \043A\043E\0440\0438\0441\043D\0438\0447\043A\043E\0433 \0438\043C\0435\043D\0430 \043D\0430 \043B\0438\0441\0442\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867747969402044)
,p_name=>'EDIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877145578402051)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\0430\0434\0440\0435\0441\0430 "%0" \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862260513402039)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0448\0438\0459\0430\043B\0430\0446 \043E\0432\0435 \0435-\043F\043E\0440\0443\043A\0435 \0458\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971530746402124)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\0430\0434\0440\0435\0441\0430 \0458\0435 \043F\0440\0435\0434\0443\0433\0430\0447\043A\0430. \041E\0433\0440\0430\043D\0438\0447\0435\045A\0435 \0458\0435 240 \0437\043D\0430\043A\043E\0432\0430.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905111849402073)
,p_name=>'ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934354697402095)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\043E\0434\0435\0441\0438\0442\0438 \0432\0440\0435\0434\043D\043E\0441\0442 \0438\0437\0432\043E\0440\0430 \0441\0442\0430\0432\043A\0435 \0441\0442\0440\0430\043D\0438\0446\0435 \0437\0430 \0440\0435\0433\0438\043E\043D \0441\0430 \043F\0430\0440\0446\0438\0458\0430\043B\043D\0438\043C \043E\0441\0432\0435\0436\0430\0432\0430\045A\0435\043C \0441\0442\0440\0430\043D\0438\0446\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896675425402066)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0443\0442\043E\0440')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862547222402039)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \0458\0435 \0438\0441\0442\0435\043A\043B\0430')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114856698453402035)
,p_name=>'FILE_EMPTY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\043E\0442\0435\043A\0430 \0458\0435 \043F\0440\0430\0437\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936848887402097)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\043B\0438\0447\0438\043D\0430 \043E\0442\043F\0440\0435\043C\0459\0435\043D\0435 \0434\0430\0442\043E\0442\0435\043A\0435 \0458\0435 \0431\0438\043B\0430 \0432\0435\045B\0430 \043E\0434 %0 MB. \041E\0442\043F\0440\0435\043C\0438\0442\0435 \043C\0430\045A\0443 \0434\0430\0442\043E\0442\0435\043A\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864688913402041)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0432\0440\0434\0430 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\0430 \0438 \0458\0435\0434\043D\0430 \0438\043B\0438 \0432\0438\0448\0435 \0434\0430\0442\043E\0442\0435\043A\0430 \043D\0438\0441\0443 \043E\0442\043F\0440\0435\043C\0459\0435\043D\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864727156402041)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430 \0438\043D\0441\0442\0430\043D\0446\0430 \043D\0435 \0434\043E\0437\0432\043E\0459\0430\0432\0430 \043D\0435\043E\0432\043B\0430\0448\045B\0435\043D\0438\043C \043A\043E\0440\0438\0441\043D\0438\0446\0438\043C\0430 \0434\0430 \043E\0442\043F\0440\0435\043C\0430\0458\0443 \0434\0430\0442\043E\0442\0435\043A\0435.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917787634402083)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E 1 \0433\0440\0435\0448\043A\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916932231402082)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\0430\043A\0430 (%0)')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867166643402043)
,p_name=>'FORM_OF'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043E\0434 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901883089402070)
,p_name=>'GO'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0434\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001600733402147)
,p_name=>'HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043C\043E\045B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854096041402033)
,p_name=>'HOME'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0447\0435\0442\0430\043A')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884428033402057)
,p_name=>'HOUR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884527315402057)
,p_name=>'HOURS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0447.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868558200402044)
,p_name=>'ICON'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043A\043E\043D\0430 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918537951402083)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \043A\0440\0435\0434\0435\043D\0446\0438\0458\0430\043B\0438 \0437\0430 \043F\0440\0438\0458\0430\0432\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115018022753402160)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \0437\0430 \043F\0430\0440\0430\043C\0435\0442\0430\0440: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913223831402079)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0430\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0430 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913366814402079)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0430\043E \0438\043C\0435\043D\043E\0432\0430\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895795298402066)
,p_name=>'IR_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 - \0433\0440\0435\0448\043A\0430. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895421336402065)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0438\0437\0440\0430\0447\0443\043D\0430\0442\0438 \043D\0430\0432\0438\0433\0430\0446\0438\0458\0443 \043E\0431\0440\0430\0441\0446\0435\043C. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873014341402048)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872424779402047)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\043B\0430\0441\0442 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\043E\0433 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 %0, \0441\0442\0440\0430\043D\0438\0446\0438 %1 \0438 \0440\0435\0433\0438\043E\043D\0443 %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114913196032402079)
,p_name=>'IR_STAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437\0443\0458\0435 \0441\0435 \0441\0430\043C\043E \0437\0430 \043F\0440\043E\0433\0440\0430\043C\0435\0440\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901509091402070)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430 \0443\043F\0438\0442 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043F\043E\0442\0440\0435\0431\0430\043D \0458\0435 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\0438 \043A\0459\0443\0447 \0440\0430\0434\0438 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0458\0435 \0441\0432\0430\043A\043E\0433 \0440\0435\0434\0430. \0418\0441\043F\043E\0440\0443\0447\0435\043D\0438 \043A\0459\0443\0447 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\0440\0438\0441\0442\0438 \0437\0430 \043E\0432\0430\0458 \0443\043F\0438\0442. \0414\0435\0444\0438\043D\0438\0448\0438\0442\0435 \043A\043E\043B\043E\043D\0443 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E\0433 \043A\0459\0443\0447\0430. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901685009402070)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430 \0443\043F\0438\0442 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043F\043E\0442\0440\0435\0431\0430\043D \0458\0435 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\0438 \043A\0459\0443\0447 \0440\0430\0434\0438 \0438\0434\0435\043D\0442\0438\0444\0438\043A\0430\0446\0438\0458\0435 \0441\0432\0430\043A\043E\0433 \0440\0435\0434\0430. \0418\0441\043F\043E\0440\0443\0447\0435\043D\0438 \043A\0459\0443\0447 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\0440\0438\0441\0442\0438 \0437\0430 \043E\0432\0430\0458 \0443\043F\0438\0442. \0423\0440\0435\0434\0438\0442\0435 \0430\0442\0440\0438\0431\0443\0442\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0434\0430 \0431\0438\0441\0442\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043B\0438 \043A\043E\043B\043E\043D\0443 \0458\0435\0434\0438\043D\0441\0442\0432\0435\043D\043E\0433 \043A\0459\0443\0447\0430. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938910386402099)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0430\0431\0435\0440\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0443')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938898740402099)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0432\0443\0446\0438\0442\0435 \0438 \043E\0442\043F\0443\0441\0442\0438\0442\0435 \0434\0430\0442\043E\0442\0435\043A\0443 \043E\0432\0434\0435 \0438\043B\0438')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867415850402043)
,p_name=>'ITEMS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896885519402066)
,p_name=>'ITEM_VALUE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \0441\0442\0430\0432\043A\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911248752402078)
,p_name=>'LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923364129402087)
,p_name=>'LANGUAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0435\0437\0438\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885159690402057)
,p_name=>'LAST'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\0441\043B\0435\0434\045A\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864559397402041)
,p_name=>'LENGTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0443\0436\0438\043D\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917841868402083)
,p_name=>'LOGIN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0458\0430\0432\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956421185402113)
,p_name=>'MANAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\0440\0430\0432\0459\0430\045A\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115021034950402163)
,p_name=>'MAXIMIZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0432\0435\045B\0430\0458')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884243958402057)
,p_name=>'MINUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0438\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884377640402057)
,p_name=>'MINUTES'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0438\043D.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971788426402125)
,p_name=>'MISSING_AT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0434\043E\043C\0435\043D\0443 \0435-\0430\0434\0440\0435\0441\0435 \043D\0435\0434\043E\0441\0442\0430\0458\0435 "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971963232402125)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\043E\0437\043E\0440\0435\045A\0435: \0417\0430 \0441\0442\0440\0430\043D\0438\0446\0443 \0434\0438\0458\0430\043B\043E\0433\0430 %0 \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 %1 \043D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D \043D\0438\0458\0435\0434\0430\043D \0448\0430\0431\043B\043E\043D \0441\0442\0440\0430\043D\0438\0446\0435 \0434\0438\0458\0430\043B\043E\0433\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971614810402124)
,p_name=>'MISSING_DOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0434\043E\043C\0435\043D\0443 \0435-\0430\0434\0440\0435\0441\0435 \043D\0435\0434\043E\0441\0442\0430\0458\0435 ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920865260402085)
,p_name=>'MODULE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\043E\0434\0443\043B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877988997402052)
,p_name=>'MONTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\0441\0435\0446')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881777610402055)
,p_name=>'MONTHLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0435\0441\0435\0447\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878041456402052)
,p_name=>'MONTHS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043C\0435\0441.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910878514402077)
,p_name=>'MOVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978303096402130)
,p_name=>'MOVE_FROM'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438 \0438\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978427867402130)
,p_name=>'MOVE_TO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0435\0441\0442\0438 \0443')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114898014382402067)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \0431\0440\0438\0441\0430\045A\0430 \0432\0438\0448\0435 \0440\0435\0434\043E\0432\0430: \0440\0435\0434= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897033178402067)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \0441\043C\0435 \0434\0430 \0431\0443\0434\0435 \0458\0430\0432\043D\0438 \043A\043E\0440\0438\0441\043D\0438\043A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854271080402033)
,p_name=>'NAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911053476402077)
,p_name=>'NEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\043E\0432\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877721817402051)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\043E\0436\0435\0442\0435 \0434\0430 \0441\0435 \043F\0440\0438\0458\0430\0432\0438\0442\0435 \043D\0430 %0 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043E\0442\0438\045B\0438 \043D\0430:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877842488402051)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\043E\0432\043E \043E\0431\0430\0432\0435\0448\0442\0435\045A\0435 \0437\0430 %0 \043D\0430\043B\043E\0433')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001840353402148)
,p_name=>'NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920709116402085)
,p_name=>'NO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115016074894402159)
,p_name=>'NOBODY'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0438\043A\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885503099402058)
,p_name=>'NOT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926304123402089)
,p_name=>'NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897199663402067)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916790383402082)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\043E\0434\0430\0446\0438 \043D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925841530402089)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D \0438\0437\0432\0435\0448\0442\0430\0458 \043A\043E\0458\0438 \0458\0435 \043C\043E\0433\0443\045B\0435 \0430\0436\0443\0440\0438\0440\0430\0442\0438. \0420\0430\0434\045A\0435 \0430\0436\0443\0440\0438\0440\0430\045A\0430 \0438 \0431\0440\0438\0441\0430\045A\0430 \0432\0438\0448\0435 \0440\0435\0434\043E\0432\0430 \043C\043E\0433\0443\045B\0435 \0458\0435 \043E\0431\0430\0432\0438\0442\0438 \0441\0430\043C\043E \043D\0430 \0442\0430\0431\0443\043B\0430\0440\043D\0438\043C \043E\0431\0440\0430\0441\0446\0438\043C\0430 \0442\0438\043F\0430 ''\0418\0437\0432\0435\0448\0442\0430\0458 \043A\043E\0458\0438 \0458\0435 \043C\043E\0433\0443\045B\0435 \0430\0436\0443\0440\0438\0440\0430\0442\0438''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926764291402090)
,p_name=>'OK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423 \0440\0435\0434\0443')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922483762402086)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'sr'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115019810106402162)
,p_name=>'ORA_06550'
,p_message_language=>'sr'
,p_message_text=>unistr('ORA-06550: \0440\0435\0434 %0, \043A\043E\043B\043E\043D\0430 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969396338402123)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\0442\0438\0442\0435 \0437\0430\0441\0442\0430\0440\0435\043B\0438 \0432\0435\0431 \043F\0440\0435\0433\043B\0435\0434\0430\0447. \041B\0438\0441\0442\0443 \043F\043E\0434\0440\0436\0430\043D\0438\0445 \043F\0440\0435\0433\043B\0435\0434\0430\0447\0430 \043F\043E\0442\0440\0430\0436\0438\0442\0435 \0443 \0432\043E\0434\0438\0447\0443 \0437\0430 \0438\043D\0441\0442\0430\043B\0438\0440\0430\045A\0435 \0443\0441\043B\0443\0433\0435 Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870778820402046)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0445\0442\0435\0432\0430\043D \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0438 \0441\043A\0443\043F \0440\0435\0434\043E\0432\0430, \0438\0437\0432\043E\0440\043D\0438 \043F\043E\0434\0430\0446\0438 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \0441\0443 \0438\0437\043C\0435\045A\0435\043D\0438.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890849234402062)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0440\0435\0431\043D\043E \0458\0435 \043D\0430\0432\0435\0441\0442\0438 \0432\0430\0436\0435\045B\0438 \0431\0440\043E\0458 \0441\0442\0440\0430\043D\0435, \043D\0430 \043F\0440\0438\043C\0435\0440 p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894458391402064)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894523880402065)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0435\0434\0435\045B\0438 \0441\043A\0443\043F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894618924402065)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114894746723402065)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\0438 \0441\043A\0443\043F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001716458402148)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932365165402094)
,p_name=>'PASSWORD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877039921402051)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \0437\0430 %0 \0458\0435 \043F\0440\043E\043C\0435\045A\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866821638402043)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043D\0438\0458\0435 \0443\0441\0430\0433\043B\0430\0448\0435\043D\0430 \0441\0430 \043F\0440\0430\0432\0438\043B\0438\043C\0430 \0441\043B\043E\0436\0435\043D\043E\0441\0442\0438 \043B\043E\0437\0438\043D\043A\0435 \043E\0432\0435 \043B\043E\043A\0430\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865916650402042)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\043E\0432\0430 \043B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0435 \0440\0430\0437\043B\0438\043A\0443\0458\0435 \043E\0434 \0441\0442\0430\0440\0435 \043B\043E\0437\0438\043D\043A\0435 \0437\0430 \043D\0430\0458\043C\0430\045A\0435 %0 \0437\043D\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866526322402043)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043D\0435 \0441\043C\0435 \0434\0430 \0441\0430\0434\0440\0436\0438 \043A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866716097402043)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \0441\0430\0434\0440\0436\0438 \0437\0430\0431\0440\0430\045A\0435\043D\0443 \0458\0435\0434\043D\043E\0441\0442\0430\0432\043D\0443 \0440\0435\0447.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866621709402043)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043D\0435 \0441\043C\0435 \0434\0430 \0441\0430\0434\0440\0436\0438 \043D\0430\0437\0438\0432 \0440\0430\0434\043D\043E\0433 \043F\0440\043E\0441\0442\043E\0440\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865881242402042)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0437\043D\0430\043A\043E\0432\0430 \043A\043E\0458\0438 \043B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0430\0434\0440\0436\0438 \0458\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866086286402042)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0430\0434\0440\0436\0438 \0431\0430\0440 \0458\0435\0434\0430\043D \0441\043B\043E\0432\043D\0438 \0437\043D\0430\043A (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866472865402042)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0430\0434\0440\0436\0438 \0431\0430\0440 \0458\0435\0434\0430\043D \043C\0430\043B\0438 \0441\043B\043E\0432\043D\0438 \0437\043D\0430\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866130852402042)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0430\0434\0440\0436\0438 \043D\0430\0458\043C\0430\045A\0435 \0458\0435\0434\0430\043D \043D\0443\043C\0435\0440\0438\0447\043A\0438 \0437\043D\0430\043A (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866200857402042)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0430\0434\0440\0436\0438 \043D\0430\0458\043C\0430\045A\0435 \0458\0435\0434\0430\043D \0437\043D\0430\043A \0438\043D\0442\0435\0440\043F\0443\043D\043A\0446\0438\0458\0435 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114866323111402042)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \043C\043E\0440\0430 \0434\0430 \0441\0430\0434\0440\0436\0438 \0431\0430\0440 \0458\0435\0434\0430\043D \0432\0435\043B\0438\043A\0438 \0441\043B\043E\0432\043D\0438 \0437\043D\0430\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877563174402051)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0430\0432\0435\0448\0442\0435\045A\0435 \043E \0440\0435\0441\0435\0442\043E\0432\0430\045A\0443 \043B\043E\0437\0438\043D\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864812059402041)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430 \0441\0435 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\0440\0438\0441\0442\0438 \0458\0435\0440 \0458\0435 \0443\043F\043E\0442\0440\0435\0431\0459\0435\043D\0430 \0443 \043F\0440\0435\0442\0445\043E\0434\043D\043E\043C \043F\0435\0440\0438\043E\0434\0443 \043E\0434 %0 \0434\0430\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945121951402104)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114945200634402104)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922265812402086)
,p_name=>'PERCENT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0446\0435\043D\0430\0442')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892516699402063)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115001975192402148)
,p_name=>'PREVIOUS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0445\043E\0434\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937375251402098)
,p_name=>'PRINT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0448\0442\0430\043C\043F\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921043959402085)
,p_name=>'PRIVILEGES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890901824402062)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0444\0435\0440\0435\043D\0446\0435 \0440\0435\0433\0438\043E\043D\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911140531402077)
,p_name=>'REPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920954124402085)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0435\0440\0438\043E\0434 \0438\0437\0432\0435\0448\0442\0430\0432\0430\045A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002112075402148)
,p_name=>'REPORT_LABEL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921683718402086)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0432\0435\0448\0442\0430\0458 - \0443\043A\0443\043F\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870805575402046)
,p_name=>'RESET'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896776404402066)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0443')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925703601402089)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0441\0435\0442\0443\0458 \043B\043E\0437\0438\043D\043A\0443')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902598818402071)
,p_name=>'RESTORE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0430\0442\0438')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114934412531402095)
,p_name=>'RESULTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0437\0443\043B\0442\0430\0442\0438')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926863608402090)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0432\0440\0430\0442\0430\043A \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114927163753402090)
,p_name=>'RIGHT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0435\0441\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956764430402113)
,p_name=>'ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0435\0434 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910774711402077)
,p_name=>'ROW_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0411\0440\043E\0458 \0440\0435\0434\043E\0432\0430')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114926213407402089)
,p_name=>'SAVE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0447\0443\0432\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922815657402086)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043B\0442\0435\0440\043D\0430\0442\0438\0432\043D\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923233500402087)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0438\0441')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922761031402086)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043C\0430\0440\043D\043E \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923501301402087)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0441\0442\0443\043F\043D\043E \0458\0435 \0432\0438\0448\0435 \043E\0434 \0441\043B\0435\0434\0435\045B\0435\0433 \0431\0440\043E\0458\0430 \0440\0435\0434\043E\0432\0430: %0. \041F\043E\0432\0435\045B\0430\0458\0442\0435 \0431\0438\0440\0430\0447 \0440\0435\0434\043E\0432\0430 \0434\0430 \0431\0438\0441\0442\0435 \043F\0440\0438\043A\0430\0437\0430\043B\0438 \0432\0438\0448\0435 \0440\0435\0434\043E\0432\0430.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988976742402138)
,p_name=>'SEARCH'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\0440\0430\0433\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884171961402056)
,p_name=>'SECONDS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0441\0435\043A.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922381014402086)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0433\043B\0435\0434\0430\0458\0442\0435 \043F\0440\0438\043B\043E\0433\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980010415402131)
,p_name=>'SELECT_ROW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0430\0431\0435\0440\0438\0442\0435 \0440\0435\0434')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922033890402086)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0441\0438\0442\0435 \0440\0435\0436\0438\043C \0447\0438\0442\0430\0447\0430 \0435\043A\0440\0430\043D\0430 \043D\0430 \0438\0441\043A\0459\0443\0447\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922185149402086)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0435\0441\0438\0442\0435 \0440\0435\0436\0438\043C \0447\0438\0442\0430\0447\0430 \0435\043A\0440\0430\043D\0430 \043D\0430 \0443\043A\0459\0443\0447\0435\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918427861402083)
,p_name=>'SHOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981827207402132)
,p_name=>'SHOW_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0441\0432\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115007925868402152)
,p_name=>'SIGN_IN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0458\0430\0432\0459\0438\0432\0430\045A\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114957570420402114)
,p_name=>'SIGN_OUT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0458\0430\0432\0459\0438\0432\0430\045A\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911746428402078)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \0434\0430\043D\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918938221402083)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0434\0430\043D(\0430) \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911663593402078)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \0447.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918894531402083)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0447. \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911597300402078)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \043C\0438\043D.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918790011402083)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0438\043D. \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911919934402078)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \043C\0435\0441.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919142553402084)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043C\0435\0441. \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919344936402084)
,p_name=>'SINCE_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0430\0434\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911441444402078)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \0441\0435\043A.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114918644176402083)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0441\0435\043A. \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114911882479402078)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \043D\0435\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919031300402084)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435\0434. \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114912038942402078)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435 %0 \0433\043E\0434.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919255808402084)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0433\043E\0434. \043E\0434 \0441\0430\0434\0430\0448\045A\0435\0433 \0442\0440\0435\043D\0443\0442\043A\0430')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905507824402073)
,p_name=>'STANDARD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\043D\0434\0430\0440\0434')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921953185402086)
,p_name=>'START_DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\0442\0443\043C \043F\043E\0447\0435\0442\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862405201402039)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0431\0438\043B\0438 \0441\0442\0435 \043E\0432\0443 \0435-\043F\043E\0440\0443\043A\0443 \043E\0434 \043F\0440\0435\0442\043F\043B\0430\0442\0435 \043D\0430 \0438\043D\0442\0435\0440\0430\043A\0442\0438\0432\043D\0438 \0438\0437\0432\0435\0448\0442\0430\0458 \0447\0438\0458\0438 \0458\0435 \0430\0443\0442\043E\0440 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017189744402160)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\0442\043F\043B\0430\0442\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965299992402119)
,p_name=>'TAB'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0430\0440\0442\0438\0446\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884067943402056)
,p_name=>'TITLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0441\043B\043E\0432')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867072145402043)
,p_name=>'TODAY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430\043D\0430\0441')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921542710402085)
,p_name=>'TOTAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043A\0443\043F\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868079739402044)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\043A\0441\0438\043C\0430\043B\0430\043D \0431\0440\043E\0458 \043A\043E\043B\043E\043D\0430 \043A\043E\0458\0435 \0458\0435 \043C\043E\0433\0443\045B\0435 \0438\0437\0430\0431\0440\0430\0442\0438 \0458\0435 %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846532631402027)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043A\0443\043F\0438 \0441\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846817578402027)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043A\0443\043F\0438 \0441\0432\0435 \0438\0441\043F\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846413082402027)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0437\0432\0438\0458 \0441\0432\0435')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846632070402027)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0448\0438\0440\0438 \0441\0432\0435 \0438\0441\043F\043E\0434')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846967475402027)
,p_name=>'TREE.REPARENT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\043D\043E\0432\043E \043F\043E\0441\0442\0430\0432\0438 \043A\0430\043E \043D\0430\0434\0440\0435\0452\0435\043D\043E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939108915402099)
,p_name=>'TREES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0431\043B\0430')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114982625444402133)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0431\0430\0432\0435\0437\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114906202001402074)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0434\043E\0431\0440\0435\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114953069252402110)
,p_name=>'UNAVAILABLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919704415402084)
,p_name=>'UNKNOWN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043F\043E\0437\043D\0430\0442\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863320835402040)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \043D\0435\043F\043E\0437\043D\0430\0442\0435 \0433\0440\0435\0448\043A\0435 \043F\043E\0442\0432\0440\0434\0435 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865351744402042)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043A\043E \0432\0438\0448\0435 \043D\0435 \0436\0435\043B\0438\0442\0435 \0434\0430 \043F\0440\0438\043C\0430\0442\0435 \0435-\043F\043E\0440\0443\043A\0435, \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 <a href="%0">\043E\0442\043A\0430\0436\0438 \043F\0440\0435\0442\043F\043B\0430\0442\0443</a> \0434\0430 \0431\0438\0441\0442\0435 \0443\043F\0440\0430\0432\0459\0430\043B\0438 \043F\0440\0435\0442\043F\043B\0430\0442\043E\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114862322036402039)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043A\043E \0432\0438\0448\0435 \043D\0435 \0436\0435\043B\0438\0442\0435 \0434\0430 \043F\0440\0438\043C\0430\0442\0435 \0435-\043F\043E\0440\0443\043A\0435, \043F\043E\0441\0435\0442\0438\0442\0435 \0441\043B\0435\0434\0435\045B\0443 URL \0430\0434\0440\0435\0441\0443 \0434\0430 \0431\0438\0441\0442\0435 \0443\043F\0440\0430\0432\0459\0430\043B\0438 \043F\0440\0435\0442\043F\043B\0430\0442\043E\043C:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114897265087402067)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435\043F\043E\0434\0440\0436\0430\043D\0438 \0442\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885397408402057)
,p_name=>'UPDATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0430\0436\0443\0440\0438\0440\0430\0458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883900644402056)
,p_name=>'UPDATED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0436\0443\0440\0438\0440\0430\043D\043E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890692381402062)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0445\0442\0435\0432\0430\043D\0438 URL \0458\0435 \0437\0430\0431\0440\0430\045A\0435\043D. \041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114910639070402077)
,p_name=>'USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\043A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114932226674402094)
,p_name=>'USERNAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971831963402125)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435 \0458\0435 \043F\0440\0435\0434\0443\0433\0430\0447\043A\043E. \041E\0433\0440\0430\043D\0438\0447\0435\045A\0435 \0431\0440\043E\0458\0430 \0437\043D\0430\043A\043E\0432\0430 \0458\0435 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917442786402082)
,p_name=>'USERS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043A\043E\0440\0438\0441\043D\0438\043A(\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114971448703402124)
,p_name=>'USER_EXISTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435 \0432\0435\045B \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114986101865402136)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043B\0438\043A\0430 \043F\0440\043E\0444\0438\043B\0430 \0437\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873774457402048)
,p_name=>'VALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0430\0436\0435\045B\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867376114402043)
,p_name=>'VALIDATIONS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\0432\0435\0440\0435 \0438\0441\043F\0440\0430\0432\043D\043E\0441\0442\0438')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923093735402087)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043D\0430\0432\0435\0434\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966437279402120)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043D\0430\0432\0435\0434\0435\043D\0430 \0437\0430 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892907700402063)
,p_name=>'VERTICAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0432\0435\0440\0442\0438\043A\0430\043B\043D\043E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885272160402057)
,p_name=>'VIEW'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\0440\0438\043A\0430\0436\0438 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917543300402082)
,p_name=>'VIEWS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043F\0440\0438\043A\0430\0437(\0430)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923890355402087)
,p_name=>'VIEW_ALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0436\0438 \0441\0432\0435')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114905043621402073)
,p_name=>'WARNING'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\043E\0437\043E\0440\0435\045A\0435')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884818995402057)
,p_name=>'WEEK'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881861085402055)
,p_name=>'WEEKLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0434\0435\0459\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114884926268402057)
,p_name=>'WEEKS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043D\0435\0434.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114923199233402087)
,p_name=>'WELCOME_USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0431\0440\043E \0434\043E\0448\043B\0438: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921360871402085)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D\0430 \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442, \043F\043E\0442\0432\0440\0434\0438\0442\0435 \0443\043D\0435\0442\0435 \043F\043E\0434\0430\0442\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921419700402085)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D\0430 \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442, \043F\043E\0442\0432\0440\0434\0438\0442\0435 \0443\043D\0435\0442\0435 \043F\043E\0434\0430\0442\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864477880402041)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D\0430 \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \0434\0430\0442\0443\043C\0430, \043F\043E\0442\0432\0440\0434\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \0434\0430\0442\0443\043C\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114921248380402085)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D\0430 \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \0431\0440\043E\0458\0430, \043F\043E\0442\0432\0440\0434\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \0431\0440\043E\0458\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873377389402048)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D\0430 \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \043E\0437\043D\0430\043A\0435 \0432\0440\0435\043C\0435\043D\0430, \043F\043E\0442\0432\0440\0434\0438\0442\0435 \0444\043E\0440\043C\0430\0442 \043E\0437\043D\0430\043A\0435 \0432\0440\0435\043C\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114895809978402066)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\043E\0432\0435\0437\0430\0442\0438 "%0". \041A\043E\0440\0438\0441\0442\0438\0442\0435 \0434\0432\043E\0441\0442\0440\0443\043A\0435 \043D\0430\0432\043E\0434\043D\0438\043A\0435 \0437\0430 \0441\0442\0430\0432\043A\0435 \043E\0434 \0432\0438\0448\0435 \0431\0430\0458\0442\043E\0432\0430 \0438\043B\0438 \043F\043E\0442\0432\0440\0434\0438\0442\0435 \0434\0430 \0458\0435 \0434\0443\0436\0438\043D\0430 \0441\0442\0430\0432\043A\0435 30 \0431\0430\0458\0442\043E\0432\0430 \0438\043B\0438 \043C\0430\045A\0435. \0423\043F\043E\0442\0440\0435\0431\0438\0442\0435 v() \0441\0438\043D\0442\0430\043A\0441\0443 \0437\0430 \0440\0435\0444\0435\0440\0435\043D\0446\0438\0440\0430\045A\0435 \0441\0442\0430\0432\043A\0438 \0434\0443\0436\0438\0445 \043E\0434 30 \0431\0430\0458\0442\043E\0432\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886368202402058)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0441\0442\0443\043F \0458\0435 \0437\0430\0431\0440\0430\043D\0438\043B\0430 %0 \0431\0435\0437\0431\0435\0434\043D\043E\0441\043D\0430 \043F\0440\043E\0432\0435\0440\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888881430402060)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887258923402059)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1014 \0410\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887363720402059)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0430\043F\043B\0438\043A\0430\0446\0438\0458\0430=%0 \0440\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887722421402059)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0441\0442\0443\043F \043E\0432\043E\0458 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 \0458\0435 \043E\0433\0440\0430\043D\0438\0447\0435\043D, \043F\043E\043A\0443\0448\0430\0458\0442\0435 \043F\043E\043D\043E\0432\043E \043A\0430\0441\043D\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887657702402059)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0441\0442\0443\043F \043E\0432\043E\0458 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 \0458\0435 \043E\0433\0440\0430\043D\0438\0447\0435\043D \043D\0430 \043F\0440\043E\0433\0440\0430\043C\0435\0440\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435, \043F\043E\043A\0443\0448\0430\0458\0442\0435 \043F\043E\043D\043E\0432\043E \043A\0430\0441\043D\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886838389402059)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-7744 \041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043E\0431\0440\0430\0434\0438\0442\0438 URL \0437\0430 \0432\0440\0430\045B\0430\045A\0435 \0433\0440\0430\043D\0430\045A\0430 \043D\0430 \0444\0443\043D\043A\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886723200402059)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-7744 \041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043E\0431\0440\0430\0434\0438\0442\0438 \0441\0442\0440\0430\043D\0438\0446\0443 \0437\0430 \0432\0440\0430\045B\0430\045A\0435 \0433\0440\0430\043D\0430\045A\0430 \043D\0430 \0444\0443\043D\043A\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887012444402059)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1430 \041F\043E\0437\0438\0432 \0437\0430 \043F\0440\0438\043A\0430\0437 \0437\0430 \043F\0440\043E\0446\0435\0441\0430 \0441\0442\0440\0430\043D\0438\0446\0435 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888132929402060)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1018 \0413\0440\0435\0448\043A\0430 \043F\0440\0438 \0431\0440\0438\0441\0430\045A\0443 \043A\0435\0448 \043C\0435\043C\043E\0440\0438\0458\0435 \043A\043E\0440\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886573019402058)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1005 \041D\0435\043F\043E\0437\043D\0430\0442\0438 \0442\0438\043F \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887440477402059)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ID \0441\0435\0441\0438\0458\0435 ERR-1201 \043D\0438\0458\0435 \043F\043E\0434\0435\0448\0435\043D \043D\0430 \043F\0440\0438\043B\0430\0433\043E\0452\0435\043D\0443 \043F\043E\0442\0432\0440\0434\0443 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887516127402059)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0441\0442\0440\0430\043D\0438\0446\0430=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114887109160402059)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-7620 \041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043E\0434\0440\0435\0434\0438\0442\0438 \0440\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440 \0437\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869519253402045)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0440\0435\0434\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886208159402058)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1802 \041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D ID \0441\0442\0430\0432\043A\0435 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885902019402058)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1002 \041D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D ID \0441\0442\0430\0432\043A\0435 \0437\0430 \0441\0442\0430\0432\043A\0443 "%0" \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886064480402058)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0447\0435\043A\0438\0432\0430\043D\0430 \0433\0440\0435\0448\043A\0430, \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\043E \0438\043C\0435 \0441\0442\0430\0432\043A\0435 \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 \0438\043B\0438 \043D\0430 \043D\0438\0432\043E\0443 \0441\0442\0440\0430\043D\0438\0446\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886470075402058)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0435\045B \0441\0435 \043D\0430\043B\0430\0437\0438\0442\0435 \043D\0430 \043F\0440\0432\043E\0458 \0441\0442\0440\0430\043D\0438\0446\0438 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114901944121402070)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'sr'
,p_message_text=>unistr('ID \0441\0442\0430\0432\043A\0435 (%0) \043D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430 \0441\0442\0430\0432\043A\0430 \043D\0430 \0442\0440\0435\043D\0443\0442\043D\043E\0458 \0441\0442\0440\0430\043D\0438\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864038273402041)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\043E\0434\0435\0441\0438 \043F\0440\043E\0441\043B\0435\0452\0438\0432\0430\045A\0435\043C \0430\0440\0433\0443\043C\0435\043D\0430\0442\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864390331402041)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'sr'
,p_message_text=>unistr('(\041D\0438\0458\0435 \043E\0431\0435\0437\0431\0435\0452\0435\043D \043A\043E\043D\0442\0440\043E\043B\043D\0438 \0437\0431\0438\0440)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863882705402040)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\043E\0434\0435\0441\0438 \043A\0430\0434\0430 \0458\0435 \043F\0440\043E\043F\0440\0430\045B\0435\043D\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438\043C \0437\0431\0438\0440\043E\043C "\043E\0431\0435\043B\0435\0436\0438\0432\0430\0447\0430 \043D\0430 \043D\0438\0432\043E\0443 \043A\043E\0440\0438\0441\043D\0438\043A\0430".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863783736402040)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\043E\0434\0435\0441\0438 \043A\0430\0434\0430 \0458\0435 \043F\0440\043E\043F\0440\0430\045B\0435\043D\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438\043C \0437\0431\0438\0440\043E\043C "\043E\0431\0435\043B\0435\0436\0438\0432\0430\0447\0430 \043D\0430 \043D\0438\0432\043E\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863941886402041)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043F\043E\0434\0435\0441\0438 \043A\0430\0434\0430 \0458\0435 \043F\0440\043E\043F\0440\0430\045B\0435\043D\0430 \043A\043E\043D\0442\0440\043E\043B\043D\0438\043C \0437\0431\0438\0440\043E\043C "\0441\0435\0441\0438\0458\0435".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863643312402040)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0430\0432\043A\0430 \043D\0435\043C\0430 \0437\0430\0448\0442\0438\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888240756402060)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0442\0440\0430\043D\0438\0446\0430 \043F\043E\043C\043E\045B\0438 \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114877364306402051)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440 %0 \043D\0435\043C\0430 \043F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0435 \0437\0430 \0440\0430\0448\0447\043B\0430\045A\0438\0432\0430\045A\0435 \043F\043E \0448\0435\043C\0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886666073402058)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1010 \041F\0440\0435\043A\043E\0440\0430\0447\0435\043D\043E \0458\0435 \043E\0433\0440\0430\043D\0438\0447\0435\045A\0435 \0440\0435\043A\0443\0440\0437\0438\0458\0435 \043E\0431\0440\0430\0434\0435 \043F\0440\0438\0445\0432\0430\0442\0430\045A\0430 \0433\0440\0430\043D\0430\045A\0430 \043D\0430 \0441\0442\0440\0430\043D\0438\0446\0443. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864249582402041)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0443 \0441\0442\0440\0430\043D\0438\0446\0443 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\043E\0437\0432\0430\0442\0438 \043F\043E\043C\043E\045B\0443 URL \0430\0434\0440\0435\0441\0435 \0438\043B\0438 \043A\043E\0440\0438\0441\0442\0435\045B\0438 GET \0438\043B\0438 POST \0437\0430 \043F\0440\043E\0446\0435\0434\0443\0440\0443 \043F\0440\0438\043A\0430\0437\0430. \041C\043E\0440\0430 \0434\0430 \0441\0435 \043F\043E\0437\043E\0432\0435 \043A\043E\0440\0438\0441\0442\0435\045B\0438 \0442\0438\043F \0433\0440\0430\043D\0430\045A\0430 "\0413\0440\0430\043D\0430 \043D\0430 \0441\0442\0440\0430\043D\0443".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114940909008402101)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438\043B\0438\043A\043E\043C \043F\043E\043A\0443\0448\0430\0432\0430\045A\0430 \0447\0443\0432\0430\045A\0430 \043D\0435\043D\0443\043C\0435\0440\0438\0447\043A\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0443 \0441\0442\0430\0432\0446\0438 %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879030068402052)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0428\0435\043C\0430 \0440\0430\0448\0447\043B\0430\045A\0438\0432\0430\045A\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 "%0" \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 \0431\0430\0437\0438 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114879106923402052)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\043B\043E\0437\0438 \0443 \0440\0430\0434\043D\043E\043C \043F\0440\043E\0441\0442\043E\0440\0443 INTERNAL \043C\043E\0433\0443 \0441\0435 \0434\0430 \043A\043E\0440\0438\0441\0442\0435 \0441\0430\043C\043E \0437\0430 \043F\0440\0438\0441\0442\0443\043F\0430\045A\0435 &PRODUCT_NAME. <a href="%0">\0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\0438\0432\043D\0438\043C \0443\0441\043B\0443\0433\0430\043C\0430</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885854091402058)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-1029 \041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0441\0430\0447\0443\0432\0430\0442\0438 \0438\043D\0444\043E\0440\043C\0430\0446\0438\0458\0435 \043E \0441\0435\0441\0438\0458\0438. \0441\0435\0441\0438\0458\0430=%0 \0441\0442\0430\0432\043A\0430=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888928673402060)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0437\0430\0443\0441\0442\0430\0432\0438\0442\0438 \043F\0440\0430\045B\0435\045A\0435: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114886145414402058)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0447\0435\043A\0438\0432\0430\043D\0430 \0433\0440\0435\0448\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896158442402066)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \0443 update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889073408402060)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\043E\0440\0430\0442\0435 \0434\0430 \043D\0430\0432\0435\0434\0435\0442\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0443 \0438 \0441\0442\0440\0430\043D\0438\0446\0443 \0434\0430 \0431\0438\0441\0442\0435 \0432\0438\0434\0435\043B\0438 \043F\043E\043C\043E\045B.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114909532903402076)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0443\0442\043E\043C\0430\0442\0438\0437\0430\0446\0438\0458\0430 \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890122268402061)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0447\0438\0448\045B\0435\043D\0438\0445 \0441\0435\0441\0438\0458\0430: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849406752402029)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0438\0437\0432\0440\0448\0438\0442\0438 \043A\043E\0434 %0! \0411\0430\0437\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0433\0430 \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \0438\043B\0438 \043D\0438\0458\0435 \043E\043C\043E\0433\0443\045B\0435\043D \043F\0430\0440\0430\043C\0435\0442\0440\043E\043C \0438\043D\0441\0442\0430\043D\0446\0435 MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114849245994402029)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0438\0448\0435\0458\0435\0437\0438\0447\043D\0430 \043C\0430\0448\0438\043D\0430 \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\0430 \0443 \043E\0432\043E\0458 \0432\0435\0440\0437\0438\0458\0438 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870053732402045)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0437 \043A\043E\043B\0435\043A\0446\0438\0458\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043D\0435 \0441\043C\0435 \0434\0430 \0431\0443\0434\0435 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869823579402045)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D\0438 \0431\0440\043E\0458 \0430\0442\0440\0438\0431\0443\0442\0430 \0447\043B\0430\043D\0430 %0 \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0438.  \0411\0440\043E\0458 \0430\0442\0440\0438\0431\0443\0442\0430 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0438\0437\043C\0435\0452\0443 1 \0438 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870311675402046)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\0435\043A\0446\0438\0458\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 \043F\043E\0441\0442\043E\0458\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870172065402045)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435 \043A\043E\043B\0435\043A\0446\0438\0458\0435 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0431\0443\0434\0435 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870270864402046)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043C\0435 \043A\043E\043B\0435\043A\0446\0438\0458\0435 \043D\0435 \0441\043C\0435 \0434\0430 \0431\0443\0434\0435 \0434\0443\0436\0435 \043E\0434 255 \0437\043D\0430\043A\043E\0432\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869680462402045)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\0435\043A\0446\0438\0458\0430 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870406277402046)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\0443\0440\0441\043E\0440 \0458\043E\0448 \0443\0432\0435\043A \043D\0438\0458\0435 \043E\0442\0432\043E\0440\0435\043D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869729198402045)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\041D\0438\0437 \0447\043B\0430\043D\043E\0432\0430 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 \043A\043E\043B\0435\043A\0446\0438\0458\0438 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114869916212402045)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0437 \0447\043B\0430\043D\043E\0432\0430 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 \043A\043E\043B\0435\043A\0446\0438\0458\0438 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0430 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941739820402101)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0438\0441\0442\0435\043C \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \043A\0440\0438\043F\0442\043E\0433\0440\0430\0444\0441\043A\0443 \0444\0443\043D\043A\0446\0438\0458\0443 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995257672402142)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0441\0442\0443\043F\0430\0447\043D\043E\0441\0442 \0458\0435 \0442\0435\0441\0442\0438\0440\0430\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889631208402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430\0442\0432\043E\0440\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889778109402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\043F\0446\0438\0458\0435 \043F\0440\0438\043B\0430\0433\043E\0452\0430\0432\0430\045A\0430 \0441\0442\0440\0430\043D\0438\0446\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889830606402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889936496402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437\0430\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890032909402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043A\0440\0438\0432\0435\043D\043E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889423772402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0437\043D\0430\0447\0438\0442\0435 \0440\0435\0433\0438\043E\043D\0435 \043A\043E\0458\0435 \0436\0435\043B\0438\0442\0435 \0434\0430 \043E\0431\0443\0445\0432\0430\0442\0438\0442\0435 \043E\0432\043E\043C \0441\0442\0440\0430\043D\0438\0446\043E\043C. \041E\0437\043D\0430\0447\0435\043D\0438 \0440\0435\0433\0438\043E\043D\0438 \0441\0435 \043C\043E\0436\0434\0430 \043D\0435\045B\0435 \043F\0440\0438\043A\0430\0437\0430\0442\0438 \0430\043A\043E \0441\0435 \043D\0435 \043D\0430\043B\0430\0437\0438\0442\0435 \0443 \043E\0434\0433\043E\0432\0430\0440\0430\0458\0443\045B\0435\043C \043A\043E\043D\0442\0435\043A\0441\0442\0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0438\043B\0438 \043D\0435\043C\0430\0442\0435 \043E\0434\0433\043E\0432\0430\0440\0430\0458\0443\045B\0435 \043F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889522633402061)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0443 \0441\0442\0440\0430\043D\0438\0446\0443 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\0440\0438\043B\0430\0433\043E\0434\0438\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995592221402143)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\043E\0436\0435\0442\0435 \0434\0430 \043F\0435\0440\0441\043E\043D\0430\043B\0438\0437\0443\0458\0435\0442\0435 \0438\0437\0433\043B\0435\0434 \043E\0432\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435 \0442\0430\043A\043E \0448\0442\043E \045B\0435\0442\0435 \043F\0440\043E\043C\0435\043D\0438\0442\0438 \0441\0442\0438\043B \0442\0435\043C\0435. \0418\0437\0430\0431\0435\0440\0438\0442\0435 \0441\0442\0438\043B \0442\0435\043C\0435 \043D\0430 \043B\0438\0441\0442\0438 \0443 \043D\0430\0441\0442\0430\0432\043A\0443, \043F\0430 \043A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \041F\0440\0438\043C\0435\043D\0438 \043F\0440\043E\043C\0435\043D\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114996305062402143)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043A\0430\0437 \0440\0435\0433\0438\043E\043D\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995476473402143)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\0442\0438 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0438 \0441\0442\0438\043B \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114995326642402143)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\0437\0433\043B\0435\0434 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938333494402099)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \043A\043E\043B\043E\043D\0435 \0440\0435\0444\0435\0440\0435\043D\0446\0438\0440\0430\043D \0443 \0430\0433\0440\0435\0433\0430\0446\0438\0458\0438 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114841694736402023)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'sr'
,p_message_text=>unistr('CLOB \0438\0437\043B\0430\0437 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \0437\0430 \0444\043E\0440\043C\0430\0442 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938019875402098)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043B\043E\043C \043A\043E\043B\043E\043D\0435 \043C\043E\0440\0430 \0434\0430 \0441\0435 \043D\0430\043B\0430\0437\0438 \043D\0430 \043F\043E\0447\0435\0442\043A\0443 \043D\0438\0437\0430 \043A\043E\043B\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938135737402098)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \0433\0440\0443\043F\0435 \043A\043E\043B\043E\043D\0430 \043A\043E\0458\0435\0433 \0440\0435\0444\0435\0440\0435\043D\0446\0438\0440\0430 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114855685592402034)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'sr'
,p_message_text=>unistr('\0438\0437\0432\043E\0437')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114860827419402038)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\043E\0440\043C\0430\0442 \0438\0437\043B\0430\0437\0430 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 XML \043A\043E\0458\0438 \043A\043E\0440\0438\0441\0442\0438 ORDS \043A\0430\043E \0441\0435\0440\0432\0435\0440 \0437\0430 \0448\0442\0430\043C\043F\0430\045A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938475240402099)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \043A\043E\043B\043E\043D\0435 \0440\0435\0444\0435\0440\0435\043D\0446\0438\0440\0430\043D \0443 \0438\0441\0442\0430\043A\043D\0443\0442\043E\0458 \0441\0442\0430\0432\0446\0438 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854193926402033)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0444\043E\0440\043C\0430\0442 \0438\0437\0432\043E\0437\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114938290236402099)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\0418\043D\0434\0435\043A\0441 \043D\0430\0434\0440\0435\0452\0435\043D\0435 \043A\043E\0458\0435\0433 \0440\0435\0444\0435\0440\0435\043D\0446\0438\0440\0430 %0 \043D\0435 \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114963466794402118)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 %1 \0442\0430\0431\0435\043B\0435 %0 \0458\0435 \043A\043E\043B\043E\043D\0430 \0441\0430 \0438\0434\0435\043D\0442\0438\0442\0435\0442\043E\043C "GENERATED ALWAYS". \0423\0432\0435\0440\0438\0442\0435 \0441\0435 \0434\0430 \0441\0435 \043D\0438\0458\0435\0434\043D\0430 \0438\0437\0432\043E\0440\043D\0430 \043A\043E\043B\043E\043D\0430 \043D\0435 \043C\0430\043F\0438\0440\0430 \0443 \043A\043E\043B\043E\043D\0443 %1 \0434\0438\0458\0430\043B\043E\0433\0430 \0437\0430 \043A\043E\043D\0444\0438\0433\0443\0440\0438\0441\0430\045A\0435.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880801619402054)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D\0438 \0438\043D\0442\0435\0440\0432\0430\043B \043F\0440\0438\043C\0435\043D\0435 \0458\0435 \0441\0443\0432\0438\0448\0435 \043A\0440\0430\0442\0430\043A.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114880944404402054)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0441\0443 \043E\0431\0435\0437\0431\0435\0452\0435\043D\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \0443\0447\0438\0442\0430\0432\0430\045A\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882110933402055)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0435 \043A\043E\043B\043E\043D\0435 \0437\0430 \0431\0438\0440\0430\0447 \0440\0435\0434\043E\0432\0430 "%0". \041F\043E\043A\0443\0448\0430\0458\0442\0435 \0441\0430 \0430\0443\0442\043E\043C\0430\0442\0441\043A\0438\043C \043E\0442\043A\0440\0438\0432\0430\045A\0435\043C \0438\043B\0438 \043F\0440\0435\0433\043B\0435\0434\0430\0458\0442\0435 JSON \0441\0442\0440\0443\043A\0442\0443\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890419140402061)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438 \0440\0430\0434\043D\0438 \043B\0438\0441\0442\043E\0432\0438 \0443 XLSX \0434\0430\0442\043E\0442\0435\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890383248402061)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D\0438 \0440\0430\0434\043D\0438 \043B\0438\0441\0442 \043D\0435 \043F\043E\0441\0442\043E\0458\0438 \0443 XLSX \0434\0430\0442\043E\0442\0435\0446\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114870572126402046)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0435\043D\0443\0442\043D\0430 \0432\0435\0440\0437\0438\0458\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0443 \0431\0430\0437\0438 \043F\043E\0434\0430\0442\0430\043A\0430 \0458\0435 \043F\0440\043E\043C\0435\045A\0435\043D\0430 \043E\0434 \043A\0430\0434\0430 \0458\0435 \043A\043E\0440\0438\0441\043D\0438\043A \043F\043E\043A\0440\0435\043D\0443\043E \043F\0440\043E\0446\0435\0441 \0430\0436\0443\0440\0438\0440\0430\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872981219402048)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438 \0430\0436\0443\0440\0438\0440\0430\045A\0443 \043A\043E\043B\043E\043D\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977679419402129)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\043D\0432\0435\0440\0442\0443\0458\0435 \0443 SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917147269402082)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 %0, \043A\043E\0458\0430 \0441\0430\0434\0440\0436\0438 \043F\043E\0434\0430\0442\043A\0435 \0442\0438\043F\0430 %1, \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\043D\0432\0435\0440\0442\0443\0458\0435 \0443 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924186819402088)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 "%0" \043E\0434\0440\0435\0452\0435\043D\0430 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%1" \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430 \0443 \0438\0437\0432\043E\0440\0443 \043F\043E\0434\0430\0442\0430\043A\0430!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865444664402042)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \0444\0438\043B\0442\0435\0440\0430 %0 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \0437\0430 \043A\043E\043B\043E\043D\0435 \0441\0430 \0432\0438\0448\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114981041688402132)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0444\0438\043B\0442\0435\0440 "\0438\0437\043C\0435\0452\0443".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847586135402028)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D \0458\0435 \043D\0435\0432\0430\0436\0435\045B\0438 \0442\0438\043F \043B\0438\0441\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847427591402028)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \0442\0438\043F \0443\043F\0438\0442\0430. \0422\0438\043F \0443\043F\0438\0442\0430 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \0442\0430\0431\0435\043B\0430, SQL \0443\043F\0438\0442 \0438\043B\0438 PL/SQL \0444\0443\043D\043A\0446\0438\0458\0430 \043A\043E\0458\0430 \0432\0440\0430\045B\0430 SQL \0443\043F\0438\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917246548402082)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0420\0430\0448\0447\043B\0430\045A\0438\0432\0430\045A\0435 SQL \0443\043F\0438\0442\0430 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E.'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924245524402088)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D\0438 \043F\043E\043B\043E\0436\0430\0458 \043A\043E\043B\043E\043D\0435 %0 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%1" \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D \0443 SQL \043D\0430\0440\0435\0434\0431\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114846043878402027)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\043E\0442\0440\0435\0431\0459\0435\043D\043E \0458\0435 \043F\0440\0435\0432\0438\0448\0435 \0441\0442\0430\0432\043A\0438 \0443 \0444\0438\043B\0442\0435\0440\0443 \0441\0430 \0432\0438\0448\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924059036402087)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043D\0430\0432\0435\0434\0435\043D\0430 \043D\0438\0458\0435\0434\043D\0430 \043A\043E\043B\043E\043D\0430 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847386799402028)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0435\043A\0441\0442 \0444\0443\043D\043A\0446\0438\0458\0435 PL/SQL \043D\0438\0458\0435 \0432\0440\0430\0442\0438\043E \0432\0440\0435\0434\043D\043E\0441\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114937215058402098)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'sr'
,p_message_text=>unistr('REST \0438\0437\0432\043E\0440 \043F\043E\0434\0430\0442\0430\043A\0430 \043D\0435 \0441\0430\0434\0440\0436\0438 \043E\043F\0435\0440\0430\0446\0438\0458\0443 \0437\0430 \0440\0443\043A\043E\0432\0430\045A\0435 \0437\0430\0445\0442\0435\0432\0430\043D\043E\043C DML \0440\0430\0434\045A\043E\043C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114843241226402024)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043D\0432\0435\0440\0437\0438\0458\0430 \0438\0437 GeoJSON \0443 SDO_GEOMETRY (\043A\043E\043B\043E\043D\0430 %0) \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\043D\0430 \0443 \043E\0432\043E\0458 \0431\0430\0437\0438 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844315380402025)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'sr'
,p_message_text=>unistr('SDO_GEOMETRY \043A\043E\043D\0432\0435\0440\0437\0438\0458\0430 (\043A\043E\043B\043E\043D\0430 %0) \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D\0430 \0437\0430 \0438\0437\0432\043E\0440\0435 XML \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114851696126402031)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\043D\0430\043A %0 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D \043A\0430\043E \0441\0435\043F\0430\0440\0430\0442\043E\0440 \0437\0430 \0432\0438\0448\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114978997800402130)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430 \0444\0443\043D\043A\0446\0438\0458\0430 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \0443\043F\043E\0442\0440\0435\0431\0438 \0437\0430 \043A\043E\043D\0442\0435\043A\0441\0442 \0443\043F\0438\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114844435503402025)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043F\043E\0434\0443\0434\0430\0440\0430\045A\0435 \0442\0438\043F\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \043A\043E\043B\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847229844402028)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043A\043E\0440\0430\0447\0435\043D\0435 \0441\0443 \0433\0440\0430\043D\0438\0447\043D\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0437\0430 ORDS OUT \0432\0435\0437\0438\0432\0430\045A\0435. \0421\043C\0430\045A\0438\0442\0435 \0431\0440\043E\0458 DML \0440\0435\0434\043E\0432\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114925019738402088)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('JSON \043E\0434\0433\043E\0432\043E\0440 \0443\0434\0430\0459\0435\043D\043E\0433 \0441\0435\0440\0432\0435\0440\0430 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0440\0430\0448\0447\043B\0430\043D\0438\0442\0438: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114847100014402027)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043F\043E\0437\043D\0430\0442\0438 \0438\043B\0438 \043F\043E\0433\0440\0435\0448\043D\0438 \0442\0438\043F \043A\043E\043D\0442\0435\043A\0441\0442\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114941669527402101)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0448\0447\043B\0430\045A\0438\0432\0430\0447 \043D\0435 \043F\043E\0434\0440\0436\0430\0432\0430 \043E\0432\0430\0458 \0442\0438\043F \0434\0430\0442\043E\0442\0435\043A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896211389402066)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0432\043B\0430\0448\045B\0435\043D \043F\0440\0438\0441\0442\0443\043F (wwv_flow_api.set_credentials not set).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873247082402048)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0434\043D\0438 \043F\0440\043E\0441\0442\043E\0440 \043D\0438\0458\0435 \043A\0440\0435\0438\0440\0430\043D \0458\0435\0440 \0432\0435\045B \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114873154269402048)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\0430 \0433\0440\0443\043F\0430 \043D\0438\0458\0435 \043A\0440\0435\0438\0440\0430\043D\0430 \0458\0435\0440 \0432\0435\045B \043F\043E\0441\0442\043E\0458\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883482980402056)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\043E\043D\0430\0452\0435\043D \0458\0435 \0434\0443\043F\043B\0438\043A\0430\0442 \043A\043E\0440\0438\0441\043D\0438\0447\043A\043E\0433 \0438\043C\0435\043D\0430 \0437\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883540164402056)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438\043B\0438\043A\043E\043C \0443\0447\0438\0442\0430\0432\0430\045A\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0430. \041D\0438\0458\0435 \0443\0441\043F\0435\043B\043E \043D\0430 \043A\043E\0440\0438\0441\043D\0438\043A\0443 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893499672402064)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\0447\0438\0442\0430\043E \0431\0438 \0441\0435 \0441\043B\0435\0434\0435\045B\0438 \0431\0440\043E\0458 \043A\043E\0440\0438\0441\043D\0438\043A\0430: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893246905402064)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\043E\0437\0438\043D\043A\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893329094402064)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\0432\0438\043B\0435\0433\0438\0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893077484402063)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969505231402123)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043F\0440\0438\043A\0430\0437\0438\0432\0430\045A\0430 \0441\0442\0430\0432\043A\0435 \0441\0442\0440\0430\043D\0438\0446\0435 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889177407402060)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\0440\0438\043A\0430\0437\0430\0442\0438 \0441\0442\0430\0432\043A\0443 \0441\0442\0440\0430\043D\0438\0446\0435 \0458\0435\0440 HTML \043E\0431\0440\0430\0437\0430\0446 \0458\043E\0448 \043D\0438\0458\0435 \043E\0442\0432\043E\0440\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114854435726402033)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 \043F\043E\0434\0440\0430\0437\0443\043C\0435\0432\0430\043D\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0441\0442\0430\0432\043A\0435 \0437\0430 \0441\0442\0430\0432\043A\0443 \0441\0442\0440\0430\043D\0438\0446\0435 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888406210402060)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043D\0430\043A\043E\043D \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 \0441\0442\0430\0432\043A\0435 \0437\0430 \0441\0442\0430\0432\043A\0443 \0441\0442\0440\0430\043D\0438\0446\0435 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888307953402060)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 \0438\0437\0432\043E\0440\043D\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0441\0442\0430\0432\043A\0435 \0437\0430 \0441\0442\0430\0432\043A\0443 \0441\0442\0440\0430\043D\0438\0446\0435 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868195555402044)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\043E\0432\043B\0430\0448\045B\0435\043D\0438 \043F\0440\0438\0441\0442\0443\043F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888631895402060)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'sr'
,p_message_text=>unistr('JavaScript \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888759062402060)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114889348877402061)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\043E\043A\0440\0435\043D\0443\0442\0438 \0443\043F\0438\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896558022402066)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0410\0436\0443\0440\0438\0440\0430\045A\0435 \0437\0430 %0 \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114890734018402062)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 ID \0441\0442\0430\0432\043A\0435: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114917048564402082)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435 \043F\043E\0441\0442\043E\0458\0438 \043F\043E\043C\043E\045B \0437\0430 \043E\0432\0443 \0441\0442\0430\0432\043A\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881586799402054)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0435\043D\0435\0440\0438\0441\0430\045A\0435 \0443\043F\0438\0442\0430 \0433\0440\0430\0444\0438\043A\043E\043D\0430 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E. \041F\0440\043E\0432\0435\0440\0438\0442\0435 \043F\043E\0434\0435\0448\0430\0432\0430\045A\0430 \043C\0430\043F\0438\0440\0430\045A\0430 \0438\0437\0432\043E\0440\0430 \0438 \043A\043E\043B\043E\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976383104402128)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0438\043B\043E\0433 \0432\0435\043B\0438\0447\0438\043D\0435 %0 MB \043F\0440\0435\043C\0430\0448\0443\0458\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0443 \0432\0435\043B\0438\0447\0438\043D\0443 \043F\0440\0438\043B\043E\0433\0430 \043E\0434 %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882460544402055)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0430 \0432\0440\0435\0434\043D\043E\0441\0442 \0437\0430 \043F\0430\0440\0430\043C\0435\0442\0430\0440 p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114999851219402146)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0430\0448\0438\043B\0438 \0441\0442\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0435-\043F\043E\0440\0443\043A\0430 \043F\043E \0440\0430\0434\043D\043E\043C \043F\0440\043E\0441\0442\043E\0440\0443. \041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863442029402040)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430 \043F\0440\043E\0446\0435\0434\0443\0440\0430 \043C\043E\0440\0430 \0434\0430 \0441\0435 \043F\043E\0437\043E\0432\0435 \0438\0437 \0441\0435\0441\0438\0458\0435 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882341082402055)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 null \0458\0435 \0443\043D\0435\0442\0430 \0437\0430 \043F\0430\0440\0430\043C\0435\0442\0430\0440 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936327285402097)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0428\0430\0431\043B\043E\043D \0435-\043F\043E\0440\0443\043A\0435 "%0" \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115012813578402156)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0430\0440\0430\043C\0435\0442\0430\0440 \0438\043D\0441\0442\0430\043D\0446\0435 SMTP_HOST_ADDRESS \043C\043E\0440\0430 \0434\0430 \0441\0435 \043F\043E\0434\0435\0441\0438 \043D\0430 \0441\043B\0430\045A\0435 \043F\043E\0448\0442\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882016838402055)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\043E\0440\0430\0442\0435 \0434\0430 \0443\043D\0435\0441\0435\0442\0435 \043F\0440\0438\043C\0430\043E\0446\0430 \043F\043E\0440\0443\043A\0435 \0434\0430 \0431\0438\0441\0442\0435 \043F\043E\0441\043B\0430\043B\0438 \043F\043E\0448\0442\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115002247246402148)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0443\0441\043F\043E\0441\0442\0430\0432\0438\0442\0438 SMTP \0432\0435\0437\0443 \0441\0430 \043A\043E\043D\0444\0438\0433\0443\0440\0438\0441\0430\043D\0438\043C \0441\0435\0440\0432\0435\0440\043E\043C \0435-\043F\043E\0448\0442\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114976408781402128)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0435\0432\0430\0436\0435\045B\0438 \043F\043E\0437\0438\0432 \0437\0430 Ajax!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867889057402044)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435\0434\043D\0430 Ajax \0444\0443\043D\043A\0446\0438\0458\0430 \043D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430 \0437\0430 \0434\043E\0434\0430\0442\043D\0443 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0443 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966874997402121)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430 \0444\0443\043D\043A\0446\0438\0458\0430 \0438\0437\0432\0440\0448\0430\0432\0430\045A\0430 \0437\0430 \0434\043E\0434\0430\0442\043D\0443 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0443 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867963956402044)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435\0434\043D\0430 \0444\0443\043D\043A\0446\0438\0458\0430 \0438\0441\0446\0440\0442\0430\0432\0430\045A\0430 \043D\0438\0458\0435 \0434\0435\0444\0438\043D\0438\0441\0430\043D\0430 \0437\0430 \0434\043E\0434\0430\0442\043D\0443 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0443 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977391932402129)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0442\043D\0430 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0430 \0438\0437\0432\043E\0440\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0437\0430 REST "%0" \043D\0435 \0441\0430\0434\0440\0436\0438 \0444\0443\043D\043A\0446\0438\0458\0443 "\041C\043E\0433\0443\045B\043D\043E\0441\0442\0438".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977249821402129)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0442\043D\0430 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0430 \0438\0437\0432\043E\0440\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0437\0430 REST "%0" \043D\0435 \0441\0430\0434\0440\0436\0438 DML \0444\0443\043D\043A\0446\0438\0458\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977490048402129)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0442\043D\0430 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0430 \0438\0437\0432\043E\0440\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0437\0430 REST "%0" \043D\0435 \0441\0430\0434\0440\0436\0438 \0444\0443\043D\043A\0446\0438\0458\0443 \0438\0437\0432\0440\0448\0430\0432\0430\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114977579843402129)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0434\0430\0442\043D\0430 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0430 \0438\0437\0432\043E\0440\0430 \043F\043E\0434\0430\0442\0430\043A\0430 \0437\0430 REST "%0" \043D\0435 \0441\0430\0434\0440\0436\0438 \0444\0443\043D\043A\0446\0438\0458\0443 \043F\0440\0438\0431\0430\0432\0459\0430\045A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865668436402042)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \0443 PLSQL \043A\043E\0434\0443 \0442\043E\043A\043E\043C \043E\0431\0440\0430\0434\0435 \0434\043E\0434\0430\0442\043D\0435 \043A\043E\043C\043F\043E\043D\0435\043D\0442\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872213874402047)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0412\0440\0435\0434\043D\043E\0441\0442 \043C\043E\0440\0430 \0434\0430 \0431\0443\0434\0435 \043D\0430\0432\0435\0434\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902851208402071)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 %0 \043D\0435 \043C\043E\0436\0435 \0434\0430 \0441\0435 \043A\043E\043D\0432\0435\0440\0442\0443\0458\0435 \0443 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988428619402137)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 "%0", \043A\043E\0458\0430 \0458\0435 \043D\0430\0432\0435\0434\0435\043D\0430 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%1", \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D\0430 \0443 SQL \043D\0430\0440\0435\0434\0431\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964763699402119)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043F\0438\0442 \043B\0438\0441\0442\0435 \0432\0440\0435\0434\043D\043E\0441\0442\0438 (LOV) \0438\043B\0438 \0438\043C\0435\043D\043E\0432\0430\043D\0430 \043B\0438\0441\0442\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \043C\043E\0440\0430\0458\0443 \0434\0430 \0441\0435 \043D\0430\0432\0435\0434\0443 \0437\0430 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114966314481402120)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0433\0440\0435\0448\0430\043D \0431\0440\043E\0458 \043A\043E\043B\043E\043D\0430 \0458\0435 \0438\0437\0430\0431\0440\0430\043D \043D\0430 \043B\0438\0441\0442\0438 \0432\0440\0435\0434\043D\043E\0441\0442\0438 SQL \0443\043F\0438\0442\0430 \0437\0430 %0. \041F\043E\0433\043B\0435\0434\0430\0458\0442\0435 \043F\0440\0438\043C\0435\0440\0435 \0432\0430\0436\0435\045B\0438\0445 \043D\0430\0440\0435\0434\0431\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988228415402137)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043D\0430\0432\0435\0434\0435\043D\0430 \043D\0438\0458\0435\0434\043D\0430 \043A\043E\043B\043E\043D\0430 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017948180402160)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0423\043D\0435\0442\0430 \0432\0440\0435\0434\043D\043E\0441\0442 %0 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%1" \043D\0438\0458\0435 \043D\0443\043C\0435\0440\0438\0447\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114969856716402123)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 \0438\043C\0430 \043F\043E\0433\0440\0435\0448\0430\043D \0442\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 \0443 SQL \043D\0430\0440\0435\0434\0431\0438. \041A\043E\043B\043E\043D\0430 \0431\0440\043E\0458 %1 \0458\0435 %2, \0430 \043E\0447\0435\043A\0443\0458\0435 \0441\0435 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114988375894402137)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 "%0", \043A\043E\0458\0430 \0458\0435 \043D\0430\0432\0435\0434\0435\043D\0430 \0437\0430 \0430\0442\0440\0438\0431\0443\0442 "%1", \0438\043C\0430 \0442\0438\043F \043F\043E\0434\0430\0442\0430\043A\0430 %2, \0430\043B\0438 \0442\0440\0435\0431\0430\043B\043E \0431\0438 \0434\0430 \0438\043C\0430 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114864971827402041)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'sr'
,p_message_text=>unistr('\0420\0430\0441\043F\043E\0440\0435\0434 \0438\0437\0432\0435\0448\0442\0430\0458\0430 \043D\0438\0458\0435 \043F\0440\043E\043D\0430\0452\0435\043D.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924951711402088)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0424\0443\043D\043A\0446\0438\0458\0443 \0438\0437\0440\0430\0447\0443\043D\0430\0432\0430\045A\0430 \0437\0431\0438\0440\0430 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043A\043E\0440\0438\0441\0442\0438\0442\0438 \0437\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0435 \0437\0430\0441\043D\043E\0432\0430\043D\0435 \043D\0430 REST \0438\0437\0432\043E\0440\0443 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114888578840402060)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('ERR-2904 \041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\043E\0434\0435\0441\0438\0442\0438 \0432\0440\0435\0434\043D\043E\0441\0442 \043F\0440\0435\0447\0438\0446\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114892885716402063)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430: \043D\0435\043F\043E\0437\043D\0430\0442\0438 \0442\0438\043F \043F\0440\0435\0447\0438\0446\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114882806933402055)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043F\0440\0435\0443\0437\0435\0442\0438 authentication_scheme \0443 \0430\043F\043B\0438\043A\0430\0446\0438\0458\0438 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114956314655402113)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430 \0442\0440\0435\043D\0443\0442\043D\0443 \0441\0435\0441\0438\0458\0443 \0432\0435\045B \043F\043E\0441\0442\043E\0458\0438 ID \0437\0430\043A\0443\043F\0446\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114893162906402063)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'sr'
,p_message_text=>unistr('\0415-\0430\0434\0440\0435\0441\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017383241402160)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\043E\0442\0432\0440\0434\0430 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114919624739402084)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'sr'
,p_message_text=>unistr('\0408\0435\0434\0430\043D \0438\043B\0438 \0432\0438\0448\0435 \043A\043E\043B\0430\0447\0438\045B\0430 \043F\043E\0434\0435\0448\0435\043D\0438\0445 \0443 apex_util.g_request_cookies \0441\0430\0434\0440\0436\0435 \043D\0435\0432\0430\0436\0435\045B\0443 \0432\0440\0435\0434\043D\043E\0441\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114902175799402071)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0433\043E\0432\043E\0440 UDDI \0440\0435\0433\0438\0441\0442\0440\0430 \0458\0435 \0431\0438\043E \043D\0435\0432\0430\0436\0435\045B\0438.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114865776496402042)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0430\0432\0435\0434\0435\043D\0438 URL \043D\0438\0458\0435 \043F\0440\0443\0436\0438\043E \0432\0430\0436\0435\045B\0438 WSDL \0434\043E\043A\0443\043C\0435\043D\0442.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114868214643402044)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'sr'
,p_message_text=>unistr('WSDL \0434\043E\043A\0443\043C\0435\043D\0442 \0441\0430\0434\0440\0436\0438 \0432\0438\0448\0435 SOAP \043F\043E\0432\0435\0437\0438\0432\0430\045A\0430. &PRODUCT_NAME. \043F\043E\0434\0440\0436\0430\0432\0430 \0441\0430\043C\043E WSDL \0434\043E\043A\0443\043C\0435\043D\0442\0435 \0441\0430 \0458\0435\0434\043D\0438\043C SOAP \043F\043E\0432\0435\0437\0438\0432\0430\045A\0435\043C. \041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0420\0443\0447\043D\043E \043A\0440\0435\0438\0440\0430\0458 \0440\0435\0444\0435\0440\0435\043D\0446\0443 \0432\0435\0431-\0443\0441\043B\0443\0433\0435 \0434\0430 \0431\0438\0441\0442\0435 \043D\0430\0441\0442\0430\0432\0438\043B\0438 \0434\0430 \043A\0440\0435\0438\0440\0430\0442\0435 \0440\0435\0444\0435\0440\0435\043D\0446\0443 \0437\0430 \043E\0432\0443 \0443\0441\043B\0443\0433\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114936684955402097)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0434\0433\043E\0432\043E\0440 \0443\0441\043B\0443\0433\0435 \043D\0438\0458\0435 \0431\0438\043E XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017212847402160)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'sr'
,p_message_text=>unistr('OAuth \043F\0440\0438\0441\0442\0443\043F\043D\0438 \0442\043E\043A\0435\043D \043D\0438\0458\0435 \0434\043E\0441\0442\0443\043F\0430\043D \0438\043B\0438 \0458\0435 \0438\0441\0442\0435\043A\0430\043E.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114980475052402131)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041F\0440\0435\043C\0430\0448\0438\043B\0438 \0441\0442\0435 \043C\0430\043A\0441\0438\043C\0430\043B\043D\0438 \0431\0440\043E\0458 \0437\0430\0445\0442\0435\0432\0430 \0437\0430 \0432\0435\0431 \0443\0441\043B\0443\0433\0443 \043F\043E \0440\0430\0434\043D\043E\043C \043F\0440\043E\0441\0442\043E\0440\0443. \041E\0431\0440\0430\0442\0438\0442\0435 \0441\0435 \0430\0434\043C\0438\043D\0438\0441\0442\0440\0430\0442\043E\0440\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115017404806402160)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\0435\0440\0432\0435\0440 \0458\0435 \043E\0434\0433\043E\0432\043E\0440\0438\043E \043D\0435\043F\043E\0434\0440\0436\0430\043D\0438\043C \0442\0438\043F\043E\043C OAuth \0442\043E\043A\0435\043D\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867635922402043)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'sr'
,p_message_text=>unistr('WSDL \043D\0435 \0441\0430\0434\0440\0436\0438 \043F\043E\0432\0435\0437\0438\0432\0430\045A\0435 \0437\0430 SOAP \043A\043E\0458\0435 \0458\0435 \043F\043E\0442\0440\0435\0431\043D\043E \0434\0430 \0431\0438 \0441\0435 \0434\043E\0434\0430\043B\0430 \0440\0435\0444\0435\0440\0435\043D\0446\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114863507558402040)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'sr'
,p_message_text=>unistr('\0417\0430 \043E\0432\0430\0458 WSDL \0441\0443 \043F\043E\0442\0440\0435\0431\043D\0438 \043A\0440\0435\0434\0435\043D\0446\0438\0458\0430\043B\0438 \0437\0430 \043F\043E\0442\0432\0440\0434\0443 \0438\0434\0435\043D\0442\0438\0442\0435\0442\0430. \0423\043D\0435\0441\0438\0442\0435 \043A\043E\0440\0438\0441\043D\0438\0447\043A\043E \0438\043C\0435 \0438 \043B\043E\0437\0438\043D\043A\0443 \0443 \043D\0430\0441\0442\0430\0432\043A\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114872353181402047)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0430\0448\0438\043D\0430 \0437\0430 \0432\0438\0437\0443\0435\043B\0438\0437\0430\0446\0438\0458\0443 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\0430 \0434\0430 \0440\0430\0437\0443\043C\0435 WSDL \0434\043E\043A\0443\043C\0435\043D\0442. \041A\043B\0438\043A\043D\0438\0442\0435 \043D\0430 \0420\0443\0447\043D\043E \043A\0440\0435\0438\0440\0430\0458 \0440\0435\0444\0435\0440\0435\043D\0446\0443 \0432\0435\0431-\0443\0441\043B\0443\0433\0435 \0434\0430 \0431\0438\0441\0442\0435 \043D\0430\0441\0442\0430\0432\0438\043B\0438 \0434\0430 \043A\0440\0435\0438\0440\0430\0442\0435 \0440\0435\0444\0435\0440\0435\043D\0446\0443 \0437\0430 \043E\0432\0443 \0443\0441\043B\0443\0433\0443.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114939247888402099)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'sr'
,p_message_text=>unistr('\041D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043E\0431\0440\0430\0434\0438\0442\0438 \0430\0436\0443\0440\0438\0440\0430\045A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114965015933402119)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'sr'
,p_message_text=>unistr('\041A\043E\043B\043E\043D\0430 \0437\0430 \0432\0440\0430\045B\0430\045A\0435 \0438 \043A\043E\043B\043E\043D\0430 \0437\0430 \043F\0440\0438\043A\0430\0437 \0443 \043B\0438\0441\0442\0438 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \0441\0443 \0438\0441\0442\0435!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114964994767402119)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\041B\0438\0441\0442\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \043D\0435\043C\0430 \043A\043E\043B\043E\043D\0443 \0437\0430 \0432\0440\0430\045B\0430\045A\0435.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896484074402066)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438\043B\0438\043A\043E\043C \043F\0440\0435\0443\0437\0438\043C\0430\045A\0430 \0432\0440\0435\0434\043D\043E\0441\0442\0438 \043A\043E\043B\043E\043D\0435: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920434587402085)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'sr'
,p_message_text=>unistr('\0422\0440\0435\043D\0443\0442\043D\0438 \043F\043E\0434\0430\0446\0438 \0442\0430\0431\0443\043B\0430\0440\043D\043E\0433 \043E\0431\0440\0430\0441\0446\0430 \0441\0443 \0441\0443\0432\0438\0448\0435 \0441\0442\0430\0440\0438; \0438\0437\0432\043E\0440\043D\0438 \043F\043E\0434\0430\0446\0438 \0441\0443 \0438\0437\043C\0435\045A\0435\043D\0438.<br/> \041A\043B\0438\043A\043D\0438\0442\0435 <strong><a href="%0">\043E\0432\0434\0435</a></strong> \0434\0430 \0431\0438\0441\0442\0435 \043E\0434\0431\0430\0446\0438\043B\0438 \043F\0440\043E\043C\0435\043D\0435 \0438 \043F\043E\043D\043E\0432\043E \0443\0447\0438\0442\0430\043B\0438 \043F\043E\0434\0430\0442\043A\0435 \0438\0437 \0431\0430\0437\0435 \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878595692402052)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438 \043E\0434\0440\0435\0452\0438\0432\0430\045A\0443 \043D\0438\0441\043A\0435 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878457240402052)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \043E\0434\0440\0435\0434\0438\0442\0438 \0437\0430\0433\043B\0430\0432\0459\0430 \0443\043F\0438\0442\0430:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878665508402052)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'sr'
,p_message_text=>unistr('\0434\043E\0448\043B\043E \0458\0435 \0434\043E \0433\0440\0435\0448\043A\0435 \043F\0440\0438\043B\0438\043A\043E\043C \043E\0431\0430\0432\0459\0430\045A\0430 \0437\0430\043C\0435\043D\0430 \043F\043E\0434\043D\043E\0436\0458\0430 \0438\0437\0432\0435\0448\0442\0430\0458\0430')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878723356402052)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0440\0430\0448\0447\043B\0430\045A\0438\0432\0430\045A\0435 SQL \0443\043F\0438\0442\0430 \043D\0438\0458\0435 \0443\0441\043F\0435\043B\043E:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883704393402056)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'sr'
,p_message_text=>unistr('\041C\0438\043D\0438\043C\0430\043B\043D\0438 \0437\0430\0445\0442\0435\0432\0430\043D\0438 \0431\0440\043E\0458 \0440\0435\0434\043E\0432\0430: %0, \0440\0435\0434\043E\0432\0438 \043A\043E\0458\0438 \0441\0443 \043F\0440\043E\043D\0430\0452\0435\043D\0438, \0430\043B\0438 \043D\0438\0441\0443 \043F\0440\0438\043A\0430\0437\0430\043D\0438: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881227576402054)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043A\043E\043B\043E\043D\0430 \0443\043F\0438\0442\0430 \0431\0440. %0 (%1) \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0430, \0437\0430 \043A\043E\043B\043E\043D\0435 \043A\043E\0458\0435 \043A\043E\0440\0438\0441\0442\0435 HTML \043F\043E\0442\0440\0435\0431\043D\0438 \0441\0443 \0430\043B\0438\0458\0430\0441\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114896373314402066)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0413\0440\0435\0448\043A\0430 \043F\0440\0438\043B\0438\043A\043E\043C \043F\0440\0435\0443\0437\0438\043C\0430\045A\0430 \0437\0430\0433\043B\0430\0432\0459\0430 \0443\043F\0438\0442\0430: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878884462402052)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0433\0440\0435\0448\043A\0430 \0443 \0438\0437\0432\0435\0448\0442\0430\0458\0443:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114916584034402082)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'sr'
,p_message_text=>unistr('\0421\043E\0440\0442\0438\0440\0430\0458 \043F\0440\0435\043C\0430 \043E\0432\043E\0458 \043A\043E\043B\043E\043D\0438')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881393048402054)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'sr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0423\043F\0438\0442 \043D\0438\0458\0435 \043C\043E\0433\0443\045B\0435 \0440\0430\0448\0447\043B\0430\043D\0438\0442\0438, \043F\0440\043E\0432\0435\0440\0438\0442\0435 \0441\0438\043D\0442\0430\043A\0441\0443 \0443\043F\0438\0442\0430.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920546164402085)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'sr'
,p_message_text=>unistr('\041E\0432\0430\0458 \043E\0431\0440\0430\0437\0430\0446 \0441\0430\0434\0440\0436\0438 \043D\0435\0441\0430\0447\0443\0432\0430\043D\0435 \043F\0440\043E\043C\0435\043D\0435. \041F\0440\0438\0442\0438\0441\043D\0438\0442\0435 "\0423 \0440\0435\0434\0443" \0434\0430 \0431\0438\0441\0442\0435 \043D\0430\0441\0442\0430\0432\0438\043B\0438 \0431\0435\0437 \0447\0443\0432\0430\045A\0430 \043F\0440\043E\043C\0435\043D\0430. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114924889410402088)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'sr'
,p_message_text=>unistr('\0428\0435\043C\0430 \043F\0430\0433\0438\043D\0430\0446\0438\0458\0435 \0438\0437\0432\0435\0448\0442\0430\0458\0430 (%0) \043D\0438\0458\0435 \043F\043E\0434\0440\0436\0430\043D\0430 \0441\0430 \043E\0434\0430\0431\0440\0430\043D\0438\043C \0438\0437\0432\043E\0440\043E\043C \043F\043E\0434\0430\0442\0430\043A\0430.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114881173575402054)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'sr'
,p_message_text=>unistr('\043A\043E\043B\043E\043D\0430 \0443\043F\0438\0442\0430 \0431\0440. %0 (%1) \043D\0438\0458\0435 \0432\0430\0436\0435\045B\0430, \0443\043F\043E\0442\0440\0435\0431\0438\0442\0435 \0430\043B\0438\0458\0430\0441 \043A\043E\043B\043E\043D\0435')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883811916402056)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'sr'
,p_message_text=>unistr('\0440\0435\0434\043E\0432\0438 %0 - %1 o\0434 \0432\0438\0448\0435 \043E\0434 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114922502628402086)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 - %1 \043E\0434 \0432\0438\0448\0435 \043E\0434 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114883620328402056)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'sr'
,p_message_text=>unistr('\0440\0435\0434\043E\0432\0438 %0 - %1 o\0434 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114867504296402043)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'sr'
,p_message_text=>unistr('%0 - %1 \043E\0434 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878983943402052)
,p_name=>'Y'
,p_message_language=>'sr'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114885064580402057)
,p_name=>'YEAR'
,p_message_language=>'sr'
,p_message_text=>unistr('\0433\043E\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114878173073402052)
,p_name=>'YEARS'
,p_message_language=>'sr'
,p_message_text=>unistr('\0433\043E\0434.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(114920638614402085)
,p_name=>'YES'
,p_message_language=>'sr'
,p_message_text=>unistr('\0414\0430')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4492)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4492)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4492
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4492)
,p_name=>unistr('\041F\043E\0440\0443\043A\0435')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\041F\043E\0440\0443\043A\0435')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
